/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/uri","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/path","vs/platform/environment/common/environment","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/files/common/files","vs/base/common/resources","vs/base/common/types","vs/base/common/network","vs/base/node/pfs","vs/base/common/strings","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/platform/userDataSync/common/userDataSync","vs/base/common/arrays","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/base/common/json","vs/base/common/process","os","vs/base/parts/ipc/common/ipc","vs/platform/configuration/common/configurationRegistry","vs/base/common/map","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/base/common/extpath","child_process","vs/base/common/errorMessage","vs/platform/product/common/product","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/codicons","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/common/glob","vs/base/node/decoder","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","util","path","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ee=function(K){for(var e=[],p=0,L=K.length;p<L;p++)e[p]=Z[K[p]];return e};define(Z[88],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(L,P){if(!L)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}e.ok=p}),define(Z[63],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const p=Object.prototype.hasOwnProperty;function L(n){const y=[];for(let m in n)p.call(n,m)&&y.push(n[m]);return y}e.values=L;function P(n,y){for(let m in n)if(p.call(n,m)&&y({key:m,value:n[m]},function(){delete n[m]})===!1)return}e.forEach=P;function k(n,y){const m=Object.create(null);for(const v of n){const h=y(v);let C=m[h];C||(C=m[h]=[]),C.push(v)}return m}e.groupBy=k;function A(n){const y=Object.create(null);return n&&n.forEach((m,v)=>{y[v]=m}),y}e.fromMap=A;function R(n,y){const m=[],v=[];for(let h of n)y.has(h)||m.push(h);for(let h of y)n.has(h)||v.push(h);return{removed:m,added:v}}e.diffSets=R;function S(n,y){const m=[],v=[];for(let[h,C]of n)y.has(h)||m.push(C);for(let[h,C]of y)n.has(h)||v.push(C);return{removed:m,added:v}}e.diffMaps=S;class w{constructor(){this.map=new Map}add(y,m){let v=this.map.get(y);v||(v=new Set,this.map.set(y,v)),v.add(m)}delete(y,m){const v=this.map.get(y);!v||(v.delete(m),v.size===0&&this.map.delete(y))}forEach(y,m){const v=this.map.get(y);!v||v.forEach(m)}}e.SetMap=w}),define(Z[64],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function p(A){return(R,S,w)=>{let n=null,y=null;if(typeof w.value=="function"?(n="value",y=w.value):typeof w.get=="function"&&(n="get",y=w.get),!y)throw new Error("not supported");w[n]=A(y,S)}}e.createDecorator=p;function L(A,R,S){let w=null,n=null;if(typeof S.value=="function"?(w="value",n=S.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(w="get",n=S.get),!n)throw new Error("not supported");const y=`$memoize$${R}`;S[w]=function(...m){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,m)}),this[y]}}e.memoize=L;function P(A,R,S){return p((w,n)=>{const y=`$debounce$${n}`,m=`$debounce$result$${n}`;return function(...v){this[m]||(this[m]=S?S():void 0),clearTimeout(this[y]),R&&(this[m]=R(this[m],...v),v=[this[m]]),this[y]=setTimeout(()=>{w.apply(this,v),this[m]=S?S():void 0},A)}})}e.debounce=P;function k(A,R,S){return p((w,n)=>{const y=`$throttle$timer$${n}`,m=`$throttle$result$${n}`,v=`$throttle$lastRun$${n}`,h=`$throttle$pending$${n}`;return function(...C){if(this[m]||(this[m]=S?S():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),R&&(this[m]=R(this[m],...C)),this[h])return;const D=this[v]+A;D<=Date.now()?(this[v]=Date.now(),w.apply(this,[this[m]]),this[m]=S?S():void 0):(this[h]=!0,this[y]=setTimeout(()=>{this[h]=!1,this[v]=Date.now(),w.apply(this,[this[m]]),this[m]=S?S():void 0},D-Date.now()))}})}e.throttle=k}),define(Z[11],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=p,e.errorHandler=new p;function L(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=L;function P(c){S(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=P;function k(c){S(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=k;function A(c){if(c instanceof Error){let{name:t,message:r}=c;const i=c.stacktrace||c.stack;return{$isError:!0,name:t,message:r,stack:i}}return c}e.transformErrorForSerialization=A;const R="Canceled";function S(c){return c instanceof Error&&c.name===R&&c.message===R}e.isPromiseCanceledError=S;class w extends Error{constructor(){super(R);this.name=this.message}}e.CancellationError=w;function n(){const c=new Error(R);return c.name=c.message,c}e.canceled=n;function y(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=y;function m(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=m;function v(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=v;function h(c){const t=new Error(`${c} has been disposed`);return t.name="DISPOSED",t}e.disposed=h;function C(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=C;class D extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=D;class b extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=b;class I extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=I;function f(c){const t=c;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=f;function a(c,t=Object.create(null)){const r=new Error(c);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=a}),define(Z[23],ee([0,1,11]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(x,B=0){return x[x.length-(1+B)]}e.tail=L;function P(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}e.tail2=P;function k(x,B,H=(X,Q)=>X===Q){if(x===B)return!0;if(!x||!B||x.length!==B.length)return!1;for(let X=0,Q=x.length;X<Q;X++)if(!H(x[X],B[X]))return!1;return!0}e.equals=k;function A(x,B,H){let X=0,Q=x.length-1;for(;X<=Q;){const ie=(X+Q)/2|0,ne=H(x[ie],B);if(ne<0)X=ie+1;else if(ne>0)Q=ie-1;else return ie}return-(X+1)}e.binarySearch=A;function R(x,B){let H=0,X=x.length;if(X===0)return 0;for(;H<X;){const Q=Math.floor((H+X)/2);B(x[Q])?X=Q:H=Q+1}return H}e.findFirstInSorted=R;function S(x,B,H){if(x=x|0,x>=B.length)throw new TypeError("invalid index");let X=B[Math.floor(B.length*Math.random())],Q=[],ie=[],ne=[];for(let le of B){const de=H(le,X);de<0?Q.push(le):de>0?ie.push(le):ne.push(le)}return x<Q.length?S(x,Q,H):x<Q.length+ne.length?ne[0]:S(x-(Q.length+ne.length),ie,H)}e.quickSelect=S;function w(x,B){const H=[];let X;for(const Q of x.slice(0).sort(B))!X||B(X[0],Q)!==0?(X=[Q],H.push(X)):X.push(Q);return H}e.groupBy=w;function n(x,B,H){const X=[];function Q(le,de,ye){if(de===0&&ye.length===0)return;const pe=X[X.length-1];pe&&pe.start+pe.deleteCount===le?(pe.deleteCount+=de,pe.toInsert.push(...ye)):X.push({start:le,deleteCount:de,toInsert:ye})}let ie=0,ne=0;for(;;){if(ie===x.length){Q(ie,0,B.slice(ne));break}if(ne===B.length){Q(ie,x.length-ie,[]);break}const le=x[ie],de=B[ne],ye=H(le,de);ye===0?(ie+=1,ne+=1):ye<0?(Q(ie,1,[]),ie+=1):ye>0&&(Q(ie,0,[de]),ne+=1)}return X}e.sortedDiff=n;function y(x,B,H){const X=n(x,B,H),Q=[],ie=[];for(const ne of X)Q.push(...x.slice(ne.start,ne.start+ne.deleteCount)),ie.push(...ne.toInsert);return{removed:Q,added:ie}}e.delta=y;function m(x,B,H){if(H===0)return[];const X=x.slice(0,H).sort(B);return h(x,B,X,H,x.length),X}e.top=m;function v(x,B,H,X,Q){return H===0?Promise.resolve([]):new Promise((ie,ne)=>{(async()=>{const le=x.length,de=x.slice(0,H).sort(B);for(let ye=H,pe=Math.min(H+X,le);ye<le;ye=pe,pe=Math.min(pe+X,le)){if(ye>H&&await new Promise(De=>setTimeout(De)),Q&&Q.isCancellationRequested)throw(0,p.canceled)();h(x,B,de,ye,pe)}return de})().then(ie,ne)})}e.topAsync=v;function h(x,B,H,X,Q){for(const ie=H.length;X<Q;X++){const ne=x[X];if(B(ne,H[ie-1])<0){H.pop();const le=R(H,de=>B(ne,de)<0);H.splice(le,0,ne)}}}function C(x){return x.filter(B=>!!B)}e.coalesce=C;function D(x){let B=0;for(let H=0;H<x.length;H++)x[H]&&(x[B]=x[H],B+=1);x.length=B}e.coalesceInPlace=D;function b(x,B,H){x.splice(H,0,x.splice(B,1)[0])}e.move=b;function I(x){return!Array.isArray(x)||x.length===0}e.isFalsyOrEmpty=I;function f(x){return Array.isArray(x)&&x.length>0}e.isNonEmptyArray=f;function a(x,B){if(!B)return x.filter((X,Q)=>x.indexOf(X)===Q);const H=Object.create(null);return x.filter(X=>{const Q=B(X);return H[Q]?!1:(H[Q]=!0,!0)})}e.distinct=a;function c(x){const B=new Set;return x.filter(H=>B.has(H)?!1:(B.add(H),!0))}e.distinctES6=c;function t(x){const B=Object.create(null);return H=>{const X=x(H);return B[X]?!1:(B[X]=!0,!0)}}e.uniqueFilter=t;function r(x,B){for(let H=x.length-1;H>=0;H--){const X=x[H];if(B(X))return H}return-1}e.lastIndex=r;function i(x,B){return x.length>0?x[0]:B}e.firstOrDefault=i;function s(x,B,H=(X,Q)=>X===Q){let X=0;for(let Q=0,ie=Math.min(x.length,B.length);Q<ie&&H(x[Q],B[Q]);Q++)X++;return X}e.commonPrefixLength=s;function u(x){return[].concat(...x)}e.flatten=u;function o(x,B){let H=typeof B=="number"?x:0;typeof B=="number"?H=x:(H=0,B=x);const X=[];if(H<=B)for(let Q=H;Q<B;Q++)X.push(Q);else for(let Q=H;Q>B;Q--)X.push(Q);return X}e.range=o;function l(x,B,H){return x.reduce((X,Q)=>(X[B(Q)]=H?H(Q):Q,X),Object.create(null))}e.index=l;function g(x,B){return x.push(B),()=>E(x,B)}e.insert=g;function E(x,B){const H=x.indexOf(B);if(H>-1)return x.splice(H,1),B}e.remove=E;function d(x,B,H){const X=x.slice(0,B),Q=x.slice(B);return X.concat(H,Q)}e.arrayInsert=d;function T(x,B){let H;if(typeof B=="number"){let X=B;H=()=>{const Q=Math.sin(X++)*179426549;return Q-Math.floor(Q)}}else H=Math.random;for(let X=x.length-1;X>0;X-=1){const Q=Math.floor(H()*(X+1)),ie=x[X];x[X]=x[Q],x[Q]=ie}}e.shuffle=T;function O(x,B){const H=x.indexOf(B);H>-1&&(x.splice(H,1),x.unshift(B))}e.pushToStart=O;function $(x,B){const H=x.indexOf(B);H>-1&&(x.splice(H,1),x.push(B))}e.pushToEnd=$;function z(x,B){return Array.isArray(x)?x.map(B):B(x)}e.mapArrayOrNot=z;function G(x){return Array.isArray(x)?x:[x]}e.asArray=G;function V(x){return x[Math.floor(Math.random()*x.length)]}e.getRandomElement=V;function U(x,B){for(const H of x){const X=B(H);if(X!==void 0)return X}}e.mapFind=U;function M(x,B,H){const X=j(x,B),Q=x.length,ie=H.length;x.length=Q+ie;for(let ne=Q-1;ne>=X;ne--)x[ne+ie]=x[ne];for(let ne=0;ne<ie;ne++)x[ne+X]=H[ne]}e.insertInto=M;function F(x,B,H,X){const Q=j(x,B),ie=x.splice(Q,H);return M(x,Q,X),ie}e.splice=F;function j(x,B){return B<0?Math.max(B+x.length,0):Math.min(B,x.length)}function _(x,B){let H=Number.MAX_SAFE_INTEGER,X=0;return x.forEach((Q,ie)=>{const ne=B(Q);ne<H&&(H=ne,X=ie)}),X}e.minIndex=_;function N(x,B){let H=Number.MIN_SAFE_INTEGER,X=0;return x.forEach((Q,ie)=>{const ne=B(Q);ne>H&&(H=ne,X=ie)}),X}e.maxIndex=N;class W{constructor(B){this.items=B,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(B){let H=this.firstIdx;for(;H<this.items.length&&B(this.items[H]);)H++;const X=H===this.firstIdx?null:this.items.slice(this.firstIdx,H);return this.firstIdx=H,X}takeFromEndWhile(B){let H=this.lastIdx;for(;H>=0&&B(this.items[H]);)H--;const X=H===this.lastIdx?null:this.items.slice(H+1,this.lastIdx+1);return this.lastIdx=H,X}}e.ArrayQueue=W}),define(Z[65],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(L){const P=this;let k=!1,A;return function(){return k||(k=!0,A=L.apply(P,arguments)),A}}e.once=p}),define(Z[54],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(L){function P(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}L.is=P;const k=Object.freeze([]);function A(){return k}L.empty=A;function*R(c){yield c}L.single=R;function S(c){return c||k}L.from=S;function w(c){return!c||c[Symbol.iterator]().next().done===!0}L.isEmpty=w;function n(c){return c[Symbol.iterator]().next().value}L.first=n;function y(c,t){for(const r of c)if(t(r))return!0;return!1}L.some=y;function m(c,t){for(const r of c)if(t(r))return r}L.find=m;function*v(c,t){for(const r of c)t(r)&&(yield r)}L.filter=v;function*h(c,t){let r=0;for(const i of c)yield t(i,r++)}L.map=h;function*C(...c){for(const t of c)for(const r of t)yield r}L.concat=C;function*D(c){for(const t of c)for(const r of t)yield r}L.concatNested=D;function b(c,t,r){let i=r;for(const s of c)i=t(i,s);return i}L.reduce=b;function*I(c,t,r=c.length){for(t<0&&(t+=c.length),r<0?r+=c.length:r>c.length&&(r=c.length);t<r;t++)yield c[t]}L.slice=I;function f(c,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,c];const i=c[Symbol.iterator]();for(let s=0;s<t;s++){const u=i.next();if(u.done)return[r,L.empty()];r.push(u.value)}return[r,{[Symbol.iterator](){return i}}]}L.consume=f;function a(c,t,r=(i,s)=>i===s){const i=c[Symbol.iterator](),s=t[Symbol.iterator]();for(;;){const u=i.next(),o=s.next();if(u.done!==o.done)return!1;if(u.done)return!0;if(!r(u.value,o.value))return!1}}L.equals=a})(p=e.Iterable||(e.Iterable={}))}),define(Z[33],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(t){t.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function A(t,r=!1){let i=0,s=t.length,u="",o=0,l=16,g=0;function E(V){let U=0,M=0;for(;U<V;){const F=t.charCodeAt(i);if(F>=48&&F<=57)M=M*16+F-48;else if(F>=65&&F<=70)M=M*16+F-65+10;else if(F>=97&&F<=102)M=M*16+F-97+10;else break;i++,U++}return U<V&&(M=-1),M}function d(V){i=V,u="",o=0,l=16,g=0}function T(){const V=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&w(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&w(t.charCodeAt(i)))for(i++;i<t.length&&w(t.charCodeAt(i));)i++;else return g=3,t.substring(V,i);let U=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&w(t.charCodeAt(i))){for(i++;i<t.length&&w(t.charCodeAt(i));)i++;U=i}else g=3;return t.substring(V,U)}function O(){let V="",U=i;for(;;){if(i>=s){V+=t.substring(U,i),g=2;break}const M=t.charCodeAt(i);if(M===34){V+=t.substring(U,i),i++;break}if(M===92){if(V+=t.substring(U,i),i++,i>=s){g=2;break}switch(t.charCodeAt(i++)){case 34:V+='"';break;case 92:V+="\\";break;case 47:V+="/";break;case 98:V+="\b";break;case 102:V+="\f";break;case 110:V+=`
`;break;case 114:V+="\r";break;case 116:V+="	";break;case 117:const j=E(4);j>=0?V+=String.fromCharCode(j):g=4;break;default:g=5}U=i;continue}if(M>=0&&M<=31)if(S(M)){V+=t.substring(U,i),g=2;break}else g=6;i++}return V}function $(){if(u="",g=0,o=i,i>=s)return o=s,l=17;let V=t.charCodeAt(i);if(R(V)){do i++,u+=String.fromCharCode(V),V=t.charCodeAt(i);while(R(V));return l=15}if(S(V))return i++,u+=String.fromCharCode(V),V===13&&t.charCodeAt(i)===10&&(i++,u+=`
`),l=14;switch(V){case 123:return i++,l=1;case 125:return i++,l=2;case 91:return i++,l=3;case 93:return i++,l=4;case 58:return i++,l=6;case 44:return i++,l=5;case 34:return i++,u=O(),l=10;case 47:const U=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<s&&!S(t.charCodeAt(i));)i++;return u=t.substring(U,i),l=12}if(t.charCodeAt(i+1)===42){i+=2;const M=s-1;let F=!1;for(;i<M;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,F=!0;break}i++}return F||(i++,g=1),u=t.substring(U,i),l=13}return u+=String.fromCharCode(V),i++,l=16;case 45:if(u+=String.fromCharCode(V),i++,i===s||!w(t.charCodeAt(i)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=T(),l=11;default:for(;i<s&&z(V);)i++,V=t.charCodeAt(i);if(o!==i){switch(u=t.substring(o,i),u){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return u+=String.fromCharCode(V),i++,l=16}}function z(V){if(R(V)||S(V))return!1;switch(V){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let V;do V=$();while(V>=12&&V<=15);return V}return{setPosition:d,getPosition:()=>i,scan:r?G:$,getToken:()=>l,getTokenValue:()=>u,getTokenOffset:()=>o,getTokenLength:()=>i-o,getTokenError:()=>g}}e.createScanner=A;function R(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function w(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function y(t,r){const i=[],s=new Object;let u;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function g(E,d,T,O){o.value=E,o.offset=d,o.length=T,o.type=O,o.colonOffset=void 0,u=o}try{f(t,{onObjectBegin:(E,d)=>{if(r<=E)throw s;u=void 0,l=r>E,i.push("")},onObjectProperty:(E,d,T)=>{if(r<d||(g(E,d,T,"property"),i[i.length-1]=E,r<=d+T))throw s},onObjectEnd:(E,d)=>{if(r<=E)throw s;u=void 0,i.pop()},onArrayBegin:(E,d)=>{if(r<=E)throw s;u=void 0,i.push(0)},onArrayEnd:(E,d)=>{if(r<=E)throw s;u=void 0,i.pop()},onLiteralValue:(E,d,T)=>{if(r<d||(g(E,d,T,c(E)),r<=d+T))throw s},onSeparator:(E,d,T)=>{if(r<=d)throw s;if(E===":"&&u&&u.type==="property")u.colonOffset=d,l=!1,u=void 0;else if(E===","){const O=i[i.length-1];typeof O=="number"?i[i.length-1]=O+1:(l=!0,i[i.length-1]=""),u=void 0}}})}catch(E){if(E!==s)throw E}return{path:i,previousNode:u,isAtPropertyKey:l,matches:E=>{let d=0;for(let T=0;d<E.length&&T<i.length;T++)if(E[d]===i[T]||E[d]==="*")d++;else if(E[d]!=="**")return!1;return d===E.length}}}e.getLocation=y;function m(t,r=[],i=k.DEFAULT){let s=null,u=[];const o=[];function l(E){Array.isArray(u)?u.push(E):s!==null&&(u[s]=E)}return f(t,{onObjectBegin:()=>{const E={};l(E),o.push(u),u=E,s=null},onObjectProperty:E=>{s=E},onObjectEnd:()=>{u=o.pop()},onArrayBegin:()=>{const E=[];l(E),o.push(u),u=E,s=null},onArrayEnd:()=>{u=o.pop()},onLiteralValue:l,onError:(E,d,T)=>{r.push({error:E,offset:d,length:T})}},i),u[0]}e.parse=m;function v(t,r=[],i=k.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(E){s.type==="property"&&(s.length=E-s.offset,s=s.parent)}function o(E){return s.children.push(E),E}f(t,{onObjectBegin:E=>{s=o({type:"object",offset:E,length:-1,parent:s,children:[]})},onObjectProperty:(E,d,T)=>{s=o({type:"property",offset:d,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:E,offset:d,length:T,parent:s})},onObjectEnd:(E,d)=>{s.length=E+d-s.offset,s=s.parent,u(E+d)},onArrayBegin:(E,d)=>{s=o({type:"array",offset:E,length:-1,parent:s,children:[]})},onArrayEnd:(E,d)=>{s.length=E+d-s.offset,s=s.parent,u(E+d)},onLiteralValue:(E,d,T)=>{o({type:c(E),offset:d,length:T,parent:s,value:E}),u(d+T)},onSeparator:(E,d,T)=>{s.type==="property"&&(E===":"?s.colonOffset=d:E===","&&u(d))},onError:(E,d,T)=>{r.push({error:E,offset:d,length:T})}},i);const g=s.children[0];return g&&delete g.parent,g}e.parseTree=v;function h(t,r){if(!t)return;let i=t;for(let s of r)if(typeof s=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let u=!1;for(const o of i.children)if(Array.isArray(o.children)&&o.children[0].value===s){i=o.children[1],u=!0;break}if(!u)return}else{const u=s;if(i.type!=="array"||u<0||!Array.isArray(i.children)||u>=i.children.length)return;i=i.children[u]}return i}e.findNodeAtLocation=h;function C(t){if(!t.parent||!t.parent.children)return[];const r=C(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;r.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&r.push(i)}return r}e.getNodePath=C;function D(t){switch(t.type){case"array":return t.children.map(D);case"object":const r=Object.create(null);for(let i of t.children){const s=i.children[1];s&&(r[i.children[0].value]=D(s))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=D;function b(t,r,i=!1){return r>=t.offset&&r<t.offset+t.length||i&&r===t.offset+t.length}e.contains=b;function I(t,r,i=!1){if(b(t,r,i)){const s=t.children;if(Array.isArray(s))for(let u=0;u<s.length&&s[u].offset<=r;u++){const o=I(s[u],r,i);if(o)return o}return t}}e.findNodeAtOffset=I;function f(t,r,i=k.DEFAULT){const s=A(t,!1);function u(H){return H?()=>H(s.getTokenOffset(),s.getTokenLength()):()=>!0}function o(H){return H?X=>H(X,s.getTokenOffset(),s.getTokenLength()):()=>!0}const l=u(r.onObjectBegin),g=o(r.onObjectProperty),E=u(r.onObjectEnd),d=u(r.onArrayBegin),T=u(r.onArrayEnd),O=o(r.onLiteralValue),$=o(r.onSeparator),z=u(r.onComment),G=o(r.onError),V=i&&i.disallowComments,U=i&&i.allowTrailingComma;function M(){for(;;){const H=s.scan();switch(s.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:V||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(H){case 12:case 13:V?F(10):z();break;case 16:F(1);break;case 15:case 14:break;default:return H}}}function F(H,X=[],Q=[]){if(G(H),X.length+Q.length>0){let ie=s.getToken();for(;ie!==17;){if(X.indexOf(ie)!==-1){M();break}else if(Q.indexOf(ie)!==-1)break;ie=M()}}}function j(H){const X=s.getTokenValue();return H?O(X):g(X),M(),!0}function _(){switch(s.getToken()){case 11:let H=0;try{H=JSON.parse(s.getTokenValue()),typeof H!="number"&&(F(2),H=0)}catch(X){F(2)}O(H);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return M(),!0}function N(){return s.getToken()!==10?(F(3,[],[2,5]),!1):(j(!1),s.getToken()===6?($(":"),M(),B()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function W(){l(),M();let H=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(H||F(4,[],[]),$(","),M(),s.getToken()===2&&U)break}else H&&F(6,[],[]);N()||F(4,[],[2,5]),H=!0}return E(),s.getToken()!==2?F(7,[2],[]):M(),!0}function x(){d(),M();let H=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(H||F(4,[],[]),$(","),M(),s.getToken()===4&&U)break}else H&&F(6,[],[]);B()||F(4,[],[4,5]),H=!0}return T(),s.getToken()!==4?F(8,[4],[]):M(),!0}function B(){switch(s.getToken()){case 3:return x();case 1:return W();case 10:return j(!0);default:return _()}}return M(),s.getToken()===17?i.allowEmptyContent?!0:(F(4,[],[]),!1):B()?(s.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.visit=f;function a(t,r){let i=A(t),s=[],u,o=0,l;do switch(l=i.getPosition(),u=i.scan(),u){case 12:case 13:case 17:o!==l&&s.push(t.substring(o,l)),r!==void 0&&s.push(i.getTokenValue().replace(/[^\r\n]/g,r)),o=i.getPosition();break}while(u!==17);return s.join("")}e.stripComments=a;function c(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(Z[47],ee([0,1,33]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(S,w,n){let y,m,v,h,C;if(w){for(h=w.offset,C=h+w.length,v=h;v>0&&!R(S,v-1);)v--;let o=C;for(;o<S.length&&!R(S,o);)o++;m=S.substring(v,o),y=k(m,n)}else m=S,y=0,v=0,h=0,C=S.length;const D=A(n,S);let b=!1,I=0,f;n.insertSpaces?f=P(" ",n.tabSize||4):f="	";const a=(0,p.createScanner)(m,!1);let c=!1;function t(){return D+P(f,y+I)}function r(){let o=a.scan();for(b=!1;o===15||o===14;)b=b||o===14,o=a.scan();return c=o===16||a.getTokenError()!==0,o}const i=[];function s(o,l,g){!c&&l<C&&g>h&&S.substring(l,g)!==o&&i.push({offset:l,length:g-l,content:o})}let u=r();if(u!==17){const o=a.getTokenOffset()+v,l=P(f,y);s(l,v,o)}for(;u!==17;){let o=a.getTokenOffset()+a.getTokenLength()+v,l=r(),g="";for(;!b&&(l===12||l===13);){const d=a.getTokenOffset()+v;s(" ",o,d),o=a.getTokenOffset()+a.getTokenLength()+v,g=l===12?t():"",l=r()}if(l===2)u!==1&&(I--,g=t());else if(l===4)u!==3&&(I--,g=t());else{switch(u){case 3:case 1:I++,g=t();break;case 5:case 12:g=t();break;case 13:b?g=t():g=" ";break;case 6:g=" ";break;case 10:if(l===6){g="";break}case 7:case 8:case 9:case 11:case 2:case 4:l===12||l===13?g=" ":l!==5&&l!==17&&(c=!0);break;case 16:c=!0;break}b&&(l===12||l===13)&&(g=t())}const E=a.getTokenOffset()+v;s(g,o,E),u=l}return i}e.format=L;function P(S,w){let n="";for(let y=0;y<w;y++)n+=S;return n}function k(S,w){let n=0,y=0;const m=w.tabSize||4;for(;n<S.length;){const v=S.charAt(n);if(v===" ")y++;else if(v==="	")y+=m;else break;n++}return Math.floor(y/m)}function A(S,w){for(let n=0;n<w.length;n++){const y=w.charAt(n);if(y==="\r")return n+1<w.length&&w.charAt(n+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=A;function R(S,w){return`\r
`.indexOf(S.charAt(w))!==-1}e.isEOL=R}),define(Z[40],ee([0,1,33,47]),function(K,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function P(w,n,y){return k(w,n,void 0,y)}e.removeProperty=P;function k(w,n,y,m,v){const h=n.slice(),C=[],D=(0,p.parseTree)(w,C);let b,I;for(;h.length>0&&(I=h.pop(),b=(0,p.findNodeAtLocation)(D,h),b===void 0&&y!==void 0);)typeof I=="string"?y={[I]:y}:y=[y];if(b)if(b.type==="object"&&typeof I=="string"&&Array.isArray(b.children)){const f=(0,p.findNodeAtLocation)(b,[I]);if(f!==void 0)if(y===void 0){if(!f.parent)throw new Error("Malformed AST");const a=b.children.indexOf(f.parent);let c,t=f.parent.offset+f.parent.length;if(a>0){const r=b.children[a-1];c=r.offset+r.length}else c=b.offset+1,b.children.length>1&&(t=b.children[1].offset);return A(w,{offset:c,length:t-c,content:""},m)}else return A(w,{offset:f.offset,length:f.length,content:JSON.stringify(y)},m);else{if(y===void 0)return[];const a=`${JSON.stringify(I)}: ${JSON.stringify(y)}`,c=v?v(b.children.map(r=>r.children[0].value)):b.children.length;let t;if(c>0){const r=b.children[c-1];t={offset:r.offset+r.length,length:0,content:","+a}}else b.children.length===0?t={offset:b.offset+1,length:0,content:a}:t={offset:b.offset+1,length:0,content:a+","};return A(w,t,m)}}else if(b.type==="array"&&typeof I=="number"&&Array.isArray(b.children))if(y!==void 0){const f=`${JSON.stringify(y)}`;let a;if(b.children.length===0||I===0)a={offset:b.offset+1,length:0,content:b.children.length===0?f:f+","};else{const c=I===-1||I>b.children.length?b.children.length:I,t=b.children[c-1];a={offset:t.offset+t.length,length:0,content:","+f}}return A(w,a,m)}else{const f=I,a=b.children[f];let c;if(b.children.length===1)c={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===f){const t=b.children[f-1],r=t.offset+t.length,i=b.offset+b.length;c={offset:r,length:i-2-r,content:""}}else c={offset:a.offset,length:b.children[f+1].offset-a.offset,content:""};return A(w,c,m)}else throw new Error(`Can not add ${typeof I!="number"?"index":"property"} to parent of type ${b.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return A(w,{offset:D?D.offset:0,length:D?D.length:0,content:JSON.stringify(y)},m)}}e.setProperty=k;function A(w,n,y){let m=R(w,n),v=n.offset,h=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;v>0&&!(0,L.isEOL)(m,v-1);)v--;for(;h<m.length&&!(0,L.isEOL)(m,h);)h++}const C=(0,L.format)(m,{offset:v,length:h-v},y);for(let b=C.length-1;b>=0;b--){const I=C[b];m=R(m,I),v=Math.min(v,I.offset),h=Math.max(h,I.offset+I.length),h+=I.content.length-I.length}const D=w.length-(m.length-h)-v;return[{offset:v,length:D,content:m.substring(v,h)}]}e.withFormatting=A;function R(w,n){return w.substring(0,n.offset)+n.content+w.substring(n.offset+n.length)}e.applyEdit=R;function S(w,n){let y=n.slice(0).sort((v,h)=>{const C=v.offset-h.offset;return C===0?v.length-h.length:C}),m=w.length;for(let v=y.length-1;v>=0;v--){let h=y[v];if(h.offset+h.length<=m)w=R(w,h);else throw new Error("Overlapping edit");m=h.offset}return w}e.applyEdits=S}),define(Z[2],ee([0,1,65,54]),function(K,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const P=!1;let k=null;function A(i){k=i}if(e.setDisposableTracker=A,P){const i="__is_disposable_tracked__";A(new class{trackDisposable(s){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[i]||console.log(u)},3e3)}setParent(s,u){if(s&&s!==I.None)try{s[i]=!0}catch{}}markAsDisposed(s){if(s&&s!==I.None)try{s[i]=!0}catch{}}markAsSingleton(s){}})}function R(i){return k?.trackDisposable(i),i}function S(i){k?.markAsDisposed(i)}function w(i,s){k?.setParent(i,s)}function n(i,s){if(!!k)for(const u of i)k.setParent(u,s)}function y(i){return k?.markAsSingleton(i),i}e.markAsSingleton=y;class m extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=m;function v(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=v;function h(i){if(L.Iterable.is(i)){let s=[];for(const u of i)if(u)try{u.dispose()}catch(o){s.push(o)}if(s.length===1)throw s[0];if(s.length>1)throw new m(s);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=h;function C(...i){const s=D(()=>h(i));return n(i,s),s}e.combinedDisposable=C;function D(i){const s=R({dispose:(0,p.once)(()=>{S(s),i()})});return s}e.toDisposable=D;class b{constructor(){this._toDispose=new Set,this._isDisposed=!1,R(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return w(s,this),this._isDisposed?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=b,b.DISABLE_DISPOSED_WARNING=!1;class I{constructor(){this._store=new b,R(this),w(this._store,this)}dispose(){S(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=I,I.None=Object.freeze({dispose(){}});class f{constructor(){this._isDisposed=!1,R(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&w(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&w(s,null),s}}e.MutableDisposable=f;class a{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class c{constructor(){this.references=new Map}acquire(s,...u){let o=this.references.get(s);o||(o={counter:0,object:this.createReferencedObject(s,...u)},this.references.set(s,o));const{object:l}=o,g=(0,p.once)(()=>{--o.counter==0&&(this.destroyReferencedObject(s,o.object),this.references.delete(s))});return o.counter++,{object:l,dispose:g}}}e.ReferenceCollection=c;class t{constructor(s){this.referenceCollection=s}async acquire(s,...u){const o=this.referenceCollection.acquire(s,...u);try{return{object:await o.object,dispose:()=>o.dispose()}}catch(l){throw o.dispose(),l}}}e.AsyncReferenceCollection=t;class r{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=r}),define(Z[89],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(k){this.element=k,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class L{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let k=this._first;for(;k!==p.Undefined;){const A=k.next;k.prev=p.Undefined,k.next=p.Undefined,k=A}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,A){const R=new p(k);if(this._first===p.Undefined)this._first=R,this._last=R;else if(A){const w=this._last;this._last=R,R.prev=w,w.next=R}else{const w=this._first;this._first=R,R.next=w,w.prev=R}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(R))}}shift(){if(this._first!==p.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==p.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==p.Undefined&&k.next!==p.Undefined){const A=k.prev;A.next=k.next,k.next.prev=A}else k.prev===p.Undefined&&k.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):k.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):k.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==p.Undefined;)yield k.element,k=k.next}}e.LinkedList=L}),function(){function K(P){const k=[];typeof P=="number"&&k.push("code/timeOrigin",P);function A(S){k.push(S,Date.now())}function R(){const S=[];for(let w=0;w<k.length;w+=2)S.push({name:k[w],startTime:k[w+1]});return S}return{mark:A,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const A of performance.getEntriesByType("mark"))k.push({name:A.name,startTime:Math.round(P+A.startTime)});return k}};if(typeof process=="object"){const P=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function p(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=p(L))}(),define(Z[7],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const p="en";let L=!1,P=!1,k=!1,A=!1,R=!1,S=!1,w=!1,n,y=p,m,v;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const C=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=C&&h?.sandboxed,e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const i=h?.env.VSCODE_BROWSER_CODE_LOADING;if(typeof i=="string")return i==="none"||i==="code"||i==="bypassHeatCheck"||i==="bypassHeatCheckAndEagerCompile"?i:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!C)v=navigator.userAgent,L=v.indexOf("Windows")>=0,P=v.indexOf("Macintosh")>=0,w=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=v.indexOf("Linux")>=0,S=!0,n=navigator.language,y=n;else if(typeof h=="object"){L=h.platform==="win32",P=h.platform==="darwin",k=h.platform==="linux",A=k&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,n=p,y=p;const i=h.env.VSCODE_NLS_CONFIG;if(i)try{const s=JSON.parse(i),u=s.availableLanguages["*"];n=s.locale,y=u||p,m=s._translationsConfigFile}catch(s){}R=!0}else console.error("Unable to resolve platform.");var D;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(D=e.Platform||(e.Platform={}));function b(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let I=0;P?I=1:L?I=3:k&&(I=2),e.isWindows=L,e.isMacintosh=P,e.isLinux=k,e.isLinuxSnap=A,e.isNative=R,e.isWeb=S,e.isIOS=w,e.platform=I,e.userAgent=v,e.language=y;var f;(function(i){function s(){return e.language}i.value=s;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=u;function o(){return e.language==="en"}i.isDefault=o})(f=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=m,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let u=[];e.globals.addEventListener("message",l=>{if(l.data&&l.data.vscodeSetImmediateId)for(let g=0,E=u.length;g<E;g++){const d=u[g];if(d.id===l.data.vscodeSetImmediateId){u.splice(g,1),d.callback();return}}});let o=0;return l=>{const g=++o;u.push({id:g,callback:l}),e.globals.postMessage({vscodeSetImmediateId:g},"*")}}if(typeof h?.nextTick=="function")return h.nextTick.bind(h);const s=Promise.resolve();return u=>s.then(u)}();var a;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=P||w?2:L?1:3;let c=!0,t=!1;function r(){if(!t){t=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,c=new Uint16Array(i.buffer)[0]===(2<<8)+1}return c}e.isLittleEndian=r}),define(Z[34],ee([0,1,7]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof p.globals.vscode!="undefined"&&typeof p.globals.vscode.process!="undefined"){const P=p.globals.vscode.process;L={get platform(){return P.platform},get env(){return P.env},cwd(){return P.cwd()},nextTick(k){return(0,p.setImmediate)(k)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(P){return process.nextTick(P)}}:L={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},nextTick(P){return(0,p.setImmediate)(P)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick}),define(Z[8],ee([0,1,34]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,P=97,k=90,A=122,R=46,S=47,w=92,n=58,y=63;class m extends Error{constructor(a,c,t){let r;typeof c=="string"&&c.indexOf("not ")===0?(r="must not be",c=c.replace(/^not /,"")):r="must be";const i=a.indexOf(".")!==-1?"property":"argument";let s=`The "${a}" ${i} ${r} of type ${c}`;s+=`. Received type ${typeof t}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function v(f,a){if(typeof f!="string")throw new m(a,"string",f)}function h(f){return f===S||f===w}function C(f){return f===S}function D(f){return f>=L&&f<=k||f>=P&&f<=A}function b(f,a,c,t){let r="",i=0,s=-1,u=0,o=0;for(let l=0;l<=f.length;++l){if(l<f.length)o=f.charCodeAt(l);else{if(t(o))break;o=S}if(t(o)){if(!(s===l-1||u===1))if(u===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==R||r.charCodeAt(r.length-2)!==R){if(r.length>2){const g=r.lastIndexOf(c);g===-1?(r="",i=0):(r=r.slice(0,g),i=r.length-1-r.lastIndexOf(c)),s=l,u=0;continue}else if(r.length!==0){r="",i=0,s=l,u=0;continue}}a&&(r+=r.length>0?`${c}..`:"..",i=2)}else r.length>0?r+=`${c}${f.slice(s+1,l)}`:r=f.slice(s+1,l),i=l-s-1;s=l,u=0}else o===R&&u!==-1?++u:u=-1}return r}function I(f,a){if(a===null||typeof a!="object")throw new m("pathObject","Object",a);const c=a.dir||a.root,t=a.base||`${a.name||""}${a.ext||""}`;return c?c===a.root?`${c}${t}`:`${c}${f}${t}`:t}e.win32={resolve(...f){let a="",c="",t=!1;for(let r=f.length-1;r>=-1;r--){let i;if(r>=0){if(i=f[r],v(i,"path"),i.length===0)continue}else a.length===0?i=p.cwd():(i=p.env[`=${a}`]||p.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==a.toLowerCase()&&i.charCodeAt(2)===w)&&(i=`${a}\\`));const s=i.length;let u=0,o="",l=!1;const g=i.charCodeAt(0);if(s===1)h(g)&&(u=1,l=!0);else if(h(g))if(l=!0,h(i.charCodeAt(1))){let E=2,d=E;for(;E<s&&!h(i.charCodeAt(E));)E++;if(E<s&&E!==d){const T=i.slice(d,E);for(d=E;E<s&&h(i.charCodeAt(E));)E++;if(E<s&&E!==d){for(d=E;E<s&&!h(i.charCodeAt(E));)E++;(E===s||E!==d)&&(o=`\\\\${T}\\${i.slice(d,E)}`,u=E)}}}else u=1;else D(g)&&i.charCodeAt(1)===n&&(o=i.slice(0,2),u=2,s>2&&h(i.charCodeAt(2))&&(l=!0,u=3));if(o.length>0)if(a.length>0){if(o.toLowerCase()!==a.toLowerCase())continue}else a=o;if(t){if(a.length>0)break}else if(c=`${i.slice(u)}\\${c}`,t=l,l&&a.length>0)break}return c=b(c,!t,"\\",h),t?`${a}\\${c}`:`${a}${c}`||"."},normalize(f){v(f,"path");const a=f.length;if(a===0)return".";let c=0,t,r=!1;const i=f.charCodeAt(0);if(a===1)return C(i)?"\\":f;if(h(i))if(r=!0,h(f.charCodeAt(1))){let u=2,o=u;for(;u<a&&!h(f.charCodeAt(u));)u++;if(u<a&&u!==o){const l=f.slice(o,u);for(o=u;u<a&&h(f.charCodeAt(u));)u++;if(u<a&&u!==o){for(o=u;u<a&&!h(f.charCodeAt(u));)u++;if(u===a)return`\\\\${l}\\${f.slice(o)}\\`;u!==o&&(t=`\\\\${l}\\${f.slice(o,u)}`,c=u)}}}else c=1;else D(i)&&f.charCodeAt(1)===n&&(t=f.slice(0,2),c=2,a>2&&h(f.charCodeAt(2))&&(r=!0,c=3));let s=c<a?b(f.slice(c),!r,"\\",h):"";return s.length===0&&!r&&(s="."),s.length>0&&h(f.charCodeAt(a-1))&&(s+="\\"),t===void 0?r?`\\${s}`:s:r?`${t}\\${s}`:`${t}${s}`},isAbsolute(f){v(f,"path");const a=f.length;if(a===0)return!1;const c=f.charCodeAt(0);return h(c)||a>2&&D(c)&&f.charCodeAt(1)===n&&h(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let a,c;for(let i=0;i<f.length;++i){const s=f[i];v(s,"path"),s.length>0&&(a===void 0?a=c=s:a+=`\\${s}`)}if(a===void 0)return".";let t=!0,r=0;if(typeof c=="string"&&h(c.charCodeAt(0))){++r;const i=c.length;i>1&&h(c.charCodeAt(1))&&(++r,i>2&&(h(c.charCodeAt(2))?++r:t=!1))}if(t){for(;r<a.length&&h(a.charCodeAt(r));)r++;r>=2&&(a=`\\${a.slice(r)}`)}return e.win32.normalize(a)},relative(f,a){if(v(f,"from"),v(a,"to"),f===a)return"";const c=e.win32.resolve(f),t=e.win32.resolve(a);if(c===t||(f=c.toLowerCase(),a=t.toLowerCase(),f===a))return"";let r=0;for(;r<f.length&&f.charCodeAt(r)===w;)r++;let i=f.length;for(;i-1>r&&f.charCodeAt(i-1)===w;)i--;const s=i-r;let u=0;for(;u<a.length&&a.charCodeAt(u)===w;)u++;let o=a.length;for(;o-1>u&&a.charCodeAt(o-1)===w;)o--;const l=o-u,g=s<l?s:l;let E=-1,d=0;for(;d<g;d++){const O=f.charCodeAt(r+d);if(O!==a.charCodeAt(u+d))break;O===w&&(E=d)}if(d!==g){if(E===-1)return t}else{if(l>g){if(a.charCodeAt(u+d)===w)return t.slice(u+d+1);if(d===2)return t.slice(u+d)}s>g&&(f.charCodeAt(r+d)===w?E=d:d===2&&(E=3)),E===-1&&(E=0)}let T="";for(d=r+E+1;d<=i;++d)(d===i||f.charCodeAt(d)===w)&&(T+=T.length===0?"..":"\\..");return u+=E,T.length>0?`${T}${t.slice(u,o)}`:(t.charCodeAt(u)===w&&++u,t.slice(u,o))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const a=e.win32.resolve(f);if(a.length<=2)return f;if(a.charCodeAt(0)===w){if(a.charCodeAt(1)===w){const c=a.charCodeAt(2);if(c!==y&&c!==R)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(D(a.charCodeAt(0))&&a.charCodeAt(1)===n&&a.charCodeAt(2)===w)return`\\\\?\\${a}`;return f},dirname(f){v(f,"path");const a=f.length;if(a===0)return".";let c=-1,t=0;const r=f.charCodeAt(0);if(a===1)return h(r)?f:".";if(h(r)){if(c=t=1,h(f.charCodeAt(1))){let u=2,o=u;for(;u<a&&!h(f.charCodeAt(u));)u++;if(u<a&&u!==o){for(o=u;u<a&&h(f.charCodeAt(u));)u++;if(u<a&&u!==o){for(o=u;u<a&&!h(f.charCodeAt(u));)u++;if(u===a)return f;u!==o&&(c=t=u+1)}}}}else D(r)&&f.charCodeAt(1)===n&&(c=a>2&&h(f.charCodeAt(2))?3:2,t=c);let i=-1,s=!0;for(let u=a-1;u>=t;--u)if(h(f.charCodeAt(u))){if(!s){i=u;break}}else s=!1;if(i===-1){if(c===-1)return".";i=c}return f.slice(0,i)},basename(f,a){a!==void 0&&v(a,"ext"),v(f,"path");let c=0,t=-1,r=!0,i;if(f.length>=2&&D(f.charCodeAt(0))&&f.charCodeAt(1)===n&&(c=2),a!==void 0&&a.length>0&&a.length<=f.length){if(a===f)return"";let s=a.length-1,u=-1;for(i=f.length-1;i>=c;--i){const o=f.charCodeAt(i);if(h(o)){if(!r){c=i+1;break}}else u===-1&&(r=!1,u=i+1),s>=0&&(o===a.charCodeAt(s)?--s==-1&&(t=i):(s=-1,t=u))}return c===t?t=u:t===-1&&(t=f.length),f.slice(c,t)}for(i=f.length-1;i>=c;--i)if(h(f.charCodeAt(i))){if(!r){c=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":f.slice(c,t)},extname(f){v(f,"path");let a=0,c=-1,t=0,r=-1,i=!0,s=0;f.length>=2&&f.charCodeAt(1)===n&&D(f.charCodeAt(0))&&(a=t=2);for(let u=f.length-1;u>=a;--u){const o=f.charCodeAt(u);if(h(o)){if(!i){t=u+1;break}continue}r===-1&&(i=!1,r=u+1),o===R?c===-1?c=u:s!==1&&(s=1):c!==-1&&(s=-1)}return c===-1||r===-1||s===0||s===1&&c===r-1&&c===t+1?"":f.slice(c,r)},format:I.bind(null,"\\"),parse(f){v(f,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return a;const c=f.length;let t=0,r=f.charCodeAt(0);if(c===1)return h(r)?(a.root=a.dir=f,a):(a.base=a.name=f,a);if(h(r)){if(t=1,h(f.charCodeAt(1))){let E=2,d=E;for(;E<c&&!h(f.charCodeAt(E));)E++;if(E<c&&E!==d){for(d=E;E<c&&h(f.charCodeAt(E));)E++;if(E<c&&E!==d){for(d=E;E<c&&!h(f.charCodeAt(E));)E++;E===c?t=E:E!==d&&(t=E+1)}}}}else if(D(r)&&f.charCodeAt(1)===n){if(c<=2)return a.root=a.dir=f,a;if(t=2,h(f.charCodeAt(2))){if(c===3)return a.root=a.dir=f,a;t=3}}t>0&&(a.root=f.slice(0,t));let i=-1,s=t,u=-1,o=!0,l=f.length-1,g=0;for(;l>=t;--l){if(r=f.charCodeAt(l),h(r)){if(!o){s=l+1;break}continue}u===-1&&(o=!1,u=l+1),r===R?i===-1?i=l:g!==1&&(g=1):i!==-1&&(g=-1)}return u!==-1&&(i===-1||g===0||g===1&&i===u-1&&i===s+1?a.base=a.name=f.slice(s,u):(a.name=f.slice(s,i),a.base=f.slice(s,u),a.ext=f.slice(i,u))),s>0&&s!==t?a.dir=f.slice(0,s-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let a="",c=!1;for(let t=f.length-1;t>=-1&&!c;t--){const r=t>=0?f[t]:p.cwd();v(r,"path"),r.length!==0&&(a=`${r}/${a}`,c=r.charCodeAt(0)===S)}return a=b(a,!c,"/",C),c?`/${a}`:a.length>0?a:"."},normalize(f){if(v(f,"path"),f.length===0)return".";const a=f.charCodeAt(0)===S,c=f.charCodeAt(f.length-1)===S;return f=b(f,!a,"/",C),f.length===0?a?"/":c?"./":".":(c&&(f+="/"),a?`/${f}`:f)},isAbsolute(f){return v(f,"path"),f.length>0&&f.charCodeAt(0)===S},join(...f){if(f.length===0)return".";let a;for(let c=0;c<f.length;++c){const t=f[c];v(t,"path"),t.length>0&&(a===void 0?a=t:a+=`/${t}`)}return a===void 0?".":e.posix.normalize(a)},relative(f,a){if(v(f,"from"),v(a,"to"),f===a||(f=e.posix.resolve(f),a=e.posix.resolve(a),f===a))return"";const c=1,t=f.length,r=t-c,i=1,s=a.length-i,u=r<s?r:s;let o=-1,l=0;for(;l<u;l++){const E=f.charCodeAt(c+l);if(E!==a.charCodeAt(i+l))break;E===S&&(o=l)}if(l===u)if(s>u){if(a.charCodeAt(i+l)===S)return a.slice(i+l+1);if(l===0)return a.slice(i+l)}else r>u&&(f.charCodeAt(c+l)===S?o=l:l===0&&(o=0));let g="";for(l=c+o+1;l<=t;++l)(l===t||f.charCodeAt(l)===S)&&(g+=g.length===0?"..":"/..");return`${g}${a.slice(i+o)}`},toNamespacedPath(f){return f},dirname(f){if(v(f,"path"),f.length===0)return".";const a=f.charCodeAt(0)===S;let c=-1,t=!0;for(let r=f.length-1;r>=1;--r)if(f.charCodeAt(r)===S){if(!t){c=r;break}}else t=!1;return c===-1?a?"/":".":a&&c===1?"//":f.slice(0,c)},basename(f,a){a!==void 0&&v(a,"ext"),v(f,"path");let c=0,t=-1,r=!0,i;if(a!==void 0&&a.length>0&&a.length<=f.length){if(a===f)return"";let s=a.length-1,u=-1;for(i=f.length-1;i>=0;--i){const o=f.charCodeAt(i);if(o===S){if(!r){c=i+1;break}}else u===-1&&(r=!1,u=i+1),s>=0&&(o===a.charCodeAt(s)?--s==-1&&(t=i):(s=-1,t=u))}return c===t?t=u:t===-1&&(t=f.length),f.slice(c,t)}for(i=f.length-1;i>=0;--i)if(f.charCodeAt(i)===S){if(!r){c=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":f.slice(c,t)},extname(f){v(f,"path");let a=-1,c=0,t=-1,r=!0,i=0;for(let s=f.length-1;s>=0;--s){const u=f.charCodeAt(s);if(u===S){if(!r){c=s+1;break}continue}t===-1&&(r=!1,t=s+1),u===R?a===-1?a=s:i!==1&&(i=1):a!==-1&&(i=-1)}return a===-1||t===-1||i===0||i===1&&a===t-1&&a===c+1?"":f.slice(a,t)},format:I.bind(null,"/"),parse(f){v(f,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return a;const c=f.charCodeAt(0)===S;let t;c?(a.root="/",t=1):t=0;let r=-1,i=0,s=-1,u=!0,o=f.length-1,l=0;for(;o>=t;--o){const g=f.charCodeAt(o);if(g===S){if(!u){i=o+1;break}continue}s===-1&&(u=!1,s=o+1),g===R?r===-1?r=o:l!==1&&(l=1):r!==-1&&(l=-1)}if(s!==-1){const g=i===0&&c?1:i;r===-1||l===0||l===1&&r===s-1&&r===i+1?a.base=a.name=f.slice(g,s):(a.name=f.slice(g,r),a.base=f.slice(g,s),a.ext=f.slice(r,s))}return i>0?a.dir=f.slice(0,i-1):c&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var p=e();for(var L in p)(typeof exports=="object"?exports:K)[L]=p[L]}}(typeof self!="undefined"?self:this,function(){return function(K){var e={};function p(L){if(e[L])return e[L].exports;var P=e[L]={i:L,l:!1,exports:{}};return K[L].call(P.exports,P,P.exports,p),P.l=!0,P.exports}return p.m=K,p.c=e,p.d=function(L,P,k){p.o(L,P)||Object.defineProperty(L,P,{enumerable:!0,get:k})},p.r=function(L){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},p.t=function(L,P){if(1&P&&(L=p(L)),8&P||4&P&&typeof L=="object"&&L&&L.__esModule)return L;var k=Object.create(null);if(p.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:L}),2&P&&typeof L!="string")for(var A in L)p.d(k,A,function(R){return L[R]}.bind(null,A));return k},p.n=function(L){var P=L&&L.__esModule?function(){return L.default}:function(){return L};return p.d(P,"a",P),P},p.o=function(L,P){return Object.prototype.hasOwnProperty.call(L,P)},p.p="",p(p.s=0)}([function(K,e,p){(function(L){var P;e=K.exports=Q,P=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],S=e.src=[],w=0,n=w++;S[n]="0|[1-9]\\d*";var y=w++;S[y]="[0-9]+";var m=w++;S[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=w++;S[v]="("+S[n]+")\\.("+S[n]+")\\.("+S[n]+")";var h=w++;S[h]="("+S[y]+")\\.("+S[y]+")\\.("+S[y]+")";var C=w++;S[C]="(?:"+S[n]+"|"+S[m]+")";var D=w++;S[D]="(?:"+S[y]+"|"+S[m]+")";var b=w++;S[b]="(?:-("+S[C]+"(?:\\."+S[C]+")*))";var I=w++;S[I]="(?:-?("+S[D]+"(?:\\."+S[D]+")*))";var f=w++;S[f]="[0-9A-Za-z-]+";var a=w++;S[a]="(?:\\+("+S[f]+"(?:\\."+S[f]+")*))";var c=w++,t="v?"+S[v]+S[b]+"?"+S[a]+"?";S[c]="^"+t+"$";var r="[v=\\s]*"+S[h]+S[I]+"?"+S[a]+"?",i=w++;S[i]="^"+r+"$";var s=w++;S[s]="((?:<|>)?=?)";var u=w++;S[u]=S[y]+"|x|X|\\*";var o=w++;S[o]=S[n]+"|x|X|\\*";var l=w++;S[l]="[v=\\s]*("+S[o]+")(?:\\.("+S[o]+")(?:\\.("+S[o]+")(?:"+S[b]+")?"+S[a]+"?)?)?";var g=w++;S[g]="[v=\\s]*("+S[u]+")(?:\\.("+S[u]+")(?:\\.("+S[u]+")(?:"+S[I]+")?"+S[a]+"?)?)?";var E=w++;S[E]="^"+S[s]+"\\s*"+S[l]+"$";var d=w++;S[d]="^"+S[s]+"\\s*"+S[g]+"$";var T=w++;S[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=w++;S[O]="(?:~>?)";var $=w++;S[$]="(\\s*)"+S[O]+"\\s+",R[$]=new RegExp(S[$],"g");var z=w++;S[z]="^"+S[O]+S[l]+"$";var G=w++;S[G]="^"+S[O]+S[g]+"$";var V=w++;S[V]="(?:\\^)";var U=w++;S[U]="(\\s*)"+S[V]+"\\s+",R[U]=new RegExp(S[U],"g");var M=w++;S[M]="^"+S[V]+S[l]+"$";var F=w++;S[F]="^"+S[V]+S[g]+"$";var j=w++;S[j]="^"+S[s]+"\\s*("+r+")$|^$";var _=w++;S[_]="^"+S[s]+"\\s*("+t+")$|^$";var N=w++;S[N]="(\\s*)"+S[s]+"\\s*("+r+"|"+S[l]+")",R[N]=new RegExp(S[N],"g");var W=w++;S[W]="^\\s*("+S[l]+")\\s+-\\s+("+S[l]+")\\s*$";var x=w++;S[x]="^\\s*("+S[g]+")\\s+-\\s+("+S[g]+")\\s*$";var B=w++;S[B]="(<|>)?=?\\s*\\*";for(var H=0;H<35;H++)P(H,S[H]),R[H]||(R[H]=new RegExp(S[H]));function X(J,re){if(J instanceof Q)return J;if(typeof J!="string"||J.length>k||!(re?R[i]:R[c]).test(J))return null;try{return new Q(J,re)}catch(se){return null}}function Q(J,re){if(J instanceof Q){if(J.loose===re)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof Q))return new Q(J,re);P("SemVer",J,re),this.loose=re;var se=J.trim().match(re?R[i]:R[c]);if(!se)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+se[1],this.minor=+se[2],this.patch=+se[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");se[4]?this.prerelease=se[4].split(".").map(function(me){if(/^[0-9]+$/.test(me)){var ve=+me;if(ve>=0&&ve<A)return ve}return me}):this.prerelease=[],this.build=se[5]?se[5].split("."):[],this.format()}e.parse=X,e.valid=function(J,re){var se=X(J,re);return se?se.version:null},e.clean=function(J,re){var se=X(J.trim().replace(/^[=v]+/,""),re);return se?se.version:null},e.SemVer=Q,Q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Q.prototype.toString=function(){return this.version},Q.prototype.compare=function(J){return P("SemVer.compare",this.version,this.loose,J),J instanceof Q||(J=new Q(J,this.loose)),this.compareMain(J)||this.comparePre(J)},Q.prototype.compareMain=function(J){return J instanceof Q||(J=new Q(J,this.loose)),ne(this.major,J.major)||ne(this.minor,J.minor)||ne(this.patch,J.patch)},Q.prototype.comparePre=function(J){if(J instanceof Q||(J=new Q(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var re=0;do{var se=this.prerelease[re],me=J.prerelease[re];if(P("prerelease compare",re,se,me),se===void 0&&me===void 0)return 0;if(me===void 0)return 1;if(se===void 0)return-1;if(se!==me)return ne(se,me)}while(++re)},Q.prototype.inc=function(J,re){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",re);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",re);break;case"prepatch":this.prerelease.length=0,this.inc("patch",re),this.inc("pre",re);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",re),this.inc("pre",re);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var se=this.prerelease.length;--se>=0;)typeof this.prerelease[se]=="number"&&(this.prerelease[se]++,se=-2);se===-1&&this.prerelease.push(0)}re&&(this.prerelease[0]===re?isNaN(this.prerelease[1])&&(this.prerelease=[re,0]):this.prerelease=[re,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,re,se,me){typeof se=="string"&&(me=se,se=void 0);try{return new Q(J,se).inc(re,me).version}catch(ve){return null}},e.diff=function(J,re){if(pe(J,re))return null;var se=X(J),me=X(re);if(se.prerelease.length||me.prerelease.length){for(var ve in se)if((ve==="major"||ve==="minor"||ve==="patch")&&se[ve]!==me[ve])return"pre"+ve;return"prerelease"}for(var ve in se)if((ve==="major"||ve==="minor"||ve==="patch")&&se[ve]!==me[ve])return ve},e.compareIdentifiers=ne;var ie=/^[0-9]+$/;function ne(J,re){var se=ie.test(J),me=ie.test(re);return se&&me&&(J=+J,re=+re),se&&!me?-1:me&&!se?1:J<re?-1:J>re?1:0}function le(J,re,se){return new Q(J,se).compare(new Q(re,se))}function de(J,re,se){return le(J,re,se)>0}function ye(J,re,se){return le(J,re,se)<0}function pe(J,re,se){return le(J,re,se)===0}function De(J,re,se){return le(J,re,se)!==0}function Te(J,re,se){return le(J,re,se)>=0}function Ne(J,re,se){return le(J,re,se)<=0}function Oe(J,re,se,me){var ve;switch(re){case"===":typeof J=="object"&&(J=J.version),typeof se=="object"&&(se=se.version),ve=J===se;break;case"!==":typeof J=="object"&&(J=J.version),typeof se=="object"&&(se=se.version),ve=J!==se;break;case"":case"=":case"==":ve=pe(J,se,me);break;case"!=":ve=De(J,se,me);break;case">":ve=de(J,se,me);break;case">=":ve=Te(J,se,me);break;case"<":ve=ye(J,se,me);break;case"<=":ve=Ne(J,se,me);break;default:throw new TypeError("Invalid operator: "+re)}return ve}function Le(J,re){if(J instanceof Le){if(J.loose===re)return J;J=J.value}if(!(this instanceof Le))return new Le(J,re);P("comparator",J,re),this.loose=re,this.parse(J),this.semver===_e?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(J,re){return ne(re,J)},e.major=function(J,re){return new Q(J,re).major},e.minor=function(J,re){return new Q(J,re).minor},e.patch=function(J,re){return new Q(J,re).patch},e.compare=le,e.compareLoose=function(J,re){return le(J,re,!0)},e.rcompare=function(J,re,se){return le(re,J,se)},e.sort=function(J,re){return J.sort(function(se,me){return e.compare(se,me,re)})},e.rsort=function(J,re){return J.sort(function(se,me){return e.rcompare(se,me,re)})},e.gt=de,e.lt=ye,e.eq=pe,e.neq=De,e.gte=Te,e.lte=Ne,e.cmp=Oe,e.Comparator=Le;var _e={};function be(J,re){if(J instanceof be)return J.loose===re?J:new be(J.raw,re);if(J instanceof Le)return new be(J.value,re);if(!(this instanceof be))return new be(J,re);if(this.loose=re,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(se){return this.parseRange(se.trim())},this).filter(function(se){return se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function ke(J){return!J||J.toLowerCase()==="x"||J==="*"}function Ye(J,re,se,me,ve,Pe,we,Ae,Ce,Re,Ue,q,te){return((re=ke(se)?"":ke(me)?">="+se+".0.0":ke(ve)?">="+se+"."+me+".0":">="+re)+" "+(Ae=ke(Ce)?"":ke(Re)?"<"+(+Ce+1)+".0.0":ke(Ue)?"<"+Ce+"."+(+Re+1)+".0":q?"<="+Ce+"."+Re+"."+Ue+"-"+q:"<="+Ae)).trim()}function Je(J,re){for(var se=0;se<J.length;se++)if(!J[se].test(re))return!1;if(re.prerelease.length){for(se=0;se<J.length;se++)if(P(J[se].semver),J[se].semver!==_e&&J[se].semver.prerelease.length>0){var me=J[se].semver;if(me.major===re.major&&me.minor===re.minor&&me.patch===re.patch)return!0}return!1}return!0}function xe(J,re,se){try{re=new be(re,se)}catch(me){return!1}return re.test(J)}function je(J,re,se,me){var ve,Pe,we,Ae,Ce;switch(J=new Q(J,me),re=new be(re,me),se){case">":ve=de,Pe=Ne,we=ye,Ae=">",Ce=">=";break;case"<":ve=ye,Pe=Te,we=de,Ae="<",Ce="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(xe(J,re,me))return!1;for(var Re=0;Re<re.set.length;++Re){var Ue=re.set[Re],q=null,te=null;if(Ue.forEach(function(ae){ae.semver===_e&&(ae=new Le(">=0.0.0")),q=q||ae,te=te||ae,ve(ae.semver,q.semver,me)?q=ae:we(ae.semver,te.semver,me)&&(te=ae)}),q.operator===Ae||q.operator===Ce||(!te.operator||te.operator===Ae)&&Pe(J,te.semver)||te.operator===Ce&&we(J,te.semver))return!1}return!0}Le.prototype.parse=function(J){var re=this.loose?R[j]:R[_],se=J.match(re);if(!se)throw new TypeError("Invalid comparator: "+J);this.operator=se[1],this.operator==="="&&(this.operator=""),se[2]?this.semver=new Q(se[2],this.loose):this.semver=_e},Le.prototype.toString=function(){return this.value},Le.prototype.test=function(J){return P("Comparator.test",J,this.loose),this.semver===_e||(typeof J=="string"&&(J=new Q(J,this.loose)),Oe(J,this.operator,this.semver,this.loose))},Le.prototype.intersects=function(J,re){if(!(J instanceof Le))throw new TypeError("a Comparator is required");var se;if(this.operator==="")return se=new be(J.value,re),xe(this.value,se,re);if(J.operator==="")return se=new be(this.value,re),xe(J.semver,se,re);var me=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),Pe=this.semver.version===J.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),Ae=Oe(this.semver,"<",J.semver,re)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),Ce=Oe(this.semver,">",J.semver,re)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return me||ve||Pe&&we||Ae||Ce},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(J){var re=this.loose;J=J.trim(),P("range",J,re);var se=re?R[x]:R[W];J=J.replace(se,Ye),P("hyphen replace",J),J=J.replace(R[N],"$1$2$3"),P("comparator trim",J,R[N]),J=(J=(J=J.replace(R[$],"$1~")).replace(R[U],"$1^")).split(/\s+/).join(" ");var me=re?R[j]:R[_],ve=J.split(" ").map(function(Pe){return function(we,Ae){return P("comp",we),we=function(Ce,Re){return Ce.trim().split(/\s+/).map(function(Ue){return function(q,te){P("caret",q,te);var ae=te?R[F]:R[M];return q.replace(ae,function(ce,oe,he,ge,Se){var ue;return P("caret",q,ce,oe,he,ge,Se),ke(oe)?ue="":ke(he)?ue=">="+oe+".0.0 <"+(+oe+1)+".0.0":ke(ge)?ue=oe==="0"?">="+oe+"."+he+".0 <"+oe+"."+(+he+1)+".0":">="+oe+"."+he+".0 <"+(+oe+1)+".0.0":Se?(P("replaceCaret pr",Se),Se.charAt(0)!=="-"&&(Se="-"+Se),ue=oe==="0"?he==="0"?">="+oe+"."+he+"."+ge+Se+" <"+oe+"."+he+"."+(+ge+1):">="+oe+"."+he+"."+ge+Se+" <"+oe+"."+(+he+1)+".0":">="+oe+"."+he+"."+ge+Se+" <"+(+oe+1)+".0.0"):(P("no pr"),ue=oe==="0"?he==="0"?">="+oe+"."+he+"."+ge+" <"+oe+"."+he+"."+(+ge+1):">="+oe+"."+he+"."+ge+" <"+oe+"."+(+he+1)+".0":">="+oe+"."+he+"."+ge+" <"+(+oe+1)+".0.0"),P("caret return",ue),ue})}(Ue,Re)}).join(" ")}(we,Ae),P("caret",we),we=function(Ce,Re){return Ce.trim().split(/\s+/).map(function(Ue){return function(q,te){var ae=te?R[G]:R[z];return q.replace(ae,function(ce,oe,he,ge,Se){var ue;return P("tilde",q,ce,oe,he,ge,Se),ke(oe)?ue="":ke(he)?ue=">="+oe+".0.0 <"+(+oe+1)+".0.0":ke(ge)?ue=">="+oe+"."+he+".0 <"+oe+"."+(+he+1)+".0":Se?(P("replaceTilde pr",Se),Se.charAt(0)!=="-"&&(Se="-"+Se),ue=">="+oe+"."+he+"."+ge+Se+" <"+oe+"."+(+he+1)+".0"):ue=">="+oe+"."+he+"."+ge+" <"+oe+"."+(+he+1)+".0",P("tilde return",ue),ue})}(Ue,Re)}).join(" ")}(we,Ae),P("tildes",we),we=function(Ce,Re){return P("replaceXRanges",Ce,Re),Ce.split(/\s+/).map(function(Ue){return function(q,te){q=q.trim();var ae=te?R[d]:R[E];return q.replace(ae,function(ce,oe,he,ge,Se,ue){P("xRange",q,ce,oe,he,ge,Se,ue);var Ee=ke(he),Ie=Ee||ke(ge),Fe=Ie||ke(Se);return oe==="="&&Fe&&(oe=""),Ee?ce=oe===">"||oe==="<"?"<0.0.0":"*":oe&&Fe?(Ie&&(ge=0),Fe&&(Se=0),oe===">"?(oe=">=",Ie?(he=+he+1,ge=0,Se=0):Fe&&(ge=+ge+1,Se=0)):oe==="<="&&(oe="<",Ie?he=+he+1:ge=+ge+1),ce=oe+he+"."+ge+"."+Se):Ie?ce=">="+he+".0.0 <"+(+he+1)+".0.0":Fe&&(ce=">="+he+"."+ge+".0 <"+he+"."+(+ge+1)+".0"),P("xRange return",ce),ce})}(Ue,Re)}).join(" ")}(we,Ae),P("xrange",we),we=function(Ce,Re){return P("replaceStars",Ce,Re),Ce.trim().replace(R[B],"")}(we,Ae),P("stars",we),we}(Pe,re)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(Pe){return!!Pe.match(me)})),ve=ve.map(function(Pe){return new Le(Pe,re)})},be.prototype.intersects=function(J,re){if(!(J instanceof be))throw new TypeError("a Range is required");return this.set.some(function(se){return se.every(function(me){return J.set.some(function(ve){return ve.every(function(Pe){return me.intersects(Pe,re)})})})})},e.toComparators=function(J,re){return new be(J,re).set.map(function(se){return se.map(function(me){return me.value}).join(" ").trim().split(" ")})},be.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new Q(J,this.loose));for(var re=0;re<this.set.length;re++)if(Je(this.set[re],J))return!0;return!1},e.satisfies=xe,e.maxSatisfying=function(J,re,se){var me=null,ve=null;try{var Pe=new be(re,se)}catch(we){return null}return J.forEach(function(we){Pe.test(we)&&(me&&ve.compare(we)!==-1||(ve=new Q(me=we,se)))}),me},e.minSatisfying=function(J,re,se){var me=null,ve=null;try{var Pe=new be(re,se)}catch(we){return null}return J.forEach(function(we){Pe.test(we)&&(me&&ve.compare(we)!==1||(ve=new Q(me=we,se)))}),me},e.validRange=function(J,re){try{return new be(J,re).range||"*"}catch(se){return null}},e.ltr=function(J,re,se){return je(J,re,"<",se)},e.gtr=function(J,re,se){return je(J,re,">",se)},e.outside=je,e.prerelease=function(J,re){var se=X(J,re);return se&&se.prerelease.length?se.prerelease:null},e.intersects=function(J,re,se){return J=new be(J,se),re=new be(re,se),J.intersects(re)},e.coerce=function(J){if(J instanceof Q)return J;if(typeof J!="string")return null;var re=J.match(R[T]);return re==null?null:X((re[1]||"0")+"."+(re[2]||"0")+"."+(re[3]||"0"))}}).call(this,p(1))},function(K,e){var p,L,P=K.exports={};function k(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function R(D){if(p===setTimeout)return setTimeout(D,0);if((p===k||!p)&&setTimeout)return p=setTimeout,setTimeout(D,0);try{return p(D,0)}catch(b){try{return p.call(null,D,0)}catch(I){return p.call(this,D,0)}}}(function(){try{p=typeof setTimeout=="function"?setTimeout:k}catch(D){p=k}try{L=typeof clearTimeout=="function"?clearTimeout:A}catch(D){L=A}})();var S,w=[],n=!1,y=-1;function m(){n&&S&&(n=!1,S.length?w=S.concat(w):y=-1,w.length&&v())}function v(){if(!n){var D=R(m);n=!0;for(var b=w.length;b;){for(S=w,w=[];++y<b;)S&&S[y].run();y=-1,b=w.length}S=null,n=!1,function(I){if(L===clearTimeout)return clearTimeout(I);if((L===A||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(I);try{L(I)}catch(f){try{return L.call(null,I)}catch(a){return L.call(this,I)}}}(D)}}function h(D,b){this.fun=D,this.array=b}function C(){}P.nextTick=function(D){var b=new Array(arguments.length-1);if(arguments.length>1)for(var I=1;I<arguments.length;I++)b[I-1]=arguments[I];w.push(new h(D,b)),w.length!==1||n||R(v)},h.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=C,P.addListener=C,P.once=C,P.off=C,P.removeListener=C,P.removeAllListeners=C,P.emit=C,P.prependListener=C,P.prependOnceListener=C,P.listeners=function(D){return[]},P.binding=function(D){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(D){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Z[90],ee([0,1,7]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=p.globals.performance&&typeof p.globals.performance.now=="function";class P{constructor(A){this._highResolution=L&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new P(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=P}),define(Z[3],ee([0,1,11,65,2,89,90]),function(K,e,p,L,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var R;(function(f){f.None=()=>P.Disposable.None;function a(V){return(U,M=null,F)=>{let j=!1,_;return _=V(N=>{if(!j)return _?_.dispose():j=!0,U.call(M,N)},null,F),j&&_.dispose(),_}}f.once=a;function c(V,U){return o((M,F=null,j)=>V(_=>M.call(F,U(_)),null,j))}f.map=c;function t(V,U){return o((M,F=null,j)=>V(_=>{U(_),M.call(F,_)},null,j))}f.forEach=t;function r(V,U){return o((M,F=null,j)=>V(_=>U(_)&&M.call(F,_),null,j))}f.filter=r;function i(V){return V}f.signal=i;function s(...V){return(U,M=null,F)=>(0,P.combinedDisposable)(...V.map(j=>j(_=>U.call(M,_),null,F)))}f.any=s;function u(V,U,M){let F=M;return c(V,j=>(F=U(F,j),F))}f.reduce=u;function o(V){let U;const M=new m({onFirstListenerAdd(){U=V(M.fire,M)},onLastListenerRemove(){U.dispose()}});return M.event}function l(V,U,M=100,F=!1,j){let _,N,W,x=0;const B=new m({leakWarningThreshold:j,onFirstListenerAdd(){_=V(H=>{x++,N=U(N,H),F&&!W&&(B.fire(N),N=void 0),clearTimeout(W),W=setTimeout(()=>{const X=N;N=void 0,W=void 0,(!F||x>1)&&B.fire(X),x=0},M)})},onLastListenerRemove(){_.dispose()}});return B.event}f.debounce=l;function g(V,U=(M,F)=>M===F){let M=!0,F;return r(V,j=>{const _=M||!U(j,F);return M=!1,F=j,_})}f.latch=g;function E(V,U){return[f.filter(V,U),f.filter(V,M=>!U(M))]}f.split=E;function d(V,U=!1,M=[]){let F=M.slice(),j=V(W=>{F?F.push(W):N.fire(W)});const _=()=>{F&&F.forEach(W=>N.fire(W)),F=null},N=new m({onFirstListenerAdd(){j||(j=V(W=>N.fire(W)))},onFirstListenerDidAdd(){F&&(U?setTimeout(_):_())},onLastListenerRemove(){j&&j.dispose(),j=null}});return N.event}f.buffer=d;class T{constructor(U){this.event=U}map(U){return new T(c(this.event,U))}forEach(U){return new T(t(this.event,U))}filter(U){return new T(r(this.event,U))}reduce(U,M){return new T(u(this.event,U,M))}latch(){return new T(g(this.event))}debounce(U,M=100,F=!1,j){return new T(l(this.event,U,M,F,j))}on(U,M,F){return this.event(U,M,F)}once(U,M,F){return a(this.event)(U,M,F)}}function O(V){return new T(V)}f.chain=O;function $(V,U,M=F=>F){const F=(...W)=>N.fire(M(...W)),j=()=>V.on(U,F),_=()=>V.removeListener(U,F),N=new m({onFirstListenerAdd:j,onLastListenerRemove:_});return N.event}f.fromNodeEventEmitter=$;function z(V,U,M=F=>F){const F=(...W)=>N.fire(M(...W)),j=()=>V.addEventListener(U,F),_=()=>V.removeEventListener(U,F),N=new m({onFirstListenerAdd:j,onLastListenerRemove:_});return N.event}f.fromDOMEventEmitter=z;function G(V){return new Promise(U=>a(V)(U))}f.toPromise=G})(R=e.Event||(e.Event={}));class S{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${S._idPool++}`}start(a){this._stopWatch=new A.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let w=-1;function n(f){const a=w;return w=f,{dispose(){w=a}}}e.setGlobalLeakWarningThreshold=n;class y{constructor(a,c=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a){let c=w;if(typeof this.customThreshold=="number"&&(c=this.customThreshold),c<=0||a<c)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(t)||0;if(this._stacks.set(t,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=c*.5;let i,s=0;for(const[u,o]of this._stacks)(!i||s<o)&&(i=u,s=o);console.warn(`[${this.name}] potential listener LEAK detected, having ${a} listeners already. MOST frequent listener (${s}):`),console.warn(i)}return()=>{const i=this._stacks.get(t)||0;this._stacks.set(t,i-1)}}}class m{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=w>0?new y(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(a,c,t)=>{this._listeners||(this._listeners=new k.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(c?[a,c]:a);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,c);const s=this._leakageMon?.check(this._listeners.size),u=(0,P.toDisposable)(()=>{s&&s(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof P.DisposableStore?t.add(u):Array.isArray(t)&&t.push(u),u}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new k.LinkedList);for(let c of this._listeners)this._deliveryQueue.push([c,a]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[c,t]=this._deliveryQueue.shift();try{typeof c=="function"?c.call(void 0,t):c[0].call(c[1],t)}catch(r){(0,p.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=m;class v extends m{async fireAsync(a,c,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,a]);for(;this._asyncDeliveryQueue.size>0&&!c.isCancellationRequested;){const[r,i]=this._asyncDeliveryQueue.shift(),s=[],u={...i,waitUntil:o=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");t&&(o=t(o,typeof r=="function"?r:r[0])),s.push(o)}};try{typeof r=="function"?r.call(void 0,u):r[0].call(r[1],u)}catch(o){(0,p.onUnexpectedError)(o);continue}Object.freeze(s),await Promise.allSettled(s).then(o=>{for(const l of o)l.status==="rejected"&&(0,p.onUnexpectedError)(l.reason)})}}}}e.AsyncEmitter=v;class h extends m{constructor(a){super(a);this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=h;class C extends h{constructor(a){super(a);this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=C;class D{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const c={event:a,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const t=()=>{this.hasListeners&&this.unhook(c);const r=this.events.indexOf(c);this.events.splice(r,1)};return(0,P.toDisposable)((0,L.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(c=>this.emitter.fire(c))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=D;class b{constructor(){this.buffers=[]}wrapEvent(a){return(c,t,r)=>a(i=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>c.call(t,i)):c.call(t,i)},void 0,r)}bufferEvents(a){const c=[];this.buffers.push(c);const t=a();return this.buffers.pop(),c.forEach(r=>r()),t}}e.EventBufferer=b;class I{constructor(){this.listening=!1,this.inputEvent=R.None,this.inputEventListener=P.Disposable.None,this.emitter=new m({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=I}),define(Z[29],ee([0,1,3]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(R,S){const w=setTimeout(R.bind(S),0);return{dispose(){clearTimeout(w)}}});var P;(function(R){function S(w){return w===R.None||w===R.Cancelled||w instanceof k?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}R.isCancellationToken=S,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(P=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=P.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=P.None}}e.CancellationTokenSource=A}),define(Z[55],ee([0,1,3]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new p.Emitter}add(y){const m=this._icons.get(y.id);m?y.description?m.description=y.description:console.error(`Duplicate registration of codicon ${y.id}`):(this._icons.set(y.id,y),this._onDidRegister.fire(y))}get(y){return this._icons.get(y)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const P=new L;e.iconRegistry=P;function k(n,y){return new R(n,y)}e.registerCodicon=k;function A(n){return n?n.replace(/\$\((.*?)\)/g,(y,m)=>` ${m} `).trim():""}e.getCodiconAriaLabel=A;class R{constructor(y,m,v){this.id=y,this.definition=m,this.description=v,P.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=R;function S(n,y){const m=["codicon","codicon-"+n];return y&&m.push("codicon-modifier-"+y),m}e.getClassNamesArray=S;var w;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const y=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function m(C){if(C instanceof R)return["codicon","codicon-"+C.id];const D=y.exec(C.id);if(!D)return m(R.error);let[,b,I]=D;const f=["codicon","codicon-"+b];return I&&f.push("codicon-modifier-"+I.substr(1)),f}n.asClassNameArray=m;function v(C){return m(C).join(" ")}n.asClassName=v;function h(C){return"."+m(C).join(".")}n.asCSSSelector=h})(w=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(R=e.Codicon||(e.Codicon={}))}),define(Z[48],ee([0,1,11,2]),function(K,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function P(f){const a=f;return a?[a.on,a.pause,a.resume,a.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=P;function k(f){const a=f;return a?P(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=k;function A(f,a){return new R(f,a)}e.newWriteableStream=A;class R{constructor(a,c){this.reducer=a,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(c=>c(a))}emitError(a){this.listeners.error.length===0?(0,p.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(c=>c(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,c){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(a,c){if(this.state.destroyed)return;let t;switch(a){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(c);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(f,a){const c=[];let t;for(;(t=f.read())!==null;)c.push(t);return a(c)}e.consumeReadable=S;function w(f,a,c){const t=[];let r;for(;(r=f.read())!==null&&t.length<c;)t.push(r);return r===null&&t.length>0?a(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const i=r;return r=void 0,i}return f.read()}}}e.peekReadable=w;function n(f,a){return new Promise((c,t)=>{const r=[];y(f,{onData:i=>{a&&r.push(i)},onError:i=>{a?t(i):c(void 0)},onEnd:()=>{c(a?a(r):void 0)}})})}e.consumeStream=n;function y(f,a){f.on("error",c=>a.onError(c)),f.on("end",()=>a.onEnd()),f.on("data",c=>a.onData(c))}e.listenStream=y;function m(f,a){return new Promise((c,t)=>{const r=new L.DisposableStore,i=[],s=l=>{if(i.push(l),i.length>a)return r.dispose(),f.pause(),c({stream:f,buffer:i,ended:!1})},u=l=>t(l),o=()=>c({stream:f,buffer:i,ended:!0});r.add((0,L.toDisposable)(()=>f.removeListener("error",u))),f.on("error",u),r.add((0,L.toDisposable)(()=>f.removeListener("end",o))),f.on("end",o),r.add((0,L.toDisposable)(()=>f.removeListener("data",s))),f.on("data",s)})}e.peekStream=m;function v(f,a){const c=A(a);return c.end(f),c}e.toStream=v;function h(){const f=A(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=h;function C(f){let a=!1;return{read:()=>a?null:(a=!0,f)}}e.toReadable=C;function D(f,a,c){const t=A(c);return y(f,{onData:r=>t.write(a.data(r)),onError:r=>t.error(a.error?a.error(r):r),onEnd:()=>t.end()}),t}e.transform=D;function b(f,a,c){let t=!1;return{read:()=>{const r=a.read();return t?r:(t=!0,r!==null?c([f,r]):f)}}}e.prefixedReadable=b;function I(f,a,c){let t=!1;const r=A(c);return y(a,{onData:i=>t?r.write(i):(t=!0,r.write(c([f,i]))),onError:i=>r.error(i),onEnd:()=>{t||(t=!0,r.write(f)),r.end()}}),r}e.prefixedStream=I}),define(Z[19],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function p(q){return!q||typeof q!="string"?!0:q.trim().length===0}e.isFalsyOrWhitespace=p;const L=/{(\d+)}/g;function P(q,...te){return te.length===0?q:q.replace(L,function(ae,ce){const oe=parseInt(ce,10);return isNaN(oe)||oe<0||oe>=te.length?ae:te[oe]})}e.format=P;const k=/{([^}]+)}/g;function A(q,te){return q.replace(k,(ae,ce)=>te[ce]??ae)}e.format2=A;function R(q){return q.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=R;function S(q){return q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function w(q,te){let ae=0;const ce=te.charCodeAt(0);for(let oe=q.length-1;oe>=0;oe--)q.charCodeAt(oe)===ce&&ae++;return ae}e.count=w;function n(q,te,ae="\u2026"){return q.length<=te?q:`${q.substr(0,te)}${ae}`}e.truncate=n;function y(q,te=" "){const ae=m(q,te);return v(ae,te)}e.trim=y;function m(q,te){if(!q||!te)return q;const ae=te.length;if(ae===0||q.length===0)return q;let ce=0;for(;q.indexOf(te,ce)===ce;)ce=ce+ae;return q.substring(ce)}e.ltrim=m;function v(q,te){if(!q||!te)return q;const ae=te.length,ce=q.length;if(ae===0||ce===0)return q;let oe=ce,he=-1;for(;he=q.lastIndexOf(te,oe-1),!(he===-1||he+ae!==oe);){if(he===0)return"";oe=he}return q.substring(0,oe)}e.rtrim=v;function h(q){return q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function C(q){return q.replace(/\*/g,"")}e.stripWildcards=C;function D(q,te,ae={}){if(!q)throw new Error("Cannot create regex from empty string");te||(q=S(q)),ae.wholeWord&&(/\B/.test(q.charAt(0))||(q="\\b"+q),/\B/.test(q.charAt(q.length-1))||(q=q+"\\b"));let ce="";return ae.global&&(ce+="g"),ae.matchCase||(ce+="i"),ae.multiline&&(ce+="m"),ae.unicode&&(ce+="u"),new RegExp(q,ce)}e.createRegExp=D;function b(q){return q.source==="^"||q.source==="^$"||q.source==="$"||q.source==="^\\s*$"?!1:!!(q.exec("")&&q.lastIndex===0)}e.regExpLeadsToEndlessLoop=b;function I(q){return!!q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=I;function f(q){return(q.global?"g":"")+(q.ignoreCase?"i":"")+(q.multiline?"m":"")+(q.unicode?"u":"")}e.regExpFlags=f;function a(q){return q.split(/\r\n|\r|\n/)}e.splitLines=a;function c(q){for(let te=0,ae=q.length;te<ae;te++){const ce=q.charCodeAt(te);if(ce!==32&&ce!==9)return te}return-1}e.firstNonWhitespaceIndex=c;function t(q,te=0,ae=q.length){for(let ce=te;ce<ae;ce++){const oe=q.charCodeAt(ce);if(oe!==32&&oe!==9)return q.substring(te,ce)}return q.substring(te,ae)}e.getLeadingWhitespace=t;function r(q,te=q.length-1){for(let ae=te;ae>=0;ae--){const ce=q.charCodeAt(ae);if(ce!==32&&ce!==9)return ae}return-1}e.lastNonWhitespaceIndex=r;function i(q,te){return q<te?-1:q>te?1:0}e.compare=i;function s(q,te,ae=0,ce=q.length,oe=0,he=te.length){for(;ae<ce&&oe<he;ae++,oe++){let ue=q.charCodeAt(ae),Ee=te.charCodeAt(oe);if(ue<Ee)return-1;if(ue>Ee)return 1}const ge=ce-ae,Se=he-oe;return ge<Se?-1:ge>Se?1:0}e.compareSubstring=s;function u(q,te){return o(q,te,0,q.length,0,te.length)}e.compareIgnoreCase=u;function o(q,te,ae=0,ce=q.length,oe=0,he=te.length){for(;ae<ce&&oe<he;ae++,oe++){let ue=q.charCodeAt(ae),Ee=te.charCodeAt(oe);if(ue===Ee)continue;const Ie=ue-Ee;if(!(Ie===32&&g(Ee))&&!(Ie===-32&&g(ue)))return l(ue)&&l(Ee)?Ie:s(q.toLowerCase(),te.toLowerCase(),ae,ce,oe,he)}const ge=ce-ae,Se=he-oe;return ge<Se?-1:ge>Se?1:0}e.compareSubstringIgnoreCase=o;function l(q){return q>=97&&q<=122}e.isLowerAsciiLetter=l;function g(q){return q>=65&&q<=90}e.isUpperAsciiLetter=g;function E(q){return l(q)||g(q)}function d(q,te){return q.length===te.length&&T(q,te)}e.equalsIgnoreCase=d;function T(q,te,ae=q.length){for(let ce=0;ce<ae;ce++){const oe=q.charCodeAt(ce),he=te.charCodeAt(ce);if(oe!==he){if(E(oe)&&E(he)){const ge=Math.abs(oe-he);if(ge!==0&&ge!==32)return!1}else if(String.fromCharCode(oe).toLowerCase()!==String.fromCharCode(he).toLowerCase())return!1}}return!0}function O(q,te){const ae=te.length;return te.length>q.length?!1:T(q,te,ae)}e.startsWithIgnoreCase=O;function $(q,te){let ae,ce=Math.min(q.length,te.length);for(ae=0;ae<ce;ae++)if(q.charCodeAt(ae)!==te.charCodeAt(ae))return ae;return ce}e.commonPrefixLength=$;function z(q,te){let ae,ce=Math.min(q.length,te.length);const oe=q.length-1,he=te.length-1;for(ae=0;ae<ce;ae++)if(q.charCodeAt(oe-ae)!==te.charCodeAt(he-ae))return ae;return ce}e.commonSuffixLength=z;function G(q){return 55296<=q&&q<=56319}e.isHighSurrogate=G;function V(q){return 56320<=q&&q<=57343}e.isLowSurrogate=V;function U(q,te){return(q-55296<<10)+(te-56320)+65536}e.computeCodePoint=U;function M(q,te,ae){const ce=q.charCodeAt(ae);if(G(ce)&&ae+1<te){const oe=q.charCodeAt(ae+1);if(V(oe))return U(ce,oe)}return ce}e.getNextCodePoint=M;function F(q,te){const ae=q.charCodeAt(te-1);if(V(ae)&&te>1){const ce=q.charCodeAt(te-2);if(G(ce))return U(ce,ae)}return ae}function j(q,te){const ae=ve.getInstance(),ce=te,oe=q.length,he=M(q,oe,te);te+=he>=65536?2:1;let ge=ae.getGraphemeBreakType(he);for(;te<oe;){const Se=M(q,oe,te),ue=ae.getGraphemeBreakType(Se);if(se(ge,ue))break;te+=Se>=65536?2:1,ge=ue}return te-ce}e.nextCharLength=j;function _(q,te){const ae=ve.getInstance(),ce=te,oe=F(q,te);te-=oe>=65536?2:1;let he=ae.getGraphemeBreakType(oe);for(;te>0;){const ge=F(q,te),Se=ae.getGraphemeBreakType(ge);if(se(Se,he))break;te-=ge>=65536?2:1,he=Se}return ce-te}e.prevCharLength=_;function N(q,te){const ae=ve.getInstance(),ce=q.length,oe=te,he=M(q,ce,te),ge=ae.getGraphemeBreakType(he);te+=he>=65536?2:1;let Se=ge;for(;te<ce;){const Ee=M(q,ce,te),Ie=ae.getGraphemeBreakType(Ee);if(se(Se,Ie))break;te+=Ee>=65536?2:1,Se=Ie}const ue=te;for(te=oe,Se=ge;te>0;){const Ee=F(q,te),Ie=ae.getGraphemeBreakType(Ee);if(se(Ie,Se))break;te-=Ee>=65536?2:1,Se=Ie}return[te,ue]}function W(q,te){return te>0&&V(q.charCodeAt(te))?N(q,te-1):N(q,te)}e.getCharContainingOffset=W;function x(q){const te=q.length;let ae=0,ce=0;for(;ce<te;){const ge=M(q,te,ce);ce+=ge>=65536?2:1,ge<128?ae+=1:ge<2048?ae+=2:ge<65536?ae+=3:ae+=4}const oe=new Uint8Array(ae);ce=0;let he=0;for(;ce<te;){const ge=M(q,te,ce);ce+=ge>=65536?2:1,ge<128?oe[he++]=ge:ge<2048?(oe[he++]=192|(ge&1984)>>>6,oe[he++]=128|(ge&63)>>>0):ge<65536?(oe[he++]=224|(ge&61440)>>>12,oe[he++]=128|(ge&4032)>>>6,oe[he++]=128|(ge&63)>>>0):(oe[he++]=240|(ge&1835008)>>>18,oe[he++]=128|(ge&258048)>>>12,oe[he++]=128|(ge&4032)>>>6,oe[he++]=128|(ge&63)>>>0)}return oe}e.encodeUTF8=x;function B(q){const te=q.byteLength,ae=[];let ce=0;for(;ce<te;){const oe=q[ce];let he;if(oe>=240&&ce+3<te?he=(q[ce++]&7)<<18>>>0|(q[ce++]&63)<<12>>>0|(q[ce++]&63)<<6>>>0|(q[ce++]&63)<<0>>>0:oe>=224&&ce+2<te?he=(q[ce++]&15)<<12>>>0|(q[ce++]&63)<<6>>>0|(q[ce++]&63)<<0>>>0:oe>=192&&ce+1<te?he=(q[ce++]&31)<<6>>>0|(q[ce++]&63)<<0>>>0:he=q[ce++],he>=0&&he<=55295||he>=57344&&he<=65535)ae.push(String.fromCharCode(he));else if(he>=65536&&he<=1114111){const ge=he-65536,Se=55296+((ge&1047552)>>>10),ue=56320+((ge&1023)>>>0);ae.push(String.fromCharCode(Se)),ae.push(String.fromCharCode(ue))}else ae.push(String.fromCharCode(65533))}return ae.join("")}e.decodeUTF8=B;const H=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function X(q){return H.test(q)}e.containsRTL=X;const Q=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function ie(q){return Q.test(q)}e.containsEmoji=ie;const ne=/^[\t\n\r\x20-\x7E]*$/;function le(q){return ne.test(q)}e.isBasicASCII=le,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function de(q){return e.UNUSUAL_LINE_TERMINATORS.test(q)}e.containsUnusualLineTerminators=de;function ye(q){for(let te=0,ae=q.length;te<ae;te++)if(pe(q.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=ye;function pe(q){return q=+q,q>=11904&&q<=55215||q>=63744&&q<=64255||q>=65281&&q<=65374}e.isFullWidthCharacter=pe;function De(q){return q>=127462&&q<=127487||q===8986||q===8987||q===9200||q===9203||q>=9728&&q<=10175||q===11088||q===11093||q>=127744&&q<=128591||q>=128640&&q<=128764||q>=128992&&q<=129003||q>=129280&&q<=129535||q>=129648&&q<=129750}e.isEmojiImprecise=De;function Te(q,te){if(q.length<te)return q;const ae=/\b/g;let ce=0;for(;ae.test(q)&&!(q.length-ae.lastIndex<te);)ce=ae.lastIndex,ae.lastIndex+=1;return q.substring(ce).replace(/^\s/,"")}e.lcut=Te;const Ne=/\x1B\x5B[12]?K/g,Oe=/\x1b\[\d+m/g,Le=/\x1b\[0?m/g;function _e(q){return q&&(q=q.replace(Ne,""),q=q.replace(Oe,""),q=q.replace(Le,"")),q}e.removeAnsiEscapeCodes=_e,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function be(q){return!!(q&&q.length>0&&q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=be;function ke(q){return be(q)?q.substr(1):q}e.stripUTF8BOM=ke;function Ye(q,te){if(!q||!te||q.length<te.length)return!1;const ae=te.length,ce=q.toLowerCase();let oe=0,he=-1;for(;oe<ae;){const ge=ce.indexOf(te[oe],he+1);if(ge<0)return!1;he=ge,oe++}return!0}e.fuzzyContains=Ye;function Je(q,te=!1){return q?(te&&(q=q.replace(/\\./g,"")),q.toLowerCase()!==q):!1}e.containsUppercaseCharacter=Je;function xe(q){return q.charAt(0).toUpperCase()+q.slice(1)}e.uppercaseFirstLetter=xe;function je(q,te=1){if(te===0)return"";let ae=-1;do ae=q.indexOf(`
`,ae+1),te--;while(te>0&&ae>=0);return ae===-1?q:(q[ae-1]==="\r"&&ae--,q.substr(0,ae))}e.getNLines=je;function J(q){const te=90-65+1;return q=q%(2*te),q<te?String.fromCharCode(97+q):String.fromCharCode(65+q-te)}e.singleLetterHash=J;function re(q){return ve.getInstance().getGraphemeBreakType(q)}e.getGraphemeBreakType=re;function se(q,te){return q===0?te!==5&&te!==7:q===2&&te===3?!1:q===4||q===2||q===3||te===4||te===2||te===3?!0:!(q===8&&(te===8||te===9||te===11||te===12)||(q===11||q===9)&&(te===9||te===10)||(q===12||q===10)&&te===10||te===5||te===13||te===7||q===1||q===13&&te===14||q===6&&te===6)}e.breakBetweenGraphemeBreakType=se;var me;(function(q){q[q.Other=0]="Other",q[q.Prepend=1]="Prepend",q[q.CR=2]="CR",q[q.LF=3]="LF",q[q.Control=4]="Control",q[q.Extend=5]="Extend",q[q.Regional_Indicator=6]="Regional_Indicator",q[q.SpacingMark=7]="SpacingMark",q[q.L=8]="L",q[q.V=9]="V",q[q.T=10]="T",q[q.LV=11]="LV",q[q.LVT=12]="LVT",q[q.ZWJ=13]="ZWJ",q[q.Extended_Pictographic=14]="Extended_Pictographic"})(me=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ve{constructor(){this._data=Pe()}static getInstance(){return ve._INSTANCE||(ve._INSTANCE=new ve),ve._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const ae=this._data,ce=ae.length/3;let oe=1;for(;oe<=ce;)if(te<ae[3*oe])oe=2*oe;else if(te>ae[3*oe+1])oe=2*oe+1;else return ae[3*oe+2];return 0}}ve._INSTANCE=null;function Pe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function we(q,te){if(q===0)return 0;const ae=Ae(q,te);if(ae!==void 0)return ae;const ce=F(te,q);return q-=Ce(ce),q}e.getLeftDeleteOffset=we;function Ae(q,te){let ae=F(te,q);for(q-=Ce(ae);Re(ae)||ae===65039||ae===8419;){if(q===0)return;ae=F(te,q),q-=Ce(ae)}if(!!De(ae)){if(q>=0){const ce=F(te,q);ce===8205&&(q-=Ce(ce))}return q}}function Ce(q){return q>=65536?2:1}function Re(q){return 127995<=q&&q<=127999}var Ue;(function(q){q[q.zwj=8205]="zwj",q[q.emojiVariantSelector=65039]="emojiVariantSelector",q[q.enclosingKeyCap=8419]="enclosingKeyCap"})(Ue||(Ue={}))}),define(Z[25],ee([0,1,19,48]),function(K,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const P=typeof Buffer!="undefined",k=typeof TextEncoder!="undefined",A=typeof TextDecoder!="undefined";let R,S;class w{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return P?new w(Buffer.allocUnsafe(l)):new w(new Uint8Array(l))}static wrap(l){return P&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new w(l)}static fromString(l,g){return!(g?.dontUseNodeBuffer||!1)&&P?new w(Buffer.from(l)):k?(R||(R=new TextEncoder),new w(R.encode(l))):new w(p.encodeUTF8(l))}static concat(l,g){if(typeof g=="undefined"){g=0;for(let T=0,O=l.length;T<O;T++)g+=l[T].byteLength}const E=w.alloc(g);let d=0;for(let T=0,O=l.length;T<O;T++){const $=l[T];E.set($,d),d+=$.byteLength}return E}toString(){return P?this.buffer.toString():A?(S||(S=new TextDecoder),S.decode(this.buffer)):p.decodeUTF8(this.buffer)}slice(l,g){return new w(this.buffer.subarray(l,g))}set(l,g){l instanceof w?this.buffer.set(l.buffer,g):this.buffer.set(l,g)}readUInt32BE(l){return m(this.buffer,l)}writeUInt32BE(l,g){v(this.buffer,l,g)}readUInt32LE(l){return h(this.buffer,l)}writeUInt32LE(l,g){C(this.buffer,l,g)}readUInt8(l){return D(this.buffer,l)}writeUInt8(l,g){b(this.buffer,l,g)}}e.VSBuffer=w;function n(o,l){return o[l+0]<<0>>>0|o[l+1]<<8>>>0}e.readUInt16LE=n;function y(o,l,g){o[g+0]=l&255,l=l>>>8,o[g+1]=l&255}e.writeUInt16LE=y;function m(o,l){return o[l]*2**24+o[l+1]*2**16+o[l+2]*2**8+o[l+3]}e.readUInt32BE=m;function v(o,l,g){o[g+3]=l,l=l>>>8,o[g+2]=l,l=l>>>8,o[g+1]=l,l=l>>>8,o[g]=l}e.writeUInt32BE=v;function h(o,l){return o[l+0]<<0>>>0|o[l+1]<<8>>>0|o[l+2]<<16>>>0|o[l+3]<<24>>>0}e.readUInt32LE=h;function C(o,l,g){o[g+0]=l&255,l=l>>>8,o[g+1]=l&255,l=l>>>8,o[g+2]=l&255,l=l>>>8,o[g+3]=l&255}e.writeUInt32LE=C;function D(o,l){return o[l]}e.readUInt8=D;function b(o,l,g){o[g]=l}e.writeUInt8=b;function I(o){return L.consumeReadable(o,l=>w.concat(l))}e.readableToBuffer=I;function f(o){return L.toReadable(o)}e.bufferToReadable=f;function a(o){return L.consumeStream(o,l=>w.concat(l))}e.streamToBuffer=a;async function c(o){return o.ended?w.concat(o.buffer):w.concat([...o.buffer,await a(o.stream)])}e.bufferedStreamToBuffer=c;function t(o){return L.toStream(o,l=>w.concat(l))}e.bufferToStream=t;function r(o){return L.transform(o,{data:l=>typeof l=="string"?w.fromString(l):w.wrap(l)},l=>w.concat(l))}e.streamToBufferReadableStream=r;function i(o){return L.newWriteableStream(l=>w.concat(l),o)}e.newWriteableBufferStream=i;function s(o,l){return L.prefixedReadable(o,l,g=>w.concat(g))}e.prefixedBufferReadable=s;function u(o,l){return L.prefixedStream(o,l,g=>w.concat(g))}e.prefixedBufferStream=u}),define(Z[16],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(l){return Array.isArray(l)}e.isArray=p;function L(l){return typeof l=="string"}e.isString=L;function P(l){return Array.isArray(l)&&l.every(g=>L(g))}e.isStringArray=P;function k(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.isObject=k;function A(l){return typeof l=="number"&&!isNaN(l)}e.isNumber=A;function R(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.isIterable=R;function S(l){return l===!0||l===!1}e.isBoolean=S;function w(l){return typeof l=="undefined"}e.isUndefined=w;function n(l){return!y(l)}e.isDefined=n;function y(l){return w(l)||l===null}e.isUndefinedOrNull=y;function m(l,g){if(!l)throw new Error(g?`Unexpected type, expected '${g}'`:"Unexpected type")}e.assertType=m;function v(l){if(y(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.assertIsDefined=v;function h(...l){const g=[];for(let E=0;E<l.length;E++){const d=l[E];if(y(d))throw new Error(`Assertion Failed: argument at index ${E} is undefined or null`);g.push(d)}return g}e.assertAllDefined=h;const C=Object.prototype.hasOwnProperty;function D(l){if(!k(l))return!1;for(let g in l)if(C.call(l,g))return!1;return!0}e.isEmptyObject=D;function b(l){return typeof l=="function"}e.isFunction=b;function I(...l){return l.length>0&&l.every(b)}e.areFunctions=I;function f(l,g){const E=Math.min(l.length,g.length);for(let d=0;d<E;d++)a(l[d],g[d])}e.validateConstraints=f;function a(l,g){if(L(g)){if(typeof l!==g)throw new Error(`argument does not match constraint: typeof ${g}`)}else if(b(g)){try{if(l instanceof g)return}catch{}if(!y(l)&&l.constructor===g||g.length===1&&g.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function c(l){let g=[],E=Object.getPrototypeOf(l);for(;Object.prototype!==E;)g=g.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return g}e.getAllPropertyNames=c;function t(l){const g=[];for(const E of c(l))typeof l[E]=="function"&&g.push(E);return g}e.getAllMethodNames=t;function r(l,g){const E=T=>function(){const O=Array.prototype.slice.call(arguments,0);return g(T,O)};let d={};for(const T of l)d[T]=E(T);return d}e.createProxyObject=r;function i(l){return l===null?void 0:l}e.withNullAsUndefined=i;function s(l){return typeof l=="undefined"?null:l}e.withUndefinedAsNull=s;function u(l){return class{constructor(){return new Proxy({},{get(g,E){if(g[E])return g[E];throw new Error(`Not Implemented: ${l}->${String(E)}`)}})}}}e.NotImplementedProxy=u;function o(l,g="Unreachable"){throw new Error(g)}e.assertNever=o}),define(Z[41],ee([0,1,7,19,8,16]),function(K,e,p,L,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(i){return i===47||i===92}e.isPathSeparator=A;function R(i){return i.replace(/[\\/]/g,P.posix.sep)}e.toSlashes=R;function S(i){return i.indexOf("/")===-1&&(i=R(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=S;function w(i,s=P.posix.sep){if(!i)return"";const u=i.length,o=i.charCodeAt(0);if(A(o)){if(A(i.charCodeAt(1))&&!A(i.charCodeAt(2))){let g=3;const E=g;for(;g<u&&!A(i.charCodeAt(g));g++);if(E!==g&&!A(i.charCodeAt(g+1))){for(g+=1;g<u;g++)if(A(i.charCodeAt(g)))return i.slice(0,g+1).replace(/[\\/]/g,s)}}return s}else if(b(o)&&i.charCodeAt(1)===58)return A(i.charCodeAt(2))?i.slice(0,2)+s:i.slice(0,2);let l=i.indexOf("://");if(l!==-1){for(l+=3;l<u;l++)if(A(i.charCodeAt(l)))return i.slice(0,l+1)}return""}e.getRoot=w;function n(i){if(!p.isWindows||!i||i.length<5)return!1;let s=i.charCodeAt(0);if(s!==92||(s=i.charCodeAt(1),s!==92))return!1;let u=2;const o=u;for(;u<i.length&&(s=i.charCodeAt(u),s!==92);u++);return!(o===u||(s=i.charCodeAt(u+1),isNaN(s)||s===92))}e.isUNC=n;const y=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(i,s=p.isWindows){const u=s?y:m;return!(!i||i.length===0||/^\s+$/.test(i)||(u.lastIndex=0,u.test(i))||s&&v.test(i)||i==="."||i===".."||s&&i[i.length-1]==="."||s&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=h;function C(i,s,u){const o=i===s;return!u||o?o:!i||!s?!1:(0,L.equalsIgnoreCase)(i,s)}e.isEqual=C;function D(i,s,u,o=P.sep){if(i===s)return!0;if(!i||!s||s.length>i.length)return!1;if(u){if(!(0,L.startsWithIgnoreCase)(i,s))return!1;if(s.length===i.length)return!0;let g=s.length;return s.charAt(s.length-1)===o&&g--,i.charAt(g)===o}return s.charAt(s.length-1)!==o&&(s+=o),i.indexOf(s)===0}e.isEqualOrParent=D;function b(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=b;function I(i,s){return p.isWindows&&i.endsWith(":")&&(i+=P.sep),(0,P.isAbsolute)(i)||(i=(0,P.join)(s,i)),i=(0,P.normalize)(i),p.isWindows?(i=(0,L.rtrim)(i,P.sep),i.endsWith(":")&&(i+=P.sep)):(i=(0,L.rtrim)(i,P.sep),i||(i=P.sep)),i}e.sanitizeFilePath=I;function f(i){const s=(0,P.normalize)(i);return p.isWindows?i.length>3?!1:a(s)&&(i.length===2||s.charCodeAt(2)===92):s===P.posix.sep}e.isRootOrDriveLetter=f;function a(i){return p.isWindows?b(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function c(i){return a(i)?i[0]:void 0}e.getDriveLetter=c;function t(i,s,u){return s.length>i.length?-1:i===s?0:(u&&(i=i.toLowerCase(),s=s.toLowerCase()),i.indexOf(s))}e.indexOfPath=t;function r(i){const s=i.split(":");let u,o,l;if(s.forEach(g=>{const E=Number(g);(0,k.isNumber)(E)?o===void 0?o=E:l===void 0&&(l=E):u=u?[u,g].join(":"):g}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:o!==void 0?o:void 0,column:l!==void 0?l:o!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(Z[26],ee([0,1,16]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(C){if(!C||typeof C!="object"||C instanceof RegExp)return C;const D=Array.isArray(C)?[]:{};return Object.keys(C).forEach(b=>{C[b]&&typeof C[b]=="object"?D[b]=L(C[b]):D[b]=C[b]}),D}e.deepClone=L;function P(C){if(!C||typeof C!="object")return C;const D=[C];for(;D.length>0;){const b=D.shift();Object.freeze(b);for(const I in b)if(k.call(b,I)){const f=b[I];typeof f=="object"&&!Object.isFrozen(f)&&D.push(f)}}return C}e.deepFreeze=P;const k=Object.prototype.hasOwnProperty;function A(C,D){return R(C,D,new Set)}e.cloneAndChange=A;function R(C,D,b){if((0,p.isUndefinedOrNull)(C))return C;const I=D(C);if(typeof I!="undefined")return I;if((0,p.isArray)(C)){const f=[];for(const a of C)f.push(R(a,D,b));return f}if((0,p.isObject)(C)){if(b.has(C))throw new Error("Cannot clone recursive data-structure");b.add(C);const f={};for(let a in C)k.call(C,a)&&(f[a]=R(C[a],D,b));return b.delete(C),f}return C}function S(C,D,b=!0){return(0,p.isObject)(C)?((0,p.isObject)(D)&&Object.keys(D).forEach(I=>{I in C?b&&((0,p.isObject)(C[I])&&(0,p.isObject)(D[I])?S(C[I],D[I],b):C[I]=D[I]):C[I]=D[I]}),C):D}e.mixin=S;function w(C,D){if(C===D)return!0;if(C==null||D===null||D===void 0||typeof C!=typeof D||typeof C!="object"||Array.isArray(C)!==Array.isArray(D))return!1;let b,I;if(Array.isArray(C)){if(C.length!==D.length)return!1;for(b=0;b<C.length;b++)if(!w(C[b],D[b]))return!1}else{const f=[];for(I in C)f.push(I);f.sort();const a=[];for(I in D)a.push(I);if(a.sort(),!w(f,a))return!1;for(b=0;b<f.length;b++)if(!w(C[f[b]],D[f[b]]))return!1}return!0}e.equals=w;function n(C){const D=new Set;return JSON.stringify(C,(b,I)=>{if((0,p.isObject)(I)||Array.isArray(I)){if(D.has(I))return"[Circular]";D.add(I)}return I})}e.safeStringify=n;function y(C,D,b){const I=D(C);return typeof I=="undefined"?b:I}e.getOrDefault=y;function m(C,D){const b=Object.create(null);return!C||!D||Object.keys(D).forEach(f=>{const a=C[f],c=D[f];w(a,c)||(b[f]=c)}),b}e.distinct=m;function v(C,D){const b=D.toLowerCase(),I=Object.keys(C).find(f=>f.toLowerCase()===b);return I?C[I]:C[D]}e.getCaseInsensitive=v;function h(C,D){const b=Object.create(null);for(const I of Object.keys(C))D(I,C[I])&&(b[I]=C[I]);return b}e.filter=h}),define(Z[4],ee([0,1,7,8]),function(K,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const P=/^\w[\w\d+.-]*$/,k=/^\//,A=/^\/\//;function R(i,s){if(!i.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!P.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!k.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(i,s){return!i&&!s?"file":i}function w(i,s){switch(i){case"https":case"http":case"file":s?s[0]!==y&&(s=y+s):s=y;break}return s}const n="",y="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{constructor(s,u,o,l,g,E=!1){typeof s=="object"?(this.scheme=s.scheme||n,this.authority=s.authority||n,this.path=s.path||n,this.query=s.query||n,this.fragment=s.fragment||n):(this.scheme=S(s,E),this.authority=u||n,this.path=w(this.scheme,o||n),this.query=l||n,this.fragment=g||n,R(this,E))}static isUri(s){return s instanceof v?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return f(this,!1)}with(s){if(!s)return this;let{scheme:u,authority:o,path:l,query:g,fragment:E}=s;return u===void 0?u=this.scheme:u===null&&(u=n),o===void 0?o=this.authority:o===null&&(o=n),l===void 0?l=this.path:l===null&&(l=n),g===void 0?g=this.query:g===null&&(g=n),E===void 0?E=this.fragment:E===null&&(E=n),u===this.scheme&&o===this.authority&&l===this.path&&g===this.query&&E===this.fragment?this:new C(u,o,l,g,E)}static parse(s,u=!1){const o=m.exec(s);return o?new C(o[2]||n,r(o[4]||n),r(o[5]||n),r(o[7]||n),r(o[9]||n),u):new C(n,n,n,n,n)}static file(s){let u=n;if(p.isWindows&&(s=s.replace(/\\/g,y)),s[0]===y&&s[1]===y){const o=s.indexOf(y,2);o===-1?(u=s.substring(2),s=y):(u=s.substring(2,o),s=s.substring(o)||y)}return new C("file",u,s,n,n)}static from(s){const u=new C(s.scheme,s.authority,s.path,s.query,s.fragment);return R(u,!0),u}static joinPath(s,...u){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return p.isWindows&&s.scheme==="file"?o=v.file(L.win32.join(f(s,!0),...u)).path:o=L.posix.join(s.path,...u),s.with({path:o})}toString(s=!1){return a(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof v)return s;{const u=new C(s);return u._formatted=s.external,u._fsPath=s._sep===h?s.fsPath:null,u}}else return s}}e.URI=v;const h=p.isWindows?1:void 0;class C extends v{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(s=!1){return s?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=h),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const D={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(i,s){let u,o=-1;for(let l=0;l<i.length;l++){const g=i.charCodeAt(l);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||s&&g===47)o!==-1&&(u+=encodeURIComponent(i.substring(o,l)),o=-1),u!==void 0&&(u+=i.charAt(l));else{u===void 0&&(u=i.substr(0,l));const E=D[g];E!==void 0?(o!==-1&&(u+=encodeURIComponent(i.substring(o,l)),o=-1),u+=E):o===-1&&(o=l)}}return o!==-1&&(u+=encodeURIComponent(i.substring(o))),u!==void 0?u:i}function I(i){let s;for(let u=0;u<i.length;u++){const o=i.charCodeAt(u);o===35||o===63?(s===void 0&&(s=i.substr(0,u)),s+=D[o]):s!==void 0&&(s+=i[u])}return s!==void 0?s:i}function f(i,s){let u;return i.authority&&i.path.length>1&&i.scheme==="file"?u=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?s?u=i.path.substr(1):u=i.path[1].toLowerCase()+i.path.substr(2):u=i.path,p.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=f;function a(i,s){const u=s?I:b;let o="",{scheme:l,authority:g,path:E,query:d,fragment:T}=i;if(l&&(o+=l,o+=":"),(g||l==="file")&&(o+=y,o+=y),g){let O=g.indexOf("@");if(O!==-1){const $=g.substr(0,O);g=g.substr(O+1),O=$.indexOf(":"),O===-1?o+=u($,!1):(o+=u($.substr(0,O),!1),o+=":",o+=u($.substr(O+1),!1)),o+="@"}g=g.toLowerCase(),O=g.indexOf(":"),O===-1?o+=u(g,!1):(o+=u(g.substr(0,O),!1),o+=g.substr(O))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const O=E.charCodeAt(1);O>=65&&O<=90&&(E=`/${String.fromCharCode(O+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const O=E.charCodeAt(0);O>=65&&O<=90&&(E=`${String.fromCharCode(O+32)}:${E.substr(2)}`)}o+=u(E,!0)}return d&&(o+="?",o+=u(d,!1)),T&&(o+="#",o+=s?T:b(T,!1)),o}function c(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+c(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(t)?i.replace(t,s=>c(s)):i}}),define(Z[91],ee([0,1,4]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(w){const n=w;return n&&typeof n.type=="string"&&typeof n.severity=="string"}e.isRemoteConsoleLog=L;function P(w){const n=[];let y;try{const m=JSON.parse(w.arguments),v=m[m.length-1];v&&v.__$stack&&(m.pop(),y=v.__$stack),n.push(...m)}catch(m){n.push("Unable to log remote console arguments",w.arguments)}return{args:n,stack:y}}e.parse=P;function k(w){if(typeof w!="string")return k(P(w).stack);const n=w;if(n){const y=A(n),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(m&&m.length===4)return{uri:p.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=k;function A(w){if(!w)return w;const n=w.indexOf(`
`);return n===-1?w:w.substring(0,n)}function R(w,n){const{args:y,stack:m}=P(w),v=typeof y[0]=="string"&&y.length===1;let h=A(m);h&&(h=`(${h.trim()})`);let C=[];if(typeof y[0]=="string"?h&&v?C=[`%c[${n}] %c${y[0]} %c${h}`,S("blue"),S(""),S("grey")]:C=[`%c[${n}] %c${y[0]}`,S("blue"),S(""),...y.slice(1)]:C=[`%c[${n}]%`,S("blue"),...y],h&&!v&&C.push(h),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,C)}e.log=R;function S(w){return`color: ${w}`}});var ut=this&&this.__classPrivateFieldSet||function(K,e,p,L,P){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!P:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?P.call(K,p):P?P.value=p:e.set(K,p),p},$e=this&&this.__classPrivateFieldGet||function(K,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!L:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(K):L?L.value:e.get(K)};define(Z[38],ee([0,1,4,19]),function(K,e,p,L){"use strict";var P,k,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function R(t,r,i){let s=t.get(r);return s===void 0&&(s=i,t.set(r,s)),s}e.getOrSet=R;function S(t){const r=[];return t.forEach((i,s)=>{r.push(`${s} => ${i}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=S;function w(t){const r=[];return t.forEach(i=>{r.push(i)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=w;class n{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const i=r.charCodeAt(0),s=this._value.charCodeAt(this._pos);return i-s}value(){return this._value[this._pos]}}e.StringIterator=n;class y{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=y;class m{constructor(r=!0,i=!0){this._splitOnBackslash=r,this._caseSensitive=i}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const i=this._value.charCodeAt(this._to);if(i===47||this._splitOnBackslash&&i===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var v;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(v||(v={}));class h{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,L.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class C{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class D{constructor(r){this._iter=r}static forUris(r=()=>!1){return new D(new h(r))}static forPaths(){return new D(new m)}static forStrings(){return new D(new n)}static forConfigKeys(){return new D(new y)}clear(){this._root=void 0}set(r,i){const s=this._iter.reset(r);let u;for(this._root||(this._root=new C,this._root.segment=s.value()),u=this._root;;){const l=s.cmp(u.segment);if(l>0)u.left||(u.left=new C,u.left.segment=s.value()),u=u.left;else if(l<0)u.right||(u.right=new C,u.right.segment=s.value()),u=u.right;else if(s.hasNext())s.next(),u.mid||(u.mid=new C,u.mid.segment=s.value()),u=u.mid;else break}const o=u.value;return u.value=i,u.key=r,o}get(r){return this._getNode(r)?.value}_getNode(r){const i=this._iter.reset(r);let s=this._root;for(;s;){const u=i.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(i.hasNext())i.next(),s=s.mid;else break}return s}has(r){const i=this._getNode(r);return!(i?.value===void 0&&i?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,i){const s=this._iter.reset(r),u=[];let o=this._root;for(;o;){const l=s.cmp(o.segment);if(l>0)u.push([1,o]),o=o.left;else if(l<0)u.push([-1,o]),o=o.right;else if(s.hasNext())s.next(),u.push([0,o]),o=o.mid;else{for(i?(o.left=void 0,o.mid=void 0,o.right=void 0):o.value=void 0;u.length>0&&o.isEmpty();){let[g,E]=u.pop();switch(g){case 1:E.left=void 0;break;case 0:E.mid=void 0;break;case-1:E.right=void 0;break}o=E}break}}}findSubstr(r){const i=this._iter.reset(r);let s=this._root,u;for(;s;){const o=i.cmp(s.segment);if(o>0)s=s.left;else if(o<0)s=s.right;else if(i.hasNext())i.next(),u=s.value||u,s=s.mid;else break}return s&&s.value||u}findSuperstr(r){const i=this._iter.reset(r);let s=this._root;for(;s;){const u=i.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(i.hasNext())i.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(r){for(const[i,s]of this)r(s,i)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const i=[r];for(;i.length>0;){const s=i.pop();s&&(s.value&&(yield[s.key,s.value]),s.left&&i.push(s.left),s.mid&&i.push(s.mid),s.right&&i.push(s.right))}}}e.TernarySearchTree=D;class b{constructor(r,i){this[P]="ResourceMap",r instanceof b?(this.map=new Map(r.map),this.toKey=i??b.defaultToKey):(this.map=new Map,this.toKey=r??b.defaultToKey)}set(r,i){return this.map.set(this.toKey(r),i),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,i){typeof i!="undefined"&&(r=r.bind(i));for(let[s,u]of this.map)r(u,p.URI.parse(s),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield p.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[p.URI.parse(r[0]),r[1]]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[p.URI.parse(r[0]),r[1]]}}e.ResourceMap=b,b.defaultToKey=t=>t.toString();var I;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(I=e.Touch||(e.Touch={}));class f{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,i=0){const s=this._map.get(r);if(!!s)return i!==0&&this.touch(s,i),s.value}set(r,i,s=0){let u=this._map.get(r);if(u)u.value=i,s!==0&&this.touch(u,s);else{switch(u={key:r,value:i,next:void 0,previous:void 0},s){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(r,u),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const i=this._map.get(r);if(!!i)return this._map.delete(r),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,i){const s=this._state;let u=this._head;for(;u;){if(i?r.bind(i)(u.value,u.key,this):r(u.value,u.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const r=this,i=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const o={value:s.key,done:!1};return s=s.next,o}else return{value:void 0,done:!0}}};return u}values(){const r=this,i=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const o={value:s.value,done:!1};return s=s.next,o}else return{value:void 0,done:!0}}};return u}entries(){const r=this,i=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const o={value:[s.key,s.value],done:!1};return s=s.next,o}else return{value:void 0,done:!0}}};return u}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this._head,s=this.size;for(;i&&s>r;)this._map.delete(i.key),i=i.next,s--;this._head=i,this._size=s,i&&(i.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const i=r.next,s=r.previous;if(!i||!s)throw new Error("Invalid list");i.previous=s,s.next=i}r.next=void 0,r.previous=void 0,this._state++}touch(r,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(r===this._head)return;const s=r.next,u=r.previous;r===this._tail?(u.next=void 0,this._tail=u):(s.previous=u,u.next=s),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(i===2){if(r===this._tail)return;const s=r.next,u=r.previous;r===this._head?(s.previous=void 0,this._head=s):(s.previous=u,u.next=s),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((i,s)=>{r.push([s,i])}),r}fromJSON(r){this.clear();for(const[i,s]of r)this.set(i,s)}}e.LinkedMap=f;class a extends f{constructor(r,i=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,i=2){return super.get(r,i)}peek(r){return super.get(r,0)}set(r,i){return super.set(r,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class c{constructor(r){A.set(this,void 0),ut(this,A,r,"f")}get size(){return $e(this,A,"f").size}forEach(r,i){$e(this,A,"f").forEach(r,i)}get(r){return $e(this,A,"f").get(r)}has(r){return $e(this,A,"f").has(r)}entries(){return $e(this,A,"f").entries()}keys(){return $e(this,A,"f").keys()}values(){return $e(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return $e(this,A,"f").entries()}}e.ReadonlyMapView=c}),define(Z[92],ee([0,1,25,19,4]),function(K,e,p,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function k(n){return JSON.stringify(n,S)}e.stringify=k;function A(n){let y=JSON.parse(n);return y=w(y),y}e.parse=A;var R;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(R=e.MarshalledId||(e.MarshalledId={}));function S(n,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:(0,L.regExpFlags)(y)}:y}function w(n,y=0){if(!n||y>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return P.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof p.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let m=0;m<n.length;++m)n[m]=w(n[m],y+1);else for(const m in n)Object.hasOwnProperty.call(n,m)&&(n[m]=w(n[m],y+1))}return n}e.revive=w}),define(Z[17],ee([0,1,4,7]),function(K,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var P;(function(R){R.inMemory="inmemory",R.vscode="vscode",R.internal="private",R.walkThrough="walkThrough",R.walkThroughSnippet="walkThroughSnippet",R.http="http",R.https="https",R.file="file",R.mailto="mailto",R.untitled="untitled",R.data="data",R.command="command",R.vscodeRemote="vscode-remote",R.vscodeRemoteResource="vscode-remote-resource",R.userData="vscode-userdata",R.vscodeCustomEditor="vscode-custom-editor",R.vscodeNotebook="vscode-notebook",R.vscodeNotebookCell="vscode-notebook-cell",R.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",R.vscodeNotebookCellOutput="vscode-notebook-cell-output",R.vscodeInteractive="vscode-interactive",R.vscodeInteractiveInput="vscode-interactive-input",R.vscodeSettings="vscode-settings",R.vscodeWorkspaceTrust="vscode-workspace-trust",R.vscodeTerminal="vscode-terminal",R.webviewPanel="webview-panel",R.vscodeWebview="vscode-webview",R.extension="extension",R.vscodeFileResource="vscode-file",R.tmp="tmp"})(P=e.Schemas||(e.Schemas={}));class k{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,w,n){this._hosts[S]=w,this._ports[S]=n}setConnectionToken(S,w){this._connectionTokens[S]=w}rewrite(S){if(this._delegate)return this._delegate(S);const w=S.authority;let n=this._hosts[w];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const y=this._ports[w],m=this._connectionTokens[w];let v=`path=${encodeURIComponent(S.path)}`;return typeof m=="string"&&(v+=`&tkn=${encodeURIComponent(m)}`),p.URI.from({scheme:L.isWeb?this._preferredWebSchema:P.vscodeRemoteResource,authority:`${n}:${y}`,path:"/vscode-remote-resource",query:v})}}e.RemoteAuthorities=new k;class A{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(S,w,n){const y=this.toUri(S,w);if(y.scheme===P.vscodeRemote)return e.RemoteAuthorities.rewrite(y);let m=!1;return L.isNative&&(n||L.isPreferringBrowserCodeLoad)&&y.scheme===P.file&&(m=!0),y.scheme===P.file&&typeof L.globals.importScripts=="function"&&L.globals.origin==="vscode-file://vscode-app"&&(m=!0),m?y.with({scheme:P.vscodeFileResource,authority:y.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):y}asFileUri(S,w){const n=this.toUri(S,w);return n.scheme===P.vscodeFileResource?n.with({scheme:P.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(S,w){return p.URI.isUri(S)?S:p.URI.parse(w.toUrl(S))}}e.FileAccess=new A}),define(Z[66],ee([0,1,38]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new p.LRUCache(1e4);function P(w){return S(w,"NFC",L)}e.normalizeNFC=P;const k=new p.LRUCache(1e4);function A(w){return S(w,"NFD",k)}e.normalizeNFD=A;const R=/[^\u0000-\u0080]/;function S(w,n,y){if(!w)return w;const m=y.get(w);if(m)return m;let v;return R.test(w)?v=w.normalize(n):v=w,y.set(w,v),v}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(n){return A(n).replace(w,"")}}()}),define(Z[15],ee([0,1,41,8,4,19,17,7]),function(K,e,p,L,P,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(v){return(0,P.uriToFsPath)(v,!0)}e.originalFSPath=S;class w{constructor(h){this._ignorePathCasing=h}compare(h,C,D=!1){return h===C?0:(0,k.compare)(this.getComparisonKey(h,D),this.getComparisonKey(C,D))}isEqual(h,C,D=!1){return h===C?!0:!h||!C?!1:this.getComparisonKey(h,D)===this.getComparisonKey(C,D)}getComparisonKey(h,C=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:C?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,C,D=!1){if(h.scheme===C.scheme){if(h.scheme===A.Schemas.file)return p.isEqualOrParent(S(h),S(C),this._ignorePathCasing(h))&&h.query===C.query&&(D||h.fragment===C.fragment);if((0,e.isEqualAuthority)(h.authority,C.authority))return p.isEqualOrParent(h.path,C.path,this._ignorePathCasing(h),"/")&&h.query===C.query&&(D||h.fragment===C.fragment)}return!1}joinPath(h,...C){return P.URI.joinPath(h,...C)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return L.posix.basename(h.path)}extname(h){return L.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let C;return h.scheme===A.Schemas.file?C=P.URI.file(L.dirname(S(h))).path:(C=L.posix.dirname(h.path),h.authority&&C.length&&C.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),C="/")),h.with({path:C})}normalizePath(h){if(!h.path.length)return h;let C;return h.scheme===A.Schemas.file?C=P.URI.file(L.normalize(S(h))).path:C=L.posix.normalize(h.path),h.with({path:C})}relativePath(h,C){if(h.scheme!==C.scheme||!(0,e.isEqualAuthority)(h.authority,C.authority))return;if(h.scheme===A.Schemas.file){const I=L.relative(S(h),S(C));return R.isWindows?p.toSlashes(I):I}let D=h.path||"/",b=C.path||"/";if(this._ignorePathCasing(h)){let I=0;for(const f=Math.min(D.length,b.length);I<f&&!(D.charCodeAt(I)!==b.charCodeAt(I)&&D.charAt(I).toLowerCase()!==b.charAt(I).toLowerCase());I++);D=b.substr(0,I)+D.substr(I)}return L.posix.relative(D,b)}resolvePath(h,C){if(h.scheme===A.Schemas.file){const D=P.URI.file(L.resolve(S(h),C));return h.with({authority:D.authority,path:D.path})}return C=p.toPosixPath(C),h.with({path:L.posix.resolve(h.path,C)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,C){return h===C||(0,k.equalsIgnoreCase)(h,C)}hasTrailingPathSeparator(h,C=L.sep){if(h.scheme===A.Schemas.file){const D=S(h);return D.length>p.getRoot(D).length&&D[D.length-1]===C}else{const D=h.path;return D.length>1&&D.charCodeAt(D.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,C=L.sep){return(0,e.hasTrailingPathSeparator)(h,C)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,C=L.sep){let D=!1;if(h.scheme===A.Schemas.file){const b=S(h);D=b!==void 0&&b.length===p.getRoot(b).length&&b[b.length-1]===C}else{C="/";const b=h.path;D=b.length===1&&b.charCodeAt(b.length-1)===47}return!D&&!(0,e.hasTrailingPathSeparator)(h,C)?h.with({path:h.path+"/"}):h}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(v=>v.scheme===A.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new w(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(v,h){const C=[];for(let D=0;D<v.length;D++){const b=h(v[D]);v.some((I,f)=>f===D?!1:(0,e.isEqualOrParent)(b,h(I)))||C.push(v[D])}return C}e.distinctParents=n;var y;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function h(C){const D=new Map;C.path.substring(C.path.indexOf(";")+1,C.path.lastIndexOf(";")).split(";").forEach(f=>{const[a,c]=f.split(":");a&&c&&D.set(a,c)});const I=C.path.substring(0,C.path.indexOf(";"));return I&&D.set(v.META_DATA_MIME,I),D}v.parseMetaData=h})(y=e.DataUri||(e.DataUri={}));function m(v,h,C){if(h){let D=v.path;return D&&D[0]!==L.posix.sep&&(D=L.posix.sep+D),v.with({scheme:C,authority:h,path:D})}return v.with({scheme:C})}e.toLocalResource=m}),define(Z[5],ee([0,1,29,11,3,2,15]),function(K,e,p,L,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function R(M){return!!M&&typeof M.then=="function"}e.isThenable=R;function S(M){const F=new p.CancellationTokenSource,j=M(F.token),_=new Promise((N,W)=>{const x=F.token.onCancellationRequested(()=>{x.dispose(),F.dispose(),W((0,L.canceled)())});Promise.resolve(j).then(B=>{x.dispose(),F.dispose(),N(B)},B=>{x.dispose(),F.dispose(),W(B)})});return new class{cancel(){F.cancel()}then(N,W){return _.then(N,W)}catch(N){return this.then(void 0,N)}finally(N){return _.finally(N)}}}e.createCancelablePromise=S;function w(M,F,j){return Promise.race([M,new Promise(_=>F.onCancellationRequested(()=>_(j)))])}e.raceCancellation=w;async function n(M){let F=-1;const j=M.map((N,W)=>N.then(x=>(F=W,x))),_=await Promise.race(j);return M.forEach((N,W)=>{W!==F&&N.cancel()}),_}e.raceCancellablePromises=n;function y(M,F,j){let _;const N=setTimeout(()=>{_?.(void 0),j?.()},F);return Promise.race([M.finally(()=>clearTimeout(N)),new Promise(W=>_=W)])}e.raceTimeout=y;function m(M){return new Promise((F,j)=>{const _=M();R(_)?_.then(F,j):F(_)})}e.asPromise=m;class v{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const j=()=>{this.queuedPromise=null;const _=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_};this.queuedPromise=new Promise(_=>{this.activePromise.then(j,j).then(_)})}return new Promise((j,_)=>{this.queuedPromise.then(j,_)})}return this.activePromise=F(),new Promise((j,_)=>{this.activePromise.then(N=>{this.activePromise=null,j(N)},N=>{this.activePromise=null,_(N)})})}}e.Throttler=v;class h{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=h;class C{constructor(){this.promiseMap=new Map}queue(F,j){const N=(this.promiseMap.get(F)??Promise.resolve()).catch(()=>{}).then(j).finally(()=>{this.promiseMap.get(F)===N&&this.promiseMap.delete(F)});return this.promiseMap.set(F,N),N}}e.SequencerByKey=C;class D{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,j=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((_,N)=>{this.doResolve=_,this.doReject=N}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const _=this.task;return this.task=null,_()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},j),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=D;class b{constructor(F){this.delayer=new D(F),this.throttler=new v}trigger(F,j){return this.delayer.trigger(()=>this.throttler.queue(F),j)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class I{constructor(){this._isOpen=!1,this._promise=new Promise((F,j)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=I;class f extends I{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=f;function a(M,F){return F?new Promise((j,_)=>{const N=setTimeout(()=>{W.dispose(),j()},M),W=F.onCancellationRequested(()=>{clearTimeout(N),W.dispose(),_((0,L.canceled)())})}):S(j=>a(M,j))}e.timeout=a;function c(M,F=0){const j=setTimeout(M,F);return(0,k.toDisposable)(()=>clearTimeout(j))}e.disposableTimeout=c;function t(M){const F=[];let j=0;const _=M.length;function N(){return j<_?M[j++]():null}function W(x){x!=null&&F.push(x);const B=N();return B?B.then(W):Promise.resolve(F)}return Promise.resolve(null).then(W)}e.sequence=t;function r(M,F=_=>!!_,j=null){let _=0;const N=M.length,W=()=>{if(_>=N)return Promise.resolve(j);const x=M[_++];return Promise.resolve(x()).then(H=>F(H)?Promise.resolve(H):W())};return W()}e.first=r;function i(M,F=_=>!!_,j=null){if(M.length===0)return Promise.resolve(j);let _=M.length;const N=()=>{_=-1;for(const W of M)W.cancel?.()};return new Promise((W,x)=>{for(const B of M)B.then(H=>{--_>=0&&F(H)?(N(),W(H)):_===0&&W(j)}).catch(H=>{--_>=0&&(N(),x(H))})})}e.firstParallel=i;class s{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new P.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((j,_)=>{this.outstandingPromises.push({factory:F,c:j,e:_}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const j=F.factory();j.then(F.c,F.e),j.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class u extends s{constructor(){super(1)}}e.Queue=u;class o{constructor(){this.queues=new Map}queueFor(F,j=A.extUri){const _=j.getComparisonKey(F);let N=this.queues.get(_);return N||(N=new u,P.Event.once(N.onFinished)(()=>{N?.dispose(),this.queues.delete(_)}),this.queues.set(_,N)),N}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=o;class l{constructor(F,j){this._token=-1,typeof F=="function"&&typeof j=="number"&&this.setIfNotSet(F,j)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,j){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},j)}setIfNotSet(F,j){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},j))}}e.TimeoutTimer=l;class g{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,j){this.cancel(),this._token=setInterval(()=>{F()},j)}}e.IntervalTimer=g;class E{constructor(F,j){this.timeoutToken=-1,this.runner=F,this.timeout=j,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=E;class d extends E{constructor(F,j){super(F,j);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=d;class T extends k.Disposable{constructor(F,j,_,N){super();this.maxWorkChunkSize=F,this.maxPendingWork=j,this.throttleDelay=_,this.handler=N,this.pendingWork=[],this.throttler=this._register(new k.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(F){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+F.length>this.maxPendingWork)return!1}else if(this.pending+F.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...F),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new E(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=T,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const M=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const j=setTimeout(()=>F(M));let _=!1;return{dispose(){_||(_=!0,clearTimeout(j))}}}}else e.runWhenIdle=(M,F)=>{const j=requestIdleCallback(M,typeof F=="number"?{timeout:F}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(j))}}}}();class O{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(j){this._error=j}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=O;async function $(M,F,j){let _;for(let N=0;N<j;N++)try{return await M()}catch(W){_=W,await a(F)}throw _}e.retry=$;class z{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(F,j,_){return this._pending={taskId:F,cancel:()=>_?.(),promise:j},j.then(()=>this.donePending(F),()=>this.donePending(F)),j}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let j,_;const N=new Promise((W,x)=>{j=W,_=x});this._next={run:F,promise:N,promiseResolve:j,promiseReject:_}}return this._next.promise}}e.TaskSequentializer=z;class G{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=G;class V{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,j)=>{this.completeCallback=F,this.errorCallback=j})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(j=>{this.completeCallback(F),this.resolved=!0,j()})}error(F){return new Promise(j=>{this.errorCallback(F),this.rejected=!0,j()})}cancel(){new Promise(F=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,F()})}}e.DeferredPromise=V;var U;(function(M){async function F(j){let _;const N=await Promise.all(j.map(W=>W.then(x=>x,x=>{_||(_=x)})));if(typeof _!="undefined")throw _;return N}M.settled=F})(U=e.Promises||(e.Promises={}))}),define(Z[67],ee([0,1,19,41,8,38,5]),function(K,e,p,L,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function R(){return Object.create(null)}e.getEmptyExpression=R;const S="**",w="/",n="[/\\\\]",y="[^/\\\\]",m=/\//g;function v(N){switch(N){case 0:return"";case 1:return`${y}*?`;default:return`(?:${n}|${y}+${n}|${n}${y}+)*?`}}function h(N,W){if(!N)return[];const x=[];let B=!1,H=!1,X="";for(const Q of N){switch(Q){case W:if(!B&&!H){x.push(X),X="";continue}break;case"{":B=!0;break;case"}":B=!1;break;case"[":H=!0;break;case"]":H=!1;break}X+=Q}return X&&x.push(X),x}e.splitGlobAware=h;function C(N){if(!N)return"";let W="";const x=h(N,w);if(x.every(B=>B===S))W=".*";else{let B=!1;x.forEach((H,X)=>{if(H===S){B||(W+=v(2),B=!0);return}let Q=!1,ie="",ne=!1,le="";for(const de of H){if(de!=="}"&&Q){ie+=de;continue}if(ne&&(de!=="]"||!le)){let ye;de==="-"?ye=de:(de==="^"||de==="!")&&!le?ye="^":de===w?ye="":ye=p.escapeRegExpCharacters(de),le+=ye;continue}switch(de){case"{":Q=!0;continue;case"[":ne=!0;continue;case"}":W+=`(?:${h(ie,",").map(De=>C(De)).join("|")})`,Q=!1,ie="";break;case"]":W+="["+le+"]",ne=!1,le="";break;case"?":W+=y;continue;case"*":W+=v(1);continue;default:W+=p.escapeRegExpCharacters(de)}}X<x.length-1&&(x[X+1]!==S||X+2<x.length)&&(W+=n),B=!1})}return W}const D=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,I=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,f=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new k.LRUCache(1e4),r=function(){return!1},i=function(){return null};function s(N,W){if(!N)return i;let x;typeof N!="string"?x=N.pattern:x=N,x=x.trim();const B=`${x}_${!!W.trimForExclusions}`;let H=t.get(B);if(H)return u(H,N);let X;if(D.test(x)){const Q=x.substr(4);H=function(ie,ne){return typeof ie=="string"&&ie.endsWith(Q)?x:null}}else(X=b.exec(o(x,W)))?H=l(X[1],x):(W.trimForExclusions?f:I).test(x)?H=g(x,W):(X=a.exec(o(x,W)))?H=E(X[1].substr(1),x,!0):(X=c.exec(o(x,W)))?H=E(X[1],x,!1):H=d(x);return t.set(B,H),u(H,N)}function u(N,W){return typeof W=="string"?N:function(x,B){return L.isEqualOrParent(x,W.base)?N(P.relative(W.base,x),B):null}}function o(N,W){return W.trimForExclusions&&N.endsWith("/**")?N.substr(0,N.length-2):N}function l(N,W){const x=`/${N}`,B=`\\${N}`,H=function(Q,ie){return typeof Q!="string"?null:ie?ie===N?W:null:Q===N||Q.endsWith(x)||Q.endsWith(B)?W:null},X=[N];return H.basenames=X,H.patterns=[W],H.allBasenames=X,H}function g(N,W){const x=_(N.slice(1,-1).split(",").map(ie=>s(ie,W)).filter(ie=>ie!==i),N),B=x.length;if(!B)return i;if(B===1)return x[0];const H=function(ie,ne){for(let le=0,de=x.length;le<de;le++)if(x[le](ie,ne))return N;return null},X=x.find(ie=>!!ie.allBasenames);X&&(H.allBasenames=X.allBasenames);const Q=x.reduce((ie,ne)=>ne.allPaths?ie.concat(ne.allPaths):ie,[]);return Q.length&&(H.allPaths=Q),H}function E(N,W,x){const B=P.sep===P.posix.sep,H=B?N:N.replace(m,P.sep),X=P.sep+H,Q=P.posix.sep+N,ie=x?function(ne,le){return typeof ne=="string"&&(ne===H||ne.endsWith(X)||!B&&(ne===N||ne.endsWith(Q)))?W:null}:function(ne,le){return typeof ne=="string"&&(ne===H||!B&&ne===N)?W:null};return ie.allPaths=[(x?"*/":"./")+N],ie}function d(N){try{const W=new RegExp(`^${C(N)}$`);return function(x){return W.lastIndex=0,typeof x=="string"&&W.test(x)?N:null}}catch(W){return i}}function T(N,W,x){return!N||typeof W!="string"?!1:O(N)(W,void 0,x)}e.match=T;function O(N,W={}){if(!N)return r;if(typeof N=="string"||V(N)){const x=s(N,W);if(x===i)return r;const B=function(H,X){return!!x(H,X)};return x.allBasenames&&(B.allBasenames=x.allBasenames),x.allPaths&&(B.allPaths=x.allPaths),B}return F(N,W)}e.parse=O;function $(N){if(!N)return;let W;return x=>(W||(W=(N()||Promise.resolve([])).then(B=>B?G(B):{})),W.then(B=>!!B[x]))}e.hasSiblingPromiseFn=$;function z(N){if(!N)return;let W;return x=>{if(!W){const B=N();W=B?G(B):{}}return!!W[x]}}e.hasSiblingFn=z;function G(N){const W={};for(const x of N)W[x]=!0;return W}function V(N){const W=N;return W&&typeof W.base=="string"&&typeof W.pattern=="string"}e.isRelativePattern=V;function U(N){return N.allBasenames||[]}e.getBasenameTerms=U;function M(N){return N.allPaths||[]}e.getPathTerms=M;function F(N,W){const x=_(Object.getOwnPropertyNames(N).map(ie=>j(ie,N[ie],W)).filter(ie=>ie!==i)),B=x.length;if(!B)return i;if(!x.some(ie=>!!ie.requiresSiblings)){if(B===1)return x[0];const ie=function(de,ye){for(let pe=0,De=x.length;pe<De;pe++){const Te=x[pe](de,ye);if(Te)return Te}return null},ne=x.find(de=>!!de.allBasenames);ne&&(ie.allBasenames=ne.allBasenames);const le=x.reduce((de,ye)=>ye.allPaths?de.concat(ye.allPaths):de,[]);return le.length&&(ie.allPaths=le),ie}const H=function(ie,ne,le){let de;for(let ye=0,pe=x.length;ye<pe;ye++){const De=x[ye];De.requiresSiblings&&le&&(ne||(ne=P.basename(ie)),de||(de=ne.substr(0,ne.length-P.extname(ie).length)));const Te=De(ie,ne,de,le);if(Te)return Te}return null},X=x.find(ie=>!!ie.allBasenames);X&&(H.allBasenames=X.allBasenames);const Q=x.reduce((ie,ne)=>ne.allPaths?ie.concat(ne.allPaths):ie,[]);return Q.length&&(H.allPaths=Q),H}function j(N,W,x){if(W===!1)return i;const B=s(N,x);if(B===i)return i;if(typeof W=="boolean")return B;if(W){const H=W.when;if(typeof H=="string"){const X=(Q,ie,ne,le)=>{if(!le||!B(Q,ie))return null;const de=H.replace("$(basename)",ne),ye=le(de);return(0,A.isThenable)(ye)?ye.then(pe=>pe?N:null):ye?N:null};return X.requiresSiblings=!0,X}}return B}function _(N,W){const x=N.filter(ie=>!!ie.basenames);if(x.length<2)return N;const B=x.reduce((ie,ne)=>{const le=ne.basenames;return le?ie.concat(le):ie},[]);let H;if(W){H=[];for(let ie=0,ne=B.length;ie<ne;ie++)H.push(W)}else H=x.reduce((ie,ne)=>{const le=ne.patterns;return le?ie.concat(le):ie},[]);const X=function(ie,ne){if(typeof ie!="string")return null;if(!ne){let de;for(de=ie.length;de>0;de--){const ye=ie.charCodeAt(de-1);if(ye===47||ye===92)break}ne=ie.substr(de)}const le=B.indexOf(ne);return le!==-1?H[le]:null};X.basenames=B,X.patterns=H,X.allBasenames=B;const Q=N.filter(ie=>!ie.basenames);return Q.push(X),Q}}),define(Z[93],ee([0,1,8,19,67,17,15]),function(K,e,p,L,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var R;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown"})(R=e.Mimes||(e.Mimes={}));let S=[],w=[],n=[];function y(r,i=!1){const s=m(r);S.push(s),s.userConfigured?n.push(s):w.push(s),i&&!s.userConfigured&&S.forEach(u=>{u.mime===s.mime||u.userConfigured||(s.extension&&u.extension===s.extension&&console.warn(`Overwriting extension <<${s.extension}>> to now point to mime <<${s.mime}>>`),s.filename&&u.filename===s.filename&&console.warn(`Overwriting filename <<${s.filename}>> to now point to mime <<${s.mime}>>`),s.filepattern&&u.filepattern===s.filepattern&&console.warn(`Overwriting filepattern <<${s.filepattern}>> to now point to mime <<${s.mime}>>`),s.firstline&&u.firstline===s.firstline&&console.warn(`Overwriting firstline <<${s.firstline}>> to now point to mime <<${s.mime}>>`))})}e.registerTextMime=y;function m(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?r.filepattern.toLowerCase():void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(p.posix.sep)>=0:!1}}function v(r){r?(S=S.filter(i=>!i.userConfigured),n=[]):(S=[],w=[],n=[])}e.clearTextMimes=v;function h(r,i){let s;if(r)switch(r.scheme){case k.Schemas.file:s=r.fsPath;break;case k.Schemas.data:s=A.DataUri.parseMetaData(r).get(A.DataUri.META_DATA_LABEL);break;default:s=r.path}if(!s)return[R.unknown];s=s.toLowerCase();const u=(0,p.basename)(s),o=C(s,u,n);if(o)return[o,R.text];const l=C(s,u,w);if(l)return[l,R.text];if(i){const g=D(i);if(g)return[g,R.text]}return[R.unknown]}e.guessMimeTypes=h;function C(r,i,s){let u=null,o=null,l=null;for(let g=s.length-1;g>=0;g--){const E=s[g];if(i===E.filenameLowercase){u=E;break}if(E.filepattern&&(!o||E.filepattern.length>o.filepattern.length)){const d=E.filepatternOnPath?r:i;(0,P.match)(E.filepatternLowercase,d)&&(o=E)}E.extension&&(!l||E.extension.length>l.extension.length)&&i.endsWith(E.extensionLowercase)&&(l=E)}return u?u.mime:o?o.mime:l?l.mime:null}function D(r){if((0,L.startsWithUTF8BOM)(r)&&(r=r.substr(1)),r.length>0)for(let i=S.length-1;i>=0;i--){const s=S[i];if(!s.firstline)continue;const u=r.match(s.firstline);if(u&&u.length>0)return s.mime}return null}function b(r){return r?typeof r=="string"?r===R.binary||r===R.text||r===R.unknown:r.length===1&&b(r[0]):!0}e.isUnspecific=b;const I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function f(r){const i=(0,p.extname)(r);return I[i.toLowerCase()]}e.getMediaMime=f;function a(r){for(const i in I)if(I[i]===r)return i}e.getExtensionForMimeType=a;const c=/^(.+)\/(.+?)(;.+)?$/;function t(r,i){const s=c.exec(r);return s?`${s[1].toLowerCase()}/${s[2].toLowerCase()}${s[3]??""}`:i?void 0:r}e.normalizeMimeType=t}),define(Z[94],ee([0,1,4]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(n){return n.toJSON()}class P{constructor(y){this._uriTransformer=y}transformIncoming(y){const m=this._uriTransformer.transformIncoming(y);return m===y?y:L(p.URI.from(m))}transformOutgoing(y){const m=this._uriTransformer.transformOutgoing(y);return m===y?y:L(p.URI.from(m))}transformOutgoingURI(y){const m=this._uriTransformer.transformOutgoing(y);return m===y?y:p.URI.from(m)}transformOutgoingScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}}e.URITransformer=P,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function k(n,y,m){if(!n||m>200)return null;if(typeof n=="object"){if(n instanceof p.URI)return y.transformOutgoing(n);for(let v in n)if(Object.hasOwnProperty.call(n,v)){const h=k(n[v],y,m+1);h!==null&&(n[v]=h)}}return null}function A(n,y){const m=k(n,y,0);return m===null?n:m}e.transformOutgoingURIs=A;function R(n,y,m,v){if(!n||v>200)return null;if(typeof n=="object"){if(n.$mid===1)return m?p.URI.revive(y.transformIncoming(n)):y.transformIncoming(n);for(let h in n)if(Object.hasOwnProperty.call(n,h)){const C=R(n[h],y,m,v+1);C!==null&&(n[h]=C)}}return null}function S(n,y){const m=R(n,y,!1,0);return m===null?n:m}e.transformIncomingURIs=S;function w(n,y){const m=R(n,y,!0,0);return m===null?n:m}e.transformAndReviveIncomingURIs=w}),define(Z[30],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(S){return p.test(S)}e.isUUID=L;const P=new Uint8Array(16),k=[];for(let S=0;S<256;S++)k.push(S.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(S){for(let w=0;w<S.length;w++)S[w]=Math.floor(Math.random()*256);return S};function R(){A(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let S=0,w="";return w+=k[P[S++]],w+=k[P[S++]],w+=k[P[S++]],w+=k[P[S++]],w+="-",w+=k[P[S++]],w+=k[P[S++]],w+="-",w+=k[P[S++]],w+=k[P[S++]],w+="-",w+=k[P[S++]],w+=k[P[S++]],w+="-",w+=k[P[S++]],w+=k[P[S++]],w+=k[P[S++]],w+=k[P[S++]],w+=k[P[S++]],w+=k[P[S++]],w}e.generateUuid=R}),define(Z[68],ee([0,1,210]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(k="utf8"){this.stringDecoder=new p.StringDecoder(k),this.remaining=null}write(k){const A=[],R=this.remaining?this.remaining+this.stringDecoder.write(k):this.stringDecoder.write(k);if(R.length<1)return A;let S=0,w,n=S;for(;n<R.length;)if(w=R.charCodeAt(n),w===13||w===10){if(A.push(R.substring(S,n)),n++,n<R.length){const y=w;w=R.charCodeAt(n),(y===13&&w===10||y===10&&w===13)&&n++}S=n}else n++;return this.remaining=S<R.length?R.substr(S):null,A}end(){return this.remaining}}e.LineDecoder=L}),define(Z[95],ee([0,1,35]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function P(R){const S=R.replace(/\-/g,":").toLowerCase();return!L.has(S)}function k(){return new Promise(async(R,S)=>{const w=setTimeout(()=>S("Unable to retrieve mac address (timeout after 10s)"),1e4);try{R(await A())}catch(n){S(n)}finally{clearTimeout(w)}})}e.getMac=k;function A(){return new Promise((R,S)=>{try{const w=(0,p.networkInterfaces)();for(let n in w){const y=w[n];if(y){for(const{mac:m}of y)if(P(m))return R(m)}}S("Unable to retrieve mac address (unexpected format)")}catch(w){S(w)}})}}),define(Z[96],ee([0,1,11,30,35,38,95]),function(K,e,p,L,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(n){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(n)}value(){if(this._value===void 0){let n=0,y=0;const m=(0,P.networkInterfaces)();for(let v in m){const h=m[v];if(h)for(const{mac:C,internal:D}of h)D||(y+=1,this._isVirtualMachineMacAdress(C.toUpperCase())&&(n+=1))}this._value=y>0?n/y:0}return this._value}};let R;async function S(){return R||(R=(async()=>await w()||L.generateUuid())()),R}e.getMachineId=S;async function w(){try{const n=await new Promise((m,v)=>{K(["crypto"],m,v)}),y=await(0,A.getMac)();return n.createHash("sha256").update(y,"utf8").digest("hex")}catch(n){p.onUnexpectedError(n);return}}}),define(Z[18],ee([0,1,49,35,211,8,5,7,41,30,66,15,4]),function(K,e,p,L,P,k,A,R,S,w,n,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function h(U,M=v.UNLINK){if((0,S.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return M===v.UNLINK?D(U):C(U)}async function C(U){try{const M=(0,k.join)((0,L.tmpdir)(),(0,w.generateUuid)());try{await e.Promises.rename(U,M)}catch(F){return D(U)}D(M).catch(F=>{})}catch(M){if(M.code!=="ENOENT")throw M}}async function D(U){return e.Promises.rmdir(U,{recursive:!0,maxRetries:3})}function b(U){if((0,S.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");p.rmdirSync(U,{recursive:!0})}e.rimrafSync=b;async function I(U,M){return c(await(M?f(U):(0,P.promisify)(p.readdir)(U)))}async function f(U){try{return await(0,P.promisify)(p.readdir)(U,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const M=[],F=await I(U);for(const j of F){let _=!1,N=!1,W=!1;try{const x=await e.Promises.lstat((0,k.join)(U,j));_=x.isFile(),N=x.isDirectory(),W=x.isSymbolicLink()}catch(x){console.warn("[node.js fs] unexpected error from lstat after readdir: ",x)}M.push({name:j,isFile:()=>_,isDirectory:()=>N,isSymbolicLink:()=>W})}return M}function a(U){return c(p.readdirSync(U))}e.readdirSync=a;function c(U){return U.map(M=>typeof M=="string"?R.isMacintosh?(0,n.normalizeNFC)(M):M:(M.name=R.isMacintosh?(0,n.normalizeNFC)(M.name):M.name,M))}async function t(U){const M=await I(U),F=[];for(const j of M)await i.existsDirectory((0,k.join)(U,j))&&F.push(j);return F}function r(U,M=1e3){return new Promise(F=>{let j=!1;const _=setInterval(()=>{j||(j=!0,p.access(U,N=>{j=!1,N&&(clearInterval(_),F(void 0))}))},M)})}e.whenDeleted=r;var i;(function(U){async function M(_){let N;try{if(N=await e.Promises.lstat(_),!N.isSymbolicLink())return{stat:N}}catch(W){}try{return{stat:await e.Promises.stat(_),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(R.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(_)),symbolicLink:{dangling:!1}}}catch(x){if(x.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw x}throw W}}U.stat=M;async function F(_){try{const{stat:N,symbolicLink:W}=await U.stat(_);return N.isFile()&&W?.dangling!==!0}catch(N){}return!1}U.existsFile=F;async function j(_){try{const{stat:N,symbolicLink:W}=await U.stat(_);return N.isDirectory()&&W?.dangling!==!0}catch(N){}return!1}U.existsDirectory=j})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new A.ResourceQueue;function u(U,M,F){return s.queueFor(m.URI.file(U),y.extUriBiasedIgnorePathCase).queue(()=>{const j=E(F);return new Promise((_,N)=>l(U,M,j,W=>W?N(W):_()))})}let o=!0;function l(U,M,F,j){if(!o)return p.writeFile(U,M,{mode:F.mode,flag:F.flag},j);p.open(U,F.flag,F.mode,(_,N)=>{if(_)return j(_);p.writeFile(N,M,W=>{if(W)return p.close(N,()=>j(W));p.fdatasync(N,x=>(x&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",x),o=!1),p.close(N,B=>j(B))))})})}function g(U,M,F){const j=E(F);if(!o)return p.writeFileSync(U,M,{mode:j.mode,flag:j.flag});const _=p.openSync(U,j.flag,j.mode);try{p.writeFileSync(_,M);try{p.fdatasyncSync(_)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),o=!1}}finally{p.closeSync(_)}}e.writeFileSync=g;function E(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function d(U,M){if(U===M)return;async function F(j){try{const _=await e.Promises.lstat(j);if(_.isDirectory()||_.isSymbolicLink())return;await e.Promises.utimes(j,_.atime,new Date)}catch(_){}}try{await e.Promises.rename(U,M),await F(M)}catch(j){if(U.toLowerCase()!==M.toLowerCase()&&j.code==="EXDEV"||U.endsWith("."))await T(U,M,{preserveSymlinks:!1}),await h(U,v.MOVE),await F(M);else throw j}}async function T(U,M,F){return $(U,M,{root:{source:U,target:M},options:F,handledSourcePaths:new Set})}const O=511;async function $(U,M,F){if(F.handledSourcePaths.has(U))return;F.handledSourcePaths.add(U);const{stat:j,symbolicLink:_}=await i.stat(U);if(_){if(F.options.preserveSymlinks)try{return await V(U,M,F)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(_.dangling)return}return j.isDirectory()?z(U,M,j.mode&O,F):G(U,M,j.mode&O)}async function z(U,M,F,j){await e.Promises.mkdir(M,{recursive:!0,mode:F});const _=await I(U);for(const N of _)await $((0,k.join)(U,N),(0,k.join)(M,N),j)}async function G(U,M,F){await e.Promises.copyFile(U,M),await e.Promises.chmod(M,F)}async function V(U,M,F){let j=await e.Promises.readlink(U);(0,S.isEqualOrParent)(j,F.root.source,!R.isLinux)&&(j=(0,k.join)(F.root.target,j.substr(F.root.source.length+1))),await e.Promises.symlink(j,M)}e.Promises=new class{get access(){return(0,P.promisify)(p.access)}get stat(){return(0,P.promisify)(p.stat)}get lstat(){return(0,P.promisify)(p.lstat)}get utimes(){return(0,P.promisify)(p.utimes)}get read(){return(0,P.promisify)(p.read)}get readFile(){return(0,P.promisify)(p.readFile)}get write(){return(0,P.promisify)(p.write)}get appendFile(){return(0,P.promisify)(p.appendFile)}get fdatasync(){return(0,P.promisify)(p.fdatasync)}get truncate(){return(0,P.promisify)(p.truncate)}get rename(){return(0,P.promisify)(p.rename)}get copyFile(){return(0,P.promisify)(p.copyFile)}get open(){return(0,P.promisify)(p.open)}get close(){return(0,P.promisify)(p.close)}get symlink(){return(0,P.promisify)(p.symlink)}get readlink(){return(0,P.promisify)(p.readlink)}get chmod(){return(0,P.promisify)(p.chmod)}get mkdir(){return(0,P.promisify)(p.mkdir)}get unlink(){return(0,P.promisify)(p.unlink)}get rmdir(){return(0,P.promisify)(p.rmdir)}get realpath(){return(0,P.promisify)(p.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return I}get readDirsInDir(){return t}get writeFile(){return u}get rm(){return h}get move(){return d}get copy(){return T}}}),define(Z[97],ee([0,1,49,19,8,18]),function(K,e,p,L,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(n){const y=(0,P.dirname)(n);if(n===y)return n;const m=((0,P.basename)(n)||n).toLowerCase();try{const h=(0,k.readdirSync)(y).filter(C=>C.toLowerCase()===m);if(h.length===1){const C=A(y);if(C)return(0,P.join)(C,h[0])}else if(h.length>1){const C=h.indexOf(m);if(C>=0){const D=A(y);if(D)return(0,P.join)(D,h[C])}}}catch(v){}return null}e.realcaseSync=A;async function R(n){try{return await k.Promises.realpath(n)}catch(y){const m=w(n);return await k.Promises.access(m,p.constants.R_OK),m}}e.realpath=R;function S(n){try{return p.realpathSync(n)}catch(y){const m=w(n);return p.accessSync(m,p.constants.R_OK),m}}e.realpathSync=S;function w(n){return(0,L.rtrim)((0,P.normalize)(n),P.sep)}}),define(Z[98],ee([0,1,18,35,8]),function(K,e,p,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,A=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var S;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(S||(S={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let n;process.env.PROCESSOR_ARCHITEW6432?n=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?n=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?n=1:n=0;class y{constructor(c,t,r){this.exePath=c,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await p.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:a=!1}={}){return a?w===0?process.env["ProgramFiles(x86)"]||null:n===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:a=!1,findPreview:c=!1}={}){const t=m({useAlternateBitness:a});if(!t)return null;const r=P.join(t,"PowerShell");if(!await p.SymlinkSupport.existsDirectory(r))return null;let i=-1,s=null;for(const l of await p.Promises.readdir(r)){let g=-1;if(c){const d=l.indexOf("-");if(d<0)continue;const T=l.substring(0,d);if(!k.test(T)||l.substring(d+1)!=="preview")continue;g=parseInt(T,10)}else{if(!k.test(l))continue;g=parseInt(l,10)}if(g<=i)continue;const E=P.join(r,l,"pwsh.exe");!await p.SymlinkSupport.existsFile(E)||(s=E,i=g)}if(!s)return null;const u=t.includes("x86")?" (x86)":"",o=c?" Preview":"";return new y(s,`PowerShell${o}${u}`,!0)}async function h({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const c=P.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await p.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=a?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const i of await p.Promises.readdir(c))if(t.test(i)){const s=P.join(c,i,"pwsh.exe");return new y(s,r)}return null}function C(){const a=P.join(L.homedir(),".dotnet","tools","pwsh.exe");return new y(a,".NET Core PowerShell Global Tool")}function D(){const a=P.join(process.env.windir,w===1&&n!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(a,"Windows PowerShell",!0)}async function*b(){let a=await v();a&&(yield a),a=await v({useAlternateBitness:!0}),a&&(yield a),a=await h(),a&&(yield a),a=C(),a&&(yield a),a=await v({findPreview:!0}),a&&(yield a),a=await h({findPreview:!0}),a&&(yield a),a=await v({useAlternateBitness:!0,findPreview:!0}),a&&(yield a),a=D(),a&&(yield a)}async function*I(){for await(const a of b())await a.exists()&&(yield a)}e.enumeratePowerShellInstallations=I;async function f(){for await(const a of I())return a;return null}e.getFirstAvailablePowerShellInstallation=f}),define(Z[99],ee([0,1,42,17]),function(K,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function P(A){return new Promise((R,S)=>{let w;const n=new Map;function y(v,h,C,D,b){const I=n.get(h);if(v===A||I){const f={name:m(C),cmd:C,pid:v,ppid:h,load:D,mem:b};n.set(v,f),v===A&&(w=f),I&&(I.children||(I.children=[]),I.children.push(f),I.children.length>1&&(I.children=I.children.sort((a,c)=>a.pid-c.pid)))}}function m(v){const h=/--disable-blink-features=Auxclick/,C=/\\watcher\\win32\\CodeHelper\.exe/,D=/--crashes-directory/,b=/\\pipe\\winpty-control/,I=/conhost\.exe/,f=/--type=([a-zA-Z-]+)/;if(C.exec(v))return"watcherService ";if(D.exec(v))return"electron-crash-reporter";if(b.exec(v))return"winpty-process";if(I.exec(v))return"console-window-host (Windows internal process)";let a=f.exec(v);if(a&&a.length===2)return a[1]==="renderer"?h.exec(v)?"shared-process":"window":a[1];const c=/[a-zA-Z-]+\.js/g;let t="";do a=c.exec(v),a&&(t+=a+" ");while(a);return t&&v.indexOf("node ")<0&&v.indexOf("node.exe")<0?`electron_node ${t}`:v}if(process.platform==="win32"){const v=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,C)=>{K(["windows-process-tree"],h,C)}).then(h=>{h.getProcessList(A,C=>{h.getProcessCpuUsage(C,D=>{const b=new Map;D.forEach(I=>{const f=v(I.commandLine||"");b.set(I.pid,{name:m(f),cmd:f,pid:I.pid,ppid:I.ppid,load:I.cpu||0,mem:I.memory||0})}),w=b.get(A),w?(b.forEach(I=>{const f=b.get(I.ppid);f&&(f.children||(f.children=[]),f.children.push(I))}),b.forEach(I=>{I.children&&(I.children=I.children.sort((f,a)=>f.pid-a.pid))}),R(w)):S(new Error(`Root process ${A} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let v=function(){let h=[w];const C=[];for(;h.length;){const b=h.shift();b&&(C.push(b.pid),b.children&&(h=h.concat(b.children)))}let D=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",K).fsPath);D+=" "+C.join(" "),(0,p.exec)(D,{},(b,I,f)=>{if(b||f)S(b||new Error(f.toString()));else{const a=I.toString().split(`
`);for(let c=0;c<C.length;c++){const t=n.get(C[c]);t.load=parseFloat(a[c])}if(!w){S(new Error(`Root process ${A} not found`));return}R(w)}})};(0,p.exec)("which ps",{},(h,C,D)=>{if(h||D)if(process.platform!=="linux")S(h||new Error(D.toString()));else{const b=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",K).fsPath);(0,p.exec)(b,{},(I,f,a)=>{I||a?S(I||new Error(a.toString())):(k(f,y),v())})}else{const b=C.toString().trim(),I="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,p.exec)(`${b} ${I}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,a,c)=>{f||c&&!c.includes("screen size is bogus")?S(f||new Error(c.toString())):(k(a,y),process.platform==="linux"?v():w?R(w):S(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=P;function k(A,R){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=A.toString().split(`
`);for(const n of w){const y=S.exec(n.trim());y&&y.length===6&&R(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(Z[100],ee([0,1,8,49,7,66,2,18]),function(K,e,p,L,P,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function S(y,m,v){return n({path:y,isDirectory:!1},m,v)}e.watchFile=S;function w(y,m,v){return n({path:y,isDirectory:!0},m,v)}e.watchFolder=w,e.CHANGE_BUFFER_DELAY=100;function n(y,m,v){const h=(0,p.basename)(y.path),C=new Map;let D=!1,b=[(0,A.toDisposable)(()=>{C.forEach(I=>(0,A.dispose)(I)),C.clear()})];try{const I=(0,L.watch)(y.path);b.push((0,A.toDisposable)(()=>{I.removeAllListeners(),I.close()}));const f=new Set;y.isDirectory&&R.Promises.readdir(y.path).then(a=>a.forEach(c=>f.add(c))),I.on("error",(a,c)=>{D||v(`Failed to watch ${y.path} for changes using fs.watch() (${a}, ${c})`)}),I.on("change",(a,c)=>{if(D)return;let t="";if(c&&(t=c.toString(),P.isMacintosh&&(t=(0,k.normalizeNFC)(t))),!t||a!=="change"&&a!=="rename")return;const r=y.isDirectory?(0,p.join)(y.path,t):y.path;if(y.isDirectory)if(a==="rename"){const i=C.get(r);i&&(0,A.dispose)(i);const s=setTimeout(async()=>{C.delete(r);const u=await R.Promises.exists(r);if(D)return;let o;u?f.has(t)?o="changed":(o="added",f.add(t)):(f.delete(t),o="deleted"),m(o,r)},e.CHANGE_BUFFER_DELAY);C.set(r,(0,A.toDisposable)(()=>clearTimeout(s)))}else{let i;f.has(t)?i="changed":(i="added",f.add(t)),m(i,r)}else if(a==="rename"||t!==h){const i=setTimeout(async()=>{const s=await R.Promises.exists(r);D||(s?(m("changed",r),b=[n(y,m,v)]):m("deleted",r))},e.CHANGE_BUFFER_DELAY);(0,A.dispose)(b),b=[(0,A.toDisposable)(()=>clearTimeout(i))]}else m("changed",r)})}catch(I){R.Promises.exists(y.path).then(f=>{f&&!D&&v(`Failed to watch ${y.path} for changes using fs.watch() (${I.toString()})`)})}return(0,A.toDisposable)(()=>{D=!0,b=(0,A.dispose)(b)})}});var fe=this&&this.__decorate||function(K,e,p,L){var P=arguments.length,k=P<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,p):L,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(K,e,p,L);else for(var R=K.length-1;R>=0;R--)(A=K[R])&&(k=(P<3?A(k):P>3?A(e,p,k):A(e,p))||k);return P>3&&k&&Object.defineProperty(e,p,k),k};define(Z[36],ee([0,1,3,2,5,29,11,25,23,16,92,19,64]),function(K,e,p,L,P,k,A,R,S,w,n,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var v;(function(_){_[_.Promise=100]="Promise",_[_.PromiseCancel=101]="PromiseCancel",_[_.EventListen=102]="EventListen",_[_.EventDispose=103]="EventDispose"})(v=e.RequestType||(e.RequestType={}));function h(_){switch(_){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var C;(function(_){_[_.Initialize=200]="Initialize",_[_.PromiseSuccess=201]="PromiseSuccess",_[_.PromiseError=202]="PromiseError",_[_.PromiseErrorObj=203]="PromiseErrorObj",_[_.EventFire=204]="EventFire"})(C=e.ResponseType||(e.ResponseType={}));function D(_){switch(_){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(_){_[_.Uninitialized=0]="Uninitialized",_[_.Idle=1]="Idle"})(b||(b={}));class I{constructor(N){this.buffer=N,this.pos=0}read(N){const W=this.buffer.slice(this.pos,this.pos+N);return this.pos+=W.byteLength,W}}class f{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}var a;(function(_){_[_.Undefined=0]="Undefined",_[_.String=1]="String",_[_.Buffer=2]="Buffer",_[_.VSBuffer=3]="VSBuffer",_[_.Array=4]="Array",_[_.Object=5]="Object"})(a||(a={}));function c(_){const N=R.VSBuffer.alloc(4);return N.writeUInt32BE(_,0),N}function t(_){return _.read(4).readUInt32BE(0)}function r(_){const N=R.VSBuffer.alloc(1);return N.writeUInt8(_,0),N}const i={Undefined:r(a.Undefined),String:r(a.String),Buffer:r(a.Buffer),VSBuffer:r(a.VSBuffer),Array:r(a.Array),Object:r(a.Object)},s=typeof Buffer!="undefined";function u(_,N){if(typeof N=="undefined")_.write(i.Undefined);else if(typeof N=="string"){const W=R.VSBuffer.fromString(N);_.write(i.String),_.write(c(W.byteLength)),_.write(W)}else if(s&&Buffer.isBuffer(N)){const W=R.VSBuffer.wrap(N);_.write(i.Buffer),_.write(c(W.byteLength)),_.write(W)}else if(N instanceof R.VSBuffer)_.write(i.VSBuffer),_.write(c(N.byteLength)),_.write(N);else if(Array.isArray(N)){_.write(i.Array),_.write(c(N.length));for(const W of N)u(_,W)}else{const W=R.VSBuffer.fromString(JSON.stringify(N));_.write(i.Object),_.write(c(W.byteLength)),_.write(W)}}function o(_){switch(_.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return _.read(t(_)).toString();case a.Buffer:return _.read(t(_)).buffer;case a.VSBuffer:return _.read(t(_));case a.Array:{const W=t(_),x=[];for(let B=0;B<W;B++)x.push(o(_));return x}case a.Object:return JSON.parse(_.read(t(_)).toString())}}class l{constructor(N,W,x=null,B=1e3){this.protocol=N,this.ctx=W,this.logger=x,this.timeoutDelay=B,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(H=>this.onRawMessage(H)),this.sendResponse({type:200})}registerChannel(N,W){this.channels.set(N,W),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const W=this.send([N.type]);this.logger&&this.logger.logOutgoing(W,0,1,D(N.type));return}case 201:case 202:case 204:case 203:{const W=this.send([N.type,N.id],N.data);this.logger&&this.logger.logOutgoing(W,N.id,1,D(N.type),N.data);return}}}send(N,W=void 0){const x=new f;return u(x,N),u(x,W),this.sendBuffer(x.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(W){return 0}}onRawMessage(N){const W=new I(N),x=o(W),B=o(W),H=x[0];switch(H){case 100:return this.logger&&this.logger.logIncoming(N.byteLength,x[1],1,`${h(H)}: ${x[2]}.${x[3]}`,B),this.onPromise({type:H,id:x[1],channelName:x[2],name:x[3],arg:B});case 102:return this.logger&&this.logger.logIncoming(N.byteLength,x[1],1,`${h(H)}: ${x[2]}.${x[3]}`,B),this.onEventListen({type:H,id:x[1],channelName:x[2],name:x[3],arg:B});case 101:return this.logger&&this.logger.logIncoming(N.byteLength,x[1],1,`${h(H)}`),this.disposeActiveRequest({type:H,id:x[1]});case 103:return this.logger&&this.logger.logIncoming(N.byteLength,x[1],1,`${h(H)}`),this.disposeActiveRequest({type:H,id:x[1]})}}onPromise(N){const W=this.channels.get(N.channelName);if(!W){this.collectPendingRequest(N);return}const x=new k.CancellationTokenSource;let B;try{B=W.call(this.ctx,N.name,N.arg,x.token)}catch(Q){B=Promise.reject(Q)}const H=N.id;B.then(Q=>{this.sendResponse({id:H,data:Q,type:201}),this.activeRequests.delete(N.id)},Q=>{Q instanceof Error?this.sendResponse({id:H,data:{message:Q.message,name:Q.name,stack:Q.stack?Q.stack.split?Q.stack.split(`
`):Q.stack:void 0},type:202}):this.sendResponse({id:H,data:Q,type:203}),this.activeRequests.delete(N.id)});const X=(0,L.toDisposable)(()=>x.cancel());this.activeRequests.set(N.id,X)}onEventListen(N){const W=this.channels.get(N.channelName);if(!W){this.collectPendingRequest(N);return}const x=N.id,H=W.listen(this.ctx,N.name,N.arg)(X=>this.sendResponse({id:x,data:X,type:204}));this.activeRequests.set(N.id,H)}disposeActiveRequest(N){const W=this.activeRequests.get(N.id);W&&(W.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let W=this.pendingRequests.get(N.channelName);W||(W=[],this.pendingRequests.set(N.channelName,W));const x=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:N,timeoutTimer:x})}flushPendingRequests(N){const W=this.pendingRequests.get(N);if(W){for(const x of W)switch(clearTimeout(x.timeoutTimer),x.request.type){case 100:this.onPromise(x.request);break;case 102:this.onEventListen(x.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}e.ChannelServer=l;var g;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(N,W=null){this.protocol=N,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(x=>this.onBuffer(x)),this.logger=W}getChannel(N){const W=this;return{call(x,B,H){return W.isDisposed?Promise.reject(A.canceled()):W.requestPromise(N,x,B,H)},listen(x,B){return W.isDisposed?Promise.reject(A.canceled()):W.requestEvent(N,x,B)}}}requestPromise(N,W,x,B=k.CancellationToken.None){const H=this.lastRequestId++,Q={id:H,type:100,channelName:N,name:W,arg:x};if(B.isCancellationRequested)return Promise.reject(A.canceled());let ie;return new Promise((le,de)=>{if(B.isCancellationRequested)return de(A.canceled());const ye=()=>{const Ne=Oe=>{switch(Oe.type){case 201:this.handlers.delete(H),le(Oe.data);break;case 202:this.handlers.delete(H);const Le=new Error(Oe.data.message);Le.stack=Oe.data.stack,Le.name=Oe.data.name,de(Le);break;case 203:this.handlers.delete(H),de(Oe.data);break}};this.handlers.set(H,Ne),this.sendRequest(Q)};let pe=null;this.state===b.Idle?ye():(pe=(0,P.createCancelablePromise)(Ne=>this.whenInitialized()),pe.then(()=>{pe=null,ye()}));const De=()=>{pe?(pe.cancel(),pe=null):this.sendRequest({id:H,type:101}),de(A.canceled())},Te=B.onCancellationRequested(De);ie=(0,L.combinedDisposable)((0,L.toDisposable)(De),Te),this.activeRequests.add(ie)}).finally(()=>{this.activeRequests.delete(ie)})}requestEvent(N,W,x){const B=this.lastRequestId++,X={id:B,type:102,channelName:N,name:W,arg:x};let Q=null;const ie=new p.Emitter({onFirstListenerAdd:()=>{Q=(0,P.createCancelablePromise)(le=>this.whenInitialized()),Q.then(()=>{Q=null,this.activeRequests.add(ie),this.sendRequest(X)})},onLastListenerRemove:()=>{Q?(Q.cancel(),Q=null):(this.activeRequests.delete(ie),this.sendRequest({id:B,type:103}))}}),ne=le=>ie.fire(le.data);return this.handlers.set(B,ne),ie.event}sendRequest(N){switch(N.type){case 100:case 102:{const W=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger&&this.logger.logOutgoing(W,N.id,0,`${h(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const W=this.send([N.type,N.id]);this.logger&&this.logger.logOutgoing(W,N.id,0,h(N.type));return}}}send(N,W=void 0){const x=new f;return u(x,N),u(x,W),this.sendBuffer(x.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch(W){return 0}}onBuffer(N){const W=new I(N),x=o(W),B=o(W),H=x[0];switch(H){case 200:return this.logger&&this.logger.logIncoming(N.byteLength,0,0,D(H)),this.onResponse({type:x[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(N.byteLength,x[1],0,D(H),B),this.onResponse({type:x[0],id:x[1],data:B})}}onResponse(N){if(N.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const W=this.handlers.get(N.id);W&&W(N)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(N=>N.dispose()),this.activeRequests.clear()}}fe([m.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class d{constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:W,onDidClientDisconnect:x})=>{p.Event.once(W.onMessage)(H=>{const X=new I(H),Q=o(X),ie=new l(W,Q),ne=new E(W);this.channels.forEach((de,ye)=>ie.registerChannel(ye,de));const le={channelServer:ie,channelClient:ne,ctx:Q};this._connections.add(le),this._onDidAddConnection.fire(le),x(()=>{ie.dispose(),ne.dispose(),this._connections.delete(le),this._onDidRemoveConnection.fire(le)})})})}get connections(){const N=[];return this._connections.forEach(W=>N.push(W)),N}getChannel(N,W){const x=this;return{call(B,H,X){let Q;if((0,w.isFunction)(W)){let ne=(0,S.getRandomElement)(x.connections.filter(W));Q=ne?Promise.resolve(ne):p.Event.toPromise(p.Event.filter(x.onDidAddConnection,W))}else Q=W.routeCall(x,B,H);const ie=Q.then(ne=>ne.channelClient.getChannel(N));return O(ie).call(B,H,X)},listen(B,H){if((0,w.isFunction)(W))return x.getMulticastEvent(N,W,B,H);const X=W.routeEvent(x,B,H).then(Q=>Q.channelClient.getChannel(N));return O(X).listen(B,H)}}}getMulticastEvent(N,W,x,B){const H=this;let X=new L.DisposableStore;const Q=new p.Emitter({onFirstListenerAdd:()=>{X=new L.DisposableStore;const ie=new p.EventMultiplexer,ne=new Map,le=ye=>{const De=ye.channelClient.getChannel(N).listen(x,B),Te=ie.add(De);ne.set(ye,Te)},de=ye=>{const pe=ne.get(ye);!pe||(pe.dispose(),ne.delete(ye))};H.connections.filter(W).forEach(le),p.Event.filter(H.onDidAddConnection,W)(le,void 0,X),H.onDidRemoveConnection(de,void 0,X),ie.event(Q.fire,Q,X),X.add(ie)},onLastListenerRemove:()=>{X.dispose()}});return Q.event}registerChannel(N,W){this.channels.set(N,W),this._connections.forEach(x=>{x.channelServer.registerChannel(N,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=d;class T{constructor(N,W,x=null){const B=new f;u(B,W),N.send(B.buffer),this.channelClient=new E(N,x),this.channelServer=new l(N,W,x)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,W){this.channelServer.registerChannel(N,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function O(_){return{call(N,W,x){return _.then(B=>B.call(N,W,x))},listen(N,W){const x=new p.Relay;return _.then(B=>x.input=B.listen(N,W)),x.event}}}e.getDelayedChannel=O;function $(_){let N=!1;return{call(W,x,B){return N?_.call(W,x,B):(0,P.timeout)(0).then(()=>N=!0).then(()=>_.call(W,x,B))},listen(W,x){if(N)return _.listen(W,x);const B=new p.Relay;return(0,P.timeout)(0).then(()=>N=!0).then(()=>B.input=_.listen(W,x)),B.event}}}e.getNextTickChannel=$;class z{constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const W of N.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await p.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=z;var G;(function(_){function N(B,H){const X=B,Q=H&&H.disableMarshalling,ie=new Map;for(const ne in X)x(ne)&&ie.set(ne,p.Event.buffer(X[ne],!0));return new class{listen(ne,le){const de=ie.get(le);if(de)return de;throw new Error(`Event not found: ${le}`)}call(ne,le,de){const ye=X[le];if(typeof ye=="function"){if(!Q&&Array.isArray(de))for(let pe=0;pe<de.length;pe++)de[pe]=(0,n.revive)(de[pe]);return ye.apply(X,de)}throw new Error(`Method not found: ${le}`)}}}_.fromService=N;function W(B,H){const X=H&&H.disableMarshalling;return new Proxy({},{get(Q,ie){if(typeof ie=="string")return H?.properties?.has(ie)?H.properties.get(ie):x(ie)?B.listen(ie):async function(...ne){let le;H&&!(0,w.isUndefinedOrNull)(H.context)?le=[H.context,...ne]:le=ne;const de=await B.call(ie,le);return X?de:(0,n.revive)(de)};throw new Error(`Property not found: ${String(ie)}`)}})}_.toService=W;function x(B){return B[0]==="o"&&B[1]==="n"&&y.isUpperAsciiLetter(B.charCodeAt(2))}})(G=e.ProxyChannel||(e.ProxyChannel={}));const V=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(_){if(Array.isArray(_))return _;if(_&&typeof _=="object"&&typeof _.toString=="function"){let N=_.toString();if(N!=="[object Object]")return N}return _}function M(_){return Array.isArray(_)?_.map(U):U(_)}function F(_,N,W,x,B,H,X){X=M(X);const Q=V[B],ie=Q[x%Q.length];let ne=[`%c[${_}]%c[${String(N).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(x).padStart(5," ")} - ${H}`,"color: darkgreen","color: grey","color: grey",`color: ${ie}`];/\($/.test(H)?(ne=ne.concat(X),ne.push(")")):ne.push(X),console.log.apply(console,ne)}e.logWithColors=F;class j{constructor(N,W){this._outgoingPrefix=N,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,W,x,B,H){this._totalOutgoing+=N,F(this._outgoingPrefix,this._totalOutgoing,N,W,x,B,H)}logIncoming(N,W,x,B,H){this._totalIncoming+=N,F(this._incomingPrefix,this._totalIncoming,N,W,x,B,H)}}e.IPCLogger=j}),define(Z[101],ee([0,1,3,36,25]),function(K,e,p,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class k{constructor(S){this.port=S,this.onMessage=p.Event.fromDOMEventEmitter(this.port,"message",w=>P.VSBuffer.wrap(w.data)),S.start()}send(S){this.port.postMessage(S.buffer)}disconnect(){this.port.close()}}e.Protocol=k;class A extends L.IPCClient{constructor(S,w){const n=new k(S);super(n,w);this.protocol=n}dispose(){this.protocol.disconnect()}}e.Client=A}),define(Z[102],ee([0,1,103,3,36,101]),function(K,e,p,L,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends P.IPCServer{static getOnDidClientConnect(){const S=L.Event.fromNodeEventEmitter(p.ipcRenderer,"vscode:createMessageChannel",(w,n)=>n);return L.Event.map(S,w=>{const{port1:n,port2:y}=new MessageChannel,v={protocol:new k.Protocol(n),onDidClientDisconnect:L.Event.fromDOMEventEmitter(n,"close")};return p.ipcRenderer.postMessage("vscode:createMessageChannelResult",w,[y]),v})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(Z[104],ee([0,1,11,25]),function(K,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function P(R,S){R.proxyAuthorization&&(R.headers={...R.headers||{},"Proxy-Authorization":R.proxyAuthorization});const w=new XMLHttpRequest;return new Promise((n,y)=>{w.open(R.type||"GET",R.url||"",!0,R.user,R.password),k(w,R),w.responseType="arraybuffer",w.onerror=m=>y(new Error(w.statusText&&"XHR failed: "+w.statusText||"XHR failed")),w.onload=m=>{n({res:{statusCode:w.status,headers:A(w)},stream:(0,L.bufferToStream)(L.VSBuffer.wrap(new Uint8Array(w.response)))})},w.ontimeout=m=>y(new Error(`XHR timeout: ${R.timeout}ms`)),R.timeout&&(w.timeout=R.timeout),w.send(R.data),S.onCancellationRequested(()=>{w.abort(),y((0,p.canceled)())})})}e.request=P;function k(R,S){if(S.headers){e:for(let w in S.headers){switch(w){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}R.setRequestHeader(w,S.headers[w])}}}function A(R){const S=Object.create(null);for(const w of R.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(w){const n=w.indexOf(":");S[w.substr(0,n).trim().toLowerCase()]=w.substr(n+1).trim()}return S}}),define(Z[69],ee([0,1,2,3,5,16]),function(K,e,p,L,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var A;(function(n){n[n.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));var R;(function(n){n[n.None=0]="None",n[n.Initialized=1]="Initialized",n[n.Closed=2]="Closed"})(R||(R={}));class S extends p.Disposable{constructor(y,m=Object.create(null)){super();this.database=y,this.options=m,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=R.None,this.cache=new Map,this.flushDelayer=new P.ThrottledDelayer(S.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(y=>this.onDidChangeItemsExternal(y)))}onDidChangeItemsExternal(y){y.changed?.forEach((m,v)=>this.accept(v,m)),y.deleted?.forEach(m=>this.accept(m,void 0))}accept(y,m){if(this.state===R.Closed)return;let v=!1;(0,k.isUndefinedOrNull)(m)?v=this.cache.delete(y):this.cache.get(y)!==m&&(this.cache.set(y,m),v=!0),v&&this._onDidChangeStorage.fire(y)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===R.None&&(this.state=R.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(y,m){const v=this.cache.get(y);return(0,k.isUndefinedOrNull)(v)?m:v}getBoolean(y,m){const v=this.get(y);return(0,k.isUndefinedOrNull)(v)?m:v==="true"}getNumber(y,m){const v=this.get(y);return(0,k.isUndefinedOrNull)(v)?m:parseInt(v,10)}async set(y,m){if(this.state===R.Closed)return;if((0,k.isUndefinedOrNull)(m))return this.delete(y);const v=String(m);if(this.cache.get(y)!==v)return this.cache.set(y,v),this.pendingInserts.set(y,v),this.pendingDeletes.delete(y),this._onDidChangeStorage.fire(y),this.flushDelayer.trigger(()=>this.flushPending())}async delete(y){if(!(this.state===R.Closed||!this.cache.delete(y)))return this.pendingDeletes.has(y)||this.pendingDeletes.add(y),this.pendingInserts.delete(y),this._onDidChangeStorage.fire(y),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=R.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(y){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const y={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(y).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(y=>this.whenFlushedCallbacks.push(y))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=S,S.DEFAULT_FLUSH_DELAY=100;class w{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(y){y.insert&&y.insert.forEach((m,v)=>this.items.set(v,m)),y.delete&&y.delete.forEach(m=>this.items.delete(m))}async close(){}}e.InMemoryStorageDatabase=w}),define(Z[105],ee([12,13]),function(K,e){return K.create("vs/base/common/date",e)}),define(Z[56],ee([0,1,105]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,P=L*60,k=P*24,A=k*7,R=k*30,S=k*365;function w(y,m){typeof y!="number"&&(y=y.getTime());const v=Math.round((new Date().getTime()-y)/1e3);if(v<-30)return(0,p.localize)(0,null,w(new Date().getTime()+v*1e3,!1));if(v<30)return(0,p.localize)(1,null);let h;return v<L?(h=v,m?h===1?(0,p.localize)(2,null,h):(0,p.localize)(3,null,h):h===1?(0,p.localize)(4,null,h):(0,p.localize)(5,null,h)):v<P?(h=Math.floor(v/L),m?h===1?(0,p.localize)(6,null,h):(0,p.localize)(7,null,h):h===1?(0,p.localize)(8,null,h):(0,p.localize)(9,null,h)):v<k?(h=Math.floor(v/P),m?h===1?(0,p.localize)(10,null,h):(0,p.localize)(11,null,h):h===1?(0,p.localize)(12,null,h):(0,p.localize)(13,null,h)):v<A?(h=Math.floor(v/k),m?h===1?(0,p.localize)(14,null,h):(0,p.localize)(15,null,h):h===1?(0,p.localize)(16,null,h):(0,p.localize)(17,null,h)):v<R?(h=Math.floor(v/A),m?h===1?(0,p.localize)(18,null,h):(0,p.localize)(19,null,h):h===1?(0,p.localize)(20,null,h):(0,p.localize)(21,null,h)):v<S?(h=Math.floor(v/R),m?h===1?(0,p.localize)(22,null,h):(0,p.localize)(23,null,h):h===1?(0,p.localize)(24,null,h):(0,p.localize)(25,null,h)):(h=Math.floor(v/S),m?h===1?(0,p.localize)(26,null,h):(0,p.localize)(27,null,h):h===1?(0,p.localize)(28,null,h):(0,p.localize)(29,null,h))}e.fromNow=w;function n(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(Z[106],ee([12,13]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(Z[43],ee([0,1,106,16,23]),function(K,e,p,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function k(w,n){return n&&(w.stack||w.stacktrace)?p.localize(0,null,R(w),A(w.stack)||A(w.stacktrace)):R(w)}function A(w){return Array.isArray(w)?w.join(`
`):w}function R(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?p.localize(1,null,w.message):w.message||p.localize(2,null)}function S(w=null,n=!1){if(!w)return p.localize(3,null);if(Array.isArray(w)){const y=P.coalesce(w),m=S(y[0],n);return y.length>1?p.localize(4,null,m,y.length):m}if(L.isString(w))return w;if(w.detail){const y=w.detail;if(y.error)return k(y.error,n);if(y.exception)return k(y.exception,n)}return w.stack?k(w,n):w.message?w.message:p.localize(5,null)}e.toErrorMessage=S}),define(Z[107],ee([12,13]),function(K,e){return K.create("vs/base/node/processes",e)}),define(Z[108],ee([0,1,8,18,42,107,34,16,26,41,7,68,17]),function(K,e,p,L,P,k,A,R,S,w,n,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function v(a){switch(a){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(a,c){if(n.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};c&&(t.cwd=c);const r=P.execFile("taskkill",["/T","/F","/PID",a.pid.toString()],t);return new Promise(i=>{r.once("error",s=>{i({success:!1,error:s})}),r.once("exit",(s,u)=>{i(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?v(t.status):1})}else if(n.isLinux||n.isMacintosh)try{const t=m.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(r=>{P.execFile(t,[a.pid.toString()],{encoding:"utf8",shell:!0},(i,s,u)=>{r(i?{success:!1,error:i}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else a.kill("SIGKILL");return Promise.resolve({success:!0})}function C(a=A.env){return a.comspec||"cmd.exe"}e.getWindowsShell=C;class D{constructor(c,t,r,i){if(t!==void 0&&r!==void 0&&i!==void 0)this.cmd=c,this.args=t,this.shell=r,this.options=i;else{const s=c;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(A.env).forEach(u=>{s[u]=A.env[u]}),Object.keys(this.options.env).forEach(u=>{s[u]=this.options.env[u]}),this.options.env=s}}getSanitizedCommand(){let c=this.cmd.toLowerCase();const t=c.lastIndexOf(p.sep);return t!==-1&&(c=c.substring(t+1)),D.WellKnowCommands[c]?c:"other"}start(c){return n.isWindows&&(this.options&&this.options.cwd&&w.isUNC(this.options.cwd)||!this.options&&w.isUNC(A.cwd()))?Promise.reject(new Error(k.localize(0,null))):this.useExec().then(t=>{let r,i;const s=new Promise((u,o)=>{r=u,i=o});if(t){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=P.exec(u,this.options,(o,l,g)=>{this.childProcess=null;const E=o;E&&E.killed?i({killed:this.terminateRequested,stdout:l.toString(),stderr:g.toString()}):this.handleExec(r,c,o,l,g)})}else{let u=null;const o=l=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(l,r,c,i);const g={terminated:this.terminateRequested};R.isNumber(l)&&(g.cmdCode=l),r(g)};if(this.shell&&n.isWindows){const l=S.deepClone(this.options);l.windowsVerbatimArguments=!0,l.detached=!1;let g=!1,E=!1;const d=[];let T=this.ensureQuotes(this.cmd);d.push(T.value),g=T.quoted,this.args&&this.args.forEach($=>{T=this.ensureQuotes($),d.push(T.value),E=E&&T.quoted});const O=["/s","/c"];g?E?O.push('"'+d.join(" ")+'"'):d.length>1?O.push('"'+d[0]+'" '+d.slice(1).join(" ")):O.push('"'+d[0]+'"'):O.push(d.join(" ")),u=P.spawn(C(),O,l)}else this.cmd&&(u=P.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(R.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",l=>{this.childProcess=null,i({terminated:this.terminateRequested,error:l})}),u.pid&&(this.childProcess.on("close",o),this.handleSpawn(u,r,c,i,!0)))}return s})}handleClose(c,t,r,i){}ensureQuotes(c){return D.regexp.test(c)?{value:'"'+c+'"',quoted:!0}:{value:c,quoted:c.length>0&&c[0]==='"'&&c[c.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(c=>c.pid,c=>-1):new Promise(c=>{this.pidResolve=c})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(c=>(this.terminateRequested=!0,h(c,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),c=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(c=>{if(!this.shell||!n.isWindows)return c(!1);const t=P.spawn(C(),["/s","/c"]);t.on("error",r=>c(!0)),t.on("exit",r=>c(!1))})}}e.AbstractProcess=D,D.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},D.regexp=/^[^"].* .*[^"]/;class b extends D{constructor(c,t,r,i){super(c,t,r,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(c,t,r,i,s){[i,s].forEach((u,o)=>{const l=new y.LineDecoder;l.write(u).forEach(d=>{t({line:d,source:o===0?0:1})});const E=l.end();E&&t({line:E,source:o===0?0:1})}),c({terminated:this.terminateRequested,error:r})}handleSpawn(c,t,r,i,s){const u=new y.LineDecoder,o=new y.LineDecoder;c.stdout.on("data",l=>{u.write(l).forEach(E=>r({line:E,source:0}))}),c.stderr.on("data",l=>{o.write(l).forEach(E=>r({line:E,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=o}handleClose(c,t,r,i){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&r({line:s,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&r({line:u,source:1})}}e.LineProcess=b;function I(a){let c=[],t=!1;const r=function(i){if(t){c.push(i);return}(!a.send(i,u=>{if(u&&console.error(u),t=!1,c.length>0){const o=c.slice(0);c=[],o.forEach(l=>r(l))}})||n.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=I;var f;(function(a){async function c(t,r,i){if(p.isAbsolute(t))return t;if(r===void 0&&(r=A.cwd()),p.dirname(t)!=="."||(i===void 0&&R.isString(A.env.PATH)&&(i=A.env.PATH.split(p.delimiter)),i===void 0||i.length===0))return p.join(r,t);async function u(o){return await L.Promises.exists(o)?!(await L.Promises.stat(o)).isDirectory():!1}for(let o of i){let l;if(p.isAbsolute(o)?l=p.join(o,t):l=p.join(r,o,t),await u(l))return l;let g=l+".com";if(await u(g)||(g=l+".exe",await u(g)))return g}return p.join(r,t)}a.findExecutable=c})(f=e.win32||(e.win32={}))}),define(Z[50],ee([0,1,42,2,5,26,3,108,36,91,29,11,25,7]),function(K,e,p,L,P,k,A,R,S,w,n,y,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends S.ChannelServer{constructor(b){super({send:I=>{try{process.send&&process.send(I.buffer.toString("base64"))}catch(f){}},onMessage:A.Event.fromNodeEventEmitter(process,"message",I=>m.VSBuffer.wrap(Buffer.from(I,"base64")))},b);process.once("disconnect",()=>this.dispose())}}e.Server=h;class C{constructor(b,I){this.modulePath=b,this.options=I,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new A.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const f=I&&I.timeout?I.timeout:6e4;this.disposeDelayer=new P.Delayer(f),this.child=null,this._client=null}getChannel(b){const I=this;return{call(f,a,c){return I.requestPromise(b,f,a,c)},listen(f,a){return I.requestEvent(b,f,a)}}}requestPromise(b,I,f,a=n.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(a.isCancellationRequested)return Promise.reject(y.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(b),t=(0,P.createCancelablePromise)(s=>c.call(I,f,s)),r=a.onCancellationRequested(()=>t.cancel()),i=(0,L.toDisposable)(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(b,I,f){if(!this.disposeDelayer)return A.Event.None;this.disposeDelayer.cancel();let a;const c=new A.Emitter({onFirstListenerAdd:()=>{a=this.getCachedChannel(b).listen(I,f)(c.fire,c),this.activeRequests.add(a)},onLastListenerRemove:()=>{this.activeRequests.delete(a),a.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const b=this.options&&this.options.args?this.options.args:[],I=Object.create(null);I.env={...(0,k.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(I.env={...I.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(I.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(I.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(I.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),I.execArgv===void 0&&(I.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u))),v.isMacintosh&&I.env&&delete I.env.DYLD_LIBRARY_PATH,this.child=(0,p.fork)(this.modulePath,b,I);const f=new A.Emitter;A.Event.fromNodeEventEmitter(this.child,"message",u=>u)(u=>{if((0,w.isRemoteConsoleLog)(u)){(0,w.log)(u,`IPC Library: ${this.options.serverName}`);return}f.fire(m.VSBuffer.wrap(Buffer.from(u,"base64")))});const c=this.options.useQueue?(0,R.createQueuedSender)(this.child):this.child,t=u=>this.child&&this.child.connected&&c.send(u.buffer.toString("base64")),r=f.event,i={send:t,onMessage:r};this._client=new S.ChannelClient(i);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",u=>console.warn('IPC "'+this.options.serverName+'" errored with '+u)),this.child.on("exit",(u,o)=>{process.removeListener("exit",s),this.activeRequests.forEach(l=>(0,L.dispose)(l)),this.activeRequests.clear(),u!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+u+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:u,signal:o})})}return this._client}getCachedChannel(b){let I=this.channels.get(b);return I||(I=this.client.getChannel(b),this.channels.set(b,I)),I}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=C}),define(Z[109],ee([12,13]),function(K,e){return K.create("vs/base/node/zip",e)}),define(Z[110],ee([12,13]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[111],ee([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Z[112],ee([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[113],ee([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(Z[114],ee([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[115],ee([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[116],ee([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(Z[117],ee([12,13]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[118],ee([12,13]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(Z[119],ee([12,13]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(Z[120],ee([12,13]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(Z[121],ee([12,13]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[122],ee([12,13]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(Z[123],ee([12,13]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[124],ee([12,13]),function(K,e){return K.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(Z[125],ee([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(Z[126],ee([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(Z[127],ee([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/settingsSync",e)}),define(Z[128],ee([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(Z[129],ee([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSync",e)}),define(Z[130],ee([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(Z[131],ee([0,1,8,15,64,56,17,4,34]),function(K,e,p,L,P,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class w{constructor(h,C,D){this._args=h,this.paths=C,this.productService=D}get appRoot(){return(0,p.dirname)(A.FileAccess.asFileUri("",K).fsPath)}get userHome(){return R.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return R.URI.file((0,p.join)(this.userDataPath,"User"))}get tmpDir(){return R.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,L.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,L.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,p.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return R.URI.file((0,p.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,L.joinPath)(R.URI.file((0,p.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return R.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return R.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=S.env.VSCODE_PORTABLE;return h?R.URI.file((0,p.join)(h,"argv.json")):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,L.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return R.URI.file((0,p.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,p.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,p.resolve)(h):(0,p.normalize)((0,p.join)(A.FileAccess.asFileUri("",K).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?(0,p.resolve)(h):(0,p.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,p.resolve)(h);const C=S.env.VSCODE_EXTENSIONS;if(C)return C;const D=S.env.VSCODE_PORTABLE;return D?(0,p.join)(D,"extensions"):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(C=>/^[^:/?#]+?:\/\//.test(C)?R.URI.parse(C):R.URI.file((0,p.normalize)(C)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?R.URI.parse(h):R.URI.file((0,p.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return n(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!S.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,L.joinPath)(R.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return R.URI.file((0,p.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}fe([P.memoize],w.prototype,"appRoot",null),fe([P.memoize],w.prototype,"userHome",null),fe([P.memoize],w.prototype,"userDataPath",null),fe([P.memoize],w.prototype,"appSettingsHome",null),fe([P.memoize],w.prototype,"tmpDir",null),fe([P.memoize],w.prototype,"userRoamingDataHome",null),fe([P.memoize],w.prototype,"settingsResource",null),fe([P.memoize],w.prototype,"userDataSyncHome",null),fe([P.memoize],w.prototype,"userDataSyncLogResource",null),fe([P.memoize],w.prototype,"sync",null),fe([P.memoize],w.prototype,"machineSettingsResource",null),fe([P.memoize],w.prototype,"globalStorageHome",null),fe([P.memoize],w.prototype,"workspaceStorageHome",null),fe([P.memoize],w.prototype,"keybindingsResource",null),fe([P.memoize],w.prototype,"keyboardLayoutResource",null),fe([P.memoize],w.prototype,"argvResource",null),fe([P.memoize],w.prototype,"snippetsHome",null),fe([P.memoize],w.prototype,"isExtensionDevelopment",null),fe([P.memoize],w.prototype,"untitledWorkspacesHome",null),fe([P.memoize],w.prototype,"installSourcePath",null),fe([P.memoize],w.prototype,"builtinExtensionsPath",null),fe([P.memoize],w.prototype,"extensionsPath",null),fe([P.memoize],w.prototype,"extensionDevelopmentLocationURI",null),fe([P.memoize],w.prototype,"extensionDevelopmentKind",null),fe([P.memoize],w.prototype,"extensionTestsLocationURI",null),fe([P.memoize],w.prototype,"debugExtensionHost",null),fe([P.memoize],w.prototype,"serviceMachineIdResource",null),fe([P.memoize],w.prototype,"telemetryLogResource",null),fe([P.memoize],w.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=w;function n(v,h){return m(v["inspect-extensions"],v["inspect-brk-extensions"],5870,h,v.debugId)}e.parseExtensionHostPort=n;function y(v,h){return m(v["inspect-search"],v["inspect-brk-search"],5876,h)}e.parseSearchPort=y;function m(v,h,C,D,b){const f=Number(h||v)||(D?null:C),a=f?Boolean(!!h):!1;return{port:f,break:a,debugId:b}}}),function(){"use strict";function K(e,p,L,P){function k(R){const S=A(R),w=[S];return e.isAbsolute(S)||w.unshift(P),e.resolve(...w)}function A(R){const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,L);const n=R["user-data-dir"];if(n)return n;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(y,"AppData","Roaming")}break;case"darwin":w=e.join(p.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(p.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,L)}return{getUserDataPath:k}}if(typeof define=="function")define(Z[132],ee([0,212,35,17,15,34]),function(e,p,L,P,k,A){const R=k.dirname(P.FileAccess.asFileUri("",e)),S=e.__$__nodeRequire(k.joinPath(R,"package.json").fsPath);return K(p,L,S.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),p=require("path"),L=require("os");module.exports=K(p,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[133],ee([0,1,35,132,131]),function(K,e,p,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends P.AbstractNativeEnvironmentService{constructor(R,S){super(R,{homeDir:(0,p.homedir)(),tmpDir:(0,p.tmpdir)(),userDataDir:(0,L.getUserDataPath)(R)},S)}}e.NativeEnvironmentService=k}),define(Z[134],ee([0,1,4]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const L=/^([^@:]+@)?([^:]+):/,P=/^([^@:]+@)?([^:]+):(.+)$/,k=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,S=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function w(D){const b=D.match(A);return b?b[1]:null}function n(D){if(D.indexOf("://")===-1){const b=D.match(L);return b?w(b[2]):null}try{const b=p.URI.parse(D);if(b.authority)return w(b.authority)}catch(b){}return null}function y(D,b){const I=new Set;let f;for(;f=R.exec(D);){const c=n(f[1]);c&&I.add(c)}const a=new Set(b);return Array.from(I).map(c=>a.has(c)?c:c.replace(S,"a"))}e.getDomainsOfRemotes=y;function m(D){const b=D.match(k);return b?b[2]:null}function v(D,b,I){return D&&b?(I&&b.endsWith(".git")&&(b=b.substr(0,b.length-4)),b.indexOf("/")===0?`${D}${b}`:`${D}/${b}`):null}function h(D,b){if(D.indexOf("://")===-1){const I=D.match(P);if(I)return v(I[2],I[3],b)}try{const I=p.URI.parse(D);if(I.authority)return v(m(I.authority),I.path,b)}catch(I){}return null}function C(D,b=!1){const I=[];let f;for(;f=R.exec(D);){const a=h(f[1],b);a&&I.push(a)}return I}e.getRemotes=C}),define(Z[135],ee([0,1,3,4,94,26,2]),function(K,e,p,L,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function R(h,C){return L.URI.revive(C?C.transformIncoming(h):h)}function S(h,C){return C?C.transformOutgoingURI(h):h}function w(h,C){C=C||P.DefaultURITransformer;const D=h.manifest;return{...(0,P.transformAndReviveIncomingURIs)({...h,manifest:void 0},C),manifest:D}}function n(h,C){return C?(0,k.cloneAndChange)(h,D=>D instanceof L.URI?C.transformOutgoingURI(D):void 0):h}class y{constructor(C,D){this.service=C,this.getUriTransformer=D,this.onInstallExtension=p.Event.buffer(C.onInstallExtension,!0),this.onDidInstallExtensions=p.Event.buffer(C.onDidInstallExtensions,!0),this.onUninstallExtension=p.Event.buffer(C.onUninstallExtension,!0),this.onDidUninstallExtension=p.Event.buffer(C.onDidUninstallExtension,!0)}listen(C,D){const b=this.getUriTransformer(C);switch(D){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return p.Event.map(this.onDidInstallExtensions,I=>I.map(f=>({...f,local:f.local?n(f.local,b):f.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(C,D,b){const I=this.getUriTransformer(C);switch(D){case"zip":return this.service.zip(w(b[0],I)).then(f=>S(f,I));case"unzip":return this.service.unzip(R(b[0],I));case"install":return this.service.install(R(b[0],I),b[1]);case"getManifest":return this.service.getManifest(R(b[0],I));case"canInstall":return this.service.canInstall(b[0]);case"installFromGallery":return this.service.installFromGallery(b[0],b[1]);case"uninstall":return this.service.uninstall(w(b[0],I),b[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(w(b[0],I));case"getInstalled":return this.service.getInstalled(b[0]).then(f=>f.map(a=>n(a,I)));case"updateMetadata":return this.service.updateMetadata(w(b[0],I),b[1]).then(f=>n(f,I));case"updateExtensionScope":return this.service.updateExtensionScope(w(b[0],I),b[1]).then(f=>n(f,I));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=y;class m extends A.Disposable{constructor(C){super();this.channel=C,this._onInstallExtension=this._register(new p.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new p.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new p.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new p.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(D=>this._onInstallExtension.fire({identifier:D.identifier,source:this.isUriComponents(D.source)?L.URI.revive(D.source):D.source}))),this._register(this.channel.listen("onDidInstallExtensions")(D=>this._onDidInstallExtensions.fire(D.map(b=>({...b,local:b.local?w(b.local,null):b.local,source:this.isUriComponents(b.source)?L.URI.revive(b.source):b.source}))))),this._register(this.channel.listen("onUninstallExtension")(D=>this._onUninstallExtension.fire(D))),this._register(this.channel.listen("onDidUninstallExtension")(D=>this._onDidUninstallExtension.fire(D)))}isUriComponents(C){return C?typeof C.path=="string"&&typeof C.scheme=="string":!1}zip(C){return Promise.resolve(this.channel.call("zip",[C]).then(D=>L.URI.revive(D)))}unzip(C){return Promise.resolve(this.channel.call("unzip",[C]))}install(C,D){return Promise.resolve(this.channel.call("install",[C,D])).then(b=>w(b,null))}getManifest(C){return Promise.resolve(this.channel.call("getManifest",[C]))}async canInstall(C){return!0}installFromGallery(C,D){return Promise.resolve(this.channel.call("installFromGallery",[C,D])).then(b=>w(b,null))}uninstall(C,D){return Promise.resolve(this.channel.call("uninstall",[C,D]))}reinstallFromGallery(C){return Promise.resolve(this.channel.call("reinstallFromGallery",[C]))}getInstalled(C=null){return Promise.resolve(this.channel.call("getInstalled",[C])).then(D=>D.map(b=>w(b,null)))}updateMetadata(C,D){return Promise.resolve(this.channel.call("updateMetadata",[C,D])).then(b=>w(b,null))}updateExtensionScope(C,D){return Promise.resolve(this.channel.call("updateExtensionScope",[C,D])).then(b=>w(b,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=m;class v{constructor(C){this.service=C}listen(C,D){throw new Error("Invalid listen")}call(C,D,b){switch(D){case"getConfigBasedTips":return this.service.getConfigBasedTips(L.URI.revive(b[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=v}),define(Z[136],ee([0,1,26]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const L=/^%([\w\d.-]+)%$/i;function P(k,A){const R=S=>{if(typeof S!="string")return;const w=L.exec(S);if(!w)return;const n=A[w[1]]??S;return typeof n=="string"?n:typeof n.message=="string"?n.message:S};return(0,p.cloneAndChange)(k,R)}e.localizeManifest=P}),define(Z[137],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class p{constructor(k){this.channel=k}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(k,A,R,S){return this.channel.call("promptImportantExtensionsInstallNotification",[k,A,R,S])}promptWorkspaceRecommendations(k){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=p;class L{constructor(k){this.service=k}listen(k,A){throw new Error(`Event not found: ${A}`)}call(k,A,R){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=L}),define(Z[70],ee([0,1,117]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function k(m){return m=m.trim(),m==="*"||L.test(m)}e.isValidVersionStr=k;function A(m){if(!k(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let v=m.match(L);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=A;function R(m){if(!m)return null;let v=m.majorBase,h=m.majorMustEqual,C=m.minorBase,D=m.minorMustEqual,b=m.patchBase,I=m.patchMustEqual;m.hasCaret&&(v===0||(D=!1),I=!1);let f=0;if(m.preRelease){const a=P.exec(m.preRelease);if(a){const[,c,t,r]=a;f=Date.UTC(Number(c),Number(t)-1,Number(r))}}return{majorBase:v,majorMustEqual:h,minorBase:C,minorMustEqual:D,patchBase:b,patchMustEqual:I,isMinimum:m.hasGreaterEquals,notBefore:f}}e.normalizeVersion=R;function S(m,v,h){let C;typeof m=="string"?C=R(A(m)):C=m;let D;v instanceof Date?D=v.getTime():typeof v=="string"&&(D=new Date(v).getTime());let b;if(typeof h=="string"?b=R(A(h)):b=h,!C||!b)return!1;let I=C.majorBase,f=C.minorBase,a=C.patchBase,c=b.majorBase,t=b.minorBase,r=b.patchBase,i=b.notBefore,s=b.majorMustEqual,u=b.minorMustEqual,o=b.patchMustEqual;return b.isMinimum?I>c?!0:I<c?!1:f>t?!0:f<t||D&&D<i?!1:a>=r:(I===1&&c===0&&(!s||!u||!o)&&(c=1,t=0,r=0,s=!0,u=!1,o=!1),I<c?!1:I>c?!s:f<t?!1:f>t?!u:a<r?!1:a>r?!o:!(D&&D<i))}e.isValidVersion=S;function w(m,v,h,C){return h.isBuiltin||typeof h.main=="undefined"?!0:y(m,v,h.engines.vscode,C)}e.isValidExtensionVersion=w;function n(m,v,h){return m==="*"||y(v,h,m)}e.isEngineValid=n;function y(m,v,h,C=[]){let D=R(A(h));if(!D)return C.push(p.localize(0,null,h)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return C.push(p.localize(1,null,h)),!1}else if(!D.majorMustEqual)return C.push(p.localize(2,null,h)),!1;return S(m,v,D)?!0:(C.push(p.localize(3,null,m,h)),!1)}}),define(Z[138],ee([0,1,36,50,2,17]),function(K,e,p,L,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A extends P.Disposable{constructor(S,w,n,y){super();this.folders=S,this.onDidFilesChange=w,this.onLogMessage=n,this.verboseLogging=y,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const S=this._register(new L.Client(k.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(S.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=p.ProxyChannel.toService((0,p.getNextTickChannel)(S.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.setFolders(this.folders)}setVerboseLogging(S){this.verboseLogging=S,!this.isDisposed&&this.service&&this.service.setVerboseLogging(S)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${S}`})}setFolders(S){this.folders=S,this.service&&this.service.setRoots(S)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=A,A.MAX_RESTARTS=5}),define(Z[139],ee([0,1,36,50,2,17]),function(K,e,p,L,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A extends P.Disposable{constructor(S,w,n,y,m={}){super();this.folders=S,this.onDidFilesChange=w,this.onLogMessage=n,this.verboseLogging=y,this.watcherOptions=m,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const S=this._register(new L.Client(k.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(S.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=p.ProxyChannel.toService((0,p.getNextTickChannel)(S.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.service.setRoots(this.folders)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${S}`})}setVerboseLogging(S){this.verboseLogging=S,this.service&&this.service.setVerboseLogging(S)}setFolders(S){this.folders=S,this.service&&this.service.setRoots(S)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=A,A.MAX_RESTARTS=5}),define(Z[140],ee([0,1,42,68,67,17]),function(K,e,p,L,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class A{constructor(S,w,n,y,m){this.watchedFolder=S,this.eventCallback=n,this.logCallback=y,this.verboseLogging=m,this.restartCounter=0,Array.isArray(w)?this.ignored=w.map(v=>(0,P.parse)(v)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${S}, excludes: ${w.join(",")}`),this.startWatcher()}startWatcher(){const S=[this.watchedFolder];this.verboseLogging&&S.push("-verbose"),this.handle=(0,p.spawn)(k.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",K).fsPath,S);const w=new L.LineDecoder;this.handle.stdout.on("data",n=>{const y=[];for(const m of w.write(n)){const v=m.split("|");if(v.length===2){const h=Number(v[0]),C=v[1];if(h>=0&&h<3){if(this.ignored&&this.ignored.some(D=>D(C))){this.verboseLogging&&this.log(C);continue}y.push({type:A.changeTypeMap[h],path:C})}else this.log(v[1])}}y.length>0&&this.eventCallback(y)}),this.handle.on("error",n=>this.onError(n)),this.handle.stderr.on("data",n=>this.onError(n)),this.handle.on("exit",(n,y)=>this.onExit(n,y))}onError(S){this.error("process error: "+S.toString())}onExit(S,w){this.handle&&(this.error(`terminated unexpectedly (code: ${S}, signal: ${w})`),this.restartCounter<=A.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(S){this.logCallback({type:"error",message:`[File Watcher (C#)] ${S}`})}log(S){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${S}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=A,A.MAX_RESTARTS=5,A.changeTypeMap=[0,1,2]}),define(Z[141],ee([0,1,140,8,19]),function(K,e,p,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k{constructor(R,S,w,n){this.onDidFilesChange=S,this.onLogMessage=w,this.verboseLogging=n,this.service=void 0,this.folder=R[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(L.posix.sep)&&(this.folder.path=(0,P.rtrim)(this.folder.path,L.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new p.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,R=>this.onFileEvents(R),R=>this.onLogMessage(R),this.verboseLogging)}setVerboseLogging(R){this.verboseLogging=R,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(R){this.isDisposed||R.length>0&&this.onDidFilesChange(R)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=k}),define(Z[51],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class p{constructor(P,k=[],A=!1){this.ctor=P,this.staticArguments=k,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=p}),define(Z[142],ee([0,1,51]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function P(A,R,S){R instanceof p.SyncDescriptor||(R=new p.SyncDescriptor(R,[],S)),L.push([A,R])}e.registerSingleton=P;function k(){return L}e.getSingletonServiceDescriptors=k}),define(Z[143],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(k){this.incoming=new Map,this.outgoing=new Map,this.data=k}}e.Node=p;class L{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(let A of this._nodes.values())A.outgoing.size===0&&k.push(A);return k}insertEdge(k,A){const R=this.lookupOrInsertNode(k),S=this.lookupOrInsertNode(A);R.outgoing.set(this._hashFn(A),S),S.incoming.set(this._hashFn(k),R)}removeNode(k){const A=this._hashFn(k);this._nodes.delete(A);for(let R of this._nodes.values())R.outgoing.delete(A),R.incoming.delete(A)}lookupOrInsertNode(k){const A=this._hashFn(k);let R=this._nodes.get(A);return R||(R=new p(k),this._nodes.set(A,R)),R}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){let k=[];for(let[A,R]of this._nodes)k.push(`${A}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return k.join(`
`)}findCycleSlow(){for(let[k,A]of this._nodes){const R=new Set([k]),S=this._findCycle(A,R);if(S)return S}}_findCycle(k,A){for(let[R,S]of k.outgoing){if(A.has(R))return[...A,R].join(" -> ");A.add(R);const w=this._findCycle(S,A);if(w)return w;A.delete(R)}}}e.Graph=L}),define(Z[6],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function S(w){return w[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=S})(p=e._util||(e._util={})),e.IInstantiationService=P("instantiationService");function L(R,S,w,n){S[p.DI_TARGET]===S?S[p.DI_DEPENDENCIES].push({id:R,index:w,optional:n}):(S[p.DI_DEPENDENCIES]=[{id:R,index:w,optional:n}],S[p.DI_TARGET]=S)}function P(R){if(p.serviceIds.has(R))return p.serviceIds.get(R);const S=function(w,n,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(S,w,y,!1)};return S.toString=()=>R,p.serviceIds.set(R,S),S}e.createDecorator=P;function k(R){return R}e.refineServiceDecorator=k;function A(R){return function(S,w,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(R,S,n,!0)}}e.optional=A}),define(Z[144],ee([0,1,6]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,p.createDecorator)("checksumService")}),define(Z[145],ee([0,1,19,6,7]),function(K,e,p,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let k=P.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",P.isMacintosh),A.set("isLinux",P.isLinux),A.set("isWindows",P.isWindows),A.set("isWeb",P.isWeb),A.set("isMacNative",P.isMacintosh&&!P.isWeb),A.set("isEdge",k.indexOf("Edg/")>=0),A.set("isFirefox",k.indexOf("Firefox")>=0),A.set("isChrome",k.indexOf("Chrome")>=0),A.set("isSafari",k.indexOf("Safari")>=0);const R=Object.prototype.hasOwnProperty;var S;(function(E){E[E.False=0]="False",E[E.True=1]="True",E[E.Defined=2]="Defined",E[E.Not=3]="Not",E[E.Equals=4]="Equals",E[E.NotEquals=5]="NotEquals",E[E.And=6]="And",E[E.Regex=7]="Regex",E[E.NotRegex=8]="NotRegex",E[E.Or=9]="Or",E[E.In=10]="In",E[E.NotIn=11]="NotIn",E[E.Greater=12]="Greater",E[E.GreaterEquals=13]="GreaterEquals",E[E.Smaller=14]="Smaller",E[E.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class w{static false(){return y.INSTANCE}static true(){return m.INSTANCE}static has(d){return v.create(d)}static equals(d,T){return h.create(d,T)}static notEquals(d,T){return b.create(d,T)}static regex(d,T){return r.create(d,T)}static in(d,T){return C.create(d,T)}static not(d){return I.create(d)}static and(...d){return s.create(d)}static or(...d){return u.create(d)}static greater(d,T){return f.create(d,T)}static less(d,T){return c.create(d,T)}static deserialize(d,T=!1){if(!!d)return this._deserializeOrExpression(d,T)}static _deserializeOrExpression(d,T){let O=d.split("||");return u.create(O.map($=>this._deserializeAndExpression($,T)))}static _deserializeAndExpression(d,T){let O=d.split("&&");return s.create(O.map($=>this._deserializeOne($,T)))}static _deserializeOne(d,T){if(d=d.trim(),d.indexOf("!=")>=0){let O=d.split("!=");return b.create(O[0].trim(),this._deserializeValue(O[1],T))}if(d.indexOf("==")>=0){let O=d.split("==");return h.create(O[0].trim(),this._deserializeValue(O[1],T))}if(d.indexOf("=~")>=0){let O=d.split("=~");return r.create(O[0].trim(),this._deserializeRegexValue(O[1],T))}if(d.indexOf(" in ")>=0){let O=d.split(" in ");return C.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(d)){const O=d.split(">=");return a.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(d)){const O=d.split(">");return f.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(d)){const O=d.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(d)){const O=d.split("<");return c.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(d)?I.create(d.substr(1).trim()):v.create(d)}static _deserializeValue(d,T){if(d=d.trim(),d==="true")return!0;if(d==="false")return!1;let O=/^'([^']*)'$/.exec(d);return O?O[1].trim():d}static _deserializeRegexValue(d,T){if((0,p.isFalsyOrWhitespace)(d)){if(T)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=d.indexOf("/"),$=d.lastIndexOf("/");if(O===$||O<0){if(T)throw new Error(`bad regexp-value '${d}', missing /-enclosure`);return console.warn(`bad regexp-value '${d}', missing /-enclosure`),null}let z=d.slice(O+1,$),G=d[$+1]==="i"?"i":"";try{return new RegExp(z,G)}catch(V){if(T)throw new Error(`bad regexp-value '${d}', parse error: ${V}`);return console.warn(`bad regexp-value '${d}', parse error: ${V}`),null}}}e.ContextKeyExpr=w;function n(E,d){return E.cmp(d)}class y{constructor(){this.type=0}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}evaluate(d){return!1}serialize(){return"false"}keys(){return[]}map(d){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=y,y.INSTANCE=new y;class m{constructor(){this.type=1}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}evaluate(d){return!0}serialize(){return"true"}keys(){return[]}map(d){return this}negate(){return y.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class v{constructor(d){this.key=d,this.type=2}static create(d){const T=A.get(d);return typeof T=="boolean"?T?m.INSTANCE:y.INSTANCE:new v(d)}cmp(d){return d.type!==this.type?this.type-d.type:l(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}evaluate(d){return!!d.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(d){return d.mapDefined(this.key)}negate(){return I.create(this.key)}}e.ContextKeyDefinedExpr=v;class h{constructor(d,T){this.key=d,this.value=T,this.type=4}static create(d,T){if(typeof T=="boolean")return T?v.create(d):I.create(d);const O=A.get(d);return typeof O=="boolean"?T===(O?"true":"false")?m.INSTANCE:y.INSTANCE:new h(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:g(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return d.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(d){return d.mapEquals(this.key,this.value)}negate(){return b.create(this.key,this.value)}}e.ContextKeyEqualsExpr=h;class C{constructor(d,T){this.key=d,this.valueKey=T,this.type=10}static create(d,T){return new C(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:g(this.key,this.valueKey,d.key,d.valueKey)}equals(d){return d.type===this.type?this.key===d.key&&this.valueKey===d.valueKey:!1}evaluate(d){const T=d.getValue(this.valueKey),O=d.getValue(this.key);return Array.isArray(T)?T.indexOf(O)>=0:typeof O=="string"&&typeof T=="object"&&T!==null?R.call(T,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(d){return d.mapIn(this.key,this.valueKey)}negate(){return D.create(this)}}e.ContextKeyInExpr=C;class D{constructor(d){this._actual=d,this.type=11}static create(d){return new D(d)}cmp(d){return d.type!==this.type?this.type-d.type:this._actual.cmp(d._actual)}equals(d){return d.type===this.type?this._actual.equals(d._actual):!1}evaluate(d){return!this._actual.evaluate(d)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(d){return new D(this._actual.map(d))}negate(){return this._actual}}e.ContextKeyNotInExpr=D;class b{constructor(d,T){this.key=d,this.value=T,this.type=5}static create(d,T){if(typeof T=="boolean")return T?I.create(d):v.create(d);const O=A.get(d);return typeof O=="boolean"?T===(O?"true":"false")?y.INSTANCE:m.INSTANCE:new b(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:g(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return d.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(d){return d.mapNotEquals(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=b;class I{constructor(d){this.key=d,this.type=3}static create(d){const T=A.get(d);return typeof T=="boolean"?T?y.INSTANCE:m.INSTANCE:new I(d)}cmp(d){return d.type!==this.type?this.type-d.type:l(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}evaluate(d){return!d.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(d){return d.mapNot(this.key)}negate(){return v.create(this.key)}}e.ContextKeyNotExpr=I;class f{constructor(d,T){this.key=d,this.value=T,this.type=12}static create(d,T){return new f(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:g(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(d){return d.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=f;class a{constructor(d,T){this.key=d,this.value=T,this.type=13}static create(d,T){return new a(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:g(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(d){return d.mapGreaterEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=a;class c{constructor(d,T){this.key=d,this.value=T,this.type=14}static create(d,T){return new c(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:g(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(d){return d.mapSmaller(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeySmallerExpr=c;class t{constructor(d,T){this.key=d,this.value=T,this.type=15}static create(d,T){return new t(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:g(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(d){return d.mapSmallerEquals(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(d,T){this.key=d,this.regexp=T,this.type=7}static create(d,T){return new r(d,T)}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.key<d.key)return-1;if(this.key>d.key)return 1;const T=this.regexp?this.regexp.source:"",O=d.regexp?d.regexp.source:"";return T<O?-1:T>O?1:0}equals(d){if(d.type===this.type){const T=this.regexp?this.regexp.source:"",O=d.regexp?d.regexp.source:"";return this.key===d.key&&T===O}return!1}evaluate(d){let T=d.getValue(this.key);return this.regexp?this.regexp.test(T):!1}serialize(){const d=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${d}`}keys(){return[this.key]}map(d){return d.mapRegex(this.key,this.regexp)}negate(){return i.create(this)}}e.ContextKeyRegexExpr=r;class i{constructor(d){this._actual=d,this.type=8}static create(d){return new i(d)}cmp(d){return d.type!==this.type?this.type-d.type:this._actual.cmp(d._actual)}equals(d){return d.type===this.type?this._actual.equals(d._actual):!1}evaluate(d){return!this._actual.evaluate(d)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(d){return new i(this._actual.map(d))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;class s{constructor(d){this.expr=d,this.type=6}static create(d){return s._normalizeArr(d)}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let T=0,O=this.expr.length;T<O;T++){const $=n(this.expr[T],d.expr[T]);if($!==0)return $}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let T=0,O=this.expr.length;T<O;T++)if(!this.expr[T].equals(d.expr[T]))return!1;return!0}return!1}evaluate(d){for(let T=0,O=this.expr.length;T<O;T++)if(!this.expr[T].evaluate(d))return!1;return!0}static _normalizeArr(d){const T=[];let O=!1;for(const $ of d)if(!!$){if($.type===1){O=!0;continue}if($.type===0)return y.INSTANCE;if($.type===6){T.push(...$.expr);continue}T.push($)}if(T.length===0&&O)return m.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];for(T.sort(n);T.length>1;){const $=T[T.length-1];if($.type!==9)break;T.pop();const z=T.pop(),G=u.create($.expr.map(V=>s.create([V,z])));G&&(T.push(G),T.sort(n))}return T.length===1?T[0]:new s(T)}}serialize(){return this.expr.map(d=>d.serialize()).join(" && ")}keys(){const d=[];for(let T of this.expr)d.push(...T.keys());return d}map(d){return new s(this.expr.map(T=>T.map(d)))}negate(){let d=[];for(let T of this.expr)d.push(T.negate());return u.create(d)}}e.ContextKeyAndExpr=s;class u{constructor(d){this.expr=d,this.type=9}static create(d){const T=u._normalizeArr(d);if(T.length!==0)return T.length===1?T[0]:new u(T)}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let T=0,O=this.expr.length;T<O;T++){const $=n(this.expr[T],d.expr[T]);if($!==0)return $}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let T=0,O=this.expr.length;T<O;T++)if(!this.expr[T].equals(d.expr[T]))return!1;return!0}return!1}evaluate(d){for(let T=0,O=this.expr.length;T<O;T++)if(this.expr[T].evaluate(d))return!0;return!1}static _normalizeArr(d){let T=[],O=!1;if(d){for(let $=0,z=d.length;$<z;$++){const G=d[$];if(!!G){if(G.type===0){O=!0;continue}if(G.type===1)return[m.INSTANCE];if(G.type===9){T=T.concat(G.expr);continue}T.push(G)}}if(T.length===0&&O)return[y.INSTANCE];T.sort(n)}return T}serialize(){return this.expr.map(d=>d.serialize()).join(" || ")}keys(){const d=[];for(let T of this.expr)d.push(...T.keys());return d}map(d){return new u(this.expr.map(T=>T.map(d)))}negate(){let d=[];for(let O of this.expr)d.push(O.negate());const T=O=>O.type===9?O.expr:[O];for(;d.length>1;){const O=d.shift(),$=d.shift(),z=[];for(const G of T(O))for(const V of T($))z.push(w.and(G,V));d.unshift(w.or(...z))}return d[0]}}e.ContextKeyOrExpr=u;class o extends v{constructor(d,T,O){super(d);this._defaultValue=T,typeof O=="object"?o._info.push({...O,key:d}):O!==!0&&o._info.push({key:d,description:O,type:T!=null?typeof T:void 0})}static all(){return o._info.values()}bindTo(d){return d.createKey(this.key,this._defaultValue)}getValue(d){return d.getContextKeyValue(this.key)}toNegated(){return w.not(this.key)}isEqualTo(d){return w.equals(this.key,d)}notEqualsTo(d){return w.notEquals(this.key,d)}}e.RawContextKey=o,o._info=[],e.IContextKeyService=(0,L.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function l(E,d){return E<d?-1:E>d?1:0}function g(E,d,T,O){return E<T?-1:E>T?1:d<O?-1:d>O?1:0}}),define(Z[71],ee([0,1,6]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,p.createDecorator)(e.ID);function L(P){return!!P.hostName&&!!P.errorMessage}e.isRemoteDiagnosticError=L}),define(Z[72],ee([0,1,6]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,p.createDecorator)("downloadService")}),define(Z[9],ee([0,1,6]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,p.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,p.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[27],ee([0,1,112,6,17]),function(K,e,p,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}e.isIExtensionIdentifier=k;var A;(function(y){y[y.NoneOrRelevance=0]="NoneOrRelevance",y[y.LastUpdatedDate=1]="LastUpdatedDate",y[y.Title=2]="Title",y[y.PublisherName=3]="PublisherName",y[y.InstallCount=4]="InstallCount",y[y.PublishedDate=5]="PublishedDate",y[y.AverageRating=6]="AverageRating",y[y.WeightedRating=12]="WeightedRating"})(A=e.SortBy||(e.SortBy={}));var R;(function(y){y[y.Default=0]="Default",y[y.Ascending=1]="Ascending",y[y.Descending=2]="Descending"})(R=e.SortOrder||(e.SortOrder={}));var S;(function(y){y.Uninstall="uninstall"})(S=e.StatisticType||(e.StatisticType={}));var w;(function(y){y[y.None=0]="None",y[y.Install=1]="Install",y[y.Update=2]="Update"})(w=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class n extends Error{constructor(m,v){super(m);this.code=v,this.name=v}}e.ExtensionManagementError=n,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=P.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,p.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,p.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,L.createDecorator)("IExtensionManagementCLIService")});var Y=this&&this.__param||function(K,e){return function(p,L){e(p,L,K)}};define(Z[146],ee([0,1,2,27]),function(K,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let P=class extends p.Disposable{constructor(A){super();this.extensionManagementService=A,this._register(A),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};P=fe([Y(0,L.IExtensionManagementService)],P),e.DeprecatedExtensionsCleaner=P}),define(Z[73],ee([0,1,6]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var L;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(L=e.RecommendationSource||(e.RecommendationSource={}));function P(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=P;var k;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(k=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,p.createDecorator)("IExtensionRecommendationNotificationService")}),define(Z[74],ee([0,1,19,6]),function(K,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function P(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=P;function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class R{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,m){if(typeof y=="undefined"||y===null)return typeof m=="undefined"||m===null;if(typeof m=="undefined"||m===null)return!1;if(typeof y=="string"||typeof m=="string"){let v=typeof y=="string"?y:y.value,h=typeof m=="string"?m:m.value;return p.equalsIgnoreCase(v,h)}return y._lower===m._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.ExtensionIdentifier=R;function S(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function w(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=w,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[31],ee([0,1,19,74]),function(K,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function P(h,C){return h.uuid&&C.uuid?h.uuid===C.uuid:h.id===C.id?!0:(0,p.compareIgnoreCase)(h.id,C.id)===0}e.areSameExtensions=P;class k{constructor(C,D){this.version=D,this.id=C.id,this.uuid=C.uuid}key(){return`${this.id}-${this.version}`}equals(C){return C instanceof k?P(this,C)&&this.version===C.version:!1}}e.ExtensionIdentifierWithVersion=k;function A(h,C){return`${h}.${C}`}e.getExtensionId=A;function R(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=R;function S(h,C){return R(A(h,C))}e.getGalleryExtensionId=S;function w(h,C){const D=[],b=I=>{for(const f of D)if(f.some(a=>P(C(a),C(I))))return f;return null};for(const I of h){const f=b(I);f?f.push(I):D.push([I])}return D}e.groupByExtension=w;function n(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function y(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function m(h){const C=new Set;for(const D of h)D.malicious&&C.add(D.id.id);return C}e.getMaliciousExtensionsSet=m;function v(h,C){const D=[],b=C.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const I=b.shift();if(I&&D.every(f=>!P(f.identifier,{id:I}))){const f=h.filter(a=>P(a.identifier,{id:I}));f.length===1&&(D.push(f[0]),b.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return D}e.getExtensionDependencies=v}),define(Z[147],ee([0,1,2,8,74,18]),function(K,e,p,L,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends p.Disposable{constructor(S,w){super();this.environmentService=S,this.extensionsManifestCache=(0,L.join)(this.environmentService.userDataPath,P.MANIFEST_CACHE_FOLDER,P.USER_MANIFEST_CACHE_FILE),this._register(w.onDidInstallExtensions(n=>this.onDidInstallExtensions(n))),this._register(w.onDidUninstallExtension(n=>this.onDidUnInstallExtension(n)))}onDidInstallExtensions(S){S.some(w=>!!w.local)&&this.invalidate()}onDidUnInstallExtension(S){S.error||this.invalidate()}invalidate(){k.Promises.rm(this.extensionsManifestCache,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(Z[14],ee([0,1,119,8,4,6,19,16,38]),function(K,e,p,L,P,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,k.createDecorator)("fileService");function w(U){return U.create===!0}e.isFileOpenForWriteOptions=w;var n;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var y;(function(U){U[U.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var m;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=v;function h(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=h;function C(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=C;function D(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=D;var b;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class I extends Error{constructor(M,F){super(M);this.code=F}}e.FileSystemProviderError=I;function f(U,M){const F=new I(U.toString(),M);return c(F,M),F}e.createFileSystemProviderError=f;function a(U){return U||f((0,p.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=a;function c(U,M){return U.name=M?`${M} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=c;function t(U){if(!U)return b.Unknown;if(U instanceof I)return U.code;const M=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!M)return b.Unknown;switch(M[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=t;function r(U){if(U instanceof g)return U.fileOperationResult;switch(t(U)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var i;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class s{constructor(M,F,j){this.resource=M,this.operation=F,this.target=j}isOperation(M){return this.operation===M}}e.FileOperationEvent=s;var u;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class o{constructor(M,F){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const j of M)switch(j.type){case 1:this.added||(this.added=S.TernarySearchTree.forUris(()=>F)),this.added.set(j.resource,j);break;case 0:this.updated||(this.updated=S.TernarySearchTree.forUris(()=>F)),this.updated.set(j.resource,j);break;case 2:this.deleted||(this.deleted=S.TernarySearchTree.forUris(()=>F)),this.deleted.set(j.resource,j);break}}contains(M,...F){return this.doContains(M,{includeChildren:!1},...F)}affects(M,...F){return this.doContains(M,{includeChildren:!0},...F)}doContains(M,F,...j){if(!M)return!1;const _=j.length>0;return!!((!_||j.includes(1))&&(this.added?.get(M)||F.includeChildren&&this.added?.findSuperstr(M))||(!_||j.includes(0))&&(this.updated?.get(M)||F.includeChildren&&this.updated?.findSuperstr(M))||(!_||j.includes(2))&&(this.deleted?.findSubstr(M)||F.includeChildren&&this.deleted?.findSuperstr(M)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=o;function l(U,M,F){return!U||!M||U===M||M.length>U.length?!1:(M.charAt(M.length-1)!==L.sep&&(M+=L.sep),F?(0,A.startsWithIgnoreCase)(U,M):U.indexOf(M)===0)}e.isParent=l;class g extends Error{constructor(M,F,j){super(M);this.fileOperationResult=F,this.options=j}}e.FileOperationError=g;class E extends g{constructor(M,F,j){super(M,2,j);this.stat=F}}e.NotModifiedSinceFileOperationError=E;var d;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(d=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var T;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(T=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=O;async function $(U,M){if(!M.canHandleResource(P.URI.from({scheme:U.scheme})))return new Promise(F=>{const j=M.onDidChangeFileSystemProviderRegistrations(_=>{_.scheme===U.scheme&&_.added&&(j.dispose(),F())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class z{static formatSize(M){return(0,R.isNumber)(M)||(M=0),M<z.KB?(0,p.localize)(1,null,M.toFixed(0)):M<z.MB?(0,p.localize)(2,null,(M/z.KB).toFixed(2)):M<z.GB?(0,p.localize)(3,null,(M/z.MB).toFixed(2)):M<z.TB?(0,p.localize)(4,null,(M/z.GB).toFixed(2)):(0,p.localize)(5,null,(M/z.TB).toFixed(2))}}e.ByteSize=z,z.KB=1024,z.MB=z.KB*z.KB,z.GB=z.MB*z.KB,z.TB=z.GB*z.KB;var G;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(G=e.Arch||(e.Arch={}));function V(U){return{maxFileSize:U===0?300*z.MB:16*z.GB,maxHeapSize:U===0?700*z.MB:2*700*z.MB}}e.getPlatformLimits=V}),define(Z[148],ee([0,1,149,48,14]),function(K,e,p,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let k=class{constructor(R){this.fileService=R}checksum(R){return new Promise(async(S,w)=>{const n=(0,p.createHash)("md5"),y=(await this.fileService.readFileStream(R)).value;(0,L.listenStream)(y,{onData:m=>n.update(m.buffer),onError:m=>w(m),onEnd:()=>S(n.digest("base64").replace(/=+$/,""))})})}};k=fe([Y(0,P.IFileService)],k),e.ChecksumService=k}),define(Z[75],ee([0,1,4,14,7]),function(K,e,p,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function k(S){return S.map(w=>({type:w.type,resource:p.URI.file(w.path)}))}e.toFileChanges=k;function A(S){const w=new R;for(const n of S)w.processEvent(n);return w.normalize()}e.normalizeFileChanges=A;class R{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(w){const n=this.mapPathToChange.get(w.path);if(n){const y=n.type,m=w.type;y===1&&m===2?(this.mapPathToChange.delete(w.path),this.normalized.splice(this.normalized.indexOf(n),1)):y===2&&m===1?n.type=0:y===1&&m===0||(n.type=m)}else this.normalized.push(w),this.mapPathToChange.set(w.path,w)}normalize(){const w=[],n=[];return this.normalized.filter(y=>y.type!==2?(w.push(y),!1):!0).sort((y,m)=>y.path.length-m.path.length).filter(y=>n.some(m=>(0,L.isParent)(y.path,m,!P.isLinux))?!1:(n.push(y.path),!0)).concat(w)}}}),define(Z[150],ee([0,1,75,2,18,97,100,5,8]),function(K,e,p,L,P,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class w extends L.Disposable{constructor(y,m,v,h){super();this.path=y,this.onDidFilesChange=m,this.onLogMessage=v,this.verboseLogging=h,this.fileChangesDelayer=this._register(new R.ThrottledDelayer(A.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(y){this.verboseLogging=y}async startWatching(){try{const{stat:y,symbolicLink:m}=await P.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let v=this.path;if(m)try{v=await(0,k.realpath)(v)}catch(h){if(this.onError(h),m.dangling)return}y.isDirectory()?this._register((0,A.watchFolder)(v,(h,C)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:(0,S.join)(this.path,(0,S.basename)(C))})},h=>this.onError(h))):this._register((0,A.watchFile)(v,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(y){y.code!=="ENOENT"&&this.onError(y)}}onFileChange(y){this.fileChangesBuffer.push(y),this.verboseLogging&&this.onVerbose(`${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.path}`),this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const v=(0,p.normalizeFileChanges)(m);if(this.verboseLogging)for(const h of v)this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);v.length>0&&this.onDidFilesChange(v)})}onError(y){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${y}`})}onVerbose(y){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${y}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=w}),define(Z[76],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...P){this._entries=new Map;for(let[k,A]of P)this.set(k,A)}set(P,k){const A=this._entries.get(P);return this._entries.set(P,k),A}has(P){return this._entries.has(P)}get(P){return this._entries.get(P)}}e.ServiceCollection=p}),define(Z[151],ee([0,1,11,143,51,6,76,5]),function(K,e,p,L,P,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class w extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class n{constructor(h=new A.ServiceCollection,C=!1,D){this._activeInstantiations=new Set,this._services=h,this._strict=C,this._parent=D,this._services.set(k.IInstantiationService,this)}createChild(h){return new n(h,this._strict,this)}invokeFunction(h,...C){let D=m.traceInvocation(h),b=!1;try{return h({get:(f,a)=>{if(b)throw(0,p.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(f,D);if(!c&&a!==k.optional)throw new Error(`[invokeFunction] unknown service '${f}'`);return c}},...C)}finally{b=!0,D.stop()}}createInstance(h,...C){let D,b;return h instanceof P.SyncDescriptor?(D=m.traceCreation(h.ctor),b=this._createInstance(h.ctor,h.staticArguments.concat(C),D)):(D=m.traceCreation(h),b=this._createInstance(h,C,D)),D.stop(),b}_createInstance(h,C=[],D){let b=k._util.getServiceDependencies(h).sort((a,c)=>a.index-c.index),I=[];for(const a of b){let c=this._getOrCreateServiceInstance(a.id,D);if(!c&&this._strict&&!a.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${a.id}.`);I.push(c)}let f=b.length>0?b[0].index:C.length;if(C.length!==f){console.warn(`[createInstance] First service dependency of ${h.name} at position ${f+1} conflicts with ${C.length} static arguments`);let a=f-C.length;a>0?C=C.concat(new Array(a)):C=C.slice(0,f)}return new h(...[...C,...I])}_setServiceInstance(h,C){if(this._services.get(h)instanceof P.SyncDescriptor)this._services.set(h,C);else if(this._parent)this._parent._setServiceInstance(h,C);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let C=this._services.get(h);return!C&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):C}_getOrCreateServiceInstance(h,C){let D=this._getServiceInstanceOrDescriptor(h);return D instanceof P.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,D,C.branch(h,!0)):(C.branch(h,!1),D)}_safeCreateAndCacheServiceInstance(h,C,D){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,C,D)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,C,D){const b=new L.Graph(a=>a.id.toString());let I=0;const f=[{id:h,desc:C,_trace:D}];for(;f.length;){const a=f.pop();if(b.lookupOrInsertNode(a),I++>1e3)throw new w(b);for(let c of k._util.getServiceDependencies(a.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(c.id);if(!t&&!c.optional&&console.warn(`[createInstance] ${h} depends on ${c.id} which is NOT registered.`),t instanceof P.SyncDescriptor){const r={id:c.id,desc:t,_trace:a._trace.branch(c.id,!0)};b.insertEdge(a,r),f.push(r)}}}for(;;){const a=b.roots();if(a.length===0){if(!b.isEmpty())throw new w(b);break}for(const{data:c}of a){if(this._getServiceInstanceOrDescriptor(c.id)instanceof P.SyncDescriptor){const r=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,r)}b.removeNode(c)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,C,D=[],b,I){if(this._services.get(h)instanceof P.SyncDescriptor)return this._createServiceInstance(C,D,b,I);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,C,D,b,I);throw new Error(`illegalState - creating UNKNOWN service instance ${C.name}`)}_createServiceInstance(h,C=[],D,b){if(D){const I=new R.IdleValue(()=>this._createInstance(h,C,b));return new Proxy(Object.create(null),{get(f,a){if(a in f)return f[a];let c=I.value,t=c[a];return typeof t!="function"||(t=t.bind(c),f[a]=t),t},set(f,a,c){return I.value[a]=c,!0}})}else return this._createInstance(h,C,b)}}e.InstantiationService=n;var y;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(y||(y={}));class m{constructor(h,C){this.type=h,this.name=C,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return S?new m(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(h){return S?new m(0,h.name):m._None}branch(h,C){let D=new m(2,h.toString());return this._dep.push([h,C,D]),D}stop(){let h=Date.now()-this._start;m._totals+=h;let C=!1;function D(I,f){let a=[],c=new Array(I+1).join("	");for(const[t,r,i]of f._dep)if(r&&i){C=!0,a.push(`${c}CREATES -> ${t}`);let s=D(I+1,i);s&&a.push(s)}else a.push(`${c}uses -> ${t}`);return a.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${D(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(h>2||C)&&console.log(b.join(`
`))}}m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(Z[152],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class p{constructor(P,k){this.server=P,this.router=k}getChannel(P){return this.server.getChannel(P,this.router)}registerChannel(P,k){this.server.registerChannel(P,k)}}e.MessagePortMainProcessService=p}),define(Z[153],ee([0,1,36,51,142,6]),function(K,e,p,L,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(v,h,C){const D=C.getChannel(v);return R(h)?new h.channelClientCtor(D):p.ProxyChannel.toService(D,h?.proxyOptions)}}function R(m){return!!m?.channelClientCtor}e.IMainProcessService=(0,k.createDecorator)("mainProcessService");let S=class extends A{constructor(v,h,C){super(v,h,C)}};S=fe([Y(2,e.IMainProcessService)],S);function w(m,v,h){(0,P.registerSingleton)(m,new L.SyncDescriptor(S,[v,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=w,e.ISharedProcessService=(0,k.createDecorator)("sharedProcessService");let n=class extends A{constructor(v,h,C){super(v,h,C)}};n=fe([Y(2,e.ISharedProcessService)],n);function y(m,v,h){(0,P.registerSingleton)(m,new L.SyncDescriptor(n,[v,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=y}),define(Z[57],ee([0,1,6]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,p.createDecorator)("localizationsService");function L(P){if(typeof P.languageId!="string"||!Array.isArray(P.translations)||P.translations.length===0)return!1;for(const k of P.translations)if(typeof k.id!="string"||typeof k.path!="string")return!1;return!(P.languageName&&typeof P.languageName!="string"||P.localizedLanguageName&&typeof P.localizedLanguageName!="string")}e.isValidLocalization=L}),define(Z[154],ee([0,1,2,57]),function(K,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let P=class extends p.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};P=fe([Y(0,L.ILocalizationsService)],P),e.LocalizationsUpdater=P}),define(Z[10],ee([0,1,6,2,7,3,43]),function(K,e,p,L,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,p.createDecorator)("logService"),e.ILoggerService=(0,p.createDecorator)("loggerService");function R(){return new Date().toISOString()}var S;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class w extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new k.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class n extends w{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(S.Error))if(t instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=t.stack,this.log(S.Error,this.format(i))}else this.log(S.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let i=0;i<t.length;i++){let s=t[i];if(typeof s=="object")try{s=JSON.stringify(s)}catch(u){}r+=(i>0?" ":"")+s}return r}}e.AbstractMessageLogger=n;class y extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!P.isWindows}trace(t,...r){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,t,...r):console.log(`[main ${R()}]`,t,...r))}debug(t,...r){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,t,...r):console.log(`[main ${R()}]`,t,...r))}info(t,...r){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,t,...r):console.log(`[main ${R()}]`,t,...r))}warn(t,...r){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,t,...r):console.warn(`[main ${R()}]`,t,...r))}error(t,...r){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,t,...r):console.error(`[main ${R()}]`,t,...r))}critical(t,...r){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,t,...r):console.error(`[main ${R()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class m extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=m;class v extends w{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,A.toErrorMessage)(t,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=v;class h extends w{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const i of this.logServices)i.trace(t,...r)}debug(t,...r){for(const i of this.logServices)i.debug(t,...r)}info(t,...r){for(const i of this.logServices)i.info(t,...r)}warn(t,...r){for(const i of this.logServices)i.warn(t,...r)}error(t,...r){for(const i of this.logServices)i.error(t,...r)}critical(t,...r){for(const i of this.logServices)i.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=h;class C extends L.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=C;class D extends L.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(i))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,r){let i=this.loggers.get(t.toString());return i||(i=this.doCreateLogger(t,r?.always?S.Trace:this.logLevel,r),this.loggers.set(t.toString(),i),r?.always||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=D;class b{constructor(){this.onDidChangeLogLevel=new k.Emitter().event}setLevel(t){}getLevel(){return S.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=b;function I(c){if(c.verbose)return S.Trace;if(typeof c.logLevel=="string"){const t=f(c.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=I;function f(c){switch(c){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=f;function a(c){switch(c){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=a}),define(Z[155],ee([0,1,9,8,18,11,2,5,10]),function(K,e,p,L,P,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let w=class extends A.Disposable{constructor(y,m){super();this.environmentService=y,this.logService=m,this._register(new R.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.info("[logs cleanup]: Starting to clean up old logs.");try{const y=(0,L.basename)(this.environmentService.logsPath),m=(0,L.dirname)(this.environmentService.logsPath),C=(await P.Promises.readdir(m)).filter(b=>/^\d{8}T\d{6}$/.test(b)).sort().filter(b=>b!==y),D=C.slice(0,Math.max(0,C.length-9));D.length>0&&(this.logService.info(`[logs cleanup]: Removing log folders '${D.join(", ")}'`),await Promise.all(D.map(b=>P.Promises.rm((0,L.join)(m,b)))))}catch(y){(0,k.onUnexpectedError)(y)}}};w=fe([Y(0,p.IEnvironmentService),Y(1,S.ILogService)],w),e.LogsDataCleaner=w}),define(Z[156],ee([0,1,9,8,18,11,2,5,10]),function(K,e,p,L,P,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let w=class lt extends A.Disposable{constructor(y,m,v){super();this.backupWorkspacesPath=y,this.environmentService=m,this.logService=v,this._register(new R.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.info("[storage cleanup]: Starting to clean up storage folders.");try{const y=await P.Promises.readFile(this.backupWorkspacesPath,"utf8"),v=JSON.parse(y).emptyWorkspaceInfos.map(C=>C.backupFolder),h=await P.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async C=>{C.length!==lt.NON_EMPTY_WORKSPACE_ID_LENGTH&&v.indexOf(C)===-1&&(this.logService.info(`[storage cleanup]: Deleting storage folder ${C}.`),await P.Promises.rm((0,L.join)(this.environmentService.workspaceStorageHome.fsPath,C)))}))}catch(y){(0,k.onUnexpectedError)(y)}}};w.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,w=fe([Y(1,p.INativeEnvironmentService),Y(2,S.ILogService)],w),e.StorageDataCleaner=w}),define(Z[157],ee([0,1,18,2,14,27,9,4,15,31,10,30,58,7,5,11]),function(K,e,p,L,P,k,A,R,S,w,n,y,m,v,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let b=class extends L.Disposable{constructor(f,a,c,t){super();this.fileService=a,this.extensionGalleryService=c,this.logService=t,this.extensionsDownloadDir=R.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,a){await this.cleanUpPromise;const c=this.getName(f),t=(0,S.joinPath)(this.extensionsDownloadDir,c);if(!await this.fileService.exists(t)){const r=(0,S.joinPath)(this.extensionsDownloadDir,`.${(0,y.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(f,r,a);try{await this.rename(r,t,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(r)}catch(s){}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,C.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,r.path),i}}return t}async delete(f){}async rename(f,a,c){try{await p.Promises.rename(f.fsPath,a.fsPath)}catch(t){if(v.isWindows&&t&&t.code==="EPERM"&&Date.now()<c)return this.logService.info(`Failed renaming ${f} to ${a} with 'EPERM' error. Trying again...`),this.rename(f,a,c);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const a=[],c=[];for(const i of f.children){const s=this.parse(i.name);s&&c.push([s,i])}const t=(0,w.groupByExtension)(c,([i])=>i),r=[];for(const i of t)i.sort((s,u)=>m.rcompare(s[0].version,u[0].version)),a.push(...i.slice(1).map(s=>s[1].resource)),r.push(i[0][1]);r.sort((i,s)=>i.mtime-s.mtime),a.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(i=>i.resource)),await h.Promises.settled(a.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?new w.ExtensionIdentifierWithVersion(f.identifier,f.version).key().toLowerCase():(0,y.generateUuid)()}parse(f){const a=D.exec(f);return a&&a[1]&&a[2]?new w.ExtensionIdentifierWithVersion({id:a[1]},a[2]):null}};b=fe([Y(0,A.INativeEnvironmentService),Y(1,P.IFileService),Y(2,k.IExtensionGalleryService),Y(3,n.ILogService)],b),e.ExtensionsDownloader=b}),define(Z[158],ee([0,1,2,10,42,43,8,5,3,17,18,9]),function(K,e,p,L,P,k,A,R,S,w,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends p.Disposable{constructor(h,C){super();this.environmentService=h,this.logService=C,this.processesLimiter=new R.Limiter(5)}async postUninstall(h){const C=this.parseScript(h,"uninstall");return C&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(C.script,"uninstall",C.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),D=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${D}`)))),n.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,D=>this.logService.error("Error while removing extension storage path",D))}parseScript(h,C){const D=`vscode:${C}`;if(h.location.scheme===w.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[D]=="string"){const b=h.manifest.scripts[D].split(" ");return b.length<2||b[0]!=="node"||!b[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${D} should be a node script`),null):{script:(0,A.join)(h.location.fsPath,b[1]),args:b.slice(2)||[]}}return null}runLifecycleHook(h,C,D,b,I){return new Promise((f,a)=>{const c=this.start(h,C,D,I);let t;const r=i=>{t&&(clearTimeout(t),t=null),i?a(i):f(void 0)};c.on("error",i=>{r((0,k.toErrorMessage)(i)||"Unknown")}),c.on("exit",(i,s)=>{r(i?`post-${C} process exited with code ${i}`:void 0)}),b&&(t=setTimeout(()=>{t=null,c.kill(),a("timed out")},5e3))})}start(h,C,D,b){const I={silent:!0,execArgv:void 0},f=(0,P.fork)(h,[`--type=extension-post-${C}`,...D],I);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const a=S.Event.fromNodeEventEmitter(f.stdout,"data"),c=S.Event.fromNodeEventEmitter(f.stderr,"data");a(i=>this.logService.info(b.identifier.id,b.manifest.version,`post-${C}`,i)),c(i=>this.logService.error(b.identifier.id,b.manifest.version,`post-${C}`,i));const t=S.Event.any(S.Event.map(a,i=>({data:`%c${i}`,format:[""]})),S.Event.map(c,i=>({data:`%c${i}`,format:["color: red"]})));return S.Event.debounce(t,(i,s)=>i?{data:i.data+s.data,format:[...i.format,...s.format]}:{data:s.data,format:s.format},100)(i=>{console.group(b.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),f}getExtensionStoragePath(h){return(0,A.join)(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};m=fe([Y(0,y.IEnvironmentService),Y(1,L.ILogService)],m),e.ExtensionsLifecycle=m}),define(Z[159],ee([0,1,2,9,3,14,4,31,15,10]),function(K,e,p,L,P,k,A,R,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let n=class extends p.Disposable{constructor(m,v,h,C){super();this.extensionsManagementService=m,this.logService=C,this._onDidChangeExtensionsByAnotherSource=this._register(new P.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(I=>{this.installedExtensions=I.map(f=>f.identifier),this.startTimestamp=Date.now()}),this._register(m.onInstallExtension(I=>this.onInstallExtension(I))),this._register(m.onDidInstallExtensions(I=>this.onDidInstallExtensions(I))),this._register(m.onDidUninstallExtension(I=>this.onDidUninstallExtension(I)));const D=A.URI.file(h.extensionsPath),b=new S.ExtUri(I=>!v.hasCapability(I,1024));this._register(v.watch(D)),this._register(P.Event.filter(v.onDidChangeFilesRaw,I=>I.changes.some(f=>this.doesChangeAffects(f,D,b)))(()=>this.onDidChange()))}doesChangeAffects(m,v,h){return h.isEqual(h.dirname(m.resource),v)?h.isEqual(m.resource,h.joinPath(v,".obsolete"))?!0:!(m.type!==1&&m.type!==2||h.basename(m.resource).startsWith(".")):!1}onInstallExtension(m){this.addInstallingExtension(m.identifier)}onDidInstallExtensions(m){for(const v of m)this.removeInstallingExtension(v.identifier),v.local&&this.addInstalledExtension(v.identifier)}onDidUninstallExtension(m){m.error||this.removeInstalledExtension(m.identifier)}addInstallingExtension(m){this.removeInstallingExtension(m),this.installingExtensions.push(m)}removeInstallingExtension(m){this.installingExtensions=this.installingExtensions.filter(v=>!(0,R.areSameExtensions)(v,m))}addInstalledExtension(m){this.installedExtensions&&(this.removeInstalledExtension(m),this.installedExtensions.push(m))}removeInstalledExtension(m){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(v=>!(0,R.areSameExtensions)(v,m)))}async onDidChange(){if(this.installedExtensions){const m=await this.extensionsManagementService.getInstalled(1),v=m.filter(C=>[...this.installingExtensions,...this.installedExtensions].some(D=>(0,R.areSameExtensions)(D,C.identifier))?!1:C.installedTimestamp&&C.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",C.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",C.identifier.id),!1)),h=this.installedExtensions.filter(C=>this.installingExtensions.some(D=>(0,R.areSameExtensions)(D,C))?!1:m.every(D=>!(0,R.areSameExtensions)(D.identifier,C))?(this.logService.info("Detected extension removed from another source",C.id),!0):!1);this.installedExtensions=m.map(C=>C.identifier),(v.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:v,removed:h})}}};n=fe([Y(1,k.IFileService),Y(2,L.INativeEnvironmentService),Y(3,w.ILogService)],n),e.ExtensionsWatcher=n}),define(Z[160],ee([0,1,18,149,27,2,9,5,31,10,57,23,17,8]),function(K,e,p,L,P,k,A,R,S,w,n,y,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let h=class extends k.Disposable{constructor(b,I,f){super();this.extensionManagementService=b,this.logService=f,this.cache=this._register(new C(I,f)),this.extensionManagementService.registerParticipant({postInstall:async a=>this.postInstallExtension(a),postUninstall:async a=>this.postUninstallExtension(a)})}async getLanguageIds(){const b=await this.cache.getLanguagePacks(),I=["en",...Object.keys(b)];return(0,y.distinct)(I)}async postInstallExtension(b){b&&b.manifest&&b.manifest.contributes&&b.manifest.contributes.localizations&&b.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",b.identifier.id),await this.update())}async postUninstallExtension(b){const I=await this.cache.getLanguagePacks();Object.keys(I).some(f=>I[f]&&I[f].extensions.some(a=>(0,S.areSameExtensions)(a.extensionIdentifier,b.identifier)))&&(this.logService.info("Removing language packs from the extension",b.identifier.id),await this.update())}async update(){const[b,I]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(I);return!(0,y.equals)(Object.keys(b),Object.keys(f))}};h=fe([Y(0,P.IExtensionManagementService),Y(1,A.INativeEnvironmentService),Y(2,w.ILogService)],h),e.LocalizationsService=h;let C=class extends k.Disposable{constructor(b,I){super();this.logService=I,this.languagePacks={},this.languagePacksFilePath=(0,v.join)(b.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new R.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(b){return this.withLanguagePacks(I=>{Object.keys(I).forEach(f=>delete I[f]),this.createLanguagePacksFromExtensions(I,...b)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(b,...I){for(const f of I)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(b,f);Object.keys(b).forEach(f=>this.updateHash(b[f]))}createLanguagePacksFromExtension(b,I){const f=I.identifier,a=I.manifest.contributes&&I.manifest.contributes.localizations?I.manifest.contributes.localizations:[];for(const c of a)if(I.location.scheme===m.Schemas.file&&(0,n.isValidLocalization)(c)){let t=b[c.languageId];t||(t={hash:"",extensions:[],translations:{}},b[c.languageId]=t);let r=t.extensions.filter(i=>(0,S.areSameExtensions)(i.extensionIdentifier,f))[0];r?r.version=I.manifest.version:t.extensions.push({extensionIdentifier:f,version:I.manifest.version});for(const i of c.translations)t.translations[i.id]=(0,v.join)(I.location.fsPath,i.path)}}updateHash(b){if(b){const I=(0,L.createHash)("md5");for(const f of b.extensions)I.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);b.hash=I.digest("hex")}}withLanguagePacks(b=()=>null){return this.languagePacksFileLimiter.queue(()=>{let I=null;return p.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch(a){return{}}}).then(f=>(I=b(f),f)).then(f=>{for(const c of Object.keys(f))f[c]||delete f[c];this.languagePacks=f,this.initializedCache=!0;const a=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",a),p.Promises.writeFile(this.languagePacksFilePath,a)}).then(()=>I,f=>this.logService.error(f))})}};C=fe([Y(0,A.INativeEnvironmentService),Y(1,w.ILogService)],C)}),define(Z[77],ee([0,1,10,3,4]),function(K,e,p,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class k{constructor(m){this.service=m,this.onDidChangeLogLevel=L.Event.buffer(m.onDidChangeLogLevel,!0)}listen(m,v){switch(v){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${v}`)}async call(m,v,h){switch(v){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${v}`)}}e.LogLevelChannel=k;class A{constructor(m){this.channel=m}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(m){A.setLevel(this.channel,m)}static setLevel(m,v){return m.call("setLevel",v)}}e.LogLevelChannelClient=A;class R{constructor(m){this.loggerService=m,this.loggers=new Map}listen(m,v){throw new Error(`Event not found: ${v}`)}async call(m,v,h){switch(v){case"createLogger":this.createLogger(P.URI.revive(h[0]),h[1]);return;case"log":return this.log(P.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${v}`)}createLogger(m,v){this.loggers.set(m.toString(),this.loggerService.createLogger(m,v))}consoleLog(m,v){let h=console.log;switch(m){case p.LogLevel.Error:h=console.error;break;case p.LogLevel.Warning:h=console.warn;break;case p.LogLevel.Info:h=console.info;break}h.call(console,...v)}log(m,v){const h=this.loggers.get(m.toString());if(!h)throw new Error("Create the logger before logging");for(const[C,D]of v)switch(C){case p.LogLevel.Trace:h.trace(D);break;case p.LogLevel.Debug:h.debug(D);break;case p.LogLevel.Info:h.info(D);break;case p.LogLevel.Warning:h.warn(D);break;case p.LogLevel.Error:h.error(D);break;case p.LogLevel.Critical:h.critical(D);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=R;class S extends p.AbstractLoggerService{constructor(m,v,h){super(m,v);this.channel=h}createConsoleMainLogger(){return new p.AdapterLogger({log:(m,v)=>{this.channel.call("consoleLog",[m,v])}})}doCreateLogger(m,v,h){return new w(this.channel,m,v,h)}}e.LoggerChannelClient=S;class w extends p.AbstractMessageLogger{constructor(m,v,h,C){super(C?.always);this.channel=m,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[v,C]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(m,v){const h=[[m,v]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(m){this.channel.call("log",[this.file,m])}}class n extends p.LogService{constructor(m,v){super(v);this.parent=m,this._register(m.onDidChangeLogLevel(h=>v.setLevel(h)))}setLevel(m){super.setLevel(m),this.parent.setLevel(m)}}e.FollowerLogService=n}),define(Z[59],ee([0,1,6]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,p.createDecorator)("nativeHostService")}),define(Z[44],ee([0,1,17,7,34,15]),function(K,e,p,L,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const R=L.globals.vscode.context.configuration();if(R)A=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof K?.__$__nodeRequire=="function"){const R=(0,k.dirname)(p.FileAccess.asFileUri("",K));A=K.__$__nodeRequire((0,k.joinPath)(R,"product.json").fsPath);const S=K.__$__nodeRequire((0,k.joinPath)(R,"package.json").fsPath);P.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:S.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.59.0-dev",nameShort:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A}),define(Z[78],ee([0,1,120,25,14,11,44]),function(K,e,p,L,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function R(y,m,v,h,C,D){let b;try{await S(y,m,v,h,C,D)}catch(I){b=I}finally{b&&C.errorTransformer&&(b=C.errorTransformer(b)),typeof b!="undefined"&&v.error(b),v.end()}}e.readFileIntoStream=R;async function S(y,m,v,h,C,D){w(D);const b=await y.open(m,{create:!1});try{w(D);let I=0,f=0,a=C&&typeof C.length=="number"?C.length:void 0,c=L.VSBuffer.alloc(Math.min(C.bufferSize,typeof a=="number"?a:C.bufferSize)),t=C&&typeof C.position=="number"?C.position:0,r=0;do f=await y.read(b,t,c.buffer,r,c.byteLength-r),t+=f,r+=f,I+=f,typeof a=="number"&&(a-=f),r===c.byteLength&&(await v.write(h(c)),c=L.VSBuffer.alloc(Math.min(C.bufferSize,typeof a=="number"?a:C.bufferSize)),r=0);while(f>0&&(typeof a!="number"||a>0)&&w(D)&&n(I,C));if(r>0){let i=r;typeof a=="number"&&(i=Math.min(r,a)),v.write(h(c.slice(0,i)))}}catch(I){throw(0,P.ensureFileSystemProviderError)(I)}finally{await y.close(b)}}function w(y){if(y.isCancellationRequested)throw(0,k.canceled)();return!0}function n(y,m){if(m?.limits){if(typeof m.limits.memory=="number"&&y>m.limits.memory)throw(0,P.createFileSystemProviderError)((0,p.localize)(0,null,A.default.nameShort),P.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof m.limits.size=="number"&&y>m.limits.size)throw(0,P.createFileSystemProviderError)((0,p.localize)(1,null),P.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[161],ee([0,1,118,162,2,14,3,15,38,23,10,25,48,5,29,17,78,54]),function(K,e,p,L,P,k,A,R,S,w,n,y,m,v,h,C,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let I=class ze extends P.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new A.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new v.ThrottledWorker(ze.FILE_EVENTS_THROTTLING.maxChangesChunkSize,ze.FILE_EVENTS_THROTTLING.maxChangesBufferSize,ze.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new k.FileChangesEvent(c,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new v.ThrottledWorker(ze.FILE_EVENTS_THROTTLING.maxChangesChunkSize,ze.FILE_EVENTS_THROTTLING.maxChangesBufferSize,ze.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new k.FileChangesEvent(c,!0)))),this.watchedResources=S.TernarySearchTree.forUris(c=>{const t=this.getProvider(c.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new v.ResourceQueue)}registerProvider(a,c){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,L.mark)(`code/registerFilesystem/${a}`),this.provider.set(a,c),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:c});const t=new P.DisposableStore;return t.add(c.onDidChangeFile(r=>this.onDidChangeFile(r,this.isPathCaseSensitive(c)))),t.add(c.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:c,scheme:a}))),typeof c.onDidErrorOccur=="function"&&t.add(c.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),(0,P.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:c}),this.provider.delete(a),(0,P.dispose)(t)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const c=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(t){c.push(t)}}),!this.provider.has(a)&&await v.Promises.settled(c)}canHandleResource(a){return this.provider.has(a.scheme)}hasCapability(a,c){const t=this.provider.get(a.scheme);return!!(t&&t.capabilities&c)}listCapabilities(){return b.Iterable.map(this.provider,([a,c])=>({scheme:a,capabilities:c.capabilities}))}async withProvider(a){if(!(0,R.isAbsolutePath)(a))throw new k.FileOperationError((0,p.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const c=this.provider.get(a.scheme);if(!c){const t=new Error;throw t.name="ENOPRO",t.message=(0,p.localize)(1,null,a.toString()),t}return c}async withReadProvider(a){const c=await this.withProvider(a);if((0,k.hasOpenReadWriteCloseCapability)(c)||(0,k.hasReadWriteCapability)(c)||(0,k.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const c=await this.withProvider(a);if((0,k.hasOpenReadWriteCloseCapability)(c)||(0,k.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,c){try{return await this.doResolveFile(a,c)}catch(t){throw(0,k.toFileSystemProviderErrorCode)(t)===k.FileSystemProviderErrorCode.FileNotFound?new k.FileOperationError((0,p.localize)(2,null,this.resourceForError(a)),1):(0,k.ensureFileSystemProviderError)(t)}}async doResolveFile(a,c){const t=await this.withProvider(a),r=this.isPathCaseSensitive(t),i=c?.resolveTo,s=c?.resolveSingleChildDescendants,u=c?.resolveMetadata,o=await t.stat(a);let l;return this.toFileStat(t,a,o,void 0,!!u,(g,E)=>(l||(l=S.TernarySearchTree.forUris(()=>!r),l.set(a,!0),(0,w.isNonEmptyArray)(i)&&i.forEach(d=>l.set(d,!0))),Boolean(l.findSuperstr(g.resource)||l.get(g.resource))?!0:g.isDirectory&&s?E===1:!1))}async toFileStat(a,c,t,r,i,s){const{providerExtUri:u}=this.getExtUri(a),o={resource:c,name:u.basename(c),isFile:(t.type&k.FileType.File)!=0,isDirectory:(t.type&k.FileType.Directory)!=0,isSymbolicLink:(t.type&k.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&k.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:(0,k.etag)({mtime:t.mtime,size:t.size})};if(o.isDirectory&&s(o,r)){try{const l=await a.readdir(c),g=await v.Promises.settled(l.map(async([E,d])=>{try{const T=u.joinPath(c,E),O=i?await a.stat(T):{type:d};return await this.toFileStat(a,T,O,l.length,i,s)}catch(T){return this.logService.trace(T),null}}));o.children=(0,w.coalesce)(g)}catch(l){this.logService.trace(l),o.children=[]}return o}return o}async resolveAll(a){return v.Promises.settled(a.map(async c=>{try{return{stat:await this.doResolveFile(c.resource,c.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(a){const c=await this.withProvider(a);try{return!!await c.stat(a)}catch(t){return!1}}async canCreateFile(a,c){try{await this.doValidateCreateFile(a,c)}catch(t){return t}return!0}async doValidateCreateFile(a,c){if(!c?.overwrite&&await this.exists(a))throw new k.FileOperationError((0,p.localize)(3,null,this.resourceForError(a)),3,c)}async createFile(a,c=y.VSBuffer.fromString(""),t){await this.doValidateCreateFile(a,t);const r=await this.writeFile(a,c);return this._onDidRunOperation.fire(new k.FileOperationEvent(a,0,r)),r}async writeFile(a,c,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:i}=this.getExtUri(r);try{await this.validateWriteFile(r,a,t)||await this.mkdirp(r,i.dirname(a));let u;if((0,k.hasReadWriteCapability)(r)&&!(c instanceof y.VSBuffer))if((0,m.isReadableStream)(c)){const o=await(0,m.peekStream)(c,3);o.ended?u=y.VSBuffer.concat(o.buffer):u=o}else u=(0,m.peekReadable)(c,o=>y.VSBuffer.concat(o),3);else u=c;!(0,k.hasOpenReadWriteCloseCapability)(r)||(0,k.hasReadWriteCapability)(r)&&u instanceof y.VSBuffer?await this.doWriteUnbuffered(r,a,t,u):await this.doWriteBuffered(r,a,t,u instanceof y.VSBuffer?(0,y.bufferToReadable)(u):u)}catch(s){throw new k.FileOperationError((0,p.localize)(4,null,this.resourceForError(a),(0,k.ensureFileSystemProviderError)(s).toString()),(0,k.toFileOperationResult)(s),t)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,c,t){if(!!t?.unlock&&!(a.capabilities&8192))throw new Error((0,p.localize)(5,null,this.resourceForError(c)));let i;try{i=await a.stat(c)}catch(s){return}if((i.type&k.FileType.Directory)!=0)throw new k.FileOperationError((0,p.localize)(6,null,this.resourceForError(c)),0,t);if(this.throwIfFileIsReadonly(c,i),t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==k.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&t.mtime<i.mtime&&t.etag!==(0,k.etag)({mtime:t.mtime,size:i.size}))throw new k.FileOperationError((0,p.localize)(7,null),3,t);return i}async readFile(a,c){const t=await this.withReadProvider(a);return c?.atomic?this.doReadFileAtomic(t,a,c):this.doReadFile(t,a,c)}async doReadFileAtomic(a,c,t){return new Promise((r,i)=>{this.writeQueue.queueFor(c,this.getExtUri(a).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(a,c,t);r(s)}catch(s){i(s)}})})}async doReadFile(a,c,t){const r=await this.doReadFileStream(a,c,{...t,preferUnbuffered:!0});return{...r,value:await(0,y.streamToBuffer)(r.value)}}async readFileStream(a,c){const t=await this.withReadProvider(a);return this.doReadFileStream(t,a,c)}async doReadFileStream(a,c,t){const r=new h.CancellationTokenSource,i=this.validateReadFile(c,t).then(u=>u,u=>{throw r.cancel(),u});let s;try{return t&&typeof t.etag=="string"&&t.etag!==k.ETAG_DISABLED&&await i,!((0,k.hasOpenReadWriteCloseCapability)(a)||(0,k.hasFileReadStreamCapability)(a))||(0,k.hasReadWriteCapability)(a)&&t?.preferUnbuffered?s=this.readFileUnbuffered(a,c,t):(0,k.hasFileReadStreamCapability)(a)?s=this.readFileStreamed(a,c,r.token,t):s=this.readFileBuffered(a,c,r.token,t),{...await i,value:s}}catch(u){s&&await(0,m.consumeStream)(s);const o=(0,p.localize)(8,null,this.resourceForError(c),(0,k.ensureFileSystemProviderError)(u).toString());throw u instanceof k.NotModifiedSinceFileOperationError?new k.NotModifiedSinceFileOperationError(o,u.stat,t):new k.FileOperationError(o,(0,k.toFileOperationResult)(u),t)}}readFileStreamed(a,c,t,r=Object.create(null)){const i=a.readFileStream(c,r,t);return(0,m.transform)(i,{data:s=>s instanceof y.VSBuffer?s:y.VSBuffer.wrap(s),error:s=>new k.FileOperationError((0,p.localize)(9,null,this.resourceForError(c),(0,k.ensureFileSystemProviderError)(s).toString()),(0,k.toFileOperationResult)(s),r)},s=>y.VSBuffer.concat(s))}readFileBuffered(a,c,t,r=Object.create(null)){const i=(0,y.newWriteableBufferStream)();return(0,D.readFileIntoStream)(a,c,i,s=>s,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new k.FileOperationError((0,p.localize)(10,null,this.resourceForError(c),(0,k.ensureFileSystemProviderError)(s).toString()),(0,k.toFileOperationResult)(s),r)},t),i}readFileUnbuffered(a,c,t){const r=(0,m.newWriteableStream)(i=>y.VSBuffer.concat(i));return(async()=>{try{let i=await a.readFile(c);t&&typeof t.position=="number"&&(i=i.slice(t.position)),t&&typeof t.length=="number"&&(i=i.slice(0,t.length)),this.validateReadFileLimits(c,i.byteLength,t),r.end(y.VSBuffer.wrap(i))}catch(i){r.error(i),r.end()}})(),r}async validateReadFile(a,c){const t=await this.resolve(a,{resolveMetadata:!0});if(t.isDirectory)throw new k.FileOperationError((0,p.localize)(11,null,this.resourceForError(a)),0,c);if(c&&typeof c.etag=="string"&&c.etag!==k.ETAG_DISABLED&&c.etag===t.etag)throw new k.NotModifiedSinceFileOperationError((0,p.localize)(12,null),t,c);return this.validateReadFileLimits(a,t.size,c),t}validateReadFileLimits(a,c,t){if(t?.limits){let r;if(typeof t.limits.memory=="number"&&c>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&c>t.limits.size&&(r=7),typeof r=="number")throw new k.FileOperationError((0,p.localize)(13,null,this.resourceForError(a)),r)}}async canMove(a,c,t){return this.doCanMoveCopy(a,c,"move",t)}async canCopy(a,c,t){return this.doCanMoveCopy(a,c,"copy",t)}async doCanMoveCopy(a,c,t,r){if(a.toString()!==c.toString())try{const i=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c);await this.doValidateMoveCopy(i,a,s,c,t,r)}catch(i){return i}return!0}async move(a,c,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),s=await this.doMoveCopy(r,a,i,c,"move",!!t),u=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new k.FileOperationEvent(a,s==="move"?2:3,u)),u}async copy(a,c,t){const r=await this.withReadProvider(a),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),s=await this.doMoveCopy(r,a,i,c,"copy",!!t),u=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new k.FileOperationEvent(a,s==="copy"?3:2,u)),u}async doMoveCopy(a,c,t,r,i,s){if(c.toString()===r.toString())return i;const{exists:u,isSameResourceWithDifferentPathCase:o}=await this.doValidateMoveCopy(a,c,t,r,i,s);if(u&&!o&&s&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),i==="copy"){if(a===t&&(0,k.hasFileFolderCopyCapability)(a))await a.copy(c,r,{overwrite:s});else{const l=await this.resolve(c);l.isDirectory?await this.doCopyFolder(a,l,t,r):await this.doCopyFile(a,c,t,r)}return i}else return a===t?(await a.rename(c,r,{overwrite:s}),i):(await this.doMoveCopy(a,c,t,r,"copy",s),await this.del(c,{recursive:!0}),"copy")}async doCopyFile(a,c,t,r){if((0,k.hasOpenReadWriteCloseCapability)(a)&&(0,k.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(a,c,t,r);if((0,k.hasOpenReadWriteCloseCapability)(a)&&(0,k.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(a,c,t,r);if((0,k.hasReadWriteCapability)(a)&&(0,k.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(a,c,t,r);if((0,k.hasReadWriteCapability)(a)&&(0,k.hasReadWriteCapability)(t))return this.doPipeUnbuffered(a,c,t,r)}async doCopyFolder(a,c,t,r){await t.mkdir(r),Array.isArray(c.children)&&await v.Promises.settled(c.children.map(async i=>{const s=this.getExtUri(t).providerExtUri.joinPath(r,i.name);return i.isDirectory?this.doCopyFolder(a,await this.resolve(i.resource),t,s):this.doCopyFile(a,i.resource,t,s)}))}async doValidateMoveCopy(a,c,t,r,i,s){let u=!1;if(a===t){const{providerExtUri:l,isPathCaseSensitive:g}=this.getExtUri(a);if(g||(u=l.isEqual(c,r)),u&&i==="copy")throw new Error((0,p.localize)(14,null,this.resourceForError(c),this.resourceForError(r)));if(!u&&l.isEqualOrParent(r,c))throw new Error((0,p.localize)(15,null,this.resourceForError(c),this.resourceForError(r)))}const o=await this.exists(r);if(o&&!u){if(!s)throw new k.FileOperationError((0,p.localize)(16,null,this.resourceForError(c),this.resourceForError(r)),4);if(a===t){const{providerExtUri:l}=this.getExtUri(a);if(l.isEqualOrParent(c,r))throw new Error((0,p.localize)(17,null,this.resourceForError(c),this.resourceForError(r)))}}return{exists:o,isSameResourceWithDifferentPathCase:u}}getExtUri(a){const c=this.isPathCaseSensitive(a);return{providerExtUri:c?R.extUri:R.extUriIgnorePathCase,isPathCaseSensitive:c}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(c,a);const t=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new k.FileOperationEvent(a,0,t)),t}async mkdirp(a,c){const t=[],{providerExtUri:r}=this.getExtUri(a);for(;!r.isEqual(c,r.dirname(c));)try{if(((await a.stat(c)).type&k.FileType.Directory)==0)throw new Error((0,p.localize)(18,null,this.resourceForError(c)));break}catch(i){if((0,k.toFileSystemProviderErrorCode)(i)!==k.FileSystemProviderErrorCode.FileNotFound)throw i;t.push(r.basename(c)),c=r.dirname(c)}for(let i=t.length-1;i>=0;i--){c=r.joinPath(c,t[i]);try{await a.mkdir(c)}catch(s){if((0,k.toFileSystemProviderErrorCode)(s)!==k.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(a,c){try{await this.doValidateDelete(a,c)}catch(t){return t}return!0}async doValidateDelete(a,c){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!c?.useTrash&&!(t.capabilities&4096))throw new Error((0,p.localize)(19,null,this.resourceForError(a)));let i;try{i=await t.stat(a)}catch(u){}if(i)this.throwIfFileIsReadonly(a,i);else throw new k.FileOperationError((0,p.localize)(20,null,this.resourceForError(a)),1);if(!!!c?.recursive){const u=await this.resolve(a);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error((0,p.localize)(21,null,this.resourceForError(a)))}return t}async del(a,c){const t=await this.doValidateDelete(a,c),r=!!c?.useTrash,i=!!c?.recursive;await t.delete(a,{recursive:i,useTrash:r}),this._onDidRunOperation.fire(new k.FileOperationEvent(a,1))}onDidChangeFile(a,c){this._onDidChangeFilesRaw.fire({changes:a});let t,r;{for(const i of a)this.watchedResources.has(i.resource)?(t||(t=[]),t.push(i)):(r||(r=[]),r.push(i));t&&this._onDidFilesChange.fire(new k.FileChangesEvent(t,!c))}if(r){const i=c?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!i.work(r)&&ze.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),i.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${i.pending}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(a,c={recursive:!1,excludes:[]}){const t=new P.DisposableStore;{let r=!1,i=()=>{r=!0};t.add((0,P.toDisposable)(()=>i())),this.doWatch(a,c).then(s=>{r?(0,P.dispose)(s):i=()=>(0,P.dispose)(s)},s=>this.logService.error(s))}return c.recursive||(this.watchedResources.set(a,(this.watchedResources.get(a)??0)+1),t.add((0,P.toDisposable)(()=>{const r=this.watchedResources.get(a);typeof r=="number"&&(r<=1?this.watchedResources.delete(a):this.watchedResources.set(a,r-1))}))),t}async doWatch(a,c){const t=await this.withProvider(a),r=this.toWatchKey(t,a,c),i=this.activeWatchers.get(r)||{count:0,disposable:t.watch(a,c)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,i),i.count+=1,(0,P.toDisposable)(()=>{i.count--,i.count===0&&((0,P.dispose)(i.disposable),this.activeWatchers.delete(r))})}toWatchKey(a,c,t){const{providerExtUri:r}=this.getExtUri(a);return[r.getComparisonKey(c),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(a=>(0,P.dispose)(a.disposable)),this.activeWatchers.clear()}async doWriteBuffered(a,c,t,r){return this.writeQueue.queueFor(c,this.getExtUri(a).providerExtUri).queue(async()=>{const i=await a.open(c,{create:!0,unlock:t?.unlock??!1});try{(0,m.isReadableStream)(r)||(0,m.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(a,i,r):await this.doWriteReadableBufferedQueued(a,i,r)}catch(s){throw(0,k.ensureFileSystemProviderError)(s)}finally{await a.close(i)}})}async doWriteStreamBufferedQueued(a,c,t){let r=0,i;if((0,m.isReadableBufferedStream)(t)){if(t.buffer.length>0){const s=y.VSBuffer.concat(t.buffer);await this.doWriteBuffer(a,c,s,s.byteLength,r,0),r+=s.byteLength}if(t.ended)return;i=t.stream}else i=t;return new Promise(async(s,u)=>{(0,m.listenStream)(i,{onData:async o=>{i.pause();try{await this.doWriteBuffer(a,c,o,o.byteLength,r,0)}catch(l){return u(l)}r+=o.byteLength,setTimeout(()=>i.resume())},onError:o=>u(o),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(a,c,t){let r=0,i;for(;(i=t.read())!==null;)await this.doWriteBuffer(a,c,i,i.byteLength,r,0),r+=i.byteLength}async doWriteBuffer(a,c,t,r,i,s){let u=0;for(;u<r;)u+=await a.write(c,i+u,t.buffer,s+u,r-u)}async doWriteUnbuffered(a,c,t,r){return this.writeQueue.queueFor(c,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,c,t,r))}async doWriteUnbufferedQueued(a,c,t,r){let i;r instanceof y.VSBuffer?i=r:(0,m.isReadableStream)(r)?i=await(0,y.streamToBuffer)(r):(0,m.isReadableBufferedStream)(r)?i=await(0,y.bufferedStreamToBuffer)(r):i=(0,y.readableToBuffer)(r),await a.writeFile(c,i.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(a,c,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,c,t,r))}async doPipeBufferedQueued(a,c,t,r){let i,s;try{i=await a.open(c,{create:!1}),s=await t.open(r,{create:!0,unlock:!1});const u=y.VSBuffer.alloc(this.BUFFER_SIZE);let o=0,l=0,g=0;do g=await a.read(i,o,u.buffer,l,u.byteLength-l),await this.doWriteBuffer(t,s,u,g,o,l),o+=g,l+=g,l===u.byteLength&&(l=0);while(g>0)}catch(u){throw(0,k.ensureFileSystemProviderError)(u)}finally{await v.Promises.settled([typeof i=="number"?a.close(i):Promise.resolve(),typeof s=="number"?t.close(s):Promise.resolve()])}}async doPipeUnbuffered(a,c,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,c,t,r))}async doPipeUnbufferedQueued(a,c,t,r){return t.writeFile(r,await a.readFile(c),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,c,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,c,t,r))}async doPipeUnbufferedToBufferedQueued(a,c,t,r){const i=await t.open(r,{create:!0,unlock:!1});try{const s=await a.readFile(c);await this.doWriteBuffer(t,i,y.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,k.ensureFileSystemProviderError)(s)}finally{await t.close(i)}}async doPipeBufferedToUnbuffered(a,c,t,r){const i=await(0,y.streamToBuffer)(this.readFileBuffered(a,c,h.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,i)}throwIfFileSystemIsReadonly(a,c){if(a.capabilities&2048)throw new k.FileOperationError((0,p.localize)(22,null,this.resourceForError(c)),6);return a}throwIfFileIsReadonly(a,c){if((c.permissions??0)&k.FilePermission.Readonly)throw new k.FileOperationError((0,p.localize)(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===C.Schemas.file?a.fsPath:a.toString(!0)}};I.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},I=fe([Y(0,n.ILogService)],I),e.FileService=I}),define(Z[163],ee([0,1,2,14,3,7,18,8,15,41,5,10,121,75,139,141,138,150,48,78,23,25]),function(K,e,p,L,P,k,A,R,S,w,n,y,m,v,h,C,D,b,I,f,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends p.Disposable{constructor(i,s){super();this.logService=i,this.options=s,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=P.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new P.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new P.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,k.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:s,symbolicLink:u}=await A.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(s,u),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.toFileSystemProviderError(s)}}async readdir(i){try{const s=await A.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),u=[];return await Promise.all(s.map(async o=>{try{let l;o.isSymbolicLink()?l=(await this.stat((0,S.joinPath)(i,o.name))).type:l=this.toType(o),u.push([o.name,l])}catch(l){this.logService.trace(l)}})),u}catch(s){throw this.toFileSystemProviderError(s)}}toType(i,s){let u;return s?.dangling?u=L.FileType.Unknown:i.isFile()?u=L.FileType.File:i.isDirectory()?u=L.FileType.Directory:u=L.FileType.Unknown,s&&(u|=L.FileType.SymbolicLink),u}async readFile(i){try{const s=this.toFilePath(i);return await A.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}}readFileStream(i,s,u){const o=(0,I.newWriteableStream)(l=>c.VSBuffer.concat(l.map(g=>c.VSBuffer.wrap(g))).buffer);return(0,f.readFileIntoStream)(this,i,o,l=>l.buffer,{...s,bufferSize:this.BUFFER_SIZE},u),o}async writeFile(i,s,u){let o;try{const l=this.toFilePath(i);if(!u.create||!u.overwrite){if(await A.Promises.exists(l)){if(!u.overwrite)throw(0,L.createFileSystemProviderError)((0,m.localize)(0,null),L.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw(0,L.createFileSystemProviderError)((0,m.localize)(1,null),L.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(i,{create:!0,unlock:u.unlock}),await this.write(o,0,s,0,s.byteLength)}catch(l){throw await this.toFileSystemProviderWriteError(i,l)}finally{typeof o=="number"&&await this.close(o)}}async open(i,s){try{const u=this.toFilePath(i);if((0,L.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:g}=await A.SymlinkSupport.stat(u);g.mode&128||await A.Promises.chmod(u,g.mode|128)}catch(g){this.logService.trace(g)}let o;if((0,L.isFileOpenForWriteOptions)(s)){if(k.isWindows)try{await A.Promises.truncate(u,0),o="r+"}catch(g){g.code!=="ENOENT"&&this.logService.trace(g)}o||(o="w")}else o="r";const l=await A.Promises.open(u,o);return this.mapHandleToPos.set(l,0),(0,L.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(l,i),l}catch(u){throw(0,L.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(i,u):this.toFileSystemProviderError(u)}}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await A.Promises.fdatasync(i)}catch(s){this.canFlush=!1,this.logService.error(s)}return await A.Promises.close(i)}catch(s){throw this.toFileSystemProviderError(s)}}async read(i,s,u,o,l){const g=this.normalizePos(i,s);let E=null;try{const d=await A.Promises.read(i,u,o,l,g);return typeof d=="number"?E=d:E=d.bytesRead,E}catch(d){throw this.toFileSystemProviderError(d)}finally{this.updatePos(i,g,E)}}normalizePos(i,s){return s===this.mapHandleToPos.get(i)?null:s}updatePos(i,s,u){const o=this.mapHandleToPos.get(i);typeof o=="number"&&(typeof s=="number"||(typeof u=="number"?this.mapHandleToPos.set(i,o+u):this.mapHandleToPos.delete(i)))}async write(i,s,u,o,l){return(0,n.retry)(()=>this.doWrite(i,s,u,o,l),100,3)}async doWrite(i,s,u,o,l){const g=this.normalizePos(i,s);let E=null;try{const d=await A.Promises.write(i,u,o,l,g);return typeof d=="number"?E=d:E=d.bytesWritten,E}catch(d){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),d)}finally{this.updatePos(i,g,E)}}async mkdir(i){try{await A.Promises.mkdir(this.toFilePath(i))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(i,s){try{const u=this.toFilePath(i);await this.doDelete(u,s)}catch(u){throw this.toFileSystemProviderError(u)}}async doDelete(i,s){s.recursive?await A.Promises.rm(i,A.RimRafMode.MOVE):await A.Promises.unlink(i)}async rename(i,s,u){const o=this.toFilePath(i),l=this.toFilePath(s);if(o!==l)try{await this.validateTargetDeleted(i,s,"move",u.overwrite),await A.Promises.move(o,l)}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,m.localize)(2,null,(0,R.basename)(o),(0,R.basename)((0,R.dirname)(l)),g.toString()))),this.toFileSystemProviderError(g)}}async copy(i,s,u){const o=this.toFilePath(i),l=this.toFilePath(s);if(o!==l)try{await this.validateTargetDeleted(i,s,"copy",u.overwrite),await A.Promises.copy(o,l,{preserveSymlinks:!0})}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,m.localize)(3,null,(0,R.basename)(o),(0,R.basename)((0,R.dirname)(l)),g.toString()))),this.toFileSystemProviderError(g)}}async validateTargetDeleted(i,s,u,o){const l=this.toFilePath(i),g=this.toFilePath(s);let E=!1;if(!!(this.capabilities&1024)||(E=(0,w.isEqual)(l,g,!0)),E&&u==="copy")throw(0,L.createFileSystemProviderError)((0,m.localize)(4,null),L.FileSystemProviderErrorCode.FileExists);if(!E&&await A.Promises.exists(g)){if(!o)throw(0,L.createFileSystemProviderError)((0,m.localize)(5,null),L.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}watch(i,s){return s.recursive?this.watchRecursive(i,s.excludes):this.watchNonRecursive(i)}watchRecursive(i,s){const u={path:this.toFilePath(i),excludes:s},o=(0,a.insert)(this.recursiveFoldersToWatch,u);return this.refreshRecursiveWatchers(),(0,p.toDisposable)(()=>{o(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof D.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,p.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let i,s;this.options?.watcher?.usePolling?(i=h.FileWatcher,s=this.options?.watcher):this.recursiveFoldersToWatch.length===1?k.isWindows?i=C.FileWatcher:i=h.FileWatcher:i=D.FileWatcher,this.recursiveWatcher=new i(this.recursiveFoldersToWatch,u=>this._onDidChangeFile.fire((0,v.toFileChanges)(u)),u=>{u.type==="error"&&this._onDidWatchErrorOccur.fire(u.message),this.logService[u.type](u.message)},this.logService.getLevel()===y.LogLevel.Trace,s),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)}))}}watchNonRecursive(i){const s=new b.FileWatcher(this.toFilePath(i),o=>this._onDidChangeFile.fire((0,v.toFileChanges)(o)),o=>{o.type==="error"&&this._onDidWatchErrorOccur.fire(o.message),this.logService[o.type](o.message)},this.logService.getLevel()===y.LogLevel.Trace),u=this.logService.onDidChangeLogLevel(()=>{s.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)});return(0,p.combinedDisposable)(s,u)}toFilePath(i){return(0,R.normalize)(i.fsPath)}toFileSystemProviderError(i){if(i instanceof L.FileSystemProviderError)return i;let s;switch(i.code){case"ENOENT":s=L.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=L.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=L.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=L.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=L.FileSystemProviderErrorCode.NoPermissions;break;default:s=L.FileSystemProviderErrorCode.Unknown}return(0,L.createFileSystemProviderError)(i,s)}async toFileSystemProviderWriteError(i,s){let u=this.toFileSystemProviderError(s);if(i&&u.code===L.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await A.SymlinkSupport.stat(this.toFilePath(i));o.mode&128||(u=(0,L.createFileSystemProviderError)(s,L.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return u}dispose(){super.dispose(),(0,p.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,p.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(Z[28],ee([0,1,6]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,p.createDecorator)("productService")}),define(Z[164],ee([0,1,8,11,2,18,28,5,10]),function(K,e,p,L,P,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let w=class extends P.Disposable{constructor(y,m,v){super();this.productService=m,this.logService=v,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,y&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpCodeCaches(y)},30*1e3)).schedule()}async cleanUpCodeCaches(y){this.logService.info("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),v=(0,p.dirname)(y),h=(0,p.basename)(y),C=await k.Promises.readdir(v);await Promise.all(C.map(async D=>{if(D===h)return;const b=(0,p.join)(v,D),I=await k.Promises.stat(b);if(I.isDirectory()&&m-I.mtime.getTime()>this._DataMaxAge)return this.logService.info(`[code cache cleanup]: Removing code cache folder ${D}.`),k.Promises.rm(b)}))}catch(m){(0,L.onUnexpectedError)(m)}}};w=fe([Y(1,A.IProductService),Y(2,S.ILogService)],w),e.CodeCacheCleaner=w}),define(Z[165],ee([0,1,8,18,28,2,11,10,9,5]),function(K,e,p,L,P,k,A,R,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let n=class extends k.Disposable{constructor(m,v,h){super();this.environmentService=m,this.logService=v,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new w.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.info("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),v=JSON.parse(await L.Promises.readFile((0,p.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let I of Object.keys(v)){const f=v[I];m[`${f.hash}.${I}`]=!0}const h=(0,p.join)(this.environmentService.userDataPath,"clp");if(!await L.Promises.exists(h))return;const D=await L.Promises.readdir(h);for(const I of D){if(m[I]){this.logService.info(`[language pack cache cleanup]: Skipping folder ${I}. Language pack still in use.`);continue}this.logService.info(`[language pack cache cleanup]: Removing unused language pack: ${I}`),await L.Promises.rm((0,p.join)(h,I))}const b=Date.now();for(const I of Object.keys(m)){const f=(0,p.join)(h,I),a=await L.Promises.readdir(f);for(const c of a){if(c==="tcf.json")continue;const t=(0,p.join)(f,c),r=await L.Promises.stat(t);r.isDirectory()&&b-r.mtime.getTime()>this._DataMaxAge&&(this.logService.info(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,p.join)(I,c)}`),await L.Promises.rm(t))}}}catch(m){(0,A.onUnexpectedError)(m)}}};n=fe([Y(0,S.INativeEnvironmentService),Y(1,R.ILogService),Y(2,P.IProductService)],n),e.LanguagePackCachedDataCleaner=n}),define(Z[32],ee([0,1,16,88]),function(K,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class P{constructor(){this.data=new Map}add(A,R){L.ok(p.isString(A)),L.ok(p.isObject(R)),L.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,R)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new P}),define(Z[79],ee([0,1,32,3]),function(K,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function P(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class k{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,w){this.schemasById[P(S)]=w,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new k;p.Registry.add(e.Extensions.JSONContribution,A)}),define(Z[37],ee([0,1,110,3,32,16,79]),function(K,e,p,L,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var R;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(R=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var S;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const w=P.Registry.as(A.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:p.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(I,f=!0){this.registerConfigurations([I],f)}registerConfigurations(I,f=!0){const a=[];I.forEach(c=>{a.push(...this.validateAndRegisterProperties(c,f,c.extensionInfo)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterConfigurations(I){const f=[],a=c=>{if(c.properties)for(const t in c.properties)f.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,c.properties[t]);c.allOf&&c.allOf.forEach(t=>a(t))};for(const c of I){a(c);const t=this.configurationContributors.indexOf(c);t!==-1&&this.configurationContributors.splice(t,1)}w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}registerDefaultConfigurations(I){const f=[],a=[];for(const c of I)for(const t in c)if(f.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...c[t]};const r={type:"object",default:this.defaultValues[t],description:p.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};a.push(m(t)),this.configurationProperties[t]=r,this.defaultLanguageConfigurationOverridesNode.properties[t]=r}else{this.defaultValues[t]=c[t];const r=this.configurationProperties[t];r&&(this.updatePropertyDefaultValue(t,r),this.updateSchema(t,r))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}deregisterDefaultConfigurations(I){const f=[];for(const a of I)for(const c in a)if(f.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const t=this.configurationProperties[c];t&&(this.updatePropertyDefaultValue(c,t),this.updateSchema(c,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}notifyConfigurationSchemaUpdated(...I){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(I){for(const f of I)this.overrideIdentifiers.add(f);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(I,f=!0,a,c=3){c=k.isUndefinedOrNull(I.scope)?c:I.scope;let t=[],r=I.properties;if(r)for(let s in r){if(f&&C(s)){delete r[s];continue}const u=r[s];if(this.updatePropertyDefaultValue(s,u),e.OVERRIDE_PROPERTY_PATTERN.test(s)?u.scope=void 0:(u.scope=k.isUndefinedOrNull(u.scope)?c:u.scope,u.restricted=k.isUndefinedOrNull(u.restricted)?!!a?.restrictedConfigurations?.includes(s):u.restricted),r[s].hasOwnProperty("included")&&!r[s].included){this.excludedConfigurationProperties[s]=r[s],delete r[s];continue}else this.configurationProperties[s]=r[s];!r[s].deprecationMessage&&r[s].markdownDeprecationMessage&&(r[s].deprecationMessage=r[s].markdownDeprecationMessage),t.push(s)}let i=I.allOf;if(i)for(let s of i)t.push(...this.validateAndRegisterProperties(s,f,a,c));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(I){const f=a=>{let c=a.properties;if(c)for(const r in c)this.updateSchema(r,c[r]);let t=a.allOf;t&&t.forEach(f)};f(I)}updateSchema(I,f){switch(e.allSettings.properties[I]=f,f.scope){case 1:e.applicationSettings.properties[I]=f;break;case 2:e.machineSettings.properties[I]=f;break;case 6:e.machineOverridableSettings.properties[I]=f;break;case 3:e.windowSettings.properties[I]=f;break;case 4:e.resourceSettings.properties[I]=f;break;case 5:e.resourceSettings.properties[I]=f,this.resourceLanguageSettingsSchema.properties[I]=f;break}}removeFromSchema(I,f){switch(delete e.allSettings.properties[I],f.scope){case 1:delete e.applicationSettings.properties[I];break;case 2:delete e.machineSettings.properties[I];break;case 6:delete e.machineOverridableSettings.properties[I];break;case 3:delete e.windowSettings.properties[I];break;case 4:case 5:delete e.resourceSettings.properties[I];break}}updateOverridePropertyPatternKey(){for(const I of this.overrideIdentifiers.values()){const f=`[${I}]`,a={type:"object",description:p.localize(2,null),errorMessage:p.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(f,a),e.allSettings.properties[f]=a,e.applicationSettings.properties[f]=a,e.machineSettings.properties[f]=a,e.machineOverridableSettings.properties[f]=a,e.windowSettings.properties[f]=a,e.resourceSettings.properties[f]=a}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(I,f){let a=this.defaultValues[I];k.isUndefined(a)&&(a=f.default),k.isUndefined(a)&&(a=v(f.type)),f.default=a}}const y="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(y);function m(b){return b.substring(1,b.length-1)}e.overrideIdentifierFromKey=m;function v(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const h=new n;P.Registry.add(e.Extensions.Configuration,h);function C(b){return b.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(b)?p.localize(5,null,b):h.getConfigurationProperties()[b]!==void 0?p.localize(6,null,b):null:p.localize(4,null)}e.validateProperty=C;function D(){const b=[],I=h.getConfigurationProperties();for(const f of Object.keys(I))b.push([f,I[f].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=D}),define(Z[24],ee([0,1,26,16,4,32,6,37]),function(K,e,p,L,P,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,A.createDecorator)("configurationService");function S(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof P.URI)}e.isConfigurationOverrides=S;var w;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(w=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function y(r,i){const s=i?r?i.keys.filter(T=>r.keys.indexOf(T)===-1):[...i.keys]:[],u=r?i?r.keys.filter(T=>i.keys.indexOf(T)===-1):[...r.keys]:[],o=[];if(i&&r){for(const T of r.keys)if(i.keys.indexOf(T)!==-1){const O=b(r.contents,T),$=b(i.contents,T);p.equals(O,$)||o.push(T)}}const l=[],g=T=>{const O={};for(const $ of T)for(const z of $.identifiers)O[c(z)]=$;return O},E=i?g(i.overrides):{},d=r?g(r.overrides):{};if(Object.keys(E).length)for(const T of s){const O=E[T];O&&l.push([(0,R.overrideIdentifierFromKey)(T),O.keys])}if(Object.keys(d).length)for(const T of u){const O=d[T];O&&l.push([(0,R.overrideIdentifierFromKey)(T),O.keys])}if(Object.keys(E).length&&Object.keys(d).length)for(const T of o){const O=d[T],$=E[T];if(O&&$){const z=y({contents:O.contents,keys:O.keys,overrides:[]},{contents:$.contents,keys:$.keys,overrides:[]});l.push([(0,R.overrideIdentifierFromKey)(T),[...z.added,...z.removed,...z.updated]])}}return{added:s,removed:u,updated:o,overrides:l}}e.compare=y;function m(r,i){const s=[];for(const u of Object.keys(r))if(R.OVERRIDE_PROPERTY_PATTERN.test(u)){const o={};for(const l in r[u])o[l]=r[u][l];s.push({identifiers:[(0,R.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(o),contents:v(o,i)})}return s}e.toOverrides=m;function v(r,i){const s=Object.create(null);for(let u in r)h(s,u,r[u],i);return s}e.toValuesTree=v;function h(r,i,s,u){const o=i.split("."),l=o.pop();let g=r;for(let E=0;E<o.length;E++){let d=o[E],T=g[d];switch(typeof T){case"undefined":T=g[d]=Object.create(null);break;case"object":break;default:u(`Ignoring ${i} as ${o.slice(0,E+1).join(".")} is ${JSON.stringify(T)}`);return}g=T}if(typeof g=="object"&&g!==null)try{g[l]=s}catch(E){u(`Ignoring ${i} as ${o.join(".")} is ${JSON.stringify(g)}`)}else u(`Ignoring ${i} as ${o.join(".")} is ${JSON.stringify(g)}`)}e.addToValueTree=h;function C(r,i){const s=i.split(".");D(r,s)}e.removeFromValueTree=C;function D(r,i){const s=i.shift();if(i.length===0){delete r[s];return}if(Object.keys(r).indexOf(s)!==-1){const u=r[s];typeof u=="object"&&!Array.isArray(u)&&(D(u,i),Object.keys(u).length===0&&delete r[s])}}function b(r,i,s){function u(g,E){let d=g;for(const T of E){if(typeof d!="object"||d===null)return;d=d[T]}return d}const o=i.split("."),l=u(r,o);return typeof l=="undefined"?s:l}e.getConfigurationValue=b;function I(r,i,s){Object.keys(i).forEach(u=>{u!=="__proto__"&&(u in r?L.isObject(r[u])&&L.isObject(i[u])?I(r[u],i[u],s):s&&(r[u]=i[u]):r[u]=i[u])})}e.merge=I;function f(){const r=k.Registry.as(R.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=f;function a(){const r=Object.create(null),i=k.Registry.as(R.Extensions.Configuration).getConfigurationProperties();for(let s in i){let u=i[s].default;h(r,s,u,o=>console.error(`Conflict in default settings: ${o}`))}return r}e.getDefaultValues=a;function c(r){return`[${r}]`}e.keyFromOverrideIdentifier=c;function t(r,i,s){const u=r.inspect(i),o=r.inspect(s);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:u.defaultValue}e.getMigratedSettingValue=t}),define(Z[166],ee([0,1,33,38,23,16,26,4,37,24,32,2,3]),function(K,e,p,L,P,k,A,R,S,w,n,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class v{constructor(t={},r=[],i=[]){this._contents=t,this._keys=r,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,w.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const i=this.getContentsForOverrideIdentifer(r);return i?t?(0,w.getConfigurationValue)(i,t):i:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let i={};for(const s of P.distinct([...Object.keys(this.contents),...Object.keys(r)])){let u=this.contents[s],o=r[s];o&&(typeof u=="object"&&typeof o=="object"?(u=A.deepClone(u),this.mergeContents(u,o)):u=o),i[s]=u}return new v(i,this.keys,this.overrides)}merge(...t){const r=A.deepClone(this.contents),i=A.deepClone(this.overrides),s=[...this.keys];for(const u of t){this.mergeContents(r,u.contents);for(const o of u.overrides){const[l]=i.filter(g=>P.equals(g.identifiers,o.identifiers));l?this.mergeContents(l.contents,o.contents):i.push(A.deepClone(o))}for(const o of u.keys)s.indexOf(o)===-1&&s.push(o)}return new v(r,s,i)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const i of Object.keys(r)){if(i in t&&k.isObject(t[i])&&k.isObject(r[i])){this.mergeContents(t[i],r[i]);continue}t[i]=A.deepClone(r[i])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?A.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,w.addToValueTree)(this.contents,t,r,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&(0,w.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let i=0;i<r;i++)t.indexOf(this.keys[i])===0&&(r=i);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=v;class h extends v{constructor(){const t=(0,w.getDefaultValues)(),r=(0,w.getConfigurationKeys)(),i=[];for(const s of Object.keys(t))S.OVERRIDE_PROPERTY_PATTERN.test(s)&&i.push({identifiers:[(0,S.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(t[s]),contents:(0,w.toValuesTree)(t[s],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,r,i)}}e.DefaultConfigurationModel=h;class C{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!k.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:i,keys:s,overrides:u,restricted:o}=this.doParseRaw(t,r);this._configurationModel=new v(i,s,u),this._restrictedConfigurations=o||[]}doParseContent(t){let r={},i=null,s=[],u=[],o=[];function l(E){Array.isArray(s)?s.push(E):i&&(s[i]=E)}let g={onObjectBegin:()=>{let E={};l(E),u.push(s),s=E,i=null},onObjectProperty:E=>{i=E},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{let E=[];l(E),u.push(s),s=E,i=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:l,onError:(E,d,T)=>{o.push({error:E,offset:d,length:T})}};if(t)try{p.visit(t,g),r=s[0]||{}}catch(E){console.error(`Error while parsing settings file ${this._name}: ${E}`),this._parseErrors=[E]}return r}doParseRaw(t,r){const i=n.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),s=this.filter(t,i,!0,r);t=s.raw;const u=(0,w.toValuesTree)(t,g=>console.error(`Conflict in settings file ${this._name}: ${g}`)),o=Object.keys(t),l=(0,w.toOverrides)(t,g=>console.error(`Conflict in settings file ${this._name}: ${g}`));return{contents:u,keys:o,overrides:l,restricted:s.restricted}}filter(t,r,i,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:t,restricted:[]};const u={},o=[];for(let l in t)if(S.OVERRIDE_PROPERTY_PATTERN.test(l)&&i){const g=this.filter(t[l],r,!1,s);u[l]=g.raw,o.push(...g.restricted)}else{const g=r[l],E=g?typeof g.scope!="undefined"?g.scope:3:void 0;g?.restricted&&o.push(l),(E===void 0||s.scopes===void 0||s.scopes.includes(E))&&(s.skipRestricted&&g?.restricted||(u[l]=t[l]))}return{raw:u,restricted:o}}}e.ConfigurationModelParser=C;class D extends y.Disposable{constructor(t,r,i,s){super();this.userSettingsResource=t,this.scopes=r,this.fileService=s,this._onDidChange=this._register(new m.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new C(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(m.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=D;class b{constructor(t,r,i=new v,s=new v,u=new L.ResourceMap,o=new v,l=new L.ResourceMap,g=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=i,this._workspaceConfiguration=s,this._folderConfigurations=u,this._memoryConfiguration=o,this._memoryConfigurationByResource=l,this._freeze=g,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(t,r,i){return this.getConsolidateConfigurationModel(r,i).getValue(t)}updateValue(t,r,i={}){let s;i.resource?(s=this._memoryConfigurationByResource.get(i.resource),s||(s=new v,this._memoryConfigurationByResource.set(i.resource,s))):s=this._memoryConfiguration,r===void 0?s.removeValue(t):s.setValue(t,r),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,i){const s=this.getConsolidateConfigurationModel(r,i),u=this.getFolderConfigurationModelForResource(r.resource,i),o=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,l=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),g=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),E=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),d=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),T=i?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=u?r.overrideIdentifier?u.freeze().override(r.overrideIdentifier).getValue(t):u.freeze().getValue(t):void 0,$=r.overrideIdentifier?o.override(r.overrideIdentifier).getValue(t):o.getValue(t),z=s.getValue(t),G=P.distinct(P.flatten(s.overrides.map(V=>V.identifiers))).filter(V=>s.getOverrideValue(t,V)!==void 0);return{defaultValue:l,userValue:g,userLocalValue:E,userRemoteValue:d,workspaceValue:T,workspaceFolderValue:O,memoryValue:$,value:z,default:l!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:g!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:E!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:d!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:T!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:u?.freeze().getValue(t),override:r.overrideIdentifier?u?.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:$!==void 0?{value:o.getValue(t),override:r.overrideIdentifier?o.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:G.length?G:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const i=r.filter(s=>S.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const u=(0,S.overrideIdentifierFromKey)(s),o=this._defaultConfiguration.getKeysForOverrideIdentifier(u),l=t.getKeysForOverrideIdentifier(u),g=[...l.filter(E=>o.indexOf(E)===-1),...o.filter(E=>l.indexOf(E)===-1),...o.filter(E=>!A.equals(this._defaultConfiguration.override(u).getValue(E),t.override(u).getValue(E)))];return[u,g]});return this.updateDefaultConfiguration(t),{keys:r,overrides:i}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:i,removed:s,overrides:u}=(0,w.compare)(this.localUserConfiguration,t),o=[...r,...i,...s];return o.length&&this.updateLocalUserConfiguration(t),{keys:o,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:i,removed:s,overrides:u}=(0,w.compare)(this.remoteUserConfiguration,t);let o=[...r,...i,...s];return o.length&&this.updateRemoteUserConfiguration(t),{keys:o,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:i,removed:s,overrides:u}=(0,w.compare)(this.workspaceConfiguration,t);let o=[...r,...i,...s];return o.length&&this.updateWorkspaceConfiguration(t),{keys:o,overrides:u}}compareAndUpdateFolderConfiguration(t,r){const i=this.folderConfigurations.get(t),{added:s,updated:u,removed:o,overrides:l}=(0,w.compare)(i,r);let g=[...s,...u,...o];return(g.length||!i)&&this.updateFolderConfiguration(t,r),{keys:g,overrides:l}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:s,removed:u,overrides:o}=(0,w.compare)(r,void 0);return{keys:[...i,...s,...u],overrides:o}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let i=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?i.override(t.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:t},r){let i=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const s=r.getFolder(t);s&&(i=this.getFolderConsolidatedConfiguration(s.uri)||i);const u=this._memoryConfigurationByResource.get(t);u&&(i=i.merge(u))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const i=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(t);s?(r=i.merge(s),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=i}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const i=r.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:i,overrides:s,keys:u}=this._folderConfigurations.get(r);return t.push([r,{contents:i,overrides:s,keys:u}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.user),s=this.parseConfigurationModel(t.workspace),u=t.folders.reduce((o,l)=>(o.set(R.URI.revive(l[0]),this.parseConfigurationModel(l[1])),o),new L.ResourceMap);return new b(r,i,new v,s,u,new v,new L.ResourceMap,!1)}static parseConfigurationModel(t){return new v(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=b;function I(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const t=new Set,r=new Map;for(const s of c)s.keys.forEach(u=>t.add(u)),s.overrides.forEach(([u,o])=>{const l=(0,L.getOrSet)(r,u,new Set);o.forEach(g=>l.add(g))});const i=[];return r.forEach((s,u)=>i.push([u,[...s.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=I;class f{constructor(t,r,i,s){this.change=t,this.previous=r,this.currentConfiguraiton=i,this.currentWorkspace=s,this._previousConfiguration=void 0;const u=new Set;t.keys.forEach(l=>u.add(l)),t.overrides.forEach(([,l])=>l.forEach(g=>u.add(g))),this.affectedKeys=[...u.values()];const o=new v;this.affectedKeys.forEach(l=>o.setValue(l,{})),this.affectedKeysTree=o.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const i=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!A.equals(i,s)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let i=(0,w.toValuesTree)({[r]:!0},()=>{}),s;for(;typeof i=="object"&&(s=Object.keys(i)[0]);){if(t=t[s],!t)return!1;i=i[s]}return!0}}e.ConfigurationChangeEvent=f;class a extends f{constructor(t,r,i,s){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=i,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=a}),define(Z[167],ee([0,1,32,37,2,24,166,3,5,15]),function(K,e,p,L,P,k,A,R,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class n extends P.Disposable{constructor(m,v){super();this.settingsResource=m,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new A.UserSettings(this.settingsResource,void 0,w.extUriBiasedIgnorePathCase,v)),this.configuration=new A.Configuration(new A.DefaultConfigurationModel,new A.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new S.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(p.Registry.as(L.Extensions.Configuration).onDidUpdateConfiguration(h=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const m=await this.userConfiguration.loadConfiguration();this.configuration=new A.Configuration(new A.DefaultConfigurationModel,m)}getConfigurationData(){return this.configuration.toData()}getValue(m,v){const h=typeof m=="string"?m:void 0,C=(0,k.isConfigurationOverrides)(m)?m:(0,k.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(h,C,void 0)}updateValue(m,v,h,C){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const v=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(h,v,1)}onDidDefaultConfigurationChange(m){const v=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new A.DefaultConfigurationModel,m);this.trigger(h,v,6)}trigger(m,v,h){const C=new A.ConfigurationChangeEvent(m,{data:v},this.configuration);C.source=h,C.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(C)}getTargetConfiguration(m){switch(m){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=n}),define(Z[168],ee([0,1,24,10,104]),function(K,e,p,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let k=class{constructor(R,S){this.configurationService=R,this.logService=S}request(R,S){return this.logService.trace("RequestService#request",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,P.request)(R,S)}async resolveProxy(R){}};k=fe([Y(0,p.IConfigurationService),Y(1,L.ILogService)],k),e.RequestService=k}),define(Z[39],ee([0,1,122,6,37,32,25]),function(K,e,p,L,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function R(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=R;function S(h){return h.res.statusCode===204}async function w(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);return S(h)?null:(await(0,A.streamToBuffer)(h.stream)).toString()}e.asText=w;async function n(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);if(S(h))return null;const D=(await(0,A.streamToBuffer)(h.stream)).toString();try{return JSON.parse(D)}catch(b){throw b.message+=`:
`+D,b}}e.asJson=n;function y(h){v(h)}e.updateProxyConfigurationsScope=y;let m;function v(h){const C=k.Registry.as(P.Extensions.Configuration);m&&C.deregisterConfigurations([m]),m={id:"http",order:15,title:(0,p.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,p.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,p.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,p.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,p.localize)(4,null),(0,p.localize)(5,null),(0,p.localize)(6,null),(0,p.localize)(7,null)],default:"override",description:(0,p.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,p.localize)(9,null),restricted:!0}}},C.registerConfiguration(m)}v(2)}),define(Z[169],ee([0,1,39,29,14,17]),function(K,e,p,L,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(S,w){this.requestService=S,this.fileService=w}async download(S,w,n=L.CancellationToken.None){if(S.scheme===k.Schemas.file||S.scheme===k.Schemas.vscodeRemote){await this.fileService.copy(S,w);return}const y={type:"GET",url:S.toString()},m=await this.requestService.request(y,n);if(m.res.statusCode===200)await this.fileService.writeFile(w,m.stream);else{const v=await(0,p.asText)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${v}`)}}};A=fe([Y(0,p.IRequestService),Y(1,P.IFileService)],A),e.DownloadService=A}),define(Z[170],ee([0,1,28,14,23,63,39,29,10,15,134,2]),function(K,e,p,L,P,k,A,R,S,w,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let m=class extends y.Disposable{constructor(h,C,D,b){super();this.fileService=h,this.productService=C,this.requestService=D,this.logService=b,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,k.forEach)(this.productService.configBasedExtensionTips,({value:I})=>this.allConfigBasedTips.set(I.configPath,I))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const C=[];for(const[D,b]of this.allConfigBasedTips)try{const I=await this.fileService.readFile((0,w.joinPath)(h,D)),f=new Map;(0,k.forEach)(b.recommendations,({key:c,value:t})=>{if((0,P.isNonEmptyArray)(t.remotes))for(const r of t.remotes)f.set(r,{extensionId:c,extensionName:t.name,configName:b.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else C.push({extensionId:c,extensionName:t.name,configName:b.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const a=(0,n.getDomainsOfRemotes)(I.value.toString(),[...f.keys()]);for(const c of a){const t=f.get(c);t&&C.push(t)}}catch(I){}return C}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},R.CancellationToken.None);if(h.res.statusCode!==200)return[];const C=await(0,A.asJson)(h);return C?C.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};m=fe([Y(0,L.IFileService),Y(1,p.IProductService),Y(2,A.IRequestService),Y(3,S.ILogService)],m),e.ExtensionTipsService=m}),define(Z[45],ee([0,1,30,25]),function(K,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function P(k,A,R){let S=R&&R.get("storage.serviceMachineId",0)||null;if(S)return S;try{const n=(await A.readFile(k.serviceMachineIdResource)).value.toString();S=(0,p.isUUID)(n)?n:null}catch(w){S=null}if(!S){S=(0,p.generateUuid)();try{await A.writeFile(k.serviceMachineIdResource,L.VSBuffer.fromString(S))}catch(w){}}return R&&R.store("storage.serviceMachineId",S,0,1),S}e.getServiceMachineId=P}),define(Z[20],ee([0,1,6,3,2,16,69,5]),function(K,e,p,L,P,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const S="__$__targetStorageMarker";e.IStorageService=(0,p.createDecorator)("storageService");var w;(function(C){C[C.NONE=0]="NONE",C[C.SHUTDOWN=1]="SHUTDOWN"})(w=e.WillSaveStateReason||(e.WillSaveStateReason={}));var n;(function(C){C[C.GLOBAL=0]="GLOBAL",C[C.WORKSPACE=1]="WORKSPACE"})(n=e.StorageScope||(e.StorageScope={}));var y;(function(C){C[C.USER=0]="USER",C[C.MACHINE=1]="MACHINE"})(y=e.StorageTarget||(e.StorageTarget={}));class m extends P.Disposable{constructor(D={flushInterval:m.DEFAULT_FLUSH_INTERVAL}){super();this.options=D,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new P.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,R.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,P.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(D,b){b===S?(D===0?this._globalKeyTargets=void 0:D===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:D})):this._onDidChangeValue.fire({scope:D,key:b,target:this.getKeyTargets(D)[b]})}emitWillSaveState(D){this._onWillSaveState.fire({reason:D})}get(D,b,I){return this.getStorage(b)?.get(D,I)}getBoolean(D,b,I){return this.getStorage(b)?.getBoolean(D,I)}getNumber(D,b,I){return this.getStorage(b)?.getNumber(D,I)}store(D,b,I,f){if((0,k.isUndefinedOrNull)(b)){this.remove(D,I);return}this.withPausedEmitters(()=>{this.updateKeyTarget(D,I,f),this.getStorage(I)?.set(D,b)})}remove(D,b){this.withPausedEmitters(()=>{this.updateKeyTarget(D,b,void 0),this.getStorage(b)?.delete(D)})}withPausedEmitters(D){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{D()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(D,b){const I=[],f=this.getKeyTargets(D);for(const a of Object.keys(f))f[a]===b&&I.push(a);return I}updateKeyTarget(D,b,I){const f=this.getKeyTargets(b);typeof I=="number"?f[D]!==I&&(f[D]=I,this.getStorage(b)?.set(S,JSON.stringify(f))):typeof f[D]=="number"&&(delete f[D],this.getStorage(b)?.set(S,JSON.stringify(f)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(D){return D===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(D){const b=this.get(S,D);if(b)try{return JSON.parse(b)}catch(I){}return Object.create(null)}isNew(D){return this.getBoolean(e.IS_NEW_KEY,D)===!0}async flush(){this._onWillSaveState.fire({reason:w.NONE}),await R.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const D=this.getStorage(0)?.items??new Map,b=this.getStorage(1)?.items??new Map;return h(D,b,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=m,m.DEFAULT_FLUSH_INTERVAL=60*1e3;class v extends m{constructor(){super();this.globalStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(D=>this.emitDidChangeValue(1,D))),this._register(this.globalStorage.onDidChangeStorage(D=>this.emitDidChangeValue(0,D)))}getStorage(D){return D===0?this.globalStorage:this.workspaceStorage}getLogDetails(D){return D===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(D){}}e.InMemoryStorageService=v;async function h(C,D,b,I){const f=u=>{try{return JSON.parse(u)}catch(o){return u}},a=new Map,c=new Map;C.forEach((u,o)=>{a.set(o,u),c.set(o,f(u))});const t=new Map,r=new Map;D.forEach((u,o)=>{t.set(o,u),r.set(o,f(u))}),console.group(`Storage: Global (path: ${b})`);let i=[];a.forEach((u,o)=>{i.push({key:o,value:u})}),console.table(i),console.groupEnd(),console.log(c),console.group(`Storage: Workspace (path: ${I})`);let s=[];t.forEach((u,o)=>{s.push({key:o,value:u})}),console.table(s),console.groupEnd(),console.log(r)}e.logStorage=h}),define(Z[171],ee([0,1,3,2,27,31,20,16]),function(K,e,p,L,P,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let S=class extends L.Disposable{constructor(y){super();this._onDidChangeEnablement=new p.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new w(y)),this._register(this.storageManger.onDidChange(m=>this._onDidChangeEnablement.fire({extensions:m,source:"storage"})))}async enableExtension(y,m){return this._removeFromDisabledExtensions(y)?(this._onDidChangeEnablement.fire({extensions:[y],source:m}),!0):!1}async disableExtension(y,m){return this._addToDisabledExtensions(y)?(this._onDidChangeEnablement.fire({extensions:[y],source:m}),!0):!1}getDisabledExtensions(){return this._getExtensions(P.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(y){let m=this.getDisabledExtensions();return m.every(v=>!(0,k.areSameExtensions)(v,y))?(m.push(y),this._setDisabledExtensions(m),!0):!1}_removeFromDisabledExtensions(y){let m=this.getDisabledExtensions();for(let v=0;v<m.length;v++){const h=m[v];if((0,k.areSameExtensions)(h,y))return m.splice(v,1),this._setDisabledExtensions(m),!0}return!1}_setDisabledExtensions(y){this._setExtensions(P.DISABLED_EXTENSIONS_STORAGE_PATH,y)}_getExtensions(y){return this.storageManger.get(y,0)}_setExtensions(y,m){this.storageManger.set(y,m,0)}};S=fe([Y(0,A.IStorageService)],S),e.GlobalExtensionEnablementService=S;class w extends L.Disposable{constructor(y){super();this.storageService=y,this.storage=Object.create(null),this._onDidChange=this._register(new p.Emitter),this.onDidChange=this._onDidChange.event,this._register(y.onDidChangeValue(m=>this.onDidStorageChange(m)))}get(y,m){let v;return m===0?((0,R.isUndefinedOrNull)(this.storage[y])&&(this.storage[y]=this._get(y,m)),v=this.storage[y]):v=this._get(y,m),JSON.parse(v)}set(y,m,v){let h=JSON.stringify(m.map(({id:D,uuid:b})=>({id:D,uuid:b})));this._get(y,v)!==h&&(v===0&&(m.length?this.storage[y]=h:delete this.storage[y]),this._set(y,m.length?h:void 0,v))}onDidStorageChange(y){if(y.scope===0&&!(0,R.isUndefinedOrNull)(this.storage[y.key])&&this._get(y.key,y.scope)!==this.storage[y.key]){const v=this.get(y.key,y.scope);delete this.storage[y.key];const h=this.get(y.key,y.scope),C=v.filter(b=>!h.some(I=>(0,k.areSameExtensions)(b,I))),D=h.filter(b=>!v.some(I=>(0,k.areSameExtensions)(I,b)));(C.length||D.length)&&this._onDidChange.fire([...C,...D])}}_get(y,m){return this.storageService.get(y,m,"[]")}_set(y,m,v){m?this.storageService.store(y,m,v,1):this.storageService.remove(y,v)}}e.StorageManager=w}),define(Z[172],ee([0,1,3,2]),function(K,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class P extends L.Disposable{constructor(w,n){super();this.channel=w,this.workspace=n}async getItems(){const w={workspace:this.workspace},n=await this.channel.call("getItems",w);return new Map(n)}updateItems(w){const n={workspace:this.workspace};return w.insert&&(n.insert=Array.from(w.insert.entries())),w.delete&&(n.delete=Array.from(w.delete.values())),this.channel.call("updateItems",n)}}class k extends P{constructor(w){super(w,void 0);this._onDidChangeItemsExternal=this._register(new p.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(w=>this.onDidChangeGlobalStorage(w)))}onDidChangeGlobalStorage(w){(Array.isArray(w.changed)||Array.isArray(w.deleted))&&this._onDidChangeItemsExternal.fire({changed:w.changed?new Map(w.changed):void 0,deleted:w.deleted?new Set(w.deleted):void 0})}async close(){this.dispose()}}class A extends P{constructor(w,n){super(w,n);this.onDidChangeItemsExternal=p.Event.None}async close(){const w={workspace:this.workspace};return this.channel.call("close",w)}}class R extends L.Disposable{constructor(w,n){super();this.channel=w,this.workspace=n,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new k(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new A(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=R}),define(Z[173],ee([0,1,2,20,69,5,162,172,15]),function(K,e,p,L,P,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class w extends L.AbstractStorageService{constructor(y,m,v){super();this.mainProcessService=m,this.environmentService=v,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new p.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(y)}createGlobalStorage(){const y=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),m=new P.Storage(y.globalStorage);return this._register(m.onDidChangeStorage(v=>this.emitDidChangeValue(0,v))),m}createWorkspaceStorage(y){const m=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),y);if(m.workspaceStorage){const v=new P.Storage(m.workspaceStorage);return this.workspaceStorageDisposable.value=v.onDidChangeStorage(h=>this.emitDidChangeValue(1,h)),this.workspaceStorageId=y?.id,v}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){(0,A.mark)("code/willInitStorage");try{await k.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}finally{(0,A.mark)("code/didInitStorage")}}getStorage(y){return y===0?this.globalStorage:this.workspaceStorage}getLogDetails(y){return y===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,S.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(L.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(y){const m=this.workspaceStorage,v=m?.items??new Map;m&&(await m.close(),m.dispose()),this.workspaceStorage=this.createWorkspaceStorage(y),await this.workspaceStorage.init();for(const[h,C]of v)this.workspaceStorage.set(h,C)}}e.NativeStorageService=w}),define(Z[174],ee([0,1,7,34,30,4]),function(K,e,p,L,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(w){if(p.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function R(w,n,y,m,v,h,C,D,b,I){const f=Object.create(null);f["common.machineId"]=C,f.sessionID=(0,P.generateUuid)()+Date.now(),f.commitHash=v,f.version=h,f["common.platformVersion"]=(n||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,p.PlatformToString)(p.platform),f["common.nodePlatform"]=L.platform,f["common.nodeArch"]=m,f["common.product"]=I||"desktop";const a=S(D||[]);a&&(f["common.msftInternal"]=a);let c=0;const t=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),p.isLinuxSnap&&(f["common.snap"]="true");const r=A(y);r&&(f["common.platformDetail"]=r);try{const i=await w.readFile(k.URI.file(b));f["common.source"]=i.value.toString().slice(0,30)}catch(i){}return f}e.resolveCommonProperties=R;function S(w){const n=L.env.USERDNSDOMAIN;if(!n)return!1;const y=n.toLowerCase();return w.some(m=>y===m)}e.verifyMicrosoftInternalDomain=S}),define(Z[21],ee([0,1,6]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,p.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,p.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Z[175],ee([0,1,35,96,71,8,33,99,28,7,4,21,54,17,14,18]),function(K,e,p,L,P,k,A,R,S,w,n,y,m,v,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function D(c,t){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],i=new Map,s=new Map,u=2e4;function o(E,d,T,O){const $=d.substring(E.length+1);return new Promise(async z=>{let G;try{G=await C.Promises.readdir(d,{withFileTypes:!0})}catch(M){z();return}if(O.count>=u){O.count+=G.length,O.maxReached=!0,z();return}let V=G.length;if(V===0){z();return}let U=G;O.count+G.length>u&&(O.maxReached=!0,V=u-O.count,U=G.slice(0,V)),O.count+=G.length;for(const M of U)if(M.isDirectory()){if(T.includes(M.name)||await o(E,(0,k.join)(d,M.name),T,O),--V==0){z();return}}else{const F=M.name.lastIndexOf(".");if(F>=0){const j=M.name.substring(F+1);j&&i.set(j,(i.get(j)??0)+1)}for(const j of r)j.relativePathPattern?.test($)!==!1&&j.filePattern.test(M.name)&&s.set(j.tag,(s.get(j.tag)??0)+1);if(--V==0){z();return}}})}const l={count:0,maxReached:!1};await o(c,c,t,l);const g=await f(c);return{configFiles:b(s),fileTypes:b(i),fileCount:l.count,maxFilesReached:l.maxReached,launchConfigFiles:g}}e.collectWorkspaceStats=D;function b(c){return[...m.Iterable.map(c.entries(),([t,r])=>({name:t,count:r}))].sort((t,r)=>r.count-t.count)}function I(){const c={os:`${p.type()} ${p.arch()} ${p.release()}`,memory:`${(p.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(L.virtualMachineHint.value()*100)}%`},t=p.cpus();return t&&t.length>0&&(c.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),c}e.getMachineInfo=I;async function f(c){try{const t=new Map,r=(0,k.join)(c,".vscode","launch.json"),i=await C.Promises.readFile(r),s=[],u=(0,A.parse)(i.toString(),s);if(s.length)return console.log(`Unable to parse ${r}`),[];if((0,A.getNodeType)(u)==="object"&&u.configurations)for(const o of u.configurations){const l=o.type;l&&(t.has(l)?t.set(l,t.get(l)+1):t.set(l,1))}return b(t)}catch(t){return[]}}e.collectLaunchConfigs=f;let a=class{constructor(t,r){this.telemetryService=t,this.productService=r}formatMachineInfo(t){const r=[];return r.push(`OS Version:       ${t.os}`),r.push(`CPUs:             ${t.cpus}`),r.push(`Memory (System):  ${t.memory}`),r.push(`VM:               ${t.vmHint}`),r.join(`
`)}formatEnvironment(t){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${p.type()} ${p.arch()} ${p.release()}`);const i=p.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(p.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),w.isWindows||r.push(`Load (avg):       ${p.loadavg().map(s=>Math.round(s)).join(", ")}`),r.push(`VM:               ${Math.round(L.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${t.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(t,r){return Promise.all([(0,R.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async i=>{let[s,u]=i,o=this.formatProcessList(t,s);return r.forEach(l=>{if((0,P.isRemoteDiagnosticError)(l))o+=`
${l.errorMessage}`,u+=`
${l.errorMessage}`;else if(o+=`

Remote: ${l.hostName}`,l.processes&&(o+=`
${this.formatProcessList(t,l.processes)}`),l.workspaceMetadata){u+=`
|  Remote: ${l.hostName}`;for(const g of Object.keys(l.workspaceMetadata)){const E=l.workspaceMetadata[g];let d=`${E.fileCount} files`;E.maxFilesReached&&(d=`more than ${d}`),u+=`|    Folder (${g}): ${d}`,u+=this.formatWorkspaceStats(E)}}}),{processInfo:o,workspaceInfo:u}})}async getSystemInfo(t,r){const{memory:i,vmHint:s,os:u,cpus:o}=I(),l={os:u,memory:i,cpus:o,vmHint:s,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:r};return w.isWindows||(l.load=`${p.loadavg().map(g=>Math.round(g)).join(", ")}`),w.isLinux&&(l.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(l)}async getDiagnostics(t,r){const i=[];return(0,R.listProcesses)(t.mainPID).then(async s=>(i.push(""),i.push(this.formatEnvironment(t)),i.push(""),i.push(this.formatProcessList(t,s)),t.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(t))),r.forEach(u=>{if((0,P.isRemoteDiagnosticError)(u))i.push(`
${u.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${u.hostName}`),i.push(this.formatMachineInfo(u.machineInfo)),u.processes&&i.push(this.formatProcessList(t,u.processes)),u.workspaceMetadata)for(const o of Object.keys(u.workspaceMetadata)){const l=u.workspaceMetadata[o];let g=`${l.fileCount} files`;l.maxFilesReached&&(g=`more than ${g}`),i.push(`Folder (${o}): ${g}`),i.push(this.formatWorkspaceStats(l))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(t){const r=[],i=60;let s=0;const u=(E,d)=>{const T=` ${E}(${d})`;s+T.length>i?(r.push(o),o="|                 ",s=o.length):s+=T.length,o+=T};let o="|      File types:";const l=10;let g=t.fileTypes.length>l?l:t.fileTypes.length;for(let E=0;E<g;E++){const d=t.fileTypes[E];u(d.name,d.count)}if(r.push(o),t.configFiles.length>=0&&(o="|      Conf files:",s=0,t.configFiles.forEach(E=>{u(E.name,E.count)}),r.push(o)),t.launchConfigFiles.length>0){let E="|      Launch Configs:";t.launchConfigFiles.forEach(d=>{E+=d.count>1?` ${d.name}(${d.count})`:` ${d.name}`}),r.push(E)}return r.join(`
`)}expandGPUFeatures(t){const r=Math.max(...Object.keys(t).map(i=>i.length));return Object.keys(t).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${t[i]}`).join(`
                  `)}formatWorkspaceMetadata(t){const r=[],i=[];return t.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(r.push(`|  Window (${s.title})`),s.folderURIs.forEach(u=>{const o=n.URI.revive(u);if(o.scheme===v.Schemas.file){const l=o.fsPath;i.push(D(l,["node_modules",".git"]).then(g=>{let E=`${g.fileCount} files`;g.maxFilesReached&&(E=`more than ${E}`),r.push(`|    Folder (${(0,k.basename)(l)}): ${E}`),r.push(this.formatWorkspaceStats(g))}).catch(g=>{r.push(`|      Error: Unable to collect workspace stats for folder ${l} (${g.toString()})`)}))}else r.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(s=>r.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(t,r){const i=new Map;t.windows.forEach(u=>i.set(u.pid,u.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(t.mainPID,i,s,r,0),s.join(`
`)}formatProcessItem(t,r,i,s,u){const o=u===0;let l;o?l=s.pid===t?`${this.productService.applicationName} main`:"remote agent":(l=`${"  ".repeat(u)} ${s.name}`,s.name==="window"&&(l=`${l} (${r.get(s.pid)})`));const g=process.platform==="win32"?s.mem:p.totalmem()*(s.mem/100);i.push(`${s.load.toFixed(0).padStart(5," ")}	${(g/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${l}`),Array.isArray(s.children)&&s.children.forEach(E=>this.formatProcessItem(t,r,i,E,u+1))}async reportWorkspaceStats(t){for(const{uri:r}of t.folders){const i=n.URI.revive(r);if(i.scheme!==v.Schemas.file)continue;const s=i.fsPath;try{const u=await D(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),u.fileTypes.forEach(o=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:o.name,count:o.count})}),u.launchConfigFiles.forEach(o=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:o.name,count:o.count})}),u.configFiles.forEach(o=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};a=fe([Y(0,y.ITelemetryService),Y(1,S.IProductService)],a),e.DiagnosticsService=a}),define(Z[176],ee([0,1,111,2,27,31,3,44,10,21,29,11,4,5]),function(K,e,p,L,P,k,A,R,S,w,n,y,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.INSTALL_ERROR_LOCAL=e.ERROR_UNKNOWN=e.INSTALL_ERROR_VALIDATING=void 0,e.INSTALL_ERROR_VALIDATING="validating",e.ERROR_UNKNOWN="unknown",e.INSTALL_ERROR_LOCAL="local";let h=class extends L.Disposable{constructor(f,a,c){super();this.galleryService=f,this.telemetryService=a,this.logService=c,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,L.toDisposable)(()=>{this.installingExtensions.forEach(t=>t.cancel()),this.uninstallingExtensions.forEach(t=>t.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async installFromGallery(f,a={}){if(!this.galleryService.isEnabled())throw new Error(p.localize(0,null));try{f=await this.checkAndGetCompatibleVersion(f)}catch(t){throw this.logService.error((0,y.getErrorMessage)(t)),D(this.telemetryService,"extensionGallery:install",(0,k.getGalleryExtensionTelemetryData)(f),void 0,t),t}if(!await this.canInstall(f)){const t=new P.ExtensionManagementError("Not supported",e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Canno install extension as it is not supported.",f.identifier.id,t.message),D(this.telemetryService,"extensionGallery:install",(0,k.getGalleryExtensionTelemetryData)(f),void 0,t),t}const c=await this.galleryService.getManifest(f,n.CancellationToken.None);if(c===null){const t=new P.ExtensionManagementError(`Missing manifest for extension ${f.identifier.id}`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",f.identifier.id,t.message),D(this.telemetryService,"extensionGallery:install",(0,k.getGalleryExtensionTelemetryData)(f),void 0,t),t}return this.installExtension(c,f,a)}async uninstall(f,a={}){return this.logService.trace("ExtensionManagementService#uninstall",f.identifier.id),this.unininstallExtension(f,a)}async reinstallFromGallery(f){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",f.identifier.id),!this.galleryService.isEnabled())throw new Error(p.localize(1,null));const a=await this.findGalleryExtension(f);if(!a)throw new Error(p.localize(2,null));await this.createUninstallExtensionTask(f,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(a)}getExtensionsReport(){const f=new Date().getTime();return(!this.reportedExtensions||f-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=f),this.reportedExtensions}registerParticipant(f){this.participants.push(f)}async installExtension(f,a,c){if(!m.URI.isUri(a)){let u=this.installingExtensions.get(new k.ExtensionIdentifierWithVersion(a.identifier,a.version).key());if(u)return this.logService.info("Extensions is already requested to install",a.identifier.id),u.waitUntilTaskIsFinished();c={...c,installOnlyNewlyAddedFromExtensionPack:!0}}const t=[],r=[],i=this.createInstallExtensionTask(f,a,c);m.URI.isUri(a)||this.installingExtensions.set(new k.ExtensionIdentifierWithVersion(i.identifier,f.version).key(),i),this._onInstallExtension.fire({identifier:i.identifier,source:a}),this.logService.info("Installing extension:",i.identifier.id),t.push({task:i,manifest:f});let s=!1;try{if(c.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",i.identifier.id);else try{const o=await this.getAllDepsAndPackExtensionsToInstall(i.identifier,f,!!c.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:l,manifest:g}of o)if(s=s||!!g.extensionDependencies?.some(E=>(0,k.areSameExtensions)({id:E},i.identifier)),this.installingExtensions.has(new k.ExtensionIdentifierWithVersion(l.identifier,l.version).key()))this.logService.info("Extension is already requested to install",l.identifier.id);else{const E=this.createInstallExtensionTask(g,l,{...c,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new k.ExtensionIdentifierWithVersion(E.identifier,g.version).key(),E),this._onInstallExtension.fire({identifier:E.identifier,source:l}),this.logService.info("Installing extension:",E.identifier.id),t.push({task:E,manifest:g})}}catch(o){throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",i.identifier.id),this.logService.error(o),o}const u=t.reduce((o,{task:l,manifest:g})=>(o.set(l.identifier.id.toLowerCase(),{task:l,manifest:g}),o),new Map);for(;u.size;){let o;const l=[...u.values()].filter(({manifest:g})=>!g.extensionDependencies?.some(E=>u.has(E.toLowerCase())));l.length?o=u.size===1?l:l.filter(({task:g})=>!(g===i&&!s)):(this.logService.info("Found extensions with circular dependencies",l.map(({task:g})=>g.identifier.id)),o=[...u.values()]),await this.joinAllSettled(o.map(async({task:g})=>{const E=new Date().getTime();try{const d=await g.run();await this.joinAllSettled(this.participants.map(T=>T.postInstall(d,g.source,c,n.CancellationToken.None))),m.URI.isUri(g.source)||D(this.telemetryService,g.operation===2?"extensionGallery:update":"extensionGallery:install",(0,k.getGalleryExtensionTelemetryData)(g.source),new Date().getTime()-E,void 0),r.push({local:d,identifier:g.identifier,operation:g.operation,source:g.source})}catch(d){throw m.URI.isUri(g.source)||D(this.telemetryService,g.operation===2?"extensionGallery:update":"extensionGallery:install",(0,k.getGalleryExtensionTelemetryData)(g.source),new Date().getTime()-E,d),this.logService.error("Error while installing the extension:",g.identifier.id),this.logService.error(d),d}finally{u.delete(g.identifier.id.toLowerCase())}}))}return r.forEach(({identifier:o})=>this.logService.info("Extension installed successfully:",o.id)),this._onDidInstallExtensions.fire(r),r.filter(({identifier:o})=>(0,k.areSameExtensions)(o,i.identifier))[0].local}catch(u){if(t.forEach(({task:o})=>o.cancel()),r.length)try{const o=await Promise.allSettled(r.map(({local:l})=>this.createUninstallExtensionTask(l,{versionOnly:!0}).run()));for(let l=0;l<o.length;l++){const g=o[l],{identifier:E}=r[l];g.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",E.id):this.logService.warn("Rollback: Error while uninstalling extension",E.id,(0,y.getErrorMessage)(g.reason))}}catch(o){this.logService.warn("Error while rolling back extensions",(0,y.getErrorMessage)(o),r.map(({identifier:l})=>l.id))}throw this.logService.error("Failed to install extension:",i.identifier.id,(0,y.getErrorMessage)(u)),this._onDidInstallExtensions.fire(t.map(({task:o})=>({identifier:o.identifier,operation:1,source:o.source}))),u instanceof Error&&(u.name=u&&u.code?u.code:e.ERROR_UNKNOWN),u}finally{for(const{task:u,manifest:o}of t)if(!m.URI.isUri(u.source)){const l=new k.ExtensionIdentifierWithVersion(u.identifier,o.version).key();this.installingExtensions.delete(l)||this.logService.warn("Installation task is not found in the cache",l)}}}async joinAllSettled(f){const a=[],c=[],t=await Promise.allSettled(f);for(const r of t)r.status==="fulfilled"?a.push(r.value):c.push(r.reason);if(c.length)throw C(c);return a}async getAllDepsAndPackExtensionsToInstall(f,a,c){if(!this.galleryService.isEnabled())return[];let t=await this.getInstalled();const r=[f,...t.map(u=>u.identifier)],i=[],s=async(u,o)=>{const l=o.extensionDependencies||[];if(o.extensionPack){const g=c?t.find(E=>(0,k.areSameExtensions)(E.identifier,u)):void 0;for(const E of o.extensionPack)g&&g.manifest.extensionPack&&g.manifest.extensionPack.some(d=>(0,k.areSameExtensions)({id:d},{id:E}))||l.every(d=>!(0,k.areSameExtensions)({id:d},{id:E}))&&l.push(E)}if(l.length){const g=[...r,...i.map(d=>d.gallery.identifier)],E=l.filter(d=>g.every(T=>!(0,k.areSameExtensions)(T,{id:d})));if(E.length){const d=await this.galleryService.query({names:E,pageSize:l.length},n.CancellationToken.None);for(const T of d.firstPage){if(g.find(z=>(0,k.areSameExtensions)(z,T.identifier)))continue;const O=await this.checkAndGetCompatibleVersion(T);if(!await this.canInstall(O)){this.logService.info("Skipping the extension as it cannot be installed",O.identifier.id);continue}const $=await this.galleryService.getManifest(O,n.CancellationToken.None);if($===null)throw new P.ExtensionManagementError(`Missing manifest for extension ${O.identifier.id}`,e.INSTALL_ERROR_VALIDATING);i.push({gallery:O,manifest:$}),await s(O.identifier,$)}}}};return await s(f,a),t=await this.getInstalled(),i.filter(u=>!t.some(o=>(0,k.areSameExtensions)(o.identifier,u.gallery.identifier)))}async checkAndGetCompatibleVersion(f){if(await this.isMalicious(f))throw new P.ExtensionManagementError(p.localize(3,null,f.identifier.id),P.INSTALL_ERROR_MALICIOUS);const a=await this.galleryService.getCompatibleExtension(f);if(!a)throw new P.ExtensionManagementError(p.localize(4,null,f.identifier.id,R.default.version),P.INSTALL_ERROR_INCOMPATIBLE);return a}async isMalicious(f){const a=await this.getExtensionsReport();return(0,k.getMaliciousExtensionsSet)(a).has(f.identifier.id)}async unininstallExtension(f,a){const c=this.uninstallingExtensions.get(f.identifier.id.toLowerCase());if(c)return this.logService.info("Extensions is already requested to uninstall",f.identifier.id),c.waitUntilTaskIsFinished();const t=(u,o)=>{const l=this.createUninstallExtensionTask(u,o);return this.uninstallingExtensions.set(l.extension.identifier.id.toLowerCase(),l),this.logService.info("Uninstalling extension:",u.identifier.id),this._onUninstallExtension.fire(u.identifier),l},r=(u,o)=>{o?this.logService.error("Failed to uninstall extension:",u.identifier.id,o.message):this.logService.info("Successfully uninstalled extension:",u.identifier.id),D(this.telemetryService,"extensionGallery:uninstall",(0,k.getLocalExtensionTelemetryData)(u),void 0,o),this._onDidUninstallExtension.fire({identifier:u.identifier,error:o?.code})},i=[],s=[];try{i.push(t(f,{}));const u=await this.getInstalled(1);if(a.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",f.identifier.id);else{const o=this.getAllPackExtensionsToUninstall(f,u);for(const l of o)this.uninstallingExtensions.has(l.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",l.identifier.id):i.push(t(l,{}))}a.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",f.identifier.id):this.checkForDependents(i.map(o=>o.extension),u,f),await this.joinAllSettled(i.map(async o=>{try{if(await o.run(),await this.joinAllSettled(this.participants.map(l=>l.postUninstall(o.extension,a,n.CancellationToken.None))),o.extension.identifier.uuid)try{await this.galleryService.reportStatistic(o.extension.manifest.publisher,o.extension.manifest.name,o.extension.manifest.version,"uninstall")}catch(l){}r(o.extension)}catch(l){const g=l instanceof P.ExtensionManagementError?l:new P.ExtensionManagementError((0,y.getErrorMessage)(l),e.ERROR_UNKNOWN);throw r(o.extension,g),g}finally{s.push(o)}}))}catch(u){const o=u instanceof P.ExtensionManagementError?u:new P.ExtensionManagementError((0,y.getErrorMessage)(u),e.ERROR_UNKNOWN);for(const l of i){try{l.cancel()}catch(g){}s.includes(l)||r(l.extension,o)}throw o}finally{for(const u of i)this.uninstallingExtensions.delete(u.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",u.extension.identifier.id)}}checkForDependents(f,a,c){for(const t of f){const r=this.getDependents(t,a);if(r.length){const i=r.filter(s=>f.indexOf(s)===-1);if(i.length)throw new Error(this.getDependentsErrorMessage(t,i,c))}}}getDependentsErrorMessage(f,a,c){return c===f?a.length===1?p.localize(5,null,c.manifest.displayName||c.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?p.localize(6,null,c.manifest.displayName||c.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):p.localize(7,null,c.manifest.displayName||c.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):a.length===1?p.localize(8,null,c.manifest.displayName||c.manifest.name,f.manifest.displayName||f.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?p.localize(9,null,c.manifest.displayName||c.manifest.name,f.manifest.displayName||f.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):p.localize(10,null,c.manifest.displayName||c.manifest.name,f.manifest.displayName||f.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name)}getAllPackExtensionsToUninstall(f,a,c=[]){if(c.indexOf(f)!==-1)return[];c.push(f);const t=f.manifest.extensionPack?f.manifest.extensionPack:[];if(t.length){const r=a.filter(s=>!s.isBuiltin&&t.some(u=>(0,k.areSameExtensions)({id:u},s.identifier))),i=[];for(const s of r)i.push(...this.getAllPackExtensionsToUninstall(s,a,c));return[...r,...i]}return[]}getDependents(f,a){return a.filter(c=>c.manifest.extensionDependencies&&c.manifest.extensionDependencies.some(t=>(0,k.areSameExtensions)({id:t},f.identifier)))}async findGalleryExtension(f){if(f.identifier.uuid){const a=await this.findGalleryExtensionById(f.identifier.uuid);return a||this.findGalleryExtensionByName(f.identifier.id)}return this.findGalleryExtensionByName(f.identifier.id)}async findGalleryExtensionById(f){return(await this.galleryService.query({ids:[f],pageSize:1},n.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(f){return(await this.galleryService.query({names:[f],pageSize:1},n.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const f=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${f.length} reported extensions from service`),f}catch(f){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};h=fe([Y(0,P.IExtensionGalleryService),Y(1,w.ITelemetryService),Y(2,S.ILogService)],h),e.AbstractExtensionManagementService=h;function C(I){const f=Array.isArray(I)?I:[I];return f.length===1?f[0]instanceof Error?f[0]:new Error(f[0]):f.reduce((a,c)=>new Error(`${a.message}${a.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}e.joinErrors=C;function D(I,f,a,c,t){const r=t?t instanceof P.ExtensionManagementError?t.code:e.ERROR_UNKNOWN:void 0;I.publicLogError(f,{...a,success:!t,duration:c,errorcode:r})}e.reportTelemetry=D;class b{constructor(){this.barrier=new v.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,v.createCancelablePromise)(f=>this.doRun(f))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,v.createCancelablePromise)(f=>new Promise((a,c)=>{const t=f.onCancellationRequested(()=>{t.dispose(),c((0,y.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=b}),define(Z[177],ee([0,1,11,27,31,26,21,39,70,9,29,10,14,4,28,20,45,6]),function(K,e,p,L,P,k,A,R,S,w,n,y,m,v,h,C,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var I;(function(M){M[M.None=0]="None",M[M.IncludeVersions=1]="IncludeVersions",M[M.IncludeFiles=2]="IncludeFiles",M[M.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",M[M.IncludeSharedAccounts=8]="IncludeSharedAccounts",M[M.IncludeVersionProperties=16]="IncludeVersionProperties",M[M.ExcludeNonValidated=32]="ExcludeNonValidated",M[M.IncludeInstallationTargets=64]="IncludeInstallationTargets",M[M.IncludeAssetUri=128]="IncludeAssetUri",M[M.IncludeStatistics=256]="IncludeStatistics",M[M.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",M[M.Unpublished=4096]="Unpublished"})(I||(I={}));function f(...M){return String(M.reduce((F,j)=>F|j,0))}var a;(function(M){M[M.Tag=1]="Tag",M[M.ExtensionId=4]="ExtensionId",M[M.Category=5]="Category",M[M.ExtensionName=7]="ExtensionName",M[M.Target=8]="Target",M[M.Featured=9]="Featured",M[M.SearchText=10]="SearchText",M[M.ExcludeWithFlags=12]="ExcludeWithFlags"})(a||(a={}));const c={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},t={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},i={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:I.None,criteria:[],assetTypes:[]};class s{constructor(F=i){this.state=F}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(F,j=this.state.pageSize){return new s({...this.state,pageNumber:F,pageSize:j})}withFilter(F,...j){const _=[...this.state.criteria,...j.length?j.map(N=>({filterType:F,value:N})):[{filterType:F}]];return new s({...this.state,criteria:_})}withSortBy(F){return new s({...this.state,sortBy:F})}withSortOrder(F){return new s({...this.state,sortOrder:F})}withFlags(...F){return new s({...this.state,flags:F.reduce((j,_)=>j|_,0)})}withAssetTypes(...F){return new s({...this.state,assetTypes:F})}get raw(){const{criteria:F,pageNumber:j,pageSize:_,sortBy:N,sortOrder:W,flags:x,assetTypes:B}=this.state;return{filters:[{criteria:F,pageNumber:j,pageSize:_,sortBy:N,sortOrder:W}],assetTypes:B,flags:x}}get searchText(){const F=this.state.criteria.filter(j=>j.filterType===a.SearchText)[0];return F&&F.value?F.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(F=>String(F.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function u(M,F){const j=(M||[]).filter(_=>_.statisticName===F)[0];return j?j.value:0}function o(M){const F="Microsoft.VisualStudio.Code.Translation.";return M.files.filter(_=>_.assetType.indexOf(F)===0).reduce((_,N)=>{const W=d(M,N.assetType);return W&&_.push([N.assetType.substring(F.length),W]),_},[])}function l(M){if(M.properties){const F=M.properties.filter(N=>N.key===c.Repository),j=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),_=F.filter(N=>j.test(N.value))[0];return _?{uri:_.value,fallbackUri:_.value}:null}return d(M,c.Repository)}function g(M){return{uri:`${M.fallbackAssetUri}/${c.VSIX}?redirect=true`,fallbackUri:`${M.fallbackAssetUri}/${c.VSIX}`}}function E(M){const F=d(M,c.Icon);if(F)return F;const j=L.DefaultIconPath;return{uri:j,fallbackUri:j}}function d(M,F){return M.files.filter(_=>_.assetType===F)[0]?{uri:`${M.assetUri}/${F}`,fallbackUri:`${M.fallbackAssetUri}/${F}`}:null}function T(M,F){const j=M.properties?M.properties.filter(N=>N.key===F):[],_=j.length>0&&j[0].value;return _?_.split(",").map(N=>(0,P.adoptToGalleryExtensionId)(N)):[]}function O(M){const F=M.properties?M.properties.filter(j=>j.key===t.Engine):[];return F.length>0&&F[0].value||""}function $(M){const F=M.properties?M.properties.filter(_=>_.key===t.LocalizedLanguages):[],j=F.length>0&&F[0].value||"";return j?j.split(","):[]}function z(M){return M.indexOf("preview")!==-1}function G(M,F,j,_,N){const W={manifest:d(F,c.Manifest),readme:d(F,c.Details),changelog:d(F,c.Changelog),license:d(F,c.License),repository:l(F),download:g(F),icon:E(F),coreTranslations:o(F)};return{identifier:{id:(0,P.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},name:M.extensionName,version:F.version,date:F.lastUpdated,displayName:M.displayName,publisherId:M.publisher.publisherId,publisher:M.publisher.publisherName,publisherDisplayName:M.publisher.displayName,description:M.shortDescription||"",installCount:u(M.statistics,"install"),rating:u(M.statistics,"averagerating"),ratingCount:u(M.statistics,"ratingcount"),assetUri:v.URI.parse(F.assetUri),categories:M.categories||[],tags:M.tags||[],releaseDate:Date.parse(M.releaseDate),lastUpdated:Date.parse(M.lastUpdated),webExtension:!!M.tags?.includes(L.WEB_EXTENSION_TAG),assetTypes:F.files.map(({assetType:x})=>x),assets:W,properties:{dependencies:T(F,t.Dependency),extensionPack:T(F,t.ExtensionPack),engine:O(F),localizedLanguages:$(F)},telemetryData:{index:(_.pageNumber-1)*_.pageSize+j,querySource:N},preview:z(M.flags)}}let V=class{constructor(F,j,_,N,W,x,B){this.requestService=F,this.logService=j,this.environmentService=_,this.telemetryService=N,this.fileService=W,this.productService=x;const H=x.extensionsGallery;this.extensionsGalleryUrl=H&&H.serviceUrl,this.extensionsControlUrl=H&&H.controlUrl,this.commonHeadersPromise=U(x.version,this.environmentService,this.fileService,B)}api(F=""){return`${this.extensionsGalleryUrl}${F}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(F,j){const _=[];let{total:N,firstPage:W,getPage:x}=await this.query({names:F,pageSize:F.length},j);_.push(...W);for(let B=1;_.length<N&&(W=await x(B,j),W.length);B++)_.push(...W);return _}async getCompatibleExtension(F,j){return this.getCompatibleExtensionByEngine(F,j)}async getCompatibleExtensionByEngine(F,j){const _=(0,L.isIExtensionIdentifier)(F)?null:F;if(_&&_.properties.engine&&(0,S.isEngineValid)(_.properties.engine,this.productService.version,this.productService.date))return _;const{id:N,uuid:W}=_?_.identifier:F;let x=new s().withFlags(I.IncludeAssetUri,I.IncludeStatistics,I.IncludeCategoryAndTags,I.IncludeFiles,I.IncludeVersionProperties).withPage(1,1).withFilter(a.Target,"Microsoft.VisualStudio.Code");W?x=x.withFilter(a.ExtensionId,W):x=x.withFilter(a.ExtensionName,N);const{galleryExtensions:B}=await this.queryGallery(x,n.CancellationToken.None),[H]=B;if(!H||!H.versions.length)return null;if(j){const Q=H.versions.filter(ie=>ie.version===j)[0];if(Q){const ie=G(H,Q,0,x);if(ie.properties.engine&&(0,S.isEngineValid)(ie.properties.engine,this.productService.version,this.productService.date))return ie}return null}const X=await this.getLastValidExtensionVersion(H,H.versions);return X?G(H,X,0,x):null}async query(F,j){const _=n.CancellationToken.isCancellationToken(F)?{}:F,N=n.CancellationToken.isCancellationToken(F)?F:j;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let W=_.text||"";const x=(0,k.getOrDefault)(_,ne=>ne.pageSize,50);let B=new s().withFlags(I.IncludeLatestVersionOnly,I.IncludeAssetUri,I.IncludeStatistics,I.IncludeCategoryAndTags,I.IncludeFiles,I.IncludeVersionProperties).withPage(1,x).withFilter(a.Target,"Microsoft.VisualStudio.Code");W?(W=W.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ne,le,de)=>(B=B.withFilter(a.Category,de||le),"")),W=W.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ne,le,de)=>(B=B.withFilter(a.Tag,de||le),"")),W=W.replace(/\bfeatured(\s+|\b|$)/g,()=>(B=B.withFilter(a.Featured),"")),W=W.trim(),W&&(W=W.length<200?W:W.substring(0,200),B=B.withFilter(a.SearchText,W)),B=B.withSortBy(0)):_.ids?B=B.withFilter(a.ExtensionId,..._.ids):_.names?B=B.withFilter(a.ExtensionName,..._.names):B=B.withSortBy(4),typeof _.sortBy=="number"&&(B=B.withSortBy(_.sortBy)),typeof _.sortOrder=="number"&&(B=B.withSortOrder(_.sortOrder));const{galleryExtensions:H,total:X}=await this.queryGallery(B,N),Q=H.map((ne,le)=>G(ne,ne.versions[0],le,B,_.source)),ie=async(ne,le)=>{if(le.isCancellationRequested)throw(0,p.canceled)();const de=B.withPage(ne+1),{galleryExtensions:ye}=await this.queryGallery(de,le);return ye.map((pe,De)=>G(pe,pe.versions[0],De,de,_.source))};return{firstPage:Q,total:X,pageSize:B.pageSize,getPage:ie}}async queryGallery(F,j){if(!this.isEnabled())throw new Error("No extension gallery service configured.");F=F.withFlags(F.flags,I.ExcludeNonValidated).withFilter(a.ExcludeWithFlags,f(I.Unpublished));const _=await this.commonHeadersPromise,N=JSON.stringify(F.raw),W={..._,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(N.length)},x=new Date().getTime();let B,H,X=0;try{if(B=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:N,headers:W},j),B.res.statusCode&&B.res.statusCode>=400&&B.res.statusCode<500)return{galleryExtensions:[],total:X};const Q=await(0,R.asJson)(B);if(Q){const ie=Q.results[0],ne=ie.extensions,le=ie.resultMetadata&&ie.resultMetadata.filter(de=>de.metadataType==="ResultCount")[0];return X=le&&le.metadataItems.filter(de=>de.name==="TotalCount")[0].count||0,{galleryExtensions:ne,total:X}}return{galleryExtensions:[],total:X}}catch(Q){throw H=Q,Q}finally{this.telemetryService.publicLog2("galleryService:query",{...F.telemetryData,requestBodySize:String(N.length),duration:new Date().getTime()-x,success:!!B&&(0,R.isSuccess)(B),responseBodySize:B?.res.headers["Content-Length"],statusCode:B?String(B.res.statusCode):void 0,errorCode:H?(0,p.isPromiseCanceledError)(H)?"canceled":(0,p.getErrorMessage)(H).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(X)})}}async reportStatistic(F,j,_,N){if(!this.isEnabled())return;const x={...await this.commonHeadersPromise,Accept:"*/*;api-version=4.0-preview.1"};try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${F}/extensions/${j}/${_}/stats?statType=${N}`),headers:x},n.CancellationToken.None)}catch(B){}}async download(F,j,_){this.logService.trace("ExtensionGalleryService#download",F.identifier.id);const N=(0,P.getGalleryExtensionTelemetryData)(F),W=new Date().getTime(),x=Q=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...N,duration:Q}),B=_===1?"install":_===2?"update":"",H=B?{uri:`${F.assets.download.uri}&${B}=true`,fallbackUri:`${F.assets.download.fallbackUri}?${B}=true`}:F.assets.download,X=await this.getAsset(H);await this.fileService.writeFile(j,X.stream),x(new Date().getTime()-W)}async getReadme(F,j){if(F.assets.readme){const _=await this.getAsset(F.assets.readme,{},j);return await(0,R.asText)(_)||""}return""}async getManifest(F,j){if(F.assets.manifest){const _=await this.getAsset(F.assets.manifest,{},j),N=await(0,R.asText)(_);return N?JSON.parse(N):null}return null}async getCoreTranslation(F,j){const _=F.assets.coreTranslations.filter(N=>N[0]===j.toUpperCase())[0];if(_){const N=await this.getAsset(_[1]),W=await(0,R.asText)(N);return W?JSON.parse(W):null}return null}async getChangelog(F,j){if(F.assets.changelog){const _=await this.getAsset(F.assets.changelog,{},j);return await(0,R.asText)(_)||""}return""}async getAllVersions(F,j){let _=new s().withFlags(I.IncludeVersions,I.IncludeCategoryAndTags,I.IncludeFiles,I.IncludeVersionProperties).withPage(1,1).withFilter(a.Target,"Microsoft.VisualStudio.Code");F.identifier.uuid?_=_.withFilter(a.ExtensionId,F.identifier.uuid):_=_.withFilter(a.ExtensionName,F.identifier.id);const N=[],{galleryExtensions:W}=await this.queryGallery(_,n.CancellationToken.None);return W.length&&(j?await Promise.all(W[0].versions.map(async x=>{let B;try{B=await this.getEngine(x)}catch(H){}B&&(0,S.isEngineValid)(B,this.productService.version,this.productService.date)&&N.push({version:x.version,date:x.lastUpdated})})):N.push(...W[0].versions.map(x=>({version:x.version,date:x.lastUpdated})))),N}async getAsset(F,j={},_=n.CancellationToken.None){const N=await this.commonHeadersPromise,W={type:"GET"},x={...N,...j.headers||{}};j={...j,...W,headers:x};const B=F.uri,H=F.fallbackUri,X={...j,url:B};try{const Q=await this.requestService.request(X,_);if(Q.res.statusCode===200)return Q;const ie=await(0,R.asText)(Q);throw new Error(`Expected 200, got back ${Q.res.statusCode} instead.

${ie}`)}catch(Q){if((0,p.isPromiseCanceledError)(Q))throw Q;const ie=(0,p.getErrorMessage)(Q);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:B,message:ie});const ne={...j,url:H};return this.requestService.request(ne,_)}}async getLastValidExtensionVersion(F,j){const _=this.getLastValidExtensionVersionFromProperties(F,j);return _||this.getLastValidExtensionVersionRecursively(F,j)}getLastValidExtensionVersionFromProperties(F,j){for(const _ of j){const N=O(_);if(!N)return null;if((0,S.isEngineValid)(N,this.productService.version,this.productService.date))return _}return null}async getEngine(F){const j=O(F);if(j)return j;const _=d(F,c.Manifest);if(!_)throw new Error("Manifest was not found");const N={"Accept-Encoding":"gzip"},W=await this.getAsset(_,{headers:N}),x=await(0,R.asJson)(W);if(x)return x.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(F,j){if(!j.length)return null;const _=j[0],N=await this.getEngine(_);return(0,S.isEngineValid)(N,this.productService.version,this.productService.date)?{..._,properties:[..._.properties||[],{key:t.Engine,value:N}]}:this.getLastValidExtensionVersionRecursively(F,j.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const F=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(F.res.statusCode!==200)throw new Error("Could not get extensions report.");const j=await(0,R.asJson)(F),_=new Map;if(j)for(const N of j.malicious){const W=_.get(N)||{id:{id:N},malicious:!0,slow:!1};W.malicious=!0,_.set(N,W)}return[..._.values()]}};V=fe([Y(0,R.IRequestService),Y(1,y.ILogService),Y(2,w.IEnvironmentService),Y(3,A.ITelemetryService),Y(4,m.IFileService),Y(5,h.IProductService),Y(6,(0,b.optional)(C.IStorageService))],V),e.ExtensionGalleryService=V;async function U(M,F,j,_){const N={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M}`},W=await(0,D.getServiceMachineId)(F,j,_);return N["X-Market-User-Id"]=W,N}e.resolveMarketplaceHeaders=U}),define(Z[178],ee([0,1,4,8,28,9,34,14,7,23,27,63,39,10,170,5,21,73,113,20,3,59]),function(K,e,p,L,P,k,A,R,S,w,n,y,m,v,h,C,D,b,I,f,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",r="extensionTips/lastPromptedMediumImpExeTime";let i=class extends h.ExtensionTipsService{constructor(u,o,l,g,E,d,T,O,$,z){super(T,O,$,z);this.environmentService=u,this.telemetryService=o,this.extensionManagementService=l,this.storageService=g,this.nativeHostService=E,this.extensionRecommendationNotificationService=d,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,O.exeBasedExtensionTips&&(0,y.forEach)(O.exeBasedExtensionTips,({key:G,value:V})=>{const U=[],M=[],F=[];(0,y.forEach)(V.recommendations,({key:j,value:_})=>{_.important?V.important?U.push({extensionId:j,extensionName:_.name,isExtensionPack:!!_.isExtensionPack}):M.push({extensionId:j,extensionName:_.name,isExtensionPack:!!_.isExtensionPack}):F.push({extensionId:j,extensionName:_.name,isExtensionPack:!!_.isExtensionPack})}),U.length&&this.highImportanceExecutableTips.set(G,{exeFriendlyName:V.friendlyName,windowsPath:V.windowsPath,recommendations:U}),M.length&&this.mediumImportanceExecutableTips.set(G,{exeFriendlyName:V.friendlyName,windowsPath:V.windowsPath,recommendations:M}),F.length&&this.allOtherExecutableTips.set(G,{exeFriendlyName:V.friendlyName,windowsPath:V.windowsPath,recommendations:F})}),(0,C.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const u=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...u,...o]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const u=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),l=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(u,l),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(o,l)}groupImportantTipsByExe(u,o){const l=new Map;u.forEach(O=>l.set(O.extensionId.toLowerCase(),O));const{installed:g,uninstalled:E}=this.groupByInstalled([...l.keys()],o);for(const O of g){const $=l.get(O);$&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:$.exeName})}for(const O of E){const $=l.get(O);$&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:$.exeName})}const d=this.getPromptedExecutableTips(),T=new Map;for(const O of E){const $=l.get(O);if($&&(!d[$.exeName]||!d[$.exeName].includes($.extensionId))){let z=T.get($.exeName);z||(z=[],T.set($.exeName,z)),z.push($)}}return T}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[u,o]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(l=>{switch(l){case"reacted":this.addToRecommendedExecutables(o[0].exeName,o);break;case"ignored":this.highImportanceTipsByExe.delete(u);break;case"incompatibleWindow":const g=a.Event.once(a.Event.latch(a.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(g(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const E=this._register((0,C.disposableTimeout)(()=>{E.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const u=this.getLastPromptedMediumExeTime(),o=Date.now()-u,l=7*24*60*60*1e3;if(o<l){const d=this._register((0,C.disposableTimeout)(()=>{d.dispose(),this.promptMediumImportanceExeBasedTip()},l-o));return}const[g,E]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(E).then(d=>{switch(d){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(g),this.addToRecommendedExecutables(E[0].exeName,E);const T=this._register((0,C.disposableTimeout)(()=>{T.dispose(),this.promptMediumImportanceExeBasedTip()},l));break;case"ignored":this.mediumImportanceTipsByExe.delete(g),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const O=a.Event.once(a.Event.latch(a.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(O(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const $=this._register((0,C.disposableTimeout)(()=>{$.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(u){const o=u.map(({extensionId:g})=>g.toLowerCase()),l=(0,I.localize)(0,null,u[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(o,l,`@exe:"${u[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let u=this.storageService.getNumber(r,0);return u||(u=Date.now(),this.updateLastPromptedMediumExeTime(u)),u}updateLastPromptedMediumExeTime(u){this.storageService.store(r,u,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(u,o){const l=this.getPromptedExecutableTips();l[u]=o.map(({extensionId:g})=>g.toLowerCase()),this.storageService.store(t,JSON.stringify(l),0,0)}groupByInstalled(u,o){const l=[],g=[],E=o.reduce((d,T)=>(d.add(T.identifier.id.toLowerCase()),d),new Set);return u.forEach(d=>{E.has(d.toLowerCase())?l.push(d):g.push(d)}),{installed:l,uninstalled:g}}async getValidExecutableBasedExtensionTips(u){const o=[],l=new Map;for(const g of u.keys()){const E=u.get(g);if(!E||!(0,w.isNonEmptyArray)(E.recommendations))continue;const d=[];S.isWindows?E.windowsPath&&d.push(E.windowsPath.replace("%USERPROFILE%",A.env.USERPROFILE).replace("%ProgramFiles(x86)%",A.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",A.env.ProgramFiles).replace("%APPDATA%",A.env.APPDATA).replace("%WINDIR%",A.env.WINDIR)):(d.push((0,L.join)("/usr/local/bin",g)),d.push((0,L.join)("/usr/bin",g)),d.push((0,L.join)(this.environmentService.userHome.fsPath,g)));for(const T of d){let O=l.get(T);if(O===void 0&&(O=await this.fileService.exists(p.URI.file(T)),l.set(T,O)),O)for(const{extensionId:$,extensionName:z,isExtensionPack:G}of E.recommendations)o.push({extensionId:$,extensionName:z,isExtensionPack:G,exeName:g,exeFriendlyName:E.exeFriendlyName,windowsPath:E.windowsPath})}}return o}};i=fe([Y(0,k.INativeEnvironmentService),Y(1,D.ITelemetryService),Y(2,n.IExtensionManagementService),Y(3,f.IStorageService),Y(4,c.INativeHostService),Y(5,b.IExtensionRecommendationNotificationService),Y(6,R.IFileService),Y(7,P.IProductService),Y(8,m.IRequestService),Y(9,v.ILogService)],i),e.ExtensionTipsService=i}),define(Z[80],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class p{constructor(k){this.appender=k}listen(k,A){throw new Error(`Event not found: ${A}`)}call(k,A,{eventName:R,data:S}){return this.appender.log(R,S),Promise.resolve(null)}}e.TelemetryAppenderChannel=p;class L{constructor(k){this.channel=k}log(k,A){return this.channel.call("log",{eventName:k,data:A}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(Z[81],ee([0,1,44,123,19,6,24,37,2,26,32]),function(K,e,p,L,P,k,A,R,S,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{constructor(h,C){this._configurationService=C,this._experimentProperties={},this._disposables=new S.DisposableStore,this._cleanupPatterns=[],this._appender=h.appender,this._commonProperties=h.commonProperties||Promise.resolve({}),this._piiPaths=h.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!h.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let D of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,P.escapeRegExpCharacters)(D),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(D=>{const b=/^[a-f0-9]+$/i.test(D["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!b})}))}setExperimentProperty(h,C){this._experimentProperties[h]=C}setEnabled(h){this._enabled=h}_updateUserOptIn(){const h=this._configurationService?.getValue(m);this._userOptIn=h?h.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const h=await this._commonProperties;let C=h.sessionID,D=h["common.instanceId"],b=h["common.machineId"],I=h["common.firstSessionDate"],f=h["common.msftInternal"];return{sessionId:C,instanceId:D,machineId:b,firstSessionDate:I,msftInternal:f}}dispose(){this._disposables.dispose()}publicLog(h,C,D){return this.isOptedIn?this._commonProperties.then(b=>{C=(0,w.mixin)(C,b),C=(0,w.mixin)(C,this._experimentProperties),C=(0,w.cloneAndChange)(C,I=>{if(typeof I=="string")return this._cleanupInfo(I,D)}),this._appender.log(h,C)},b=>{console.error(b)}):Promise.resolve(void 0)}publicLog2(h,C,D){return this.publicLog(h,C,D)}publicLogError(h,C){return this.sendErrorTelemetry?this.publicLog(h,C,!0):Promise.resolve(void 0)}publicLogError2(h,C){return this.publicLogError(h,C)}_cleanupInfo(h,C){let D=h;if(C){const b=[];for(let c of this._cleanupPatterns)for(;;){const t=c.exec(h);if(!t)break;b.push([t.index,c.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,f=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(D="";;){const c=f.exec(h);if(!c)break;!I.test(c[0])&&b.every(([t,r])=>c.index<t||c.index>=r)&&(D+=h.substring(a,c.index)+"<REDACTED: user-file-path>",a=f.lastIndex)}a<h.length&&(D+=h.substr(a))}for(let b of this._cleanupPatterns)D=D.replace(b,"");return D}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=fe([Y(1,(0,k.optional)(A.IConfigurationService))],y),e.TelemetryService=y;const m="telemetry";n.Registry.as(R.Extensions.Configuration).registerConfiguration({id:m,order:110,type:"object",title:(0,L.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:p.default.privacyStatementUrl?(0,L.localize)(2,null,p.default.privacyStatementUrl):(0,L.localize)(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[52],ee([0,1,24,26,16,5]),function(K,e,p,L,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(h,C){return Promise.resolve(void 0)}publicLog2(h,C){return this.publicLog(h,C)}publicLogError(h,C){return Promise.resolve(void 0)}publicLogError2(h,C){return this.publicLogError(h,C)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class A{async publicLog(C,D,b){}async publicLogError(C,D,b){}}e.NullEndpointTelemetryService=A;function R(...h){return{log:(C,D)=>h.forEach(b=>b.log(C,D)),flush:()=>k.Promises.settled(h.map(C=>C.flush())),productIdentifier:h.find(C=>C.productIdentifier!==void 0)?.productIdentifier}}e.combinedAppender=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(h,C){return C.onDidChangeConfiguration(D=>{D.source!==6&&h.publicLog2("updateConfiguration",{configurationSource:(0,p.ConfigurationTargetToString)(D.source),configurationKeys:m(D.sourceConfig)})})}e.configurationTelemetry=S;function w(h){const C=Object.create(null),D=Object.create(null),b=Object.create(null);y(h,b);for(let I in b){I=I.length>150?I.substr(I.length-149):I;const f=b[I];typeof f=="number"?D[I]=f:typeof f=="boolean"?D[I]=f?1:0:typeof f=="string"?C[I]=f.substring(0,1023):typeof f!="undefined"&&f!==null&&(C[I]=f)}return{properties:C,measurements:D}}e.validateTelemetryData=w;function n(h){if(!h)return"none";let C="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(b=>{h.indexOf(`${b}+`)===0&&(C=b)}),C}e.cleanRemoteAuthority=n;function y(h,C,D=0,b){if(!!h)for(let I of Object.getOwnPropertyNames(h)){const f=h[I],a=b?b+I:I;Array.isArray(f)?C[a]=(0,L.safeStringify)(f):f instanceof Date?C[a]=f.toISOString():(0,P.isObject)(f)?D<2?y(f,C,D+1,a+"."):C[a]=(0,L.safeStringify)(f):C[a]=f}}function m(h){if(!h)return[];const C=[];return v(C,"",h),C}function v(h,C,D){D&&typeof D=="object"&&!Array.isArray(D)?Object.keys(D).forEach(b=>v(h,C?`${C}.${b}`:b,D[b])):h.push(C)}}),define(Z[82],ee([0,1,2,9,10,52]),function(K,e,p,L,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends p.Disposable{constructor(S,w,n=""){super();this.prefix=n;const y=S.getLogger(w.telemetryLogResource);y?this.logger=this._register(y):(this.logger=this._register(S.createLogger(w.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(S,w){this.logger.trace(`${this.prefix}telemetry/${S}`,(0,k.validateTelemetryData)(w))}};A=fe([Y(0,P.ILoggerService),Y(1,L.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(Z[179],ee([0,1,11,26,52]),function(K,e,p,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function k(R){const S=await new Promise((n,y)=>{K(["applicationinsights"],n,y)});let w;return S.defaultClient?(w=new S.TelemetryClient(R),w.channel.setUseDiskRetryCaching(!0)):(S.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),w=S.defaultClient),R.indexOf("AIF-")===0&&(w.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),w}class A{constructor(S,w,n){this._eventPrefix=S,this._defaultData=w,this._defaultData||(this._defaultData=Object.create(null)),typeof n=="function"?this._aiClient=n():this._aiClient=n,this._asyncAIClient=null}_withAIClient(S){if(!!this._aiClient){if(typeof this._aiClient!="string"){S(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=k(this._aiClient)),this._asyncAIClient.then(w=>{S(w)},w=>{(0,p.onUnexpectedError)(w),console.error(w)})}}log(S,w){!this._aiClient||(w=(0,L.mixin)(w,this._defaultData),w=(0,P.validateTelemetryData)(w),this._withAIClient(n=>n.trackEvent({name:this._eventPrefix+"/"+S,properties:w.properties,measurements:w.measurements})))}flush(){return this._aiClient?new Promise(S=>{this._withAIClient(w=>{w.flush({callback:()=>{this._aiClient=void 0,S(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=A}),define(Z[180],ee([0,1,50,80,17,81,24,21,52,9,10,82]),function(K,e,p,L,P,k,A,R,S,w,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let m=class{constructor(h,C,D,b){this.configurationService=h,this.telemetryService=C,this.loggerService=D,this.environmentService=b,this.customTelemetryServices=new Map}async getCustomTelemetryService(h){if(!this.customTelemetryServices.has(h.id)){const{machineId:C,sessionId:D}=await this.telemetryService.getTelemetryInfo(),b=Object.create(null);b["common.vscodemachineid"]=C,b["common.vscodesessionid"]=D;const I=[h.id,JSON.stringify(b),h.aiKey],a=new p.Client(P.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:I,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),c=(0,S.combinedAppender)(new L.TelemetryAppenderClient(a),new y.TelemetryLogAppender(this.loggerService,this.environmentService,`[${h.id}] `));this.customTelemetryServices.set(h.id,new k.TelemetryService({appender:c,sendErrorTelemetry:h.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(h.id)}async publicLog(h,C,D){await(await this.getCustomTelemetryService(h)).publicLog(C,D)}async publicLogError(h,C,D){await(await this.getCustomTelemetryService(h)).publicLogError(C,D)}};m=fe([Y(0,A.IConfigurationService),Y(1,R.ITelemetryService),Y(2,n.ILoggerService),Y(3,w.IEnvironmentService)],m),e.CustomEndpointTelemetryService=m}),define(Z[181],ee([0,1,5,29,3,2,10]),function(K,e,p,L,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends k.Disposable{constructor(w,n){super();this._logService=n,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new P.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=w===void 0?15e3:w}createRequest(w){return new Promise((n,y)=>{const m=++this._lastRequestId;this._pendingRequests.set(m,n),this._onCreateRequest.fire({requestId:m,...w});const v=new L.CancellationTokenSource;(0,p.timeout)(this._timeout,v.token).then(()=>y(`Request ${m} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(m,[(0,k.toDisposable)(()=>v.cancel())])})}acceptReply(w,n){const y=this._pendingRequests.get(w);y?(this._pendingRequests.delete(w),(0,k.dispose)(this._pendingRequestDisposables.get(w)||[]),this._pendingRequestDisposables.delete(w),y(n)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${w}`)}};R=fe([Y(1,A.ILogService)],R),e.RequestStore=R}),define(Z[83],ee([0,1,6]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var L;(function(v){v.Shell="terminal.integrated.shell.",v.ShellArgs="terminal.integrated.shellArgs.",v.DefaultProfile="terminal.integrated.defaultProfile.",v.Profiles="terminal.integrated.profiles."})(L=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var P;(function(v){v.ShellLinux="terminal.integrated.shell.linux",v.ShellMacOs="terminal.integrated.shell.osx",v.ShellWindows="terminal.integrated.shell.windows",v.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",v.AutomationShellLinux="terminal.integrated.automationShell.linux",v.AutomationShellMacOs="terminal.integrated.automationShell.osx",v.AutomationShellWindows="terminal.integrated.automationShell.windows",v.ShellArgsLinux="terminal.integrated.shellArgs.linux",v.ShellArgsMacOs="terminal.integrated.shellArgs.osx",v.ShellArgsWindows="terminal.integrated.shellArgs.windows",v.ProfilesWindows="terminal.integrated.profiles.windows",v.ProfilesMacOs="terminal.integrated.profiles.osx",v.ProfilesLinux="terminal.integrated.profiles.linux",v.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",v.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",v.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",v.UseWslProfiles="terminal.integrated.useWslProfiles",v.TabsEnabled="terminal.integrated.tabs.enabled",v.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",v.TabsHideCondition="terminal.integrated.tabs.hideCondition",v.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",v.TabsShowActions="terminal.integrated.tabs.showActions",v.TabsLocation="terminal.integrated.tabs.location",v.TabsFocusMode="terminal.integrated.tabs.focusMode",v.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",v.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",v.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",v.CopyOnSelection="terminal.integrated.copyOnSelection",v.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",v.FontFamily="terminal.integrated.fontFamily",v.FontSize="terminal.integrated.fontSize",v.LetterSpacing="terminal.integrated.letterSpacing",v.LineHeight="terminal.integrated.lineHeight",v.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",v.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",v.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",v.BellDuration="terminal.integrated.bellDuration",v.FontWeight="terminal.integrated.fontWeight",v.FontWeightBold="terminal.integrated.fontWeightBold",v.CursorBlinking="terminal.integrated.cursorBlinking",v.CursorStyle="terminal.integrated.cursorStyle",v.CursorWidth="terminal.integrated.cursorWidth",v.Scrollback="terminal.integrated.scrollback",v.DetectLocale="terminal.integrated.detectLocale",v.DefaultLocation="terminal.integrated.defaultLocation",v.GpuAcceleration="terminal.integrated.gpuAcceleration",v.RightClickBehavior="terminal.integrated.rightClickBehavior",v.Cwd="terminal.integrated.cwd",v.ConfirmOnExit="terminal.integrated.confirmOnExit",v.ConfirmOnKill="terminal.integrated.confirmOnKill",v.EnableBell="terminal.integrated.enableBell",v.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",v.AllowChords="terminal.integrated.allowChords",v.AllowMnemonics="terminal.integrated.allowMnemonics",v.EnvMacOs="terminal.integrated.env.osx",v.EnvLinux="terminal.integrated.env.linux",v.EnvWindows="terminal.integrated.env.windows",v.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",v.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",v.ShowExitAlert="terminal.integrated.showExitAlert",v.SplitCwd="terminal.integrated.splitCwd",v.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",v.WordSeparators="terminal.integrated.wordSeparators",v.TitleMode="terminal.integrated.titleMode",v.EnableFileLinks="terminal.integrated.enableFileLinks",v.UnicodeVersion="terminal.integrated.unicodeVersion",v.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",v.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",v.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",v.LocalEchoStyle="terminal.integrated.localEchoStyle",v.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",v.InheritEnv="terminal.integrated.inheritEnv",v.ShowLinkHover="terminal.integrated.showLinkHover"})(P=e.TerminalSettingId||(e.TerminalSettingId={}));var k;(function(v){v.CommandPrompt="cmd",v.PowerShell="pwsh",v.Wsl="wsl",v.GitBash="gitbash"})(k=e.WindowsShellType||(e.WindowsShellType={}));var A;(function(v){v[v.Api=0]="Api",v[v.Process=1]="Process",v[v.Sequence=2]="Sequence"})(A=e.TitleEventSource||(e.TitleEventSource={}));var R;(function(v){v.LocalPty="localPty",v.PtyHost="ptyHost",v.Log="log",v.Heartbeat="heartbeat"})(R=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,p.createDecorator)("ptyService");var S;(function(v){v[v.BeatInterval=5e3]="BeatInterval",v[v.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",v[v.SecondWaitMultiplier=1]="SecondWaitMultiplier",v[v.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(S=e.HeartbeatConstants||(e.HeartbeatConstants={}));var w;(function(v){v.TerminalView="view",v.Editor="editor"})(w=e.TerminalLocation||(e.TerminalLocation={}));var n;(function(v){v[v.GraceTime=6e4]="GraceTime",v[v.ShortGraceTime=6e3]="ShortGraceTime"})(n=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var y;(function(v){v[v.HighWatermarkChars=1e5]="HighWatermarkChars",v[v.LowWatermarkChars=5e3]="LowWatermarkChars",v[v.CharCountAckSize=5e3]="CharCountAckSize"})(y=e.FlowControlConstants||(e.FlowControlConstants={}));var m;(function(v){v.GitBash="Git Bash",v.Pwsh="PowerShell"})(m=e.ProfileSource||(e.ProfileSource={}))}),define(Z[182],ee([0,1,6]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,p.createDecorator)("localPtyService")}),define(Z[183],ee([0,1,35,8,34,18,16,26,7]),function(K,e,p,L,P,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function w(){const y=/(\d+)\.(\d+)\.(\d+)/g.exec(p.release());let m=0;return y&&y.length===4&&(m=parseInt(y[3])),m}e.getWindowsBuildNumber=w;async function n(y,m,v,h=P.env,C=k.Promises.exists){if(L.isAbsolute(y))return await C(y)?y:void 0;if(m===void 0&&(m=P.cwd()),L.dirname(y)!=="."){const f=L.join(m,y);return await C(f)?f:void 0}const b=(0,R.getCaseInsensitive)(h,"PATH");if(v===void 0&&(0,A.isString)(b)&&(v=b.split(L.delimiter)),v===void 0||v.length===0){const f=L.join(m,y);return await C(f)?f:void 0}for(let f of v){let a;if(L.isAbsolute(f)?a=L.join(f,y):a=L.join(m,f,y),await C(a))return a;if(S.isWindows){let c=a+".com";if(await C(c)||(c=a+".exe",await C(c)))return c}}const I=L.join(m,y);return await C(I)?I:void 0}e.findExecutable=n}),define(Z[184],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var p;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(p=e.ColorScheme||(e.ColorScheme={}))}),define(Z[84],ee([0,1,6,2,32,3,184,55]),function(K,e,p,L,P,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,p.createDecorator)("themeService");var S;(function(D){function b(I){return I&&typeof I=="object"&&typeof I.id=="string"}D.isThemeColor=b})(S=e.ThemeColor||(e.ThemeColor={}));function w(D){return{id:D}}e.themeColorFromId=w;var n;(function(D){function b(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||S.isThemeColor(r.color))}D.isThemeIcon=b;const I=new RegExp(`^\\$\\((${R.CSSIcon.iconNameExpression}(?:${R.CSSIcon.iconModifierExpression})?)\\)$`);function f(r){const i=I.exec(r);if(!i)return;let[,s]=i;return{id:s}}D.fromString=f;function a(r,i){let s=r.id;const u=s.lastIndexOf("~");return u!==-1&&(s=s.substring(0,u)),i&&(s=`${s}~${i}`),{id:s}}D.modify=a;function c(r,i){return r.id===i.id&&r.color?.id===i.color?.id}D.isEqual=c;function t(r,i){return{id:r.id,color:i?w(i):void 0}}D.asThemeIcon=t,D.asClassNameArray=R.CSSIcon.asClassNameArray,D.asClassName=R.CSSIcon.asClassName,D.asCSSSelector=R.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=R.Codicon.file,e.FolderThemeIcon=R.Codicon.folder;function y(D){switch(D){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=y,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new k.Emitter}onColorThemeChange(b){return this.themingParticipants.push(b),this.onThemingParticipantAddedEmitter.fire(b),(0,L.toDisposable)(()=>{const I=this.themingParticipants.indexOf(b);this.themingParticipants.splice(I,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let v=new m;P.Registry.add(e.Extensions.ThemingContribution,v);function h(D){return v.onColorThemeChange(D)}e.registerThemingParticipant=h;class C extends L.Disposable{constructor(b){super();this.themeService=b,this.theme=b.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(I=>this.onThemeChange(I)))}onThemeChange(b){this.theme=b,this.updateStyles()}updateStyles(){}getColor(b,I){let f=this.theme.getColor(b);return f&&I&&(f=I(f,this.theme)),f?f.toString():null}}e.Themable=C}),define(Z[185],ee([0,1,37,124,32,55,84]),function(K,e,p,L,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const R={args:{description:(0,L.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,L.localize)(1,null),type:"boolean"},icon:{description:(0,L.localize)(2,null),type:"string",enum:Array.from(k.iconRegistry.all,b=>b.id),markdownEnumDescriptions:Array.from(k.iconRegistry.all,b=>`$(${b.id})`)},color:{description:(0,L.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,L.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},S={type:"object",required:["path"],properties:{path:{description:(0,L.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},w=(0,L.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),n=(0,L.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),y=(0,L.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),m={id:"terminal",order:100,title:(0,L.localize)(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(13,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(14,null),type:["string","null"],default:null,markdownDeprecationMessage:n},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(15,null),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:w},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:n},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,L.localize)(19,null)}},{type:"string",markdownDescription:(0,L.localize)(20,null)}],default:[],markdownDeprecationMessage:y},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,L.localize)(22,null),enum:["PowerShell","Git Bash"]},...R}},{type:"null"},S]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(23,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"null"},S]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(24,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"null"},S]}},["terminal.integrated.useWslProfiles"]:{description:(0,L.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,L.localize)(26,null),type:"boolean",default:!0},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,L.localize)(27,null),type:"boolean",default:!0}}};function v(){P.Registry.as(p.Extensions.Configuration).registerConfiguration(m),C()}e.registerTerminalPlatformConfiguration=v;let h;function C(b){const I=P.Registry.as(p.Extensions.Configuration);h&&I.deregisterConfigurations([h]);let f,a;if(b){const c=b.profiles.map(t=>({name:t.profileName,description:D(t)}));f=c.map(t=>t.name),a=c.map(t=>t.description)}h={id:"terminal",order:100,title:(0,L.localize)(28,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(29,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:b?.os===3?f:void 0,markdownEnumDescriptions:b?.os===3?a:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(30,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:b?.os===2?f:void 0,markdownEnumDescriptions:b?.os===2?a:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(31,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:b?.os===1?f:void 0,markdownEnumDescriptions:b?.os===1?a:void 0}}},I.registerConfiguration(h)}e.registerTerminalDefaultProfileConfiguration=C;function D(b){let I=`$(${A.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:k.Codicon.terminal.id}) ${b.profileName}
- path: ${b.path}`;return b.args&&(typeof b.args=="string"?I+=`
- args: "${b.args}"`:I+=`
- args: [${b.args.length===0?"":b.args.join("','")}]`),b.overrideName!==void 0&&(I+=`
- overrideName: ${b.overrideName}`),b.color&&(I+=`
- color: ${b.color}`),b.env&&(I+=`
- env: ${JSON.stringify(b.env)}`),I}}),define(Z[186],ee([0,1,8,98,183,42,18,55,7,84]),function(K,e,p,L,P,k,A,R,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let n;function y(t,r,i,s,u,o,l,g){return u=u||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},S.isWindows?m(i,u,o,s.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:s.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:s.getValue("terminal.integrated.defaultProfile.windows"),g,l):f(u,o,i,t&&typeof t=="object"?{...t}:s.getValue(S.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:s.getValue(S.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),g,l)}e.detectAvailableProfiles=y;async function m(t,r,i,s,u,o,l,g){const E=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),d=`${process.env.windir}\\${E?"Sysnative":"System32"}`;let T=!1;(0,P.getWindowsBuildNumber)()>=16299&&(T=!0),await C(l);const O=new Map;t&&(O.set("PowerShell",{source:"PowerShell",icon:R.Codicon.terminalPowershell,isAutoDetected:!0}),O.set("Windows PowerShell",{path:`${d}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:R.Codicon.terminalPowershell,isAutoDetected:!0}),O.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),O.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),O.set("Command Prompt",{path:`${d}\\cmd.exe`,icon:R.Codicon.terminalCmd,isAutoDetected:!0})),a(u,O);const $=await v(O.entries(),o,r,i,g);if(t||!t&&s)try{const z=await b(`${d}\\${T?"wsl":"bash"}.exe`,o);for(const G of z)(!u||!(G.profileName in u))&&$.push(G)}catch(z){i?.info("WSL is not installed, so could not detect WSL profiles")}return $}async function v(t,r,i,s,u){const o=[];for(const[l,g]of t){if(g===null)continue;let E,d,T;if("source"in g){const z=n?.get(g.source);if(!z)continue;E=z.paths,d=g.args||z.args,g.icon?T=h(g.icon):z.icon&&(T=z.icon)}else E=Array.isArray(g.path)?g.path:[g.path],d=S.isWindows||Array.isArray(g.args)?g.args:void 0,T=h(g.icon)||void 0;const O=await u?.(E)||E.slice(),$=await c(l,r,O,i,d,g.env,g.overrideName,g.isAutoDetected,s);$?($.isAutoDetected=g.isAutoDetected,$.icon=T,$.color=g.color,o.push($)):s?.trace("profile not validated",l,E)}return o}function h(t){return typeof t=="string"?{id:t}:t}async function C(t){n&&!t||(n=new Map,n.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),n.set("PowerShell",{profileName:"PowerShell",paths:t||await D(),icon:w.ThemeIcon.asThemeIcon(R.Codicon.terminalPowershell)}))}async function D(){const t=[];for await(const r of(0,L.enumeratePowerShellInstallations)())t.push(r.exePath);return t}async function b(t,r){const i=[],s=await new Promise((l,g)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le"},(E,d)=>{if(E)return g("Problem occurred when getting wsl distros");l(d)})});if(!s)return[];const u=new RegExp(/[\r?\n]/),o=s.split(u).filter(l=>l.trim().length>0&&l!=="");for(const l of o){if(l===""||l.startsWith("docker-desktop"))continue;const g=`${l} (WSL)`,E={profileName:g,path:t,args:["-d",`${l}`],isDefault:g===r,icon:I(l)};i.push(E)}return i}function I(t){return t.includes("Ubuntu")?w.ThemeIcon.asThemeIcon(R.Codicon.terminalUbuntu):t.includes("Debian")?w.ThemeIcon.asThemeIcon(R.Codicon.terminalDebian):w.ThemeIcon.asThemeIcon(R.Codicon.terminalLinux)}async function f(t,r,i,s,u,o,l){const g=new Map;if(i){const E=(await t.readFile("/etc/shells")).toString(),d=o||E.split(`
`).filter(O=>O.trim().indexOf("#")!==0&&O.trim().length>0),T=new Map;for(const O of d){let $=(0,p.basename)(O),z=T.get($)||0;z++,z>1&&($=`${$} (${z})`),T.set($,z),g.set($,{path:O,isAutoDetected:!0})}}return a(s,g),await v(g.entries(),u,t,r,l)}function a(t,r){if(!!t)for(const[i,s]of Object.entries(t))s===null||!("path"in s)&&!("source"in s)?r.delete(i):r.set(i,s)}async function c(t,r,i,s,u,o,l,g,E){if(i.length===0)return Promise.resolve(void 0);const d=i.shift();if(d==="")return c(t,r,i,s,u,o,l,g);const T={profileName:t,path:d,args:u,env:o,overrideName:l,isAutoDetected:g,isDefault:t===r};if((0,p.basename)(d)===d){const $=process.env.PATH?process.env.PATH.split(p.delimiter):void 0;return await(0,P.findExecutable)(d,void 0,$,void 0,s.existsFile)?T:c(t,r,i,s,u)}return await s.existsFile((0,p.normalize)(d))?T:c(t,r,i,s,u,o,l,g)}}),define(Z[187],ee([0,1,2,10,83,50,17,36,3,77,21,186,24,185,181]),function(K,e,p,L,P,k,A,R,S,w,n,y,m,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var C;(function(I){I[I.MaxRestarts=5]="MaxRestarts"})(C||(C={}));let D=0,b=class extends p.Disposable{constructor(f,a,c,t){super();this._reconnectConstants=f,this._configurationService=a,this._logService=c,this._telemetryService=t,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new S.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new S.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new S.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new S.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new S.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new S.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new S.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new S.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new S.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new S.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new S.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new S.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new S.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new S.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new S.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onProcessDidChangeHasChildProcesses=this._register(new S.Emitter),this.onProcessDidChangeHasChildProcesses=this._onProcessDidChangeHasChildProcesses.event,(0,v.registerTerminalPlatformConfiguration)(),this._register((0,p.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new h.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const f=new k.Client(A.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:D,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.GraceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.ShortGraceTime}});this._onPtyHostStart.fire(),R.ProxyChannel.toService(f.getChannel(P.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(f.onDidProcessExit(r=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(r.code),this._isDisposed||(this._restartCount<=C.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}, giving up`))}));const c=f.getChannel(P.TerminalIpcChannels.Log);w.LogLevelChannelClient.setLevel(c,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{w.LogLevelChannelClient.setLevel(c,this._logService.getLevel())}));const t=R.ProxyChannel.toService(f.getChannel(P.TerminalIpcChannels.PtyHost));return this._register(t.onProcessData(r=>this._onProcessData.fire(r))),this._register(t.onProcessExit(r=>this._onProcessExit.fire(r))),this._register(t.onProcessReady(r=>this._onProcessReady.fire(r))),this._register(t.onProcessTitleChanged(r=>this._onProcessTitleChanged.fire(r))),this._register(t.onProcessShellTypeChanged(r=>this._onProcessShellTypeChanged.fire(r))),this._register(t.onProcessOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r))),this._register(t.onProcessResolvedShellLaunchConfig(r=>this._onProcessResolvedShellLaunchConfig.fire(r))),this._register(t.onProcessDidChangeHasChildProcesses(r=>this._onProcessDidChangeHasChildProcesses.fire(r))),this._register(t.onProcessReplay(r=>this._onProcessReplay.fire(r))),this._register(t.onProcessOrphanQuestion(r=>this._onProcessOrphanQuestion.fire(r))),this._register(t.onDidRequestDetach(r=>this._onDidRequestDetach.fire(r))),[f,t]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(f,a,c,t,r,i,s,u,o,l){const g=setTimeout(()=>this._handleUnresponsiveCreateProcess(),P.HeartbeatConstants.CreateProcessTimeout),E=await this._proxy.createProcess(f,a,c,t,r,i,s,u,o,l);return clearTimeout(g),D=Math.max(D,E),E}updateTitle(f,a,c){return this._proxy.updateTitle(f,a,c)}updateIcon(f,a,c){return this._proxy.updateIcon(f,a,c)}attachToProcess(f){return this._proxy.attachToProcess(f)}detachFromProcess(f){return this._proxy.detachFromProcess(f)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(f){return this._proxy.start(f)}shutdown(f,a){return this._proxy.shutdown(f,a)}input(f,a){return this._proxy.input(f,a)}processBinary(f,a){return this._proxy.processBinary(f,a)}resize(f,a,c){return this._proxy.resize(f,a,c)}acknowledgeDataEvent(f,a){return this._proxy.acknowledgeDataEvent(f,a)}getInitialCwd(f){return this._proxy.getInitialCwd(f)}getCwd(f){return this._proxy.getCwd(f)}getLatency(f){return this._proxy.getLatency(f)}orphanQuestionReply(f){return this._proxy.orphanQuestionReply(f)}getDefaultSystemShell(f){return this._proxy.getDefaultSystemShell(f)}async getProfiles(f,a,c,t=!1){return(0,y.detectAvailableProfiles)(a,c,t,this._configurationService,void 0,this._logService,this._resolveVariables.bind(this,f))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(f){return this._proxy.getWslPath(f)}setTerminalLayoutInfo(f){return this._proxy.setTerminalLayoutInfo(f)}async getTerminalLayoutInfo(f){return await this._proxy.getTerminalLayoutInfo(f)}async requestDetachInstance(f,a){return this._proxy.requestDetachInstance(f,a)}async acceptDetachInstanceReply(f,a){return this._proxy.acceptDetachInstanceReply(f,a)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),P.HeartbeatConstants.BeatInterval*P.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${P.HeartbeatConstants.BeatInterval*P.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),P.HeartbeatConstants.BeatInterval*P.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(P.HeartbeatConstants.BeatInterval*P.HeartbeatConstants.FirstWaitMultiplier+P.HeartbeatConstants.BeatInterval*P.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${P.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(f,a){return this._resolveVariablesRequestStore.createRequest({workspaceId:f,originalText:a})}async acceptPtyHostResolvedVariables(f,a){this._resolveVariablesRequestStore.acceptReply(f,a)}};b=fe([Y(1,m.IConfigurationService),Y(2,L.ILogService),Y(3,n.ITelemetryService)],b),e.PtyHostService=b}),define(Z[53],ee([0,1,40]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function L(A,R,S,w){const n=(0,p.setProperty)(A,R,S,w)[0];return n&&(A=A.substring(0,n.offset)+n.content+A.substring(n.offset+n.length)),A}e.edit=L;function P(A,R,S){let w=S;for(;w>=0;){if(A.charAt(w)===R.charAt(R.length-1)&&R.length===1)return w+1;if(w--,R.length===2&&w>=0&&A.charAt(w)===R.charAt(0))return w+2}return 0}e.getLineStartOffset=P;function k(A,R,S){let w=S;for(;w>=0;)if(A.charAt(w)===R.charAt(R.length-1)&&R.length===1||(w++,R.length===2&&w>=0&&A.charAt(w)===R.charAt(1)))return w;return A.length-1}e.getLineEndOffset=k}),define(Z[188],ee([0,1,26,58]),function(K,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function P(y,m,v,h,C){const D=[],b=[],I=[];if(!m){const T=y.filter(({identifier:O})=>C.every($=>$.toLowerCase()!==O.id.toLowerCase()));return{local:{added:D,removed:b,updated:I},remote:T.length>0?{added:T,updated:[],removed:[],all:T}:null}}y=y.map(w),m=m.map(w),v=v?v.map(w):null;const f=new Map,a=T=>{T.uuid&&f.set(T.id.toLowerCase(),T.uuid)};y.forEach(({identifier:T})=>a(T)),m.forEach(({identifier:T})=>a(T)),v&&v.forEach(({identifier:T})=>a(T));const c=T=>{const O=T.identifier.uuid||f.get(T.identifier.id.toLowerCase());return O?`uuid:${O}`:`id:${T.identifier.id.toLowerCase()}`},t=(T,O)=>(T.set(c(O),O),T),r=y.reduce(t,new Map),i=m.reduce(t,new Map),s=m.reduce((T,O)=>{const $=c(O);O=(0,p.deepClone)(O);const z=r.get($);return z&&(z.installed&&(O.installed=!0),O.version||(O.version=z.version)),t(T,O)},new Map),u=v?v.reduce(t,new Map):null,o=h.reduce(t,new Map),l=C.reduce((T,O)=>{const $=f.get(O.toLowerCase());return T.add($?`uuid:${$}`:`id:${O.toLowerCase()}`)},new Set),g=k(r,i,l);if(g.added.size>0||g.removed.size>0||g.updated.size>0){const T=k(u,r,l),O=k(u,i,l),$=(z,G)=>{const V=r.get(z);if(V){const U=i.get(z);return{...G?U:V,version:(U.version&&L.gt(U.version,V.version),V.version),state:A(V,U,u?.get(z))}}};for(const z of O.removed.values()){const G=r.get(z);G&&b.push(G.identifier)}for(const z of O.added.values())if(T.added.has(z)){if(g.updated.has(z)){const G=$(z,!0);G&&(I.push(n(G,z)),s.set(z,G))}}else{const G=i.get(z);G.installed&&D.push(n(G,z))}for(const z of O.updated.values()){const G=$(z,!0);G&&(I.push(n(G,z)),s.set(z,G))}for(const z of T.added.values())O.added.has(z)||s.set(z,r.get(z));for(const z of T.updated.values())if(!O.removed.has(z)&&!O.updated.has(z)){const G=$(z,!1);G&&(s.get(z)?.installed&&(G.installed=!0),s.set(z,G))}for(const z of T.removed.values())!o.has(z)&&!O.updated.has(z)&&u?.get(z)?.installed&&s.delete(z)}const E=[],d=k(i,s,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(d.added.size>0||d.updated.size>0||d.removed.size>0)&&s.forEach((T,O)=>E.push(n(T,O))),{local:{added:D,removed:b,updated:I},remote:E.length?{added:[...d.added].map(T=>s.get(T)),updated:[...d.updated].map(T=>s.get(T)),removed:[...d.removed].map(T=>i.get(T)),all:E}:null}}e.merge=P;function k(y,m,v,{checkInstalledProperty:h,checkVersionProperty:C}={checkInstalledProperty:!1,checkVersionProperty:!1}){const D=y?[...y.keys()].filter(c=>!v.has(c)):[],b=[...m.keys()].filter(c=>!v.has(c)),I=b.filter(c=>D.indexOf(c)===-1).reduce((c,t)=>(c.add(t),c),new Set),f=D.filter(c=>b.indexOf(c)===-1).reduce((c,t)=>(c.add(t),c),new Set),a=new Set;for(const c of D){if(f.has(c))continue;const t=y.get(c),r=m.get(c);(!r||t.disabled!==r.disabled||!S(t.state,r.state)||C&&t.version!==r.version||h&&t.installed!==r.installed)&&a.add(c)}return{added:I,removed:f,updated:a}}function A(y,m,v){const h=y.state,C=m.state,D=v?.state;if(!m.version||h&&L.gt(y.version,m.version))return h;if(C&&L.gt(m.version,y.version)||!h)return C;if(!C)return h;const b=(0,p.deepClone)(h),I=D?R(D,C):{added:Object.keys(C).reduce((a,c)=>(a.add(c),a),new Set),removed:new Set,updated:new Set},f=D?R(D,h):{added:Object.keys(h).reduce((a,c)=>(a.add(c),a),new Set),removed:new Set,updated:new Set};for(const a of[...I.added.values(),...I.updated.values()])b[a]=C[a];for(const a of I.removed.values())f.updated.has(a)||delete b[a];return b}function R(y,m){const v=Object.keys(y),h=Object.keys(m),C=h.filter(I=>v.indexOf(I)===-1).reduce((I,f)=>(I.add(f),I),new Set),D=v.filter(I=>h.indexOf(I)===-1).reduce((I,f)=>(I.add(f),I),new Set),b=new Set;for(const I of v){if(D.has(I))continue;const f=y[I],a=m[I];(0,p.equals)(f,a)||b.add(I)}return{added:C,removed:D,updated:b}}function S(y={},m={}){const{added:v,removed:h,updated:C}=R(y,m);return v.size===0&&h.size===0&&C.size===0}function w(y){return{...y,disabled:!!y.disabled,installed:!!y.installed}}function n(y,m){const v={identifier:{id:y.identifier.id,uuid:m.startsWith("uuid:")?m.substring("uuid:".length):void 0}};return y.version&&(v.version=y.version),y.disabled&&(v.disabled=!0),y.installed&&(v.installed=!0),y.state&&(v.state=y.state),v}}),define(Z[85],ee([0,1,23,3,2,31,6,28,20]),function(K,e,p,L,P,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,A.createDecorator)("IExtensionsStorageSyncService");const w=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let n=class Ze extends P.Disposable{constructor(m,v){super();this.storageService=m,this.productService=v,this._onDidChangeExtensionsStorage=this._register(new L.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}static toKey(m){return`extensionKeys/${(0,k.adoptToGalleryExtensionId)(m.id)}@${m.version}`}static fromKey(m){const v=w.exec(m);if(v&&v[1])return{id:v[1],version:v[2]}}initialize(){const m=this.storageService.keys(0,1);for(const v of m){const h=Ze.fromKey(v);h&&this.extensionsWithKeysForSync.add(h.id.toLowerCase())}}onDidChangeStorageValue(m){if(m.scope!==0)return;if(this.extensionsWithKeysForSync.has(m.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const v=Ze.fromKey(m.key);if(v){this.extensionsWithKeysForSync.add(v.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(m,v){this.storageService.store(Ze.toKey(m),JSON.stringify(v),0,1)}getKeysForSync(m){const v=this.productService.extensionSyncedKeys?.[m.id.toLowerCase()],h=this.storageService.get(Ze.toKey(m),0),C=h?JSON.parse(h):void 0;return C&&v?(0,p.distinct)([...C,...v]):C||v}};n=fe([Y(0,S.IStorageService),Y(1,R.IProductService)],n),e.ExtensionsStorageSyncService=n}),define(Z[86],ee([0,1,23,24,6]),function(K,e,p,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,P.createDecorator)("IIgnoredExtensionsManagementService");let k=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,S){let w=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return w=w.filter(n=>n!==R&&n!==`-${R}`),S&&w.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,1)}updateSynchronizedExtensions(R,S){let w=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return w=w.filter(n=>n!==R&&n!==`-${R}`),S&&w.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,1)}getIgnoredExtensions(R){const S=R.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),w=this.getConfiguredIgnoredExtensions().map(m=>m.toLowerCase()),n=[],y=[];if(Array.isArray(w))for(const m of w)m.startsWith("-")?y.push(m.substring(1)):n.push(m);return(0,p.distinct)([...S,...n].filter(m=>y.indexOf(m)===-1))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(S=>S.toLowerCase())}};k=fe([Y(0,L.IConfigurationService)],k),e.IgnoredExtensionsManagementService=k}),define(Z[189],ee([0,1,26,33,23,145,53]),function(K,e,p,L,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function R(a){return(0,L.parse)(a)||[]}e.parseKeybindings=R;async function S(a,c,t,r,i){const s=R(a),u=R(c),o=t?R(t):null,l=[...s,...u,...o||[]].map(M=>M.key),g=await i.resolveUserBindings(l);let E=n(s,u,o,g);if(!E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:a,hasChanges:!1,hasConflicts:!1};if(!E.hasLocalForwarded&&E.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};if(E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:a,hasChanges:!0,hasConflicts:!1};const d=m(s),T=m(u),O=o?m(o):null,$=h(d,T,g),z=O?h(O,d,g):{added:[...d.keys()].reduce((M,F)=>(M.add(F),M),new Set),removed:new Set,updated:new Set},G=O?h(O,T,g):{added:[...T.keys()].reduce((M,F)=>(M.add(F),M),new Set),removed:new Set,updated:new Set},V=w($,z,G);let U=a;for(const M of V.removed.values())V.conflicts.has(M)||(U=I(U,M,r));for(const M of V.added.values()){if(V.conflicts.has(M))continue;const F=T.get(M);if(F.some(j=>j.command!==`-${M}`&&E.conflicts.has(g[j.key]))){V.conflicts.add(M);continue}U=b(U,F,r)}for(const M of V.updated.values()){if(V.conflicts.has(M))continue;const F=T.get(M);if(F.some(j=>j.command!==`-${M}`&&E.conflicts.has(g[j.key]))){V.conflicts.add(M);continue}U=f(U,M,F,r)}return{mergeContent:U,hasChanges:!0,hasConflicts:V.conflicts.size>0}}e.merge=S;function w(a,c,t){const r=new Set,i=new Set,s=new Set,u=new Set;for(const o of c.removed.values())t.updated.has(o)&&u.add(o);for(const o of t.removed.values())u.has(o)||(c.updated.has(o)?u.add(o):i.add(o));for(const o of c.added.values())u.has(o)||t.added.has(o)&&a.updated.has(o)&&u.add(o);for(const o of t.added.values())u.has(o)||(c.added.has(o)?a.updated.has(o)&&u.add(o):r.add(o));for(const o of c.updated.values())u.has(o)||t.updated.has(o)&&a.updated.has(o)&&u.add(o);for(const o of t.updated.values())u.has(o)||(c.updated.has(o)?a.updated.has(o)&&u.add(o):s.add(o));return{added:r,removed:i,updated:s,conflicts:u}}function n(a,c,t,r){const i=new Set,s=y(a,r),u=y(c,r),o=t?y(t,r):null,l=v(s,u);if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const g=o?v(o,s):{added:[...s.keys()].reduce((z,G)=>(z.add(G),z),new Set),removed:new Set,updated:new Set};if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const E=o?v(o,u):{added:[...u.keys()].reduce((z,G)=>(z.add(G),z),new Set),removed:new Set,updated:new Set};if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:d,removed:T,updated:O,conflicts:$}=w(l,g,E);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:d,removed:T,updated:O,conflicts:$}}function y(a,c){const t=new Map;for(const r of a){const i=c[r.key];let s=t.get(i);s||(s=[],t.set(i,s)),s.push(r)}return t}function m(a){const c=new Map;for(const t of a){const r=t.command[0]==="-"?t.command.substring(1):t.command;let i=c.get(r);i||(i=[],c.set(r,i)),i.push(t)}return c}function v(a,c){const t=[...a.keys()],r=[...c.keys()],i=r.filter(o=>t.indexOf(o)===-1).reduce((o,l)=>(o.add(l),o),new Set),s=t.filter(o=>r.indexOf(o)===-1).reduce((o,l)=>(o.add(l),o),new Set),u=new Set;for(const o of t){if(s.has(o))continue;const l=a.get(o).map(E=>({...E,key:o})),g=c.get(o).map(E=>({...E,key:o}));(0,P.equals)(l,g,(E,d)=>D(E,d))||u.add(o)}return{added:i,removed:s,updated:u}}function h(a,c,t){const r=[...a.keys()],i=[...c.keys()],s=i.filter(l=>r.indexOf(l)===-1).reduce((l,g)=>(l.add(g),l),new Set),u=r.filter(l=>i.indexOf(l)===-1).reduce((l,g)=>(l.add(g),l),new Set),o=new Set;for(const l of r){if(u.has(l))continue;const g=a.get(l).map(d=>({...d,key:t[d.key]})),E=c.get(l).map(d=>({...d,key:t[d.key]}));C(g,E)||o.add(l)}return{added:s,removed:u,updated:o}}function C(a,c){return!(!(0,P.equals)(a.filter(({command:t})=>t[0]!=="-"),c.filter(({command:t})=>t[0]!=="-"),(t,r)=>D(t,r))||!(0,P.equals)(a.filter(({command:t})=>t[0]==="-"),c.filter(({command:t})=>t[0]==="-"),(t,r)=>D(t,r)))}function D(a,c){if(a.command!==c.command||a.key!==c.key)return!1;const t=k.ContextKeyExpr.deserialize(a.when),r=k.ContextKeyExpr.deserialize(c.when);return!(t&&!r||!t&&r||t&&r&&!t.equals(r)||!p.equals(a.args,c.args))}function b(a,c,t){for(const r of c)a=A.edit(a,[-1],r,t);return a}function I(a,c,t){const r=R(a);for(let i=r.length-1;i>=0;i--)(r[i].command===c||r[i].command===`-${c}`)&&(a=A.edit(a,[i],void 0,t));return a}function f(a,c,t,r){const i=R(a),s=i.findIndex(u=>u.command===c||u.command===`-${c}`);for(let u=i.length-1;u>=0;u--)(i[u].command===c||i[u].command===`-${c}`)&&(a=A.edit(a,[u],void 0,r));for(let u=t.length-1;u>=0;u--)a=A.edit(a,[s],t[u],r);return a}}),define(Z[190],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function p(k,A,R){const S={},w={},n=new Set;if(!A)return{local:{added:S,updated:w,removed:[...n.values()]},remote:{added:k,updated:{},removed:[]},conflicts:[]};const y=L(k,A);if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{local:{added:S,updated:w,removed:[...n.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=L(R,k),v=L(R,A),h={},C={},D=new Set,b=new Set;for(const I of m.removed.values())v.updated.has(I)?S[I]=A[I]:D.add(I);for(const I of v.removed.values())b.has(I)||(m.updated.has(I)?b.add(I):n.add(I));for(const I of m.updated.values())b.has(I)||(v.updated.has(I)?y.updated.has(I)&&b.add(I):C[I]=k[I]);for(const I of v.updated.values())b.has(I)||(m.updated.has(I)?y.updated.has(I)&&b.add(I):k[I]!==void 0&&(w[I]=A[I]));for(const I of m.added.values())b.has(I)||(v.added.has(I)?y.updated.has(I)&&b.add(I):h[I]=k[I]);for(const I of v.added.values())b.has(I)||(m.added.has(I)?y.updated.has(I)&&b.add(I):S[I]=A[I]);return{local:{added:S,removed:[...n.values()],updated:w},remote:{added:h,removed:[...D.values()],updated:C},conflicts:[...b.values()]}}e.merge=p;function L(k,A){const R=k?Object.keys(k):[],S=A?Object.keys(A):[],w=S.filter(m=>R.indexOf(m)===-1).reduce((m,v)=>(m.add(v),m),new Set),n=R.filter(m=>S.indexOf(m)===-1).reduce((m,v)=>(m.add(v),m),new Set),y=new Set;for(const m of R){if(n.has(m))continue;const v=k[m],h=A[m];v!==h&&y.add(m)}return{added:w,removed:n,updated:y}}function P(k,A){const{added:R,removed:S,updated:w}=L(k,A);return R.size===0&&S.size===0&&w.size===0}e.areSame=P}),define(Z[22],ee([0,1,6,27,32,37,129,79,15,23,16]),function(K,e,p,L,P,k,A,R,S,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function y(){const o=P.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(o).filter(l=>!!o[l].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=y;function m(){const o=P.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(o).filter(d=>!!o[d].ignoreSync),g=Object.keys(o).filter(d=>o[d].scope===2||o[d].scope===6),E=y();return(0,w.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...l,...g,...E])}e.getDefaultIgnoredSettings=m;function v(){const o="vscode://schemas/ignoredSettings",l=P.Registry.as(k.Extensions.Configuration);l.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,A.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(2,null),items:[{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,A.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(4,null),default:[],scope:1,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const g=P.Registry.as(R.Extensions.JSONContribution),E=()=>{const d=y(),T=m().filter(G=>G!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(k.allSettings.properties).filter(G=>T.indexOf(G)===-1),$=T.filter(G=>d.indexOf(G)===-1),z={items:{type:"string",enum:[...O,...$.map(G=>`-${G}`)]}};g.registerSchema(o,z)};return l.onDidUpdateConfiguration(()=>E())}e.registerConfiguration=v;function h(o){return o&&(0,n.isObject)(o)&&(0,n.isString)(o.id)&&(0,n.isArray)(o.scopes)}e.isAuthenticationProvider=h;var C;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Extensions="extensions",o.GlobalState="globalState"})(C=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function D(o,l,g){return g.joinPath(l.userDataSyncHome,o,`lastSync${o}.json`)}e.getLastSyncResourceUri=D,e.IUserDataSyncStoreManagementService=(0,p.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,p.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,p.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function b(o){const l={};return l[e.HEADER_EXECUTION_ID]=o,l}e.createSyncHeaders=b;var I;(function(o){o.Unauthorized="Unauthorized",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.NoRef="NoRef",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.UnresolvedConflicts="UnresolvedConflicts",o.Unknown="Unknown"})(I=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class f extends Error{constructor(l,g,E,d){super(l);this.code=g,this.resource=E,this.operationId=d,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=f;class a extends f{constructor(l,g,E,d){super(l,E,void 0,d);this.url=g}}e.UserDataSyncStoreError=a;class c extends f{constructor(l,g){super(l,g)}}e.UserDataAutoSyncError=c,function(o){function l(g){if(g instanceof o)return g;const E=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(g.name);if(E&&E[1]){const d=E[2]==="unknown"?void 0:E[2],T=E[3]==="unknown"?void 0:E[3];return new o(g.message,E[1],d,T)}return new o(g.message,I.Unknown)}o.toUserDataSyncError=l}(f=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var r;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var i;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function s(o){return`sync.enable.${o}`}e.getEnablementKey=s,e.IUserDataSyncResourceEnablementService=(0,p.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,p.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,p.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,p.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,p.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,p.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function u(o,l){if(o.scheme!==e.USER_DATA_SYNC_SCHEME)return o=o.with({scheme:l.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(g=>(0,S.isEqualOrParent)(o,(0,S.joinPath)(l.userDataSyncHome,g,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=u}),define(Z[46],ee([0,1,2,14,25,4,22,9,15,5,3,21,33,125,24,16,19,23,45,20,29]),function(K,e,p,L,P,k,A,R,S,w,n,y,m,v,h,C,D,b,I,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function c(u){return!!(u&&u.version!==void 0&&typeof u.version=="number"&&u.content!==void 0&&typeof u.content=="string"&&(Object.keys(u).length===2||Object.keys(u).length===3&&u.machineId!==void 0&&typeof u.machineId=="string"))}e.isSyncData=c;let t=class extends p.Disposable{constructor(o,l,g,E,d,T,O,$,z,G){super();this.resource=o,this.fileService=l,this.environmentService=g,this.userDataSyncStoreService=d,this.userDataSyncBackupStoreService=T,this.userDataSyncResourceEnablementService=O,this.telemetryService=$,this.logService=z,this.configurationService=G,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new n.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new n.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new w.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new n.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,D.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(g.userDataSyncHome,1024)?S.extUri:S.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(g.userDataSyncHome,o),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,A.PREVIEW_DIR_NAME),this.lastSyncResource=(0,A.getLastSyncResourceUri)(o,g,this.extUri),this.currentMachineIdPromise=(0,I.getServiceMachineId)(g,l,E)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const o=await this.syncPreviewPromise;this.syncPreviewPromise=null;const l=await this.performSync(o.remoteUserData,o.lastSyncUserData,!0);this.setStatus(l)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const o=await this.getLastSyncUserData();(o?(await this.doGenerateSyncResourcePreview(o,o,!0,a.CancellationToken.None)).resourcePreviews.some(({remoteChange:g})=>g!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(o){if(this._status!==o){const l=this._status;o==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),l==="hasConflicts"&&o==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=o,this._onDidChangStatus.fire(o)}}async sync(o,l={}){await this._sync(o,!0,l)}async preview(o,l={}){return this._sync(o,!1,l)}async apply(o,l={}){try{this.syncHeaders={...l};const g=await this.doApply(o);return this.setStatus(g),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(o,l,g){try{if(this.syncHeaders={...g},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let E="idle";try{const d=await this.getLastSyncUserData(),T=await this.getLatestRemoteUserData(o,d);return E=await this.performSync(T,d,l),E==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):E==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(E)}}finally{this.syncHeaders={}}}async replace(o){const l=await this.resolveContent(o);if(!l)return!1;const g=this.parseSyncData(l);if(!g)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const E=await this.getLastSyncUserData(),d=await this.getLatestRemoteUserData(null,E),T=await this.isRemoteDataFromCurrentMachine(d),O=await this.generateSyncPreview({ref:d.ref,syncData:g},E,T,a.CancellationToken.None),$=[];for(const z of O){const G=await this.getAcceptResult(z,z.remoteResource,void 0,a.CancellationToken.None),{remoteChange:V}=await this.getAcceptResult(z,z.previewResource,z.remoteContent,a.CancellationToken.None);$.push([z,{...G,remoteChange:V!==0?V:2}])}await this.applyResult(d,E,$,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(o){const l=await this.currentMachineIdPromise;return!!o.syncData?.machineId&&o.syncData.machineId===l}async getLatestRemoteUserData(o,l){if(l){const g=o&&o.latest?o.latest[this.resource]:void 0;if(l.ref===g||g===void 0&&l.syncData===null)return l}return this.getRemoteUserData(l)}async performSync(o,l,g){if(o.syncData&&o.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new A.UserDataSyncError((0,v.localize)(0,null,this.resource,this.version,o.syncData.version),A.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.doSync(o,l,g)}catch(E){if(E instanceof A.UserDataSyncError)switch(E.code){case A.UserDataSyncErrorCode.LocalPreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(o,l,g);case A.UserDataSyncErrorCode.Conflict:case A.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),o=await this.getRemoteUserData(null),l=await this.getLastSyncUserData(),this.performSync(o,l,g)}throw E}}async doSync(o,l,g){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,w.createCancelablePromise)(d=>this.doGenerateSyncResourcePreview(o,l,g,d)));const E=await this.syncPreviewPromise;return this.updateConflicts(E.resourcePreviews),E.resourcePreviews.some(({mergeState:d})=>d==="conflict")?"hasConflicts":g?await this.doApply(!1):"syncing"}catch(E){throw this.syncPreviewPromise=null,E}}async merge(o){return await this.updateSyncResourcePreview(o,async l=>{const g=await this.getMergeResult(l,a.CancellationToken.None);await this.fileService.writeFile(l.previewResource,P.VSBuffer.fromString(g?.content||""));const E=g&&!g.hasConflicts?await this.getAcceptResult(l,l.previewResource,void 0,a.CancellationToken.None):void 0;return l.acceptResult=E,l.mergeState=g.hasConflicts?"conflict":E?"accepted":"preview",l.localChange=E?E.localChange:g.localChange,l.remoteChange=E?E.remoteChange:g.remoteChange,l}),this.syncPreviewPromise}async accept(o,l){return await this.updateSyncResourcePreview(o,async g=>{const E=await this.getAcceptResult(g,o,l,a.CancellationToken.None);return g.acceptResult=E,g.mergeState="accepted",g.localChange=E.localChange,g.remoteChange=E.remoteChange,g}),this.syncPreviewPromise}async discard(o){return await this.updateSyncResourcePreview(o,async l=>{const g=await this.getMergeResult(l,a.CancellationToken.None);return await this.fileService.writeFile(l.previewResource,P.VSBuffer.fromString(g.content||"")),l.acceptResult=void 0,l.mergeState="preview",l.localChange=g.localChange,l.remoteChange=g.remoteChange,l}),this.syncPreviewPromise}async updateSyncResourcePreview(o,l){if(!this.syncPreviewPromise)return;let g=await this.syncPreviewPromise;const E=g.resourcePreviews.findIndex(({localResource:d,remoteResource:T,previewResource:O})=>this.extUri.isEqual(d,o)||this.extUri.isEqual(T,o)||this.extUri.isEqual(O,o));E!==-1&&(this.syncPreviewPromise=(0,w.createCancelablePromise)(async d=>{const T=[...g.resourcePreviews];return T[E]=await l(T[E]),{...g,resourcePreviews:T}}),g=await this.syncPreviewPromise,this.updateConflicts(g.resourcePreviews),g.resourcePreviews.some(({mergeState:d})=>d==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(o){if(!this.syncPreviewPromise)return"idle";const l=await this.syncPreviewPromise;return l.resourcePreviews.some(({mergeState:g})=>g==="conflict")?"hasConflicts":l.resourcePreviews.some(({mergeState:g})=>g!=="accepted")?"syncing":(await this.applyResult(l.remoteUserData,l.lastSyncUserData,l.resourcePreviews.map(g=>[g,g.acceptResult]),o),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(o){}}updateConflicts(o){const l=o.filter(({mergeState:g})=>g==="conflict");(0,b.equals)(this._conflicts,l,(g,E)=>this.extUri.isEqual(g.previewResource,E.previewResource))||(this._conflicts=l,this._onDidChangeConflicts.fire(l))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:l,ref:g})=>({created:l,uri:this.toRemoteBackupResource(g)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:l,ref:g})=>({created:l,uri:this.toLocalBackupResource(g)}))}toRemoteBackupResource(o){return k.URI.from({scheme:A.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${o}`})}toLocalBackupResource(o){return k.URI.from({scheme:A.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${o}`})}async getMachineId({uri:o}){const l=this.extUri.basename(o);if(this.extUri.isEqual(o,this.toRemoteBackupResource(l))){const{content:g}=await this.getUserData(l);if(g)return this.parseSyncData(g)?.machineId}}async resolveContent(o){const l=this.extUri.basename(o);if(this.extUri.isEqual(o,this.toRemoteBackupResource(l))){const{content:g}=await this.getUserData(l);return g}return this.extUri.isEqual(o,this.toLocalBackupResource(l))?this.userDataSyncBackupStoreService.resolveContent(this.resource,l):null}async resolvePreviewContent(o){const l=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(l)for(const g of l.resourcePreviews){if(this.extUri.isEqual(g.acceptedResource,o))return g.acceptResult?g.acceptResult.content:null;if(this.extUri.isEqual(g.remoteResource,o))return g.remoteContent;if(this.extUri.isEqual(g.localResource,o))return g.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(o){}}async doGenerateSyncResourcePreview(o,l,g,E){const d=await this.isRemoteDataFromCurrentMachine(o),T=await this.generateSyncPreview(o,l,d,E),O=[];for(const $ of T){const z=$.previewResource.with({scheme:A.USER_DATA_SYNC_SCHEME,authority:"accepted"});if($.localChange===0&&$.remoteChange===0)O.push({...$,acceptedResource:z,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const G=g?await this.getMergeResult($,E):void 0;if(E.isCancellationRequested)break;await this.fileService.writeFile($.previewResource,P.VSBuffer.fromString(G?.content||""));const V=G&&!G.hasConflicts?await this.getAcceptResult($,$.previewResource,void 0,E):void 0;O.push({...$,acceptResult:V,mergeState:G?.hasConflicts?"conflict":V?"accepted":"preview",localChange:V?V.localChange:G?G.localChange:$.localChange,remoteChange:V?V.remoteChange:G?G.remoteChange:$.remoteChange})}}return{remoteUserData:o,lastSyncUserData:l,resourcePreviews:O,isLastSyncFromCurrentMachine:d}}async getLastSyncUserData(){try{const o=await this.fileService.readFile(this.lastSyncResource),l=JSON.parse(o.value.toString()),g=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=l.version&&g&&l.version!==g,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${l.version} is not compatible with current sync state version ${g}.`),await this.resetLocal(),null;const E=l;if(E.content===null)return{ref:l.ref,syncData:null};const d=JSON.parse(E.content);if(c(d))return{...l,syncData:d,content:void 0}}catch(o){o instanceof L.FileOperationError&&o.fileOperationResult===1||this.logService.error(o)}return null}async updateLastSyncUserData(o,l={}){if(l.ref||l.content||l.version)throw new Error("Cannot have core properties as additional");const g=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),E={ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null,version:g,...l};await this.fileService.writeFile(this.lastSyncResource,P.VSBuffer.fromString(JSON.stringify(E)))}async getRemoteUserData(o){const{ref:l,content:g}=await this.getUserData(o);let E=null;return g!==null&&(E=this.parseSyncData(g)),{ref:l,syncData:E}}parseSyncData(o){try{const l=JSON.parse(o);if(c(l))return l}catch(l){this.logService.error(l)}throw new A.UserDataSyncError((0,v.localize)(1,null),A.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async getUserData(o){if((0,C.isString)(o)){const l=await this.userDataSyncStoreService.resolveContent(this.resource,o);return{ref:o,content:l}}else{const l=o?{ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,l,this.syncHeaders)}}async updateRemoteUserData(o,l){const g=await this.currentMachineIdPromise,E={version:this.version,machineId:g,content:o};return l=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(E),l,this.syncHeaders),{ref:l,syncData:E}}async backupLocal(o){const l={version:this.version,content:o};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(l))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};t=fe([Y(1,L.IFileService),Y(2,R.IEnvironmentService),Y(3,f.IStorageService),Y(4,A.IUserDataSyncStoreService),Y(5,A.IUserDataSyncBackupStoreService),Y(6,A.IUserDataSyncResourceEnablementService),Y(7,y.ITelemetryService),Y(8,A.IUserDataSyncLogService),Y(9,h.IConfigurationService)],t),e.AbstractSynchroniser=t;let r=class extends t{constructor(o,l,g,E,d,T,O,$,z,G,V){super(l,g,E,d,T,O,$,z,G,V);this.file=o,this._register(this.fileService.watch(this.extUri.dirname(o))),this._register(this.fileService.onDidFilesChange(U=>this.onFileChanges(U)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(o){return null}}async updateLocalFileContent(o,l,g){try{l?await this.fileService.writeFile(this.file,P.VSBuffer.fromString(o),g?void 0:l):await this.fileService.createFile(this.file,P.VSBuffer.fromString(o),{overwrite:g})}catch(E){throw E instanceof L.FileOperationError&&E.fileOperationResult===1||E instanceof L.FileOperationError&&E.fileOperationResult===3?new A.UserDataSyncError(E.message,A.UserDataSyncErrorCode.LocalPreconditionFailed):E}}onFileChanges(o){!o.contains(this.file)||this.triggerLocalChange()}};r=fe([Y(2,L.IFileService),Y(3,R.IEnvironmentService),Y(4,f.IStorageService),Y(5,A.IUserDataSyncStoreService),Y(6,A.IUserDataSyncBackupStoreService),Y(7,A.IUserDataSyncResourceEnablementService),Y(8,y.ITelemetryService),Y(9,A.IUserDataSyncLogService),Y(10,h.IConfigurationService)],r),e.AbstractFileSynchroniser=r;let i=class extends r{constructor(o,l,g,E,d,T,O,$,z,G,V,U){super(o,l,g,E,d,T,O,$,z,G,U);this.userDataSyncUtilService=V,this._formattingOptions=void 0}hasErrors(o){const l=[];return(0,m.parse)(o,l,{allowEmptyContent:!0,allowTrailingComma:!0}),l.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};i=fe([Y(2,L.IFileService),Y(3,R.IEnvironmentService),Y(4,f.IStorageService),Y(5,A.IUserDataSyncStoreService),Y(6,A.IUserDataSyncBackupStoreService),Y(7,A.IUserDataSyncResourceEnablementService),Y(8,y.ITelemetryService),Y(9,A.IUserDataSyncLogService),Y(10,A.IUserDataSyncUtilService),Y(11,h.IConfigurationService)],i),e.AbstractJsonFileSynchroniser=i;let s=class{constructor(o,l,g,E){this.resource=o,this.environmentService=l,this.logService=g,this.fileService=E,this.extUri=this.fileService.hasCapability(l.userDataSyncHome,1024)?S.extUri:S.extUriIgnorePathCase,this.lastSyncResource=(0,A.getLastSyncResourceUri)(this.resource,l,S.extUri)}async initialize({ref:o,content:l}){if(!l){this.logService.info("Remote content does not exist.",this.resource);return}const g=this.parseSyncData(l);if(!g)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:o,syncData:g})}catch(d){this.logService.error(d)}}parseSyncData(o){try{const l=JSON.parse(o);if(c(l))return l}catch(l){this.logService.error(l)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(o,l={}){const g={ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null,...l};await this.fileService.writeFile(this.lastSyncResource,P.VSBuffer.fromString(JSON.stringify(g)))}};s=fe([Y(1,R.IEnvironmentService),Y(2,A.IUserDataSyncLogService),Y(3,L.IFileService)],s),e.AbstractInitializer=s}),define(Z[191],ee([0,1,22,3,9,27,31,14,24,188,46,21,4,47,40,19,20,86,11,85,5]),function(K,e,p,L,P,k,A,R,S,w,n,y,m,v,h,C,D,b,I,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function c(u,o){const l=JSON.parse(u.content);if(u.version===1||u.version===2){const g=(await o.getInstalled(0)).filter(E=>E.isBuiltin);for(const E of l)u.version===1&&(E.enabled===!1&&(E.disabled=!0),delete E.enabled),u.version===2&&g.every(d=>!(0,A.areSameExtensions)(d.identifier,E.identifier))&&(E.installed=!0)}return l}function t(u,o,l){const g=l.get((0,A.getExtensionId)(u,o),0)||"{}";return JSON.parse(g)}e.getExtensionStorageState=t;function r(u,o,l,g){g.store((0,A.getExtensionId)(u,o),JSON.stringify(l),0,1)}e.storeExtensionStorageState=r;let i=class at extends n.AbstractSynchroniser{constructor(o,l,g,E,d,T,O,$,z,G,V,U,M,F){super("extensions",l,o,g,E,d,U,M,z,V);this.storageService=g,this.extensionManagementService=T,this.extensionEnablementService=O,this.ignoredExtensionsManagementService=$,this.extensionGalleryService=G,this.extensionsStorageSyncService=F,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.debounce(L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,j=>j.some(({local:_})=>!!_)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,j=>!j.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(o,l){const g=o.syncData?await c(o.syncData,this.extensionManagementService):null,E=l?.skippedExtensions||[],d=l?.syncData?await c(l.syncData,this.extensionManagementService):null,T=await this.extensionManagementService.getInstalled(),O=this.getLocalExtensions(T),$=this.ignoredExtensionsManagementService.getIgnoredExtensions(T);g?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:z,remote:G}=(0,w.merge)(O,g,d,E,$),V={local:z,remote:G,content:this.getPreviewContent(O,z.added,z.updated,z.removed),localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?2:0,remoteChange:G!==null?2:0};return[{skippedExtensions:E,localResource:this.localResource,localContent:this.format(O),localExtensions:O,remoteResource:this.remoteResource,remoteContent:g?this.format(g):null,previewResource:this.previewResource,previewResult:V,localChange:V.localChange,remoteChange:V.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(o,l,g,E){const d=[...l,...g],T=new Set,O=$=>{T.add($.id.toLowerCase()),$.uuid&&T.add($.uuid)};d.forEach(({identifier:$})=>O($)),E.forEach(O);for(const $ of o)T.has($.identifier.id.toLowerCase())||$.identifier.uuid&&T.has($.identifier.uuid)||d.push($);return this.format(d)}async getMergeResult(o,l){return{...o.previewResult,hasConflicts:!1}}async getAcceptResult(o,l,g,E){if(this.extUri.isEqual(l,this.localResource))return this.acceptLocal(o);if(this.extUri.isEqual(l,this.remoteResource))return this.acceptRemote(o);if(this.extUri.isEqual(l,this.previewResource))return o.previewResult;throw new Error(`Invalid Resource: ${l.toString()}`)}async acceptLocal(o){const l=await this.extensionManagementService.getInstalled(),g=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),E=(0,w.merge)(o.localExtensions,null,null,o.skippedExtensions,g),{local:d,remote:T}=E;return{content:o.localContent,local:d,remote:T,localChange:d.added.length>0||d.removed.length>0||d.updated.length>0?2:0,remoteChange:T!==null?2:0}}async acceptRemote(o){const l=await this.extensionManagementService.getInstalled(),g=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),E=o.remoteContent?JSON.parse(o.remoteContent):null;if(E!==null){const d=(0,w.merge)(o.localExtensions,E,o.localExtensions,[],g),{local:T,remote:O}=d;return{content:o.remoteContent,local:T,remote:O,localChange:T.added.length>0||T.removed.length>0||T.updated.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:o.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(o,l,g,E){let{skippedExtensions:d,localExtensions:T}=g[0][0],{local:O,remote:$,localChange:z,remoteChange:G}=g[0][1];if(z===0&&G===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),z!==0&&(await this.backupLocal(JSON.stringify(T)),d=await this.updateLocalExtensions(O.added,O.removed,O.updated,d)),$){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const V=JSON.stringify($.all);o=await this.updateRemoteUserData(V,E?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${$.added.length?` Added: ${JSON.stringify($.added.map(U=>U.identifier.id))}.`:""}${$.updated.length?` Updated: ${JSON.stringify($.updated.map(U=>U.identifier.id))}.`:""}${$.removed.length?` Removed: ${JSON.stringify($.removed.map(U=>U.identifier.id))}.`:""}`)}l?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(o,{skippedExtensions:d}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${d.length?` Skipped: ${JSON.stringify(d.map(V=>V.identifier.id))}.`:""}`))}async getAssociatedResources({uri:o}){return[{resource:this.extUri.joinPath(o,"extensions.json"),comparableResource:at.EXTENSIONS_DATA_URI}]}async resolveContent(o){if(this.extUri.isEqual(o,at.EXTENSIONS_DATA_URI)){const g=await this.extensionManagementService.getInstalled(),E=this.ignoredExtensionsManagementService.getIgnoredExtensions(g),d=this.getLocalExtensions(g).filter(T=>!E.some(O=>(0,A.areSameExtensions)({id:O},T.identifier)));return this.format(d)}if(this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o))return this.resolvePreviewContent(o);let l=await super.resolveContent(o);if(l)return l;if(l=await super.resolveContent(this.extUri.dirname(o)),l){const g=this.parseSyncData(l);if(g)switch(this.extUri.basename(o)){case"extensions.json":return this.format(this.parseExtensions(g))}}return null}format(o){o.sort((E,d)=>!E.identifier.uuid&&d.identifier.uuid?-1:E.identifier.uuid&&!d.identifier.uuid?1:(0,C.compare)(E.identifier.id,d.identifier.id));const l=JSON.stringify(o),g=(0,v.format)(l,void 0,{});return(0,h.applyEdits)(l,g)}async hasLocalData(){try{const o=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(o).some(g=>g.installed||g.disabled))return!0}catch(o){}return!1}async updateLocalExtensions(o,l,g,E){const d=[],T=[],O=await this.extensionManagementService.getInstalled();if(l.length){const z=O.filter(({identifier:G,isBuiltin:V})=>!V&&l.some(U=>(0,A.areSameExtensions)(G,U)));await a.Promises.settled(z.map(async G=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,G.identifier.id),await this.extensionManagementService.uninstall(G,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,G.identifier.id),d.push(G.identifier)}))}(o.length||g.length)&&await a.Promises.settled([...o,...g].map(async z=>{const G=O.find(U=>(0,A.areSameExtensions)(U.identifier,z.identifier));if(G&&G.isBuiltin){z.state&&G.manifest.version===z.version&&this.updateExtensionState(z.state,G.manifest.publisher,G.manifest.name,G.manifest.version),z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id),await this.extensionEnablementService.disableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id),await this.extensionEnablementService.enableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id)),d.push(z.identifier);return}const V=await this.extensionGalleryService.getCompatibleExtension(z.identifier);if(z.state&&(G?G.manifest.version===z.version:!!V)){const U=G?G.manifest.publisher:V.publisher,M=G?G.manifest.name:V.name;this.updateExtensionState(z.state,U,M,G?.manifest.version)}if(V)try{z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id,V.version),await this.extensionEnablementService.disableExtension(V.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id,V.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id,V.version),await this.extensionEnablementService.enableExtension(V.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id,V.version)),G||(await this.extensionManagementService.canInstall(V)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,z.identifier.id,V.version),await this.extensionManagementService.installFromGallery(V,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,z.identifier.id,V.version),d.push(V.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,V.displayName||V.identifier.id),T.push(z)))}catch(U){T.push(z),this.logService.error(U),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,V.displayName||V.identifier.id)}else this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,z.identifier.id),T.push(z)}));const $=[];for(const z of E)d.some(G=>(0,A.areSameExtensions)(G,z.identifier))||$.push(z);for(const z of T)$.some(G=>(0,A.areSameExtensions)(G.identifier,z.identifier))||$.push(z);return $}updateExtensionState(o,l,g,E){const d=t(l,g,this.storageService),T=E?this.extensionsStorageSyncService.getKeysForSync({id:(0,A.getGalleryExtensionId)(l,g),version:E}):void 0;T?T.forEach(O=>{d[O]=o[O]}):Object.keys(o).forEach(O=>d[O]=o[O]),r(l,g,d,this.storageService)}parseExtensions(o){return JSON.parse(o.content)}getLocalExtensions(o){const l=this.extensionEnablementService.getDisabledExtensions();return o.map(({identifier:g,isBuiltin:E,manifest:d})=>{const T={identifier:g,version:d.version};l.some(O=>(0,A.areSameExtensions)(O,g))&&(T.disabled=!0),E||(T.installed=!0);try{const O=this.extensionsStorageSyncService.getKeysForSync({id:g.id,version:d.version});if(O){const $=t(d.publisher,d.name,this.storageService);T.state=Object.keys($).reduce((z,G)=>(O.includes(G)&&(z[G]=$[G]),z),{})}}catch(O){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,I.getErrorMessage)(O))}return T})}};i.EXTENSIONS_DATA_URI=m.URI.from({scheme:p.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=fe([Y(0,P.IEnvironmentService),Y(1,R.IFileService),Y(2,D.IStorageService),Y(3,p.IUserDataSyncStoreService),Y(4,p.IUserDataSyncBackupStoreService),Y(5,k.IExtensionManagementService),Y(6,k.IGlobalExtensionEnablementService),Y(7,b.IIgnoredExtensionsManagementService),Y(8,p.IUserDataSyncLogService),Y(9,k.IExtensionGalleryService),Y(10,S.IConfigurationService),Y(11,p.IUserDataSyncResourceEnablementService),Y(12,y.ITelemetryService),Y(13,f.IExtensionsStorageSyncService)],i),e.ExtensionsSynchroniser=i;let s=class extends n.AbstractInitializer{constructor(o,l,g,E,d){super("extensions",E,d,g);this.extensionManagementService=o,this.ignoredExtensionsManagementService=l}async parseExtensions(o){return o.syncData?await c(o.syncData,this.extensionManagementService):null}generatePreview(o,l){const g=[],E=[],d=[];for(const T of o){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(T.identifier.id))continue;const O=l.find($=>(0,A.areSameExtensions)($.identifier,T.identifier));O?(g.push(O),T.disabled&&d.push(T.identifier)):T.installed&&(E.push(T.identifier),T.disabled&&d.push(T.identifier))}return{installedExtensions:g,newExtensions:E,disabledExtensions:d,remoteExtensions:o}}};s=fe([Y(0,k.IExtensionManagementService),Y(1,b.IIgnoredExtensionsManagementService),Y(2,R.IFileService),Y(3,P.IEnvironmentService),Y(4,p.IUserDataSyncLogService)],s),e.AbstractExtensionsInitializer=s}),define(Z[192],ee([0,1,26,22]),function(K,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function P(R,S,w,n,y){if(!S)return{remote:Object.keys(R).length>0?R:null,local:{added:{},removed:[],updated:{}}};const m=k(R,S);if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const v=w?k(w,S):{added:Object.keys(S).reduce((I,f)=>(I.add(f),I),new Set),removed:new Set,updated:new Set},h=w?k(w,R):{added:Object.keys(R).reduce((I,f)=>(I.add(f),I),new Set),removed:new Set,updated:new Set},C={added:{},removed:[],updated:{}},D=p.deepClone(S),b=!w;for(const I of h.added.values())I!==L.SYNC_SERVICE_URL_TYPE&&b&&v.added.has(I)||(D[I]=R[I]);for(const I of h.updated.values())D[I]=R[I];for(const I of h.removed.values())n.unregistered.includes(I)||delete D[I];for(const I of v.added.values()){const f=S[I];if(n.machine.includes(I)){y.info(`GlobalState: Skipped adding ${I} in local storage because it is declared as machine scoped.`);continue}if(w&&h.added.has(I))continue;const a=R[I];a&&a.value===f.value||I===L.SYNC_SERVICE_URL_TYPE&&b&&h.added.has(I)||(a?C.updated[I]=f:C.added[I]=f)}for(const I of v.updated.values()){const f=S[I];if(n.machine.includes(I)){y.info(`GlobalState: Skipped updating ${I} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(I)||h.removed.has(I))continue;const a=R[I];a&&a.value===f.value||(C.updated[I]=f)}for(const I of v.removed.values()){if(n.machine.includes(I)){y.trace(`GlobalState: Skipped removing ${I} in local storage because it is declared as machine scoped.`);continue}h.updated.has(I)||h.removed.has(I)||C.removed.push(I)}return{local:C,remote:A(D,S)?null:D}}e.merge=P;function k(R,S){const w=Object.keys(R),n=Object.keys(S),y=n.filter(h=>w.indexOf(h)===-1).reduce((h,C)=>(h.add(C),h),new Set),m=w.filter(h=>n.indexOf(h)===-1).reduce((h,C)=>(h.add(C),h),new Set),v=new Set;for(const h of w){if(m.has(h))continue;const C=R[h],D=S[h];p.equals(C,D)||v.add(h)}return{added:y,removed:m,updated:v}}function A(R,S){const{added:w,removed:n,updated:y}=k(R,S);return w.size===0&&n.size===0&&y.size===0}}),define(Z[193],ee([0,1,22,25,3,9,14,53,192,33,46,21,24,4,47,40,20,7,45,30,10]),function(K,e,p,L,P,k,A,R,S,w,n,y,m,v,h,C,D,b,I,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const c="globalState.argv.",t=["locale"];function r(l){const g=l.storage?Object.keys(l.storage).sort():[],E={};g.forEach(O=>E[O]=l.storage[O]),l.storage=E;const d=JSON.stringify(l),T=(0,h.format)(d,void 0,{});return(0,C.applyEdits)(d,T)}const i=1;let s=class ot extends n.AbstractSynchroniser{constructor(g,E,d,T,O,$,z,G,V){super("globalState",g,O,V,E,d,$,z,T,G);this.storageService=V,this.version=i,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(g.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(P.Event.any(P.Event.filter(g.onDidFilesChange,U=>U.contains(this.environmentService.argvResource)),P.Event.filter(V.onDidChangeValue,U=>U.scope===0&&U.target!==void 0?U.target===0:V.keys(0,0).includes(U.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(g,E,d,T){const O=g.syncData?JSON.parse(g.syncData.content):null;E=E===null&&d?g:E;const $=E&&E.syncData?JSON.parse(E.syncData.content):null,z=await this.getLocalGlobalState();O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const G=this.getStorageKeys($),{local:V,remote:U}=(0,S.merge)(z.storage,O?O.storage:null,$?$.storage:null,G,this.logService),M={content:null,local:V,remote:U,localChange:Object.keys(V.added).length>0||Object.keys(V.updated).length>0||V.removed.length>0?2:0,remoteChange:U!==null?2:0};return[{localResource:this.localResource,localContent:r(z),localUserData:z,remoteResource:this.remoteResource,remoteContent:O?r(O):null,previewResource:this.previewResource,previewResult:M,localChange:M.localChange,remoteChange:M.remoteChange,acceptedResource:this.acceptedResource,storageKeys:G}]}async getMergeResult(g,E){return{...g.previewResult,hasConflicts:!1}}async getAcceptResult(g,E,d,T){if(this.extUri.isEqual(E,this.localResource))return this.acceptLocal(g);if(this.extUri.isEqual(E,this.remoteResource))return this.acceptRemote(g);if(this.extUri.isEqual(E,this.previewResource))return g.previewResult;throw new Error(`Invalid Resource: ${E.toString()}`)}async acceptLocal(g){return{content:g.localContent,local:{added:{},removed:[],updated:{}},remote:g.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(g){if(g.remoteContent!==null){const E=JSON.parse(g.remoteContent),{local:d,remote:T}=(0,S.merge)(g.localUserData.storage,E.storage,null,g.storageKeys,this.logService);return{content:g.remoteContent,local:d,remote:T,localChange:Object.keys(d.added).length>0||Object.keys(d.updated).length>0||d.removed.length>0?2:0,remoteChange:T!==null?2:0}}else return{content:g.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(g,E,d,T){let{localUserData:O}=d[0][0],{local:$,remote:z,localChange:G,remoteChange:V}=d[0][1];if(G===0&&V===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),G!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(O)),await this.writeLocalGlobalState($),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),V!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const U=JSON.stringify({storage:z});g=await this.updateRemoteUserData(U,T?null:g.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}E?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:g}){return[{resource:this.extUri.joinPath(g,"globalState.json"),comparableResource:ot.GLOBAL_STATE_DATA_URI}]}async resolveContent(g){if(this.extUri.isEqual(g,ot.GLOBAL_STATE_DATA_URI)){const d=await this.getLocalGlobalState();return r(d)}if(this.extUri.isEqual(this.remoteResource,g)||this.extUri.isEqual(this.localResource,g)||this.extUri.isEqual(this.acceptedResource,g))return this.resolvePreviewContent(g);let E=await super.resolveContent(g);if(E)return E;if(E=await super.resolveContent(this.extUri.dirname(g)),E){const d=this.parseSyncData(E);if(d)switch(this.extUri.basename(g)){case"globalState.json":return r(JSON.parse(d.content))}}return null}async hasLocalData(){try{const{storage:g}=await this.getLocalGlobalState();if(Object.keys(g).length>1||g[`${c}.locale`]?.value!=="en")return!0}catch(g){}return!1}async getLocalGlobalState(){const g={},E=await this.getLocalArgvContent(),d=(0,w.parse)(E);for(const T of t)d[T]!==void 0&&(g[`${c}${T}`]={version:1,value:d[T]});for(const T of this.storageService.keys(0,0)){const O=this.storageService.get(T,0);O&&(g[T]={version:1,value:O})}return{storage:g}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(g){}return"{}"}async writeLocalGlobalState({added:g,removed:E,updated:d}){const T={},O={},$=(G,V)=>{for(const U of G){if(U.startsWith(c)){T[U.substring(c.length)]=V?V[U].value:void 0;continue}if(V){const M=V[U];M.value!==String(this.storageService.get(U,0))&&(O[U]=M.value)}else this.storageService.get(U,0)!==void 0&&(O[U]=void 0)}};if($(Object.keys(g),g),$(Object.keys(d),d),$(E),Object.keys(T).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(T),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(O).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const G of Object.keys(O))this.storageService.store(G,O[G],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(O))}}async updateArgv(g){const E=await this.getLocalArgvContent();let d=E;for(const T of Object.keys(g))d=(0,R.edit)(d,[T],g[T],{});E!==d&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(d)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(g){const E=this.storageService.keys(0,0),d=this.storageService.keys(0,1),T=[...E,...d],O=g?.storage?Object.keys(g.storage).filter($=>!$.startsWith(c)&&!T.includes($)&&this.storageService.get($,0)!==void 0):[];if(!b.isWeb){const $=[...p.ALL_SYNC_RESOURCES.map(z=>(0,p.getEnablementKey)(z)),p.SYNC_SERVICE_URL_TYPE];O.push(...$),d.push(...$)}return{user:E,machine:d,unregistered:O}}};s.GLOBAL_STATE_DATA_URI=v.URI.from({scheme:p.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),s=fe([Y(0,A.IFileService),Y(1,p.IUserDataSyncStoreService),Y(2,p.IUserDataSyncBackupStoreService),Y(3,p.IUserDataSyncLogService),Y(4,k.IEnvironmentService),Y(5,p.IUserDataSyncResourceEnablementService),Y(6,y.ITelemetryService),Y(7,m.IConfigurationService),Y(8,D.IStorageService)],s),e.GlobalStateSynchroniser=s;let u=class extends n.AbstractInitializer{constructor(g,E,d,T){super("globalState",d,T,E);this.storageService=g}async doInitialize(g){const E=g.syncData?JSON.parse(g.syncData.content):null;if(!E){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const d={},T={};for(const O of Object.keys(E.storage))O.startsWith(c)?d[O.substring(c.length)]=E.storage[O].value:this.storageService.get(O,0)===void 0&&(T[O]=E.storage[O].value);if(Object.keys(d).length){let O="{}";try{O=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch($){}for(const $ of Object.keys(d))O=(0,R.edit)(O,[$],d[$],{});await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(O))}if(Object.keys(T).length)for(const O of Object.keys(T))this.storageService.store(O,T[O],0,0)}};u=fe([Y(0,D.IStorageService),Y(1,A.IFileService),Y(2,k.IEnvironmentService),Y(3,p.IUserDataSyncLogService)],u),e.GlobalStateInitializer=u;let o=class{constructor(g,E,d,T,O){this.userDataSyncStoreClient=g,this.storageService=E,this.environmentService=d,this.fileService=T,this.logService=O}getSyncStoreType(g){return this.parseGlobalState(g)?.storage[p.SYNC_SERVICE_URL_TYPE]?.value}async sync(g){const E=(0,p.createSyncHeaders)((0,f.generateUuid)());try{return await this.doSync(g,E)}catch(d){if(d instanceof p.UserDataSyncError)switch(d.code){case p.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(g,E)}throw d}}async doSync(g,E){const d=await this.userDataSyncStoreClient.read("globalState",null,E),T=this.parseGlobalState(d)||{storage:{}};T.storage[p.SYNC_SERVICE_URL_TYPE]={value:g,version:i};const O=await(0,I.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),$={version:i,machineId:O,content:r(T)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify($),d.ref,E)}parseGlobalState({content:g}){if(!g)return null;const E=JSON.parse(g);if((0,n.isSyncData)(E))return E?JSON.parse(E.content):null;throw new Error("Invalid remote data")}};o=fe([Y(1,D.IStorageService),Y(2,k.IEnvironmentService),Y(3,A.IFileService),Y(4,a.ILogService)],o),e.UserDataSyncStoreTypeSynchronizer=o}),define(Z[194],ee([0,1,14,22,189,33,126,9,24,7,16,23,46,21,20,25,3]),function(K,e,p,L,P,k,A,R,S,w,n,y,m,v,h,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function b(a,c){const t=JSON.parse(a);if(!c)return(0,n.isUndefined)(t.all)?null:t.all;switch(w.OS){case 2:return(0,n.isUndefined)(t.mac)?null:t.mac;case 3:return(0,n.isUndefined)(t.linux)?null:t.linux;case 1:return(0,n.isUndefined)(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=b;let I=class extends m.AbstractJsonFileSynchroniser{constructor(c,t,r,i,s,u,o,l,g,E){super(o.keybindingsResource,"keybindings",u,o,l,c,t,s,E,r,g,i);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(D.Event.filter(i.onDidChangeConfiguration,d=>d.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(c,t,r,i){const s=c.syncData?this.getKeybindingsContentFromSyncContent(c.syncData.content):null;t=t===null&&r?c:t;const u=t?this.getKeybindingsContentFromLastSyncUserData(t):null,o=await this.getLocalFileContent(),l=await this.getFormattingOptions();let g=null,E=!1,d=!1,T=!1;if(s){let $=o?o.value.toString():"[]";if($=$||"[]",this.hasErrors($))throw new L.UserDataSyncError((0,A.localize)(0,null),L.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!u||u!==$||u!==s){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const z=await(0,P.merge)($,s,u,l,this.userDataSyncUtilService);z.hasChanges&&(g=z.mergeContent,T=z.hasConflicts,E=T||z.mergeContent!==$,d=T||z.mergeContent!==s)}}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),g=o.value.toString(),d=!0);const O={content:g,localChange:E?o?2:1:0,remoteChange:d?2:0,hasConflicts:T};return[{fileContent:o,localResource:this.localResource,localContent:o?o.value.toString():null,localChange:O.localChange,remoteResource:this.remoteResource,remoteContent:s,remoteChange:O.remoteChange,previewResource:this.previewResource,previewResult:O,acceptedResource:this.acceptedResource}]}async getMergeResult(c,t){return c.previewResult}async getAcceptResult(c,t,r,i){if(this.extUri.isEqual(t,this.localResource))return{content:c.fileContent?c.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:c.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return r===void 0?{content:c.previewResult.content,localChange:c.previewResult.localChange,remoteChange:c.previewResult.remoteChange}:{content:r,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(c,t,r,i){const{fileContent:s}=r[0][0];let{content:u,localChange:o,remoteChange:l}=r[0][1];if(o===0&&l===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),u!==null&&(u=u.trim(),u=u||"[]",this.hasErrors(u)))throw new L.UserDataSyncError((0,A.localize)(1,null),L.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(o!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),s&&await this.backupLocal(this.toSyncContent(s.value.toString())),await this.updateLocalFileContent(u||"[]",s,i),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),l!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const g=this.toSyncContent(u||"[]",c.syncData?.content);c=await this.updateRemoteUserData(g,i?null:c.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(g){}t?.ref!==c.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(c,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const c=await this.getLocalFileContent();if(c){const t=(0,k.parse)(c.value.toString());if((0,y.isNonEmptyArray)(t))return!0}}catch(c){if(c.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:c}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(c,"keybindings.json"),comparableResource:t}]}async resolveContent(c){if(this.extUri.isEqual(this.remoteResource,c)||this.extUri.isEqual(this.localResource,c)||this.extUri.isEqual(this.acceptedResource,c))return this.resolvePreviewContent(c);let t=await super.resolveContent(c);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(c)),t){const r=this.parseSyncData(t);if(r)switch(this.extUri.basename(c)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(r.content)}}return null}getKeybindingsContentFromLastSyncUserData(c){return!c.syncData||c.platformSpecific!==void 0&&c.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(c.syncData.content)}getKeybindingsContentFromSyncContent(c){try{return b(c,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(c,t){let r={};try{r=JSON.parse(t||"{}")}catch(i){this.logService.error(i)}switch(this.syncKeybindingsPerPlatform()?delete r.all:r.all=c,w.OS){case 2:r.mac=c;break;case 3:r.linux=c;break;case 1:r.windows=c;break}return JSON.stringify(r)}syncKeybindingsPerPlatform(){let c=!!this.configurationService.inspect("settingsSync.keybindingsPerPlatform").userValue;return c!==void 0||(c=!!this.configurationService.inspect("sync.keybindingsPerPlatform").userValue,c!==void 0)?c:!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};I=fe([Y(0,L.IUserDataSyncStoreService),Y(1,L.IUserDataSyncBackupStoreService),Y(2,L.IUserDataSyncLogService),Y(3,S.IConfigurationService),Y(4,L.IUserDataSyncResourceEnablementService),Y(5,p.IFileService),Y(6,R.IEnvironmentService),Y(7,h.IStorageService),Y(8,L.IUserDataSyncUtilService),Y(9,v.ITelemetryService)],I),e.KeybindingsSynchroniser=I;let f=class extends m.AbstractInitializer{constructor(c,t,r){super("keybindings",t,r,c)}async doInitialize(c){const t=c.syncData?this.getKeybindingsContentFromSyncContent(c.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,C.VSBuffer.fromString(t)),await this.updateLastSyncUserData(c)}async isEmpty(){try{const c=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,k.parse)(c.value.toString());return!(0,y.isNonEmptyArray)(t)}catch(c){return c.fileOperationResult===1}}getKeybindingsContentFromSyncContent(c){try{return b(c,!0)}catch(t){return this.logService.error(t),null}}};f=fe([Y(0,p.IFileService),Y(1,R.IEnvironmentService),Y(2,L.IUserDataSyncLogService)],f),e.KeybindingsInitializer=f}),define(Z[195],ee([0,1,26,33,40,47,53,22,23]),function(K,e,p,L,P,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function w(o,l,g){let E=[];g?E=y(g):E=n(l);const d=[],T=[...(0,R.getDisallowedIgnoredSettings)()];if(Array.isArray(E))for(const O of E)O.startsWith("-")?T.push(O.substring(1)):d.push(O);return(0,S.distinct)([...o,...d].filter(O=>T.indexOf(O)===-1))}e.getIgnoredSettings=w;function n(o){let l=o.inspect("settingsSync.ignoredSettings").userValue;return l!==void 0||(l=o.inspect("sync.ignoredSettings").userValue,l!==void 0)?l:o.getValue("settingsSync.ignoredSettings")||[]}function y(o){const l=(0,L.parse)(o);return l?l["settingsSync.ignoredSettings"]||l["sync.ignoredSettings"]||[]:[]}function m(o,l,g,E){if(g.length){const d=u(l),T=(0,L.parse)(l),O=(0,L.parse)(o),$=[];for(const z of g){const G=T[z],V=O[z];G===void 0?o=A.edit(o,[z],void 0,E):V!==void 0?o=A.edit(o,[z],G,E):$.push(c(z,d))}$.sort((z,G)=>z.startOffset-G.startOffset),$.forEach(z=>o=b(z.setting.key,l,o,E))}return o}e.updateIgnoredSettings=m;function v(o,l,g,E,d,T){const O=m(o,l,E,T),$=g!==O,z=g!==l;if(!$&&!z)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if($&&!z)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(z&&!$)return{conflictsSettings:[],localContent:m(l,o,E,T),remoteContent:null,hasConflicts:!1};if(g===null&&C(o)){const ne=h(o,l,E)?null:m(l,o,E,T);return{conflictsSettings:[],localContent:ne,remoteContent:null,hasConflicts:!1}}let G=o,V=l;const U=(0,L.parse)(o),M=(0,L.parse)(l),F=g?(0,L.parse)(g):null,j=E.reduce((ne,le)=>(ne.add(le),ne),new Set),_=D(U,M,j),N=D(F,U,j),W=D(F,M,j),x=new Map,B=new Set,H=ne=>{B.add(ne);const le=d.filter(({key:de})=>de===ne)[0];le?(G=A.edit(G,[ne],le.value,T),V=A.edit(V,[ne],le.value,T)):x.set(ne,{key:ne,localValue:U[ne],remoteValue:M[ne]})};for(const ne of N.removed.values())W.updated.has(ne)?H(ne):V=A.edit(V,[ne],void 0,T);for(const ne of W.removed.values())B.has(ne)||(N.updated.has(ne)?H(ne):G=A.edit(G,[ne],void 0,T));for(const ne of N.updated.values())B.has(ne)||(W.updated.has(ne)?_.updated.has(ne)&&H(ne):V=A.edit(V,[ne],U[ne],T));for(const ne of W.updated.values())B.has(ne)||(N.updated.has(ne)?_.updated.has(ne)&&H(ne):G=A.edit(G,[ne],M[ne],T));for(const ne of N.added.values())B.has(ne)||(W.added.has(ne)?_.updated.has(ne)&&H(ne):V=b(ne,G,V,T));for(const ne of W.added.values())B.has(ne)||(N.added.has(ne)?_.updated.has(ne)&&H(ne):G=b(ne,V,G,T));const X=x.size>0||!h(G,V,E),Q=X||!h(G,o,[]),ie=X||!h(V,l,[]);return{localContent:Q?G:null,remoteContent:ie?V:null,conflictsSettings:[...x.values()],hasConflicts:X}}e.merge=v;function h(o,l,g){if(o===l)return!0;const E=(0,L.parse)(o),d=(0,L.parse)(l),T=g.reduce((z,G)=>(z.add(G),z),new Set),O=u(o).filter(z=>!(z.setting&&T.has(z.setting.key))),$=u(l).filter(z=>!(z.setting&&T.has(z.setting.key)));if(O.length!==$.length)return!1;for(let z=0;z<O.length;z++){const G=O[z],V=$[z];if(G.setting&&V.setting){if(G.setting.key!==V.setting.key||!p.equals(E[G.setting.key],d[G.setting.key]))return!1}else if(!G.setting&&!V.setting){if(G.value!==V.value)return!1}else return!1}return!0}e.areSame=h;function C(o){return o?u(o).length===0:!0}e.isEmpty=C;function D(o,l,g){const E=o?Object.keys(o).filter(z=>!g.has(z)):[],d=Object.keys(l).filter(z=>!g.has(z)),T=d.filter(z=>E.indexOf(z)===-1).reduce((z,G)=>(z.add(G),z),new Set),O=E.filter(z=>d.indexOf(z)===-1).reduce((z,G)=>(z.add(G),z),new Set),$=new Set;if(o)for(const z of E){if(O.has(z))continue;const G=o[z],V=l[z];p.equals(G,V)||$.add(z)}return{added:T,removed:O,updated:$}}function b(o,l,g,E){const d=(0,L.parse)(l),T=u(l),O=u(g),$=I(o,T,O);return f(g,o,d[o],$,O,E)}e.addSetting=b;function I(o,l,g){const E=l.findIndex(T=>T.setting?.key===o),d=l[E-1];if(d){if(d.setting){const O=c(d.setting.key,g);if(O)return{index:g.indexOf(O),insertAfter:!0}}else{const O=t(E,l);if(O){const $=c(O.setting.key,g);if($){const z=r(g.indexOf($),g),G=i(l,O,l[E]);if(z){const V=i(g,$,z),U=s(G,V);return U?{index:g.indexOf(U),insertAfter:!0}:{index:g.indexOf(z),insertAfter:!1}}else{const V=i(g,$,g[g.length-1]),U=s(G,V);return U?{index:g.indexOf(U),insertAfter:!0}:{index:g.length-1,insertAfter:!0}}}}}const T=l[E+1];if(T)if(T.setting){const O=c(T.setting.key,g);if(O)return{index:g.indexOf(O),insertAfter:!1}}else{const O=r(E,l);if(O){const $=c(O.setting.key,g);if($){const z=t(g.indexOf($),g),G=i(l,l[E],O);if(z){const V=i(g,z,$),U=s(G.reverse(),V.reverse());return U?{index:g.indexOf(U),insertAfter:!1}:{index:g.indexOf(z),insertAfter:!0}}else{const V=i(g,g[0],$),U=s(G.reverse(),V.reverse());return U?{index:g.indexOf(U),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:g.length-1,insertAfter:!0}}function f(o,l,g,E,d,T){let O;return E.index===-1?O=(0,P.setProperty)(o,[l],g,T):O=a(o,l,g,E,d,T).map($=>(0,P.withFormatting)(o,$,T)[0]),(0,P.applyEdits)(o,O)}function a(o,l,g,E,d,T){const O=`${JSON.stringify(l)}: ${JSON.stringify(g)}`,$=(0,k.getEOL)(T,o),z=d[E.index];if(E.insertAfter){const G=[];if(z.setting)G.push({offset:z.endOffset,length:0,content:","+O});else{const V=r(E.index,d),U=t(E.index,d),M=U?.setting?.commaOffset;U&&M===void 0&&G.push({offset:U.endOffset,length:0,content:","});const F=M!==void 0&&M>z.endOffset;G.push({offset:F?M+1:z.endOffset,length:0,content:V?$+O+",":$+O})}return G}else{if(z.setting)return[{offset:z.startOffset,length:0,content:O+","}];const G=(d[E.index-1]&&!d[E.index-1].setting?$:"")+O+(r(E.index,d)?",":"")+$;return[{offset:z.startOffset,length:0,content:G}]}}function c(o,l){return l.filter(g=>g.setting?.key===o)[0]}function t(o,l){for(let g=o-1;g>=0;g--)if(l[g].setting)return l[g]}function r(o,l){for(let g=o+1;g<l.length;g++)if(l[g].setting)return l[g]}function i(o,l,g){const E=o.indexOf(l),d=o.indexOf(g);return o.filter((T,O)=>E<O&&O<d)}function s(o,l){if(o.length&&l.length){let g=0;for(;g<l.length&&g<o.length;g++)if(o[g].value!==l[g].value)return l[g-1];return l[g-1]}}function u(o){const l=[];let g=-1,E,d;const T={onObjectBegin:O=>{g++},onObjectProperty:(O,$,z)=>{g===0&&(E=$,d=O)},onObjectEnd:(O,$)=>{g--,g===0&&l.push({startOffset:E,endOffset:O+$,value:o.substring(E,O+$),setting:{key:d,commaOffset:void 0}})},onArrayBegin:(O,$)=>{g++},onArrayEnd:(O,$)=>{g--,g===0&&l.push({startOffset:E,endOffset:O+$,value:o.substring(E,O+$),setting:{key:d,commaOffset:void 0}})},onLiteralValue:(O,$,z)=>{g===0&&l.push({startOffset:E,endOffset:$+z,value:o.substring(E,$+z),setting:{key:d,commaOffset:void 0}})},onSeparator:(O,$,z)=>{if(g===0&&O===","){let G=l.length-1;for(;G>=0&&!l[G].setting;G--);const V=l[G];V&&l.splice(G,1,{startOffset:V.startOffset,endOffset:V.endOffset,value:V.value,setting:{key:V.setting.key,commaOffset:$}})}},onComment:(O,$)=>{g===0&&l.push({startOffset:O,endOffset:O+$,value:o.substring(O,O+$)})}};return(0,L.visit)(o,T),l}}),define(Z[196],ee([0,1,14,22,25,127,3,9,24,195,53,46,21,27,20,40]),function(K,e,p,L,P,k,A,R,S,w,n,y,m,v,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function D(c){return c&&c.settings&&typeof c.settings=="string"&&Object.keys(c).length===1}function b(c){const t=JSON.parse(c);return D(t)?t:{settings:c}}e.parseSettingsSyncContent=b;let I=class extends y.AbstractJsonFileSynchroniser{constructor(t,r,i,s,u,o,l,g,E,d,T){super(r.settingsResource,"settings",t,r,i,s,u,E,d,o,l,g);this.extensionManagementService=T,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,r,i,s){const u=await this.getLocalFileContent(),o=await this.getFormattingOptions(),l=this.getSettingsSyncContent(t);r=r===null&&i?t:r;const g=r?this.getSettingsSyncContent(r):null,E=await this.getIgnoredSettings();let d=null,T=!1,O=!1,$=!1;if(l){let G=u?u.value.toString().trim():"{}";G=G||"{}",this.validateContent(G),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const V=(0,w.merge)(G,l.settings,g?g.settings:null,E,[],o);d=V.localContent||V.remoteContent,T=V.localContent!==null,O=V.remoteContent!==null,$=V.hasConflicts}else u&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),d=u.value.toString(),O=!0);const z={content:d,localChange:T?2:0,remoteChange:O?2:0,hasConflicts:$};return[{fileContent:u,localResource:this.localResource,localContent:u?u.value.toString():null,localChange:z.localChange,remoteResource:this.remoteResource,remoteContent:l?l.settings:null,remoteChange:z.remoteChange,previewResource:this.previewResource,previewResult:z,acceptedResource:this.acceptedResource}]}async getMergeResult(t,r){const i=await this.getFormattingOptions(),s=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,w.updateIgnoredSettings)(t.previewResult.content,"{}",s,i):null}}async getAcceptResult(t,r,i,s){const u=await this.getFormattingOptions(),o=await this.getIgnoredSettings();if(this.extUri.isEqual(r,this.localResource))return{content:t.fileContent?(0,w.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",o,u):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(r,this.remoteResource))return{content:t.remoteContent!==null?(0,w.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",o,u):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(r,this.previewResource))return i===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:i!==null?(0,w.updateIgnoredSettings)(i,t.fileContent?t.fileContent.value.toString():"{}",o,u):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async applyResult(t,r,i,s){const{fileContent:u}=i[0][0];let{content:o,localChange:l,remoteChange:g}=i[0][1];if(l===0&&g===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.validateContent(o),l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),u&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(u.value.toString()))),await this.updateLocalFileContent(o,u,s),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),g!==0){const E=await this.getFormattingOptions(),d=this.getSettingsSyncContent(t),T=await this.getIgnoredSettings(o);o=(0,w.updateIgnoredSettings)(o,d?d.settings:"{}",T,E),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(o)),s?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(E){}r?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const r=await this.getFormattingOptions(),i=(0,n.edit)(t.value.toString(),[L.CONFIGURATION_SYNC_STORE_KEY],void 0,r);return!(0,w.isEmpty)(i)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const r=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:r}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let r=await super.resolveContent(t);if(r)return r;if(r=await super.resolveContent(this.extUri.dirname(t)),r){const i=this.parseSyncData(r);if(i){const s=this.parseSettingsSyncContent(i.content);if(s)switch(this.extUri.basename(t)){case"settings.json":return s.settings}}}return null}async resolvePreviewContent(t){let r=await super.resolvePreviewContent(t);if(r){const i=await this.getFormattingOptions(),s=await this.getIgnoredSettings();r=(0,w.updateIgnoredSettings)(r,"{}",s,i)}return r}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return b(t)}catch(r){this.logService.error(r)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=A.Event.any(A.Event.filter(this.extensionManagementService.onDidInstallExtensions,s=>s.some(({local:u})=>!!u)),A.Event.filter(this.extensionManagementService.onDidUninstallExtension,s=>!s.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const r=await this._defaultIgnoredSettings;return(0,w.getIgnoredSettings)(r,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new L.UserDataSyncError((0,k.localize)(0,null),L.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const r=JSON.parse(t.value.toString());if(!a(r))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const i=this.parseSettingsSyncContent(r.content);if(!i||!i.settings)return;let s=i.settings;const u=await this.getFormattingOptions();for(const o in r)if(["version","content","machineId"].indexOf(o)===-1&&r[o]!==void 0){const l=(0,C.setProperty)(s,[o],r[o],u);l.length&&(s=(0,C.applyEdits)(s,l))}await this.fileService.writeFile(this.file,P.VSBuffer.fromString(s))}catch(t){}}};I=fe([Y(0,p.IFileService),Y(1,R.IEnvironmentService),Y(2,h.IStorageService),Y(3,L.IUserDataSyncStoreService),Y(4,L.IUserDataSyncBackupStoreService),Y(5,L.IUserDataSyncLogService),Y(6,L.IUserDataSyncUtilService),Y(7,S.IConfigurationService),Y(8,L.IUserDataSyncResourceEnablementService),Y(9,m.ITelemetryService),Y(10,v.IExtensionManagementService)],I),e.SettingsSynchroniser=I;let f=class extends y.AbstractInitializer{constructor(t,r,i){super("settings",r,i,t)}async doInitialize(t){const r=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!r){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,P.VSBuffer.fromString(r.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,w.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return b(t)}catch(r){this.logService.error(r)}return null}};f=fe([Y(0,p.IFileService),Y(1,R.IEnvironmentService),Y(2,L.IUserDataSyncLogService)],f),e.SettingsInitializer=f;function a(c){return!!(c&&c.version!==void 0&&typeof c.version=="number"&&c.content!==void 0&&typeof c.content=="string"&&c.machineId!==void 0&&typeof c.machineId=="string")}}),define(Z[197],ee([0,1,22,9,14,24,46,21,25,190,20,26,3]),function(K,e,p,L,P,k,A,R,S,w,n,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let v=class extends A.AbstractSynchroniser{constructor(D,b,I,f,a,c,t,r,i){super("snippets",b,D,I,f,a,r,i,c,t);this.version=1,this.snippetsFolder=D.snippetsHome,this._register(this.fileService.watch(D.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(m.Event.filter(this.fileService.onDidFilesChange,s=>s.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(D,b,I,f){const a=await this.getSnippetsFileContents(),c=this.toSnippetsContents(a),t=D.syncData?this.parseSnippets(D.syncData):null;b=b===null&&I?D:b;const r=b&&b.syncData?this.parseSnippets(b.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,w.merge)(c,t,r);return this.getResourcePreviews(i,a,t||{})}async getMergeResult(D,b){return D.previewResult}async getAcceptResult(D,b,I,f){if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:D.fileContent?D.fileContent.value.toString():null,localChange:0,remoteChange:D.fileContent?D.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:D.remoteContent,localChange:D.remoteContent!==null?D.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder))return I===void 0?{content:D.previewResult.content,localChange:D.previewResult.localChange,remoteChange:D.previewResult.remoteChange}:{content:I,localChange:I===null?D.fileContent!==null?3:0:2,remoteChange:I===null?D.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${b.toString()}`)}async applyResult(D,b,I,f){const a=I.map(([c,t])=>({...c,acceptResult:t}));a.every(({localChange:c,remoteChange:t})=>c===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),a.some(({localChange:c})=>c!==0)&&(await this.updateLocalBackup(a),await this.updateLocalSnippets(a,f)),a.some(({remoteChange:c})=>c!==0)&&(D=await this.updateRemoteSnippets(a,D,f)),b?.ref!==D.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(D),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:c}of a)try{await this.fileService.del(c)}catch(t){}}getResourcePreviews(D,b,I){const f=new Map;for(const a of Object.keys(D.local.added)){const c={content:D.local.added[a],hasConflicts:!1,localChange:1,remoteChange:0};f.set(a,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[a],previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of Object.keys(D.local.updated)){const c={content:D.local.updated[a],hasConflicts:!1,localChange:2,remoteChange:0};f.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[a],localContent:b[a].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[a],previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of D.local.removed){const c={content:null,hasConflicts:!1,localChange:3,remoteChange:0};f.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[a],localContent:b[a].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of Object.keys(D.remote.added)){const c={content:D.remote.added[a],hasConflicts:!1,localChange:0,remoteChange:1};f.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[a],localContent:b[a].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of Object.keys(D.remote.updated)){const c={content:D.remote.updated[a],hasConflicts:!1,localChange:0,remoteChange:2};f.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[a],localContent:b[a].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[a],previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of D.remote.removed){const c={content:null,hasConflicts:!1,localChange:0,remoteChange:3};f.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[a],previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of D.conflicts){const c={content:b[a]?b[a].value.toString():null,hasConflicts:!0,localChange:b[a]?2:1,remoteChange:I[a]?2:1};f.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[a]||null,localContent:b[a]?b[a].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[a]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of Object.keys(b))if(!f.has(a)){const c={content:b[a]?b[a].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};f.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[a]||null,localContent:b[a]?b[a].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[a]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...f.values()]}async getAssociatedResources({uri:D}){let b=await super.resolveContent(D);if(b){const I=this.parseSyncData(b);if(I){const f=this.parseSnippets(I),a=[];for(const c of Object.keys(f)){const t=this.extUri.joinPath(D,c),r=this.extUri.joinPath(this.snippetsFolder,c),i=await this.fileService.exists(r);a.push({resource:t,comparableResource:i?r:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})})}return a}}return[]}async resolveContent(D){if(this.extUri.isEqualOrParent(D,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(D,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(D,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(D);let b=await super.resolveContent(D);if(b)return b;if(b=await super.resolveContent(this.extUri.dirname(D)),b){const I=this.parseSyncData(b);if(I)return this.parseSnippets(I)[this.extUri.basename(D)]||null}return null}async hasLocalData(){try{const D=await this.getSnippetsFileContents();if(Object.keys(D).length)return!0}catch(D){}return!1}async updateLocalBackup(D){const b={};for(const I of D)I.fileContent&&(b[this.extUri.basename(I.localResource)]=I.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(b)))}async updateLocalSnippets(D,b){for(const{fileContent:I,acceptResult:f,localResource:a,remoteResource:c,localChange:t}of D)if(t!==0){const r=c?this.extUri.basename(c):this.extUri.basename(a),i=this.extUri.joinPath(this.snippetsFolder,r);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(i)),await this.fileService.del(i),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(i))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(i)),await this.fileService.createFile(i,S.VSBuffer.fromString(f.content),{overwrite:b}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(i))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(i)),await this.fileService.writeFile(i,S.VSBuffer.fromString(f.content),b?void 0:I),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(i)))}}async updateRemoteSnippets(D,b,I){const f=b.syncData?this.parseSnippets(b.syncData):{},a=(0,y.deepClone)(f);for(const{acceptResult:c,localResource:t,remoteResource:r,remoteChange:i}of D)if(i!==0){const s=t?this.extUri.basename(t):this.extUri.basename(r);i===3?delete a[s]:a[s]=c.content}return(0,w.areSame)(f,a)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),b=await this.updateRemoteUserData(JSON.stringify(a),I?null:b.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),b}parseSnippets(D){return JSON.parse(D.content)}toSnippetsContents(D){const b={};for(const I of Object.keys(D))b[I]=D[I].value.toString();return b}async getSnippetsFileContents(){const D={};let b;try{b=await this.fileService.resolve(this.snippetsFolder)}catch(I){if(I instanceof P.FileOperationError&&I.fileOperationResult===1)return D;throw I}for(const I of b.children||[]){const f=I.resource,a=this.extUri.extname(f);if(a===".json"||a===".code-snippets"){const c=this.extUri.relativePath(this.snippetsFolder,f),t=await this.fileService.readFile(f);D[c]=t}}return D}};v=fe([Y(0,L.IEnvironmentService),Y(1,P.IFileService),Y(2,n.IStorageService),Y(3,p.IUserDataSyncStoreService),Y(4,p.IUserDataSyncBackupStoreService),Y(5,p.IUserDataSyncLogService),Y(6,k.IConfigurationService),Y(7,p.IUserDataSyncResourceEnablementService),Y(8,R.ITelemetryService)],v),e.SnippetsSynchroniser=v;let h=class extends A.AbstractInitializer{constructor(D,b,I){super("snippets",b,I,D)}async doInitialize(D){const b=D.syncData?JSON.parse(D.syncData.content):null;if(!b){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const f of Object.keys(b)){const a=b[f];if(a){const c=this.extUri.joinPath(this.environmentService.snippetsHome,f);await this.fileService.createFile(c,S.VSBuffer.fromString(a)),this.logService.info("Created snippet",this.extUri.basename(c))}}await this.updateLastSyncUserData(D)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(D){return D.fileOperationResult===1}}};h=fe([Y(0,P.IFileService),Y(1,L.IEnvironmentService),Y(2,p.IUserDataSyncLogService)],h),e.SnippetsInitializer=h}),define(Z[60],ee([0,1,6,3,2,22]),function(K,e,p,L,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,p.createDecorator)("IUserDataSyncAccountService");let A=class extends P.Disposable{constructor(S){super();this.userDataSyncStoreService=S,this._onDidChangeAccount=this._register(new L.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(S.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(S.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(S){(S&&this._account?S.token!==this._account.token||S.authenticationProviderId!==this._account.authenticationProviderId:S!==this._account)&&(this._account=S,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(S))}};A=fe([Y(0,k.IUserDataSyncStoreService)],A),e.UserDataSyncAccountService=A}),define(Z[198],ee([0,1,2,22,15,24,14,9,56,25,5]),function(K,e,p,L,P,k,A,R,S,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let y=class extends p.Disposable{constructor(v,h,C,D){super();this.environmentService=v,this.fileService=h,this.configurationService=C,this.logService=D,L.ALL_SYNC_RESOURCES.forEach(b=>this.cleanUpBackup(b))}async getAllRefs(v){const h=(0,P.joinPath)(this.environmentService.userDataSyncHome,v),C=await this.fileService.resolve(h);return C.children?C.children.filter(b=>b.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(b.name)).sort().reverse().map(b=>({ref:b.name,created:this.getCreationTime(b)})):[]}async resolveContent(v,h){if(!h){const C=await this.getAllRefs(v);C.length&&(h=C[C.length-1].ref)}if(h){const C=(0,P.joinPath)(this.environmentService.userDataSyncHome,v,h);return(await this.fileService.readFile(C)).value.toString()}return null}async backup(v,h){const C=(0,P.joinPath)(this.environmentService.userDataSyncHome,v),D=(0,P.joinPath)(C,`${(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(D,w.VSBuffer.fromString(h))}catch(b){this.logService.error(b)}try{this.cleanUpBackup(v)}catch(b){}}async cleanUpBackup(v){const h=(0,P.joinPath)(this.environmentService.userDataSyncHome,v);try{try{if(!await this.fileService.exists(h))return}catch(D){return}const C=await this.fileService.resolve(h);if(C.children){const D=C.children.filter(a=>a.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(a.name)).sort(),b=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let I=D.filter(a=>Date.now()-this.getCreationTime(a)>b);const f=D.length-I.length;f<10&&(I=I.slice(10-f)),await n.Promises.settled(I.map(async a=>{this.logService.info("Deleting from backup",a.resource.path),await this.fileService.del(a.resource)}))}}catch(C){this.logService.error(C)}}getCreationTime(v){return v.ctime||new Date(parseInt(v.name.substring(0,4)),parseInt(v.name.substring(4,6))-1,parseInt(v.name.substring(6,8)),parseInt(v.name.substring(9,11)),parseInt(v.name.substring(11,13)),parseInt(v.name.substring(13,15))).getTime()}};y=fe([Y(0,R.IEnvironmentService),Y(1,A.IFileService),Y(2,k.IConfigurationService),Y(3,L.IUserDataSyncLogService)],y),e.UserDataSyncBackupStoreService=y}),define(Z[199],ee([0,1,4,2]),function(K,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class P{constructor(m){this.service=m}listen(m,v){switch(v){case"onError":return this.service.onError}throw new Error(`Event not found: ${v}`)}call(m,v,h){switch(v){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=P;class k{constructor(m){this.service=m}listen(m,v){throw new Error(`Event not found: ${v}`)}call(m,v,h){switch(v){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(p.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=k;class A{constructor(m){this.channel=m}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(m){return this.channel.call("resolveUserKeybindings",[m])}async resolveFormattingOptions(m){return this.channel.call("resolveFormattingOptions",[m])}}e.UserDataSyncUtilServiceClient=A;class R{constructor(m){this.service=m}listen(m,v){switch(v){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${v}`)}async call(m,v,h){switch(v){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablement":return this.service.setEnablement(h[0],h[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class S{constructor(m){this.service=m}listen(m,v){switch(v){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${v}`)}call(m,v,h){switch(v){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=S;class w{constructor(m){this.service=m}listen(m,v){switch(v){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${v}`)}call(m,v,h){switch(v){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=w;class n extends L.Disposable{constructor(m){super();this.channel=m,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(m){return this.channel.call("switch",[m])}async getPreviousUserDataSyncStore(){const m=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(m)}revive(m){return{url:p.URI.revive(m.url),type:m.type,defaultUrl:p.URI.revive(m.defaultUrl),insidersUrl:p.URI.revive(m.insidersUrl),stableUrl:p.URI.revive(m.stableUrl),canSwitch:m.canSwitch,authenticationProviders:m.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=n}),define(Z[200],ee([0,1,10,9]),function(K,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let P=class extends p.AbstractLogger{constructor(A,R){super();this.logger=this._register(A.createLogger(R.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...R){this.logger.trace(A,...R)}debug(A,...R){this.logger.debug(A,...R)}info(A,...R){this.logger.info(A,...R)}warn(A,...R){this.logger.warn(A,...R)}error(A,...R){this.logger.error(A,...R)}critical(A,...R){this.logger.critical(A,...R)}flush(){this.logger.flush()}};P=fe([Y(0,p.ILoggerService),Y(1,L.IEnvironmentService)],P),e.UserDataSyncLogService=P}),define(Z[61],ee([0,1,6,2,45,9,14,20,22,130,28,7,19,3]),function(K,e,p,L,P,k,A,R,S,w,n,y,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,p.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName";let C=class Ke extends L.Disposable{constructor(b,I,f,a,c,t){super();this.storageService=f,this.userDataSyncStoreService=a,this.logService=c,this.productService=t,this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,P.getServiceMachineId)(b,I,f)}async getMachines(b){const I=await this.currentMachineIdPromise;return(await this.readMachinesData(b)).machines.map(a=>({...a,isCurrent:a.id===I}))}async addCurrentMachine(b){const I=await this.currentMachineIdPromise,f=await this.readMachinesData(b);f.machines.some(({id:a})=>a===I)||(f.machines.push({id:I,name:this.computeCurrentMachineName(f.machines)}),await this.writeMachinesData(f))}async removeCurrentMachine(b){const I=await this.currentMachineIdPromise,f=await this.readMachinesData(b),a=f.machines.filter(({id:c})=>c!==I);a.length!==f.machines.length&&(f.machines=a,await this.writeMachinesData(f))}async renameMachine(b,I,f){const a=await this.currentMachineIdPromise,c=await this.readMachinesData(f),t=c.machines.find(({id:r})=>r===b);t&&(t.name=I,await this.writeMachinesData(c),c.machines.some(({id:r})=>r===a)&&this.storageService.store(h,I,0,1))}async setEnablement(b,I){const f=await this.readMachinesData(),a=f.machines.find(({id:c})=>c===b);a&&(a.disabled=I?void 0:!0,await this.writeMachinesData(f))}computeCurrentMachineName(b){const I=this.storageService.get(h,0);if(I)return I;const f=`${this.productService.nameLong} (${(0,y.PlatformToString)(y.isWeb?0:y.platform)})`,a=new RegExp(`${(0,m.escapeRegExpCharacters)(f)}\\s#(\\d+)`);let c=0;for(const t of b){const r=a.exec(t.name),i=r?parseInt(r[1]):0;c=i>c?i:c}return`${f} #${c+1}`}async readMachinesData(b){this.userData=await this.readUserData(b);const I=this.parse(this.userData);if(I.version!==Ke.VERSION)throw new Error((0,w.localize)(0,null,this.productService.nameLong));return I}async writeMachinesData(b){const I=JSON.stringify(b),f=await this.userDataSyncStoreService.write(Ke.RESOURCE,I,this.userData?.ref||null);this.userData={ref:f,content:I},this._onDidChange.fire()}async readUserData(b){if(this.userData){const I=b&&b.latest?b.latest[Ke.RESOURCE]:void 0;if(this.userData.ref===I)return this.userData;if(I===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ke.RESOURCE,this.userData)}parse(b){if(b.content!==null)try{return JSON.parse(b.content)}catch(I){this.logService.error(I)}return{version:Ke.VERSION,machines:[]}}};C.VERSION=1,C.RESOURCE="machines",C=fe([Y(0,k.IEnvironmentService),Y(1,A.IFileService),Y(2,R.IStorageService),Y(3,S.IUserDataSyncStoreService),Y(4,S.IUserDataSyncLogService),Y(5,n.IProductService)],C),e.UserDataSyncMachinesService=C}),define(Z[87],ee([0,1,5,3,2,22,60,21,11,20,9,61,128,56,4,15,7,28]),function(K,e,p,L,P,k,A,R,S,w,n,y,m,v,h,C,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const I="sync.enable",f="sync.disableMachineEventually",a="sync.sessionId",c="sync.storeUrl",t="sync.productQuality";let r=class extends P.Disposable{constructor(o,l,g){super();this.storageService=o,this.environmentService=l,this.userDataSyncStoreManagementService=g,this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(o.onDidChangeValue(E=>this.onDidStorageChange(E)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(I,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(o){o&&!this.canToggleEnablement()||this.storageService.store(I,o,0,1)}onDidStorageChange(o){if(o.scope===0&&I===o.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};r=fe([Y(0,w.IStorageService),Y(1,n.IEnvironmentService),Y(2,k.IUserDataSyncStoreManagementService)],r),e.UserDataAutoSyncEnablementService=r;let i=class extends P.Disposable{constructor(o,l,g,E,d,T,O,$,z,G,V){super();this.userDataSyncStoreManagementService=l,this.userDataSyncStoreService=g,this.userDataSyncResourceEnablementService=E,this.userDataSyncService=d,this.logService=T,this.userDataSyncAccountService=O,this.telemetryService=$,this.userDataSyncMachinesService=z,this.storageService=G,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new L.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=V,this.syncTriggerDelayer=this._register(new p.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=l.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=o.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(l.onDidChangeUserDataSyncStore(()=>{(0,C.isEqual)(this.syncUrl,l.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=l.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(O.onDidChangeAccount(()=>this.updateAutoSync())),this._register(g.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(L.Event.debounce(d.onDidChangeLocal,(U,M)=>U?[...U,M]:[M],1e3)(U=>this.triggerSync(U,!1,!1))),this._register(L.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,U])=>U)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const o=this.storageService.get(c,0);return o?h.URI.parse(o):void 0}set syncUrl(o){o?this.storageService.store(c,o.toString(),0,1):this.storageService.remove(c,0)}get productQuality(){return this.storageService.get(t,0)}set productQuality(o){o?this.storageService.store(t,o,0,1):this.storageService.remove(t,0)}updateAutoSync(){const{enabled:o,message:l}=this.isAutoSyncEnabled();o?this.autoSync.value===void 0&&(this.autoSync.value=new s(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(g=>this.onDidFinishSync(g))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(l&&this.logService.info(l),this.autoSync.clear()):l&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(l))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,v.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(o,l,g){try{this.userDataSyncAccountService.account&&!g&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(a,0),o?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(E){if(l)this.logService.error(E),this.updateEnablement(!1);else throw E}}updateEnablement(o){this.userDataAutoSyncEnablementService.isEnabled()!==o&&(this.telemetryService.publicLog2(I,{enabled:o}),this.userDataAutoSyncEnablementService.setEnablement(o),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(o){if(!o){this.successiveFailures=0;return}const l=k.UserDataSyncError.toUserDataSyncError(o);l instanceof k.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:l.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),l.code===k.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):l.code===k.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):l.code===k.UserDataSyncErrorCode.LocalTooManyRequests||l.code===k.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):l.code===k.UserDataSyncErrorCode.UpgradeRequired||l.code===k.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):l.code===k.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${l.resource} content with newer version than of client. Requires client upgrade.`)):l.code===k.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${l.resource} content with older version than of client. Requires server reset.`)):l.code===k.UserDataSyncErrorCode.ServiceChanged||l.code===k.UserDataSyncErrorCode.DefaultServiceChanged?D.isWeb&&l.code===k.UserDataSyncErrorCode.DefaultServiceChanged&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(l),this.successiveFailures++),this._onError.fire(l)}async disableMachineEventually(){this.storageService.store(f,!0,0,1),await(0,p.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(f,0,!1)}stopDisableMachineEventually(){this.storageService.remove(f,0)}async triggerSync(o,l,g){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(l&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...o),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",g)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};i=fe([Y(0,b.IProductService),Y(1,k.IUserDataSyncStoreManagementService),Y(2,k.IUserDataSyncStoreService),Y(3,k.IUserDataSyncResourceEnablementService),Y(4,k.IUserDataSyncService),Y(5,k.IUserDataSyncLogService),Y(6,A.IUserDataSyncAccountService),Y(7,R.ITelemetryService),Y(8,y.IUserDataSyncMachinesService),Y(9,w.IStorageService),Y(10,k.IUserDataAutoSyncEnablementService)],i),e.UserDataAutoSyncService=i;class s extends P.Disposable{constructor(o,l,g,E,d,T,O,$){super();this.lastSyncUrl=o,this.interval=l,this.userDataSyncStoreManagementService=g,this.userDataSyncStoreService=E,this.userDataSyncService=d,this.userDataSyncMachinesService=T,this.logService=O,this.storageService=$,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new L.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new L.Emitter),this.onDidFinishSync=this._onDidFinishSync.event}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(s.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,p.disposableTimeout)(()=>this.sync(s.INTERVAL_SYNCING,!1),this.interval)}sync(o,l){const g=(0,p.createCancelablePromise)(async E=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(d){if((0,S.isPromiseCanceledError)(d))return}return this.doSync(o,l,E)});return this.syncPromise=g,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,C.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const o=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),l=this.userDataSyncStoreManagementService.userDataSyncStore;return!!l&&!!o&&(!(0,C.isEqual)(l.defaultUrl,o.defaultUrl)||!(0,C.isEqual)(l.insidersUrl,o.insidersUrl)||!(0,C.isEqual)(l.stableUrl,o.stableUrl))}async doSync(o,l,g){this.logService.info(`Auto Sync: Triggered by ${o}`),this._onDidStartSync.fire();let E;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(l),g.isCancellationRequested)return;let d=this.syncTask.manifest;if(d===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new k.UserDataAutoSyncError((0,m.localize)(0,null),k.UserDataSyncErrorCode.DefaultServiceChanged):new k.UserDataAutoSyncError((0,m.localize)(1,null),k.UserDataSyncErrorCode.ServiceChanged):new k.UserDataAutoSyncError((0,m.localize)(2,null),k.UserDataSyncErrorCode.TurnedOff);const T=this.storageService.get(a,0);if(T&&d&&T!==d.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new k.UserDataAutoSyncError((0,m.localize)(3,null),k.UserDataSyncErrorCode.DefaultServiceChanged):new k.UserDataAutoSyncError((0,m.localize)(4,null),k.UserDataSyncErrorCode.ServiceChanged):new k.UserDataAutoSyncError((0,m.localize)(5,null),k.UserDataSyncErrorCode.SessionExpired);const O=await this.userDataSyncMachinesService.getMachines(d||void 0);if(g.isCancellationRequested)return;const $=O.find(z=>z.isCurrent);if($?.disabled)throw new k.UserDataAutoSyncError((0,m.localize)(6,null),k.UserDataSyncErrorCode.TurnedOff);if(await this.syncTask.run(),d===null&&(d=await this.userDataSyncStoreService.manifest()),d&&d.session!==T&&this.storageService.store(a,d.session,0,1),g.isCancellationRequested)return;$||await this.userDataSyncMachinesService.addCurrentMachine(d||void 0)}catch(d){this.logService.error(d),E=d}this._onDidFinishSync.fire(E)}register(o){return super._register(o)}}s.INTERVAL_SYNCING="Interval"}),define(Z[201],ee([0,1,22,2,3,20,21,7]),function(K,e,p,L,P,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let S=class extends L.Disposable{constructor(n,y){super();this.storageService=n,this.telemetryService=y,this._onDidChangeResourceEnablement=new P.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(n.onDidChangeValue(m=>this.onDidStorageChange(m)))}isResourceEnabled(n){return this.storageService.getBoolean((0,p.getEnablementKey)(n),0,!0)}setResourceEnablement(n,y){if(this.isResourceEnabled(n)!==y){const m=(0,p.getEnablementKey)(n);this.telemetryService.publicLog2(m,{enabled:y}),this.storeResourceEnablement(m,y)}}getResourceSyncStateVersion(n){}storeResourceEnablement(n,y){this.storageService.store(n,y,0,R.isWeb?0:1)}onDidStorageChange(n){if(n.scope===0){const y=p.ALL_SYNC_RESOURCES.filter(m=>(0,p.getEnablementKey)(m)===n.key)[0];if(y){this._onDidChangeResourceEnablement.fire([y,this.isResourceEnabled(y)]);return}}}};S=fe([Y(0,k.IStorageService),Y(1,A.ITelemetryService)],S),e.UserDataSyncResourceEnablementService=S}),define(Z[202],ee([0,1,22,2,6,3,191,194,193,43,21,23,20,196,15,197,30,5,11]),function(K,e,p,L,P,k,A,R,S,w,n,y,m,v,h,C,D,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const f="sync.lastSyncTime";let a=class extends L.Disposable{constructor(i,s,u,o,l,g){super();this.userDataSyncStoreService=i,this.userDataSyncStoreManagementService=s,this.instantiationService=u,this.logService=o,this.telemetryService=l,this.storageService=g,this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new k.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new k.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(v.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(R.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(C.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(S.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(A.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(k.Event.any(...this.synchronisers.map(E=>k.Event.map(E.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(k.Event.any(...this.synchronisers.map(E=>k.Event.map(E.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(f,0,void 0),this.onDidChangeLocal=k.Event.any(...this.synchronisers.map(E=>k.Event.map(E.onDidChangeLocal,()=>E.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(i){await this.checkEnablement();const s=(0,D.generateUuid)();let u;try{const E=(0,p.createSyncHeaders)(s);i&&(E["Cache-Control"]="no-cache"),u=await this.userDataSyncStoreService.manifest(E)}catch(E){const d=p.UserDataSyncError.toUserDataSyncError(E);throw this.reportUserDataSyncError(d,s),d}let o=!1;const l=this;let g;return{manifest:u,run(){if(o)throw new Error("Can run a task only once");return g=(0,b.createCancelablePromise)(E=>l.sync(u,s,E)),g.finally(()=>g=void 0)},async stop(){if(g&&g.cancel(),l.status!=="idle")return l.stop()}}}async createManualSyncTask(){await this.checkEnablement();const i=(0,D.generateUuid)(),s=(0,p.createSyncHeaders)(i);let u;try{u=await this.userDataSyncStoreService.manifest(s)}catch(o){const l=p.UserDataSyncError.toUserDataSyncError(o);throw this.reportUserDataSyncError(l,i),l}return new c(i,u,s,this.synchronisers,this.logService)}async sync(i,s,u){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),u.isCancellationRequested)return;const o=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const l=(0,p.createSyncHeaders)(s);for(const g of this.synchronisers){if(u.isCancellationRequested)return;try{await g.sync(i,l)}catch(E){if(E instanceof p.UserDataSyncError)switch(E.code){case p.UserDataSyncErrorCode.TooLarge:throw new p.UserDataSyncError(E.message,E.code,g.resource);case p.UserDataSyncErrorCode.TooManyRequests:case p.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case p.UserDataSyncErrorCode.LocalTooManyRequests:case p.UserDataSyncErrorCode.Gone:case p.UserDataSyncErrorCode.UpgradeRequired:case p.UserDataSyncErrorCode.IncompatibleRemoteContent:case p.UserDataSyncErrorCode.IncompatibleLocalContent:throw E}const d=p.UserDataSyncError.toUserDataSyncError(E);this.reportUserDataSyncError(d,s),this.logService.error(E),this.logService.error(`${g.resource}: ${(0,w.toErrorMessage)(E)}`),this._syncErrors.push([g.resource,d])}}this.logService.info(`Sync done. Took ${new Date().getTime()-o}ms`),this.updateLastSyncTime()}catch(l){const g=p.UserDataSyncError.toUserDataSyncError(l);throw this.reportUserDataSyncError(g,s),g}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const i of this.synchronisers)try{i.status!=="idle"&&await i.stop()}catch(s){this.logService.error(s)}}async replace(i){await this.checkEnablement();for(const s of this.synchronisers)if(await s.replace(i))return}async accept(i,s,u,o){await this.checkEnablement();const l=this.getSynchroniser(i);await l.accept(s,u),o&&await l.apply(!1,(0,p.createSyncHeaders)((0,D.generateUuid)()))}async resolveContent(i){for(const s of this.synchronisers){const u=await s.resolveContent(i);if(u)return u}return null}getRemoteSyncResourceHandles(i){return this.getSynchroniser(i).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(i){return this.getSynchroniser(i).getLocalSyncResourceHandles()}getAssociatedResources(i,s){return this.getSynchroniser(i).getAssociatedResources(s)}getMachineId(i,s){return this.getSynchroniser(i).getMachineId(s)}async hasLocalData(){const i=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const s of i)if(await s.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(i){this.logService.error(i)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(f,0);for(const i of this.synchronisers)try{await i.resetLocal()}catch(s){this.logService.error(`${i.resource}: ${(0,w.toErrorMessage)(s)}`),this.logService.error(s)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const i of this.synchronisers)if(await i.hasPreviouslySynced())return!0;return!1}setStatus(i){const s=this._status;this._status!==i&&(this._status=i,this._onDidChangeStatus.fire(i),s==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const i=this.computeStatus();this.setStatus(i)}updateConflicts(){const i=this.computeConflicts();(0,y.equals)(this._conflicts,i,([s,u],[o,l])=>s===s&&(0,y.equals)(u,l,(g,E)=>(0,h.isEqual)(g.previewResource,E.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(i))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(f,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(i,s){this.telemetryService.publicLog2("sync/error",{code:i.code,url:i instanceof p.UserDataSyncStoreError?i.url:void 0,resource:i.resource,executionId:s,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(i=>i.status==="hasConflicts").map(i=>[i.resource,i.conflicts.map(t)])}getSynchroniser(i){return this.synchronisers.find(s=>s.resource===i)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};a=fe([Y(0,p.IUserDataSyncStoreService),Y(1,p.IUserDataSyncStoreManagementService),Y(2,P.IInstantiationService),Y(3,p.IUserDataSyncLogService),Y(4,n.ITelemetryService),Y(5,m.IStorageService)],a),e.UserDataSyncService=a;class c extends L.Disposable{constructor(i,s,u,o,l){super();this.id=i,this.manifest=s,this.syncHeaders=u,this.synchronisers=o,this.logService=l,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new k.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,b.createCancelablePromise)(i=>this.getPreviews(i))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(i){throw this.logService.error(i),i}}async accept(i,s){try{return await this.performAction(i,u=>u.accept(i,s))}catch(u){throw this.logService.error(u),u}}async merge(i){try{return i?await this.performAction(i,s=>s.merge(i)):await this.mergeAll()}catch(s){throw this.logService.error(s),s}}async discard(i){try{return await this.performAction(i,s=>s.discard(i))}catch(s){throw this.logService.error(s),s}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const i=[];for(const[,s]of this.previews)for(const u of s.resourcePreviews)u.mergeState==="conflict"&&i.push(u.previewResource);for(const s of i)await this.discard(s);return this.previews}catch(i){throw this.logService.error(i),i}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const i=[];for(const[s,u]of this.previews){this.synchronizingResources.push([s,u.resourcePreviews.map(g=>g.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const o=this.synchronisers.find(g=>g.resource===s);for(const g of u.resourcePreviews)(g.localChange!==0||g.remoteChange!==0)&&g.mergeState==="preview"&&await o.merge(g.previewResource);const l=await o.apply(!1,this.syncHeaders);l&&i.push(this.toSyncResourcePreview(o.resource,l)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(g=>g[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}catch(i){throw this.logService.error(i),i}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,s]of this.previews){this.synchronizingResources.push([i,s.resourcePreviews.map(o=>o.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(o=>o.resource===i);for(const o of s.resourcePreviews)await u.accept(o.remoteResource);await u.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(o=>o[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,s]of this.previews){this.synchronizingResources.push([i,s.resourcePreviews.map(o=>o.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(o=>o.resource===i);for(const o of s.resourcePreviews)await u.accept(o.localResource);await u.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(o=>o[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async stop(){for(const i of this.synchronisers)try{await i.stop()}catch(s){(0,I.isPromiseCanceledError)(s)||this.logService.error(s)}this.reset()}async performAction(i,s){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const u=this.previews.findIndex(([,$])=>$.resourcePreviews.some(({localResource:z,previewResource:G,remoteResource:V})=>(0,h.isEqual)(i,z)||(0,h.isEqual)(i,G)||(0,h.isEqual)(i,V)));if(u===-1)return this.previews;const[o,l]=this.previews[u],g=l.resourcePreviews.find(({localResource:$,remoteResource:z,previewResource:G})=>(0,h.isEqual)($,i)||(0,h.isEqual)(z,i)||(0,h.isEqual)(G,i));if(!g)return this.previews;let E=this.synchronizingResources.find($=>$[0]===o);E||(E=[o,[]],this.synchronizingResources.push(E)),E[1].some($=>(0,h.isEqual)($,g.localResource))||(E[1].push(g.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const d=this.synchronisers.find($=>$.resource===this.previews[u][0]),T=await s(d);T?this.previews.splice(u,1,this.toSyncResourcePreview(d.resource,T)):this.previews.splice(u,1);const O=this.synchronizingResources.findIndex($=>$[0]===o);return this.synchronizingResources[O][1].splice(E[1].findIndex($=>(0,h.isEqual)($,g.localResource)),1),E[1].length||(this.synchronizingResources.splice(O,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const i=[];for(const[s,u]of this.previews){this.synchronizingResources.push([s,u.resourcePreviews.map(g=>g.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const o=this.synchronisers.find(g=>g.resource===s);let l=u;for(const g of u.resourcePreviews)(g.localChange!==0||g.remoteChange!==0)&&g.mergeState==="preview"&&(l=await o.merge(g.previewResource));l&&i.push(this.toSyncResourcePreview(o.resource,l)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(g=>g[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}async getPreviews(i){const s=[];for(const u of this.synchronisers){if(i.isCancellationRequested)return[];const o=await u.preview(this.manifest,this.syncHeaders);o&&s.push(this.toSyncResourcePreview(u.resource,o))}return s}toSyncResourcePreview(i,s){return[i,{isLastSyncFromCurrentMachine:s.isLastSyncFromCurrentMachine,resourcePreviews:s.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(r){return{localResource:r.localResource,previewResource:r.previewResource,remoteResource:r.remoteResource,acceptedResource:r.acceptedResource,localChange:r.localChange,remoteChange:r.remoteChange,mergeState:r.mergeState}}}),define(Z[203],ee([0,1,3,22,4,2,16]),function(K,e,p,L,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class R{constructor(y,m){this.service=y,this.logService=m,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new p.Emitter}listen(y,m){switch(m){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${m}`)}async call(y,m,v){try{return await this._call(y,m,v)}catch(h){throw this.logService.error(h),h}}async _call(y,m,v){switch(m){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(P.URI.revive(v[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(v[0],P.URI.revive(v[1]),v[2],v[3]);case"resolveContent":return this.service.resolveContent(P.URI.revive(v[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(v[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(v[0]);case"getAssociatedResources":return this.service.getAssociatedResources(v[0],{created:v[1].created,uri:P.URI.revive(v[1].uri)});case"getMachineId":return this.service.getMachineId(v[0],{created:v[1].created,uri:P.URI.revive(v[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(m.startsWith("manualSync/")){const h=m.substring("manualSync/".length),C=v[0],D=this.getManualSyncTask(C);switch(v=v.slice(1),h){case"preview":return D.preview();case"accept":return D.accept(P.URI.revive(v[0]),v[1]);case"merge":return D.merge(P.URI.revive(v[0]));case"discard":return D.discard(P.URI.revive(v[0]));case"discardConflicts":return D.discardConflicts();case"apply":return D.apply();case"pull":return D.pull();case"push":return D.push();case"stop":return D.stop();case"_getStatus":return D.status;case"dispose":return this.disposeManualSyncTask(D)}}throw new Error("Invalid call")}getManualSyncTask(y){const m=this.manualSyncTasks.get(this.createKey(y));if(!m)throw new Error(`Manual sync taks not found: ${y}`);return m.manualSyncTask}async createManualSyncTask(){const y=new k.DisposableStore,m=y.add(await this.service.createManualSyncTask());return y.add(m.onSynchronizeResources(v=>this.onManualSynchronizeResources.fire({manualSyncTaskId:m.id,data:v}))),this.manualSyncTasks.set(this.createKey(m.id),{manualSyncTask:m,disposables:y}),{id:m.id,manifest:m.manifest,status:m.status}}disposeManualSyncTask(y){y.dispose();const m=this.createKey(y.id);this.manualSyncTasks.get(m)?.disposables.dispose(),this.manualSyncTasks.delete(m)}createKey(y){return`manualSyncTask-${y}`}}e.UserDataSyncChannel=R;class S extends k.Disposable{constructor(y){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new p.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new p.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new p.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new p.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(m,v,h){return y.call(m,v,h).then(null,C=>{throw L.UserDataSyncError.toUserDataSyncError(C)})},listen(m,v){return y.listen(m,v)}},this.channel.call("_getInitialData").then(([m,v,h])=>{this.updateStatus(m),this.updateConflicts(v),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(C=>this.updateStatus(C))),this._register(this.channel.listen("onDidChangeLastSyncTime")(C=>this.updateLastSyncTime(C)))}),this._register(this.channel.listen("onDidChangeConflicts")(m=>this.updateConflicts(m))),this._register(this.channel.listen("onSyncErrors")(m=>this._onSyncErrors.fire(m.map(([v,h])=>[v,L.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:y,manifest:m,status:v}=await this.channel.call("createManualSyncTask"),h=this,C=new w(y,m,v,{async call(D,b,I){return h.channel.call(`manualSync/${D}`,[y,...(0,A.isArray)(b)?b:[b]],I)},listen(D,b){return p.Event.map(p.Event.filter(h.channel.listen(`manualSync/${D}`,b),I=>!C.isDiposed()&&I.manualSyncTaskId===y),I=>I.data)}});return C}replace(y){return this.channel.call("replace",[y])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(y,m,v,h){return this.channel.call("accept",[y,m,v,h])}resolveContent(y){return this.channel.call("resolveContent",[y])}async getLocalSyncResourceHandles(y){return(await this.channel.call("getLocalSyncResourceHandles",[y])).map(({created:v,uri:h})=>({created:v,uri:P.URI.revive(h)}))}async getRemoteSyncResourceHandles(y){return(await this.channel.call("getRemoteSyncResourceHandles",[y])).map(({created:v,uri:h})=>({created:v,uri:P.URI.revive(h)}))}async getAssociatedResources(y,m){return(await this.channel.call("getAssociatedResources",[y,m])).map(({resource:h,comparableResource:C})=>({resource:P.URI.revive(h),comparableResource:P.URI.revive(C)}))}async getMachineId(y,m){return this.channel.call("getMachineId",[y,m])}async updateStatus(y){this._status=y,this._onDidChangeStatus.fire(y)}async updateConflicts(y){this._conflicts=y.map(([m,v])=>[m,v.map(h=>({...h,localResource:P.URI.revive(h.localResource),remoteResource:P.URI.revive(h.remoteResource),previewResource:P.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(y){this._lastSyncTime!==y&&(this._lastSyncTime=y,this._onDidChangeLastSyncTime.fire(y))}}e.UserDataSyncChannelClient=S;class w extends k.Disposable{constructor(y,m,v,h){super();this.id=y,this.manifest=m,this._disposed=!1,this._status=v;const C=this;this.channel={async call(D,b,I){try{const f=await h.call(D,b,I);return C.isDiposed()||(C._status=await h.call("_getStatus")),f}catch(f){throw L.UserDataSyncError.toUserDataSyncError(f)}},listen(D,b){return h.listen(D,b)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const y=await this.channel.call("preview");return this.deserializePreviews(y)}async accept(y,m){const v=await this.channel.call("accept",[y,m]);return this.deserializePreviews(v)}async merge(y){const m=await this.channel.call("merge",[y]);return this.deserializePreviews(m)}async discard(y){const m=await this.channel.call("discard",[y]);return this.deserializePreviews(m)}async discardConflicts(){const y=await this.channel.call("discardConflicts");return this.deserializePreviews(y)}async apply(){const y=await this.channel.call("apply");return this.deserializePreviews(y)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(y){return y.map(([m,v])=>[m,{isLastSyncFromCurrentMachine:v.isLastSyncFromCurrentMachine,resourcePreviews:v.resourcePreviews.map(h=>({...h,localResource:P.URI.revive(h.localResource),remoteResource:P.URI.revive(h.remoteResource),previewResource:P.URI.revive(h.previewResource),acceptedResource:P.URI.revive(h.acceptedResource)}))}])}}}),define(Z[204],ee([0,1,2,22,39,15,29,24,28,45,9,14,20,30,7,3,5,16,4,11,93]),function(K,e,p,L,P,k,A,R,S,w,n,y,m,v,h,C,D,b,I,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const c="sync.previous.store",t="sync.donot-make-requests-until",r="sync.user-session-id",i="sync.machine-session-id",s=100,u=1e3*60*5;let o=class extends p.Disposable{constructor(O,$,z){super();this.productService=O,this.configurationService=$,this.storageService=z,this._onDidChangeUserDataSyncStore=this._register(new C.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(C.Event.filter(z.onDidChangeValue,G=>G.key===L.SYNC_SERVICE_URL_TYPE&&G.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(L.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(L.SYNC_SERVICE_URL_TYPE,O,0,h.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[L.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(L.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,$){O=h.isWeb&&O?.web?{...O,...O.web}:O;const z={...O||{},...$||{}};if(z&&(0,b.isString)(z.url)&&(0,b.isObject)(z.authenticationProviders)&&Object.keys(z.authenticationProviders).every(G=>(0,b.isArray)(z.authenticationProviders[G].scopes))){const G=z,V=!!G.canSwitch&&!$?.url,U=G.url===G.insidersUrl?"insiders":"stable",M=(V?this.userDataSyncStoreType:void 0)||U,F=$?.url||(M==="insiders"?G.insidersUrl:M==="stable"?G.stableUrl:G.url);return{url:I.URI.parse(F),type:M,defaultType:U,defaultUrl:I.URI.parse(G.url),stableUrl:I.URI.parse(G.stableUrl),insidersUrl:I.URI.parse(G.insidersUrl),canSwitch:V,authenticationProviders:Object.keys(G.authenticationProviders).reduce((j,_)=>(j.push({id:_,scopes:G.authenticationProviders[_].scopes}),j),[])}}}};o=fe([Y(0,S.IProductService),Y(1,R.IConfigurationService),Y(2,m.IStorageService)],o),e.AbstractUserDataSyncStoreManagementService=o;let l=class extends o{constructor(O,$,z){super(O,$,z);const G=this.storageService.get(c,0);G&&(this.previousConfigurationSyncStore=JSON.parse(G));const V=this.productService[L.CONFIGURATION_SYNC_STORE_KEY];V?this.storageService.store(c,JSON.stringify(V),0,1):this.storageService.remove(c,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};l=fe([Y(0,S.IProductService),Y(1,R.IConfigurationService),Y(2,m.IStorageService)],l),e.UserDataSyncStoreManagementService=l;let g=class extends p.Disposable{constructor(O,$,z,G,V,U,M){super();this.requestService=z,this.logService=G,this.storageService=M,this._onTokenFailed=this._register(new C.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new C.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new C.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,w.getServiceMachineId)(V,U,M).then(F=>{const j={"X-Client-Name":`${$.applicationName}${h.isWeb?"-web":""}`,"X-Client-Version":$.version,"X-Machine-Id":F};return $.commit&&(j["X-Client-Commit"]=$.commit),j}),this.session=new d(s,u,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,p.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,$){this.authToken={token:O,type:$}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,k.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(t,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)($=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),$).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,$=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O),z={},G=await this.request($.toString(),{type:"GET",headers:z},[],A.CancellationToken.None);return(await(0,P.asJson)(G)||[]).map(({url:U,created:M})=>({ref:(0,k.relativePath)($,$.with({path:U})),created:M*1e3}))}async resolveContent(O,$){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O,$).toString(),G={};G["Cache-Control"]="no-cache";const V=await this.request(z,{type:"GET",headers:G},[],A.CancellationToken.None);return await(0,P.asText)(V)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),z={};await this.request($,{type:"DELETE",headers:z},[],A.CancellationToken.None)}async read(O,$,z={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const G=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();z={...z},z["Cache-Control"]="no-cache",$&&(z["If-None-Match"]=$.ref);const V=await this.request(G,{type:"GET",headers:z},[304],A.CancellationToken.None);if(V.res.statusCode===304)return $;const U=V.res.headers.etag;if(!U)throw new L.UserDataSyncStoreError("Server did not return the ref",G,L.UserDataSyncErrorCode.NoRef,V.res.headers[L.HEADER_OPERATION_ID]);const M=await(0,P.asText)(V);return{ref:U,content:M}}async write(O,$,z,G={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const V=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();G={...G},G["Content-Type"]=a.Mimes.text,z&&(G["If-Match"]=z);const U=await this.request(V,{type:"POST",data:$,headers:G},[],A.CancellationToken.None),M=U.res.headers.etag;if(!M)throw new L.UserDataSyncStoreError("Server did not return the ref",V,L.UserDataSyncErrorCode.NoRef,U.res.headers[L.HEADER_OPERATION_ID]);return M}async manifest(O={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,k.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();O={...O},O["Content-Type"]="application/json";const z=await this.request($,{type:"GET",headers:O},[],A.CancellationToken.None),G=await(0,P.asJson)(z),V=this.storageService.get(r,0);return V&&G&&V!==G.session&&this.clearSession(),G===null&&V&&this.clearSession(),G&&this.storageService.store(r,G.session,0,1),G}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),$={"Content-Type":a.Mimes.text};await this.request(O,{type:"DELETE",headers:$},[],A.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(r,0),this.storageService.remove(i,0)}async request(O,$,z,G){if(!this.authToken)throw new L.UserDataSyncStoreError("No Auth Token Available",O,L.UserDataSyncErrorCode.Unauthorized,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new L.UserDataSyncStoreError(`${$.type} request '${O}' failed because of too many requests (429).`,O,L.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0);this.setDonotMakeRequestsUntil(void 0);const V=await this.commonHeadersPromise;$.headers={...$.headers||{},...V,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders($.headers),this.logService.trace("Sending request to server",{url:O,type:$.type,headers:{...$.headers,authorization:void 0}});let U;try{U=await this.session.request(O,$,G)}catch(_){if(!(_ instanceof L.UserDataSyncStoreError)){const N=(0,f.isPromiseCanceledError)(_)?L.UserDataSyncErrorCode.RequestCanceled:(0,f.getErrorMessage)(_).startsWith("XHR timeout")?L.UserDataSyncErrorCode.RequestTimeout:L.UserDataSyncErrorCode.RequestFailed;_=new L.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,N,void 0)}throw this.logService.info("Request failed",O),_}const M=U.res.headers[L.HEADER_OPERATION_ID],F={url:O,status:U.res.statusCode,"execution-id":$.headers[L.HEADER_EXECUTION_ID],"operation-id":M},j=(0,P.isSuccess)(U)||U.res.statusCode&&z.indexOf(U.res.statusCode)!==-1;if(j?this.logService.trace("Request succeeded",F):this.logService.info("Request failed",F),U.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new L.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,L.UserDataSyncErrorCode.Unauthorized,M);if(this._onTokenSucceed.fire(),U.res.statusCode===409)throw new L.UserDataSyncStoreError(`${$.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,L.UserDataSyncErrorCode.Conflict,M);if(U.res.statusCode===410)throw new L.UserDataSyncStoreError(`${$.type} request '${O}' failed because the requested resource is not longer available (410).`,O,L.UserDataSyncErrorCode.Gone,M);if(U.res.statusCode===412)throw new L.UserDataSyncStoreError(`${$.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,L.UserDataSyncErrorCode.PreconditionFailed,M);if(U.res.statusCode===413)throw new L.UserDataSyncStoreError(`${$.type} request '${O}' failed because of too large payload (413).`,O,L.UserDataSyncErrorCode.TooLarge,M);if(U.res.statusCode===426)throw new L.UserDataSyncStoreError(`${$.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,L.UserDataSyncErrorCode.UpgradeRequired,M);if(U.res.statusCode===429){const _=U.res.headers["retry-after"];throw _?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(_)*1e3)),new L.UserDataSyncStoreError(`${$.type} request '${O}' failed because of too many requests (429).`,O,L.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,M)):new L.UserDataSyncStoreError(`${$.type} request '${O}' failed because of too many requests (429).`,O,L.UserDataSyncErrorCode.TooManyRequests,M)}if(!j)throw new L.UserDataSyncStoreError("Server returned "+U.res.statusCode,O,L.UserDataSyncErrorCode.Unknown,M);return U}addSessionHeaders(O){let $=this.storageService.get(i,0);$===void 0&&($=(0,v.generateUuid)(),this.storageService.store(i,$,0,1)),O["X-Machine-Session-Id"]=$;const z=this.storageService.get(r,0);z!==void 0&&(O["X-User-Session-Id"]=z)}};g=fe([Y(1,S.IProductService),Y(2,P.IRequestService),Y(3,L.IUserDataSyncLogService),Y(4,n.IEnvironmentService),Y(5,y.IFileService),Y(6,m.IStorageService)],g),e.UserDataSyncStoreClient=g;let E=class extends g{constructor(O,$,z,G,V,U,M){super(O.userDataSyncStore?.url,$,z,G,V,U,M);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};E=fe([Y(0,L.IUserDataSyncStoreManagementService),Y(1,S.IProductService),Y(2,P.IRequestService),Y(3,L.IUserDataSyncLogService),Y(4,n.IEnvironmentService),Y(5,y.IFileService),Y(6,m.IStorageService)],E),e.UserDataSyncStoreService=E;class d{constructor(O,$,z,G){this.limit=O,this.interval=$,this.requestService=z,this.logService=G,this.requests=[],this.startTime=void 0}request(O,$,z){if(this.isExpired()&&this.reset(),$.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new L.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,L.UserDataSyncErrorCode.LocalTooManyRequests,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request($,z)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=d}),define(Z[205],ee([0,1,22,3,59,87,60,21,20,61,28]),function(K,e,p,L,P,k,A,R,S,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let y=class extends k.UserDataAutoSyncService{constructor(v,h,C,D,b,I,f,a,c,t,r,i){super(v,h,C,D,b,f,a,c,t,r,i);this._register(L.Event.debounce(L.Event.any(L.Event.map(I.onDidFocusWindow,()=>"windowFocus"),L.Event.map(I.onDidOpenWindow,()=>"windowOpen")),(s,u)=>s?[...s,u]:[u],1e3)(s=>this.triggerSync(s,!0,!1)))}};y=fe([Y(0,n.IProductService),Y(1,p.IUserDataSyncStoreManagementService),Y(2,p.IUserDataSyncStoreService),Y(3,p.IUserDataSyncResourceEnablementService),Y(4,p.IUserDataSyncService),Y(5,P.INativeHostService),Y(6,p.IUserDataSyncLogService),Y(7,A.IUserDataSyncAccountService),Y(8,R.ITelemetryService),Y(9,w.IUserDataSyncMachinesService),Y(10,S.IStorageService),Y(11,p.IUserDataAutoSyncEnablementService)],y),e.UserDataAutoSyncService=y}),define(Z[206],ee([0,1,3,2,5]),function(K,e,p,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class k extends L.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:S,getActiveWindowId:w}){super();this.disposables=this._register(new L.DisposableStore),p.Event.latch(p.Event.any(R,S))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,P.createCancelablePromise)(()=>w()),(async()=>{try{const y=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:y}catch(y){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=k}),define(Z[62],ee([0,1,109,8,49,5,18,213,214,16]),function(K,e,p,L,P,k,A,R,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class n extends Error{constructor(t,r){let i=r.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=t,this.cause=r}}e.ExtractError=n;function y(c){const t=c.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,i)=>r+i,t&61440)}function m(c){if(c instanceof n)return c;let t;return/end of central directory record signature not found/.test(c.message)&&(t="CorruptZip"),new n(t,c)}function v(c,t,r,i,s,u){const o=L.dirname(t),l=L.join(i,o);if(!l.startsWith(i))return Promise.reject(new Error(p.localize(0,null,t)));const g=L.join(i,t);let E;return u.onCancellationRequested(()=>{E&&E.destroy()}),Promise.resolve(A.Promises.mkdir(l,{recursive:!0})).then(()=>new Promise((d,T)=>{if(!u.isCancellationRequested)try{E=(0,P.createWriteStream)(g,{mode:r}),E.once("close",()=>d()),E.once("error",T),c.once("error",T),c.pipe(E)}catch(O){T(O)}}))}function h(c,t,r,i){let s=(0,k.createCancelablePromise)(()=>Promise.resolve()),u=0;return i.onCancellationRequested(()=>{s.cancel(),c.close()}),new Promise((o,l)=>{const g=new k.Sequencer,E=d=>{d.isCancellationRequested||(u++,c.readEntry())};c.once("error",l),c.once("close",()=>s.then(()=>{i.isCancellationRequested||c.entryCount===u?o():l(new n("Incomplete",new Error(p.localize(1,null,u,c.entryCount))))},l)),c.readEntry(),c.on("entry",d=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(d.fileName)){E(i);return}const T=d.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(T)){const z=L.join(t,T);s=(0,k.createCancelablePromise)(G=>A.Promises.mkdir(z,{recursive:!0}).then(()=>E(G)).then(void 0,l));return}const O=D(c,d),$=y(d);s=(0,k.createCancelablePromise)(z=>g.queue(()=>O.then(G=>v(G,T,$,t,r,z).then(()=>E(z)))).then(null,l))})})}function C(c,t=!1){return new Promise((r,i)=>{(0,R.open)(c,t?{lazyEntries:!0}:void 0,(s,u)=>{s?i(m(s)):r((0,w.assertIsDefined)(u))})})}function D(c,t){return new Promise((r,i)=>{c.openReadStream(t,(s,u)=>{s?i(m(s)):r((0,w.assertIsDefined)(u))})})}function b(c,t){return new Promise((r,i)=>{const s=new S.ZipFile;t.forEach(o=>{o.contents?s.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&s.addFile(o.localPath,o.path)}),s.end();const u=(0,P.createWriteStream)(c);s.outputStream.pipe(u),s.outputStream.once("error",i),u.once("error",i),u.once("finish",()=>r(c))})}e.zip=b;function I(c,t,r={},i){const s=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let u=C(c,!0);return r.overwrite&&(u=u.then(o=>A.Promises.rm(t).then(()=>o))),u.then(o=>h(o,t,{sourcePathRegex:s},i))}e.extract=I;function f(c,t){return C(c).then(r=>new Promise((i,s)=>{r.on("entry",u=>{u.fileName===t&&D(r,u).then(o=>i(o),o=>s(o))}),r.once("close",()=>s(new Error(p.localize(2,null,t))))}))}function a(c,t){return f(c,t).then(r=>new Promise((i,s)=>{const u=[];r.once("error",s),r.on("data",o=>u.push(o)),r.on("end",()=>i(Buffer.concat(u)))}))}e.buffer=a}),define(Z[207],ee([0,1,62,115]),function(K,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function P(k){return(0,p.buffer)(k,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch(R){throw new Error((0,L.localize)(0,null))}})}e.getManifest=P}),define(Z[208],ee([0,1,58,2,18,8,10,27,31,5,4,9,136,116,28,62,7,23,17,14,15,30,11]),function(K,e,p,L,P,k,A,R,S,w,n,y,m,v,h,C,D,b,I,f,a,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const r="scanningSystem",i="scanningUser",s="extracting",u="deleting",o="renaming";let l=class extends L.Disposable{constructor(E,d,T,O,$){super();this.beforeRemovingExtension=E,this.fileService=d,this.logService=T,this.environmentService=O,this.productService=$,this._devSystemExtensionsPath=null,this.systemExtensionsPath=O.builtinExtensionsPath,this.extensionsPath=O.extensionsPath,this.uninstalledPath=k.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new w.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(E){const d=[];(E===null||E===0)&&d.push(this.scanSystemExtensions().then(null,T=>Promise.reject(new R.ExtensionManagementError(this.joinErrors(T).message,r)))),(E===null||E===1)&&d.push(this.scanUserExtensions(!0).then(null,T=>Promise.reject(new R.ExtensionManagementError(this.joinErrors(T).message,i))));try{const T=await Promise.all(d);return(0,b.flatten)(T)}catch(T){throw this.joinErrors(T)}}async scanUserExtensions(E){this.logService.trace("Started scanning user extensions");let[d,T]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return T=T.filter(O=>!d[new S.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).key()]),E&&(T=(0,S.groupByExtension)(T,$=>$.identifier).map($=>$.sort((z,G)=>p.rcompare(z.manifest.version,G.manifest.version))[0])),this.logService.trace("Scanned user extensions:",T.length),T}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(E,d,T){const O=E.key(),$=k.join(this.extensionsPath,`.${(0,c.generateUuid)()}`),z=k.join(this.extensionsPath,O);try{await P.Promises.rm(z)}catch(V){try{await P.Promises.rm(z)}catch(U){}throw new R.ExtensionManagementError((0,v.localize)(0,null,z,E.id),u)}await this.extractAtLocation(E,d,$,T);let G=await this.scanExtension(n.URI.file($),1);if(!G)throw new Error((0,v.localize)(1,null,$));await this.storeMetadata(G,{installedTimestamp:Date.now()});try{await this.rename(E,$,z,Date.now()+2*60*1e3),this.logService.info("Renamed to",z)}catch(V){try{await P.Promises.rm($)}catch(U){}if(V.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",E.id);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(V)}. Deleted from extracted location`,$),V}try{G=await this.scanExtension(n.URI.file(z),1)}catch(V){}if(G)return G;throw new Error((0,v.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(E,d){return this.setMetadata(E,d),await this.storeMetadata(E,{...d,installedTimestamp:E.installedTimestamp}),E}async storeMetadata(E,d){d.isMachineScoped=d.isMachineScoped||void 0,d.isBuiltin=d.isBuiltin||void 0,d.installedTimestamp=d.installedTimestamp||void 0;const T=k.join(E.location.fsPath,"package.json"),O=await P.Promises.readFile(T,"utf8"),{manifest:$}=await this.parseManifest(O);return $.__metadata=d,await P.Promises.writeFile(T,JSON.stringify($,null,"	")),E}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...E){const d=E.map(T=>new S.ExtensionIdentifierWithVersion(T.identifier,T.manifest.version));await this.withUninstalledExtensions(T=>{d.forEach(O=>T[O.key()]=!0)})}async setInstalled(E){await this.withUninstalledExtensions(O=>delete O[E.key()]);const T=(await this.scanExtensions(1)).find(O=>new S.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).equals(E))||null;return T?(await this.storeMetadata(T,{installedTimestamp:Date.now()}),this.scanExtension(T.location,1)):null}async withUninstalledExtensions(E){return this.uninstalledFileLimiter.queue(async()=>{let d;try{d=await P.Promises.readFile(this.uninstalledPath,"utf8")}catch(O){if(O.code!=="ENOENT")throw O}let T={};if(d)try{T=JSON.parse(d)}catch(O){}return E&&(E(T),Object.keys(T).length?await P.Promises.writeFile(this.uninstalledPath,JSON.stringify(T)):await P.Promises.rm(this.uninstalledPath)),T})}async removeExtension(E,d){this.logService.trace(`Deleting ${d} extension from disk`,E.identifier.id,E.location.fsPath),await P.Promises.rm(E.location.fsPath),this.logService.info("Deleted from disk",E.identifier.id,E.location.fsPath)}async removeUninstalledExtension(E){await this.removeExtension(E,"uninstalled"),await this.withUninstalledExtensions(d=>delete d[new S.ExtensionIdentifierWithVersion(E.identifier,E.manifest.version).key()])}async extractAtLocation(E,d,T,O){this.logService.trace(`Started extracting the extension from ${d} to ${T}`);try{await P.Promises.rm(T)}catch($){throw new R.ExtensionManagementError(this.joinErrors($).message,u)}try{await(0,C.extract)(d,T,{sourcePath:"extension",overwrite:!0},O),this.logService.info(`Extracted extension to ${T}:`,E.id)}catch($){try{await P.Promises.rm(T)}catch(z){}throw new R.ExtensionManagementError($.message,$ instanceof C.ExtractError&&$.type?$.type:s)}}async rename(E,d,T,O){try{await P.Promises.rename(d,T)}catch($){if(D.isWindows&&$&&$.code==="EPERM"&&Date.now()<O)return this.logService.info(`Failed renaming ${d} to ${T} with 'EPERM' error. Trying again...`,E.id),this.rename(E,d,T,O);throw new R.ExtensionManagementError($.message||(0,v.localize)(3,null,d,T),$.code||o)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const E=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return E;const d=this.scanDevSystemExtensions(),[T,O]=await Promise.all([E,d]);return[...T,...O]}async scanExtensionsInDir(E,d){const T=new w.Limiter(10),O=await this.fileService.resolve(n.URI.file(E));return O.children?(await Promise.all(O.children.filter(z=>z.isDirectory).map(z=>T.queue(async()=>d===1&&(0,a.basename)(z.resource).indexOf(".")===0?null:this.scanExtension(z.resource,d))))).filter(z=>z&&z.identifier):[]}async scanExtension(E,d){try{const T=await this.fileService.resolve(E);if(T.children){const{manifest:O,metadata:$}=await this.readManifest(E.fsPath),z=T.children.find(({name:M})=>/^readme(\.txt|\.md|)$/i.test(M))?.resource,G=T.children.find(({name:M})=>/^changelog(\.txt|\.md|)$/i.test(M))?.resource,V={id:(0,S.getGalleryExtensionId)(O.publisher,O.name)},U={type:d,identifier:V,manifest:O,location:E,readmeUrl:z,changelogUrl:G,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:d===0};return $&&(this.setMetadata(U,$),U.installedTimestamp=$.installedTimestamp),U}}catch(T){d!==0&&this.logService.trace(T)}return null}async scanDefaultSystemExtensions(){const E=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",E.length),E}async scanDevSystemExtensions(){const E=this.getDevSystemExtensionsList();if(E.length){const d=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",d.length),d.filter(T=>E.some(O=>(0,S.areSameExtensions)(T.identifier,{id:O})))}else return[]}setMetadata(E,d){E.publisherDisplayName=d.publisherDisplayName||null,E.publisherId=d.publisherId||null,E.identifier.uuid=d.id,E.isMachineScoped=!!d.isMachineScoped,E.isBuiltin=E.type===0||!!d.isBuiltin}async removeUninstalledExtensions(){const E=await this.getUninstalledExtensions(),d=await this.scanAllUserExtensions(),T=new Set;for(const z of d)E[new S.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version).key()]||T.add(z.identifier.id.toLowerCase());const O=(0,S.groupByExtension)(d,z=>z.identifier);await w.Promises.settled(O.map(async z=>{const G=z.sort((V,U)=>p.rcompare(V.manifest.version,U.manifest.version))[0];T.has(G.identifier.id.toLowerCase())||await this.beforeRemovingExtension(G)}));const $=d.filter(z=>E[new S.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version).key()]);await w.Promises.settled($.map(z=>this.removeUninstalledExtension(z)))}async removeOutdatedExtensions(){const E=await this.scanAllUserExtensions(),d=[],T=(0,S.groupByExtension)(E,O=>O.identifier);d.push(...(0,b.flatten)(T.map(O=>O.sort(($,z)=>p.rcompare($.manifest.version,z.manifest.version)).slice(1)))),await w.Promises.settled(d.map(O=>this.removeExtension(O,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(E=>E.name)}joinErrors(E){const d=Array.isArray(E)?E:[E];return d.length===1?d[0]instanceof Error?d[0]:new Error(d[0]):d.reduce((T,O)=>new Error(`${T.message}${T.message?",":""}${O instanceof Error?O.message:O}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=k.normalize(k.join(I.FileAccess.asFileUri("",K).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(E){const d=[P.Promises.readFile(k.join(E,"package.json"),"utf8").then(z=>this.parseManifest(z)),P.Promises.readFile(k.join(E,"package.nls.json"),"utf8").then(void 0,z=>z.code!=="ENOENT"?Promise.reject(z):"{}").then(z=>JSON.parse(z))],[{manifest:T,metadata:O},$]=await Promise.all(d);return{manifest:(0,m.localizeManifest)(T,$),metadata:O}}parseManifest(E){return new Promise((d,T)=>{try{const O=JSON.parse(E),$=O.__metadata||null;d({manifest:O,metadata:$})}catch(O){T(new Error((0,v.localize)(4,null)))}})}};l=fe([Y(1,f.IFileService),Y(2,A.ILogService),Y(3,y.INativeEnvironmentService),Y(4,h.IProductService)],l),e.ExtensionsScanner=l}),define(Z[209],ee([0,1,114,8,18,62,27,31,9,58,4,44,7,10,147,43,21,70,15,30,72,6,17,207,157,208,158,159,14,176]),function(K,e,p,L,P,k,A,R,S,w,n,y,m,v,h,C,D,b,I,f,a,c,t,r,i,s,u,o,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const E="unsetUninstalled",d="downloading";let T=class extends g.AbstractExtensionManagementService{constructor(U,M,F,j,_,N,W){super(U,M,F);this.environmentService=j,this.downloadService=_;const x=this._register(N.createInstance(u.ExtensionsLifecycle));this.extensionsScanner=this._register(N.createInstance(s.ExtensionsScanner,H=>x.postUninstall(H))),this.manifestCache=this._register(new h.ExtensionsManifestCache(j,this)),this.extensionsDownloader=this._register(N.createInstance(i.ExtensionsDownloader));const B=this._register(new o.ExtensionsWatcher(this,W,j,F));this._register(B.onDidChangeExtensionsByAnotherSource(({added:H,removed:X})=>{H.length&&this._onDidInstallExtensions.fire(H.map(Q=>({identifier:Q.identifier,operation:0,local:Q}))),X.forEach(Q=>this._onDidUninstallExtension.fire({identifier:Q}))}))}async zip(U){this.logService.trace("ExtensionManagementService#zip",U.identifier.id);const M=await this.collectFiles(U),F=await(0,k.zip)((0,I.joinPath)(this.environmentService.tmpDir,(0,f.generateUuid)()).fsPath,M);return n.URI.file(F)}async unzip(U){return this.logService.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const M=await this.downloadVsix(U),F=L.resolve(M.fsPath);return(0,r.getManifest)(F)}getInstalled(U=null){return this.extensionsScanner.scanExtensions(U)}async canInstall(U){return!0}async install(U,M={}){this.logService.trace("ExtensionManagementService#install",U.toString());const F=await this.downloadVsix(U),j=await(0,r.getManifest)(L.resolve(F.fsPath));if(j.engines&&j.engines.vscode&&!(0,b.isEngineValid)(j.engines.vscode,y.default.version,y.default.date))throw new Error(p.localize(0,null,(0,R.getGalleryExtensionId)(j.publisher,j.name),y.default.version));return this.installExtension(j,F,M)}async updateMetadata(U,M){return this.logService.trace("ExtensionManagementService#updateMetadata",U.identifier.id),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},...M}),this.manifestCache.invalidate(),U}async updateExtensionScope(U,M){return this.logService.trace("ExtensionManagementService#updateExtensionScope",U.identifier.id),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},isMachineScoped:M}),this.manifestCache.invalidate(),U}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(U){if(U.scheme===t.Schemas.file)return U;if(!this.downloadService)throw new Error("Download service is not available");const M=(0,I.joinPath)(this.environmentService.tmpDir,(0,f.generateUuid)());return await this.downloadService.download(U,M),M}createInstallExtensionTask(U,M,F){return n.URI.isUri(M)?new z(U,M,F,this.galleryService,this.extensionsScanner,this.logService):new $(M,F,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(U,M){return new G(U,M,this.extensionsScanner)}async collectFiles(U){const M=async j=>{let _=await P.Promises.readdir(j);_=_.map(x=>L.join(j,x));const N=await Promise.all(_.map(x=>P.Promises.stat(x)));let W=Promise.resolve([]);return N.forEach((x,B)=>{const H=_[B];x.isFile()&&(W=W.then(X=>[...X,H])),x.isDirectory()&&(W=W.then(X=>M(H).then(Q=>[...X,...Q])))}),W};return(await M(U.location.fsPath)).map(j=>({path:`extension/${L.relative(U.location.fsPath,j)}`,localPath:j}))}};T=fe([Y(0,A.IExtensionGalleryService),Y(1,D.ITelemetryService),Y(2,v.ILogService),Y(3,S.INativeEnvironmentService),Y(4,(0,c.optional)(a.IDownloadService)),Y(5,c.IInstantiationService),Y(6,l.IFileService)],T),e.ExtensionManagementService=T;class O extends g.AbstractExtensionTask{constructor(U,M,F,j){super();this.identifier=U,this.source=M,this.extensionsScanner=F,this.logService=j,this._operation=1}get operation(){return this._operation}async installExtension(U,M){try{const F=await this.unsetUninstalledAndGetLocal(U.identifierWithVersion);if(F)return U.metadata?this.extensionsScanner.saveMetadataForLocalExtension(F,U.metadata):F}catch(F){throw m.isMacintosh?new A.ExtensionManagementError(p.localize(1,null),E):new A.ExtensionManagementError(p.localize(2,null),E)}return this.extract(U,M)}async unsetUninstalledAndGetLocal(U){if(!await this.isUninstalled(U))return null;this.logService.trace("Removing the extension from uninstalled list:",U.id);const F=await this.extensionsScanner.setInstalled(U);return this.logService.info("Removed the extension from uninstalled list:",U.id),F}async isUninstalled(U){return!!(await this.extensionsScanner.getUninstalledExtensions())[U.key()]}async extract({zipPath:U,identifierWithVersion:M,metadata:F},j){let _=await this.extensionsScanner.extractUserExtension(M,U,j);return this.logService.info("Extracting completed.",M.id),F&&(_=await this.extensionsScanner.saveMetadataForLocalExtension(_,F)),_}}class $ extends O{constructor(U,M,F,j,_){super(U.identifier,U,j,_);this.gallery=U,this.options=M,this.extensionsDownloader=F}async doRun(U){const F=(await this.extensionsScanner.scanExtensions(null)).find(N=>(0,R.areSameExtensions)(N.identifier,this.gallery.identifier));F&&(this._operation=2);const j=await this.downloadInstallableExtension(this.gallery,this._operation);j.metadata.isMachineScoped=this.options.isMachineScoped||F?.isMachineScoped,j.metadata.isBuiltin=this.options.isBuiltin||F?.isBuiltin;const _=await this.installExtension(j,U);F&&w.neq(F.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(F);try{await this.extensionsDownloader.delete(n.URI.file(j.zipPath))}catch(N){}return _}async downloadInstallableExtension(U,M){const F={id:U.identifier.uuid,publisherId:U.publisherId,publisherDisplayName:U.publisherDisplayName};let j;try{this.logService.trace("Started downloading extension:",U.identifier.id),j=(await this.extensionsDownloader.downloadExtension(U,M)).fsPath,this.logService.info("Downloaded extension:",U.identifier.id,j)}catch(_){throw new A.ExtensionManagementError((0,g.joinErrors)(_).message,d)}try{const _=await(0,r.getManifest)(j);return{zipPath:j,identifierWithVersion:new R.ExtensionIdentifierWithVersion(U.identifier,_.version),metadata:F}}catch(_){throw new A.ExtensionManagementError((0,g.joinErrors)(_).message,g.INSTALL_ERROR_VALIDATING)}}}class z extends O{constructor(U,M,F,j,_,N){super({id:(0,R.getGalleryExtensionId)(U.publisher,U.name)},M,_,N);this.manifest=U,this.location=M,this.options=F,this.galleryService=j}async doRun(U){const M=new R.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),j=(await this.extensionsScanner.scanExtensions(1)).find(N=>(0,R.areSameExtensions)(this.identifier,N.identifier)),_=await this.getMetadata(this.identifier.id,U);if(j)if(_.isMachineScoped=this.options.isMachineScoped||j.isMachineScoped,_.isBuiltin=this.options.isBuiltin||j.isBuiltin,this._operation=2,M.equals(new R.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version)))try{await this.extensionsScanner.removeExtension(j,"existing")}catch(N){throw new Error(p.localize(3,null,this.manifest.displayName||this.manifest.name))}else w.gt(j.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(j);else{const N=await this.unsetUninstalledAndGetLocal(M);if(N)try{await this.extensionsScanner.removeExtension(N,"existing")}catch(W){throw new Error(p.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:L.resolve(this.location.fsPath),identifierWithVersion:M,metadata:_},U)}async getMetadata(U,M){try{const F=(await this.galleryService.query({names:[U],pageSize:1},M)).firstPage[0];if(F)return{id:F.identifier.uuid,publisherDisplayName:F.publisherDisplayName,publisherId:F.publisherId}}catch(F){}return{}}}class G extends g.AbstractExtensionTask{constructor(U,M,F){super();this.extension=U,this.options=M,this.extensionsScanner=F}async doRun(U){const M=[],F=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const j=new R.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);M.push(...F.filter(_=>j.equals(new R.ExtensionIdentifierWithVersion(_.identifier,_.manifest.version))))}else M.push(...F.filter(j=>(0,R.areSameExtensions)(j.identifier,this.extension.identifier)));if(!M.length)throw new Error(p.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...M),this.options.remove)for(const j of M)try{U.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(j)}catch(_){throw new Error(p.localize(6,null,(0,C.toErrorMessage)(_)))}}}}),define(Z[215],ee([0,1,49,35,216,103,44,102,36,76,51,151,9,133,135,27,209,177,24,167,39,168,21,52,174,80,81,179,10,77,160,57,2,169,72,164,165,156,155,153,152,175,71,161,14,163,17,28,22,202,204,199,59,200,205,173,20,171,201,60,198,178,61,73,137,206,82,87,86,85,6,154,146,11,43,83,187,182,203,144,148,180,4,15]),function(K,e,p,L,P,k,A,R,S,w,n,y,m,v,h,C,D,b,I,f,a,c,t,r,i,s,u,o,l,g,E,d,T,O,$,z,G,V,U,M,F,j,_,N,W,x,B,H,X,Q,ie,ne,le,de,ye,pe,De,Te,Ne,Oe,Le,_e,be,ke,Ye,Je,xe,je,J,re,se,me,ve,Pe,we,Ae,Ce,Re,Ue,q,te,ae,ce,oe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class he extends T.Disposable{constructor(ue){super();this.configuration=ue,this.server=this._register(new R.Server),(0,P.gracefulify)(p),this.registerListeners()}registerListeners(){const ue=()=>this.dispose();process.once("exit",ue),k.ipcRenderer.once("vscode:electron-main->shared-process=exit",ue)}async open(){const ue=await this.initServices();(0,X.registerConfiguration)(),ue.invokeFunction(Ee=>{const Ie=Ee.get(l.ILogService);Ie.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ee),this.registerErrorHandler(Ie)}),this._register((0,T.combinedDisposable)(ue.createInstance(z.CodeCacheCleaner,this.configuration.codeCachePath),ue.createInstance(G.LanguagePackCachedDataCleaner),ue.createInstance(V.StorageDataCleaner,this.configuration.backupWorkspacesPath),ue.createInstance(U.LogsDataCleaner),ue.createInstance(me.LocalizationsUpdater),ue.createInstance(ve.DeprecatedExtensionsCleaner)))}async initServices(){const ue=new w.ServiceCollection,Ee={_serviceBrand:void 0,...A.default};ue.set(H.IProductService,Ee);const Ie=new S.StaticRouter(We=>We==="main"),Fe=new F.MessagePortMainProcessService(this.server,Ie);ue.set(M.IMainProcessService,Fe);const Me=new v.NativeEnvironmentService(this.configuration.args,Ee);ue.set(m.INativeEnvironmentService,Me);const et=new g.LogLevelChannelClient(this.server.getChannel("logLevel",Ie)),Be=new g.LoggerChannelClient(this.configuration.logLevel,et.onDidChangeLogLevel,Fe.getChannel("logger"));ue.set(l.ILoggerService,Be);const nt=this._register(new l.MultiplexLogService([this._register(new l.ConsoleLogger(this.configuration.logLevel)),this._register(Be.createLogger((0,oe.joinPath)(ce.URI.file(Me.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ve=this._register(new g.FollowerLogService(et,nt));ue.set(l.ILogService,Ve);const He=this._register(new N.FileService(Ve));ue.set(W.IFileService,He);const it=this._register(new x.DiskFileSystemProvider(Ve));He.registerProvider(B.Schemas.file,it);const qe=this._register(new f.ConfigurationService(Me.settingsResource,He));ue.set(I.IConfigurationService,qe),await qe.initialize();const Xe=new pe.NativeStorageService(void 0,Fe,Me);ue.set(De.IStorageService,Xe),await Xe.initialize(),this._register((0,T.toDisposable)(()=>Xe.flush())),ue.set(a.IRequestService,new n.SyncDescriptor(c.RequestService)),ue.set(q.IChecksumService,new n.SyncDescriptor(te.ChecksumService));const tt=S.ProxyChannel.toService(Fe.getChannel("nativeHost"),{context:this.configuration.windowId});ue.set(le.INativeHostService,tt),ue.set($.IDownloadService,new n.SyncDescriptor(O.DownloadService));const rt=this._register(new Je.ActiveWindowManager(tt)),ht=new S.StaticRouter(We=>rt.getActiveClientId().then(st=>We===st));ue.set(ke.IExtensionRecommendationNotificationService,new Ye.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ht)));let Qe,Ge;if(!Me.isExtensionDevelopment&&!Me.disableTelemetry&&Ee.enableTelemetry){Ge=new xe.TelemetryLogAppender(Be,Me);const{appRoot:We,extensionsPath:st,isBuilt:dt,installSourcePath:gt}=Me;if(Ee.aiConfig&&Ee.aiConfig.asimovKey&&dt){const ct=new o.AppInsightsAppender("monacoworkbench",null,Ee.aiConfig.asimovKey);this._register((0,T.toDisposable)(()=>ct.flush())),Ge=(0,r.combinedAppender)(ct,Ge)}Qe=new u.TelemetryService({appender:Ge,commonProperties:(0,i.resolveCommonProperties)(He,(0,L.release)(),(0,L.hostname)(),process.arch,Ee.commit,Ee.version,this.configuration.machineId,Ee.msftInternalDomains,gt),sendErrorTelemetry:!0,piiPaths:[We,st]},qe)}else Qe=r.NullTelemetryService,Ge=r.NullAppender;this.server.registerChannel("telemetryAppender",new s.TelemetryAppenderChannel(Ge)),ue.set(t.ITelemetryService,Qe);const ft=new ae.CustomEndpointTelemetryService(qe,Qe,Be,Me);return ue.set(t.ICustomEndpointTelemetryService,ft),ue.set(C.IExtensionManagementService,new n.SyncDescriptor(D.ExtensionManagementService)),ue.set(C.IExtensionGalleryService,new n.SyncDescriptor(b.ExtensionGalleryService)),ue.set(C.IExtensionTipsService,new n.SyncDescriptor(_e.ExtensionTipsService)),ue.set(d.ILocalizationsService,new n.SyncDescriptor(E.LocalizationsService)),ue.set(_.IDiagnosticsService,new n.SyncDescriptor(j.DiagnosticsService)),ue.set(Oe.IUserDataSyncAccountService,new n.SyncDescriptor(Oe.UserDataSyncAccountService)),ue.set(X.IUserDataSyncLogService,new n.SyncDescriptor(de.UserDataSyncLogService)),ue.set(X.IUserDataSyncUtilService,new ne.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",We=>We.ctx!=="main"))),ue.set(C.IGlobalExtensionEnablementService,new n.SyncDescriptor(Te.GlobalExtensionEnablementService)),ue.set(J.IIgnoredExtensionsManagementService,new n.SyncDescriptor(J.IgnoredExtensionsManagementService)),ue.set(re.IExtensionsStorageSyncService,new n.SyncDescriptor(re.ExtensionsStorageSyncService)),ue.set(X.IUserDataSyncStoreManagementService,new n.SyncDescriptor(ie.UserDataSyncStoreManagementService)),ue.set(X.IUserDataSyncStoreService,new n.SyncDescriptor(ie.UserDataSyncStoreService)),ue.set(be.IUserDataSyncMachinesService,new n.SyncDescriptor(be.UserDataSyncMachinesService)),ue.set(X.IUserDataSyncBackupStoreService,new n.SyncDescriptor(Le.UserDataSyncBackupStoreService)),ue.set(X.IUserDataAutoSyncEnablementService,new n.SyncDescriptor(je.UserDataAutoSyncEnablementService)),ue.set(X.IUserDataSyncResourceEnablementService,new n.SyncDescriptor(Ne.UserDataSyncResourceEnablementService)),ue.set(X.IUserDataSyncService,new n.SyncDescriptor(Q.UserDataSyncService)),ue.set(Re.ILocalPtyService,this._register(new Ce.PtyHostService({GraceTime:6e4,ShortGraceTime:6e3},qe,Ve,Qe))),new y.InstantiationService(ue)}initChannels(ue){const Ee=new h.ExtensionManagementChannel(ue.get(C.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ee);const Ie=S.ProxyChannel.fromService(ue.get(d.ILocalizationsService));this.server.registerChannel("localizations",Ie);const Fe=S.ProxyChannel.fromService(ue.get(_.IDiagnosticsService));this.server.registerChannel("diagnostics",Fe);const Me=new h.ExtensionTipsChannel(ue.get(C.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Me);const et=S.ProxyChannel.fromService(ue.get(q.IChecksumService));this.server.registerChannel("checksum",et);const Be=new ne.UserDataSyncMachinesServiceChannel(ue.get(be.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Be);const nt=S.ProxyChannel.fromService(ue.get(t.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",nt);const Ve=new ne.UserDataSyncAccountServiceChannel(ue.get(Oe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ve);const He=new ne.UserDataSyncStoreManagementServiceChannel(ue.get(X.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",He);const it=new Ue.UserDataSyncChannel(ue.get(X.IUserDataSyncService),ue.get(l.ILogService));this.server.registerChannel("userDataSync",it);const qe=this._register(ue.get(se.IInstantiationService).createInstance(ye.UserDataAutoSyncService)),Xe=new ne.UserDataAutoSyncChannel(qe);this.server.registerChannel("userDataAutoSync",Xe);const tt=ue.get(Re.ILocalPtyService),rt=S.ProxyChannel.fromService(tt);this.server.registerChannel(Ae.TerminalIpcChannels.LocalPty,rt)}registerErrorHandler(ue){window.addEventListener("unhandledrejection",Ee=>{(0,Pe.onUnexpectedError)(Ee.reason),Ee.preventDefault()}),(0,Pe.setUnexpectedErrorHandler)(Ee=>{const Ie=(0,we.toErrorMessage)(Ee,!0);!Ie||ue.error(`[uncaught exception in sharedProcess]: ${Ie}`)})}}async function ge(Se){const ue=new he(Se);k.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ue.open(),k.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b805d2e94937976bb17d0439f57fcd3a9d423c31/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
