/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Y=["require","exports","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/uri","vs/base/common/errors","vs/base/common/network","vs/base/node/pfs","vs/platform/instantiation/common/instantiation","vs/base/common/types","vs/base/common/event","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/objects","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/arrays","vs/platform/registry/common/platform","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/base/common/errorMessage","vs/base/common/uuid","vs/platform/configuration/common/configurationRegistry","os","child_process","vs/base/common/process","vs/platform/product/common/product","vs/platform/telemetry/common/telemetry","vs/base/common/stream","vs/base/common/extpath","fs","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/product/common/productService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/map","vs/base/node/decoder","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/base/common/assert","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/download/common/download","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/base/common/normalization","vs/platform/environment/node/argvHelper","crypto","vs/base/common/performance","vs/base/common/iterator","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],ee=function(G){for(var t=[],g=0,T=G.length;g<T;g++)t[g]=Y[G[g]];return t};define(Y[57],ee([0,1]),function(G,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function g(T,y){if(!T)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}t.ok=g}),define(Y[44],ee([0,1]),function(G,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function g(C){return(D,u,d)=>{let v=null,p=null;if(typeof d.value=="function"?(v="value",p=d.value):typeof d.get=="function"&&(v="get",p=d.get),!p)throw new Error("not supported");d[v]=C(p,u)}}t.createDecorator=g;function T(C,D,u){let d=null,v=null;if(typeof u.value=="function"?(d="value",v=u.value,v.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(d="get",v=u.get),!v)throw new Error("not supported");const p=`$memoize$${D}`;u[d]=function(...E){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:v.apply(this,E)}),this[p]}}t.memoize=T;function y(C,D,u){return g((d,v)=>{const p=`$debounce$${v}`,E=`$debounce$result$${v}`;return function(...F){this[E]||(this[E]=u?u():void 0),clearTimeout(this[p]),D&&(this[E]=D(this[E],...F),F=[this[E]]),this[p]=setTimeout(()=>{d.apply(this,F),this[E]=u?u():void 0},C)}})}t.debounce=y;function I(C,D,u){return g((d,v)=>{const p=`$throttle$timer$${v}`,E=`$throttle$result$${v}`,F=`$throttle$lastRun$${v}`,c=`$throttle$pending$${v}`;return function(...f){if(this[E]||(this[E]=u?u():void 0),(this[F]===null||this[F]===void 0)&&(this[F]=-Number.MAX_VALUE),D&&(this[E]=D(this[E],...f)),this[c])return;const P=this[F]+C;P<=Date.now()?(this[F]=Date.now(),d.apply(this,[this[E]]),this[E]=u?u():void 0):(this[c]=!0,this[p]=setTimeout(()=>{this[c]=!1,this[F]=Date.now(),d.apply(this,[this[E]]),this[E]=u?u():void 0},P-Date.now()))}})}t.throttle=I}),define(Y[24],ee([0,1,8]),function(G,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayQueue=t.maxIndex=t.minIndex=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0;function T(b,O=0){return b[b.length-(1+O)]}t.tail=T;function y(b){if(b.length===0)throw new Error("Invalid tail call");return[b.slice(0,b.length-1),b[b.length-1]]}t.tail2=y;function I(b,O,A=(V,B)=>V===B){if(b===O)return!0;if(!b||!O||b.length!==O.length)return!1;for(let V=0,B=b.length;V<B;V++)if(!A(b[V],O[V]))return!1;return!0}t.equals=I;function C(b,O,A){let V=0,B=b.length-1;for(;V<=B;){const $=(V+B)/2|0,K=A(b[$],O);if(K<0)V=$+1;else if(K>0)B=$-1;else return $}return-(V+1)}t.binarySearch=C;function D(b,O){let A=0,V=b.length;if(V===0)return 0;for(;A<V;){const B=Math.floor((A+V)/2);O(b[B])?V=B:A=B+1}return A}t.findFirstInSorted=D;function u(b,O,A){if(b=b|0,b>=O.length)throw new TypeError("invalid index");let V=O[Math.floor(O.length*Math.random())],B=[],$=[],K=[];for(let te of O){const ie=A(te,V);ie<0?B.push(te):ie>0?$.push(te):K.push(te)}return b<B.length?u(b,B,A):b<B.length+K.length?K[0]:u(b-(B.length+K.length),$,A)}t.quickSelect=u;function d(b,O){const A=[];let V;for(const B of b.slice(0).sort(O))!V||O(V[0],B)!==0?(V=[B],A.push(V)):V.push(B);return A}t.groupBy=d;function v(b,O,A){const V=[];function B(te,ie,oe){if(ie===0&&oe.length===0)return;const le=V[V.length-1];le&&le.start+le.deleteCount===te?(le.deleteCount+=ie,le.toInsert.push(...oe)):V.push({start:te,deleteCount:ie,toInsert:oe})}let $=0,K=0;for(;;){if($===b.length){B($,0,O.slice(K));break}if(K===O.length){B($,b.length-$,[]);break}const te=b[$],ie=O[K],oe=A(te,ie);oe===0?($+=1,K+=1):oe<0?(B($,1,[]),$+=1):oe>0&&(B($,0,[ie]),K+=1)}return V}t.sortedDiff=v;function p(b,O,A){const V=v(b,O,A),B=[],$=[];for(const K of V)B.push(...b.slice(K.start,K.start+K.deleteCount)),$.push(...K.toInsert);return{removed:B,added:$}}t.delta=p;function E(b,O,A){if(A===0)return[];const V=b.slice(0,A).sort(O);return c(b,O,V,A,b.length),V}t.top=E;function F(b,O,A,V,B){return A===0?Promise.resolve([]):new Promise(($,K)=>{(async()=>{const te=b.length,ie=b.slice(0,A).sort(O);for(let oe=A,le=Math.min(A+V,te);oe<te;oe=le,le=Math.min(le+V,te)){if(oe>A&&await new Promise(pe=>setTimeout(pe)),B&&B.isCancellationRequested)throw(0,g.canceled)();c(b,O,ie,oe,le)}return ie})().then($,K)})}t.topAsync=F;function c(b,O,A,V,B){for(const $=A.length;V<B;V++){const K=b[V];if(O(K,A[$-1])<0){A.pop();const te=D(A,ie=>O(K,ie)<0);A.splice(te,0,K)}}}function f(b){return b.filter(O=>!!O)}t.coalesce=f;function P(b){let O=0;for(let A=0;A<b.length;A++)b[A]&&(b[O]=b[A],O+=1);b.length=O}t.coalesceInPlace=P;function S(b,O,A){b.splice(A,0,b.splice(O,1)[0])}t.move=S;function w(b){return!Array.isArray(b)||b.length===0}t.isFalsyOrEmpty=w;function l(b){return Array.isArray(b)&&b.length>0}t.isNonEmptyArray=l;function r(b,O){if(!O)return b.filter((V,B)=>b.indexOf(V)===B);const A=Object.create(null);return b.filter(V=>{const B=O(V);return A[B]?!1:(A[B]=!0,!0)})}t.distinct=r;function s(b){const O=new Set;return b.filter(A=>O.has(A)?!1:(O.add(A),!0))}t.distinctES6=s;function e(b){const O=Object.create(null);return A=>{const V=b(A);return O[V]?!1:(O[V]=!0,!0)}}t.uniqueFilter=e;function i(b,O){for(let A=b.length-1;A>=0;A--){const V=b[A];if(O(V))return A}return-1}t.lastIndex=i;function n(b,O){return b.length>0?b[0]:O}t.firstOrDefault=n;function o(b,O,A=(V,B)=>V===B){let V=0;for(let B=0,$=Math.min(b.length,O.length);B<$&&A(b[B],O[B]);B++)V++;return V}t.commonPrefixLength=o;function a(b){return[].concat(...b)}t.flatten=a;function h(b,O){let A=typeof O=="number"?b:0;typeof O=="number"?A=b:(A=0,O=b);const V=[];if(A<=O)for(let B=A;B<O;B++)V.push(B);else for(let B=A;B>O;B--)V.push(B);return V}t.range=h;function m(b,O,A){return b.reduce((V,B)=>(V[O(B)]=A?A(B):B,V),Object.create(null))}t.index=m;function N(b,O){return b.push(O),()=>L(b,O)}t.insert=N;function L(b,O){const A=b.indexOf(O);if(A>-1)return b.splice(A,1),O}t.remove=L;function k(b,O,A){const V=b.slice(0,O),B=b.slice(O);return V.concat(A,B)}t.arrayInsert=k;function j(b,O){let A;if(typeof O=="number"){let V=O;A=()=>{const B=Math.sin(V++)*179426549;return B-Math.floor(B)}}else A=Math.random;for(let V=b.length-1;V>0;V-=1){const B=Math.floor(A()*(V+1)),$=b[V];b[V]=b[B],b[B]=$}}t.shuffle=j;function _(b,O){const A=b.indexOf(O);A>-1&&(b.splice(A,1),b.unshift(O))}t.pushToStart=_;function Q(b,O){const A=b.indexOf(O);A>-1&&(b.splice(A,1),b.push(O))}t.pushToEnd=Q;function ne(b,O){return Array.isArray(b)?b.map(O):O(b)}t.mapArrayOrNot=ne;function re(b){return Array.isArray(b)?b:[b]}t.asArray=re;function Z(b){return b[Math.floor(Math.random()*b.length)]}t.getRandomElement=Z;function J(b,O){for(const A of b){const V=O(A);if(V!==void 0)return V}}t.mapFind=J;function W(b,O,A){const V=q(b,O),B=b.length,$=A.length;b.length=B+$;for(let K=B-1;K>=V;K--)b[K+$]=b[K];for(let K=0;K<$;K++)b[K+V]=A[K]}t.insertInto=W;function x(b,O,A,V){const B=q(b,O),$=b.splice(B,A);return W(b,B,V),$}t.splice=x;function q(b,O){return O<0?Math.max(O+b.length,0):Math.min(O,b.length)}function U(b,O){let A=Number.MAX_SAFE_INTEGER,V=0;return b.forEach((B,$)=>{const K=O(B);K<A&&(A=K,V=$)}),V}t.minIndex=U;function R(b,O){let A=Number.MIN_SAFE_INTEGER,V=0;return b.forEach((B,$)=>{const K=O(B);K>A&&(A=K,V=$)}),V}t.maxIndex=R;class M{constructor(O){this.items=O,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(O){let A=this.firstIdx;for(;A<this.items.length&&O(this.items[A]);)A++;const V=A===this.firstIdx?null:this.items.slice(this.firstIdx,A);return this.firstIdx=A,V}takeFromEndWhile(O){let A=this.lastIdx;for(;A>=0&&O(this.items[A]);)A--;const V=A===this.lastIdx?null:this.items.slice(A+1,this.lastIdx+1);return this.lastIdx=A,V}}t.ArrayQueue=M}),define(Y[58],ee([0,1]),function(G,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var g;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(g=t.ScanError||(t.ScanError={}));var T;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(T=t.SyntaxKind||(t.SyntaxKind={}));var y;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(y=t.ParseErrorCode||(t.ParseErrorCode={}));var I;(function(e){e.DEFAULT={allowTrailingComma:!0}})(I=t.ParseOptions||(t.ParseOptions={}));function C(e,i=!1){let n=0,o=e.length,a="",h=0,m=16,N=0;function L(Z){let J=0,W=0;for(;J<Z;){const x=e.charCodeAt(n);if(x>=48&&x<=57)W=W*16+x-48;else if(x>=65&&x<=70)W=W*16+x-65+10;else if(x>=97&&x<=102)W=W*16+x-97+10;else break;n++,J++}return J<Z&&(W=-1),W}function k(Z){n=Z,a="",h=0,m=16,N=0}function j(){const Z=n;if(e.charCodeAt(n)===48)n++;else for(n++;n<e.length&&d(e.charCodeAt(n));)n++;if(n<e.length&&e.charCodeAt(n)===46)if(n++,n<e.length&&d(e.charCodeAt(n)))for(n++;n<e.length&&d(e.charCodeAt(n));)n++;else return N=3,e.substring(Z,n);let J=n;if(n<e.length&&(e.charCodeAt(n)===69||e.charCodeAt(n)===101))if(n++,(n<e.length&&e.charCodeAt(n)===43||e.charCodeAt(n)===45)&&n++,n<e.length&&d(e.charCodeAt(n))){for(n++;n<e.length&&d(e.charCodeAt(n));)n++;J=n}else N=3;return e.substring(Z,J)}function _(){let Z="",J=n;for(;;){if(n>=o){Z+=e.substring(J,n),N=2;break}const W=e.charCodeAt(n);if(W===34){Z+=e.substring(J,n),n++;break}if(W===92){if(Z+=e.substring(J,n),n++,n>=o){N=2;break}switch(e.charCodeAt(n++)){case 34:Z+='"';break;case 92:Z+="\\";break;case 47:Z+="/";break;case 98:Z+="\b";break;case 102:Z+="\f";break;case 110:Z+=`
`;break;case 114:Z+="\r";break;case 116:Z+="	";break;case 117:const q=L(4);q>=0?Z+=String.fromCharCode(q):N=4;break;default:N=5}J=n;continue}if(W>=0&&W<=31)if(u(W)){Z+=e.substring(J,n),N=2;break}else N=6;n++}return Z}function Q(){if(a="",N=0,h=n,n>=o)return h=o,m=17;let Z=e.charCodeAt(n);if(D(Z)){do n++,a+=String.fromCharCode(Z),Z=e.charCodeAt(n);while(D(Z));return m=15}if(u(Z))return n++,a+=String.fromCharCode(Z),Z===13&&e.charCodeAt(n)===10&&(n++,a+=`
`),m=14;switch(Z){case 123:return n++,m=1;case 125:return n++,m=2;case 91:return n++,m=3;case 93:return n++,m=4;case 58:return n++,m=6;case 44:return n++,m=5;case 34:return n++,a=_(),m=10;case 47:const J=n-1;if(e.charCodeAt(n+1)===47){for(n+=2;n<o&&!u(e.charCodeAt(n));)n++;return a=e.substring(J,n),m=12}if(e.charCodeAt(n+1)===42){n+=2;const W=o-1;let x=!1;for(;n<W;){if(e.charCodeAt(n)===42&&e.charCodeAt(n+1)===47){n+=2,x=!0;break}n++}return x||(n++,N=1),a=e.substring(J,n),m=13}return a+=String.fromCharCode(Z),n++,m=16;case 45:if(a+=String.fromCharCode(Z),n++,n===o||!d(e.charCodeAt(n)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=j(),m=11;default:for(;n<o&&ne(Z);)n++,Z=e.charCodeAt(n);if(h!==n){switch(a=e.substring(h,n),a){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return a+=String.fromCharCode(Z),n++,m=16}}function ne(Z){if(D(Z)||u(Z))return!1;switch(Z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let Z;do Z=Q();while(Z>=12&&Z<=15);return Z}return{setPosition:k,getPosition:()=>n,scan:i?re:Q,getToken:()=>m,getTokenValue:()=>a,getTokenOffset:()=>h,getTokenLength:()=>n-h,getTokenError:()=>N}}t.createScanner=C;function D(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function u(e){return e===10||e===13||e===8232||e===8233}function d(e){return e>=48&&e<=57}var v;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(v||(v={}));function p(e,i){const n=[],o=new Object;let a;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function N(L,k,j,_){h.value=L,h.offset=k,h.length=j,h.type=_,h.colonOffset=void 0,a=h}try{l(e,{onObjectBegin:(L,k)=>{if(i<=L)throw o;a=void 0,m=i>L,n.push("")},onObjectProperty:(L,k,j)=>{if(i<k||(N(L,k,j,"property"),n[n.length-1]=L,i<=k+j))throw o},onObjectEnd:(L,k)=>{if(i<=L)throw o;a=void 0,n.pop()},onArrayBegin:(L,k)=>{if(i<=L)throw o;a=void 0,n.push(0)},onArrayEnd:(L,k)=>{if(i<=L)throw o;a=void 0,n.pop()},onLiteralValue:(L,k,j)=>{if(i<k||(N(L,k,j,s(L)),i<=k+j))throw o},onSeparator:(L,k,j)=>{if(i<=k)throw o;if(L===":"&&a&&a.type==="property")a.colonOffset=k,m=!1,a=void 0;else if(L===","){const _=n[n.length-1];typeof _=="number"?n[n.length-1]=_+1:(m=!0,n[n.length-1]=""),a=void 0}}})}catch(L){if(L!==o)throw L}return{path:n,previousNode:a,isAtPropertyKey:m,matches:L=>{let k=0;for(let j=0;k<L.length&&j<n.length;j++)if(L[k]===n[j]||L[k]==="*")k++;else if(L[k]!=="**")return!1;return k===L.length}}}t.getLocation=p;function E(e,i=[],n=I.DEFAULT){let o=null,a=[];const h=[];function m(L){Array.isArray(a)?a.push(L):o!==null&&(a[o]=L)}return l(e,{onObjectBegin:()=>{const L={};m(L),h.push(a),a=L,o=null},onObjectProperty:L=>{o=L},onObjectEnd:()=>{a=h.pop()},onArrayBegin:()=>{const L=[];m(L),h.push(a),a=L,o=null},onArrayEnd:()=>{a=h.pop()},onLiteralValue:m,onError:(L,k,j)=>{i.push({error:L,offset:k,length:j})}},n),a[0]}t.parse=E;function F(e,i=[],n=I.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(L){o.type==="property"&&(o.length=L-o.offset,o=o.parent)}function h(L){return o.children.push(L),L}l(e,{onObjectBegin:L=>{o=h({type:"object",offset:L,length:-1,parent:o,children:[]})},onObjectProperty:(L,k,j)=>{o=h({type:"property",offset:k,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:L,offset:k,length:j,parent:o})},onObjectEnd:(L,k)=>{o.length=L+k-o.offset,o=o.parent,a(L+k)},onArrayBegin:(L,k)=>{o=h({type:"array",offset:L,length:-1,parent:o,children:[]})},onArrayEnd:(L,k)=>{o.length=L+k-o.offset,o=o.parent,a(L+k)},onLiteralValue:(L,k,j)=>{h({type:s(L),offset:k,length:j,parent:o,value:L}),a(k+j)},onSeparator:(L,k,j)=>{o.type==="property"&&(L===":"?o.colonOffset=k:L===","&&a(k))},onError:(L,k,j)=>{i.push({error:L,offset:k,length:j})}},n);const N=o.children[0];return N&&delete N.parent,N}t.parseTree=F;function c(e,i){if(!e)return;let n=e;for(let o of i)if(typeof o=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let a=!1;for(const h of n.children)if(Array.isArray(h.children)&&h.children[0].value===o){n=h.children[1],a=!0;break}if(!a)return}else{const a=o;if(n.type!=="array"||a<0||!Array.isArray(n.children)||a>=n.children.length)return;n=n.children[a]}return n}t.findNodeAtLocation=c;function f(e){if(!e.parent||!e.parent.children)return[];const i=f(e.parent);if(e.parent.type==="property"){const n=e.parent.children[0].value;i.push(n)}else if(e.parent.type==="array"){const n=e.parent.children.indexOf(e);n!==-1&&i.push(n)}return i}t.getNodePath=f;function P(e){switch(e.type){case"array":return e.children.map(P);case"object":const i=Object.create(null);for(let n of e.children){const o=n.children[1];o&&(i[n.children[0].value]=P(o))}return i;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=P;function S(e,i,n=!1){return i>=e.offset&&i<e.offset+e.length||n&&i===e.offset+e.length}t.contains=S;function w(e,i,n=!1){if(S(e,i,n)){const o=e.children;if(Array.isArray(o))for(let a=0;a<o.length&&o[a].offset<=i;a++){const h=w(o[a],i,n);if(h)return h}return e}}t.findNodeAtOffset=w;function l(e,i,n=I.DEFAULT){const o=C(e,!1);function a(A){return A?()=>A(o.getTokenOffset(),o.getTokenLength()):()=>!0}function h(A){return A?V=>A(V,o.getTokenOffset(),o.getTokenLength()):()=>!0}const m=a(i.onObjectBegin),N=h(i.onObjectProperty),L=a(i.onObjectEnd),k=a(i.onArrayBegin),j=a(i.onArrayEnd),_=h(i.onLiteralValue),Q=h(i.onSeparator),ne=a(i.onComment),re=h(i.onError),Z=n&&n.disallowComments,J=n&&n.allowTrailingComma;function W(){for(;;){const A=o.scan();switch(o.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:Z||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(A){case 12:case 13:Z?x(10):ne();break;case 16:x(1);break;case 15:case 14:break;default:return A}}}function x(A,V=[],B=[]){if(re(A),V.length+B.length>0){let $=o.getToken();for(;$!==17;){if(V.indexOf($)!==-1){W();break}else if(B.indexOf($)!==-1)break;$=W()}}}function q(A){const V=o.getTokenValue();return A?_(V):N(V),W(),!0}function U(){switch(o.getToken()){case 11:let A=0;try{A=JSON.parse(o.getTokenValue()),typeof A!="number"&&(x(2),A=0)}catch(V){x(2)}_(A);break;case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return W(),!0}function R(){return o.getToken()!==10?(x(3,[],[2,5]),!1):(q(!1),o.getToken()===6?(Q(":"),W(),O()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function M(){m(),W();let A=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(A||x(4,[],[]),Q(","),W(),o.getToken()===2&&J)break}else A&&x(6,[],[]);R()||x(4,[],[2,5]),A=!0}return L(),o.getToken()!==2?x(7,[2],[]):W(),!0}function b(){k(),W();let A=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(A||x(4,[],[]),Q(","),W(),o.getToken()===4&&J)break}else A&&x(6,[],[]);O()||x(4,[],[4,5]),A=!0}return j(),o.getToken()!==4?x(8,[4],[]):W(),!0}function O(){switch(o.getToken()){case 3:return b();case 1:return M();case 10:return q(!0);default:return U()}}return W(),o.getToken()===17?n.allowEmptyContent?!0:(x(4,[],[]),!1):O()?(o.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}t.visit=l;function r(e,i){let n=C(e),o=[],a,h=0,m;do switch(m=n.getPosition(),a=n.scan(),a){case 12:case 13:case 17:h!==m&&o.push(e.substring(h,m)),i!==void 0&&o.push(n.getTokenValue().replace(/[^\r\n]/g,i)),h=n.getPosition();break}while(a!==17);return o.join("")}t.stripComments=r;function s(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=s}),function(){function G(y){const I=[];typeof y=="number"&&I.push("code/timeOrigin",y);function C(u){I.push(u,Date.now())}function D(){const u=[];for(let d=0;d<I.length;d+=2)u.push({name:I[d],startTime:I[d+1]});return u}return{mark:C,getMarks:D}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const C of performance.getEntriesByType("mark"))I.push({name:C.name,startTime:Math.round(y+C.startTime)});return I}};if(typeof process=="object"){const y=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function g(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=t()),y.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=g(T))}(),function(G,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var g=t();for(var T in g)(typeof exports=="object"?exports:G)[T]=g[T]}}(typeof self!="undefined"?self:this,function(){return function(G){var t={};function g(T){if(t[T])return t[T].exports;var y=t[T]={i:T,l:!1,exports:{}};return G[T].call(y.exports,y,y.exports,g),y.l=!0,y.exports}return g.m=G,g.c=t,g.d=function(T,y,I){g.o(T,y)||Object.defineProperty(T,y,{enumerable:!0,get:I})},g.r=function(T){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},g.t=function(T,y){if(1&y&&(T=g(T)),8&y||4&y&&typeof T=="object"&&T&&T.__esModule)return T;var I=Object.create(null);if(g.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:T}),2&y&&typeof T!="string")for(var C in T)g.d(I,C,function(D){return T[D]}.bind(null,C));return I},g.n=function(T){var y=T&&T.__esModule?function(){return T.default}:function(){return T};return g.d(y,"a",y),y},g.o=function(T,y){return Object.prototype.hasOwnProperty.call(T,y)},g.p="",g(g.s=0)}([function(G,t,g){(function(T){var y;t=G.exports=B,y=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var I=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,D=t.re=[],u=t.src=[],d=0,v=d++;u[v]="0|[1-9]\\d*";var p=d++;u[p]="[0-9]+";var E=d++;u[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var F=d++;u[F]="("+u[v]+")\\.("+u[v]+")\\.("+u[v]+")";var c=d++;u[c]="("+u[p]+")\\.("+u[p]+")\\.("+u[p]+")";var f=d++;u[f]="(?:"+u[v]+"|"+u[E]+")";var P=d++;u[P]="(?:"+u[p]+"|"+u[E]+")";var S=d++;u[S]="(?:-("+u[f]+"(?:\\."+u[f]+")*))";var w=d++;u[w]="(?:-?("+u[P]+"(?:\\."+u[P]+")*))";var l=d++;u[l]="[0-9A-Za-z-]+";var r=d++;u[r]="(?:\\+("+u[l]+"(?:\\."+u[l]+")*))";var s=d++,e="v?"+u[F]+u[S]+"?"+u[r]+"?";u[s]="^"+e+"$";var i="[v=\\s]*"+u[c]+u[w]+"?"+u[r]+"?",n=d++;u[n]="^"+i+"$";var o=d++;u[o]="((?:<|>)?=?)";var a=d++;u[a]=u[p]+"|x|X|\\*";var h=d++;u[h]=u[v]+"|x|X|\\*";var m=d++;u[m]="[v=\\s]*("+u[h]+")(?:\\.("+u[h]+")(?:\\.("+u[h]+")(?:"+u[S]+")?"+u[r]+"?)?)?";var N=d++;u[N]="[v=\\s]*("+u[a]+")(?:\\.("+u[a]+")(?:\\.("+u[a]+")(?:"+u[w]+")?"+u[r]+"?)?)?";var L=d++;u[L]="^"+u[o]+"\\s*"+u[m]+"$";var k=d++;u[k]="^"+u[o]+"\\s*"+u[N]+"$";var j=d++;u[j]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=d++;u[_]="(?:~>?)";var Q=d++;u[Q]="(\\s*)"+u[_]+"\\s+",D[Q]=new RegExp(u[Q],"g");var ne=d++;u[ne]="^"+u[_]+u[m]+"$";var re=d++;u[re]="^"+u[_]+u[N]+"$";var Z=d++;u[Z]="(?:\\^)";var J=d++;u[J]="(\\s*)"+u[Z]+"\\s+",D[J]=new RegExp(u[J],"g");var W=d++;u[W]="^"+u[Z]+u[m]+"$";var x=d++;u[x]="^"+u[Z]+u[N]+"$";var q=d++;u[q]="^"+u[o]+"\\s*("+i+")$|^$";var U=d++;u[U]="^"+u[o]+"\\s*("+e+")$|^$";var R=d++;u[R]="(\\s*)"+u[o]+"\\s*("+i+"|"+u[m]+")",D[R]=new RegExp(u[R],"g");var M=d++;u[M]="^\\s*("+u[m]+")\\s+-\\s+("+u[m]+")\\s*$";var b=d++;u[b]="^\\s*("+u[N]+")\\s+-\\s+("+u[N]+")\\s*$";var O=d++;u[O]="(<|>)?=?\\s*\\*";for(var A=0;A<35;A++)y(A,u[A]),D[A]||(D[A]=new RegExp(u[A]));function V(z,H){if(z instanceof B)return z;if(typeof z!="string"||z.length>I||!(H?D[n]:D[s]).test(z))return null;try{return new B(z,H)}catch(X){return null}}function B(z,H){if(z instanceof B){if(z.loose===H)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof B))return new B(z,H);y("SemVer",z,H),this.loose=H;var X=z.trim().match(H?D[n]:D[s]);if(!X)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+X[1],this.minor=+X[2],this.patch=+X[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");X[4]?this.prerelease=X[4].split(".").map(function(se){if(/^[0-9]+$/.test(se)){var ae=+se;if(ae>=0&&ae<C)return ae}return se}):this.prerelease=[],this.build=X[5]?X[5].split("."):[],this.format()}t.parse=V,t.valid=function(z,H){var X=V(z,H);return X?X.version:null},t.clean=function(z,H){var X=V(z.trim().replace(/^[=v]+/,""),H);return X?X.version:null},t.SemVer=B,B.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},B.prototype.toString=function(){return this.version},B.prototype.compare=function(z){return y("SemVer.compare",this.version,this.loose,z),z instanceof B||(z=new B(z,this.loose)),this.compareMain(z)||this.comparePre(z)},B.prototype.compareMain=function(z){return z instanceof B||(z=new B(z,this.loose)),K(this.major,z.major)||K(this.minor,z.minor)||K(this.patch,z.patch)},B.prototype.comparePre=function(z){if(z instanceof B||(z=new B(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var H=0;do{var X=this.prerelease[H],se=z.prerelease[H];if(y("prerelease compare",H,X,se),X===void 0&&se===void 0)return 0;if(se===void 0)return 1;if(X===void 0)return-1;if(X!==se)return K(X,se)}while(++H)},B.prototype.inc=function(z,H){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var X=this.prerelease.length;--X>=0;)typeof this.prerelease[X]=="number"&&(this.prerelease[X]++,X=-2);X===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},t.inc=function(z,H,X,se){typeof X=="string"&&(se=X,X=void 0);try{return new B(z,X).inc(H,se).version}catch(ae){return null}},t.diff=function(z,H){if(le(z,H))return null;var X=V(z),se=V(H);if(X.prerelease.length||se.prerelease.length){for(var ae in X)if((ae==="major"||ae==="minor"||ae==="patch")&&X[ae]!==se[ae])return"pre"+ae;return"prerelease"}for(var ae in X)if((ae==="major"||ae==="minor"||ae==="patch")&&X[ae]!==se[ae])return ae},t.compareIdentifiers=K;var $=/^[0-9]+$/;function K(z,H){var X=$.test(z),se=$.test(H);return X&&se&&(z=+z,H=+H),X&&!se?-1:se&&!X?1:z<H?-1:z>H?1:0}function te(z,H,X){return new B(z,X).compare(new B(H,X))}function ie(z,H,X){return te(z,H,X)>0}function oe(z,H,X){return te(z,H,X)<0}function le(z,H,X){return te(z,H,X)===0}function pe(z,H,X){return te(z,H,X)!==0}function De(z,H,X){return te(z,H,X)>=0}function ke(z,H,X){return te(z,H,X)<=0}function Te(z,H,X,se){var ae;switch(H){case"===":typeof z=="object"&&(z=z.version),typeof X=="object"&&(X=X.version),ae=z===X;break;case"!==":typeof z=="object"&&(z=z.version),typeof X=="object"&&(X=X.version),ae=z!==X;break;case"":case"=":case"==":ae=le(z,X,se);break;case"!=":ae=pe(z,X,se);break;case">":ae=ie(z,X,se);break;case">=":ae=De(z,X,se);break;case"<":ae=oe(z,X,se);break;case"<=":ae=ke(z,X,se);break;default:throw new TypeError("Invalid operator: "+H)}return ae}function we(z,H){if(z instanceof we){if(z.loose===H)return z;z=z.value}if(!(this instanceof we))return new we(z,H);y("comparator",z,H),this.loose=H,this.parse(z),this.semver===Fe?this.value="":this.value=this.operator+this.semver.version,y("comp",this)}t.rcompareIdentifiers=function(z,H){return K(H,z)},t.major=function(z,H){return new B(z,H).major},t.minor=function(z,H){return new B(z,H).minor},t.patch=function(z,H){return new B(z,H).patch},t.compare=te,t.compareLoose=function(z,H){return te(z,H,!0)},t.rcompare=function(z,H,X){return te(H,z,X)},t.sort=function(z,H){return z.sort(function(X,se){return t.compare(X,se,H)})},t.rsort=function(z,H){return z.sort(function(X,se){return t.rcompare(X,se,H)})},t.gt=ie,t.lt=oe,t.eq=le,t.neq=pe,t.gte=De,t.lte=ke,t.cmp=Te,t.Comparator=we;var Fe={};function ve(z,H){if(z instanceof ve)return z.loose===H?z:new ve(z.raw,H);if(z instanceof we)return new ve(z.value,H);if(!(this instanceof ve))return new ve(z,H);if(this.loose=H,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(X){return this.parseRange(X.trim())},this).filter(function(X){return X.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function Re(z){return!z||z.toLowerCase()==="x"||z==="*"}function je(z,H,X,se,ae,Se,de,Le,ye,Pe,Ae,Ee,be){return((H=Re(X)?"":Re(se)?">="+X+".0.0":Re(ae)?">="+X+"."+se+".0":">="+H)+" "+(Le=Re(ye)?"":Re(Pe)?"<"+(+ye+1)+".0.0":Re(Ae)?"<"+ye+"."+(+Pe+1)+".0":Ee?"<="+ye+"."+Pe+"."+Ae+"-"+Ee:"<="+Le)).trim()}function Be(z,H){for(var X=0;X<z.length;X++)if(!z[X].test(H))return!1;if(H.prerelease.length){for(X=0;X<z.length;X++)if(y(z[X].semver),z[X].semver!==Fe&&z[X].semver.prerelease.length>0){var se=z[X].semver;if(se.major===H.major&&se.minor===H.minor&&se.patch===H.patch)return!0}return!1}return!0}function xe(z,H,X){try{H=new ve(H,X)}catch(se){return!1}return H.test(z)}function ze(z,H,X,se){var ae,Se,de,Le,ye;switch(z=new B(z,se),H=new ve(H,se),X){case">":ae=ie,Se=ke,de=oe,Le=">",ye=">=";break;case"<":ae=oe,Se=De,de=ie,Le="<",ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(xe(z,H,se))return!1;for(var Pe=0;Pe<H.set.length;++Pe){var Ae=H.set[Pe],Ee=null,be=null;if(Ae.forEach(function(Ce){Ce.semver===Fe&&(Ce=new we(">=0.0.0")),Ee=Ee||Ce,be=be||Ce,ae(Ce.semver,Ee.semver,se)?Ee=Ce:de(Ce.semver,be.semver,se)&&(be=Ce)}),Ee.operator===Le||Ee.operator===ye||(!be.operator||be.operator===Le)&&Se(z,be.semver)||be.operator===ye&&de(z,be.semver))return!1}return!0}we.prototype.parse=function(z){var H=this.loose?D[q]:D[U],X=z.match(H);if(!X)throw new TypeError("Invalid comparator: "+z);this.operator=X[1],this.operator==="="&&(this.operator=""),X[2]?this.semver=new B(X[2],this.loose):this.semver=Fe},we.prototype.toString=function(){return this.value},we.prototype.test=function(z){return y("Comparator.test",z,this.loose),this.semver===Fe||(typeof z=="string"&&(z=new B(z,this.loose)),Te(z,this.operator,this.semver,this.loose))},we.prototype.intersects=function(z,H){if(!(z instanceof we))throw new TypeError("a Comparator is required");var X;if(this.operator==="")return X=new ve(z.value,H),xe(this.value,X,H);if(z.operator==="")return X=new ve(this.value,H),xe(z.semver,X,H);var se=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),ae=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),Se=this.semver.version===z.semver.version,de=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Le=Te(this.semver,"<",z.semver,H)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),ye=Te(this.semver,">",z.semver,H)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return se||ae||Se&&de||Le||ye},t.Range=ve,ve.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},ve.prototype.toString=function(){return this.range},ve.prototype.parseRange=function(z){var H=this.loose;z=z.trim(),y("range",z,H);var X=H?D[b]:D[M];z=z.replace(X,je),y("hyphen replace",z),z=z.replace(D[R],"$1$2$3"),y("comparator trim",z,D[R]),z=(z=(z=z.replace(D[Q],"$1~")).replace(D[J],"$1^")).split(/\s+/).join(" ");var se=H?D[q]:D[U],ae=z.split(" ").map(function(Se){return function(de,Le){return y("comp",de),de=function(ye,Pe){return ye.trim().split(/\s+/).map(function(Ae){return function(Ee,be){y("caret",Ee,be);var Ce=be?D[x]:D[W];return Ee.replace(Ce,function(Oe,ce,he,ge,me){var Ie;return y("caret",Ee,Oe,ce,he,ge,me),Re(ce)?Ie="":Re(he)?Ie=">="+ce+".0.0 <"+(+ce+1)+".0.0":Re(ge)?Ie=ce==="0"?">="+ce+"."+he+".0 <"+ce+"."+(+he+1)+".0":">="+ce+"."+he+".0 <"+(+ce+1)+".0.0":me?(y("replaceCaret pr",me),me.charAt(0)!=="-"&&(me="-"+me),Ie=ce==="0"?he==="0"?">="+ce+"."+he+"."+ge+me+" <"+ce+"."+he+"."+(+ge+1):">="+ce+"."+he+"."+ge+me+" <"+ce+"."+(+he+1)+".0":">="+ce+"."+he+"."+ge+me+" <"+(+ce+1)+".0.0"):(y("no pr"),Ie=ce==="0"?he==="0"?">="+ce+"."+he+"."+ge+" <"+ce+"."+he+"."+(+ge+1):">="+ce+"."+he+"."+ge+" <"+ce+"."+(+he+1)+".0":">="+ce+"."+he+"."+ge+" <"+(+ce+1)+".0.0"),y("caret return",Ie),Ie})}(Ae,Pe)}).join(" ")}(de,Le),y("caret",de),de=function(ye,Pe){return ye.trim().split(/\s+/).map(function(Ae){return function(Ee,be){var Ce=be?D[re]:D[ne];return Ee.replace(Ce,function(Oe,ce,he,ge,me){var Ie;return y("tilde",Ee,Oe,ce,he,ge,me),Re(ce)?Ie="":Re(he)?Ie=">="+ce+".0.0 <"+(+ce+1)+".0.0":Re(ge)?Ie=">="+ce+"."+he+".0 <"+ce+"."+(+he+1)+".0":me?(y("replaceTilde pr",me),me.charAt(0)!=="-"&&(me="-"+me),Ie=">="+ce+"."+he+"."+ge+me+" <"+ce+"."+(+he+1)+".0"):Ie=">="+ce+"."+he+"."+ge+" <"+ce+"."+(+he+1)+".0",y("tilde return",Ie),Ie})}(Ae,Pe)}).join(" ")}(de,Le),y("tildes",de),de=function(ye,Pe){return y("replaceXRanges",ye,Pe),ye.split(/\s+/).map(function(Ae){return function(Ee,be){Ee=Ee.trim();var Ce=be?D[k]:D[L];return Ee.replace(Ce,function(Oe,ce,he,ge,me,Ie){y("xRange",Ee,Oe,ce,he,ge,me,Ie);var Ve=Re(he),Me=Ve||Re(ge),Ue=Me||Re(me);return ce==="="&&Ue&&(ce=""),Ve?Oe=ce===">"||ce==="<"?"<0.0.0":"*":ce&&Ue?(Me&&(ge=0),Ue&&(me=0),ce===">"?(ce=">=",Me?(he=+he+1,ge=0,me=0):Ue&&(ge=+ge+1,me=0)):ce==="<="&&(ce="<",Me?he=+he+1:ge=+ge+1),Oe=ce+he+"."+ge+"."+me):Me?Oe=">="+he+".0.0 <"+(+he+1)+".0.0":Ue&&(Oe=">="+he+"."+ge+".0 <"+he+"."+(+ge+1)+".0"),y("xRange return",Oe),Oe})}(Ae,Pe)}).join(" ")}(de,Le),y("xrange",de),de=function(ye,Pe){return y("replaceStars",ye,Pe),ye.trim().replace(D[O],"")}(de,Le),y("stars",de),de}(Se,H)}).join(" ").split(/\s+/);return this.loose&&(ae=ae.filter(function(Se){return!!Se.match(se)})),ae=ae.map(function(Se){return new we(Se,H)})},ve.prototype.intersects=function(z,H){if(!(z instanceof ve))throw new TypeError("a Range is required");return this.set.some(function(X){return X.every(function(se){return z.set.some(function(ae){return ae.every(function(Se){return se.intersects(Se,H)})})})})},t.toComparators=function(z,H){return new ve(z,H).set.map(function(X){return X.map(function(se){return se.value}).join(" ").trim().split(" ")})},ve.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new B(z,this.loose));for(var H=0;H<this.set.length;H++)if(Be(this.set[H],z))return!0;return!1},t.satisfies=xe,t.maxSatisfying=function(z,H,X){var se=null,ae=null;try{var Se=new ve(H,X)}catch(de){return null}return z.forEach(function(de){Se.test(de)&&(se&&ae.compare(de)!==-1||(ae=new B(se=de,X)))}),se},t.minSatisfying=function(z,H,X){var se=null,ae=null;try{var Se=new ve(H,X)}catch(de){return null}return z.forEach(function(de){Se.test(de)&&(se&&ae.compare(de)!==1||(ae=new B(se=de,X)))}),se},t.validRange=function(z,H){try{return new ve(z,H).range||"*"}catch(X){return null}},t.ltr=function(z,H,X){return ze(z,H,"<",X)},t.gtr=function(z,H,X){return ze(z,H,">",X)},t.outside=ze,t.prerelease=function(z,H){var X=V(z,H);return X&&X.prerelease.length?X.prerelease:null},t.intersects=function(z,H,X){return z=new ve(z,X),H=new ve(H,X),z.intersects(H)},t.coerce=function(z){if(z instanceof B)return z;if(typeof z!="string")return null;var H=z.match(D[j]);return H==null?null:V((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,g(1))},function(G,t){var g,T,y=G.exports={};function I(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function D(P){if(g===setTimeout)return setTimeout(P,0);if((g===I||!g)&&setTimeout)return g=setTimeout,setTimeout(P,0);try{return g(P,0)}catch(S){try{return g.call(null,P,0)}catch(w){return g.call(this,P,0)}}}(function(){try{g=typeof setTimeout=="function"?setTimeout:I}catch(P){g=I}try{T=typeof clearTimeout=="function"?clearTimeout:C}catch(P){T=C}})();var u,d=[],v=!1,p=-1;function E(){v&&u&&(v=!1,u.length?d=u.concat(d):p=-1,d.length&&F())}function F(){if(!v){var P=D(E);v=!0;for(var S=d.length;S;){for(u=d,d=[];++p<S;)u&&u[p].run();p=-1,S=d.length}u=null,v=!1,function(w){if(T===clearTimeout)return clearTimeout(w);if((T===C||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(w);try{T(w)}catch(l){try{return T.call(null,w)}catch(r){return T.call(this,w)}}}(P)}}function c(P,S){this.fun=P,this.array=S}function f(){}y.nextTick=function(P){var S=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)S[w-1]=arguments[w];d.push(new c(P,S)),d.length!==1||v||D(F)},c.prototype.run=function(){this.fun.apply(null,this.array)},y.title="browser",y.browser=!0,y.env={},y.argv=[],y.version="",y.versions={},y.on=f,y.addListener=f,y.once=f,y.off=f,y.removeListener=f,y.removeAllListeners=f,y.emit=f,y.prependListener=f,y.prependOnceListener=f,y.listeners=function(P){return[]},y.binding=function(P){throw new Error("process.binding is not supported")},y.cwd=function(){return"/"},y.chdir=function(P){throw new Error("process.chdir is not supported")},y.umask=function(){return 0}}])}),define(Y[36],ee([0,1,8,2]),function(G,t,g,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function y(l){const r=l;return r?[r.on,r.pause,r.resume,r.destroy].every(s=>typeof s=="function"):!1}t.isReadableStream=y;function I(l){const r=l;return r?y(r.stream)&&Array.isArray(r.buffer)&&typeof r.ended=="boolean":!1}t.isReadableBufferedStream=I;function C(l,r){return new D(l,r)}t.newWriteableStream=C;class D{constructor(r,s){this.reducer=r,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(r){if(!this.state.destroyed){if(this.state.flowing)this.emitData(r);else if(this.buffer.data.push(r),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(r){this.state.destroyed||(this.state.flowing?this.emitError(r):this.buffer.error.push(r))}end(r){this.state.destroyed||(typeof r!="undefined"&&this.write(r),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(r){this.listeners.data.slice(0).forEach(s=>s(r))}emitError(r){this.listeners.error.length===0?(0,g.onUnexpectedError)(r):this.listeners.error.slice(0).forEach(s=>s(r))}emitEnd(){this.listeners.end.slice(0).forEach(r=>r())}on(r,s){if(!this.state.destroyed)switch(r){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(r,s){if(this.state.destroyed)return;let e;switch(r){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const i=e.indexOf(s);i>=0&&e.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const r=this.reducer(this.buffer.data);this.emitData(r),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const r of this.buffer.error)this.emitError(r);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function u(l,r){const s=[];let e;for(;(e=l.read())!==null;)s.push(e);return r(s)}t.consumeReadable=u;function d(l,r,s){const e=[];let i;for(;(i=l.read())!==null&&e.length<s;)e.push(i);return i===null&&e.length>0?r(e):{read:()=>{if(e.length>0)return e.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return l.read()}}}t.peekReadable=d;function v(l,r){return new Promise((s,e)=>{const i=[];p(l,{onData:n=>{r&&i.push(n)},onError:n=>{r?e(n):s(void 0)},onEnd:()=>{s(r?r(i):void 0)}})})}t.consumeStream=v;function p(l,r){l.on("error",s=>r.onError(s)),l.on("end",()=>r.onEnd()),l.on("data",s=>r.onData(s))}t.listenStream=p;function E(l,r){return new Promise((s,e)=>{const i=new T.DisposableStore,n=[],o=m=>{if(n.push(m),n.length>r)return i.dispose(),l.pause(),s({stream:l,buffer:n,ended:!1})},a=m=>e(m),h=()=>s({stream:l,buffer:n,ended:!0});i.add((0,T.toDisposable)(()=>l.removeListener("error",a))),l.on("error",a),i.add((0,T.toDisposable)(()=>l.removeListener("end",h))),l.on("end",h),i.add((0,T.toDisposable)(()=>l.removeListener("data",o))),l.on("data",o)})}t.peekStream=E;function F(l,r){const s=C(r);return s.end(l),s}t.toStream=F;function c(){const l=C(()=>{throw new Error("not supported")});return l.end(),l}t.emptyStream=c;function f(l){let r=!1;return{read:()=>r?null:(r=!0,l)}}t.toReadable=f;function P(l,r,s){const e=C(s);return p(l,{onData:i=>e.write(r.data(i)),onError:i=>e.error(r.error?r.error(i):i),onEnd:()=>e.end()}),e}t.transform=P;function S(l,r,s){let e=!1;return{read:()=>{const i=r.read();return e?i:(e=!0,i!==null?s([l,i]):l)}}}t.prefixedReadable=S;function w(l,r,s){let e=!1;const i=C(s);return p(r,{onData:n=>e?i.write(n):(e=!0,i.write(s([l,n]))),onError:n=>i.error(n),onEnd:()=>{e||(e=!0,i.write(l)),i.end()}}),i}t.prefixedStream=w}),define(Y[16],ee([0,1,18,36]),function(G,t,g,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const y=typeof Buffer!="undefined",I=typeof TextEncoder!="undefined",C=typeof TextDecoder!="undefined";let D,u;class d{constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}static alloc(m){return y?new d(Buffer.allocUnsafe(m)):new d(new Uint8Array(m))}static wrap(m){return y&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new d(m)}static fromString(m,N){return!(N?.dontUseNodeBuffer||!1)&&y?new d(Buffer.from(m)):I?(D||(D=new TextEncoder),new d(D.encode(m))):new d(g.encodeUTF8(m))}static concat(m,N){if(typeof N=="undefined"){N=0;for(let j=0,_=m.length;j<_;j++)N+=m[j].byteLength}const L=d.alloc(N);let k=0;for(let j=0,_=m.length;j<_;j++){const Q=m[j];L.set(Q,k),k+=Q.byteLength}return L}toString(){return y?this.buffer.toString():C?(u||(u=new TextDecoder),u.decode(this.buffer)):g.decodeUTF8(this.buffer)}slice(m,N){return new d(this.buffer.subarray(m,N))}set(m,N){m instanceof d?this.buffer.set(m.buffer,N):this.buffer.set(m,N)}readUInt32BE(m){return E(this.buffer,m)}writeUInt32BE(m,N){F(this.buffer,m,N)}readUInt32LE(m){return c(this.buffer,m)}writeUInt32LE(m,N){f(this.buffer,m,N)}readUInt8(m){return P(this.buffer,m)}writeUInt8(m,N){S(this.buffer,m,N)}}t.VSBuffer=d;function v(h,m){return h[m+0]<<0>>>0|h[m+1]<<8>>>0}t.readUInt16LE=v;function p(h,m,N){h[N+0]=m&255,m=m>>>8,h[N+1]=m&255}t.writeUInt16LE=p;function E(h,m){return h[m]*2**24+h[m+1]*2**16+h[m+2]*2**8+h[m+3]}t.readUInt32BE=E;function F(h,m,N){h[N+3]=m,m=m>>>8,h[N+2]=m,m=m>>>8,h[N+1]=m,m=m>>>8,h[N]=m}t.writeUInt32BE=F;function c(h,m){return h[m+0]<<0>>>0|h[m+1]<<8>>>0|h[m+2]<<16>>>0|h[m+3]<<24>>>0}t.readUInt32LE=c;function f(h,m,N){h[N+0]=m&255,m=m>>>8,h[N+1]=m&255,m=m>>>8,h[N+2]=m&255,m=m>>>8,h[N+3]=m&255}t.writeUInt32LE=f;function P(h,m){return h[m]}t.readUInt8=P;function S(h,m,N){h[N]=m}t.writeUInt8=S;function w(h){return T.consumeReadable(h,m=>d.concat(m))}t.readableToBuffer=w;function l(h){return T.toReadable(h)}t.bufferToReadable=l;function r(h){return T.consumeStream(h,m=>d.concat(m))}t.streamToBuffer=r;async function s(h){return h.ended?d.concat(h.buffer):d.concat([...h.buffer,await r(h.stream)])}t.bufferedStreamToBuffer=s;function e(h){return T.toStream(h,m=>d.concat(m))}t.bufferToStream=e;function i(h){return T.transform(h,{data:m=>typeof m=="string"?d.fromString(m):d.wrap(m)},m=>d.concat(m))}t.streamToBufferReadableStream=i;function n(h){return T.newWriteableStream(m=>d.concat(m),h)}t.newWriteableBufferStream=n;function o(h,m){return T.prefixedReadable(h,m,N=>d.concat(N))}t.prefixedBufferReadable=o;function a(h,m){return T.prefixedStream(h,m,N=>d.concat(N))}t.prefixedBufferStream=a}),define(Y[19],ee([0,1,12]),function(G,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function T(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const P=Array.isArray(f)?[]:{};return Object.keys(f).forEach(S=>{f[S]&&typeof f[S]=="object"?P[S]=T(f[S]):P[S]=f[S]}),P}t.deepClone=T;function y(f){if(!f||typeof f!="object")return f;const P=[f];for(;P.length>0;){const S=P.shift();Object.freeze(S);for(const w in S)if(I.call(S,w)){const l=S[w];typeof l=="object"&&!Object.isFrozen(l)&&P.push(l)}}return f}t.deepFreeze=y;const I=Object.prototype.hasOwnProperty;function C(f,P){return D(f,P,new Set)}t.cloneAndChange=C;function D(f,P,S){if((0,g.isUndefinedOrNull)(f))return f;const w=P(f);if(typeof w!="undefined")return w;if((0,g.isArray)(f)){const l=[];for(const r of f)l.push(D(r,P,S));return l}if((0,g.isObject)(f)){if(S.has(f))throw new Error("Cannot clone recursive data-structure");S.add(f);const l={};for(let r in f)I.call(f,r)&&(l[r]=D(f[r],P,S));return S.delete(f),l}return f}function u(f,P,S=!0){return(0,g.isObject)(f)?((0,g.isObject)(P)&&Object.keys(P).forEach(w=>{w in f?S&&((0,g.isObject)(f[w])&&(0,g.isObject)(P[w])?u(f[w],P[w],S):f[w]=P[w]):f[w]=P[w]}),f):P}t.mixin=u;function d(f,P){if(f===P)return!0;if(f==null||P===null||P===void 0||typeof f!=typeof P||typeof f!="object"||Array.isArray(f)!==Array.isArray(P))return!1;let S,w;if(Array.isArray(f)){if(f.length!==P.length)return!1;for(S=0;S<f.length;S++)if(!d(f[S],P[S]))return!1}else{const l=[];for(w in f)l.push(w);l.sort();const r=[];for(w in P)r.push(w);if(r.sort(),!d(l,r))return!1;for(S=0;S<l.length;S++)if(!d(f[l[S]],P[l[S]]))return!1}return!0}t.equals=d;function v(f){const P=new Set;return JSON.stringify(f,(S,w)=>{if((0,g.isObject)(w)||Array.isArray(w)){if(P.has(w))return"[Circular]";P.add(w)}return w})}t.safeStringify=v;function p(f,P,S){const w=P(f);return typeof w=="undefined"?S:w}t.getOrDefault=p;function E(f,P){const S=Object.create(null);return!f||!P||Object.keys(P).forEach(l=>{const r=f[l],s=P[l];d(r,s)||(S[l]=s)}),S}t.distinct=E;function F(f,P){const S=P.toLowerCase(),w=Object.keys(f).find(l=>l.toLowerCase()===S);return w?f[w]:f[P]}t.getCaseInsensitive=F;function c(f,P){const S=Object.create(null);for(const w of Object.keys(f))P(w,f[w])&&(S[w]=f[w]);return S}t.filter=c}),define(Y[59],ee([0,1,7]),function(G,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function T(d){const v=d;return v&&typeof v.type=="string"&&typeof v.severity=="string"}t.isRemoteConsoleLog=T;function y(d){const v=[];let p;try{const E=JSON.parse(d.arguments),F=E[E.length-1];F&&F.__$stack&&(E.pop(),p=F.__$stack),v.push(...E)}catch(E){v.push("Unable to log remote console arguments",d.arguments)}return{args:v,stack:p}}t.parse=y;function I(d){if(typeof d!="string")return I(y(d).stack);const v=d;if(v){const p=C(v),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if(E&&E.length===4)return{uri:g.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}t.getFirstFrame=I;function C(d){if(!d)return d;const v=d.indexOf(`
`);return v===-1?d:d.substring(0,v)}function D(d,v){const{args:p,stack:E}=y(d),F=typeof p[0]=="string"&&p.length===1;let c=C(E);c&&(c=`(${c.trim()})`);let f=[];if(typeof p[0]=="string"?c&&F?f=[`%c[${v}] %c${p[0]} %c${c}`,u("blue"),u(""),u("grey")]:f=[`%c[${v}] %c${p[0]}`,u("blue"),u(""),...p.slice(1)]:f=[`%c[${v}]%`,u("blue"),...p],c&&!F&&f.push(c),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,f)}t.log=D;function u(d){return`color: ${d}`}}),define(Y[60],ee([0,1,16,18,7]),function(G,t,g,T,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function I(v){return JSON.stringify(v,u)}t.stringify=I;function C(v){let p=JSON.parse(v);return p=d(p),p}t.parse=C;var D;(function(v){v[v.Uri=1]="Uri",v[v.Regexp=2]="Regexp",v[v.ScmResource=3]="ScmResource",v[v.ScmResourceGroup=4]="ScmResourceGroup",v[v.ScmProvider=5]="ScmProvider",v[v.CommentController=6]="CommentController",v[v.CommentThread=7]="CommentThread",v[v.CommentThreadReply=8]="CommentThreadReply",v[v.CommentNode=9]="CommentNode",v[v.CommentThreadNode=10]="CommentThreadNode",v[v.TimelineActionContext=11]="TimelineActionContext",v[v.NotebookCellActionContext=12]="NotebookCellActionContext",v[v.TestItemContext=13]="TestItemContext"})(D=t.MarshalledId||(t.MarshalledId={}));function u(v,p){return p instanceof RegExp?{$mid:2,source:p.source,flags:(0,T.regExpFlags)(p)}:p}function d(v,p=0){if(!v||p>200)return v;if(typeof v=="object"){switch(v.$mid){case 1:return y.URI.revive(v);case 2:return new RegExp(v.source,v.flags)}if(v instanceof g.VSBuffer||v instanceof Uint8Array)return v;if(Array.isArray(v))for(let E=0;E<v.length;++E)v[E]=d(v[E],p+1);else for(const E in v)Object.hasOwnProperty.call(v,E)&&(v[E]=d(v[E],p+1))}return v}t.revive=d}),define(Y[61],ee([0,1,18,37,3,45,4]),function(G,t,g,T,y,I,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function D(){return Object.create(null)}t.getEmptyExpression=D;const u="**",d="/",v="[/\\\\]",p="[^/\\\\]",E=/\//g;function F(R){switch(R){case 0:return"";case 1:return`${p}*?`;default:return`(?:${v}|${p}+${v}|${v}${p}+)*?`}}function c(R,M){if(!R)return[];const b=[];let O=!1,A=!1,V="";for(const B of R){switch(B){case M:if(!O&&!A){b.push(V),V="";continue}break;case"{":O=!0;break;case"}":O=!1;break;case"[":A=!0;break;case"]":A=!1;break}V+=B}return V&&b.push(V),b}t.splitGlobAware=c;function f(R){if(!R)return"";let M="";const b=c(R,d);if(b.every(O=>O===u))M=".*";else{let O=!1;b.forEach((A,V)=>{if(A===u){O||(M+=F(2),O=!0);return}let B=!1,$="",K=!1,te="";for(const ie of A){if(ie!=="}"&&B){$+=ie;continue}if(K&&(ie!=="]"||!te)){let oe;ie==="-"?oe=ie:(ie==="^"||ie==="!")&&!te?oe="^":ie===d?oe="":oe=g.escapeRegExpCharacters(ie),te+=oe;continue}switch(ie){case"{":B=!0;continue;case"[":K=!0;continue;case"}":M+=`(?:${c($,",").map(pe=>f(pe)).join("|")})`,B=!1,$="";break;case"]":M+="["+te+"]",K=!1,te="";break;case"?":M+=p;continue;case"*":M+=F(1);continue;default:M+=g.escapeRegExpCharacters(ie)}}V<b.length-1&&(b[V+1]!==u||V+2<b.length)&&(M+=v),O=!1})}return M}const P=/^\*\*\/\*\.[\w\.-]+$/,S=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,l=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new I.LRUCache(1e4),i=function(){return!1},n=function(){return null};function o(R,M){if(!R)return n;let b;typeof R!="string"?b=R.pattern:b=R,b=b.trim();const O=`${b}_${!!M.trimForExclusions}`;let A=e.get(O);if(A)return a(A,R);let V;if(P.test(b)){const B=b.substr(4);A=function($,K){return typeof $=="string"&&$.endsWith(B)?b:null}}else(V=S.exec(h(b,M)))?A=m(V[1],b):(M.trimForExclusions?l:w).test(b)?A=N(b,M):(V=r.exec(h(b,M)))?A=L(V[1].substr(1),b,!0):(V=s.exec(h(b,M)))?A=L(V[1],b,!1):A=k(b);return e.set(O,A),a(A,R)}function a(R,M){return typeof M=="string"?R:function(b,O){return T.isEqualOrParent(b,M.base)?R(y.relative(M.base,b),O):null}}function h(R,M){return M.trimForExclusions&&R.endsWith("/**")?R.substr(0,R.length-2):R}function m(R,M){const b=`/${R}`,O=`\\${R}`,A=function(B,$){return typeof B!="string"?null:$?$===R?M:null:B===R||B.endsWith(b)||B.endsWith(O)?M:null},V=[R];return A.basenames=V,A.patterns=[M],A.allBasenames=V,A}function N(R,M){const b=U(R.slice(1,-1).split(",").map($=>o($,M)).filter($=>$!==n),R),O=b.length;if(!O)return n;if(O===1)return b[0];const A=function($,K){for(let te=0,ie=b.length;te<ie;te++)if(b[te]($,K))return R;return null},V=b.find($=>!!$.allBasenames);V&&(A.allBasenames=V.allBasenames);const B=b.reduce(($,K)=>K.allPaths?$.concat(K.allPaths):$,[]);return B.length&&(A.allPaths=B),A}function L(R,M,b){const O=y.sep===y.posix.sep,A=O?R:R.replace(E,y.sep),V=y.sep+A,B=y.posix.sep+R,$=b?function(K,te){return typeof K=="string"&&(K===A||K.endsWith(V)||!O&&(K===R||K.endsWith(B)))?M:null}:function(K,te){return typeof K=="string"&&(K===A||!O&&K===R)?M:null};return $.allPaths=[(b?"*/":"./")+R],$}function k(R){try{const M=new RegExp(`^${f(R)}$`);return function(b){return M.lastIndex=0,typeof b=="string"&&M.test(b)?R:null}}catch(M){return n}}function j(R,M,b){return!R||typeof M!="string"?!1:_(R)(M,void 0,b)}t.match=j;function _(R,M={}){if(!R)return i;if(typeof R=="string"||Z(R)){const b=o(R,M);if(b===n)return i;const O=function(A,V){return!!b(A,V)};return b.allBasenames&&(O.allBasenames=b.allBasenames),b.allPaths&&(O.allPaths=b.allPaths),O}return x(R,M)}t.parse=_;function Q(R){if(!R)return;let M;return b=>(M||(M=(R()||Promise.resolve([])).then(O=>O?re(O):{})),M.then(O=>!!O[b]))}t.hasSiblingPromiseFn=Q;function ne(R){if(!R)return;let M;return b=>{if(!M){const O=R();M=O?re(O):{}}return!!M[b]}}t.hasSiblingFn=ne;function re(R){const M={};for(const b of R)M[b]=!0;return M}function Z(R){const M=R;return M&&typeof M.base=="string"&&typeof M.pattern=="string"}t.isRelativePattern=Z;function J(R){return R.allBasenames||[]}t.getBasenameTerms=J;function W(R){return R.allPaths||[]}t.getPathTerms=W;function x(R,M){const b=U(Object.getOwnPropertyNames(R).map($=>q($,R[$],M)).filter($=>$!==n)),O=b.length;if(!O)return n;if(!b.some($=>!!$.requiresSiblings)){if(O===1)return b[0];const $=function(ie,oe){for(let le=0,pe=b.length;le<pe;le++){const De=b[le](ie,oe);if(De)return De}return null},K=b.find(ie=>!!ie.allBasenames);K&&($.allBasenames=K.allBasenames);const te=b.reduce((ie,oe)=>oe.allPaths?ie.concat(oe.allPaths):ie,[]);return te.length&&($.allPaths=te),$}const A=function($,K,te){let ie;for(let oe=0,le=b.length;oe<le;oe++){const pe=b[oe];pe.requiresSiblings&&te&&(K||(K=y.basename($)),ie||(ie=K.substr(0,K.length-y.extname($).length)));const De=pe($,K,ie,te);if(De)return De}return null},V=b.find($=>!!$.allBasenames);V&&(A.allBasenames=V.allBasenames);const B=b.reduce(($,K)=>K.allPaths?$.concat(K.allPaths):$,[]);return B.length&&(A.allPaths=B),A}function q(R,M,b){if(M===!1)return n;const O=o(R,b);if(O===n)return n;if(typeof M=="boolean")return O;if(M){const A=M.when;if(typeof A=="string"){const V=(B,$,K,te)=>{if(!te||!O(B,$))return null;const ie=A.replace("$(basename)",K),oe=te(ie);return(0,C.isThenable)(oe)?oe.then(le=>le?R:null):oe?R:null};return V.requiresSiblings=!0,V}}return O}function U(R,M){const b=R.filter($=>!!$.basenames);if(b.length<2)return R;const O=b.reduce(($,K)=>{const te=K.basenames;return te?$.concat(te):$},[]);let A;if(M){A=[];for(let $=0,K=O.length;$<K;$++)A.push(M)}else A=b.reduce(($,K)=>{const te=K.patterns;return te?$.concat(te):$},[]);const V=function($,K){if(typeof $!="string")return null;if(!K){let ie;for(ie=$.length;ie>0;ie--){const oe=$.charCodeAt(ie-1);if(oe===47||oe===92)break}K=$.substr(ie)}const te=O.indexOf(K);return te!==-1?A[te]:null};V.basenames=O,V.patterns=A,V.allBasenames=O;const B=R.filter($=>!$.basenames);return B.push(V),B}}),define(Y[62],ee([0,1,7,3,18,9,15,20,37]),function(G,t,g,T,y,I,C,D,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function d(o,a,h){if(typeof o=="string"&&(o=g.URI.file(o)),h){const N=h.getWorkspaceFolder(o);if(N){const L=h.getWorkspace().folders.length>1;let k;if((0,D.isEqual)(N.uri,o)?k="":k=(0,D.relativePath)(N.uri,o),L){const j=N.name?N.name:(0,D.basename)(N.uri);k=k?j+" \u2022 "+k:j}return k}}if(o.scheme!==I.Schemas.file&&o.scheme!==I.Schemas.untitled)return o.with({query:null,fragment:null}).toString(!0);if((0,u.hasDriveLetter)(o.fsPath))return(0,T.normalize)(p(o.fsPath));let m=(0,T.normalize)(o.fsPath);return!C.isWindows&&a?.userHome&&(m=F(m,a.userHome.fsPath)),m}t.getPathLabel=d;function v(o){if(!o)return;typeof o=="string"&&(o=g.URI.file(o));const a=(0,D.basename)(o)||(o.scheme===I.Schemas.file?o.fsPath:o.path);return C.isWindows&&(0,u.isRootOrDriveLetter)(a)?p(a):a}t.getBaseLabel=v;function p(o){return(0,u.hasDriveLetter)(o)?o.charAt(0).toUpperCase()+o.slice(1):o}t.normalizeDriveLetter=p;let E=Object.create(null);function F(o,a){if(C.isWindows||!o||!a)return o;let h=E.original===a?E.normalized:void 0;return h||(h=`${(0,y.rtrim)(a,T.posix.sep)}${T.posix.sep}`,E={original:a,normalized:h}),(C.isLinux?o.startsWith(h):(0,y.startsWithIgnoreCase)(o,h))&&(o=`~/${o.substr(h.length)}`),o}t.tildify=F;function c(o,a){return o.replace(/^~($|\/|\\)/,`${a}$1`)}t.untildify=c;const f="\u2026",P="\\\\",S="~";function w(o,a=T.sep){const h=new Array(o.length);let m=!1;for(let N=0;N<o.length;N++){let L=o[N];if(L===""){h[N]=`.${a}`;continue}if(!L){h[N]=L;continue}m=!0;let k="";L.indexOf(P)===0?(k=L.substr(0,L.indexOf(P)+P.length),L=L.substr(L.indexOf(P)+P.length)):L.indexOf(a)===0?(k=L.substr(0,L.indexOf(a)+a.length),L=L.substr(L.indexOf(a)+a.length)):L.indexOf(S)===0&&(k=L.substr(0,L.indexOf(S)+S.length),L=L.substr(L.indexOf(S)+S.length));const j=L.split(a);for(let _=1;m&&_<=j.length;_++)for(let Q=j.length-_;m&&Q>=0;Q--){m=!1;let ne=j.slice(Q,Q+_).join(a);for(let re=0;!m&&re<o.length;re++)if(re!==N&&o[re]&&o[re].indexOf(ne)>-1){const Z=Q+_===j.length,J=Q>0&&o[re].indexOf(a)>-1?a+ne:ne,W=o[re].endsWith(J);m=!Z||W}if(!m){let re="";(j[0].endsWith(":")||k!=="")&&(Q===1&&(Q=0,_++,ne=j[0]+a+ne),Q>0&&(re=j[0]+a),re=k+re),Q>0&&(re=re+f+a),re=re+ne,Q+_<j.length&&(re=re+a+f),h[N]=re}}m&&(h[N]=L)}return h}t.shorten=w;var l;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function r(o,a=Object.create(null)){const h=[];let m=!1,N="";for(const L of o)if(L==="$"||m&&L==="{")N&&h.push({value:N,type:l.TEXT}),N="",m=!0;else if(L==="}"&&m){const k=a[N];if(typeof k=="string")k.length&&h.push({value:k,type:l.VARIABLE});else if(k){const j=h[h.length-1];(!j||j.type!==l.SEPARATOR)&&h.push({value:k.label,type:l.SEPARATOR})}N="",m=!1}else N+=L;return N&&!m&&h.push({value:N,type:l.TEXT}),h.filter((L,k)=>{if(L.type===l.SEPARATOR){const j=h[k-1],_=h[k+1];return[j,_].every(Q=>Q&&(Q.type===l.VARIABLE||Q.type===l.TEXT)&&Q.value.length>0)}return!0}).map(L=>L.value).join("")}t.template=r;function s(o,a){return C.isMacintosh||a?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):o.replace(/&&|&/g,h=>h==="&"?"&&":"&")}t.mnemonicMenuLabel=s;function e(o,a){return C.isMacintosh||a?o.replace(/\(&&\w\)|&&/g,""):C.isWindows?o.replace(/&&|&/g,h=>h==="&"?"&&":"&"):o.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function i(o){return o.replace(/&/g,"&&")}t.unmnemonicLabel=i;function n(o){const a=o.indexOf("/")!==-1?T.posix:T.win32,h=a.basename(o),m=a.dirname(o);return h.length?{name:h,parentPath:m}:{name:m,parentPath:""}}t.splitName=n}),define(Y[46],ee([0,1,126]),function(G,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class T{constructor(I="utf8"){this.stringDecoder=new g.StringDecoder(I),this.remaining=null}write(I){const C=[],D=this.remaining?this.remaining+this.stringDecoder.write(I):this.stringDecoder.write(I);if(D.length<1)return C;let u=0,d,v=u;for(;v<D.length;)if(d=D.charCodeAt(v),d===13||d===10){if(C.push(D.substring(u,v)),v++,v<D.length){const p=d;d=D.charCodeAt(v),(p===13&&d===10||p===10&&d===13)&&v++}u=v}else v++;return this.remaining=u<D.length?D.substr(u):null,C}end(){return this.remaining}}t.LineDecoder=T}),define(Y[63],ee([0,1,38,18,3,10]),function(G,t,g,T,y,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function C(v){const p=(0,y.dirname)(v);if(v===p)return v;const E=((0,y.basename)(v)||v).toLowerCase();try{const c=(0,I.readdirSync)(p).filter(f=>f.toLowerCase()===E);if(c.length===1){const f=C(p);if(f)return(0,y.join)(f,c[0])}else if(c.length>1){const f=c.indexOf(E);if(f>=0){const P=C(p);if(P)return(0,y.join)(P,c[f])}}}catch(F){}return null}t.realcaseSync=C;async function D(v){try{return await I.Promises.realpath(v)}catch(p){const E=d(v);return await I.Promises.access(E,g.constants.R_OK),E}}t.realpath=D;function u(v){try{return g.realpathSync(v)}catch(p){const E=d(v);return g.accessSync(E,g.constants.R_OK),E}}t.realpathSync=u;function d(v){return(0,T.rtrim)((0,y.normalize)(v),y.sep)}}),define(Y[64],ee([0,1,10,31,3]),function(G,t,g,T,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const I=/^\d+$/,C=/^Microsoft.PowerShell_.*/,D=/^Microsoft.PowerShellPreview_.*/;var u;(function(r){r[r.x64=0]="x64",r[r.x86=1]="x86",r[r.ARM=2]="ARM"})(u||(u={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let v;process.env.PROCESSOR_ARCHITEW6432?v=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?v=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?v=1:v=0;class p{constructor(s,e,i){this.exePath=s,this.displayName=e,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await g.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function E({useAlternateBitness:r=!1}={}){return r?d===0?process.env["ProgramFiles(x86)"]||null:v===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function F({useAlternateBitness:r=!1,findPreview:s=!1}={}){const e=E({useAlternateBitness:r});if(!e)return null;const i=y.join(e,"PowerShell");if(!await g.SymlinkSupport.existsDirectory(i))return null;let n=-1,o=null;for(const m of await g.Promises.readdir(i)){let N=-1;if(s){const k=m.indexOf("-");if(k<0)continue;const j=m.substring(0,k);if(!I.test(j)||m.substring(k+1)!=="preview")continue;N=parseInt(j,10)}else{if(!I.test(m))continue;N=parseInt(m,10)}if(N<=n)continue;const L=y.join(i,m,"pwsh.exe");!await g.SymlinkSupport.existsFile(L)||(o=L,n=N)}if(!o)return null;const a=e.includes("x86")?" (x86)":"",h=s?" Preview":"";return new p(o,`PowerShell${h}${a}`,!0)}async function c({findPreview:r}={}){if(!process.env.LOCALAPPDATA)return null;const s=y.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await g.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:e,pwshMsixName:i}=r?{pwshMsixDirRegex:D,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const n of await g.Promises.readdir(s))if(e.test(n)){const o=y.join(s,n,"pwsh.exe");return new p(o,i)}return null}function f(){const r=y.join(T.homedir(),".dotnet","tools","pwsh.exe");return new p(r,".NET Core PowerShell Global Tool")}function P(){const r=y.join(process.env.windir,d===1&&v!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new p(r,"Windows PowerShell",!0)}async function*S(){let r=await F();r&&(yield r),r=await F({useAlternateBitness:!0}),r&&(yield r),r=await c(),r&&(yield r),r=f(),r&&(yield r),r=await F({findPreview:!0}),r&&(yield r),r=await c({findPreview:!0}),r&&(yield r),r=await F({useAlternateBitness:!0,findPreview:!0}),r&&(yield r),r=P(),r&&(yield r)}async function*w(){for await(const r of S())await r.exists()&&(yield r)}t.enumeratePowerShellInstallations=w;async function l(){for await(const r of w())return r;return null}t.getFirstAvailablePowerShellInstallation=l}),define(Y[65],ee([0,1,3,38,15,127,2,10]),function(G,t,g,T,y,I,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function u(p,E,F){return v({path:p,isDirectory:!1},E,F)}t.watchFile=u;function d(p,E,F){return v({path:p,isDirectory:!0},E,F)}t.watchFolder=d,t.CHANGE_BUFFER_DELAY=100;function v(p,E,F){const c=(0,g.basename)(p.path),f=new Map;let P=!1,S=[(0,C.toDisposable)(()=>{f.forEach(w=>(0,C.dispose)(w)),f.clear()})];try{const w=(0,T.watch)(p.path);S.push((0,C.toDisposable)(()=>{w.removeAllListeners(),w.close()}));const l=new Set;p.isDirectory&&D.Promises.readdir(p.path).then(r=>r.forEach(s=>l.add(s))),w.on("error",(r,s)=>{P||F(`Failed to watch ${p.path} for changes using fs.watch() (${r}, ${s})`)}),w.on("change",(r,s)=>{if(P)return;let e="";if(s&&(e=s.toString(),y.isMacintosh&&(e=(0,I.normalizeNFC)(e))),!e||r!=="change"&&r!=="rename")return;const i=p.isDirectory?(0,g.join)(p.path,e):p.path;if(p.isDirectory)if(r==="rename"){const n=f.get(i);n&&(0,C.dispose)(n);const o=setTimeout(async()=>{f.delete(i);const a=await D.Promises.exists(i);if(P)return;let h;a?l.has(e)?h="changed":(h="added",l.add(e)):(l.delete(e),h="deleted"),E(h,i)},t.CHANGE_BUFFER_DELAY);f.set(i,(0,C.toDisposable)(()=>clearTimeout(o)))}else{let n;l.has(e)?n="changed":(n="added",l.add(e)),E(n,i)}else if(r==="rename"||e!==c){const n=setTimeout(async()=>{const o=await D.Promises.exists(i);P||(o?(E("changed",i),S=[v(p,E,F)]):E("deleted",i))},t.CHANGE_BUFFER_DELAY);(0,C.dispose)(S),S=[(0,C.toDisposable)(()=>clearTimeout(n))]}else E("changed",i)})}catch(w){D.Promises.exists(p.path).then(l=>{l&&!P&&F(`Failed to watch ${p.path} for changes using fs.watch() (${w.toString()})`)})}return(0,C.toDisposable)(()=>{P=!0,S=(0,C.dispose)(S)})}});var ue=this&&this.__decorate||function(G,t,g,T){var y=arguments.length,I=y<3?t:T===null?T=Object.getOwnPropertyDescriptor(t,g):T,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(G,t,g,T);else for(var D=G.length-1;D>=0;D--)(C=G[D])&&(I=(y<3?C(I):y>3?C(t,g,I):C(t,g))||I);return y>3&&I&&Object.defineProperty(t,g,I),I};define(Y[39],ee([0,1,13,2,4,26,8,16,24,12,60,18,44]),function(G,t,g,T,y,I,C,D,u,d,v,p,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var F;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(F=t.RequestType||(t.RequestType={}));function c(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var f;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(f=t.ResponseType||(t.ResponseType={}));function P(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var S;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(S||(S={}));class w{constructor(R){this.buffer=R,this.pos=0}read(R){const M=this.buffer.slice(this.pos,this.pos+R);return this.pos+=M.byteLength,M}}class l{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(R){this.buffers.push(R)}}var r;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object"})(r||(r={}));function s(U){const R=D.VSBuffer.alloc(4);return R.writeUInt32BE(U,0),R}function e(U){return U.read(4).readUInt32BE(0)}function i(U){const R=D.VSBuffer.alloc(1);return R.writeUInt8(U,0),R}const n={Undefined:i(r.Undefined),String:i(r.String),Buffer:i(r.Buffer),VSBuffer:i(r.VSBuffer),Array:i(r.Array),Object:i(r.Object)},o=typeof Buffer!="undefined";function a(U,R){if(typeof R=="undefined")U.write(n.Undefined);else if(typeof R=="string"){const M=D.VSBuffer.fromString(R);U.write(n.String),U.write(s(M.byteLength)),U.write(M)}else if(o&&Buffer.isBuffer(R)){const M=D.VSBuffer.wrap(R);U.write(n.Buffer),U.write(s(M.byteLength)),U.write(M)}else if(R instanceof D.VSBuffer)U.write(n.VSBuffer),U.write(s(R.byteLength)),U.write(R);else if(Array.isArray(R)){U.write(n.Array),U.write(s(R.length));for(const M of R)a(U,M)}else{const M=D.VSBuffer.fromString(JSON.stringify(R));U.write(n.Object),U.write(s(M.byteLength)),U.write(M)}}function h(U){switch(U.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return U.read(e(U)).toString();case r.Buffer:return U.read(e(U)).buffer;case r.VSBuffer:return U.read(e(U));case r.Array:{const M=e(U),b=[];for(let O=0;O<M;O++)b.push(h(U));return b}case r.Object:return JSON.parse(U.read(e(U)).toString())}}class m{constructor(R,M,b=null,O=1e3){this.protocol=R,this.ctx=M,this.logger=b,this.timeoutDelay=O,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(A=>this.onRawMessage(A)),this.sendResponse({type:200})}registerChannel(R,M){this.channels.set(R,M),setTimeout(()=>this.flushPendingRequests(R),0)}sendResponse(R){switch(R.type){case 200:{const M=this.send([R.type]);this.logger&&this.logger.logOutgoing(M,0,1,P(R.type));return}case 201:case 202:case 204:case 203:{const M=this.send([R.type,R.id],R.data);this.logger&&this.logger.logOutgoing(M,R.id,1,P(R.type),R.data);return}}}send(R,M=void 0){const b=new l;return a(b,R),a(b,M),this.sendBuffer(b.buffer)}sendBuffer(R){try{return this.protocol.send(R),R.byteLength}catch(M){return 0}}onRawMessage(R){const M=new w(R),b=h(M),O=h(M),A=b[0];switch(A){case 100:return this.logger&&this.logger.logIncoming(R.byteLength,b[1],1,`${c(A)}: ${b[2]}.${b[3]}`,O),this.onPromise({type:A,id:b[1],channelName:b[2],name:b[3],arg:O});case 102:return this.logger&&this.logger.logIncoming(R.byteLength,b[1],1,`${c(A)}: ${b[2]}.${b[3]}`,O),this.onEventListen({type:A,id:b[1],channelName:b[2],name:b[3],arg:O});case 101:return this.logger&&this.logger.logIncoming(R.byteLength,b[1],1,`${c(A)}`),this.disposeActiveRequest({type:A,id:b[1]});case 103:return this.logger&&this.logger.logIncoming(R.byteLength,b[1],1,`${c(A)}`),this.disposeActiveRequest({type:A,id:b[1]})}}onPromise(R){const M=this.channels.get(R.channelName);if(!M){this.collectPendingRequest(R);return}const b=new I.CancellationTokenSource;let O;try{O=M.call(this.ctx,R.name,R.arg,b.token)}catch(B){O=Promise.reject(B)}const A=R.id;O.then(B=>{this.sendResponse({id:A,data:B,type:201}),this.activeRequests.delete(R.id)},B=>{B instanceof Error?this.sendResponse({id:A,data:{message:B.message,name:B.name,stack:B.stack?B.stack.split?B.stack.split(`
`):B.stack:void 0},type:202}):this.sendResponse({id:A,data:B,type:203}),this.activeRequests.delete(R.id)});const V=(0,T.toDisposable)(()=>b.cancel());this.activeRequests.set(R.id,V)}onEventListen(R){const M=this.channels.get(R.channelName);if(!M){this.collectPendingRequest(R);return}const b=R.id,A=M.listen(this.ctx,R.name,R.arg)(V=>this.sendResponse({id:b,data:V,type:204}));this.activeRequests.set(R.id,A)}disposeActiveRequest(R){const M=this.activeRequests.get(R.id);M&&(M.dispose(),this.activeRequests.delete(R.id))}collectPendingRequest(R){let M=this.pendingRequests.get(R.channelName);M||(M=[],this.pendingRequests.set(R.channelName,M));const b=setTimeout(()=>{console.error(`Unknown channel: ${R.channelName}`),R.type===100&&this.sendResponse({id:R.id,data:{name:"Unknown channel",message:`Channel name '${R.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);M.push({request:R,timeoutTimer:b})}flushPendingRequests(R){const M=this.pendingRequests.get(R);if(M){for(const b of M)switch(clearTimeout(b.timeoutTimer),b.request.type){case 100:this.onPromise(b.request);break;case 102:this.onEventListen(b.request);break}this.pendingRequests.delete(R)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(R=>R.dispose()),this.activeRequests.clear()}}t.ChannelServer=m;var N;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(N=t.RequestInitiator||(t.RequestInitiator={}));class L{constructor(R,M=null){this.protocol=R,this.isDisposed=!1,this.state=S.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new g.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(b=>this.onBuffer(b)),this.logger=M}getChannel(R){const M=this;return{call(b,O,A){return M.isDisposed?Promise.reject(C.canceled()):M.requestPromise(R,b,O,A)},listen(b,O){return M.isDisposed?Promise.reject(C.canceled()):M.requestEvent(R,b,O)}}}requestPromise(R,M,b,O=I.CancellationToken.None){const A=this.lastRequestId++,B={id:A,type:100,channelName:R,name:M,arg:b};if(O.isCancellationRequested)return Promise.reject(C.canceled());let $;return new Promise((te,ie)=>{if(O.isCancellationRequested)return ie(C.canceled());const oe=()=>{const ke=Te=>{switch(Te.type){case 201:this.handlers.delete(A),te(Te.data);break;case 202:this.handlers.delete(A);const we=new Error(Te.data.message);we.stack=Te.data.stack,we.name=Te.data.name,ie(we);break;case 203:this.handlers.delete(A),ie(Te.data);break}};this.handlers.set(A,ke),this.sendRequest(B)};let le=null;this.state===S.Idle?oe():(le=(0,y.createCancelablePromise)(ke=>this.whenInitialized()),le.then(()=>{le=null,oe()}));const pe=()=>{le?(le.cancel(),le=null):this.sendRequest({id:A,type:101}),ie(C.canceled())},De=O.onCancellationRequested(pe);$=(0,T.combinedDisposable)((0,T.toDisposable)(pe),De),this.activeRequests.add($)}).finally(()=>{this.activeRequests.delete($)})}requestEvent(R,M,b){const O=this.lastRequestId++,V={id:O,type:102,channelName:R,name:M,arg:b};let B=null;const $=new g.Emitter({onFirstListenerAdd:()=>{B=(0,y.createCancelablePromise)(te=>this.whenInitialized()),B.then(()=>{B=null,this.activeRequests.add($),this.sendRequest(V)})},onLastListenerRemove:()=>{B?(B.cancel(),B=null):(this.activeRequests.delete($),this.sendRequest({id:O,type:103}))}}),K=te=>$.fire(te.data);return this.handlers.set(O,K),$.event}sendRequest(R){switch(R.type){case 100:case 102:{const M=this.send([R.type,R.id,R.channelName,R.name],R.arg);this.logger&&this.logger.logOutgoing(M,R.id,0,`${c(R.type)}: ${R.channelName}.${R.name}`,R.arg);return}case 101:case 103:{const M=this.send([R.type,R.id]);this.logger&&this.logger.logOutgoing(M,R.id,0,c(R.type));return}}}send(R,M=void 0){const b=new l;return a(b,R),a(b,M),this.sendBuffer(b.buffer)}sendBuffer(R){try{return this.protocol.send(R),R.byteLength}catch(M){return 0}}onBuffer(R){const M=new w(R),b=h(M),O=h(M),A=b[0];switch(A){case 200:return this.logger&&this.logger.logIncoming(R.byteLength,0,0,P(A)),this.onResponse({type:b[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(R.byteLength,b[1],0,P(A),O),this.onResponse({type:b[0],id:b[1],data:O})}}onResponse(R){if(R.type===200){this.state=S.Idle,this._onDidInitialize.fire();return}const M=this.handlers.get(R.id);M&&M(R)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===S.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(R=>R.dispose()),this.activeRequests.clear()}}ue([E.memoize],L.prototype,"onDidInitializePromise",null),t.ChannelClient=L;class k{constructor(R){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new g.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new g.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,R(({protocol:M,onDidClientDisconnect:b})=>{g.Event.once(M.onMessage)(A=>{const V=new w(A),B=h(V),$=new m(M,B),K=new L(M);this.channels.forEach((ie,oe)=>$.registerChannel(oe,ie));const te={channelServer:$,channelClient:K,ctx:B};this._connections.add(te),this._onDidAddConnection.fire(te),b(()=>{$.dispose(),K.dispose(),this._connections.delete(te),this._onDidRemoveConnection.fire(te)})})})}get connections(){const R=[];return this._connections.forEach(M=>R.push(M)),R}getChannel(R,M){const b=this;return{call(O,A,V){let B;if((0,d.isFunction)(M)){let K=(0,u.getRandomElement)(b.connections.filter(M));B=K?Promise.resolve(K):g.Event.toPromise(g.Event.filter(b.onDidAddConnection,M))}else B=M.routeCall(b,O,A);const $=B.then(K=>K.channelClient.getChannel(R));return _($).call(O,A,V)},listen(O,A){if((0,d.isFunction)(M))return b.getMulticastEvent(R,M,O,A);const V=M.routeEvent(b,O,A).then(B=>B.channelClient.getChannel(R));return _(V).listen(O,A)}}}getMulticastEvent(R,M,b,O){const A=this;let V=new T.DisposableStore;const B=new g.Emitter({onFirstListenerAdd:()=>{V=new T.DisposableStore;const $=new g.EventMultiplexer,K=new Map,te=oe=>{const pe=oe.channelClient.getChannel(R).listen(b,O),De=$.add(pe);K.set(oe,De)},ie=oe=>{const le=K.get(oe);!le||(le.dispose(),K.delete(oe))};A.connections.filter(M).forEach(te),g.Event.filter(A.onDidAddConnection,M)(te,void 0,V),A.onDidRemoveConnection(ie,void 0,V),$.event(B.fire,B,V),V.add($)},onLastListenerRemove:()=>{V.dispose()}});return B.event}registerChannel(R,M){this.channels.set(R,M),this._connections.forEach(b=>{b.channelServer.registerChannel(R,M)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=k;class j{constructor(R,M,b=null){const O=new l;a(O,M),R.send(O.buffer),this.channelClient=new L(R,b),this.channelServer=new m(R,M,b)}getChannel(R){return this.channelClient.getChannel(R)}registerChannel(R,M){this.channelServer.registerChannel(R,M)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=j;function _(U){return{call(R,M,b){return U.then(O=>O.call(R,M,b))},listen(R,M){const b=new g.Relay;return U.then(O=>b.input=O.listen(R,M)),b.event}}}t.getDelayedChannel=_;function Q(U){let R=!1;return{call(M,b,O){return R?U.call(M,b,O):(0,y.timeout)(0).then(()=>R=!0).then(()=>U.call(M,b,O))},listen(M,b){if(R)return U.listen(M,b);const O=new g.Relay;return(0,y.timeout)(0).then(()=>R=!0).then(()=>O.input=U.listen(M,b)),O.event}}}t.getNextTickChannel=Q;class ne{constructor(R){this.fn=R}routeCall(R){return this.route(R)}routeEvent(R){return this.route(R)}async route(R){for(const M of R.connections)if(await Promise.resolve(this.fn(M.ctx)))return Promise.resolve(M);return await g.Event.toPromise(R.onDidAddConnection),await this.route(R)}}t.StaticRouter=ne;var re;(function(U){function R(O,A){const V=O,B=A&&A.disableMarshalling,$=new Map;for(const K in V)b(K)&&$.set(K,g.Event.buffer(V[K],!0));return new class{listen(K,te){const ie=$.get(te);if(ie)return ie;throw new Error(`Event not found: ${te}`)}call(K,te,ie){const oe=V[te];if(typeof oe=="function"){if(!B&&Array.isArray(ie))for(let le=0;le<ie.length;le++)ie[le]=(0,v.revive)(ie[le]);return oe.apply(V,ie)}throw new Error(`Method not found: ${te}`)}}}U.fromService=R;function M(O,A){const V=A&&A.disableMarshalling;return new Proxy({},{get(B,$){if(typeof $=="string")return A?.properties?.has($)?A.properties.get($):b($)?O.listen($):async function(...K){let te;A&&!(0,d.isUndefinedOrNull)(A.context)?te=[A.context,...K]:te=K;const ie=await O.call($,te);return V?ie:(0,v.revive)(ie)};throw new Error(`Property not found: ${String($)}`)}})}U.toService=M;function b(O){return O[0]==="o"&&O[1]==="n"&&p.isUpperAsciiLetter(O.charCodeAt(2))}})(re=t.ProxyChannel||(t.ProxyChannel={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function J(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){let R=U.toString();if(R!=="[object Object]")return R}return U}function W(U){return Array.isArray(U)?U.map(J):J(U)}function x(U,R,M,b,O,A,V){V=W(V);const B=Z[O],$=B[b%B.length];let K=[`%c[${U}]%c[${String(R).padStart(7," ")}]%c[len: ${String(M).padStart(5," ")}]%c${String(b).padStart(5," ")} - ${A}`,"color: darkgreen","color: grey","color: grey",`color: ${$}`];/\($/.test(A)?(K=K.concat(V),K.push(")")):K.push(V),console.log.apply(console,K)}t.logWithColors=x;class q{constructor(R,M){this._outgoingPrefix=R,this._incomingPrefix=M,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(R,M,b,O,A){this._totalOutgoing+=R,x(this._outgoingPrefix,this._totalOutgoing,R,M,b,O,A)}logIncoming(R,M,b,O,A){this._totalIncoming+=R,x(this._incomingPrefix,this._totalIncoming,R,M,b,O,A)}}t.IPCLogger=q}),define(Y[66],ee([0,1,2,13,4,12]),function(G,t,g,T,y,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageHint=void 0;var C;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(C=t.StorageHint||(t.StorageHint={}));var D;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(D||(D={}));class u extends g.Disposable{constructor(p,E=Object.create(null)){super();this.database=p,this.options=E,this._onDidChangeStorage=this._register(new T.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=D.None,this.cache=new Map,this.flushDelayer=new y.ThrottledDelayer(u.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(p=>this.onDidChangeItemsExternal(p)))}onDidChangeItemsExternal(p){p.changed?.forEach((E,F)=>this.accept(F,E)),p.deleted?.forEach(E=>this.accept(E,void 0))}accept(p,E){if(this.state===D.Closed)return;let F=!1;(0,I.isUndefinedOrNull)(E)?F=this.cache.delete(p):this.cache.get(p)!==E&&(this.cache.set(p,E),F=!0),F&&this._onDidChangeStorage.fire(p)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===D.None&&(this.state=D.Initialized,this.options.hint!==C.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(p,E){const F=this.cache.get(p);return(0,I.isUndefinedOrNull)(F)?E:F}getBoolean(p,E){const F=this.get(p);return(0,I.isUndefinedOrNull)(F)?E:F==="true"}getNumber(p,E){const F=this.get(p);return(0,I.isUndefinedOrNull)(F)?E:parseInt(F,10)}async set(p,E){if(this.state===D.Closed)return;if((0,I.isUndefinedOrNull)(E))return this.delete(p);const F=String(E);if(this.cache.get(p)!==F)return this.cache.set(p,F),this.pendingInserts.set(p,F),this.pendingDeletes.delete(p),this._onDidChangeStorage.fire(p),this.flushDelayer.trigger(()=>this.flushPending())}async delete(p){if(!(this.state===D.Closed||!this.cache.delete(p)))return this.pendingDeletes.has(p)||this.pendingDeletes.add(p),this.pendingInserts.delete(p),this._onDidChangeStorage.fire(p),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=D.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(p){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const p={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(p).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(p=>this.whenFlushedCallbacks.push(p))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=u,u.DEFAULT_FLUSH_DELAY=100;class d{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(p){p.insert&&p.insert.forEach((E,F)=>this.items.set(F,E)),p.delete&&p.delete.forEach(E=>this.items.delete(E))}async close(){}}t.InMemoryStorageDatabase=d}),define(Y[67],ee([5,6]),function(G,t){return G.create("vs/base/common/date",t)}),define(Y[68],ee([0,1,67]),function(G,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const T=60,y=T*60,I=y*24,C=I*7,D=I*30,u=I*365;function d(p,E){typeof p!="number"&&(p=p.getTime());const F=Math.round((new Date().getTime()-p)/1e3);if(F<-30)return(0,g.localize)(0,null,d(new Date().getTime()+F*1e3,!1));if(F<30)return(0,g.localize)(1,null);let c;return F<T?(c=F,E?c===1?(0,g.localize)(2,null,c):(0,g.localize)(3,null,c):c===1?(0,g.localize)(4,null,c):(0,g.localize)(5,null,c)):F<y?(c=Math.floor(F/T),E?c===1?(0,g.localize)(6,null,c):(0,g.localize)(7,null,c):c===1?(0,g.localize)(8,null,c):(0,g.localize)(9,null,c)):F<I?(c=Math.floor(F/y),E?c===1?(0,g.localize)(10,null,c):(0,g.localize)(11,null,c):c===1?(0,g.localize)(12,null,c):(0,g.localize)(13,null,c)):F<C?(c=Math.floor(F/I),E?c===1?(0,g.localize)(14,null,c):(0,g.localize)(15,null,c):c===1?(0,g.localize)(16,null,c):(0,g.localize)(17,null,c)):F<D?(c=Math.floor(F/C),E?c===1?(0,g.localize)(18,null,c):(0,g.localize)(19,null,c):c===1?(0,g.localize)(20,null,c):(0,g.localize)(21,null,c)):F<u?(c=Math.floor(F/D),E?c===1?(0,g.localize)(22,null,c):(0,g.localize)(23,null,c):c===1?(0,g.localize)(24,null,c):(0,g.localize)(25,null,c)):(c=Math.floor(F/u),E?c===1?(0,g.localize)(26,null,c):(0,g.localize)(27,null,c):c===1?(0,g.localize)(28,null,c):(0,g.localize)(29,null,c))}t.fromNow=d;function v(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=v}),define(Y[69],ee([5,6]),function(G,t){return G.create("vs/base/common/errorMessage",t)}),define(Y[28],ee([0,1,69,12,24]),function(G,t,g,T,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function I(d,v){return v&&(d.stack||d.stacktrace)?g.localize(0,null,D(d),C(d.stack)||C(d.stacktrace)):D(d)}function C(d){return Array.isArray(d)?d.join(`
`):d}function D(d){return typeof d.code=="string"&&typeof d.errno=="number"&&typeof d.syscall=="string"?g.localize(1,null,d.message):d.message||g.localize(2,null)}function u(d=null,v=!1){if(!d)return g.localize(3,null);if(Array.isArray(d)){const p=y.coalesce(d),E=u(p[0],v);return p.length>1?g.localize(4,null,E,p.length):E}if(T.isString(d))return d;if(d.detail){const p=d.detail;if(p.error)return I(p.error,v);if(p.exception)return I(p.exception,v)}return d.stack?I(d,v):d.message?d.message:g.localize(5,null)}t.toErrorMessage=u}),define(Y[70],ee([5,6]),function(G,t){return G.create("vs/base/node/processes",t)}),define(Y[47],ee([0,1,3,10,32,70,33,12,19,37,15,46,9]),function(G,t,g,T,y,I,C,D,u,d,v,p,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function F(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function c(r,s){if(v.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};s&&(e.cwd=s);const i=y.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],e);return new Promise(n=>{i.once("error",o=>{n({success:!1,error:o})}),i.once("exit",(o,a)=>{n(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?F(e.status):1})}else if(v.isLinux||v.isMacintosh)try{const e=E.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",G).fsPath;return new Promise(i=>{y.execFile(e,[r.pid.toString()],{encoding:"utf8",shell:!0},(n,o,a)=>{i(n?{success:!1,error:n}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function f(r=C.env){return r.comspec||"cmd.exe"}t.getWindowsShell=f;class P{constructor(s,e,i,n){if(e!==void 0&&i!==void 0&&n!==void 0)this.cmd=s,this.args=e,this.shell=i,this.options=n;else{const o=s;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(C.env).forEach(a=>{o[a]=C.env[a]}),Object.keys(this.options.env).forEach(a=>{o[a]=this.options.env[a]}),this.options.env=o}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const e=s.lastIndexOf(g.sep);return e!==-1&&(s=s.substring(e+1)),P.WellKnowCommands[s]?s:"other"}start(s){return v.isWindows&&(this.options&&this.options.cwd&&d.isUNC(this.options.cwd)||!this.options&&d.isUNC(C.cwd()))?Promise.reject(new Error(I.localize(0,null))):this.useExec().then(e=>{let i,n;const o=new Promise((a,h)=>{i=a,n=h});if(e){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=y.exec(a,this.options,(h,m,N)=>{this.childProcess=null;const L=h;L&&L.killed?n({killed:this.terminateRequested,stdout:m.toString(),stderr:N.toString()}):this.handleExec(i,s,h,m,N)})}else{let a=null;const h=m=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(m,i,s,n);const N={terminated:this.terminateRequested};D.isNumber(m)&&(N.cmdCode=m),i(N)};if(this.shell&&v.isWindows){const m=u.deepClone(this.options);m.windowsVerbatimArguments=!0,m.detached=!1;let N=!1,L=!1;const k=[];let j=this.ensureQuotes(this.cmd);k.push(j.value),N=j.quoted,this.args&&this.args.forEach(Q=>{j=this.ensureQuotes(Q),k.push(j.value),L=L&&j.quoted});const _=["/s","/c"];N?L?_.push('"'+k.join(" ")+'"'):k.length>1?_.push('"'+k[0]+'" '+k.slice(1).join(" ")):_.push('"'+k[0]+'"'):_.push(k.join(" ")),a=y.spawn(f(),_,m)}else this.cmd&&(a=y.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(D.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",m=>{this.childProcess=null,n({terminated:this.terminateRequested,error:m})}),a.pid&&(this.childProcess.on("close",h),this.handleSpawn(a,i,s,n,!0)))}return o})}handleClose(s,e,i,n){}ensureQuotes(s){return P.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,c(s,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!v.isWindows)return s(!1);const e=y.spawn(f(),["/s","/c"]);e.on("error",i=>s(!0)),e.on("exit",i=>s(!1))})}}t.AbstractProcess=P,P.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},P.regexp=/^[^"].* .*[^"]/;class S extends P{constructor(s,e,i,n){super(s,e,i,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,e,i,n,o){[n,o].forEach((a,h)=>{const m=new p.LineDecoder;m.write(a).forEach(k=>{e({line:k,source:h===0?0:1})});const L=m.end();L&&e({line:L,source:h===0?0:1})}),s({terminated:this.terminateRequested,error:i})}handleSpawn(s,e,i,n,o){const a=new p.LineDecoder,h=new p.LineDecoder;s.stdout.on("data",m=>{a.write(m).forEach(L=>i({line:L,source:0}))}),s.stderr.on("data",m=>{h.write(m).forEach(L=>i({line:L,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=h}handleClose(s,e,i,n){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&i({line:o,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&i({line:a,source:1})}}t.LineProcess=S;function w(r){let s=[],e=!1;const i=function(n){if(e){s.push(n);return}(!r.send(n,a=>{if(a&&console.error(a),e=!1,s.length>0){const h=s.slice(0);s=[],h.forEach(m=>i(m))}})||v.isWindows)&&(e=!0)};return{send:i}}t.createQueuedSender=w;var l;(function(r){async function s(e,i,n){if(g.isAbsolute(e))return e;if(i===void 0&&(i=C.cwd()),g.dirname(e)!=="."||(n===void 0&&D.isString(C.env.PATH)&&(n=C.env.PATH.split(g.delimiter)),n===void 0||n.length===0))return g.join(i,e);async function a(h){return await T.Promises.exists(h)?!(await T.Promises.stat(h)).isDirectory():!1}for(let h of n){let m;if(g.isAbsolute(h)?m=g.join(h,e):m=g.join(i,h,e),await a(m))return m;let N=m+".com";if(await a(N)||(N=m+".exe",await a(N)))return N}return g.join(i,e)}r.findExecutable=s})(l=t.win32||(t.win32={}))}),define(Y[71],ee([0,1,31,15,64,47]),function(G,t,g,T,y,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function C(F,c){return F===1?T.isWindows?p():I.getWindowsShell(c):d(F,c)}t.getSystemShell=C;function D(F,c){return F===1?T.isWindows?E(c):I.getWindowsShell(c):d(F,c)}t.getSystemShellSync=D;let u=null;function d(F,c){if(T.isLinux&&F===2||T.isMacintosh&&F===3)return"/bin/bash";if(!u){let f;if(T.isWindows)f="/bin/bash";else{if(f=c.SHELL,!f)try{f=(0,g.userInfo)().shell}catch(P){}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}u=f}return u}let v=null;async function p(){return v||(v=(await(0,y.getFirstAvailablePowerShellInstallation)()).exePath),v}function E(F){if(v)return v;const c=T.isWindows&&parseFloat((0,g.release)())>=10,f=F.hasOwnProperty("PROCESSOR_ARCHITEW6432"),P=`${F.windir}\\${f?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return c?P:I.getWindowsShell(F)}}),define(Y[48],ee([0,1,32,2,4,19,13,47,39,59,26,8,16,15]),function(G,t,g,T,y,I,C,D,u,d,v,p,E,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class c extends u.ChannelServer{constructor(S){super({send:w=>{try{process.send&&process.send(w.buffer.toString("base64"))}catch(l){}},onMessage:C.Event.fromNodeEventEmitter(process,"message",w=>E.VSBuffer.wrap(Buffer.from(w,"base64")))},S);process.once("disconnect",()=>this.dispose())}}t.Server=c;class f{constructor(S,w){this.modulePath=S,this.options=w,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new C.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const l=w&&w.timeout?w.timeout:6e4;this.disposeDelayer=new y.Delayer(l),this.child=null,this._client=null}getChannel(S){const w=this;return{call(l,r,s){return w.requestPromise(S,l,r,s)},listen(l,r){return w.requestEvent(S,l,r)}}}requestPromise(S,w,l,r=v.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(p.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(S),e=(0,y.createCancelablePromise)(o=>s.call(w,l,o)),i=r.onCancellationRequested(()=>e.cancel()),n=(0,T.toDisposable)(()=>e.cancel());return this.activeRequests.add(n),e.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(S,w,l){if(!this.disposeDelayer)return C.Event.None;this.disposeDelayer.cancel();let r;const s=new C.Emitter({onFirstListenerAdd:()=>{r=this.getCachedChannel(S).listen(w,l)(s.fire,s),this.activeRequests.add(r)},onLastListenerRemove:()=>{this.activeRequests.delete(r),r.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const S=this.options&&this.options.args?this.options.args:[],w=Object.create(null);w.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(w.env={...w.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(w.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(w.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(w.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),w.execArgv===void 0&&(w.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),F.isMacintosh&&w.env&&delete w.env.DYLD_LIBRARY_PATH,this.child=(0,g.fork)(this.modulePath,S,w);const l=new C.Emitter;C.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,d.isRemoteConsoleLog)(a)){(0,d.log)(a,`IPC Library: ${this.options.serverName}`);return}l.fire(E.VSBuffer.wrap(Buffer.from(a,"base64")))});const s=this.options.useQueue?(0,D.createQueuedSender)(this.child):this.child,e=a=>this.child&&this.child.connected&&s.send(a.buffer.toString("base64")),i=l.event,n={send:e,onMessage:i};this._client=new u.ChannelClient(n);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,h)=>{process.removeListener("exit",o),this.activeRequests.forEach(m=>(0,T.dispose)(m)),this.activeRequests.clear(),a!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+h),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:h})})}return this._client}getCachedChannel(S){let w=this.channels.get(S);return w||(w=this.client.getChannel(S),this.channels.set(S,w)),w}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=f}),define(Y[72],ee([5,6]),function(G,t){return G.create("vs/base/node/zip",t)}),define(Y[73],ee([5,6]),function(G,t){return G.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Y[74],ee([5,6]),function(G,t){return G.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(Y[75],ee([5,6]),function(G,t){return G.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Y[76],ee([5,6]),function(G,t){return G.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Y[77],ee([5,6]),function(G,t){return G.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Y[78],ee([5,6]),function(G,t){return G.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Y[79],ee([5,6]),function(G,t){return G.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Y[80],ee([5,6]),function(G,t){return G.create("vs/platform/extensions/common/extensionValidator",t)}),define(Y[81],ee([5,6]),function(G,t){return G.create("vs/platform/files/common/fileService",t)}),define(Y[82],ee([5,6]),function(G,t){return G.create("vs/platform/files/common/io",t)}),define(Y[83],ee([5,6]),function(G,t){return G.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Y[84],ee([5,6]),function(G,t){return G.create("vs/platform/request/common/request",t)}),define(Y[85],ee([5,6]),function(G,t){return G.create("vs/platform/telemetry/common/telemetryService",t)}),define(Y[86],ee([0,1,3,20,44,68,9,7,33]),function(G,t,g,T,y,I,C,D,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class d{constructor(c,f,P){this._args=c,this.paths=f,this.productService=P}get appRoot(){return(0,g.dirname)(C.FileAccess.asFileUri("",G).fsPath)}get userHome(){return D.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return D.URI.file((0,g.join)(this.userDataPath,"User"))}get tmpDir(){return D.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,T.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,T.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const c=(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,g.join)(this.userDataPath,"logs",c)}return this.args.logsPath}get userDataSyncLogResource(){return D.URI.file((0,g.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,T.joinPath)(D.URI.file((0,g.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return D.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return D.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,T.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,T.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=u.env.VSCODE_PORTABLE;return c?D.URI.file((0,g.join)(c,"argv.json")):(0,T.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,T.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return D.URI.file((0,g.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,g.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?(0,g.resolve)(c):(0,g.normalize)((0,g.join)(C.FileAccess.asFileUri("",G).fsPath,"..","extensions"))}get extensionsDownloadPath(){const c=this.args["extensions-download-dir"];return c?(0,g.resolve)(c):(0,g.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return(0,g.resolve)(c);const f=u.env.VSCODE_EXTENSIONS;if(f)return f;const P=u.env.VSCODE_PORTABLE;return P?(0,g.join)(P,"extensions"):(0,T.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map(f=>/^[^:/?#]+?:\/\//.test(f)?D.URI.parse(f):D.URI.file((0,g.normalize)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(c=>c==="ui"||c==="workspace"||c==="web"?c:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?D.URI.parse(c):D.URI.file((0,g.normalize)(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return v(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!u.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,T.joinPath)(D.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return D.URI.file((0,g.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ue([y.memoize],d.prototype,"appRoot",null),ue([y.memoize],d.prototype,"userHome",null),ue([y.memoize],d.prototype,"userDataPath",null),ue([y.memoize],d.prototype,"appSettingsHome",null),ue([y.memoize],d.prototype,"tmpDir",null),ue([y.memoize],d.prototype,"userRoamingDataHome",null),ue([y.memoize],d.prototype,"settingsResource",null),ue([y.memoize],d.prototype,"userDataSyncHome",null),ue([y.memoize],d.prototype,"userDataSyncLogResource",null),ue([y.memoize],d.prototype,"sync",null),ue([y.memoize],d.prototype,"machineSettingsResource",null),ue([y.memoize],d.prototype,"globalStorageHome",null),ue([y.memoize],d.prototype,"workspaceStorageHome",null),ue([y.memoize],d.prototype,"keybindingsResource",null),ue([y.memoize],d.prototype,"keyboardLayoutResource",null),ue([y.memoize],d.prototype,"argvResource",null),ue([y.memoize],d.prototype,"snippetsHome",null),ue([y.memoize],d.prototype,"isExtensionDevelopment",null),ue([y.memoize],d.prototype,"untitledWorkspacesHome",null),ue([y.memoize],d.prototype,"installSourcePath",null),ue([y.memoize],d.prototype,"builtinExtensionsPath",null),ue([y.memoize],d.prototype,"extensionsPath",null),ue([y.memoize],d.prototype,"extensionDevelopmentLocationURI",null),ue([y.memoize],d.prototype,"extensionDevelopmentKind",null),ue([y.memoize],d.prototype,"extensionTestsLocationURI",null),ue([y.memoize],d.prototype,"debugExtensionHost",null),ue([y.memoize],d.prototype,"serviceMachineIdResource",null),ue([y.memoize],d.prototype,"telemetryLogResource",null),ue([y.memoize],d.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=d;function v(F,c){return E(F["inspect-extensions"],F["inspect-brk-extensions"],5870,c,F.debugId)}t.parseExtensionHostPort=v;function p(F,c){return E(F["inspect-search"],F["inspect-brk-search"],5876,c)}t.parseSearchPort=p;function E(F,c,f,P,S){const l=Number(c||F)||(P?null:f),r=l?Boolean(!!c):!1;return{port:l,break:r,debugId:S}}}),function(){"use strict";function G(t,g,T,y){function I(D){const u=C(D),d=[u];return t.isAbsolute(u)||d.unshift(y),t.resolve(...d)}function C(D){const u=process.env.VSCODE_PORTABLE;if(u)return t.join(u,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return t.join(d,T);const v=D["user-data-dir"];if(v)return v;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const p=process.env.USERPROFILE;if(typeof p!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=t.join(p,"AppData","Roaming")}break;case"darwin":d=t.join(g.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||t.join(g.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(d,T)}return{getUserDataPath:I}}if(typeof define=="function")define(Y[87],ee([0,88,31,9,20,33]),function(t,g,T,y,I,C){const D=I.dirname(y.FileAccess.asFileUri("",t)),u=t.__$__nodeRequire(I.joinPath(D,"package.json").fsPath);return G(g,T,u.name,C.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),g=require("path"),T=require("os");module.exports=G(g,T,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Y[89],ee([0,1,31,87,86]),function(G,t,g,T,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class I extends y.AbstractNativeEnvironmentService{constructor(D,u){super(D,{homeDir:(0,g.homedir)(),tmpDir:(0,g.tmpdir)(),userDataDir:(0,T.getUserDataPath)(D)},u)}}t.NativeEnvironmentService=I}),define(Y[90],ee([0,1,19]),function(G,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const T=/^%([\w\d.-]+)%$/i;function y(I,C){const D=u=>{if(typeof u!="string")return;const d=T.exec(u);if(!d)return;const v=C[d[1]]??u;return typeof v=="string"?v:typeof v.message=="string"?v.message:u};return(0,g.cloneAndChange)(I,D)}t.localizeManifest=y}),define(Y[49],ee([0,1,80]),function(G,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function I(E){return E=E.trim(),E==="*"||T.test(E)}t.isValidVersionStr=I;function C(E){if(!I(E))return null;if(E=E.trim(),E==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let F=E.match(T);return F?{hasCaret:F[1]==="^",hasGreaterEquals:F[1]===">=",majorBase:F[2]==="x"?0:parseInt(F[2],10),majorMustEqual:F[2]!=="x",minorBase:F[4]==="x"?0:parseInt(F[4],10),minorMustEqual:F[4]!=="x",patchBase:F[6]==="x"?0:parseInt(F[6],10),patchMustEqual:F[6]!=="x",preRelease:F[8]||null}:null}t.parseVersion=C;function D(E){if(!E)return null;let F=E.majorBase,c=E.majorMustEqual,f=E.minorBase,P=E.minorMustEqual,S=E.patchBase,w=E.patchMustEqual;E.hasCaret&&(F===0||(P=!1),w=!1);let l=0;if(E.preRelease){const r=y.exec(E.preRelease);if(r){const[,s,e,i]=r;l=Date.UTC(Number(s),Number(e)-1,Number(i))}}return{majorBase:F,majorMustEqual:c,minorBase:f,minorMustEqual:P,patchBase:S,patchMustEqual:w,isMinimum:E.hasGreaterEquals,notBefore:l}}t.normalizeVersion=D;function u(E,F,c){let f;typeof E=="string"?f=D(C(E)):f=E;let P;F instanceof Date?P=F.getTime():typeof F=="string"&&(P=new Date(F).getTime());let S;if(typeof c=="string"?S=D(C(c)):S=c,!f||!S)return!1;let w=f.majorBase,l=f.minorBase,r=f.patchBase,s=S.majorBase,e=S.minorBase,i=S.patchBase,n=S.notBefore,o=S.majorMustEqual,a=S.minorMustEqual,h=S.patchMustEqual;return S.isMinimum?w>s?!0:w<s?!1:l>e?!0:l<e||P&&P<n?!1:r>=i:(w===1&&s===0&&(!o||!a||!h)&&(s=1,e=0,i=0,o=!0,a=!1,h=!1),w<s?!1:w>s?!o:l<e?!1:l>e?!a:r<i?!1:r>i?!h:!(P&&P<n))}t.isValidVersion=u;function d(E,F,c,f){return c.isBuiltin||typeof c.main=="undefined"?!0:p(E,F,c.engines.vscode,f)}t.isValidExtensionVersion=d;function v(E,F,c){return E==="*"||p(F,c,E)}t.isEngineValid=v;function p(E,F,c,f=[]){let P=D(C(c));if(!P)return f.push(g.localize(0,null,c)),!1;if(P.majorBase===0){if(!P.majorMustEqual||!P.minorMustEqual)return f.push(g.localize(1,null,c)),!1}else if(!P.majorMustEqual)return f.push(g.localize(2,null,c)),!1;return u(E,F,P)?!0:(f.push(g.localize(3,null,E,c)),!1)}}),define(Y[91],ee([0,1,39,48,2,9]),function(G,t,g,T,y,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class C extends y.Disposable{constructor(u,d,v,p){super();this.folders=u,this.onDidFilesChange=d,this.onLogMessage=v,this.verboseLogging=p,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const u=this._register(new T.Client(I.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(u.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=C.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=g.ProxyChannel.toService((0,g.getNextTickChannel)(u.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d))),this.setFolders(this.folders)}setVerboseLogging(u){this.verboseLogging=u,!this.isDisposed&&this.service&&this.service.setVerboseLogging(u)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${u}`})}setFolders(u){this.folders=u,this.service&&this.service.setRoots(u)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=C,C.MAX_RESTARTS=5}),define(Y[92],ee([0,1,39,48,2,9]),function(G,t,g,T,y,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class C extends y.Disposable{constructor(u,d,v,p,E={}){super();this.folders=u,this.onDidFilesChange=d,this.onLogMessage=v,this.verboseLogging=p,this.watcherOptions=E,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const u=this._register(new T.Client(I.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(u.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=C.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=g.ProxyChannel.toService((0,g.getNextTickChannel)(u.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d))),this.service.setRoots(this.folders)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${u}`})}setVerboseLogging(u){this.verboseLogging=u,this.service&&this.service.setVerboseLogging(u)}setFolders(u){this.folders=u,this.service&&this.service.setRoots(u)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=C,C.MAX_RESTARTS=5}),define(Y[93],ee([0,1,32,46,61,9]),function(G,t,g,T,y,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class C{constructor(u,d,v,p,E){this.watchedFolder=u,this.eventCallback=v,this.logCallback=p,this.verboseLogging=E,this.restartCounter=0,Array.isArray(d)?this.ignored=d.map(F=>(0,y.parse)(F)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${u}, excludes: ${d.join(",")}`),this.startWatcher()}startWatcher(){const u=[this.watchedFolder];this.verboseLogging&&u.push("-verbose"),this.handle=(0,g.spawn)(I.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",G).fsPath,u);const d=new T.LineDecoder;this.handle.stdout.on("data",v=>{const p=[];for(const E of d.write(v)){const F=E.split("|");if(F.length===2){const c=Number(F[0]),f=F[1];if(c>=0&&c<3){if(this.ignored&&this.ignored.some(P=>P(f))){this.verboseLogging&&this.log(f);continue}p.push({type:C.changeTypeMap[c],path:f})}else this.log(F[1])}}p.length>0&&this.eventCallback(p)}),this.handle.on("error",v=>this.onError(v)),this.handle.stderr.on("data",v=>this.onError(v)),this.handle.on("exit",(v,p)=>this.onExit(v,p))}onError(u){this.error("process error: "+u.toString())}onExit(u,d){this.handle&&(this.error(`terminated unexpectedly (code: ${u}, signal: ${d})`),this.restartCounter<=C.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(u){this.logCallback({type:"error",message:`[File Watcher (C#)] ${u}`})}log(u){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${u}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=C,C.MAX_RESTARTS=5,C.changeTypeMap=[0,1,2]}),define(Y[94],ee([0,1,93,3,18]),function(G,t,g,T,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class I{constructor(D,u,d,v){this.onDidFilesChange=u,this.onLogMessage=d,this.verboseLogging=v,this.service=void 0,this.folder=D[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(T.posix.sep)&&(this.folder.path=(0,y.rtrim)(this.folder.path,T.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new g.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,D=>this.onFileEvents(D),D=>this.onLogMessage(D),this.verboseLogging)}setVerboseLogging(D){this.verboseLogging=D,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(D){this.isDisposed||D.length>0&&this.onDidFilesChange(D)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=I}),define(Y[50],ee([0,1]),function(G,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class g{constructor(y,I=[],C=!1){this.ctor=y,this.staticArguments=I,this.supportsDelayedInstantiation=C}}t.SyncDescriptor=g}),define(Y[95],ee([0,1]),function(G,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class g{constructor(I){this.incoming=new Map,this.outgoing=new Map,this.data=I}}t.Node=g;class T{constructor(I){this._hashFn=I,this._nodes=new Map}roots(){const I=[];for(let C of this._nodes.values())C.outgoing.size===0&&I.push(C);return I}insertEdge(I,C){const D=this.lookupOrInsertNode(I),u=this.lookupOrInsertNode(C);D.outgoing.set(this._hashFn(C),u),u.incoming.set(this._hashFn(I),D)}removeNode(I){const C=this._hashFn(I);this._nodes.delete(C);for(let D of this._nodes.values())D.outgoing.delete(C),D.incoming.delete(C)}lookupOrInsertNode(I){const C=this._hashFn(I);let D=this._nodes.get(C);return D||(D=new g(I),this._nodes.set(C,D)),D}lookup(I){return this._nodes.get(this._hashFn(I))}isEmpty(){return this._nodes.size===0}toString(){let I=[];for(let[C,D]of this._nodes)I.push(`${C}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return I.join(`
`)}findCycleSlow(){for(let[I,C]of this._nodes){const D=new Set([I]),u=this._findCycle(C,D);if(u)return u}}_findCycle(I,C){for(let[D,u]of I.outgoing){if(C.has(D))return[...C,D].join(" -> ");C.add(D);const d=this._findCycle(u,C);if(d)return d;C.delete(D)}}}t.Graph=T}),define(Y[96],ee([0,1,11]),function(G,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,g.createDecorator)("downloadService")}),define(Y[21],ee([0,1,11]),function(G,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,g.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,g.refineServiceDecorator)(t.IEnvironmentService)}),define(Y[22],ee([0,1,75,11,9]),function(G,t,g,T,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";function I(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}t.isIExtensionIdentifier=I;var C;(function(p){p[p.NoneOrRelevance=0]="NoneOrRelevance",p[p.LastUpdatedDate=1]="LastUpdatedDate",p[p.Title=2]="Title",p[p.PublisherName=3]="PublisherName",p[p.InstallCount=4]="InstallCount",p[p.PublishedDate=5]="PublishedDate",p[p.AverageRating=6]="AverageRating",p[p.WeightedRating=12]="WeightedRating"})(C=t.SortBy||(t.SortBy={}));var D;(function(p){p[p.Default=0]="Default",p[p.Ascending=1]="Ascending",p[p.Descending=2]="Descending"})(D=t.SortOrder||(t.SortOrder={}));var u;(function(p){p.Uninstall="uninstall"})(u=t.StatisticType||(t.StatisticType={}));var d;(function(p){p[p.None=0]="None",p[p.Install=1]="Install",p[p.Update=2]="Update"})(d=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class v extends Error{constructor(E,F){super(E);this.code=F,this.name=F}}t.ExtensionManagementError=v,t.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=y.FileAccess.asBrowserUri("./media/defaultIcon.png",G).toString(!0),t.ExtensionsLabel=(0,g.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,g.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,T.createDecorator)("IExtensionManagementCLIService")}),define(Y[40],ee([0,1,18,11]),function(G,t,g,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin";function y(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}t.getWorkspaceSupportTypeMessage=y;function I(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}t.isIExtensionIdentifier=I,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(C=t.ExtensionType||(t.ExtensionType={}));class D{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,E){if(typeof p=="undefined"||p===null)return typeof E=="undefined"||E===null;if(typeof E=="undefined"||E===null)return!1;if(typeof p=="string"||typeof E=="string"){let F=typeof p=="string"?p:p.value,c=typeof E=="string"?E:E.value;return g.equalsIgnoreCase(F,c)}return p._lower===E._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}t.ExtensionIdentifier=D;function u(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}t.isLanguagePackExtension=u;function d(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=d,t.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(Y[23],ee([0,1,18,40]),function(G,t,g,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function y(c,f){return c.uuid&&f.uuid?c.uuid===f.uuid:c.id===f.id?!0:(0,g.compareIgnoreCase)(c.id,f.id)===0}t.areSameExtensions=y;class I{constructor(f,P){this.version=P,this.id=f.id,this.uuid=f.uuid}key(){return`${this.id}-${this.version}`}equals(f){return f instanceof I?y(this,f)&&this.version===f.version:!1}}t.ExtensionIdentifierWithVersion=I;function C(c,f){return`${c}.${f}`}t.getExtensionId=C;function D(c){return c.toLocaleLowerCase()}t.adoptToGalleryExtensionId=D;function u(c,f){return D(C(c,f))}t.getGalleryExtensionId=u;function d(c,f){const P=[],S=w=>{for(const l of P)if(l.some(r=>y(f(r),f(w))))return l;return null};for(const w of c){const l=S(w);l?l.push(w):P.push([w])}return P}t.groupByExtension=d;function v(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=v;function p(c){return{id:c.identifier.id,name:c.name,galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),...c.telemetryData}}t.getGalleryExtensionTelemetryData=p,t.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function E(c){const f=new Set;for(const P of c)P.malicious&&f.add(P.id.id);return f}t.getMaliciousExtensionsSet=E;function F(c,f){const P=[],S=f.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const w=S.shift();if(w&&P.every(l=>!y(l.identifier,{id:w}))){const l=c.filter(r=>y(r.identifier,{id:w}));l.length===1&&(P.push(l[0]),S.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return P}t.getExtensionDependencies=F});var fe=this&&this.__param||function(G,t){return function(g,T){t(g,T,G)}};define(Y[97],ee([0,1,76,8,7,41,22,23,40,62,26,9]),function(G,t,g,T,y,I,C,D,u,d,v,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const E=w=>(0,g.localize)(0,null,w),F=(0,g.localize)(1,null,"ms-dotnettools.csharp");function c(w,l){return l?`${w.publisher}.${w.name}@${w.version}`:`${w.publisher}.${w.name}`}const f=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function P(w){const l=f.exec(w);return l&&l[1]?[(0,D.adoptToGalleryExtensionId)(l[1]),l[2]]:[(0,D.adoptToGalleryExtensionId)(w),void 0]}t.getIdAndVersion=P;let S=class{constructor(l,r){this.extensionManagementService=l,this.extensionGalleryService=r}get location(){}async listExtensions(l,r,s=console){let e=await this.extensionManagementService.getInstalled(1);const i=u.EXTENSION_CATEGORIES.map(o=>o.toLowerCase());if(r&&r!==""){if(i.indexOf(r.toLowerCase())<0){s.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(o=>o.manifest.categories?o.manifest.categories.map(h=>h.toLowerCase()).indexOf(r.toLowerCase())>-1:!1)}else if(r===""){s.log("Possible Categories: "),i.forEach(o=>{s.log(o)});return}this.location&&s.log((0,g.localize)(2,null,this.location)),e=e.sort((o,a)=>o.identifier.id.localeCompare(a.identifier.id));let n;for(let o of e)n!==o.identifier.id&&(n=o.identifier.id,s.log(c(o.manifest,l)))}async installExtensions(l,r,s,e,i=console){const n=[],o=[];l.length&&i.log(this.location?(0,g.localize)(3,null,this.location):(0,g.localize)(4,null));const a=await this.extensionManagementService.getInstalled(1),h=(L,k)=>{const j=a.find(_=>(0,D.areSameExtensions)(_.identifier,{id:L}));if(j){if(!k&&!e)return i.log((0,g.localize)(5,null,L,j.manifest.version,L)),!1;if(k&&j.manifest.version===k)return i.log((0,g.localize)(6,null,`${L}@${k}`)),!1}return!0},m=[],N=[];for(const L of l)if(L instanceof y.URI)m.push(L);else{const[k,j]=P(L);h(k,j)&&N.push({id:k,version:j,installOptions:{isBuiltin:!1,isMachineScoped:s}})}for(const L of r){const[k,j]=P(L);h(k,j)&&N.push({id:k,version:j,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(m.length&&await Promise.all(m.map(async L=>{try{const k=await this.installVSIX(L,{isBuiltin:!1,isMachineScoped:s},e,i);k&&o.push(k)}catch(k){i.error(k.message||k.stack||k),n.push(L.toString())}})),N.length){const L=await this.getGalleryExtensions(N);await Promise.all(N.map(async k=>{const j=L.get(k.id.toLowerCase());if(j)try{const _=await this.installFromGallery(k,j,a,e,i);_&&o.push(_)}catch(_){i.error(_.message||_.stack||_),n.push(k.id)}else i.error(`${E(k.version?`${k.id}@${k.version}`:k.id)}
${F}`),n.push(k.id)}))}if(n.length)throw new Error((0,g.localize)(7,null,n.join(", ")))}async installVSIX(l,r,s,e){const i=await this.extensionManagementService.getManifest(l);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,s,e))try{return await this.extensionManagementService.install(l,r),e.log((0,g.localize)(8,null,(0,d.getBaseLabel)(l))),i}catch(o){if((0,T.isPromiseCanceledError)(o))return e.log((0,g.localize)(9,null,(0,d.getBaseLabel)(l))),null;throw o}return null}async getGalleryExtensions(l){const r=l.filter(({version:i})=>i===void 0).map(({id:i})=>i),s=l.filter(({version:i})=>i!==void 0),e=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(r,v.CancellationToken.None)).forEach(n=>e.set(n.identifier.id.toLowerCase(),n))})(),Promise.all(s.map(async({id:i,version:n})=>{const o=await this.extensionGalleryService.getCompatibleExtension({id:i},n);o&&e.set(o.identifier.id.toLowerCase(),o)}))]),e}async installFromGallery({id:l,version:r,installOptions:s},e,i,n,o){const a=await this.extensionGalleryService.getManifest(e,v.CancellationToken.None);if(a&&!this.validateExtensionKind(a,o))return null;const h=i.find(m=>(0,D.areSameExtensions)(m.identifier,e.identifier));if(h){if(e.version===h.manifest.version)return o.log((0,g.localize)(10,null,r?`${l}@${r}`:l)),null;o.log((0,g.localize)(11,null,l,e.version))}try{return s.isBuiltin?o.log(r?(0,g.localize)(12,null,l,r):(0,g.localize)(13,null,l)):o.log(r?(0,g.localize)(14,null,l,r):(0,g.localize)(15,null,l)),await this.extensionManagementService.installFromGallery(e,s),o.log((0,g.localize)(16,null,l,e.version)),a}catch(m){if((0,T.isPromiseCanceledError)(m))return o.log((0,g.localize)(17,null,l)),null;throw m}}validateExtensionKind(l,r){return!0}async validateVSIX(l,r,s){const e={id:(0,D.getGalleryExtensionId)(l.publisher,l.name)},n=(await this.extensionManagementService.getInstalled(1)).find(o=>(0,D.areSameExtensions)(e,o.identifier)&&(0,I.gt)(o.manifest.version,l.version));return n&&!r?(s.log((0,g.localize)(18,null,n.identifier.id,n.manifest.version,l.version)),!1):this.validateExtensionKind(l,s)}async uninstallExtensions(l,r,s=console){const e=async n=>{if(n instanceof y.URI){const o=await this.extensionManagementService.getManifest(n);return c(o)}return n},i=[];for(const n of l){const o=await e(n),h=(await this.extensionManagementService.getInstalled()).filter(m=>(0,D.areSameExtensions)(m.identifier,{id:o}));if(!h.length)throw new Error(`${this.notInstalled(o)}
${F}`);if(h.some(m=>m.type===0)){s.log((0,g.localize)(19,null,o));return}if(!r&&h.some(m=>m.isBuiltin)){s.log((0,g.localize)(20,null,o));return}s.log((0,g.localize)(21,null,o));for(const m of h)await this.extensionManagementService.uninstall(m),i.push(m);this.location?s.log((0,g.localize)(22,null,o,this.location)):s.log((0,g.localize)(23,null,o))}}async locateExtension(l,r=console){const s=await this.extensionManagementService.getInstalled();l.forEach(e=>{s.forEach(i=>{if(i.identifier.id===e&&i.location.scheme===p.Schemas.file){r.log(i.location.fsPath);return}})})}notInstalled(l){return this.location?(0,g.localize)(24,null,l,this.location):(0,g.localize)(25,null,l)}};S=ue([fe(0,C.IExtensionManagementService),fe(1,C.IExtensionGalleryService)],S),t.ExtensionManagementCLIService=S}),define(Y[98],ee([0,1,2,3,40,10]),function(G,t,g,T,y,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class C extends g.Disposable{constructor(u,d){super();this.environmentService=u,this.extensionsManifestCache=(0,T.join)(this.environmentService.userDataPath,y.MANIFEST_CACHE_FOLDER,y.USER_MANIFEST_CACHE_FILE),this._register(d.onDidInstallExtensions(v=>this.onDidInstallExtensions(v))),this._register(d.onDidUninstallExtension(v=>this.onDidUnInstallExtension(v)))}onDidInstallExtensions(u){u.some(d=>!!d.local)&&this.invalidate()}onDidUnInstallExtension(u){u.error||this.invalidate()}invalidate(){I.Promises.rm(this.extensionsManifestCache,I.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=C}),define(Y[99],ee([0,1,88,32,29,15,128,28,71,26,8]),function(G,t,g,T,y,I,C,D,u,d,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function p(c,f,P){return f["force-disable-user-env"]?(c.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):I.isWindows?(c.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,C.isLaunchedFromCli)(P)&&!f["force-user-env"]?(c.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,C.isLaunchedFromCli)(P)?c.trace("resolveShellEnv(): running (--force-user-env)"):c.trace("resolveShellEnv(): running (macOS/Linux)"),E||(E=new Promise(async S=>{const w=new d.CancellationTokenSource,l=setTimeout(()=>{c.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),w.dispose(!0),S({})},1e4);try{const r=await F(c,w.token);S(r)}catch(r){(0,v.isPromiseCanceledError)(r)||c.error(`[resolve shell env] Unable to resolve shell environment (${r}). Proceeding without shell environment...`),S({})}finally{clearTimeout(l),w.dispose()}})),E)}t.resolveShellEnv=p;let E;async function F(c,f){const P=new Promise(async(S,w)=>{const l=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",l);const r=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",r);const s=(0,y.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(s+"(.*)"+s),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};c.trace("getUnixShellEnvironment#env",i);const n=await(0,u.getSystemShell)(I.OS,i);if(c.trace("getUnixShellEnvironment#shell",n),f.isCancellationRequested)return w(v.canceled);const o=g.basename(n);let a,h;/^pwsh(-preview)?$/.test(o)?(a=`& '${process.execPath}' -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,h=["-Login","-Command"]):(a=`'${process.execPath}' -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,h=["-ilc"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),a);const m=(0,T.spawn)(n,[...h,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});f.onCancellationRequested(()=>(m.kill(),w(v.canceled))),m.on("error",k=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(k)),S({})});const N=[];m.stdout.on("data",k=>N.push(k));const L=[];m.stderr.on("data",k=>L.push(k)),m.on("close",(k,j)=>{const _=Buffer.concat(N).toString("utf8");c.trace("getUnixShellEnvironment#raw",_);const Q=Buffer.concat(L).toString("utf8");if(Q.trim()&&c.trace("getUnixShellEnvironment#stderr",Q),k||j)return w(new Error(`Failed to get environment (code ${k}, signal ${j})`));const ne=e.exec(_),re=ne?ne[1]:"{}";try{const Z=JSON.parse(re);l?Z.ELECTRON_RUN_AS_NODE=l:delete Z.ELECTRON_RUN_AS_NODE,r?Z.ELECTRON_NO_ATTACH_CONSOLE=r:delete Z.ELECTRON_NO_ATTACH_CONSOLE,delete Z.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",Z),S(Z)}catch(Z){c.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(Z)),w(Z)}})});try{return await P}catch(S){return c.error("getUnixShellEnvironment#error",(0,D.toErrorMessage)(S)),{}}}}),define(Y[51],ee([0,1,7,17,15]),function(G,t,g,T,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function I(u){return u.map(d=>({type:d.type,resource:g.URI.file(d.path)}))}t.toFileChanges=I;function C(u){const d=new D;for(const v of u)d.processEvent(v);return d.normalize()}t.normalizeFileChanges=C;class D{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(d){const v=this.mapPathToChange.get(d.path);if(v){const p=v.type,E=d.type;p===1&&E===2?(this.mapPathToChange.delete(d.path),this.normalized.splice(this.normalized.indexOf(v),1)):p===2&&E===1?v.type=0:p===1&&E===0||(v.type=E)}else this.normalized.push(d),this.mapPathToChange.set(d.path,d)}normalize(){const d=[],v=[];return this.normalized.filter(p=>p.type!==2?(d.push(p),!1):!0).sort((p,E)=>p.path.length-E.path.length).filter(p=>v.some(E=>(0,T.isParent)(p.path,E,!y.isLinux))?!1:(v.push(p.path),!0)).concat(d)}}}),define(Y[100],ee([0,1,51,2,10,63,65,4,3]),function(G,t,g,T,y,I,C,D,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class d extends T.Disposable{constructor(p,E,F,c){super();this.path=p,this.onDidFilesChange=E,this.onLogMessage=F,this.verboseLogging=c,this.fileChangesDelayer=this._register(new D.ThrottledDelayer(C.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(p){this.verboseLogging=p}async startWatching(){try{const{stat:p,symbolicLink:E}=await y.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let F=this.path;if(E)try{F=await(0,I.realpath)(F)}catch(c){if(this.onError(c),E.dangling)return}p.isDirectory()?this._register((0,C.watchFolder)(F,(c,f)=>{this.onFileChange({type:c==="changed"?0:c==="added"?1:2,path:(0,u.join)(this.path,(0,u.basename)(f))})},c=>this.onError(c))):this._register((0,C.watchFile)(F,c=>{this.onFileChange({type:c==="changed"?0:2,path:this.path})},c=>this.onError(c)))}catch(p){p.code!=="ENOENT"&&this.onError(p)}}onFileChange(p){this.fileChangesBuffer.push(p),this.verboseLogging&&this.onVerbose(`${p.type===1?"[ADDED]":p.type===2?"[DELETED]":"[CHANGED]"} ${p.path}`),this.fileChangesDelayer.trigger(async()=>{const E=this.fileChangesBuffer;this.fileChangesBuffer=[];const F=(0,g.normalizeFileChanges)(E);if(this.verboseLogging)for(const c of F)this.onVerbose(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);F.length>0&&this.onDidFilesChange(F)})}onError(p){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${p}`})}onVerbose(p){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${p}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=d}),define(Y[52],ee([0,1]),function(G,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class g{constructor(...y){this._entries=new Map;for(let[I,C]of y)this.set(I,C)}set(y,I){const C=this._entries.get(y);return this._entries.set(y,I),C}has(y){return this._entries.has(y)}get(y){return this._entries.get(y)}}t.ServiceCollection=g}),define(Y[101],ee([0,1,8,95,50,11,52,4]),function(G,t,g,T,y,I,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const u=!1;class d extends Error{constructor(c){super("cyclic dependency between services");this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class v{constructor(c=new C.ServiceCollection,f=!1,P){this._activeInstantiations=new Set,this._services=c,this._strict=f,this._parent=P,this._services.set(I.IInstantiationService,this)}createChild(c){return new v(c,this._strict,this)}invokeFunction(c,...f){let P=E.traceInvocation(c),S=!1;try{return c({get:(l,r)=>{if(S)throw(0,g.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(l,P);if(!s&&r!==I.optional)throw new Error(`[invokeFunction] unknown service '${l}'`);return s}},...f)}finally{S=!0,P.stop()}}createInstance(c,...f){let P,S;return c instanceof y.SyncDescriptor?(P=E.traceCreation(c.ctor),S=this._createInstance(c.ctor,c.staticArguments.concat(f),P)):(P=E.traceCreation(c),S=this._createInstance(c,f,P)),P.stop(),S}_createInstance(c,f=[],P){let S=I._util.getServiceDependencies(c).sort((r,s)=>r.index-s.index),w=[];for(const r of S){let s=this._getOrCreateServiceInstance(r.id,P);if(!s&&this._strict&&!r.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${r.id}.`);w.push(s)}let l=S.length>0?S[0].index:f.length;if(f.length!==l){console.warn(`[createInstance] First service dependency of ${c.name} at position ${l+1} conflicts with ${f.length} static arguments`);let r=l-f.length;r>0?f=f.concat(new Array(r)):f=f.slice(0,l)}return new c(...[...f,...w])}_setServiceInstance(c,f){if(this._services.get(c)instanceof y.SyncDescriptor)this._services.set(c,f);else if(this._parent)this._parent._setServiceInstance(c,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let f=this._services.get(c);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):f}_getOrCreateServiceInstance(c,f){let P=this._getServiceInstanceOrDescriptor(c);return P instanceof y.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,P,f.branch(c,!0)):(f.branch(c,!1),P)}_safeCreateAndCacheServiceInstance(c,f,P){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,f,P)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,f,P){const S=new T.Graph(r=>r.id.toString());let w=0;const l=[{id:c,desc:f,_trace:P}];for(;l.length;){const r=l.pop();if(S.lookupOrInsertNode(r),w++>1e3)throw new d(S);for(let s of I._util.getServiceDependencies(r.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(s.id);if(!e&&!s.optional&&console.warn(`[createInstance] ${c} depends on ${s.id} which is NOT registered.`),e instanceof y.SyncDescriptor){const i={id:s.id,desc:e,_trace:r._trace.branch(s.id,!0)};S.insertEdge(r,i),l.push(i)}}}for(;;){const r=S.roots();if(r.length===0){if(!S.isEmpty())throw new d(S);break}for(const{data:s}of r){if(this._getServiceInstanceOrDescriptor(s.id)instanceof y.SyncDescriptor){const i=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,i)}S.removeNode(s)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,f,P=[],S,w){if(this._services.get(c)instanceof y.SyncDescriptor)return this._createServiceInstance(f,P,S,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,f,P,S,w);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(c,f=[],P,S){if(P){const w=new D.IdleValue(()=>this._createInstance(c,f,S));return new Proxy(Object.create(null),{get(l,r){if(r in l)return l[r];let s=w.value,e=s[r];return typeof e!="function"||(e=e.bind(s),l[r]=e),e},set(l,r,s){return w.value[r]=s,!0}})}else return this._createInstance(c,f,S)}}t.InstantiationService=v;var p;(function(F){F[F.Creation=0]="Creation",F[F.Invocation=1]="Invocation",F[F.Branch=2]="Branch"})(p||(p={}));class E{constructor(c,f){this.type=c,this.name=f,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return u?new E(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):E._None}static traceCreation(c){return u?new E(0,c.name):E._None}branch(c,f){let P=new E(2,c.toString());return this._dep.push([c,f,P]),P}stop(){let c=Date.now()-this._start;E._totals+=c;let f=!1;function P(w,l){let r=[],s=new Array(w+1).join("	");for(const[e,i,n]of l._dep)if(i&&n){f=!0,r.push(`${s}CREATES -> ${e}`);let o=P(w+1,n);o&&r.push(o)}else r.push(`${s}uses -> ${e}`);return r.join(`
`)}let S=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${P(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${E._totals.toFixed(2)}ms)`];(c>2||f)&&console.log(S.join(`
`))}}E._None=new class extends E{constructor(){super(-1,null)}stop(){}branch(){return this}},E._totals=0}),define(Y[53],ee([0,1,11]),function(G,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,g.createDecorator)("localizationsService");function T(y){if(typeof y.languageId!="string"||!Array.isArray(y.translations)||y.translations.length===0)return!1;for(const I of y.translations)if(typeof I.id!="string"||typeof I.path!="string")return!1;return!(y.languageName&&typeof y.languageName!="string"||y.localizedLanguageName&&typeof y.localizedLanguageName!="string")}t.isValidLocalization=T}),define(Y[14],ee([0,1,11,2,15,13,28]),function(G,t,g,T,y,I,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,g.createDecorator)("logService"),t.ILoggerService=(0,g.createDecorator)("loggerService");function D(){return new Date().toISOString()}var u;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(u=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=u.Info;class d extends T.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=d;class v extends d{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(u.Trace)&&this.log(u.Trace,this.format([e,...i]))}debug(e,...i){this.checkLogLevel(u.Debug)&&this.log(u.Debug,this.format([e,...i]))}info(e,...i){this.checkLogLevel(u.Info)&&this.log(u.Info,this.format([e,...i]))}warn(e,...i){this.checkLogLevel(u.Warning)&&this.log(u.Warning,this.format([e,...i]))}error(e,...i){if(this.checkLogLevel(u.Error))if(e instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=e.stack,this.log(u.Error,this.format(n))}else this.log(u.Error,this.format([e,...i]))}critical(e,...i){this.checkLogLevel(u.Critical)&&this.log(u.Critical,this.format([e,...i]))}flush(){}format(e){let i="";for(let n=0;n<e.length;n++){let o=e[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch(a){}i+=(n>0?" ":"")+o}return i}}t.AbstractMessageLogger=v;class p extends d{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!y.isWindows}trace(e,...i){this.getLevel()<=u.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,e,...i):console.log(`[main ${D()}]`,e,...i))}debug(e,...i){this.getLevel()<=u.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,e,...i):console.log(`[main ${D()}]`,e,...i))}info(e,...i){this.getLevel()<=u.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,e,...i):console.log(`[main ${D()}]`,e,...i))}warn(e,...i){this.getLevel()<=u.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,e,...i):console.warn(`[main ${D()}]`,e,...i))}error(e,...i){this.getLevel()<=u.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,e,...i):console.error(`[main ${D()}]`,e,...i))}critical(e,...i){this.getLevel()<=u.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,e,...i):console.error(`[main ${D()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=p;class E extends d{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=u.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=u.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=u.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=u.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=u.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=u.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=E;class F extends d{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=u.Trace&&this.adapter.log(u.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=u.Debug&&this.adapter.log(u.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=u.Info&&this.adapter.log(u.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=u.Warning&&this.adapter.log(u.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=u.Error&&this.adapter.log(u.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=u.Critical&&this.adapter.log(u.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:(0,C.toErrorMessage)(e,this.getLevel()<=u.Trace)}dispose(){}flush(){}}t.AdapterLogger=F;class c extends d{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const n of this.logServices)n.trace(e,...i)}debug(e,...i){for(const n of this.logServices)n.debug(e,...i)}info(e,...i){for(const n of this.logServices)n.info(e,...i)}warn(e,...i){for(const n of this.logServices)n.warn(e,...i)}error(e,...i){for(const n of this.logServices)n.error(e,...i)}critical(e,...i){for(const n of this.logServices)n.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=c;class f extends T.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=f;class P extends T.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(n))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,i){let n=this.loggers.get(e.toString());return n||(n=this.doCreateLogger(e,i?.always?u.Trace:this.logLevel,i),this.loggers.set(e.toString(),n),i?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=P;class S{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(e){}getLevel(){return u.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=S;function w(s){if(s.verbose)return u.Trace;if(typeof s.logLevel=="string"){const e=l(s.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=w;function l(s){switch(s){case"trace":return u.Trace;case"debug":return u.Debug;case"info":return u.Info;case"warn":return u.Warning;case"error":return u.Error;case"critical":return u.Critical;case"off":return u.Off}}t.parseLogLevel=l;function r(s){switch(s){case u.Trace:return"trace";case u.Debug:return"debug";case u.Info:return"info";case u.Warning:return"warn";case u.Error:return"error";case u.Critical:return"critical";case u.Off:return"off"}}t.LogLevelToString=r}),define(Y[102],ee([0,1,10,2,17,22,21,7,20,23,14,29,41,15,4,8]),function(G,t,g,T,y,I,C,D,u,d,v,p,E,F,c,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let S=class extends T.Disposable{constructor(l,r,s,e){super();this.fileService=r,this.extensionGalleryService=s,this.logService=e,this.extensionsDownloadDir=D.URI.file(l.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(l,r){await this.cleanUpPromise;const s=this.getName(l),e=(0,u.joinPath)(this.extensionsDownloadDir,s);if(!await this.fileService.exists(e)){const i=(0,u.joinPath)(this.extensionsDownloadDir,`.${(0,p.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(l,i,r);try{await this.rename(i,e,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(o){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",l.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,f.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return e}async delete(l){}async rename(l,r,s){try{await g.Promises.rename(l.fsPath,r.fsPath)}catch(e){if(F.isWindows&&e&&e.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${l} to ${r} with 'EPERM' error. Trying again...`),this.rename(l,r,s);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const l=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(l.children){const r=[],s=[];for(const n of l.children){const o=this.parse(n.name);o&&s.push([o,n])}const e=(0,d.groupByExtension)(s,([n])=>n),i=[];for(const n of e)n.sort((o,a)=>E.rcompare(o[0].version,a[0].version)),r.push(...n.slice(1).map(o=>o[1].resource)),i.push(n[0][1]);i.sort((n,o)=>n.mtime-o.mtime),r.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await c.Promises.settled(r.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(l){this.logService.error(l)}}getName(l){return this.cache?new d.ExtensionIdentifierWithVersion(l.identifier,l.version).key().toLowerCase():(0,p.generateUuid)()}parse(l){const r=P.exec(l);return r&&r[1]&&r[2]?new d.ExtensionIdentifierWithVersion({id:r[1]},r[2]):null}};S=ue([fe(0,C.INativeEnvironmentService),fe(1,y.IFileService),fe(2,I.IExtensionGalleryService),fe(3,v.ILogService)],S),t.ExtensionsDownloader=S}),define(Y[103],ee([0,1,2,14,32,28,3,4,13,9,10,21]),function(G,t,g,T,y,I,C,D,u,d,v,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let E=class extends g.Disposable{constructor(c,f){super();this.environmentService=c,this.logService=f,this.processesLimiter=new D.Limiter(5)}async postUninstall(c){const f=this.parseScript(c,"uninstall");return f&&(this.logService.info(c.identifier.id,c.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(f.script,"uninstall",f.args,!0,c).then(()=>this.logService.info(c.identifier.id,c.manifest.version,"Finished running post uninstall script"),P=>this.logService.error(c.identifier.id,c.manifest.version,`Failed to run post uninstall script: ${P}`)))),v.Promises.rm(this.getExtensionStoragePath(c)).then(void 0,P=>this.logService.error("Error while removing extension storage path",P))}parseScript(c,f){const P=`vscode:${f}`;if(c.location.scheme===d.Schemas.file&&c.manifest&&c.manifest.scripts&&typeof c.manifest.scripts[P]=="string"){const S=c.manifest.scripts[P].split(" ");return S.length<2||S[0]!=="node"||!S[1]?(this.logService.warn(c.identifier.id,c.manifest.version,`${P} should be a node script`),null):{script:(0,C.join)(c.location.fsPath,S[1]),args:S.slice(2)||[]}}return null}runLifecycleHook(c,f,P,S,w){return new Promise((l,r)=>{const s=this.start(c,f,P,w);let e;const i=n=>{e&&(clearTimeout(e),e=null),n?r(n):l(void 0)};s.on("error",n=>{i((0,I.toErrorMessage)(n)||"Unknown")}),s.on("exit",(n,o)=>{i(n?`post-${f} process exited with code ${n}`:void 0)}),S&&(e=setTimeout(()=>{e=null,s.kill(),r("timed out")},5e3))})}start(c,f,P,S){const w={silent:!0,execArgv:void 0},l=(0,y.fork)(c,[`--type=extension-post-${f}`,...P],w);l.stdout.setEncoding("utf8"),l.stderr.setEncoding("utf8");const r=u.Event.fromNodeEventEmitter(l.stdout,"data"),s=u.Event.fromNodeEventEmitter(l.stderr,"data");r(n=>this.logService.info(S.identifier.id,S.manifest.version,`post-${f}`,n)),s(n=>this.logService.error(S.identifier.id,S.manifest.version,`post-${f}`,n));const e=u.Event.any(u.Event.map(r,n=>({data:`%c${n}`,format:[""]})),u.Event.map(s,n=>({data:`%c${n}`,format:["color: red"]})));return u.Event.debounce(e,(n,o)=>n?{data:n.data+o.data,format:[...n.format,...o.format]}:{data:o.data,format:o.format},100)(n=>{console.group(S.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),l}getExtensionStoragePath(c){return(0,C.join)(this.environmentService.globalStorageHome.fsPath,c.identifier.id.toLowerCase())}};E=ue([fe(0,p.IEnvironmentService),fe(1,T.ILogService)],E),t.ExtensionsLifecycle=E}),define(Y[104],ee([0,1,2,21,13,17,7,23,20,14]),function(G,t,g,T,y,I,C,D,u,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let v=class extends g.Disposable{constructor(E,F,c,f){super();this.extensionsManagementService=E,this.logService=f,this._onDidChangeExtensionsByAnotherSource=this._register(new y.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(w=>{this.installedExtensions=w.map(l=>l.identifier),this.startTimestamp=Date.now()}),this._register(E.onInstallExtension(w=>this.onInstallExtension(w))),this._register(E.onDidInstallExtensions(w=>this.onDidInstallExtensions(w))),this._register(E.onDidUninstallExtension(w=>this.onDidUninstallExtension(w)));const P=C.URI.file(c.extensionsPath),S=new u.ExtUri(w=>!F.hasCapability(w,1024));this._register(F.watch(P)),this._register(y.Event.filter(F.onDidChangeFilesRaw,w=>w.changes.some(l=>this.doesChangeAffects(l,P,S)))(()=>this.onDidChange()))}doesChangeAffects(E,F,c){return c.isEqual(c.dirname(E.resource),F)?c.isEqual(E.resource,c.joinPath(F,".obsolete"))?!0:!(E.type!==1&&E.type!==2||c.basename(E.resource).startsWith(".")):!1}onInstallExtension(E){this.addInstallingExtension(E.identifier)}onDidInstallExtensions(E){for(const F of E)this.removeInstallingExtension(F.identifier),F.local&&this.addInstalledExtension(F.identifier)}onDidUninstallExtension(E){E.error||this.removeInstalledExtension(E.identifier)}addInstallingExtension(E){this.removeInstallingExtension(E),this.installingExtensions.push(E)}removeInstallingExtension(E){this.installingExtensions=this.installingExtensions.filter(F=>!(0,D.areSameExtensions)(F,E))}addInstalledExtension(E){this.installedExtensions&&(this.removeInstalledExtension(E),this.installedExtensions.push(E))}removeInstalledExtension(E){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(F=>!(0,D.areSameExtensions)(F,E)))}async onDidChange(){if(this.installedExtensions){const E=await this.extensionsManagementService.getInstalled(1),F=E.filter(f=>[...this.installingExtensions,...this.installedExtensions].some(P=>(0,D.areSameExtensions)(P,f.identifier))?!1:f.installedTimestamp&&f.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",f.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",f.identifier.id),!1)),c=this.installedExtensions.filter(f=>this.installingExtensions.some(P=>(0,D.areSameExtensions)(P,f))?!1:E.every(P=>!(0,D.areSameExtensions)(P.identifier,f))?(this.logService.info("Detected extension removed from another source",f.id),!0):!1);this.installedExtensions=E.map(f=>f.identifier),(F.length||c.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:F,removed:c})}}};v=ue([fe(1,I.IFileService),fe(2,T.INativeEnvironmentService),fe(3,d.ILogService)],v),t.ExtensionsWatcher=v}),define(Y[105],ee([0,1,10,129,22,2,21,4,23,14,53,24,9,3]),function(G,t,g,T,y,I,C,D,u,d,v,p,E,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let c=class extends I.Disposable{constructor(S,w,l){super();this.extensionManagementService=S,this.logService=l,this.cache=this._register(new f(w,l)),this.extensionManagementService.registerParticipant({postInstall:async r=>this.postInstallExtension(r),postUninstall:async r=>this.postUninstallExtension(r)})}async getLanguageIds(){const S=await this.cache.getLanguagePacks(),w=["en",...Object.keys(S)];return(0,p.distinct)(w)}async postInstallExtension(S){S&&S.manifest&&S.manifest.contributes&&S.manifest.contributes.localizations&&S.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",S.identifier.id),await this.update())}async postUninstallExtension(S){const w=await this.cache.getLanguagePacks();Object.keys(w).some(l=>w[l]&&w[l].extensions.some(r=>(0,u.areSameExtensions)(r.extensionIdentifier,S.identifier)))&&(this.logService.info("Removing language packs from the extension",S.identifier.id),await this.update())}async update(){const[S,w]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),l=await this.cache.update(w);return!(0,p.equals)(Object.keys(S),Object.keys(l))}};c=ue([fe(0,y.IExtensionManagementService),fe(1,C.INativeEnvironmentService),fe(2,d.ILogService)],c),t.LocalizationsService=c;let f=class extends I.Disposable{constructor(S,w){super();this.logService=w,this.languagePacks={},this.languagePacksFilePath=(0,F.join)(S.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new D.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(S){return this.withLanguagePacks(w=>{Object.keys(w).forEach(l=>delete w[l]),this.createLanguagePacksFromExtensions(w,...S)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(S,...w){for(const l of w)l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(S,l);Object.keys(S).forEach(l=>this.updateHash(S[l]))}createLanguagePacksFromExtension(S,w){const l=w.identifier,r=w.manifest.contributes&&w.manifest.contributes.localizations?w.manifest.contributes.localizations:[];for(const s of r)if(w.location.scheme===E.Schemas.file&&(0,v.isValidLocalization)(s)){let e=S[s.languageId];e||(e={hash:"",extensions:[],translations:{}},S[s.languageId]=e);let i=e.extensions.filter(n=>(0,u.areSameExtensions)(n.extensionIdentifier,l))[0];i?i.version=w.manifest.version:e.extensions.push({extensionIdentifier:l,version:w.manifest.version});for(const n of s.translations)e.translations[n.id]=(0,F.join)(w.location.fsPath,n.path)}}updateHash(S){if(S){const w=(0,T.createHash)("md5");for(const l of S.extensions)w.update(l.extensionIdentifier.uuid||l.extensionIdentifier.id).update(l.version);S.hash=w.digest("hex")}}withLanguagePacks(S=()=>null){return this.languagePacksFileLimiter.queue(()=>{let w=null;return g.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,l=>l.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(l)).then(l=>{try{return JSON.parse(l)}catch(r){return{}}}).then(l=>(w=S(l),l)).then(l=>{for(const s of Object.keys(l))l[s]||delete l[s];this.languagePacks=l,this.initializedCache=!0;const r=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",r),g.Promises.writeFile(this.languagePacksFilePath,r)}).then(()=>w,l=>this.logService.error(l))})}};f=ue([fe(0,C.INativeEnvironmentService),fe(1,d.ILogService)],f)}),define(Y[106],ee([0,1,14,17]),function(G,t,g,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function y(u,d,v,p){try{const E=await new Promise((F,c)=>{G(["spdlog"],F,c)});return E.setFlushOn(g.LogLevel.Trace),E.createAsyncRotatingLogger(u,d,v,p)}catch(E){console.error(E)}return null}function I(u,d,v,p){const E=G.__$__nodeRequire("spdlog");return E.setFlushOn(g.LogLevel.Trace),E.createRotatingLogger(u,d,v,p)}t.createRotatingLogger=I;function C(u,d,v){switch(d){case g.LogLevel.Trace:u.trace(v);break;case g.LogLevel.Debug:u.debug(v);break;case g.LogLevel.Info:u.info(v);break;case g.LogLevel.Warning:u.warn(v);break;case g.LogLevel.Error:u.error(v);break;case g.LogLevel.Critical:u.critical(v);break;default:throw new Error("Invalid log level")}}class D extends g.AbstractMessageLogger{constructor(d,v,p,E){super();this.name=d,this.filepath=v,this.rotating=p,this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(F=>{this._logger&&this._logger.setLevel(F)}))}_createSpdLogLogger(){const d=this.rotating?6:1,v=30/d*T.ByteSize.MB;return y(this.name,this.filepath,v,d).then(p=>{if(p){this._logger=p,this._logger.setLevel(this.getLevel());for(const{level:E,message:F}of this.buffer)C(this._logger,E,F);this.buffer=[]}})}log(d,v){this._logger?C(this._logger,d,v):this.getLevel()<=d&&this.buffer.push({level:d,message:v})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=D}),define(Y[54],ee([0,1,82,16,17,8,34]),function(G,t,g,T,y,I,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function D(p,E,F,c,f,P){let S;try{await u(p,E,F,c,f,P)}catch(w){S=w}finally{S&&f.errorTransformer&&(S=f.errorTransformer(S)),typeof S!="undefined"&&F.error(S),F.end()}}t.readFileIntoStream=D;async function u(p,E,F,c,f,P){d(P);const S=await p.open(E,{create:!1});try{d(P);let w=0,l=0,r=f&&typeof f.length=="number"?f.length:void 0,s=T.VSBuffer.alloc(Math.min(f.bufferSize,typeof r=="number"?r:f.bufferSize)),e=f&&typeof f.position=="number"?f.position:0,i=0;do l=await p.read(S,e,s.buffer,i,s.byteLength-i),e+=l,i+=l,w+=l,typeof r=="number"&&(r-=l),i===s.byteLength&&(await F.write(c(s)),s=T.VSBuffer.alloc(Math.min(f.bufferSize,typeof r=="number"?r:f.bufferSize)),i=0);while(l>0&&(typeof r!="number"||r>0)&&d(P)&&v(w,f));if(i>0){let n=i;typeof r=="number"&&(n=Math.min(i,r)),F.write(c(s.slice(0,n)))}}catch(w){throw(0,y.ensureFileSystemProviderError)(w)}finally{await p.close(S)}}function d(p){if(p.isCancellationRequested)throw(0,I.canceled)();return!0}function v(p,E){if(E?.limits){if(typeof E.limits.memory=="number"&&p>E.limits.memory)throw(0,y.createFileSystemProviderError)((0,g.localize)(0,null,C.default.nameShort),y.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&p>E.limits.size)throw(0,y.createFileSystemProviderError)((0,g.localize)(1,null),y.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Y[107],ee([0,1,81,130,2,17,13,20,45,24,14,16,36,4,26,9,54,131]),function(G,t,g,T,y,I,C,D,u,d,v,p,E,F,c,f,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let w=class Ne extends y.Disposable{constructor(r){super();this.logService=r,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new C.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new C.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new C.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new C.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new C.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new C.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new C.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new F.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new I.FileChangesEvent(s,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new F.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new I.FileChangesEvent(s,!0)))),this.watchedResources=u.TernarySearchTree.forUris(s=>{const e=this.getProvider(s.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new F.ResourceQueue)}registerProvider(r,s){if(this.provider.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,T.mark)(`code/registerFilesystem/${r}`),this.provider.set(r,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:r,provider:s});const e=new y.DisposableStore;return e.add(s.onDidChangeFile(i=>this.onDidChangeFile(i,this.isPathCaseSensitive(s)))),e.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:r}))),typeof s.onDidErrorOccur=="function"&&e.add(s.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,y.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:r,provider:s}),this.provider.delete(r),(0,y.dispose)(e)})}getProvider(r){return this.provider.get(r)}async activateProvider(r){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:r,join(e){s.push(e)}}),!this.provider.has(r)&&await F.Promises.settled(s)}canHandleResource(r){return this.provider.has(r.scheme)}hasCapability(r,s){const e=this.provider.get(r.scheme);return!!(e&&e.capabilities&s)}listCapabilities(){return S.Iterable.map(this.provider,([r,s])=>({scheme:r,capabilities:s.capabilities}))}async withProvider(r){if(!(0,D.isAbsolutePath)(r))throw new I.FileOperationError((0,g.localize)(0,null,this.resourceForError(r)),8);await this.activateProvider(r.scheme);const s=this.provider.get(r.scheme);if(!s){const e=new Error;throw e.name="ENOPRO",e.message=(0,g.localize)(1,null,r.toString()),e}return s}async withReadProvider(r){const s=await this.withProvider(r);if((0,I.hasOpenReadWriteCloseCapability)(s)||(0,I.hasReadWriteCapability)(s)||(0,I.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(r){const s=await this.withProvider(r);if((0,I.hasOpenReadWriteCloseCapability)(s)||(0,I.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,s){try{return await this.doResolveFile(r,s)}catch(e){throw(0,I.toFileSystemProviderErrorCode)(e)===I.FileSystemProviderErrorCode.FileNotFound?new I.FileOperationError((0,g.localize)(2,null,this.resourceForError(r)),1):(0,I.ensureFileSystemProviderError)(e)}}async doResolveFile(r,s){const e=await this.withProvider(r),i=this.isPathCaseSensitive(e),n=s?.resolveTo,o=s?.resolveSingleChildDescendants,a=s?.resolveMetadata,h=await e.stat(r);let m;return this.toFileStat(e,r,h,void 0,!!a,(N,L)=>(m||(m=u.TernarySearchTree.forUris(()=>!i),m.set(r,!0),(0,d.isNonEmptyArray)(n)&&n.forEach(k=>m.set(k,!0))),Boolean(m.findSuperstr(N.resource)||m.get(N.resource))?!0:N.isDirectory&&o?L===1:!1))}async toFileStat(r,s,e,i,n,o){const{providerExtUri:a}=this.getExtUri(r),h={resource:s,name:a.basename(s),isFile:(e.type&I.FileType.File)!=0,isDirectory:(e.type&I.FileType.Directory)!=0,isSymbolicLink:(e.type&I.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean((e.permissions??0)&I.FilePermission.Readonly)||Boolean(r.capabilities&2048),etag:(0,I.etag)({mtime:e.mtime,size:e.size})};if(h.isDirectory&&o(h,i)){try{const m=await r.readdir(s),N=await F.Promises.settled(m.map(async([L,k])=>{try{const j=a.joinPath(s,L),_=n?await r.stat(j):{type:k};return await this.toFileStat(r,j,_,m.length,n,o)}catch(j){return this.logService.trace(j),null}}));h.children=(0,d.coalesce)(N)}catch(m){this.logService.trace(m),h.children=[]}return h}return h}async resolveAll(r){return F.Promises.settled(r.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(r){const s=await this.withProvider(r);try{return!!await s.stat(r)}catch(e){return!1}}async canCreateFile(r,s){try{await this.doValidateCreateFile(r,s)}catch(e){return e}return!0}async doValidateCreateFile(r,s){if(!s?.overwrite&&await this.exists(r))throw new I.FileOperationError((0,g.localize)(3,null,this.resourceForError(r)),3,s)}async createFile(r,s=p.VSBuffer.fromString(""),e){await this.doValidateCreateFile(r,e);const i=await this.writeFile(r,s);return this._onDidRunOperation.fire(new I.FileOperationEvent(r,0,i)),i}async writeFile(r,s,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,r,e)||await this.mkdirp(i,n.dirname(r));let a;if((0,I.hasReadWriteCapability)(i)&&!(s instanceof p.VSBuffer))if((0,E.isReadableStream)(s)){const h=await(0,E.peekStream)(s,3);h.ended?a=p.VSBuffer.concat(h.buffer):a=h}else a=(0,E.peekReadable)(s,h=>p.VSBuffer.concat(h),3);else a=s;!(0,I.hasOpenReadWriteCloseCapability)(i)||(0,I.hasReadWriteCapability)(i)&&a instanceof p.VSBuffer?await this.doWriteUnbuffered(i,r,e,a):await this.doWriteBuffered(i,r,e,a instanceof p.VSBuffer?(0,p.bufferToReadable)(a):a)}catch(o){throw new I.FileOperationError((0,g.localize)(4,null,this.resourceForError(r),(0,I.ensureFileSystemProviderError)(o).toString()),(0,I.toFileOperationResult)(o),e)}return this.resolve(r,{resolveMetadata:!0})}async validateWriteFile(r,s,e){if(!!e?.unlock&&!(r.capabilities&8192))throw new Error((0,g.localize)(5,null,this.resourceForError(s)));let n;try{n=await r.stat(s)}catch(o){return}if((n.type&I.FileType.Directory)!=0)throw new I.FileOperationError((0,g.localize)(6,null,this.resourceForError(s)),0,e);if(this.throwIfFileIsReadonly(s,n),e&&typeof e.mtime=="number"&&typeof e.etag=="string"&&e.etag!==I.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&e.mtime<n.mtime&&e.etag!==(0,I.etag)({mtime:e.mtime,size:n.size}))throw new I.FileOperationError((0,g.localize)(7,null),3,e);return n}async readFile(r,s){const e=await this.withReadProvider(r);return s?.atomic?this.doReadFileAtomic(e,r,s):this.doReadFile(e,r,s)}async doReadFileAtomic(r,s,e){return new Promise((i,n)=>{this.writeQueue.queueFor(s,this.getExtUri(r).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(r,s,e);i(o)}catch(o){n(o)}})})}async doReadFile(r,s,e){const i=await this.doReadFileStream(r,s,{...e,preferUnbuffered:!0});return{...i,value:await(0,p.streamToBuffer)(i.value)}}async readFileStream(r,s){const e=await this.withReadProvider(r);return this.doReadFileStream(e,r,s)}async doReadFileStream(r,s,e){const i=new c.CancellationTokenSource,n=this.validateReadFile(s,e).then(a=>a,a=>{throw i.cancel(),a});let o;try{return e&&typeof e.etag=="string"&&e.etag!==I.ETAG_DISABLED&&await n,!((0,I.hasOpenReadWriteCloseCapability)(r)||(0,I.hasFileReadStreamCapability)(r))||(0,I.hasReadWriteCapability)(r)&&e?.preferUnbuffered?o=this.readFileUnbuffered(r,s,e):(0,I.hasFileReadStreamCapability)(r)?o=this.readFileStreamed(r,s,i.token,e):o=this.readFileBuffered(r,s,i.token,e),{...await n,value:o}}catch(a){o&&await(0,E.consumeStream)(o);const h=(0,g.localize)(8,null,this.resourceForError(s),(0,I.ensureFileSystemProviderError)(a).toString());throw a instanceof I.NotModifiedSinceFileOperationError?new I.NotModifiedSinceFileOperationError(h,a.stat,e):new I.FileOperationError(h,(0,I.toFileOperationResult)(a),e)}}readFileStreamed(r,s,e,i=Object.create(null)){const n=r.readFileStream(s,i,e);return(0,E.transform)(n,{data:o=>o instanceof p.VSBuffer?o:p.VSBuffer.wrap(o),error:o=>new I.FileOperationError((0,g.localize)(9,null,this.resourceForError(s),(0,I.ensureFileSystemProviderError)(o).toString()),(0,I.toFileOperationResult)(o),i)},o=>p.VSBuffer.concat(o))}readFileBuffered(r,s,e,i=Object.create(null)){const n=(0,p.newWriteableBufferStream)();return(0,P.readFileIntoStream)(r,s,n,o=>o,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new I.FileOperationError((0,g.localize)(10,null,this.resourceForError(s),(0,I.ensureFileSystemProviderError)(o).toString()),(0,I.toFileOperationResult)(o),i)},e),n}readFileUnbuffered(r,s,e){const i=(0,E.newWriteableStream)(n=>p.VSBuffer.concat(n));return(async()=>{try{let n=await r.readFile(s);e&&typeof e.position=="number"&&(n=n.slice(e.position)),e&&typeof e.length=="number"&&(n=n.slice(0,e.length)),this.validateReadFileLimits(s,n.byteLength,e),i.end(p.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(r,s){const e=await this.resolve(r,{resolveMetadata:!0});if(e.isDirectory)throw new I.FileOperationError((0,g.localize)(11,null,this.resourceForError(r)),0,s);if(s&&typeof s.etag=="string"&&s.etag!==I.ETAG_DISABLED&&s.etag===e.etag)throw new I.NotModifiedSinceFileOperationError((0,g.localize)(12,null),e,s);return this.validateReadFileLimits(r,e.size,s),e}validateReadFileLimits(r,s,e){if(e?.limits){let i;if(typeof e.limits.memory=="number"&&s>e.limits.memory&&(i=9),typeof e.limits.size=="number"&&s>e.limits.size&&(i=7),typeof i=="number")throw new I.FileOperationError((0,g.localize)(13,null,this.resourceForError(r)),i)}}async canMove(r,s,e){return this.doCanMoveCopy(r,s,"move",e)}async canCopy(r,s,e){return this.doCanMoveCopy(r,s,"copy",e)}async doCanMoveCopy(r,s,e,i){if(r.toString()!==s.toString())try{const n=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r):await this.withReadProvider(r),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(n,r,o,s,e,i)}catch(n){return n}return!0}async move(r,s,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(i,r,n,s,"move",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new I.FileOperationEvent(r,o==="move"?2:3,a)),a}async copy(r,s,e){const i=await this.withReadProvider(r),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(i,r,n,s,"copy",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new I.FileOperationEvent(r,o==="copy"?3:2,a)),a}async doMoveCopy(r,s,e,i,n,o){if(s.toString()===i.toString())return n;const{exists:a,isSameResourceWithDifferentPathCase:h}=await this.doValidateMoveCopy(r,s,e,i,n,o);if(a&&!h&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i)),n==="copy"){if(r===e&&(0,I.hasFileFolderCopyCapability)(r))await r.copy(s,i,{overwrite:o});else{const m=await this.resolve(s);m.isDirectory?await this.doCopyFolder(r,m,e,i):await this.doCopyFile(r,s,e,i)}return n}else return r===e?(await r.rename(s,i,{overwrite:o}),n):(await this.doMoveCopy(r,s,e,i,"copy",o),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(r,s,e,i){if((0,I.hasOpenReadWriteCloseCapability)(r)&&(0,I.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(r,s,e,i);if((0,I.hasOpenReadWriteCloseCapability)(r)&&(0,I.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(r,s,e,i);if((0,I.hasReadWriteCapability)(r)&&(0,I.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(r,s,e,i);if((0,I.hasReadWriteCapability)(r)&&(0,I.hasReadWriteCapability)(e))return this.doPipeUnbuffered(r,s,e,i)}async doCopyFolder(r,s,e,i){await e.mkdir(i),Array.isArray(s.children)&&await F.Promises.settled(s.children.map(async n=>{const o=this.getExtUri(e).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(r,await this.resolve(n.resource),e,o):this.doCopyFile(r,n.resource,e,o)}))}async doValidateMoveCopy(r,s,e,i,n,o){let a=!1;if(r===e){const{providerExtUri:m,isPathCaseSensitive:N}=this.getExtUri(r);if(N||(a=m.isEqual(s,i)),a&&n==="copy")throw new Error((0,g.localize)(14,null,this.resourceForError(s),this.resourceForError(i)));if(!a&&m.isEqualOrParent(i,s))throw new Error((0,g.localize)(15,null,this.resourceForError(s),this.resourceForError(i)))}const h=await this.exists(i);if(h&&!a){if(!o)throw new I.FileOperationError((0,g.localize)(16,null,this.resourceForError(s),this.resourceForError(i)),4);if(r===e){const{providerExtUri:m}=this.getExtUri(r);if(m.isEqualOrParent(s,i))throw new Error((0,g.localize)(17,null,this.resourceForError(s),this.resourceForError(i)))}}return{exists:h,isSameResourceWithDifferentPathCase:a}}getExtUri(r){const s=this.isPathCaseSensitive(r);return{providerExtUri:s?D.extUri:D.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(r){return!!(r.capabilities&1024)}async createFolder(r){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r);await this.mkdirp(s,r);const e=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new I.FileOperationEvent(r,0,e)),e}async mkdirp(r,s){const e=[],{providerExtUri:i}=this.getExtUri(r);for(;!i.isEqual(s,i.dirname(s));)try{if(((await r.stat(s)).type&I.FileType.Directory)==0)throw new Error((0,g.localize)(18,null,this.resourceForError(s)));break}catch(n){if((0,I.toFileSystemProviderErrorCode)(n)!==I.FileSystemProviderErrorCode.FileNotFound)throw n;e.push(i.basename(s)),s=i.dirname(s)}for(let n=e.length-1;n>=0;n--){s=i.joinPath(s,e[n]);try{await r.mkdir(s)}catch(o){if((0,I.toFileSystemProviderErrorCode)(o)!==I.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(r,s){try{await this.doValidateDelete(r,s)}catch(e){return e}return!0}async doValidateDelete(r,s){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r);if(!!s?.useTrash&&!(e.capabilities&4096))throw new Error((0,g.localize)(19,null,this.resourceForError(r)));let n;try{n=await e.stat(r)}catch(a){}if(n)this.throwIfFileIsReadonly(r,n);else throw new I.FileOperationError((0,g.localize)(20,null,this.resourceForError(r)),1);if(!!!s?.recursive){const a=await this.resolve(r);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,g.localize)(21,null,this.resourceForError(r)))}return e}async del(r,s){const e=await this.doValidateDelete(r,s),i=!!s?.useTrash,n=!!s?.recursive;await e.delete(r,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new I.FileOperationEvent(r,1))}onDidChangeFile(r,s){this._onDidChangeFilesRaw.fire({changes:r});let e,i;{for(const n of r)this.watchedResources.has(n.resource)?(e||(e=[]),e.push(n)):(i||(i=[]),i.push(n));e&&this._onDidFilesChange.fire(new I.FileChangesEvent(e,!s))}if(i){const n=s?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(i)&&Ne.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(r,s={recursive:!1,excludes:[]}){const e=new y.DisposableStore;{let i=!1,n=()=>{i=!0};e.add((0,y.toDisposable)(()=>n())),this.doWatch(r,s).then(o=>{i?(0,y.dispose)(o):n=()=>(0,y.dispose)(o)},o=>this.logService.error(o))}return s.recursive||(this.watchedResources.set(r,(this.watchedResources.get(r)??0)+1),e.add((0,y.toDisposable)(()=>{const i=this.watchedResources.get(r);typeof i=="number"&&(i<=1?this.watchedResources.delete(r):this.watchedResources.set(r,i-1))}))),e}async doWatch(r,s){const e=await this.withProvider(r),i=this.toWatchKey(e,r,s),n=this.activeWatchers.get(i)||{count:0,disposable:e.watch(r,s)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,(0,y.toDisposable)(()=>{n.count--,n.count===0&&((0,y.dispose)(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(r,s,e){const{providerExtUri:i}=this.getExtUri(r);return[i.getComparisonKey(s),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(r=>(0,y.dispose)(r.disposable)),this.activeWatchers.clear()}async doWriteBuffered(r,s,e,i){return this.writeQueue.queueFor(s,this.getExtUri(r).providerExtUri).queue(async()=>{const n=await r.open(s,{create:!0,unlock:e?.unlock??!1});try{(0,E.isReadableStream)(i)||(0,E.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(r,n,i):await this.doWriteReadableBufferedQueued(r,n,i)}catch(o){throw(0,I.ensureFileSystemProviderError)(o)}finally{await r.close(n)}})}async doWriteStreamBufferedQueued(r,s,e){let i=0,n;if((0,E.isReadableBufferedStream)(e)){if(e.buffer.length>0){const o=p.VSBuffer.concat(e.buffer);await this.doWriteBuffer(r,s,o,o.byteLength,i,0),i+=o.byteLength}if(e.ended)return;n=e.stream}else n=e;return new Promise(async(o,a)=>{(0,E.listenStream)(n,{onData:async h=>{n.pause();try{await this.doWriteBuffer(r,s,h,h.byteLength,i,0)}catch(m){return a(m)}i+=h.byteLength,setTimeout(()=>n.resume())},onError:h=>a(h),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(r,s,e){let i=0,n;for(;(n=e.read())!==null;)await this.doWriteBuffer(r,s,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(r,s,e,i,n,o){let a=0;for(;a<i;)a+=await r.write(s,n+a,e.buffer,o+a,i-a)}async doWriteUnbuffered(r,s,e,i){return this.writeQueue.queueFor(s,this.getExtUri(r).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(r,s,e,i))}async doWriteUnbufferedQueued(r,s,e,i){let n;i instanceof p.VSBuffer?n=i:(0,E.isReadableStream)(i)?n=await(0,p.streamToBuffer)(i):(0,E.isReadableBufferedStream)(i)?n=await(0,p.bufferedStreamToBuffer)(i):n=(0,p.readableToBuffer)(i),await r.writeFile(s,n.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1})}async doPipeBuffered(r,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(r,s,e,i))}async doPipeBufferedQueued(r,s,e,i){let n,o;try{n=await r.open(s,{create:!1}),o=await e.open(i,{create:!0,unlock:!1});const a=p.VSBuffer.alloc(this.BUFFER_SIZE);let h=0,m=0,N=0;do N=await r.read(n,h,a.buffer,m,a.byteLength-m),await this.doWriteBuffer(e,o,a,N,h,m),h+=N,m+=N,m===a.byteLength&&(m=0);while(N>0)}catch(a){throw(0,I.ensureFileSystemProviderError)(a)}finally{await F.Promises.settled([typeof n=="number"?r.close(n):Promise.resolve(),typeof o=="number"?e.close(o):Promise.resolve()])}}async doPipeUnbuffered(r,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(r,s,e,i))}async doPipeUnbufferedQueued(r,s,e,i){return e.writeFile(i,await r.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(r,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(r,s,e,i))}async doPipeUnbufferedToBufferedQueued(r,s,e,i){const n=await e.open(i,{create:!0,unlock:!1});try{const o=await r.readFile(s);await this.doWriteBuffer(e,n,p.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,I.ensureFileSystemProviderError)(o)}finally{await e.close(n)}}async doPipeBufferedToUnbuffered(r,s,e,i){const n=await(0,p.streamToBuffer)(this.readFileBuffered(r,s,c.CancellationToken.None));await this.doWriteUnbuffered(e,i,void 0,n)}throwIfFileSystemIsReadonly(r,s){if(r.capabilities&2048)throw new I.FileOperationError((0,g.localize)(22,null,this.resourceForError(s)),6);return r}throwIfFileIsReadonly(r,s){if((s.permissions??0)&I.FilePermission.Readonly)throw new I.FileOperationError((0,g.localize)(23,null,this.resourceForError(r)),6)}resourceForError(r){return r.scheme===f.Schemas.file?r.fsPath:r.toString(!0)}};w.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},w=ue([fe(0,v.ILogService)],w),t.FileService=w}),define(Y[108],ee([0,1,2,17,13,15,10,3,20,37,4,14,83,51,92,94,91,100,36,54,24,16]),function(G,t,g,T,y,I,C,D,u,d,v,p,E,F,c,f,P,S,w,l,r,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class e extends g.Disposable{constructor(n,o){super();this.logService=n,this.options=o,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=y.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new y.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new y.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new v.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,I.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:o,symbolicLink:a}=await C.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(o,a),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.toFileSystemProviderError(o)}}async readdir(n){try{const o=await C.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),a=[];return await Promise.all(o.map(async h=>{try{let m;h.isSymbolicLink()?m=(await this.stat((0,u.joinPath)(n,h.name))).type:m=this.toType(h),a.push([h.name,m])}catch(m){this.logService.trace(m)}})),a}catch(o){throw this.toFileSystemProviderError(o)}}toType(n,o){let a;return o?.dangling?a=T.FileType.Unknown:n.isFile()?a=T.FileType.File:n.isDirectory()?a=T.FileType.Directory:a=T.FileType.Unknown,o&&(a|=T.FileType.SymbolicLink),a}async readFile(n){try{const o=this.toFilePath(n);return await C.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}}readFileStream(n,o,a){const h=(0,w.newWriteableStream)(m=>s.VSBuffer.concat(m.map(N=>s.VSBuffer.wrap(N))).buffer);return(0,l.readFileIntoStream)(this,n,h,m=>m.buffer,{...o,bufferSize:this.BUFFER_SIZE},a),h}async writeFile(n,o,a){let h;try{const m=this.toFilePath(n);if(!a.create||!a.overwrite){if(await C.Promises.exists(m)){if(!a.overwrite)throw(0,T.createFileSystemProviderError)((0,E.localize)(0,null),T.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,T.createFileSystemProviderError)((0,E.localize)(1,null),T.FileSystemProviderErrorCode.FileNotFound)}h=await this.open(n,{create:!0,unlock:a.unlock}),await this.write(h,0,o,0,o.byteLength)}catch(m){throw await this.toFileSystemProviderWriteError(n,m)}finally{typeof h=="number"&&await this.close(h)}}async open(n,o){try{const a=this.toFilePath(n);if((0,T.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:N}=await C.SymlinkSupport.stat(a);N.mode&128||await C.Promises.chmod(a,N.mode|128)}catch(N){this.logService.trace(N)}let h;if((0,T.isFileOpenForWriteOptions)(o)){if(I.isWindows)try{await C.Promises.truncate(a,0),h="r+"}catch(N){N.code!=="ENOENT"&&this.logService.trace(N)}h||(h="w")}else h="r";const m=await C.Promises.open(a,h);return this.mapHandleToPos.set(m,0),(0,T.isFileOpenForWriteOptions)(o)&&this.writeHandles.set(m,n),m}catch(a){throw(0,T.isFileOpenForWriteOptions)(o)?await this.toFileSystemProviderWriteError(n,a):this.toFileSystemProviderError(a)}}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await C.Promises.fdatasync(n)}catch(o){this.canFlush=!1,this.logService.error(o)}return await C.Promises.close(n)}catch(o){throw this.toFileSystemProviderError(o)}}async read(n,o,a,h,m){const N=this.normalizePos(n,o);let L=null;try{const k=await C.Promises.read(n,a,h,m,N);return typeof k=="number"?L=k:L=k.bytesRead,L}catch(k){throw this.toFileSystemProviderError(k)}finally{this.updatePos(n,N,L)}}normalizePos(n,o){return o===this.mapHandleToPos.get(n)?null:o}updatePos(n,o,a){const h=this.mapHandleToPos.get(n);typeof h=="number"&&(typeof o=="number"||(typeof a=="number"?this.mapHandleToPos.set(n,h+a):this.mapHandleToPos.delete(n)))}async write(n,o,a,h,m){return(0,v.retry)(()=>this.doWrite(n,o,a,h,m),100,3)}async doWrite(n,o,a,h,m){const N=this.normalizePos(n,o);let L=null;try{const k=await C.Promises.write(n,a,h,m,N);return typeof k=="number"?L=k:L=k.bytesWritten,L}catch(k){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),k)}finally{this.updatePos(n,N,L)}}async mkdir(n){try{await C.Promises.mkdir(this.toFilePath(n))}catch(o){throw this.toFileSystemProviderError(o)}}async delete(n,o){try{const a=this.toFilePath(n);await this.doDelete(a,o)}catch(a){throw this.toFileSystemProviderError(a)}}async doDelete(n,o){o.recursive?await C.Promises.rm(n,C.RimRafMode.MOVE):await C.Promises.unlink(n)}async rename(n,o,a){const h=this.toFilePath(n),m=this.toFilePath(o);if(h!==m)try{await this.validateTargetDeleted(n,o,"move",a.overwrite),await C.Promises.move(h,m)}catch(N){throw(N.code==="EINVAL"||N.code==="EBUSY"||N.code==="ENAMETOOLONG")&&(N=new Error((0,E.localize)(2,null,(0,D.basename)(h),(0,D.basename)((0,D.dirname)(m)),N.toString()))),this.toFileSystemProviderError(N)}}async copy(n,o,a){const h=this.toFilePath(n),m=this.toFilePath(o);if(h!==m)try{await this.validateTargetDeleted(n,o,"copy",a.overwrite),await C.Promises.copy(h,m,{preserveSymlinks:!0})}catch(N){throw(N.code==="EINVAL"||N.code==="EBUSY"||N.code==="ENAMETOOLONG")&&(N=new Error((0,E.localize)(3,null,(0,D.basename)(h),(0,D.basename)((0,D.dirname)(m)),N.toString()))),this.toFileSystemProviderError(N)}}async validateTargetDeleted(n,o,a,h){const m=this.toFilePath(n),N=this.toFilePath(o);let L=!1;if(!!(this.capabilities&1024)||(L=(0,d.isEqual)(m,N,!0)),L&&a==="copy")throw(0,T.createFileSystemProviderError)((0,E.localize)(4,null),T.FileSystemProviderErrorCode.FileExists);if(!L&&await C.Promises.exists(N)){if(!h)throw(0,T.createFileSystemProviderError)((0,E.localize)(5,null),T.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}watch(n,o){return o.recursive?this.watchRecursive(n,o.excludes):this.watchNonRecursive(n)}watchRecursive(n,o){const a={path:this.toFilePath(n),excludes:o},h=(0,r.insert)(this.recursiveFoldersToWatch,a);return this.refreshRecursiveWatchers(),(0,g.toDisposable)(()=>{h(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof P.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,g.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let n,o;this.options?.watcher?.usePolling?(n=c.FileWatcher,o=this.options?.watcher):this.recursiveFoldersToWatch.length===1?I.isWindows?n=f.FileWatcher:n=c.FileWatcher:n=P.FileWatcher,this.recursiveWatcher=new n(this.recursiveFoldersToWatch,a=>this._onDidChangeFile.fire((0,F.toFileChanges)(a)),a=>{a.type==="error"&&this._onDidWatchErrorOccur.fire(a.message),this.logService[a.type](a.message)},this.logService.getLevel()===p.LogLevel.Trace,o),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)}))}}watchNonRecursive(n){const o=new S.FileWatcher(this.toFilePath(n),h=>this._onDidChangeFile.fire((0,F.toFileChanges)(h)),h=>{h.type==="error"&&this._onDidWatchErrorOccur.fire(h.message),this.logService[h.type](h.message)},this.logService.getLevel()===p.LogLevel.Trace),a=this.logService.onDidChangeLogLevel(()=>{o.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)});return(0,g.combinedDisposable)(o,a)}toFilePath(n){return(0,D.normalize)(n.fsPath)}toFileSystemProviderError(n){if(n instanceof T.FileSystemProviderError)return n;let o;switch(n.code){case"ENOENT":o=T.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=T.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=T.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=T.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=T.FileSystemProviderErrorCode.NoPermissions;break;default:o=T.FileSystemProviderErrorCode.Unknown}return(0,T.createFileSystemProviderError)(n,o)}async toFileSystemProviderWriteError(n,o){let a=this.toFileSystemProviderError(o);if(n&&a.code===T.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await C.SymlinkSupport.stat(this.toFilePath(n));h.mode&128||(a=(0,T.createFileSystemProviderError)(o,T.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.logService.trace(h)}return a}dispose(){super.dispose(),(0,g.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,g.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=e}),define(Y[42],ee([0,1,11]),function(G,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,g.createDecorator)("productService")}),define(Y[25],ee([0,1,12,57]),function(G,t,g,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class y{constructor(){this.data=new Map}add(C,D){T.ok(g.isString(C)),T.ok(g.isObject(D)),T.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,D)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}t.Registry=new y}),define(Y[109],ee([0,1,25,13]),function(G,t,g,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function y(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class I{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(u,d){this.schemasById[y(u)]=d,this._onDidChangeSchema.fire(u)}notifySchemaChanged(u){this._onDidChangeSchema.fire(u)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new I;g.Registry.add(t.Extensions.JSONContribution,C)}),define(Y[30],ee([0,1,73,13,25,12,109]),function(G,t,g,T,y,I,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var D;(function(S){S.Multiline="multilineText",S.Singleline="singlelineText"})(D=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var u;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(u=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const d=y.Registry.as(C.Extensions.JSONContribution);class v{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:g.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},d.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,l=!0){this.registerConfigurations([w],l)}registerConfigurations(w,l=!0){const r=[];w.forEach(s=>{r.push(...this.validateAndRegisterProperties(s,l,s.extensionInfo)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),d.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(r)}deregisterConfigurations(w){const l=[],r=s=>{if(s.properties)for(const e in s.properties)l.push(e),delete this.configurationProperties[e],this.removeFromSchema(e,s.properties[e]);s.allOf&&s.allOf.forEach(e=>r(e))};for(const s of w){r(s);const e=this.configurationContributors.indexOf(s);e!==-1&&this.configurationContributors.splice(e,1)}d.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}registerDefaultConfigurations(w){const l=[],r=[];for(const s of w)for(const e in s)if(l.push(e),t.OVERRIDE_PROPERTY_PATTERN.test(e)){this.defaultValues[e]={...this.defaultValues[e]||{},...s[e]};const i={type:"object",default:this.defaultValues[e],description:g.localize(1,null,e),$ref:t.resourceLanguageSettingsSchemaId};r.push(E(e)),this.configurationProperties[e]=i,this.defaultLanguageConfigurationOverridesNode.properties[e]=i}else{this.defaultValues[e]=s[e];const i=this.configurationProperties[e];i&&(this.updatePropertyDefaultValue(e,i),this.updateSchema(e,i))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterDefaultConfigurations(w){const l=[];for(const r of w)for(const s in r)if(l.push(s),delete this.defaultValues[s],t.OVERRIDE_PROPERTY_PATTERN.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const e=this.configurationProperties[s];e&&(this.updatePropertyDefaultValue(s,e),this.updateSchema(s,e))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const l of w)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,l=!0,r,s=3){s=I.isUndefinedOrNull(w.scope)?s:w.scope;let e=[],i=w.properties;if(i)for(let o in i){if(l&&f(o)){delete i[o];continue}const a=i[o];if(this.updatePropertyDefaultValue(o,a),t.OVERRIDE_PROPERTY_PATTERN.test(o)?a.scope=void 0:(a.scope=I.isUndefinedOrNull(a.scope)?s:a.scope,a.restricted=I.isUndefinedOrNull(a.restricted)?!!r?.restrictedConfigurations?.includes(o):a.restricted),i[o].hasOwnProperty("included")&&!i[o].included){this.excludedConfigurationProperties[o]=i[o],delete i[o];continue}else this.configurationProperties[o]=i[o];!i[o].deprecationMessage&&i[o].markdownDeprecationMessage&&(i[o].deprecationMessage=i[o].markdownDeprecationMessage),e.push(o)}let n=w.allOf;if(n)for(let o of n)e.push(...this.validateAndRegisterProperties(o,l,r,s));return e}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const l=r=>{let s=r.properties;if(s)for(const i in s)this.updateSchema(i,s[i]);let e=r.allOf;e&&e.forEach(l)};l(w)}updateSchema(w,l){switch(t.allSettings.properties[w]=l,l.scope){case 1:t.applicationSettings.properties[w]=l;break;case 2:t.machineSettings.properties[w]=l;break;case 6:t.machineOverridableSettings.properties[w]=l;break;case 3:t.windowSettings.properties[w]=l;break;case 4:t.resourceSettings.properties[w]=l;break;case 5:t.resourceSettings.properties[w]=l,this.resourceLanguageSettingsSchema.properties[w]=l;break}}removeFromSchema(w,l){switch(delete t.allSettings.properties[w],l.scope){case 1:delete t.applicationSettings.properties[w];break;case 2:delete t.machineSettings.properties[w];break;case 6:delete t.machineOverridableSettings.properties[w];break;case 3:delete t.windowSettings.properties[w];break;case 4:case 5:delete t.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const l=`[${w}]`,r={type:"object",description:g.localize(2,null),errorMessage:g.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,r),t.allSettings.properties[l]=r,t.applicationSettings.properties[l]=r,t.machineSettings.properties[l]=r,t.machineOverridableSettings.properties[l]=r,t.windowSettings.properties[l]=r,t.resourceSettings.properties[l]=r}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,l){let r=this.defaultValues[w];I.isUndefined(r)&&(r=l.default),I.isUndefined(r)&&(r=F(l.type)),l.default=r}}const p="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(p);function E(S){return S.substring(1,S.length-1)}t.overrideIdentifierFromKey=E;function F(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=F;const c=new v;y.Registry.add(t.Extensions.Configuration,c);function f(S){return S.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(S)?g.localize(5,null,S):c.getConfigurationProperties()[S]!==void 0?g.localize(6,null,S):null:g.localize(4,null)}t.validateProperty=f;function P(){const S=[],w=c.getConfigurationProperties();for(const l of Object.keys(w))S.push([l,w[l].scope]);return S.push(["launch",4]),S.push(["task",4]),S}t.getScopes=P}),define(Y[27],ee([0,1,19,12,7,25,11,30]),function(G,t,g,T,y,I,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,C.createDecorator)("configurationService");function u(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof y.URI)}t.isConfigurationOverrides=u;var d;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(d=t.ConfigurationTarget||(t.ConfigurationTarget={}));function v(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=v;function p(i,n){const o=n?i?n.keys.filter(j=>i.keys.indexOf(j)===-1):[...n.keys]:[],a=i?n?i.keys.filter(j=>n.keys.indexOf(j)===-1):[...i.keys]:[],h=[];if(n&&i){for(const j of i.keys)if(n.keys.indexOf(j)!==-1){const _=S(i.contents,j),Q=S(n.contents,j);g.equals(_,Q)||h.push(j)}}const m=[],N=j=>{const _={};for(const Q of j)for(const ne of Q.identifiers)_[s(ne)]=Q;return _},L=n?N(n.overrides):{},k=i?N(i.overrides):{};if(Object.keys(L).length)for(const j of o){const _=L[j];_&&m.push([(0,D.overrideIdentifierFromKey)(j),_.keys])}if(Object.keys(k).length)for(const j of a){const _=k[j];_&&m.push([(0,D.overrideIdentifierFromKey)(j),_.keys])}if(Object.keys(L).length&&Object.keys(k).length)for(const j of h){const _=k[j],Q=L[j];if(_&&Q){const ne=p({contents:_.contents,keys:_.keys,overrides:[]},{contents:Q.contents,keys:Q.keys,overrides:[]});m.push([(0,D.overrideIdentifierFromKey)(j),[...ne.added,...ne.removed,...ne.updated]])}}return{added:o,removed:a,updated:h,overrides:m}}t.compare=p;function E(i,n){const o=[];for(const a of Object.keys(i))if(D.OVERRIDE_PROPERTY_PATTERN.test(a)){const h={};for(const m in i[a])h[m]=i[a][m];o.push({identifiers:[(0,D.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(h),contents:F(h,n)})}return o}t.toOverrides=E;function F(i,n){const o=Object.create(null);for(let a in i)c(o,a,i[a],n);return o}t.toValuesTree=F;function c(i,n,o,a){const h=n.split("."),m=h.pop();let N=i;for(let L=0;L<h.length;L++){let k=h[L],j=N[k];switch(typeof j){case"undefined":j=N[k]=Object.create(null);break;case"object":break;default:a(`Ignoring ${n} as ${h.slice(0,L+1).join(".")} is ${JSON.stringify(j)}`);return}N=j}if(typeof N=="object"&&N!==null)try{N[m]=o}catch(L){a(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(N)}`)}else a(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(N)}`)}t.addToValueTree=c;function f(i,n){const o=n.split(".");P(i,o)}t.removeFromValueTree=f;function P(i,n){const o=n.shift();if(n.length===0){delete i[o];return}if(Object.keys(i).indexOf(o)!==-1){const a=i[o];typeof a=="object"&&!Array.isArray(a)&&(P(a,n),Object.keys(a).length===0&&delete i[o])}}function S(i,n,o){function a(N,L){let k=N;for(const j of L){if(typeof k!="object"||k===null)return;k=k[j]}return k}const h=n.split("."),m=a(i,h);return typeof m=="undefined"?o:m}t.getConfigurationValue=S;function w(i,n,o){Object.keys(n).forEach(a=>{a!=="__proto__"&&(a in i?T.isObject(i[a])&&T.isObject(n[a])?w(i[a],n[a],o):o&&(i[a]=n[a]):i[a]=n[a])})}t.merge=w;function l(){const i=I.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}t.getConfigurationKeys=l;function r(){const i=Object.create(null),n=I.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let o in n){let a=n[o].default;c(i,o,a,h=>console.error(`Conflict in default settings: ${h}`))}return i}t.getDefaultValues=r;function s(i){return`[${i}]`}t.keyFromOverrideIdentifier=s;function e(i,n,o){const a=i.inspect(n),h=i.inspect(o);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:a.defaultValue}t.getMigratedSettingValue=e}),define(Y[110],ee([0,1,58,45,24,12,19,7,30,27,25,2,13]),function(G,t,g,T,y,I,C,D,u,d,v,p,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class F{constructor(e={},i=[],n=[]){this._contents=e,this._keys=i,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,d.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,i){const n=this.getContentsForOverrideIdentifer(i);return n?e?(0,d.getConfigurationValue)(n,e):n:void 0}getKeysForOverrideIdentifier(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.keys;return[]}override(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const o of y.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[o],h=i[o];h&&(typeof a=="object"&&typeof h=="object"?(a=C.deepClone(a),this.mergeContents(a,h)):a=h),n[o]=a}return new F(n,this.keys,this.overrides)}merge(...e){const i=C.deepClone(this.contents),n=C.deepClone(this.overrides),o=[...this.keys];for(const a of e){this.mergeContents(i,a.contents);for(const h of a.overrides){const[m]=n.filter(N=>y.equals(N.identifiers,h.identifiers));m?this.mergeContents(m.contents,h.contents):n.push(C.deepClone(h))}for(const h of a.keys)o.indexOf(h)===-1&&o.push(h)}return new F(i,o,n)}freeze(){return this.isFrozen=!0,this}mergeContents(e,i){for(const n of Object.keys(i)){if(n in e&&I.isObject(e[n])&&I.isObject(i[n])){this.mergeContents(e[n],i[n]);continue}e[n]=C.deepClone(i[n])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?C.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),(0,d.addToValueTree)(this.contents,e,i,n=>{throw new Error(n)})}removeValue(e){this.removeKey(e)&&(0,d.removeFromValueTree)(this.contents,e)}addKey(e){let i=this.keys.length;for(let n=0;n<i;n++)e.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=F;class c extends F{constructor(){const e=(0,d.getDefaultValues)(),i=(0,d.getConfigurationKeys)(),n=[];for(const o of Object.keys(e))u.OVERRIDE_PROPERTY_PATTERN.test(o)&&n.push({identifiers:[(0,u.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(e[o]),contents:(0,d.toValuesTree)(e[o],a=>console.error(`Conflict in default settings file: ${a}`))});super(e,i,n)}}t.DefaultConfigurationModel=c;class f{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new F}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!I.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:n,keys:o,overrides:a,restricted:h}=this.doParseRaw(e,i);this._configurationModel=new F(n,o,a),this._restrictedConfigurations=h||[]}doParseContent(e){let i={},n=null,o=[],a=[],h=[];function m(L){Array.isArray(o)?o.push(L):n&&(o[n]=L)}let N={onObjectBegin:()=>{let L={};m(L),a.push(o),o=L,n=null},onObjectProperty:L=>{n=L},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{let L=[];m(L),a.push(o),o=L,n=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:m,onError:(L,k,j)=>{h.push({error:L,offset:k,length:j})}};if(e)try{g.visit(e,N),i=o[0]||{}}catch(L){console.error(`Error while parsing settings file ${this._name}: ${L}`),this._parseErrors=[L]}return i}doParseRaw(e,i){const n=v.Registry.as(u.Extensions.Configuration).getConfigurationProperties(),o=this.filter(e,n,!0,i);e=o.raw;const a=(0,d.toValuesTree)(e,N=>console.error(`Conflict in settings file ${this._name}: ${N}`)),h=Object.keys(e),m=(0,d.toOverrides)(e,N=>console.error(`Conflict in settings file ${this._name}: ${N}`));return{contents:a,keys:h,overrides:m,restricted:o.restricted}}filter(e,i,n,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:e,restricted:[]};const a={},h=[];for(let m in e)if(u.OVERRIDE_PROPERTY_PATTERN.test(m)&&n){const N=this.filter(e[m],i,!1,o);a[m]=N.raw,h.push(...N.restricted)}else{const N=i[m],L=N?typeof N.scope!="undefined"?N.scope:3:void 0;N?.restricted&&h.push(m),(L===void 0||o.scopes===void 0||o.scopes.includes(L))&&(o.skipRestricted&&N?.restricted||(a[m]=e[m]))}return{raw:a,restricted:h}}}t.ConfigurationModelParser=f;class P extends p.Disposable{constructor(e,i,n,o){super();this.userSettingsResource=e,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(E.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new F}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=P;class S{constructor(e,i,n=new F,o=new F,a=new T.ResourceMap,h=new F,m=new T.ResourceMap,N=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=o,this._folderConfigurations=a,this._memoryConfiguration=h,this._memoryConfigurationByResource=m,this._freeze=N,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(e,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(e)}updateValue(e,i,n={}){let o;n.resource?(o=this._memoryConfigurationByResource.get(n.resource),o||(o=new F,this._memoryConfigurationByResource.set(n.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(e):o.setValue(e,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,n){const o=this.getConsolidateConfigurationModel(i,n),a=this.getFolderConfigurationModelForResource(i.resource,n),h=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,m=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),N=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),L=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),k=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),j=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,_=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(e):a.freeze().getValue(e):void 0,Q=i.overrideIdentifier?h.override(i.overrideIdentifier).getValue(e):h.getValue(e),ne=o.getValue(e),re=y.distinct(y.flatten(o.overrides.map(Z=>Z.identifiers))).filter(Z=>o.getOverrideValue(e,Z)!==void 0);return{defaultValue:m,userValue:N,userLocalValue:L,userRemoteValue:k,workspaceValue:j,workspaceFolderValue:_,memoryValue:Q,value:ne,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:N!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:L!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:k!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:j!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:_!==void 0?{value:a?.freeze().getValue(e),override:i.overrideIdentifier?a?.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:Q!==void 0?{value:h.getValue(e),override:i.overrideIdentifier?h.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:re.length?re:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const n=i.filter(o=>u.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const a=(0,u.overrideIdentifierFromKey)(o),h=this._defaultConfiguration.getKeysForOverrideIdentifier(a),m=e.getKeysForOverrideIdentifier(a),N=[...m.filter(L=>h.indexOf(L)===-1),...h.filter(L=>m.indexOf(L)===-1),...h.filter(L=>!C.equals(this._defaultConfiguration.override(a).getValue(L),e.override(a).getValue(L)))];return[a,N]});return this.updateDefaultConfiguration(e),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:n,removed:o,overrides:a}=(0,d.compare)(this.localUserConfiguration,e),h=[...i,...n,...o];return h.length&&this.updateLocalUserConfiguration(e),{keys:h,overrides:a}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:n,removed:o,overrides:a}=(0,d.compare)(this.remoteUserConfiguration,e);let h=[...i,...n,...o];return h.length&&this.updateRemoteUserConfiguration(e),{keys:h,overrides:a}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:n,removed:o,overrides:a}=(0,d.compare)(this.workspaceConfiguration,e);let h=[...i,...n,...o];return h.length&&this.updateWorkspaceConfiguration(e),{keys:h,overrides:a}}compareAndUpdateFolderConfiguration(e,i){const n=this.folderConfigurations.get(e),{added:o,updated:a,removed:h,overrides:m}=(0,d.compare)(n,i);let N=[...o,...a,...h];return(N.length||!n)&&this.updateFolderConfiguration(e,i),{keys:N,overrides:m}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:n,updated:o,removed:a,overrides:h}=(0,d.compare)(i,void 0);return{keys:[...n,...o,...a],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let n=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?n.override(e.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:e},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const o=i.getFolder(e);o&&(n=this.getFolderConsolidatedConfiguration(o.uri)||n);const a=this._memoryConfigurationByResource.get(e);a&&(n=n.merge(a))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(e);o?(i=n.merge(o),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=n}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const n=i.getFolder(e);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:n,overrides:o,keys:a}=this._folderConfigurations.get(i);return e.push([i,{contents:n,overrides:o,keys:a}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>e.add(n))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(e).forEach(o=>i.add(o))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),n=this.parseConfigurationModel(e.user),o=this.parseConfigurationModel(e.workspace),a=e.folders.reduce((h,m)=>(h.set(D.URI.revive(m[0]),this.parseConfigurationModel(m[1])),h),new T.ResourceMap);return new S(i,n,new F,o,a,new F,new T.ResourceMap,!1)}static parseConfigurationModel(e){return new F(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=S;function w(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const e=new Set,i=new Map;for(const o of s)o.keys.forEach(a=>e.add(a)),o.overrides.forEach(([a,h])=>{const m=(0,T.getOrSet)(i,a,new Set);h.forEach(N=>m.add(N))});const n=[];return i.forEach((o,a)=>n.push([a,[...o.values()]])),{keys:[...e.values()],overrides:n}}t.mergeChanges=w;class l{constructor(e,i,n,o){this.change=e,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=o,this._previousConfiguration=void 0;const a=new Set;e.keys.forEach(m=>a.add(m)),e.overrides.forEach(([,m])=>m.forEach(N=>a.add(N))),this.affectedKeys=[...a.values()];const h=new F;this.affectedKeys.forEach(m=>h.setValue(m,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=S.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(e,i,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!C.equals(n,o)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let n=(0,d.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof n=="object"&&(o=Object.keys(n)[0]);){if(e=e[o],!e)return!1;n=n[o]}return!0}}t.ConfigurationChangeEvent=l;class r extends l{constructor(e,i,n,o){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=n,this.sourceConfig=o}}t.AllKeysConfigurationChangeEvent=r}),define(Y[111],ee([0,1,25,30,2,27,110,13,4,20]),function(G,t,g,T,y,I,C,D,u,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class v extends y.Disposable{constructor(E,F){super();this.settingsResource=E,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new C.UserSettings(this.settingsResource,void 0,d.extUriBiasedIgnorePathCase,F)),this.configuration=new C.Configuration(new C.DefaultConfigurationModel,new C.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new u.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(g.Registry.as(T.Extensions.Configuration).onDidUpdateConfiguration(c=>this.onDidDefaultConfigurationChange(c))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const E=await this.userConfiguration.loadConfiguration();this.configuration=new C.Configuration(new C.DefaultConfigurationModel,E)}getConfigurationData(){return this.configuration.toData()}getValue(E,F){const c=typeof E=="string"?E:void 0,f=(0,I.isConfigurationOverrides)(E)?E:(0,I.isConfigurationOverrides)(F)?F:{};return this.configuration.getValue(c,f,void 0)}updateValue(E,F,c,f){return Promise.reject(new Error("not supported"))}inspect(E){return this.configuration.inspect(E,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const E=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(E)}onDidChangeUserConfiguration(E){const F=this.configuration.toData(),c=this.configuration.compareAndUpdateLocalUserConfiguration(E);this.trigger(c,F,1)}onDidDefaultConfigurationChange(E){const F=this.configuration.toData(),c=this.configuration.compareAndUpdateDefaultConfiguration(new C.DefaultConfigurationModel,E);this.trigger(c,F,6)}trigger(E,F,c){const f=new C.ConfigurationChangeEvent(E,{data:F},this.configuration);f.source=c,f.sourceConfig=this.getTargetConfiguration(c),this._onDidChangeConfiguration.fire(f)}getTargetConfiguration(E){switch(E){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=v}),define(Y[55],ee([0,1,84,11,30,25,16]),function(G,t,g,T,y,I,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,T.createDecorator)("requestService");function D(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}t.isSuccess=D;function u(c){return c.res.statusCode===204}async function d(c){if(!D(c))throw new Error("Server returned "+c.res.statusCode);return u(c)?null:(await(0,C.streamToBuffer)(c.stream)).toString()}t.asText=d;async function v(c){if(!D(c))throw new Error("Server returned "+c.res.statusCode);if(u(c))return null;const P=(await(0,C.streamToBuffer)(c.stream)).toString();try{return JSON.parse(P)}catch(S){throw S.message+=`:
`+P,S}}t.asJson=v;function p(c){F(c)}t.updateProxyConfigurationsScope=p;let E;function F(c){const f=I.Registry.as(y.Extensions.Configuration);E&&f.deregisterConfigurations([E]),E={id:"http",order:15,title:(0,g.localize)(0,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,g.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,g.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,g.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,g.localize)(4,null),(0,g.localize)(5,null),(0,g.localize)(6,null),(0,g.localize)(7,null)],default:"override",description:(0,g.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,g.localize)(9,null),restricted:!0}}},f.registerConfiguration(E)}F(2)}),define(Y[112],ee([0,1,113,12]),function(G,t,g,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function y(C,D){return C.protocol==="http:"?D.HTTP_PROXY||D.http_proxy||null:C.protocol==="https:"&&(D.HTTPS_PROXY||D.https_proxy||D.HTTP_PROXY||D.http_proxy)||null}async function I(C,D,u={}){const d=(0,g.parse)(C),v=u.proxyUrl||y(d,D);if(!v)return null;const p=(0,g.parse)(v);if(!/^https?:$/.test(p.protocol||""))return null;const E={host:p.hostname||"",port:p.port||(p.protocol==="https"?"443":"80"),auth:p.auth,rejectUnauthorized:(0,T.isBoolean)(u.strictSSL)?u.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((F,c)=>{G(["http-proxy-agent"],F,c)}))(E):new(await new Promise((F,c)=>{G(["https-proxy-agent"],F,c)}))(E)}t.getProxyAgent=I}),define(Y[114],ee([0,1,29,16]),function(G,t,g,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function y(I,C,D){let u=D&&D.get("storage.serviceMachineId",0)||null;if(u)return u;try{const v=(await C.readFile(I.serviceMachineIdResource)).value.toString();u=(0,g.isUUID)(v)?v:null}catch(d){u=null}if(!u){u=(0,g.generateUuid)();try{await C.writeFile(I.serviceMachineIdResource,T.VSBuffer.fromString(u))}catch(d){}}return D&&D.store("storage.serviceMachineId",u,0,1),u}t.getServiceMachineId=y}),define(Y[115],ee([0,1,11,13,2,12,66,4]),function(G,t,g,T,y,I,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const u="__$__targetStorageMarker";t.IStorageService=(0,g.createDecorator)("storageService");var d;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(d=t.WillSaveStateReason||(t.WillSaveStateReason={}));var v;(function(f){f[f.GLOBAL=0]="GLOBAL",f[f.WORKSPACE=1]="WORKSPACE"})(v=t.StorageScope||(t.StorageScope={}));var p;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(p=t.StorageTarget||(t.StorageTarget={}));class E extends y.Disposable{constructor(P={flushInterval:E.DEFAULT_FLUSH_INTERVAL}){super();this.options=P,this._onDidChangeValue=this._register(new T.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new T.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new T.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new y.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,y.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(P,S){S===u?(P===0?this._globalKeyTargets=void 0:P===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:P})):this._onDidChangeValue.fire({scope:P,key:S,target:this.getKeyTargets(P)[S]})}emitWillSaveState(P){this._onWillSaveState.fire({reason:P})}get(P,S,w){return this.getStorage(S)?.get(P,w)}getBoolean(P,S,w){return this.getStorage(S)?.getBoolean(P,w)}getNumber(P,S,w){return this.getStorage(S)?.getNumber(P,w)}store(P,S,w,l){if((0,I.isUndefinedOrNull)(S)){this.remove(P,w);return}this.withPausedEmitters(()=>{this.updateKeyTarget(P,w,l),this.getStorage(w)?.set(P,S)})}remove(P,S){this.withPausedEmitters(()=>{this.updateKeyTarget(P,S,void 0),this.getStorage(S)?.delete(P)})}withPausedEmitters(P){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{P()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(P,S){const w=[],l=this.getKeyTargets(P);for(const r of Object.keys(l))l[r]===S&&w.push(r);return w}updateKeyTarget(P,S,w){const l=this.getKeyTargets(S);typeof w=="number"?l[P]!==w&&(l[P]=w,this.getStorage(S)?.set(u,JSON.stringify(l))):typeof l[P]=="number"&&(delete l[P],this.getStorage(S)?.set(u,JSON.stringify(l)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(P){return P===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(P){const S=this.get(u,P);if(S)try{return JSON.parse(S)}catch(w){}return Object.create(null)}isNew(P){return this.getBoolean(t.IS_NEW_KEY,P)===!0}async flush(){this._onWillSaveState.fire({reason:d.NONE}),await D.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const P=this.getStorage(0)?.items??new Map,S=this.getStorage(1)?.items??new Map;return c(P,S,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=E,E.DEFAULT_FLUSH_INTERVAL=60*1e3;class F extends E{constructor(){super();this.globalStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(P=>this.emitDidChangeValue(1,P))),this._register(this.globalStorage.onDidChangeStorage(P=>this.emitDidChangeValue(0,P)))}getStorage(P){return P===0?this.globalStorage:this.workspaceStorage}getLogDetails(P){return P===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(P){}}t.InMemoryStorageService=F;async function c(f,P,S,w){const l=a=>{try{return JSON.parse(a)}catch(h){return a}},r=new Map,s=new Map;f.forEach((a,h)=>{r.set(h,a),s.set(h,l(a))});const e=new Map,i=new Map;P.forEach((a,h)=>{e.set(h,a),i.set(h,l(a))}),console.group(`Storage: Global (path: ${S})`);let n=[];r.forEach((a,h)=>{n.push({key:h,value:a})}),console.table(n),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${w})`);let o=[];e.forEach((a,h)=>{o.push({key:h,value:a})}),console.table(o),console.groupEnd(),console.log(i)}t.logStorage=c}),define(Y[116],ee([0,1,15,33,29,7]),function(G,t,g,T,y,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function C(d){if(g.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function D(d,v,p,E,F,c,f,P,S,w){const l=Object.create(null);l["common.machineId"]=f,l.sessionID=(0,y.generateUuid)()+Date.now(),l.commitHash=F,l.version=c,l["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,g.PlatformToString)(g.platform),l["common.nodePlatform"]=T.platform,l["common.nodeArch"]=E,l["common.product"]=w||"desktop";const r=u(P||[]);r&&(l["common.msftInternal"]=r);let s=0;const e=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),g.isLinuxSnap&&(l["common.snap"]="true");const i=C(p);i&&(l["common.platformDetail"]=i);try{const n=await d.readFile(I.URI.file(S));l["common.source"]=n.value.toString().slice(0,30)}catch(n){}return l}t.resolveCommonProperties=D;function u(d){const v=T.env.USERDNSDOMAIN;if(!v)return!1;const p=v.toLowerCase();return d.some(E=>p===E)}t.verifyMicrosoftInternalDomain=u}),define(Y[35],ee([0,1,11]),function(G,t,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,g.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,g.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(Y[117],ee([0,1,74,2,22,23,13,34,14,35,26,8,7,4]),function(G,t,g,T,y,I,C,D,u,d,v,p,E,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=t.INSTALL_ERROR_LOCAL=t.ERROR_UNKNOWN=t.INSTALL_ERROR_VALIDATING=void 0,t.INSTALL_ERROR_VALIDATING="validating",t.ERROR_UNKNOWN="unknown",t.INSTALL_ERROR_LOCAL="local";let c=class extends T.Disposable{constructor(l,r,s){super();this.galleryService=l,this.telemetryService=r,this.logService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new C.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new C.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new C.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new C.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,T.toDisposable)(()=>{this.installingExtensions.forEach(e=>e.cancel()),this.uninstallingExtensions.forEach(e=>e.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async installFromGallery(l,r={}){if(!this.galleryService.isEnabled())throw new Error(g.localize(0,null));try{l=await this.checkAndGetCompatibleVersion(l)}catch(e){throw this.logService.error((0,p.getErrorMessage)(e)),P(this.telemetryService,"extensionGallery:install",(0,I.getGalleryExtensionTelemetryData)(l),void 0,e),e}if(!await this.canInstall(l)){const e=new y.ExtensionManagementError("Not supported",t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Canno install extension as it is not supported.",l.identifier.id,e.message),P(this.telemetryService,"extensionGallery:install",(0,I.getGalleryExtensionTelemetryData)(l),void 0,e),e}const s=await this.galleryService.getManifest(l,v.CancellationToken.None);if(s===null){const e=new y.ExtensionManagementError(`Missing manifest for extension ${l.identifier.id}`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",l.identifier.id,e.message),P(this.telemetryService,"extensionGallery:install",(0,I.getGalleryExtensionTelemetryData)(l),void 0,e),e}return this.installExtension(s,l,r)}async uninstall(l,r={}){return this.logService.trace("ExtensionManagementService#uninstall",l.identifier.id),this.unininstallExtension(l,r)}async reinstallFromGallery(l){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",l.identifier.id),!this.galleryService.isEnabled())throw new Error(g.localize(1,null));const r=await this.findGalleryExtension(l);if(!r)throw new Error(g.localize(2,null));await this.createUninstallExtensionTask(l,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(r)}getExtensionsReport(){const l=new Date().getTime();return(!this.reportedExtensions||l-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=l),this.reportedExtensions}registerParticipant(l){this.participants.push(l)}async installExtension(l,r,s){if(!E.URI.isUri(r)){let a=this.installingExtensions.get(new I.ExtensionIdentifierWithVersion(r.identifier,r.version).key());if(a)return this.logService.info("Extensions is already requested to install",r.identifier.id),a.waitUntilTaskIsFinished();s={...s,installOnlyNewlyAddedFromExtensionPack:!0}}const e=[],i=[],n=this.createInstallExtensionTask(l,r,s);E.URI.isUri(r)||this.installingExtensions.set(new I.ExtensionIdentifierWithVersion(n.identifier,l.version).key(),n),this._onInstallExtension.fire({identifier:n.identifier,source:r}),this.logService.info("Installing extension:",n.identifier.id),e.push({task:n,manifest:l});let o=!1;try{if(s.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",n.identifier.id);else try{const h=await this.getAllDepsAndPackExtensionsToInstall(n.identifier,l,!!s.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:m,manifest:N}of h)if(o=o||!!N.extensionDependencies?.some(L=>(0,I.areSameExtensions)({id:L},n.identifier)),this.installingExtensions.has(new I.ExtensionIdentifierWithVersion(m.identifier,m.version).key()))this.logService.info("Extension is already requested to install",m.identifier.id);else{const L=this.createInstallExtensionTask(N,m,{...s,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new I.ExtensionIdentifierWithVersion(L.identifier,N.version).key(),L),this._onInstallExtension.fire({identifier:L.identifier,source:m}),this.logService.info("Installing extension:",L.identifier.id),e.push({task:L,manifest:N})}}catch(h){throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",n.identifier.id),this.logService.error(h),h}const a=e.reduce((h,{task:m,manifest:N})=>(h.set(m.identifier.id.toLowerCase(),{task:m,manifest:N}),h),new Map);for(;a.size;){let h;const m=[...a.values()].filter(({manifest:N})=>!N.extensionDependencies?.some(L=>a.has(L.toLowerCase())));m.length?h=a.size===1?m:m.filter(({task:N})=>!(N===n&&!o)):(this.logService.info("Found extensions with circular dependencies",m.map(({task:N})=>N.identifier.id)),h=[...a.values()]),await this.joinAllSettled(h.map(async({task:N})=>{const L=new Date().getTime();try{const k=await N.run();await this.joinAllSettled(this.participants.map(j=>j.postInstall(k,N.source,s,v.CancellationToken.None))),E.URI.isUri(N.source)||P(this.telemetryService,N.operation===2?"extensionGallery:update":"extensionGallery:install",(0,I.getGalleryExtensionTelemetryData)(N.source),new Date().getTime()-L,void 0),i.push({local:k,identifier:N.identifier,operation:N.operation,source:N.source})}catch(k){throw E.URI.isUri(N.source)||P(this.telemetryService,N.operation===2?"extensionGallery:update":"extensionGallery:install",(0,I.getGalleryExtensionTelemetryData)(N.source),new Date().getTime()-L,k),this.logService.error("Error while installing the extension:",N.identifier.id),this.logService.error(k),k}finally{a.delete(N.identifier.id.toLowerCase())}}))}return i.forEach(({identifier:h})=>this.logService.info("Extension installed successfully:",h.id)),this._onDidInstallExtensions.fire(i),i.filter(({identifier:h})=>(0,I.areSameExtensions)(h,n.identifier))[0].local}catch(a){if(e.forEach(({task:h})=>h.cancel()),i.length)try{const h=await Promise.allSettled(i.map(({local:m})=>this.createUninstallExtensionTask(m,{versionOnly:!0}).run()));for(let m=0;m<h.length;m++){const N=h[m],{identifier:L}=i[m];N.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",L.id):this.logService.warn("Rollback: Error while uninstalling extension",L.id,(0,p.getErrorMessage)(N.reason))}}catch(h){this.logService.warn("Error while rolling back extensions",(0,p.getErrorMessage)(h),i.map(({identifier:m})=>m.id))}throw this.logService.error("Failed to install extension:",n.identifier.id,(0,p.getErrorMessage)(a)),this._onDidInstallExtensions.fire(e.map(({task:h})=>({identifier:h.identifier,operation:1,source:h.source}))),a instanceof Error&&(a.name=a&&a.code?a.code:t.ERROR_UNKNOWN),a}finally{for(const{task:a,manifest:h}of e)if(!E.URI.isUri(a.source)){const m=new I.ExtensionIdentifierWithVersion(a.identifier,h.version).key();this.installingExtensions.delete(m)||this.logService.warn("Installation task is not found in the cache",m)}}}async joinAllSettled(l){const r=[],s=[],e=await Promise.allSettled(l);for(const i of e)i.status==="fulfilled"?r.push(i.value):s.push(i.reason);if(s.length)throw f(s);return r}async getAllDepsAndPackExtensionsToInstall(l,r,s){if(!this.galleryService.isEnabled())return[];let e=await this.getInstalled();const i=[l,...e.map(a=>a.identifier)],n=[],o=async(a,h)=>{const m=h.extensionDependencies||[];if(h.extensionPack){const N=s?e.find(L=>(0,I.areSameExtensions)(L.identifier,a)):void 0;for(const L of h.extensionPack)N&&N.manifest.extensionPack&&N.manifest.extensionPack.some(k=>(0,I.areSameExtensions)({id:k},{id:L}))||m.every(k=>!(0,I.areSameExtensions)({id:k},{id:L}))&&m.push(L)}if(m.length){const N=[...i,...n.map(k=>k.gallery.identifier)],L=m.filter(k=>N.every(j=>!(0,I.areSameExtensions)(j,{id:k})));if(L.length){const k=await this.galleryService.query({names:L,pageSize:m.length},v.CancellationToken.None);for(const j of k.firstPage){if(N.find(ne=>(0,I.areSameExtensions)(ne,j.identifier)))continue;const _=await this.checkAndGetCompatibleVersion(j);if(!await this.canInstall(_)){this.logService.info("Skipping the extension as it cannot be installed",_.identifier.id);continue}const Q=await this.galleryService.getManifest(_,v.CancellationToken.None);if(Q===null)throw new y.ExtensionManagementError(`Missing manifest for extension ${_.identifier.id}`,t.INSTALL_ERROR_VALIDATING);n.push({gallery:_,manifest:Q}),await o(_.identifier,Q)}}}};return await o(l,r),e=await this.getInstalled(),n.filter(a=>!e.some(h=>(0,I.areSameExtensions)(h.identifier,a.gallery.identifier)))}async checkAndGetCompatibleVersion(l){if(await this.isMalicious(l))throw new y.ExtensionManagementError(g.localize(3,null,l.identifier.id),y.INSTALL_ERROR_MALICIOUS);const r=await this.galleryService.getCompatibleExtension(l);if(!r)throw new y.ExtensionManagementError(g.localize(4,null,l.identifier.id,D.default.version),y.INSTALL_ERROR_INCOMPATIBLE);return r}async isMalicious(l){const r=await this.getExtensionsReport();return(0,I.getMaliciousExtensionsSet)(r).has(l.identifier.id)}async unininstallExtension(l,r){const s=this.uninstallingExtensions.get(l.identifier.id.toLowerCase());if(s)return this.logService.info("Extensions is already requested to uninstall",l.identifier.id),s.waitUntilTaskIsFinished();const e=(a,h)=>{const m=this.createUninstallExtensionTask(a,h);return this.uninstallingExtensions.set(m.extension.identifier.id.toLowerCase(),m),this.logService.info("Uninstalling extension:",a.identifier.id),this._onUninstallExtension.fire(a.identifier),m},i=(a,h)=>{h?this.logService.error("Failed to uninstall extension:",a.identifier.id,h.message):this.logService.info("Successfully uninstalled extension:",a.identifier.id),P(this.telemetryService,"extensionGallery:uninstall",(0,I.getLocalExtensionTelemetryData)(a),void 0,h),this._onDidUninstallExtension.fire({identifier:a.identifier,error:h?.code})},n=[],o=[];try{n.push(e(l,{}));const a=await this.getInstalled(1);if(r.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",l.identifier.id);else{const h=this.getAllPackExtensionsToUninstall(l,a);for(const m of h)this.uninstallingExtensions.has(m.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",m.identifier.id):n.push(e(m,{}))}r.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",l.identifier.id):this.checkForDependents(n.map(h=>h.extension),a,l),await this.joinAllSettled(n.map(async h=>{try{if(await h.run(),await this.joinAllSettled(this.participants.map(m=>m.postUninstall(h.extension,r,v.CancellationToken.None))),h.extension.identifier.uuid)try{await this.galleryService.reportStatistic(h.extension.manifest.publisher,h.extension.manifest.name,h.extension.manifest.version,"uninstall")}catch(m){}i(h.extension)}catch(m){const N=m instanceof y.ExtensionManagementError?m:new y.ExtensionManagementError((0,p.getErrorMessage)(m),t.ERROR_UNKNOWN);throw i(h.extension,N),N}finally{o.push(h)}}))}catch(a){const h=a instanceof y.ExtensionManagementError?a:new y.ExtensionManagementError((0,p.getErrorMessage)(a),t.ERROR_UNKNOWN);for(const m of n){try{m.cancel()}catch(N){}o.includes(m)||i(m.extension,h)}throw h}finally{for(const a of n)this.uninstallingExtensions.delete(a.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",a.extension.identifier.id)}}checkForDependents(l,r,s){for(const e of l){const i=this.getDependents(e,r);if(i.length){const n=i.filter(o=>l.indexOf(o)===-1);if(n.length)throw new Error(this.getDependentsErrorMessage(e,n,s))}}}getDependentsErrorMessage(l,r,s){return s===l?r.length===1?g.localize(5,null,s.manifest.displayName||s.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?g.localize(6,null,s.manifest.displayName||s.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):g.localize(7,null,s.manifest.displayName||s.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?g.localize(8,null,s.manifest.displayName||s.manifest.name,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?g.localize(9,null,s.manifest.displayName||s.manifest.name,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):g.localize(10,null,s.manifest.displayName||s.manifest.name,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(l,r,s=[]){if(s.indexOf(l)!==-1)return[];s.push(l);const e=l.manifest.extensionPack?l.manifest.extensionPack:[];if(e.length){const i=r.filter(o=>!o.isBuiltin&&e.some(a=>(0,I.areSameExtensions)({id:a},o.identifier))),n=[];for(const o of i)n.push(...this.getAllPackExtensionsToUninstall(o,r,s));return[...i,...n]}return[]}getDependents(l,r){return r.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(e=>(0,I.areSameExtensions)({id:e},l.identifier)))}async findGalleryExtension(l){if(l.identifier.uuid){const r=await this.findGalleryExtensionById(l.identifier.uuid);return r||this.findGalleryExtensionByName(l.identifier.id)}return this.findGalleryExtensionByName(l.identifier.id)}async findGalleryExtensionById(l){return(await this.galleryService.query({ids:[l],pageSize:1},v.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(l){return(await this.galleryService.query({names:[l],pageSize:1},v.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const l=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${l.length} reported extensions from service`),l}catch(l){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};c=ue([fe(0,y.IExtensionGalleryService),fe(1,d.ITelemetryService),fe(2,u.ILogService)],c),t.AbstractExtensionManagementService=c;function f(w){const l=Array.isArray(w)?w:[w];return l.length===1?l[0]instanceof Error?l[0]:new Error(l[0]):l.reduce((r,s)=>new Error(`${r.message}${r.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}t.joinErrors=f;function P(w,l,r,s,e){const i=e?e instanceof y.ExtensionManagementError?e.code:t.ERROR_UNKNOWN:void 0;w.publicLogError(l,{...r,success:!e,duration:s,errorcode:i})}t.reportTelemetry=P;class S{constructor(){this.barrier=new F.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,F.createCancelablePromise)(l=>this.doRun(l))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,F.createCancelablePromise)(l=>new Promise((r,s)=>{const e=l.onCancellationRequested(()=>{e.dispose(),s((0,p.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=S}),define(Y[118],ee([0,1,8,22,23,19,35,55,49,21,26,14,17,7,42,115,114,11]),function(G,t,g,T,y,I,C,D,u,d,v,p,E,F,c,f,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0;var w;(function(W){W[W.None=0]="None",W[W.IncludeVersions=1]="IncludeVersions",W[W.IncludeFiles=2]="IncludeFiles",W[W.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",W[W.IncludeSharedAccounts=8]="IncludeSharedAccounts",W[W.IncludeVersionProperties=16]="IncludeVersionProperties",W[W.ExcludeNonValidated=32]="ExcludeNonValidated",W[W.IncludeInstallationTargets=64]="IncludeInstallationTargets",W[W.IncludeAssetUri=128]="IncludeAssetUri",W[W.IncludeStatistics=256]="IncludeStatistics",W[W.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",W[W.Unpublished=4096]="Unpublished"})(w||(w={}));function l(...W){return String(W.reduce((x,q)=>x|q,0))}var r;(function(W){W[W.Tag=1]="Tag",W[W.ExtensionId=4]="ExtensionId",W[W.Category=5]="Category",W[W.ExtensionName=7]="ExtensionName",W[W.Target=8]="Target",W[W.Featured=9]="Featured",W[W.SearchText=10]="SearchText",W[W.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},e={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},n={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:w.None,criteria:[],assetTypes:[]};class o{constructor(x=n){this.state=x}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(x,q=this.state.pageSize){return new o({...this.state,pageNumber:x,pageSize:q})}withFilter(x,...q){const U=[...this.state.criteria,...q.length?q.map(R=>({filterType:x,value:R})):[{filterType:x}]];return new o({...this.state,criteria:U})}withSortBy(x){return new o({...this.state,sortBy:x})}withSortOrder(x){return new o({...this.state,sortOrder:x})}withFlags(...x){return new o({...this.state,flags:x.reduce((q,U)=>q|U,0)})}withAssetTypes(...x){return new o({...this.state,assetTypes:x})}get raw(){const{criteria:x,pageNumber:q,pageSize:U,sortBy:R,sortOrder:M,flags:b,assetTypes:O}=this.state;return{filters:[{criteria:x,pageNumber:q,pageSize:U,sortBy:R,sortOrder:M}],assetTypes:O,flags:b}}get searchText(){const x=this.state.criteria.filter(q=>q.filterType===r.SearchText)[0];return x&&x.value?x.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(x=>String(x.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function a(W,x){const q=(W||[]).filter(U=>U.statisticName===x)[0];return q?q.value:0}function h(W){const x="Microsoft.VisualStudio.Code.Translation.";return W.files.filter(U=>U.assetType.indexOf(x)===0).reduce((U,R)=>{const M=k(W,R.assetType);return M&&U.push([R.assetType.substring(x.length),M]),U},[])}function m(W){if(W.properties){const x=W.properties.filter(R=>R.key===s.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),U=x.filter(R=>q.test(R.value))[0];return U?{uri:U.value,fallbackUri:U.value}:null}return k(W,s.Repository)}function N(W){return{uri:`${W.fallbackAssetUri}/${s.VSIX}?redirect=true`,fallbackUri:`${W.fallbackAssetUri}/${s.VSIX}`}}function L(W){const x=k(W,s.Icon);if(x)return x;const q=T.DefaultIconPath;return{uri:q,fallbackUri:q}}function k(W,x){return W.files.filter(U=>U.assetType===x)[0]?{uri:`${W.assetUri}/${x}`,fallbackUri:`${W.fallbackAssetUri}/${x}`}:null}function j(W,x){const q=W.properties?W.properties.filter(R=>R.key===x):[],U=q.length>0&&q[0].value;return U?U.split(",").map(R=>(0,y.adoptToGalleryExtensionId)(R)):[]}function _(W){const x=W.properties?W.properties.filter(q=>q.key===e.Engine):[];return x.length>0&&x[0].value||""}function Q(W){const x=W.properties?W.properties.filter(U=>U.key===e.LocalizedLanguages):[],q=x.length>0&&x[0].value||"";return q?q.split(","):[]}function ne(W){return W.indexOf("preview")!==-1}function re(W,x,q,U,R){const M={manifest:k(x,s.Manifest),readme:k(x,s.Details),changelog:k(x,s.Changelog),license:k(x,s.License),repository:m(x),download:N(x),icon:L(x),coreTranslations:h(x)};return{identifier:{id:(0,y.getGalleryExtensionId)(W.publisher.publisherName,W.extensionName),uuid:W.extensionId},name:W.extensionName,version:x.version,date:x.lastUpdated,displayName:W.displayName,publisherId:W.publisher.publisherId,publisher:W.publisher.publisherName,publisherDisplayName:W.publisher.displayName,description:W.shortDescription||"",installCount:a(W.statistics,"install"),rating:a(W.statistics,"averagerating"),ratingCount:a(W.statistics,"ratingcount"),assetUri:F.URI.parse(x.assetUri),categories:W.categories||[],tags:W.tags||[],releaseDate:Date.parse(W.releaseDate),lastUpdated:Date.parse(W.lastUpdated),webExtension:!!W.tags?.includes(T.WEB_EXTENSION_TAG),assetTypes:x.files.map(({assetType:b})=>b),assets:M,properties:{dependencies:j(x,e.Dependency),extensionPack:j(x,e.ExtensionPack),engine:_(x),localizedLanguages:Q(x)},telemetryData:{index:(U.pageNumber-1)*U.pageSize+q,querySource:R},preview:ne(W.flags)}}let Z=class{constructor(x,q,U,R,M,b,O){this.requestService=x,this.logService=q,this.environmentService=U,this.telemetryService=R,this.fileService=M,this.productService=b;const A=b.extensionsGallery;this.extensionsGalleryUrl=A&&A.serviceUrl,this.extensionsControlUrl=A&&A.controlUrl,this.commonHeadersPromise=J(b.version,this.environmentService,this.fileService,O)}api(x=""){return`${this.extensionsGalleryUrl}${x}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(x,q){const U=[];let{total:R,firstPage:M,getPage:b}=await this.query({names:x,pageSize:x.length},q);U.push(...M);for(let O=1;U.length<R&&(M=await b(O,q),M.length);O++)U.push(...M);return U}async getCompatibleExtension(x,q){return this.getCompatibleExtensionByEngine(x,q)}async getCompatibleExtensionByEngine(x,q){const U=(0,T.isIExtensionIdentifier)(x)?null:x;if(U&&U.properties.engine&&(0,u.isEngineValid)(U.properties.engine,this.productService.version,this.productService.date))return U;const{id:R,uuid:M}=U?U.identifier:x;let b=new o().withFlags(w.IncludeAssetUri,w.IncludeStatistics,w.IncludeCategoryAndTags,w.IncludeFiles,w.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");M?b=b.withFilter(r.ExtensionId,M):b=b.withFilter(r.ExtensionName,R);const{galleryExtensions:O}=await this.queryGallery(b,v.CancellationToken.None),[A]=O;if(!A||!A.versions.length)return null;if(q){const B=A.versions.filter($=>$.version===q)[0];if(B){const $=re(A,B,0,b);if($.properties.engine&&(0,u.isEngineValid)($.properties.engine,this.productService.version,this.productService.date))return $}return null}const V=await this.getLastValidExtensionVersion(A,A.versions);return V?re(A,V,0,b):null}async query(x,q){const U=v.CancellationToken.isCancellationToken(x)?{}:x,R=v.CancellationToken.isCancellationToken(x)?x:q;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let M=U.text||"";const b=(0,I.getOrDefault)(U,K=>K.pageSize,50);let O=new o().withFlags(w.IncludeLatestVersionOnly,w.IncludeAssetUri,w.IncludeStatistics,w.IncludeCategoryAndTags,w.IncludeFiles,w.IncludeVersionProperties).withPage(1,b).withFilter(r.Target,"Microsoft.VisualStudio.Code");M?(M=M.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(K,te,ie)=>(O=O.withFilter(r.Category,ie||te),"")),M=M.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(K,te,ie)=>(O=O.withFilter(r.Tag,ie||te),"")),M=M.replace(/\bfeatured(\s+|\b|$)/g,()=>(O=O.withFilter(r.Featured),"")),M=M.trim(),M&&(M=M.length<200?M:M.substring(0,200),O=O.withFilter(r.SearchText,M)),O=O.withSortBy(0)):U.ids?O=O.withFilter(r.ExtensionId,...U.ids):U.names?O=O.withFilter(r.ExtensionName,...U.names):O=O.withSortBy(4),typeof U.sortBy=="number"&&(O=O.withSortBy(U.sortBy)),typeof U.sortOrder=="number"&&(O=O.withSortOrder(U.sortOrder));const{galleryExtensions:A,total:V}=await this.queryGallery(O,R),B=A.map((K,te)=>re(K,K.versions[0],te,O,U.source)),$=async(K,te)=>{if(te.isCancellationRequested)throw(0,g.canceled)();const ie=O.withPage(K+1),{galleryExtensions:oe}=await this.queryGallery(ie,te);return oe.map((le,pe)=>re(le,le.versions[0],pe,ie,U.source))};return{firstPage:B,total:V,pageSize:O.pageSize,getPage:$}}async queryGallery(x,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");x=x.withFlags(x.flags,w.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,l(w.Unpublished));const U=await this.commonHeadersPromise,R=JSON.stringify(x.raw),M={...U,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(R.length)},b=new Date().getTime();let O,A,V=0;try{if(O=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:R,headers:M},q),O.res.statusCode&&O.res.statusCode>=400&&O.res.statusCode<500)return{galleryExtensions:[],total:V};const B=await(0,D.asJson)(O);if(B){const $=B.results[0],K=$.extensions,te=$.resultMetadata&&$.resultMetadata.filter(ie=>ie.metadataType==="ResultCount")[0];return V=te&&te.metadataItems.filter(ie=>ie.name==="TotalCount")[0].count||0,{galleryExtensions:K,total:V}}return{galleryExtensions:[],total:V}}catch(B){throw A=B,B}finally{this.telemetryService.publicLog2("galleryService:query",{...x.telemetryData,requestBodySize:String(R.length),duration:new Date().getTime()-b,success:!!O&&(0,D.isSuccess)(O),responseBodySize:O?.res.headers["Content-Length"],statusCode:O?String(O.res.statusCode):void 0,errorCode:A?(0,g.isPromiseCanceledError)(A)?"canceled":(0,g.getErrorMessage)(A).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(V)})}}async reportStatistic(x,q,U,R){if(!this.isEnabled())return;const b={...await this.commonHeadersPromise,Accept:"*/*;api-version=4.0-preview.1"};try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${x}/extensions/${q}/${U}/stats?statType=${R}`),headers:b},v.CancellationToken.None)}catch(O){}}async download(x,q,U){this.logService.trace("ExtensionGalleryService#download",x.identifier.id);const R=(0,y.getGalleryExtensionTelemetryData)(x),M=new Date().getTime(),b=B=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...R,duration:B}),O=U===1?"install":U===2?"update":"",A=O?{uri:`${x.assets.download.uri}&${O}=true`,fallbackUri:`${x.assets.download.fallbackUri}?${O}=true`}:x.assets.download,V=await this.getAsset(A);await this.fileService.writeFile(q,V.stream),b(new Date().getTime()-M)}async getReadme(x,q){if(x.assets.readme){const U=await this.getAsset(x.assets.readme,{},q);return await(0,D.asText)(U)||""}return""}async getManifest(x,q){if(x.assets.manifest){const U=await this.getAsset(x.assets.manifest,{},q),R=await(0,D.asText)(U);return R?JSON.parse(R):null}return null}async getCoreTranslation(x,q){const U=x.assets.coreTranslations.filter(R=>R[0]===q.toUpperCase())[0];if(U){const R=await this.getAsset(U[1]),M=await(0,D.asText)(R);return M?JSON.parse(M):null}return null}async getChangelog(x,q){if(x.assets.changelog){const U=await this.getAsset(x.assets.changelog,{},q);return await(0,D.asText)(U)||""}return""}async getAllVersions(x,q){let U=new o().withFlags(w.IncludeVersions,w.IncludeCategoryAndTags,w.IncludeFiles,w.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");x.identifier.uuid?U=U.withFilter(r.ExtensionId,x.identifier.uuid):U=U.withFilter(r.ExtensionName,x.identifier.id);const R=[],{galleryExtensions:M}=await this.queryGallery(U,v.CancellationToken.None);return M.length&&(q?await Promise.all(M[0].versions.map(async b=>{let O;try{O=await this.getEngine(b)}catch(A){}O&&(0,u.isEngineValid)(O,this.productService.version,this.productService.date)&&R.push({version:b.version,date:b.lastUpdated})})):R.push(...M[0].versions.map(b=>({version:b.version,date:b.lastUpdated})))),R}async getAsset(x,q={},U=v.CancellationToken.None){const R=await this.commonHeadersPromise,M={type:"GET"},b={...R,...q.headers||{}};q={...q,...M,headers:b};const O=x.uri,A=x.fallbackUri,V={...q,url:O};try{const B=await this.requestService.request(V,U);if(B.res.statusCode===200)return B;const $=await(0,D.asText)(B);throw new Error(`Expected 200, got back ${B.res.statusCode} instead.

${$}`)}catch(B){if((0,g.isPromiseCanceledError)(B))throw B;const $=(0,g.getErrorMessage)(B);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:O,message:$});const K={...q,url:A};return this.requestService.request(K,U)}}async getLastValidExtensionVersion(x,q){const U=this.getLastValidExtensionVersionFromProperties(x,q);return U||this.getLastValidExtensionVersionRecursively(x,q)}getLastValidExtensionVersionFromProperties(x,q){for(const U of q){const R=_(U);if(!R)return null;if((0,u.isEngineValid)(R,this.productService.version,this.productService.date))return U}return null}async getEngine(x){const q=_(x);if(q)return q;const U=k(x,s.Manifest);if(!U)throw new Error("Manifest was not found");const R={"Accept-Encoding":"gzip"},M=await this.getAsset(U,{headers:R}),b=await(0,D.asJson)(M);if(b)return b.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(x,q){if(!q.length)return null;const U=q[0],R=await this.getEngine(U);return(0,u.isEngineValid)(R,this.productService.version,this.productService.date)?{...U,properties:[...U.properties||[],{key:e.Engine,value:R}]}:this.getLastValidExtensionVersionRecursively(x,q.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const x=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},v.CancellationToken.None);if(x.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,D.asJson)(x),U=new Map;if(q)for(const R of q.malicious){const M=U.get(R)||{id:{id:R},malicious:!0,slow:!1};M.malicious=!0,U.set(R,M)}return[...U.values()]}};Z=ue([fe(0,D.IRequestService),fe(1,p.ILogService),fe(2,d.IEnvironmentService),fe(3,C.ITelemetryService),fe(4,E.IFileService),fe(5,c.IProductService),fe(6,(0,S.optional)(f.IStorageService))],Z),t.ExtensionGalleryService=Z;async function J(W,x,q,U){const R={"X-Market-Client-Id":`VSCode ${W}`,"User-Agent":`VSCode ${W}`},M=await(0,P.getServiceMachineId)(x,q,U);return R["X-Market-User-Id"]=M,R}t.resolveMarketplaceHeaders=J}),define(Y[119],ee([0,1,34,85,18,11,27,30,2,19,25]),function(G,t,g,T,y,I,C,D,u,d,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let p=class{constructor(c,f){this._configurationService=f,this._experimentProperties={},this._disposables=new u.DisposableStore,this._cleanupPatterns=[],this._appender=c.appender,this._commonProperties=c.commonProperties||Promise.resolve({}),this._piiPaths=c.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!c.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let P of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,y.escapeRegExpCharacters)(P),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(P=>{const S=/^[a-f0-9]+$/i.test(P["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!S})}))}setExperimentProperty(c,f){this._experimentProperties[c]=f}setEnabled(c){this._enabled=c}_updateUserOptIn(){const c=this._configurationService?.getValue(E);this._userOptIn=c?c.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const c=await this._commonProperties;let f=c.sessionID,P=c["common.instanceId"],S=c["common.machineId"],w=c["common.firstSessionDate"],l=c["common.msftInternal"];return{sessionId:f,instanceId:P,machineId:S,firstSessionDate:w,msftInternal:l}}dispose(){this._disposables.dispose()}publicLog(c,f,P){return this.isOptedIn?this._commonProperties.then(S=>{f=(0,d.mixin)(f,S),f=(0,d.mixin)(f,this._experimentProperties),f=(0,d.cloneAndChange)(f,w=>{if(typeof w=="string")return this._cleanupInfo(w,P)}),this._appender.log(c,f)},S=>{console.error(S)}):Promise.resolve(void 0)}publicLog2(c,f,P){return this.publicLog(c,f,P)}publicLogError(c,f){return this.sendErrorTelemetry?this.publicLog(c,f,!0):Promise.resolve(void 0)}publicLogError2(c,f){return this.publicLogError(c,f)}_cleanupInfo(c,f){let P=c;if(f){const S=[];for(let s of this._cleanupPatterns)for(;;){const e=s.exec(c);if(!e)break;S.push([e.index,s.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let r=0;for(P="";;){const s=l.exec(c);if(!s)break;!w.test(s[0])&&S.every(([e,i])=>s.index<e||s.index>=i)&&(P+=c.substring(r,s.index)+"<REDACTED: user-file-path>",r=l.lastIndex)}r<c.length&&(P+=c.substr(r))}for(let S of this._cleanupPatterns)P=P.replace(S,"");return P}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=ue([fe(1,(0,I.optional)(C.IConfigurationService))],p),t.TelemetryService=p;const E="telemetry";v.Registry.as(D.Extensions.Configuration).registerConfiguration({id:E,order:110,type:"object",title:(0,T.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,T.localize)(2,null,g.default.privacyStatementUrl):(0,T.localize)(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Y[56],ee([0,1,27,19,12,4]),function(G,t,g,T,y,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(c,f){return Promise.resolve(void 0)}publicLog2(c,f){return this.publicLog(c,f)}publicLogError(c,f){return Promise.resolve(void 0)}publicLogError2(c,f){return this.publicLogError(c,f)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class C{async publicLog(f,P,S){}async publicLogError(f,P,S){}}t.NullEndpointTelemetryService=C;function D(...c){return{log:(f,P)=>c.forEach(S=>S.log(f,P)),flush:()=>I.Promises.settled(c.map(f=>f.flush())),productIdentifier:c.find(f=>f.productIdentifier!==void 0)?.productIdentifier}}t.combinedAppender=D,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function u(c,f){return f.onDidChangeConfiguration(P=>{P.source!==6&&c.publicLog2("updateConfiguration",{configurationSource:(0,g.ConfigurationTargetToString)(P.source),configurationKeys:E(P.sourceConfig)})})}t.configurationTelemetry=u;function d(c){const f=Object.create(null),P=Object.create(null),S=Object.create(null);p(c,S);for(let w in S){w=w.length>150?w.substr(w.length-149):w;const l=S[w];typeof l=="number"?P[w]=l:typeof l=="boolean"?P[w]=l?1:0:typeof l=="string"?f[w]=l.substring(0,1023):typeof l!="undefined"&&l!==null&&(f[w]=l)}return{properties:f,measurements:P}}t.validateTelemetryData=d;function v(c){if(!c)return"none";let f="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(S=>{c.indexOf(`${S}+`)===0&&(f=S)}),f}t.cleanRemoteAuthority=v;function p(c,f,P=0,S){if(!!c)for(let w of Object.getOwnPropertyNames(c)){const l=c[w],r=S?S+w:w;Array.isArray(l)?f[r]=(0,T.safeStringify)(l):l instanceof Date?f[r]=l.toISOString():(0,y.isObject)(l)?P<2?p(l,f,P+1,r+"."):f[r]=(0,T.safeStringify)(l):f[r]=l}}function E(c){if(!c)return[];const f=[];return F(f,"",c),f}function F(c,f,P){P&&typeof P=="object"&&!Array.isArray(P)?Object.keys(P).forEach(S=>F(c,f?`${f}.${S}`:S,P[S])):c.push(f)}}),define(Y[120],ee([0,1,8,19,56]),function(G,t,g,T,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function I(D){const u=await new Promise((v,p)=>{G(["applicationinsights"],v,p)});let d;return u.defaultClient?(d=new u.TelemetryClient(D),d.channel.setUseDiskRetryCaching(!0)):(u.setup(D).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),d=u.defaultClient),D.indexOf("AIF-")===0&&(d.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),d}class C{constructor(u,d,v){this._eventPrefix=u,this._defaultData=d,this._defaultData||(this._defaultData=Object.create(null)),typeof v=="function"?this._aiClient=v():this._aiClient=v,this._asyncAIClient=null}_withAIClient(u){if(!!this._aiClient){if(typeof this._aiClient!="string"){u(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=I(this._aiClient)),this._asyncAIClient.then(d=>{u(d)},d=>{(0,g.onUnexpectedError)(d),console.error(d)})}}log(u,d){!this._aiClient||(d=(0,T.mixin)(d,this._defaultData),d=(0,y.validateTelemetryData)(d),this._withAIClient(v=>v.trackEvent({name:this._eventPrefix+"/"+u,properties:d.properties,measurements:d.measurements})))}flush(){return this._aiClient?new Promise(u=>{this._withAIClient(d=>{d.flush({callback:()=>{this._aiClient=void 0,u(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=C}),define(Y[121],ee([0,1,10,3]),function(G,t,g,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function y(I,C){const D=Object.create(null),u=(v,p)=>{const E=JSON.parse(v);D[p]=E};if(C){const v=[],p=await g.Promises.readdir(C);for(const F of p)try{(await g.Promises.stat((0,T.join)(C,F))).isDirectory()&&v.push(F)}catch{}const E=[];for(const F of v)(await g.Promises.readdir((0,T.join)(C,F))).filter(f=>f==="telemetry.json").length===1&&E.push(F);for(const F of E){const c=(await g.Promises.readFile((0,T.join)(C,F,"telemetry.json"))).toString();u(c,F)}}let d=(await g.Promises.readFile((0,T.join)(I,"telemetry-core.json"))).toString();return u(d,"vscode-core"),d=(await g.Promises.readFile((0,T.join)(I,"telemetry-extensions.json"))).toString(),u(d,"vscode-extensions"),JSON.stringify(D,null,4)}t.buildTelemetryMessage=y}),define(Y[43],ee([0,1,72,3,38,4,10,132,133,12]),function(G,t,g,T,y,I,C,D,u,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class v extends Error{constructor(e,i){let n=i.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=e,this.cause=i}}t.ExtractError=v;function p(s){const e=s.externalFileAttributes>>16||33188;return[448,56,7].map(i=>e&i).reduce((i,n)=>i+n,e&61440)}function E(s){if(s instanceof v)return s;let e;return/end of central directory record signature not found/.test(s.message)&&(e="CorruptZip"),new v(e,s)}function F(s,e,i,n,o,a){const h=T.dirname(e),m=T.join(n,h);if(!m.startsWith(n))return Promise.reject(new Error(g.localize(0,null,e)));const N=T.join(n,e);let L;return a.onCancellationRequested(()=>{L&&L.destroy()}),Promise.resolve(C.Promises.mkdir(m,{recursive:!0})).then(()=>new Promise((k,j)=>{if(!a.isCancellationRequested)try{L=(0,y.createWriteStream)(N,{mode:i}),L.once("close",()=>k()),L.once("error",j),s.once("error",j),s.pipe(L)}catch(_){j(_)}}))}function c(s,e,i,n){let o=(0,I.createCancelablePromise)(()=>Promise.resolve()),a=0;return n.onCancellationRequested(()=>{o.cancel(),s.close()}),new Promise((h,m)=>{const N=new I.Sequencer,L=k=>{k.isCancellationRequested||(a++,s.readEntry())};s.once("error",m),s.once("close",()=>o.then(()=>{n.isCancellationRequested||s.entryCount===a?h():m(new v("Incomplete",new Error(g.localize(1,null,a,s.entryCount))))},m)),s.readEntry(),s.on("entry",k=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(k.fileName)){L(n);return}const j=k.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(j)){const ne=T.join(e,j);o=(0,I.createCancelablePromise)(re=>C.Promises.mkdir(ne,{recursive:!0}).then(()=>L(re)).then(void 0,m));return}const _=P(s,k),Q=p(k);o=(0,I.createCancelablePromise)(ne=>N.queue(()=>_.then(re=>F(re,j,Q,e,i,ne).then(()=>L(ne)))).then(null,m))})})}function f(s,e=!1){return new Promise((i,n)=>{(0,D.open)(s,e?{lazyEntries:!0}:void 0,(o,a)=>{o?n(E(o)):i((0,d.assertIsDefined)(a))})})}function P(s,e){return new Promise((i,n)=>{s.openReadStream(e,(o,a)=>{o?n(E(o)):i((0,d.assertIsDefined)(a))})})}function S(s,e){return new Promise((i,n)=>{const o=new u.ZipFile;e.forEach(h=>{h.contents?o.addBuffer(typeof h.contents=="string"?Buffer.from(h.contents,"utf8"):h.contents,h.path):h.localPath&&o.addFile(h.localPath,h.path)}),o.end();const a=(0,y.createWriteStream)(s);o.outputStream.pipe(a),o.outputStream.once("error",n),a.once("error",n),a.once("finish",()=>i(s))})}t.zip=S;function w(s,e,i={},n){const o=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let a=f(s,!0);return i.overwrite&&(a=a.then(h=>C.Promises.rm(e).then(()=>h))),a.then(h=>c(h,e,{sourcePathRegex:o},n))}t.extract=w;function l(s,e){return f(s).then(i=>new Promise((n,o)=>{i.on("entry",a=>{a.fileName===e&&P(i,a).then(h=>n(h),h=>o(h))}),i.once("close",()=>o(new Error(g.localize(2,null,e))))}))}function r(s,e){return l(s,e).then(i=>new Promise((n,o)=>{const a=[];i.once("error",o),i.on("data",h=>a.push(h)),i.on("end",()=>n(Buffer.concat(a)))}))}t.buffer=r}),define(Y[122],ee([0,1,43,78]),function(G,t,g,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function y(I){return(0,g.buffer)(I,"extension/package.json").then(C=>{try{return JSON.parse(C.toString("utf8"))}catch(D){throw new Error((0,T.localize)(0,null))}})}t.getManifest=y}),define(Y[123],ee([0,1,41,2,10,3,14,22,23,4,7,21,90,79,42,43,15,24,9,17,20,29,8]),function(G,t,g,T,y,I,C,D,u,d,v,p,E,F,c,f,P,S,w,l,r,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const i="scanningSystem",n="scanningUser",o="extracting",a="deleting",h="renaming";let m=class extends T.Disposable{constructor(L,k,j,_,Q){super();this.beforeRemovingExtension=L,this.fileService=k,this.logService=j,this.environmentService=_,this.productService=Q,this._devSystemExtensionsPath=null,this.systemExtensionsPath=_.builtinExtensionsPath,this.extensionsPath=_.extensionsPath,this.uninstalledPath=I.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new d.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(L){const k=[];(L===null||L===0)&&k.push(this.scanSystemExtensions().then(null,j=>Promise.reject(new D.ExtensionManagementError(this.joinErrors(j).message,i)))),(L===null||L===1)&&k.push(this.scanUserExtensions(!0).then(null,j=>Promise.reject(new D.ExtensionManagementError(this.joinErrors(j).message,n))));try{const j=await Promise.all(k);return(0,S.flatten)(j)}catch(j){throw this.joinErrors(j)}}async scanUserExtensions(L){this.logService.trace("Started scanning user extensions");let[k,j]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return j=j.filter(_=>!k[new u.ExtensionIdentifierWithVersion(_.identifier,_.manifest.version).key()]),L&&(j=(0,u.groupByExtension)(j,Q=>Q.identifier).map(Q=>Q.sort((ne,re)=>g.rcompare(ne.manifest.version,re.manifest.version))[0])),this.logService.trace("Scanned user extensions:",j.length),j}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(L,k,j){const _=L.key(),Q=I.join(this.extensionsPath,`.${(0,s.generateUuid)()}`),ne=I.join(this.extensionsPath,_);try{await y.Promises.rm(ne)}catch(Z){try{await y.Promises.rm(ne)}catch(J){}throw new D.ExtensionManagementError((0,F.localize)(0,null,ne,L.id),a)}await this.extractAtLocation(L,k,Q,j);let re=await this.scanExtension(v.URI.file(Q),1);if(!re)throw new Error((0,F.localize)(1,null,Q));await this.storeMetadata(re,{installedTimestamp:Date.now()});try{await this.rename(L,Q,ne,Date.now()+2*60*1e3),this.logService.info("Renamed to",ne)}catch(Z){try{await y.Promises.rm(Q)}catch(J){}if(Z.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",L.id);else throw this.logService.info(`Rename failed because of ${(0,e.getErrorMessage)(Z)}. Deleted from extracted location`,Q),Z}try{re=await this.scanExtension(v.URI.file(ne),1)}catch(Z){}if(re)return re;throw new Error((0,F.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(L,k){return this.setMetadata(L,k),await this.storeMetadata(L,{...k,installedTimestamp:L.installedTimestamp}),L}async storeMetadata(L,k){k.isMachineScoped=k.isMachineScoped||void 0,k.isBuiltin=k.isBuiltin||void 0,k.installedTimestamp=k.installedTimestamp||void 0;const j=I.join(L.location.fsPath,"package.json"),_=await y.Promises.readFile(j,"utf8"),{manifest:Q}=await this.parseManifest(_);return Q.__metadata=k,await y.Promises.writeFile(j,JSON.stringify(Q,null,"	")),L}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...L){const k=L.map(j=>new u.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version));await this.withUninstalledExtensions(j=>{k.forEach(_=>j[_.key()]=!0)})}async setInstalled(L){await this.withUninstalledExtensions(_=>delete _[L.key()]);const j=(await this.scanExtensions(1)).find(_=>new u.ExtensionIdentifierWithVersion(_.identifier,_.manifest.version).equals(L))||null;return j?(await this.storeMetadata(j,{installedTimestamp:Date.now()}),this.scanExtension(j.location,1)):null}async withUninstalledExtensions(L){return this.uninstalledFileLimiter.queue(async()=>{let k;try{k=await y.Promises.readFile(this.uninstalledPath,"utf8")}catch(_){if(_.code!=="ENOENT")throw _}let j={};if(k)try{j=JSON.parse(k)}catch(_){}return L&&(L(j),Object.keys(j).length?await y.Promises.writeFile(this.uninstalledPath,JSON.stringify(j)):await y.Promises.rm(this.uninstalledPath)),j})}async removeExtension(L,k){this.logService.trace(`Deleting ${k} extension from disk`,L.identifier.id,L.location.fsPath),await y.Promises.rm(L.location.fsPath),this.logService.info("Deleted from disk",L.identifier.id,L.location.fsPath)}async removeUninstalledExtension(L){await this.removeExtension(L,"uninstalled"),await this.withUninstalledExtensions(k=>delete k[new u.ExtensionIdentifierWithVersion(L.identifier,L.manifest.version).key()])}async extractAtLocation(L,k,j,_){this.logService.trace(`Started extracting the extension from ${k} to ${j}`);try{await y.Promises.rm(j)}catch(Q){throw new D.ExtensionManagementError(this.joinErrors(Q).message,a)}try{await(0,f.extract)(k,j,{sourcePath:"extension",overwrite:!0},_),this.logService.info(`Extracted extension to ${j}:`,L.id)}catch(Q){try{await y.Promises.rm(j)}catch(ne){}throw new D.ExtensionManagementError(Q.message,Q instanceof f.ExtractError&&Q.type?Q.type:o)}}async rename(L,k,j,_){try{await y.Promises.rename(k,j)}catch(Q){if(P.isWindows&&Q&&Q.code==="EPERM"&&Date.now()<_)return this.logService.info(`Failed renaming ${k} to ${j} with 'EPERM' error. Trying again...`,L.id),this.rename(L,k,j,_);throw new D.ExtensionManagementError(Q.message||(0,F.localize)(3,null,k,j),Q.code||h)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const L=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return L;const k=this.scanDevSystemExtensions(),[j,_]=await Promise.all([L,k]);return[...j,..._]}async scanExtensionsInDir(L,k){const j=new d.Limiter(10),_=await this.fileService.resolve(v.URI.file(L));return _.children?(await Promise.all(_.children.filter(ne=>ne.isDirectory).map(ne=>j.queue(async()=>k===1&&(0,r.basename)(ne.resource).indexOf(".")===0?null:this.scanExtension(ne.resource,k))))).filter(ne=>ne&&ne.identifier):[]}async scanExtension(L,k){try{const j=await this.fileService.resolve(L);if(j.children){const{manifest:_,metadata:Q}=await this.readManifest(L.fsPath),ne=j.children.find(({name:W})=>/^readme(\.txt|\.md|)$/i.test(W))?.resource,re=j.children.find(({name:W})=>/^changelog(\.txt|\.md|)$/i.test(W))?.resource,Z={id:(0,u.getGalleryExtensionId)(_.publisher,_.name)},J={type:k,identifier:Z,manifest:_,location:L,readmeUrl:ne,changelogUrl:re,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:k===0};return Q&&(this.setMetadata(J,Q),J.installedTimestamp=Q.installedTimestamp),J}}catch(j){k!==0&&this.logService.trace(j)}return null}async scanDefaultSystemExtensions(){const L=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",L.length),L}async scanDevSystemExtensions(){const L=this.getDevSystemExtensionsList();if(L.length){const k=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",k.length),k.filter(j=>L.some(_=>(0,u.areSameExtensions)(j.identifier,{id:_})))}else return[]}setMetadata(L,k){L.publisherDisplayName=k.publisherDisplayName||null,L.publisherId=k.publisherId||null,L.identifier.uuid=k.id,L.isMachineScoped=!!k.isMachineScoped,L.isBuiltin=L.type===0||!!k.isBuiltin}async removeUninstalledExtensions(){const L=await this.getUninstalledExtensions(),k=await this.scanAllUserExtensions(),j=new Set;for(const ne of k)L[new u.ExtensionIdentifierWithVersion(ne.identifier,ne.manifest.version).key()]||j.add(ne.identifier.id.toLowerCase());const _=(0,u.groupByExtension)(k,ne=>ne.identifier);await d.Promises.settled(_.map(async ne=>{const re=ne.sort((Z,J)=>g.rcompare(Z.manifest.version,J.manifest.version))[0];j.has(re.identifier.id.toLowerCase())||await this.beforeRemovingExtension(re)}));const Q=k.filter(ne=>L[new u.ExtensionIdentifierWithVersion(ne.identifier,ne.manifest.version).key()]);await d.Promises.settled(Q.map(ne=>this.removeUninstalledExtension(ne)))}async removeOutdatedExtensions(){const L=await this.scanAllUserExtensions(),k=[],j=(0,u.groupByExtension)(L,_=>_.identifier);k.push(...(0,S.flatten)(j.map(_=>_.sort((Q,ne)=>g.rcompare(Q.manifest.version,ne.manifest.version)).slice(1)))),await d.Promises.settled(k.map(_=>this.removeExtension(_,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(L=>L.name)}joinErrors(L){const k=Array.isArray(L)?L:[L];return k.length===1?k[0]instanceof Error?k[0]:new Error(k[0]):k.reduce((j,_)=>new Error(`${j.message}${j.message?",":""}${_ instanceof Error?_.message:_}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=I.normalize(I.join(w.FileAccess.asFileUri("",G).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(L){const k=[y.Promises.readFile(I.join(L,"package.json"),"utf8").then(ne=>this.parseManifest(ne)),y.Promises.readFile(I.join(L,"package.nls.json"),"utf8").then(void 0,ne=>ne.code!=="ENOENT"?Promise.reject(ne):"{}").then(ne=>JSON.parse(ne))],[{manifest:j,metadata:_},Q]=await Promise.all(k);return{manifest:(0,E.localizeManifest)(j,Q),metadata:_}}parseManifest(L){return new Promise((k,j)=>{try{const _=JSON.parse(L),Q=_.__metadata||null;k({manifest:_,metadata:Q})}catch(_){j(new Error((0,F.localize)(4,null)))}})}};m=ue([fe(1,l.IFileService),fe(2,C.ILogService),fe(3,p.INativeEnvironmentService),fe(4,c.IProductService)],m),t.ExtensionsScanner=m}),define(Y[124],ee([0,1,77,3,10,43,22,23,21,41,7,34,15,14,98,28,35,49,20,29,96,11,9,122,102,123,103,104,17,117]),function(G,t,g,T,y,I,C,D,u,d,v,p,E,F,c,f,P,S,w,l,r,s,e,i,n,o,a,h,m,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const L="unsetUninstalled",k="downloading";let j=class extends N.AbstractExtensionManagementService{constructor(J,W,x,q,U,R,M){super(J,W,x);this.environmentService=q,this.downloadService=U;const b=this._register(R.createInstance(a.ExtensionsLifecycle));this.extensionsScanner=this._register(R.createInstance(o.ExtensionsScanner,A=>b.postUninstall(A))),this.manifestCache=this._register(new c.ExtensionsManifestCache(q,this)),this.extensionsDownloader=this._register(R.createInstance(n.ExtensionsDownloader));const O=this._register(new h.ExtensionsWatcher(this,M,q,x));this._register(O.onDidChangeExtensionsByAnotherSource(({added:A,removed:V})=>{A.length&&this._onDidInstallExtensions.fire(A.map(B=>({identifier:B.identifier,operation:0,local:B}))),V.forEach(B=>this._onDidUninstallExtension.fire({identifier:B}))}))}async zip(J){this.logService.trace("ExtensionManagementService#zip",J.identifier.id);const W=await this.collectFiles(J),x=await(0,I.zip)((0,w.joinPath)(this.environmentService.tmpDir,(0,l.generateUuid)()).fsPath,W);return v.URI.file(x)}async unzip(J){return this.logService.trace("ExtensionManagementService#unzip",J.toString()),(await this.install(J)).identifier}async getManifest(J){const W=await this.downloadVsix(J),x=T.resolve(W.fsPath);return(0,i.getManifest)(x)}getInstalled(J=null){return this.extensionsScanner.scanExtensions(J)}async canInstall(J){return!0}async install(J,W={}){this.logService.trace("ExtensionManagementService#install",J.toString());const x=await this.downloadVsix(J),q=await(0,i.getManifest)(T.resolve(x.fsPath));if(q.engines&&q.engines.vscode&&!(0,S.isEngineValid)(q.engines.vscode,p.default.version,p.default.date))throw new Error(g.localize(0,null,(0,D.getGalleryExtensionId)(q.publisher,q.name),p.default.version));return this.installExtension(q,x,W)}async updateMetadata(J,W){return this.logService.trace("ExtensionManagementService#updateMetadata",J.identifier.id),J=await this.extensionsScanner.saveMetadataForLocalExtension(J,{...J.manifest.__metadata||{},...W}),this.manifestCache.invalidate(),J}async updateExtensionScope(J,W){return this.logService.trace("ExtensionManagementService#updateExtensionScope",J.identifier.id),J=await this.extensionsScanner.saveMetadataForLocalExtension(J,{...J.manifest.__metadata||{},isMachineScoped:W}),this.manifestCache.invalidate(),J}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(J){if(J.scheme===e.Schemas.file)return J;if(!this.downloadService)throw new Error("Download service is not available");const W=(0,w.joinPath)(this.environmentService.tmpDir,(0,l.generateUuid)());return await this.downloadService.download(J,W),W}createInstallExtensionTask(J,W,x){return v.URI.isUri(W)?new ne(J,W,x,this.galleryService,this.extensionsScanner,this.logService):new Q(W,x,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(J,W){return new re(J,W,this.extensionsScanner)}async collectFiles(J){const W=async q=>{let U=await y.Promises.readdir(q);U=U.map(b=>T.join(q,b));const R=await Promise.all(U.map(b=>y.Promises.stat(b)));let M=Promise.resolve([]);return R.forEach((b,O)=>{const A=U[O];b.isFile()&&(M=M.then(V=>[...V,A])),b.isDirectory()&&(M=M.then(V=>W(A).then(B=>[...V,...B])))}),M};return(await W(J.location.fsPath)).map(q=>({path:`extension/${T.relative(J.location.fsPath,q)}`,localPath:q}))}};j=ue([fe(0,C.IExtensionGalleryService),fe(1,P.ITelemetryService),fe(2,F.ILogService),fe(3,u.INativeEnvironmentService),fe(4,(0,s.optional)(r.IDownloadService)),fe(5,s.IInstantiationService),fe(6,m.IFileService)],j),t.ExtensionManagementService=j;class _ extends N.AbstractExtensionTask{constructor(J,W,x,q){super();this.identifier=J,this.source=W,this.extensionsScanner=x,this.logService=q,this._operation=1}get operation(){return this._operation}async installExtension(J,W){try{const x=await this.unsetUninstalledAndGetLocal(J.identifierWithVersion);if(x)return J.metadata?this.extensionsScanner.saveMetadataForLocalExtension(x,J.metadata):x}catch(x){throw E.isMacintosh?new C.ExtensionManagementError(g.localize(1,null),L):new C.ExtensionManagementError(g.localize(2,null),L)}return this.extract(J,W)}async unsetUninstalledAndGetLocal(J){if(!await this.isUninstalled(J))return null;this.logService.trace("Removing the extension from uninstalled list:",J.id);const x=await this.extensionsScanner.setInstalled(J);return this.logService.info("Removed the extension from uninstalled list:",J.id),x}async isUninstalled(J){return!!(await this.extensionsScanner.getUninstalledExtensions())[J.key()]}async extract({zipPath:J,identifierWithVersion:W,metadata:x},q){let U=await this.extensionsScanner.extractUserExtension(W,J,q);return this.logService.info("Extracting completed.",W.id),x&&(U=await this.extensionsScanner.saveMetadataForLocalExtension(U,x)),U}}class Q extends _{constructor(J,W,x,q,U){super(J.identifier,J,q,U);this.gallery=J,this.options=W,this.extensionsDownloader=x}async doRun(J){const x=(await this.extensionsScanner.scanExtensions(null)).find(R=>(0,D.areSameExtensions)(R.identifier,this.gallery.identifier));x&&(this._operation=2);const q=await this.downloadInstallableExtension(this.gallery,this._operation);q.metadata.isMachineScoped=this.options.isMachineScoped||x?.isMachineScoped,q.metadata.isBuiltin=this.options.isBuiltin||x?.isBuiltin;const U=await this.installExtension(q,J);x&&d.neq(x.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(x);try{await this.extensionsDownloader.delete(v.URI.file(q.zipPath))}catch(R){}return U}async downloadInstallableExtension(J,W){const x={id:J.identifier.uuid,publisherId:J.publisherId,publisherDisplayName:J.publisherDisplayName};let q;try{this.logService.trace("Started downloading extension:",J.identifier.id),q=(await this.extensionsDownloader.downloadExtension(J,W)).fsPath,this.logService.info("Downloaded extension:",J.identifier.id,q)}catch(U){throw new C.ExtensionManagementError((0,N.joinErrors)(U).message,k)}try{const U=await(0,i.getManifest)(q);return{zipPath:q,identifierWithVersion:new D.ExtensionIdentifierWithVersion(J.identifier,U.version),metadata:x}}catch(U){throw new C.ExtensionManagementError((0,N.joinErrors)(U).message,N.INSTALL_ERROR_VALIDATING)}}}class ne extends _{constructor(J,W,x,q,U,R){super({id:(0,D.getGalleryExtensionId)(J.publisher,J.name)},W,U,R);this.manifest=J,this.location=W,this.options=x,this.galleryService=q}async doRun(J){const W=new D.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),q=(await this.extensionsScanner.scanExtensions(1)).find(R=>(0,D.areSameExtensions)(this.identifier,R.identifier)),U=await this.getMetadata(this.identifier.id,J);if(q)if(U.isMachineScoped=this.options.isMachineScoped||q.isMachineScoped,U.isBuiltin=this.options.isBuiltin||q.isBuiltin,this._operation=2,W.equals(new D.ExtensionIdentifierWithVersion(q.identifier,q.manifest.version)))try{await this.extensionsScanner.removeExtension(q,"existing")}catch(R){throw new Error(g.localize(3,null,this.manifest.displayName||this.manifest.name))}else d.gt(q.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(q);else{const R=await this.unsetUninstalledAndGetLocal(W);if(R)try{await this.extensionsScanner.removeExtension(R,"existing")}catch(M){throw new Error(g.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:T.resolve(this.location.fsPath),identifierWithVersion:W,metadata:U},J)}async getMetadata(J,W){try{const x=(await this.galleryService.query({names:[J],pageSize:1},W)).firstPage[0];if(x)return{id:x.identifier.uuid,publisherDisplayName:x.publisherDisplayName,publisherId:x.publisherId}}catch(x){}return{}}}class re extends N.AbstractExtensionTask{constructor(J,W,x){super();this.extension=J,this.options=W,this.extensionsScanner=x}async doRun(J){const W=[],x=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const q=new D.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);W.push(...x.filter(U=>q.equals(new D.ExtensionIdentifierWithVersion(U.identifier,U.manifest.version))))}else W.push(...x.filter(q=>(0,D.areSameExtensions)(q.identifier,this.extension.identifier)));if(!W.length)throw new Error(g.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...W),this.options.remove)for(const q of W)try{J.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(q)}catch(U){throw new Error(g.localize(6,null,(0,f.toErrorMessage)(U)))}}}}),define(Y[125],ee([0,1,134,113,2,12,8,112,27,14,16,21,99]),function(G,t,g,T,y,I,C,D,u,d,v,p,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let F=class extends y.Disposable{constructor(f,P,S){super();this.environmentService=P,this.logService=S,this.configure(f.getValue()),this._register(f.onDidChangeConfiguration(()=>this.configure(f.getValue()),this))}configure(f){this.proxyUrl=f.http&&f.http.proxy,this.strictSSL=!!(f.http&&f.http.proxyStrictSSL),this.authorization=f.http&&f.http.proxyAuthorization}async request(f,P){this.logService.trace("RequestService#request",f.url);const{proxyUrl:S,strictSSL:w}=this,l={...process.env,...await(0,E.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},r=f.agent?f.agent:await(0,D.getProxyAgent)(f.url||"",l,{proxyUrl:S,strictSSL:w});return f.agent=r,f.strictSSL=w,this.authorization&&(f.headers={...f.headers||{},"Proxy-Authorization":this.authorization}),this._request(f,P)}async getNodeRequest(f){return((0,T.parse)(f.url).protocol==="https:"?await new Promise((w,l)=>{G(["https"],w,l)}):await new Promise((w,l)=>{G(["http"],w,l)})).request}_request(f,P){return new Promise(async(S,w)=>{let l;const r=(0,T.parse)(f.url),s=f.getRawRequest?f.getRawRequest(f):await this.getNodeRequest(f),e={hostname:r.hostname,port:r.port?parseInt(r.port):r.protocol==="https:"?443:80,protocol:r.protocol,path:r.path,method:f.type||"GET",headers:f.headers,agent:f.agent,rejectUnauthorized:(0,I.isBoolean)(f.strictSSL)?f.strictSSL:!0};f.user&&f.password&&(e.auth=f.user+":"+f.password),l=s(e,i=>{const n=(0,I.isNumber)(f.followRedirects)?f.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...f,url:i.headers.location,followRedirects:n-1},P).then(S,w);else{let o=i;i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,g.createGunzip)())),S({res:i,stream:(0,v.streamToBufferReadableStream)(o)})}}),l.on("error",w),f.timeout&&l.setTimeout(f.timeout),f.data&&typeof f.data=="string"&&l.write(f.data),l.end(),P.onCancellationRequested(()=>{l.abort(),w((0,C.canceled)())})})}async resolveProxy(f){}};F=ue([fe(0,u.IConfigurationService),fe(1,p.INativeEnvironmentService),fe(2,d.ILogService)],F),t.RequestService=F}),define(Y[135],ee([0,1,31,38,136,10,3,4,34,52,50,101,21,89,22,124,118,35,56,119,116,55,125,27,111,120,14,9,106,121,107,17,108,2,42,97,7,105,53,8,28,16,33]),function(G,t,g,T,y,I,C,D,u,d,v,p,E,F,c,f,P,S,w,l,r,s,e,i,n,o,a,h,m,N,L,k,j,_,Q,ne,re,Z,J,W,x,q,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class R extends _.Disposable{constructor(O){super();this.argv=O,(0,y.gracefulify)(T),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[O,A]=await this.initServices();return O.invokeFunction(async V=>{const B=V.get(a.ILogService),$=V.get(k.IFileService),K=V.get(E.INativeEnvironmentService),te=V.get(c.IExtensionManagementCLIService);return B.info("CLI main",this.argv),this.registerErrorHandler(B),await this.doRun(K,te,$),(0,D.raceTimeout)((0,w.combinedAppender)(...A).flush(),1e3)})}async initServices(){const O=new d.ServiceCollection,A={_serviceBrand:void 0,...u.default};O.set(Q.IProductService,A);const V=new F.NativeEnvironmentService(this.argv,A);O.set(E.INativeEnvironmentService,V),await Promise.all([V.appSettingsHome.fsPath,V.extensionsPath].map(pe=>pe?I.Promises.mkdir(pe,{recursive:!0}):void 0));const B=(0,a.getLogLevel)(V),$=[];$.push(new m.SpdLogLogger("cli",(0,C.join)(V.logsPath,"cli.log"),!0,B)),B===a.LogLevel.Trace&&$.push(new a.ConsoleLogger(B));const K=this._register(new a.MultiplexLogService($));O.set(a.ILogService,K);const te=this._register(new L.FileService(K));O.set(k.IFileService,te);const ie=this._register(new j.DiskFileSystemProvider(K));te.registerProvider(h.Schemas.file,ie);const oe=this._register(new n.ConfigurationService(V.settingsResource,te));O.set(i.IConfigurationService,oe),await oe.initialize(),O.set(s.IRequestService,new v.SyncDescriptor(e.RequestService)),O.set(c.IExtensionManagementService,new v.SyncDescriptor(f.ExtensionManagementService)),O.set(c.IExtensionGalleryService,new v.SyncDescriptor(P.ExtensionGalleryService)),O.set(c.IExtensionManagementCLIService,new v.SyncDescriptor(ne.ExtensionManagementCLIService)),O.set(J.ILocalizationsService,new v.SyncDescriptor(Z.LocalizationsService));const le=[];if(V.isBuilt&&!V.isExtensionDevelopment&&!V.disableTelemetry&&A.enableTelemetry){A.aiConfig&&A.aiConfig.asimovKey&&le.push(new o.AppInsightsAppender("monacoworkbench",null,A.aiConfig.asimovKey));const{appRoot:pe,extensionsPath:De,installSourcePath:ke}=V,Te={appender:(0,w.combinedAppender)(...le),sendErrorTelemetry:!1,commonProperties:(async()=>{let we;try{const Fe=await I.Promises.readFile((0,C.join)(V.userDataPath,"storage.json"));we=JSON.parse(Fe.toString())[S.machineIdKey]}catch(Fe){Fe.code!=="ENOENT"&&K.error(Fe)}return(0,r.resolveCommonProperties)(te,(0,g.release)(),(0,g.hostname)(),process.arch,A.commit,A.version,we,A.msftInternalDomains,ke)})(),piiPaths:[pe,De]};O.set(S.ITelemetryService,new v.SyncDescriptor(l.TelemetryService,[Te]))}else O.set(S.ITelemetryService,w.NullTelemetryService);return[new p.InstantiationService(O),le]}registerErrorHandler(O){(0,W.setUnexpectedErrorHandler)(A=>{const V=(0,x.toErrorMessage)(A,!0);!V||O.error(`[uncaught exception in CLI]: ${V}`)})}async doRun(O,A,V){if(this.argv["install-source"])return this.setInstallSource(O,V,this.argv["install-source"]);if(this.argv["list-extensions"])return A.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return A.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return A.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return A.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,N.buildTelemetryMessage)(O.appRoot,O.extensionsPath))}asExtensionIdOrVSIX(O){return O.map(A=>/\.vsix$/i.test(A)?re.URI.file((0,C.isAbsolute)(A)?A:(0,C.join)((0,U.cwd)(),A)):A)}async setInstallSource(O,A,V){await A.writeFile(re.URI.file(O.installSourcePath),q.VSBuffer.fromString(V.slice(0,30)))}}async function M(b){const O=new R(b);try{await O.run()}finally{O.dispose()}}t.main=M})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b805d2e94937976bb17d0439f57fcd3a9d423c31/core/vs/code/node/cliProcessMain.js.map
