/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/network","vs/base/common/errors","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/platform/log/common/log","vs/base/common/async","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/map","vs/base/common/platform","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/editor/common/core/range","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/uuid","vs/editor/common/core/position","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/process","vs/base/common/hash","vs/base/common/severity","vs/base/common/extpath","vs/platform/contextkey/common/contextkey","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],Ee=function(ee){for(var e=[],g=0,F=ee.length;g<F;g++)e[g]=be[ee[g]];return e};define(be[40],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function g(F,S){if(!F)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=g}),define(be[50],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const g=Object.prototype.hasOwnProperty;function F(n){const I=[];for(let l in n)g.call(n,l)&&I.push(n[l]);return I}e.values=F;function S(n,I){for(let l in n)if(g.call(n,l)&&I({key:l,value:n[l]},function(){delete n[l]})===!1)return}e.forEach=S;function E(n,I){const l=Object.create(null);for(const d of n){const u=I(d);let m=l[u];m||(m=l[u]=[]),m.push(d)}return l}e.groupBy=E;function C(n){const I=Object.create(null);return n&&n.forEach((l,d)=>{I[d]=l}),I}e.fromMap=C;function y(n,I){const l=[],d=[];for(let u of n)I.has(u)||l.push(u);for(let u of I)n.has(u)||d.push(u);return{removed:l,added:d}}e.diffSets=y;function _(n,I){const l=[],d=[];for(let[u,m]of n)I.has(u)||l.push(m);for(let[u,m]of I)n.has(u)||d.push(m);return{removed:l,added:d}}e.diffMaps=_;class k{constructor(){this.map=new Map}add(I,l){let d=this.map.get(I);d||(d=new Set,this.map.set(I,d)),d.add(l)}delete(I,l){const d=this.map.get(I);!d||(d.delete(l),d.size===0&&this.map.delete(I))}forEach(I,l){const d=this.map.get(I);!d||d.forEach(l)}}e.SetMap=k}),define(be[51],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function g(C){return(y,_,k)=>{let n=null,I=null;if(typeof k.value=="function"?(n="value",I=k.value):typeof k.get=="function"&&(n="get",I=k.get),!I)throw new Error("not supported");k[n]=C(I,_)}}e.createDecorator=g;function F(C,y,_){let k=null,n=null;if(typeof _.value=="function"?(k="value",n=_.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(k="get",n=_.get),!n)throw new Error("not supported");const I=`$memoize$${y}`;_[k]=function(...l){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,l)}),this[I]}}e.memoize=F;function S(C,y,_){return g((k,n)=>{const I=`$debounce$${n}`,l=`$debounce$result$${n}`;return function(...d){this[l]||(this[l]=_?_():void 0),clearTimeout(this[I]),y&&(this[l]=y(this[l],...d),d=[this[l]]),this[I]=setTimeout(()=>{k.apply(this,d),this[l]=_?_():void 0},C)}})}e.debounce=S;function E(C,y,_){return g((k,n)=>{const I=`$throttle$timer$${n}`,l=`$throttle$result$${n}`,d=`$throttle$lastRun$${n}`,u=`$throttle$pending$${n}`;return function(...m){if(this[l]||(this[l]=_?_():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),y&&(this[l]=y(this[l],...m)),this[u])return;const b=this[d]+C;b<=Date.now()?(this[d]=Date.now(),k.apply(this,[this[l]]),this[l]=_?_():void 0):(this[u]=!0,this[I]=setTimeout(()=>{this[u]=!1,this[d]=Date.now(),k.apply(this,[this[l]]),this[l]=_?_():void 0},b-Date.now()))}})}e.throttle=E}),define(be[12],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class g{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=g,e.errorHandler=new g;function F(v){e.errorHandler.setUnexpectedErrorHandler(v)}e.setUnexpectedErrorHandler=F;function S(v){_(v)||e.errorHandler.onUnexpectedError(v)}e.onUnexpectedError=S;function E(v){_(v)||e.errorHandler.onUnexpectedExternalError(v)}e.onUnexpectedExternalError=E;function C(v){if(v instanceof Error){let{name:t,message:r}=v;const s=v.stacktrace||v.stack;return{$isError:!0,name:t,message:r,stack:s}}return v}e.transformErrorForSerialization=C;const y="Canceled";function _(v){return v instanceof Error&&v.name===y&&v.message===y}e.isPromiseCanceledError=_;class k extends Error{constructor(){super(y);this.name=this.message}}e.CancellationError=k;function n(){const v=new Error(y);return v.name=v.message,v}e.canceled=n;function I(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}e.illegalArgument=I;function l(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}e.illegalState=l;function d(v){return v?new Error(`readonly property '${v} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=d;function u(v){const t=new Error(`${v} has been disposed`);return t.name="DISPOSED",t}e.disposed=u;function m(v){return v?v.message?v.message:v.stack?v.stack.split(`
`)[0]:String(v):"Error"}e.getErrorMessage=m;class b extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=b;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class P extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=P;function a(v){const t=v;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=a;function f(v,t=Object.create(null)){const r=new Error(v);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=f}),define(be[17],Ee([0,1,12]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function F(B,ne=0){return B[B.length-(1+ne)]}e.tail=F;function S(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=S;function E(B,ne,ue=(ye,Re)=>ye===Re){if(B===ne)return!0;if(!B||!ne||B.length!==ne.length)return!1;for(let ye=0,Re=B.length;ye<Re;ye++)if(!ue(B[ye],ne[ye]))return!1;return!0}e.equals=E;function C(B,ne,ue){let ye=0,Re=B.length-1;for(;ye<=Re;){const Te=(ye+Re)/2|0,$e=ue(B[Te],ne);if($e<0)ye=Te+1;else if($e>0)Re=Te-1;else return Te}return-(ye+1)}e.binarySearch=C;function y(B,ne){let ue=0,ye=B.length;if(ye===0)return 0;for(;ue<ye;){const Re=Math.floor((ue+ye)/2);ne(B[Re])?ye=Re:ue=Re+1}return ue}e.findFirstInSorted=y;function _(B,ne,ue){if(B=B|0,B>=ne.length)throw new TypeError("invalid index");let ye=ne[Math.floor(ne.length*Math.random())],Re=[],Te=[],$e=[];for(let Je of ne){const Ve=ue(Je,ye);Ve<0?Re.push(Je):Ve>0?Te.push(Je):$e.push(Je)}return B<Re.length?_(B,Re,ue):B<Re.length+$e.length?$e[0]:_(B-(Re.length+$e.length),Te,ue)}e.quickSelect=_;function k(B,ne){const ue=[];let ye;for(const Re of B.slice(0).sort(ne))!ye||ne(ye[0],Re)!==0?(ye=[Re],ue.push(ye)):ye.push(Re);return ue}e.groupBy=k;function n(B,ne,ue){const ye=[];function Re(Je,Ve,je){if(Ve===0&&je.length===0)return;const O=ye[ye.length-1];O&&O.start+O.deleteCount===Je?(O.deleteCount+=Ve,O.toInsert.push(...je)):ye.push({start:Je,deleteCount:Ve,toInsert:je})}let Te=0,$e=0;for(;;){if(Te===B.length){Re(Te,0,ne.slice($e));break}if($e===ne.length){Re(Te,B.length-Te,[]);break}const Je=B[Te],Ve=ne[$e],je=ue(Je,Ve);je===0?(Te+=1,$e+=1):je<0?(Re(Te,1,[]),Te+=1):je>0&&(Re(Te,0,[Ve]),$e+=1)}return ye}e.sortedDiff=n;function I(B,ne,ue){const ye=n(B,ne,ue),Re=[],Te=[];for(const $e of ye)Re.push(...B.slice($e.start,$e.start+$e.deleteCount)),Te.push(...$e.toInsert);return{removed:Re,added:Te}}e.delta=I;function l(B,ne,ue){if(ue===0)return[];const ye=B.slice(0,ue).sort(ne);return u(B,ne,ye,ue,B.length),ye}e.top=l;function d(B,ne,ue,ye,Re){return ue===0?Promise.resolve([]):new Promise((Te,$e)=>{(async()=>{const Je=B.length,Ve=B.slice(0,ue).sort(ne);for(let je=ue,O=Math.min(ue+ye,Je);je<Je;je=O,O=Math.min(O+ye,Je)){if(je>ue&&await new Promise(K=>setTimeout(K)),Re&&Re.isCancellationRequested)throw(0,g.canceled)();u(B,ne,Ve,je,O)}return Ve})().then(Te,$e)})}e.topAsync=d;function u(B,ne,ue,ye,Re){for(const Te=ue.length;ye<Re;ye++){const $e=B[ye];if(ne($e,ue[Te-1])<0){ue.pop();const Je=y(ue,Ve=>ne($e,Ve)<0);ue.splice(Je,0,$e)}}}function m(B){return B.filter(ne=>!!ne)}e.coalesce=m;function b(B){let ne=0;for(let ue=0;ue<B.length;ue++)B[ue]&&(B[ne]=B[ue],ne+=1);B.length=ne}e.coalesceInPlace=b;function w(B,ne,ue){B.splice(ue,0,B.splice(ne,1)[0])}e.move=w;function P(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=P;function a(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=a;function f(B,ne){if(!ne)return B.filter((ye,Re)=>B.indexOf(ye)===Re);const ue=Object.create(null);return B.filter(ye=>{const Re=ne(ye);return ue[Re]?!1:(ue[Re]=!0,!0)})}e.distinct=f;function v(B){const ne=new Set;return B.filter(ue=>ne.has(ue)?!1:(ne.add(ue),!0))}e.distinctES6=v;function t(B){const ne=Object.create(null);return ue=>{const ye=B(ue);return ne[ye]?!1:(ne[ye]=!0,!0)}}e.uniqueFilter=t;function r(B,ne){for(let ue=B.length-1;ue>=0;ue--){const ye=B[ue];if(ne(ye))return ue}return-1}e.lastIndex=r;function s(B,ne){return B.length>0?B[0]:ne}e.firstOrDefault=s;function i(B,ne,ue=(ye,Re)=>ye===Re){let ye=0;for(let Re=0,Te=Math.min(B.length,ne.length);Re<Te&&ue(B[Re],ne[Re]);Re++)ye++;return ye}e.commonPrefixLength=i;function c(B){return[].concat(...B)}e.flatten=c;function h(B,ne){let ue=typeof ne=="number"?B:0;typeof ne=="number"?ue=B:(ue=0,ne=B);const ye=[];if(ue<=ne)for(let Re=ue;Re<ne;Re++)ye.push(Re);else for(let Re=ue;Re>ne;Re--)ye.push(Re);return ye}e.range=h;function p(B,ne,ue){return B.reduce((ye,Re)=>(ye[ne(Re)]=ue?ue(Re):Re,ye),Object.create(null))}e.index=p;function D(B,ne){return B.push(ne),()=>T(B,ne)}e.insert=D;function T(B,ne){const ue=B.indexOf(ne);if(ue>-1)return B.splice(ue,1),ne}e.remove=T;function o(B,ne,ue){const ye=B.slice(0,ne),Re=B.slice(ne);return ye.concat(ue,Re)}e.arrayInsert=o;function A(B,ne){let ue;if(typeof ne=="number"){let ye=ne;ue=()=>{const Re=Math.sin(ye++)*179426549;return Re-Math.floor(Re)}}else ue=Math.random;for(let ye=B.length-1;ye>0;ye-=1){const Re=Math.floor(ue()*(ye+1)),Te=B[ye];B[ye]=B[Re],B[Re]=Te}}e.shuffle=A;function L(B,ne){const ue=B.indexOf(ne);ue>-1&&(B.splice(ue,1),B.unshift(ne))}e.pushToStart=L;function $(B,ne){const ue=B.indexOf(ne);ue>-1&&(B.splice(ue,1),B.push(ne))}e.pushToEnd=$;function oe(B,ne){return Array.isArray(B)?B.map(ne):ne(B)}e.mapArrayOrNot=oe;function he(B){return Array.isArray(B)?B:[B]}e.asArray=he;function Q(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=Q;function z(B,ne){for(const ue of B){const ye=ne(ue);if(ye!==void 0)return ye}}e.mapFind=z;function V(B,ne,ue){const ye=G(B,ne),Re=B.length,Te=ue.length;B.length=Re+Te;for(let $e=Re-1;$e>=ye;$e--)B[$e+Te]=B[$e];for(let $e=0;$e<Te;$e++)B[$e+ye]=ue[$e]}e.insertInto=V;function R(B,ne,ue,ye){const Re=G(B,ne),Te=B.splice(Re,ue);return V(B,Re,ye),Te}e.splice=R;function G(B,ne){return ne<0?Math.max(ne+B.length,0):Math.min(ne,B.length)}function x(B,ne){let ue=Number.MAX_SAFE_INTEGER,ye=0;return B.forEach((Re,Te)=>{const $e=ne(Re);$e<ue&&(ue=$e,ye=Te)}),ye}e.minIndex=x;function j(B,ne){let ue=Number.MIN_SAFE_INTEGER,ye=0;return B.forEach((Re,Te)=>{const $e=ne(Re);$e>ue&&(ue=$e,ye=Te)}),ye}e.maxIndex=j;class de{constructor(ne){this.items=ne,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ne){let ue=this.firstIdx;for(;ue<this.items.length&&ne(this.items[ue]);)ue++;const ye=ue===this.firstIdx?null:this.items.slice(this.firstIdx,ue);return this.firstIdx=ue,ye}takeFromEndWhile(ne){let ue=this.lastIdx;for(;ue>=0&&ne(this.items[ue]);)ue--;const ye=ue===this.lastIdx?null:this.items.slice(ue+1,this.lastIdx+1);return this.lastIdx=ue,ye}}e.ArrayQueue=de}),define(be[52],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function g(F){const S=this;let E=!1,C;return function(){return E||(E=!0,C=F.apply(S,arguments)),C}}e.once=g}),define(be[53],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class g{constructor(S){this._prefix=S,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=g,e.defaultGenerator=new g("id#")}),define(be[54],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var g;(function(F){function S(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}F.is=S;const E=Object.freeze([]);function C(){return E}F.empty=C;function*y(v){yield v}F.single=y;function _(v){return v||E}F.from=_;function k(v){return!v||v[Symbol.iterator]().next().done===!0}F.isEmpty=k;function n(v){return v[Symbol.iterator]().next().value}F.first=n;function I(v,t){for(const r of v)if(t(r))return!0;return!1}F.some=I;function l(v,t){for(const r of v)if(t(r))return r}F.find=l;function*d(v,t){for(const r of v)t(r)&&(yield r)}F.filter=d;function*u(v,t){let r=0;for(const s of v)yield t(s,r++)}F.map=u;function*m(...v){for(const t of v)for(const r of t)yield r}F.concat=m;function*b(v){for(const t of v)for(const r of t)yield r}F.concatNested=b;function w(v,t,r){let s=r;for(const i of v)s=t(s,i);return s}F.reduce=w;function*P(v,t,r=v.length){for(t<0&&(t+=v.length),r<0?r+=v.length:r>v.length&&(r=v.length);t<r;t++)yield v[t]}F.slice=P;function a(v,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,v];const s=v[Symbol.iterator]();for(let i=0;i<t;i++){const c=s.next();if(c.done)return[r,F.empty()];r.push(c.value)}return[r,{[Symbol.iterator](){return s}}]}F.consume=a;function f(v,t,r=(s,i)=>s===i){const s=v[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const c=s.next(),h=i.next();if(c.done!==h.done)return!1;if(c.done)return!0;if(!r(c.value,h.value))return!1}}F.equals=f})(g=e.Iterable||(e.Iterable={}))}),define(be[111],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var g;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(g=e.ScanError||(e.ScanError={}));var F;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(F=e.SyntaxKind||(e.SyntaxKind={}));var S;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(S=e.ParseErrorCode||(e.ParseErrorCode={}));var E;(function(t){t.DEFAULT={allowTrailingComma:!0}})(E=e.ParseOptions||(e.ParseOptions={}));function C(t,r=!1){let s=0,i=t.length,c="",h=0,p=16,D=0;function T(Q){let z=0,V=0;for(;z<Q;){const R=t.charCodeAt(s);if(R>=48&&R<=57)V=V*16+R-48;else if(R>=65&&R<=70)V=V*16+R-65+10;else if(R>=97&&R<=102)V=V*16+R-97+10;else break;s++,z++}return z<Q&&(V=-1),V}function o(Q){s=Q,c="",h=0,p=16,D=0}function A(){const Q=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&k(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&k(t.charCodeAt(s)))for(s++;s<t.length&&k(t.charCodeAt(s));)s++;else return D=3,t.substring(Q,s);let z=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&k(t.charCodeAt(s))){for(s++;s<t.length&&k(t.charCodeAt(s));)s++;z=s}else D=3;return t.substring(Q,z)}function L(){let Q="",z=s;for(;;){if(s>=i){Q+=t.substring(z,s),D=2;break}const V=t.charCodeAt(s);if(V===34){Q+=t.substring(z,s),s++;break}if(V===92){if(Q+=t.substring(z,s),s++,s>=i){D=2;break}switch(t.charCodeAt(s++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:const G=T(4);G>=0?Q+=String.fromCharCode(G):D=4;break;default:D=5}z=s;continue}if(V>=0&&V<=31)if(_(V)){Q+=t.substring(z,s),D=2;break}else D=6;s++}return Q}function $(){if(c="",D=0,h=s,s>=i)return h=i,p=17;let Q=t.charCodeAt(s);if(y(Q)){do s++,c+=String.fromCharCode(Q),Q=t.charCodeAt(s);while(y(Q));return p=15}if(_(Q))return s++,c+=String.fromCharCode(Q),Q===13&&t.charCodeAt(s)===10&&(s++,c+=`
`),p=14;switch(Q){case 123:return s++,p=1;case 125:return s++,p=2;case 91:return s++,p=3;case 93:return s++,p=4;case 58:return s++,p=6;case 44:return s++,p=5;case 34:return s++,c=L(),p=10;case 47:const z=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<i&&!_(t.charCodeAt(s));)s++;return c=t.substring(z,s),p=12}if(t.charCodeAt(s+1)===42){s+=2;const V=i-1;let R=!1;for(;s<V;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,R=!0;break}s++}return R||(s++,D=1),c=t.substring(z,s),p=13}return c+=String.fromCharCode(Q),s++,p=16;case 45:if(c+=String.fromCharCode(Q),s++,s===i||!k(t.charCodeAt(s)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=A(),p=11;default:for(;s<i&&oe(Q);)s++,Q=t.charCodeAt(s);if(h!==s){switch(c=t.substring(h,s),c){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return c+=String.fromCharCode(Q),s++,p=16}}function oe(Q){if(y(Q)||_(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function he(){let Q;do Q=$();while(Q>=12&&Q<=15);return Q}return{setPosition:o,getPosition:()=>s,scan:r?he:$,getToken:()=>p,getTokenValue:()=>c,getTokenOffset:()=>h,getTokenLength:()=>s-h,getTokenError:()=>D}}e.createScanner=C;function y(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function _(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function I(t,r){const s=[],i=new Object;let c;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function D(T,o,A,L){h.value=T,h.offset=o,h.length=A,h.type=L,h.colonOffset=void 0,c=h}try{a(t,{onObjectBegin:(T,o)=>{if(r<=T)throw i;c=void 0,p=r>T,s.push("")},onObjectProperty:(T,o,A)=>{if(r<o||(D(T,o,A,"property"),s[s.length-1]=T,r<=o+A))throw i},onObjectEnd:(T,o)=>{if(r<=T)throw i;c=void 0,s.pop()},onArrayBegin:(T,o)=>{if(r<=T)throw i;c=void 0,s.push(0)},onArrayEnd:(T,o)=>{if(r<=T)throw i;c=void 0,s.pop()},onLiteralValue:(T,o,A)=>{if(r<o||(D(T,o,A,v(T)),r<=o+A))throw i},onSeparator:(T,o,A)=>{if(r<=o)throw i;if(T===":"&&c&&c.type==="property")c.colonOffset=o,p=!1,c=void 0;else if(T===","){const L=s[s.length-1];typeof L=="number"?s[s.length-1]=L+1:(p=!0,s[s.length-1]=""),c=void 0}}})}catch(T){if(T!==i)throw T}return{path:s,previousNode:c,isAtPropertyKey:p,matches:T=>{let o=0;for(let A=0;o<T.length&&A<s.length;A++)if(T[o]===s[A]||T[o]==="*")o++;else if(T[o]!=="**")return!1;return o===T.length}}}e.getLocation=I;function l(t,r=[],s=E.DEFAULT){let i=null,c=[];const h=[];function p(T){Array.isArray(c)?c.push(T):i!==null&&(c[i]=T)}return a(t,{onObjectBegin:()=>{const T={};p(T),h.push(c),c=T,i=null},onObjectProperty:T=>{i=T},onObjectEnd:()=>{c=h.pop()},onArrayBegin:()=>{const T=[];p(T),h.push(c),c=T,i=null},onArrayEnd:()=>{c=h.pop()},onLiteralValue:p,onError:(T,o,A)=>{r.push({error:T,offset:o,length:A})}},s),c[0]}e.parse=l;function d(t,r=[],s=E.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(T){i.type==="property"&&(i.length=T-i.offset,i=i.parent)}function h(T){return i.children.push(T),T}a(t,{onObjectBegin:T=>{i=h({type:"object",offset:T,length:-1,parent:i,children:[]})},onObjectProperty:(T,o,A)=>{i=h({type:"property",offset:o,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:T,offset:o,length:A,parent:i})},onObjectEnd:(T,o)=>{i.length=T+o-i.offset,i=i.parent,c(T+o)},onArrayBegin:(T,o)=>{i=h({type:"array",offset:T,length:-1,parent:i,children:[]})},onArrayEnd:(T,o)=>{i.length=T+o-i.offset,i=i.parent,c(T+o)},onLiteralValue:(T,o,A)=>{h({type:v(T),offset:o,length:A,parent:i,value:T}),c(o+A)},onSeparator:(T,o,A)=>{i.type==="property"&&(T===":"?i.colonOffset=o:T===","&&c(o))},onError:(T,o,A)=>{r.push({error:T,offset:o,length:A})}},s);const D=i.children[0];return D&&delete D.parent,D}e.parseTree=d;function u(t,r){if(!t)return;let s=t;for(let i of r)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let c=!1;for(const h of s.children)if(Array.isArray(h.children)&&h.children[0].value===i){s=h.children[1],c=!0;break}if(!c)return}else{const c=i;if(s.type!=="array"||c<0||!Array.isArray(s.children)||c>=s.children.length)return;s=s.children[c]}return s}e.findNodeAtLocation=u;function m(t){if(!t.parent||!t.parent.children)return[];const r=m(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}e.getNodePath=m;function b(t){switch(t.type){case"array":return t.children.map(b);case"object":const r=Object.create(null);for(let s of t.children){const i=s.children[1];i&&(r[s.children[0].value]=b(i))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=b;function w(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}e.contains=w;function P(t,r,s=!1){if(w(t,r,s)){const i=t.children;if(Array.isArray(i))for(let c=0;c<i.length&&i[c].offset<=r;c++){const h=P(i[c],r,s);if(h)return h}return t}}e.findNodeAtOffset=P;function a(t,r,s=E.DEFAULT){const i=C(t,!1);function c(ue){return ue?()=>ue(i.getTokenOffset(),i.getTokenLength()):()=>!0}function h(ue){return ue?ye=>ue(ye,i.getTokenOffset(),i.getTokenLength()):()=>!0}const p=c(r.onObjectBegin),D=h(r.onObjectProperty),T=c(r.onObjectEnd),o=c(r.onArrayBegin),A=c(r.onArrayEnd),L=h(r.onLiteralValue),$=h(r.onSeparator),oe=c(r.onComment),he=h(r.onError),Q=s&&s.disallowComments,z=s&&s.allowTrailingComma;function V(){for(;;){const ue=i.scan();switch(i.getTokenError()){case 4:R(14);break;case 5:R(15);break;case 3:R(13);break;case 1:Q||R(11);break;case 2:R(12);break;case 6:R(16);break}switch(ue){case 12:case 13:Q?R(10):oe();break;case 16:R(1);break;case 15:case 14:break;default:return ue}}}function R(ue,ye=[],Re=[]){if(he(ue),ye.length+Re.length>0){let Te=i.getToken();for(;Te!==17;){if(ye.indexOf(Te)!==-1){V();break}else if(Re.indexOf(Te)!==-1)break;Te=V()}}}function G(ue){const ye=i.getTokenValue();return ue?L(ye):D(ye),V(),!0}function x(){switch(i.getToken()){case 11:let ue=0;try{ue=JSON.parse(i.getTokenValue()),typeof ue!="number"&&(R(2),ue=0)}catch(ye){R(2)}L(ue);break;case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return V(),!0}function j(){return i.getToken()!==10?(R(3,[],[2,5]),!1):(G(!1),i.getToken()===6?($(":"),V(),ne()||R(4,[],[2,5])):R(5,[],[2,5]),!0)}function de(){p(),V();let ue=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ue||R(4,[],[]),$(","),V(),i.getToken()===2&&z)break}else ue&&R(6,[],[]);j()||R(4,[],[2,5]),ue=!0}return T(),i.getToken()!==2?R(7,[2],[]):V(),!0}function B(){o(),V();let ue=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ue||R(4,[],[]),$(","),V(),i.getToken()===4&&z)break}else ue&&R(6,[],[]);ne()||R(4,[],[4,5]),ue=!0}return A(),i.getToken()!==4?R(8,[4],[]):V(),!0}function ne(){switch(i.getToken()){case 3:return B();case 1:return de();case 10:return G(!0);default:return x()}}return V(),i.getToken()===17?s.allowEmptyContent?!0:(R(4,[],[]),!1):ne()?(i.getToken()!==17&&R(9,[],[]),!0):(R(4,[],[]),!1)}e.visit=a;function f(t,r){let s=C(t),i=[],c,h=0,p;do switch(p=s.getPosition(),c=s.scan(),c){case 12:case 13:case 17:h!==p&&i.push(t.substring(h,p)),r!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,r)),h=s.getPosition();break}while(c!==17);return i.join("")}e.stripComments=f;function v(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(be[112],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class g{constructor(S){this.executor=S,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(S){this._error=S}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(S){return new g(()=>S(this.getValue()))}}e.Lazy=g}),define(be[6],Ee([0,1,52,54]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const S=!1;let E=null;function C(s){E=s}if(e.setDisposableTracker=C,S){const s="__is_disposable_tracked__";C(new class{trackDisposable(i){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[s]||console.log(c)},3e3)}setParent(i,c){if(i&&i!==P.None)try{i[s]=!0}catch{}}markAsDisposed(i){if(i&&i!==P.None)try{i[s]=!0}catch{}}markAsSingleton(i){}})}function y(s){return E?.trackDisposable(s),s}function _(s){E?.markAsDisposed(s)}function k(s,i){E?.setParent(s,i)}function n(s,i){if(!!E)for(const c of s)E.setParent(c,i)}function I(s){return E?.markAsSingleton(s),s}e.markAsSingleton=I;class l extends Error{constructor(i){super(`Encountered errors while disposing of store. Errors: [${i.join(", ")}]`);this.errors=i}}e.MultiDisposeError=l;function d(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=d;function u(s){if(F.Iterable.is(s)){let i=[];for(const c of s)if(c)try{c.dispose()}catch(h){i.push(h)}if(i.length===1)throw i[0];if(i.length>1)throw new l(i);return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=u;function m(...s){const i=b(()=>u(s));return n(s,i),i}e.combinedDisposable=m;function b(s){const i=y({dispose:(0,g.once)(()=>{_(i),s()})});return i}e.toDisposable=b;class w{constructor(){this._toDispose=new Set,this._isDisposed=!1,y(this)}dispose(){this._isDisposed||(_(this),this._isDisposed=!0,this.clear())}clear(){try{u(this._toDispose.values())}finally{this._toDispose.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return k(i,this),this._isDisposed?w.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(i),i}}e.DisposableStore=w,w.DISABLE_DISPOSED_WARNING=!1;class P{constructor(){this._store=new w,y(this),k(this._store,this)}dispose(){_(this),this._store.dispose()}_register(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(i)}}e.Disposable=P,P.None=Object.freeze({dispose(){}});class a{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(i){this._isDisposed||i===this._value||(this._value?.dispose(),i&&k(i,this),this._value=i)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,_(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const i=this._value;return this._value=void 0,i&&k(i,null),i}}e.MutableDisposable=a;class f{constructor(i){this._disposable=i,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=f;class v{constructor(){this.references=new Map}acquire(i,...c){let h=this.references.get(i);h||(h={counter:0,object:this.createReferencedObject(i,...c)},this.references.set(i,h));const{object:p}=h,D=(0,g.once)(()=>{--h.counter==0&&(this.destroyReferencedObject(i,h.object),this.references.delete(i))});return h.counter++,{object:p,dispose:D}}}e.ReferenceCollection=v;class t{constructor(i){this.referenceCollection=i}async acquire(i,...c){const h=this.referenceCollection.acquire(i,...c);try{return{object:await h.object,dispose:()=>h.dispose()}}catch(p){throw h.dispose(),p}}}e.AsyncReferenceCollection=t;class r{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=r}),define(be[80],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class g{constructor(E){this.element=E,this.next=g.Undefined,this.prev=g.Undefined}}g.Undefined=new g(void 0);class F{constructor(){this._first=g.Undefined,this._last=g.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===g.Undefined}clear(){let E=this._first;for(;E!==g.Undefined;){const C=E.next;E.prev=g.Undefined,E.next=g.Undefined,E=C}this._first=g.Undefined,this._last=g.Undefined,this._size=0}unshift(E){return this._insert(E,!1)}push(E){return this._insert(E,!0)}_insert(E,C){const y=new g(E);if(this._first===g.Undefined)this._first=y,this._last=y;else if(C){const k=this._last;this._last=y,y.prev=k,k.next=y}else{const k=this._first;this._first=y,y.next=k,k.prev=y}this._size+=1;let _=!1;return()=>{_||(_=!0,this._remove(y))}}shift(){if(this._first!==g.Undefined){const E=this._first.element;return this._remove(this._first),E}}pop(){if(this._last!==g.Undefined){const E=this._last.element;return this._remove(this._last),E}}_remove(E){if(E.prev!==g.Undefined&&E.next!==g.Undefined){const C=E.prev;C.next=E.next,E.next.prev=C}else E.prev===g.Undefined&&E.next===g.Undefined?(this._first=g.Undefined,this._last=g.Undefined):E.next===g.Undefined?(this._last=this._last.prev,this._last.next=g.Undefined):E.prev===g.Undefined&&(this._first=this._first.next,this._first.prev=g.Undefined);this._size-=1}*[Symbol.iterator](){let E=this._first;for(;E!==g.Undefined;)yield E.element,E=E.next}}e.LinkedList=F}),function(ee,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ee=typeof globalThis!="undefined"?globalThis:ee||self,ee.marked=e())}(this,function(){"use strict";function ee(De,Se){for(var Pe=0;Pe<Se.length;Pe++){var re=Se[Pe];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(De,re.key,re)}}function e(De,Se,Pe){return Se&&ee(De.prototype,Se),Pe&&ee(De,Pe),De}function g(De,Se){if(!!De){if(typeof De=="string")return F(De,Se);var Pe=Object.prototype.toString.call(De).slice(8,-1);if(Pe==="Object"&&De.constructor&&(Pe=De.constructor.name),Pe==="Map"||Pe==="Set")return Array.from(De);if(Pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Pe))return F(De,Se)}}function F(De,Se){(Se==null||Se>De.length)&&(Se=De.length);for(var Pe=0,re=new Array(Se);Pe<Se;Pe++)re[Pe]=De[Pe];return re}function S(De,Se){var Pe;if(typeof Symbol=="undefined"||De[Symbol.iterator]==null){if(Array.isArray(De)||(Pe=g(De))||Se&&De&&typeof De.length=="number"){Pe&&(De=Pe);var re=0;return function(){return re>=De.length?{done:!0}:{done:!1,value:De[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Pe=De[Symbol.iterator](),Pe.next.bind(Pe)}function E(De){var Se={exports:{}};return De(Se,Se.exports),Se.exports}var C=E(function(De){function Se(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Pe(re){De.exports.defaults=re}De.exports={defaults:Se(),getDefaults:Se,changeDefaults:Pe}}),y=/[&<>"']/,_=/[&<>"']/g,k=/[<>"']|&(?!#?\w+;)/,n=/[<>"']|&(?!#?\w+;)/g,I={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},l=function(Se){return I[Se]};function d(De,Se){if(Se){if(y.test(De))return De.replace(_,l)}else if(k.test(De))return De.replace(n,l);return De}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(De){return De.replace(u,function(Se,Pe){return Pe=Pe.toLowerCase(),Pe==="colon"?":":Pe.charAt(0)==="#"?Pe.charAt(1)==="x"?String.fromCharCode(parseInt(Pe.substring(2),16)):String.fromCharCode(+Pe.substring(1)):""})}var b=/(^|[^\[])\^/g;function w(De,Se){De=De.source||De,Se=Se||"";var Pe={replace:function(ae,fe){return fe=fe.source||fe,fe=fe.replace(b,"$1"),De=De.replace(ae,fe),Pe},getRegex:function(){return new RegExp(De,Se)}};return Pe}var P=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function f(De,Se,Pe){if(De){var re;try{re=decodeURIComponent(m(Pe)).replace(P,"").toLowerCase()}catch(ae){return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}Se&&!a.test(Pe)&&(Pe=i(Se,Pe));try{Pe=encodeURI(Pe).replace(/%25/g,"%")}catch(ae){return null}return Pe}var v={},t=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function i(De,Se){v[" "+De]||(t.test(De)?v[" "+De]=De+"/":v[" "+De]=D(De,"/",!0)),De=v[" "+De];var Pe=De.indexOf(":")===-1;return Se.substring(0,2)==="//"?Pe?Se:De.replace(r,"$1")+Se:Se.charAt(0)==="/"?Pe?Se:De.replace(s,"$1")+Se:De+Se}var c={exec:function(){}};function h(De){for(var Se=1,Pe,re;Se<arguments.length;Se++){Pe=arguments[Se];for(re in Pe)Object.prototype.hasOwnProperty.call(Pe,re)&&(De[re]=Pe[re])}return De}function p(De,Se){var Pe=De.replace(/\|/g,function(fe,pe,U){for(var me=!1,we=pe;--we>=0&&U[we]==="\\";)me=!me;return me?"|":" |"}),re=Pe.split(/ \|/),ae=0;if(re.length>Se)re.splice(Se);else for(;re.length<Se;)re.push("");for(;ae<re.length;ae++)re[ae]=re[ae].trim().replace(/\\\|/g,"|");return re}function D(De,Se,Pe){var re=De.length;if(re===0)return"";for(var ae=0;ae<re;){var fe=De.charAt(re-ae-1);if(fe===Se&&!Pe)ae++;else if(fe!==Se&&Pe)ae++;else break}return De.substr(0,re-ae)}function T(De,Se){if(De.indexOf(Se[1])===-1)return-1;for(var Pe=De.length,re=0,ae=0;ae<Pe;ae++)if(De[ae]==="\\")ae++;else if(De[ae]===Se[0])re++;else if(De[ae]===Se[1]&&(re--,re<0))return ae;return-1}function o(De){De&&De.sanitize&&!De.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(De,Se){if(Se<1)return"";for(var Pe="";Se>1;)Se&1&&(Pe+=De),Se>>=1,De+=De;return Pe+De}var L={escape:d,unescape:m,edit:w,cleanUrl:f,resolveUrl:i,noopTest:c,merge:h,splitCells:p,rtrim:D,findClosingBracket:T,checkSanitizeDeprecation:o,repeatString:A},$=C.defaults,oe=L.rtrim,he=L.splitCells,Q=L.escape,z=L.findClosingBracket;function V(De,Se,Pe){var re=Se.href,ae=Se.title?Q(Se.title):null,fe=De[1].replace(/\\([\[\]])/g,"$1");return De[0].charAt(0)!=="!"?{type:"link",raw:Pe,href:re,title:ae,text:fe}:{type:"image",raw:Pe,href:re,title:ae,text:Q(fe)}}function R(De,Se){var Pe=De.match(/^(\s+)(?:```)/);if(Pe===null)return Se;var re=Pe[1];return Se.split(`
`).map(function(ae){var fe=ae.match(/^\s+/);if(fe===null)return ae;var pe=fe[0];return pe.length>=re.length?ae.slice(re.length):ae}).join(`
`)}var G=function(){function De(Pe){this.options=Pe||$}var Se=De.prototype;return Se.space=function(re){var ae=this.rules.block.newline.exec(re);if(ae)return ae[0].length>1?{type:"space",raw:ae[0]}:{raw:`
`}},Se.code=function(re){var ae=this.rules.block.code.exec(re);if(ae){var fe=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?fe:oe(fe,`
`)}}},Se.fences=function(re){var ae=this.rules.block.fences.exec(re);if(ae){var fe=ae[0],pe=R(fe,ae[3]||"");return{type:"code",raw:fe,lang:ae[2]?ae[2].trim():ae[2],text:pe}}},Se.heading=function(re){var ae=this.rules.block.heading.exec(re);if(ae){var fe=ae[2].trim();if(/#$/.test(fe)){var pe=oe(fe,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&(fe=pe.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:fe}}},Se.nptable=function(re){var ae=this.rules.block.nptable.exec(re);if(ae){var fe={type:"table",header:he(ae[1].replace(/^ *| *\| *$/g,"")),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ae[3]?ae[3].replace(/\n$/,"").split(`
`):[],raw:ae[0]};if(fe.header.length===fe.align.length){var pe=fe.align.length,U;for(U=0;U<pe;U++)/^ *-+: *$/.test(fe.align[U])?fe.align[U]="right":/^ *:-+: *$/.test(fe.align[U])?fe.align[U]="center":/^ *:-+ *$/.test(fe.align[U])?fe.align[U]="left":fe.align[U]=null;for(pe=fe.cells.length,U=0;U<pe;U++)fe.cells[U]=he(fe.cells[U],fe.header.length);return fe}}},Se.hr=function(re){var ae=this.rules.block.hr.exec(re);if(ae)return{type:"hr",raw:ae[0]}},Se.blockquote=function(re){var ae=this.rules.block.blockquote.exec(re);if(ae){var fe=ae[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ae[0],text:fe}}},Se.list=function(re){var ae=this.rules.block.list.exec(re);if(ae){var fe=ae[0],pe=ae[2],U=pe.length>1,me={type:"list",raw:fe,ordered:U,start:U?+pe.slice(0,-1):"",loose:!1,items:[]},we=ae[0].match(this.rules.block.item),Ie=!1,Oe,He,et,Ke,Ge,lt,ft,_t,ut=we.length;et=this.rules.block.listItemStart.exec(we[0]);for(var ot=0;ot<ut;ot++){if(Oe=we[ot],fe=Oe,ot!==ut-1){if(Ke=this.rules.block.listItemStart.exec(we[ot+1]),this.options.pedantic?Ke[1].length>et[1].length:Ke[1].length>et[0].length||Ke[1].length>3){we.splice(ot,2,we[ot]+`
`+we[ot+1]),ot--,ut--;continue}else(!this.options.pedantic||this.options.smartLists?Ke[2][Ke[2].length-1]!==pe[pe.length-1]:U===(Ke[2].length===1))&&(Ge=we.slice(ot+1).join(`
`),me.raw=me.raw.substring(0,me.raw.length-Ge.length),ot=ut-1);et=Ke}He=Oe.length,Oe=Oe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Oe.indexOf(`
 `)&&(He-=Oe.length,Oe=this.options.pedantic?Oe.replace(/^ {1,4}/gm,""):Oe.replace(new RegExp("^ {1,"+He+"}","gm"),"")),lt=Ie||/\n\n(?!\s*$)/.test(Oe),ot!==ut-1&&(Ie=Oe.charAt(Oe.length-1)===`
`,lt||(lt=Ie)),lt&&(me.loose=!0),this.options.gfm&&(ft=/^\[[ xX]\] /.test(Oe),_t=void 0,ft&&(_t=Oe[1]!==" ",Oe=Oe.replace(/^\[[ xX]\] +/,""))),me.items.push({type:"list_item",raw:fe,task:ft,checked:_t,loose:lt,text:Oe})}return me}},Se.html=function(re){var ae=this.rules.block.html.exec(re);if(ae)return{type:this.options.sanitize?"paragraph":"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):Q(ae[0]):ae[0]}},Se.def=function(re){var ae=this.rules.block.def.exec(re);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var fe=ae[1].toLowerCase().replace(/\s+/g," ");return{tag:fe,raw:ae[0],href:ae[2],title:ae[3]}}},Se.table=function(re){var ae=this.rules.block.table.exec(re);if(ae){var fe={type:"table",header:he(ae[1].replace(/^ *| *\| *$/g,"")),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ae[3]?ae[3].replace(/\n$/,"").split(`
`):[]};if(fe.header.length===fe.align.length){fe.raw=ae[0];var pe=fe.align.length,U;for(U=0;U<pe;U++)/^ *-+: *$/.test(fe.align[U])?fe.align[U]="right":/^ *:-+: *$/.test(fe.align[U])?fe.align[U]="center":/^ *:-+ *$/.test(fe.align[U])?fe.align[U]="left":fe.align[U]=null;for(pe=fe.cells.length,U=0;U<pe;U++)fe.cells[U]=he(fe.cells[U].replace(/^ *\| *| *\| *$/g,""),fe.header.length);return fe}}},Se.lheading=function(re){var ae=this.rules.block.lheading.exec(re);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1]}},Se.paragraph=function(re){var ae=this.rules.block.paragraph.exec(re);if(ae)return{type:"paragraph",raw:ae[0],text:ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1]}},Se.text=function(re){var ae=this.rules.block.text.exec(re);if(ae)return{type:"text",raw:ae[0],text:ae[0]}},Se.escape=function(re){var ae=this.rules.inline.escape.exec(re);if(ae)return{type:"escape",raw:ae[0],text:Q(ae[1])}},Se.tag=function(re,ae,fe){var pe=this.rules.inline.tag.exec(re);if(pe)return!ae&&/^<a /i.test(pe[0])?ae=!0:ae&&/^<\/a>/i.test(pe[0])&&(ae=!1),!fe&&/^<(pre|code|kbd|script)(\s|>)/i.test(pe[0])?fe=!0:fe&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(pe[0])&&(fe=!1),{type:this.options.sanitize?"text":"html",raw:pe[0],inLink:ae,inRawBlock:fe,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):Q(pe[0]):pe[0]}},Se.link=function(re){var ae=this.rules.inline.link.exec(re);if(ae){var fe=ae[2].trim();if(!this.options.pedantic&&/^</.test(fe)){if(!/>$/.test(fe))return;var pe=oe(fe.slice(0,-1),"\\");if((fe.length-pe.length)%2==0)return}else{var U=z(ae[2],"()");if(U>-1){var me=ae[0].indexOf("!")===0?5:4,we=me+ae[1].length+U;ae[2]=ae[2].substring(0,U),ae[0]=ae[0].substring(0,we).trim(),ae[3]=""}}var Ie=ae[2],Oe="";if(this.options.pedantic){var He=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ie);He&&(Ie=He[1],Oe=He[3])}else Oe=ae[3]?ae[3].slice(1,-1):"";return Ie=Ie.trim(),/^</.test(Ie)&&(this.options.pedantic&&!/>$/.test(fe)?Ie=Ie.slice(1):Ie=Ie.slice(1,-1)),V(ae,{href:Ie&&Ie.replace(this.rules.inline._escapes,"$1"),title:Oe&&Oe.replace(this.rules.inline._escapes,"$1")},ae[0])}},Se.reflink=function(re,ae){var fe;if((fe=this.rules.inline.reflink.exec(re))||(fe=this.rules.inline.nolink.exec(re))){var pe=(fe[2]||fe[1]).replace(/\s+/g," ");if(pe=ae[pe.toLowerCase()],!pe||!pe.href){var U=fe[0].charAt(0);return{type:"text",raw:U,text:U}}return V(fe,pe,fe[0])}},Se.emStrong=function(re,ae,fe){fe===void 0&&(fe="");var pe=this.rules.inline.emStrong.lDelim.exec(re);if(!!pe&&!(pe[3]&&fe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var U=pe[1]||pe[2]||"";if(!U||U&&(fe===""||this.rules.inline.punctuation.exec(fe))){var me=pe[0].length-1,we,Ie,Oe=me,He=0,et=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(et.lastIndex=0,ae=ae.slice(-1*re.length+me);(pe=et.exec(ae))!=null;)if(we=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!we){if(Ie=we.length,pe[3]||pe[4]){Oe+=Ie;continue}else if((pe[5]||pe[6])&&me%3&&!((me+Ie)%3)){He+=Ie;continue}if(Oe-=Ie,!(Oe>0)){if(Oe+He-Ie<=0&&!ae.slice(et.lastIndex).match(et)&&(Ie=Math.min(Ie,Ie+Oe+He)),Math.min(me,Ie)%2)return{type:"em",raw:re.slice(0,me+pe.index+Ie+1),text:re.slice(1,me+pe.index+Ie)};if(Math.min(me,Ie)%2==0)return{type:"strong",raw:re.slice(0,me+pe.index+Ie+1),text:re.slice(2,me+pe.index+Ie-1)}}}}}},Se.codespan=function(re){var ae=this.rules.inline.code.exec(re);if(ae){var fe=ae[2].replace(/\n/g," "),pe=/[^ ]/.test(fe),U=/^ /.test(fe)&&/ $/.test(fe);return pe&&U&&(fe=fe.substring(1,fe.length-1)),fe=Q(fe,!0),{type:"codespan",raw:ae[0],text:fe}}},Se.br=function(re){var ae=this.rules.inline.br.exec(re);if(ae)return{type:"br",raw:ae[0]}},Se.del=function(re){var ae=this.rules.inline.del.exec(re);if(ae)return{type:"del",raw:ae[0],text:ae[2]}},Se.autolink=function(re,ae){var fe=this.rules.inline.autolink.exec(re);if(fe){var pe,U;return fe[2]==="@"?(pe=Q(this.options.mangle?ae(fe[1]):fe[1]),U="mailto:"+pe):(pe=Q(fe[1]),U=pe),{type:"link",raw:fe[0],text:pe,href:U,tokens:[{type:"text",raw:pe,text:pe}]}}},Se.url=function(re,ae){var fe;if(fe=this.rules.inline.url.exec(re)){var pe,U;if(fe[2]==="@")pe=Q(this.options.mangle?ae(fe[0]):fe[0]),U="mailto:"+pe;else{var me;do me=fe[0],fe[0]=this.rules.inline._backpedal.exec(fe[0])[0];while(me!==fe[0]);pe=Q(fe[0]),fe[1]==="www."?U="http://"+pe:U=pe}return{type:"link",raw:fe[0],text:pe,href:U,tokens:[{type:"text",raw:pe,text:pe}]}}},Se.inlineText=function(re,ae,fe){var pe=this.rules.inline.text.exec(re);if(pe){var U;return ae?U=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):Q(pe[0]):pe[0]:U=Q(this.options.smartypants?fe(pe[0]):pe[0]),{type:"text",raw:pe[0],text:U}}},De}(),x=L.noopTest,j=L.edit,de=L.merge,B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:x,table:x,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=j(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,B.item=j(B.item,"gm").replace(/bull/g,B.bullet).getRegex(),B.listItemStart=j(/^( *)(bull)/).replace("bull",B.bullet).getRegex(),B.list=j(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=j(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=j(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",B._tag).getRegex(),B.blockquote=j(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=de({},B),B.gfm=de({},B.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.nptable=j(B.gfm.nptable).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",B._tag).getRegex(),B.gfm.table=j(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",B._tag).getRegex(),B.pedantic=de({},B.normal,{html:j(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:x,paragraph:j(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ne={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:x,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:x,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ne._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ne.punctuation=j(ne.punctuation).replace(/punctuation/g,ne._punctuation).getRegex(),ne.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ne.escapedEmSt=/\\\*|\\_/g,ne._comment=j(B._comment).replace("(?:-->|$)","-->").getRegex(),ne.emStrong.lDelim=j(ne.emStrong.lDelim).replace(/punct/g,ne._punctuation).getRegex(),ne.emStrong.rDelimAst=j(ne.emStrong.rDelimAst,"g").replace(/punct/g,ne._punctuation).getRegex(),ne.emStrong.rDelimUnd=j(ne.emStrong.rDelimUnd,"g").replace(/punct/g,ne._punctuation).getRegex(),ne._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ne._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ne._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ne.autolink=j(ne.autolink).replace("scheme",ne._scheme).replace("email",ne._email).getRegex(),ne._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ne.tag=j(ne.tag).replace("comment",ne._comment).replace("attribute",ne._attribute).getRegex(),ne._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ne._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ne._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ne.link=j(ne.link).replace("label",ne._label).replace("href",ne._href).replace("title",ne._title).getRegex(),ne.reflink=j(ne.reflink).replace("label",ne._label).getRegex(),ne.reflinkSearch=j(ne.reflinkSearch,"g").replace("reflink",ne.reflink).replace("nolink",ne.nolink).getRegex(),ne.normal=de({},ne),ne.pedantic=de({},ne.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:j(/^!?\[(label)\]\((.*?)\)/).replace("label",ne._label).getRegex(),reflink:j(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ne._label).getRegex()}),ne.gfm=de({},ne.normal,{escape:j(ne.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),ne.gfm.url=j(ne.gfm.url,"i").replace("email",ne.gfm._extended_email).getRegex(),ne.breaks=de({},ne.gfm,{br:j(ne.br).replace("{2,}","*").getRegex(),text:j(ne.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ue={block:B,inline:ne},ye=C.defaults,Re=ue.block,Te=ue.inline,$e=L.repeatString;function Je(De){return De.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Ve(De){var Se="",Pe,re,ae=De.length;for(Pe=0;Pe<ae;Pe++)re=De.charCodeAt(Pe),Math.random()>.5&&(re="x"+re.toString(16)),Se+="&#"+re+";";return Se}var je=function(){function De(Pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=Pe||ye,this.options.tokenizer=this.options.tokenizer||new G,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var re={block:Re.normal,inline:Te.normal};this.options.pedantic?(re.block=Re.pedantic,re.inline=Te.pedantic):this.options.gfm&&(re.block=Re.gfm,this.options.breaks?re.inline=Te.breaks:re.inline=Te.gfm),this.tokenizer.rules=re}De.lex=function(re,ae){var fe=new De(ae);return fe.lex(re)},De.lexInline=function(re,ae){var fe=new De(ae);return fe.inlineTokens(re)};var Se=De.prototype;return Se.lex=function(re){return re=re.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(re,this.tokens,!0),this.inline(this.tokens),this.tokens},Se.blockTokens=function(re,ae,fe){ae===void 0&&(ae=[]),fe===void 0&&(fe=!0),this.options.pedantic&&(re=re.replace(/^ +$/gm,""));for(var pe,U,me,we;re;){if(pe=this.tokenizer.space(re)){re=re.substring(pe.raw.length),pe.type&&ae.push(pe);continue}if(pe=this.tokenizer.code(re)){re=re.substring(pe.raw.length),we=ae[ae.length-1],we&&we.type==="paragraph"?(we.raw+=`
`+pe.raw,we.text+=`
`+pe.text):ae.push(pe);continue}if(pe=this.tokenizer.fences(re)){re=re.substring(pe.raw.length),ae.push(pe);continue}if(pe=this.tokenizer.heading(re)){re=re.substring(pe.raw.length),ae.push(pe);continue}if(pe=this.tokenizer.nptable(re)){re=re.substring(pe.raw.length),ae.push(pe);continue}if(pe=this.tokenizer.hr(re)){re=re.substring(pe.raw.length),ae.push(pe);continue}if(pe=this.tokenizer.blockquote(re)){re=re.substring(pe.raw.length),pe.tokens=this.blockTokens(pe.text,[],fe),ae.push(pe);continue}if(pe=this.tokenizer.list(re)){for(re=re.substring(pe.raw.length),me=pe.items.length,U=0;U<me;U++)pe.items[U].tokens=this.blockTokens(pe.items[U].text,[],!1);ae.push(pe);continue}if(pe=this.tokenizer.html(re)){re=re.substring(pe.raw.length),ae.push(pe);continue}if(fe&&(pe=this.tokenizer.def(re))){re=re.substring(pe.raw.length),this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(re)){re=re.substring(pe.raw.length),ae.push(pe);continue}if(pe=this.tokenizer.lheading(re)){re=re.substring(pe.raw.length),ae.push(pe);continue}if(fe&&(pe=this.tokenizer.paragraph(re))){re=re.substring(pe.raw.length),ae.push(pe);continue}if(pe=this.tokenizer.text(re)){re=re.substring(pe.raw.length),we=ae[ae.length-1],we&&we.type==="text"?(we.raw+=`
`+pe.raw,we.text+=`
`+pe.text):ae.push(pe);continue}if(re){var Ie="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return ae},Se.inline=function(re){var ae,fe,pe,U,me,we,Ie=re.length;for(ae=0;ae<Ie;ae++)switch(we=re[ae],we.type){case"paragraph":case"text":case"heading":{we.tokens=[],this.inlineTokens(we.text,we.tokens);break}case"table":{for(we.tokens={header:[],cells:[]},U=we.header.length,fe=0;fe<U;fe++)we.tokens.header[fe]=[],this.inlineTokens(we.header[fe],we.tokens.header[fe]);for(U=we.cells.length,fe=0;fe<U;fe++)for(me=we.cells[fe],we.tokens.cells[fe]=[],pe=0;pe<me.length;pe++)we.tokens.cells[fe][pe]=[],this.inlineTokens(me[pe],we.tokens.cells[fe][pe]);break}case"blockquote":{this.inline(we.tokens);break}case"list":{for(U=we.items.length,fe=0;fe<U;fe++)this.inline(we.items[fe].tokens);break}}return re},Se.inlineTokens=function(re,ae,fe,pe){ae===void 0&&(ae=[]),fe===void 0&&(fe=!1),pe===void 0&&(pe=!1);var U,me,we=re,Ie,Oe,He;if(this.tokens.links){var et=Object.keys(this.tokens.links);if(et.length>0)for(;(Ie=this.tokenizer.rules.inline.reflinkSearch.exec(we))!=null;)et.includes(Ie[0].slice(Ie[0].lastIndexOf("[")+1,-1))&&(we=we.slice(0,Ie.index)+"["+$e("a",Ie[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ie=this.tokenizer.rules.inline.blockSkip.exec(we))!=null;)we=we.slice(0,Ie.index)+"["+$e("a",Ie[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ie=this.tokenizer.rules.inline.escapedEmSt.exec(we))!=null;)we=we.slice(0,Ie.index)+"++"+we.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;){if(Oe||(He=""),Oe=!1,U=this.tokenizer.escape(re)){re=re.substring(U.raw.length),ae.push(U);continue}if(U=this.tokenizer.tag(re,fe,pe)){re=re.substring(U.raw.length),fe=U.inLink,pe=U.inRawBlock;var Ke=ae[ae.length-1];Ke&&U.type==="text"&&Ke.type==="text"?(Ke.raw+=U.raw,Ke.text+=U.text):ae.push(U);continue}if(U=this.tokenizer.link(re)){re=re.substring(U.raw.length),U.type==="link"&&(U.tokens=this.inlineTokens(U.text,[],!0,pe)),ae.push(U);continue}if(U=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(U.raw.length);var Ge=ae[ae.length-1];U.type==="link"?(U.tokens=this.inlineTokens(U.text,[],!0,pe),ae.push(U)):Ge&&U.type==="text"&&Ge.type==="text"?(Ge.raw+=U.raw,Ge.text+=U.text):ae.push(U);continue}if(U=this.tokenizer.emStrong(re,we,He)){re=re.substring(U.raw.length),U.tokens=this.inlineTokens(U.text,[],fe,pe),ae.push(U);continue}if(U=this.tokenizer.codespan(re)){re=re.substring(U.raw.length),ae.push(U);continue}if(U=this.tokenizer.br(re)){re=re.substring(U.raw.length),ae.push(U);continue}if(U=this.tokenizer.del(re)){re=re.substring(U.raw.length),U.tokens=this.inlineTokens(U.text,[],fe,pe),ae.push(U);continue}if(U=this.tokenizer.autolink(re,Ve)){re=re.substring(U.raw.length),ae.push(U);continue}if(!fe&&(U=this.tokenizer.url(re,Ve))){re=re.substring(U.raw.length),ae.push(U);continue}if(U=this.tokenizer.inlineText(re,pe,Je)){re=re.substring(U.raw.length),U.raw.slice(-1)!=="_"&&(He=U.raw.slice(-1)),Oe=!0,me=ae[ae.length-1],me&&me.type==="text"?(me.raw+=U.raw,me.text+=U.text):ae.push(U);continue}if(re){var lt="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(lt);break}else throw new Error(lt)}}return ae},e(De,null,[{key:"rules",get:function(){return{block:Re,inline:Te}}}]),De}(),O=C.defaults,K=L.cleanUrl,X=L.escape,se=function(){function De(Pe){this.options=Pe||O}var Se=De.prototype;return Se.code=function(re,ae,fe){var pe=(ae||"").match(/\S*/)[0];if(this.options.highlight){var U=this.options.highlight(re,pe);U!=null&&U!==re&&(fe=!0,re=U)}return re=re.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+X(pe,!0)+'">'+(fe?re:X(re,!0))+`</code></pre>
`:"<pre><code>"+(fe?re:X(re,!0))+`</code></pre>
`},Se.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},Se.html=function(re){return re},Se.heading=function(re,ae,fe,pe){return this.options.headerIds?"<h"+ae+' id="'+this.options.headerPrefix+pe.slug(fe)+'">'+re+"</h"+ae+`>
`:"<h"+ae+">"+re+"</h"+ae+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(re,ae,fe){var pe=ae?"ol":"ul",U=ae&&fe!==1?' start="'+fe+'"':"";return"<"+pe+U+`>
`+re+"</"+pe+`>
`},Se.listitem=function(re){return"<li>"+re+`</li>
`},Se.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(re){return"<p>"+re+`</p>
`},Se.table=function(re,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+ae+`</table>
`},Se.tablerow=function(re){return`<tr>
`+re+`</tr>
`},Se.tablecell=function(re,ae){var fe=ae.header?"th":"td",pe=ae.align?"<"+fe+' align="'+ae.align+'">':"<"+fe+">";return pe+re+"</"+fe+`>
`},Se.strong=function(re){return"<strong>"+re+"</strong>"},Se.em=function(re){return"<em>"+re+"</em>"},Se.codespan=function(re){return"<code>"+re+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(re){return"<del>"+re+"</del>"},Se.link=function(re,ae,fe){if(re=K(this.options.sanitize,this.options.baseUrl,re),re===null)return fe;var pe='<a href="'+X(re)+'"';return ae&&(pe+=' title="'+ae+'"'),pe+=">"+fe+"</a>",pe},Se.image=function(re,ae,fe){if(re=K(this.options.sanitize,this.options.baseUrl,re),re===null)return fe;var pe='<img src="'+re+'" alt="'+fe+'"';return ae&&(pe+=' title="'+ae+'"'),pe+=this.options.xhtml?"/>":">",pe},Se.text=function(re){return re},De}(),q=function(){function De(){}var Se=De.prototype;return Se.strong=function(re){return re},Se.em=function(re){return re},Se.codespan=function(re){return re},Se.del=function(re){return re},Se.html=function(re){return re},Se.text=function(re){return re},Se.link=function(re,ae,fe){return""+fe},Se.image=function(re,ae,fe){return""+fe},Se.br=function(){return""},De}(),ie=function(){function De(){this.seen={}}var Se=De.prototype;return Se.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(re,ae){var fe=re,pe=0;if(this.seen.hasOwnProperty(fe)){pe=this.seen[re];do pe++,fe=re+"-"+pe;while(this.seen.hasOwnProperty(fe))}return ae||(this.seen[re]=pe,this.seen[fe]=0),fe},Se.slug=function(re,ae){ae===void 0&&(ae={});var fe=this.serialize(re);return this.getNextSafeSlug(fe,ae.dryrun)},De}(),ge=C.defaults,Le=L.unescape,We=function(){function De(Pe){this.options=Pe||ge,this.options.renderer=this.options.renderer||new se,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new q,this.slugger=new ie}De.parse=function(re,ae){var fe=new De(ae);return fe.parse(re)},De.parseInline=function(re,ae){var fe=new De(ae);return fe.parseInline(re)};var Se=De.prototype;return Se.parse=function(re,ae){ae===void 0&&(ae=!0);var fe="",pe,U,me,we,Ie,Oe,He,et,Ke,Ge,lt,ft,_t,ut,ot,_e,ke,Y,W=re.length;for(pe=0;pe<W;pe++)switch(Ge=re[pe],Ge.type){case"space":continue;case"hr":{fe+=this.renderer.hr();continue}case"heading":{fe+=this.renderer.heading(this.parseInline(Ge.tokens),Ge.depth,Le(this.parseInline(Ge.tokens,this.textRenderer)),this.slugger);continue}case"code":{fe+=this.renderer.code(Ge.text,Ge.lang,Ge.escaped);continue}case"table":{for(et="",He="",we=Ge.header.length,U=0;U<we;U++)He+=this.renderer.tablecell(this.parseInline(Ge.tokens.header[U]),{header:!0,align:Ge.align[U]});for(et+=this.renderer.tablerow(He),Ke="",we=Ge.cells.length,U=0;U<we;U++){for(Oe=Ge.tokens.cells[U],He="",Ie=Oe.length,me=0;me<Ie;me++)He+=this.renderer.tablecell(this.parseInline(Oe[me]),{header:!1,align:Ge.align[me]});Ke+=this.renderer.tablerow(He)}fe+=this.renderer.table(et,Ke);continue}case"blockquote":{Ke=this.parse(Ge.tokens),fe+=this.renderer.blockquote(Ke);continue}case"list":{for(lt=Ge.ordered,ft=Ge.start,_t=Ge.loose,we=Ge.items.length,Ke="",U=0;U<we;U++)ot=Ge.items[U],_e=ot.checked,ke=ot.task,ut="",ot.task&&(Y=this.renderer.checkbox(_e),_t?ot.tokens.length>0&&ot.tokens[0].type==="text"?(ot.tokens[0].text=Y+" "+ot.tokens[0].text,ot.tokens[0].tokens&&ot.tokens[0].tokens.length>0&&ot.tokens[0].tokens[0].type==="text"&&(ot.tokens[0].tokens[0].text=Y+" "+ot.tokens[0].tokens[0].text)):ot.tokens.unshift({type:"text",text:Y}):ut+=Y),ut+=this.parse(ot.tokens,_t),Ke+=this.renderer.listitem(ut,ke,_e);fe+=this.renderer.list(Ke,lt,ft);continue}case"html":{fe+=this.renderer.html(Ge.text);continue}case"paragraph":{fe+=this.renderer.paragraph(this.parseInline(Ge.tokens));continue}case"text":{for(Ke=Ge.tokens?this.parseInline(Ge.tokens):Ge.text;pe+1<W&&re[pe+1].type==="text";)Ge=re[++pe],Ke+=`
`+(Ge.tokens?this.parseInline(Ge.tokens):Ge.text);fe+=ae?this.renderer.paragraph(Ke):Ke;continue}default:{var Fe='Token with "'+Ge.type+'" type was not found.';if(this.options.silent){console.error(Fe);return}else throw new Error(Fe)}}return fe},Se.parseInline=function(re,ae){ae=ae||this.renderer;var fe="",pe,U,me=re.length;for(pe=0;pe<me;pe++)switch(U=re[pe],U.type){case"escape":{fe+=ae.text(U.text);break}case"html":{fe+=ae.html(U.text);break}case"link":{fe+=ae.link(U.href,U.title,this.parseInline(U.tokens,ae));break}case"image":{fe+=ae.image(U.href,U.title,U.text);break}case"strong":{fe+=ae.strong(this.parseInline(U.tokens,ae));break}case"em":{fe+=ae.em(this.parseInline(U.tokens,ae));break}case"codespan":{fe+=ae.codespan(U.text);break}case"br":{fe+=ae.br();break}case"del":{fe+=ae.del(this.parseInline(U.tokens,ae));break}case"text":{fe+=ae.text(U.text);break}default:{var we='Token with "'+U.type+'" type was not found.';if(this.options.silent){console.error(we);return}else throw new Error(we)}}return fe},De}(),ve=L.merge,Xe=L.checkSanitizeDeprecation,H=L.escape,Z=C.getDefaults,ce=C.changeDefaults,Be=C.defaults;function xe(De,Se,Pe){if(typeof De=="undefined"||De===null)throw new Error("marked(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");if(typeof Se=="function"&&(Pe=Se,Se=null),Se=ve({},xe.defaults,Se||{}),Xe(Se),Pe){var re=Se.highlight,ae;try{ae=je.lex(De,Se)}catch(me){return Pe(me)}var fe=function(we){var Ie;if(!we)try{Ie=We.parse(ae,Se)}catch(Oe){we=Oe}return Se.highlight=re,we?Pe(we):Pe(null,Ie)};if(!re||re.length<3||(delete Se.highlight,!ae.length))return fe();var pe=0;xe.walkTokens(ae,function(me){me.type==="code"&&(pe++,setTimeout(function(){re(me.text,me.lang,function(we,Ie){if(we)return fe(we);Ie!=null&&Ie!==me.text&&(me.text=Ie,me.escaped=!0),pe--,pe===0&&fe()})},0))}),pe===0&&fe();return}try{var U=je.lex(De,Se);return Se.walkTokens&&xe.walkTokens(U,Se.walkTokens),We.parse(U,Se)}catch(me){if(me.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+H(me.message+"",!0)+"</pre>";throw me}}xe.options=xe.setOptions=function(De){return ve(xe.defaults,De),ce(xe.defaults),xe},xe.getDefaults=Z,xe.defaults=Be,xe.use=function(De){var Se=ve({},De);if(De.renderer&&function(){var re=xe.defaults.renderer||new se,ae=function(U){var me=re[U];re[U]=function(){for(var we=arguments.length,Ie=new Array(we),Oe=0;Oe<we;Oe++)Ie[Oe]=arguments[Oe];var He=De.renderer[U].apply(re,Ie);return He===!1&&(He=me.apply(re,Ie)),He}};for(var fe in De.renderer)ae(fe);Se.renderer=re}(),De.tokenizer&&function(){var re=xe.defaults.tokenizer||new G,ae=function(U){var me=re[U];re[U]=function(){for(var we=arguments.length,Ie=new Array(we),Oe=0;Oe<we;Oe++)Ie[Oe]=arguments[Oe];var He=De.tokenizer[U].apply(re,Ie);return He===!1&&(He=me.apply(re,Ie)),He}};for(var fe in De.tokenizer)ae(fe);Se.tokenizer=re}(),De.walkTokens){var Pe=xe.defaults.walkTokens;Se.walkTokens=function(re){De.walkTokens(re),Pe&&Pe(re)}}xe.setOptions(Se)},xe.walkTokens=function(De,Se){for(var Pe=S(De),re;!(re=Pe()).done;){var ae=re.value;switch(Se(ae),ae.type){case"table":{for(var fe=S(ae.tokens.header),pe;!(pe=fe()).done;){var U=pe.value;xe.walkTokens(U,Se)}for(var me=S(ae.tokens.cells),we;!(we=me()).done;)for(var Ie=we.value,Oe=S(Ie),He;!(He=Oe()).done;){var et=He.value;xe.walkTokens(et,Se)}break}case"list":{xe.walkTokens(ae.items,Se);break}default:ae.tokens&&xe.walkTokens(ae.tokens,Se)}}},xe.parseInline=function(De,Se){if(typeof De=="undefined"||De===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");Se=ve({},xe.defaults,Se||{}),Xe(Se);try{var Pe=je.lexInline(De,Se);return Se.walkTokens&&xe.walkTokens(Pe,Se.walkTokens),We.parseInline(Pe,Se)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+H(re.message+"",!0)+"</pre>";throw re}},xe.Parser=We,xe.parser=We.parse,xe.Renderer=se,xe.TextRenderer=q,xe.Lexer=je,xe.lexer=je.lex,xe.Tokenizer=G,xe.Slugger=ie,xe.parse=xe;var Ze=xe;return Ze}),define(be[81],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function g(C,y,_){return Math.min(Math.max(C,y),_)}e.clamp=g;function F(C,y){return(y+C%y)%y}e.rot=F;class S{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=S;class E{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=E}),function(){function ee(S){const E=[];typeof S=="number"&&E.push("code/timeOrigin",S);function C(_){E.push(_,Date.now())}function y(){const _=[];for(let k=0;k<E.length;k+=2)_.push({name:E[k],startTime:E[k+1]});return _}return{mark:C,getMarks:y}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const E=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const C of performance.getEntriesByType("mark"))E.push({name:C.name,startTime:Math.round(S+C.startTime)});return E}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function g(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=g(F))}(),define(be[22],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const g="en";let F=!1,S=!1,E=!1,C=!1,y=!1,_=!1,k=!1,n,I=g,l,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?u=e.globals.vscode.process:typeof process!="undefined"&&(u=process);const m=typeof u?.versions?.electron=="string"&&u.type==="renderer";if(e.isElectronSandboxed=m&&u?.sandboxed,e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const s=u?.env.VSCODE_BROWSER_CODE_LOADING;if(typeof s=="string")return s==="none"||s==="code"||s==="bypassHeatCheck"||s==="bypassHeatCheckAndEagerCompile"?s:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!m)d=navigator.userAgent,F=d.indexOf("Windows")>=0,S=d.indexOf("Macintosh")>=0,k=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,E=d.indexOf("Linux")>=0,_=!0,n=navigator.language,I=n;else if(typeof u=="object"){F=u.platform==="win32",S=u.platform==="darwin",E=u.platform==="linux",C=E&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,n=g,I=g;const s=u.env.VSCODE_NLS_CONFIG;if(s)try{const i=JSON.parse(s),c=i.availableLanguages["*"];n=i.locale,I=c||g,l=i._translationsConfigFile}catch(i){}y=!0}else console.error("Unable to resolve platform.");var b;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function w(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=w;let P=0;S?P=1:F?P=3:E&&(P=2),e.isWindows=F,e.isMacintosh=S,e.isLinux=E,e.isLinuxSnap=C,e.isNative=y,e.isWeb=_,e.isIOS=k,e.platform=P,e.userAgent=d,e.language=I;var a;(function(s){function i(){return e.language}s.value=i;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=c;function h(){return e.language==="en"}s.isDefault=h})(a=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=l,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let c=[];e.globals.addEventListener("message",p=>{if(p.data&&p.data.vscodeSetImmediateId)for(let D=0,T=c.length;D<T;D++){const o=c[D];if(o.id===p.data.vscodeSetImmediateId){c.splice(D,1),o.callback();return}}});let h=0;return p=>{const D=++h;c.push({id:D,callback:p}),e.globals.postMessage({vscodeSetImmediateId:D},"*")}}if(typeof u?.nextTick=="function")return u.nextTick.bind(u);const i=Promise.resolve();return c=>i.then(c)}();var f;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(f=e.OperatingSystem||(e.OperatingSystem={})),e.OS=S||k?2:F?1:3;let v=!0,t=!1;function r(){if(!t){t=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,v=new Uint16Array(s.buffer)[0]===(2<<8)+1}return v}e.isLittleEndian=r}),define(be[41],Ee([0,1,22]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let F;if(typeof g.globals.vscode!="undefined"&&typeof g.globals.vscode.process!="undefined"){const S=g.globals.vscode.process;F={get platform(){return S.platform},get env(){return S.env},cwd(){return S.cwd()},nextTick(E){return(0,g.setImmediate)(E)}}}else typeof process!="undefined"?F={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(S){return process.nextTick(S)}}:F={get platform(){return g.isWindows?"win32":g.isMacintosh?"darwin":"linux"},nextTick(S){return(0,g.setImmediate)(S)},get env(){return{}},cwd(){return"/"}};e.cwd=F.cwd,e.env=F.env,e.platform=F.platform,e.nextTick=F.nextTick}),define(be[14],Ee([0,1,41]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const F=65,S=97,E=90,C=122,y=46,_=47,k=92,n=58,I=63;class l extends Error{constructor(f,v,t){let r;typeof v=="string"&&v.indexOf("not ")===0?(r="must not be",v=v.replace(/^not /,"")):r="must be";const s=f.indexOf(".")!==-1?"property":"argument";let i=`The "${f}" ${s} ${r} of type ${v}`;i+=`. Received type ${typeof t}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function d(a,f){if(typeof a!="string")throw new l(f,"string",a)}function u(a){return a===_||a===k}function m(a){return a===_}function b(a){return a>=F&&a<=E||a>=S&&a<=C}function w(a,f,v,t){let r="",s=0,i=-1,c=0,h=0;for(let p=0;p<=a.length;++p){if(p<a.length)h=a.charCodeAt(p);else{if(t(h))break;h=_}if(t(h)){if(!(i===p-1||c===1))if(c===2){if(r.length<2||s!==2||r.charCodeAt(r.length-1)!==y||r.charCodeAt(r.length-2)!==y){if(r.length>2){const D=r.lastIndexOf(v);D===-1?(r="",s=0):(r=r.slice(0,D),s=r.length-1-r.lastIndexOf(v)),i=p,c=0;continue}else if(r.length!==0){r="",s=0,i=p,c=0;continue}}f&&(r+=r.length>0?`${v}..`:"..",s=2)}else r.length>0?r+=`${v}${a.slice(i+1,p)}`:r=a.slice(i+1,p),s=p-i-1;i=p,c=0}else h===y&&c!==-1?++c:c=-1}return r}function P(a,f){if(f===null||typeof f!="object")throw new l("pathObject","Object",f);const v=f.dir||f.root,t=f.base||`${f.name||""}${f.ext||""}`;return v?v===f.root?`${v}${t}`:`${v}${a}${t}`:t}e.win32={resolve(...a){let f="",v="",t=!1;for(let r=a.length-1;r>=-1;r--){let s;if(r>=0){if(s=a[r],d(s,"path"),s.length===0)continue}else f.length===0?s=g.cwd():(s=g.env[`=${f}`]||g.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==f.toLowerCase()&&s.charCodeAt(2)===k)&&(s=`${f}\\`));const i=s.length;let c=0,h="",p=!1;const D=s.charCodeAt(0);if(i===1)u(D)&&(c=1,p=!0);else if(u(D))if(p=!0,u(s.charCodeAt(1))){let T=2,o=T;for(;T<i&&!u(s.charCodeAt(T));)T++;if(T<i&&T!==o){const A=s.slice(o,T);for(o=T;T<i&&u(s.charCodeAt(T));)T++;if(T<i&&T!==o){for(o=T;T<i&&!u(s.charCodeAt(T));)T++;(T===i||T!==o)&&(h=`\\\\${A}\\${s.slice(o,T)}`,c=T)}}}else c=1;else b(D)&&s.charCodeAt(1)===n&&(h=s.slice(0,2),c=2,i>2&&u(s.charCodeAt(2))&&(p=!0,c=3));if(h.length>0)if(f.length>0){if(h.toLowerCase()!==f.toLowerCase())continue}else f=h;if(t){if(f.length>0)break}else if(v=`${s.slice(c)}\\${v}`,t=p,p&&f.length>0)break}return v=w(v,!t,"\\",u),t?`${f}\\${v}`:`${f}${v}`||"."},normalize(a){d(a,"path");const f=a.length;if(f===0)return".";let v=0,t,r=!1;const s=a.charCodeAt(0);if(f===1)return m(s)?"\\":a;if(u(s))if(r=!0,u(a.charCodeAt(1))){let c=2,h=c;for(;c<f&&!u(a.charCodeAt(c));)c++;if(c<f&&c!==h){const p=a.slice(h,c);for(h=c;c<f&&u(a.charCodeAt(c));)c++;if(c<f&&c!==h){for(h=c;c<f&&!u(a.charCodeAt(c));)c++;if(c===f)return`\\\\${p}\\${a.slice(h)}\\`;c!==h&&(t=`\\\\${p}\\${a.slice(h,c)}`,v=c)}}}else v=1;else b(s)&&a.charCodeAt(1)===n&&(t=a.slice(0,2),v=2,f>2&&u(a.charCodeAt(2))&&(r=!0,v=3));let i=v<f?w(a.slice(v),!r,"\\",u):"";return i.length===0&&!r&&(i="."),i.length>0&&u(a.charCodeAt(f-1))&&(i+="\\"),t===void 0?r?`\\${i}`:i:r?`${t}\\${i}`:`${t}${i}`},isAbsolute(a){d(a,"path");const f=a.length;if(f===0)return!1;const v=a.charCodeAt(0);return u(v)||f>2&&b(v)&&a.charCodeAt(1)===n&&u(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let f,v;for(let s=0;s<a.length;++s){const i=a[s];d(i,"path"),i.length>0&&(f===void 0?f=v=i:f+=`\\${i}`)}if(f===void 0)return".";let t=!0,r=0;if(typeof v=="string"&&u(v.charCodeAt(0))){++r;const s=v.length;s>1&&u(v.charCodeAt(1))&&(++r,s>2&&(u(v.charCodeAt(2))?++r:t=!1))}if(t){for(;r<f.length&&u(f.charCodeAt(r));)r++;r>=2&&(f=`\\${f.slice(r)}`)}return e.win32.normalize(f)},relative(a,f){if(d(a,"from"),d(f,"to"),a===f)return"";const v=e.win32.resolve(a),t=e.win32.resolve(f);if(v===t||(a=v.toLowerCase(),f=t.toLowerCase(),a===f))return"";let r=0;for(;r<a.length&&a.charCodeAt(r)===k;)r++;let s=a.length;for(;s-1>r&&a.charCodeAt(s-1)===k;)s--;const i=s-r;let c=0;for(;c<f.length&&f.charCodeAt(c)===k;)c++;let h=f.length;for(;h-1>c&&f.charCodeAt(h-1)===k;)h--;const p=h-c,D=i<p?i:p;let T=-1,o=0;for(;o<D;o++){const L=a.charCodeAt(r+o);if(L!==f.charCodeAt(c+o))break;L===k&&(T=o)}if(o!==D){if(T===-1)return t}else{if(p>D){if(f.charCodeAt(c+o)===k)return t.slice(c+o+1);if(o===2)return t.slice(c+o)}i>D&&(a.charCodeAt(r+o)===k?T=o:o===2&&(T=3)),T===-1&&(T=0)}let A="";for(o=r+T+1;o<=s;++o)(o===s||a.charCodeAt(o)===k)&&(A+=A.length===0?"..":"\\..");return c+=T,A.length>0?`${A}${t.slice(c,h)}`:(t.charCodeAt(c)===k&&++c,t.slice(c,h))},toNamespacedPath(a){if(typeof a!="string")return a;if(a.length===0)return"";const f=e.win32.resolve(a);if(f.length<=2)return a;if(f.charCodeAt(0)===k){if(f.charCodeAt(1)===k){const v=f.charCodeAt(2);if(v!==I&&v!==y)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(b(f.charCodeAt(0))&&f.charCodeAt(1)===n&&f.charCodeAt(2)===k)return`\\\\?\\${f}`;return a},dirname(a){d(a,"path");const f=a.length;if(f===0)return".";let v=-1,t=0;const r=a.charCodeAt(0);if(f===1)return u(r)?a:".";if(u(r)){if(v=t=1,u(a.charCodeAt(1))){let c=2,h=c;for(;c<f&&!u(a.charCodeAt(c));)c++;if(c<f&&c!==h){for(h=c;c<f&&u(a.charCodeAt(c));)c++;if(c<f&&c!==h){for(h=c;c<f&&!u(a.charCodeAt(c));)c++;if(c===f)return a;c!==h&&(v=t=c+1)}}}}else b(r)&&a.charCodeAt(1)===n&&(v=f>2&&u(a.charCodeAt(2))?3:2,t=v);let s=-1,i=!0;for(let c=f-1;c>=t;--c)if(u(a.charCodeAt(c))){if(!i){s=c;break}}else i=!1;if(s===-1){if(v===-1)return".";s=v}return a.slice(0,s)},basename(a,f){f!==void 0&&d(f,"ext"),d(a,"path");let v=0,t=-1,r=!0,s;if(a.length>=2&&b(a.charCodeAt(0))&&a.charCodeAt(1)===n&&(v=2),f!==void 0&&f.length>0&&f.length<=a.length){if(f===a)return"";let i=f.length-1,c=-1;for(s=a.length-1;s>=v;--s){const h=a.charCodeAt(s);if(u(h)){if(!r){v=s+1;break}}else c===-1&&(r=!1,c=s+1),i>=0&&(h===f.charCodeAt(i)?--i==-1&&(t=s):(i=-1,t=c))}return v===t?t=c:t===-1&&(t=a.length),a.slice(v,t)}for(s=a.length-1;s>=v;--s)if(u(a.charCodeAt(s))){if(!r){v=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":a.slice(v,t)},extname(a){d(a,"path");let f=0,v=-1,t=0,r=-1,s=!0,i=0;a.length>=2&&a.charCodeAt(1)===n&&b(a.charCodeAt(0))&&(f=t=2);for(let c=a.length-1;c>=f;--c){const h=a.charCodeAt(c);if(u(h)){if(!s){t=c+1;break}continue}r===-1&&(s=!1,r=c+1),h===y?v===-1?v=c:i!==1&&(i=1):v!==-1&&(i=-1)}return v===-1||r===-1||i===0||i===1&&v===r-1&&v===t+1?"":a.slice(v,r)},format:P.bind(null,"\\"),parse(a){d(a,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return f;const v=a.length;let t=0,r=a.charCodeAt(0);if(v===1)return u(r)?(f.root=f.dir=a,f):(f.base=f.name=a,f);if(u(r)){if(t=1,u(a.charCodeAt(1))){let T=2,o=T;for(;T<v&&!u(a.charCodeAt(T));)T++;if(T<v&&T!==o){for(o=T;T<v&&u(a.charCodeAt(T));)T++;if(T<v&&T!==o){for(o=T;T<v&&!u(a.charCodeAt(T));)T++;T===v?t=T:T!==o&&(t=T+1)}}}}else if(b(r)&&a.charCodeAt(1)===n){if(v<=2)return f.root=f.dir=a,f;if(t=2,u(a.charCodeAt(2))){if(v===3)return f.root=f.dir=a,f;t=3}}t>0&&(f.root=a.slice(0,t));let s=-1,i=t,c=-1,h=!0,p=a.length-1,D=0;for(;p>=t;--p){if(r=a.charCodeAt(p),u(r)){if(!h){i=p+1;break}continue}c===-1&&(h=!1,c=p+1),r===y?s===-1?s=p:D!==1&&(D=1):s!==-1&&(D=-1)}return c!==-1&&(s===-1||D===0||D===1&&s===c-1&&s===i+1?f.base=f.name=a.slice(i,c):(f.name=a.slice(i,s),f.base=a.slice(i,c),f.ext=a.slice(s,c))),i>0&&i!==t?f.dir=a.slice(0,i-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...a){let f="",v=!1;for(let t=a.length-1;t>=-1&&!v;t--){const r=t>=0?a[t]:g.cwd();d(r,"path"),r.length!==0&&(f=`${r}/${f}`,v=r.charCodeAt(0)===_)}return f=w(f,!v,"/",m),v?`/${f}`:f.length>0?f:"."},normalize(a){if(d(a,"path"),a.length===0)return".";const f=a.charCodeAt(0)===_,v=a.charCodeAt(a.length-1)===_;return a=w(a,!f,"/",m),a.length===0?f?"/":v?"./":".":(v&&(a+="/"),f?`/${a}`:a)},isAbsolute(a){return d(a,"path"),a.length>0&&a.charCodeAt(0)===_},join(...a){if(a.length===0)return".";let f;for(let v=0;v<a.length;++v){const t=a[v];d(t,"path"),t.length>0&&(f===void 0?f=t:f+=`/${t}`)}return f===void 0?".":e.posix.normalize(f)},relative(a,f){if(d(a,"from"),d(f,"to"),a===f||(a=e.posix.resolve(a),f=e.posix.resolve(f),a===f))return"";const v=1,t=a.length,r=t-v,s=1,i=f.length-s,c=r<i?r:i;let h=-1,p=0;for(;p<c;p++){const T=a.charCodeAt(v+p);if(T!==f.charCodeAt(s+p))break;T===_&&(h=p)}if(p===c)if(i>c){if(f.charCodeAt(s+p)===_)return f.slice(s+p+1);if(p===0)return f.slice(s+p)}else r>c&&(a.charCodeAt(v+p)===_?h=p:p===0&&(h=0));let D="";for(p=v+h+1;p<=t;++p)(p===t||a.charCodeAt(p)===_)&&(D+=D.length===0?"..":"/..");return`${D}${f.slice(s+h)}`},toNamespacedPath(a){return a},dirname(a){if(d(a,"path"),a.length===0)return".";const f=a.charCodeAt(0)===_;let v=-1,t=!0;for(let r=a.length-1;r>=1;--r)if(a.charCodeAt(r)===_){if(!t){v=r;break}}else t=!1;return v===-1?f?"/":".":f&&v===1?"//":a.slice(0,v)},basename(a,f){f!==void 0&&d(f,"ext"),d(a,"path");let v=0,t=-1,r=!0,s;if(f!==void 0&&f.length>0&&f.length<=a.length){if(f===a)return"";let i=f.length-1,c=-1;for(s=a.length-1;s>=0;--s){const h=a.charCodeAt(s);if(h===_){if(!r){v=s+1;break}}else c===-1&&(r=!1,c=s+1),i>=0&&(h===f.charCodeAt(i)?--i==-1&&(t=s):(i=-1,t=c))}return v===t?t=c:t===-1&&(t=a.length),a.slice(v,t)}for(s=a.length-1;s>=0;--s)if(a.charCodeAt(s)===_){if(!r){v=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":a.slice(v,t)},extname(a){d(a,"path");let f=-1,v=0,t=-1,r=!0,s=0;for(let i=a.length-1;i>=0;--i){const c=a.charCodeAt(i);if(c===_){if(!r){v=i+1;break}continue}t===-1&&(r=!1,t=i+1),c===y?f===-1?f=i:s!==1&&(s=1):f!==-1&&(s=-1)}return f===-1||t===-1||s===0||s===1&&f===t-1&&f===v+1?"":a.slice(f,t)},format:P.bind(null,"/"),parse(a){d(a,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return f;const v=a.charCodeAt(0)===_;let t;v?(f.root="/",t=1):t=0;let r=-1,s=0,i=-1,c=!0,h=a.length-1,p=0;for(;h>=t;--h){const D=a.charCodeAt(h);if(D===_){if(!c){s=h+1;break}continue}i===-1&&(c=!1,i=h+1),D===y?r===-1?r=h:p!==1&&(p=1):r!==-1&&(p=-1)}if(i!==-1){const D=s===0&&v?1:s;r===-1||p===0||p===1&&r===i-1&&r===s+1?f.base=f.name=a.slice(D,i):(f.name=a.slice(D,r),f.base=a.slice(D,i),f.ext=a.slice(r,i))}return s>0?f.dir=a.slice(0,s-1):v&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=g.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g.platform==="win32"?e.win32.join:e.posix.join,e.resolve=g.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=g.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=g.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=g.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=g.platform==="win32"?e.win32.extname:e.posix.extname,e.format=g.platform==="win32"?e.win32.format:e.posix.format,e.parse=g.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=g.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=g.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(be[55],Ee([0,1,22]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const F=g.globals.performance&&typeof g.globals.performance.now=="function";class S{constructor(C){this._highResolution=F&&C,this._startTime=this._now(),this._stopTime=-1}static create(C=!0){return new S(C)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?g.globals.performance.now():Date.now()}}e.StopWatch=S}),define(be[3],Ee([0,1,12,52,6,80,55]),function(ee,e,g,F,S,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var y;(function(a){a.None=()=>S.Disposable.None;function f(Q){return(z,V=null,R)=>{let G=!1,x;return x=Q(j=>{if(!G)return x?x.dispose():G=!0,z.call(V,j)},null,R),G&&x.dispose(),x}}a.once=f;function v(Q,z){return h((V,R=null,G)=>Q(x=>V.call(R,z(x)),null,G))}a.map=v;function t(Q,z){return h((V,R=null,G)=>Q(x=>{z(x),V.call(R,x)},null,G))}a.forEach=t;function r(Q,z){return h((V,R=null,G)=>Q(x=>z(x)&&V.call(R,x),null,G))}a.filter=r;function s(Q){return Q}a.signal=s;function i(...Q){return(z,V=null,R)=>(0,S.combinedDisposable)(...Q.map(G=>G(x=>z.call(V,x),null,R)))}a.any=i;function c(Q,z,V){let R=V;return v(Q,G=>(R=z(R,G),R))}a.reduce=c;function h(Q){let z;const V=new l({onFirstListenerAdd(){z=Q(V.fire,V)},onLastListenerRemove(){z.dispose()}});return V.event}function p(Q,z,V=100,R=!1,G){let x,j,de,B=0;const ne=new l({leakWarningThreshold:G,onFirstListenerAdd(){x=Q(ue=>{B++,j=z(j,ue),R&&!de&&(ne.fire(j),j=void 0),clearTimeout(de),de=setTimeout(()=>{const ye=j;j=void 0,de=void 0,(!R||B>1)&&ne.fire(ye),B=0},V)})},onLastListenerRemove(){x.dispose()}});return ne.event}a.debounce=p;function D(Q,z=(V,R)=>V===R){let V=!0,R;return r(Q,G=>{const x=V||!z(G,R);return V=!1,R=G,x})}a.latch=D;function T(Q,z){return[a.filter(Q,z),a.filter(Q,V=>!z(V))]}a.split=T;function o(Q,z=!1,V=[]){let R=V.slice(),G=Q(de=>{R?R.push(de):j.fire(de)});const x=()=>{R&&R.forEach(de=>j.fire(de)),R=null},j=new l({onFirstListenerAdd(){G||(G=Q(de=>j.fire(de)))},onFirstListenerDidAdd(){R&&(z?setTimeout(x):x())},onLastListenerRemove(){G&&G.dispose(),G=null}});return j.event}a.buffer=o;class A{constructor(z){this.event=z}map(z){return new A(v(this.event,z))}forEach(z){return new A(t(this.event,z))}filter(z){return new A(r(this.event,z))}reduce(z,V){return new A(c(this.event,z,V))}latch(){return new A(D(this.event))}debounce(z,V=100,R=!1,G){return new A(p(this.event,z,V,R,G))}on(z,V,R){return this.event(z,V,R)}once(z,V,R){return f(this.event)(z,V,R)}}function L(Q){return new A(Q)}a.chain=L;function $(Q,z,V=R=>R){const R=(...de)=>j.fire(V(...de)),G=()=>Q.on(z,R),x=()=>Q.removeListener(z,R),j=new l({onFirstListenerAdd:G,onLastListenerRemove:x});return j.event}a.fromNodeEventEmitter=$;function oe(Q,z,V=R=>R){const R=(...de)=>j.fire(V(...de)),G=()=>Q.addEventListener(z,R),x=()=>Q.removeEventListener(z,R),j=new l({onFirstListenerAdd:G,onLastListenerRemove:x});return j.event}a.fromDOMEventEmitter=oe;function he(Q){return new Promise(z=>f(Q)(z))}a.toPromise=he})(y=e.Event||(e.Event={}));class _{constructor(f){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${f}_${_._idPool++}`}start(f){this._stopWatch=new C.StopWatch(!0),this._listenerCount=f}stop(){if(this._stopWatch){const f=this._stopWatch.elapsed();this._elapsedOverall+=f,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${f.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}_._idPool=0;let k=-1;function n(a){const f=k;return k=a,{dispose(){k=f}}}e.setGlobalLeakWarningThreshold=n;class I{constructor(f,v=Math.random().toString(18).slice(2,5)){this.customThreshold=f,this.name=v,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(f){let v=k;if(typeof this.customThreshold=="number"&&(v=this.customThreshold),v<=0||f<v)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(t)||0;if(this._stacks.set(t,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=v*.5;let s,i=0;for(const[c,h]of this._stacks)(!s||i<h)&&(s=c,i=h);console.warn(`[${this.name}] potential listener LEAK detected, having ${f} listeners already. MOST frequent listener (${i}):`),console.warn(s)}return()=>{const s=this._stacks.get(t)||0;this._stacks.set(t,s-1)}}}class l{constructor(f){this._disposed=!1,this._options=f,this._leakageMon=k>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new _(this._options._profName):void 0}get event(){return this._event||(this._event=(f,v,t)=>{this._listeners||(this._listeners=new E.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const s=this._listeners.push(v?[f,v]:f);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,f,v);const i=this._leakageMon?.check(this._listeners.size),c=(0,S.toDisposable)(()=>{i&&i(),this._disposed||(s(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof S.DisposableStore?t.add(c):Array.isArray(t)&&t.push(c),c}),this._event}fire(f){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new E.LinkedList);for(let v of this._listeners)this._deliveryQueue.push([v,f]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[v,t]=this._deliveryQueue.shift();try{typeof v=="function"?v.call(void 0,t):v[0].call(v[1],t)}catch(r){(0,g.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=l;class d extends l{async fireAsync(f,v,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new E.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,f]);for(;this._asyncDeliveryQueue.size>0&&!v.isCancellationRequested;){const[r,s]=this._asyncDeliveryQueue.shift(),i=[],c={...s,waitUntil:h=>{if(Object.isFrozen(i))throw new Error("waitUntil can NOT be called asynchronous");t&&(h=t(h,typeof r=="function"?r:r[0])),i.push(h)}};try{typeof r=="function"?r.call(void 0,c):r[0].call(r[1],c)}catch(h){(0,g.onUnexpectedError)(h);continue}Object.freeze(i),await Promise.allSettled(i).then(h=>{for(const p of h)p.status==="rejected"&&(0,g.onUnexpectedError)(p.reason)})}}}}e.AsyncEmitter=d;class u extends l{constructor(f){super(f);this._isPaused=0,this._eventQueue=new E.LinkedList,this._mergeFn=f?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const f=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(f))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(f){this._listeners&&(this._isPaused!==0?this._eventQueue.push(f):super.fire(f))}}e.PauseableEmitter=u;class m extends u{constructor(f){super(f);this._delay=f.delay??100}fire(f){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(f)}}e.DebounceEmitter=m;class b{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(f){const v={event:f,listener:null};this.events.push(v),this.hasListeners&&this.hook(v);const t=()=>{this.hasListeners&&this.unhook(v);const r=this.events.indexOf(v);this.events.splice(r,1)};return(0,S.toDisposable)((0,F.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(f=>this.hook(f))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(f=>this.unhook(f))}hook(f){f.listener=f.event(v=>this.emitter.fire(v))}unhook(f){f.listener&&f.listener.dispose(),f.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=b;class w{constructor(){this.buffers=[]}wrapEvent(f){return(v,t,r)=>f(s=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>v.call(t,s)):v.call(t,s)},void 0,r)}bufferEvents(f){const v=[];this.buffers.push(v);const t=f();return this.buffers.pop(),v.forEach(r=>r()),t}}e.EventBufferer=w;class P{constructor(){this.listening=!1,this.inputEvent=y.None,this.inputEventListener=S.Disposable.None,this.emitter=new l({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(f){this.inputEvent=f,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=f(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=P}),define(be[20],Ee([0,1,3]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const F=Object.freeze(function(y,_){const k=setTimeout(y.bind(_),0);return{dispose(){clearTimeout(k)}}});var S;(function(y){function _(k){return k===y.None||k===y.Cancelled||k instanceof E?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}y.isCancellationToken=_,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:g.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(S=e.CancellationToken||(e.CancellationToken={}));class E{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?F:(this._emitter||(this._emitter=new g.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class C{constructor(_){this._token=void 0,this._parentListener=void 0,this._parentListener=_&&_.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new E),this._token}cancel(){this._token?this._token instanceof E&&this._token.cancel():this._token=S.Cancelled}dispose(_=!1){_&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof E&&this._token.dispose():this._token=S.None}}e.CancellationTokenSource=C}),define(be[35],Ee([0,1,3]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class F{constructor(){this._icons=new Map,this._onDidRegister=new g.Emitter}add(I){const l=this._icons.get(I.id);l?I.description?l.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const S=new F;e.iconRegistry=S;function E(n,I){return new y(n,I)}e.registerCodicon=E;function C(n){return n?n.replace(/\$\((.*?)\)/g,(I,l)=>` ${l} `).trim():""}e.getCodiconAriaLabel=C;class y{constructor(I,l,d){this.id=I,this.definition=l,this.description=d,S.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=y;function _(n,I){const l=["codicon","codicon-"+n];return I&&l.push("codicon-modifier-"+I),l}e.getClassNamesArray=_;var k;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function l(m){if(m instanceof y)return["codicon","codicon-"+m.id];const b=I.exec(m.id);if(!b)return l(y.error);let[,w,P]=b;const a=["codicon","codicon-"+w];return P&&a.push("codicon-modifier-"+P.substr(1)),a}n.asClassNameArray=l;function d(m){return l(m).join(" ")}n.asClassName=d;function u(m){return"."+l(m).join(".")}n.asCSSSelector=u})(k=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(y=e.Codicon||(e.Codicon={}))}),define(be[113],Ee([0,1,12,6]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function S(a){const f=a;return f?[f.on,f.pause,f.resume,f.destroy].every(v=>typeof v=="function"):!1}e.isReadableStream=S;function E(a){const f=a;return f?S(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.isReadableBufferedStream=E;function C(a,f){return new y(a,f)}e.newWriteableStream=C;class y{constructor(f,v){this.reducer=f,this.options=v,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(f){if(!this.state.destroyed){if(this.state.flowing)this.emitData(f);else if(this.buffer.data.push(f),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(v=>this.pendingWritePromises.push(v))}}error(f){this.state.destroyed||(this.state.flowing?this.emitError(f):this.buffer.error.push(f))}end(f){this.state.destroyed||(typeof f!="undefined"&&this.write(f),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(f){this.listeners.data.slice(0).forEach(v=>v(f))}emitError(f){this.listeners.error.length===0?(0,g.onUnexpectedError)(f):this.listeners.error.slice(0).forEach(v=>v(f))}emitEnd(){this.listeners.end.slice(0).forEach(f=>f())}on(f,v){if(!this.state.destroyed)switch(f){case"data":this.listeners.data.push(v),this.resume();break;case"end":this.listeners.end.push(v),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(v),this.state.flowing&&this.flowErrors();break}}removeListener(f,v){if(this.state.destroyed)return;let t;switch(f){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(v);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const f=this.reducer(this.buffer.data);this.emitData(f),this.buffer.data.length=0;const v=[...this.pendingWritePromises];this.pendingWritePromises.length=0,v.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const f of this.buffer.error)this.emitError(f);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function _(a,f){const v=[];let t;for(;(t=a.read())!==null;)v.push(t);return f(v)}e.consumeReadable=_;function k(a,f,v){const t=[];let r;for(;(r=a.read())!==null&&t.length<v;)t.push(r);return r===null&&t.length>0?f(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const s=r;return r=void 0,s}return a.read()}}}e.peekReadable=k;function n(a,f){return new Promise((v,t)=>{const r=[];I(a,{onData:s=>{f&&r.push(s)},onError:s=>{f?t(s):v(void 0)},onEnd:()=>{v(f?f(r):void 0)}})})}e.consumeStream=n;function I(a,f){a.on("error",v=>f.onError(v)),a.on("end",()=>f.onEnd()),a.on("data",v=>f.onData(v))}e.listenStream=I;function l(a,f){return new Promise((v,t)=>{const r=new F.DisposableStore,s=[],i=p=>{if(s.push(p),s.length>f)return r.dispose(),a.pause(),v({stream:a,buffer:s,ended:!1})},c=p=>t(p),h=()=>v({stream:a,buffer:s,ended:!0});r.add((0,F.toDisposable)(()=>a.removeListener("error",c))),a.on("error",c),r.add((0,F.toDisposable)(()=>a.removeListener("end",h))),a.on("end",h),r.add((0,F.toDisposable)(()=>a.removeListener("data",i))),a.on("data",i)})}e.peekStream=l;function d(a,f){const v=C(f);return v.end(a),v}e.toStream=d;function u(){const a=C(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=u;function m(a){let f=!1;return{read:()=>f?null:(f=!0,a)}}e.toReadable=m;function b(a,f,v){const t=C(v);return I(a,{onData:r=>t.write(f.data(r)),onError:r=>t.error(f.error?f.error(r):r),onEnd:()=>t.end()}),t}e.transform=b;function w(a,f,v){let t=!1;return{read:()=>{const r=f.read();return t?r:(t=!0,r!==null?v([a,r]):a)}}}e.prefixedReadable=w;function P(a,f,v){let t=!1;const r=C(v);return I(f,{onData:s=>t?r.write(s):(t=!0,r.write(v([a,s]))),onError:s=>r.error(s),onEnd:()=>{t||(t=!0,r.write(a)),r.end()}}),r}e.prefixedStream=P}),define(be[8],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function g(U){return!U||typeof U!="string"?!0:U.trim().length===0}e.isFalsyOrWhitespace=g;const F=/{(\d+)}/g;function S(U,...me){return me.length===0?U:U.replace(F,function(we,Ie){const Oe=parseInt(Ie,10);return isNaN(Oe)||Oe<0||Oe>=me.length?we:me[Oe]})}e.format=S;const E=/{([^}]+)}/g;function C(U,me){return U.replace(E,(we,Ie)=>me[Ie]??we)}e.format2=C;function y(U){return U.replace(/[<>&]/g,function(me){switch(me){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return me}})}e.escape=y;function _(U){return U.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=_;function k(U,me){let we=0;const Ie=me.charCodeAt(0);for(let Oe=U.length-1;Oe>=0;Oe--)U.charCodeAt(Oe)===Ie&&we++;return we}e.count=k;function n(U,me,we="\u2026"){return U.length<=me?U:`${U.substr(0,me)}${we}`}e.truncate=n;function I(U,me=" "){const we=l(U,me);return d(we,me)}e.trim=I;function l(U,me){if(!U||!me)return U;const we=me.length;if(we===0||U.length===0)return U;let Ie=0;for(;U.indexOf(me,Ie)===Ie;)Ie=Ie+we;return U.substring(Ie)}e.ltrim=l;function d(U,me){if(!U||!me)return U;const we=me.length,Ie=U.length;if(we===0||Ie===0)return U;let Oe=Ie,He=-1;for(;He=U.lastIndexOf(me,Oe-1),!(He===-1||He+we!==Oe);){if(He===0)return"";Oe=He}return U.substring(0,Oe)}e.rtrim=d;function u(U){return U.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function m(U){return U.replace(/\*/g,"")}e.stripWildcards=m;function b(U,me,we={}){if(!U)throw new Error("Cannot create regex from empty string");me||(U=_(U)),we.wholeWord&&(/\B/.test(U.charAt(0))||(U="\\b"+U),/\B/.test(U.charAt(U.length-1))||(U=U+"\\b"));let Ie="";return we.global&&(Ie+="g"),we.matchCase||(Ie+="i"),we.multiline&&(Ie+="m"),we.unicode&&(Ie+="u"),new RegExp(U,Ie)}e.createRegExp=b;function w(U){return U.source==="^"||U.source==="^$"||U.source==="$"||U.source==="^\\s*$"?!1:!!(U.exec("")&&U.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function P(U){return!!U.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=P;function a(U){return(U.global?"g":"")+(U.ignoreCase?"i":"")+(U.multiline?"m":"")+(U.unicode?"u":"")}e.regExpFlags=a;function f(U){return U.split(/\r\n|\r|\n/)}e.splitLines=f;function v(U){for(let me=0,we=U.length;me<we;me++){const Ie=U.charCodeAt(me);if(Ie!==32&&Ie!==9)return me}return-1}e.firstNonWhitespaceIndex=v;function t(U,me=0,we=U.length){for(let Ie=me;Ie<we;Ie++){const Oe=U.charCodeAt(Ie);if(Oe!==32&&Oe!==9)return U.substring(me,Ie)}return U.substring(me,we)}e.getLeadingWhitespace=t;function r(U,me=U.length-1){for(let we=me;we>=0;we--){const Ie=U.charCodeAt(we);if(Ie!==32&&Ie!==9)return we}return-1}e.lastNonWhitespaceIndex=r;function s(U,me){return U<me?-1:U>me?1:0}e.compare=s;function i(U,me,we=0,Ie=U.length,Oe=0,He=me.length){for(;we<Ie&&Oe<He;we++,Oe++){let Ge=U.charCodeAt(we),lt=me.charCodeAt(Oe);if(Ge<lt)return-1;if(Ge>lt)return 1}const et=Ie-we,Ke=He-Oe;return et<Ke?-1:et>Ke?1:0}e.compareSubstring=i;function c(U,me){return h(U,me,0,U.length,0,me.length)}e.compareIgnoreCase=c;function h(U,me,we=0,Ie=U.length,Oe=0,He=me.length){for(;we<Ie&&Oe<He;we++,Oe++){let Ge=U.charCodeAt(we),lt=me.charCodeAt(Oe);if(Ge===lt)continue;const ft=Ge-lt;if(!(ft===32&&D(lt))&&!(ft===-32&&D(Ge)))return p(Ge)&&p(lt)?ft:i(U.toLowerCase(),me.toLowerCase(),we,Ie,Oe,He)}const et=Ie-we,Ke=He-Oe;return et<Ke?-1:et>Ke?1:0}e.compareSubstringIgnoreCase=h;function p(U){return U>=97&&U<=122}e.isLowerAsciiLetter=p;function D(U){return U>=65&&U<=90}e.isUpperAsciiLetter=D;function T(U){return p(U)||D(U)}function o(U,me){return U.length===me.length&&A(U,me)}e.equalsIgnoreCase=o;function A(U,me,we=U.length){for(let Ie=0;Ie<we;Ie++){const Oe=U.charCodeAt(Ie),He=me.charCodeAt(Ie);if(Oe!==He){if(T(Oe)&&T(He)){const et=Math.abs(Oe-He);if(et!==0&&et!==32)return!1}else if(String.fromCharCode(Oe).toLowerCase()!==String.fromCharCode(He).toLowerCase())return!1}}return!0}function L(U,me){const we=me.length;return me.length>U.length?!1:A(U,me,we)}e.startsWithIgnoreCase=L;function $(U,me){let we,Ie=Math.min(U.length,me.length);for(we=0;we<Ie;we++)if(U.charCodeAt(we)!==me.charCodeAt(we))return we;return Ie}e.commonPrefixLength=$;function oe(U,me){let we,Ie=Math.min(U.length,me.length);const Oe=U.length-1,He=me.length-1;for(we=0;we<Ie;we++)if(U.charCodeAt(Oe-we)!==me.charCodeAt(He-we))return we;return Ie}e.commonSuffixLength=oe;function he(U){return 55296<=U&&U<=56319}e.isHighSurrogate=he;function Q(U){return 56320<=U&&U<=57343}e.isLowSurrogate=Q;function z(U,me){return(U-55296<<10)+(me-56320)+65536}e.computeCodePoint=z;function V(U,me,we){const Ie=U.charCodeAt(we);if(he(Ie)&&we+1<me){const Oe=U.charCodeAt(we+1);if(Q(Oe))return z(Ie,Oe)}return Ie}e.getNextCodePoint=V;function R(U,me){const we=U.charCodeAt(me-1);if(Q(we)&&me>1){const Ie=U.charCodeAt(me-2);if(he(Ie))return z(Ie,we)}return we}function G(U,me){const we=De.getInstance(),Ie=me,Oe=U.length,He=V(U,Oe,me);me+=He>=65536?2:1;let et=we.getGraphemeBreakType(He);for(;me<Oe;){const Ke=V(U,Oe,me),Ge=we.getGraphemeBreakType(Ke);if(xe(et,Ge))break;me+=Ke>=65536?2:1,et=Ge}return me-Ie}e.nextCharLength=G;function x(U,me){const we=De.getInstance(),Ie=me,Oe=R(U,me);me-=Oe>=65536?2:1;let He=we.getGraphemeBreakType(Oe);for(;me>0;){const et=R(U,me),Ke=we.getGraphemeBreakType(et);if(xe(Ke,He))break;me-=et>=65536?2:1,He=Ke}return Ie-me}e.prevCharLength=x;function j(U,me){const we=De.getInstance(),Ie=U.length,Oe=me,He=V(U,Ie,me),et=we.getGraphemeBreakType(He);me+=He>=65536?2:1;let Ke=et;for(;me<Ie;){const lt=V(U,Ie,me),ft=we.getGraphemeBreakType(lt);if(xe(Ke,ft))break;me+=lt>=65536?2:1,Ke=ft}const Ge=me;for(me=Oe,Ke=et;me>0;){const lt=R(U,me),ft=we.getGraphemeBreakType(lt);if(xe(ft,Ke))break;me-=lt>=65536?2:1,Ke=ft}return[me,Ge]}function de(U,me){return me>0&&Q(U.charCodeAt(me))?j(U,me-1):j(U,me)}e.getCharContainingOffset=de;function B(U){const me=U.length;let we=0,Ie=0;for(;Ie<me;){const et=V(U,me,Ie);Ie+=et>=65536?2:1,et<128?we+=1:et<2048?we+=2:et<65536?we+=3:we+=4}const Oe=new Uint8Array(we);Ie=0;let He=0;for(;Ie<me;){const et=V(U,me,Ie);Ie+=et>=65536?2:1,et<128?Oe[He++]=et:et<2048?(Oe[He++]=192|(et&1984)>>>6,Oe[He++]=128|(et&63)>>>0):et<65536?(Oe[He++]=224|(et&61440)>>>12,Oe[He++]=128|(et&4032)>>>6,Oe[He++]=128|(et&63)>>>0):(Oe[He++]=240|(et&1835008)>>>18,Oe[He++]=128|(et&258048)>>>12,Oe[He++]=128|(et&4032)>>>6,Oe[He++]=128|(et&63)>>>0)}return Oe}e.encodeUTF8=B;function ne(U){const me=U.byteLength,we=[];let Ie=0;for(;Ie<me;){const Oe=U[Ie];let He;if(Oe>=240&&Ie+3<me?He=(U[Ie++]&7)<<18>>>0|(U[Ie++]&63)<<12>>>0|(U[Ie++]&63)<<6>>>0|(U[Ie++]&63)<<0>>>0:Oe>=224&&Ie+2<me?He=(U[Ie++]&15)<<12>>>0|(U[Ie++]&63)<<6>>>0|(U[Ie++]&63)<<0>>>0:Oe>=192&&Ie+1<me?He=(U[Ie++]&31)<<6>>>0|(U[Ie++]&63)<<0>>>0:He=U[Ie++],He>=0&&He<=55295||He>=57344&&He<=65535)we.push(String.fromCharCode(He));else if(He>=65536&&He<=1114111){const et=He-65536,Ke=55296+((et&1047552)>>>10),Ge=56320+((et&1023)>>>0);we.push(String.fromCharCode(Ke)),we.push(String.fromCharCode(Ge))}else we.push(String.fromCharCode(65533))}return we.join("")}e.decodeUTF8=ne;const ue=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ye(U){return ue.test(U)}e.containsRTL=ye;const Re=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Te(U){return Re.test(U)}e.containsEmoji=Te;const $e=/^[\t\n\r\x20-\x7E]*$/;function Je(U){return $e.test(U)}e.isBasicASCII=Je,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Ve(U){return e.UNUSUAL_LINE_TERMINATORS.test(U)}e.containsUnusualLineTerminators=Ve;function je(U){for(let me=0,we=U.length;me<we;me++)if(O(U.charCodeAt(me)))return!0;return!1}e.containsFullWidthCharacter=je;function O(U){return U=+U,U>=11904&&U<=55215||U>=63744&&U<=64255||U>=65281&&U<=65374}e.isFullWidthCharacter=O;function K(U){return U>=127462&&U<=127487||U===8986||U===8987||U===9200||U===9203||U>=9728&&U<=10175||U===11088||U===11093||U>=127744&&U<=128591||U>=128640&&U<=128764||U>=128992&&U<=129003||U>=129280&&U<=129535||U>=129648&&U<=129750}e.isEmojiImprecise=K;function X(U,me){if(U.length<me)return U;const we=/\b/g;let Ie=0;for(;we.test(U)&&!(U.length-we.lastIndex<me);)Ie=we.lastIndex,we.lastIndex+=1;return U.substring(Ie).replace(/^\s/,"")}e.lcut=X;const se=/\x1B\x5B[12]?K/g,q=/\x1b\[\d+m/g,ie=/\x1b\[0?m/g;function ge(U){return U&&(U=U.replace(se,""),U=U.replace(q,""),U=U.replace(ie,"")),U}e.removeAnsiEscapeCodes=ge,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Le(U){return!!(U&&U.length>0&&U.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Le;function We(U){return Le(U)?U.substr(1):U}e.stripUTF8BOM=We;function ve(U,me){if(!U||!me||U.length<me.length)return!1;const we=me.length,Ie=U.toLowerCase();let Oe=0,He=-1;for(;Oe<we;){const et=Ie.indexOf(me[Oe],He+1);if(et<0)return!1;He=et,Oe++}return!0}e.fuzzyContains=ve;function Xe(U,me=!1){return U?(me&&(U=U.replace(/\\./g,"")),U.toLowerCase()!==U):!1}e.containsUppercaseCharacter=Xe;function H(U){return U.charAt(0).toUpperCase()+U.slice(1)}e.uppercaseFirstLetter=H;function Z(U,me=1){if(me===0)return"";let we=-1;do we=U.indexOf(`
`,we+1),me--;while(me>0&&we>=0);return we===-1?U:(U[we-1]==="\r"&&we--,U.substr(0,we))}e.getNLines=Z;function ce(U){const me=90-65+1;return U=U%(2*me),U<me?String.fromCharCode(97+U):String.fromCharCode(65+U-me)}e.singleLetterHash=ce;function Be(U){return De.getInstance().getGraphemeBreakType(U)}e.getGraphemeBreakType=Be;function xe(U,me){return U===0?me!==5&&me!==7:U===2&&me===3?!1:U===4||U===2||U===3||me===4||me===2||me===3?!0:!(U===8&&(me===8||me===9||me===11||me===12)||(U===11||U===9)&&(me===9||me===10)||(U===12||U===10)&&me===10||me===5||me===13||me===7||U===1||U===13&&me===14||U===6&&me===6)}e.breakBetweenGraphemeBreakType=xe;var Ze;(function(U){U[U.Other=0]="Other",U[U.Prepend=1]="Prepend",U[U.CR=2]="CR",U[U.LF=3]="LF",U[U.Control=4]="Control",U[U.Extend=5]="Extend",U[U.Regional_Indicator=6]="Regional_Indicator",U[U.SpacingMark=7]="SpacingMark",U[U.L=8]="L",U[U.V=9]="V",U[U.T=10]="T",U[U.LV=11]="LV",U[U.LVT=12]="LVT",U[U.ZWJ=13]="ZWJ",U[U.Extended_Pictographic=14]="Extended_Pictographic"})(Ze=e.GraphemeBreakType||(e.GraphemeBreakType={}));class De{constructor(){this._data=Se()}static getInstance(){return De._INSTANCE||(De._INSTANCE=new De),De._INSTANCE}getGraphemeBreakType(me){if(me<32)return me===10?3:me===13?2:4;if(me<127)return 0;const we=this._data,Ie=we.length/3;let Oe=1;for(;Oe<=Ie;)if(me<we[3*Oe])Oe=2*Oe;else if(me>we[3*Oe+1])Oe=2*Oe+1;else return we[3*Oe+2];return 0}}De._INSTANCE=null;function Se(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Pe(U,me){if(U===0)return 0;const we=re(U,me);if(we!==void 0)return we;const Ie=R(me,U);return U-=ae(Ie),U}e.getLeftDeleteOffset=Pe;function re(U,me){let we=R(me,U);for(U-=ae(we);fe(we)||we===65039||we===8419;){if(U===0)return;we=R(me,U),U-=ae(we)}if(!!K(we)){if(U>=0){const Ie=R(me,U);Ie===8205&&(U-=ae(Ie))}return U}}function ae(U){return U>=65536?2:1}function fe(U){return 127995<=U&&U<=127999}var pe;(function(U){U[U.zwj=8205]="zwj",U[U.emojiVariantSelector=65039]="emojiVariantSelector",U[U.enclosingKeyCap=8419]="enclosingKeyCap"})(pe||(pe={}))}),define(be[24],Ee([0,1,8,113]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const S=typeof Buffer!="undefined",E=typeof TextEncoder!="undefined",C=typeof TextDecoder!="undefined";let y,_;class k{constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}static alloc(p){return S?new k(Buffer.allocUnsafe(p)):new k(new Uint8Array(p))}static wrap(p){return S&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new k(p)}static fromString(p,D){return!(D?.dontUseNodeBuffer||!1)&&S?new k(Buffer.from(p)):E?(y||(y=new TextEncoder),new k(y.encode(p))):new k(g.encodeUTF8(p))}static concat(p,D){if(typeof D=="undefined"){D=0;for(let A=0,L=p.length;A<L;A++)D+=p[A].byteLength}const T=k.alloc(D);let o=0;for(let A=0,L=p.length;A<L;A++){const $=p[A];T.set($,o),o+=$.byteLength}return T}toString(){return S?this.buffer.toString():C?(_||(_=new TextDecoder),_.decode(this.buffer)):g.decodeUTF8(this.buffer)}slice(p,D){return new k(this.buffer.subarray(p,D))}set(p,D){p instanceof k?this.buffer.set(p.buffer,D):this.buffer.set(p,D)}readUInt32BE(p){return l(this.buffer,p)}writeUInt32BE(p,D){d(this.buffer,p,D)}readUInt32LE(p){return u(this.buffer,p)}writeUInt32LE(p,D){m(this.buffer,p,D)}readUInt8(p){return b(this.buffer,p)}writeUInt8(p,D){w(this.buffer,p,D)}}e.VSBuffer=k;function n(h,p){return h[p+0]<<0>>>0|h[p+1]<<8>>>0}e.readUInt16LE=n;function I(h,p,D){h[D+0]=p&255,p=p>>>8,h[D+1]=p&255}e.writeUInt16LE=I;function l(h,p){return h[p]*2**24+h[p+1]*2**16+h[p+2]*2**8+h[p+3]}e.readUInt32BE=l;function d(h,p,D){h[D+3]=p,p=p>>>8,h[D+2]=p,p=p>>>8,h[D+1]=p,p=p>>>8,h[D]=p}e.writeUInt32BE=d;function u(h,p){return h[p+0]<<0>>>0|h[p+1]<<8>>>0|h[p+2]<<16>>>0|h[p+3]<<24>>>0}e.readUInt32LE=u;function m(h,p,D){h[D+0]=p&255,p=p>>>8,h[D+1]=p&255,p=p>>>8,h[D+2]=p&255,p=p>>>8,h[D+3]=p&255}e.writeUInt32LE=m;function b(h,p){return h[p]}e.readUInt8=b;function w(h,p,D){h[D]=p}e.writeUInt8=w;function P(h){return F.consumeReadable(h,p=>k.concat(p))}e.readableToBuffer=P;function a(h){return F.toReadable(h)}e.bufferToReadable=a;function f(h){return F.consumeStream(h,p=>k.concat(p))}e.streamToBuffer=f;async function v(h){return h.ended?k.concat(h.buffer):k.concat([...h.buffer,await f(h.stream)])}e.bufferedStreamToBuffer=v;function t(h){return F.toStream(h,p=>k.concat(p))}e.bufferToStream=t;function r(h){return F.transform(h,{data:p=>typeof p=="string"?k.fromString(p):k.wrap(p)},p=>k.concat(p))}e.streamToBufferReadableStream=r;function s(h){return F.newWriteableStream(p=>k.concat(p),h)}e.newWriteableBufferStream=s;function i(h,p){return F.prefixedReadable(h,p,D=>k.concat(D))}e.prefixedBufferReadable=i;function c(h,p){return F.prefixedStream(h,p,D=>k.concat(D))}e.prefixedBufferStream=c}),define(be[42],Ee([0,1,8]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function F(w){return S(w,0)}e.hash=F;function S(w,P){switch(typeof w){case"object":return w===null?E(349,P):Array.isArray(w)?_(w,P):k(w,P);case"string":return y(w,P);case"boolean":return C(w,P);case"number":return E(w,P);case"undefined":return E(937,P);default:return E(617,P)}}e.doHash=S;function E(w,P){return(P<<5)-P+w|0}function C(w,P){return E(w?433:863,P)}function y(w,P){P=E(149417,P);for(let a=0,f=w.length;a<f;a++)P=E(w.charCodeAt(a),P);return P}e.stringHash=y;function _(w,P){return P=E(104579,P),w.reduce((a,f)=>S(f,a),P)}function k(w,P){return P=E(181387,P),Object.keys(w).sort().reduce((a,f)=>(a=y(f,a),S(w[f],a)),P)}class n{constructor(){this._value=0}get value(){return this._value}hash(P){return this._value=S(P,this._value),this._value}}e.Hasher=n;var I;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function l(w,P,a=32){const f=a-P,v=~((1<<f)-1);return(w<<P|(v&w)>>>f)>>>0}function d(w,P=0,a=w.byteLength,f=0){for(let v=0;v<a;v++)w[P+v]=f}function u(w,P,a="0"){for(;w.length<P;)w=a+w;return w}function m(w,P=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(a=>a.toString(16).padStart(2,"0")).join(""):u((w>>>0).toString(16),P/4)}e.toHexString=m;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(P){const a=P.length;if(a===0)return;const f=this._buff;let v=this._buffLen,t=this._leftoverHighSurrogate,r,s;for(t!==0?(r=t,s=-1,t=0):(r=P.charCodeAt(0),s=0);;){let i=r;if(g.isHighSurrogate(r))if(s+1<a){const c=P.charCodeAt(s+1);g.isLowSurrogate(c)?(s++,i=g.computeCodePoint(r,c)):i=65533}else{t=r;break}else g.isLowSurrogate(r)&&(i=65533);if(v=this._push(f,v,i),s++,s<a)r=P.charCodeAt(s);else break}this._buffLen=v,this._leftoverHighSurrogate=t}_push(P,a,f){return f<128?P[a++]=f:f<2048?(P[a++]=192|(f&1984)>>>6,P[a++]=128|(f&63)>>>0):f<65536?(P[a++]=224|(f&61440)>>>12,P[a++]=128|(f&4032)>>>6,P[a++]=128|(f&63)>>>0):(P[a++]=240|(f&1835008)>>>18,P[a++]=128|(f&258048)>>>12,P[a++]=128|(f&4032)>>>6,P[a++]=128|(f&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,P[0]=P[64+0],P[1]=P[64+1],P[2]=P[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,d(this._buff,this._buffLen),this._buffLen>56&&(this._step(),d(this._buff));const P=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(P/4294967296),!1),this._buffDV.setUint32(60,P%4294967296,!1),this._step()}_step(){const P=b._bigBlock32,a=this._buffDV;for(let p=0;p<64;p+=4)P.setUint32(p,a.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)P.setUint32(p,l(P.getUint32(p-12,!1)^P.getUint32(p-32,!1)^P.getUint32(p-56,!1)^P.getUint32(p-64,!1),1),!1);let f=this._h0,v=this._h1,t=this._h2,r=this._h3,s=this._h4,i,c,h;for(let p=0;p<80;p++)p<20?(i=v&t|~v&r,c=1518500249):p<40?(i=v^t^r,c=1859775393):p<60?(i=v&t|v&r|t&r,c=2400959708):(i=v^t^r,c=3395469782),h=l(f,5)+i+s+c+P.getUint32(p*4,!1)&4294967295,s=r,r=t,t=l(v,30),v=f,f=h;this._h0=this._h0+f&4294967295,this._h1=this._h1+v&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))}),define(be[43],Ee([0,1,8]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(F||(F={})),function(S){const E="error",C="warning",y="warn",_="info",k="ignore";function n(l){return l?g.equalsIgnoreCase(E,l)?S.Error:g.equalsIgnoreCase(C,l)||g.equalsIgnoreCase(y,l)?S.Warning:g.equalsIgnoreCase(_,l)?S.Info:S.Ignore:S.Ignore}S.fromValue=n;function I(l){switch(l){case S.Error:return E;case S.Warning:return C;case S.Info:return _;default:return k}}S.toString=I}(F||(F={})),e.default=F}),define(be[10],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function g(p){return Array.isArray(p)}e.isArray=g;function F(p){return typeof p=="string"}e.isString=F;function S(p){return Array.isArray(p)&&p.every(D=>F(D))}e.isStringArray=S;function E(p){return typeof p=="object"&&p!==null&&!Array.isArray(p)&&!(p instanceof RegExp)&&!(p instanceof Date)}e.isObject=E;function C(p){return typeof p=="number"&&!isNaN(p)}e.isNumber=C;function y(p){return!!p&&typeof p[Symbol.iterator]=="function"}e.isIterable=y;function _(p){return p===!0||p===!1}e.isBoolean=_;function k(p){return typeof p=="undefined"}e.isUndefined=k;function n(p){return!I(p)}e.isDefined=n;function I(p){return k(p)||p===null}e.isUndefinedOrNull=I;function l(p,D){if(!p)throw new Error(D?`Unexpected type, expected '${D}'`:"Unexpected type")}e.assertType=l;function d(p){if(I(p))throw new Error("Assertion Failed: argument is undefined or null");return p}e.assertIsDefined=d;function u(...p){const D=[];for(let T=0;T<p.length;T++){const o=p[T];if(I(o))throw new Error(`Assertion Failed: argument at index ${T} is undefined or null`);D.push(o)}return D}e.assertAllDefined=u;const m=Object.prototype.hasOwnProperty;function b(p){if(!E(p))return!1;for(let D in p)if(m.call(p,D))return!1;return!0}e.isEmptyObject=b;function w(p){return typeof p=="function"}e.isFunction=w;function P(...p){return p.length>0&&p.every(w)}e.areFunctions=P;function a(p,D){const T=Math.min(p.length,D.length);for(let o=0;o<T;o++)f(p[o],D[o])}e.validateConstraints=a;function f(p,D){if(F(D)){if(typeof p!==D)throw new Error(`argument does not match constraint: typeof ${D}`)}else if(w(D)){try{if(p instanceof D)return}catch{}if(!I(p)&&p.constructor===D||D.length===1&&D.call(void 0,p)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=f;function v(p){let D=[],T=Object.getPrototypeOf(p);for(;Object.prototype!==T;)D=D.concat(Object.getOwnPropertyNames(T)),T=Object.getPrototypeOf(T);return D}e.getAllPropertyNames=v;function t(p){const D=[];for(const T of v(p))typeof p[T]=="function"&&D.push(T);return D}e.getAllMethodNames=t;function r(p,D){const T=A=>function(){const L=Array.prototype.slice.call(arguments,0);return D(A,L)};let o={};for(const A of p)o[A]=T(A);return o}e.createProxyObject=r;function s(p){return p===null?void 0:p}e.withNullAsUndefined=s;function i(p){return typeof p=="undefined"?null:p}e.withUndefinedAsNull=i;function c(p){return class{constructor(){return new Proxy({},{get(D,T){if(D[T])return D[T];throw new Error(`Not Implemented: ${p}->${String(T)}`)}})}}}e.NotImplementedProxy=c;function h(p,D="Unreachable"){throw new Error(D)}e.assertNever=h}),define(be[44],Ee([0,1,22,8,14,10]),function(ee,e,g,F,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(s){return s===47||s===92}e.isPathSeparator=C;function y(s){return s.replace(/[\\/]/g,S.posix.sep)}e.toSlashes=y;function _(s){return s.indexOf("/")===-1&&(s=y(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=_;function k(s,i=S.posix.sep){if(!s)return"";const c=s.length,h=s.charCodeAt(0);if(C(h)){if(C(s.charCodeAt(1))&&!C(s.charCodeAt(2))){let D=3;const T=D;for(;D<c&&!C(s.charCodeAt(D));D++);if(T!==D&&!C(s.charCodeAt(D+1))){for(D+=1;D<c;D++)if(C(s.charCodeAt(D)))return s.slice(0,D+1).replace(/[\\/]/g,i)}}return i}else if(w(h)&&s.charCodeAt(1)===58)return C(s.charCodeAt(2))?s.slice(0,2)+i:s.slice(0,2);let p=s.indexOf("://");if(p!==-1){for(p+=3;p<c;p++)if(C(s.charCodeAt(p)))return s.slice(0,p+1)}return""}e.getRoot=k;function n(s){if(!g.isWindows||!s||s.length<5)return!1;let i=s.charCodeAt(0);if(i!==92||(i=s.charCodeAt(1),i!==92))return!1;let c=2;const h=c;for(;c<s.length&&(i=s.charCodeAt(c),i!==92);c++);return!(h===c||(i=s.charCodeAt(c+1),isNaN(i)||i===92))}e.isUNC=n;const I=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(s,i=g.isWindows){const c=i?I:l;return!(!s||s.length===0||/^\s+$/.test(s)||(c.lastIndex=0,c.test(s))||i&&d.test(s)||s==="."||s===".."||i&&s[s.length-1]==="."||i&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=u;function m(s,i,c){const h=s===i;return!c||h?h:!s||!i?!1:(0,F.equalsIgnoreCase)(s,i)}e.isEqual=m;function b(s,i,c,h=S.sep){if(s===i)return!0;if(!s||!i||i.length>s.length)return!1;if(c){if(!(0,F.startsWithIgnoreCase)(s,i))return!1;if(i.length===s.length)return!0;let D=i.length;return i.charAt(i.length-1)===h&&D--,s.charAt(D)===h}return i.charAt(i.length-1)!==h&&(i+=h),s.indexOf(i)===0}e.isEqualOrParent=b;function w(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=w;function P(s,i){return g.isWindows&&s.endsWith(":")&&(s+=S.sep),(0,S.isAbsolute)(s)||(s=(0,S.join)(i,s)),s=(0,S.normalize)(s),g.isWindows?(s=(0,F.rtrim)(s,S.sep),s.endsWith(":")&&(s+=S.sep)):(s=(0,F.rtrim)(s,S.sep),s||(s=S.sep)),s}e.sanitizeFilePath=P;function a(s){const i=(0,S.normalize)(s);return g.isWindows?s.length>3?!1:f(i)&&(s.length===2||i.charCodeAt(2)===92):i===S.posix.sep}e.isRootOrDriveLetter=a;function f(s){return g.isWindows?w(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function v(s){return f(s)?s[0]:void 0}e.getDriveLetter=v;function t(s,i,c){return i.length>s.length?-1:s===i?0:(c&&(s=s.toLowerCase(),i=i.toLowerCase()),s.indexOf(i))}e.indexOfPath=t;function r(s){const i=s.split(":");let c,h,p;if(i.forEach(D=>{const T=Number(D);(0,E.isNumber)(T)?h===void 0?h=T:p===void 0&&(p=T):c=c?[c,D].join(":"):D}),!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:h!==void 0?h:void 0,column:p!==void 0?p:h!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(be[23],Ee([0,1,10]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function F(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const b=Array.isArray(m)?[]:{};return Object.keys(m).forEach(w=>{m[w]&&typeof m[w]=="object"?b[w]=F(m[w]):b[w]=m[w]}),b}e.deepClone=F;function S(m){if(!m||typeof m!="object")return m;const b=[m];for(;b.length>0;){const w=b.shift();Object.freeze(w);for(const P in w)if(E.call(w,P)){const a=w[P];typeof a=="object"&&!Object.isFrozen(a)&&b.push(a)}}return m}e.deepFreeze=S;const E=Object.prototype.hasOwnProperty;function C(m,b){return y(m,b,new Set)}e.cloneAndChange=C;function y(m,b,w){if((0,g.isUndefinedOrNull)(m))return m;const P=b(m);if(typeof P!="undefined")return P;if((0,g.isArray)(m)){const a=[];for(const f of m)a.push(y(f,b,w));return a}if((0,g.isObject)(m)){if(w.has(m))throw new Error("Cannot clone recursive data-structure");w.add(m);const a={};for(let f in m)E.call(m,f)&&(a[f]=y(m[f],b,w));return w.delete(m),a}return m}function _(m,b,w=!0){return(0,g.isObject)(m)?((0,g.isObject)(b)&&Object.keys(b).forEach(P=>{P in m?w&&((0,g.isObject)(m[P])&&(0,g.isObject)(b[P])?_(m[P],b[P],w):m[P]=b[P]):m[P]=b[P]}),m):b}e.mixin=_;function k(m,b){if(m===b)return!0;if(m==null||b===null||b===void 0||typeof m!=typeof b||typeof m!="object"||Array.isArray(m)!==Array.isArray(b))return!1;let w,P;if(Array.isArray(m)){if(m.length!==b.length)return!1;for(w=0;w<m.length;w++)if(!k(m[w],b[w]))return!1}else{const a=[];for(P in m)a.push(P);a.sort();const f=[];for(P in b)f.push(P);if(f.sort(),!k(a,f))return!1;for(w=0;w<a.length;w++)if(!k(m[a[w]],b[a[w]]))return!1}return!0}e.equals=k;function n(m){const b=new Set;return JSON.stringify(m,(w,P)=>{if((0,g.isObject)(P)||Array.isArray(P)){if(b.has(P))return"[Circular]";b.add(P)}return P})}e.safeStringify=n;function I(m,b,w){const P=b(m);return typeof P=="undefined"?w:P}e.getOrDefault=I;function l(m,b){const w=Object.create(null);return!m||!b||Object.keys(b).forEach(a=>{const f=m[a],v=b[a];k(f,v)||(w[a]=v)}),w}e.distinct=l;function d(m,b){const w=b.toLowerCase(),P=Object.keys(m).find(a=>a.toLowerCase()===w);return P?m[P]:m[b]}e.getCaseInsensitive=d;function u(m,b){const w=Object.create(null);for(const P of Object.keys(m))b(P,m[P])&&(w[P]=m[P]);return w}e.filter=u}),define(be[82],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var g;(function(E){E[E.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",E[E.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",E[E.MAX_UINT_8=255]="MAX_UINT_8",E[E.MAX_UINT_16=65535]="MAX_UINT_16",E[E.MAX_UINT_32=4294967295]="MAX_UINT_32",E[E.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(g=e.Constants||(e.Constants={}));function F(E){return E<0?0:E>255?255:E|0}e.toUint8=F;function S(E){return E<0?0:E>4294967295?4294967295:E|0}e.toUint32=S}),define(be[2],Ee([0,1,22,14]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const S=/^\w[\w\d+.-]*$/,E=/^\//,C=/^\/\//;function y(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!S.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!E.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function _(s,i){return!s&&!i?"file":s}function k(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==I&&(i=I+i):i=I;break}return i}const n="",I="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{constructor(i,c,h,p,D,T=!1){typeof i=="object"?(this.scheme=i.scheme||n,this.authority=i.authority||n,this.path=i.path||n,this.query=i.query||n,this.fragment=i.fragment||n):(this.scheme=_(i,T),this.authority=c||n,this.path=k(this.scheme,h||n),this.query=p||n,this.fragment=D||n,y(this,T))}static isUri(i){return i instanceof d?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return a(this,!1)}with(i){if(!i)return this;let{scheme:c,authority:h,path:p,query:D,fragment:T}=i;return c===void 0?c=this.scheme:c===null&&(c=n),h===void 0?h=this.authority:h===null&&(h=n),p===void 0?p=this.path:p===null&&(p=n),D===void 0?D=this.query:D===null&&(D=n),T===void 0?T=this.fragment:T===null&&(T=n),c===this.scheme&&h===this.authority&&p===this.path&&D===this.query&&T===this.fragment?this:new m(c,h,p,D,T)}static parse(i,c=!1){const h=l.exec(i);return h?new m(h[2]||n,r(h[4]||n),r(h[5]||n),r(h[7]||n),r(h[9]||n),c):new m(n,n,n,n,n)}static file(i){let c=n;if(g.isWindows&&(i=i.replace(/\\/g,I)),i[0]===I&&i[1]===I){const h=i.indexOf(I,2);h===-1?(c=i.substring(2),i=I):(c=i.substring(2,h),i=i.substring(h)||I)}return new m("file",c,i,n,n)}static from(i){const c=new m(i.scheme,i.authority,i.path,i.query,i.fragment);return y(c,!0),c}static joinPath(i,...c){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let h;return g.isWindows&&i.scheme==="file"?h=d.file(F.win32.join(a(i,!0),...c)).path:h=F.posix.join(i.path,...c),i.with({path:h})}toString(i=!1){return f(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof d)return i;{const c=new m(i);return c._formatted=i.external,c._fsPath=i._sep===u?i.fsPath:null,c}}else return i}}e.URI=d;const u=g.isWindows?1:void 0;class m extends d{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(i=!1){return i?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=u),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(s,i){let c,h=-1;for(let p=0;p<s.length;p++){const D=s.charCodeAt(p);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||i&&D===47)h!==-1&&(c+=encodeURIComponent(s.substring(h,p)),h=-1),c!==void 0&&(c+=s.charAt(p));else{c===void 0&&(c=s.substr(0,p));const T=b[D];T!==void 0?(h!==-1&&(c+=encodeURIComponent(s.substring(h,p)),h=-1),c+=T):h===-1&&(h=p)}}return h!==-1&&(c+=encodeURIComponent(s.substring(h))),c!==void 0?c:s}function P(s){let i;for(let c=0;c<s.length;c++){const h=s.charCodeAt(c);h===35||h===63?(i===void 0&&(i=s.substr(0,c)),i+=b[h]):i!==void 0&&(i+=s[c])}return i!==void 0?i:s}function a(s,i){let c;return s.authority&&s.path.length>1&&s.scheme==="file"?c=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?c=s.path.substr(1):c=s.path[1].toLowerCase()+s.path.substr(2):c=s.path,g.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=a;function f(s,i){const c=i?P:w;let h="",{scheme:p,authority:D,path:T,query:o,fragment:A}=s;if(p&&(h+=p,h+=":"),(D||p==="file")&&(h+=I,h+=I),D){let L=D.indexOf("@");if(L!==-1){const $=D.substr(0,L);D=D.substr(L+1),L=$.indexOf(":"),L===-1?h+=c($,!1):(h+=c($.substr(0,L),!1),h+=":",h+=c($.substr(L+1),!1)),h+="@"}D=D.toLowerCase(),L=D.indexOf(":"),L===-1?h+=c(D,!1):(h+=c(D.substr(0,L),!1),h+=D.substr(L))}if(T){if(T.length>=3&&T.charCodeAt(0)===47&&T.charCodeAt(2)===58){const L=T.charCodeAt(1);L>=65&&L<=90&&(T=`/${String.fromCharCode(L+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===58){const L=T.charCodeAt(0);L>=65&&L<=90&&(T=`${String.fromCharCode(L+32)}:${T.substr(2)}`)}h+=c(T,!0)}return o&&(h+="?",h+=c(o,!1)),A&&(h+="#",h+=i?A:w(A,!1)),h}function v(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+v(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(s){return s.match(t)?s.replace(t,i=>v(i)):s}});var nt=this&&this.__classPrivateFieldSet||function(ee,e,g,F,S){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Ue=this&&this.__classPrivateFieldGet||function(ee,e,g,F){if(g==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?F:g==="a"?F.call(ee):F?F.value:e.get(ee)};define(be[21],Ee([0,1,2,8]),function(ee,e,g,F){"use strict";var S,E,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function y(t,r,s){let i=t.get(r);return i===void 0&&(i=s,t.set(r,i)),i}e.getOrSet=y;function _(t){const r=[];return t.forEach((s,i)=>{r.push(`${i} => ${s}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=_;function k(t){const r=[];return t.forEach(s=>{r.push(s)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=k;class n{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),i=this._value.charCodeAt(this._pos);return s-i}value(){return this._value[this._pos]}}e.StringIterator=n;class I{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,F.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class l{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,F.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=l;var d;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(d||(d={}));class u{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new l(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,F.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,F.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,F.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,F.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=u;class m{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class b{constructor(r){this._iter=r}static forUris(r=()=>!1){return new b(new u(r))}static forPaths(){return new b(new l)}static forStrings(){return new b(new n)}static forConfigKeys(){return new b(new I)}clear(){this._root=void 0}set(r,s){const i=this._iter.reset(r);let c;for(this._root||(this._root=new m,this._root.segment=i.value()),c=this._root;;){const p=i.cmp(c.segment);if(p>0)c.left||(c.left=new m,c.left.segment=i.value()),c=c.left;else if(p<0)c.right||(c.right=new m,c.right.segment=i.value()),c=c.right;else if(i.hasNext())i.next(),c.mid||(c.mid=new m,c.mid.segment=i.value()),c=c.mid;else break}const h=c.value;return c.value=s,c.key=r,h}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let i=this._root;for(;i;){const c=s.cmp(i.segment);if(c>0)i=i.left;else if(c<0)i=i.right;else if(s.hasNext())s.next(),i=i.mid;else break}return i}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const i=this._iter.reset(r),c=[];let h=this._root;for(;h;){const p=i.cmp(h.segment);if(p>0)c.push([1,h]),h=h.left;else if(p<0)c.push([-1,h]),h=h.right;else if(i.hasNext())i.next(),c.push([0,h]),h=h.mid;else{for(s?(h.left=void 0,h.mid=void 0,h.right=void 0):h.value=void 0;c.length>0&&h.isEmpty();){let[D,T]=c.pop();switch(D){case 1:T.left=void 0;break;case 0:T.mid=void 0;break;case-1:T.right=void 0;break}h=T}break}}}findSubstr(r){const s=this._iter.reset(r);let i=this._root,c;for(;i;){const h=s.cmp(i.segment);if(h>0)i=i.left;else if(h<0)i=i.right;else if(s.hasNext())s.next(),c=i.value||c,i=i.mid;else break}return i&&i.value||c}findSuperstr(r){const s=this._iter.reset(r);let i=this._root;for(;i;){const c=s.cmp(i.segment);if(c>0)i=i.left;else if(c<0)i=i.right;else if(s.hasNext())s.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(r){for(const[s,i]of this)r(i,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const s=[r];for(;s.length>0;){const i=s.pop();i&&(i.value&&(yield[i.key,i.value]),i.left&&s.push(i.left),i.mid&&s.push(i.mid),i.right&&s.push(i.right))}}}e.TernarySearchTree=b;class w{constructor(r,s){this[S]="ResourceMap",r instanceof w?(this.map=new Map(r.map),this.toKey=s??w.defaultToKey):(this.map=new Map,this.toKey=r??w.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),s),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s!="undefined"&&(r=r.bind(s));for(let[i,c]of this.map)r(c,g.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield g.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[g.URI.parse(r[0]),r[1]]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[g.URI.parse(r[0]),r[1]]}}e.ResourceMap=w,w.defaultToKey=t=>t.toString();var P;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(P=e.Touch||(e.Touch={}));class a{constructor(){this[E]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const i=this._map.get(r);if(!!i)return s!==0&&this.touch(i,s),i.value}set(r,s,i=0){let c=this._map.get(r);if(c)c.value=s,i!==0&&this.touch(c,i);else{switch(c={key:r,value:s,next:void 0,previous:void 0},i){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(r,c),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const i=this._state;let c=this._head;for(;c;){if(s?r.bind(s)(c.value,c.key,this):r(c.value,c.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const r=this,s=this._state;let i=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const h={value:i.key,done:!1};return i=i.next,h}else return{value:void 0,done:!0}}};return c}values(){const r=this,s=this._state;let i=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const h={value:i.value,done:!1};return i=i.next,h}else return{value:void 0,done:!0}}};return c}entries(){const r=this,s=this._state;let i=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const h={value:[i.key,i.value],done:!1};return i=i.next,h}else return{value:void 0,done:!0}}};return c}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,i=this.size;for(;s&&i>r;)this._map.delete(s.key),s=s.next,i--;this._head=s,this._size=i,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,i=r.previous;if(!s||!i)throw new Error("Invalid list");s.previous=i,i.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const i=r.next,c=r.previous;r===this._tail?(c.next=void 0,this._tail=c):(i.previous=c,c.next=i),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const i=r.next,c=r.previous;r===this._head?(i.previous=void 0,this._head=i):(i.previous=c,c.next=i),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,i)=>{r.push([i,s])}),r}fromJSON(r){this.clear();for(const[s,i]of r)this.set(s,i)}}e.LinkedMap=a;class f extends a{constructor(r,s=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=f;class v{constructor(r){C.set(this,void 0),nt(this,C,r,"f")}get size(){return Ue(this,C,"f").size}forEach(r,s){Ue(this,C,"f").forEach(r,s)}get(r){return Ue(this,C,"f").get(r)}has(r){return Ue(this,C,"f").has(r)}entries(){return Ue(this,C,"f").entries()}keys(){return Ue(this,C,"f").keys()}values(){return Ue(this,C,"f").values()}[(C=new WeakMap,Symbol.iterator)](){return Ue(this,C,"f").entries()}}e.ReadonlyMapView=v}),define(be[114],Ee([0,1,21,8]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function S(...q){return function(ie,ge){for(let Le=0,We=q.length;Le<We;Le++){const ve=q[Le](ie,ge);if(ve)return ve}return null}}e.or=S,e.matchesStrictPrefix=E.bind(void 0,!1),e.matchesPrefix=E.bind(void 0,!0);function E(q,ie,ge){if(!ge||ge.length<ie.length)return null;let Le;return q?Le=F.startsWithIgnoreCase(ge,ie):Le=ge.indexOf(ie)===0,Le?ie.length>0?[{start:0,end:ie.length}]:[]:null}function C(q,ie){const ge=ie.toLowerCase().indexOf(q.toLowerCase());return ge===-1?null:[{start:ge,end:ge+q.length}]}e.matchesContiguousSubString=C;function y(q,ie){return _(q.toLowerCase(),ie.toLowerCase(),0,0)}e.matchesSubString=y;function _(q,ie,ge,Le){if(ge===q.length)return[];if(Le===ie.length)return null;if(q[ge]===ie[Le]){let We=null;return(We=_(q,ie,ge+1,Le+1))?w({start:Le,end:Le+1},We):null}return _(q,ie,ge,Le+1)}function k(q){return 97<=q&&q<=122}function n(q){return 65<=q&&q<=90}e.isUpper=n;function I(q){return 48<=q&&q<=57}function l(q){return q===32||q===9||q===10||q===13}const d=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(q=>d.add(q.charCodeAt(0)));function u(q){return l(q)||d.has(q)}function m(q,ie){return q===ie||u(q)&&u(ie)}function b(q){return k(q)||n(q)||I(q)}function w(q,ie){return ie.length===0?ie=[q]:q.end===ie[0].start?ie[0].start=q.start:ie.unshift(q),ie}function P(q,ie){for(let ge=ie;ge<q.length;ge++){const Le=q.charCodeAt(ge);if(n(Le)||I(Le)||ge>0&&!b(q.charCodeAt(ge-1)))return ge}return q.length}function a(q,ie,ge,Le){if(ge===q.length)return[];if(Le===ie.length)return null;if(q[ge]!==ie[Le].toLowerCase())return null;{let We=null,ve=Le+1;for(We=a(q,ie,ge+1,Le+1);!We&&(ve=P(ie,ve))<ie.length;)We=a(q,ie,ge+1,ve),ve++;return We===null?null:w({start:Le,end:Le+1},We)}}function f(q){let ie=0,ge=0,Le=0,We=0,ve=0;for(let Be=0;Be<q.length;Be++)ve=q.charCodeAt(Be),n(ve)&&ie++,k(ve)&&ge++,b(ve)&&Le++,I(ve)&&We++;const Xe=ie/q.length,H=ge/q.length,Z=Le/q.length,ce=We/q.length;return{upperPercent:Xe,lowerPercent:H,alphaPercent:Z,numericPercent:ce}}function v(q){const{upperPercent:ie,lowerPercent:ge}=q;return ge===0&&ie>.6}function t(q){const{upperPercent:ie,lowerPercent:ge,alphaPercent:Le,numericPercent:We}=q;return ge>.2&&ie<.8&&Le>.6&&We<.2}function r(q){let ie=0,ge=0,Le=0,We=0;for(let ve=0;ve<q.length;ve++)Le=q.charCodeAt(ve),n(Le)&&ie++,k(Le)&&ge++,l(Le)&&We++;return(ie===0||ge===0)&&We===0?q.length<=30:ie<=5}function s(q,ie){if(!ie||(ie=ie.trim(),ie.length===0)||!r(q)||ie.length>60)return null;const ge=f(ie);if(!t(ge)){if(!v(ge))return null;ie=ie.toLowerCase()}let Le=null,We=0;for(q=q.toLowerCase();We<ie.length&&(Le=a(q,ie,0,We))===null;)We=P(ie,We+1);return Le}e.matchesCamelCase=s;function i(q,ie,ge=!1){if(!ie||ie.length===0)return null;let Le=null,We=0;for(q=q.toLowerCase(),ie=ie.toLowerCase();We<ie.length&&(Le=c(q,ie,0,We,ge))===null;)We=h(ie,We+1);return Le}e.matchesWords=i;function c(q,ie,ge,Le,We){if(ge===q.length)return[];if(Le===ie.length)return null;if(m(q.charCodeAt(ge),ie.charCodeAt(Le))){let ve=null,Xe=Le+1;if(ve=c(q,ie,ge+1,Le+1,We),!We)for(;!ve&&(Xe=h(ie,Xe))<ie.length;)ve=c(q,ie,ge+1,Xe,We),Xe++;return ve===null?null:w({start:Le,end:Le+1},ve)}else return null}function h(q,ie){for(let ge=ie;ge<q.length;ge++)if(u(q.charCodeAt(ge))||ge>0&&u(q.charCodeAt(ge-1)))return ge;return q.length}const p=S(e.matchesPrefix,s,C),D=S(e.matchesPrefix,s,y),T=new g.LRUCache(1e4);function o(q,ie,ge=!1){if(typeof q!="string"||typeof ie!="string")return null;let Le=T.get(q);Le||(Le=new RegExp(F.convertSimple2RegExpPattern(q),"i"),T.set(q,Le));const We=Le.exec(ie);return We?[{start:We.index,end:We.index+We[0].length}]:ge?D(q,ie):p(q,ie)}e.matchesFuzzy=o;function A(q,ie){const ge=Je(q,q.toLowerCase(),0,ie,ie.toLowerCase(),0,!0);return ge?$(ge):null}e.matchesFuzzy2=A;function L(q,ie,ge,Le,We,ve){const Xe=Math.min(13,q.length);for(;ge<Xe;ge++){const H=Je(q,ie,ge,Le,We,ve,!1);if(H)return H}return[0,ve]}e.anyScore=L;function $(q){if(typeof q=="undefined")return[];const ie=[],ge=q[1];for(let Le=q.length-1;Le>1;Le--){const We=q[Le]+ge,ve=ie[ie.length-1];ve&&ve.end===We?ve.end=We+1:ie.push({start:We,end:We+1})}return ie}e.createMatches=$;const oe=128;function he(){const q=[],ie=[];for(let ge=0;ge<=oe;ge++)ie[ge]=0;for(let ge=0;ge<=oe;ge++)q.push(ie.slice(0));return q}function Q(q){const ie=[];for(let ge=0;ge<=q;ge++)ie[ge]=0;return ie}const z=Q(2*oe),V=Q(2*oe),R=he(),G=he(),x=he(),j=!1;function de(q,ie,ge,Le,We){function ve(H,Z,ce=" "){for(;H.length<Z;)H=ce+H;return H}let Xe=` |   |${Le.split("").map(H=>ve(H,3)).join("|")}
`;for(let H=0;H<=ge;H++)H===0?Xe+=" |":Xe+=`${ie[H-1]}|`,Xe+=q[H].slice(0,We+1).map(Z=>ve(Z.toString(),3)).join("|")+`
`;return Xe}function B(q,ie,ge,Le){q=q.substr(ie),ge=ge.substr(Le),console.log(de(G,q,q.length,ge,ge.length)),console.log(de(x,q,q.length,ge,ge.length)),console.log(de(R,q,q.length,ge,ge.length))}function ne(q,ie){if(ie<0||ie>=q.length)return!1;const ge=q.codePointAt(ie);switch(ge){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!F.isEmojiImprecise(ge)}}function ue(q,ie){if(ie<0||ie>=q.length)return!1;switch(q.charCodeAt(ie)){case 32:case 9:return!0;default:return!1}}function ye(q,ie,ge){return ie[q]!==ge[q]}function Re(q,ie,ge,Le,We,ve,Xe=!1){for(;ie<ge&&We<ve;)q[ie]===Le[We]&&(Xe&&(z[ie]=We),ie+=1),We+=1;return ie===ge}e.isPatternInWord=Re;var Te;(function(q){q[q.Diag=1]="Diag",q[q.Left=2]="Left",q[q.LeftLeft=3]="LeftLeft"})(Te||(Te={}));var $e;(function(q){q.Default=[-100,0];function ie(ge){return!ge||ge.length===2&&ge[0]===-100&&ge[1]===0}q.isDefault=ie})($e=e.FuzzyScore||(e.FuzzyScore={}));function Je(q,ie,ge,Le,We,ve,Xe){const H=q.length>oe?oe:q.length,Z=Le.length>oe?oe:Le.length;if(ge>=H||ve>=Z||H-ge>Z-ve||!Re(ie,ge,H,We,ve,Z,!0))return;Ve(H,Z,ge,ve,ie,We);let ce=1,Be=1,xe=ge,Ze=ve;const De=[!1];for(ce=1,xe=ge;xe<H;ce++,xe++){const fe=z[xe],pe=V[xe],U=xe+1<H?V[xe+1]:Z;for(Be=fe-ve+1,Ze=fe;Ze<U;Be++,Ze++){let me=Number.MIN_SAFE_INTEGER,we=!1;Ze<=pe&&(me=je(q,ie,xe,ge,Le,We,Ze,Z,ve,R[ce-1][Be-1]===0,De));let Ie=0;me!==Number.MAX_SAFE_INTEGER&&(we=!0,Ie=me+G[ce-1][Be-1]);const Oe=Ze>fe,He=Oe?G[ce][Be-1]+(R[ce][Be-1]>0?-5:0):0,et=Ze>fe+1&&R[ce][Be-1]>0,Ke=et?G[ce][Be-2]+(R[ce][Be-2]>0?-5:0):0;if(et&&(!Oe||Ke>=He)&&(!we||Ke>=Ie))G[ce][Be]=Ke,x[ce][Be]=3,R[ce][Be]=0;else if(Oe&&(!we||He>=Ie))G[ce][Be]=He,x[ce][Be]=2,R[ce][Be]=0;else if(we)G[ce][Be]=Ie,x[ce][Be]=1,R[ce][Be]=R[ce-1][Be-1]+1;else throw new Error("not possible")}}if(j&&B(q,ge,Le,ve),!De[0]&&!Xe)return;ce--,Be--;const Se=[G[ce][Be],ve];let Pe=0,re=0;for(;ce>=1;){let fe=Be;do{const pe=x[ce][fe];if(pe===3)fe=fe-2;else if(pe===2)fe=fe-1;else break}while(fe>=1);Pe>1&&ie[ge+ce-1]===We[ve+Be-1]&&!ye(fe+ve-1,Le,We)&&Pe+1>R[ce][fe]&&(fe=Be),fe===Be?Pe++:Pe=1,re||(re=fe),ce--,Be=fe-1,Se.push(Be)}Z===H&&(Se[0]+=2);const ae=re-H;return Se[0]-=ae,Se}e.fuzzyScore=Je;function Ve(q,ie,ge,Le,We,ve){let Xe=q-1,H=ie-1;for(;Xe>=ge&&H>=Le;)We[Xe]===ve[H]&&(V[Xe]=H,Xe--),H--}function je(q,ie,ge,Le,We,ve,Xe,H,Z,ce,Be){if(ie[ge]!==ve[Xe])return Number.MIN_SAFE_INTEGER;let xe=1,Ze=!1;return Xe===ge-Le?xe=q[ge]===We[Xe]?7:5:ye(Xe,We,ve)&&(Xe===0||!ye(Xe-1,We,ve))?(xe=q[ge]===We[Xe]?7:5,Ze=!0):ne(ve,Xe)&&(Xe===0||!ne(ve,Xe-1))?xe=5:(ne(ve,Xe-1)||ue(ve,Xe-1))&&(xe=5,Ze=!0),xe>1&&ge===Le&&(Be[0]=!0),Ze||(Ze=ye(Xe,We,ve)||ne(ve,Xe-1)||ue(ve,Xe-1)),ge===Le?Xe>Z&&(xe-=Ze?3:5):ce?xe+=Ze?2:0:xe+=Ze?0:1,Xe+1===H&&(xe-=Ze?3:5),xe}function O(q,ie,ge,Le,We,ve,Xe){return X(q,ie,ge,Le,We,ve,!0,Xe)}e.fuzzyScoreGracefulAggressive=O;function K(q,ie,ge,Le,We,ve,Xe){return X(q,ie,ge,Le,We,ve,!1,Xe)}e.fuzzyScoreGraceful=K;function X(q,ie,ge,Le,We,ve,Xe,H){let Z=Je(q,ie,ge,Le,We,ve,H);if(Z&&!Xe)return Z;if(q.length>=3){const ce=Math.min(7,q.length-1);for(let Be=ge+1;Be<ce;Be++){const xe=se(q,Be);if(xe){const Ze=Je(xe,xe.toLowerCase(),ge,Le,We,ve,H);Ze&&(Ze[0]-=3,(!Z||Ze[0]>Z[0])&&(Z=Ze))}}}return Z}function se(q,ie){if(ie+1>=q.length)return;const ge=q[ie],Le=q[ie+1];if(ge!==Le)return q.slice(0,ie)+Le+ge+q.slice(ie+2)}}),define(be[115],Ee([0,1,35,114,8]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const E=new RegExp(`\\$\\(${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?\\)`,"g"),C=new RegExp(`(\\\\)?${E.source}`,"g");function y(m){return m.replace(C,(b,w)=>w?b:`\\${b}`)}e.escapeIcons=y;const _=new RegExp(`\\\\${E.source}`,"g");function k(m){return m.replace(_,b=>`\\${b}`)}e.markdownEscapeEscapedIcons=k;const n=new RegExp(`(\\s)?(\\\\)?${E.source}(\\s)?`,"g");function I(m){return m.indexOf(e.iconStartMarker)===-1?m:m.replace(n,(b,w,P,a)=>P?b:w||a||"")}e.stripIcons=I;function l(m){const b=m.indexOf(e.iconStartMarker);return b===-1?{text:m}:d(m,b)}e.parseLabelWithIcons=l;function d(m,b){const w=[];let P="";function a(h){if(h){P+=h;for(const p of h)w.push(t)}}let f=-1,v="",t=0,r,s,i=b;const c=m.length;for(a(m.substr(0,b));i<c;)r=m[i],s=m[i+1],r===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(f=i,a(v),v=e.iconStartMarker,i++):r===")"&&f!==-1?(t+=i-f+1,f=-1,v=""):f!==-1?/^[a-z0-9\-]$/i.test(r)?v+=r:(a(v),f=-1,v=""):a(r),i++;return a(v),{text:P,iconOffsets:w}}function u(m,b,w=!1){const{text:P,iconOffsets:a}=b;if(!a||a.length===0)return(0,F.matchesFuzzy)(m,P,w);const f=(0,S.ltrim)(P," "),v=P.length-f.length,t=(0,F.matchesFuzzy)(m,f,w);if(t)for(const r of t){const s=a[r.start+v]+v;r.start+=s,r.end+=s}return t}e.matchesFuzzyIconAware=u}),define(be[83],Ee([0,1,115,12]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var S;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(S=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class E{constructor(d="",u=!1){if(this.value=d,typeof this.value!="string")throw(0,F.illegalArgument)("value");typeof u=="boolean"?(this.isTrusted=u,this.supportThemeIcons=!1):(this.isTrusted=u.isTrusted??void 0,this.supportThemeIcons=u.supportThemeIcons??!1)}appendText(d,u=0){return this.value+=k(this.supportThemeIcons?(0,g.escapeIcons)(d):d).replace(/([ \t]+)/g,(m,b)=>"&nbsp;".repeat(b.length)).replace(/^>/gm,"\\>").replace(/\n/g,u===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,u){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=u,this.value+="\n```\n",this}}e.MarkdownString=E;function C(l){return y(l)?!l.value:Array.isArray(l)?l.every(C):!0}e.isEmptyMarkdownString=C;function y(l){return l instanceof E?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=y;function _(l,d){return l===d?!0:!l||!d?!1:l.value===d.value&&l.isTrusted===d.isTrusted&&l.supportThemeIcons===d.supportThemeIcons}e.markdownStringEqual=_;function k(l){return l.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=k;function n(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=n;function I(l){const d=[],u=l.split("|").map(b=>b.trim());l=u[0];const m=u[1];if(m){const b=/height=(\d+)/.exec(m),w=/width=(\d+)/.exec(m),P=b?b[1]:"",a=w?w[1]:"",f=isFinite(parseInt(a)),v=isFinite(parseInt(P));f&&d.push(`width="${a}"`),v&&d.push(`height="${P}"`)}return{href:l,dimensions:d}}e.parseHrefAndDimensions=I}),define(be[56],Ee([0,1,24,8,2]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function E(n){return JSON.stringify(n,_)}e.stringify=E;function C(n){let I=JSON.parse(n);return I=k(I),I}e.parse=C;var y;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(y=e.MarshalledId||(e.MarshalledId={}));function _(n,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,F.regExpFlags)(I)}:I}function k(n,I=0){if(!n||I>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return S.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof g.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let l=0;l<n.length;++l)n[l]=k(n[l],I+1);else for(const l in n)Object.hasOwnProperty.call(n,l)&&(n[l]=k(n[l],I+1))}return n}e.revive=k}),define(be[11],Ee([0,1,2,22]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var S;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.userData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebook="vscode-notebook",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractive="vscode-interactive",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp"})(S=e.Schemas||(e.Schemas={}));class E{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(_){this._preferredWebSchema=_}setDelegate(_){this._delegate=_}set(_,k,n){this._hosts[_]=k,this._ports[_]=n}setConnectionToken(_,k){this._connectionTokens[_]=k}rewrite(_){if(this._delegate)return this._delegate(_);const k=_.authority;let n=this._hosts[k];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const I=this._ports[k],l=this._connectionTokens[k];let d=`path=${encodeURIComponent(_.path)}`;return typeof l=="string"&&(d+=`&tkn=${encodeURIComponent(l)}`),g.URI.from({scheme:F.isWeb?this._preferredWebSchema:S.vscodeRemoteResource,authority:`${n}:${I}`,path:"/vscode-remote-resource",query:d})}}e.RemoteAuthorities=new E;class C{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(_,k,n){const I=this.toUri(_,k);if(I.scheme===S.vscodeRemote)return e.RemoteAuthorities.rewrite(I);let l=!1;return F.isNative&&(n||F.isPreferringBrowserCodeLoad)&&I.scheme===S.file&&(l=!0),I.scheme===S.file&&typeof F.globals.importScripts=="function"&&F.globals.origin==="vscode-file://vscode-app"&&(l=!0),l?I.with({scheme:S.vscodeFileResource,authority:I.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(_,k){const n=this.toUri(_,k);return n.scheme===S.vscodeFileResource?n.with({scheme:S.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(_,k){return g.URI.isUri(_)?_:g.URI.parse(k.toUrl(_))}}e.FileAccess=new C}),define(be[25],Ee([0,1,44,14,2,8,11,22]),function(ee,e,g,F,S,E,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(d){return(0,S.uriToFsPath)(d,!0)}e.originalFSPath=_;class k{constructor(u){this._ignorePathCasing=u}compare(u,m,b=!1){return u===m?0:(0,E.compare)(this.getComparisonKey(u,b),this.getComparisonKey(m,b))}isEqual(u,m,b=!1){return u===m?!0:!u||!m?!1:this.getComparisonKey(u,b)===this.getComparisonKey(m,b)}getComparisonKey(u,m=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,m,b=!1){if(u.scheme===m.scheme){if(u.scheme===C.Schemas.file)return g.isEqualOrParent(_(u),_(m),this._ignorePathCasing(u))&&u.query===m.query&&(b||u.fragment===m.fragment);if((0,e.isEqualAuthority)(u.authority,m.authority))return g.isEqualOrParent(u.path,m.path,this._ignorePathCasing(u),"/")&&u.query===m.query&&(b||u.fragment===m.fragment)}return!1}joinPath(u,...m){return S.URI.joinPath(u,...m)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return F.posix.basename(u.path)}extname(u){return F.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let m;return u.scheme===C.Schemas.file?m=S.URI.file(F.dirname(_(u))).path:(m=F.posix.dirname(u.path),u.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),m="/")),u.with({path:m})}normalizePath(u){if(!u.path.length)return u;let m;return u.scheme===C.Schemas.file?m=S.URI.file(F.normalize(_(u))).path:m=F.posix.normalize(u.path),u.with({path:m})}relativePath(u,m){if(u.scheme!==m.scheme||!(0,e.isEqualAuthority)(u.authority,m.authority))return;if(u.scheme===C.Schemas.file){const P=F.relative(_(u),_(m));return y.isWindows?g.toSlashes(P):P}let b=u.path||"/",w=m.path||"/";if(this._ignorePathCasing(u)){let P=0;for(const a=Math.min(b.length,w.length);P<a&&!(b.charCodeAt(P)!==w.charCodeAt(P)&&b.charAt(P).toLowerCase()!==w.charAt(P).toLowerCase());P++);b=w.substr(0,P)+b.substr(P)}return F.posix.relative(b,w)}resolvePath(u,m){if(u.scheme===C.Schemas.file){const b=S.URI.file(F.resolve(_(u),m));return u.with({authority:b.authority,path:b.path})}return m=g.toPosixPath(m),u.with({path:F.posix.resolve(u.path,m)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,m){return u===m||(0,E.equalsIgnoreCase)(u,m)}hasTrailingPathSeparator(u,m=F.sep){if(u.scheme===C.Schemas.file){const b=_(u);return b.length>g.getRoot(b).length&&b[b.length-1]===m}else{const b=u.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,m=F.sep){return(0,e.hasTrailingPathSeparator)(u,m)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,m=F.sep){let b=!1;if(u.scheme===C.Schemas.file){const w=_(u);b=w!==void 0&&w.length===g.getRoot(w).length&&w[w.length-1]===m}else{m="/";const w=u.path;b=w.length===1&&w.charCodeAt(w.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(u,m)?u.with({path:u.path+"/"}):u}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(d=>d.scheme===C.Schemas.file?!y.isLinux:!0),e.extUriIgnorePathCase=new k(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(d,u){const m=[];for(let b=0;b<d.length;b++){const w=u(d[b]);d.some((P,a)=>a===b?!1:(0,e.isEqualOrParent)(w,u(P)))||m.push(d[b])}return m}e.distinctParents=n;var I;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function u(m){const b=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(a=>{const[f,v]=a.split(":");f&&v&&b.set(f,v)});const P=m.path.substring(0,m.path.indexOf(";"));return P&&b.set(d.META_DATA_MIME,P),b}d.parseMetaData=u})(I=e.DataUri||(e.DataUri={}));function l(d,u,m){if(u){let b=d.path;return b&&b[0]!==F.posix.sep&&(b=F.posix.sep+b),d.with({scheme:m,authority:u,path:b})}return d.with({scheme:m})}e.toLocalResource=l}),define(be[16],Ee([0,1,20,12,3,6,25]),function(ee,e,g,F,S,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(V){return!!V&&typeof V.then=="function"}e.isThenable=y;function _(V){const R=new g.CancellationTokenSource,G=V(R.token),x=new Promise((j,de)=>{const B=R.token.onCancellationRequested(()=>{B.dispose(),R.dispose(),de((0,F.canceled)())});Promise.resolve(G).then(ne=>{B.dispose(),R.dispose(),j(ne)},ne=>{B.dispose(),R.dispose(),de(ne)})});return new class{cancel(){R.cancel()}then(j,de){return x.then(j,de)}catch(j){return this.then(void 0,j)}finally(j){return x.finally(j)}}}e.createCancelablePromise=_;function k(V,R,G){return Promise.race([V,new Promise(x=>R.onCancellationRequested(()=>x(G)))])}e.raceCancellation=k;async function n(V){let R=-1;const G=V.map((j,de)=>j.then(B=>(R=de,B))),x=await Promise.race(G);return V.forEach((j,de)=>{de!==R&&j.cancel()}),x}e.raceCancellablePromises=n;function I(V,R,G){let x;const j=setTimeout(()=>{x?.(void 0),G?.()},R);return Promise.race([V.finally(()=>clearTimeout(j)),new Promise(de=>x=de)])}e.raceTimeout=I;function l(V){return new Promise((R,G)=>{const x=V();y(x)?x.then(R,G):R(x)})}e.asPromise=l;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(R){if(this.activePromise){if(this.queuedPromiseFactory=R,!this.queuedPromise){const G=()=>{this.queuedPromise=null;const x=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,x};this.queuedPromise=new Promise(x=>{this.activePromise.then(G,G).then(x)})}return new Promise((G,x)=>{this.queuedPromise.then(G,x)})}return this.activePromise=R(),new Promise((G,x)=>{this.activePromise.then(j=>{this.activePromise=null,G(j)},j=>{this.activePromise=null,x(j)})})}}e.Throttler=d;class u{constructor(){this.current=Promise.resolve(null)}queue(R){return this.current=this.current.then(()=>R(),()=>R())}}e.Sequencer=u;class m{constructor(){this.promiseMap=new Map}queue(R,G){const j=(this.promiseMap.get(R)??Promise.resolve()).catch(()=>{}).then(G).finally(()=>{this.promiseMap.get(R)===j&&this.promiseMap.delete(R)});return this.promiseMap.set(R,j),j}}e.SequencerByKey=m;class b{constructor(R){this.defaultDelay=R,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(R,G=this.defaultDelay){return this.task=R,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((x,j)=>{this.doResolve=x,this.doReject=j}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const x=this.task;return this.task=null,x()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},G),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,F.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=b;class w{constructor(R){this.delayer=new b(R),this.throttler=new d}trigger(R,G){return this.delayer.trigger(()=>this.throttler.queue(R),G)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class P{constructor(){this._isOpen=!1,this._promise=new Promise((R,G)=>{this._completePromise=R})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=P;class a extends P{constructor(R){super();this._timeout=setTimeout(()=>this.open(),R)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function f(V,R){return R?new Promise((G,x)=>{const j=setTimeout(()=>{de.dispose(),G()},V),de=R.onCancellationRequested(()=>{clearTimeout(j),de.dispose(),x((0,F.canceled)())})}):_(G=>f(V,G))}e.timeout=f;function v(V,R=0){const G=setTimeout(V,R);return(0,E.toDisposable)(()=>clearTimeout(G))}e.disposableTimeout=v;function t(V){const R=[];let G=0;const x=V.length;function j(){return G<x?V[G++]():null}function de(B){B!=null&&R.push(B);const ne=j();return ne?ne.then(de):Promise.resolve(R)}return Promise.resolve(null).then(de)}e.sequence=t;function r(V,R=x=>!!x,G=null){let x=0;const j=V.length,de=()=>{if(x>=j)return Promise.resolve(G);const B=V[x++];return Promise.resolve(B()).then(ue=>R(ue)?Promise.resolve(ue):de())};return de()}e.first=r;function s(V,R=x=>!!x,G=null){if(V.length===0)return Promise.resolve(G);let x=V.length;const j=()=>{x=-1;for(const de of V)de.cancel?.()};return new Promise((de,B)=>{for(const ne of V)ne.then(ue=>{--x>=0&&R(ue)?(j(),de(ue)):x===0&&de(G)}).catch(ue=>{--x>=0&&(j(),B(ue))})})}e.firstParallel=s;class i{constructor(R){this._size=0,this.maxDegreeOfParalellism=R,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new S.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(R){return this._size++,new Promise((G,x)=>{this.outstandingPromises.push({factory:R,c:G,e:x}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const R=this.outstandingPromises.shift();this.runningPromises++;const G=R.factory();G.then(R.c,R.e),G.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class c extends i{constructor(){super(1)}}e.Queue=c;class h{constructor(){this.queues=new Map}queueFor(R,G=C.extUri){const x=G.getComparisonKey(R);let j=this.queues.get(x);return j||(j=new c,S.Event.once(j.onFinished)(()=>{j?.dispose(),this.queues.delete(x)}),this.queues.set(x,j)),j}dispose(){this.queues.forEach(R=>R.dispose()),this.queues.clear()}}e.ResourceQueue=h;class p{constructor(R,G){this._token=-1,typeof R=="function"&&typeof G=="number"&&this.setIfNotSet(R,G)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(R,G){this.cancel(),this._token=setTimeout(()=>{this._token=-1,R()},G)}setIfNotSet(R,G){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,R()},G))}}e.TimeoutTimer=p;class D{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(R,G){this.cancel(),this._token=setInterval(()=>{R()},G)}}e.IntervalTimer=D;class T{constructor(R,G){this.timeoutToken=-1,this.runner=R,this.timeout=G,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(R=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,R)}get delay(){return this.timeout}set delay(R){this.timeout=R}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=T;class o extends T{constructor(R,G){super(R,G);this.units=[]}work(R){this.units.push(R),this.isScheduled()||this.schedule()}doRun(){const R=this.units;this.units=[],this.runner&&this.runner(R)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=o;class A extends E.Disposable{constructor(R,G,x,j){super();this.maxWorkChunkSize=R,this.maxPendingWork=G,this.throttleDelay=x,this.handler=j,this.pendingWork=[],this.throttler=this._register(new E.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(R){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+R.length>this.maxPendingWork)return!1}else if(this.pending+R.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...R),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new T(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=A,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const V=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=R=>{const G=setTimeout(()=>R(V));let x=!1;return{dispose(){x||(x=!0,clearTimeout(G))}}}}else e.runWhenIdle=(V,R)=>{const G=requestIdleCallback(V,typeof R=="number"?{timeout:R}:void 0);let x=!1;return{dispose(){x||(x=!0,cancelIdleCallback(G))}}}}();class L{constructor(R){this._didRun=!1,this._executor=()=>{try{this._value=R()}catch(G){this._error=G}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=L;async function $(V,R,G){let x;for(let j=0;j<G;j++)try{return await V()}catch(de){x=de,await f(R)}throw x}e.retry=$;class oe{hasPending(R){return this._pending?typeof R=="number"?this._pending.taskId===R:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(R,G,x){return this._pending={taskId:R,cancel:()=>x?.(),promise:G},G.then(()=>this.donePending(R),()=>this.donePending(R)),G}donePending(R){this._pending&&R===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const R=this._next;this._next=void 0,R.run().then(R.promiseResolve,R.promiseReject)}}setNext(R){if(this._next)this._next.run=R;else{let G,x;const j=new Promise((de,B)=>{G=de,x=B});this._next={run:R,promise:j,promiseResolve:G,promiseReject:x}}return this._next.promise}}e.TaskSequentializer=oe;class he{constructor(R){this.interval=R,this.lastIncrementTime=0,this.value=0}increment(){const R=Date.now();return R-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=R,this.value=0),this.value++,this.value}}e.IntervalCounter=he;class Q{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((R,G)=>{this.completeCallback=R,this.errorCallback=G})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(R){return new Promise(G=>{this.completeCallback(R),this.resolved=!0,G()})}error(R){return new Promise(G=>{this.errorCallback(R),this.rejected=!0,G()})}cancel(){new Promise(R=>{this.errorCallback((0,F.canceled)()),this.rejected=!0,R()})}}e.DeferredPromise=Q;var z;(function(V){async function R(G){let x;const j=await Promise.all(G.map(de=>de.then(B=>B,B=>{x||(x=B)})));if(typeof x!="undefined")throw x;return j}V.settled=R})(z=e.Promises||(e.Promises={}))}),define(be[116],Ee([0,1,14,16]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const S=new F.IdleValue(()=>{const T=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:T,collatorIsNumeric:T.resolvedOptions().numeric}}),E=new F.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new F.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function y(T,o,A=!1){const L=T||"",$=o||"",oe=S.value.collator.compare(L,$);return S.value.collatorIsNumeric&&oe===0&&L!==$?L<$?-1:1:oe}e.compareFileNames=y;function _(T,o){const A=E.value.collator;return T=T||"",o=o||"",v(A,T,o)}e.compareFileNamesDefault=_;function k(T,o){const A=E.value.collator;return T=T||"",o=o||"",i(T,o)||v(A,T,o)}e.compareFileNamesUpper=k;function n(T,o){const A=E.value.collator;return T=T||"",o=o||"",s(T,o)||v(A,T,o)}e.compareFileNamesLower=n;function I(T,o){return T=T||"",o=o||"",T===o?0:T<o?-1:1}e.compareFileNamesUnicode=I;function l(T,o,A=!1){A||(T=T&&T.toLowerCase(),o=o&&o.toLowerCase());const[L,$]=a(T),[oe,he]=a(o);return L!==oe?L<oe?-1:1:$===he?0:$<he?-1:1}e.noIntlCompareFileNames=l;function d(T,o){const[A,L]=a(T),[$,oe]=a(o);let he=S.value.collator.compare(L,oe);if(he===0){if(S.value.collatorIsNumeric&&L!==oe)return L<oe?-1:1;if(he=S.value.collator.compare(A,$),S.value.collatorIsNumeric&&he===0&&A!==$)return A<$?-1:1}return he}e.compareFileExtensions=d;function u(T,o){T=T||"",o=o||"";const A=f(T),L=f(o),$=E.value.collator,oe=C.value.collator;return v(oe,A,L)||v($,T,o)}e.compareFileExtensionsDefault=u;function m(T,o){T=T||"",o=o||"";const A=f(T),L=f(o),$=E.value.collator,oe=C.value.collator;return v(oe,A,L)||i(T,o)||v($,T,o)}e.compareFileExtensionsUpper=m;function b(T,o){T=T||"",o=o||"";const A=f(T),L=f(o),$=E.value.collator,oe=C.value.collator;return v(oe,A,L)||s(T,o)||v($,T,o)}e.compareFileExtensionsLower=b;function w(T,o){T=T||"",o=o||"";const A=f(T).toLowerCase(),L=f(o).toLowerCase();return A!==L?A<L?-1:1:T!==o?T<o?-1:1:0}e.compareFileExtensionsUnicode=w;const P=/^(.*?)(\.([^.]*))?$/;function a(T,o=!1){const A=T?P.exec(T):[];let L=[A&&A[1]||"",A&&A[3]||""];return o&&(!L[0]&&L[1]||L[0]&&L[0].charAt(0)===".")&&(L=[L[0]+"."+L[1],""]),L}function f(T){const o=T?P.exec(T):[];return o&&o[1]&&o[1].charAt(0)!=="."&&o[3]||""}function v(T,o,A){let L=T.compare(o,A);return L!==0?L:o.length!==A.length?o.length<A.length?-1:1:0}function t(T){const o=T.charAt(0);return o.toLocaleUpperCase()!==o}function r(T){const o=T.charAt(0);return o.toLocaleLowerCase()!==o}function s(T,o){return t(T)&&r(o)?-1:r(T)&&t(o)?1:0}function i(T,o){return r(T)&&t(o)?-1:t(T)&&r(o)?1:0}function c(T,o,A=!1){return A||(T=T&&T.toLowerCase(),o=o&&o.toLowerCase()),T===o?0:T<o?-1:1}function h(T,o,A=!1){const L=T.split(g.sep),$=o.split(g.sep),oe=L.length-1,he=$.length-1;let Q,z;for(let V=0;;V++){if(Q=oe===V,z=he===V,Q&&z)return y(L[V],$[V],A);if(Q)return-1;if(z)return 1;const R=c(L[V],$[V],A);if(R!==0)return R}}e.comparePaths=h;function p(T,o,A){const L=T.toLowerCase(),$=o.toLowerCase(),oe=D(T,o,A);if(oe)return oe;const he=L.endsWith(A),Q=$.endsWith(A);if(he!==Q)return he?-1:1;const z=y(L,$);return z!==0?z:L.localeCompare($)}e.compareAnything=p;function D(T,o,A){const L=T.toLowerCase(),$=o.toLowerCase(),oe=L.startsWith(A),he=$.startsWith(A);if(oe!==he)return oe?-1:1;if(oe&&he){if(L.length<$.length)return-1;if(L.length>$.length)return 1}return 0}e.compareByPrefix=D}),define(be[27],Ee([0,1,8,44,14,21,16]),function(ee,e,g,F,S,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function y(){return Object.create(null)}e.getEmptyExpression=y;const _="**",k="/",n="[/\\\\]",I="[^/\\\\]",l=/\//g;function d(j){switch(j){case 0:return"";case 1:return`${I}*?`;default:return`(?:${n}|${I}+${n}|${n}${I}+)*?`}}function u(j,de){if(!j)return[];const B=[];let ne=!1,ue=!1,ye="";for(const Re of j){switch(Re){case de:if(!ne&&!ue){B.push(ye),ye="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}ye+=Re}return ye&&B.push(ye),B}e.splitGlobAware=u;function m(j){if(!j)return"";let de="";const B=u(j,k);if(B.every(ne=>ne===_))de=".*";else{let ne=!1;B.forEach((ue,ye)=>{if(ue===_){ne||(de+=d(2),ne=!0);return}let Re=!1,Te="",$e=!1,Je="";for(const Ve of ue){if(Ve!=="}"&&Re){Te+=Ve;continue}if($e&&(Ve!=="]"||!Je)){let je;Ve==="-"?je=Ve:(Ve==="^"||Ve==="!")&&!Je?je="^":Ve===k?je="":je=g.escapeRegExpCharacters(Ve),Je+=je;continue}switch(Ve){case"{":Re=!0;continue;case"[":$e=!0;continue;case"}":de+=`(?:${u(Te,",").map(K=>m(K)).join("|")})`,Re=!1,Te="";break;case"]":de+="["+Je+"]",$e=!1,Je="";break;case"?":de+=I;continue;case"*":de+=d(1);continue;default:de+=g.escapeRegExpCharacters(Ve)}}ye<B.length-1&&(B[ye+1]!==_||ye+2<B.length)&&(de+=n),ne=!1})}return de}const b=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,P=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,a=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new E.LRUCache(1e4),r=function(){return!1},s=function(){return null};function i(j,de){if(!j)return s;let B;typeof j!="string"?B=j.pattern:B=j,B=B.trim();const ne=`${B}_${!!de.trimForExclusions}`;let ue=t.get(ne);if(ue)return c(ue,j);let ye;if(b.test(B)){const Re=B.substr(4);ue=function(Te,$e){return typeof Te=="string"&&Te.endsWith(Re)?B:null}}else(ye=w.exec(h(B,de)))?ue=p(ye[1],B):(de.trimForExclusions?a:P).test(B)?ue=D(B,de):(ye=f.exec(h(B,de)))?ue=T(ye[1].substr(1),B,!0):(ye=v.exec(h(B,de)))?ue=T(ye[1],B,!1):ue=o(B);return t.set(ne,ue),c(ue,j)}function c(j,de){return typeof de=="string"?j:function(B,ne){return F.isEqualOrParent(B,de.base)?j(S.relative(de.base,B),ne):null}}function h(j,de){return de.trimForExclusions&&j.endsWith("/**")?j.substr(0,j.length-2):j}function p(j,de){const B=`/${j}`,ne=`\\${j}`,ue=function(Re,Te){return typeof Re!="string"?null:Te?Te===j?de:null:Re===j||Re.endsWith(B)||Re.endsWith(ne)?de:null},ye=[j];return ue.basenames=ye,ue.patterns=[de],ue.allBasenames=ye,ue}function D(j,de){const B=x(j.slice(1,-1).split(",").map(Te=>i(Te,de)).filter(Te=>Te!==s),j),ne=B.length;if(!ne)return s;if(ne===1)return B[0];const ue=function(Te,$e){for(let Je=0,Ve=B.length;Je<Ve;Je++)if(B[Je](Te,$e))return j;return null},ye=B.find(Te=>!!Te.allBasenames);ye&&(ue.allBasenames=ye.allBasenames);const Re=B.reduce((Te,$e)=>$e.allPaths?Te.concat($e.allPaths):Te,[]);return Re.length&&(ue.allPaths=Re),ue}function T(j,de,B){const ne=S.sep===S.posix.sep,ue=ne?j:j.replace(l,S.sep),ye=S.sep+ue,Re=S.posix.sep+j,Te=B?function($e,Je){return typeof $e=="string"&&($e===ue||$e.endsWith(ye)||!ne&&($e===j||$e.endsWith(Re)))?de:null}:function($e,Je){return typeof $e=="string"&&($e===ue||!ne&&$e===j)?de:null};return Te.allPaths=[(B?"*/":"./")+j],Te}function o(j){try{const de=new RegExp(`^${m(j)}$`);return function(B){return de.lastIndex=0,typeof B=="string"&&de.test(B)?j:null}}catch(de){return s}}function A(j,de,B){return!j||typeof de!="string"?!1:L(j)(de,void 0,B)}e.match=A;function L(j,de={}){if(!j)return r;if(typeof j=="string"||Q(j)){const B=i(j,de);if(B===s)return r;const ne=function(ue,ye){return!!B(ue,ye)};return B.allBasenames&&(ne.allBasenames=B.allBasenames),B.allPaths&&(ne.allPaths=B.allPaths),ne}return R(j,de)}e.parse=L;function $(j){if(!j)return;let de;return B=>(de||(de=(j()||Promise.resolve([])).then(ne=>ne?he(ne):{})),de.then(ne=>!!ne[B]))}e.hasSiblingPromiseFn=$;function oe(j){if(!j)return;let de;return B=>{if(!de){const ne=j();de=ne?he(ne):{}}return!!de[B]}}e.hasSiblingFn=oe;function he(j){const de={};for(const B of j)de[B]=!0;return de}function Q(j){const de=j;return de&&typeof de.base=="string"&&typeof de.pattern=="string"}e.isRelativePattern=Q;function z(j){return j.allBasenames||[]}e.getBasenameTerms=z;function V(j){return j.allPaths||[]}e.getPathTerms=V;function R(j,de){const B=x(Object.getOwnPropertyNames(j).map(Te=>G(Te,j[Te],de)).filter(Te=>Te!==s)),ne=B.length;if(!ne)return s;if(!B.some(Te=>!!Te.requiresSiblings)){if(ne===1)return B[0];const Te=function(Ve,je){for(let O=0,K=B.length;O<K;O++){const X=B[O](Ve,je);if(X)return X}return null},$e=B.find(Ve=>!!Ve.allBasenames);$e&&(Te.allBasenames=$e.allBasenames);const Je=B.reduce((Ve,je)=>je.allPaths?Ve.concat(je.allPaths):Ve,[]);return Je.length&&(Te.allPaths=Je),Te}const ue=function(Te,$e,Je){let Ve;for(let je=0,O=B.length;je<O;je++){const K=B[je];K.requiresSiblings&&Je&&($e||($e=S.basename(Te)),Ve||(Ve=$e.substr(0,$e.length-S.extname(Te).length)));const X=K(Te,$e,Ve,Je);if(X)return X}return null},ye=B.find(Te=>!!Te.allBasenames);ye&&(ue.allBasenames=ye.allBasenames);const Re=B.reduce((Te,$e)=>$e.allPaths?Te.concat($e.allPaths):Te,[]);return Re.length&&(ue.allPaths=Re),ue}function G(j,de,B){if(de===!1)return s;const ne=i(j,B);if(ne===s)return s;if(typeof de=="boolean")return ne;if(de){const ue=de.when;if(typeof ue=="string"){const ye=(Re,Te,$e,Je)=>{if(!Je||!ne(Re,Te))return null;const Ve=ue.replace("$(basename)",$e),je=Je(Ve);return(0,C.isThenable)(je)?je.then(O=>O?j:null):je?j:null};return ye.requiresSiblings=!0,ye}}return ne}function x(j,de){const B=j.filter(Te=>!!Te.basenames);if(B.length<2)return j;const ne=B.reduce((Te,$e)=>{const Je=$e.basenames;return Je?Te.concat(Je):Te},[]);let ue;if(de){ue=[];for(let Te=0,$e=ne.length;Te<$e;Te++)ue.push(de)}else ue=B.reduce((Te,$e)=>{const Je=$e.patterns;return Je?Te.concat(Je):Te},[]);const ye=function(Te,$e){if(typeof Te!="string")return null;if(!$e){let Ve;for(Ve=Te.length;Ve>0;Ve--){const je=Te.charCodeAt(Ve-1);if(je===47||je===92)break}$e=Te.substr(Ve)}const Je=ne.indexOf($e);return Je!==-1?ue[Je]:null};ye.basenames=ne,ye.patterns=ue,ye.allBasenames=ne;const Re=j.filter(Te=>!Te.basenames);return Re.push(ye),Re}}),define(be[84],Ee([0,1,2,14,8,11,22,25,44]),function(ee,e,g,F,S,E,C,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(i,c,h){if(typeof i=="string"&&(i=g.URI.file(i)),h){const D=h.getWorkspaceFolder(i);if(D){const T=h.getWorkspace().folders.length>1;let o;if((0,y.isEqual)(D.uri,i)?o="":o=(0,y.relativePath)(D.uri,i),T){const A=D.name?D.name:(0,y.basename)(D.uri);o=o?A+" \u2022 "+o:A}return o}}if(i.scheme!==E.Schemas.file&&i.scheme!==E.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,_.hasDriveLetter)(i.fsPath))return(0,F.normalize)(I(i.fsPath));let p=(0,F.normalize)(i.fsPath);return!C.isWindows&&c?.userHome&&(p=d(p,c.userHome.fsPath)),p}e.getPathLabel=k;function n(i){if(!i)return;typeof i=="string"&&(i=g.URI.file(i));const c=(0,y.basename)(i)||(i.scheme===E.Schemas.file?i.fsPath:i.path);return C.isWindows&&(0,_.isRootOrDriveLetter)(c)?I(c):c}e.getBaseLabel=n;function I(i){return(0,_.hasDriveLetter)(i)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=I;let l=Object.create(null);function d(i,c){if(C.isWindows||!i||!c)return i;let h=l.original===c?l.normalized:void 0;return h||(h=`${(0,S.rtrim)(c,F.posix.sep)}${F.posix.sep}`,l={original:c,normalized:h}),(C.isLinux?i.startsWith(h):(0,S.startsWithIgnoreCase)(i,h))&&(i=`~/${i.substr(h.length)}`),i}e.tildify=d;function u(i,c){return i.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=u;const m="\u2026",b="\\\\",w="~";function P(i,c=F.sep){const h=new Array(i.length);let p=!1;for(let D=0;D<i.length;D++){let T=i[D];if(T===""){h[D]=`.${c}`;continue}if(!T){h[D]=T;continue}p=!0;let o="";T.indexOf(b)===0?(o=T.substr(0,T.indexOf(b)+b.length),T=T.substr(T.indexOf(b)+b.length)):T.indexOf(c)===0?(o=T.substr(0,T.indexOf(c)+c.length),T=T.substr(T.indexOf(c)+c.length)):T.indexOf(w)===0&&(o=T.substr(0,T.indexOf(w)+w.length),T=T.substr(T.indexOf(w)+w.length));const A=T.split(c);for(let L=1;p&&L<=A.length;L++)for(let $=A.length-L;p&&$>=0;$--){p=!1;let oe=A.slice($,$+L).join(c);for(let he=0;!p&&he<i.length;he++)if(he!==D&&i[he]&&i[he].indexOf(oe)>-1){const Q=$+L===A.length,z=$>0&&i[he].indexOf(c)>-1?c+oe:oe,V=i[he].endsWith(z);p=!Q||V}if(!p){let he="";(A[0].endsWith(":")||o!=="")&&($===1&&($=0,L++,oe=A[0]+c+oe),$>0&&(he=A[0]+c),he=o+he),$>0&&(he=he+m+c),he=he+oe,$+L<A.length&&(he=he+c+m),h[D]=he}}p&&(h[D]=T)}return h}e.shorten=P;var a;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function f(i,c=Object.create(null)){const h=[];let p=!1,D="";for(const T of i)if(T==="$"||p&&T==="{")D&&h.push({value:D,type:a.TEXT}),D="",p=!0;else if(T==="}"&&p){const o=c[D];if(typeof o=="string")o.length&&h.push({value:o,type:a.VARIABLE});else if(o){const A=h[h.length-1];(!A||A.type!==a.SEPARATOR)&&h.push({value:o.label,type:a.SEPARATOR})}D="",p=!1}else D+=T;return D&&!p&&h.push({value:D,type:a.TEXT}),h.filter((T,o)=>{if(T.type===a.SEPARATOR){const A=h[o-1],L=h[o+1];return[A,L].every($=>$&&($.type===a.VARIABLE||$.type===a.TEXT)&&$.value.length>0)}return!0}).map(T=>T.value).join("")}e.template=f;function v(i,c){return C.isMacintosh||c?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):i.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.mnemonicMenuLabel=v;function t(i,c){return C.isMacintosh||c?i.replace(/\(&&\w\)|&&/g,""):C.isWindows?i.replace(/&&|&/g,h=>h==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=r;function s(i){const c=i.indexOf("/")!==-1?F.posix:F.win32,h=c.basename(i),p=c.dirname(i);return h.length?{name:h,parentPath:p}:{name:p,parentPath:""}}e.splitName=s}),define(be[85],Ee([0,1,14,8,27,11,25]),function(ee,e,g,F,S,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var y;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown"})(y=e.Mimes||(e.Mimes={}));let _=[],k=[],n=[];function I(r,s=!1){const i=l(r);_.push(i),i.userConfigured?n.push(i):k.push(i),s&&!i.userConfigured&&_.forEach(c=>{c.mime===i.mime||c.userConfigured||(i.extension&&c.extension===i.extension&&console.warn(`Overwriting extension <<${i.extension}>> to now point to mime <<${i.mime}>>`),i.filename&&c.filename===i.filename&&console.warn(`Overwriting filename <<${i.filename}>> to now point to mime <<${i.mime}>>`),i.filepattern&&c.filepattern===i.filepattern&&console.warn(`Overwriting filepattern <<${i.filepattern}>> to now point to mime <<${i.mime}>>`),i.firstline&&c.firstline===i.firstline&&console.warn(`Overwriting firstline <<${i.firstline}>> to now point to mime <<${i.mime}>>`))})}e.registerTextMime=I;function l(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?r.filepattern.toLowerCase():void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(g.posix.sep)>=0:!1}}function d(r){r?(_=_.filter(s=>!s.userConfigured),n=[]):(_=[],k=[],n=[])}e.clearTextMimes=d;function u(r,s){let i;if(r)switch(r.scheme){case E.Schemas.file:i=r.fsPath;break;case E.Schemas.data:i=C.DataUri.parseMetaData(r).get(C.DataUri.META_DATA_LABEL);break;default:i=r.path}if(!i)return[y.unknown];i=i.toLowerCase();const c=(0,g.basename)(i),h=m(i,c,n);if(h)return[h,y.text];const p=m(i,c,k);if(p)return[p,y.text];if(s){const D=b(s);if(D)return[D,y.text]}return[y.unknown]}e.guessMimeTypes=u;function m(r,s,i){let c=null,h=null,p=null;for(let D=i.length-1;D>=0;D--){const T=i[D];if(s===T.filenameLowercase){c=T;break}if(T.filepattern&&(!h||T.filepattern.length>h.filepattern.length)){const o=T.filepatternOnPath?r:s;(0,S.match)(T.filepatternLowercase,o)&&(h=T)}T.extension&&(!p||T.extension.length>p.extension.length)&&s.endsWith(T.extensionLowercase)&&(p=T)}return c?c.mime:h?h.mime:p?p.mime:null}function b(r){if((0,F.startsWithUTF8BOM)(r)&&(r=r.substr(1)),r.length>0)for(let s=_.length-1;s>=0;s--){const i=_[s];if(!i.firstline)continue;const c=r.match(i.firstline);if(c&&c.length>0)return i.mime}return null}function w(r){return r?typeof r=="string"?r===y.binary||r===y.text||r===y.unknown:r.length===1&&w(r[0]):!0}e.isUnspecific=w;const P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function a(r){const s=(0,g.extname)(r);return P[s.toLowerCase()]}e.getMediaMime=a;function f(r){for(const s in P)if(P[s]===r)return s}e.getExtensionForMimeType=f;const v=/^(.+)\/(.+?)(;.+)?$/;function t(r,s){const i=v.exec(r);return i?`${i[1].toLowerCase()}/${i[2].toLowerCase()}${i[3]??""}`:s?void 0:r}e.normalizeMimeType=t}),define(be[117],Ee([0,1,2]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function F(n){return n.toJSON()}class S{constructor(I){this._uriTransformer=I}transformIncoming(I){const l=this._uriTransformer.transformIncoming(I);return l===I?I:F(g.URI.from(l))}transformOutgoing(I){const l=this._uriTransformer.transformOutgoing(I);return l===I?I:F(g.URI.from(l))}transformOutgoingURI(I){const l=this._uriTransformer.transformOutgoing(I);return l===I?I:g.URI.from(l)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=S,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function E(n,I,l){if(!n||l>200)return null;if(typeof n=="object"){if(n instanceof g.URI)return I.transformOutgoing(n);for(let d in n)if(Object.hasOwnProperty.call(n,d)){const u=E(n[d],I,l+1);u!==null&&(n[d]=u)}}return null}function C(n,I){const l=E(n,I,0);return l===null?n:l}e.transformOutgoingURIs=C;function y(n,I,l,d){if(!n||d>200)return null;if(typeof n=="object"){if(n.$mid===1)return l?g.URI.revive(I.transformIncoming(n)):I.transformIncoming(n);for(let u in n)if(Object.hasOwnProperty.call(n,u)){const m=y(n[u],I,l,d+1);m!==null&&(n[u]=m)}}return null}function _(n,I){const l=y(n,I,!1,0);return l===null?n:l}e.transformIncomingURIs=_;function k(n,I){const l=y(n,I,!0,0);return l===null?n:l}e.transformAndReviveIncomingURIs=k}),define(be[36],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const g=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(_){return g.test(_)}e.isUUID=F;const S=new Uint8Array(16),E=[];for(let _=0;_<256;_++)E.push(_.toString(16).padStart(2,"0"));let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(_){for(let k=0;k<_.length;k++)_[k]=Math.floor(Math.random()*256);return _};function y(){C(S),S[6]=S[6]&15|64,S[8]=S[8]&63|128;let _=0,k="";return k+=E[S[_++]],k+=E[S[_++]],k+=E[S[_++]],k+=E[S[_++]],k+="-",k+=E[S[_++]],k+=E[S[_++]],k+="-",k+=E[S[_++]],k+=E[S[_++]],k+="-",k+=E[S[_++]],k+=E[S[_++]],k+="-",k+=E[S[_++]],k+=E[S[_++]],k+=E[S[_++]],k+=E[S[_++]],k+=E[S[_++]],k+=E[S[_++]],k}e.generateUuid=y}),define(be[86],Ee([0,1,82]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class F{constructor(y){let _=(0,g.toUint8)(y);this._defaultValue=_,this._asciiMap=F._createAsciiMap(_),this._map=new Map}static _createAsciiMap(y){let _=new Uint8Array(256);for(let k=0;k<256;k++)_[k]=y;return _}set(y,_){let k=(0,g.toUint8)(_);y>=0&&y<256?this._asciiMap[y]=k:this._map.set(y,k)}get(y){return y>=0&&y<256?this._asciiMap[y]:this._map.get(y)||this._defaultValue}}e.CharacterClassifier=F;var S;(function(C){C[C.False=0]="False",C[C.True=1]="True"})(S||(S={}));class E{constructor(){this._actual=new F(0)}add(y){this._actual.set(y,1)}has(y){return this._actual.get(y)===1}}e.CharacterSet=E}),define(be[118],Ee([0,1,86]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var F;(function(C){C[C.Regular=0]="Regular",C[C.Whitespace=1]="Whitespace",C[C.WordSeparator=2]="WordSeparator"})(F=e.WordCharacterClass||(e.WordCharacterClass={}));class S extends g.CharacterClassifier{constructor(y){super(0);for(let _=0,k=y.length;_<k;_++)this.set(y.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=S;function E(C){let y={};return _=>(y.hasOwnProperty(_)||(y[_]=C(_)),y[_])}e.getMapForWordSeparators=E(C=>new S(C))}),define(be[37],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class g{constructor(S,E){this.lineNumber=S,this.column=E}with(S=this.lineNumber,E=this.column){return S===this.lineNumber&&E===this.column?this:new g(S,E)}delta(S=0,E=0){return this.with(this.lineNumber+S,this.column+E)}equals(S){return g.equals(this,S)}static equals(S,E){return!S&&!E?!0:!!S&&!!E&&S.lineNumber===E.lineNumber&&S.column===E.column}isBefore(S){return g.isBefore(this,S)}static isBefore(S,E){return S.lineNumber<E.lineNumber?!0:E.lineNumber<S.lineNumber?!1:S.column<E.column}isBeforeOrEqual(S){return g.isBeforeOrEqual(this,S)}static isBeforeOrEqual(S,E){return S.lineNumber<E.lineNumber?!0:E.lineNumber<S.lineNumber?!1:S.column<=E.column}static compare(S,E){let C=S.lineNumber|0,y=E.lineNumber|0;if(C===y){let _=S.column|0,k=E.column|0;return _-k}return C-y}clone(){return new g(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(S){return new g(S.lineNumber,S.column)}static isIPosition(S){return S&&typeof S.lineNumber=="number"&&typeof S.column=="number"}}e.Position=g}),define(be[31],Ee([0,1,37]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class F{constructor(E,C,y,_){E>y||E===y&&C>_?(this.startLineNumber=y,this.startColumn=_,this.endLineNumber=E,this.endColumn=C):(this.startLineNumber=E,this.startColumn=C,this.endLineNumber=y,this.endColumn=_)}isEmpty(){return F.isEmpty(this)}static isEmpty(E){return E.startLineNumber===E.endLineNumber&&E.startColumn===E.endColumn}containsPosition(E){return F.containsPosition(this,E)}static containsPosition(E,C){return!(C.lineNumber<E.startLineNumber||C.lineNumber>E.endLineNumber||C.lineNumber===E.startLineNumber&&C.column<E.startColumn||C.lineNumber===E.endLineNumber&&C.column>E.endColumn)}containsRange(E){return F.containsRange(this,E)}static containsRange(E,C){return!(C.startLineNumber<E.startLineNumber||C.endLineNumber<E.startLineNumber||C.startLineNumber>E.endLineNumber||C.endLineNumber>E.endLineNumber||C.startLineNumber===E.startLineNumber&&C.startColumn<E.startColumn||C.endLineNumber===E.endLineNumber&&C.endColumn>E.endColumn)}strictContainsRange(E){return F.strictContainsRange(this,E)}static strictContainsRange(E,C){return!(C.startLineNumber<E.startLineNumber||C.endLineNumber<E.startLineNumber||C.startLineNumber>E.endLineNumber||C.endLineNumber>E.endLineNumber||C.startLineNumber===E.startLineNumber&&C.startColumn<=E.startColumn||C.endLineNumber===E.endLineNumber&&C.endColumn>=E.endColumn)}plusRange(E){return F.plusRange(this,E)}static plusRange(E,C){let y,_,k,n;return C.startLineNumber<E.startLineNumber?(y=C.startLineNumber,_=C.startColumn):C.startLineNumber===E.startLineNumber?(y=C.startLineNumber,_=Math.min(C.startColumn,E.startColumn)):(y=E.startLineNumber,_=E.startColumn),C.endLineNumber>E.endLineNumber?(k=C.endLineNumber,n=C.endColumn):C.endLineNumber===E.endLineNumber?(k=C.endLineNumber,n=Math.max(C.endColumn,E.endColumn)):(k=E.endLineNumber,n=E.endColumn),new F(y,_,k,n)}intersectRanges(E){return F.intersectRanges(this,E)}static intersectRanges(E,C){let y=E.startLineNumber,_=E.startColumn,k=E.endLineNumber,n=E.endColumn,I=C.startLineNumber,l=C.startColumn,d=C.endLineNumber,u=C.endColumn;return y<I?(y=I,_=l):y===I&&(_=Math.max(_,l)),k>d?(k=d,n=u):k===d&&(n=Math.min(n,u)),y>k||y===k&&_>n?null:new F(y,_,k,n)}equalsRange(E){return F.equalsRange(this,E)}static equalsRange(E,C){return!!E&&!!C&&E.startLineNumber===C.startLineNumber&&E.startColumn===C.startColumn&&E.endLineNumber===C.endLineNumber&&E.endColumn===C.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(E){return new g.Position(E.endLineNumber,E.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(E){return new g.Position(E.startLineNumber,E.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(E,C){return new F(this.startLineNumber,this.startColumn,E,C)}setStartPosition(E,C){return new F(E,C,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(E){return new F(E.startLineNumber,E.startColumn,E.startLineNumber,E.startColumn)}static fromPositions(E,C=E){return new F(E.lineNumber,E.column,C.lineNumber,C.column)}static lift(E){return E?new F(E.startLineNumber,E.startColumn,E.endLineNumber,E.endColumn):null}static isIRange(E){return E&&typeof E.startLineNumber=="number"&&typeof E.startColumn=="number"&&typeof E.endLineNumber=="number"&&typeof E.endColumn=="number"}static areIntersectingOrTouching(E,C){return!(E.endLineNumber<C.startLineNumber||E.endLineNumber===C.startLineNumber&&E.endColumn<C.startColumn||C.endLineNumber<E.startLineNumber||C.endLineNumber===E.startLineNumber&&C.endColumn<E.startColumn)}static areIntersecting(E,C){return!(E.endLineNumber<C.startLineNumber||E.endLineNumber===C.startLineNumber&&E.endColumn<=C.startColumn||C.endLineNumber<E.startLineNumber||C.endLineNumber===E.startLineNumber&&C.endColumn<=E.startColumn)}static compareRangesUsingStarts(E,C){if(E&&C){const k=E.startLineNumber|0,n=C.startLineNumber|0;if(k===n){const I=E.startColumn|0,l=C.startColumn|0;if(I===l){const d=E.endLineNumber|0,u=C.endLineNumber|0;if(d===u){const m=E.endColumn|0,b=C.endColumn|0;return m-b}return d-u}return I-l}return k-n}return(E?1:0)-(C?1:0)}static compareRangesUsingEnds(E,C){return E.endLineNumber===C.endLineNumber?E.endColumn===C.endColumn?E.startLineNumber===C.startLineNumber?E.startColumn-C.startColumn:E.startLineNumber-C.startLineNumber:E.endColumn-C.endColumn:E.endLineNumber-C.endLineNumber}static spansMultipleLines(E){return E.endLineNumber>E.startLineNumber}}e.Range=F}),define(be[119],Ee([0,1,37,31]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var S;(function(C){C[C.LTR=0]="LTR",C[C.RTL=1]="RTL"})(S=e.SelectionDirection||(e.SelectionDirection={}));class E extends F.Range{constructor(y,_,k,n){super(y,_,k,n);this.selectionStartLineNumber=y,this.selectionStartColumn=_,this.positionLineNumber=k,this.positionColumn=n}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(y){return E.selectionsEqual(this,y)}static selectionsEqual(y,_){return y.selectionStartLineNumber===_.selectionStartLineNumber&&y.selectionStartColumn===_.selectionStartColumn&&y.positionLineNumber===_.positionLineNumber&&y.positionColumn===_.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(y,_){return this.getDirection()===0?new E(this.startLineNumber,this.startColumn,y,_):new E(y,_,this.startLineNumber,this.startColumn)}getPosition(){return new g.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(y,_){return this.getDirection()===0?new E(y,_,this.endLineNumber,this.endColumn):new E(this.endLineNumber,this.endColumn,y,_)}static fromPositions(y,_=y){return new E(y.lineNumber,y.column,_.lineNumber,_.column)}static liftSelection(y){return new E(y.selectionStartLineNumber,y.selectionStartColumn,y.positionLineNumber,y.positionColumn)}static selectionsArrEqual(y,_){if(y&&!_||!y&&_)return!1;if(!y&&!_)return!0;if(y.length!==_.length)return!1;for(let k=0,n=y.length;k<n;k++)if(!this.selectionsEqual(y[k],_[k]))return!1;return!0}static isISelection(y){return y&&typeof y.selectionStartLineNumber=="number"&&typeof y.selectionStartColumn=="number"&&typeof y.positionLineNumber=="number"&&typeof y.positionColumn=="number"}static createWithDirection(y,_,k,n,I){return I===0?new E(y,_,k,n):new E(k,n,y,_)}}e.Selection=E}),define(be[87],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var g;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=4]="Right",u[u.Full=7]="Full"})(g=e.OverviewRulerLane||(e.OverviewRulerLane={}));var F;(function(u){u[u.Inline=1]="Inline",u[u.Gutter=2]="Gutter"})(F=e.MinimapPosition||(e.MinimapPosition={}));var S;(function(u){u[u.TextDefined=0]="TextDefined",u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(S=e.EndOfLinePreference||(e.EndOfLinePreference={}));var E;(function(u){u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(E=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var C;(function(u){u[u.LF=0]="LF",u[u.CRLF=1]="CRLF"})(C=e.EndOfLineSequence||(e.EndOfLineSequence={}));class y{constructor(m){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,m.tabSize|0),this.indentSize=m.tabSize|0,this.insertSpaces=Boolean(m.insertSpaces),this.defaultEOL=m.defaultEOL|0,this.trimAutoWhitespace=Boolean(m.trimAutoWhitespace)}equals(m){return this.tabSize===m.tabSize&&this.indentSize===m.indentSize&&this.insertSpaces===m.insertSpaces&&this.defaultEOL===m.defaultEOL&&this.trimAutoWhitespace===m.trimAutoWhitespace}createChangeEvent(m){return{tabSize:this.tabSize!==m.tabSize,indentSize:this.indentSize!==m.indentSize,insertSpaces:this.insertSpaces!==m.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==m.trimAutoWhitespace}}}e.TextModelResolvedOptions=y;class _{constructor(m,b){this._findMatchBrand=void 0,this.range=m,this.matches=b}}e.FindMatch=_;var k;(function(u){u[u.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",u[u.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",u[u.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",u[u.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var n;(function(u){u[u.Left=0]="Left",u[u.Right=1]="Right",u[u.None=2]="None"})(n=e.PositionAffinity||(e.PositionAffinity={}));var I;(function(u){u[u.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(I=e.ModelConstants||(e.ModelConstants={}));class l{constructor(m,b,w,P,a,f){this.identifier=m,this.range=b,this.text=w,this.forceMoveMarkers=P,this.isAutoWhitespaceEdit=a,this._isTracked=f}}e.ValidAnnotatedEditOperation=l;class d{constructor(m,b,w){this.reverseEdits=m,this.changes=b,this.trimAutoWhitespaceLineNumbers=w}}e.ApplyEditsResult=d}),define(be[120],Ee([0,1,8,118,37,31,87]),function(ee,e,g,F,S,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const y=999;class _{constructor(a,f,v,t){this.searchString=a,this.isRegex=f,this.matchCase=v,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let a;this.isRegex?a=k(this.searchString):a=this.searchString.indexOf(`
`)>=0;let f=null;try{f=g.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:a,global:!0,unicode:!0})}catch(t){return null}if(!f)return null;let v=!this.isRegex&&!a;return v&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(v=this.matchCase),new n(f,this.wordSeparators?(0,F.getMapForWordSeparators)(this.wordSeparators):null,v?this.searchString:null)}}e.SearchParams=_;function k(P){if(!P||P.length===0)return!1;for(let a=0,f=P.length;a<f;a++)if(P.charCodeAt(a)===92){if(a++,a>=f)break;const t=P.charCodeAt(a);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=k;class n{constructor(a,f,v){this.regex=a,this.wordSeparators=f,this.simpleSearch=v}}e.SearchData=n;function I(P,a,f){if(!f)return new C.FindMatch(P,null);let v=[];for(let t=0,r=a.length;t<r;t++)v[t]=a[t];return new C.FindMatch(P,v)}e.createFindMatch=I;class l{constructor(a){let f=[],v=0;for(let t=0,r=a.length;t<r;t++)a.charCodeAt(t)===10&&(f[v++]=t);this._lineFeedsOffsets=f}findLineFeedCountBeforeOffset(a){const f=this._lineFeedsOffsets;let v=0,t=f.length-1;if(t===-1||a<=f[0])return 0;for(;v<t;){const r=v+((t-v)/2>>0);f[r]>=a?t=r-1:f[r+1]>=a?(v=r,t=r):v=r+1}return v+1}}class d{static findMatches(a,f,v,t,r){const s=f.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(a,v,new w(s.wordSeparators,s.regex),t,r):this._doFindMatchesLineByLine(a,v,s,t,r):[]}static _getMultilineMatchRange(a,f,v,t,r,s){let i,c=0;t?(c=t.findLineFeedCountBeforeOffset(r),i=f+r+c):i=f+r;let h;if(t){let o=t.findLineFeedCountBeforeOffset(r+s.length)-c;h=i+s.length+o}else h=i+s.length;const p=a.getPositionAt(i),D=a.getPositionAt(h);return new E.Range(p.lineNumber,p.column,D.lineNumber,D.column)}static _doFindMatchesMultiline(a,f,v,t,r){const s=a.getOffsetAt(f.getStartPosition()),i=a.getValueInRange(f,1),c=a.getEOL()===`\r
`?new l(i):null,h=[];let p=0,D;for(v.reset(0);D=v.next(i);)if(h[p++]=I(this._getMultilineMatchRange(a,s,i,c,D.index,D[0]),D,t),p>=r)return h;return h}static _doFindMatchesLineByLine(a,f,v,t,r){const s=[];let i=0;if(f.startLineNumber===f.endLineNumber){const h=a.getLineContent(f.startLineNumber).substring(f.startColumn-1,f.endColumn-1);return i=this._findMatchesInLine(v,h,f.startLineNumber,f.startColumn-1,i,s,t,r),s}const c=a.getLineContent(f.startLineNumber).substring(f.startColumn-1);i=this._findMatchesInLine(v,c,f.startLineNumber,f.startColumn-1,i,s,t,r);for(let h=f.startLineNumber+1;h<f.endLineNumber&&i<r;h++)i=this._findMatchesInLine(v,a.getLineContent(h),h,0,i,s,t,r);if(i<r){const h=a.getLineContent(f.endLineNumber).substring(0,f.endColumn-1);i=this._findMatchesInLine(v,h,f.endLineNumber,0,i,s,t,r)}return s}static _findMatchesInLine(a,f,v,t,r,s,i,c){const h=a.wordSeparators;if(!i&&a.simpleSearch){const T=a.simpleSearch,o=T.length,A=f.length;let L=-o;for(;(L=f.indexOf(T,L+o))!==-1;)if((!h||b(h,f,A,L,o))&&(s[r++]=new C.FindMatch(new E.Range(v,L+1+t,v,L+1+o+t),null),r>=c))return r;return r}const p=new w(a.wordSeparators,a.regex);let D;p.reset(0);do if(D=p.next(f),D&&(s[r++]=I(new E.Range(v,D.index+1+t,v,D.index+1+D[0].length+t),D,i),r>=c))return r;while(D);return r}static findNextMatch(a,f,v,t){const r=f.parseSearchRequest();if(!r)return null;const s=new w(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(a,v,s,t):this._doFindNextMatchLineByLine(a,v,s,t)}static _doFindNextMatchMultiline(a,f,v,t){const r=new S.Position(f.lineNumber,1),s=a.getOffsetAt(r),i=a.getLineCount(),c=a.getValueInRange(new E.Range(r.lineNumber,r.column,i,a.getLineMaxColumn(i)),1),h=a.getEOL()===`\r
`?new l(c):null;v.reset(f.column-1);let p=v.next(c);return p?I(this._getMultilineMatchRange(a,s,c,h,p.index,p[0]),p,t):f.lineNumber!==1||f.column!==1?this._doFindNextMatchMultiline(a,new S.Position(1,1),v,t):null}static _doFindNextMatchLineByLine(a,f,v,t){const r=a.getLineCount(),s=f.lineNumber,i=a.getLineContent(s),c=this._findFirstMatchInLine(v,i,s,f.column,t);if(c)return c;for(let h=1;h<=r;h++){const p=(s+h-1)%r,D=a.getLineContent(p+1),T=this._findFirstMatchInLine(v,D,p+1,1,t);if(T)return T}return null}static _findFirstMatchInLine(a,f,v,t,r){a.reset(t-1);const s=a.next(f);return s?I(new E.Range(v,s.index+1,v,s.index+1+s[0].length),s,r):null}static findPreviousMatch(a,f,v,t){const r=f.parseSearchRequest();if(!r)return null;const s=new w(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(a,v,s,t):this._doFindPreviousMatchLineByLine(a,v,s,t)}static _doFindPreviousMatchMultiline(a,f,v,t){const r=this._doFindMatchesMultiline(a,new E.Range(1,1,f.lineNumber,f.column),v,t,10*y);if(r.length>0)return r[r.length-1];const s=a.getLineCount();return f.lineNumber!==s||f.column!==a.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(a,new S.Position(s,a.getLineMaxColumn(s)),v,t):null}static _doFindPreviousMatchLineByLine(a,f,v,t){const r=a.getLineCount(),s=f.lineNumber,i=a.getLineContent(s).substring(0,f.column-1),c=this._findLastMatchInLine(v,i,s,t);if(c)return c;for(let h=1;h<=r;h++){const p=(r+s-h-1)%r,D=a.getLineContent(p+1),T=this._findLastMatchInLine(v,D,p+1,t);if(T)return T}return null}static _findLastMatchInLine(a,f,v,t){let r=null,s;for(a.reset(0);s=a.next(f);)r=I(new E.Range(v,s.index+1,v,s.index+1+s[0].length),s,t);return r}}e.TextModelSearch=d;function u(P,a,f,v,t){if(v===0)return!0;const r=a.charCodeAt(v-1);if(P.get(r)!==0||r===13||r===10)return!0;if(t>0){const s=a.charCodeAt(v);if(P.get(s)!==0)return!0}return!1}function m(P,a,f,v,t){if(v+t===f)return!0;const r=a.charCodeAt(v+t);if(P.get(r)!==0||r===13||r===10)return!0;if(t>0){const s=a.charCodeAt(v+t-1);if(P.get(s)!==0)return!0}return!1}function b(P,a,f,v,t){return u(P,a,f,v,t)&&m(P,a,f,v,t)}e.isValidMatch=b;class w{constructor(a,f){this._wordSeparators=a,this._searchRegex=f,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(a){this._searchRegex.lastIndex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(a){const f=a.length;let v;do{if(this._prevMatchStartIndex+this._prevMatchLength===f||(v=this._searchRegex.exec(a),!v))return null;const t=v.index,r=v[0].length;if(t===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){g.getNextCodePoint(a,f,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=r,!this._wordSeparators||b(this._wordSeparators,a,f,t,r))return v}while(v);return null}}e.Searcher=w}),define(be[88],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function g(y=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)y.indexOf(k)>=0||(_+="\\"+k);return _+="\\s]+)",new RegExp(_,"g")}e.DEFAULT_WORD_REGEXP=g();function F(y){let _=e.DEFAULT_WORD_REGEXP;if(y&&y instanceof RegExp)if(y.global)_=y;else{let k="g";y.ignoreCase&&(k+="i"),y.multiline&&(k+="m"),y.unicode&&(k+="u"),_=new RegExp(y.source,k)}return _.lastIndex=0,_}e.ensureValidWordDefinition=F;const S={maxLen:1e3,windowSize:15,timeBudget:150};function E(y,_,k,n,I=S){if(k.length>I.maxLen){let b=y-I.maxLen/2;return b<0?b=0:n+=b,k=k.substring(b,y+I.maxLen/2),E(y,_,k,n,I)}const l=Date.now(),d=y-1-n;let u=-1,m=null;for(let b=1;!(Date.now()-l>=I.timeBudget);b++){const w=d-I.windowSize*b;_.lastIndex=Math.max(0,w);const P=C(_,k,d,u);if(!P&&m||(m=P,w<=0))break;u=w}if(m){let b={word:m[0],startColumn:n+1+m.index,endColumn:n+1+m.index+m[0].length};return _.lastIndex=0,b}return null}e.getWordAtText=E;function C(y,_,k,n){let I;for(;I=y.exec(_);){const l=I.index||0;if(l<=k&&y.lastIndex>=k)return I;if(n>0&&l>n)return null}return null}}),define(be[121],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var g;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(g=e.IndentAction||(e.IndentAction={}));class F{constructor(y){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=y.open,this.close=y.close,this._standardTokenMask=0,Array.isArray(y.notIn))for(let _=0,k=y.notIn.length;_<k;_++)switch(y.notIn[_]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(y){return(this._standardTokenMask&y)==0}}e.StandardAutoClosingPairConditional=F;class S{constructor(y){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of y)E(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),E(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),E(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),E(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&E(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=S;function E(C,y,_){C.has(y)?C.get(y).push(_):C.set(y,[_])}}),define(be[57],Ee([0,1,27,14]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function S(E,C,y,_){if(Array.isArray(E)){let k=0;for(const n of E){const I=S(n,C,y,_);if(I===10)return I;I>k&&(k=I)}return k}else{if(typeof E=="string")return _?E==="*"?5:E===y?10:0:0;if(E){const{language:k,pattern:n,scheme:I,hasAccessToAllModels:l}=E;if(!_&&!l)return 0;let d=0;if(I)if(I===C.scheme)d=10;else if(I==="*")d=5;else return 0;if(k)if(k===y)d=10;else if(k==="*")d=Math.max(d,5);else return 0;if(n){let u;if(typeof n=="string"?u=n:u={...n,base:(0,F.normalize)(n.base)},u===C.fsPath||(0,g.match)(u,C.fsPath))d=10;else return 0}return d}else return 0}}e.score=S}),define(be[122],Ee([0,1,86]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var F;(function(d){d[d.Invalid=0]="Invalid",d[d.Start=1]="Start",d[d.H=2]="H",d[d.HT=3]="HT",d[d.HTT=4]="HTT",d[d.HTTP=5]="HTTP",d[d.F=6]="F",d[d.FI=7]="FI",d[d.FIL=8]="FIL",d[d.BeforeColon=9]="BeforeColon",d[d.AfterColon=10]="AfterColon",d[d.AlmostThere=11]="AlmostThere",d[d.End=12]="End",d[d.Accept=13]="Accept",d[d.LastKnownState=14]="LastKnownState"})(F=e.State||(e.State={}));class S{constructor(u,m,b){const w=new Uint8Array(u*m);for(let P=0,a=u*m;P<a;P++)w[P]=b;this._data=w,this.rows=u,this.cols=m}get(u,m){return this._data[u*this.cols+m]}set(u,m,b){this._data[u*this.cols+m]=b}}e.Uint8Matrix=S;class E{constructor(u){let m=0,b=0;for(let P=0,a=u.length;P<a;P++){let[f,v,t]=u[P];v>m&&(m=v),f>b&&(b=f),t>b&&(b=t)}m++,b++;let w=new S(b,m,0);for(let P=0,a=u.length;P<a;P++){let[f,v,t]=u[P];w.set(f,v,t)}this._states=w,this._maxCharCode=m}nextState(u,m){return m<0||m>=this._maxCharCode?0:this._states.get(u,m)}}e.StateMachine=E;let C=null;function y(){return C===null&&(C=new E([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),C}var _;(function(d){d[d.None=0]="None",d[d.ForceTermination=1]="ForceTermination",d[d.CannotEndIn=2]="CannotEndIn"})(_||(_={}));let k=null;function n(){if(k===null){k=new g.CharacterClassifier(0);const d=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<d.length;m++)k.set(d.charCodeAt(m),1);const u=".,;";for(let m=0;m<u.length;m++)k.set(u.charCodeAt(m),2)}return k}class I{static _createLink(u,m,b,w,P){let a=P-1;do{const f=m.charCodeAt(a);if(u.get(f)!==2)break;a--}while(a>w);if(w>0){const f=m.charCodeAt(w-1),v=m.charCodeAt(a);(f===40&&v===41||f===91&&v===93||f===123&&v===125)&&a--}return{range:{startLineNumber:b,startColumn:w+1,endLineNumber:b,endColumn:a+2},url:m.substring(w,a+1)}}static computeLinks(u,m=y()){const b=n();let w=[];for(let P=1,a=u.getLineCount();P<=a;P++){const f=u.getLineContent(P),v=f.length;let t=0,r=0,s=0,i=1,c=!1,h=!1,p=!1,D=!1;for(;t<v;){let T=!1;const o=f.charCodeAt(t);if(i===13){let A;switch(o){case 40:c=!0,A=0;break;case 41:A=c?0:1;break;case 91:p=!0,h=!0,A=0;break;case 93:p=!1,A=h?0:1;break;case 123:D=!0,A=0;break;case 125:A=D?0:1;break;case 39:A=s===34||s===96?0:1;break;case 34:A=s===39||s===96?0:1;break;case 96:A=s===39||s===34?0:1;break;case 42:A=s===42?1:0;break;case 124:A=s===124?1:0;break;case 32:A=p?0:1;break;default:A=b.get(o)}A===1&&(w.push(I._createLink(b,f,P,r,t)),T=!0)}else if(i===12){let A;o===91?(h=!0,A=0):A=b.get(o),A===1?T=!0:i=13}else i=m.nextState(i,o),i===0&&(T=!0);T&&(i=1,c=!1,h=!1,D=!1,r=t+1,s=o),t++}i===13&&w.push(I._createLink(b,f,P,r,v))}return w}}e.LinkComputer=I;function l(d){return!d||typeof d.getLineCount!="function"||typeof d.getLineContent!="function"?[]:I.computeLinks(d)}e.computeLinks=l}),define(be[123],Ee([0,1,3,6]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class S{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new g.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(C){this._onDidChange.fire({changedLanguages:C,changedColorMap:!1})}register(C,y){return this._map.set(C,y),this.fire([C]),(0,F.toDisposable)(()=>{this._map.get(C)===y&&(this._map.delete(C),this.fire([C]))})}registerPromise(C,y){let _=null,k=!1;return this._promises.set(C,y.then(n=>{this._promises.delete(C),!(k||!n)&&(_=this.register(C,n))})),(0,F.toDisposable)(()=>{k=!0,_&&_.dispose()})}getPromise(C){const y=this.get(C);if(y)return Promise.resolve(y);const _=this._promises.get(C);return _?_.then(k=>this.get(C)):null}get(C){return this._map.get(C)||null}setColorMap(C){this._colorMap=C,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=S}),define(be[89],Ee([0,1,24,22]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var S;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(S||(S={}));function E(I){for(let l=0,d=I.length;l<d;l+=4){const u=I[l+0],m=I[l+1],b=I[l+2],w=I[l+3];I[l+0]=w,I[l+1]=b,I[l+2]=m,I[l+3]=u}}function C(I){const l=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return F.isLittleEndian()||E(l),g.VSBuffer.wrap(l)}function y(I){const l=I.buffer;if(F.isLittleEndian()||E(l),l.byteOffset%4==0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const d=new Uint8Array(l.byteLength);return d.set(l),new Uint32Array(d.buffer,d.byteOffset,d.length/4)}}function _(I){const l=new Uint32Array(k(I));let d=0;if(l[d++]=I.id,I.type==="full")l[d++]=1,l[d++]=I.data.length,l.set(I.data,d),d+=I.data.length;else{l[d++]=2,l[d++]=I.deltas.length;for(const u of I.deltas)l[d++]=u.start,l[d++]=u.deleteCount,u.data?(l[d++]=u.data.length,l.set(u.data,d),d+=u.data.length):l[d++]=0}return C(l)}e.encodeSemanticTokensDto=_;function k(I){let l=0;if(l+=1+1,I.type==="full")l+=1+I.data.length;else{l+=1,l+=(1+1+1)*I.deltas.length;for(const d of I.deltas)d.data&&(l+=d.data.length)}return l}function n(I){const l=y(I);let d=0;const u=l[d++];if(l[d++]===1){const P=l[d++],a=l.subarray(d,d+P);return d+=P,{id:u,type:"full",data:a}}const b=l[d++];let w=[];for(let P=0;P<b;P++){const a=l[d++],f=l[d++],v=l[d++];let t;v>0&&(t=l.subarray(d,d+v),d+=v),w[P]={start:a,deleteCount:f,data:t}}return{id:u,type:"delta",deltas:w}}e.decodeSemanticTokensDto=n}),define(be[90],Ee([0,1,82]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class F{constructor(C,y){this._prefixSumIndexOfResultBrand=void 0,this.index=C,this.remainder=y}}e.PrefixSumIndexOfResult=F;class S{constructor(C){this.values=C,this.prefixSum=new Uint32Array(C.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(C,y){C=(0,g.toUint32)(C);const _=this.values,k=this.prefixSum,n=y.length;return n===0?!1:(this.values=new Uint32Array(_.length+n),this.values.set(_.subarray(0,C),0),this.values.set(_.subarray(C),C+n),this.values.set(y,C),C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(C,y){return C=(0,g.toUint32)(C),y=(0,g.toUint32)(y),this.values[C]===y?!1:(this.values[C]=y,C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),!0)}removeValues(C,y){C=(0,g.toUint32)(C),y=(0,g.toUint32)(y);const _=this.values,k=this.prefixSum;if(C>=_.length)return!1;let n=_.length-C;return y>=n&&(y=n),y===0?!1:(this.values=new Uint32Array(_.length-y),this.values.set(_.subarray(0,C),0),this.values.set(_.subarray(C+y),C),this.prefixSum=new Uint32Array(this.values.length),C-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=C-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(C){return C<0?0:(C=(0,g.toUint32)(C),this._getPrefixSum(C))}_getPrefixSum(C){if(C<=this.prefixSumValidIndex[0])return this.prefixSum[C];let y=this.prefixSumValidIndex[0]+1;y===0&&(this.prefixSum[0]=this.values[0],y++),C>=this.values.length&&(C=this.values.length-1);for(let _=y;_<=C;_++)this.prefixSum[_]=this.prefixSum[_-1]+this.values[_];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],C),this.prefixSum[C]}getIndexOf(C){C=Math.floor(C),this.getTotalSum();let y=0,_=this.values.length-1,k=0,n=0,I=0;for(;y<=_;)if(k=y+(_-y)/2|0,n=this.prefixSum[k],I=n-this.values[k],C<I)_=k-1;else if(C>=n)y=k+1;else break;return new F(k,C-I)}}e.PrefixSumComputer=S}),define(be[124],Ee([0,1,8,37,90]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class E{constructor(y,_,k,n){this._uri=y,this._lines=_,this._eol=k,this._versionId=n,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(y){y.eol&&y.eol!==this._eol&&(this._eol=y.eol,this._lineStarts=null);const _=y.changes;for(const k of _)this._acceptDeleteRange(k.range),this._acceptInsertText(new F.Position(k.range.startLineNumber,k.range.startColumn),k.text);this._versionId=y.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const y=this._eol.length,_=this._lines.length,k=new Uint32Array(_);for(let n=0;n<_;n++)k[n]=this._lines[n].length+y;this._lineStarts=new S.PrefixSumComputer(k)}}_setLineText(y,_){this._lines[y]=_,this._lineStarts&&this._lineStarts.changeValue(y,this._lines[y].length+this._eol.length)}_acceptDeleteRange(y){if(y.startLineNumber===y.endLineNumber){if(y.startColumn===y.endColumn)return;this._setLineText(y.startLineNumber-1,this._lines[y.startLineNumber-1].substring(0,y.startColumn-1)+this._lines[y.startLineNumber-1].substring(y.endColumn-1));return}this._setLineText(y.startLineNumber-1,this._lines[y.startLineNumber-1].substring(0,y.startColumn-1)+this._lines[y.endLineNumber-1].substring(y.endColumn-1)),this._lines.splice(y.startLineNumber,y.endLineNumber-y.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(y.startLineNumber,y.endLineNumber-y.startLineNumber)}_acceptInsertText(y,_){if(_.length===0)return;let k=(0,g.splitLines)(_);if(k.length===1){this._setLineText(y.lineNumber-1,this._lines[y.lineNumber-1].substring(0,y.column-1)+k[0]+this._lines[y.lineNumber-1].substring(y.column-1));return}k[k.length-1]+=this._lines[y.lineNumber-1].substring(y.column-1),this._setLineText(y.lineNumber-1,this._lines[y.lineNumber-1].substring(0,y.column-1)+k[0]);let n=new Uint32Array(k.length-1);for(let I=1;I<k.length;I++)this._lines.splice(y.lineNumber+I-1,0,k[I]),n[I-1]=k[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(y.lineNumber,n)}}e.MirrorTextModel=E}),define(be[125],Ee([18,19]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(be[58],Ee([0,1,125,10,17]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function E(k,n){return n&&(k.stack||k.stacktrace)?g.localize(0,null,y(k),C(k.stack)||C(k.stacktrace)):y(k)}function C(k){return Array.isArray(k)?k.join(`
`):k}function y(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?g.localize(1,null,k.message):k.message||g.localize(2,null)}function _(k=null,n=!1){if(!k)return g.localize(3,null);if(Array.isArray(k)){const I=S.coalesce(k),l=_(I[0],n);return I.length>1?g.localize(4,null,l,I.length):l}if(F.isString(k))return k;if(k.detail){const I=k.detail;if(I.error)return E(I.error,n);if(I.exception)return E(I.exception,n)}return k.stack?E(k,n):k.message?k.message:g.localize(5,null)}e.toErrorMessage=_}),define(be[126],Ee([18,19]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(be[127],Ee([0,1,126,22,88]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(H){H[H.None=0]="None",H[H.Keep=1]="Keep",H[H.Brackets=2]="Brackets",H[H.Advanced=3]="Advanced",H[H.Full=4]="Full"})(E=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class C{constructor(Z){this._values=Z}hasChanged(Z){return this._values[Z]}}e.ConfigurationChangedEvent=C;class y{constructor(){this._values=[]}_read(Z){return this._values[Z]}get(Z){return this._values[Z]}_write(Z,ce){this._values[Z]=ce}}e.ValidatedEditorOptions=y;class _{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=_;class k{constructor(Z,ce,Be,xe){this.id=Z,this.name=ce,this.defaultValue=Be,this.schema=xe}compute(Z,ce,Be){return Be}}class n{constructor(Z,ce=null){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0,this.deps=ce}validate(Z){return this.defaultValue}}class I{constructor(Z,ce,Be,xe){this.id=Z,this.name=ce,this.defaultValue=Be,this.schema=xe}validate(Z){return typeof Z=="undefined"?this.defaultValue:Z}compute(Z,ce,Be){return Be}}function l(H,Z){return typeof H=="undefined"?Z:H==="false"?!1:Boolean(H)}e.boolean=l;class d extends I{constructor(Z,ce,Be,xe=void 0){typeof xe!="undefined"&&(xe.type="boolean",xe.default=Be),super(Z,ce,Be,xe)}validate(Z){return l(Z,this.defaultValue)}}class u extends I{constructor(Z,ce,Be,xe,Ze,De=void 0){typeof De!="undefined"&&(De.type="integer",De.default=Be,De.minimum=xe,De.maximum=Ze),super(Z,ce,Be,De),this.minimum=xe,this.maximum=Ze}static clampedInt(Z,ce,Be,xe){if(typeof Z=="undefined")return ce;let Ze=parseInt(Z,10);return isNaN(Ze)?ce:(Ze=Math.max(Be,Ze),Ze=Math.min(xe,Ze),Ze|0)}validate(Z){return u.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}class m extends I{constructor(Z,ce,Be,xe,Ze){typeof Ze!="undefined"&&(Ze.type="number",Ze.default=Be),super(Z,ce,Be,Ze),this.validationFn=xe}static clamp(Z,ce,Be){return Z<ce?ce:Z>Be?Be:Z}static float(Z,ce){if(typeof Z=="number")return Z;if(typeof Z=="undefined")return ce;const Be=parseFloat(Z);return isNaN(Be)?ce:Be}validate(Z){return this.validationFn(m.float(Z,this.defaultValue))}}class b extends I{static string(Z,ce){return typeof Z!="string"?ce:Z}constructor(Z,ce,Be,xe=void 0){typeof xe!="undefined"&&(xe.type="string",xe.default=Be),super(Z,ce,Be,xe)}validate(Z){return b.string(Z,this.defaultValue)}}function w(H,Z,ce){return typeof H!="string"||ce.indexOf(H)===-1?Z:H}e.stringSet=w;class P extends I{constructor(Z,ce,Be,xe,Ze=void 0){typeof Ze!="undefined"&&(Ze.type="string",Ze.enum=xe,Ze.default=Be),super(Z,ce,Be,Ze),this._allowedValues=xe}validate(Z){return w(Z,this.defaultValue,this._allowedValues)}}class a extends k{constructor(Z,ce,Be,xe,Ze,De,Se=void 0){typeof Se!="undefined"&&(Se.type="string",Se.enum=Ze,Se.default=xe),super(Z,ce,Be,Se),this._allowedValues=Ze,this._convert=De}validate(Z){return typeof Z!="string"?this.defaultValue:this._allowedValues.indexOf(Z)===-1?this.defaultValue:this._convert(Z)}}function f(H){switch(H){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class v extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",description:g.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,ce,Be){return Be===0?Z.accessibilitySupport:Be}}class t extends k{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:g.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z;return{insertSpace:l(ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:l(ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(H){H[H.Hidden=0]="Hidden",H[H.Blink=1]="Blink",H[H.Smooth=2]="Smooth",H[H.Phase=3]="Phase",H[H.Expand=4]="Expand",H[H.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(H){switch(H){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var i;(function(H){H[H.Line=1]="Line",H[H.Block=2]="Block",H[H.Underline=3]="Underline",H[H.LineThin=4]="LineThin",H[H.BlockOutline=5]="BlockOutline",H[H.UnderlineThin=6]="UnderlineThin"})(i=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function c(H){switch(H){case i.Line:return"line";case i.Block:return"block";case i.Underline:return"underline";case i.LineThin:return"line-thin";case i.BlockOutline:return"block-outline";case i.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=c;function h(H){switch(H){case"line":return i.Line;case"block":return i.Block;case"underline":return i.Underline;case"line-thin":return i.LineThin;case"block-outline":return i.BlockOutline;case"underline-thin":return i.UnderlineThin}}class p extends n{constructor(){super(126,[64,31])}compute(Z,ce,Be){const xe=["monaco-editor"];return ce.get(31)&&xe.push(ce.get(31)),Z.extraEditorClassName&&xe.push(Z.extraEditorClassName),ce.get(64)==="default"?xe.push("mouse-default"):ce.get(64)==="copy"&&xe.push("mouse-copy"),ce.get(99)&&xe.push("showUnused"),ce.get(124)&&xe.push("showDeprecated"),xe.join(" ")}}class D extends d{constructor(){super(30,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(Z,ce,Be){return Be&&Z.emptySelectionClipboard}}class T extends k{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:Z.seedSearchStringFromSelection,description:g.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[g.localize(9,null),g.localize(10,null),g.localize(11,null)],description:g.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:g.localize(13,null),included:F.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:g.localize(14,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:g.localize(15,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z;return{cursorMoveOnType:l(ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:l(ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":w(ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:l(ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:l(ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:l(ce.loop,this.defaultValue.loop)}}}class o extends k{constructor(){super(42,"fontLigatures",o.OFF,{anyOf:[{type:"boolean",description:g.localize(16,null)},{type:"string",description:g.localize(17,null)}],description:g.localize(18,null),default:!1})}validate(Z){return typeof Z=="undefined"?this.defaultValue:typeof Z=="string"?Z==="false"?o.OFF:Z==="true"?o.ON:Z:Boolean(Z)?o.ON:o.OFF}}e.EditorFontLigatures=o,o.OFF='"liga" off, "calt" off',o.ON='"liga" on, "calt" on';class A extends n{constructor(){super(41)}compute(Z,ce,Be){return Z.fontInfo}}class L extends I{constructor(){super(43,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(19,null)})}validate(Z){let ce=m.float(Z,this.defaultValue);return ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:m.clamp(ce,6,100)}compute(Z,ce,Be){return Z.fontInfo.fontSize}}class $ extends k{constructor(){super(44,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:$.MINIMUM_VALUE,maximum:$.MAXIMUM_VALUE,errorMessage:g.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:$.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(21,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(u.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,$.MINIMUM_VALUE,$.MAXIMUM_VALUE))}}$.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],$.MINIMUM_VALUE=1,$.MAXIMUM_VALUE=1e3;class oe extends k{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[g.localize(22,null),g.localize(23,null),g.localize(24,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(48,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(25,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(26,null),...ce},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(27,null),...ce},"editor.gotoLocation.multipleDeclarations":{description:g.localize(28,null),...ce},"editor.gotoLocation.multipleImplementations":{description:g.localize(29,null),...ce},"editor.gotoLocation.multipleReferences":{description:g.localize(30,null),...ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:Be,description:g.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:Be,description:g.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:Be,description:g.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:Be,description:g.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:Be,description:g.localize(35,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z;return{multiple:w(ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ce.multipleDefinitions??w(ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ce.multipleTypeDefinitions??w(ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ce.multipleDeclarations??w(ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ce.multipleImplementations??w(ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ce.multipleReferences??w(ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:b.string(ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:b.string(ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:b.string(ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:b.string(ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:b.string(ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class he extends k{constructor(){const Z={enabled:!0,delay:300,sticky:!0};super(51,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:g.localize(36,null)},"editor.hover.delay":{type:"number",default:Z.delay,description:g.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:g.localize(38,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z;return{enabled:l(ce.enabled,this.defaultValue.enabled),delay:u.clampedInt(ce.delay,this.defaultValue.delay,0,1e4),sticky:l(ce.sticky,this.defaultValue.sticky)}}}var Q;(function(H){H[H.None=0]="None",H[H.Text=1]="Text",H[H.Blocks=2]="Blocks"})(Q=e.RenderMinimap||(e.RenderMinimap={}));class z extends n{constructor(){super(129,[47,56,35,63,91,58,59,93,116,119,120,121,2])}compute(Z,ce,Be){return z.computeLayout(ce,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio})}static computeContainedMinimapLineCount(Z){const ce=Z.height/Z.lineHeight,Be=Z.scrollBeyondLastLine?ce-1:0,xe=(Z.viewLineCount+Be)/(Z.pixelRatio*Z.height),Ze=Math.floor(Z.viewLineCount/xe);return{typicalViewportLineCount:ce,extraLinesBeyondLastLine:Be,desiredRatio:xe,minimapLineCount:Ze}}static _computeMinimapLayout(Z,ce){const Be=Z.outerWidth,xe=Z.outerHeight,Ze=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const De=ce.stableMinimapLayoutInput,Se=De&&Z.outerHeight===De.outerHeight&&Z.lineHeight===De.lineHeight&&Z.typicalHalfwidthCharacterWidth===De.typicalHalfwidthCharacterWidth&&Z.pixelRatio===De.pixelRatio&&Z.scrollBeyondLastLine===De.scrollBeyondLastLine&&Z.minimap.enabled===De.minimap.enabled&&Z.minimap.side===De.minimap.side&&Z.minimap.size===De.minimap.size&&Z.minimap.showSlider===De.minimap.showSlider&&Z.minimap.renderCharacters===De.minimap.renderCharacters&&Z.minimap.maxColumn===De.minimap.maxColumn&&Z.minimap.scale===De.minimap.scale&&Z.verticalScrollbarWidth===De.verticalScrollbarWidth&&Z.isViewportWrapping===De.isViewportWrapping,Pe=Z.lineHeight,re=Z.typicalHalfwidthCharacterWidth,ae=Z.scrollBeyondLastLine,fe=Z.minimap.renderCharacters;let pe=Ze>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const U=Z.minimap.maxColumn,me=Z.minimap.size,we=Z.minimap.side,Ie=Z.verticalScrollbarWidth,Oe=Z.viewLineCount,He=Z.remainingWidth,et=Z.isViewportWrapping,Ke=fe?2:3;let Ge=Math.floor(Ze*xe);const lt=Ge/Ze;let ft=!1,_t=!1,ut=Ke*pe,ot=pe/Ze,_e=1;if(me==="fill"||me==="fit"){const{typicalViewportLineCount:Qe,extraLinesBeyondLastLine:dt,desiredRatio:yt,minimapLineCount:kt}=z.computeContainedMinimapLineCount({viewLineCount:Oe,scrollBeyondLastLine:ae,height:xe,lineHeight:Pe,pixelRatio:Ze});if(Oe/kt>1)ft=!0,_t=!0,pe=1,ut=1,ot=pe/Ze;else{let mt=!1,ct=pe+1;if(me==="fit"){const Et=Math.ceil((Oe+dt)*ut);et&&Se&&He<=ce.stableFitRemainingWidth?(mt=!0,ct=ce.stableFitMaxMinimapScale):mt=Et>Ge}if(me==="fill"||mt){ft=!0;const Et=pe;ut=Math.min(Pe*Ze,Math.max(1,Math.floor(1/yt))),et&&Se&&He<=ce.stableFitRemainingWidth&&(ct=ce.stableFitMaxMinimapScale),pe=Math.min(ct,Math.max(1,Math.floor(ut/Ke))),pe>Et&&(_e=Math.min(2,pe/Et)),ot=pe/Ze/_e,Ge=Math.ceil(Math.max(Qe,Oe+dt)*ut),et?(ce.stableMinimapLayoutInput=Z,ce.stableFitRemainingWidth=He,ce.stableFitMaxMinimapScale=pe):(ce.stableMinimapLayoutInput=null,ce.stableFitRemainingWidth=0)}}}const ke=Math.floor(U*ot),Y=Math.min(ke,Math.max(0,Math.floor((He-Ie-2)*ot/(re+ot)))+e.MINIMAP_GUTTER_WIDTH);let W=Math.floor(Ze*Y);const Fe=W/Ze;W=Math.floor(W*_e);const Me=fe?1:2,tt=we==="left"?0:Be-Y-Ie;return{renderMinimap:Me,minimapLeft:tt,minimapWidth:Y,minimapHeightIsEditorHeight:ft,minimapIsSampling:_t,minimapScale:pe,minimapLineHeight:ut,minimapCanvasInnerWidth:W,minimapCanvasInnerHeight:Ge,minimapCanvasOuterWidth:Fe,minimapCanvasOuterHeight:lt}}static computeLayout(Z,ce){const Be=ce.outerWidth|0,xe=ce.outerHeight|0,Ze=ce.lineHeight|0,De=ce.lineNumbersDigitCount|0,Se=ce.typicalHalfwidthCharacterWidth,Pe=ce.maxDigitWidth,re=ce.pixelRatio,ae=ce.viewLineCount,fe=Z.get(121),pe=fe==="inherit"?Z.get(120):fe,U=pe==="inherit"?Z.get(116):pe,me=Z.get(119),we=Z.get(2),Ie=ce.isDominatedByLongLines,Oe=Z.get(47),He=Z.get(58).renderType!==0,et=Z.get(59),Ke=Z.get(93),Ge=Z.get(63),lt=Z.get(91),ft=lt.verticalScrollbarSize,_t=lt.verticalHasArrows,ut=lt.arrowSize,ot=lt.horizontalScrollbarSize,_e=Z.get(56),ke=Z.get(35);let Y;if(typeof _e=="string"&&/^\d+(\.\d+)?ch$/.test(_e)){const Pt=parseFloat(_e.substr(0,_e.length-2));Y=u.clampedInt(Pt*Se,0,0,1e3)}else Y=u.clampedInt(_e,0,0,1e3);ke&&(Y+=16);let W=0;if(He){const Pt=Math.max(De,et);W=Math.round(Pt*Pe)}let Fe=0;Oe&&(Fe=Ze);let Me=0,tt=Me+Fe,Qe=tt+W,dt=Qe+Y;const yt=Be-Fe-W-Y;let kt=!1,bt=!1,mt=-1;we!==2&&(pe==="inherit"&&Ie?(kt=!0,bt=!0):U==="on"||U==="bounded"?bt=!0:U==="wordWrapColumn"&&(mt=me));const ct=z._computeMinimapLayout({outerWidth:Be,outerHeight:xe,lineHeight:Ze,typicalHalfwidthCharacterWidth:Se,pixelRatio:re,scrollBeyondLastLine:Ke,minimap:Ge,verticalScrollbarWidth:ft,viewLineCount:ae,remainingWidth:yt,isViewportWrapping:bt},ce.memory||new _);ct.renderMinimap!==0&&ct.minimapLeft===0&&(Me+=ct.minimapWidth,tt+=ct.minimapWidth,Qe+=ct.minimapWidth,dt+=ct.minimapWidth);const Et=yt-ct.minimapWidth,gt=Math.max(1,Math.floor((Et-ft-2)/Se)),Ot=_t?ut:0;return bt&&(mt=Math.max(1,gt),U==="bounded"&&(mt=Math.min(mt,me))),{width:Be,height:xe,glyphMarginLeft:Me,glyphMarginWidth:Fe,lineNumbersLeft:tt,lineNumbersWidth:W,decorationsLeft:Qe,decorationsWidth:Y,contentLeft:dt,contentWidth:Et,minimap:ct,viewportColumn:gt,isWordWrapMinified:kt,isViewportWrapping:bt,wrappingColumn:mt,verticalScrollbarWidth:ft,horizontalScrollbarHeight:ot,overviewRuler:{top:Ot,width:ft,height:xe-2*Ot,right:0}}}}e.EditorLayoutInfoComputer=z;class V extends k{constructor(){const Z={enabled:!0};super(55,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"boolean",default:Z.enabled,description:g.localize(39,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:l(Z.enabled,this.defaultValue.enabled)}}}class R extends k{constructor(){const Z={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"boolean",default:Z.enabled,description:g.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:g.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,description:g.localize(42,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z;return{enabled:l(ce.enabled,this.defaultValue.enabled),fontSize:u.clampedInt(ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:b.string(ce.fontFamily,this.defaultValue.fontFamily)}}}class G extends m{constructor(){super(57,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>m.clamp(Z,0,150),{markdownDescription:g.localize(43,null)})}compute(Z,ce,Be){return Z.fontInfo.lineHeight}}class x extends k{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(63,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:g.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(45,null),g.localize(46,null),g.localize(47,null)],default:Z.size,description:g.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:g.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:g.localize(50,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:g.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:g.localize(53,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z;return{enabled:l(ce.enabled,this.defaultValue.enabled),size:w(ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(ce.side,this.defaultValue.side,["right","left"]),showSlider:w(ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:l(ce.renderCharacters,this.defaultValue.renderCharacters),scale:u.clampedInt(ce.scale,1,1,3),maxColumn:u.clampedInt(ce.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function j(H){return H==="ctrlCmd"?F.isMacintosh?"metaKey":"ctrlKey":"altKey"}class de extends k{constructor(){super(73,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(55,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z;return{top:u.clampedInt(ce.top,0,0,1e3),bottom:u.clampedInt(ce.bottom,0,0,1e3)}}}class B extends k{constructor(){const Z={enabled:!0,cycle:!1};super(74,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:g.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:g.localize(57,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z;return{enabled:l(ce.enabled,this.defaultValue.enabled),cycle:l(ce.cycle,this.defaultValue.cycle)}}}class ne extends n{constructor(){super(127)}compute(Z,ce,Be){return Z.pixelRatio}}class ue extends k{constructor(){const Z={other:!0,comments:!1,strings:!1};super(77,"quickSuggestions",Z,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Z.strings,description:g.localize(58,null)},comments:{type:"boolean",default:Z.comments,description:g.localize(59,null)},other:{type:"boolean",default:Z.other,description:g.localize(60,null)}}}],default:Z,description:g.localize(61,null)});this.defaultValue=Z}validate(Z){if(typeof Z=="boolean")return Z;if(Z&&typeof Z=="object"){const ce=Z,Be={other:l(ce.other,this.defaultValue.other),comments:l(ce.comments,this.defaultValue.comments),strings:l(ce.strings,this.defaultValue.strings)};return Be.other&&Be.comments&&Be.strings?!0:!Be.other&&!Be.comments&&!Be.strings?!1:Be}return this.defaultValue}}var ye;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative",H[H.Interval=3]="Interval",H[H.Custom=4]="Custom"})(ye=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Re extends k{constructor(){super(58,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(62,null),g.localize(63,null),g.localize(64,null),g.localize(65,null)],default:"on",description:g.localize(66,null)})}validate(Z){let ce=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof Z!="undefined"&&(typeof Z=="function"?(ce=4,Be=Z):Z==="interval"?ce=3:Z==="relative"?ce=2:Z==="on"?ce=1:ce=0),{renderType:ce,renderFn:Be}}}function Te(H){const Z=H.get(86);return Z==="editable"?H.get(79):Z!=="on"}e.filterValidationDecorations=Te;class $e extends k{constructor(){const Z=[],ce={type:"number",description:g.localize(67,null)};super(90,"rulers",Z,{type:"array",items:{anyOf:[ce,{type:["object"],properties:{column:ce,color:{type:"string",description:g.localize(68,null),format:"color-hex"}}}]},default:Z,description:g.localize(69,null)})}validate(Z){if(Array.isArray(Z)){let ce=[];for(let Be of Z)if(typeof Be=="number")ce.push({column:u.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const xe=Be;ce.push({column:u.clampedInt(xe.column,0,0,1e4),color:xe.color})}return ce.sort((Be,xe)=>Be.column-xe.column),ce}return this.defaultValue}}function Je(H,Z){if(typeof H!="string")return Z;switch(H){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ve extends k{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(70,null),g.localize(71,null),g.localize(72,null)],default:"auto",description:g.localize(73,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(74,null),g.localize(75,null),g.localize(76,null)],default:"auto",description:g.localize(77,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:g.localize(78,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:g.localize(79,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:g.localize(80,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z,Be=u.clampedInt(ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=u.clampedInt(ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:u.clampedInt(ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Je(ce.vertical,this.defaultValue.vertical),horizontal:Je(ce.horizontal,this.defaultValue.horizontal),useShadows:l(ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:l(ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:l(ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:l(ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:l(ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:u.clampedInt(ce.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:u.clampedInt(ce.verticalSliderSize,xe,0,1e3),scrollByPage:l(ce.scrollByPage,this.defaultValue.scrollByPage)}}}class je extends k{constructor(){const Z={enabled:!1,mode:"subwordSmart"};super(53,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:g.localize(81,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[g.localize(82,null),g.localize(83,null),g.localize(84,null)],default:Z.mode,description:g.localize(85,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z;return{enabled:l(ce.enabled,this.defaultValue.enabled),mode:w(ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class O extends k{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(86,null),g.localize(87,null)],default:Z.insertMode,description:g.localize(88,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:g.localize(89,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:g.localize(90,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:g.localize(91,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:g.localize(92,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:g.localize(93,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:g.localize(94,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:g.localize(95,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[g.localize(96,null),g.localize(97,null),g.localize(98,null)],default:Z.previewMode,description:g.localize(99,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:g.localize(100,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(101,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(102,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(103,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(104,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(105,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(106,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(107,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(108,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(109,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(110,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(111,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(112,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(113,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(114,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(115,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(116,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(117,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(118,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(119,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(120,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(121,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(122,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(123,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(124,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(125,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(126,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(127,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(128,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(129,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(130,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(131,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ce=Z;return{insertMode:w(ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:l(ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:l(ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:l(ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:l(ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:l(ce.showIcons,this.defaultValue.showIcons),showStatusBar:l(ce.showStatusBar,this.defaultValue.showStatusBar),preview:l(ce.preview,this.defaultValue.preview),previewMode:w(ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:l(ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:l(ce.showMethods,this.defaultValue.showMethods),showFunctions:l(ce.showFunctions,this.defaultValue.showFunctions),showConstructors:l(ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:l(ce.showDeprecated,this.defaultValue.showDeprecated),showFields:l(ce.showFields,this.defaultValue.showFields),showVariables:l(ce.showVariables,this.defaultValue.showVariables),showClasses:l(ce.showClasses,this.defaultValue.showClasses),showStructs:l(ce.showStructs,this.defaultValue.showStructs),showInterfaces:l(ce.showInterfaces,this.defaultValue.showInterfaces),showModules:l(ce.showModules,this.defaultValue.showModules),showProperties:l(ce.showProperties,this.defaultValue.showProperties),showEvents:l(ce.showEvents,this.defaultValue.showEvents),showOperators:l(ce.showOperators,this.defaultValue.showOperators),showUnits:l(ce.showUnits,this.defaultValue.showUnits),showValues:l(ce.showValues,this.defaultValue.showValues),showConstants:l(ce.showConstants,this.defaultValue.showConstants),showEnums:l(ce.showEnums,this.defaultValue.showEnums),showEnumMembers:l(ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:l(ce.showKeywords,this.defaultValue.showKeywords),showWords:l(ce.showWords,this.defaultValue.showWords),showColors:l(ce.showColors,this.defaultValue.showColors),showFiles:l(ce.showFiles,this.defaultValue.showFiles),showReferences:l(ce.showReferences,this.defaultValue.showReferences),showFolders:l(ce.showFolders,this.defaultValue.showFolders),showTypeParameters:l(ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:l(ce.showSnippets,this.defaultValue.showSnippets),showUsers:l(ce.showUsers,this.defaultValue.showUsers),showIssues:l(ce.showIssues,this.defaultValue.showIssues)}}}class K extends k{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(132,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:l(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class X extends n{constructor(){super(128,[79])}compute(Z,ce,Be){return ce.get(79)?!0:Z.tabFocusMode}}var se;(function(H){H[H.None=0]="None",H[H.Same=1]="Same",H[H.Indent=2]="Indent",H[H.DeepIndent=3]="DeepIndent"})(se=e.WrappingIndent||(e.WrappingIndent={}));function q(H){switch(H){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ie extends n{constructor(){super(130,[129])}compute(Z,ce,Be){const xe=ce.get(129);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}const ge="Consolas, 'Courier New', monospace",Le="Menlo, Monaco, 'Courier New', monospace",We="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:F.isMacintosh?Le:F.isLinux?We:ge,fontWeight:"normal",fontSize:F.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function ve(H){return e.editorOptionsRegistry[H.id]=H,H}var Xe;(function(H){H[H.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",H[H.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",H[H.accessibilitySupport=2]="accessibilitySupport",H[H.accessibilityPageSize=3]="accessibilityPageSize",H[H.ariaLabel=4]="ariaLabel",H[H.autoClosingBrackets=5]="autoClosingBrackets",H[H.autoClosingDelete=6]="autoClosingDelete",H[H.autoClosingOvertype=7]="autoClosingOvertype",H[H.autoClosingQuotes=8]="autoClosingQuotes",H[H.autoIndent=9]="autoIndent",H[H.automaticLayout=10]="automaticLayout",H[H.autoSurround=11]="autoSurround",H[H.codeLens=12]="codeLens",H[H.codeLensFontFamily=13]="codeLensFontFamily",H[H.codeLensFontSize=14]="codeLensFontSize",H[H.colorDecorators=15]="colorDecorators",H[H.columnSelection=16]="columnSelection",H[H.comments=17]="comments",H[H.contextmenu=18]="contextmenu",H[H.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",H[H.cursorBlinking=20]="cursorBlinking",H[H.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",H[H.cursorStyle=22]="cursorStyle",H[H.cursorSurroundingLines=23]="cursorSurroundingLines",H[H.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",H[H.cursorWidth=25]="cursorWidth",H[H.disableLayerHinting=26]="disableLayerHinting",H[H.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",H[H.domReadOnly=28]="domReadOnly",H[H.dragAndDrop=29]="dragAndDrop",H[H.emptySelectionClipboard=30]="emptySelectionClipboard",H[H.extraEditorClassName=31]="extraEditorClassName",H[H.fastScrollSensitivity=32]="fastScrollSensitivity",H[H.find=33]="find",H[H.fixedOverflowWidgets=34]="fixedOverflowWidgets",H[H.folding=35]="folding",H[H.foldingStrategy=36]="foldingStrategy",H[H.foldingHighlight=37]="foldingHighlight",H[H.foldingImportsByDefault=38]="foldingImportsByDefault",H[H.unfoldOnClickAfterEndOfLine=39]="unfoldOnClickAfterEndOfLine",H[H.fontFamily=40]="fontFamily",H[H.fontInfo=41]="fontInfo",H[H.fontLigatures=42]="fontLigatures",H[H.fontSize=43]="fontSize",H[H.fontWeight=44]="fontWeight",H[H.formatOnPaste=45]="formatOnPaste",H[H.formatOnType=46]="formatOnType",H[H.glyphMargin=47]="glyphMargin",H[H.gotoLocation=48]="gotoLocation",H[H.hideCursorInOverviewRuler=49]="hideCursorInOverviewRuler",H[H.highlightActiveIndentGuide=50]="highlightActiveIndentGuide",H[H.hover=51]="hover",H[H.inDiffEditor=52]="inDiffEditor",H[H.inlineSuggest=53]="inlineSuggest",H[H.letterSpacing=54]="letterSpacing",H[H.lightbulb=55]="lightbulb",H[H.lineDecorationsWidth=56]="lineDecorationsWidth",H[H.lineHeight=57]="lineHeight",H[H.lineNumbers=58]="lineNumbers",H[H.lineNumbersMinChars=59]="lineNumbersMinChars",H[H.linkedEditing=60]="linkedEditing",H[H.links=61]="links",H[H.matchBrackets=62]="matchBrackets",H[H.minimap=63]="minimap",H[H.mouseStyle=64]="mouseStyle",H[H.mouseWheelScrollSensitivity=65]="mouseWheelScrollSensitivity",H[H.mouseWheelZoom=66]="mouseWheelZoom",H[H.multiCursorMergeOverlapping=67]="multiCursorMergeOverlapping",H[H.multiCursorModifier=68]="multiCursorModifier",H[H.multiCursorPaste=69]="multiCursorPaste",H[H.occurrencesHighlight=70]="occurrencesHighlight",H[H.overviewRulerBorder=71]="overviewRulerBorder",H[H.overviewRulerLanes=72]="overviewRulerLanes",H[H.padding=73]="padding",H[H.parameterHints=74]="parameterHints",H[H.peekWidgetDefaultFocus=75]="peekWidgetDefaultFocus",H[H.definitionLinkOpensInPeek=76]="definitionLinkOpensInPeek",H[H.quickSuggestions=77]="quickSuggestions",H[H.quickSuggestionsDelay=78]="quickSuggestionsDelay",H[H.readOnly=79]="readOnly",H[H.renameOnType=80]="renameOnType",H[H.renderControlCharacters=81]="renderControlCharacters",H[H.renderIndentGuides=82]="renderIndentGuides",H[H.renderFinalNewline=83]="renderFinalNewline",H[H.renderLineHighlight=84]="renderLineHighlight",H[H.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",H[H.renderValidationDecorations=86]="renderValidationDecorations",H[H.renderWhitespace=87]="renderWhitespace",H[H.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",H[H.roundedSelection=89]="roundedSelection",H[H.rulers=90]="rulers",H[H.scrollbar=91]="scrollbar",H[H.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",H[H.scrollBeyondLastLine=93]="scrollBeyondLastLine",H[H.scrollPredominantAxis=94]="scrollPredominantAxis",H[H.selectionClipboard=95]="selectionClipboard",H[H.selectionHighlight=96]="selectionHighlight",H[H.selectOnLineNumbers=97]="selectOnLineNumbers",H[H.showFoldingControls=98]="showFoldingControls",H[H.showUnused=99]="showUnused",H[H.snippetSuggestions=100]="snippetSuggestions",H[H.smartSelect=101]="smartSelect",H[H.smoothScrolling=102]="smoothScrolling",H[H.stickyTabStops=103]="stickyTabStops",H[H.stopRenderingLineAfter=104]="stopRenderingLineAfter",H[H.suggest=105]="suggest",H[H.suggestFontSize=106]="suggestFontSize",H[H.suggestLineHeight=107]="suggestLineHeight",H[H.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",H[H.suggestSelection=109]="suggestSelection",H[H.tabCompletion=110]="tabCompletion",H[H.tabIndex=111]="tabIndex",H[H.unusualLineTerminators=112]="unusualLineTerminators",H[H.useShadowDOM=113]="useShadowDOM",H[H.useTabStops=114]="useTabStops",H[H.wordSeparators=115]="wordSeparators",H[H.wordWrap=116]="wordWrap",H[H.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",H[H.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",H[H.wordWrapColumn=119]="wordWrapColumn",H[H.wordWrapOverride1=120]="wordWrapOverride1",H[H.wordWrapOverride2=121]="wordWrapOverride2",H[H.wrappingIndent=122]="wrappingIndent",H[H.wrappingStrategy=123]="wrappingStrategy",H[H.showDeprecated=124]="showDeprecated",H[H.inlayHints=125]="inlayHints",H[H.editorClassName=126]="editorClassName",H[H.pixelRatio=127]="pixelRatio",H[H.tabFocusMode=128]="tabFocusMode",H[H.layoutInfo=129]="layoutInfo",H[H.wrappingInfo=130]="wrappingInfo"})(Xe=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ve(new d(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(133,null)})),acceptSuggestionOnEnter:ve(new P(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(134,null),""],markdownDescription:g.localize(135,null)})),accessibilitySupport:ve(new v),accessibilityPageSize:ve(new u(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(136,null)})),ariaLabel:ve(new b(4,"ariaLabel",g.localize(137,null))),autoClosingBrackets:ve(new P(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(138,null),g.localize(139,null),""],description:g.localize(140,null)})),autoClosingDelete:ve(new P(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(141,null),""],description:g.localize(142,null)})),autoClosingOvertype:ve(new P(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(143,null),""],description:g.localize(144,null)})),autoClosingQuotes:ve(new P(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(145,null),g.localize(146,null),""],description:g.localize(147,null)})),autoIndent:ve(new a(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],f,{enumDescriptions:[g.localize(148,null),g.localize(149,null),g.localize(150,null),g.localize(151,null),g.localize(152,null)],description:g.localize(153,null)})),automaticLayout:ve(new d(10,"automaticLayout",!1)),autoSurround:ve(new P(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(154,null),g.localize(155,null),g.localize(156,null),""],description:g.localize(157,null)})),stickyTabStops:ve(new d(103,"stickyTabStops",!1,{description:g.localize(158,null)})),codeLens:ve(new d(12,"codeLens",!0,{description:g.localize(159,null)})),codeLensFontFamily:ve(new b(13,"codeLensFontFamily","",{description:g.localize(160,null)})),codeLensFontSize:ve(new u(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(161,null)})),colorDecorators:ve(new d(15,"colorDecorators",!0,{description:g.localize(162,null)})),columnSelection:ve(new d(16,"columnSelection",!1,{description:g.localize(163,null)})),comments:ve(new t),contextmenu:ve(new d(18,"contextmenu",!0)),copyWithSyntaxHighlighting:ve(new d(19,"copyWithSyntaxHighlighting",!0,{description:g.localize(164,null)})),cursorBlinking:ve(new a(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:g.localize(165,null)})),cursorSmoothCaretAnimation:ve(new d(21,"cursorSmoothCaretAnimation",!1,{description:g.localize(166,null)})),cursorStyle:ve(new a(22,"cursorStyle",i.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],h,{description:g.localize(167,null)})),cursorSurroundingLines:ve(new u(23,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(168,null)})),cursorSurroundingLinesStyle:ve(new P(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(169,null),g.localize(170,null)],description:g.localize(171,null)})),cursorWidth:ve(new u(25,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(172,null)})),disableLayerHinting:ve(new d(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:ve(new d(27,"disableMonospaceOptimizations",!1)),domReadOnly:ve(new d(28,"domReadOnly",!1)),dragAndDrop:ve(new d(29,"dragAndDrop",!0,{description:g.localize(173,null)})),emptySelectionClipboard:ve(new D),extraEditorClassName:ve(new b(31,"extraEditorClassName","")),fastScrollSensitivity:ve(new m(32,"fastScrollSensitivity",5,H=>H<=0?5:H,{markdownDescription:g.localize(174,null)})),find:ve(new T),fixedOverflowWidgets:ve(new d(34,"fixedOverflowWidgets",!1)),folding:ve(new d(35,"folding",!0,{description:g.localize(175,null)})),foldingStrategy:ve(new P(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(176,null),g.localize(177,null)],description:g.localize(178,null)})),foldingHighlight:ve(new d(37,"foldingHighlight",!0,{description:g.localize(179,null)})),foldingImportsByDefault:ve(new d(38,"foldingImportsByDefault",!1,{description:g.localize(180,null)})),unfoldOnClickAfterEndOfLine:ve(new d(39,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(181,null)})),fontFamily:ve(new b(40,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(182,null)})),fontInfo:ve(new A),fontLigatures2:ve(new o),fontSize:ve(new L),fontWeight:ve(new $),formatOnPaste:ve(new d(45,"formatOnPaste",!1,{description:g.localize(183,null)})),formatOnType:ve(new d(46,"formatOnType",!1,{description:g.localize(184,null)})),glyphMargin:ve(new d(47,"glyphMargin",!0,{description:g.localize(185,null)})),gotoLocation:ve(new oe),hideCursorInOverviewRuler:ve(new d(49,"hideCursorInOverviewRuler",!1,{description:g.localize(186,null)})),highlightActiveIndentGuide:ve(new d(50,"highlightActiveIndentGuide",!0,{description:g.localize(187,null)})),hover:ve(new he),inDiffEditor:ve(new d(52,"inDiffEditor",!1)),letterSpacing:ve(new m(54,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,H=>m.clamp(H,-5,20),{description:g.localize(188,null)})),lightbulb:ve(new V),lineDecorationsWidth:ve(new I(56,"lineDecorationsWidth",10)),lineHeight:ve(new G),lineNumbers:ve(new Re),lineNumbersMinChars:ve(new u(59,"lineNumbersMinChars",5,1,300)),linkedEditing:ve(new d(60,"linkedEditing",!1,{description:g.localize(189,null)})),links:ve(new d(61,"links",!0,{description:g.localize(190,null)})),matchBrackets:ve(new P(62,"matchBrackets","always",["always","near","never"],{description:g.localize(191,null)})),minimap:ve(new x),mouseStyle:ve(new P(64,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ve(new m(65,"mouseWheelScrollSensitivity",1,H=>H===0?1:H,{markdownDescription:g.localize(192,null)})),mouseWheelZoom:ve(new d(66,"mouseWheelZoom",!1,{markdownDescription:g.localize(193,null)})),multiCursorMergeOverlapping:ve(new d(67,"multiCursorMergeOverlapping",!0,{description:g.localize(194,null)})),multiCursorModifier:ve(new a(68,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],j,{markdownEnumDescriptions:[g.localize(195,null),g.localize(196,null)],markdownDescription:g.localize(197,null)})),multiCursorPaste:ve(new P(69,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(198,null),g.localize(199,null)],markdownDescription:g.localize(200,null)})),occurrencesHighlight:ve(new d(70,"occurrencesHighlight",!0,{description:g.localize(201,null)})),overviewRulerBorder:ve(new d(71,"overviewRulerBorder",!0,{description:g.localize(202,null)})),overviewRulerLanes:ve(new u(72,"overviewRulerLanes",3,0,3)),padding:ve(new de),parameterHints:ve(new B),peekWidgetDefaultFocus:ve(new P(75,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(203,null),g.localize(204,null)],description:g.localize(205,null)})),definitionLinkOpensInPeek:ve(new d(76,"definitionLinkOpensInPeek",!1,{description:g.localize(206,null)})),quickSuggestions:ve(new ue),quickSuggestionsDelay:ve(new u(78,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(207,null)})),readOnly:ve(new d(79,"readOnly",!1)),renameOnType:ve(new d(80,"renameOnType",!1,{description:g.localize(208,null),markdownDeprecationMessage:g.localize(209,null)})),renderControlCharacters:ve(new d(81,"renderControlCharacters",!1,{description:g.localize(210,null)})),renderIndentGuides:ve(new d(82,"renderIndentGuides",!0,{description:g.localize(211,null)})),renderFinalNewline:ve(new d(83,"renderFinalNewline",!0,{description:g.localize(212,null)})),renderLineHighlight:ve(new P(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(213,null)],description:g.localize(214,null)})),renderLineHighlightOnlyWhenFocus:ve(new d(85,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(215,null)})),renderValidationDecorations:ve(new P(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ve(new P(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(216,null),g.localize(217,null),g.localize(218,null),""],description:g.localize(219,null)})),revealHorizontalRightPadding:ve(new u(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ve(new d(89,"roundedSelection",!0,{description:g.localize(220,null)})),rulers:ve(new $e),scrollbar:ve(new Ve),scrollBeyondLastColumn:ve(new u(92,"scrollBeyondLastColumn",5,0,1073741824,{description:g.localize(221,null)})),scrollBeyondLastLine:ve(new d(93,"scrollBeyondLastLine",!0,{description:g.localize(222,null)})),scrollPredominantAxis:ve(new d(94,"scrollPredominantAxis",!0,{description:g.localize(223,null)})),selectionClipboard:ve(new d(95,"selectionClipboard",!0,{description:g.localize(224,null),included:F.isLinux})),selectionHighlight:ve(new d(96,"selectionHighlight",!0,{description:g.localize(225,null)})),selectOnLineNumbers:ve(new d(97,"selectOnLineNumbers",!0)),showFoldingControls:ve(new P(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[g.localize(226,null),g.localize(227,null)],description:g.localize(228,null)})),showUnused:ve(new d(99,"showUnused",!0,{description:g.localize(229,null)})),showDeprecated:ve(new d(124,"showDeprecated",!0,{description:g.localize(230,null)})),inlayHints:ve(new R),snippetSuggestions:ve(new P(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(231,null),g.localize(232,null),g.localize(233,null),g.localize(234,null)],description:g.localize(235,null)})),smartSelect:ve(new K),smoothScrolling:ve(new d(102,"smoothScrolling",!1,{description:g.localize(236,null)})),stopRenderingLineAfter:ve(new u(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ve(new O),inlineSuggest:ve(new je),suggestFontSize:ve(new u(106,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(237,null)})),suggestLineHeight:ve(new u(107,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(238,null)})),suggestOnTriggerCharacters:ve(new d(108,"suggestOnTriggerCharacters",!0,{description:g.localize(239,null)})),suggestSelection:ve(new P(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(240,null),g.localize(241,null),g.localize(242,null)],description:g.localize(243,null)})),tabCompletion:ve(new P(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(244,null),g.localize(245,null),g.localize(246,null)],description:g.localize(247,null)})),tabIndex:ve(new u(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ve(new P(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(248,null),g.localize(249,null),g.localize(250,null)],description:g.localize(251,null)})),useShadowDOM:ve(new d(113,"useShadowDOM",!0)),useTabStops:ve(new d(114,"useTabStops",!0,{description:g.localize(252,null)})),wordSeparators:ve(new b(115,"wordSeparators",S.USUAL_WORD_SEPARATORS,{description:g.localize(253,null)})),wordWrap:ve(new P(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(254,null),g.localize(255,null),g.localize(256,null),g.localize(257,null)],description:g.localize(258,null)})),wordWrapBreakAfterCharacters:ve(new b(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ve(new b(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ve(new u(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(259,null)})),wordWrapOverride1:ve(new P(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ve(new P(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ve(new a(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],q,{enumDescriptions:[g.localize(260,null),g.localize(261,null),g.localize(262,null),g.localize(263,null)],description:g.localize(264,null)})),wrappingStrategy:ve(new P(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[g.localize(265,null),g.localize(266,null)],description:g.localize(267,null)})),editorClassName:ve(new p),pixelRatio:ve(new ne),tabFocusMode:ve(new X),layoutInfo:ve(new z),wrappingInfo:ve(new ie)}}),define(be[128],Ee([18,19]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[129],Ee([18,19]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[130],Ee([18,19]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(be[131],Ee([18,19]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(be[132],Ee([18,19]),function(ee,e){return ee.create("vs/platform/theme/common/iconRegistry",e)}),define(be[133],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[134],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[135],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(be[136],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[137],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[138],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[139],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[140],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(be[141],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/common/views",e)}),define(be[142],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[143],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[144],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[145],Ee([18,19]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[146],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var g;(function(C){C[C.ACTIVATE=1]="ACTIVATE",C[C.RESTORE=2]="RESTORE",C[C.PRESERVE=3]="PRESERVE"})(g=e.EditorActivation||(e.EditorActivation={}));var F;(function(C){C[C.PICK=0]="PICK",C[C.DISABLED=1]="DISABLED",C[C.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(F=e.EditorResolution||(e.EditorResolution={}));var S;(function(C){C[C.API=0]="API",C[C.USER=1]="USER"})(S=e.EditorOpenContext||(e.EditorOpenContext={}));var E;(function(C){C[C.Center=0]="Center",C[C.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",C[C.NearTop=2]="NearTop",C[C.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(E=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[147],Ee([0,1,129]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const F=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function E(l){return l=l.trim(),l==="*"||F.test(l)}e.isValidVersionStr=E;function C(l){if(!E(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let d=l.match(F);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=C;function y(l){if(!l)return null;let d=l.majorBase,u=l.majorMustEqual,m=l.minorBase,b=l.minorMustEqual,w=l.patchBase,P=l.patchMustEqual;l.hasCaret&&(d===0||(b=!1),P=!1);let a=0;if(l.preRelease){const f=S.exec(l.preRelease);if(f){const[,v,t,r]=f;a=Date.UTC(Number(v),Number(t)-1,Number(r))}}return{majorBase:d,majorMustEqual:u,minorBase:m,minorMustEqual:b,patchBase:w,patchMustEqual:P,isMinimum:l.hasGreaterEquals,notBefore:a}}e.normalizeVersion=y;function _(l,d,u){let m;typeof l=="string"?m=y(C(l)):m=l;let b;d instanceof Date?b=d.getTime():typeof d=="string"&&(b=new Date(d).getTime());let w;if(typeof u=="string"?w=y(C(u)):w=u,!m||!w)return!1;let P=m.majorBase,a=m.minorBase,f=m.patchBase,v=w.majorBase,t=w.minorBase,r=w.patchBase,s=w.notBefore,i=w.majorMustEqual,c=w.minorMustEqual,h=w.patchMustEqual;return w.isMinimum?P>v?!0:P<v?!1:a>t?!0:a<t||b&&b<s?!1:f>=r:(P===1&&v===0&&(!i||!c||!h)&&(v=1,t=0,r=0,i=!0,c=!1,h=!1),P<v?!1:P>v?!i:a<t?!1:a>t?!c:f<r?!1:f>r?!h:!(b&&b<s))}e.isValidVersion=_;function k(l,d,u,m){return u.isBuiltin||typeof u.main=="undefined"?!0:I(l,d,u.engines.vscode,m)}e.isValidExtensionVersion=k;function n(l,d,u){return l==="*"||I(d,u,l)}e.isEngineValid=n;function I(l,d,u,m=[]){let b=y(C(u));if(!b)return m.push(g.localize(0,null,u)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return m.push(g.localize(1,null,u)),!1}else if(!b.majorMustEqual)return m.push(g.localize(2,null,u)),!1;return _(l,d,b)?!0:(m.push(g.localize(3,null,l,u)),!1)}}),define(be[91],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class g{constructor(S,E=[],C=!1){this.ctor=S,this.staticArguments=E,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=g}),define(be[59],Ee([0,1,91]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const F=[];function S(C,y,_){y instanceof g.SyncDescriptor||(y=new g.SyncDescriptor(y,[],_)),F.push([C,y])}e.registerSingleton=S;function E(){return F}e.getSingletonServiceDescriptors=E}),define(be[148],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class g{constructor(E){this.incoming=new Map,this.outgoing=new Map,this.data=E}}e.Node=g;class F{constructor(E){this._hashFn=E,this._nodes=new Map}roots(){const E=[];for(let C of this._nodes.values())C.outgoing.size===0&&E.push(C);return E}insertEdge(E,C){const y=this.lookupOrInsertNode(E),_=this.lookupOrInsertNode(C);y.outgoing.set(this._hashFn(C),_),_.incoming.set(this._hashFn(E),y)}removeNode(E){const C=this._hashFn(E);this._nodes.delete(C);for(let y of this._nodes.values())y.outgoing.delete(C),y.incoming.delete(C)}lookupOrInsertNode(E){const C=this._hashFn(E);let y=this._nodes.get(C);return y||(y=new g(E),this._nodes.set(C,y)),y}lookup(E){return this._nodes.get(this._hashFn(E))}isEmpty(){return this._nodes.size===0}toString(){let E=[];for(let[C,y]of this._nodes)E.push(`${C}, (incoming)[${[...y.incoming.keys()].join(", ")}], (outgoing)[${[...y.outgoing.keys()].join(",")}]`);return E.join(`
`)}findCycleSlow(){for(let[E,C]of this._nodes){const y=new Set([E]),_=this._findCycle(C,y);if(_)return _}}_findCycle(E,C){for(let[y,_]of E.outgoing){if(C.has(y))return[...C,y].join(" -> ");C.add(y);const k=this._findCycle(_,C);if(k)return k;C.delete(y)}}}e.Graph=F}),define(be[4],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var g;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function _(k){return k[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=_})(g=e._util||(e._util={})),e.IInstantiationService=S("instantiationService");function F(y,_,k,n){_[g.DI_TARGET]===_?_[g.DI_DEPENDENCIES].push({id:y,index:k,optional:n}):(_[g.DI_DEPENDENCIES]=[{id:y,index:k,optional:n}],_[g.DI_TARGET]=_)}function S(y){if(g.serviceIds.has(y))return g.serviceIds.get(y);const _=function(k,n,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(_,k,I,!1)};return _.toString=()=>y,g.serviceIds.set(y,_),_}e.createDecorator=S;function E(y){return y}e.refineServiceDecorator=E;function C(y){return function(_,k,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");F(y,_,n,!0)}}e.optional=C}),define(be[149],Ee([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,g.createDecorator)("modelService");function F(S){return!S.isTooLargeForSyncing()&&!S.isForSimpleWidget}e.shouldSynchronizeModel=F}),define(be[150],Ee([0,1,3,42,6,21,81,57,149]),function(ee,e,g,F,S,E,C,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function k(l){return typeof l=="string"?!1:Array.isArray(l)?l.every(k):!!l.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new g.Emitter}get onDidChange(){return this._onDidChange.event}register(d,u){let m={selector:d,provider:u,_score:-1,_time:this._clock++};return this._entries.push(m),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,S.toDisposable)(()=>{if(m){let b=this._entries.indexOf(m);b>=0&&(this._entries.splice(b,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),m=void 0)}})}has(d){return this.all(d).length>0}all(d){if(!d)return[];this._updateScores(d);const u=[];for(let m of this._entries)m._score>0&&u.push(m.provider);return u}ordered(d){const u=[];return this._orderedForEach(d,m=>u.push(m.provider)),u}orderedGroups(d){const u=[];let m,b;return this._orderedForEach(d,w=>{m&&b===w._score?m.push(w.provider):(b=w._score,m=[w.provider],u.push(m))}),u}_orderedForEach(d,u){if(!!d){this._updateScores(d);for(const m of this._entries)m._score>0&&u(m)}}_updateScores(d){let u={uri:d.uri.toString(),language:d.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===u.language&&this._lastCandidate.uri===u.uri)){this._lastCandidate=u;for(let m of this._entries)if(m._score=(0,y.score)(m.selector,d.uri,d.getLanguageIdentifier().language,(0,_.shouldSynchronizeModel)(d)),k(m.selector)&&m._score>0){for(let b of this._entries)b._score=0;m._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(d,u){return d._score<u._score?1:d._score>u._score?-1:d._time<u._time?1:d._time>u._time?-1:0}}e.LanguageFeatureRegistry=n;class I{constructor(d,u,m=Number.MAX_SAFE_INTEGER){this._registry=d,this.min=u,this.max=m,this._cache=new E.LRUCache(50,.7)}_key(d){return d.id+(0,F.hash)(this._registry.all(d))}_clamp(d){return d===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(d*1.3)))}get(d){const u=this._key(d),m=this._cache.get(u);return this._clamp(m?.value)}update(d,u){const m=this._key(d);let b=this._cache.get(m);return b||(b=new C.MovingAverage,this._cache.set(m,b)),b.update(u),this.get(d)}}e.LanguageFeatureRequestDelays=I}),define(be[60],Ee([0,1,2,31,150,123,35]),function(ee,e,g,F,S,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var y;(function(o){o[o.Null=0]="Null",o[o.PlainText=1]="PlainText"})(y=e.LanguageId||(e.LanguageId={}));class _{constructor(A,L){this.language=A,this.id=L}}e.LanguageIdentifier=_;var k;(function(o){o[o.NotSet=-1]="NotSet",o[o.None=0]="None",o[o.Italic=1]="Italic",o[o.Bold=2]="Bold",o[o.Underline=4]="Underline"})(k=e.FontStyle||(e.FontStyle={}));var n;(function(o){o[o.None=0]="None",o[o.DefaultForeground=1]="DefaultForeground",o[o.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var I;(function(o){o[o.Other=0]="Other",o[o.Comment=1]="Comment",o[o.String=2]="String",o[o.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var l;(function(o){o[o.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",o[o.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",o[o.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",o[o.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",o[o.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",o[o.ITALIC_MASK=2048]="ITALIC_MASK",o[o.BOLD_MASK=4096]="BOLD_MASK",o[o.UNDERLINE_MASK=8192]="UNDERLINE_MASK",o[o.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",o[o.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",o[o.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",o[o.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",o[o.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",o[o.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",o[o.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",o[o.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",o[o.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",o[o.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(l=e.MetadataConsts||(e.MetadataConsts={}));class d{static getLanguageId(A){return(A&255)>>>0}static getTokenType(A){return(A&1792)>>>8}static getFontStyle(A){return(A&14336)>>>11}static getForeground(A){return(A&8372224)>>>14}static getBackground(A){return(A&4286578688)>>>23}static getClassNameFromMetadata(A){let L=this.getForeground(A),$="mtk"+L,oe=this.getFontStyle(A);return oe&1&&($+=" mtki"),oe&2&&($+=" mtkb"),oe&4&&($+=" mtku"),$}static getInlineStyleFromMetadata(A,L){const $=this.getForeground(A),oe=this.getFontStyle(A);let he=`color: ${L[$]};`;return oe&1&&(he+="font-style: italic;"),oe&2&&(he+="font-weight: bold;"),oe&4&&(he+="text-decoration: underline;"),he}}e.TokenMetadata=d;var u;(function(o){o[o.Method=0]="Method",o[o.Function=1]="Function",o[o.Constructor=2]="Constructor",o[o.Field=3]="Field",o[o.Variable=4]="Variable",o[o.Class=5]="Class",o[o.Struct=6]="Struct",o[o.Interface=7]="Interface",o[o.Module=8]="Module",o[o.Property=9]="Property",o[o.Event=10]="Event",o[o.Operator=11]="Operator",o[o.Unit=12]="Unit",o[o.Value=13]="Value",o[o.Constant=14]="Constant",o[o.Enum=15]="Enum",o[o.EnumMember=16]="EnumMember",o[o.Keyword=17]="Keyword",o[o.Text=18]="Text",o[o.Color=19]="Color",o[o.File=20]="File",o[o.Reference=21]="Reference",o[o.Customcolor=22]="Customcolor",o[o.Folder=23]="Folder",o[o.TypeParameter=24]="TypeParameter",o[o.User=25]="User",o[o.Issue=26]="Issue",o[o.Snippet=27]="Snippet"})(u=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let o=Object.create(null);return o[0]="symbol-method",o[1]="symbol-function",o[2]="symbol-constructor",o[3]="symbol-field",o[4]="symbol-variable",o[5]="symbol-class",o[6]="symbol-struct",o[7]="symbol-interface",o[8]="symbol-module",o[9]="symbol-property",o[10]="symbol-event",o[11]="symbol-operator",o[12]="symbol-unit",o[13]="symbol-value",o[14]="symbol-constant",o[15]="symbol-enum",o[16]="symbol-enum-member",o[17]="symbol-keyword",o[27]="symbol-snippet",o[18]="symbol-text",o[19]="symbol-color",o[20]="symbol-file",o[21]="symbol-reference",o[22]="symbol-customcolor",o[23]="symbol-folder",o[24]="symbol-type-parameter",o[25]="account",o[26]="issues",function(A){const L=o[A];let $=L&&C.iconRegistry.get(L);return $||(console.info("No codicon found for CompletionItemKind "+A),$=C.Codicon.symbolProperty),$.classNames}}(),e.completionKindFromString=function(){let o=Object.create(null);return o.method=0,o.function=1,o.constructor=2,o.field=3,o.variable=4,o.class=5,o.struct=6,o.interface=7,o.module=8,o.property=9,o.event=10,o.operator=11,o.unit=12,o.value=13,o.constant=14,o.enum=15,o["enum-member"]=16,o.enumMember=16,o.keyword=17,o.snippet=27,o.text=18,o.color=19,o.file=20,o.reference=21,o.customcolor=22,o.folder=23,o["type-parameter"]=24,o.typeParameter=24,o.account=25,o.issue=26,function(A,L){let $=o[A];return typeof $=="undefined"&&!L&&($=9),$}}();var m;(function(o){o[o.Deprecated=1]="Deprecated"})(m=e.CompletionItemTag||(e.CompletionItemTag={}));var b;(function(o){o[o.KeepWhitespace=1]="KeepWhitespace",o[o.InsertAsSnippet=4]="InsertAsSnippet"})(b=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(o){o[o.Invoke=0]="Invoke",o[o.TriggerCharacter=1]="TriggerCharacter",o[o.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var P;(function(o){o[o.Automatic=0]="Automatic",o[o.Explicit=1]="Explicit"})(P=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var a;(function(o){o[o.Invoke=1]="Invoke",o[o.Auto=2]="Auto"})(a=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var f;(function(o){o[o.Invoke=1]="Invoke",o[o.TriggerCharacter=2]="TriggerCharacter",o[o.ContentChange=3]="ContentChange"})(f=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var v;(function(o){o[o.Text=0]="Text",o[o.Read=1]="Read",o[o.Write=2]="Write"})(v=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(o){return o&&g.URI.isUri(o.uri)&&F.Range.isIRange(o.range)&&(F.Range.isIRange(o.originSelectionRange)||F.Range.isIRange(o.targetSelectionRange))}e.isLocationLink=t;var r;(function(o){o[o.File=0]="File",o[o.Module=1]="Module",o[o.Namespace=2]="Namespace",o[o.Package=3]="Package",o[o.Class=4]="Class",o[o.Method=5]="Method",o[o.Property=6]="Property",o[o.Field=7]="Field",o[o.Constructor=8]="Constructor",o[o.Enum=9]="Enum",o[o.Interface=10]="Interface",o[o.Function=11]="Function",o[o.Variable=12]="Variable",o[o.Constant=13]="Constant",o[o.String=14]="String",o[o.Number=15]="Number",o[o.Boolean=16]="Boolean",o[o.Array=17]="Array",o[o.Object=18]="Object",o[o.Key=19]="Key",o[o.Null=20]="Null",o[o.EnumMember=21]="EnumMember",o[o.Struct=22]="Struct",o[o.Event=23]="Event",o[o.Operator=24]="Operator",o[o.TypeParameter=25]="TypeParameter"})(r=e.SymbolKind||(e.SymbolKind={}));var s;(function(o){o[o.Deprecated=1]="Deprecated"})(s=e.SymbolTag||(e.SymbolTag={}));var i;(function(o){const A=new Map;A.set("file",0),A.set("module",1),A.set("namespace",2),A.set("package",3),A.set("class",4),A.set("method",5),A.set("property",6),A.set("field",7),A.set("constructor",8),A.set("enum",9),A.set("interface",10),A.set("function",11),A.set("variable",12),A.set("constant",13),A.set("string",14),A.set("number",15),A.set("boolean",16),A.set("array",17),A.set("object",18),A.set("key",19),A.set("null",20),A.set("enum-member",21),A.set("struct",22),A.set("event",23),A.set("operator",24),A.set("type-parameter",25);const L=new Map;L.set(0,"file"),L.set(1,"module"),L.set(2,"namespace"),L.set(3,"package"),L.set(4,"class"),L.set(5,"method"),L.set(6,"property"),L.set(7,"field"),L.set(8,"constructor"),L.set(9,"enum"),L.set(10,"interface"),L.set(11,"function"),L.set(12,"variable"),L.set(13,"constant"),L.set(14,"string"),L.set(15,"number"),L.set(16,"boolean"),L.set(17,"array"),L.set(18,"object"),L.set(19,"key"),L.set(20,"null"),L.set(21,"enum-member"),L.set(22,"struct"),L.set(23,"event"),L.set(24,"operator"),L.set(25,"type-parameter");function $(Q){return A.get(Q)}o.fromString=$;function oe(Q){return L.get(Q)}o.toString=oe;function he(Q,z){const V=L.get(Q);let R=V&&C.iconRegistry.get("symbol-"+V);return R||(console.info("No codicon found for SymbolKind "+Q),R=C.Codicon.symbolProperty),`${z?"inline":"block"} ${R.classNames}`}o.toCssClassName=he})(i=e.SymbolKinds||(e.SymbolKinds={}));class c{constructor(A){this.value=A}}e.FoldingRangeKind=c,c.Comment=new c("comment"),c.Imports=new c("imports"),c.Region=new c("region");var h;(function(o){o[o.Collapsed=0]="Collapsed",o[o.Expanded=1]="Expanded"})(h=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var p;(function(o){o[o.Editing=0]="Editing",o[o.Preview=1]="Preview"})(p=e.CommentMode||(e.CommentMode={}));var D;(function(o){o[o.Other=0]="Other",o[o.Type=1]="Type",o[o.Parameter=2]="Parameter"})(D=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new S.LanguageFeatureRegistry,e.RenameProviderRegistry=new S.LanguageFeatureRegistry,e.CompletionProviderRegistry=new S.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new S.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new S.LanguageFeatureRegistry,e.HoverProviderRegistry=new S.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new S.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new S.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new S.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new S.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new S.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new S.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new S.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new S.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new S.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.LinkProviderRegistry=new S.LanguageFeatureRegistry,e.ColorProviderRegistry=new S.LanguageFeatureRegistry,e.SelectionRangeRegistry=new S.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new S.LanguageFeatureRegistry,e.TokenizationRegistry=new E.TokenizationRegistryImpl;var T;(function(o){o[o.None=0]="None",o[o.Option=1]="Option",o[o.Default=2]="Default",o[o.Preferred=3]="Preferred"})(T=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[45],Ee([0,1,8,4,22]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let E=S.userAgent||"";const C=new Map;C.set("false",!1),C.set("true",!0),C.set("isMac",S.isMacintosh),C.set("isLinux",S.isLinux),C.set("isWindows",S.isWindows),C.set("isWeb",S.isWeb),C.set("isMacNative",S.isMacintosh&&!S.isWeb),C.set("isEdge",E.indexOf("Edg/")>=0),C.set("isFirefox",E.indexOf("Firefox")>=0),C.set("isChrome",E.indexOf("Chrome")>=0),C.set("isSafari",E.indexOf("Safari")>=0);const y=Object.prototype.hasOwnProperty;var _;(function(T){T[T.False=0]="False",T[T.True=1]="True",T[T.Defined=2]="Defined",T[T.Not=3]="Not",T[T.Equals=4]="Equals",T[T.NotEquals=5]="NotEquals",T[T.And=6]="And",T[T.Regex=7]="Regex",T[T.NotRegex=8]="NotRegex",T[T.Or=9]="Or",T[T.In=10]="In",T[T.NotIn=11]="NotIn",T[T.Greater=12]="Greater",T[T.GreaterEquals=13]="GreaterEquals",T[T.Smaller=14]="Smaller",T[T.SmallerEquals=15]="SmallerEquals"})(_=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return I.INSTANCE}static true(){return l.INSTANCE}static has(o){return d.create(o)}static equals(o,A){return u.create(o,A)}static notEquals(o,A){return w.create(o,A)}static regex(o,A){return r.create(o,A)}static in(o,A){return m.create(o,A)}static not(o){return P.create(o)}static and(...o){return i.create(o)}static or(...o){return c.create(o)}static greater(o,A){return a.create(o,A)}static less(o,A){return v.create(o,A)}static deserialize(o,A=!1){if(!!o)return this._deserializeOrExpression(o,A)}static _deserializeOrExpression(o,A){let L=o.split("||");return c.create(L.map($=>this._deserializeAndExpression($,A)))}static _deserializeAndExpression(o,A){let L=o.split("&&");return i.create(L.map($=>this._deserializeOne($,A)))}static _deserializeOne(o,A){if(o=o.trim(),o.indexOf("!=")>=0){let L=o.split("!=");return w.create(L[0].trim(),this._deserializeValue(L[1],A))}if(o.indexOf("==")>=0){let L=o.split("==");return u.create(L[0].trim(),this._deserializeValue(L[1],A))}if(o.indexOf("=~")>=0){let L=o.split("=~");return r.create(L[0].trim(),this._deserializeRegexValue(L[1],A))}if(o.indexOf(" in ")>=0){let L=o.split(" in ");return m.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(o)){const L=o.split(">=");return f.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(o)){const L=o.split(">");return a.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(o)){const L=o.split("<=");return t.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(o)){const L=o.split("<");return v.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(o)?P.create(o.substr(1).trim()):d.create(o)}static _deserializeValue(o,A){if(o=o.trim(),o==="true")return!0;if(o==="false")return!1;let L=/^'([^']*)'$/.exec(o);return L?L[1].trim():o}static _deserializeRegexValue(o,A){if((0,g.isFalsyOrWhitespace)(o)){if(A)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let L=o.indexOf("/"),$=o.lastIndexOf("/");if(L===$||L<0){if(A)throw new Error(`bad regexp-value '${o}', missing /-enclosure`);return console.warn(`bad regexp-value '${o}', missing /-enclosure`),null}let oe=o.slice(L+1,$),he=o[$+1]==="i"?"i":"";try{return new RegExp(oe,he)}catch(Q){if(A)throw new Error(`bad regexp-value '${o}', parse error: ${Q}`);return console.warn(`bad regexp-value '${o}', parse error: ${Q}`),null}}}e.ContextKeyExpr=k;function n(T,o){return T.cmp(o)}class I{constructor(){this.type=0}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!1}serialize(){return"false"}keys(){return[]}map(o){return this}negate(){return l.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class l{constructor(){this.type=1}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!0}serialize(){return"true"}keys(){return[]}map(o){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=l,l.INSTANCE=new l;class d{constructor(o){this.key=o,this.type=2}static create(o){const A=C.get(o);return typeof A=="boolean"?A?l.INSTANCE:I.INSTANCE:new d(o)}cmp(o){return o.type!==this.type?this.type-o.type:p(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!!o.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(o){return o.mapDefined(this.key)}negate(){return P.create(this.key)}}e.ContextKeyDefinedExpr=d;class u{constructor(o,A){this.key=o,this.value=A,this.type=4}static create(o,A){if(typeof A=="boolean")return A?d.create(o):P.create(o);const L=C.get(o);return typeof L=="boolean"?A===(L?"true":"false")?l.INSTANCE:I.INSTANCE:new u(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:D(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(o){return o.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=u;class m{constructor(o,A){this.key=o,this.valueKey=A,this.type=10}static create(o,A){return new m(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:D(this.key,this.valueKey,o.key,o.valueKey)}equals(o){return o.type===this.type?this.key===o.key&&this.valueKey===o.valueKey:!1}evaluate(o){const A=o.getValue(this.valueKey),L=o.getValue(this.key);return Array.isArray(A)?A.indexOf(L)>=0:typeof L=="string"&&typeof A=="object"&&A!==null?y.call(A,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(o){return o.mapIn(this.key,this.valueKey)}negate(){return b.create(this)}}e.ContextKeyInExpr=m;class b{constructor(o){this._actual=o,this.type=11}static create(o){return new b(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new b(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotInExpr=b;class w{constructor(o,A){this.key=o,this.value=A,this.type=5}static create(o,A){if(typeof A=="boolean")return A?P.create(o):d.create(o);const L=C.get(o);return typeof L=="boolean"?A===(L?"true":"false")?I.INSTANCE:l.INSTANCE:new w(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:D(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(o){return o.mapNotEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class P{constructor(o){this.key=o,this.type=3}static create(o){const A=C.get(o);return typeof A=="boolean"?A?I.INSTANCE:l.INSTANCE:new P(o)}cmp(o){return o.type!==this.type?this.type-o.type:p(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!o.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(o){return o.mapNot(this.key)}negate(){return d.create(this.key)}}e.ContextKeyNotExpr=P;class a{constructor(o,A){this.key=o,this.value=A,this.type=12}static create(o,A){return new a(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:D(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=a;class f{constructor(o,A){this.key=o,this.value=A,this.type=13}static create(o,A){return new f(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:D(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreaterEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=f;class v{constructor(o,A){this.key=o,this.value=A,this.type=14}static create(o,A){return new v(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:D(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmaller(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeySmallerExpr=v;class t{constructor(o,A){this.key=o,this.value=A,this.type=15}static create(o,A){return new t(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:D(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmallerEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(o,A){this.key=o,this.regexp=A,this.type=7}static create(o,A){return new r(o,A)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.key<o.key)return-1;if(this.key>o.key)return 1;const A=this.regexp?this.regexp.source:"",L=o.regexp?o.regexp.source:"";return A<L?-1:A>L?1:0}equals(o){if(o.type===this.type){const A=this.regexp?this.regexp.source:"",L=o.regexp?o.regexp.source:"";return this.key===o.key&&A===L}return!1}evaluate(o){let A=o.getValue(this.key);return this.regexp?this.regexp.test(A):!1}serialize(){const o=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${o}`}keys(){return[this.key]}map(o){return o.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=r;class s{constructor(o){this._actual=o,this.type=8}static create(o){return new s(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new s(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class i{constructor(o){this.expr=o,this.type=6}static create(o){return i._normalizeArr(o)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let A=0,L=this.expr.length;A<L;A++){const $=n(this.expr[A],o.expr[A]);if($!==0)return $}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let A=0,L=this.expr.length;A<L;A++)if(!this.expr[A].equals(o.expr[A]))return!1;return!0}return!1}evaluate(o){for(let A=0,L=this.expr.length;A<L;A++)if(!this.expr[A].evaluate(o))return!1;return!0}static _normalizeArr(o){const A=[];let L=!1;for(const $ of o)if(!!$){if($.type===1){L=!0;continue}if($.type===0)return I.INSTANCE;if($.type===6){A.push(...$.expr);continue}A.push($)}if(A.length===0&&L)return l.INSTANCE;if(A.length!==0){if(A.length===1)return A[0];for(A.sort(n);A.length>1;){const $=A[A.length-1];if($.type!==9)break;A.pop();const oe=A.pop(),he=c.create($.expr.map(Q=>i.create([Q,oe])));he&&(A.push(he),A.sort(n))}return A.length===1?A[0]:new i(A)}}serialize(){return this.expr.map(o=>o.serialize()).join(" && ")}keys(){const o=[];for(let A of this.expr)o.push(...A.keys());return o}map(o){return new i(this.expr.map(A=>A.map(o)))}negate(){let o=[];for(let A of this.expr)o.push(A.negate());return c.create(o)}}e.ContextKeyAndExpr=i;class c{constructor(o){this.expr=o,this.type=9}static create(o){const A=c._normalizeArr(o);if(A.length!==0)return A.length===1?A[0]:new c(A)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let A=0,L=this.expr.length;A<L;A++){const $=n(this.expr[A],o.expr[A]);if($!==0)return $}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let A=0,L=this.expr.length;A<L;A++)if(!this.expr[A].equals(o.expr[A]))return!1;return!0}return!1}evaluate(o){for(let A=0,L=this.expr.length;A<L;A++)if(this.expr[A].evaluate(o))return!0;return!1}static _normalizeArr(o){let A=[],L=!1;if(o){for(let $=0,oe=o.length;$<oe;$++){const he=o[$];if(!!he){if(he.type===0){L=!0;continue}if(he.type===1)return[l.INSTANCE];if(he.type===9){A=A.concat(he.expr);continue}A.push(he)}}if(A.length===0&&L)return[I.INSTANCE];A.sort(n)}return A}serialize(){return this.expr.map(o=>o.serialize()).join(" || ")}keys(){const o=[];for(let A of this.expr)o.push(...A.keys());return o}map(o){return new c(this.expr.map(A=>A.map(o)))}negate(){let o=[];for(let L of this.expr)o.push(L.negate());const A=L=>L.type===9?L.expr:[L];for(;o.length>1;){const L=o.shift(),$=o.shift(),oe=[];for(const he of A(L))for(const Q of A($))oe.push(k.and(he,Q));o.unshift(k.or(...oe))}return o[0]}}e.ContextKeyOrExpr=c;class h extends d{constructor(o,A,L){super(o);this._defaultValue=A,typeof L=="object"?h._info.push({...L,key:o}):L!==!0&&h._info.push({key:o,description:L,type:A!=null?typeof A:void 0})}static all(){return h._info.values()}bindTo(o){return o.createKey(this.key,this._defaultValue)}getValue(o){return o.getContextKeyValue(this.key)}toNegated(){return k.not(this.key)}isEqualTo(o){return k.equals(this.key,o)}notEqualsTo(o){return k.notEquals(this.key,o)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,F.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(T,o){return T<o?-1:T>o?1:0}function D(T,o,A,L){return T<A?-1:T>A?1:o<L?-1:o>L?1:0}}),define(be[151],Ee([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,g.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,g.refineServiceDecorator)(e.IEnvironmentService)}),define(be[26],Ee([0,1,8,4]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function S(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=S;function E(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=E,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(C=e.ExtensionType||(e.ExtensionType={}));class y{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,l){if(typeof I=="undefined"||I===null)return typeof l=="undefined"||l===null;if(typeof l=="undefined"||l===null)return!1;if(typeof I=="string"||typeof l=="string"){let d=typeof I=="string"?I:I.value,u=typeof l=="string"?l:l.value;return g.equalsIgnoreCase(d,u)}return I._lower===l._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=y;function _(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=_;function k(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=k,e.IBuiltinExtensionsScannerService=(0,F.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[152],Ee([0,1,8,26]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function S(u,m){return u.uuid&&m.uuid?u.uuid===m.uuid:u.id===m.id?!0:(0,g.compareIgnoreCase)(u.id,m.id)===0}e.areSameExtensions=S;class E{constructor(m,b){this.version=b,this.id=m.id,this.uuid=m.uuid}key(){return`${this.id}-${this.version}`}equals(m){return m instanceof E?S(this,m)&&this.version===m.version:!1}}e.ExtensionIdentifierWithVersion=E;function C(u,m){return`${u}.${m}`}e.getExtensionId=C;function y(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=y;function _(u,m){return y(C(u,m))}e.getGalleryExtensionId=_;function k(u,m){const b=[],w=P=>{for(const a of b)if(a.some(f=>S(m(f),m(P))))return a;return null};for(const P of u){const a=w(P);a?a.push(P):b.push([P])}return b}e.groupByExtension=k;function n(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function I(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new F.ExtensionIdentifier("pprice.better-merge");function l(u){const m=new Set;for(const b of u)b.malicious&&m.add(b.id.id);return m}e.getMaliciousExtensionsSet=l;function d(u,m){const b=[],w=m.manifest.extensionDependencies?.slice(0)??[];for(;w.length;){const P=w.shift();if(P&&b.every(a=>!S(a.identifier,{id:P}))){const a=u.filter(f=>S(f.identifier,{id:P}));a.length===1&&(b.push(a[0]),w.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}e.getExtensionDependencies=d}),define(be[61],Ee([0,1,130,14,2,4,8,10,21]),function(ee,e,g,F,S,E,C,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function k(z){return z.create===!0}e.isFileOpenForWriteOptions=k;var n;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var I;(function(z){z[z.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var l;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock"})(l=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=d;function u(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=u;function m(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function b(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=b;var w;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class P extends Error{constructor(V,R){super(V);this.code=R}}e.FileSystemProviderError=P;function a(z,V){const R=new P(z.toString(),V);return v(R,V),R}e.createFileSystemProviderError=a;function f(z){return z||a((0,g.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=f;function v(z,V){return z.name=V?`${V} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=v;function t(z){if(!z)return w.Unknown;if(z instanceof P)return z.code;const V=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!V)return w.Unknown;switch(V[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=t;function r(z){if(z instanceof D)return z.fileOperationResult;switch(t(z)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class i{constructor(V,R,G){this.resource=V,this.operation=R,this.target=G}isOperation(V){return this.operation===V}}e.FileOperationEvent=i;var c;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class h{constructor(V,R){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const G of V)switch(G.type){case 1:this.added||(this.added=_.TernarySearchTree.forUris(()=>R)),this.added.set(G.resource,G);break;case 0:this.updated||(this.updated=_.TernarySearchTree.forUris(()=>R)),this.updated.set(G.resource,G);break;case 2:this.deleted||(this.deleted=_.TernarySearchTree.forUris(()=>R)),this.deleted.set(G.resource,G);break}}contains(V,...R){return this.doContains(V,{includeChildren:!1},...R)}affects(V,...R){return this.doContains(V,{includeChildren:!0},...R)}doContains(V,R,...G){if(!V)return!1;const x=G.length>0;return!!((!x||G.includes(1))&&(this.added?.get(V)||R.includeChildren&&this.added?.findSuperstr(V))||(!x||G.includes(0))&&(this.updated?.get(V)||R.includeChildren&&this.updated?.findSuperstr(V))||(!x||G.includes(2))&&(this.deleted?.findSubstr(V)||R.includeChildren&&this.deleted?.findSuperstr(V)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=h;function p(z,V,R){return!z||!V||z===V||V.length>z.length?!1:(V.charAt(V.length-1)!==F.sep&&(V+=F.sep),R?(0,C.startsWithIgnoreCase)(z,V):z.indexOf(V)===0)}e.isParent=p;class D extends Error{constructor(V,R,G){super(V);this.fileOperationResult=R,this.options=G}}e.FileOperationError=D;class T extends D{constructor(V,R,G){super(V,2,G);this.stat=R}}e.NotModifiedSinceFileOperationError=T;var o;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(o=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function L(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=L;async function $(z,V){if(!V.canHandleResource(S.URI.from({scheme:z.scheme})))return new Promise(R=>{const G=V.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===z.scheme&&x.added&&(G.dispose(),R())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class oe{static formatSize(V){return(0,y.isNumber)(V)||(V=0),V<oe.KB?(0,g.localize)(1,null,V.toFixed(0)):V<oe.MB?(0,g.localize)(2,null,(V/oe.KB).toFixed(2)):V<oe.GB?(0,g.localize)(3,null,(V/oe.MB).toFixed(2)):V<oe.TB?(0,g.localize)(4,null,(V/oe.GB).toFixed(2)):(0,g.localize)(5,null,(V/oe.TB).toFixed(2))}}e.ByteSize=oe,oe.KB=1024,oe.MB=oe.KB*oe.KB,oe.GB=oe.MB*oe.KB,oe.TB=oe.GB*oe.KB;var he;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(he=e.Arch||(e.Arch={}));function Q(z){return{maxFileSize:z===0?300*oe.MB:16*oe.GB,maxHeapSize:z===0?700*oe.MB:2*700*oe.MB}}e.getPlatformLimits=Q}),define(be[62],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class g{constructor(...S){this._entries=new Map;for(let[E,C]of S)this.set(E,C)}set(S,E){const C=this._entries.get(S);return this._entries.set(S,E),C}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}e.ServiceCollection=g}),define(be[153],Ee([0,1,12,148,91,4,62,16]),function(ee,e,g,F,S,E,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const _=!1;class k extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class n{constructor(u=new C.ServiceCollection,m=!1,b){this._activeInstantiations=new Set,this._services=u,this._strict=m,this._parent=b,this._services.set(E.IInstantiationService,this)}createChild(u){return new n(u,this._strict,this)}invokeFunction(u,...m){let b=l.traceInvocation(u),w=!1;try{return u({get:(a,f)=>{if(w)throw(0,g.illegalState)("service accessor is only valid during the invocation of its target method");const v=this._getOrCreateServiceInstance(a,b);if(!v&&f!==E.optional)throw new Error(`[invokeFunction] unknown service '${a}'`);return v}},...m)}finally{w=!0,b.stop()}}createInstance(u,...m){let b,w;return u instanceof S.SyncDescriptor?(b=l.traceCreation(u.ctor),w=this._createInstance(u.ctor,u.staticArguments.concat(m),b)):(b=l.traceCreation(u),w=this._createInstance(u,m,b)),b.stop(),w}_createInstance(u,m=[],b){let w=E._util.getServiceDependencies(u).sort((f,v)=>f.index-v.index),P=[];for(const f of w){let v=this._getOrCreateServiceInstance(f.id,b);if(!v&&this._strict&&!f.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${f.id}.`);P.push(v)}let a=w.length>0?w[0].index:m.length;if(m.length!==a){console.warn(`[createInstance] First service dependency of ${u.name} at position ${a+1} conflicts with ${m.length} static arguments`);let f=a-m.length;f>0?m=m.concat(new Array(f)):m=m.slice(0,a)}return new u(...[...m,...P])}_setServiceInstance(u,m){if(this._services.get(u)instanceof S.SyncDescriptor)this._services.set(u,m);else if(this._parent)this._parent._setServiceInstance(u,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let m=this._services.get(u);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):m}_getOrCreateServiceInstance(u,m){let b=this._getServiceInstanceOrDescriptor(u);return b instanceof S.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,b,m.branch(u,!0)):(m.branch(u,!1),b)}_safeCreateAndCacheServiceInstance(u,m,b){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,m,b)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,m,b){const w=new F.Graph(f=>f.id.toString());let P=0;const a=[{id:u,desc:m,_trace:b}];for(;a.length;){const f=a.pop();if(w.lookupOrInsertNode(f),P++>1e3)throw new k(w);for(let v of E._util.getServiceDependencies(f.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(v.id);if(!t&&!v.optional&&console.warn(`[createInstance] ${u} depends on ${v.id} which is NOT registered.`),t instanceof S.SyncDescriptor){const r={id:v.id,desc:t,_trace:f._trace.branch(v.id,!0)};w.insertEdge(f,r),a.push(r)}}}for(;;){const f=w.roots();if(f.length===0){if(!w.isEmpty())throw new k(w);break}for(const{data:v}of f){if(this._getServiceInstanceOrDescriptor(v.id)instanceof S.SyncDescriptor){const r=this._createServiceInstanceWithOwner(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this._setServiceInstance(v.id,r)}w.removeNode(v)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,m,b=[],w,P){if(this._services.get(u)instanceof S.SyncDescriptor)return this._createServiceInstance(m,b,w,P);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,m,b,w,P);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(u,m=[],b,w){if(b){const P=new y.IdleValue(()=>this._createInstance(u,m,w));return new Proxy(Object.create(null),{get(a,f){if(f in a)return a[f];let v=P.value,t=v[f];return typeof t!="function"||(t=t.bind(v),a[f]=t),t},set(a,f,v){return P.value[f]=v,!0}})}else return this._createInstance(u,m,w)}}e.InstantiationService=n;var I;(function(d){d[d.Creation=0]="Creation",d[d.Invocation=1]="Invocation",d[d.Branch=2]="Branch"})(I||(I={}));class l{constructor(u,m){this.type=u,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return _?new l(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):l._None}static traceCreation(u){return _?new l(0,u.name):l._None}branch(u,m){let b=new l(2,u.toString());return this._dep.push([u,m,b]),b}stop(){let u=Date.now()-this._start;l._totals+=u;let m=!1;function b(P,a){let f=[],v=new Array(P+1).join("	");for(const[t,r,s]of a._dep)if(r&&s){m=!0,f.push(`${v}CREATES -> ${t}`);let i=b(P+1,s);i&&f.push(i)}else f.push(`${v}uses -> ${t}`);return f.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(u>2||m)&&console.log(w.join(`
`))}}l._None=new class extends l{constructor(){super(-1,null)}stop(){}branch(){return this}},l._totals=0}),define(be[15],Ee([0,1,4,6,22,3,58]),function(ee,e,g,F,S,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,g.createDecorator)("logService"),e.ILoggerService=(0,g.createDecorator)("loggerService");function y(){return new Date().toISOString()}var _;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(_=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=_.Info;class k extends F.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new E.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class n extends k{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(_.Trace)&&this.log(_.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(_.Debug)&&this.log(_.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(_.Info)&&this.log(_.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(_.Warning)&&this.log(_.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(_.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(_.Error,this.format(s))}else this.log(_.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(_.Critical)&&this.log(_.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let s=0;s<t.length;s++){let i=t[s];if(typeof i=="object")try{i=JSON.stringify(i)}catch(c){}r+=(s>0?" ":"")+i}return r}}e.AbstractMessageLogger=n;class I extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!S.isWindows}trace(t,...r){this.getLevel()<=_.Trace&&(this.useColors?console.log(`[90m[main ${y()}][0m`,t,...r):console.log(`[main ${y()}]`,t,...r))}debug(t,...r){this.getLevel()<=_.Debug&&(this.useColors?console.log(`[90m[main ${y()}][0m`,t,...r):console.log(`[main ${y()}]`,t,...r))}info(t,...r){this.getLevel()<=_.Info&&(this.useColors?console.log(`[90m[main ${y()}][0m`,t,...r):console.log(`[main ${y()}]`,t,...r))}warn(t,...r){this.getLevel()<=_.Warning&&(this.useColors?console.warn(`[93m[main ${y()}][0m`,t,...r):console.warn(`[main ${y()}]`,t,...r))}error(t,...r){this.getLevel()<=_.Error&&(this.useColors?console.error(`[91m[main ${y()}][0m`,t,...r):console.error(`[main ${y()}]`,t,...r))}critical(t,...r){this.getLevel()<=_.Critical&&(this.useColors?console.error(`[90m[main ${y()}][0m`,t,...r):console.error(`[main ${y()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class l extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=_.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=_.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=_.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=_.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=_.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=_.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=l;class d extends k{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=_.Trace&&this.adapter.log(_.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=_.Debug&&this.adapter.log(_.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=_.Info&&this.adapter.log(_.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=_.Warning&&this.adapter.log(_.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=_.Error&&this.adapter.log(_.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=_.Critical&&this.adapter.log(_.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,C.toErrorMessage)(t,this.getLevel()<=_.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class u extends k{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const s of this.logServices)s.trace(t,...r)}debug(t,...r){for(const s of this.logServices)s.debug(t,...r)}info(t,...r){for(const s of this.logServices)s.info(t,...r)}warn(t,...r){for(const s of this.logServices)s.warn(t,...r)}error(t,...r){for(const s of this.logServices)s.error(t,...r)}critical(t,...r){for(const s of this.logServices)s.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=u;class m extends F.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=m;class b extends F.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(s))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,r){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,r?.always?_.Trace:this.logLevel,r),this.loggers.set(t.toString(),s),r?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=b;class w{constructor(){this.onDidChangeLogLevel=new E.Emitter().event}setLevel(t){}getLevel(){return _.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=w;function P(v){if(v.verbose)return _.Trace;if(typeof v.logLevel=="string"){const t=a(v.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=P;function a(v){switch(v){case"trace":return _.Trace;case"debug":return _.Debug;case"info":return _.Info;case"warn":return _.Warning;case"error":return _.Error;case"critical":return _.Critical;case"off":return _.Off}}e.parseLogLevel=a;function f(v){switch(v){case _.Trace:return"trace";case _.Debug:return"debug";case _.Info:return"info";case _.Warning:return"warn";case _.Error:return"error";case _.Critical:return"critical";case _.Off:return"off"}}e.LogLevelToString=f}),define(be[92],Ee([0,1,4,131,43]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var E;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(E=e.MarkerTag||(e.MarkerTag={}));var C;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(_){function k(u,m){return m-u}_.compare=k;const n=Object.create(null);n[_.Error]=(0,F.localize)(0,null),n[_.Warning]=(0,F.localize)(1,null),n[_.Info]=(0,F.localize)(2,null);function I(u){return n[u]||""}_.toString=I;function l(u){switch(u){case S.default.Error:return _.Error;case S.default.Warning:return _.Warning;case S.default.Info:return _.Info;case S.default.Ignore:return _.Hint}}_.fromSeverity=l;function d(u){switch(u){case _.Error:return S.default.Error;case _.Warning:return S.default.Warning;case _.Info:return S.default.Info;case _.Hint:return S.default.Ignore}}_.toSeverity=d}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var y;(function(_){const k="";function n(l){return I(l,!0)}_.makeKey=n;function I(l,d){let u=[k];return l.source?u.push(l.source.replace("\xA6","\\\xA6")):u.push(k),l.code?typeof l.code=="string"?u.push(l.code.replace("\xA6","\\\xA6")):u.push(l.code.value.replace("\xA6","\\\xA6")):u.push(k),l.severity!==void 0&&l.severity!==null?u.push(C.toString(l.severity)):u.push(k),l.message&&d?u.push(l.message.replace("\xA6","\\\xA6")):u.push(k),l.startLineNumber!==void 0&&l.startLineNumber!==null?u.push(l.startLineNumber.toString()):u.push(k),l.startColumn!==void 0&&l.startColumn!==null?u.push(l.startColumn.toString()):u.push(k),l.endLineNumber!==void 0&&l.endLineNumber!==null?u.push(l.endLineNumber.toString()):u.push(k),l.endColumn!==void 0&&l.endColumn!==null?u.push(l.endColumn.toString()):u.push(k),u.push(k),u.join("\xA6")}_.makeKeyOptionalMessage=I})(y=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,g.createDecorator)("markerService")}),define(be[154],Ee([0,1,43,4,3]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=g.default,e.INotificationService=(0,F.createDecorator)("notificationService");var E;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.GLOBAL=1]="GLOBAL"})(E=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class y{constructor(){this.progress=new _,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=y;class _{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=_}),define(be[155],Ee([0,1,6,8,2,4]),function(ee,e,g,F,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,E.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return g.Disposable.None},registerValidator(){return g.Disposable.None},registerExternalUriResolver(){return g.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return g.Disposable.None},async open(){return!1},async resolveExternalUri(y){return{resolved:y,dispose(){}}}});function C(y,_){return S.URI.isUri(y)?(0,F.equalsIgnoreCase)(y.scheme,_):(0,F.startsWithIgnoreCase)(y,_+":")}e.matchesScheme=C});var ze=this&&this.__decorate||function(ee,e,g,F){var S=arguments.length,E=S<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,g):F,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")E=Reflect.decorate(ee,e,g,F);else for(var y=ee.length-1;y>=0;y--)(C=ee[y])&&(E=(S<3?C(E):S>3?C(e,g,E):C(e,g))||E);return S>3&&E&&Object.defineProperty(e,g,E),E},qe=this&&this.__param||function(ee,e){return function(g,F){e(g,F,ee)}};define(be[156],Ee([0,1,4,20,6,16]),function(ee,e,g,F,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,g.createDecorator)("progressService");var C;(function(n){n[n.Explorer=1]="Explorer",n[n.Scm=3]="Scm",n[n.Extensions=5]="Extensions",n[n.Window=10]="Window",n[n.Notification=15]="Notification",n[n.Dialog=20]="Dialog"})(C=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class y{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=y,y.None=Object.freeze({report(){}});let _=class extends S.Disposable{constructor(I,l){super();this.deferred=new E.DeferredPromise,l.withProgress(I,d=>(this.reporter=d,this.lastStep&&d.report(this.lastStep),this.deferred.p)),this._register((0,S.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};_=ze([qe(1,e.IProgressService)],_),e.UnmanagedProgress=_;class k extends S.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new S.DisposableStore)}start(I){this.stop();const l=++this.currentOperationId,d=new F.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{l===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,S.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,S.toDisposable)(()=>d.cancel())),this.currentOperationDisposables.add((0,S.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:l,token:d.token,stop:()=>this.doStop(l),isCurrent:()=>this.currentOperationId===l}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,g.createDecorator)("editorProgressService")}),define(be[28],Ee([0,1,10,40]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class S{constructor(){this.data=new Map}add(C,y){F.ok(g.isString(C)),F.ok(g.isObject(y)),F.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,y)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}e.Registry=new S}),define(be[93],Ee([0,1,28,3]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function S(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class E{constructor(){this._onDidChangeSchema=new F.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,k){this.schemasById[S(_)]=k,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new E;g.Registry.add(e.Extensions.JSONContribution,C)}),define(be[63],Ee([0,1,128,3,28,10,93]),function(ee,e,g,F,S,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(y=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var _;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(_=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const k=S.Registry.as(C.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new F.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new F.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:g.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(P,a=!0){this.registerConfigurations([P],a)}registerConfigurations(P,a=!0){const f=[];P.forEach(v=>{f.push(...this.validateAndRegisterProperties(v,a,v.extensionInfo)),this.configurationContributors.push(v),this.registerJSONConfiguration(v)}),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}deregisterConfigurations(P){const a=[],f=v=>{if(v.properties)for(const t in v.properties)a.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,v.properties[t]);v.allOf&&v.allOf.forEach(t=>f(t))};for(const v of P){f(v);const t=this.configurationContributors.indexOf(v);t!==-1&&this.configurationContributors.splice(t,1)}k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}registerDefaultConfigurations(P){const a=[],f=[];for(const v of P)for(const t in v)if(a.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...v[t]};const r={type:"object",default:this.defaultValues[t],description:g.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};f.push(l(t)),this.configurationProperties[t]=r,this.defaultLanguageConfigurationOverridesNode.properties[t]=r}else{this.defaultValues[t]=v[t];const r=this.configurationProperties[t];r&&(this.updatePropertyDefaultValue(t,r),this.updateSchema(t,r))}this.registerOverrideIdentifiers(f),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterDefaultConfigurations(P){const a=[];for(const f of P)for(const v in f)if(a.push(v),delete this.defaultValues[v],e.OVERRIDE_PROPERTY_PATTERN.test(v))delete this.configurationProperties[v],delete this.defaultLanguageConfigurationOverridesNode.properties[v];else{const t=this.configurationProperties[v];t&&(this.updatePropertyDefaultValue(v,t),this.updateSchema(v,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}notifyConfigurationSchemaUpdated(...P){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(P){for(const a of P)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(P,a=!0,f,v=3){v=E.isUndefinedOrNull(P.scope)?v:P.scope;let t=[],r=P.properties;if(r)for(let i in r){if(a&&m(i)){delete r[i];continue}const c=r[i];if(this.updatePropertyDefaultValue(i,c),e.OVERRIDE_PROPERTY_PATTERN.test(i)?c.scope=void 0:(c.scope=E.isUndefinedOrNull(c.scope)?v:c.scope,c.restricted=E.isUndefinedOrNull(c.restricted)?!!f?.restrictedConfigurations?.includes(i):c.restricted),r[i].hasOwnProperty("included")&&!r[i].included){this.excludedConfigurationProperties[i]=r[i],delete r[i];continue}else this.configurationProperties[i]=r[i];!r[i].deprecationMessage&&r[i].markdownDeprecationMessage&&(r[i].deprecationMessage=r[i].markdownDeprecationMessage),t.push(i)}let s=P.allOf;if(s)for(let i of s)t.push(...this.validateAndRegisterProperties(i,a,f,v));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(P){const a=f=>{let v=f.properties;if(v)for(const r in v)this.updateSchema(r,v[r]);let t=f.allOf;t&&t.forEach(a)};a(P)}updateSchema(P,a){switch(e.allSettings.properties[P]=a,a.scope){case 1:e.applicationSettings.properties[P]=a;break;case 2:e.machineSettings.properties[P]=a;break;case 6:e.machineOverridableSettings.properties[P]=a;break;case 3:e.windowSettings.properties[P]=a;break;case 4:e.resourceSettings.properties[P]=a;break;case 5:e.resourceSettings.properties[P]=a,this.resourceLanguageSettingsSchema.properties[P]=a;break}}removeFromSchema(P,a){switch(delete e.allSettings.properties[P],a.scope){case 1:delete e.applicationSettings.properties[P];break;case 2:delete e.machineSettings.properties[P];break;case 6:delete e.machineOverridableSettings.properties[P];break;case 3:delete e.windowSettings.properties[P];break;case 4:case 5:delete e.resourceSettings.properties[P];break}}updateOverridePropertyPatternKey(){for(const P of this.overrideIdentifiers.values()){const a=`[${P}]`,f={type:"object",description:g.localize(2,null),errorMessage:g.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,f),e.allSettings.properties[a]=f,e.applicationSettings.properties[a]=f,e.machineSettings.properties[a]=f,e.machineOverridableSettings.properties[a]=f,e.windowSettings.properties[a]=f,e.resourceSettings.properties[a]=f}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(P,a){let f=this.defaultValues[P];E.isUndefined(f)&&(f=a.default),E.isUndefined(f)&&(f=d(a.type)),a.default=f}}const I="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(I);function l(w){return w.substring(1,w.length-1)}e.overrideIdentifierFromKey=l;function d(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const u=new n;S.Registry.add(e.Extensions.Configuration,u);function m(w){return w.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(w)?g.localize(5,null,w):u.getConfigurationProperties()[w]!==void 0?g.localize(6,null,w):null:g.localize(4,null)}e.validateProperty=m;function b(){const w=[],P=u.getConfigurationProperties();for(const a of Object.keys(P))w.push([a,P[a].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=b}),define(be[94],Ee([0,1,23,10,2,28,4,63]),function(ee,e,g,F,S,E,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,C.createDecorator)("configurationService");function _(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof S.URI)}e.isConfigurationOverrides=_;var k;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function I(r,s){const i=s?r?s.keys.filter(A=>r.keys.indexOf(A)===-1):[...s.keys]:[],c=r?s?r.keys.filter(A=>s.keys.indexOf(A)===-1):[...r.keys]:[],h=[];if(s&&r){for(const A of r.keys)if(s.keys.indexOf(A)!==-1){const L=w(r.contents,A),$=w(s.contents,A);g.equals(L,$)||h.push(A)}}const p=[],D=A=>{const L={};for(const $ of A)for(const oe of $.identifiers)L[v(oe)]=$;return L},T=s?D(s.overrides):{},o=r?D(r.overrides):{};if(Object.keys(T).length)for(const A of i){const L=T[A];L&&p.push([(0,y.overrideIdentifierFromKey)(A),L.keys])}if(Object.keys(o).length)for(const A of c){const L=o[A];L&&p.push([(0,y.overrideIdentifierFromKey)(A),L.keys])}if(Object.keys(T).length&&Object.keys(o).length)for(const A of h){const L=o[A],$=T[A];if(L&&$){const oe=I({contents:L.contents,keys:L.keys,overrides:[]},{contents:$.contents,keys:$.keys,overrides:[]});p.push([(0,y.overrideIdentifierFromKey)(A),[...oe.added,...oe.removed,...oe.updated]])}}return{added:i,removed:c,updated:h,overrides:p}}e.compare=I;function l(r,s){const i=[];for(const c of Object.keys(r))if(y.OVERRIDE_PROPERTY_PATTERN.test(c)){const h={};for(const p in r[c])h[p]=r[c][p];i.push({identifiers:[(0,y.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(h),contents:d(h,s)})}return i}e.toOverrides=l;function d(r,s){const i=Object.create(null);for(let c in r)u(i,c,r[c],s);return i}e.toValuesTree=d;function u(r,s,i,c){const h=s.split("."),p=h.pop();let D=r;for(let T=0;T<h.length;T++){let o=h[T],A=D[o];switch(typeof A){case"undefined":A=D[o]=Object.create(null);break;case"object":break;default:c(`Ignoring ${s} as ${h.slice(0,T+1).join(".")} is ${JSON.stringify(A)}`);return}D=A}if(typeof D=="object"&&D!==null)try{D[p]=i}catch(T){c(`Ignoring ${s} as ${h.join(".")} is ${JSON.stringify(D)}`)}else c(`Ignoring ${s} as ${h.join(".")} is ${JSON.stringify(D)}`)}e.addToValueTree=u;function m(r,s){const i=s.split(".");b(r,i)}e.removeFromValueTree=m;function b(r,s){const i=s.shift();if(s.length===0){delete r[i];return}if(Object.keys(r).indexOf(i)!==-1){const c=r[i];typeof c=="object"&&!Array.isArray(c)&&(b(c,s),Object.keys(c).length===0&&delete r[i])}}function w(r,s,i){function c(D,T){let o=D;for(const A of T){if(typeof o!="object"||o===null)return;o=o[A]}return o}const h=s.split("."),p=c(r,h);return typeof p=="undefined"?i:p}e.getConfigurationValue=w;function P(r,s,i){Object.keys(s).forEach(c=>{c!=="__proto__"&&(c in r?F.isObject(r[c])&&F.isObject(s[c])?P(r[c],s[c],i):i&&(r[c]=s[c]):r[c]=s[c])})}e.merge=P;function a(){const r=E.Registry.as(y.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=a;function f(){const r=Object.create(null),s=E.Registry.as(y.Extensions.Configuration).getConfigurationProperties();for(let i in s){let c=s[i].default;u(r,i,c,h=>console.error(`Conflict in default settings: ${h}`))}return r}e.getDefaultValues=f;function v(r){return`[${r}]`}e.keyFromOverrideIdentifier=v;function t(r,s,i){const c=r.inspect(s),h=r.inspect(i);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:c.defaultValue}e.getMigratedSettingValue=t}),define(be[157],Ee([0,1,111,21,17,10,23,2,63,94,28,6,3]),function(ee,e,g,F,S,E,C,y,_,k,n,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class d{constructor(t={},r=[],s=[]){this._contents=t,this._keys=r,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,k.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const s=this.getContentsForOverrideIdentifer(r);return s?t?(0,k.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let s={};for(const i of S.distinct([...Object.keys(this.contents),...Object.keys(r)])){let c=this.contents[i],h=r[i];h&&(typeof c=="object"&&typeof h=="object"?(c=C.deepClone(c),this.mergeContents(c,h)):c=h),s[i]=c}return new d(s,this.keys,this.overrides)}merge(...t){const r=C.deepClone(this.contents),s=C.deepClone(this.overrides),i=[...this.keys];for(const c of t){this.mergeContents(r,c.contents);for(const h of c.overrides){const[p]=s.filter(D=>S.equals(D.identifiers,h.identifiers));p?this.mergeContents(p.contents,h.contents):s.push(C.deepClone(h))}for(const h of c.keys)i.indexOf(h)===-1&&i.push(h)}return new d(r,i,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const s of Object.keys(r)){if(s in t&&E.isObject(t[s])&&E.isObject(r[s])){this.mergeContents(t[s],r[s]);continue}t[s]=C.deepClone(r[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?C.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,k.addToValueTree)(this.contents,t,r,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,k.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let s=0;s<r;s++)t.indexOf(this.keys[s])===0&&(r=s);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=d;class u extends d{constructor(){const t=(0,k.getDefaultValues)(),r=(0,k.getConfigurationKeys)(),s=[];for(const i of Object.keys(t))_.OVERRIDE_PROPERTY_PATTERN.test(i)&&s.push({identifiers:[(0,_.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(t[i]),contents:(0,k.toValuesTree)(t[i],c=>console.error(`Conflict in default settings file: ${c}`))});super(t,r,s)}}e.DefaultConfigurationModel=u;class m{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new d}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!E.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:s,keys:i,overrides:c,restricted:h}=this.doParseRaw(t,r);this._configurationModel=new d(s,i,c),this._restrictedConfigurations=h||[]}doParseContent(t){let r={},s=null,i=[],c=[],h=[];function p(T){Array.isArray(i)?i.push(T):s&&(i[s]=T)}let D={onObjectBegin:()=>{let T={};p(T),c.push(i),i=T,s=null},onObjectProperty:T=>{s=T},onObjectEnd:()=>{i=c.pop()},onArrayBegin:()=>{let T=[];p(T),c.push(i),i=T,s=null},onArrayEnd:()=>{i=c.pop()},onLiteralValue:p,onError:(T,o,A)=>{h.push({error:T,offset:o,length:A})}};if(t)try{g.visit(t,D),r=i[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return r}doParseRaw(t,r){const s=n.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,s,!0,r);t=i.raw;const c=(0,k.toValuesTree)(t,D=>console.error(`Conflict in settings file ${this._name}: ${D}`)),h=Object.keys(t),p=(0,k.toOverrides)(t,D=>console.error(`Conflict in settings file ${this._name}: ${D}`));return{contents:c,keys:h,overrides:p,restricted:i.restricted}}filter(t,r,s,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:t,restricted:[]};const c={},h=[];for(let p in t)if(_.OVERRIDE_PROPERTY_PATTERN.test(p)&&s){const D=this.filter(t[p],r,!1,i);c[p]=D.raw,h.push(...D.restricted)}else{const D=r[p],T=D?typeof D.scope!="undefined"?D.scope:3:void 0;D?.restricted&&h.push(p),(T===void 0||i.scopes===void 0||i.scopes.includes(T))&&(i.skipRestricted&&D?.restricted||(c[p]=t[p]))}return{raw:c,restricted:h}}}e.ConfigurationModelParser=m;class b extends I.Disposable{constructor(t,r,s,i){super();this.userSettingsResource=t,this.scopes=r,this.fileService=i,this._onDidChange=this._register(new l.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(l.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new d}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=b;class w{constructor(t,r,s=new d,i=new d,c=new F.ResourceMap,h=new d,p=new F.ResourceMap,D=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=i,this._folderConfigurations=c,this._memoryConfiguration=h,this._memoryConfigurationByResource=p,this._freeze=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new F.ResourceMap,this._userConfiguration=null}getValue(t,r,s){return this.getConsolidateConfigurationModel(r,s).getValue(t)}updateValue(t,r,s={}){let i;s.resource?(i=this._memoryConfigurationByResource.get(s.resource),i||(i=new d,this._memoryConfigurationByResource.set(s.resource,i))):i=this._memoryConfiguration,r===void 0?i.removeValue(t):i.setValue(t,r),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,s){const i=this.getConsolidateConfigurationModel(r,s),c=this.getFolderConfigurationModelForResource(r.resource,s),h=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,p=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),D=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),T=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),o=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),A=s?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,L=c?r.overrideIdentifier?c.freeze().override(r.overrideIdentifier).getValue(t):c.freeze().getValue(t):void 0,$=r.overrideIdentifier?h.override(r.overrideIdentifier).getValue(t):h.getValue(t),oe=i.getValue(t),he=S.distinct(S.flatten(i.overrides.map(Q=>Q.identifiers))).filter(Q=>i.getOverrideValue(t,Q)!==void 0);return{defaultValue:p,userValue:D,userLocalValue:T,userRemoteValue:o,workspaceValue:A,workspaceFolderValue:L,memoryValue:$,value:oe,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:D!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:o!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:A!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:c?.freeze().getValue(t),override:r.overrideIdentifier?c?.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:$!==void 0?{value:h.getValue(t),override:r.overrideIdentifier?h.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:he.length?he:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const s=r.filter(i=>_.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const c=(0,_.overrideIdentifierFromKey)(i),h=this._defaultConfiguration.getKeysForOverrideIdentifier(c),p=t.getKeysForOverrideIdentifier(c),D=[...p.filter(T=>h.indexOf(T)===-1),...h.filter(T=>p.indexOf(T)===-1),...h.filter(T=>!C.equals(this._defaultConfiguration.override(c).getValue(T),t.override(c).getValue(T)))];return[c,D]});return this.updateDefaultConfiguration(t),{keys:r,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:s,removed:i,overrides:c}=(0,k.compare)(this.localUserConfiguration,t),h=[...r,...s,...i];return h.length&&this.updateLocalUserConfiguration(t),{keys:h,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:s,removed:i,overrides:c}=(0,k.compare)(this.remoteUserConfiguration,t);let h=[...r,...s,...i];return h.length&&this.updateRemoteUserConfiguration(t),{keys:h,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:s,removed:i,overrides:c}=(0,k.compare)(this.workspaceConfiguration,t);let h=[...r,...s,...i];return h.length&&this.updateWorkspaceConfiguration(t),{keys:h,overrides:c}}compareAndUpdateFolderConfiguration(t,r){const s=this.folderConfigurations.get(t),{added:i,updated:c,removed:h,overrides:p}=(0,k.compare)(s,r);let D=[...i,...c,...h];return(D.length||!s)&&this.updateFolderConfiguration(t,r),{keys:D,overrides:p}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:i,removed:c,overrides:h}=(0,k.compare)(r,void 0);return{keys:[...s,...i,...c],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let s=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},r){let s=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const i=r.getFolder(t);i&&(s=this.getFolderConsolidatedConfiguration(i.uri)||s);const c=this._memoryConfigurationByResource.get(t);c&&(s=s.merge(c))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const s=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(r=s.merge(i),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=s}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const s=r.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:s,overrides:i,keys:c}=this._folderConfigurations.get(r);return t.push([r,{contents:s,overrides:i,keys:c}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),c=t.folders.reduce((h,p)=>(h.set(y.URI.revive(p[0]),this.parseConfigurationModel(p[1])),h),new F.ResourceMap);return new w(r,s,new d,i,c,new d,new F.ResourceMap,!1)}static parseConfigurationModel(t){return new d(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function P(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const t=new Set,r=new Map;for(const i of v)i.keys.forEach(c=>t.add(c)),i.overrides.forEach(([c,h])=>{const p=(0,F.getOrSet)(r,c,new Set);h.forEach(D=>p.add(D))});const s=[];return r.forEach((i,c)=>s.push([c,[...i.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=P;class a{constructor(t,r,s,i){this.change=t,this.previous=r,this.currentConfiguraiton=s,this.currentWorkspace=i,this._previousConfiguration=void 0;const c=new Set;t.keys.forEach(p=>c.add(p)),t.overrides.forEach(([,p])=>p.forEach(D=>c.add(D))),this.affectedKeys=[...c.values()];const h=new d;this.affectedKeys.forEach(p=>h.setValue(p,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const s=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!C.equals(s,i)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let s=(0,k.toValuesTree)({[r]:!0},()=>{}),i;for(;typeof s=="object"&&(i=Object.keys(s)[0]);){if(t=t[i],!t)return!1;s=s[i]}return!0}}e.ConfigurationChangeEvent=a;class f extends a{constructor(t,r,s,i){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=s,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=f}),define(be[95],Ee([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,g.createDecorator)("remoteAuthorityResolverService");var F;(function(E){E.Unknown="Unknown",E.NotAvailable="NotAvailable",E.TemporarilyNotAvailable="TemporarilyNotAvailable",E.NoResolverFound="NoResolverFound"})(F=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class S extends Error{constructor(C,y=F.Unknown,_){super(C);this._message=C,this._code=y,this._detail=_,this.isHandled=y===F.NotAvailable&&_===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,S.prototype)}static isTemporarilyNotAvailable(C){return C instanceof S&&C._code===F.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof S&&C._code===F.NoResolverFound}static isHandled(C){return C instanceof S&&C.isHandled}}e.RemoteAuthorityResolverError=S}),define(be[96],Ee([0,1,11]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function F(k){return k.scheme===g.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=F;function S(k){if(!k)return;const n=k.indexOf("+");return n<0?k:k.substr(0,n)}e.getRemoteName=S;function E(k){return k.scheme!==g.Schemas.file&&k.scheme!==g.Schemas.vscodeRemote}e.isVirtualResource=E;function C(k){if(k.folders.length)return k.folders.every(n=>E(n.uri))?k.folders[0].uri:void 0;if(k.configuration&&E(k.configuration))return k.configuration}e.getVirtualWorkspaceLocation=C;function y(k){return C(k)?.scheme}e.getVirtualWorkspaceScheme=y;function _(k){return C(k)!==void 0}e.isVirtualWorkspace=_}),define(be[158],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class g{constructor(S){this._callback=S,this._terminalBufferMap=new Map}dispose(){for(const S of this._terminalBufferMap.values())S.dispose()}startBuffering(S,E,C=5){let y;return y=E(_=>{const k=typeof _=="string"?_:_.data;let n=this._terminalBufferMap.get(S);if(n){n.data.push(k);return}const I=setTimeout(()=>this.flushBuffer(S),C);n={data:[k],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(S),y.dispose()}},this._terminalBufferMap.set(S,n)}),y}stopBuffering(S){const E=this._terminalBufferMap.get(S);E&&E.dispose()}flushBuffer(S){const E=this._terminalBufferMap.get(S);E&&(this._terminalBufferMap.delete(S),this._callback(S,E.data.join("")))}}e.TerminalDataBufferer=g}),define(be[159],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var g;(function(F){F.DARK="dark",F.LIGHT="light",F.HIGH_CONTRAST="hc"})(g=e.ColorScheme||(e.ColorScheme={}))}),define(be[64],Ee([0,1,4,6,28,3,159,35]),function(ee,e,g,F,S,E,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,g.createDecorator)("themeService");var _;(function(b){function w(P){return P&&typeof P=="object"&&typeof P.id=="string"}b.isThemeColor=w})(_=e.ThemeColor||(e.ThemeColor={}));function k(b){return{id:b}}e.themeColorFromId=k;var n;(function(b){function w(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||_.isThemeColor(r.color))}b.isThemeIcon=w;const P=new RegExp(`^\\$\\((${y.CSSIcon.iconNameExpression}(?:${y.CSSIcon.iconModifierExpression})?)\\)$`);function a(r){const s=P.exec(r);if(!s)return;let[,i]=s;return{id:i}}b.fromString=a;function f(r,s){let i=r.id;const c=i.lastIndexOf("~");return c!==-1&&(i=i.substring(0,c)),s&&(i=`${i}~${s}`),{id:i}}b.modify=f;function v(r,s){return r.id===s.id&&r.color?.id===s.color?.id}b.isEqual=v;function t(r,s){return{id:r.id,color:s?k(s):void 0}}b.asThemeIcon=t,b.asClassNameArray=y.CSSIcon.asClassNameArray,b.asClassName=y.CSSIcon.asClassName,b.asCSSSelector=y.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=y.Codicon.file,e.FolderThemeIcon=y.Codicon.folder;function I(b){switch(b){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class l{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new E.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,F.toDisposable)(()=>{const P=this.themingParticipants.indexOf(w);this.themingParticipants.splice(P,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let d=new l;S.Registry.add(e.Extensions.ThemingContribution,d);function u(b){return d.onColorThemeChange(b)}e.registerThemingParticipant=u;class m extends F.Disposable{constructor(w){super();this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(P=>this.onThemeChange(P)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,P){let a=this.theme.getColor(w);return a&&P&&(a=P(a,this.theme)),a?a.toString():null}}e.Themable=m}),define(be[160],Ee([0,1,28,64,3,132,93,16,35]),function(ee,e,g,F,S,E,C,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class k{constructor(){this._onDidChange=new S.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${_.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(w,P,a,f){const v=this.iconsById[w];if(v){if(a&&!v.description){v.description=a,this.iconSchema.properties[w].markdownDescription=`${a} $(${w})`;const s=this.iconReferenceSchema.enum.indexOf(w);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=a),this._onDidChange.fire()}return v}let t={id:w,description:a,defaults:P,deprecationMessage:f};this.iconsById[w]=t;let r={$ref:"#/definitions/icons"};return f&&(r.deprecationMessage=f),a&&(r.markdownDescription=`${a}: $(${w})`),this.iconSchema.properties[w]=r,this.iconReferenceSchema.enum.push(w),this.iconReferenceSchema.enumDescriptions.push(a||""),this._onDidChange.fire(),{id:w}}deregisterIcon(w){delete this.iconsById[w],delete this.iconSchema.properties[w];const P=this.iconReferenceSchema.enum.indexOf(w);P!==-1&&(this.iconReferenceSchema.enum.splice(P,1),this.iconReferenceSchema.enumDescriptions.splice(P,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(w=>this.iconsById[w])}getIcon(w){return this.iconsById[w]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(w,P){const a=this.iconFontsById[w];if(a)return a;let f={id:w,definition:P};return this.iconFontsById[w]=f,this._onDidChange.fire(),f}deregisterIconFont(w){delete this.iconFontsById[w]}getIconFonts(){return Object.keys(this.iconFontsById).map(w=>this.iconFontsById[w])}getIconFont(w){return this.iconFontsById[w]}toString(){const w=(v,t)=>v.id.localeCompare(t.id),P=v=>{for(;F.ThemeIcon.isThemeIcon(v.defaults);)v=this.iconsById[v.defaults.id];return`codicon codicon-${v?v.id:""}`};let a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const f=Object.keys(this.iconsById).map(v=>this.iconsById[v]);for(const v of f.filter(t=>!!t.description).sort(w))a.push(`|<i class="${P(v)}"></i>|${v.id}|${F.ThemeIcon.isThemeIcon(v.defaults)?v.defaults.id:v.id}|${v.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const v of f.filter(t=>!F.ThemeIcon.isThemeIcon(t.defaults)).sort(w))a.push(`|<i class="${P(v)}"></i>|${v.id}|`);return a.join(`
`)}}const n=new k;g.Registry.add(e.Extensions.IconContribution,n);function I(b,w,P,a){return n.registerIcon(b,w,P,a)}e.registerIcon=I;function l(){return n}e.getIconRegistry=l;function d(){for(const b of _.iconRegistry.all)n.registerIcon(b.id,b.definition,b.description);_.iconRegistry.onDidRegister(b=>n.registerIcon(b.id,b.definition,b.description))}d(),e.iconsSchemaId="vscode://schemas/icons";let u=g.Registry.as(C.Extensions.JSONContribution);u.registerSchema(e.iconsSchemaId,n.getIconSchema());const m=new y.RunOnceScheduler(()=>u.notifySchemaChanged(e.iconsSchemaId),200);n.onDidChange(()=>{m.isScheduled()||m.schedule()}),e.widgetClose=I("widget-close",_.Codicon.close,(0,E.localize)(2,null)),e.gotoPreviousLocation=I("goto-previous-location",_.Codicon.arrowUp,(0,E.localize)(3,null)),e.gotoNextLocation=I("goto-next-location",_.Codicon.arrowDown,(0,E.localize)(4,null)),e.syncing=F.ThemeIcon.modify(_.Codicon.sync,"spin")}),define(be[46],Ee([0,1,2,25,4,21]),function(ee,e,g,F,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,S.createDecorator)("contextService");var C;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(C=e.WorkbenchState||(e.WorkbenchState={}));function y(l){const d=l;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&Array.isArray(d.folders))}e.isWorkspace=y;function _(l){const d=l;return!!(d&&typeof d=="object"&&g.URI.isUri(d.uri)&&typeof d.name=="string"&&typeof d.toResource=="function")}e.isWorkspaceFolder=_;class k{constructor(d,u,m,b){this._id=d,this._configuration=m,this._ignorePathCasing=b,this._foldersMap=E.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=u}update(d){this._id=d.id,this._configuration=d.configuration,this._ignorePathCasing=d._ignorePathCasing,this.folders=d.folders}get folders(){return this._folders}set folders(d){this._folders=d,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(d){this._configuration=d}getFolder(d){return d&&this._foldersMap.findSubstr(d.with({scheme:d.scheme,authority:d.authority,path:d.path}))||null}updateFoldersMap(){this._foldersMap=E.TernarySearchTree.forUris(this._ignorePathCasing);for(const d of this.folders)this._foldersMap.set(d.uri,d)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=k;class n{constructor(d,u){this.raw=u,this.uri=d.uri,this.index=d.index,this.name=d.name}toResource(d){return(0,F.joinPath)(this.uri,d)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function I(l){return new n({uri:l,index:0,name:(0,F.basenameOrAuthority)(l)},{uri:l.toString()})}e.toWorkspaceFolder=I}),define(be[65],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class g{constructor(S){this.id=S,this._data=new Map,this._idPool=1}add(S){const E=this._idPool++;return this._data.set(E,S),this.logDebugInfo(),E}get(S,E){return this._data.has(S)?this._data.get(S)[E]:void 0}delete(S){this._data.delete(S),this.logDebugInfo()}logDebugInfo(){!g.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=g,g.enableDebugLogging=!1}),define(be[66],Ee([0,1,2,3,4]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,S.createDecorator)("IExtHostEditorTabs");class E{constructor(){this._onDidChangeTabs=new F.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(y){this._tabs=y.map(_=>({name:_.name,group:_.group,resource:g.URI.revive(_.resource),isActive:_.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=E}),define(be[47],Ee([0,1,11,4]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class S{constructor(){this._systemSchemes=new Set(Object.keys(g.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(C,y){y===null?this._providerInfo.delete(C):this._providerInfo.set(C,y)}isFreeScheme(C){return!this._providerInfo.has(C)&&!this._systemSchemes.has(C)}getCapabilities(C){return this._providerInfo.get(C)}}e.ExtHostFileSystemInfo=S,e.IExtHostFileSystemInfo=(0,F.createDecorator)("IExtHostFileSystemInfo")}),define(be[29],Ee([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,g.createDecorator)("IExtHostInitDataService")}),define(be[161],Ee([0,1,2]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class F{constructor(E,C,y){this._extHostNotebooks=C,this._textDocumentsAndEditors=y}$willAddInteractiveDocument(E,C,y,_){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:C,lines:[""],modeId:y,uri:E,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(g.URI.revive(_))?.apiNotebook}]})}$willRemoveInteractiveDocument(E,C){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[E]})}}e.ExtHostInteractive=F}),define(be[162],Ee([0,1,16]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class F{constructor(C,y,_){this._deferredPromises=new Map,this._id=C,this._shared=y,this._storage=_,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new g.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const n of k.values())n.complete()}catch(n){for(const I of k.values())I.error(n)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,C])=>C!==void 0).map(([C])=>C)}get whenReady(){return this._init}get(C,y){let _=this._value[C];return typeof _=="undefined"&&(_=y),_}update(C,y){this._value[C]=y;let _=this._deferredPromises.get(C);if(_!==void 0)return _.p;const k=new g.DeferredPromise;return this._deferredPromises.set(C,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=F;class S extends F{constructor(C,y){super(C.identifier.value,!0,y);this._extension=C}setKeysForSync(C){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},C)}}e.ExtensionGlobalMemento=S}),define(be[163],Ee([0,1,3,2,15]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let E=class{constructor(y,_){this._logService=y,this._notebooksAndEditors=_,this._onDidChangeNotebookDocumentMetadata=new g.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new g.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(y,_,k){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(y)).acceptModelChanged(_,k)}$acceptDirtyStateChanged(y,_){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(y)).acceptDirty(_)}$acceptModelSaved(y){const _=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(y));this._onDidSaveNotebookDocument.fire(_.apiNotebook)}$acceptDocumentPropertiesChanged(y,_){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",y.path,_);const k=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(y));k.acceptDocumentPropertiesChanged(_),_.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:k.apiNotebook})}};E=ze([qe(0,S.ILogService)],E),e.ExtHostNotebookDocuments=E}),define(be[13],Ee([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,g.createDecorator)("IExtHostRpcService");class F{constructor(E){this.getProxy=E.getProxy.bind(E),this.set=E.set.bind(E),this.assertRegistered=E.assertRegistered.bind(E),this.drain=E.drain.bind(E)}}e.ExtHostRpcService=F});var nt=this&&this.__classPrivateFieldSet||function(ee,e,g,F,S){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Ue=this&&this.__classPrivateFieldGet||function(ee,e,g,F){if(g==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?F:g==="a"?F.call(ee):F?F.value:e.get(ee)};define(be[164],Ee([0,1,26,3]),function(ee,e,g,F){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class E{constructor(y,_){S.set(this,void 0),this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._id=g.ExtensionIdentifier.toKey(y.identifier),nt(this,S,_,"f"),Ue(this,S,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(y){return Ue(this,S,"f").get(this._id,y)}store(y,_){return Ue(this,S,"f").store(this._id,y,_)}delete(y){return Ue(this,S,"f").delete(this._id,y)}}e.ExtensionSecrets=E,S=new WeakMap}),define(be[97],Ee([0,1,4,3]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class S{constructor(){this._onDidChangeTelemetryEnabled=new F.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(C){this._enabled=C}$onDidChangeTelemetryEnabled(C){this._enabled=C,this._onDidChangeTelemetryEnabled.fire(C)}}e.ExtHostTelemetry=S,e.IExtHostTelemetry=(0,g.createDecorator)("IExtHostTelemetry")}),define(be[67],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.createTestItemCollection=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var g;(function(b){b[b.Upsert=0]="Upsert",b[b.RemoveChild=1]="RemoveChild",b[b.Invalidated=2]="Invalidated",b[b.SetProp=3]="SetProp",b[b.Bulk=4]="Bulk"})(g=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const F=new WeakMap,S=b=>{let w=F.get(b);return w||(w={},F.set(b,w)),w};e.getPrivateApiFor=S;const E=(b,w,P,a)=>{let f=P;return{enumerable:!0,configurable:!1,get(){return f},set(v){a(f,v)||(f=v,b.listener?.({op:3,key:w,value:v}))}}},C=(b,w)=>b===w,y={range:(b,w)=>b===w?!0:!b||!w?!1:b.isEqual(w),label:C,description:C,busy:C,error:C,canResolveChildren:C},_=Object.keys(y),k=(b,w)=>({range:E(b,"range",void 0,y.range),label:E(b,"label",w,y.label),description:E(b,"description",void 0,y.description),canResolveChildren:E(b,"canResolveChildren",!1,y.canResolveChildren),busy:E(b,"busy",!1,y.busy),error:E(b,"error",void 0,y.error)}),n=(b,w)=>{const P=new Map;for(const a of _)y[a](b[a],w[a])||P.set(a,w[a]);return P};e.diffTestItems=n;class I extends Error{constructor(w){super(`Attempted to insert a duplicate test item ID ${w}`)}}e.DuplicateTestItemError=I;class l extends Error{constructor(w){super(`TestItem with ID "${w}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=l;const d=b=>{const w=(0,e.getPrivateApiFor)(b);let P=new Map;return{forEach(a,f){for(const v of P.values())a.call(f,v,this)},set(a){const f=new Map,v=new Set(P.keys()),t={op:4,ops:[]};for(const r of a){if(!(r instanceof u))throw new l(r.id);if(f.has(r.id))throw new I(r.id);f.set(r.id,r),v.delete(r.id),t.ops.push({op:0,item:r})}for(const r of v.keys())t.ops.push({op:1,id:r});w.listener?.(t),P=f},add(a){if(!(a instanceof u))throw new l(a.id);P.set(a.id,a),w.listener?.({op:0,item:a})},delete(a){P.delete(a)&&w.listener?.({op:1,id:a})},get(a){return P.get(a)},toJSON(){return Array.from(P.values())},[Symbol.iterator](){return P.values()}}};e.createTestItemCollection=d;class u{constructor(w,P,a){const f=(0,e.getPrivateApiFor)(this);if(w.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(w)} symbol`);Object.defineProperties(this,{id:{value:w,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return f.parent instanceof m?void 0:f.parent}},children:{value:(0,e.createTestItemCollection)(this),enumerable:!0,writable:!1},...k(f,P)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=u;class m extends u{constructor(w,P){super(w,P,void 0)}}e.TestItemRootImpl=m}),define(be[68],Ee([0,1,4,3,13]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var E;(function(y){function _(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,protocol:n.protocol}}y.fromApiTunnel=_;function k(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.public,protocol:n.protocol}}y.fromServiceTunnel=k})(E=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,g.createDecorator)("IExtHostTunnelService");let C=class{constructor(_){this.onDidChangeTunnels=new F.Emitter().event}async $applyCandidateFilter(_){return _}async openTunnel(_,k){}async getTunnels(){return[]}async setTunnelExtensionFunctions(_){return{dispose:()=>{}}}registerPortsAttributesProvider(_,k){return{dispose:()=>{}}}async $providePortAttributes(_,k,n,I,l){return[]}async $forwardPort(_,k){}async $closeTunnel(_){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};C=ze([qe(0,S.IExtHostRpcService)],C),e.ExtHostTunnelService=C});var nt=this&&this.__classPrivateFieldSet||function(ee,e,g,F,S){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Ue=this&&this.__classPrivateFieldGet||function(ee,e,g,F){if(g==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?F:g==="a"?F.call(ee):F?F.value:e.get(ee)};define(be[7],Ee([0,1,17,12,83,21,85,10,2,36,61,95]),function(ee,e,g,F,S,E,C,y,_,k,n,I){"use strict";var l,d,u,m,b,w,P,a,f,v,t,r,s,i,c,h,p,D,T,o;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestMessage=e.TestRunRequest=e.TestRunProfileGroup=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function A(N){function M(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(M,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(M,N),Object.setPrototypeOf(M.prototype,N.prototype),M}let L=b=class{constructor(M){l.set(this,void 0),nt(this,l,M,"f")}static from(...M){let te=M;return new b(function(){if(te){for(const Ce of te)Ce&&typeof Ce.dispose=="function"&&Ce.dispose();te=void 0}})}dispose(){typeof Ue(this,l,"f")=="function"&&(Ue(this,l,"f").call(this),nt(this,l,void 0,"f"))}};l=new WeakMap,L=b=ze([A],L),e.Disposable=L;let $=w=class{constructor(M,te){if(M<0)throw(0,F.illegalArgument)("line must be non-negative");if(te<0)throw(0,F.illegalArgument)("character must be non-negative");this._line=M,this._character=te}static Min(...M){if(M.length===0)throw new TypeError;let te=M[0];for(let Ce=1;Ce<M.length;Ce++){const Ye=M[Ce];Ye.isBefore(te)&&(te=Ye)}return te}static Max(...M){if(M.length===0)throw new TypeError;let te=M[0];for(let Ce=1;Ce<M.length;Ce++){const Ye=M[Ce];Ye.isAfter(te)&&(te=Ye)}return te}static isPosition(M){if(!M)return!1;if(M instanceof w)return!0;let{line:te,character:Ce}=M;return typeof te=="number"&&typeof Ce=="number"}get line(){return this._line}get character(){return this._character}isBefore(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<M._character}isBeforeOrEqual(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<=M._character}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this._line===M._line&&this._character===M._character}compareTo(M){return this._line<M._line?-1:this._line>M.line?1:this._character<M._character?-1:this._character>M._character?1:0}translate(M,te=0){if(M===null||te===null)throw(0,F.illegalArgument)();let Ce;return typeof M=="undefined"?Ce=0:typeof M=="number"?Ce=M:(Ce=typeof M.lineDelta=="number"?M.lineDelta:0,te=typeof M.characterDelta=="number"?M.characterDelta:0),Ce===0&&te===0?this:new w(this.line+Ce,this.character+te)}with(M,te=this.character){if(M===null||te===null)throw(0,F.illegalArgument)();let Ce;return typeof M=="undefined"?Ce=this.line:typeof M=="number"?Ce=M:(Ce=typeof M.line=="number"?M.line:this.line,te=typeof M.character=="number"?M.character:this.character),Ce===this.line&&te===this.character?this:new w(Ce,te)}toJSON(){return{line:this.line,character:this.character}}};$=w=ze([A],$),e.Position=$;let oe=P=class{constructor(M,te,Ce,Ye){let it,rt;if(typeof M=="number"&&typeof te=="number"&&typeof Ce=="number"&&typeof Ye=="number"?(it=new $(M,te),rt=new $(Ce,Ye)):M instanceof $&&te instanceof $&&(it=M,rt=te),!it||!rt)throw new Error("Invalid arguments");it.isBefore(rt)?(this._start=it,this._end=rt):(this._start=rt,this._end=it)}static isRange(M){return M instanceof P?!0:M?$.isPosition(M.start)&&$.isPosition(M.end):!1}get start(){return this._start}get end(){return this._end}contains(M){return M instanceof P?this.contains(M._start)&&this.contains(M._end):M instanceof $?!(M.isBefore(this._start)||this._end.isBefore(M)):!1}isEqual(M){return this._start.isEqual(M._start)&&this._end.isEqual(M._end)}intersection(M){const te=$.Max(M.start,this._start),Ce=$.Min(M.end,this._end);if(!te.isAfter(Ce))return new P(te,Ce)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const te=$.Min(M.start,this._start),Ce=$.Max(M.end,this.end);return new P(te,Ce)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(M,te=this.end){if(M===null||te===null)throw(0,F.illegalArgument)();let Ce;return M?$.isPosition(M)?Ce=M:(Ce=M.start||this.start,te=M.end||this.end):Ce=this.start,Ce.isEqual(this._start)&&te.isEqual(this.end)?this:new P(Ce,te)}toJSON(){return[this.start,this.end]}};oe=P=ze([A],oe),e.Range=oe;let he=a=class extends oe{constructor(M,te,Ce,Ye){let it,rt;if(typeof M=="number"&&typeof te=="number"&&typeof Ce=="number"&&typeof Ye=="number"?(it=new $(M,te),rt=new $(Ce,Ye)):M instanceof $&&te instanceof $&&(it=M,rt=te),!it||!rt)throw new Error("Invalid arguments");super(it,rt);this._anchor=it,this._active=rt}static isSelection(M){return M instanceof a?!0:M?oe.isRange(M)&&$.isPosition(M.anchor)&&$.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};he=a=ze([A],he),e.Selection=he;class Q{constructor(M,te,Ce){if(typeof M!="string"||M.length===0)throw(0,F.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,F.illegalArgument)("port");if(typeof Ce!="undefined"&&(typeof Ce!="string"||Ce.length===0||!/^[0-9A-Za-z\-]+$/.test(Ce)))throw(0,F.illegalArgument)("connectionToken");this.host=M,this.port=Math.round(te),this.connectionToken=Ce}}e.ResolvedAuthority=Q;class z extends Error{constructor(M,te=I.RemoteAuthorityResolverErrorCode.Unknown,Ce){super(M);this._message=M,this._code=te,this._detail=Ce,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,z.prototype)}static NotAvailable(M,te){return new z(M,I.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(M){return new z(M,I.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=z;var V;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(V=e.EndOfLine||(e.EndOfLine={}));var R;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(R=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let G=f=class{constructor(M,te){this._range=M,this._newText=te}static isTextEdit(M){return M instanceof f?!0:M?oe.isRange(M)&&typeof M.newText=="string":!1}static replace(M,te){return new f(M,te)}static insert(M,te){return f.replace(new oe(M,M),te)}static delete(M){return f.replace(M,"")}static setEndOfLine(M){const te=new f(new oe(new $(0,0),new $(0,0)),"");return te.newEol=M,te}get range(){return this._range}set range(M){if(M&&!oe.isRange(M))throw(0,F.illegalArgument)("range");this._range=M}get newText(){return this._newText||""}set newText(M){if(M&&typeof M!="string")throw(0,F.illegalArgument)("newText");this._newText=M}get newEol(){return this._newEol}set newEol(M){if(M&&typeof M!="number")throw(0,F.illegalArgument)("newEol");this._newEol=M}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};G=f=ze([A],G),e.TextEdit=G;var x;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace"})(x=e.FileEditType||(e.FileEditType={}));let j=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(M,te,Ce,Ye){this._edits.push({_type:1,from:M,to:te,options:Ce,metadata:Ye})}createFile(M,te,Ce){this._edits.push({_type:1,from:void 0,to:M,options:te,metadata:Ce})}deleteFile(M,te,Ce){this._edits.push({_type:1,from:M,to:void 0,options:te,metadata:Ce})}replaceNotebookMetadata(M,te,Ce){this._edits.push({_type:3,metadata:Ce,uri:M,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(M,te,Ce,Ye,it){let rt,at,St=[],It;if(Bt.isNotebookRange(te)&&Lt.isNotebookCellDataArray(Ce)&&!Lt.isNotebookCellDataArray(Ye)?(rt=te.start,at=te.end,St=Ce,It=Ye):typeof te=="number"&&typeof Ce=="number"&&Lt.isNotebookCellDataArray(Ye)&&(rt=te,at=Ce,St=Ye,It=it),rt===void 0||at===void 0)throw new Error("Invalid arguments");(rt!==at||St.length>0)&&this._edits.push({_type:5,uri:M,index:rt,count:at-rt,cells:St,metadata:It})}replaceNotebookCellMetadata(M,te,Ce,Ye){this._edits.push({_type:3,metadata:Ye,uri:M,edit:{editType:8,index:te,metadata:Ce}})}replace(M,te,Ce,Ye){this._edits.push({_type:2,uri:M,edit:new G(te,Ce),metadata:Ye})}insert(M,te,Ce,Ye){this.replace(M,new oe(te,te),Ce,Ye)}delete(M,te,Ce){this.replace(M,te,"",Ce)}has(M){return this._edits.some(te=>te._type===2&&te.uri.toString()===M.toString())}set(M,te){if(te)for(const Ce of te)Ce&&this._edits.push({_type:2,uri:M,edit:Ce});else{for(let Ce=0;Ce<this._edits.length;Ce++){const Ye=this._edits[Ce];Ye._type===2&&Ye.uri.toString()===M.toString()&&(this._edits[Ce]=void 0)}(0,g.coalesceInPlace)(this._edits)}}get(M){const te=[];for(let Ce of this._edits)Ce._type===2&&Ce.uri.toString()===M.toString()&&te.push(Ce.edit);return te}entries(){const M=new E.ResourceMap;for(let te of this._edits)if(te._type===2){let Ce=M.get(te.uri);Ce||(Ce=[te.uri,[]],M.set(te.uri,Ce)),Ce[1].push(te.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};j=ze([A],j),e.WorkspaceEdit=j;let de=v=class{constructor(M){this._tabstop=1,this.value=M||""}static isSnippetString(M){return M instanceof v?!0:M?typeof M.value=="string":!1}static _escape(M){return M.replace(/\$|}|\\/g,"\\$&")}appendText(M){return this.value+=v._escape(M),this}appendTabstop(M=this._tabstop++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,te=this._tabstop++){if(typeof M=="function"){const Ce=new v;Ce._tabstop=this._tabstop,M(Ce),this._tabstop=Ce._tabstop,M=Ce.value}else M=v._escape(M);return this.value+="${",this.value+=te,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,te=this._tabstop++){const Ce=M.map(Ye=>Ye.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Ce,this.value+="|}",this}appendVariable(M,te){if(typeof te=="function"){const Ce=new v;Ce._tabstop=this._tabstop,te(Ce),this._tabstop=Ce._tabstop,te=Ce.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,te&&(this.value+=":",this.value+=te),this.value+="}",this}};de=v=ze([A],de),e.SnippetString=de;var B;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(B=e.DiagnosticTag||(e.DiagnosticTag={}));var ne;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(ne=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ue=t=class{constructor(M,te){if(this.uri=M,te)if(te instanceof oe)this.range=te;else if(te instanceof $)this.range=new oe(te,te);else throw new Error("Illegal argument")}static isLocation(M){return M instanceof t?!0:M?oe.isRange(M.range)&&_.URI.isUri(M.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ue=t=ze([A],ue),e.Location=ue;let ye=class{constructor(M,te){this.location=M,this.message=te}static is(M){return M?typeof M.message=="string"&&M.location&&oe.isRange(M.location.range)&&_.URI.isUri(M.location.uri):!1}static isEqual(M,te){return M===te?!0:!M||!te?!1:M.message===te.message&&M.location.range.isEqual(te.location.range)&&M.location.uri.toString()===te.location.uri.toString()}};ye=ze([A],ye),e.DiagnosticRelatedInformation=ye;let Re=class{constructor(M,te,Ce=ne.Error){if(!oe.isRange(M))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=M,this.message=te,this.severity=Ce}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,te){return M===te?!0:!M||!te?!1:M.message===te.message&&M.severity===te.severity&&M.code===te.code&&M.severity===te.severity&&M.source===te.source&&M.range.isEqual(te.range)&&(0,g.equals)(M.tags,te.tags)&&(0,g.equals)(M.relatedInformation,te.relatedInformation,ye.isEqual)}};Re=ze([A],Re),e.Diagnostic=Re;let Te=class{constructor(M,te){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:this.contents=[M],this.range=te}};Te=ze([A],Te),e.Hover=Te;var $e;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})($e=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Je=class{constructor(M,te=$e.Text){this.range=M,this.kind=te}toJSON(){return{range:this.range,kind:$e[this.kind]}}};Je=ze([A],Je),e.DocumentHighlight=Je;var Ve;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(Ve=e.SymbolKind||(e.SymbolKind={}));var je;(function(N){N[N.Deprecated=1]="Deprecated"})(je=e.SymbolTag||(e.SymbolTag={}));let O=r=class{constructor(M,te,Ce,Ye,it){this.name=M,this.kind=te,this.containerName=it,typeof Ce=="string"&&(this.containerName=Ce),Ye instanceof ue?this.location=Ye:Ce instanceof oe&&(this.location=new ue(Ye,Ce)),r.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ve[this.kind],location:this.location,containerName:this.containerName}}};O=r=ze([A],O),e.SymbolInformation=O;let K=s=class{constructor(M,te,Ce,Ye,it){this.name=M,this.detail=te,this.kind=Ce,this.range=Ye,this.selectionRange=it,this.children=[],s.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children&&M.children.forEach(s.validate)}};K=s=ze([A],K),e.DocumentSymbol=K;var X;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(X=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let se=class{constructor(M,te){this.title=M,this.kind=te}};se=ze([A],se),e.CodeAction=se;let q=i=class{constructor(M){this.value=M}append(M){return new i(this.value?this.value+i.sep+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+i.sep)}};q.sep=".",q=i=ze([A],q),e.CodeActionKind=q,q.Empty=new q(""),q.QuickFix=q.Empty.append("quickfix"),q.Refactor=q.Empty.append("refactor"),q.RefactorExtract=q.Refactor.append("extract"),q.RefactorInline=q.Refactor.append("inline"),q.RefactorRewrite=q.Refactor.append("rewrite"),q.Source=q.Empty.append("source"),q.SourceOrganizeImports=q.Source.append("organizeImports"),q.SourceFixAll=q.Source.append("fixAll");let ie=class{constructor(M,te){if(this.range=M,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ie=ze([A],ie),e.SelectionRange=ie;class ge{constructor(M,te,Ce,Ye,it,rt){this.kind=M,this.name=te,this.detail=Ce,this.uri=Ye,this.range=it,this.selectionRange=rt}}e.CallHierarchyItem=ge;class Le{constructor(M,te){this.fromRanges=te,this.from=M}}e.CallHierarchyIncomingCall=Le;class We{constructor(M,te){this.fromRanges=te,this.to=M}}e.CallHierarchyOutgoingCall=We;let ve=class{constructor(M,te){this.range=M,this.command=te}get isResolved(){return!!this.command}};ve=ze([A],ve),e.CodeLens=ve;let Xe=c=class{constructor(M,te=!1){d.set(this,void 0),nt(this,d,new S.MarkdownString(M,{supportThemeIcons:te}),"f")}static isMarkdownString(M){return M instanceof c?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}get value(){return Ue(this,d,"f").value}set value(M){Ue(this,d,"f").value=M}get isTrusted(){return Ue(this,d,"f").isTrusted}set isTrusted(M){Ue(this,d,"f").isTrusted=M}get supportThemeIcons(){return Ue(this,d,"f").supportThemeIcons}set supportThemeIcons(M){Ue(this,d,"f").supportThemeIcons=M}appendText(M){return Ue(this,d,"f").appendText(M),this}appendMarkdown(M){return Ue(this,d,"f").appendMarkdown(M),this}appendCodeblock(M,te){return Ue(this,d,"f").appendCodeblock(te??"",M),this}};d=new WeakMap,Xe=c=ze([A],Xe),e.MarkdownString=Xe;let H=class{constructor(M,te){this.label=M,this.documentation=te}};H=ze([A],H),e.ParameterInformation=H;let Z=class{constructor(M,te){this.label=M,this.documentation=te,this.parameters=[]}};Z=ze([A],Z),e.SignatureInformation=Z;let ce=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ce=ze([A],ce),e.SignatureHelp=ce;var Be;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(Be=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var xe;(function(N){N[N.Other=0]="Other",N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(xe=e.InlayHintKind||(e.InlayHintKind={}));let Ze=class{constructor(M,te,Ce){this.text=M,this.position=te,this.kind=Ce}};Ze=ze([A],Ze),e.InlayHint=Ze;var De;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(De=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Se;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(Se=e.CompletionItemKind||(e.CompletionItemKind={}));var Pe;(function(N){N[N.Deprecated=1]="Deprecated"})(Pe=e.CompletionItemTag||(e.CompletionItemTag={}));let re=class{constructor(M,te){this.label=M,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&Se[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};re=ze([A],re),e.CompletionItem=re;let ae=class{constructor(M=[],te=!1){this.items=M,this.isIncomplete=te}};ae=ze([A],ae),e.CompletionList=ae;let fe=class{constructor(M,te,Ce){this.text=M,this.range=te,this.command=Ce}};fe=ze([A],fe),e.InlineSuggestion=fe;let pe=class{constructor(M){this.items=M}};pe=ze([A],pe),e.InlineSuggestions=pe;var U;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(U=e.ViewColumn||(e.ViewColumn={}));var me;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(me=e.StatusBarAlignment||(e.StatusBarAlignment={}));var we;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(we=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ie;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(Ie=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Oe;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(Oe=e.TextEditorRevealType||(e.TextEditorRevealType={}));var He;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(He=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var et;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(et=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Ke;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(Ke=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function M(te){switch(te){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=M}(He=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ge=class{constructor(M,te){if(te&&!_.URI.isUri(te))throw(0,F.illegalArgument)("target");if(!oe.isRange(M)||M.isEmpty)throw(0,F.illegalArgument)("range");this.range=M,this.target=te}};Ge=ze([A],Ge),e.DocumentLink=Ge;let lt=class{constructor(M,te,Ce,Ye){this.red=M,this.green=te,this.blue=Ce,this.alpha=Ye}};lt=ze([A],lt),e.Color=lt;let ft=class{constructor(M,te){if(te&&!(te instanceof lt))throw(0,F.illegalArgument)("color");if(!oe.isRange(M)||M.isEmpty)throw(0,F.illegalArgument)("range");this.range=M,this.color=te}};ft=ze([A],ft),e.ColorInformation=ft;let _t=class{constructor(M){if(!M||typeof M!="string")throw(0,F.illegalArgument)("label");this.label=M}};_t=ze([A],_t),e.ColorPresentation=_t;var ut;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(ut=e.ColorFormat||(e.ColorFormat={}));var ot;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(ot=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class _e{constructor(M,te,Ce){if(this.startIndex=M,this.length=te,this.tooltip=Ce,typeof M!="number"||M<0)throw(0,F.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,F.illegalArgument)("length");if(Ce!==void 0&&typeof Ce!="string")throw(0,F.illegalArgument)("tooltip")}}e.TerminalLink=_e;class ke{constructor(M){this.options=M,typeof M!="object"&&(0,F.illegalArgument)("options")}}e.TerminalProfile=ke;var Y;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(Y=e.TaskRevealKind||(e.TaskRevealKind={}));var W;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(W=e.TaskPanelKind||(e.TaskPanelKind={}));let Fe=h=class{constructor(M,te){if(typeof M!="string"||typeof te!="string")throw(0,F.illegalArgument)("name");this._id=M}static from(M){switch(M){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}get id(){return this._id}};Fe.Clean=new h("clean","Clean"),Fe.Build=new h("build","Build"),Fe.Rebuild=new h("rebuild","Rebuild"),Fe.Test=new h("test","Test"),Fe=h=ze([A],Fe),e.TaskGroup=Fe;function Me(N){let M="";for(let te=0;te<N.length;te++)M+=N[te].replace(/,/g,",,")+",";return M}let tt=class{constructor(M,te,Ce){if(typeof M!="string")throw(0,F.illegalArgument)("process");this._args=[],this._process=M,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=Ce):this._options=te)}get process(){return this._process}set process(M){if(typeof M!="string")throw(0,F.illegalArgument)("process");this._process=M}get args(){return this._args}set args(M){Array.isArray(M)||(M=[]),this._args=M}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("process"),this._process!==void 0&&M.push(this._process),this._args&&this._args.length>0)for(let te of this._args)M.push(te);return Me(M)}};tt=ze([A],tt),e.ProcessExecution=tt;let Qe=class{constructor(M,te,Ce){if(this._args=[],Array.isArray(te)){if(!M)throw(0,F.illegalArgument)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,F.illegalArgument)("command");this._command=M,this._args=te,this._options=Ce}else{if(typeof M!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=M,this._options=te}}get commandLine(){return this._commandLine}set commandLine(M){if(typeof M!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=M}get command(){return this._command?this._command:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,F.illegalArgument)("command");this._command=M}get args(){return this._args}set args(M){this._args=M||[]}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("shell"),this._commandLine!==void 0&&M.push(this._commandLine),this._command!==void 0&&M.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)M.push(typeof te=="string"?te:te.value);return Me(M)}};Qe=ze([A],Qe),e.ShellExecution=Qe;var dt;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(dt=e.ShellQuoting||(e.ShellQuoting={}));var yt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(yt=e.TaskScope||(e.TaskScope={}));class kt{constructor(M){this._callback=M}computeId(){return"customExecution"+(0,k.generateUuid)()}set callback(M){this._callback=M}get callback(){return this._callback}}e.CustomExecution=kt;let bt=p=class{constructor(M,te,Ce,Ye,it,rt){this.__deprecated=!1,this._definition=this.definition=M;let at;typeof te=="string"?(this._name=this.name=te,this._source=this.source=Ce,this.execution=Ye,at=it,this.__deprecated=!0):te===yt.Global||te===yt.Workspace?(this.target=te,this._name=this.name=Ce,this._source=this.source=Ye,this.execution=it,at=rt):(this.target=te,this._name=this.name=Ce,this._source=this.source=Ye,this.execution=it,at=rt),typeof at=="string"?(this._problemMatchers=[at],this._hasDefinedMatchers=!0):Array.isArray(at)?(this._problemMatchers=at,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(M){this.__id=M}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof tt?this._definition={type:p.ProcessType,id:this._execution.computeId()}:this._execution instanceof Qe?this._definition={type:p.ShellType,id:this._execution.computeId()}:this._execution instanceof kt?this._definition={type:p.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:p.EmptyType,id:(0,k.generateUuid)()}}get definition(){return this._definition}set definition(M){if(M==null)throw(0,F.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=M}get scope(){return this._scope}set target(M){this.clear(),this._scope=M}get name(){return this._name}set name(M){if(typeof M!="string")throw(0,F.illegalArgument)("name");this.clear(),this._name=M}get execution(){return this._execution}set execution(M){M===null&&(M=void 0),this.clear(),this._execution=M;const te=this._definition.type;(p.EmptyType===te||p.ProcessType===te||p.ShellType===te||p.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(M){if(Array.isArray(M))this.clear(),this._problemMatchers=M,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.clear(),this._isBackground=M}get source(){return this._source}set source(M){if(typeof M!="string"||M.length===0)throw(0,F.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=M}get group(){return this._group}set group(M){M===null&&(M=void 0),this.clear(),this._group=M}get detail(){return this._detail}set detail(M){M===null&&(M=void 0),this._detail=M}get presentationOptions(){return this._presentationOptions}set presentationOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._presentationOptions=M}get runOptions(){return this._runOptions}set runOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._runOptions=M}};bt.ExtensionCallbackType="customExecution",bt.ProcessType="process",bt.ShellType="shell",bt.EmptyType="$empty",bt=p=ze([A],bt),e.Task=bt;var mt;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(mt=e.ProgressLocation||(e.ProgressLocation={}));let ct=class{constructor(M,te=Et.None){this.collapsibleState=te,_.URI.isUri(M)?this.resourceUri=M:this.label=M}};ct=ze([A],ct),e.TreeItem=ct;var Et;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(Et=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let gt=class{constructor(M,te){this.id=M,this.color=te}};gt=ze([A],gt),e.ThemeIcon=gt,gt.File=new gt("file"),gt.Folder=new gt("folder");let Ot=class{constructor(M){this.id=M}};Ot=ze([A],Ot),e.ThemeColor=Ot;var Pt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(Pt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Kt=class{constructor(M,te){if(typeof M!="string"&&(!M||!_.URI.isUri(M)&&!_.URI.isUri(M.uri)))throw(0,F.illegalArgument)("base");if(typeof te!="string")throw(0,F.illegalArgument)("pattern");typeof M=="string"?(this.baseFolder=_.URI.file(M),this.base=M):_.URI.isUri(M)?(this.baseFolder=M,this.base=M.fsPath):(this.baseFolder=M.uri,this.base=M.uri.fsPath),this.pattern=te}};Kt=ze([A],Kt),e.RelativePattern=Kt;let Ut=class{constructor(M,te,Ce,Ye){this.enabled=typeof M=="boolean"?M:!0,typeof te=="string"&&(this.condition=te),typeof Ce=="string"&&(this.hitCondition=Ce),typeof Ye=="string"&&(this.logMessage=Ye)}get id(){return this._id||(this._id=(0,k.generateUuid)()),this._id}};Ut=ze([A],Ut),e.Breakpoint=Ut;let Ct=class extends Ut{constructor(M,te,Ce,Ye,it){super(te,Ce,Ye,it);if(M===null)throw(0,F.illegalArgument)("location");this.location=M}};Ct=ze([A],Ct),e.SourceBreakpoint=Ct;let Qt=class extends Ut{constructor(M,te,Ce,Ye,it){super(te,Ce,Ye,it);this.functionName=M}};Qt=ze([A],Qt),e.FunctionBreakpoint=Qt;let Yt=class extends Ut{constructor(M,te,Ce,Ye,it,rt,at){super(Ye,it,rt,at);if(!te)throw(0,F.illegalArgument)("dataId");this.label=M,this.dataId=te,this.canPersist=Ce}};Yt=ze([A],Yt),e.DataBreakpoint=Yt;let pt=class{constructor(M,te,Ce){this.command=M,this.args=te||[],this.options=Ce}};pt=ze([A],pt),e.DebugAdapterExecutable=pt;let qt=class{constructor(M,te){this.port=M,this.host=te}};qt=ze([A],qt),e.DebugAdapterServer=qt;let zt=class{constructor(M){this.path=M}};zt=ze([A],zt),e.DebugAdapterNamedPipeServer=zt;let Jt=class{constructor(M){this.implementation=M}};Jt=ze([A],Jt),e.DebugAdapterInlineImplementation=Jt;let Xt=class{constructor(M,te){this.range=M,this.expression=te}};Xt=ze([A],Xt),e.EvaluatableExpression=Xt;var At;(function(N){N[N.Automatic=0]="Automatic",N[N.Explicit=1]="Explicit"})(At=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let jt=class{constructor(M,te){this.range=M,this.text=te}};jt=ze([A],jt),e.InlineValueText=jt;let Zt=class{constructor(M,te,Ce=!0){this.range=M,this.variableName=te,this.caseSensitiveLookup=Ce}};Zt=ze([A],Zt),e.InlineValueVariableLookup=Zt;let Ht=class{constructor(M,te){this.range=M,this.expression=te}};Ht=ze([A],Ht),e.InlineValueEvaluatableExpression=Ht;let ht=class{constructor(M,te){this.frameId=M,this.stoppedLocation=te}};ht=ze([A],ht),e.InlineValueContext=ht;var En;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(En=e.FileChangeType||(e.FileChangeType={}));let Rt=D=class extends Error{constructor(M,te=n.FileSystemProviderErrorCode.Unknown,Ce){super(_.URI.isUri(M)?M.toString(!0):M);this.code=Ce?.name??"Unknown",(0,n.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype),typeof Error.captureStackTrace=="function"&&typeof Ce=="function"&&Error.captureStackTrace(this,Ce)}static FileExists(M){return new D(M,n.FileSystemProviderErrorCode.FileExists,D.FileExists)}static FileNotFound(M){return new D(M,n.FileSystemProviderErrorCode.FileNotFound,D.FileNotFound)}static FileNotADirectory(M){return new D(M,n.FileSystemProviderErrorCode.FileNotADirectory,D.FileNotADirectory)}static FileIsADirectory(M){return new D(M,n.FileSystemProviderErrorCode.FileIsADirectory,D.FileIsADirectory)}static NoPermissions(M){return new D(M,n.FileSystemProviderErrorCode.NoPermissions,D.NoPermissions)}static Unavailable(M){return new D(M,n.FileSystemProviderErrorCode.Unavailable,D.Unavailable)}};Rt=D=ze([A],Rt),e.FileSystemError=Rt;let xt=class{constructor(M,te,Ce){this.start=M,this.end=te,this.kind=Ce}};xt=ze([A],xt),e.FoldingRange=xt;var cn;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(cn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var _n;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(_n=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var dn;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(dn=e.CommentMode||(e.CommentMode={}));class yn{constructor(M,te=[]){this.tokenTypes=M,this.tokenModifiers=te}}e.SemanticTokensLegend=yn;function hn(N){return typeof N=="undefined"||(0,y.isStringArray)(N)}class Vt{constructor(M){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,M){this._hasLegend=!0;for(let te=0,Ce=M.tokenTypes.length;te<Ce;te++)this._tokenTypeStrToInt.set(M.tokenTypes[te],te);for(let te=0,Ce=M.tokenModifiers.length;te<Ce;te++)this._tokenModifierStrToInt.set(M.tokenModifiers[te],te)}}push(M,te,Ce,Ye,it){if(typeof M=="number"&&typeof te=="number"&&typeof Ce=="number"&&typeof Ye=="number"&&(typeof it=="number"||typeof it=="undefined"))return typeof it=="undefined"&&(it=0),this._pushEncoded(M,te,Ce,Ye,it);if(oe.isRange(M)&&typeof te=="string"&&hn(Ce))return this._push(M,te,Ce);throw(0,F.illegalArgument)()}_push(M,te,Ce){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const Ye=M.start.line,it=M.start.character,rt=M.end.character-M.start.character,at=this._tokenTypeStrToInt.get(te);let St=0;if(Ce)for(const It of Ce){if(!this._tokenModifierStrToInt.has(It))throw new Error("`tokenModifier` is not in the provided legend");const Mt=this._tokenModifierStrToInt.get(It);St|=1<<Mt>>>0}this._pushEncoded(Ye,it,rt,at,St)}_pushEncoded(M,te,Ce,Ye,it){if(this._dataIsSortedAndDeltaEncoded&&(M<this._prevLine||M===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let It=0,Mt=0;for(let Nt=0;Nt<St;Nt++){let $t=this._data[5*Nt],ln=this._data[5*Nt+1];$t===0?($t=It,ln+=Mt):$t+=It,this._data[5*Nt]=$t,this._data[5*Nt+1]=ln,It=$t,Mt=ln}}let rt=M,at=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(rt-=this._prevLine,rt===0&&(at-=this._prevChar)),this._data[this._dataLen++]=rt,this._data[this._dataLen++]=at,this._data[this._dataLen++]=Ce,this._data[this._dataLen++]=Ye,this._data[this._dataLen++]=it,this._prevLine=M,this._prevChar=te}static _sortAndDeltaEncode(M){let te=[];const Ce=M.length/5|0;for(let at=0;at<Ce;at++)te[at]=at;te.sort((at,St)=>{const It=M[5*at],Mt=M[5*St];if(It===Mt){const Nt=M[5*at+1],$t=M[5*St+1];return Nt-$t}return It-Mt});const Ye=new Uint32Array(M.length);let it=0,rt=0;for(let at=0;at<Ce;at++){const St=5*te[at],It=M[St+0],Mt=M[St+1],Nt=M[St+2],$t=M[St+3],ln=M[St+4],On=It-it,qn=On===0?Mt-rt:Mt,un=5*at;Ye[un+0]=On,Ye[un+1]=qn,Ye[un+2]=Nt,Ye[un+3]=$t,Ye[un+4]=ln,it=It,rt=Mt}return Ye}build(M){return this._dataIsSortedAndDeltaEncoded?new en(new Uint32Array(this._data),M):new en(Vt._sortAndDeltaEncode(this._data),M)}}e.SemanticTokensBuilder=Vt;class en{constructor(M,te){this.resultId=te,this.data=M}}e.SemanticTokens=en;class tn{constructor(M,te,Ce){this.start=M,this.deleteCount=te,this.data=Ce}}e.SemanticTokensEdit=tn;class nn{constructor(M,te){this.resultId=te,this.edits=M}}e.SemanticTokensEdits=nn;var Sn;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(Sn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Dn;(function(N){N[N.Initial=1]="Initial",N[N.Dynamic=2]="Dynamic"})(Dn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Ft=class{constructor(){}};Ft.Back={iconPath:new gt("arrow-left")},Ft=ze([A],Ft),e.QuickInputButtons=Ft;var Cn;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Cn=e.ExtensionKind||(e.ExtensionKind={}));class kn{constructor(M,te,Ce){this.badge=M,this.tooltip=te,this.color=Ce}static validate(M){if(M.badge&&M.badge.length!==1&&M.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=kn;let rn=class{constructor(M){this.kind=M}};rn=ze([A],rn),e.ColorTheme=rn;var In;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast"})(In=e.ColorThemeKind||(e.ColorThemeKind={}));class Bt{constructor(M,te){if(M<0)throw(0,F.illegalArgument)("start must be positive");if(te<0)throw(0,F.illegalArgument)("end must be positive");M<=te?(this._start=M,this._end=te):(this._start=te,this._end=M)}static isNotebookRange(M){return M instanceof Bt?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(M){let te=this._start,Ce=this._end;return M.start!==void 0&&(te=M.start),M.end!==void 0&&(Ce=M.end),te===this._start&&Ce===this._end?this:new Bt(te,Ce)}}e.NotebookRange=Bt;class Lt{constructor(M,te,Ce,Ye,it,rt,at){this.kind=M,this.value=te,this.languageId=Ce,this.mime=Ye,this.outputs=it??[],this.metadata=rt,this.executionSummary=at,Lt.validate(this)}static validate(M){if(typeof M.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof M.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof M.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(te=>Lt.isNotebookCellData(te))}static isNotebookCellData(M){return!0}}e.NotebookCellData=Lt;class fn{constructor(M){this.cells=M}}e.NotebookData=fn;class Tt{constructor(M,te){this.data=M,this.mime=te;const Ce=(0,C.normalizeMimeType)(te,!0);if(!Ce)throw new Error("INVALID mime type, must not be empty or falsy: "+te);this.mime=Ce}static isNotebookCellOutputItem(M){return M instanceof Tt?!0:M?typeof M.mime=="string"&&M.data instanceof Uint8Array:!1}static error(M){const te={name:M.name,message:M.message,stack:M.stack};return Tt.json(te,"application/vnd.code.notebook.error")}static stdout(M){return Tt.text(M,"application/vnd.code.notebook.stdout")}static stderr(M){return Tt.text(M,"application/vnd.code.notebook.stderr")}static bytes(M,te="application/octet-stream"){return new Tt(M,te)}static text(M,te=C.Mimes.text){const Ce=Ue(Tt,u,"f",m).encode(String(M));return new Tt(Ce,te)}static json(M,te="application/json"){const Ce=JSON.stringify(M,void 0,"	");return Tt.text(Ce,te)}}e.NotebookCellOutputItem=Tt,u=Tt,m={value:new TextEncoder};class Ne{constructor(M,te,Ce){this.items=Ne.ensureUniqueMimeTypes(M,!0),typeof te=="string"?(this.id=te,this.metadata=Ce):(this.id=(0,k.generateUuid)(),this.metadata=te??Ce)}static isNotebookCellOutput(M){return M instanceof Ne?!0:!M||typeof M!="object"?!1:typeof M.id=="string"&&(0,y.isArray)(M.items)}static ensureUniqueMimeTypes(M,te=!1){const Ce=new Set,Ye=new Set;for(let it=0;it<M.length;it++){const rt=M[it],at=(0,C.normalizeMimeType)(rt.mime);if(!Ce.has(at)){Ce.add(at);continue}Ye.add(it),te&&console.warn(`DUPLICATED mime type '${rt.mime}' will be dropped`)}return Ye.size===0?M:M.filter((it,rt)=>!Ye.has(rt))}}e.NotebookCellOutput=Ne;var sn;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(sn=e.NotebookCellKind||(e.NotebookCellKind={}));var mn;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(mn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var vt;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(vt=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pn;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(Pn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class An{constructor(M,te){this.text=M,this.alignment=te}}e.NotebookCellStatusBarItem=An;var gn;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(gn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class pn{constructor(M,te=[]){this.uri=M,this.provides=(0,g.asArray)(te)}}e.NotebookRendererScript=pn;let on=class{constructor(M,te){this.label=M,this.timestamp=te}};on=ze([A],on),e.TimelineItem=on;var Tn;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(Tn=e.ExtensionMode||(e.ExtensionMode={}));var Rn;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(Rn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Fn;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=4]="RegEx"})(Fn=e.StandardTokenType||(e.StandardTokenType={}));class vn{constructor(M,te){this.ranges=M,this.wordPattern=te}}e.LinkedEditingRanges=vn;class Mn{constructor(M,te){this._port=M,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Mn;var Ln;(function(N){N[N.Unset=0]="Unset",N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(Ln=e.TestResultState||(e.TestResultState={}));var wn;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information",N[N.Hint=3]="Hint"})(wn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var Nn;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(Nn=e.TestRunProfileGroup||(e.TestRunProfileGroup={}));let an=class{constructor(M,te,Ce){this.include=M,this.exclude=te,this.profile=Ce}};an=ze([A],an),e.TestRunRequest=an;let J=T=class{constructor(M){this.message=M,this.severity=wn.Error}static diff(M,te,Ce){const Ye=new T(M);return Ye.expectedOutput=te,Ye.actualOutput=Ce,Ye}};J=T=ze([A],J),e.TestMessage=J;let le=class{constructor(M,te){this.covered=M,this.total=te}};le=ze([A],le),e.CoveredCount=le;let Ae=o=class{constructor(M,te,Ce,Ye){this.uri=M,this.statementCoverage=te,this.branchCoverage=Ce,this.functionCoverage=Ye}static fromDetails(M,te){const Ce=new le(0,0),Ye=new le(0,0),it=new le(0,0);for(const at of te)if("branches"in at){Ce.total+=1,Ce.covered+=at.executionCount>0?1:0;for(const St of at.branches)Ye.total+=1,Ye.covered+=St.executionCount>0?1:0}else it.total+=1,it.covered+=at.executionCount>0?1:0;const rt=new o(M,Ce,Ye.total>0?Ye:void 0,it.total>0?it:void 0);return rt.detailedCoverage=te,rt}};Ae=o=ze([A],Ae),e.FileCoverage=Ae;let st=class{constructor(M,te,Ce=[]){this.executionCount=M,this.location=te,this.branches=Ce}};st=ze([A],st),e.StatementCoverage=st;let wt=class{constructor(M,te){this.executionCount=M,this.location=te}};wt=ze([A],wt),e.BranchCoverage=wt;let Dt=class{constructor(M,te){this.executionCount=M,this.location=te}};Dt=ze([A],Dt),e.FunctionCoverage=Dt;var Wn;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(Wn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Hn;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(Hn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var zn;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(zn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Vn{constructor(M,te,Ce,Ye,it,rt){this.kind=M,this.name=te,this.detail=Ce,this.uri=Ye,this.range=it,this.selectionRange=rt}}e.TypeHierarchyItem=Vn}),define(be[98],Ee([0,1,40,11,8,124,88,7,17]),function(ee,e,g,F,S,E,C,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function n(u,m){m?k.set(u,m):k.delete(u)}e.setWordDefinitionFor=n;function I(u){return k.get(u)}e.getWordDefinitionFor=I;class l extends E.MirrorTextModel{constructor(m,b,w,P,a,f,v,t){super(b,w,P,a);this._proxy=m,this._languageId=f,this._isDirty=v,this._notebook=t,this._isDisposed=!1}dispose(){(0,g.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(m){return(0,_.equals)(this._lines,m)}get document(){if(!this._document){const m=this;this._document={get uri(){return m._uri},get fileName(){return m._uri.fsPath},get isUntitled(){return m._uri.scheme===F.Schemas.untitled},get languageId(){return m._languageId},get version(){return m._versionId},get isClosed(){return m._isDisposed},get isDirty(){return m._isDirty},get notebook(){return m._notebook},save(){return m._save()},getText(b){return b?m._getTextInRange(b):m.getText()},get eol(){return m._eol===`
`?y.EndOfLine.LF:y.EndOfLine.CRLF},get lineCount(){return m._lines.length},lineAt(b){return m._lineAt(b)},offsetAt(b){return m._offsetAt(b)},positionAt(b){return m._positionAt(b)},validateRange(b){return m._validateRange(b)},validatePosition(b){return m._validatePosition(b)},getWordRangeAtPosition(b,w){return m._getWordRangeAtPosition(b,w)}}}return Object.freeze(this._document)}_acceptLanguageId(m){(0,g.ok)(!this._isDisposed),this._languageId=m}_acceptIsDirty(m){(0,g.ok)(!this._isDisposed),this._isDirty=m}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(m){const b=this._validateRange(m);if(b.isEmpty)return"";if(b.isSingleLine)return this._lines[b.start.line].substring(b.start.character,b.end.character);const w=this._eol,P=b.start.line,a=b.end.line,f=[];f.push(this._lines[P].substring(b.start.character));for(let v=P+1;v<a;v++)f.push(this._lines[v]);return f.push(this._lines[a].substring(0,b.end.character)),f.join(w)}_lineAt(m){let b;if(m instanceof y.Position?b=m.line:typeof m=="number"&&(b=m),typeof b!="number"||b<0||b>=this._lines.length||Math.floor(b)!==b)throw new Error("Illegal value for `line`");return new d(b,this._lines[b],b===this._lines.length-1)}_offsetAt(m){return m=this._validatePosition(m),this._ensureLineStarts(),this._lineStarts.getPrefixSum(m.line-1)+m.character}_positionAt(m){m=Math.floor(m),m=Math.max(0,m),this._ensureLineStarts();const b=this._lineStarts.getIndexOf(m),w=this._lines[b.index].length;return new y.Position(b.index,Math.min(b.remainder,w))}_validateRange(m){if(!(m instanceof y.Range))throw new Error("Invalid argument");const b=this._validatePosition(m.start),w=this._validatePosition(m.end);return b===m.start&&w===m.end?m:new y.Range(b.line,b.character,w.line,w.character)}_validatePosition(m){if(!(m instanceof y.Position))throw new Error("Invalid argument");if(this._lines.length===0)return m.with(0,0);let{line:b,character:w}=m,P=!1;if(b<0)b=0,w=0,P=!0;else if(b>=this._lines.length)b=this._lines.length-1,w=this._lines[b].length,P=!0;else{const a=this._lines[b].length;w<0?(w=0,P=!0):w>a&&(w=a,P=!0)}return P?new y.Position(b,w):m}_getWordRangeAtPosition(m,b){const w=this._validatePosition(m);if(!b)b=I(this._languageId);else if((0,S.regExpLeadsToEndlessLoop)(b))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${b.source}' because it matches the empty string.`);const P=(0,C.getWordAtText)(w.character+1,(0,C.ensureValidWordDefinition)(b),this._lines[w.line],0);if(P)return new y.Range(w.line,P.startColumn-1,w.line,P.endColumn-1)}}e.ExtHostDocumentData=l;class d{constructor(m,b,w){this._line=m,this._text=b,this._isLastLine=w}get lineNumber(){return this._line}get text(){return this._text}get range(){return new y.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new y.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=d}),define(be[165],Ee([0,1,7,3,90,6,57,21,2,36]),function(ee,e,g,F,S,E,C,y,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class n{constructor(l,d,u,m){this._notebook=u,this._selector=m,this._disposables=new E.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this.uri=_.URI.from({scheme:"vscode-concat-doc",path:(0,k.generateUuid)()}),this._init(),this._disposables.add(d.onDidChangeDocument(w=>{const P=this._cellUris.get(w.document.uri);P!==void 0&&(this._cellLengths.changeValue(P,this._cells[P].document.getText().length+1),this._cellLines.changeValue(P,this._cells[P].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const b=w=>{w===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(l.onDidChangeNotebookCells(w=>b(w.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new y.ResourceMap;const l=[],d=[];for(const u of this._notebook.getCells())u.kind===g.NotebookCellKind.Code&&(!this._selector||(0,C.score)(this._selector,u.document.uri,u.document.languageId,!0))&&(this._cellUris.set(u.document.uri,this._cells.length),this._cells.push(u),l.push(u.document.getText().length+1),d.push(u.document.lineCount));this._cellLengths=new S.PrefixSumComputer(new Uint32Array(l)),this._cellLines=new S.PrefixSumComputer(new Uint32Array(d))}get version(){return this._versionId}getText(l){if(!l){let P="";for(const a of this._cells)P+=a.document.getText()+`
`;return P=P.slice(0,-1),P}if(l.isEmpty)return"";const d=this.locationAt(l.start),u=this.locationAt(l.end),m=this._cellUris.get(d.uri),b=this._cellUris.get(u.uri);if(m===void 0||b===void 0)return"";if(m===b)return this._cells[m].document.getText(new g.Range(d.range.start,u.range.end));const w=[this._cells[m].document.getText(new g.Range(d.range.start,new g.Position(this._cells[m].document.lineCount,0)))];for(let P=m+1;P<b;P++)w.push(this._cells[P].document.getText());return w.push(this._cells[b].document.getText(new g.Range(new g.Position(0,0),u.range.end))),w.join(`
`)}offsetAt(l){const d=this._cellLines.getIndexOf(l.line),u=this._cellLengths.getPrefixSum(d.index-1),m=this._cells[d.index].document.offsetAt(l.with(d.remainder));return u+m}positionAt(l){if(typeof l=="number"){const u=this._cellLengths.getIndexOf(l),m=this._cellLines.getPrefixSum(u.index-1);return this._cells[u.index].document.positionAt(u.remainder).translate(m)}const d=this._cellUris.get(l.uri);if(d!==void 0){const u=this._cellLines.getPrefixSum(d-1);return new g.Position(u+l.range.start.line,l.range.start.character)}return new g.Position(0,0)}locationAt(l){g.Range.isRange(l)||(l=new g.Range(l,l));const d=this._cellLines.getIndexOf(l.start.line);let u=d;l.isEmpty||(u=this._cellLines.getIndexOf(l.end.line));const m=new g.Position(d.remainder,l.start.character),b=new g.Position(u.remainder,l.end.character),w=new g.Range(m,b),P=this._cells[d.index];return new g.Location(P.document.uri,P.document.validateRange(w))}contains(l){return this._cellUris.has(l)}validateRange(l){const d=this.validatePosition(l.start),u=this.validatePosition(l.end);return l.with(d,u)}validatePosition(l){const d=this._cellLines.getIndexOf(l.line),u=new g.Position(d.remainder,l.character),m=this._cells[d.index].document.validatePosition(u),b=this._cellLines.getPrefixSum(d.index-1);return new g.Position(b+m.line,m.character)}}e.ExtHostNotebookConcatDocument=n}),define(be[166],Ee([0,1,7,13,3]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let E=class{constructor(y){this._actual=new g.ColorTheme(g.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new S.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(y){let _=y==="light"?g.ColorThemeKind.Light:y==="dark"?g.ColorThemeKind.Dark:g.ColorThemeKind.HighContrast;this._actual=new g.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};E=ze([qe(0,F.IExtHostRpcService)],E),e.ExtHostTheming=E}),define(be[69],Ee([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,g.createDecorator)("IURITransformerService");class F{constructor(E){E?(this.transformIncoming=E.transformIncoming.bind(E),this.transformOutgoing=E.transformOutgoing.bind(E),this.transformOutgoingURI=E.transformOutgoingURI.bind(E),this.transformOutgoingScheme=E.transformOutgoingScheme.bind(E)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=F}),define(be[167],Ee([0,1,24]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class F{constructor(){this.buffers=[]}add(_){let k=this.buffers.indexOf(_);return k<0&&(k=this.buffers.length,this.buffers.push(_)),k}}function S(y,_){if(_.serializeBuffersForPostMessage){const k=new F,n=(d,u)=>{if(u instanceof ArrayBuffer){const m=k.add(u);return{$$vscode_array_buffer_reference$$:!0,index:m}}else if(ArrayBuffer.isView(u)){const m=E(u);if(m){const b=k.add(u.buffer);return{$$vscode_array_buffer_reference$$:!0,index:b,view:{type:m,byteLength:u.byteLength,byteOffset:u.byteOffset}}}}return u},I=JSON.stringify(y,n),l=k.buffers.map(d=>{const u=new Uint8Array(d);return g.VSBuffer.wrap(u)});return{message:I,buffers:l}}else return{message:JSON.stringify(y),buffers:[]}}e.serializeWebviewMessage=S;function E(y){switch(y.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function C(y,_){const k=_.map(l=>{const d=new ArrayBuffer(l.byteLength);return new Uint8Array(d).set(l.buffer),d}),n=_.length?(l,d)=>{if(typeof d=="object"&&d.$$vscode_array_buffer_reference$$){const u=d,{index:m}=u,b=k[m];if(u.view)switch(u.view.type){case 1:return new Int8Array(b,u.view.byteOffset,u.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(b,u.view.byteOffset,u.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(b,u.view.byteOffset,u.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(b,u.view.byteOffset,u.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(b,u.view.byteOffset,u.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(b,u.view.byteOffset,u.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(b,u.view.byteOffset,u.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(b,u.view.byteOffset,u.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(b,u.view.byteOffset,u.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(b,u.view.byteOffset,u.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(b,u.view.byteOffset,u.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return b}return d}:void 0;return{message:JSON.parse(y,n),arrayBuffers:k}}e.deserializeWebviewMessage=C}),define(be[168],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var g;(function(F){function S(C){const y={items:new Map};return C.types.forEach((_,k)=>{y.items.set(_,{asString:async()=>C.items[k].asString})}),y}F.toITreeDataTransfer=S;async function E(C){const y={types:[],items:[]},_=Array.from(C.items.entries());for(const k of _)y.types.push(k[0]),y.items.push({asString:await k[1].asString()});return y}F.toTreeDataTransferDTO=E})(g=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(be[70],Ee([0,1,11,2]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function S(E,C){return E.scheme===g.Schemas.http||E.scheme===g.Schemas.https?E:(C&&C.authority&&C.isRemote&&E.scheme===g.Schemas.file&&(E=F.URI.from({scheme:g.Schemas.vscodeRemote,authority:C.authority,path:E.path})),F.URI.from({scheme:g.Schemas.https,authority:`${E.scheme}+${E.authority}.${e.webviewRootResourceAuthority}`,path:E.path,fragment:E.fragment,query:E.query}))}e.asWebviewUri=S}),define(be[169],Ee([0,1,3,6,70]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class E{constructor(y,_,k){this._proxy=y,this._editors=_,this._initData=k,this._handlePool=0,this._disposables=new F.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const n=_.getVisibleTextEditors();for(const I of this._insets.values())n.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(y=>y.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(y,_,k,n,I){let l;for(const a of this._editors.getVisibleTextEditors(!0))if(a.value===y){l=a;break}if(!l)throw new Error("not a visible editor");const d=this,u=this._handlePool++,m=new g.Emitter,b=new g.Emitter,w=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(a){return(0,S.asWebviewUri)(a,d._initData.remote)}get cspSource(){return S.webviewGenericCspSource}set options(a){this._options=a,d._proxy.$setOptions(u,a)}get options(){return this._options}set html(a){this._html=a,d._proxy.$setHtml(u,a)}get html(){return this._html}get onDidReceiveMessage(){return m.event}postMessage(a){return d._proxy.$postMessage(u,a)}},P=new class{constructor(){this.editor=y,this.line=_,this.height=k,this.webview=w,this.onDidDispose=b.event}dispose(){d._insets.has(u)&&(d._insets.delete(u),d._proxy.$disposeEditorInset(u),b.fire(),b.dispose(),m.dispose())}};return this._proxy.$createEditorInset(u,l.id,l.value.document.uri,_+1,k,n||{},I.identifier,I.extensionLocation),this._insets.set(u,{editor:y,inset:P,onDidReceiveMessage:m}),P}$onDidDispose(y){const _=this._insets.get(y);_&&_.inset.dispose()}$onDidReceiveMessage(y,_){const k=this._insets.get(y);k&&k.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=E}),define(be[170],Ee([0,1,140,10,2,6,4,45,28,17,11]),function(ee,e,g,F,S,E,C,y,_,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,g.localize)(0,null),providerDisplayName:(0,g.localize)(1,null)},e.ActiveEditorDirtyContext=new y.RawContextKey("activeEditorIsDirty",!1,(0,g.localize)(2,null)),e.ActiveEditorPinnedContext=new y.RawContextKey("activeEditorIsNotPreview",!1,(0,g.localize)(3,null)),e.ActiveEditorStickyContext=new y.RawContextKey("activeEditorIsPinned",!1,(0,g.localize)(4,null)),e.ActiveEditorReadonlyContext=new y.RawContextKey("activeEditorIsReadonly",!1,(0,g.localize)(5,null)),e.ActiveEditorCanRevertContext=new y.RawContextKey("activeEditorCanRevert",!1,(0,g.localize)(6,null)),e.ActiveEditorContext=new y.RawContextKey("activeEditor",null,{type:"string",description:(0,g.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new y.RawContextKey("activeEditorAvailableEditorIds","",(0,g.localize)(8,null)),e.TextCompareEditorVisibleContext=new y.RawContextKey("textCompareEditorVisible",!1,(0,g.localize)(9,null)),e.TextCompareEditorActiveContext=new y.RawContextKey("textCompareEditorActive",!1,(0,g.localize)(10,null)),e.EditorGroupEditorsCountContext=new y.RawContextKey("groupEditorsCount",0,(0,g.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new y.RawContextKey("activeEditorGroupEmpty",!1,(0,g.localize)(12,null)),e.ActiveEditorGroupIndexContext=new y.RawContextKey("activeEditorGroupIndex",0,(0,g.localize)(13,null)),e.ActiveEditorGroupLastContext=new y.RawContextKey("activeEditorGroupLast",!1,(0,g.localize)(14,null)),e.MultipleEditorGroupsContext=new y.RawContextKey("multipleEditorGroups",!1,(0,g.localize)(15,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new y.RawContextKey("editorIsOpen",!1,(0,g.localize)(16,null)),e.InEditorZenModeContext=new y.RawContextKey("inZenMode",!1,(0,g.localize)(17,null)),e.IsCenteredLayoutContext=new y.RawContextKey("isCenteredLayout",!1,(0,g.localize)(18,null)),e.SplitEditorsVertically=new y.RawContextKey("splitEditorsVertically",!1,(0,g.localize)(19,null)),e.EditorAreaVisibleContext=new y.RawContextKey("editorAreaVisible",!0,(0,g.localize)(20,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function I(o){return typeof o?.getViewState=="function"}e.isTextEditorPane=I;function l(o){if(a(o))return!1;const A=o;return S.URI.isUri(A?.resource)}e.isResourceEditorInput=l;function d(o){if(a(o))return!1;const A=o;return A?.original!==void 0&&A.modified!==void 0}e.isResourceDiffEditorInput=d;function u(o){if(a(o))return!1;const A=o;return A?A?.resource===void 0||A.resource.scheme===n.Schemas.untitled||A.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=u;var m;(function(o){o[o.SHORT=0]="SHORT",o[o.MEDIUM=1]="MEDIUM",o[o.LONG=2]="LONG"})(m=e.Verbosity||(e.Verbosity={}));var b;(function(o){o[o.EXPLICIT=1]="EXPLICIT",o[o.AUTO=2]="AUTO",o[o.FOCUS_CHANGE=3]="FOCUS_CHANGE",o[o.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(b=e.SaveReason||(e.SaveReason={}));var w;(function(o){o[o.None=0]="None",o[o.Readonly=2]="Readonly",o[o.Untitled=4]="Untitled",o[o.Singleton=8]="Singleton",o[o.RequiresTrust=16]="RequiresTrust"})(w=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class P extends E.Disposable{}e.AbstractEditorInput=P;function a(o){return o instanceof P}e.isEditorInput=a;function f(o){const A=o;return S.URI.isUri(A?.preferredResource)}function v(o){const A=o;return a(A?.primary)&&a(A?.secondary)}e.isSideBySideEditorInput=v;function t(o){return a(o?.editor)}e.isEditorInputWithOptions=t;function r(o){const A=o;return t(o)&&A?.group!==void 0}e.isEditorInputWithOptionsAndGroup=r;function s(o){const A=o;return typeof A?.groupId=="number"&&a(A.editor)}e.isEditorIdentifier=s;var i;(function(o){o[o.PRIMARY=1]="PRIMARY",o[o.SECONDARY=2]="SECONDARY",o[o.BOTH=3]="BOTH"})(i=e.SideBySideEditor||(e.SideBySideEditor={}));class c{getOriginalUri(A,L){if(!A)return;const $=v(A)?A.primary:d(A)?A.modified:void 0,oe=v(A)?A.secondary:d(A)?A.original:void 0;if(L?.supportSideBySide&&$&&oe){if(L?.supportSideBySide===i.BOTH)return{primary:this.getOriginalUri($,{filterByScheme:L.filterByScheme}),secondary:this.getOriginalUri(oe,{filterByScheme:L.filterByScheme})};A=L.supportSideBySide===i.PRIMARY?$:oe}if(d(A))return;const he=f(A)?A.preferredResource:A.resource;return!he||!L||!L.filterByScheme?he:this.filterUri(he,L.filterByScheme)}getCanonicalUri(A,L){if(!A)return;const $=v(A)?A.primary:d(A)?A.modified:void 0,oe=v(A)?A.secondary:d(A)?A.original:void 0;if(L?.supportSideBySide&&$&&oe){if(L?.supportSideBySide===i.BOTH)return{primary:this.getCanonicalUri($,{filterByScheme:L.filterByScheme}),secondary:this.getCanonicalUri(oe,{filterByScheme:L.filterByScheme})};A=L.supportSideBySide===i.PRIMARY?$:oe}if(d(A))return;const he=A.resource;return!he||!L||!L.filterByScheme?he:this.filterUri(he,L.filterByScheme)}filterUri(A,L){if(Array.isArray(L)){if(L.some($=>A.scheme===$))return A}else if(L===A.scheme)return A}}e.EditorResourceAccessor=new c;var h;(function(o){o[o.LEFT=0]="LEFT",o[o.RIGHT=1]="RIGHT"})(h=e.CloseDirection||(e.CloseDirection={}));class p{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(A){const L=this.instantiationService=A.get(C.IInstantiationService);for(const[$,oe]of this.editorSerializerConstructors)this.createEditorSerializer($,oe,L);this.editorSerializerConstructors.clear()}createEditorSerializer(A,L,$){const oe=$.createInstance(L);this.editorSerializerInstances.set(A,oe)}registerFileEditorFactory(A){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=A}getFileEditorFactory(){return(0,F.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(A,L){if(this.editorSerializerConstructors.has(A)||this.editorSerializerInstances.has(A))throw new Error(`A editor serializer with type ID '${A}' was already registered.`);return this.instantiationService?this.createEditorSerializer(A,L,this.instantiationService):this.editorSerializerConstructors.set(A,L),(0,E.toDisposable)(()=>{this.editorSerializerConstructors.delete(A),this.editorSerializerInstances.delete(A)})}getEditorSerializer(A){return this.editorSerializerInstances.get(typeof A=="string"?A:A.typeId)}}_.Registry.add(e.EditorExtensions.EditorFactory,new p);async function D(o,A){if(!o||!o.length)return[];const L=await Promise.all(o.map(async $=>{const oe=S.URI.revive($.fileUri);if(!oe||(await A.activateProvider(oe.scheme),!A.canHandleResource(oe)))return;const he=typeof $.exists=="boolean"?$.exists:await A.exists(oe);if(!he&&$.openOnlyIfExists)return;const Q=he&&typeof $.lineNumber=="number"?{selection:{startLineNumber:$.lineNumber,startColumn:$.columnNumber||1},pinned:!0,override:$.editorOverrideId}:{pinned:!0,override:$.editorOverrideId};let z;return he?z={resource:oe,options:Q,forceFile:!0}:z={resource:oe,options:Q,forceUntitled:!0},z}));return(0,k.coalesce)(L)}e.pathsToEditors=D;var T;(function(o){o[o.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",o[o.SEQUENTIAL=1]="SEQUENTIAL"})(T=e.EditorsOrder||(e.EditorsOrder={}))}),define(be[171],Ee([0,1,3,45,141,4,6,21,28,17,50,23,35,160]),function(ee,e,g,F,S,E,C,y,_,k,n,I,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,d.registerIcon)("default-view-icon",l.Codicon.window,(0,S.localize)(0,null));var u;(function(c){c.ViewContainersRegistry="workbench.registry.view.containers",c.ViewsRegistry="workbench.registry.view"})(u=e.Extensions||(e.Extensions={}));var m;(function(c){c[c.Sidebar=0]="Sidebar",c[c.Panel=1]="Panel"})(m=e.ViewContainerLocation||(e.ViewContainerLocation={}));function b(c){switch(c){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=b;function w(c){return`viewContainer.${c}.enabled`}e.getEnabledViewContainerContextKey=w;class P extends C.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new g.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new g.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,k.flatten)([...this.viewContainers.values()])}registerViewContainer(h,p,D){const T=this.get(h.id);if(T)return T;const o=h;return o.openCommandActionDescriptor=D?.donotRegisterOpenCommand?void 0:o.openCommandActionDescriptor??{id:o.id},(0,y.getOrSet)(this.viewContainers,p,[]).push(o),D?.isDefault&&this.defaultViewContainers.push(o),this._onDidRegister.fire({viewContainer:o,viewContainerLocation:p}),o}deregisterViewContainer(h){for(const p of this.viewContainers.keys()){const D=this.viewContainers.get(p),T=D?.indexOf(h);if(T!==-1){D?.splice(T,1),D.length===0&&this.viewContainers.delete(p),this._onDidDeregister.fire({viewContainer:h,viewContainerLocation:p});return}}}get(h){return this.all.filter(p=>p.id===h)[0]}getViewContainers(h){return[...this.viewContainers.get(h)||[]]}getViewContainerLocation(h){return[...this.viewContainers.keys()].filter(p=>this.getViewContainers(p).filter(D=>D?.id===h.id).length>0)[0]}getDefaultViewContainer(h){return this.defaultViewContainers.find(p=>this.getViewContainerLocation(p)===h)}}_.Registry.add(u.ViewContainersRegistry,new P);var a;(function(c){c.Open="2_open",c.Debug="4_debug",c.SCM="5_scm",c.More="9_more"})(a=e.ViewContentGroups||(e.ViewContentGroups={}));function f(c,h){const p=c.group??a.More,D=h.group??a.More;return p!==D?p.localeCompare(D):(c.order??5)-(h.order??5)}class v extends C.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new g.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new g.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new g.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new g.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new n.SetMap}registerViews(h,p){this.registerViews2([{views:h,viewContainer:p}])}registerViews2(h){h.forEach(({views:p,viewContainer:D})=>this.addViews(p,D)),this._onViewsRegistered.fire(h)}deregisterViews(h,p){const D=this.removeViews(h,p);D.length&&this._onViewsDeregistered.fire({views:D,viewContainer:p})}moveViews(h,p){for(const D of this._views.keys())if(D!==p){const T=this.removeViews(h,D);T.length&&(this.addViews(T,p),this._onDidChangeContainer.fire({views:T,from:D,to:p}))}}getViews(h){return this._views.get(h)||[]}getView(h){for(const p of this._viewContainers){const D=(this._views.get(p)||[]).filter(T=>T.id===h)[0];if(D)return D}return null}getViewContainer(h){for(const p of this._viewContainers)if((this._views.get(p)||[]).filter(T=>T.id===h)[0])return p;return null}registerViewWelcomeContent(h,p){return this._viewWelcomeContents.add(h,p),this._onDidChangeViewWelcomeContent.fire(h),(0,C.toDisposable)(()=>{this._viewWelcomeContents.delete(h,p),this._onDidChangeViewWelcomeContent.fire(h)})}registerViewWelcomeContent2(h,p){const D=new Map;for(const[T,o]of p)this._viewWelcomeContents.add(h,o),D.set(T,(0,C.toDisposable)(()=>{this._viewWelcomeContents.delete(h,o),this._onDidChangeViewWelcomeContent.fire(h)}));return this._onDidChangeViewWelcomeContent.fire(h),D}getViewWelcomeContent(h){const p=[];return this._viewWelcomeContents.forEach(h,D=>p.push(D)),p.sort(f)}addViews(h,p){let D=this._views.get(p);D||(D=[],this._views.set(p,D),this._viewContainers.push(p));for(const T of h){if(this.getView(T.id)!==null)throw new Error((0,S.localize)(1,null,T.id));D.push(T)}}removeViews(h,p){const D=this._views.get(p);if(!D)return[];const T=[],o=[];for(const A of D)h.includes(A)?T.push(A):o.push(A);return T.length&&(o.length?this._views.set(p,o):(this._views.delete(p),this._viewContainers.splice(this._viewContainers.indexOf(p),1))),T}}_.Registry.add(u.ViewsRegistry,new v),e.IViewsService=(0,E.createDecorator)("viewsService"),e.FocusedViewContext=new F.RawContextKey("focusedView","",(0,S.localize)(2,null));function t(c){return`view.${c}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,E.createDecorator)("viewDescriptorService");var r;(function(c){c[c.Default=0]="Default",c[c.Expand=1]="Expand"})(r=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(c){c[c.None=0]="None",c[c.Collapsed=1]="Collapsed",c[c.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(h,p){this.resolved=!1,this._hasResolve=!1,(0,I.mixin)(this,h),this._hasResolve=!!p,this.resolve=async D=>{if(p&&!this.resolved){const T=await p(D);T&&(this.tooltip=this.tooltip??T.tooltip,this.command=this.command??T.command)}D.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(be[172],Ee([0,1,3,16,142]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class E{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new g.Emitter,this._onExit=new g.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(y){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=y}onEvent(y){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=y}onRequest(y){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=y}sendResponse(y){y.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${y.command}`)):this.internalSend("response",y)}sendRequest(y,_,k,n){const I={command:y};if(_&&Object.keys(_).length>0&&(I.arguments=_),this.internalSend("request",I),typeof n=="number"){const l=setTimeout(()=>{clearTimeout(l);const d=this.pendingRequests.get(I.seq);if(d){this.pendingRequests.delete(I.seq);const u={type:"response",seq:0,request_seq:I.seq,success:!1,command:y,message:(0,S.localize)(0,null,n,y)};d(u)}},n)}return k&&this.pendingRequests.set(I.seq,k),I.seq}acceptMessage(y){this.messageCallback?this.messageCallback(y):(this.queue.push(y),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(y,_){return y.type!=="event"||_.type!=="event"}async processQueue(){let y;for(;this.queue.length;){if((!y||this.needsTaskBoundaryBetween(this.queue[0],y))&&await(0,F.timeout)(0),y=this.queue.shift(),!y)return;switch(y.type){case"event":this.eventCallback&&this.eventCallback(y);break;case"request":this.requestCallback&&this.requestCallback(y);break;case"response":const _=y,k=this.pendingRequests.get(_.request_seq);k&&(this.pendingRequests.delete(_.request_seq),k(_));break}}}internalSend(y,_){_.type=y,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const y=new Map;this.pendingRequests.forEach((_,k)=>y.set(k,_)),await(0,F.timeout)(500),y.forEach((_,k)=>{_({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=E}),define(be[173],Ee([0,1,8,2,14,23,11]),function(ee,e,g,F,S,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const y=/{([^}]+)}/g;function _(r,s,i){return r.replace(y,function(c,h){return s&&h.length>0&&h[0]!=="_"?c:i&&i.hasOwnProperty(h)?i[h]:c})}e.formatPII=_;function k(r){const s={};for(const i of Object.keys(r))i.startsWith("!")||(s[i]=r[i]);return s}e.filterExceptionsFromTelemetry=k;function n(r){return r.configuration.request==="attach"&&!I(r)&&(!r.parentSession||n(r.parentSession))}e.isSessionAttach=n;function I(r){let s=r.configuration.type;if(!!s)return s==="vslsShare"&&(s=r.configuration.adapterProxy.configuration.type),(0,g.equalsIgnoreCase)(s,"extensionhost")||(0,g.equalsIgnoreCase)(s,"pwa-extensionhost")?r:r.parentSession?I(r.parentSession):void 0}e.getExtensionHostDebugSession=I;function l(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=l;function d(r,s,i){let c,h=0,p=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,D=null;for(;D=p.exec(r);){let T=D.index+1,o=T+D[0].length;if(T<=s&&o>=i){c=D[0],h=T;break}}if(c){let T=/\w+/g,o=null;for(;(o=T.exec(c))&&!(o.index+1+h+o[0].length>=i););o&&(c=c.substring(0,T.lastIndex))}return c?{start:h,end:h+c.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=d;const u=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function m(r){return!!(r&&r.match(u))}e.isUri=m;function b(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(m(r.path))return F.URI.parse(r.path);if((0,S.isAbsolute)(r.path))return F.URI.file(r.path)}return r.path}function w(r){if(typeof r.path=="object"){const s=F.URI.revive(r.path);if(s)return s.scheme===C.Schemas.file?s.fsPath:s.toString()}return r.path}function P(r,s){const i=s?b:w,c=(0,E.deepClone)(r);return f(c,(h,p)=>{h&&p&&(p.path=i(p))}),c}e.convertToDAPaths=P;function a(r,s){const i=s?b:w,c=(0,E.deepClone)(r);return f(c,(h,p)=>{!h&&p&&(p.path=i(p))}),c}e.convertToVSCPaths=a;function f(r,s){switch(r.type){case"event":const i=r;switch(i.event){case"output":s(!1,i.body.source);break;case"loadedSource":s(!1,i.body.source);break;case"breakpoint":s(!1,i.body.breakpoint.source);break;default:break}break;case"request":const c=r;switch(c.command){case"setBreakpoints":s(!0,c.arguments.source);break;case"breakpointLocations":s(!0,c.arguments.source);break;case"source":s(!0,c.arguments.source);break;case"gotoTargets":s(!0,c.arguments.source);break;case"launchVSCode":c.arguments.args.forEach(p=>s(!1,p));break;default:break}break;case"response":const h=r;if(h.success&&h.body)switch(h.command){case"stackTrace":h.body.stackFrames.forEach(p=>s(!1,p.source));break;case"loadedSources":h.body.sources.forEach(p=>s(!1,p));break;case"scopes":h.body.scopes.forEach(p=>s(!1,p.source));break;case"setFunctionBreakpoints":h.body.breakpoints.forEach(p=>s(!1,p.source));break;case"setBreakpoints":h.body.breakpoints.forEach(p=>s(!1,p.source));break;default:break}break}}function v(r){return r.filter(s=>!s.presentation?.hidden).sort((s,i)=>s.presentation?i.presentation?s.presentation.group?i.presentation.group?s.presentation.group!==i.presentation.group?s.presentation.group.localeCompare(i.presentation.group):t(s.presentation.order,i.presentation.order):-1:i.presentation.group?1:t(s.presentation.order,i.presentation.order):-1:i.presentation?1:0)}e.getVisibleAndSorted=v;function t(r,s){return typeof r!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:r-s}}),define(be[71],Ee([0,1,27,85,11,14,22,45]),function(ee,e,g,F,S,E,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var _;(function(o){o[o.Markup=1]="Markup",o[o.Code=2]="Code"})(_=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",F.Mimes.markdown,"image/png","image/jpeg",F.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[F.Mimes.markdown,"application/json",F.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(o){o[o.Running=1]="Running",o[o.Idle=2]="Idle"})(k=e.NotebookRunState||(e.NotebookRunState={}));var n;(function(o){o[o.Pending=2]="Pending",o[o.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var I;(function(o){o[o.WithHardKernelDependency=0]="WithHardKernelDependency",o[o.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",o[o.Pure=2]="Pure",o[o.Never=3]="Never"})(I=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var l;(function(o){o.Always="always",o.Never="never",o.Optional="optional"})(l=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var d;(function(o){o[o.ModelChange=1]="ModelChange",o[o.Move=2]="Move",o[o.ChangeLanguage=5]="ChangeLanguage",o[o.Initialize=6]="Initialize",o[o.ChangeCellMetadata=7]="ChangeCellMetadata",o[o.Output=8]="Output",o[o.OutputItem=9]="OutputItem",o[o.ChangeCellContent=10]="ChangeCellContent",o[o.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",o[o.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",o[o.ChangeCellMime=13]="ChangeCellMime",o[o.Unknown=100]="Unknown"})(d=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var u;(function(o){o[o.Handle=0]="Handle",o[o.Index=1]="Index"})(u=e.SelectionStateType||(e.SelectionStateType={}));var m;(function(o){o[o.Replace=1]="Replace",o[o.Output=2]="Output",o[o.Metadata=3]="Metadata",o[o.CellLanguage=4]="CellLanguage",o[o.DocumentMetadata=5]="DocumentMetadata",o[o.Move=6]="Move",o[o.OutputItems=7]="OutputItems",o[o.PartialMetadata=8]="PartialMetadata",o[o.PartialInternalMetadata=9]="PartialInternalMetadata"})(m=e.CellEditType||(e.CellEditType={}));var b;(function(o){o.scheme=S.Schemas.vscodeNotebookCell;const A=/^ch(\d{7,})/;function L(z,V){return z.with({scheme:o.scheme,fragment:`ch${V.toString().padStart(7,"0")}${z.scheme!==S.Schemas.file?z.scheme:""}`})}o.generate=L;function $(z){if(z.scheme!==o.scheme)return;const V=A.exec(z.fragment);return V?{handle:Number(V[1]),notebook:z.with({scheme:z.fragment.substr(V[0].length)||S.Schemas.file,fragment:null})}:void 0}o.parse=$;function oe(z){if(z.scheme!==S.Schemas.vscodeNotebookCellMetadata)return;const V=A.exec(z.fragment);return V?{handle:Number(V[1]),notebook:z.with({scheme:z.fragment.substr(V[0].length)||S.Schemas.file,fragment:null})}:void 0}o.parseCellMetadataUri=oe;function he(z,V,R){return z.with({scheme:R,fragment:`ch${V.toString().padStart(7,"0")}${z.scheme!==S.Schemas.file?z.scheme:""}`})}o.generateCellUri=he;function Q(z,V){if(z.scheme!==V)return;const R=A.exec(z.fragment);return R?{handle:Number(R[1]),notebook:z.with({scheme:z.fragment.substr(R[0].length)||S.Schemas.file,fragment:null})}:void 0}o.parseCellUri=Q})(b=e.CellUri||(e.CellUri={}));const w=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[F.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[F.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function P(o){return w.get(o)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=P;function a(o){return w.get(o)?.supportedByCore??!1}e.mimeTypeSupportedByCore=a;function f(o){return w.get(o)?.mergeable??!1}e.mimeTypeIsMergeable=f;function v(o,A){return C.isWindows&&(o=o.replace(/\//g,"\\"),A=A.replace(/\//g,"\\")),g.match(o,A)}function t(o,A,L){let $=0;for(let oe=0;oe<A.length;oe++){if(v(A[oe],o))return $;$++}for(let oe=0;oe<L.length;oe++){if(v(L[oe],o))return $;$++}return $}function r(o,A,L){return o.sort(($,oe)=>t($,A,L)-t(oe,A,L))}e.sortMimeTypes=r;function s(o,A,L,$=(oe,he)=>oe===he){const oe=[];function he(V,R,G){if(R===0&&G.length===0)return;const x=oe[oe.length-1];x&&x.start+x.deleteCount===V?(x.deleteCount+=R,x.toInsert.push(...G)):oe.push({start:V,deleteCount:R,toInsert:G})}let Q=0,z=0;for(;;){if(Q===o.length){he(Q,0,A.slice(z));break}if(z===A.length){he(Q,o.length-Q,[]);break}const V=o[Q],R=A[z];if($(V,R)){Q+=1,z+=1;continue}L(R)?(he(Q,1,[]),Q+=1):(he(Q,0,[R]),z+=1)}return oe}e.diff=s,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(o){o.default="default",o.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function c(o){const A=o;return!!((typeof A.include=="string"||g.isRelativePattern(A.include))&&(typeof A.exclude=="string"||g.isRelativePattern(A.exclude)))}e.isDocumentExcludePattern=c;function h(o,A,L){if(Array.isArray(o.viewType)&&o.viewType.indexOf(A)>=0||o.viewType===A)return!0;if(o.filenamePattern){let $=c(o.filenamePattern)?o.filenamePattern.include:o.filenamePattern,oe=c(o.filenamePattern)?o.filenamePattern.exclude:void 0;if(g.match($,(0,E.basename)(L.fsPath).toLowerCase()))return!(oe&&g.match(oe,(0,E.basename)(L.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=h;class p{constructor(A){this.textModel=A}getElements(){const A=new Int32Array(this.textModel.cells.length);for(let L=0;L<this.textModel.cells.length;L++)A[L]=this.textModel.cells[L].getHashValue();return A}}e.CellSequence=p,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted";var D;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(D=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class T{static create(A){return`${T._prefix}${A}`}static parse(A){if(A.startsWith(T._prefix))return A.substr(T._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=T,T._prefix="notebook/"}),define(be[174],Ee([0,1,144,4,45]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new S.RawContextKey("customExecutionSupported",!0,g.localize(0,null)),e.ShellExecutionSupportedContext=new S.RawContextKey("shellExecutionSupported",!1,g.localize(1,null)),e.ProcessExecutionSupportedContext=new S.RawContextKey("processExecutionSupported",!1,g.localize(2,null)),e.ITaskService=(0,F.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[175],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function g(S){return[...S.entries()]}e.serializeEnvironmentVariableCollection=g;function F(S){return new Map(S)}e.deserializeEnvironmentVariableCollection=F}),define(be[99],Ee([0,1,7]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.identifyTest=e.TestResultState=void 0,Object.defineProperty(e,"TestResultState",{enumerable:!0,get:function(){return g.TestResultState}});const F=I=>({testId:I.item.extId,controllerId:I.controllerId});e.identifyTest=F;var S;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable"})(S=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var E;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(E=e.TestItemExpandState||(e.TestItemExpandState={}));const C=(I,l)=>{l.expand!==void 0&&(I.expand=l.expand),l.item!==void 0&&(I.item=I.item?Object.assign(I.item,l.item):l.item)};e.applyTestItemUpdate=C;var y;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(y=e.DetailType||(e.DetailType={}));var _;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.Remove=2]="Remove",I[I.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",I[I.Retire=4]="Retire"})(_=e.TestDiffOpType||(e.TestDiffOpType={}));class k{add(l){}update(l){}remove(l,d){}complete(){}}e.IncrementalChangeCollector=k;class n{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(l){const d=this.createChangeCollector();for(const u of l)switch(u[0]){case 0:{const m=u[1];if(m.parent){if(this.items.has(m.parent)){const b=this.items.get(m.parent);b.children.add(m.item.extId);const w=this.createItem(m,b);this.items.set(m.item.extId,w),d.add(w)}}else{const b=this.createItem(m);this.roots.add(b),this.items.set(m.item.extId,b),d.add(b)}m.expand===2&&this.busyControllerCount++;break}case 1:{const m=u[1],b=this.items.get(m.extId);if(!b)break;m.expand!==void 0&&(b.expand===2&&this.busyControllerCount--,m.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(b,m),d.update(b);break}case 2:{const m=this.items.get(u[1]);if(!m)break;m.parent?this.items.get(m.parent).children.delete(m.item.extId):this.roots.delete(m);const b=[[u[1]]];for(;b.length;)for(const w of b.pop()){const P=this.items.get(w);P&&(b.push(P.children),this.items.delete(w),d.remove(P,P!==m),P.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(u[1]);break;case 3:this.updatePendingRoots(u[1]);break}d.complete()}retireTest(l){}updatePendingRoots(l){this.pendingRootCount+=l}createChangeCollector(){return new k}}e.AbstractIncrementalTestCollection=n}),define(be[72],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var g;(function(E){E.Delimiter="\0"})(g=e.TestIdPathParts||(e.TestIdPathParts={}));var F;(function(E){E[E.IsSame=0]="IsSame",E[E.Disconnected=1]="Disconnected",E[E.IsChild=2]="IsChild",E[E.IsParent=3]="IsParent"})(F=e.TestPosition||(e.TestPosition={}));class S{constructor(C,y=C.length){if(this.path=C,this.viewEnd=y,C.length===0||y<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(C,y,_=C.parent){if(C.id===y)return new S([y]);let k=[C.id];for(let n=_;n&&n.id!==y;n=n.parent)k.push(n.id);return k.push(y),new S(k.reverse())}static fromString(C){return new S(C.split("\0"))}static join(C,y){return new S([...C.path,y])}static joinToString(C,y){return C.toString()+"\0"+y}get parentId(){return this.viewEnd>1?new S(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){let C=this.path[0];yield C;for(let y=1;y<this.viewEnd;y++)C+="\0",C+=this.path[y],yield C}compare(C){for(let y=0;y<C.viewEnd&&y<this.viewEnd;y++)if(C.path[y]!==this.path[y])return 1;return C.viewEnd>this.viewEnd?2:C.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let C=1;C<this.viewEnd;C++)this.stringifed+="\0",this.stringifed+=this.path[C]}return this.stringifed}}e.TestId=S}),define(be[176],Ee([0,1,14,41,10,23,22,84,145]),function(ee,e,g,F,S,E,C,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(I,l,d){this._contributedVariables=new Map,this._context=I,this._labelService=l,d&&(this._envVariablesPromise=d.then(u=>this.prepareEnv(u)))}prepareEnv(I){if(C.isWindows){const l=Object.create(null);return Object.keys(I).forEach(d=>{l[d.toLowerCase()]=I[d]}),l}return I}resolveWithEnvironment(I,l,d){return this.recursiveResolve(this.prepareEnv(I),l?l.uri:void 0,d)}async resolveAsync(I,l){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,l)}async resolveAnyBase(I,l,d,u){const m=E.deepClone(l);return C.isWindows&&m.windows?Object.keys(m.windows).forEach(b=>m[b]=m.windows[b]):C.isMacintosh&&m.osx?Object.keys(m.osx).forEach(b=>m[b]=m.osx[b]):C.isLinux&&m.linux&&Object.keys(m.linux).forEach(b=>m[b]=m.linux[b]),delete m.windows,delete m.osx,delete m.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,m,d,u)}async resolveAnyAsync(I,l,d){return this.resolveAnyBase(I,l,d)}async resolveAnyMap(I,l,d){const u=new Map;return{newConfig:await this.resolveAnyBase(I,l,d,u),resolvedVariables:u}}resolveWithInteractionReplace(I,l,d,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,l,d,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,l){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,l)}recursiveResolve(I,l,d,u,m){if(S.isString(d))return this.resolveString(I,l,d,u,m);if(S.isArray(d))return d.map(b=>this.recursiveResolve(I,l,b,u,m));if(S.isObject(d)){let b=Object.create(null);return Object.keys(d).forEach(w=>{const P=this.resolveString(I,l,w,u,m);b[P]=this.recursiveResolve(I,l,d[w],u,m)}),b}return d}resolveString(I,l,d,u,m){return d.replace(k.VARIABLE_REGEXP,(w,P)=>{if(P.includes(k.VARIABLE_LHS))return w;let a=this.evaluateSingleVariable(I,w,P,l,u);return m&&m.set(P,a),a!==w&&S.isString(a)&&a.match(k.VARIABLE_REGEXP)&&(a=this.resolveString(I,l,a,u,m)),a})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,l,d,u,m){let b;const w=d.split(":");w.length>1&&(d=w[0],b=w[1]);const P=()=>{const v=this._context.getFilePath();if(v)return v;throw new Error((0,_.localize)(0,null,l))},a=()=>{const v=P();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,_.localize)(1,null,l,g.basename(v)))},f=()=>{if(b){const v=this._context.getFolderUri(b);if(v)return v;throw new Error((0,_.localize)(2,null,l,b))}if(u)return u;throw this._context.getWorkspaceFolderCount()>1?new Error((0,_.localize)(3,null,l)):new Error((0,_.localize)(4,null,l))};switch(d){case"env":if(b){if(I){const v=I[C.isWindows?b.toLowerCase():b];if(S.isString(v))return v}return""}throw new Error((0,_.localize)(5,null,l));case"config":if(b){const v=this._context.getConfigurationValue(u,b);if(S.isUndefinedOrNull(v))throw new Error((0,_.localize)(6,null,l,b));if(S.isObject(v))throw new Error((0,_.localize)(7,null,l,b));return v}throw new Error((0,_.localize)(8,null,l));case"command":return this.resolveFromMap(l,b,m,"command");case"input":return this.resolveFromMap(l,b,m,"input");default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,y.normalizeDriveLetter)(this.fsPath(f()));case"cwd":return u||b?(0,y.normalizeDriveLetter)(this.fsPath(f())):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return g.basename(this.fsPath(f()));case"lineNumber":const v=this._context.getLineNumber();if(v)return v;throw new Error((0,_.localize)(9,null,l));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,_.localize)(10,null,l));case"file":return P();case"fileWorkspaceFolder":return a();case"relativeFile":return u||b?g.relative(this.fsPath(f()),P()):P();case"relativeFileDirname":const r=g.dirname(P());if(u||b){const h=g.relative(this.fsPath(f()),r);return h.length===0?".":h}return r;case"fileDirname":return g.dirname(P());case"fileExtname":return g.extname(P());case"fileBasename":return g.basename(P());case"fileBasenameNoExtension":const s=g.basename(P());return s.slice(0,s.length-g.extname(s).length);case"fileDirnameBasename":return g.basename(g.dirname(P()));case"execPath":const i=this._context.getExecPath();return i||l;case"execInstallFolder":const c=this._context.getAppRoot();return c||l;case"pathSeparator":return g.sep;default:try{const h=b?`${d}:${b}`:d;return this.resolveFromMap(l,h,m,void 0)}catch(h){return l}}}}resolveFromMap(I,l,d,u){if(l&&d){const m=u===void 0?d[l]:d[u+":"+l];if(typeof m=="string")return m;throw new Error((0,_.localize)(11,null,I))}return I}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[100],Ee([0,1,4,170]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,g.createDecorator)("editorGroupsService");var S;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(S=e.GroupDirection||(e.GroupDirection={}));var E;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(E=e.GroupOrientation||(e.GroupOrientation={}));var C;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(C=e.GroupLocation||(e.GroupLocation={}));var y;(function(m){m[m.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",m[m.EVEN=1]="EVEN",m[m.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var _;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(_=e.MergeGroupMode||(e.MergeGroupMode={}));function k(m){const b=m;return(0,F.isEditorInput)(b?.editor)&&(0,F.isEditorInput)(b?.replacement)}e.isEditorReplacement=k;var n;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(n=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(m){m[m.GROUP_ACTIVE=0]="GROUP_ACTIVE",m[m.GROUP_INDEX=1]="GROUP_INDEX",m[m.EDITOR_OPEN=2]="EDITOR_OPEN",m[m.EDITOR_CLOSE=3]="EDITOR_CLOSE",m[m.EDITOR_MOVE=4]="EDITOR_MOVE",m[m.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",m[m.EDITOR_LABEL=6]="EDITOR_LABEL",m[m.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",m[m.EDITOR_PIN=8]="EDITOR_PIN",m[m.EDITOR_STICKY=9]="EDITOR_STICKY",m[m.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(I=e.GroupChangeKind||(e.GroupChangeKind={}));var l;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(l=e.OpenEditorContext||(e.OpenEditorContext={}));function d(m){const b=m;return!!b&&typeof b.id=="number"&&Array.isArray(b.editors)}e.isEditorGroup=d;function u(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=u}),define(be[177],Ee([0,1,4,100]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,g.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function S(E){const C=E;return typeof E=="number"||(0,F.isEditorGroup)(C)}e.isPreferredGroup=S}),define(be[9],Ee([0,1,17,83,233,56,23,10,2,31,60,146,92,67,71,72,177,7]),function(ee,e,g,F,S,E,C,y,_,k,n,I,l,d,u,m,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var P;(function(_e){function ke(W){const{selectionStartLineNumber:Fe,selectionStartColumn:Me,positionLineNumber:tt,positionColumn:Qe}=W,dt=new w.Position(Fe-1,Me-1),yt=new w.Position(tt-1,Qe-1);return new w.Selection(dt,yt)}_e.to=ke;function Y(W){const{anchor:Fe,active:Me}=W;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Me.line+1,positionColumn:Me.character+1}}_e.from=Y})(P=e.Selection||(e.Selection={}));var a;(function(_e){function ke(W){if(!W)return;const{start:Fe,end:Me}=W;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Me.line+1,endColumn:Me.character+1}}_e.from=ke;function Y(W){if(!W)return;const{startLineNumber:Fe,startColumn:Me,endLineNumber:tt,endColumn:Qe}=W;return new w.Range(Fe-1,Me-1,tt-1,Qe-1)}_e.to=Y})(a=e.Range||(e.Range={}));var f;(function(_e){function ke(Y){switch(Y){case 1:return w.StandardTokenType.Comment;case 0:return w.StandardTokenType.Other;case 4:return w.StandardTokenType.RegEx;case 2:return w.StandardTokenType.String}}_e.to=ke})(f=e.TokenType||(e.TokenType={}));var v;(function(_e){function ke(W){return new w.Position(W.lineNumber-1,W.column-1)}_e.to=ke;function Y(W){return{lineNumber:W.line+1,column:W.character+1}}_e.from=Y})(v=e.Position||(e.Position={}));var t;(function(_e){function ke(W){switch(W){case w.DiagnosticTag.Unnecessary:return 1;case w.DiagnosticTag.Deprecated:return 2}}_e.from=ke;function Y(W){switch(W){case 1:return w.DiagnosticTag.Unnecessary;case 2:return w.DiagnosticTag.Deprecated;default:return}}_e.to=Y})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(_e){function ke(W){let Fe;return W.code&&((0,y.isString)(W.code)||(0,y.isNumber)(W.code)?Fe=String(W.code):Fe={value:String(W.code.value),target:W.code.target}),{...a.from(W.range),message:W.message,source:W.source,code:Fe,severity:i.from(W.severity),relatedInformation:W.relatedInformation&&W.relatedInformation.map(s.from),tags:Array.isArray(W.tags)?(0,g.coalesce)(W.tags.map(t.from)):void 0}}_e.from=ke;function Y(W){const Fe=new w.Diagnostic(a.to(W),W.message,i.to(W.severity));return Fe.source=W.source,Fe.code=(0,y.isString)(W.code)?W.code:W.code?.value,Fe.relatedInformation=W.relatedInformation&&W.relatedInformation.map(s.to),Fe.tags=W.tags&&(0,g.coalesce)(W.tags.map(t.to)),Fe}_e.to=Y})(r=e.Diagnostic||(e.Diagnostic={}));var s;(function(_e){function ke(W){return{...a.from(W.location.range),message:W.message,resource:W.location.uri}}_e.from=ke;function Y(W){return new w.DiagnosticRelatedInformation(new w.Location(W.resource,a.to(W)),W.message)}_e.to=Y})(s=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(_e){function ke(W){switch(W){case w.DiagnosticSeverity.Error:return l.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return l.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return l.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return l.MarkerSeverity.Hint}return l.MarkerSeverity.Error}_e.from=ke;function Y(W){switch(W){case l.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case l.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case l.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case l.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}_e.to=Y})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var c;(function(_e){function ke(W){return typeof W=="number"&&W>=w.ViewColumn.One?W-1:W===w.ViewColumn.Beside?b.SIDE_GROUP:b.ACTIVE_GROUP}_e.from=ke;function Y(W){if(typeof W=="number"&&W>=0)return W+1;throw new Error("invalid 'EditorGroupColumn'")}_e.to=Y})(c=e.ViewColumn||(e.ViewColumn={}));function h(_e){return typeof _e.range!="undefined"}function p(_e){return _e.length===0?!0:!!h(_e[0])}e.isDecorationOptionsArr=p;var D;(function(_e){function ke(Qe){return Qe.map(_e.from)}_e.fromMany=ke;function Y(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function W(Qe){let dt;if(Y(Qe)){const{language:mt,value:ct}=Qe;dt={value:"```"+mt+`
`+ct+"\n```\n"}}else w.MarkdownString.isMarkdownString(Qe)?dt={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons}:typeof Qe=="string"?dt={value:Qe}:dt={value:""};const yt=Object.create(null);dt.uris=yt;const kt=mt=>{try{let ct=_.URI.parse(mt,!0);ct=ct.with({query:Fe(ct.query,yt)}),yt[mt]=ct}catch(ct){}return""},bt=new S.Renderer;return bt.link=kt,bt.image=mt=>kt(F.parseHrefAndDimensions(mt).href),S(dt.value,{renderer:bt}),dt}_e.from=W;function Fe(Qe,dt){if(!Qe)return Qe;let yt;try{yt=(0,E.parse)(Qe)}catch(bt){}if(!yt)return Qe;let kt=!1;return yt=(0,C.cloneAndChange)(yt,bt=>{if(_.URI.isUri(bt)){const mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return dt[mt]=bt,kt=!0,mt}else return}),kt?JSON.stringify(yt):Qe}function Me(Qe){const dt=new w.MarkdownString(Qe.value,Qe.supportThemeIcons);return dt.isTrusted=Qe.isTrusted,dt}_e.to=Me;function tt(Qe){if(!!Qe)return typeof Qe=="string"?Qe:_e.from(Qe)}_e.fromStrict=tt})(D=e.MarkdownString||(e.MarkdownString={}));function T(_e){return p(_e)?_e.map(ke=>({range:a.from(ke.range),hoverMessage:Array.isArray(ke.hoverMessage)?D.fromMany(ke.hoverMessage):ke.hoverMessage?D.from(ke.hoverMessage):void 0,renderOptions:ke.renderOptions})):_e.map(ke=>({range:a.from(ke)}))}e.fromRangeOrRangeWithMessage=T;function o(_e){return typeof _e=="undefined"?_e:typeof _e=="string"?_.URI.file(_e):_e}e.pathOrURIToURI=o;var A;(function(_e){function ke(Y){return typeof Y=="undefined"?Y:{contentText:Y.contentText,contentIconPath:Y.contentIconPath?o(Y.contentIconPath):void 0,border:Y.border,borderColor:Y.borderColor,fontStyle:Y.fontStyle,fontWeight:Y.fontWeight,textDecoration:Y.textDecoration,color:Y.color,backgroundColor:Y.backgroundColor,margin:Y.margin,width:Y.width,height:Y.height}}_e.from=ke})(A=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var L;(function(_e){function ke(Y){return typeof Y=="undefined"?Y:{backgroundColor:Y.backgroundColor,outline:Y.outline,outlineColor:Y.outlineColor,outlineStyle:Y.outlineStyle,outlineWidth:Y.outlineWidth,border:Y.border,borderColor:Y.borderColor,borderRadius:Y.borderRadius,borderSpacing:Y.borderSpacing,borderStyle:Y.borderStyle,borderWidth:Y.borderWidth,fontStyle:Y.fontStyle,fontWeight:Y.fontWeight,textDecoration:Y.textDecoration,cursor:Y.cursor,color:Y.color,opacity:Y.opacity,letterSpacing:Y.letterSpacing,gutterIconPath:Y.gutterIconPath?o(Y.gutterIconPath):void 0,gutterIconSize:Y.gutterIconSize,overviewRulerColor:Y.overviewRulerColor,before:Y.before?A.from(Y.before):void 0,after:Y.after?A.from(Y.after):void 0}}_e.from=ke})(L=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var $;(function(_e){function ke(Y){if(typeof Y=="undefined")return Y;switch(Y){case w.DecorationRangeBehavior.OpenOpen:return 0;case w.DecorationRangeBehavior.ClosedClosed:return 1;case w.DecorationRangeBehavior.OpenClosed:return 2;case w.DecorationRangeBehavior.ClosedOpen:return 3}}_e.from=ke})($=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var oe;(function(_e){function ke(Y){return{isWholeLine:Y.isWholeLine,rangeBehavior:Y.rangeBehavior?$.from(Y.rangeBehavior):void 0,overviewRulerLane:Y.overviewRulerLane,light:Y.light?L.from(Y.light):void 0,dark:Y.dark?L.from(Y.dark):void 0,backgroundColor:Y.backgroundColor,outline:Y.outline,outlineColor:Y.outlineColor,outlineStyle:Y.outlineStyle,outlineWidth:Y.outlineWidth,border:Y.border,borderColor:Y.borderColor,borderRadius:Y.borderRadius,borderSpacing:Y.borderSpacing,borderStyle:Y.borderStyle,borderWidth:Y.borderWidth,fontStyle:Y.fontStyle,fontWeight:Y.fontWeight,textDecoration:Y.textDecoration,cursor:Y.cursor,color:Y.color,opacity:Y.opacity,letterSpacing:Y.letterSpacing,gutterIconPath:Y.gutterIconPath?o(Y.gutterIconPath):void 0,gutterIconSize:Y.gutterIconSize,overviewRulerColor:Y.overviewRulerColor,before:Y.before?A.from(Y.before):void 0,after:Y.after?A.from(Y.after):void 0}}_e.from=ke})(oe=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var he;(function(_e){function ke(W){return{text:W.newText,eol:W.newEol&&ce.from(W.newEol),range:a.from(W.range)}}_e.from=ke;function Y(W){const Fe=new w.TextEdit(a.to(W.range),W.text);return Fe.newEol=typeof W.eol=="undefined"?void 0:ce.to(W.eol),Fe}_e.to=Y})(he=e.TextEdit||(e.TextEdit={}));var Q;(function(_e){function ke(W,Fe,Me){const tt={edits:[]};if(W instanceof w.WorkspaceEdit)for(let Qe of W._allEntries())if(Qe._type===1)tt.edits.push({_type:1,oldUri:Qe.from,newUri:Qe.to,options:Qe.options,metadata:Qe.metadata});else if(Qe._type===2){const dt=Fe?.getDocument(Qe.uri);tt.edits.push({_type:2,resource:Qe.uri,edit:he.from(Qe.edit),modelVersionId:dt?.version,metadata:Qe.metadata})}else Qe._type===3?tt.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Me?.getNotebookDocument(Qe.uri,!0)?.apiNotebook.version}):Qe._type===5&&tt.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Me?.getNotebookDocument(Qe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(U.from)}});return tt}_e.from=ke;function Y(W){const Fe=new w.WorkspaceEdit;for(const Me of W.edits)Me.edit?Fe.replace(_.URI.revive(Me.resource),a.to(Me.edit.range),Me.edit.text):Fe.renameFile(_.URI.revive(Me.oldUri),_.URI.revive(Me.newUri),Me.options);return Fe}_e.to=Y})(Q=e.WorkspaceEdit||(e.WorkspaceEdit={}));var z;(function(_e){const ke=Object.create(null);ke[w.SymbolKind.File]=0,ke[w.SymbolKind.Module]=1,ke[w.SymbolKind.Namespace]=2,ke[w.SymbolKind.Package]=3,ke[w.SymbolKind.Class]=4,ke[w.SymbolKind.Method]=5,ke[w.SymbolKind.Property]=6,ke[w.SymbolKind.Field]=7,ke[w.SymbolKind.Constructor]=8,ke[w.SymbolKind.Enum]=9,ke[w.SymbolKind.Interface]=10,ke[w.SymbolKind.Function]=11,ke[w.SymbolKind.Variable]=12,ke[w.SymbolKind.Constant]=13,ke[w.SymbolKind.String]=14,ke[w.SymbolKind.Number]=15,ke[w.SymbolKind.Boolean]=16,ke[w.SymbolKind.Array]=17,ke[w.SymbolKind.Object]=18,ke[w.SymbolKind.Key]=19,ke[w.SymbolKind.Null]=20,ke[w.SymbolKind.EnumMember]=21,ke[w.SymbolKind.Struct]=22,ke[w.SymbolKind.Event]=23,ke[w.SymbolKind.Operator]=24,ke[w.SymbolKind.TypeParameter]=25;function Y(Fe){return typeof ke[Fe]=="number"?ke[Fe]:6}_e.from=Y;function W(Fe){for(const Me in ke)if(ke[Me]===Fe)return Number(Me);return w.SymbolKind.Property}_e.to=W})(z=e.SymbolKind||(e.SymbolKind={}));var V;(function(_e){function ke(W){switch(W){case w.SymbolTag.Deprecated:return 1}}_e.from=ke;function Y(W){switch(W){case 1:return w.SymbolTag.Deprecated}}_e.to=Y})(V=e.SymbolTag||(e.SymbolTag={}));var R;(function(_e){function ke(W){return{name:W.name,kind:z.from(W.kind),tags:W.tags&&W.tags.map(V.from),containerName:W.containerName,location:B.from(W.location)}}_e.from=ke;function Y(W){const Fe=new w.SymbolInformation(W.name,z.to(W.kind),W.containerName,B.to(W.location));return Fe.tags=W.tags&&W.tags.map(V.to),Fe}_e.to=Y})(R=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var G;(function(_e){function ke(W){const Fe={name:W.name||"!!MISSING: name!!",detail:W.detail,range:a.from(W.range),selectionRange:a.from(W.selectionRange),kind:z.from(W.kind),tags:W.tags?.map(V.from)??[]};return W.children&&(Fe.children=W.children.map(ke)),Fe}_e.from=ke;function Y(W){const Fe=new w.DocumentSymbol(W.name,W.detail,z.to(W.kind),a.to(W.range),a.to(W.selectionRange));return(0,g.isNonEmptyArray)(W.tags)&&(Fe.tags=W.tags.map(V.to)),W.children&&(Fe.children=W.children.map(Y)),Fe}_e.to=Y})(G=e.DocumentSymbol||(e.DocumentSymbol={}));var x;(function(_e){function ke(W){const Fe=new w.CallHierarchyItem(z.to(W.kind),W.name,W.detail||"",_.URI.revive(W.uri),a.to(W.range),a.to(W.selectionRange));return Fe._sessionId=W._sessionId,Fe._itemId=W._itemId,Fe}_e.to=ke;function Y(W,Fe,Me){if(Fe=Fe??W._sessionId,Me=Me??W._itemId,Fe===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Me,name:W.name,detail:W.detail,kind:z.from(W.kind),uri:W.uri,range:a.from(W.range),selectionRange:a.from(W.selectionRange),tags:W.tags?.map(V.from)}}_e.from=Y})(x=e.CallHierarchyItem||(e.CallHierarchyItem={}));var j;(function(_e){function ke(Y){return new w.CallHierarchyIncomingCall(x.to(Y.from),Y.fromRanges.map(W=>a.to(W)))}_e.to=ke})(j=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var de;(function(_e){function ke(Y){return new w.CallHierarchyOutgoingCall(x.to(Y.to),Y.fromRanges.map(W=>a.to(W)))}_e.to=ke})(de=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var B;(function(_e){function ke(W){return{range:W.range&&a.from(W.range),uri:W.uri}}_e.from=ke;function Y(W){return new w.Location(_.URI.revive(W.uri),a.to(W.range))}_e.to=Y})(B=e.location||(e.location={}));var ne;(function(_e){function ke(W){const Fe=W,Me=W;return{originSelectionRange:Fe.originSelectionRange?a.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Me.uri,range:a.from(Fe.targetRange?Fe.targetRange:Me.range),targetSelectionRange:Fe.targetSelectionRange?a.from(Fe.targetSelectionRange):void 0}}_e.from=ke;function Y(W){return{targetUri:_.URI.revive(W.uri),targetRange:a.to(W.range),targetSelectionRange:W.targetSelectionRange?a.to(W.targetSelectionRange):void 0,originSelectionRange:W.originSelectionRange?a.to(W.originSelectionRange):void 0}}_e.to=Y})(ne=e.DefinitionLink||(e.DefinitionLink={}));var ue;(function(_e){function ke(W){return{range:a.from(W.range),contents:D.fromMany(W.contents)}}_e.from=ke;function Y(W){return new w.Hover(W.contents.map(D.to),a.to(W.range))}_e.to=Y})(ue=e.Hover||(e.Hover={}));var ye;(function(_e){function ke(W){return{range:a.from(W.range),expression:W.expression}}_e.from=ke;function Y(W){return new w.EvaluatableExpression(a.to(W.range),W.expression)}_e.to=Y})(ye=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Re;(function(_e){function ke(W){if(W instanceof w.InlineValueText)return{type:"text",range:a.from(W.range),text:W.text};if(W instanceof w.InlineValueVariableLookup)return{type:"variable",range:a.from(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};if(W instanceof w.InlineValueEvaluatableExpression)return{type:"expression",range:a.from(W.range),expression:W.expression};throw new Error("Unknown 'InlineValue' type")}_e.from=ke;function Y(W){switch(W.type){case"text":return{range:a.to(W.range),text:W.text};case"variable":return{range:a.to(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};case"expression":return{range:a.to(W.range),expression:W.expression}}}_e.to=Y})(Re=e.InlineValue||(e.InlineValue={}));var Te;(function(_e){function ke(W){return{frameId:W.frameId,stoppedLocation:a.from(W.stoppedLocation)}}_e.from=ke;function Y(W){return new w.InlineValueContext(W.frameId,a.to(W.stoppedLocation))}_e.to=Y})(Te=e.InlineValueContext||(e.InlineValueContext={}));var $e;(function(_e){function ke(W){return{range:a.from(W.range),kind:W.kind}}_e.from=ke;function Y(W){return new w.DocumentHighlight(a.to(W.range),W.kind)}_e.to=Y})($e=e.DocumentHighlight||(e.DocumentHighlight={}));var Je;(function(_e){function ke(Y){switch(Y){case 1:return w.CompletionTriggerKind.TriggerCharacter;case 2:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return w.CompletionTriggerKind.Invoke}}_e.to=ke})(Je=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ve;(function(_e){function ke(Y){return{triggerKind:Je.to(Y.triggerKind),triggerCharacter:Y.triggerCharacter}}_e.to=ke})(Ve=e.CompletionContext||(e.CompletionContext={}));var je;(function(_e){function ke(W){switch(W){case w.CompletionItemTag.Deprecated:return 1}}_e.from=ke;function Y(W){switch(W){case 1:return w.CompletionItemTag.Deprecated}}_e.to=Y})(je=e.CompletionItemTag||(e.CompletionItemTag={}));var O;(function(_e){const ke=new Map([[w.CompletionItemKind.Method,0],[w.CompletionItemKind.Function,1],[w.CompletionItemKind.Constructor,2],[w.CompletionItemKind.Field,3],[w.CompletionItemKind.Variable,4],[w.CompletionItemKind.Class,5],[w.CompletionItemKind.Interface,7],[w.CompletionItemKind.Struct,6],[w.CompletionItemKind.Module,8],[w.CompletionItemKind.Property,9],[w.CompletionItemKind.Unit,12],[w.CompletionItemKind.Value,13],[w.CompletionItemKind.Constant,14],[w.CompletionItemKind.Enum,15],[w.CompletionItemKind.EnumMember,16],[w.CompletionItemKind.Keyword,17],[w.CompletionItemKind.Snippet,27],[w.CompletionItemKind.Text,18],[w.CompletionItemKind.Color,19],[w.CompletionItemKind.File,20],[w.CompletionItemKind.Reference,21],[w.CompletionItemKind.Folder,23],[w.CompletionItemKind.Event,10],[w.CompletionItemKind.Operator,11],[w.CompletionItemKind.TypeParameter,24],[w.CompletionItemKind.Issue,26],[w.CompletionItemKind.User,25]]);function Y(Me){return ke.get(Me)??9}_e.from=Y;const W=new Map([[0,w.CompletionItemKind.Method],[1,w.CompletionItemKind.Function],[2,w.CompletionItemKind.Constructor],[3,w.CompletionItemKind.Field],[4,w.CompletionItemKind.Variable],[5,w.CompletionItemKind.Class],[7,w.CompletionItemKind.Interface],[6,w.CompletionItemKind.Struct],[8,w.CompletionItemKind.Module],[9,w.CompletionItemKind.Property],[12,w.CompletionItemKind.Unit],[13,w.CompletionItemKind.Value],[14,w.CompletionItemKind.Constant],[15,w.CompletionItemKind.Enum],[16,w.CompletionItemKind.EnumMember],[17,w.CompletionItemKind.Keyword],[27,w.CompletionItemKind.Snippet],[18,w.CompletionItemKind.Text],[19,w.CompletionItemKind.Color],[20,w.CompletionItemKind.File],[21,w.CompletionItemKind.Reference],[23,w.CompletionItemKind.Folder],[10,w.CompletionItemKind.Event],[11,w.CompletionItemKind.Operator],[24,w.CompletionItemKind.TypeParameter],[25,w.CompletionItemKind.User],[26,w.CompletionItemKind.Issue]]);function Fe(Me){return W.get(Me)??w.CompletionItemKind.Property}_e.to=Fe})(O=e.CompletionItemKind||(e.CompletionItemKind={}));var K;(function(_e){function ke(Y,W){const Fe=new w.CompletionItem(Y.label);return Fe.insertText=Y.insertText,Fe.kind=O.to(Y.kind),Fe.tags=Y.tags?.map(je.to),Fe.detail=Y.detail,Fe.documentation=F.isMarkdownString(Y.documentation)?D.to(Y.documentation):Y.documentation,Fe.sortText=Y.sortText,Fe.filterText=Y.filterText,Fe.preselect=Y.preselect,Fe.commitCharacters=Y.commitCharacters,k.Range.isIRange(Y.range)?Fe.range=a.to(Y.range):typeof Y.range=="object"&&(Fe.range={inserting:a.to(Y.range.insert),replacing:a.to(Y.range.replace)}),Fe.keepWhitespace=typeof Y.insertTextRules=="undefined"?!1:Boolean(Y.insertTextRules&1),typeof Y.insertTextRules!="undefined"&&Y.insertTextRules&4?Fe.insertText=new w.SnippetString(Y.insertText):(Fe.insertText=Y.insertText,Fe.textEdit=Fe.range instanceof w.Range?new w.TextEdit(Fe.range,Fe.insertText):void 0),Y.additionalTextEdits&&Y.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Y.additionalTextEdits.map(Me=>he.to(Me))),Fe.command=W&&Y.command?W.fromInternal(Y.command):void 0,Fe}_e.to=ke})(K=e.CompletionItem||(e.CompletionItem={}));var X;(function(_e){function ke(W){return{label:W.label,documentation:W.documentation?D.fromStrict(W.documentation):void 0}}_e.from=ke;function Y(W){return{label:W.label,documentation:F.isMarkdownString(W.documentation)?D.to(W.documentation):W.documentation}}_e.to=Y})(X=e.ParameterInformation||(e.ParameterInformation={}));var se;(function(_e){function ke(W){return{label:W.label,documentation:W.documentation?D.fromStrict(W.documentation):void 0,parameters:Array.isArray(W.parameters)?W.parameters.map(X.from):[],activeParameter:W.activeParameter}}_e.from=ke;function Y(W){return{label:W.label,documentation:F.isMarkdownString(W.documentation)?D.to(W.documentation):W.documentation,parameters:Array.isArray(W.parameters)?W.parameters.map(X.to):[],activeParameter:W.activeParameter}}_e.to=Y})(se=e.SignatureInformation||(e.SignatureInformation={}));var q;(function(_e){function ke(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(se.from):[]}}_e.from=ke;function Y(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(se.to):[]}}_e.to=Y})(q=e.SignatureHelp||(e.SignatureHelp={}));var ie;(function(_e){function ke(W){return{text:W.text,position:v.from(W.position),kind:ge.from(W.kind??w.InlayHintKind.Other),whitespaceBefore:W.whitespaceBefore,whitespaceAfter:W.whitespaceAfter}}_e.from=ke;function Y(W){const Fe=new w.InlayHint(W.text,v.to(W.position),ge.to(W.kind));return Fe.whitespaceAfter=W.whitespaceAfter,Fe.whitespaceBefore=W.whitespaceBefore,Fe}_e.to=Y})(ie=e.InlayHint||(e.InlayHint={}));var ge;(function(_e){function ke(W){return W}_e.from=ke;function Y(W){return W}_e.to=Y})(ge=e.InlayHintKind||(e.InlayHintKind={}));var Le;(function(_e){function ke(W){return{range:a.from(W.range),url:W.target,tooltip:W.tooltip}}_e.from=ke;function Y(W){let Fe;if(W.url)try{Fe=typeof W.url=="string"?_.URI.parse(W.url,!0):_.URI.revive(W.url)}catch(Me){}return new w.DocumentLink(a.to(W.range),Fe)}_e.to=Y})(Le=e.DocumentLink||(e.DocumentLink={}));var We;(function(_e){function ke(W){const Fe=new w.ColorPresentation(W.label);return W.textEdit&&(Fe.textEdit=he.to(W.textEdit)),W.additionalTextEdits&&(Fe.additionalTextEdits=W.additionalTextEdits.map(Me=>he.to(Me))),Fe}_e.to=ke;function Y(W){return{label:W.label,textEdit:W.textEdit?he.from(W.textEdit):void 0,additionalTextEdits:W.additionalTextEdits?W.additionalTextEdits.map(Fe=>he.from(Fe)):void 0}}_e.from=Y})(We=e.ColorPresentation||(e.ColorPresentation={}));var ve;(function(_e){function ke(W){return new w.Color(W[0],W[1],W[2],W[3])}_e.to=ke;function Y(W){return[W.red,W.green,W.blue,W.alpha]}_e.from=Y})(ve=e.Color||(e.Color={}));var Xe;(function(_e){function ke(W){return{range:a.from(W.range)}}_e.from=ke;function Y(W){return new w.SelectionRange(a.to(W.range))}_e.to=Y})(Xe=e.SelectionRange||(e.SelectionRange={}));var H;(function(_e){function ke(Y){switch(Y){case 2:return w.TextDocumentSaveReason.AfterDelay;case 1:return w.TextDocumentSaveReason.Manual;case 3:case 4:return w.TextDocumentSaveReason.FocusOut}}_e.to=ke})(H=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Z;(function(_e){function ke(W){switch(W){case w.TextEditorLineNumbersStyle.Off:return 0;case w.TextEditorLineNumbersStyle.Relative:return 2;case w.TextEditorLineNumbersStyle.On:default:return 1}}_e.from=ke;function Y(W){switch(W){case 0:return w.TextEditorLineNumbersStyle.Off;case 2:return w.TextEditorLineNumbersStyle.Relative;case 1:default:return w.TextEditorLineNumbersStyle.On}}_e.to=Y})(Z=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ce;(function(_e){function ke(W){if(W===w.EndOfLine.CRLF)return 1;if(W===w.EndOfLine.LF)return 0}_e.from=ke;function Y(W){if(W===1)return w.EndOfLine.CRLF;if(W===0)return w.EndOfLine.LF}_e.to=Y})(ce=e.EndOfLine||(e.EndOfLine={}));var Be;(function(_e){function ke(Y){if(typeof Y=="object")return Y.viewId;switch(Y){case w.ProgressLocation.SourceControl:return 3;case w.ProgressLocation.Window:return 10;case w.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}_e.from=ke})(Be=e.ProgressLocation||(e.ProgressLocation={}));var xe;(function(_e){function ke(Y){const W={start:Y.start+1,end:Y.end+1};return Y.kind&&(W.kind=Ze.from(Y.kind)),W}_e.from=ke})(xe=e.FoldingRange||(e.FoldingRange={}));var Ze;(function(_e){function ke(Y){if(Y)switch(Y){case w.FoldingRangeKind.Comment:return n.FoldingRangeKind.Comment;case w.FoldingRangeKind.Imports:return n.FoldingRangeKind.Imports;case w.FoldingRangeKind.Region:return n.FoldingRangeKind.Region}}_e.from=ke})(Ze=e.FoldingRangeKind||(e.FoldingRangeKind={}));var De;(function(_e){function ke(Y){if(Y)return{pinned:typeof Y.preview=="boolean"?!Y.preview:void 0,inactive:Y.background,preserveFocus:Y.preserveFocus,selection:typeof Y.selection=="object"?a.from(Y.selection):void 0,override:typeof Y.override=="boolean"?I.EditorResolution.DISABLED:void 0}}_e.from=ke})(De=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Se;(function(_e){function ke(W){return W instanceof w.RelativePattern||typeof W=="string"?W:Y(W)?new w.RelativePattern(W.base,W.pattern):W}_e.from=ke;function Y(W){const Fe=W;return Fe&&typeof Fe.base=="string"&&typeof Fe.pattern=="string"}})(Se=e.GlobPattern||(e.GlobPattern={}));var Pe;(function(_e){function ke(Y){if(Y){if(Array.isArray(Y))return Y.map(ke);if(typeof Y=="string")return Y;{const W=Y;return{language:W.language,scheme:W.scheme,pattern:typeof W.pattern=="undefined"?void 0:Se.from(W.pattern),exclusive:W.exclusive}}}else return}_e.from=ke})(Pe=e.LanguageSelector||(e.LanguageSelector={}));var re;(function(_e){function ke(W){return{start:W.start,end:W.end}}_e.from=ke;function Y(W){return new w.NotebookRange(W.start,W.end)}_e.to=Y})(re=e.NotebookRange||(e.NotebookRange={}));var ae;(function(_e){function ke(W){return{timing:typeof W.runStartTime=="number"&&typeof W.runEndTime=="number"?{startTime:W.runStartTime,endTime:W.runEndTime}:void 0,executionOrder:W.executionOrder,success:W.lastRunSuccess}}_e.to=ke;function Y(W){return{lastRunSuccess:W.success,runStartTime:W.timing?.startTime,runEndTime:W.timing?.endTime,executionOrder:W.executionOrder}}_e.from=Y})(ae=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var fe;(function(_e){function ke(W){switch(W){case w.NotebookCellKind.Markup:return u.CellKind.Markup;case w.NotebookCellKind.Code:default:return u.CellKind.Code}}_e.from=ke;function Y(W){switch(W){case u.CellKind.Markup:return w.NotebookCellKind.Markup;case u.CellKind.Code:default:return w.NotebookCellKind.Code}}_e.to=Y})(fe=e.NotebookCellKind||(e.NotebookCellKind={}));var pe;(function(_e){function ke(W){const Fe={metadata:W.metadata??Object.create(null),cells:[]};for(let Me of W.cells)w.NotebookCellData.validate(Me),Fe.cells.push(U.from(Me));return Fe}_e.from=ke;function Y(W){const Fe=new w.NotebookData(W.cells.map(U.to));return(0,y.isEmptyObject)(W.metadata)||(Fe.metadata=W.metadata),Fe}_e.to=Y})(pe=e.NotebookData||(e.NotebookData={}));var U;(function(_e){function ke(W){return{cellKind:fe.from(W.kind),language:W.languageId,mime:W.mime,source:W.value,metadata:W.metadata,internalMetadata:ae.from(W.executionSummary??{}),outputs:W.outputs?W.outputs.map(we.from):[]}}_e.from=ke;function Y(W){return new w.NotebookCellData(fe.to(W.cellKind),W.source,W.language,W.mime,W.outputs?W.outputs.map(we.to):void 0,W.metadata,W.internalMetadata?ae.to(W.internalMetadata):void 0)}_e.to=Y})(U=e.NotebookCellData||(e.NotebookCellData={}));var me;(function(_e){function ke(W){return{mime:W.mime,valueBytes:Array.from(W.data)}}_e.from=ke;function Y(W){return new w.NotebookCellOutputItem(new Uint8Array(W.valueBytes),W.mime)}_e.to=Y})(me=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var we;(function(_e){function ke(W){return{outputId:W.id,items:W.items.map(me.from),metadata:W.metadata}}_e.from=ke;function Y(W){const Fe=W.items.map(me.to);return new w.NotebookCellOutput(Fe,W.outputId,W.metadata)}_e.to=Y})(we=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ie;(function(_e){function ke(Me){if(Me!=null){if(Me instanceof w.RelativePattern||typeof Me=="string")return Me;if(Fe(Me))return new w.RelativePattern(Me.base,Me.pattern);if(W(Me))return{include:Se.from(Me.include)||void 0,exclude:Se.from(Me.exclude)||void 0}}}_e.from=ke;function Y(Me){return typeof Me=="string"?Me:Fe(Me)?{base:Me.base,pattern:Me.pattern}:{include:Me.include,exclude:Me.exclude}}_e.to=Y;function W(Me){const tt=Me,Qe=Se.from(tt.include);if(!(Qe&&Qe instanceof w.RelativePattern||typeof Qe=="string"))return!1;const dt=Se.from(tt.exclude);return!!(dt&&dt instanceof w.RelativePattern||typeof dt=="string")}function Fe(Me){const tt=Me;return tt&&typeof tt.base=="string"&&typeof tt.pattern=="string"}})(Ie=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Oe;(function(_e){function ke(Y){return{backgroundColor:Y.backgroundColor,borderColor:Y.borderColor,top:Y.top?A.from(Y.top):void 0}}_e.from=ke})(Oe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var He;(function(_e){function ke(Y,W,Fe){const Me=typeof Y.command=="string"?{title:"",command:Y.command}:Y.command;return{alignment:Y.alignment===w.NotebookCellStatusBarAlignment.Left?1:2,command:W.toInternal(Me,Fe),text:Y.text,tooltip:Y.tooltip,accessibilityInformation:Y.accessibilityInformation,priority:Y.priority}}_e.from=ke})(He=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var et;(function(_e){function ke(Y){return{transientOutputs:Y?.transientOutputs??!1,transientCellMetadata:Y?.transientCellMetadata??{},transientDocumentMetadata:Y?.transientDocumentMetadata??{}}}_e.from=ke})(et=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ke;(function(_e){function ke(W){return{uri:W.uri,provides:W.provides}}_e.from=ke;function Y(W){return new w.NotebookRendererScript(_.URI.revive(W.uri),W.provides)}_e.to=Y})(Ke=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Ge;(function(_e){function ke(W){return{message:D.fromStrict(W.message)||"",severity:W.severity,expectedOutput:W.expectedOutput,actualOutput:W.actualOutput,location:W.location?B.from(W.location):void 0}}_e.from=ke;function Y(W){const Fe=new w.TestMessage(typeof W.message=="string"?W.message:D.to(W.message));return Fe.severity=W.severity,Fe.actualOutput=W.actualOutput,Fe.expectedOutput=W.expectedOutput,Fe}_e.to=Y})(Ge=e.TestMessage||(e.TestMessage={}));var lt;(function(_e){function ke(Me,tt){return{extId:m.TestId.fromExtHostTestItem(Me,tt).toString(),label:Me.label,uri:Me.uri,range:a.from(Me.range)||null,description:Me.description||null,error:Me.error&&D.fromStrict(Me.error)||null}}_e.from=ke;function Y(Me){return{id:m.TestId.fromString(Me.extId).localId,label:Me.label,uri:_.URI.revive(Me.uri),range:a.to(Me.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Me.description||void 0}}_e.toPlain=Y;function W(Me){const tt=new d.TestItemImpl(m.TestId.fromString(Me.extId).localId,Me.label,_.URI.revive(Me.uri));return tt.range=a.to(Me.range||void 0),tt.description=Me.description||void 0,tt}function Fe(Me){let tt;for(const Qe of Me.tests){const dt=W(Qe.item);(0,d.getPrivateApiFor)(dt).parent=tt,tt=dt}return tt}_e.toItemFromContext=Fe})(lt=e.TestItem||(e.TestItem={}));var ft;(function(_e){const ke=(W,Fe)=>{const Me={...lt.toPlain(W.item),parent:void 0,taskStates:W.tasks.map(tt=>({state:tt.state,duration:tt.duration,messages:tt.messages.map(Ge.to)})),children:W.children.map(tt=>Fe.get(tt)).filter(y.isDefined).map(tt=>ke(tt,Fe))};for(const tt of Me.children)tt.parent=Me;return Me};function Y(W){const Fe=[],Me=new Map;for(const tt of W.items)Me.set(tt.item.extId,tt),W.request.targets.some(Qe=>Qe.controllerId===tt.controllerId&&Qe.testIds.includes(tt.item.extId))&&Fe.push(tt);return{completedAt:W.completedAt,results:Fe.map(tt=>ke(tt,Me))}}_e.to=Y})(ft=e.TestResults||(e.TestResults={}));var _t;(function(_e){function ke(Me){return{covered:Me.covered,total:Me.covered}}function Y(Me){return"line"in Me?v.from(Me):a.from(Me)}function W(Me){return"branches"in Me?{count:Me.executionCount,location:Y(Me.location),type:1,branches:Me.branches.length?Me.branches.map(tt=>({count:tt.executionCount,location:tt.location&&Y(tt.location)})):void 0}:{type:0,count:Me.executionCount,location:Y(Me.location)}}_e.fromDetailed=W;function Fe(Me){return{uri:Me.uri,statement:ke(Me.statementCoverage),branch:Me.branchCoverage&&ke(Me.branchCoverage),function:Me.functionCoverage&&ke(Me.functionCoverage),details:Me.detailedCoverage?.map(W)}}_e.fromFile=Fe})(_t=e.TestCoverage||(e.TestCoverage={}));var ut;(function(_e){function ke(Y){switch(Y){case 1:return w.CodeActionTriggerKind.Invoke;case 2:return w.CodeActionTriggerKind.Automatic}}_e.to=ke})(ut=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var ot;(function(_e){function ke(W){const Fe=new w.TypeHierarchyItem(z.to(W.kind),W.name,W.detail||"",_.URI.revive(W.uri),a.to(W.range),a.to(W.selectionRange));return Fe._sessionId=W._sessionId,Fe._itemId=W._itemId,Fe}_e.to=ke;function Y(W,Fe,Me){if(Fe=Fe??W._sessionId,Me=Me??W._itemId,Fe===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Me,kind:z.from(W.kind),name:W.name,detail:W.detail??"",uri:W.uri,range:a.from(W.range),selectionRange:a.from(W.selectionRange),tags:W.tags?.map(V.from)}}_e.from=Y})(ot=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(be[178],Ee([0,1,2,12,7,9,80]),function(ee,e,g,F,S,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class y{constructor(k,n,I,l={timeout:1500,errors:3}){this._logService=k,this._documents=n,this._mainThreadBulkEdits=I,this._thresholds=l,this._callbacks=new C.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(n,I,l)=>{const u={dispose:this._callbacks.push([n,I,k])};return Array.isArray(l)&&l.push(u),u}}async $participateInSave(k,n){const I=g.URI.revive(k);let l=!1;const d=setTimeout(()=>l=!0,this._thresholds.timeout),u=[];try{for(let m of[...this._callbacks]){if(l)break;const b=this._documents.getDocument(I),w=await this._deliverEventAsyncAndBlameBadListeners(m,{document:b,reason:E.TextDocumentSaveReason.to(n)});u.push(w)}}finally{clearTimeout(d)}return u}_deliverEventAsyncAndBlameBadListeners([k,n,I],l){const d=this._badListeners.get(k);return typeof d=="number"&&d>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,k,n,l).then(()=>!0,u=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(u),!(u instanceof Error)||u.message!=="concurrent_edits"){const m=this._badListeners.get(k);this._badListeners.set(k,m?m+1:1),typeof m=="number"&&m>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,n,I,l){const d=[],u=Date.now(),{document:m,reason:b}=l,{version:w}=m,P=Object.freeze({document:m,reason:b,waitUntil(a){if(Object.isFrozen(d))throw(0,F.illegalState)("waitUntil can not be called async");d.push(Promise.resolve(a))}});try{n.apply(I,[P])}catch(a){return Promise.reject(a)}return Object.freeze(d),new Promise((a,f)=>{const v=setTimeout(()=>f(new Error("timeout")),this._thresholds.timeout);return Promise.all(d).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-u}ms`),clearTimeout(v),a(t)}).catch(t=>{clearTimeout(v),f(t)})}).then(a=>{const f={edits:[]};for(const v of a)if(Array.isArray(v)&&v.every(t=>t instanceof S.TextEdit))for(const{newText:t,newEol:r,range:s}of v)f.edits.push({_type:2,resource:m.uri,edit:{range:s&&E.Range.from(s),text:t,eol:r&&E.EndOfLine.from(r)}});if(f.edits.length!==0)return w===m.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(f):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=y}),define(be[179],Ee([0,1,3,27,2,9,7]),function(ee,e,g,F,S,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(n,I,l,d,u){this._onDidCreate=new g.Emitter,this._onDidChange=new g.Emitter,this._onDidDelete=new g.Emitter,this._config=0,l&&(this._config+=1),d&&(this._config+=2),u&&(this._config+=4);const m=(0,F.parse)(I),b=n(w=>{if(!l)for(let P of w.created){const a=S.URI.revive(P);m(a.fsPath)&&this._onDidCreate.fire(a)}if(!d)for(let P of w.changed){const a=S.URI.revive(P);m(a.fsPath)&&this._onDidChange.fire(a)}if(!u)for(let P of w.deleted){const a=S.URI.revive(P);m(a.fsPath)&&this._onDidDelete.fire(a)}});this._disposable=C.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,b)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class _{constructor(n,I,l){this._logService=I,this._extHostDocumentsAndEditors=l,this._onFileSystemEvent=new g.Emitter,this._onDidRenameFile=new g.Emitter,this._onDidCreateFile=new g.Emitter,this._onDidDeleteFile=new g.Emitter,this._onWillRenameFile=new g.AsyncEmitter,this._onWillCreateFile=new g.AsyncEmitter,this._onWillDeleteFile=new g.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(n,I,l,d){return new y(this._onFileSystemEvent.event,n,I,l,d)}$onFileEvent(n){this._onFileSystemEvent.fire(n)}$onDidRunFileOperation(n,I){switch(n){case 2:this._onDidRenameFile.fire(Object.freeze({files:I.map(l=>({oldUri:S.URI.revive(l.source),newUri:S.URI.revive(l.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:I.map(l=>S.URI.revive(l.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:I.map(l=>S.URI.revive(l.target))}));break;default:}}getOnWillRenameFileEvent(n){return this._createWillExecuteEvent(n,this._onWillRenameFile)}getOnWillCreateFileEvent(n){return this._createWillExecuteEvent(n,this._onWillCreateFile)}getOnWillDeleteFileEvent(n){return this._createWillExecuteEvent(n,this._onWillDeleteFile)}_createWillExecuteEvent(n,I){return(l,d,u)=>{const m=function(w){l.call(d,w)};return m.extension=n,I.event(m,void 0,u)}}async $onWillRunFileOperation(n,I,l,d){switch(n){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:I.map(u=>({oldUri:S.URI.revive(u.source),newUri:S.URI.revive(u.target)}))},l,d);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:I.map(u=>S.URI.revive(u.target))},l,d);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:I.map(u=>S.URI.revive(u.target))},l,d)}}async _fireWillEvent(n,I,l,d){const u=new Set,m=[];if(await n.fireAsync(I,d,async(w,P)=>{const a=Date.now(),f=await Promise.resolve(w);f instanceof C.WorkspaceEdit&&(m.push(f),u.add(P.extension.displayName??P.extension.identifier.value)),Date.now()-a>l&&this._logService.warn("SLOW file-participant",P.extension.identifier)}),d.isCancellationRequested||m.length===0)return;const b={edits:[]};for(let w of m){let{edits:P}=E.WorkspaceEdit.from(w,this._extHostDocumentsAndEditors);b.edits=b.edits.concat(P)}return{edit:b,extensionNames:Array.from(u)}}}e.ExtHostFileSystemEventService=_}),define(be[180],Ee([0,1,11,23,2,9,7,71]),function(ee,e,g,F,S,E,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class _{constructor(l,d,u,m){this.start=l,this.deletedCount=d,this.deletedItems=u,this.items=m}static asApiEvents(l){return l.map(d=>({start:d.start,deletedCount:d.deletedCount,deletedItems:d.deletedItems,items:d.items.map(u=>u.apiCell)}))}}class k{constructor(l,d,u){this.notebook=l,this._extHostDocument=d,this._cellData=u,this.handle=u.handle,this.uri=S.URI.revive(u.uri),this.cellKind=u.cellKind,this._outputs=u.outputs.map(E.NotebookCellOutput.to),this._internalMetadata=u.internalMetadata??{},this._metadata=u.metadata??{},this._previousResult=E.NotebookCellExecutionSummary.to(u.internalMetadata??{})}static asModelAddData(l,d){return{EOL:d.eol,lines:d.source,modeId:d.language,uri:d.uri,isDirty:!1,versionId:1,notebook:l}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const l=this,d=this._extHostDocument.getDocument(this.uri);if(!d)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return l.notebook.getCellIndex(l)},notebook:l.notebook.apiNotebook,kind:E.NotebookCellKind.to(this._cellData.cellKind),document:d.document,get mime(){return l._mime},set mime(u){l._mime=u},get outputs(){return l._outputs.slice(0)},get metadata(){return l._metadata},get executionSummary(){return l._previousResult}})}return this._apiCell}setOutputs(l){this._outputs=l.map(E.NotebookCellOutput.to)}setOutputItems(l,d,u){const m=u.map(E.NotebookCellOutputItem.to),b=this._outputs.find(w=>w.id===l);b&&(d||(b.items.length=0),b.items.push(...m))}setMetadata(l){this._metadata=l}setInternalMetadata(l){this._internalMetadata=l,this._previousResult=E.NotebookCellExecutionSummary.to(l)}setMime(l){}}e.ExtHostCell=k;class n{constructor(l,d,u,m,b,w){this._proxy=l,this._textDocumentsAndEditors=d,this._textDocuments=u,this._emitter=m,this.uri=b,this.handle=n._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=w.viewType,this._metadata=w.metadata??Object.create(null),this._spliceNotebookCells([[0,0,w.cells]],!0),this._versionId=w.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const l=this;this._notebook={get uri(){return l.uri},get version(){return l._versionId},get notebookType(){return l._notebookType},get isDirty(){return l._isDirty},get isUntitled(){return l.uri.scheme===g.Schemas.untitled},get isClosed(){return l._disposed},get metadata(){return l._metadata},get cellCount(){return l._cells.length},cellAt(d){return d=l._validateIndex(d),l._cells[d].apiCell},getCells(d){return(d?l._getCells(d):l._cells).map(m=>m.apiCell)},save(){return l._save()}}}return this._notebook}updateBackup(l){this._backup?.delete(),this._backup=l}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(l){l.metadata&&(this._metadata={...this._metadata,...l.metadata})}acceptDirty(l){this._isDirty=l}acceptModelChanged(l,d){this._versionId=l.versionId,this._isDirty=d;for(const u of l.rawEvents)u.kind===y.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(u.changes,!1):u.kind===y.NotebookCellsChangeType.Move?this._moveCell(u.index,u.newIdx):u.kind===y.NotebookCellsChangeType.Output?this._setCellOutputs(u.index,u.outputs):u.kind===y.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(u.index,u.outputId,u.append,u.outputItems):u.kind===y.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(u.index,u.language):u.kind===y.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(u.index,u.mime):u.kind===y.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(u.index,u.metadata):u.kind===y.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(u.index,u.internalMetadata)}_validateIndex(l){return l=l|0,l<0?0:l>=this._cells.length?this._cells.length-1:l}_validateRange(l){let d=l.start|0,u=l.end|0;return d<0&&(d=0),u>this._cells.length&&(u=this._cells.length),l.with({start:d,end:u})}_getCells(l){l=this._validateRange(l);const d=[];for(let u=l.start;u<l.end;u++)d.push(this._cells[u]);return d}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(l,d){if(this._disposed)return;const u=[],m=[],b=[];l.reverse().forEach(w=>{const a=w[2].map(t=>{const r=new k(this,this._textDocumentsAndEditors,t);return d||m.push(k.asModelAddData(this.apiNotebook,t)),r}),f=new _(w[0],w[1],[],a),v=this._cells.splice(w[0],w[1],...a);for(const t of v)b.push(t.uri),f.deletedItems.push(t.apiCell);u.push(f)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:m,removedDocuments:b}),d||this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(u)}))}_moveCell(l,d){const u=this._cells.splice(l,1);this._cells.splice(d,0,...u);const m=[new _(l,1,u.map(b=>b.apiCell),[]),new _(d,0,[],u)];this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(m)}))}_setCellOutputs(l,d){const u=this._cells[l];u.setOutputs(d),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[u.apiCell]}))}_setCellOutputItems(l,d,u,m){const b=this._cells[l];b.setOutputItems(d,u,m),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[b.apiCell]}))}_changeCellLanguage(l,d){const u=this._cells[l];u.apiCell.document.languageId!==d&&this._textDocuments.$acceptModelModeChanged(u.uri,d)}_changeCellMime(l,d){const u=this._cells[l];u.apiCell.mime=d}_changeCellMetadata(l,d){const u=this._cells[l],m=u.apiCell.metadata;u.setMetadata(d);const b=u.apiCell.metadata;(0,F.equals)(m,b)||this._emitter.emitCellMetadataChange((0,F.deepFreeze)({document:this.apiNotebook,cell:u.apiCell}))}_changeCellInternalMetadata(l,d){const u=this._cells[l],m=u.internalMetadata;if(u.setInternalMetadata(d),m.runState!==d.runState){const b=d.runState??C.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,F.deepFreeze)({document:this.apiNotebook,cell:u.apiCell,state:b}))}}getCellFromApiCell(l){return this._cells.find(d=>d.apiCell===l)}getCellFromIndex(l){return this._cells[l]}getCell(l){return this._cells.find(d=>d.handle===l)}getCellIndex(l){return this._cells.indexOf(l)}}e.ExtHostNotebookDocument=n,n._handlePool=0}),define(be[101],Ee([0,1,7,9,12]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class E{constructor(_){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=_}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(_){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:_})}replaceCellMetadata(_,k){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:_,metadata:k})}replaceCells(_,k,n){this._throwIfFinalized(),!(_===k&&n.length===0)&&this._collectedEdits.push({editType:1,index:_,count:k-_,cells:n.map(F.NotebookCellData.from)})}}class C{constructor(_,k,n,I,l,d){this.id=_,this._proxy=k,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=l,this._visibleRanges=I,this._viewColumn=d}get apiEditor(){if(!this._editor){const _=this;this._editor={get document(){return _.notebookData.apiNotebook},get selections(){return _._selections},set selections(k){if(!Array.isArray(k)||!k.every(g.NotebookRange.isNotebookRange))throw(0,S.illegalArgument)("selections");_._selections=k,_._trySetSelections(k)},get visibleRanges(){return _._visibleRanges},revealRange(k,n){_._proxy.$tryRevealRange(_.id,F.NotebookRange.from(k),n??g.NotebookEditorRevealType.Default)},get viewColumn(){return _._viewColumn},edit(k){const n=new E(this.document.version);return k(n),_._applyEdit(n.finalize())},setDecorations(k,n){return _.setDecorations(k,n)}},C.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(_){this._visible=_}_acceptVisibleRanges(_){this._visibleRanges=_}_acceptSelections(_){this._selections=_}_trySetSelections(_){this._proxy.$trySetSelections(this.id,_.map(F.NotebookRange.from))}_acceptViewColumn(_){this._viewColumn=_}_applyEdit(_){if(_.cellEdits.length===0)return Promise.resolve(!0);const k=[];let n=-1;for(let I=0;I<_.cellEdits.length;I++){if(n<0){k.push(_.cellEdits[I]),n++;continue}const d=k[n],u=_.cellEdits[I];if(d.editType===1&&u.editType===1&&d.index===u.index){d.cells.push(..._.cellEdits[I].cells),d.count+=_.cellEdits[I].count;continue}k.push(_.cellEdits[I]),n++}return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,k)}setDecorations(_,k){if(!(k.isEmpty&&!this._hasDecorationsForKey.has(_.key)))return k.isEmpty?this._hasDecorationsForKey.delete(_.key):this._hasDecorationsForKey.add(_.key),this._proxy.$trySetDecorations(this.id,F.NotebookRange.from(k),_.key)}}e.ExtHostNotebookEditor=C,C.apiEditorsToExtHost=new WeakMap}),define(be[181],Ee([0,1,9,156,135,20,51]),function(ee,e,g,F,S,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}withProgress(I,l,d){const u=this._handles++,{title:m,location:b,cancellable:w}=l,P={label:(0,S.localize)(0,null,I.displayName||I.name),id:I.identifier.value};return this._proxy.$startProgress(u,{location:g.ProgressLocation.from(b),title:m,source:P,cancellable:w},I),this._withProgress(u,d,!!w)}_withProgress(I,l,d){let u;d&&(u=new E.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,u));const m=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),u&&u.dispose()};let b;try{b=l(new k(this._proxy,I),d&&u?u.token:E.CancellationToken.None)}catch(w){throw m(I),w}return b.then(w=>m(I),w=>m(I)),b}$acceptProgressCanceled(I){const l=this._mapHandleToCancellationSource.get(I);l&&(l.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=y;function _(n,I){return n.message=I.message,typeof I.increment=="number"&&(typeof n.increment=="number"?n.increment+=I.increment:n.increment=I.increment),n}class k extends F.Progress{constructor(I,l){super(d=>this.throttledReport(d));this._proxy=I,this._handle=l}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}ze([(0,C.throttle)(100,(n,I)=>_(n,I),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(be[102],Ee([0,1,40,12,53,9,7]),function(ee,e,g,F,S,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class y{constructor(l,d,u){const m=y._Keys.nextId();l.$registerTextEditorDecorationType(d.identifier,m,E.DecorationRenderOptions.from(u)),this.value=Object.freeze({key:m,dispose(){l.$removeTextEditorDecorationType(m)}})}}e.TextEditorDecorationType=y,y._Keys=new S.IdGenerator("TextEditorDecorationType");class _{constructor(l,d){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=l,this._documentVersionId=l.version,this._undoStopBefore=d.undoStopBefore,this._undoStopAfter=d.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(l,d){this._throwIfFinalized();let u=null;if(l instanceof C.Position)u=new C.Range(l,l);else if(l instanceof C.Range)u=l;else throw new Error("Unrecognized location");this._pushEdit(u,d,!1)}insert(l,d){this._throwIfFinalized(),this._pushEdit(new C.Range(l,l),d,!0)}delete(l){this._throwIfFinalized();let d=null;if(l instanceof C.Range)d=l;else throw new Error("Unrecognized location");this._pushEdit(d,null,!0)}_pushEdit(l,d,u){const m=this._document.validateRange(l);this._collectedEdits.push({range:m,text:d,forceMoveMarkers:u})}setEndOfLine(l){if(this._throwIfFinalized(),l!==C.EndOfLine.LF&&l!==C.EndOfLine.CRLF)throw(0,F.illegalArgument)("endOfLine");this._setEndOfLine=l}}e.TextEditorEdit=_;class k{constructor(l,d,u,m){this._proxy=l,this._id=d,this._accept(u),this._logService=m;const b=this;this.value={get tabSize(){return b._tabSize},set tabSize(w){b._setTabSize(w)},get insertSpaces(){return b._insertSpaces},set insertSpaces(w){b._setInsertSpaces(w)},get cursorStyle(){return b._cursorStyle},set cursorStyle(w){b._setCursorStyle(w)},get lineNumbers(){return b._lineNumbers},set lineNumbers(w){b._setLineNumbers(w)}}}_accept(l){this._tabSize=l.tabSize,this._insertSpaces=l.insertSpaces,this._cursorStyle=l.cursorStyle,this._lineNumbers=E.TextEditorLineNumbersStyle.to(l.lineNumbers)}_validateTabSize(l){if(l==="auto")return"auto";if(typeof l=="number"){const d=Math.floor(l);return d>0?d:null}if(typeof l=="string"){const d=parseInt(l,10);return isNaN(d)?null:d>0?d:null}return null}_setTabSize(l){const d=this._validateTabSize(l);if(d!==null){if(typeof d=="number"){if(this._tabSize===d)return;this._tabSize=d}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:d}))}}_validateInsertSpaces(l){return l==="auto"?"auto":l==="false"?!1:Boolean(l)}_setInsertSpaces(l){const d=this._validateInsertSpaces(l);if(typeof d=="boolean"){if(this._insertSpaces===d)return;this._insertSpaces=d}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:d}))}_setCursorStyle(l){this._cursorStyle!==l&&(this._cursorStyle=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:l})))}_setLineNumbers(l){this._lineNumbers!==l&&(this._lineNumbers=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:E.TextEditorLineNumbersStyle.from(l)})))}assign(l){const d={};let u=!1;if(typeof l.tabSize!="undefined"){const m=this._validateTabSize(l.tabSize);m==="auto"?(u=!0,d.tabSize=m):typeof m=="number"&&this._tabSize!==m&&(this._tabSize=m,u=!0,d.tabSize=m)}if(typeof l.insertSpaces!="undefined"){const m=this._validateInsertSpaces(l.insertSpaces);m==="auto"?(u=!0,d.insertSpaces=m):this._insertSpaces!==m&&(this._insertSpaces=m,u=!0,d.insertSpaces=m)}typeof l.cursorStyle!="undefined"&&this._cursorStyle!==l.cursorStyle&&(this._cursorStyle=l.cursorStyle,u=!0,d.cursorStyle=l.cursorStyle),typeof l.lineNumbers!="undefined"&&this._lineNumbers!==l.lineNumbers&&(this._lineNumbers=l.lineNumbers,u=!0,d.lineNumbers=E.TextEditorLineNumbersStyle.from(l.lineNumbers)),u&&this._warnOnError(this._proxy.$trySetOptions(this._id,d))}_warnOnError(l){l.catch(d=>this._logService.warn(d))}}e.ExtHostTextEditorOptions=k;class n{constructor(l,d,u,m,b,w,P,a){this.id=l,this._proxy=d,this._logService=u,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=b,this._options=new k(this._proxy,this.id,w,u),this._visibleRanges=P,this._viewColumn=a;const f=this;this.value=Object.freeze({get document(){return m.getValue()},set document(v){throw(0,F.readonly)("document")},get selection(){return f._selections&&f._selections[0]},set selection(v){if(!(v instanceof C.Selection))throw(0,F.illegalArgument)("selection");f._selections=[v],f._trySetSelection()},get selections(){return f._selections},set selections(v){if(!Array.isArray(v)||v.some(t=>!(t instanceof C.Selection)))throw(0,F.illegalArgument)("selections");f._selections=v,f._trySetSelection()},get visibleRanges(){return f._visibleRanges},set visibleRanges(v){throw(0,F.readonly)("visibleRanges")},get options(){return f._options.value},set options(v){f._disposed||f._options.assign(v)},get viewColumn(){return f._viewColumn},set viewColumn(v){throw(0,F.readonly)("viewColumn")},edit(v,t={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new _(m.getValue(),t);return v(r),f._applyEdit(r)},insertSnippet(v,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=f._selections.map(i=>E.Range.from(i));else if(t instanceof C.Position){const{lineNumber:i,column:c}=E.Position.from(t);s=[{startLineNumber:i,startColumn:c,endLineNumber:i,endColumn:c}]}else if(t instanceof C.Range)s=[E.Range.from(t)];else{s=[];for(const i of t)if(i instanceof C.Range)s.push(E.Range.from(i));else{const{lineNumber:c,column:h}=E.Position.from(i);s.push({startLineNumber:c,startColumn:h,endLineNumber:c,endColumn:h})}}return d.$tryInsertSnippet(l,v.value,s,r)},setDecorations(v,t){const r=t.length===0;r&&!f._hasDecorationsForKey.has(v.key)||(r?f._hasDecorationsForKey.delete(v.key):f._hasDecorationsForKey.add(v.key),f._runOnProxy(()=>{if(E.isDecorationOptionsArr(t))return d.$trySetDecorations(l,v.key,E.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let i=0,c=t.length;i<c;i++){const h=t[i];s[4*i]=h.start.line+1,s[4*i+1]=h.start.character+1,s[4*i+2]=h.end.line+1,s[4*i+3]=h.end.character+1}return d.$trySetDecorationsFast(l,v.key,s)}}))},revealRange(v,t){f._runOnProxy(()=>d.$tryRevealRange(l,E.Range.from(v),t||C.TextEditorRevealType.Default))},show(v){d.$tryShowEditor(l,E.ViewColumn.from(v))},hide(){d.$tryHideEditor(l)}})}dispose(){(0,g.ok)(!this._disposed),this._disposed=!0}_acceptOptions(l){(0,g.ok)(!this._disposed),this._options._accept(l)}_acceptVisibleRanges(l){(0,g.ok)(!this._disposed),this._visibleRanges=l}_acceptViewColumn(l){(0,g.ok)(!this._disposed),this._viewColumn=l}_acceptSelections(l){(0,g.ok)(!this._disposed),this._selections=l}async _trySetSelection(){const l=this._selections.map(E.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,l)),this.value}_applyEdit(l){const d=l.finalize();if(d.edits.length===0&&!d.setEndOfLine)return Promise.resolve(!0);const u=d.edits.map(b=>b.range);u.sort((b,w)=>b.end.line===w.end.line?b.end.character===w.end.character?b.start.line===w.start.line?b.start.character-w.start.character:b.start.line-w.start.line:b.end.character-w.end.character:b.end.line-w.end.line);for(let b=0,w=u.length-1;b<w;b++){const P=u[b].end;if(u[b+1].start.isBefore(P))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const m=d.edits.map(b=>({range:E.Range.from(b.range),text:b.text,forceMoveMarkers:b.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,d.documentVersionId,m,{setEndOfLine:typeof d.setEndOfLine=="number"?E.EndOfLine.from(d.setEndOfLine):void 0,undoStopBefore:d.undoStopBefore,undoStopAfter:d.undoStopAfter})}_runOnProxy(l){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,d=>(d instanceof Error&&d.name==="DISPOSED"||this._logService.warn(d),null))}}e.ExtHostTextEditor=n}),define(be[182],Ee([0,1,138,25,2,3,6,171,16,7,10,17,9,20,168]),function(ee,e,g,F,S,E,C,y,_,k,n,I,l,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function m(P,a){if((0,n.isString)(P))return{label:P};if(P&&typeof P=="object"&&typeof P.label=="string"){let f;return Array.isArray(P.highlights)&&(f=P.highlights.filter(v=>v.length===2&&typeof v[0]=="number"&&typeof v[1]=="number"),f=f.length?f:void 0),{label:P.label,highlights:f}}}class b{constructor(a,f,v){this._proxy=a,this.commands=f,this.logService=v,this.treeViews=new Map;function t(r){return r&&r.$treeViewId&&r.$treeItemHandle}f.registerArgumentProcessor({processArgument:r=>t(r)?this.convertArgument(r):Array.isArray(r)&&r.length>0?r.map(s=>t(s)?this.convertArgument(s):s):r})}registerTreeDataProvider(a,f,v){const t=this.createTreeView(a,{treeDataProvider:f},v);return{dispose:()=>t.dispose()}}createTreeView(a,f,v){if(!f||!f.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=f.dragAndDropController!==void 0,r=this._proxy.$registerTreeViewDataProvider(a,{showCollapseAll:!!f.showCollapseAll,canSelectMany:!!f.canSelectMany,canDragAndDrop:t}),s=this.createExtHostTreeView(a,f,v);return{get onDidCollapseElement(){return s.onDidCollapseElement},get onDidExpandElement(){return s.onDidExpandElement},get selection(){return s.selectedElements},get onDidChangeSelection(){return s.onDidChangeSelection},get visible(){return s.visible},get onDidChangeVisibility(){return s.onDidChangeVisibility},get message(){return s.message},set message(i){s.message=i},get title(){return s.title},set title(i){s.title=i},get description(){return s.description},set description(i){s.description=i},reveal:(i,c)=>s.reveal(i,c),dispose:async()=>{await r,this.treeViews.delete(a),s.dispose()}}}$getChildren(a,f){const v=this.treeViews.get(a);return v?v.getChildren(f):Promise.reject(new Error((0,g.localize)(0,null,a)))}async $onDrop(a,f,v){const t=this.treeViews.get(a);if(!t)return Promise.reject(new Error((0,g.localize)(1,null,a)));const r=u.TreeDataTransferConverter.toITreeDataTransfer(f);if(r.items.has(y.TREE_ITEM_DATA_TRANSFER_TYPE)){const i=JSON.parse(await r.items.get(y.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(c=>t.getExtensionElement(c)).filter(c=>!!c);i.length>0?r.items.set(y.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(i)}):r.items.delete(y.TREE_ITEM_DATA_TRANSFER_TYPE)}return t.onDrop(r,v)}async $hasResolve(a){const f=this.treeViews.get(a);if(!f)throw new Error((0,g.localize)(2,null,a));return f.hasResolve}$resolve(a,f,v){const t=this.treeViews.get(a);if(!t)throw new Error((0,g.localize)(3,null,a));return t.resolveTreeItem(f,v)}$setExpanded(a,f,v){const t=this.treeViews.get(a);if(!t)throw new Error((0,g.localize)(4,null,a));t.setExpanded(f,v)}$setSelection(a,f){const v=this.treeViews.get(a);if(!v)throw new Error((0,g.localize)(5,null,a));v.setSelection(f)}$setVisible(a,f){const v=this.treeViews.get(a);if(!v)throw new Error((0,g.localize)(6,null,a));v.setVisible(f)}createExtHostTreeView(a,f,v){const t=new w(a,f,this._proxy,this.commands.converter,this.logService,v);return this.treeViews.set(a,t),t}convertArgument(a){const f=this.treeViews.get(a.$treeViewId);return f?f.getExtensionElement(a.$treeItemHandle):null}}e.ExtHostTreeViews=b;class w extends C.Disposable{constructor(a,f,v,t,r,s){super();if(this.viewId=a,this.proxy=v,this.commands=t,this.logService=r,this.extension=s,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new E.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new E.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new E.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new E.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new E.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new d.CancellationTokenSource,s.contributes&&s.contributes.views)for(const h in s.contributes.views)for(const p of s.contributes.views[h])p.id===a&&(this._title=p.name);this.dataProvider=f.treeDataProvider,this.dndController=f.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(h=>this._onDidChangeData.fire({message:!1,element:h}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(h=>this._onDidChangeData.fire({message:!1,element:h})));let i,c;this._register(E.Event.debounce(this._onDidChangeData.event,(h,p)=>(h||(h={message:!1,elements:[]}),p.element!==!1&&(i||(i=new Promise(D=>c=D),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(p.element)?h.elements.push(...p.element):h.elements.push(p.element)),p.message&&(h.message=!0),h),200,!0)(({message:h,elements:p})=>{p.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const D=c;return i=null,this.refresh(p).then(()=>D())})),h&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,n.isUndefinedOrNull)(a))}getChildren(a){const f=a?this.getExtensionElement(a):void 0;if(a&&!f)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);const v=this.getChildrenNodes(a);return(v?Promise.resolve(v):this.fetchChildrenNodes(f)).then(t=>t.map(r=>r.item))}getExtensionElement(a){return this.elements.get(a)}reveal(a,f){f=f||{select:!0,focus:!1};const v=(0,n.isUndefinedOrNull)(f.select)?!0:f.select,t=(0,n.isUndefinedOrNull)(f.focus)?!1:f.focus,r=(0,n.isUndefinedOrNull)(f.expand)?!1:f.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(s=>this.resolveTreeNode(a,s[s.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:s.map(c=>c.item)},{select:v,focus:t,expand:r})),s=>this.logService.error(s)):this.proxy.$reveal(this.viewId,void 0,{select:v,focus:t,expand:r})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}setExpanded(a,f){const v=this.getExtensionElement(a);v&&(f?this._onDidExpandElement.fire(Object.freeze({element:v})):this._onDidCollapseElement.fire(Object.freeze({element:v})))}setSelection(a){(0,I.equals)(this._selectedHandles,a)||(this._selectedHandles=a,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(a,f){const v=this.getExtensionElement(f);if(!!v)return(0,_.asPromise)(()=>this.dndController?.onDrop(a,v))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,f){if(!this.dataProvider.resolveTreeItem)return;const v=this.elements.get(a);if(v){const t=this.nodes.get(v);if(t){const r=await this.dataProvider.resolveTreeItem(t.extensionItem,v,f)??t.extensionItem;return t.item.tooltip=this.getTooltip(r.tooltip),t.item.command=this.getCommand(t.disposableStore,r.command),t.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(f=>f?this.resolveUnknownParentChain(f).then(v=>this.resolveTreeNode(f,v[v.length-1]).then(t=>(v.push(t),v))):Promise.resolve([]))}resolveParent(a){const f=this.nodes.get(a);return f?Promise.resolve(f.parent?this.elements.get(f.parent.item.handle):void 0):(0,_.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,f){const v=this.nodes.get(a);return v?Promise.resolve(v):(0,_.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(t=>this.createHandle(a,t,f,!0)).then(t=>this.getChildren(f?f.item.handle:void 0).then(()=>{const r=this.getExtensionElement(t);if(r){const s=this.nodes.get(r);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${t}`)}))}getChildrenNodes(a){if(a){let f;if(typeof a=="string"){const v=this.getExtensionElement(a);f=v?this.nodes.get(v):void 0}else f=a;return f&&f.children||null}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const f=new d.CancellationTokenSource(this._refreshCancellationSource.token);try{const v=a?this.nodes.get(a):void 0,t=await this.dataProvider.getChildren(a);if(f.token.isCancellationRequested)return[];const r=await Promise.all((0,I.coalesce)(t||[]).map(async s=>{const i=await this.dataProvider.getTreeItem(s);return i&&!f.token.isCancellationRequested?this.createAndRegisterTreeNode(s,i,v):null}));return f.token.isCancellationRequested?[]:(0,I.coalesce)(r)}finally{f.dispose()}}refresh(a){if(a.some(v=>!v))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new d.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const v=this.getHandlesToRefresh(a);if(v.length)return this.refreshHandles(v)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const f=new Set,v=a.map(r=>this.nodes.get(r));for(const r of v)if(r&&!f.has(r.item.handle)){let s=r;for(;s&&s.parent&&v.findIndex(i=>s&&s.parent&&i&&i.item.handle===s.parent.item.handle)===-1;){const i=this.elements.get(s.parent.item.handle);s=i?this.nodes.get(i):void 0}s&&!s.parent&&f.add(r.item.handle)}const t=[];return f.forEach(r=>{const s=this.elements.get(r);if(s){const i=this.nodes.get(s);i&&(!i.parent||!f.has(i.parent.item.handle))&&t.push(r)}}),t}refreshHandles(a){const f={};return Promise.all(a.map(v=>this.refreshNode(v).then(t=>{t&&(f[v]=t.item)}))).then(()=>Object.keys(f).length?this.proxy.$refresh(this.viewId,f):void 0)}refreshNode(a){const f=this.getExtensionElement(a);if(f){const v=this.nodes.get(f);if(v)return this.clearChildren(f),(0,_.asPromise)(()=>this.dataProvider.getTreeItem(f)).then(t=>{if(t){const r=this.createTreeNode(f,t,v.parent);return this.updateNodeCache(f,r,v,v.parent),v.dispose(),r}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,f,v){const t=this.createTreeNode(a,f,v);if(f.id&&this.elements.has(t.item.handle))throw new Error((0,g.localize)(7,null,f.id));return this.addNodeToCache(a,t),this.addNodeToParentCache(t,v),t}getTooltip(a){return k.MarkdownString.isMarkdownString(a)?l.MarkdownString.from(a):a}getCommand(a,f){return f?this.commands.toInternal(f,a):void 0}createTreeNode(a,f,v){const t=new C.DisposableStore,r=this.createHandle(a,f,v),s=this.getLightIconPath(f);return{item:{handle:r,parentHandle:v?v.item.handle:void 0,label:m(f.label,this.extension),description:f.description,resourceUri:f.resourceUri,tooltip:this.getTooltip(f.tooltip),command:this.getCommand(t,f.command),contextValue:f.contextValue,icon:s,iconDark:this.getDarkIconPath(f)||s,themeIcon:this.getThemeIcon(f),collapsibleState:(0,n.isUndefinedOrNull)(f.collapsibleState)?k.TreeItemCollapsibleState.None:f.collapsibleState,accessibilityInformation:f.accessibilityInformation},extensionItem:f,parent:v,children:void 0,disposableStore:t,dispose(){t.dispose()}}}getThemeIcon(a){return a.iconPath instanceof k.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:f,label:v,resourceUri:t},r,s){if(f)return`${w.ID_HANDLE_PREFIX}/${f}`;const i=m(v,this.extension),c=r?r.item.handle:w.LABEL_HANDLE_PREFIX;let h=i?i.label:t?(0,F.basename)(t):"";h=h.indexOf("/")!==-1?h.replace("/","//"):h;const p=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,D=this.getChildrenNodes(r)||[];let T,o=0;do{if(T=`${c}/${o}:${h}`,s||!this.elements.has(T)||p===T)break;o++}while(o<=D.length);return T}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof k.ThemeIcon))return typeof a.iconPath=="string"||S.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof k.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return S.URI.isUri(a)?a:S.URI.file(a)}addNodeToCache(a,f){this.elements.set(f.item.handle,a),this.nodes.set(a,f)}updateNodeCache(a,f,v,t){this.elements.delete(f.item.handle),this.nodes.delete(a),f.item.handle!==v.item.handle&&this.elements.delete(v.item.handle),this.addNodeToCache(a,f);const r=this.getChildrenNodes(t)||[],s=r.filter(i=>i.item.handle===v.item.handle)[0];s&&r.splice(r.indexOf(s),1,f)}addNodeToParentCache(a,f){f?(f.children||(f.children=[]),f.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const f=this.nodes.get(a);if(f){if(f.children)for(const v of f.children){const t=this.elements.get(v.item.handle);t&&this.clear(t)}f.children=void 0}}else this.clearAll()}clear(a){const f=this.nodes.get(a);if(f){if(f.children)for(const v of f.children){const t=this.elements.get(v.item.handle);t&&this.clear(t)}this.nodes.delete(a),this.elements.delete(f.item.handle),f.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}w.LABEL_HANDLE_PREFIX="0",w.ID_HANDLE_PREFIX="1"}),define(be[183],Ee([0,1,16,3,6,10,67,9,99,72]),function(ee,e,g,F,S,E,C,y,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class n extends S.Disposable{constructor(l){super();this.controllerId=l,this.debounceSendDiff=this._register(new g.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new F.Emitter),this.root=new C.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(l){this._resolveHandler=l;for(const d of this.tree.values())this.updateExpandability(d)}collectDiff(){const l=this.diff;return this.diff=[],l}pushDiff(l){const d=this.diff[this.diff.length-1];if(d&&l[0]===1){if(d[0]===1&&d[1].extId===l[1].extId){(0,_.applyTestItemUpdate)(d[1],l[1]);return}if(d[0]===0&&d[1].item.extId===l[1].extId){(0,_.applyTestItemUpdate)(d[1],l[1]);return}}this.diff.push(l),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(l,d){const u=this.tree.get(l);if(!!u){if((u.expandLevels===void 0||d>u.expandLevels)&&(u.expandLevels=d),u.expand===1){const m=this.resolveChildren(u);return m.isOpen()?this.expandChildren(u,d-1):m.wait().then(()=>this.expandChildren(u,d-1))}else if(u.expand===3)return u.resolveBarrier?.isOpen()===!1?u.resolveBarrier.wait().then(()=>this.expandChildren(u,d-1)):this.expandChildren(u,d-1)}}dispose(){for(const l of this.tree.values())(0,C.getPrivateApiFor)(l.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(l,d){switch(d.op){case 2:this.pushDiff([4,l.fullId.toString()]);break;case 1:this.removeItem(k.TestId.joinToString(l.fullId,d.id));break;case 0:this.upsertItem(d.item,l);break;case 4:for(const w of d.ops)this.onTestItemEvent(l,w);break;case 3:const{key:u,value:m}=d,b=l.fullId.toString();switch(u){case"canResolveChildren":this.updateExpandability(l);break;case"range":this.pushDiff([1,{extId:b,item:{range:y.Range.from(m)}}]);break;case"error":this.pushDiff([1,{extId:b,item:{error:y.MarkdownString.fromStrict(m)||null}}]);break;default:this.pushDiff([1,{extId:b,item:{[u]:m??null}}]);break}break;default:(0,E.assertNever)(d)}}upsertItem(l,d){if(!(l instanceof C.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${l.id} did not`);const u=k.TestId.fromExtHostTestItem(l,this.root.id,d?.actual),m=(0,C.getPrivateApiFor)(l);m.parent&&m.parent!==d?.actual&&m.parent.children.delete(l.id);let b=this.tree.get(u.toString());if(!b){b={fullId:u,actual:l,parent:d?u.parentId:null,expandLevels:d?.expandLevels?d.expandLevels-1:void 0,expand:0},this.tree.set(b.fullId.toString(),b),this.setItemParent(l,d),this.pushDiff([0,{parent:b.parent&&b.parent.toString(),controllerId:this.controllerId,expand:b.expand,item:y.TestItem.from(l,this.root.id)}]),this.connectItemAndChildren(l,b,d);return}if(b.actual===l){this.connectItem(l,b,d);return}const w=b.actual.children,P=b.actual,a=(0,C.diffTestItems)(P,l);(0,C.getPrivateApiFor)(P).listener=void 0,b.actual=l,b.expand=0;for(const[f,v]of a)this.onTestItemEvent(b,{op:3,key:f,value:v});this.connectItemAndChildren(l,b,d);for(const f of w)l.children.get(f.id)||this.removeItem(k.TestId.joinToString(u,f.id))}setItemParent(l,d){(0,C.getPrivateApiFor)(l).parent=d&&d.actual!==this.root?d.actual:void 0}connectItem(l,d,u){this.setItemParent(l,u);const m=(0,C.getPrivateApiFor)(l);m.parent=u?.actual,m.listener=b=>this.onTestItemEvent(d,b),this.updateExpandability(d)}connectItemAndChildren(l,d,u){this.connectItem(l,d,u);for(const m of l.children)this.upsertItem(m,d)}updateExpandability(l){let d;this._resolveHandler?l.resolveBarrier?d=l.resolveBarrier.isOpen()?3:2:d=l.actual.canResolveChildren?1:0:d=0,d!==l.expand&&(l.expand=d,this.pushDiff([1,{extId:l.fullId.toString(),expand:d}]),d===1&&l.expandLevels!==void 0&&this.resolveChildren(l))}expandChildren(l,d){if(d<0)return;const u=[];for(const m of l.actual.children){const b=this.expand(k.TestId.joinToString(l.fullId,m.id),d);(0,g.isThenable)(b)&&u.push(b)}if(u.length)return Promise.all(u).then(()=>{})}resolveChildren(l){if(l.resolveBarrier)return l.resolveBarrier;if(!this._resolveHandler){const m=new g.Barrier;return m.open(),m}l.expand=2,this.pushExpandStateUpdate(l);const d=l.resolveBarrier=new g.Barrier;let u;try{u=this._resolveHandler(l.actual===this.root?void 0:l.actual)}catch(m){l.actual.error=m.stack||m.message}return(0,g.isThenable)(u)?u.catch(m=>l.actual.error=m.stack||m.message).then(()=>{d.open(),this.updateExpandability(l)}):(d.open(),this.updateExpandability(l)),l.resolveBarrier}pushExpandStateUpdate(l){this.pushDiff([1,{extId:l.fullId.toString(),expand:l.expand}])}removeItem(l){const d=this.tree.get(l);if(!d)throw new Error("attempting to remove non-existent child");this.pushDiff([2,l]);const u=[d];for(;u.length;){const m=u.pop();if(!!m){(0,C.getPrivateApiFor)(m.actual).listener=void 0,this.tree.delete(m.fullId.toString());for(const b of m.actual.children)u.push(this.tree.get(k.TestId.joinToString(m.fullId,b.id)))}}}flushDiff(){const l=this.collectDiff();l.length&&this.diffOpEmitter.fire(l)}}e.SingleUseTestCollection=n}),define(be[184],Ee([0,1,4,151]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,g.refineServiceDecorator)(F.IEnvironmentService)}),define(be[185],Ee([0,1,26,3,14]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class E{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=E;class C{constructor(n){this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(g.ExtensionIdentifier.toKey(n.identifier))){console.error("Extension `"+n.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(g.ExtensionIdentifier.toKey(n.identifier),n),this._extensionsArr.push(n),Array.isArray(n.activationEvents))for(let I of n.activationEvents)I==="onUri"&&(I=`onUri:${g.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(n)}}keepOnly(n){const I=new Set;n.forEach(l=>I.add(g.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>I.has(g.ExtensionIdentifier.toKey(l.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,I){n.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(n));const l=C._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(l.map(d=>d.identifier)),I.length>0){const d=new Set;I.forEach(u=>d.add(g.ExtensionIdentifier.toKey(u))),this._extensionDescriptions=this._extensionDescriptions.filter(u=>!d.has(g.ExtensionIdentifier.toKey(u.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new E(l)}static _findLoopingExtensions(n){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(b){this._nodesSet.has(b)||(this._nodesSet.add(b),this._nodesArr.push(b))}addArc(b,w){this.addNode(b),this.addNode(w),this._arcs.has(b)?this._arcs.get(b).push(w):this._arcs.set(b,[w])}getArcs(b){return this._arcs.has(b)?this._arcs.get(b):[]}hasOnlyGoodArcs(b,w){const P=I.getArcs(b);for(let a=0;a<P.length;a++)if(!w.has(P[a]))return!1;return!0}getNodes(){return this._nodesArr}};let l=new Map;for(let b of n){const w=g.ExtensionIdentifier.toKey(b.identifier);if(l.set(w,b),b.extensionDependencies)for(let P of b.extensionDependencies){const a=g.ExtensionIdentifier.toKey(P);I.addArc(w,a)}}let d=new Set;I.getNodes().filter(b=>I.getArcs(b).length===0).forEach(b=>d.add(b));let u=I.getNodes().filter(b=>!d.has(b)),m;do{m=!1;for(let b=0;b<u.length;b++){const w=u[b];I.hasOnlyGoodArcs(w,d)&&(u.splice(b,1),b--,d.add(w),m=!0)}}while(m);return u.map(b=>l.get(b))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(g.ExtensionIdentifier.toKey(n))}getExtensionDescriptionsForActivationEvent(n){const I=this._activationMap.get(n);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const I=this._extensionsMap.get(g.ExtensionIdentifier.toKey(n));return I||void 0}}e.ExtensionDescriptionRegistry=C;var y;(function(k){k[k.Builtin=0]="Builtin",k[k.User=1]="User",k[k.Dev=2]="Dev"})(y||(y={}));function _(k,n){const I=k.isBuiltin?0:k.isUnderDevelopment?2:1,l=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(I!==l)return I-l;const d=S.posix.basename(k.extensionLocation.path),u=S.posix.basename(n.extensionLocation.path);return d<u?-1:d>u?1:0}}),define(be[186],Ee([0,1,24]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var F;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(F=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var S;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(S=e.MessageType||(e.MessageType={}));function E(y){const _=g.VSBuffer.alloc(1);switch(y){case 0:_.writeUInt8(1,0);break;case 1:_.writeUInt8(2,0);break;case 2:_.writeUInt8(3,0);break}return _}e.createMessageOfType=E;function C(y,_){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return _===0;case 2:return _===1;case 3:return _===2;default:return!1}}e.isMessageOfType=C}),define(be[30],Ee([0,1,3,2,4,26,152]),function(ee,e,g,F,S,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new E.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,S.createDecorator)("extensionService");class y{constructor(P){this.dependency=P}}e.MissingExtensionDependency=y;var _;(function(w){w[w.LocalProcess=0]="LocalProcess",w[w.LocalWebWorker=1]="LocalWebWorker",w[w.Remote=2]="Remote"})(_=e.ExtensionHostKind||(e.ExtensionHostKind={}));class k{constructor(P,a,f,v){this.codeLoadingTime=P,this.activateCallTime=a,this.activateResolvedTime=f,this.activationReason=v}}e.ActivationTimes=k;class n{constructor(P,a){this.description=P,this.value=a}}e.ExtensionPointContribution=n,e.ExtensionHostLogFileName="exthost";var I;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(I=e.ActivationKind||(e.ActivationKind={}));function l(w){w.enableProposedApi||d(w)}e.checkProposedApiEnabled=l;function d(w){throw new Error(`[${w.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.throwProposedApiError=d;function u(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation}}e.toExtension=u;function m(w,P){return{identifier:new E.ExtensionIdentifier(w.identifier.id),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!!P,extensionLocation:w.location,...w.manifest,uuid:w.identifier.uuid}}e.toExtensionDescription=m;class b{constructor(){this.onDidRegisterExtensions=g.Event.None,this.onDidChangeExtensionsStatus=g.Event.None,this.onDidChangeExtensions=g.Event.None,this.onWillActivateByEvent=g.Event.None,this.onDidChangeResponsiveChange=g.Event.None}activateByEvent(P){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(P){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(P){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(P){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(P,a){return Promise.resolve()}_onWillActivateExtension(P){}_onDidActivateExtension(P,a,f,v,t){}_onDidActivateExtensionError(P,a){}_onExtensionRuntimeError(P,a){}_onExtensionHostExit(P){}}e.NullExtensionService=b}),define(be[187],Ee([0,1,26,30,15]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const E=Promise.resolve(void 0);class C{constructor(u,m,b,w){this.startup=u,this.codeLoadingTime=m,this.activateCallTime=b,this.activateResolvedTime=w}}e.ExtensionActivationTimes=C,C.NONE=new C(!1,-1,-1,-1);class y{constructor(u){this._startup=u,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(u,m){return u===-1||m===-1?-1:m-u}build(){return new C(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class _{constructor(u,m,b,w,P,a){this.activationFailed=u,this.activationFailedError=m,this.activationTimes=b,this.module=w,this.exports=P,this.subscriptions=a}}e.ActivatedExtension=_;class k extends _{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class n extends _{constructor(){super(!1,null,C.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=n;class I extends _{constructor(u){super(!0,u,C.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let l=class{constructor(u,m,b,w,P){this._logService=P,this._registry=u,this._resolvedExtensionsSet=new Set,m.forEach(a=>this._resolvedExtensionsSet.add(g.ExtensionIdentifier.toKey(a))),this._hostExtensionsMap=new Map,b.forEach(a=>this._hostExtensionsMap.set(g.ExtensionIdentifier.toKey(a),a)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(u){const m=g.ExtensionIdentifier.toKey(u);return this._activatedExtensions.has(m)}getActivatedExtension(u){const m=g.ExtensionIdentifier.toKey(u),b=this._activatedExtensions.get(m);if(!b)throw new Error("Extension `"+u.value+"` is not known or not activated");return b}activateByEvent(u,m){if(this._alreadyActivatedEvents[u])return E;const b=this._registry.getExtensionDescriptionsForActivationEvent(u);return this._activateExtensions(b.map(w=>({id:w.identifier,reason:{startup:m,extensionId:w.identifier,activationEvent:u}}))).then(()=>{this._alreadyActivatedEvents[u]=!0})}activateById(u,m){const b=this._registry.getExtensionDescription(u);if(!b)throw new Error("Extension `"+u+"` is not known");return this._activateExtensions([{id:b.identifier,reason:m}])}_handleActivateRequest(u,m,b){if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(u.id))){m[g.ExtensionIdentifier.toKey(u.id)]=u;return}const w=this._registry.getExtensionDescription(u.id);if(!w){const f=new Error(`Cannot activate unknown extension '${u.id.value}'`);this._host.onExtensionActivationError(u.id,f,new F.MissingExtensionDependency(u.id.value)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(u.id),new I(f));return}const P=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let a=!0;for(let f=0,v=P.length;f<v;f++){const t=P[f];if(this._resolvedExtensionsSet.has(g.ExtensionIdentifier.toKey(t)))continue;const r=this._activatedExtensions.get(g.ExtensionIdentifier.toKey(t));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const h=w.displayName||w.identifier.value,p=this._registry.getExtensionDescription(t),D=p&&p.displayName||t,T=new Error(`Cannot activate the '${h}' extension because its dependency '${D}' failed to activate`);T.detail=r.activationFailedError,this._host.onExtensionActivationError(w.identifier,T,null),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(w.identifier),new I(T));return}if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(t))){a=!1,m[g.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(g.ExtensionIdentifier.toKey(t)),reason:u.reason};continue}const s=this._registry.getExtensionDescription(t);if(s){a=!1,m[g.ExtensionIdentifier.toKey(t)]={id:s.identifier,reason:u.reason};continue}const i=w.displayName||w.identifier.value,c=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(w.identifier,c,new F.MissingExtensionDependency(t)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(w.identifier),new I(c));return}a?m[g.ExtensionIdentifier.toKey(w.identifier)]=u:b.push(u)}_activateExtensions(u){if(u.length===0||(u=u.filter(P=>!this._activatedExtensions.has(g.ExtensionIdentifier.toKey(P.id))),u.length===0))return Promise.resolve(void 0);const m=Object.create(null),b=[];for(let P=0,a=u.length;P<a;P++)this._handleActivateRequest(u[P],m,b);for(let P=0,a=b.length;P<a;P++){const f=g.ExtensionIdentifier.toKey(b[P].id);m[f]&&delete m[f]}const w=Object.keys(m).map(P=>m[P]);return b.length===0?Promise.all(w.map(P=>this._activateExtension(P.id,P.reason))).then(P=>{}):this._activateExtensions(w).then(P=>this._activateExtensions(b))}_activateExtension(u,m){const b=g.ExtensionIdentifier.toKey(u);if(this._activatedExtensions.has(b))return Promise.resolve(void 0);const w=this._activatingExtensions.get(b);if(w)return w;const P=this._host.actualActivateExtension(u,m).then(void 0,a=>{const f=new Error;return a&&a.name&&(f.name=a.name),a&&a.message?f.message=`Activating extension '${u.value}' failed: ${a.message}.`:f.message=`Activating extension '${u.value}' failed: ${a}.`,a&&a.stack&&(f.stack=a.stack),this._host.onExtensionActivationError(u,f,null),this._logService.error(`Activating extension ${u.value} failed due to an error:`),this._logService.error(a),new I(a)}).then(a=>{this._activatedExtensions.set(b,a),this._activatingExtensions.delete(b)});return this._activatingExtensions.set(b,P),P}};l=ze([qe(4,S.ILogService)],l),e.ExtensionsActivator=l}),define(be[188],Ee([0,1,12]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class F{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((E,C)=>{this._actualOk=E,this._actualErr=C,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(E){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=E,this._actual&&this._actualOk(E))}resolveErr(E){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=E,this._actual?this._actualErr(E):(0,g.onUnexpectedError)(E))}then(E,C){return this._ensureActual().then(E,C)}catch(E){return this._ensureActual().then(void 0,E)}finally(E){return this._ensureActual().finally(E)}}e.LazyPromise=F}),define(be[103],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class g{constructor(_,k){this._proxyIdentifierBrand=void 0,this.isMain=_,this.sid=k,this.nid=++g.count}}e.ProxyIdentifier=g,g.count=0;const F=[];function S(y){const _=new g(!0,y);return F[_.nid]=_,_}e.createMainContextProxyIdentifier=S;function E(y){const _=new g(!1,y);return F[_.nid]=_,_}e.createExtHostContextProxyIdentifier=E;function C(y){return F[y].sid}e.getStringIdentifierForProxy=C}),define(be[5],Ee([0,1,56,2,103]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var E;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(E=e.UIKind||(e.UIKind={}));var C;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(C=e.TextEditorRevealType||(e.TextEditorRevealType={}));var y;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(y=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var _;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(_=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var k;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(k=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var l;(function(a){a.name="$ident";function f(t,r){return Object.defineProperty(t,a.name,{value:r,enumerable:!0}),t}a.mixin=f;function v(t){return t[a.name]}a.of=v})(l=e.ObjectIdentifier||(e.ObjectIdentifier={}));class d{static mixin(f){return f._id=d._n++,f}}e.IdObject=d,d._n=0;var u;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.command="m",a.kindModifier="n"})(u=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var m;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(m=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var b;(function(a){a[a.File=1]="File",a[a.Text=2]="Text",a[a.Cell=3]="Cell"})(b=e.WorkspaceEditType||(e.WorkspaceEditType={}));function w(a){if(a&&a.edits)for(const f of a.edits)typeof f.resource=="object"?f.resource=F.URI.revive(f.resource):(f.newUri=F.URI.revive(f.newUri),f.oldUri=F.URI.revive(f.oldUri)),f.metadata&&f.metadata.iconPath&&(f.metadata=(0,g.revive)(f.metadata));return a}e.reviveWorkspaceEditDto=w;var P;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(P=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,S.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,S.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,S.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,S.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,S.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,S.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,S.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,S.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,S.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,S.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,S.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,S.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,S.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,S.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,S.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,S.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,S.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,S.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,S.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,S.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,S.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,S.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,S.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,S.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,S.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,S.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,S.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,S.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,S.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,S.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,S.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,S.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,S.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,S.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,S.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,S.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,S.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,S.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,S.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,S.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,S.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,S.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,S.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,S.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,S.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,S.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,S.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,S.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,S.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,S.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,S.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,S.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,S.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,S.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,S.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,S.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,S.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,S.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,S.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,S.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,S.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,S.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,S.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,S.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,S.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,S.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,S.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,S.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,S.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,S.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,S.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,S.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,S.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[73],Ee([0,1,5,3,4]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class E{constructor(y){this._onDidChangePassword=new F.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=y.getProxy(g.MainContext.MainThreadSecretState)}async $onDidChangePassword(y){this._onDidChangePassword.fire(y)}get(y,_){return this._proxy.$getPassword(y,_)}store(y,_,k){return this._proxy.$setPassword(y,_,k)}delete(y,_){return this._proxy.$deletePassword(y,_)}}e.ExtHostSecretState=E,e.IExtHostSecretState=(0,S.createDecorator)("IExtHostSecretState")}),define(be[74],Ee([0,1,4,15,5,13]),function(ee,e,g,F,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,g.createDecorator)("IExtHostApiDeprecationService");let C=class{constructor(_,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(S.MainContext.MainThreadTelemetry)}report(_,k,n){const I=this.getUsageKey(_,k);this._reportedUsages.has(I)||(this._reportedUsages.add(I),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${n}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:_}))}getUsageKey(_,k){return`${_}-${k.identifier.value}`}};C=ze([qe(0,E.IExtHostRpcService),qe(1,F.ILogService)],C),e.ExtHostApiDeprecationService=C,e.NullApiDeprecationService=Object.freeze(new class{report(y,_,k){}})}),define(be[189],Ee([0,1,3,5,7,26]),function(ee,e,g,F,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(_){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new g.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=_.getProxy(F.MainContext.MainThreadAuthentication)}$setProviders(_){return this._providers=_,Promise.resolve()}async getSession(_,k,n,I={}){const l=E.ExtensionIdentifier.toKey(_.identifier),d=this._inFlightRequests.get(l)||[],u=[...n].sort().join(" ");let m=d.find(b=>b.scopes===u);if(m)return m.result;{const b=this._getSession(_,l,k,n,I);m={scopes:u,result:b},d.push(m),this._inFlightRequests.set(l,d);try{await b}finally{const w=d.findIndex(P=>P.scopes===u);w>-1&&(d.splice(w),this._inFlightRequests.set(l,d))}return b}}async _getSession(_,k,n,I,l={}){await this._proxy.$ensureProvider(n);const d=_.displayName||_.name;return this._proxy.$getSession(n,I,k,d,l)}async removeSession(_,k){const n=this._authenticationProviders.get(_);return n?n.provider.removeSession(k):this._proxy.$removeSession(_,k)}registerAuthenticationProvider(_,k,n,I){if(this._authenticationProviders.get(_))throw new Error(`An authentication provider with id '${_}' is already registered.`);this._authenticationProviders.set(_,{label:k,provider:n,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(d=>d.id===_)||this._providers.push({id:_,label:k});const l=n.onDidChangeSessions(d=>{this._proxy.$sendDidChangeSessions(_,{added:d.added??[],changed:d.changed??[],removed:d.removed??[]})});return this._proxy.$registerAuthenticationProvider(_,k,I?.supportsMultipleAccounts??!1),new S.Disposable(()=>{l.dispose(),this._authenticationProviders.delete(_);const d=this._providers.findIndex(u=>u.id===_);d>-1&&this._providers.splice(d),this._proxy.$unregisterAuthenticationProvider(_)})}$createSession(_,k){const n=this._authenticationProviders.get(_);if(n)return Promise.resolve(n.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$removeSession(_,k){const n=this._authenticationProviders.get(_);if(n)return Promise.resolve(n.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$getSessions(_,k){const n=this._authenticationProviders.get(_);if(n)return Promise.resolve(n.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$onDidChangeAuthenticationSessions(_,k){return this._onDidChangeSessions.fire({provider:{id:_,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(be[190],Ee([0,1,5,13,9]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let E=class{constructor(y,_){this._extHostDocumentsAndEditors=_,this._proxy=y.getProxy(g.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(y){const _=S.WorkspaceEdit.from(y,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(_)}};E=ze([qe(0,F.IExtHostRpcService)],E),e.ExtHostBulkEdits=E}),define(be[191],Ee([0,1,5]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class F{constructor(E){const C=E.getProxy(g.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(y){return C.$writeText(y)}})}}e.ExtHostClipboard=F}),define(be[75],Ee([0,1,10,7,9,23,5,17,15,56,31,37,2,6,4,13]),function(ee,e,g,F,S,E,C,y,_,k,n,I,l,d,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let b=class{constructor(t,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(C.MainContext.MainThreadCommands),this._logService=r,this.converter=new w(this,s=>{const i=this._apiCommands.get(s);return i?.result===a.Void?i:void 0},r),this._argumentProcessors=[{processArgument(s){return(0,k.revive)(s)}},{processArgument(s){return(0,E.cloneAndChange)(s,function(i){if(n.Range.isIRange(i))return S.Range.to(i);if(I.Position.isIPosition(i))return S.Position.to(i);if(n.Range.isIRange(i.range)&&l.URI.isUri(i.uri))return S.location.to(i);if(!Array.isArray(i))return i})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const r=this.registerCommand(!1,t.id,async(...s)=>{const i=t.args.map((h,p)=>{if(!h.validate(s[p]))throw new Error(`Invalid argument '${h.name}' when running '${t.id}', received: ${s[p]}`);return h.convert(s[p])}),c=await this.executeCommand(t.internalId,...i);return t.result.convert(c,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new F.Disposable(()=>{r.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,r,s,i,c){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:s,thisArg:i,description:c}),t&&this._proxy.$registerCommand(r),new F.Disposable(()=>{this._commands.delete(r)&&t&&this._proxy.$unregisterCommand(r)})}executeCommand(t,...r){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,r,!0)}async _doExecuteCommand(t,r,s){if(this._commands.has(t))return this._executeContributedCommand(t,r);{const i=(0,E.cloneAndChange)(r,function(c){if(c instanceof F.Position)return S.Position.from(c);if(c instanceof F.Range)return S.Range.from(c);if(c instanceof F.Location)return S.location.from(c);if(F.NotebookRange.isNotebookRange(c))return S.NotebookRange.from(c);if(!Array.isArray(c))return c});try{const c=await this._proxy.$executeCommand(t,i,s);return(0,k.revive)(c)}catch(c){if(c instanceof Error&&c.message==="$executeCommand:retry")return this._doExecuteCommand(t,r,!1);throw c}}}async _executeContributedCommand(t,r){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:i,thisArg:c,description:h}=s;if(h)for(let p=0;p<h.args.length;p++)try{(0,g.validateConstraint)(r[p],h.args[p].constraint)}catch(D){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${h.args[p].name}' - ${h.args[p].description}`)}try{return await i.apply(c,r)}catch(p){if(t===this.converter.delegatingCommandId){const D=this.converter.getActualCommand(...r);D&&(t=D.command)}throw this._logService.error(p,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(r=r.map(s=>this._argumentProcessors.reduce((i,c)=>c.processArgument(i),s)),this._executeContributedCommand(t,r)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(r=>(t&&(r=r.filter(s=>s[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[r,s]of this._commands){let{description:i}=s;i&&(t[r]=i)}return Promise.resolve(t)}};b=ze([qe(0,m.IExtHostRpcService),qe(1,_.ILogService)],b),e.ExtHostCommands=b,e.IExtHostCommands=(0,u.createDecorator)("IExtHostCommands");class w{constructor(t,r,s){this._commands=t,this._lookupApiCommand=r,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,r){if(!t)return;const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const i=this._lookupApiCommand(t.command);if(i)s.id=i.internalId,s.arguments=i.args.map((c,h)=>c.convert(t.arguments&&t.arguments[h]));else if((0,y.isNonEmptyArray)(t.arguments)){const c=++this._cachIdPool;this._cache.set(c,t),r.add((0,d.toDisposable)(()=>{this._cache.delete(c),this._logService.trace("CommandsConverter#DISPOSE",c)})),s.$ident=c,s.id=this.delegatingCommandId,s.arguments=[c],this._logService.trace("CommandsConverter#CREATE",t.command,c)}return s}fromInternal(t){const r=C.ObjectIdentifier.of(t);return typeof r=="number"?this._cache.get(r):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const r=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class P{constructor(t,r,s,i){this.name=t,this.description=r,this.validate=s,this.convert=i}optional(){return new P(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,r){return new P(t??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=P,P.Uri=new P("uri","Uri of a text document",v=>l.URI.isUri(v),v=>v),P.Position=new P("position","A position in a text document",v=>F.Position.isPosition(v),S.Position.from),P.Range=new P("range","A range in a text document",v=>F.Range.isRange(v),S.Range.from),P.Selection=new P("selection","A selection in a text document",v=>F.Selection.isSelection(v),S.Selection.from),P.Number=new P("number","",v=>typeof v=="number",v=>v),P.String=new P("string","",v=>typeof v=="string",v=>v),P.CallHierarchyItem=new P("item","A call hierarchy item",v=>v instanceof F.CallHierarchyItem,S.CallHierarchyItem.from),P.TypeHierarchyItem=new P("item","A type hierarchy item",v=>v instanceof F.TypeHierarchyItem,S.TypeHierarchyItem.from);class a{constructor(t,r){this.description=t,this.convert=r}}e.ApiCommandResult=a,a.Void=new a("no result",v=>v);class f{constructor(t,r,s,i,c){this.id=t,this.internalId=r,this.description=s,this.args=i,this.result=c}}e.ApiCommand=f}),define(be[192],Ee([0,1,9,7,60,75,17,89]),function(ee,e,g,F,S,E,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const _=[new E.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",n(g.DocumentHighlight.to))),new E.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,d)=>{if((0,C.isFalsyOrEmpty)(l))return;class u extends F.SymbolInformation{static to(b){const w=new u(b.name,g.SymbolKind.to(b.kind),b.containerName||"",new F.Location(d[0],g.Range.to(b.range)));return w.detail=b.detail,w.range=w.location.range,w.selectionRange=g.Range.to(b.selectionRange),w.children=b.children?b.children.map(u.to):[],w}}return l.map(u.to)})),new E.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(g.TextEdit.to))),new E.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range,new E.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(g.TextEdit.to))),new E.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,new E.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new E.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(g.TextEdit.to))),new E.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new E.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new E.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new E.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new E.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location-instances.",n(g.location.to))),new E.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Hover-instances.",n(g.Hover.to))),new E.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(d=>F.Position.isPosition(d)),l=>l.map(g.Position.from))],new E.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(d=>{let u;for(const m of d.reverse())u=new F.SelectionRange(g.Range.to(m),u);return u}))),new E.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[E.ApiCommandArgument.String.with("query","Search string")],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>{const d=[];if(Array.isArray(l))for(let u of l)d.push(...u[1].map(g.WorkspaceSymbol.to));return d})),new E.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(g.CallHierarchyItem.to))),new E.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(g.CallHierarchyIncomingCall.to))),new E.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(g.CallHierarchyOutgoingCall.to))),new E.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("newName","The new symbol name")],new E.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return g.WorkspaceEdit.to(l)}})),new E.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new E.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(g.DocumentLink.to))),new E.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new F.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const d=(0,y.decodeSemanticTokensDto)(l);if(d.type==="full")return new F.SemanticTokens(d.data,void 0)})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new F.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const d=(0,y.decodeSemanticTokensDto)(l);if(d.type==="full")return new F.SemanticTokens(d.data,void 0)})),new E.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new E.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,d,u)=>{if(!l)return new F.CompletionList([]);const m=l.suggestions.map(b=>g.CompletionItem.to(b,u));return new F.CompletionList(m,l.incomplete)})),new E.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new E.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return g.SignatureHelp.to(l)})),new E.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new E.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,d,u)=>n(m=>new F.CodeLens(g.Range.to(m.range),m.command&&u.fromInternal(m.command)))(l))),new E.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>F.Range.isRange(l),l=>F.Selection.isSelection(l)?g.Selection.from(l):g.Range.from(l)),E.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new E.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,d,u)=>n(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return u.fromInternal(m.command)}else{const b=new F.CodeAction(m.title,m.kind?new F.CodeActionKind(m.kind):void 0);return m.edit&&(b.edit=g.WorkspaceEdit.to(m.edit)),m.command&&(b.command=u.fromInternal(m.command)),b.isPreferred=m.isPreferred,b}})(l))),new E.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(d=>new F.ColorInformation(g.Range.to(d.range),g.Color.to(d.color))):[])),new E.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new E.ApiCommandArgument("color","The color to show and insert",l=>l instanceof F.Color,g.Color.from),new E.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:g.Range.from(l.range)}))],new E.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(g.ColorPresentation.to):[])),new E.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to an array of Inlay objects",l=>l.map(g.InlayHint.to))),new E.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new E.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",n(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(d=>g.NotebookExclusiveDocumentPattern.to(d))})))),new E.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(g.InlineValue.to))),new E.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[g.ViewColumn.from(l.viewColumn),g.TextEditorOpenOptions.from(l)])).optional(),E.ApiCommandArgument.String.with("label","").optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[E.ApiCommandArgument.Uri.with("resource","Resource to open"),E.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[g.ViewColumn.from(l.viewColumn),g.TextEditorOpenOptions.from(l)])).optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[E.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),E.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),E.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[g.ViewColumn.from(l.viewColumn),g.TextEditorOpenOptions.from(l)]).optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(g.TypeHierarchyItem.to))),new E.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[E.ApiCommandArgument.TypeHierarchyItem],new E.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(g.TypeHierarchyItem.to))),new E.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[E.ApiCommandArgument.TypeHierarchyItem],new E.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(g.TypeHierarchyItem.to)))];class k{static register(d){_.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=k;function n(l){return d=>{if(Array.isArray(d))return d.map(l)}}function I(l){if(!Array.isArray(l))return;const d=[];for(const u of l)S.isLocationLink(u)?d.push(g.DefinitionLink.to(u)):d.push(g.location.to(u));return d}}),define(be[193],Ee([0,1,16,51,3,6,2,60,26,9,7,5]),function(ee,e,g,F,S,E,C,y,_,k,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function l(d,u,m){const b=d.getProxy(I.MainContext.MainThreadComments);class w{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,u.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const c=this._commentControllers.get(i.handle);return c||i}else if(i&&i.$mid===7){const c=this._commentControllers.get(i.commentControlHandle);if(!c)return i;const h=c.getCommentThread(i.commentThreadHandle);return h||i}else if(i&&i.$mid===8){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const h=c.getCommentThread(i.thread.commentThreadHandle);return h?{thread:h,text:i.text}:i}else if(i&&i.$mid===9){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const h=c.getCommentThread(i.thread.commentThreadHandle);if(!h)return i;let p=i.commentUniqueId,D=h.getCommentByUniqueId(p);return D||i}else if(i&&i.$mid===10){const c=this._commentControllers.get(i.thread.commentControlHandle);if(!c)return i;const h=c.getCommentThread(i.thread.commentThreadHandle);if(!h)return i;let p=i.text,D=i.commentUniqueId,T=h.getCommentByUniqueId(D);return T?(T.body=p,T):i}return i}})}createCommentController(i,c,h){const p=w.handlePool++,D=new a(i,p,c,h);this._commentControllers.set(D.handle,D);const T=this._commentControllersByExtension.get(_.ExtensionIdentifier.toKey(i.identifier))||[];return T.push(D),this._commentControllersByExtension.set(_.ExtensionIdentifier.toKey(i.identifier),T),D.value}$createCommentThreadTemplate(i,c,h){const p=this._commentControllers.get(i);!p||p.$createCommentThreadTemplate(c,h)}async $updateCommentThreadTemplate(i,c,h){const p=this._commentControllers.get(i);!p||p.$updateCommentThreadTemplate(c,h)}$deleteCommentThread(i,c){const h=this._commentControllers.get(i);h&&h.$deleteCommentThread(c)}$provideCommentingRanges(i,c,h){const p=this._commentControllers.get(i);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const D=m.getDocument(C.URI.revive(c));return(0,g.asPromise)(()=>p.commentingRangeProvider.provideCommentingRanges(D,h)).then(T=>T?T.map(o=>k.Range.from(o)):void 0)}$toggleReaction(i,c,h,p,D){const T=this._commentControllers.get(i);return!T||!T.reactionHandler?Promise.resolve(void 0):(0,g.asPromise)(()=>{const o=T.getCommentThread(c);if(o){const A=o.getCommentByUniqueId(p.uniqueIdInThread);if(T!==void 0&&A&&T.reactionHandler)return T.reactionHandler(A,t(D))}return Promise.resolve(void 0)})}dispose(){}}w.handlePool=0;class P{constructor(i,c,h,p,D,T,o){this._commentControllerHandle=c,this._id=h,this._uri=p,this._range=D,this._comments=T,this.handle=P._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new S.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new E.MutableDisposable,this._acceptInputDisposables.value=new E.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),b.$createCommentThread(c,this.handle,this._id,this._uri,k.Range.from(this._range),o),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=T,this._localDisposables.push({dispose:()=>{b.$deleteCommentThread(c,this.handle)}});const A=this;this.value={get uri(){return A.uri},get range(){return A.range},set range(L){A.range=L},get comments(){return A.comments},set comments(L){A.comments=L},get collapsibleState(){return A.collapsibleState},set collapsibleState(L){A.collapsibleState=L},get canReply(){return A.canReply},set canReply(L){A.canReply=L},get contextValue(){return A.contextValue},set contextValue(L){A.contextValue=L},get label(){return A.label},set label(L){A.label=L},dispose:()=>{A.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new E.DisposableStore);const i=h=>Object.prototype.hasOwnProperty.call(this.modifications,h),c={};i("range")&&(c.range=k.Range.from(this._range)),i("label")&&(c.label=this.label),i("contextValue")&&(c.contextValue=this.contextValue),i("comments")&&(c.comments=this._comments.map(h=>f(this,h,this._commentsMap))),i("collapsibleState")&&(c.collapseState=r(this._collapseState)),i("canReply")&&(c.canReply=this.canReply),this.modifications={},b.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,c)}getCommentByUniqueId(i){for(let c of this._commentsMap){let h=c[0],p=c[1];if(i===p)return h}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}P._handlePool=0,ze([(0,F.debounce)(100)],P.prototype,"eventuallyUpdateCommentThread",null);class a{constructor(i,c,h,p){this._extension=i,this._handle=c,this._id=h,this._label=p,this._threads=new Map,b.$registerCommentController(this.handle,h,p);const D=this;this.value=Object.freeze({id:D.id,label:D.label,get options(){return D.options},set options(T){D.options=T},get commentingRangeProvider(){return D.commentingRangeProvider},set commentingRangeProvider(T){D.commentingRangeProvider=T},get reactionHandler(){return D.reactionHandler},set reactionHandler(T){D.reactionHandler=T},createCommentThread(T,o,A){return D.createCommentThread(T,o,A).value},dispose:()=>{D.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{b.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,b.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,b.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,c,h,p){if(typeof i=="string"){const D=new P(this.id,this.handle,i,c,h,p,this._extension.identifier);return this._threads.set(D.handle,D),D}else{const D=new P(this.id,this.handle,void 0,i,c,h,this._extension.identifier);return this._threads.set(D.handle,D),D}}$createCommentThreadTemplate(i,c){const h=new P(this.id,this.handle,void 0,C.URI.revive(i),k.Range.to(c),[],this._extension.identifier);return h.collapsibleState=y.CommentThreadCollapsibleState.Expanded,this._threads.set(h.handle,h),h}$updateCommentThreadTemplate(i,c){let h=this._threads.get(i);h&&(h.range=k.Range.to(c))}$deleteCommentThread(i){let c=this._threads.get(i);c&&c.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function f(s,i,c){let h=c.get(i);h||(h=++s.commentHandle,c.set(i,h));const p=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:h,body:k.MarkdownString.from(i.body),userName:i.author.name,userIconPath:p,label:i.label,commentReactions:i.reactions?i.reactions.map(D=>v(D)):void 0}}function v(s){return{label:s.label,iconPath:s.iconPath?k.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function t(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?C.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function r(s){if(s!==void 0)switch(s){case n.CommentThreadCollapsibleState.Expanded:return y.CommentThreadCollapsibleState.Expanded;case n.CommentThreadCollapsibleState.Collapsed:return y.CommentThreadCollapsibleState.Collapsed}return y.CommentThreadCollapsibleState.Collapsed}return new w}e.createExtHostComments=l}),define(be[104],Ee([0,1,2,5,7,4,13,15,17,8,14]),function(ee,e,g,F,S,E,C,y,_,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class bn{constructor(d,u){this._logService=u,this._provider=new Map,this._proxy=d.getProxy(F.MainContext.MainThreadDecorations)}registerFileDecorationProvider(d,u){const m=bn._handlePool++;this._provider.set(m,{provider:d,extensionId:u}),this._proxy.$registerDecorationProvider(m,u.value);const b=d.onDidChangeFileDecorations&&d.onDidChangeFileDecorations(w=>{if(!w){this._proxy.$onDidChange(m,null);return}let P=(0,_.asArray)(w);if(P.length<=bn._maxEventSize){this._proxy.$onDidChange(m,P);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",u.value,P.length);const a=P.map(t=>({uri:t,rank:(0,k.count)(t.path,"/")})),f=(0,_.groupBy)(a,(t,r)=>t.rank-r.rank||(0,k.compare)(t.uri.path,r.uri.path));let v=[];e:for(let t of f){let r;for(let s of t){let i=(0,n.dirname)(s.uri.path);if(r!==i&&(r=i,v.push(s.uri)>=bn._maxEventSize))break e}}this._proxy.$onDidChange(m,v)});return new S.Disposable(()=>{b?.dispose(),this._proxy.$unregisterDecorationProvider(m),this._provider.delete(m)})}async $provideDecorations(d,u,m){if(!this._provider.has(d))return Object.create(null);const b=Object.create(null),{provider:w,extensionId:P}=this._provider.get(d);return await Promise.all(u.map(async a=>{try{const{uri:f,id:v}=a,t=await Promise.resolve(w.provideFileDecoration(g.URI.revive(f),m));if(!t)return;try{S.FileDecoration.validate(t),b[v]=[t.propagate,t.tooltip,t.badge,t.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${P.value}': ${r}`)}}catch(f){this._logService.error(f)}})),b}};I._handlePool=0,I._maxEventSize=250,I=ze([qe(0,C.IExtHostRpcService),qe(1,y.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,E.createDecorator)("IExtHostDecorations")}),define(be[194],Ee([0,1,133,92,2,5,7,9,3,15,21]),function(ee,e,g,F,S,E,C,y,_,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class I{constructor(u,m,b,w,P){this._name=u,this._owner=m,this._maxDiagnosticsPerFile=b,this._proxy=w,this._onDidChangeDiagnostics=P,this._isDisposed=!1,this._data=new n.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(u,m){if(!u){this.clear();return}this._checkDisposed();let b=[];if(S.URI.isUri(u)){if(!m){this.delete(u);return}this._data.set(u,m.slice()),b=[u]}else if(Array.isArray(u)){b=[];let P;u=[...u].sort(I._compareIndexedTuplesByUri);for(const a of u){const[f,v]=a;if((!P||f.toString()!==P.toString())&&(P&&this._data.get(P).length===0&&this._data.delete(P),P=f,b.push(f),this._data.set(f,[])),v){const t=this._data.get(f);t&&t.push(...v)}else{const t=this._data.get(f);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(b),!this._proxy)return;const w=[];for(let P of b){let a=[];const f=this._data.get(P);if(f)if(f.length>this._maxDiagnosticsPerFile){a=[];const v=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let r of f)if(r.severity===v[t]&&a.push(y.Diagnostic.from(r))===this._maxDiagnosticsPerFile)break e;a.push({severity:F.MarkerSeverity.Info,message:(0,g.localize)(0,null,f.length-this._maxDiagnosticsPerFile),startLineNumber:a[a.length-1].startLineNumber,startColumn:a[a.length-1].startColumn,endLineNumber:a[a.length-1].endLineNumber,endColumn:a[a.length-1].endColumn})}else a=f.map(v=>y.Diagnostic.from(v));w.push([P,a])}this._proxy.$changeMany(this._owner,w)}delete(u){this._checkDisposed(),this._onDidChangeDiagnostics.fire([u]),this._data.delete(u),this._proxy&&this._proxy.$changeMany(this._owner,[[u,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(u,m){this._checkDisposed();for(let b of this._data.keys())u.apply(m,[b,this.get(b),this])}get(u){this._checkDisposed();const m=this._data.get(u);return Array.isArray(m)?Object.freeze(m.slice(0)):[]}has(u){return this._checkDisposed(),Array.isArray(this._data.get(u))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(u,m){return u[0].toString()<m[0].toString()?-1:u[0].toString()>m[0].toString()?1:0}}e.DiagnosticCollection=I;let l=class Gt{constructor(u,m){this._logService=m,this._collections=new Map,this._onDidChangeDiagnostics=new _.DebounceEmitter({merge:b=>b.flat(),delay:50}),this.onDidChangeDiagnostics=_.Event.map(this._onDidChangeDiagnostics.event,Gt._mapper),this._proxy=u.getProxy(E.MainContext.MainThreadDiagnostics)}static _mapper(u){const m=new n.ResourceMap;for(const b of u)m.set(b,b);return{uris:Object.freeze(Array.from(m.values()))}}createDiagnosticCollection(u,m){const{_collections:b,_proxy:w,_onDidChangeDiagnostics:P,_logService:a}=this,f=new class{$changeMany(r,s){w.$changeMany(r,s),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",u.value,r,s.length===0?"CLEARING":s)}$clear(r){w.$clear(r),a.trace("[DiagnosticCollection] remove all (extension, owner)",u.value,r)}dispose(){w.dispose()}};let v;if(!m)m="_generated_diagnostic_collection_name_#"+Gt._idPool++,v=m;else if(!b.has(m))v=m;else{this._logService.warn(`DiagnosticCollection with name '${m}' does already exist.`);do v=m+Gt._idPool++;while(b.has(v))}return new class extends I{constructor(){super(m,v,Gt._maxDiagnosticsPerFile,f,P);b.set(v,this)}dispose(){super.dispose(),b.delete(v)}}}getDiagnostics(u){if(u)return this._getDiagnostics(u);{const m=new Map,b=[];for(const w of this._collections.values())w.forEach((P,a)=>{let f=m.get(P.toString());typeof f=="undefined"&&(f=b.length,m.set(P.toString(),f),b.push([P,[]])),b[f][1]=b[f][1].concat(...a)});return b}}_getDiagnostics(u){let m=[];for(let b of this._collections.values())b.has(u)&&(m=m.concat(b.get(u)));return m}$acceptMarkersChange(u){if(!this._mirrorCollection){const m="_generated_mirror",b=new I(m,m,Gt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(m,b),this._mirrorCollection=b}for(const[m,b]of u)this._mirrorCollection.set(S.URI.revive(m),b.map(y.Diagnostic.to))}};l._idPool=0,l._maxDiagnosticsPerFile=1e3,l=ze([qe(1,k.ILogService)],l),e.ExtHostDiagnostics=l}),define(be[195],Ee([0,1,2,5]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class S{constructor(C){this._proxy=C.getProxy(F.MainContext.MainThreadDialogs)}showOpenDialog(C){return this._proxy.$showOpenDialog(C).then(y=>y?y.map(_=>g.URI.revive(_)):void 0)}showSaveDialog(C){return this._proxy.$showSaveDialog(C).then(y=>y?g.URI.revive(y):void 0)}}e.ExtHostDialogs=S}),define(be[196],Ee([0,1,12,2,7,5,11,20,8]),function(ee,e,g,F,S,E,C,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(I,l,d){this._documentsAndEditors=l,this._logService=d,this._documentContentProviders=new Map,this._proxy=I.getProxy(E.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,l){if(Object.keys(C.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const d=k._handlePool++;this._documentContentProviders.set(d,l),this._proxy.$registerTextContentProvider(d,I);let u;return typeof l.onDidChange=="function"&&(u=l.onDidChange(m=>{if(m.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(m)&&this.$provideTextDocumentContent(d,m).then(b=>{if(!b&&typeof b!="string")return;const w=this._documentsAndEditors.getDocument(m);if(!w)return;const P=(0,_.splitLines)(b);if(!w.equalLines(P))return this._proxy.$onVirtualDocumentChange(m,b)},g.onUnexpectedError)})),new S.Disposable(()=>{this._documentContentProviders.delete(d)&&this._proxy.$unregisterTextContentProvider(d),u&&(u.dispose(),u=void 0)})}$provideTextDocumentContent(I,l){const d=this._documentContentProviders.get(I);return d?Promise.resolve(d.provideTextDocumentContent(F.URI.revive(l),y.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(be[197],Ee([0,1,3,6,2,5,98,9,10,23,7]),function(ee,e,g,F,S,E,C,y,_,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(d,u){this._onDidAddDocument=new g.Emitter,this._onDidRemoveDocument=new g.Emitter,this._onDidChangeDocument=new g.Emitter,this._onDidSaveDocument=new g.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new F.DisposableStore,this._documentLoader=new Map,this._proxy=d.getProxy(E.MainContext.MainThreadDocuments),this._documentsAndEditors=u,this._documentsAndEditors.onDidRemoveDocuments(m=>{for(const b of m)this._onDidRemoveDocument.fire(b.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(m=>{for(const b of m)this._onDidAddDocument.fire(b.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(d){if(!d)return;const u=this._documentsAndEditors.getDocument(d);if(u)return u}getDocument(d){const u=this.getDocumentData(d);if(!u?.document)throw new Error(`Unable to retrieve document from URI '${d}'`);return u.document}ensureDocumentData(d){const u=this._documentsAndEditors.getDocument(d);if(u)return Promise.resolve(u);let m=this._documentLoader.get(d.toString());return m||(m=this._proxy.$tryOpenDocument(d).then(b=>{this._documentLoader.delete(d.toString());const w=S.URI.revive(b);return(0,_.assertIsDefined)(this._documentsAndEditors.getDocument(w))},b=>(this._documentLoader.delete(d.toString()),Promise.reject(b))),this._documentLoader.set(d.toString(),m)),m}createDocumentData(d){return this._proxy.$tryCreateDocument(d).then(u=>S.URI.revive(u))}$acceptModelModeChanged(d,u){const m=S.URI.revive(d),b=this._documentsAndEditors.getDocument(m);if(!b)throw new Error("unknown document");this._onDidRemoveDocument.fire(b.document),b._acceptLanguageId(u),this._onDidAddDocument.fire(b.document)}$acceptModelSaved(d){const u=S.URI.revive(d),m=this._documentsAndEditors.getDocument(u);if(!m)throw new Error("unknown document");this.$acceptDirtyStateChanged(d,!1),this._onDidSaveDocument.fire(m.document)}$acceptDirtyStateChanged(d,u){const m=S.URI.revive(d),b=this._documentsAndEditors.getDocument(m);if(!b)throw new Error("unknown document");b._acceptIsDirty(u),this._onDidChangeDocument.fire({document:b.document,contentChanges:[],reason:void 0})}$acceptModelChanged(d,u,m){const b=S.URI.revive(d),w=this._documentsAndEditors.getDocument(b);if(!w)throw new Error("unknown document");w._acceptIsDirty(m),w.onEvents(u);let P;u.isUndoing?P=n.TextDocumentChangeReason.Undo:u.isRedoing&&(P=n.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:w.document,contentChanges:u.changes.map(a=>({range:y.Range.to(a.range),rangeOffset:a.rangeOffset,rangeLength:a.rangeLength,text:a.text})),reason:P}))}setWordDefinitionFor(d,u){(0,C.setWordDefinitionFor)(d,u)}}e.ExtHostDocuments=I}),define(be[48],Ee([0,1,40,3,6,2,4,5,98,13,102,9,15,21,11,54,112]),function(ee,e,g,F,S,E,C,y,_,k,n,I,l,d,u,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class w{constructor(f){this.value=f,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let P=class{constructor(f,v){this._extHostRpc=f,this._logService=v,this._activeEditorId=null,this._editors=new Map,this._documents=new d.ResourceMap,this._onDidAddDocuments=new F.Emitter,this._onDidRemoveDocuments=new F.Emitter,this._onDidChangeVisibleTextEditors=new F.Emitter,this._onDidChangeActiveTextEditor=new F.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(f){this.acceptDocumentsAndEditorsDelta(f)}acceptDocumentsAndEditorsDelta(f){const v=[],t=[],r=[];if(f.removedDocuments)for(const s of f.removedDocuments){const i=E.URI.revive(s),c=this._documents.get(i);c?.unref()&&(this._documents.delete(i),v.push(c.value))}if(f.addedDocuments)for(const s of f.addedDocuments){const i=E.URI.revive(s.uri);let c=this._documents.get(i);if(c&&i.scheme!==u.Schemas.vscodeNotebookCell&&i.scheme!==u.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);c||(c=new w(new _.ExtHostDocumentData(this._extHostRpc.getProxy(y.MainContext.MainThreadDocuments),i,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(i,c),t.push(c.value)),c.ref()}if(f.removedEditors)for(const s of f.removedEditors){const i=this._editors.get(s);this._editors.delete(s),i&&r.push(i)}if(f.addedEditors)for(const s of f.addedEditors){const i=E.URI.revive(s.documentUri);g.ok(this._documents.has(i),`document '${i}' does not exist`),g.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const c=this._documents.get(i).value,h=new n.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(y.MainContext.MainThreadTextEditors),this._logService,new b.Lazy(()=>c.document),s.selections.map(I.Selection.to),s.options,s.visibleRanges.map(p=>I.Range.to(p)),typeof s.editorPosition=="number"?I.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,h)}f.newActiveEditor!==void 0&&(g.ok(f.newActiveEditor===null||this._editors.has(f.newActiveEditor),`active editor '${f.newActiveEditor}' does not exist`),this._activeEditorId=f.newActiveEditor),(0,S.dispose)(v),(0,S.dispose)(r),f.removedDocuments&&this._onDidRemoveDocuments.fire(v),f.addedDocuments&&this._onDidAddDocuments.fire(t),(f.removedEditors||f.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),f.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(f){return this._documents.get(f)?.value}allDocuments(){return m.Iterable.map(this._documents.values(),f=>f.value)}getEditor(f){return this._editors.get(f)}activeEditor(f){if(!this._activeEditorId)return;const v=this._editors.get(this._activeEditorId);return f?v:v?.value}allEditors(){return[...this._editors.values()]}};P=ze([qe(0,k.IExtHostRpcService),qe(1,l.ILogService)],P),e.ExtHostDocumentsAndEditors=P,e.IExtHostDocumentsAndEditors=(0,C.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[198],Ee([0,1,2,5,6,7,9,122,8,24]),function(ee,e,g,F,S,E,C,y,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class n{constructor(){this._schemes=[]}add(d){this._stateMachine=void 0,this._schemes.push(d)}delete(d){const u=this._schemes.indexOf(d);u>=0&&(this._schemes.splice(u,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const d=this._schemes.sort(),u=[];let m,b,w=14,P=14;for(const a of d){let f=m?(0,_.commonPrefixLength)(m,a):0;for(f===0?b=1:b=P;f<a.length;f++)f+1===a.length?(w=P,P=9):P+=1,u.push([b,a.toUpperCase().charCodeAt(f),P]),u.push([b,a.toLowerCase().charCodeAt(f),P]),b=P;m=a,P=w}u.push([9,58,10]),u.push([10,47,12]),this._stateMachine=new y.StateMachine(u)}}provideDocumentLinks(d){this._initStateMachine();const u=[],m=y.LinkComputer.computeLinks({getLineContent(b){return d.lineAt(b-1).text},getLineCount(){return d.lineCount}},this._stateMachine);for(const b of m){const w=C.DocumentLink.to(b);w.target&&u.push(w)}return u}}class I{constructor(d,u){this._extHostLanguageFeatures=u,this._linkProvider=new n,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=d.getProxy(F.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(d,u,m,b={},w){if(this._registeredSchemes.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const P=this._handlePool++;this._linkProvider.add(u),this._registeredSchemes.add(u),this._fsProvider.set(P,m),this._enableProposedApi.set(P,w??!1);let a=2;b.isCaseSensitive&&(a+=1024),b.isReadonly&&(a+=2048),typeof m.copy=="function"&&(a+=8),typeof m.open=="function"&&typeof m.close=="function"&&typeof m.read=="function"&&typeof m.write=="function"&&(a+=4),this._proxy.$registerFileSystemProvider(P,u,a).catch(v=>{console.error(`FAILED to register filesystem provider of ${d.value}-extension for the scheme ${u}`),console.error(v)});const f=m.onDidChangeFile(v=>{const t=[];for(const r of v){let{uri:s,type:i}=r;if(s.scheme!==u)continue;let c;switch(i){case E.FileChangeType.Changed:c=0;break;case E.FileChangeType.Created:c=1;break;case E.FileChangeType.Deleted:c=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:s,type:c})}this._proxy.$onFileSystemChange(P,t)});return(0,S.toDisposable)(()=>{f.dispose(),this._linkProvider.delete(u),this._registeredSchemes.delete(u),this._fsProvider.delete(P),this._enableProposedApi.delete(P),this._proxy.$unregisterProvider(P)})}static _asIStat(d,u){const{type:m,ctime:b,mtime:w,size:P,permissions:a}=d;return u?{type:m,ctime:b,mtime:w,size:P,permissions:a}:{type:m,ctime:b,mtime:w,size:P}}$stat(d,u){return Promise.resolve(this._getFsProvider(d).stat(g.URI.revive(u))).then(m=>I._asIStat(m,this._enableProposedApi.get(d)??!1))}$readdir(d,u){return Promise.resolve(this._getFsProvider(d).readDirectory(g.URI.revive(u)))}$readFile(d,u){return Promise.resolve(this._getFsProvider(d).readFile(g.URI.revive(u))).then(m=>k.VSBuffer.wrap(m))}$writeFile(d,u,m,b){return Promise.resolve(this._getFsProvider(d).writeFile(g.URI.revive(u),m.buffer,b))}$delete(d,u,m){return Promise.resolve(this._getFsProvider(d).delete(g.URI.revive(u),m))}$rename(d,u,m,b){return Promise.resolve(this._getFsProvider(d).rename(g.URI.revive(u),g.URI.revive(m),b))}$copy(d,u,m,b){const w=this._getFsProvider(d);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(g.URI.revive(u),g.URI.revive(m),b))}$mkdir(d,u){return Promise.resolve(this._getFsProvider(d).createDirectory(g.URI.revive(u)))}$watch(d,u,m,b){const w=this._getFsProvider(d).watch(g.URI.revive(m),b);this._watches.set(u,w)}$unwatch(d,u){const m=this._watches.get(u);m&&(m.dispose(),this._watches.delete(u))}$open(d,u,m){const b=this._getFsProvider(d);if(!b.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(b.open(g.URI.revive(u),m))}$close(d,u){const m=this._getFsProvider(d);if(!m.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(m.close(u))}$read(d,u,m,b){const w=this._getFsProvider(d);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const P=k.VSBuffer.alloc(b);return Promise.resolve(w.read(u,m,P.buffer,0,b)).then(a=>P.slice(0,a))}$write(d,u,m,b){const w=this._getFsProvider(d);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(u,m,b.buffer,0,b.byteLength))}_getFsProvider(d){const u=this._fsProvider.get(d);if(!u){const m=new Error;throw m.name="ENOPRO",m.message="no provider",m}return u}}e.ExtHostFileSystem=I}),define(be[76],Ee([0,1,5,61,7,24,4,13,47]),function(ee,e,g,F,S,E,C,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let k=class Wt{constructor(I,l){const d=I.getProxy(g.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(u){return d.$stat(u).catch(Wt._handleError)},readDirectory(u){return d.$readdir(u).catch(Wt._handleError)},createDirectory(u){return d.$mkdir(u).catch(Wt._handleError)},async readFile(u){return d.$readFile(u).then(m=>m.buffer).catch(Wt._handleError)},writeFile(u,m){return d.$writeFile(u,E.VSBuffer.wrap(m)).catch(Wt._handleError)},delete(u,m){return d.$delete(u,{recursive:!1,useTrash:!1,...m}).catch(Wt._handleError)},rename(u,m,b){return d.$rename(u,m,{overwrite:!1,...b}).catch(Wt._handleError)},copy(u,m,b){return d.$copy(u,m,{overwrite:!1,...b}).catch(Wt._handleError)},isWritableFileSystem(u){const m=l.getCapabilities(u);if(typeof m=="number")return!(m&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new S.FileSystemError(String(I));if(I.name==="ENOPRO")throw S.FileSystemError.Unavailable(I.message);switch(I.name){case F.FileSystemProviderErrorCode.FileExists:throw S.FileSystemError.FileExists(I.message);case F.FileSystemProviderErrorCode.FileNotFound:throw S.FileSystemError.FileNotFound(I.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw S.FileSystemError.FileNotADirectory(I.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw S.FileSystemError.FileIsADirectory(I.message);case F.FileSystemProviderErrorCode.NoPermissions:throw S.FileSystemError.NoPermissions(I.message);case F.FileSystemProviderErrorCode.Unavailable:throw S.FileSystemError.Unavailable(I.message);default:throw new S.FileSystemError(I.message,I.name)}}};k=ze([qe(0,y.IExtHostRpcService),qe(1,_.IExtHostFileSystemInfo)],k),e.ExtHostConsumerFileSystem=k,e.IExtHostConsumerFileSystem=(0,C.createDecorator)("IExtHostConsumerFileSystem")}),define(be[199],Ee([0,1,6,5]),function(ee,e,g,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class S{constructor(C){this._handlePool=0,this._proxy=C.getProxy(F.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const y=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(y,C),(0,g.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(y)})}}e.ExtHostLabelService=S}),define(be[200],Ee([0,1,2,23,9,7,5,8,31,17,10,119,6,89,53,65,55,12,3]),function(ee,e,g,F,S,E,C,y,_,k,n,I,l,d,u,m,b,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class a{constructor(O,K){this._documents=O,this._provider=K}async provideDocumentSymbols(O,K){const X=this._documents.getDocument(O),se=await this._provider.provideDocumentSymbols(X,K);if(!(0,k.isFalsyOrEmpty)(se))return se[0]instanceof E.DocumentSymbol?se.map(S.DocumentSymbol.from):a._asDocumentSymbolTree(se)}static _asDocumentSymbolTree(O){O=O.slice(0).sort((se,q)=>{let ie=se.location.range.start.compareTo(q.location.range.start);return ie===0&&(ie=q.location.range.end.compareTo(se.location.range.end)),ie});const K=[],X=[];for(const se of O){const q={name:se.name||"!!MISSING: name!!",kind:S.SymbolKind.from(se.kind),tags:se.tags?.map(S.SymbolTag.from)||[],detail:"",containerName:se.containerName,range:S.Range.from(se.location.range),selectionRange:S.Range.from(se.location.range),children:[]};for(;;){if(X.length===0){X.push(q),K.push(q);break}const ie=X[X.length-1];if(_.Range.containsRange(ie.range,q.range)&&!_.Range.equalsRange(ie.range,q.range)){ie.children&&ie.children.push(q),X.push(q);break}X.pop()}}return K}}class f{constructor(O,K,X){this._documents=O,this._commands=K,this._provider=X,this._cache=new m.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(O,K){const X=this._documents.getDocument(O),se=await this._provider.provideCodeLenses(X,K);if(!se||K.isCancellationRequested)return;const q=this._cache.add(se),ie=new l.DisposableStore;this._disposables.set(q,ie);const ge={cacheId:q,lenses:[]};for(let Le=0;Le<se.length;Le++)ge.lenses.push({cacheId:[q,Le],range:S.Range.from(se[Le].range),command:this._commands.toInternal(se[Le].command,ie)});return ge}async resolveCodeLens(O,K){const X=O.cacheId&&this._cache.get(...O.cacheId);if(!X)return;let se;if(typeof this._provider.resolveCodeLens!="function"||X.isResolved?se=X:se=await this._provider.resolveCodeLens(X,K),se||(se=X),K.isCancellationRequested)return;const q=O.cacheId&&this._disposables.get(O.cacheId[0]);if(!!q)return O.command=this._commands.toInternal(se.command??f._badCmd,q),O}releaseCodeLenses(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}}f._badCmd={command:"missing",title:"!!MISSING: command!!"};function v(je){return Array.isArray(je)?je.map(S.DefinitionLink.from):je?[S.DefinitionLink.from(je)]:[]}class t{constructor(O,K){this._documents=O,this._provider=K}async provideDefinition(O,K,X){const se=this._documents.getDocument(O),q=S.Position.to(K),ie=await this._provider.provideDefinition(se,q,X);return v(ie)}}class r{constructor(O,K){this._documents=O,this._provider=K}async provideDeclaration(O,K,X){const se=this._documents.getDocument(O),q=S.Position.to(K),ie=await this._provider.provideDeclaration(se,q,X);return v(ie)}}class s{constructor(O,K){this._documents=O,this._provider=K}async provideImplementation(O,K,X){const se=this._documents.getDocument(O),q=S.Position.to(K),ie=await this._provider.provideImplementation(se,q,X);return v(ie)}}class i{constructor(O,K){this._documents=O,this._provider=K}async provideTypeDefinition(O,K,X){const se=this._documents.getDocument(O),q=S.Position.to(K),ie=await this._provider.provideTypeDefinition(se,q,X);return v(ie)}}class c{constructor(O,K){this._documents=O,this._provider=K}async provideHover(O,K,X){const se=this._documents.getDocument(O),q=S.Position.to(K),ie=await this._provider.provideHover(se,q,X);if(!(!ie||(0,k.isFalsyOrEmpty)(ie.contents)))return ie.range||(ie.range=se.getWordRangeAtPosition(q)),ie.range||(ie.range=new E.Range(q,q)),S.Hover.from(ie)}}class h{constructor(O,K){this._documents=O,this._provider=K}async provideEvaluatableExpression(O,K,X){const se=this._documents.getDocument(O),q=S.Position.to(K),ie=await this._provider.provideEvaluatableExpression(se,q,X);if(ie)return S.EvaluatableExpression.from(ie)}}class p{constructor(O,K){this._documents=O,this._provider=K}async provideInlineValues(O,K,X,se){const q=this._documents.getDocument(O),ie=await this._provider.provideInlineValues(q,S.Range.to(K),S.InlineValueContext.to(X),se);if(Array.isArray(ie))return ie.map(ge=>S.InlineValue.from(ge))}}class D{constructor(O,K){this._documents=O,this._provider=K}async provideDocumentHighlights(O,K,X){const se=this._documents.getDocument(O),q=S.Position.to(K),ie=await this._provider.provideDocumentHighlights(se,q,X);if(Array.isArray(ie))return ie.map(S.DocumentHighlight.from)}}class T{constructor(O,K){this._documents=O,this._provider=K}async provideLinkedEditingRanges(O,K,X){const se=this._documents.getDocument(O),q=S.Position.to(K),ie=await this._provider.provideLinkedEditingRanges(se,q,X);if(ie&&Array.isArray(ie.ranges))return{ranges:(0,k.coalesce)(ie.ranges.map(S.Range.from)),wordPattern:ie.wordPattern}}}class o{constructor(O,K){this._documents=O,this._provider=K}async provideReferences(O,K,X,se){const q=this._documents.getDocument(O),ie=S.Position.to(K),ge=await this._provider.provideReferences(q,ie,X,se);if(Array.isArray(ge))return ge.map(S.location.from)}}class A{constructor(O,K,X,se,q,ie,ge){this._documents=O,this._commands=K,this._diagnostics=X,this._provider=se,this._logService=q,this._extension=ie,this._apiDeprecation=ge,this._cache=new m.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(O,K,X,se){const q=this._documents.getDocument(O),ie=I.Selection.isISelection(K)?S.Selection.to(K):S.Range.to(K),ge=[];for(const Z of this._diagnostics.getDiagnostics(O))if(ie.intersection(Z.range)&&ge.push(Z)>A._maxCodeActionsPerFile)break;const Le={diagnostics:ge,only:X.only?new E.CodeActionKind(X.only):void 0,triggerKind:S.CodeActionTriggerKind.to(X.trigger)},We=await this._provider.provideCodeActions(q,ie,Le,se);if(!(0,k.isNonEmptyArray)(We)||se.isCancellationRequested)return;const ve=this._cache.add(We),Xe=new l.DisposableStore;this._disposables.set(ve,Xe);const H=[];for(let Z=0;Z<We.length;Z++){const ce=We[Z];!ce||(A._isCommand(ce)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),H.push({_isSynthetic:!0,title:ce.title,command:this._commands.toInternal(ce,Xe)})):(Le.only&&(ce.kind?Le.only.contains(ce.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Le.only.value} 'requested but returned code action is of kind '${ce.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Le.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),H.push({cacheId:[ve,Z],title:ce.title,command:ce.command&&this._commands.toInternal(ce.command,Xe),diagnostics:ce.diagnostics&&ce.diagnostics.map(S.Diagnostic.from),edit:ce.edit&&S.WorkspaceEdit.from(ce.edit),kind:ce.kind&&ce.kind.value,isPreferred:ce.isPreferred,disabled:ce.disabled?.reason})))}return{cacheId:ve,actions:H}}async resolveCodeAction(O,K){const[X,se]=O,q=this._cache.get(X,se);if(!q||A._isCommand(q)||!this._provider.resolveCodeAction)return;const ie=await this._provider.resolveCodeAction(q,K)??q;return ie?.edit?S.WorkspaceEdit.from(ie.edit):void 0}releaseCodeActions(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}static _isCommand(O){return typeof O.command=="string"&&typeof O.title=="string"}}A._maxCodeActionsPerFile=1e3;class L{constructor(O,K){this._documents=O,this._provider=K}async provideDocumentFormattingEdits(O,K,X){const se=this._documents.getDocument(O),q=await this._provider.provideDocumentFormattingEdits(se,K,X);if(Array.isArray(q))return q.map(S.TextEdit.from)}}class ${constructor(O,K){this._documents=O,this._provider=K}async provideDocumentRangeFormattingEdits(O,K,X,se){const q=this._documents.getDocument(O),ie=S.Range.to(K),ge=await this._provider.provideDocumentRangeFormattingEdits(q,ie,X,se);if(Array.isArray(ge))return ge.map(S.TextEdit.from)}}class oe{constructor(O,K){this._documents=O,this._provider=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,K,X,se,q){const ie=this._documents.getDocument(O),ge=S.Position.to(K),Le=await this._provider.provideOnTypeFormattingEdits(ie,ge,X,se,q);if(Array.isArray(Le))return Le.map(S.TextEdit.from)}}class he{constructor(O,K){this._provider=O,this._logService=K,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(O,K){const X=C.IdObject.mixin({symbols:[]}),se=await this._provider.provideWorkspaceSymbols(O,K);if((0,k.isNonEmptyArray)(se))for(const q of se){if(!q)continue;if(!q.name){this._logService.warn("INVALID SymbolInformation, lacks name",q);continue}const ie=C.IdObject.mixin(S.WorkspaceSymbol.from(q));this._symbolCache.set(ie._id,q),X.symbols.push(ie)}return X.symbols.length>0&&this._resultCache.set(X._id,[X.symbols[0]._id,X.symbols[X.symbols.length-1]._id]),X}async resolveWorkspaceSymbol(O,K){if(typeof this._provider.resolveWorkspaceSymbol!="function")return O;const X=this._symbolCache.get(O._id);if(X){const se=await this._provider.resolveWorkspaceSymbol(X,K);return se&&(0,F.mixin)(O,S.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols(O){const K=this._resultCache.get(O);if(K){for(let[X,se]=K;X<=se;X++)this._symbolCache.delete(X);this._resultCache.delete(O)}}}class Q{constructor(O,K,X){this._documents=O,this._provider=K,this._logService=X}static supportsResolving(O){return typeof O.prepareRename=="function"}async provideRenameEdits(O,K,X,se){const q=this._documents.getDocument(O),ie=S.Position.to(K);try{const ge=await this._provider.provideRenameEdits(q,ie,X,se);return ge?S.WorkspaceEdit.from(ge):void 0}catch(ge){const Le=Q._asMessage(ge);return Le?{rejectReason:Le,edits:void 0}:Promise.reject(ge)}}async resolveRenameLocation(O,K,X){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const se=this._documents.getDocument(O),q=S.Position.to(K);try{const ie=await this._provider.prepareRename(se,q,X);let ge,Le;if(E.Range.isRange(ie)?(ge=ie,Le=se.getText(ie)):(0,n.isObject)(ie)&&(ge=ie.range,Le=ie.placeholder),!ge||!Le)return;if(ge.start.line>q.line||ge.end.line<q.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:S.Range.from(ge),text:Le}}catch(ie){const ge=Q._asMessage(ie);return ge?{rejectReason:ge,range:void 0,text:void 0}:Promise.reject(ie)}}static _asMessage(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class z{constructor(O,K){this.resultId=O,this.tokens=K}}class V{constructor(O,K){this._documents=O,this._provider=K,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(O,K,X){const se=this._documents.getDocument(O),q=K!==0?this._previousResults.get(K):null;let ie=typeof q?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(se,q.resultId,X):await this._provider.provideDocumentSemanticTokens(se,X);return q&&this._previousResults.delete(K),ie?(ie=V._fixProvidedSemanticTokens(ie),this._send(V._convertToEdits(q,ie),ie)):null}async releaseDocumentSemanticColoring(O){this._previousResults.delete(O)}static _fixProvidedSemanticTokens(O){return V._isSemanticTokens(O)?V._isCorrectSemanticTokens(O)?O:new E.SemanticTokens(new Uint32Array(O.data),O.resultId):V._isSemanticTokensEdits(O)?V._isCorrectSemanticTokensEdits(O)?O:new E.SemanticTokensEdits(O.edits.map(K=>new E.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),O.resultId):O}static _isSemanticTokens(O){return O&&!!O.data}static _isCorrectSemanticTokens(O){return O.data instanceof Uint32Array}static _isSemanticTokensEdits(O){return O&&Array.isArray(O.edits)}static _isCorrectSemanticTokensEdits(O){for(const K of O.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(O,K){if(!V._isSemanticTokens(K)||!O||!O.tokens)return K;const X=O.tokens,se=X.length,q=K.data,ie=q.length;let ge=0;const Le=Math.min(se,ie);for(;ge<Le&&X[ge]===q[ge];)ge++;if(ge===se&&ge===ie)return new E.SemanticTokensEdits([],K.resultId);let We=0;const ve=Le-ge;for(;We<ve&&X[se-We-1]===q[ie-We-1];)We++;return new E.SemanticTokensEdits([{start:ge,deleteCount:se-ge-We,data:q.subarray(ge,ie-We)}],K.resultId)}_send(O,K){if(V._isSemanticTokens(O)){const X=this._nextResultId++;return this._previousResults.set(X,new z(O.resultId,O.data)),(0,d.encodeSemanticTokensDto)({id:X,type:"full",data:O.data})}if(V._isSemanticTokensEdits(O)){const X=this._nextResultId++;return V._isSemanticTokens(K)?this._previousResults.set(X,new z(K.resultId,K.data)):this._previousResults.set(X,new z(O.resultId)),(0,d.encodeSemanticTokensDto)({id:X,type:"delta",deltas:(O.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}e.DocumentSemanticTokensAdapter=V;class R{constructor(O,K){this._documents=O,this._provider=K}async provideDocumentRangeSemanticTokens(O,K,X){const se=this._documents.getDocument(O),q=await this._provider.provideDocumentRangeSemanticTokens(se,S.Range.to(K),X);return q?this._send(q):null}_send(O){return(0,d.encodeSemanticTokensDto)({id:0,type:"full",data:O.data})}}e.DocumentRangeSemanticTokensAdapter=R;class G{constructor(O,K,X,se,q){this._documents=O,this._commands=K,this._provider=X,this._apiDeprecation=se,this._extension=q,this._cache=new m.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}async provideCompletionItems(O,K,X,se){const q=this._documents.getDocument(O),ie=S.Position.to(K),ge=q.getWordRangeAtPosition(ie)||new E.Range(ie,ie),Le=ge.with({end:ie}),We=new b.StopWatch(!0),ve=await this._provider.provideCompletionItems(q,ie,se,S.CompletionContext.to(X));if(!ve||se.isCancellationRequested)return;const Xe=Array.isArray(ve)?new E.CompletionList(ve):ve,H=G.supportsResolving(this._provider)?this._cache.add(Xe.items):this._cache.add([]),Z=new l.DisposableStore;this._disposables.set(H,Z);const ce=[],Be={x:H,b:ce,a:{replace:S.Range.from(ge),insert:S.Range.from(Le)},c:Xe.isIncomplete||void 0,d:We.elapsed()};for(let xe=0;xe<Xe.items.length;xe++){const Ze=Xe.items[xe],De=this._convertCompletionItem(Ze,[H,xe],Le,ge);ce.push(De)}return Be}async resolveCompletionItem(O,K){if(typeof this._provider.resolveCompletionItem!="function")return;const X=this._cache.get(...O);if(!X)return;const se=await this._provider.resolveCompletionItem(X,K);if(!!se)return this._convertCompletionItem(se,O)}releaseCompletionItems(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_convertCompletionItem(O,K,X,se){const q=this._disposables.get(K[0]);if(!q)throw Error("DisposableStore is missing...");const ie={x:K,a:O.label,b:O.kind!==void 0?S.CompletionItemKind.from(O.kind):void 0,n:O.tags&&O.tags.map(S.CompletionItemTag.from),c:O.detail,d:typeof O.documentation=="undefined"?void 0:S.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters,l:O.additionalTextEdits&&O.additionalTextEdits.map(S.TextEdit.from),m:this._commands.toInternal(O.command,q)};O.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ie.h=O.textEdit.newText):typeof O.insertText=="string"?ie.h=O.insertText:O.insertText instanceof E.SnippetString&&(ie.h=O.insertText.value,ie.i|=4);let ge;return O.textEdit?ge=O.textEdit.range:O.range&&(ge=O.range),E.Range.isRange(ge)?ie.j=S.Range.from(ge):ge&&(!X?.isEqual(ge.inserting)||!se?.isEqual(ge.replacing))&&(ie.j={insert:S.Range.from(ge.inserting),replace:S.Range.from(ge.replacing)}),ie}}class x{constructor(O,K,X){this._documents=O,this._provider=K,this._commands=X,this._cache=new m.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(O,K,X,se){const q=this._documents.getDocument(O),ie=S.Position.to(K),ge=await this._provider.provideInlineCompletionItems(q,ie,X,se);if(!ge||se.isCancellationRequested)return;const Le=(0,n.isArray)(ge)?{items:ge}:ge,We=this._cache.add(Le.items);let ve;return{pid:We,items:Le.items.map((Xe,H)=>{let Z;return Xe.command&&(ve||(ve=new l.DisposableStore,this._disposables.set(We,ve)),Z=this._commands.toInternal(Xe.command,ve)),{text:Xe.text,range:Xe.range?S.Range.from(Xe.range):void 0,command:Z,idx:H}})}}disposeCompletions(O){this._cache.delete(O);const K=this._disposables.get(O);K&&K.clear(),this._disposables.delete(O)}handleDidShowCompletionItem(O,K){const X=this._cache.get(O,K);X&&j.get(this._provider).fireOnDidShowCompletionItem({completionItem:X})}}class j{constructor(){this._onDidShowCompletionItemEmitter=new P.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(O){let K=j.map.get(O);return K||(K=new j,j.map.set(O,K)),K}fireOnDidShowCompletionItem(O){this._onDidShowCompletionItemEmitter.fire(O)}}e.InlineCompletionController=j,j.map=new WeakMap;class de{constructor(O,K){this._documents=O,this._provider=K,this._cache=new m.Cache("SignatureHelp")}async provideSignatureHelp(O,K,X,se){const q=this._documents.getDocument(O),ie=S.Position.to(K),ge=this.reviveContext(X),Le=await this._provider.provideSignatureHelp(q,ie,se,ge);if(Le){const We=this._cache.add([Le]);return{...S.SignatureHelp.from(Le),id:We}}}reviveContext(O){let K;if(O.activeSignatureHelp){const X=S.SignatureHelp.to(O.activeSignatureHelp),se=this._cache.get(O.activeSignatureHelp.id,0);se?(K=se,K.activeSignature=X.activeSignature,K.activeParameter=X.activeParameter):K=X}return{...O,activeSignatureHelp:K}}releaseSignatureHelp(O){this._cache.delete(O)}}class B{constructor(O,K){this._documents=O,this._provider=K}async provideInlayHints(O,K,X){const se=this._documents.getDocument(O),q=await this._provider.provideInlayHints(se,S.Range.to(K),X);return q?{hints:q.map(S.InlayHint.from)}:void 0}}class ne{constructor(O,K){this._documents=O,this._provider=K,this._cache=new m.Cache("DocumentLink")}async provideLinks(O,K){const X=this._documents.getDocument(O),se=await this._provider.provideDocumentLinks(X,K);if(!(!Array.isArray(se)||se.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:se.filter(ne._validateLink).map(S.DocumentLink.from)};{const q=this._cache.add(se),ie={links:[],id:q};for(let ge=0;ge<se.length;ge++){if(!ne._validateLink(se[ge]))continue;const Le=S.DocumentLink.from(se[ge]);Le.cacheId=[q,ge],ie.links.push(Le)}return ie}}}static _validateLink(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,K){if(typeof this._provider.resolveDocumentLink!="function")return;const X=this._cache.get(...O);if(!X)return;const se=await this._provider.resolveDocumentLink(X,K);if(!(!se||!ne._validateLink(se)))return S.DocumentLink.from(se)}releaseLinks(O){this._cache.delete(O)}}class ue{constructor(O,K){this._documents=O,this._provider=K}async provideColors(O,K){const X=this._documents.getDocument(O),se=await this._provider.provideDocumentColors(X,K);return Array.isArray(se)?se.map(ie=>({color:S.Color.from(ie.color),range:S.Range.from(ie.range)})):[]}async provideColorPresentations(O,K,X){const se=this._documents.getDocument(O),q=S.Range.to(K.range),ie=S.Color.to(K.color),ge=await this._provider.provideColorPresentations(ie,{document:se,range:q},X);if(!!Array.isArray(ge))return ge.map(S.ColorPresentation.from)}}class ye{constructor(O,K){this._documents=O,this._provider=K}async provideFoldingRanges(O,K,X){const se=this._documents.getDocument(O),q=await this._provider.provideFoldingRanges(se,K,X);if(!!Array.isArray(q))return q.map(S.FoldingRange.from)}}class Re{constructor(O,K,X){this._documents=O,this._provider=K,this._logService=X}async provideSelectionRanges(O,K,X){const se=this._documents.getDocument(O),q=K.map(S.Position.to),ie=await this._provider.provideSelectionRanges(se,q,X);if(!(0,k.isNonEmptyArray)(ie))return[];if(ie.length!==q.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ge=[];for(let Le=0;Le<q.length;Le++){const We=[];ge.push(We);let ve=q[Le],Xe=ie[Le];for(;;){if(!Xe.range.contains(ve))throw new Error("INVALID selection range, must contain the previous range");if(We.push(S.SelectionRange.from(Xe)),!Xe.parent)break;ve=Xe.range,Xe=Xe.parent}}return ge}}class Te{constructor(O,K){this._documents=O,this._provider=K,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(O,K,X){const se=this._documents.getDocument(O),q=S.Position.to(K),ie=await this._provider.prepareCallHierarchy(se,q,X);if(!ie)return;const ge=this._idPool.nextId();return this._cache.set(ge,new Map),Array.isArray(ie)?ie.map(Le=>this._cacheAndConvertItem(ge,Le)):[this._cacheAndConvertItem(ge,ie)]}async provideCallsTo(O,K,X){const se=this._itemFromCache(O,K);if(!se)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyIncomingCalls(se,X);if(!!q)return q.map(ie=>({from:this._cacheAndConvertItem(O,ie.from),fromRanges:ie.fromRanges.map(ge=>S.Range.from(ge))}))}async provideCallsFrom(O,K,X){const se=this._itemFromCache(O,K);if(!se)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyOutgoingCalls(se,X);if(!!q)return q.map(ie=>({to:this._cacheAndConvertItem(O,ie.to),fromRanges:ie.fromRanges.map(ge=>S.Range.from(ge))}))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,K){const X=this._cache.get(O),se=S.CallHierarchyItem.from(K,O,X.size.toString(36));return X.set(se._itemId,K),se}_itemFromCache(O,K){return this._cache.get(O)?.get(K)}}class $e{constructor(O,K){this._documents=O,this._provider=K,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(O,K,X){const se=this._documents.getDocument(O),q=S.Position.to(K),ie=await this._provider.prepareTypeHierarchy(se,q,X);if(!ie)return;const ge=this._idPool.nextId();return this._cache.set(ge,new Map),Array.isArray(ie)?ie.map(Le=>this._cacheAndConvertItem(ge,Le)):[this._cacheAndConvertItem(ge,ie)]}async provideSupertypes(O,K,X){const se=this._itemFromCache(O,K);if(!se)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySupertypes(se,X);if(!!q)return q.map(ie=>this._cacheAndConvertItem(O,ie))}async provideSubtypes(O,K,X){const se=this._itemFromCache(O,K);if(!se)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySubtypes(se,X);if(!!q)return q.map(ie=>this._cacheAndConvertItem(O,ie))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,K){const X=this._cache.get(O),se=S.TypeHierarchyItem.from(K,O,X.size.toString(36));return X.set(se._itemId,K),se}_itemFromCache(O,K){return this._cache.get(O)?.get(K)}}class Je{constructor(O,K){this.adapter=O,this.extension=K}}class Ve{constructor(O,K,X,se,q,ie,ge){this._adapter=new Map,this._uriTransformer=K,this._proxy=O.getProxy(C.MainContext.MainThreadLanguageFeatures),this._documents=X,this._commands=se,this._diagnostics=q,this._logService=ie,this._apiDeprecation=ge}_transformDocumentSelector(O){return(0,k.coalesce)((0,k.asArray)(O).map(K=>this._doTransformDocumentSelector(K)))}_doTransformDocumentSelector(O){if(typeof O=="string")return{$serialized:!0,language:O};if(O)return{$serialized:!0,language:O.language,scheme:this._transformScheme(O.scheme),pattern:typeof O.pattern=="undefined"?void 0:S.GlobPattern.from(O.pattern),exclusive:O.exclusive}}_transformScheme(O){return this._uriTransformer&&typeof O=="string"?this._uriTransformer.transformOutgoingScheme(O):O}_createDisposable(O){return new E.Disposable(()=>{this._adapter.delete(O),this._proxy.$unregister(O)})}_nextHandle(){return Ve._handlePool++}_withAdapter(O,K,X,se,q=!1){const ie=this._adapter.get(O);if(!ie)return Promise.resolve(se);if(ie.adapter instanceof K){let ge;ie.extension&&(ge=Date.now(),this._logService.trace(`[${ie.extension.identifier.value}] INVOKE provider '${K.name}'`));const Le=X(ie.adapter,ie.extension),We=ie.extension;return We&&Promise.resolve(Le).then(()=>this._logService.trace(`[${We.identifier.value}] provider DONE after ${Date.now()-ge}ms`),ve=>{q&&ve instanceof w.CancellationError||(this._logService.error(`[${We.identifier.value}] provider FAILED`),this._logService.error(ve))}),Le}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(O,K){const X=this._nextHandle();return this._adapter.set(X,new Je(O,K)),X}static _extLabel(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,K,X,se){const q=this._addNewAdapter(new a(this._documents,X),O),ie=se&&se.label||Ve._extLabel(O);return this._proxy.$registerDocumentSymbolProvider(q,this._transformDocumentSelector(K),ie),this._createDisposable(q)}$provideDocumentSymbols(O,K,X){return this._withAdapter(O,a,se=>se.provideDocumentSymbols(g.URI.revive(K),X),void 0)}registerCodeLensProvider(O,K,X){const se=this._nextHandle(),q=typeof X.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(se,new Je(new f(this._documents,this._commands.converter,X),O)),this._proxy.$registerCodeLensSupport(se,this._transformDocumentSelector(K),q);let ie=this._createDisposable(se);if(q!==void 0){const ge=X.onDidChangeCodeLenses(Le=>this._proxy.$emitCodeLensEvent(q));ie=E.Disposable.from(ie,ge)}return ie}$provideCodeLenses(O,K,X){return this._withAdapter(O,f,se=>se.provideCodeLenses(g.URI.revive(K),X),void 0)}$resolveCodeLens(O,K,X){return this._withAdapter(O,f,se=>se.resolveCodeLens(K,X),void 0)}$releaseCodeLenses(O,K){this._withAdapter(O,f,X=>Promise.resolve(X.releaseCodeLenses(K)),void 0)}registerDefinitionProvider(O,K,X){const se=this._addNewAdapter(new t(this._documents,X),O);return this._proxy.$registerDefinitionSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDefinition(O,K,X,se){return this._withAdapter(O,t,q=>q.provideDefinition(g.URI.revive(K),X,se),[])}registerDeclarationProvider(O,K,X){const se=this._addNewAdapter(new r(this._documents,X),O);return this._proxy.$registerDeclarationSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDeclaration(O,K,X,se){return this._withAdapter(O,r,q=>q.provideDeclaration(g.URI.revive(K),X,se),[])}registerImplementationProvider(O,K,X){const se=this._addNewAdapter(new s(this._documents,X),O);return this._proxy.$registerImplementationSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideImplementation(O,K,X,se){return this._withAdapter(O,s,q=>q.provideImplementation(g.URI.revive(K),X,se),[])}registerTypeDefinitionProvider(O,K,X){const se=this._addNewAdapter(new i(this._documents,X),O);return this._proxy.$registerTypeDefinitionSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideTypeDefinition(O,K,X,se){return this._withAdapter(O,i,q=>q.provideTypeDefinition(g.URI.revive(K),X,se),[])}registerHoverProvider(O,K,X,se){const q=this._addNewAdapter(new c(this._documents,X),O);return this._proxy.$registerHoverProvider(q,this._transformDocumentSelector(K)),this._createDisposable(q)}$provideHover(O,K,X,se){return this._withAdapter(O,c,q=>q.provideHover(g.URI.revive(K),X,se),void 0)}registerEvaluatableExpressionProvider(O,K,X,se){const q=this._addNewAdapter(new h(this._documents,X),O);return this._proxy.$registerEvaluatableExpressionProvider(q,this._transformDocumentSelector(K)),this._createDisposable(q)}$provideEvaluatableExpression(O,K,X,se){return this._withAdapter(O,h,q=>q.provideEvaluatableExpression(g.URI.revive(K),X,se),void 0)}registerInlineValuesProvider(O,K,X,se){const q=typeof X.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ie=this._addNewAdapter(new p(this._documents,X),O);this._proxy.$registerInlineValuesProvider(ie,this._transformDocumentSelector(K),q);let ge=this._createDisposable(ie);if(q!==void 0){const Le=X.onDidChangeInlineValues(We=>this._proxy.$emitInlineValuesEvent(q));ge=E.Disposable.from(ge,Le)}return ge}$provideInlineValues(O,K,X,se,q){return this._withAdapter(O,p,ie=>ie.provideInlineValues(g.URI.revive(K),X,se,q),void 0)}registerDocumentHighlightProvider(O,K,X){const se=this._addNewAdapter(new D(this._documents,X),O);return this._proxy.$registerDocumentHighlightProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDocumentHighlights(O,K,X,se){return this._withAdapter(O,D,q=>q.provideDocumentHighlights(g.URI.revive(K),X,se),void 0)}registerLinkedEditingRangeProvider(O,K,X){const se=this._addNewAdapter(new T(this._documents,X),O);return this._proxy.$registerLinkedEditingRangeProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideLinkedEditingRanges(O,K,X,se){return this._withAdapter(O,T,async q=>{const ie=await q.provideLinkedEditingRanges(g.URI.revive(K),X,se);if(ie)return{ranges:ie.ranges,wordPattern:ie.wordPattern?Ve._serializeRegExp(ie.wordPattern):void 0}},void 0)}registerReferenceProvider(O,K,X){const se=this._addNewAdapter(new o(this._documents,X),O);return this._proxy.$registerReferenceSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideReferences(O,K,X,se,q){return this._withAdapter(O,o,ie=>ie.provideReferences(g.URI.revive(K),X,se,q),void 0)}registerCodeActionProvider(O,K,X,se){const q=new l.DisposableStore,ie=this._addNewAdapter(new A(this._documents,this._commands.converter,this._diagnostics,X,this._logService,O,this._apiDeprecation),O);return this._proxy.$registerQuickFixSupport(ie,this._transformDocumentSelector(K),{providedKinds:se?.providedCodeActionKinds?.map(ge=>ge.value),documentation:se?.documentation?.map(ge=>({kind:ge.kind.value,command:this._commands.converter.toInternal(ge.command,q)}))},Ve._extLabel(O),Boolean(X.resolveCodeAction)),q.add(this._createDisposable(ie)),q}$provideCodeActions(O,K,X,se,q){return this._withAdapter(O,A,ie=>ie.provideCodeActions(g.URI.revive(K),X,se,q),void 0)}$resolveCodeAction(O,K,X){return this._withAdapter(O,A,se=>se.resolveCodeAction(K,X),void 0)}$releaseCodeActions(O,K){this._withAdapter(O,A,X=>Promise.resolve(X.releaseCodeActions(K)),void 0)}registerDocumentFormattingEditProvider(O,K,X){const se=this._addNewAdapter(new L(this._documents,X),O);return this._proxy.$registerDocumentFormattingSupport(se,this._transformDocumentSelector(K),O.identifier,O.displayName||O.name),this._createDisposable(se)}$provideDocumentFormattingEdits(O,K,X,se){return this._withAdapter(O,L,q=>q.provideDocumentFormattingEdits(g.URI.revive(K),X,se),void 0)}registerDocumentRangeFormattingEditProvider(O,K,X){const se=this._addNewAdapter(new $(this._documents,X),O);return this._proxy.$registerRangeFormattingSupport(se,this._transformDocumentSelector(K),O.identifier,O.displayName||O.name),this._createDisposable(se)}$provideDocumentRangeFormattingEdits(O,K,X,se,q){return this._withAdapter(O,$,ie=>ie.provideDocumentRangeFormattingEdits(g.URI.revive(K),X,se,q),void 0)}registerOnTypeFormattingEditProvider(O,K,X,se){const q=this._addNewAdapter(new oe(this._documents,X),O);return this._proxy.$registerOnTypeFormattingSupport(q,this._transformDocumentSelector(K),se,O.identifier),this._createDisposable(q)}$provideOnTypeFormattingEdits(O,K,X,se,q,ie){return this._withAdapter(O,oe,ge=>ge.provideOnTypeFormattingEdits(g.URI.revive(K),X,se,q,ie),void 0)}registerWorkspaceSymbolProvider(O,K){const X=this._addNewAdapter(new he(K,this._logService),O);return this._proxy.$registerNavigateTypeSupport(X),this._createDisposable(X)}$provideWorkspaceSymbols(O,K,X){return this._withAdapter(O,he,se=>se.provideWorkspaceSymbols(K,X),{symbols:[]})}$resolveWorkspaceSymbol(O,K,X){return this._withAdapter(O,he,se=>se.resolveWorkspaceSymbol(K,X),void 0)}$releaseWorkspaceSymbols(O,K){this._withAdapter(O,he,X=>X.releaseWorkspaceSymbols(K),void 0)}registerRenameProvider(O,K,X){const se=this._addNewAdapter(new Q(this._documents,X,this._logService),O);return this._proxy.$registerRenameSupport(se,this._transformDocumentSelector(K),Q.supportsResolving(X)),this._createDisposable(se)}$provideRenameEdits(O,K,X,se,q){return this._withAdapter(O,Q,ie=>ie.provideRenameEdits(g.URI.revive(K),X,se,q),void 0)}$resolveRenameLocation(O,K,X,se){return this._withAdapter(O,Q,q=>q.resolveRenameLocation(g.URI.revive(K),X,se),void 0)}registerDocumentSemanticTokensProvider(O,K,X,se){const q=this._nextHandle(),ie=typeof X.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(q,new Je(new V(this._documents,X),O)),this._proxy.$registerDocumentSemanticTokensProvider(q,this._transformDocumentSelector(K),se,ie);let ge=this._createDisposable(q);if(ie){const Le=X.onDidChangeSemanticTokens(We=>this._proxy.$emitDocumentSemanticTokensEvent(ie));ge=E.Disposable.from(ge,Le)}return ge}$provideDocumentSemanticTokens(O,K,X,se){return this._withAdapter(O,V,q=>q.provideDocumentSemanticTokens(g.URI.revive(K),X,se),null,!0)}$releaseDocumentSemanticTokens(O,K){this._withAdapter(O,V,X=>X.releaseDocumentSemanticColoring(K),void 0)}registerDocumentRangeSemanticTokensProvider(O,K,X,se){const q=this._addNewAdapter(new R(this._documents,X),O);return this._proxy.$registerDocumentRangeSemanticTokensProvider(q,this._transformDocumentSelector(K),se),this._createDisposable(q)}$provideDocumentRangeSemanticTokens(O,K,X,se){return this._withAdapter(O,R,q=>q.provideDocumentRangeSemanticTokens(g.URI.revive(K),X,se),null,!0)}registerCompletionItemProvider(O,K,X,se){const q=this._addNewAdapter(new G(this._documents,this._commands.converter,X,this._apiDeprecation,O),O);return this._proxy.$registerSuggestSupport(q,this._transformDocumentSelector(K),se,G.supportsResolving(X),`${O.identifier.value}(${se.join("")})`),this._createDisposable(q)}$provideCompletionItems(O,K,X,se,q){return this._withAdapter(O,G,ie=>ie.provideCompletionItems(g.URI.revive(K),X,se,q),void 0)}$resolveCompletionItem(O,K,X){return this._withAdapter(O,G,se=>se.resolveCompletionItem(K,X),void 0)}$releaseCompletionItems(O,K){this._withAdapter(O,G,X=>X.releaseCompletionItems(K),void 0)}registerInlineCompletionsProvider(O,K,X){const se=this._addNewAdapter(new x(this._documents,X,this._commands.converter),O);return this._proxy.$registerInlineCompletionsSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideInlineCompletions(O,K,X,se,q){return this._withAdapter(O,x,ie=>ie.provideInlineCompletions(g.URI.revive(K),X,se,q),void 0)}$handleInlineCompletionDidShow(O,K,X){this._withAdapter(O,x,async se=>{se.handleDidShowCompletionItem(K,X)},void 0)}$freeInlineCompletionsList(O,K){this._withAdapter(O,x,async X=>{X.disposeCompletions(K)},void 0)}registerSignatureHelpProvider(O,K,X,se){const q=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,ie=this._addNewAdapter(new de(this._documents,X),O);return this._proxy.$registerSignatureHelpProvider(ie,this._transformDocumentSelector(K),q),this._createDisposable(ie)}$provideSignatureHelp(O,K,X,se,q){return this._withAdapter(O,de,ie=>ie.provideSignatureHelp(g.URI.revive(K),X,se,q),void 0)}$releaseSignatureHelp(O,K){this._withAdapter(O,de,X=>X.releaseSignatureHelp(K),void 0)}registerInlayHintsProvider(O,K,X){const se=typeof X.onDidChangeInlayHints=="function"?this._nextHandle():void 0,q=this._addNewAdapter(new B(this._documents,X),O);this._proxy.$registerInlayHintsProvider(q,this._transformDocumentSelector(K),se);let ie=this._createDisposable(q);if(se!==void 0){const ge=X.onDidChangeInlayHints(Le=>this._proxy.$emitInlayHintsEvent(se));ie=E.Disposable.from(ie,ge)}return ie}$provideInlayHints(O,K,X,se){return this._withAdapter(O,B,q=>q.provideInlayHints(g.URI.revive(K),X,se),void 0)}registerDocumentLinkProvider(O,K,X){const se=this._addNewAdapter(new ne(this._documents,X),O);return this._proxy.$registerDocumentLinkProvider(se,this._transformDocumentSelector(K),typeof X.resolveDocumentLink=="function"),this._createDisposable(se)}$provideDocumentLinks(O,K,X){return this._withAdapter(O,ne,se=>se.provideLinks(g.URI.revive(K),X),void 0)}$resolveDocumentLink(O,K,X){return this._withAdapter(O,ne,se=>se.resolveLink(K,X),void 0)}$releaseDocumentLinks(O,K){this._withAdapter(O,ne,X=>X.releaseLinks(K),void 0)}registerColorProvider(O,K,X){const se=this._addNewAdapter(new ue(this._documents,X),O);return this._proxy.$registerDocumentColorProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDocumentColors(O,K,X){return this._withAdapter(O,ue,se=>se.provideColors(g.URI.revive(K),X),[])}$provideColorPresentations(O,K,X,se){return this._withAdapter(O,ue,q=>q.provideColorPresentations(g.URI.revive(K),X,se),void 0)}registerFoldingRangeProvider(O,K,X){const se=this._nextHandle(),q=typeof X.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(se,new Je(new ye(this._documents,X),O)),this._proxy.$registerFoldingRangeProvider(se,this._transformDocumentSelector(K),q);let ie=this._createDisposable(se);if(q!==void 0){const ge=X.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(q));ie=E.Disposable.from(ie,ge)}return ie}$provideFoldingRanges(O,K,X,se){return this._withAdapter(O,ye,q=>q.provideFoldingRanges(g.URI.revive(K),X,se),void 0)}registerSelectionRangeProvider(O,K,X){const se=this._addNewAdapter(new Re(this._documents,X,this._logService),O);return this._proxy.$registerSelectionRangeProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideSelectionRanges(O,K,X,se){return this._withAdapter(O,Re,q=>q.provideSelectionRanges(g.URI.revive(K),X,se),[])}registerCallHierarchyProvider(O,K,X){const se=this._addNewAdapter(new Te(this._documents,X),O);return this._proxy.$registerCallHierarchyProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$prepareCallHierarchy(O,K,X,se){return this._withAdapter(O,Te,q=>Promise.resolve(q.prepareSession(g.URI.revive(K),X,se)),void 0)}$provideCallHierarchyIncomingCalls(O,K,X,se){return this._withAdapter(O,Te,q=>q.provideCallsTo(K,X,se),void 0)}$provideCallHierarchyOutgoingCalls(O,K,X,se){return this._withAdapter(O,Te,q=>q.provideCallsFrom(K,X,se),void 0)}$releaseCallHierarchy(O,K){this._withAdapter(O,Te,X=>Promise.resolve(X.releaseSession(K)),void 0)}registerTypeHierarchyProvider(O,K,X){const se=this._addNewAdapter(new $e(this._documents,X),O);return this._proxy.$registerTypeHierarchyProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$prepareTypeHierarchy(O,K,X,se){return this._withAdapter(O,$e,q=>Promise.resolve(q.prepareSession(g.URI.revive(K),X,se)),void 0)}$provideTypeHierarchySupertypes(O,K,X,se){return this._withAdapter(O,$e,q=>q.provideSupertypes(K,X,se),void 0)}$provideTypeHierarchySubtypes(O,K,X,se){return this._withAdapter(O,$e,q=>q.provideSubtypes(K,X,se),void 0)}$releaseTypeHierarchy(O,K){this._withAdapter(O,$e,X=>Promise.resolve(X.releaseSession(K)),void 0)}static _serializeRegExp(O){return{pattern:O.source,flags:(0,y.regExpFlags)(O)}}static _serializeIndentationRule(O){return{decreaseIndentPattern:Ve._serializeRegExp(O.decreaseIndentPattern),increaseIndentPattern:Ve._serializeRegExp(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?Ve._serializeRegExp(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?Ve._serializeRegExp(O.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(O){return{beforeText:Ve._serializeRegExp(O.beforeText),afterText:O.afterText?Ve._serializeRegExp(O.afterText):void 0,previousLineText:O.previousLineText?Ve._serializeRegExp(O.previousLineText):void 0,action:O.action}}static _serializeOnEnterRules(O){return O.map(Ve._serializeOnEnterRule)}setLanguageConfiguration(O,K,X){let{wordPattern:se}=X;if(se&&(0,y.regExpLeadsToEndlessLoop)(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this._documents.setWordDefinitionFor(K,se):this._documents.setWordDefinitionFor(K,void 0),X.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),X.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const q=this._nextHandle(),ie={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?Ve._serializeRegExp(X.wordPattern):void 0,indentationRules:X.indentationRules?Ve._serializeIndentationRule(X.indentationRules):void 0,onEnterRules:X.onEnterRules?Ve._serializeOnEnterRules(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport};return this._proxy.$setLanguageConfiguration(q,K,ie),this._createDisposable(q)}$setWordDefinitions(O){for(const K of O)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=Ve,Ve._handlePool=0}),define(be[201],Ee([0,1,5,9,7]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class E{constructor(y,_){this._proxy=y.getProxy(g.MainContext.MainThreadLanguages),this._documents=_}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(y,_){await this._proxy.$changeLanguage(y,_);const k=this._documents.getDocumentData(y);if(!k)throw new Error(`document '${y.toString}' NOT found`);return k.document}async tokenAtPosition(y,_){const k=y.version,n=F.Position.from(_),I=await this._proxy.$tokensAtPosition(y.uri,n),l={type:S.StandardTokenType.Other,range:y.getWordRangeAtPosition(_)??new S.Range(_.line,_.character,_.line,_.character)};if(!I)return l;const d={range:F.Range.to(I.range),type:F.TokenType.to(I.type)};return!d.range.contains(_)||k!==y.version?l:d}}e.ExtHostLanguages=E}),define(be[202],Ee([0,1,5,15,30]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function E(y){return y&&y.title}let C=class{constructor(_,k){this._logService=k,this._proxy=_.getProxy(g.MainContext.MainThreadMessageService)}showMessage(_,k,n,I,l){const d={extension:_};let u;typeof I=="string"||E(I)?u=[I,...l]:(d.modal=I?.modal,d.useCustom=I?.useCustom,d.detail=I?.detail,u=l),d.useCustom&&(0,S.checkProposedApiEnabled)(_);const m=[];for(let b=0;b<u.length;b++){const w=u[b];if(typeof w=="string")m.push({title:w,handle:b,isCloseAffordance:!1});else if(typeof w=="object"){let{title:P,isCloseAffordance:a}=w;m.push({title:P,isCloseAffordance:!!a,handle:b})}else this._logService.warn("Invalid message item:",w)}return this._proxy.$showMessage(k,n,d,m).then(b=>{if(typeof b=="number")return u[b]})}};C=ze([qe(1,F.ILogService)],C),e.ExtHostMessageService=C}),define(be[203],Ee([0,1,24,3,42,6,21,8,10,2,65,5,9,7,180,101]),function(ee,e,g,F,S,E,C,y,_,k,n,I,l,d,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class b{constructor(P,a,f,v,t){this._textDocumentsAndEditors=f,this._textDocuments=v,this._extensionStoragePaths=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new C.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new F.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new F.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new F.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new F.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new F.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new F.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new F.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new F.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new n.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=P.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=P.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=P.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=a.converter,a.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const s=r.notebookEditor?.notebookUri,i=r.cell.handle,h=this._documents.get(s)?.getCell(i);if(h)return h.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(P=>P.apiEditor)}getEditorById(P){const a=this._editors.get(P);if(!a)throw new Error(`unknown text editor: ${P}. known editors: ${[...this._editors.keys()]} `);return a}getIdByEditor(P){for(const[a,f]of this._editors)if(f.apiEditor===P)return a}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(P,a){const f=this._documents.get(P);if(!f&&!a)throw new Error(`NO notebook document for '${P}'`);return f}_getProviderData(P){const a=this._notebookContentProviders.get(P);if(!a)throw new Error(`NO provider for '${P}'`);return a}registerNotebookContentProvider(P,a,f,v,t){if((0,y.isFalsyOrWhitespace)(a))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(a))throw new Error(`Notebook provider for '${a}' already registered`);this._notebookContentProviders.set(a,{extension:P,provider:f});let r;return f.onDidChangeNotebookContentOptions&&(r=f.onDidChangeNotebookContentOptions(()=>{const s=l.NotebookDocumentContentOptions.from(f.options);this._notebookProxy.$updateNotebookProviderOptions(a,s)})),this._notebookProxy.$registerNotebookProvider({id:P.identifier,location:P.extensionLocation},a,l.NotebookDocumentContentOptions.from(v),b._convertNotebookRegistrationData(P,t)),new d.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(a),this._notebookProxy.$unregisterNotebookProvider(a)})}static _convertNotebookRegistrationData(P,a){if(!a)return;const f=a.filenamePattern.map(v=>l.NotebookExclusiveDocumentPattern.from(v)).filter(v=>v!==void 0);if(a.filenamePattern&&!f){console.warn(`Notebook content provider view options file name pattern is invalid ${a.filenamePattern}`);return}return{extension:P.identifier,providerDisplayName:P.displayName||P.name,displayName:a.displayName,filenamePattern:f,exclusive:a.exclusive||!1}}registerNotebookCellStatusBarItemProvider(P,a,f){const v=b._notebookStatusBarItemProviderHandlePool++,t=typeof f.onDidChangeCellStatusBarItems=="function"?b._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(v,f),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(v,t,a);let r;return t!==void 0&&(r=f.onDidChangeCellStatusBarItems(s=>this._notebookProxy.$emitCellStatusBarEvent(t))),new d.Disposable(()=>{this._notebookStatusBarItemProviders.delete(v),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(v,t),r&&r.dispose()})}async createNotebookDocument(P){const a=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:P.viewType,content:P.content&&l.NotebookData.from(P.content)});return k.URI.revive(a)}async openNotebookDocument(P){const a=this._documents.get(P);if(a)return a.apiNotebook;const f=await this._notebookDocumentsProxy.$tryOpenNotebook(P),v=this._documents.get(k.URI.revive(f));return(0,_.assertIsDefined)(v?.apiNotebook)}async showNotebookDocument(P,a){k.URI.isUri(P)&&(P=await this.openNotebookDocument(P));let f;typeof a=="object"?f={position:l.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selections:a.selections&&a.selections.map(l.NotebookRange.from),pinned:typeof a.preview=="boolean"?!a.preview:void 0}:f={preserveFocus:!1};const v=await this._notebookEditorsProxy.$tryShowNotebookDocument(P.uri,P.notebookType,f),t=v&&this._editors.get(v)?.apiEditor;if(t)return t;throw v?new Error(`Could NOT open editor for "${P.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${P.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(P,a,f,v){const t=this._notebookStatusBarItemProviders.get(P),r=k.URI.revive(a),s=this._documents.get(r);if(!s||!t)return;const i=s.getCellFromIndex(f);if(!i)return;const c=await t.provideCellStatusBarItems(i.apiCell,v);if(!c)return;const h=new E.DisposableStore,p=this._statusBarCache.add([h]),T=(Array.isArray(c)?c:[c]).map(o=>l.NotebookStatusBarItem.from(o,this._commandsConverter,h));return{cacheId:p,items:T}}$releaseNotebookCellStatusBarItems(P){this._statusBarCache.delete(P)}registerNotebookSerializer(P,a,f,v,t){if((0,y.isFalsyOrWhitespace)(a))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,f),this._notebookProxy.$registerNotebookSerializer(r,{id:P.identifier,location:P.extensionLocation},a,l.NotebookDocumentContentOptions.from(v),b._convertNotebookRegistrationData(P,t)),(0,E.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(P,a,f){const v=this._notebookSerializer.get(P);if(!v)throw new Error("NO serializer found");const t=await v.deserializeNotebook(a.buffer,f);return l.NotebookData.from(t)}async $notebookToData(P,a,f){const v=this._notebookSerializer.get(P);if(!v)throw new Error("NO serializer found");const t=await v.serializeNotebook(l.NotebookData.to(a),f);return g.VSBuffer.wrap(t)}async $openNotebook(P,a,f,v,t){const{provider:r}=this._getProviderData(P),s=await r.openNotebook(k.URI.revive(a),{backupId:f,untitledDocumentData:v?.buffer},t);return{metadata:s.metadata??Object.create(null),cells:s.cells.map(l.NotebookCellData.from)}}async $saveNotebook(P,a,f){const v=this.getNotebookDocument(k.URI.revive(a)),{provider:t}=this._getProviderData(P);return await t.saveNotebook(v.apiNotebook,f),!0}async $saveNotebookAs(P,a,f,v){const t=this.getNotebookDocument(k.URI.revive(a)),{provider:r}=this._getProviderData(P);return await r.saveNotebookAs(k.URI.revive(f),t.apiNotebook,v),!0}async $backupNotebook(P,a,f){const v=this.getNotebookDocument(k.URI.revive(a)),t=this._getProviderData(P),r=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension),s=String((0,S.hash)([v.uri.toString(),this._backupIdPool++])),i=k.URI.joinPath(r,s),c=await t.provider.backupNotebook(v.apiNotebook,{destination:i},f);return v.updateBackup(c),c.id}_createExtHostEditor(P,a,f){if(this._editors.has(a))throw new Error(`editor with id ALREADY EXSIST: ${a}`);const v=new m.ExtHostNotebookEditor(a,this._notebookEditorsProxy,P,f.visibleRanges.map(l.NotebookRange.to),f.selections.map(l.NotebookRange.to),typeof f.viewColumn=="number"?l.ViewColumn.to(f.viewColumn):void 0);this._editors.set(a,v)}$acceptDocumentAndEditorsDelta(P){if(P.removedDocuments)for(const f of P.removedDocuments){const v=k.URI.revive(f),t=this._documents.get(v);t&&(t.dispose(),this._documents.delete(v),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:t.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(t.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===v.toString()&&this._editors.delete(r.id)}if(P.addedDocuments){const f=[];for(const v of P.addedDocuments){const t=k.URI.revive(v.uri);if(this._documents.has(t))throw new Error(`adding EXISTING notebook ${t} `);const r=this,s=new u.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(i){r._onDidChangeNotebookCells.fire(i)},emitCellOutputsChange(i){r._onDidChangeCellOutputs.fire(i)},emitCellMetadataChange(i){r._onDidChangeCellMetadata.fire(i)},emitCellExecutionStateChange(i){r._onDidChangeCellExecutionState.fire(i)}},t,v);f.push(...v.cells.map(i=>u.ExtHostCell.asModelAddData(s.apiNotebook,i))),this._documents.get(t)?.dispose(),this._documents.set(t,s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:f}),this._onDidOpenNotebookDocument.fire(s.apiNotebook)}}if(P.addedEditors)for(const f of P.addedEditors){if(this._editors.has(f.id))return;const v=k.URI.revive(f.documentUri),t=this._documents.get(v);t&&this._createExtHostEditor(t,f.id,f)}const a=[];if(P.removedEditors)for(const f of P.removedEditors){const v=this._editors.get(f);v&&(this._editors.delete(f),this._activeNotebookEditor?.id===v.id&&(this._activeNotebookEditor=void 0),a.push(v))}if(P.visibleEditors){this._visibleNotebookEditors=P.visibleEditors.map(v=>this._editors.get(v)).filter(v=>!!v);const f=new Set;this._visibleNotebookEditors.forEach(v=>f.add(v.id));for(const v of this._editors.values()){const t=f.has(v.id);v._acceptVisibility(t)}this._visibleNotebookEditors=[...this._editors.values()].map(v=>v).filter(v=>v.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}P.newActiveEditor===null?this._activeNotebookEditor=void 0:P.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(P.newActiveEditor)),P.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=b,b._notebookStatusBarItemProviderHandlePool=0}),define(be[204],Ee([0,1,3,53,15,5,13,9]),function(ee,e,g,F,S,E,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class _{constructor(I,l){const d=_._Keys.nextId();I.$registerNotebookEditorDecorationType(d,y.NotebookDecorationRenderOptions.from(l)),this.value={key:d,dispose(){I.$removeNotebookEditorDecorationType(d)}}}}_._Keys=new F.IdGenerator("NotebookEditorDecorationType");let k=class{constructor(I,l,d){this._logService=I,this._extHostRpc=l,this._notebooksAndEditors=d,this._onDidChangeNotebookEditorSelection=new g.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new g.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(I){return new _(this._extHostRpc.getProxy(E.MainContext.MainThreadNotebookEditors),I).value}$acceptEditorPropertiesChanged(I,l){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,l);const d=this._notebooksAndEditors.getEditorById(I);l.visibleRanges&&d._acceptVisibleRanges(l.visibleRanges.ranges.map(y.NotebookRange.to)),l.selections&&d._acceptSelections(l.selections.selections.map(y.NotebookRange.to)),l.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:d.apiEditor,visibleRanges:d.apiEditor.visibleRanges}),l.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:d.apiEditor,selections:d.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const l in I)this._notebooksAndEditors.getEditorById(l)._acceptViewColumn(y.ViewColumn.to(I[l]))}};k=ze([qe(0,S.ILogService),qe(1,C.IExtHostRpcService)],k),e.ExtHostNotebookEditors=k}),define(be[205],Ee([0,1,3,6,5,26,2,9,70,21,16,71,20,17,15,7,30]),function(ee,e,g,F,S,E,C,y,_,k,n,I,l,d,u,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let w=class{constructor(t,r,s,i){this._initData=r,this._extHostNotebook=s,this._logService=i,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(S.MainContext.MainThreadNotebookKernels)}createNotebookController(t,r,s,i,c,h){for(let x of this._kernelData.values())if(x.controller.id===r&&E.ExtensionIdentifier.equals(t.identifier,x.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const p=this._handlePool++,D=this;this._logService.trace(`NotebookController[${p}], CREATED by ${t.identifier.value}, ${r}`);const T=()=>console.warn(`NO execute handler from notebook controller '${oe.id}' of extension: '${t.identifier}'`);let o=!1;const A=new F.DisposableStore,L=new g.Emitter,$=new g.Emitter,oe={id:`${t.identifier.value}/${r}`,notebookType:s,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:i||t.identifier.value,preloads:h?h.map(y.NotebookRendererScript.from):[]};let he=c??T,Q;this._proxy.$addKernel(p,oe).catch(x=>{console.log(x),o=!0});let z=0;const V=()=>{if(o)return;const x=++z;Promise.resolve().then(()=>{x===z&&this._proxy.$updateKernel(p,oe)})},R=new k.ResourceMap,G={get id(){return r},get notebookType(){return oe.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return oe.label},set label(x){oe.label=x??t.displayName??t.name,V()},get detail(){return oe.detail??""},set detail(x){oe.detail=x,V()},get description(){return oe.description??""},set description(x){oe.description=x,V()},get supportedLanguages(){return oe.supportedLanguages},set supportedLanguages(x){oe.supportedLanguages=x,V()},get supportsExecutionOrder(){return oe.supportsExecutionOrder??!1},set supportsExecutionOrder(x){oe.supportsExecutionOrder=x,V()},get rendererScripts(){return oe.preloads?oe.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return he},set executeHandler(x){he=x??T},get interruptHandler(){return Q},set interruptHandler(x){Q=x,oe.supportsInterrupt=Boolean(x),V()},createNotebookCellExecution(x){if(o)throw new Error("notebook controller is DISPOSED");if(!R.has(x.notebook.uri))throw D._logService.trace(`NotebookController[${p}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(R.keys()).map(j=>j.toString())),new Error(`notebook controller is NOT associated to notebook: ${x.notebook.uri.toString()}`);return D._createNotebookCellExecution(x)},dispose:()=>{o||(this._logService.trace(`NotebookController[${p}], DISPOSED`),o=!0,this._kernelData.delete(p),A.dispose(),L.dispose(),$.dispose(),this._proxy.$removeKernel(p))},updateNotebookAffinity(x,j){D._proxy.$updateNotebookPriority(p,x.uri,j)},onDidReceiveMessage:$.event,postMessage(x,j){return(0,b.checkProposedApiEnabled)(t),D._proxy.$postMessage(p,j&&D._extHostNotebook.getIdByEditor(j),x)},asWebviewUri(x){return(0,b.checkProposedApiEnabled)(t),(0,_.asWebviewUri)(x,D._initData.remote)}};return this._kernelData.set(p,{extensionId:t.identifier,controller:G,onDidReceiveMessage:$,onDidChangeSelection:L,associatedNotebooks:R}),G}$acceptNotebookAssociation(t,r,s){const i=this._kernelData.get(t);if(i){const c=this._extHostNotebook.getNotebookDocument(C.URI.revive(r));s?i.associatedNotebooks.set(c.uri,!0):i.associatedNotebooks.delete(c.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,c.uri.toString(),s),i.onDidChangeSelection.fire({selected:s,notebook:c.apiNotebook})}}async $executeCells(t,r,s){const i=this._kernelData.get(t);if(!i)return;const c=this._extHostNotebook.getNotebookDocument(C.URI.revive(r)),h=[];for(let p of s){const D=c.getCell(p);D&&h.push(D.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,c.uri.toString(),h.length),await i.controller.executeHandler.call(i.controller,h,c.apiNotebook,i.controller)}catch(p){this._logService.error(`NotebookController[${t}] execute cells FAILED`,p),console.error(p)}}async $cancelCells(t,r,s){const i=this._kernelData.get(t);if(!i)return;const c=this._extHostNotebook.getNotebookDocument(C.URI.revive(r));if(i.controller.interruptHandler)await i.controller.interruptHandler.call(i.controller,c.apiNotebook);else for(let h of s){const p=c.getCell(h);p&&this._activeExecutions.get(p.uri)?.cancel()}}$acceptKernelMessageFromRenderer(t,r,s){const i=this._kernelData.get(t);if(!i)return;const c=this._extHostNotebook.getEditorById(r);i.onDidReceiveMessage.fire(Object.freeze({editor:c.apiEditor,message:s}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const i=new a(s.notebook,s,this._proxy);this._activeExecutions.set(s.uri,i);const c=i.onDidChangeState(()=>{i.state===P.Resolved&&(i.dispose(),c.dispose(),this._activeExecutions.delete(s.uri))});return i.asApiObject()}};w=ze([qe(3,u.ILogService)],w),e.ExtHostNotebookKernels=w;var P;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(P||(P={}));class a extends F.Disposable{constructor(t,r,s){super();this._document=t,this._cell=r,this._proxy=s,this._onDidChangeState=new g.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=P.Init,this._tokenSource=this._register(new l.CancellationTokenSource),this._collector=new f(10,i=>this.applyEdits(i)),this._executionOrder=r.internalMetadata.executionOrder,this.mixinMetadata({runState:I.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyExecutionEdits(this._document.uri,t)}verifyStateForOutput(){if(this._state===P.Init)throw new Error("Must call start before modifying cell output");if(this._state===P.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){this.applyEdits([{editType:9,handle:this._cell.handle,internalMetadata:t}])}cellIndexToHandle(t){let r=this._cell;if(t&&(r=this._document.getCellFromApiCell(t)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(t){return t.map(r=>{const s=m.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return s===r.items?y.NotebookCellOutput.from(r):y.NotebookCellOutput.from({items:s,id:r.id,metadata:r.metadata})})}async updateOutputs(t,r,s){const i=this.cellIndexToHandle(r),c=this.validateAndConvertOutputs((0,d.asArray)(t));return this.applyEditSoon({editType:2,handle:i,append:s,outputs:c})}async updateOutputItems(t,r,s){return t=m.NotebookCellOutput.ensureUniqueMimeTypes((0,d.asArray)(t),!0),this.applyEditSoon({editType:7,items:t.map(y.NotebookCellOutputItem.from),outputId:r.id,append:s})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(s){t._executionOrder=s,t.mixinMetadata({executionOrder:s})},start(s){if(t._state===P.Resolved||t._state===P.Started)throw new Error("Cannot call start again");t._state=P.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:I.NotebookCellExecutionState.Executing,runStartTime:s??null})},end(s,i){if(t._state===P.Resolved)throw new Error("Cannot call resolve twice");t._state=P.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:s??null,runEndTime:i??null})},clearOutput(s){return t.verifyStateForOutput(),t.updateOutputs([],s,!1)},appendOutput(s,i){return t.verifyStateForOutput(),t.updateOutputs(s,i,!0)},replaceOutput(s,i){return t.verifyStateForOutput(),t.updateOutputs(s,i,!1)},appendOutputItems(s,i){return t.verifyStateForOutput(),t.updateOutputItems(s,i,!0)},replaceOutputItems(s,i){return t.verifyStateForOutput(),t.updateOutputItems(s,i,!1)}})}}class f{constructor(t,r){this.delay=t,this.callback=r,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=(0,n.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const r=this.batch;return this.batch=[],this.callback(r)})),this.waitPromise}}}),define(be[206],Ee([0,1,3,5,101]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class E{constructor(y,_){this._extHostNotebook=_,this._rendererMessageEmitters=new Map,this.proxy=y.getProxy(F.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(y,_,k){const n=this._extHostNotebook.getEditorById(y);this._rendererMessageEmitters.get(_)?.fire({editor:n.apiEditor,message:k})}createRendererMessaging(y,_){const k=new WeakMap;return{onDidReceiveMessage:(I,l,d)=>{const u=y?I:m=>{const b={};k.set(b,m.editor),I({editor:b,message:m.message})};return this.getOrCreateEmitterFor(_).event(u,l,d)},postMessage:(I,l)=>{const d=y?I:k.get(I),u=d&&S.ExtHostNotebookEditor.apiEditorsToExtHost.get(d);if(!u)throw new Error("The first argument to postMessage() must be a NotebookEditor");this.proxy.$postMessage(u.id,_,l)}}}getOrCreateEmitterFor(y){let _=this._rendererMessageEmitters.get(y);return _||(_=new g.Emitter({onLastListenerRemove:()=>{_?.dispose(),this._rendererMessageEmitters.delete(y)}}),this._rendererMessageEmitters.set(y,_),_)}}e.ExtHostNotebookRenderers=E}),define(be[105],Ee([0,1,5,3,6,24,4,13]),function(ee,e,g,F,S,E,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class _ extends S.Disposable{constructor(u,m,b,w,P){super();this._onDidAppend=this._register(new F.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=u,this._proxy=P,this._id=P.$register(this.name,m,b,w),this._disposed=!1,this._offset=0}get name(){return this._name}append(u){this.validate(),this._offset+=u?E.VSBuffer.fromString(u).byteLength:0}update(){this._id.then(u=>this._proxy.$update(u))}appendLine(u){this.validate(),this.append(u+`
`)}clear(){this.validate();const u=this._offset;this._id.then(m=>this._proxy.$clear(m,u))}show(u,m){this.validate(),this._id.then(b=>this._proxy.$reveal(b,!!(typeof u=="boolean"?u:m)))}hide(){this.validate(),this._id.then(u=>this._proxy.$close(u))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(u=>this._proxy.$dispose(u)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=_;class k extends _{constructor(u,m,b){super(u,!1,void 0,m,b)}append(u){super.append(u),this._id.then(m=>this._proxy.$append(m,u)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=k;class n extends _{constructor(u,m,b){super(u,!0,m,void 0,b)}append(u){throw new Error("Not supported")}}class I{constructor(u,m){this.name=u,this._channel=m}append(u){this._channel.then(m=>m.append(u))}appendLine(u){this._channel.then(m=>m.appendLine(u))}clear(){this._channel.then(u=>u.clear())}show(u,m){this._channel.then(b=>b.show(u,m))}hide(){this._channel.then(u=>u.hide())}dispose(){this._channel.then(u=>u.dispose())}}e.LazyOutputChannel=I;let l=class{constructor(u){this._proxy=u.getProxy(g.MainContext.MainThreadOutputService)}$setVisibleChannel(u){}createOutputChannel(u,m){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");return new k(u,m.identifier.value,this._proxy)}createOutputChannelFromLogFile(u,m){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");if(!m)throw new Error("illegal argument `file`. must not be falsy");return new n(u,m,this._proxy)}};l=ze([qe(0,y.IExtHostRpcService)],l),e.ExtHostOutputService=l,e.IExtHostOutputService=(0,C.createDecorator)("IExtHostOutputService")}),define(be[207],Ee([0,1,16,20,3,6,5,2,7,12,17,43]),function(ee,e,g,F,S,E,C,y,_,k,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function l(d,u,m){const b=d.getProxy(C.MainContext.MainThreadQuickOpen);class w{constructor(i,c){this._sessions=new Map,this._instances=0,this._workspace=i,this._commands=c}showQuickPick(i,c,h,p=F.CancellationToken.None){this._onDidSelectItem=void 0;const D=Promise.resolve(i),T=++this._instances,o=b.$show(T,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},p),A={},L=o.then(()=>A);return Promise.race([L,D]).then($=>{if($!==A)return D.then(oe=>{const he=[];for(let Q=0;Q<oe.length;Q++){const z=oe[Q];let V,R,G,x,j;typeof z=="string"?V=z:(V=z.label,R=z.description,G=z.detail,x=z.picked,j=z.alwaysShow),he.push({label:V,description:R,handle:Q,detail:G,picked:x,alwaysShow:j})}return h&&typeof h.onDidSelectItem=="function"&&(this._onDidSelectItem=Q=>{h.onDidSelectItem(oe[Q])}),b.$setItems(T,he),o.then(Q=>{if(typeof Q=="number")return oe[Q];if(Array.isArray(Q))return Q.map(z=>oe[z])})})}).then(void 0,$=>{if(!(0,k.isPromiseCanceledError)($))return b.$setError(T,$),Promise.reject($)})}$onItemSelected(i){this._onDidSelectItem&&this._onDidSelectItem(i)}showInput(i,c=F.CancellationToken.None){return this._validateInput=i?i.validateInput:void 0,b.$input(i,typeof this._validateInput=="function",c).then(void 0,h=>{if(!(0,k.isPromiseCanceledError)(h))return Promise.reject(h)})}$validateInput(i){return this._validateInput?(0,g.asPromise)(()=>this._validateInput(i)):Promise.resolve(void 0)}async showWorkspaceFolderPick(i,c=F.CancellationToken.None){const h=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!h)return;const p=await this._workspace.getWorkspaceFolders2();if(!!p)return p.find(D=>D.uri.toString()===h.uri.toString())}createQuickPick(i,c){const h=new t(i,c,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}createInputBox(i){const c=new r(i,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}$onDidChangeValue(i,c){const h=this._sessions.get(i);h&&h._fireDidChangeValue(c)}$onDidAccept(i){const c=this._sessions.get(i);c&&c._fireDidAccept()}$onDidChangeActive(i,c){const h=this._sessions.get(i);h instanceof t&&h._fireDidChangeActive(c)}$onDidChangeSelection(i,c){const h=this._sessions.get(i);h instanceof t&&h._fireDidChangeSelection(c)}$onDidTriggerButton(i,c){const h=this._sessions.get(i);h&&h._fireDidTriggerButton(c)}$onDidHide(i){const c=this._sessions.get(i);c&&c._fireDidHide()}}class P{constructor(i,c){this._extensionId=i,this._onDidDispose=c,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new S.Emitter,this._onDidChangeValueEmitter=new S.Emitter,this._onDidTriggerButtonEmitter=new S.Emitter,this._onDidHideEmitter=new S.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(i){this._title=i,this.update({title:i})}get step(){return this._steps}set step(i){this._steps=i,this.update({step:i})}get totalSteps(){return this._totalSteps}set totalSteps(i){this._totalSteps=i,this.update({totalSteps:i})}get enabled(){return this._enabled}set enabled(i){this._enabled=i,this.update({enabled:i})}get busy(){return this._busy}set busy(i){this._busy=i,this.update({busy:i})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(i){this._ignoreFocusOut=i,this.update({ignoreFocusOut:i})}get value(){return this._value}set value(i){this._value=i,this.update({value:i})}get placeholder(){return this._placeholder}set placeholder(i){this._placeholder=i,this.update({placeholder:i})}get buttons(){return this._buttons}set buttons(i){this._buttons=i.slice(),this._handlesToButtons.clear(),i.forEach((c,h)=>{const p=c===_.QuickInputButtons.Back?-1:h;this._handlesToButtons.set(p,c)}),this.update({buttons:i.map((c,h)=>({iconPath:a(c.iconPath),tooltip:c.tooltip,handle:c===_.QuickInputButtons.Back?-1:h}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(i){this._value=i,this._onDidChangeValueEmitter.fire(i)}_fireDidTriggerButton(i){const c=this._handlesToButtons.get(i);c&&this._onDidTriggerButtonEmitter.fire(c)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,E.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),b.$dispose(this._id))}update(i){if(!this._disposed){for(const c of Object.keys(i)){const h=i[c];this._pendingUpdate[c]=h===void 0?null:h}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){b.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}P._nextId=1;function a(s){if(s instanceof _.ThemeIcon)return{id:s.id};const i=v(s),c=f(s);return{dark:typeof i=="string"?y.URI.file(i):i,light:typeof c=="string"?y.URI.file(c):c}}function f(s){return typeof s=="object"&&"light"in s?s.light:s}function v(s){return typeof s=="object"&&"dark"in s?s.dark:s}class t extends P{constructor(i,c,h){super(i,h);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new S.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new S.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(i){this._items=i.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),i.forEach((c,h)=>{this._handlesToItems.set(h,c),this._itemsToHandles.set(c,h)}),this.update({items:i.map((c,h)=>({label:c.label,description:c.description,handle:h,detail:c.detail,picked:c.picked,alwaysShow:c.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(i){this._canSelectMany=i,this.update({canSelectMany:i})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(i){this._matchOnDescription=i,this.update({matchOnDescription:i})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(i){this._matchOnDetail=i,this.update({matchOnDetail:i})}get sortByLabel(){return this._sortByLabel}set sortByLabel(i){this._sortByLabel=i,this.update({sortByLabel:i})}get activeItems(){return this._activeItems}set activeItems(i){this._activeItems=i.filter(c=>this._itemsToHandles.has(c)),this.update({activeItems:this._activeItems.map(c=>this._itemsToHandles.get(c))})}get selectedItems(){return this._selectedItems}set selectedItems(i){this._selectedItems=i.filter(c=>this._itemsToHandles.has(c)),this.update({selectedItems:this._selectedItems.map(c=>this._itemsToHandles.get(c))})}_fireDidChangeActive(i){const c=(0,n.coalesce)(i.map(h=>this._handlesToItems.get(h)));this._activeItems=c,this._onDidChangeActiveEmitter.fire(c)}_fireDidChangeSelection(i){const c=(0,n.coalesce)(i.map(h=>this._handlesToItems.get(h)));this._selectedItems=c,this._onDidChangeSelectionEmitter.fire(c)}}class r extends P{constructor(i,c){super(i,c);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(i){this._password=i,this.update({password:i})}get prompt(){return this._prompt}set prompt(i){this._prompt=i,this.update({prompt:i})}get validationMessage(){return this._validationMessage}set validationMessage(i){this._validationMessage=i,this.update({validationMessage:i,severity:i?I.default.Error:I.default.Ignore})}}return new w(u,m)}e.createExtHostQuickOpen=l}),define(be[208],Ee([0,1,2,3,51,6,16,5,17,116,15,26,30,64]),function(ee,e,g,F,S,E,C,y,_,k,n,I,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function u(c){if(c)return typeof c.iconPath=="string"?g.URI.file(c.iconPath):g.URI.isUri(c.iconPath)||d.ThemeIcon.isThemeIcon(c.iconPath)?c.iconPath:void 0}function m(c,h){if(!c.iconPath&&!h.iconPath)return 0;if(c.iconPath){if(!h.iconPath)return 1}else return-1;const p=typeof c.iconPath=="string"?c.iconPath:g.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id,D=typeof h.iconPath=="string"?h.iconPath:g.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,k.comparePaths)(p,D)}function b(c,h){let p=0;if(c.strikeThrough!==h.strikeThrough)return c.strikeThrough?1:-1;if(c.faded!==h.faded)return c.faded?1:-1;if(c.tooltip!==h.tooltip)return(c.tooltip||"").localeCompare(h.tooltip||"");if(p=m(c,h),p!==0)return p;if(c.light&&h.light)p=m(c.light,h.light);else{if(c.light)return 1;if(h.light)return-1}if(p!==0)return p;if(c.dark&&h.dark)p=m(c.dark,h.dark);else{if(c.dark)return 1;if(h.dark)return-1}return p}function w(c,h){if(c.command!==h.command)return c.command<h.command?-1:1;if(c.title!==h.title)return c.title<h.title?-1:1;if(c.tooltip!==h.tooltip){if(c.tooltip!==void 0&&h.tooltip!==void 0)return c.tooltip<h.tooltip?-1:1;if(c.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(c.arguments===h.arguments)return 0;if(c.arguments)if(h.arguments){if(c.arguments.length!==h.arguments.length)return c.arguments.length-h.arguments.length}else return 1;else return-1;for(let p=0;p<c.arguments.length;p++){const D=c.arguments[p],T=h.arguments[p];if(D!==T)return D<T?-1:1}return 0}function P(c,h){let p=(0,k.comparePaths)(c.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(p!==0)return p;if(c.command&&h.command)p=w(c.command,h.command);else{if(c.command)return 1;if(h.command)return-1}if(p!==0)return p;if(c.decorations&&h.decorations)p=b(c.decorations,h.decorations);else{if(c.decorations)return 1;if(h.decorations)return-1}return p}function a(c,h){for(let p=0;p<c.length;p++)if(c[p]!==h[p])return!1;return!0}function f(c,h){return c.command===h.command&&c.title===h.title&&c.tooltip===h.tooltip&&(c.arguments&&h.arguments?a(c.arguments,h.arguments):c.arguments===h.arguments)}function v(c,h){return(0,_.equals)(c,h,f)}class t{constructor(h,p,D){this._extension=h,this._proxy=p,this._sourceControlHandle=D,this._value="",this._onDidChange=new F.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(h){this._proxy.$setInputBoxValue(this._sourceControlHandle,h),this.updateValue(h)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(h){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,h),this._placeholder=h}get validateInput(){return(0,l.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(h){if((0,l.checkProposedApiEnabled)(this._extension),h&&typeof h!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=h,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!h)}get visible(){return this._visible}set visible(h){h=!!h,this._visible!==h&&(this._visible=h,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,h))}focus(){(0,l.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(h,p){(0,l.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,h,p)}$onInputBoxValueChange(h){this.updateValue(h)}updateValue(h){this._value=h,this._onDidChange.fire(h)}}e.ExtHostSCMInputBox=t;class r{constructor(h,p,D,T,o){this._proxy=h,this._commands=p,this._sourceControlHandle=D,this._id=T,this._label=o,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new F.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(h){this._label=h,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,h)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(h){this._hideWhenEmpty=h,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(h){this._resourceStates=[...h],this._onDidUpdateResourceStates.fire()}getResourceState(h){return this._resourceStatesMap.get(h)}$executeResourceCommand(h,p){const D=this._resourceStatesCommandsMap.get(h);return D?(0,C.asPromise)(()=>this._commands.executeCommand(D.command,...D.arguments||[],p)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this._resourceStates].sort(P),D=(0,_.sortedDiff)(this._resourceSnapshot,h,P).map(A=>{const L=A.toInsert.map($=>{const oe=this._resourceHandlePool++;this._resourceStatesMap.set(oe,$);const he=$.resourceUri;let Q;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const ue=new E.DisposableStore;Q=this._commands.converter.toInternal($.command,ue),this._resourceStatesDisposablesMap.set(oe,ue)}else this._resourceStatesCommandsMap.set(oe,$.command);const z=u($.decorations),V=$.decorations&&u($.decorations.light)||z,R=$.decorations&&u($.decorations.dark)||z,G=[V,R],x=$.decorations&&$.decorations.tooltip||"",j=$.decorations&&!!$.decorations.strikeThrough,de=$.decorations&&!!$.decorations.faded,B=$.contextValue||"";return{rawResource:[oe,he,G,x,j,de,B,Q],handle:oe}});return{start:A.start,deleteCount:A.deleteCount,toInsert:L}}),T=D.map(({start:A,deleteCount:L,toInsert:$})=>[A,L,$.map(oe=>oe.rawResource)]),o=D.reverse();for(const{start:A,deleteCount:L,toInsert:$}of o){const oe=$.map(Q=>Q.handle),he=this._handlesSnapshot.splice(A,L,...oe);for(const Q of he)this._resourceStatesMap.delete(Q),this._resourceStatesCommandsMap.delete(Q),this._resourceStatesDisposablesMap.get(Q)?.dispose(),this._resourceStatesDisposablesMap.delete(Q)}return this._resourceSnapshot=h,T}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class s{constructor(h,p,D,T,o,A){this._proxy=p,this._commands=D,this._id=T,this._label=o,this._rootUri=A,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new E.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new E.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new F.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=s._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new t(h,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,T,o,A)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(h){this._count!==h&&(this._count=h,this._proxy.$updateSourceControl(this.handle,{count:h}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(h){this._quickDiffProvider=h,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!h})}get commitTemplate(){return this._commitTemplate}set commitTemplate(h){h!==this._commitTemplate&&(this._commitTemplate=h,this._proxy.$updateSourceControl(this.handle,{commitTemplate:h}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(h){this._acceptInputDisposables.value=new E.DisposableStore,this._acceptInputCommand=h;const p=this._commands.converter.toInternal(h,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:p})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(h){if(this._statusBarCommands&&h&&v(this._statusBarCommands,h))return;this._statusBarDisposables.value=new E.DisposableStore,this._statusBarCommands=h;const p=(h||[]).map(D=>this._commands.converter.toInternal(D,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:p})}get selected(){return this._selected}createResourceGroup(h,p){const D=new r(this._proxy,this._commands,this.handle,h,p),T=F.Event.once(D.onDidDispose)(()=>this.createdResourceGroups.delete(D));return this.createdResourceGroups.set(D,T),this.eventuallyAddResourceGroups(),D}eventuallyAddResourceGroups(){const h=[],p=[];for(const[D,T]of this.createdResourceGroups){T.dispose();const o=D.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(D),this.eventuallyUpdateResourceStates()});F.Event.once(D.onDidDispose)(()=>{this.updatedResourceGroups.delete(D),o.dispose(),this._groups.delete(D.handle),this._proxy.$unregisterGroup(this.handle,D.handle)}),h.push([D.handle,D.id,D.label,D.features]);const A=D._takeResourceStateSnapshot();A.length>0&&p.push([D.handle,A]),this._groups.set(D.handle,D)}this._proxy.$registerGroups(this.handle,h,p),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const h=[];this.updatedResourceGroups.forEach(p=>{const D=p._takeResourceStateSnapshot();D.length!==0&&h.push([p.handle,D])}),h.length>0&&this._proxy.$spliceResourceStates(this.handle,h),this.updatedResourceGroups.clear()}getResourceGroup(h){return this._groups.get(h)}setSelectionState(h){this._selected=h,this._onDidChangeSelection.fire(h)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(h=>h.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}s._handlePool=0,ze([(0,S.debounce)(100)],s.prototype,"eventuallyAddResourceGroups",null),ze([(0,S.debounce)(100)],s.prototype,"eventuallyUpdateResourceStates",null);let i=class Un{constructor(h,p,D){this._commands=p,this.logService=D,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new F.Emitter,this._proxy=h.getProxy(y.MainContext.MainThreadSCM),this._telemetry=h.getProxy(y.MainContext.MainThreadTelemetry),p.registerArgumentProcessor({processArgument:T=>{if(T&&T.$mid===3){const o=this._sourceControls.get(T.sourceControlHandle);if(!o)return T;const A=o.getResourceGroup(T.groupHandle);return A?A.getResourceState(T.handle):T}else if(T&&T.$mid===4){const o=this._sourceControls.get(T.sourceControlHandle);return o?o.getResourceGroup(T.groupHandle):T}else if(T&&T.$mid===5){const o=this._sourceControls.get(T.handle);return o||T}return T}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(h,p,D,T){this.logService.trace("ExtHostSCM#createSourceControl",h.identifier.value,p,D,T),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const o=Un._handlePool++,A=new s(h,this._proxy,this._commands,p,D,T);this._sourceControls.set(o,A);const L=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(h.identifier))||[];return L.push(A),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(h.identifier),L),A}getLastInputBox(h){this.logService.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const p=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(h.identifier)),D=p&&p[p.length-1];return D&&D.inputBox}$provideOriginalResource(h,p,D){const T=g.URI.revive(p);this.logService.trace("ExtHostSCM#$provideOriginalResource",h,T.toString());const o=this._sourceControls.get(h);return!o||!o.quickDiffProvider||!o.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,C.asPromise)(()=>o.quickDiffProvider.provideOriginalResource(T,D)).then(A=>A||null)}$onInputBoxValueChange(h,p){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",h);const D=this._sourceControls.get(h);return D&&D.inputBox.$onInputBoxValueChange(p),Promise.resolve(void 0)}$executeResourceCommand(h,p,D,T){this.logService.trace("ExtHostSCM#$executeResourceCommand",h,p,D);const o=this._sourceControls.get(h);if(!o)return Promise.resolve(void 0);const A=o.getResourceGroup(p);return A?A.$executeResourceCommand(D,T):Promise.resolve(void 0)}$validateInput(h,p,D){this.logService.trace("ExtHostSCM#$validateInput",h);const T=this._sourceControls.get(h);return!T||!T.inputBox.validateInput?Promise.resolve(void 0):(0,C.asPromise)(()=>T.inputBox.validateInput(p,D)).then(o=>o?Promise.resolve([o.message,o.type]):Promise.resolve(void 0))}$setSelectedSourceControl(h){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this._sourceControls.get(h)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=h,Promise.resolve(void 0)}};i._handlePool=0,i=ze([qe(2,n.ILogService)],i),e.ExtHostSCM=i});var nt=this&&this.__classPrivateFieldSet||function(ee,e,g,F,S){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Ue=this&&this.__classPrivateFieldGet||function(ee,e,g,F){if(g==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?F:g==="a"?F.call(ee):F?F.value:e.get(ee)};define(be[209],Ee([0,1,7,5,136,6,9]),function(ee,e,g,F,S,E,C){"use strict";var y,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class k{constructor(d,u,m,b,w=g.StatusBarAlignment.Left,P){y.set(this,void 0),_.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new E.DisposableStore,nt(this,y,d,"f"),nt(this,_,u,"f"),this._entryId=k.ID_GEN++,this._extension=m,this._id=b,this._alignment=w,this._priority=P}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(d){this._text=d,this.update()}set name(d){this._name=d,this.update()}set tooltip(d){this._tooltip=d,this.update()}set color(d){this._color=d,this.update()}set backgroundColor(d){d&&!k.ALLOWED_BACKGROUND_COLORS.has(d.id)&&(d=void 0),this._backgroundColor=d,this.update()}set command(d){this._command?.fromApi!==d&&(this._internalCommandRegistration.clear(),typeof d=="string"?this._command={fromApi:d,internal:Ue(this,_,"f").toInternal({title:"",command:d},this._internalCommandRegistration)}:d?this._command={fromApi:d,internal:Ue(this,_,"f").toInternal(d,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(d){this._accessibilityInformation=d,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let d;this._extension?this._id?d=`${this._extension.identifier.value}.${this._id}`:d=this._extension.identifier.value:d=this._id;let u;this._name?u=this._name:u=(0,S.localize)(0,null,this._extension.displayName||this._extension.name);let m=this._color;this._backgroundColor&&(m=k.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const b=this._tooltip?C.MarkdownString.fromStrict(this._tooltip):void 0;Ue(this,y,"f").$setEntry(this._entryId,d,u,this._text,b,this._command?.internal,m,this._backgroundColor,this._alignment===g.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=k,y=new WeakMap,_=new WeakMap,k.ID_GEN=0,k.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new g.ThemeColor("statusBarItem.errorForeground")]]);class n{constructor(d){this._messages=[],this._item=d.createStatusBarEntry(void 0,"status.extensionMessage",g.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,S.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(d){const u={message:d};return this._messages.unshift(u),this._update(),new g.Disposable(()=>{const m=this._messages.indexOf(u);m>=0&&(this._messages.splice(m,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class I{constructor(d,u){this._proxy=d.getProxy(F.MainContext.MainThreadStatusBar),this._commands=u,this._statusMessage=new n(this)}createStatusBarEntry(d,u,m,b){return new k(this._proxy,this._commands,d,u,m,b)}setStatusBarMessage(d,u){const m=this._statusMessage.setMessage(d);let b;return typeof u=="number"?b=setTimeout(()=>m.dispose(),u):typeof u!="undefined"&&u.then(()=>m.dispose(),()=>m.dispose()),new g.Disposable(()=>{m.dispose(),clearTimeout(b)})}}e.ExtHostStatusBar=I}),define(be[77],Ee([0,1,5,3,4]),function(ee,e,g,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class E{constructor(y){this._onDidChangeStorage=new F.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=y.getProxy(g.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(y,_){this._proxy.$registerExtensionStorageKeysToSync(y,_)}getValue(y,_,k){return this._proxy.$getValue(y,_).then(n=>n||k)}setValue(y,_,k){return this._proxy.$setValue(y,_,k)}$acceptValue(y,_,k){this._onDidChangeStorage.fire({shared:y,key:_,value:k})}}e.ExtHostStorage=E,e.IExtHostStorage=(0,S.createDecorator)("IExtHostStorage")}),define(be[78],Ee([0,1,4,29,15,76,2]),function(ee,e,g,F,S,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,g.createDecorator)("IExtensionStoragePaths");let y=class{constructor(k,n,I){this._logService=n,this._extHostFileSystem=I,this._workspace=k.workspace??void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(l=>this._value=l)}async _getWorkspaceStorageURI(k){return C.URI.joinPath(this._environment.workspaceStorageHome,k)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const k=this._workspace.id,n=await this._getWorkspaceStorageURI(k);try{return await this._extHostFileSystem.value.stat(n),this._logService.trace("[ExtHostStorage] storage dir already exists",n),n}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",n),await this._extHostFileSystem.value.createDirectory(n),await this._extHostFileSystem.value.writeFile(C.URI.joinPath(n,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:C.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),n}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(k){if(this._value)return C.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return C.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};y=ze([qe(0,F.IExtHostInitDataService),qe(1,S.ILogService),qe(2,E.IExtHostConsumerFileSystem)],y),e.ExtensionStoragePaths=y}),define(be[38],Ee([0,1,3,5,4,2,13,6,7,137,12,175,20,36,158,64,10]),function(ee,e,g,F,S,E,C,y,_,k,n,I,l,d,u,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,S.createDecorator)("IExtHostTerminalService");class w{constructor(i,c,h,p){this._proxy=i,this._id=c,this._creationOptions=h,this._name=p,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(T=>this._pidPromiseComplete=T);const D=this;this.value={get name(){return D._name||""},get processId(){return D._pidPromise},get creationOptions(){return D._creationOptions},get exitStatus(){return D._exitStatus},sendText(T,o=!0){D._checkDisposed(),D._proxy.$sendText(D._id,T,o)},show(T){D._checkDisposed(),D._proxy.$show(D._id,T)},hide(){D._checkDisposed(),D._proxy.$hide(D._id)},dispose(){D._disposed||(D._disposed=!0,D._proxy.$dispose(D._id))},get dimensions(){if(!(D._cols===void 0||D._rows===void 0))return{columns:D._cols,rows:D._rows}}}}async create(i,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:i.name,shellPath:(0,b.withNullAsUndefined)(i.shellPath),shellArgs:(0,b.withNullAsUndefined)(i.shellArgs),cwd:(0,b.withNullAsUndefined)(i.cwd),env:(0,b.withNullAsUndefined)(i.env),icon:(0,b.withNullAsUndefined)(r(i.iconPath)),color:m.ThemeColor.isThemeColor(i.color)?i.color.id:void 0,initialText:(0,b.withNullAsUndefined)(i.message),strictEnv:(0,b.withNullAsUndefined)(i.strictEnv),hideFromUser:(0,b.withNullAsUndefined)(i.hideFromUser),isFeatureTerminal:(0,b.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,b.withNullAsUndefined)(c?.useShellEnvironment),isSplitTerminal:c?.isSplitTerminal,target:c?.target})}async createExtensionTerminal(i,c,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:h,isSplitTerminal:i,target:c}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(i){this._name=i}setExitCode(i){this._exitStatus=Object.freeze({code:i})}setDimensions(i,c){return i===this._cols&&c===this._rows||i===0||c===0?!1:(this._cols=i,this._rows=c,!0)}_setProcessId(i){this._pidPromiseComplete?(this._pidPromiseComplete(i),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==i&&(this._pidPromise=Promise.resolve(i))})}}e.ExtHostTerminal=w;class P{constructor(i){this._pty=i,this.id=0,this.shouldPersist=!1,this._onProcessData=new g.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new g.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new g.Emitter,this._onProcessTitleChanged=new g.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new g.Emitter,this._onProcessShellTypeChanged=new g.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(i){this._pty.handleInput&&this._pty.handleInput(i)}resize(i,c){this._pty.setDimensions&&this._pty.setDimensions({columns:i,rows:c})}async processBinary(i){}acknowledgeDataEvent(i){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(i){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose&&this._pty.onDidClose((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(c=>this._onProcessOverrideDimensions.fire(c&&{cols:c.columns,rows:c.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(c=>this._onProcessTitleChanged.fire(c)),this._pty.open(i||void 0),this._pty.setDimensions&&i&&this._pty.setDimensions(i),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=P;let a=1,f=class extends y.Disposable{constructor(i,c){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new g.Emitter,this._onDidOpenTerminal=new g.Emitter,this._onDidChangeActiveTerminal=new g.Emitter,this._onDidChangeTerminalDimensions=new g.Emitter,this._proxy=c.getProxy(F.MainContext.MainThreadTerminalService),this._bufferer=new u.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new g.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(i),this._register({dispose:()=>{for(const[h,p]of this._terminalProcesses)p.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(i=>i.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(i){return(i?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(i){return(i?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(i,c){const h=new w(this._proxy,(0,d.generateUuid)(),i,i.name),p=new P(i.pty);return h.createExtensionTerminal(c?.isSplitTerminal,c?.target,r(i.iconPath)).then(D=>{const T=this._setupExtHostProcessListeners(D,p);this._terminalProcessDisposables[D]=T}),this._terminals.push(h),h.value}attachPtyToTerminal(i,c){if(!this._getTerminalById(i))throw new Error(`Cannot resolve terminal with id ${i} for virtual process`);const p=new P(c),D=this._setupExtHostProcessListeners(i,p);this._terminalProcessDisposables[i]=D}async $acceptActiveTerminalChanged(i){const c=this._activeTerminal;if(i===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const h=this._getTerminalById(i);h&&(this._activeTerminal=h,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(i,c){const h=this._getTerminalById(i);h&&this._onDidWriteTerminalData.fire({terminal:h.value,data:c})}async $acceptTerminalDimensions(i,c,h){const p=this._getTerminalById(i);p&&p.setDimensions(c,h)&&this._onDidChangeTerminalDimensions.fire({terminal:p.value,dimensions:p.value.dimensions})}async $acceptTerminalMaximumDimensions(i,c,h){this._terminalProcesses.get(i)?.resize(c,h)}async $acceptTerminalTitleChange(i,c){const h=this._getTerminalById(i);h&&(h.name=c)}async $acceptTerminalClosed(i,c){const h=this._getTerminalObjectIndexById(this._terminals,i);if(h!==null){const p=this._terminals.splice(h,1)[0];p.setExitCode(c),this._onDidCloseTerminal.fire(p.value)}}$acceptTerminalOpened(i,c,h,p){if(c){const o=this._getTerminalObjectIndexById(this._terminals,c);if(o!==null){this._terminals[o]._id=i,this._onDidOpenTerminal.fire(this.terminals[o]),this._terminals[o].isOpen=!0;return}}const D={name:p.name,shellPath:p.executable,shellArgs:p.args,cwd:typeof p.cwd=="string"?p.cwd:E.URI.revive(p.cwd),env:p.env,hideFromUser:p.hideFromUser},T=new w(this._proxy,i,D,h);this._terminals.push(T),this._onDidOpenTerminal.fire(T.value),T.isOpen=!0}async $acceptTerminalProcessId(i,c){const h=this._getTerminalById(i);h&&h._setProcessId(c)}async $startExtensionTerminal(i,c){const h=this._getTerminalById(i);if(!h)return{message:(0,k.localize)(0,null,i)};h.isOpen||await new Promise(D=>{const T=this.onDidOpenTerminal(async o=>{o===h.value&&(T.dispose(),D())})});const p=this._terminalProcesses.get(i);p?p.startSendingEvents(c):this._extensionTerminalAwaitingStart[i]={initialDimensions:c}}_setupExtHostProcessListeners(i,c){const h=new y.DisposableStore;h.add(c.onProcessReady(D=>this._proxy.$sendProcessReady(i,D.pid,D.cwd))),h.add(c.onProcessTitleChanged(D=>this._proxy.$sendProcessTitle(i,D))),this._bufferer.startBuffering(i,c.onProcessData),h.add(c.onProcessExit(D=>this._onProcessExit(i,D))),c.onProcessOverrideDimensions&&h.add(c.onProcessOverrideDimensions(D=>this._proxy.$sendOverrideDimensions(i,D))),this._terminalProcesses.set(i,c);const p=this._extensionTerminalAwaitingStart[i];return p&&c instanceof P&&(c.startSendingEvents(p.initialDimensions),delete this._extensionTerminalAwaitingStart[i]),h}$acceptProcessAckDataEvent(i,c){this._terminalProcesses.get(i)?.acknowledgeDataEvent(c)}$acceptProcessInput(i,c){this._terminalProcesses.get(i)?.input(c)}$acceptProcessResize(i,c,h){try{this._terminalProcesses.get(i)?.resize(c,h)}catch(p){if(p.code!=="EPIPE"&&p.code!=="ERR_IPC_CHANNEL_CLOSED")throw p}}$acceptProcessShutdown(i,c){this._terminalProcesses.get(i)?.shutdown(c)}$acceptProcessRequestInitialCwd(i){this._terminalProcesses.get(i)?.getInitialCwd().then(c=>this._proxy.$sendProcessInitialCwd(i,c))}$acceptProcessRequestCwd(i){this._terminalProcesses.get(i)?.getCwd().then(c=>this._proxy.$sendProcessCwd(i,c))}$acceptProcessRequestLatency(i){return i}registerLinkProvider(i){return this._linkProviders.add(i),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(i),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(i,c,h){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,h),this._proxy.$registerProfileProvider(c,i.identifier.value),new _.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(i,c){const h=new l.CancellationTokenSource().token,p=await this._profileProviders.get(i)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(!p||!("options"in p))throw new Error(`No terminal profile options provided for id "${i}"`);if("pty"in p.options){this.createExtensionTerminal(p.options,c);return}this.createTerminalFromOptions(p.options,c)}}async $provideLinks(i,c){const h=this._getTerminalById(i);if(!h)return[];this._terminalLinkCache.delete(i);const p=this._terminalLinkCancellationSource.get(i);p&&p.dispose(!0);const D=new l.CancellationTokenSource;this._terminalLinkCancellationSource.set(i,D);const T=[],o={terminal:h.value,line:c},A=[];for(const oe of this._linkProviders)A.push(new Promise(async he=>{D.token.onCancellationRequested(()=>he({provider:oe,links:[]}));const Q=await oe.provideTerminalLinks(o,D.token)||[];D.token.isCancellationRequested||he({provider:oe,links:Q})}));const L=await Promise.all(A);if(D.token.isCancellationRequested)return[];const $=new Map;for(const oe of L)oe&&oe.links.length>0&&T.push(...oe.links.map(he=>{const Q={id:a++,startIndex:he.startIndex,length:he.length,label:he.tooltip};return $.set(Q.id,{provider:oe.provider,link:he}),Q}));return this._terminalLinkCache.set(i,$),T}$activateLink(i,c){const h=this._terminalLinkCache.get(i)?.get(c);!h||h.provider.handleTerminalLink(h.link)}_onProcessExit(i,c){this._bufferer.stopBuffering(i),this._terminalProcesses.delete(i),delete this._extensionTerminalAwaitingStart[i];const h=this._terminalProcessDisposables[i];h&&(h.dispose(),delete this._terminalProcessDisposables[i]),this._proxy.$sendProcessExit(i,c)}_getTerminalById(i){return this._getTerminalObjectById(this._terminals,i)}_getTerminalObjectById(i,c){const h=this._getTerminalObjectIndexById(i,c);return h!==null?i[h]:null}_getTerminalObjectIndexById(i,c){let h=null;return i.some((p,D)=>p._id===c?(h=D,!0):!1),h}getEnvironmentVariableCollection(i){let c=this._environmentVariableCollections.get(i.identifier.value);return c||(c=new v,this._setEnvironmentVariableCollection(i.identifier.value,c)),c}_syncEnvironmentVariableCollection(i,c){const h=(0,I.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(i,c.persistent,h.length===0?void 0:h)}$initEnvironmentVariableCollections(i){i.forEach(c=>{const h=c[0],p=new v(c[1]);this._setEnvironmentVariableCollection(h,p)})}$acceptDefaultProfile(i,c){this._defaultProfile=i,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(i,c){this._environmentVariableCollections.set(i,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(i,c)})}};f=ze([qe(1,C.IExtHostRpcService)],f),e.BaseExtHostTerminalService=f;class v{constructor(i){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new g.Emitter,this.map=new Map(i)}get persistent(){return this._persistent}set persistent(i){this._persistent=i,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(i,c){this._setIfDiffers(i,{value:c,type:_.EnvironmentVariableMutatorType.Replace})}append(i,c){this._setIfDiffers(i,{value:c,type:_.EnvironmentVariableMutatorType.Append})}prepend(i,c){this._setIfDiffers(i,{value:c,type:_.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(i,c){const h=this.map.get(i);(!h||h.value!==c.value||h.type!==c.type)&&(this.map.set(i,c),this._onDidChangeCollection.fire())}get(i){return this.map.get(i)}forEach(i,c){this.map.forEach((h,p)=>i.call(c,p,h,this))}delete(i){this.map.delete(i),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=v;let t=class extends f{constructor(i){super(!1,i)}createTerminal(i,c,h){throw new n.NotSupportedError}createTerminalFromOptions(i,c){throw new n.NotSupportedError}};t=ze([qe(0,C.IExtHostRpcService)],t),e.WorkerExtHostTerminalService=t;function r(s){if(!(!s||typeof s=="string"))return"id"in s?{id:s.id,color:s.color}:s}});var nt=this&&this.__classPrivateFieldSet||function(ee,e,g,F,S){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Ue=this&&this.__classPrivateFieldGet||function(ee,e,g,F){if(g==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?F:g==="a"?F.call(ee):F?F.value:e.get(ee)};define(be[210],Ee([0,1,24,20,3,52,42,54,6,23,10,36,5,13,67,9,7,183,99,72]),function(ee,e,g,F,S,E,C,y,_,k,n,I,l,d,u,m,b,w,P,a){"use strict";var f,v,t,r,s,i,c;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let h=class{constructor(R,G){this.resultsChangedEmitter=new S.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(l.MainContext.MainThreadTesting),this.observer=new he(this.proxy),this.runTracker=new D(this.proxy),G.registerArgumentProcessor({processArgument:x=>x?.$mid===13?m.TestItem.toItemFromContext(x):x})}createTestController(R,G){const x=new _.DisposableStore,j=x.add(new w.SingleUseTestCollection(R)),de=new Map,B=this.proxy,ne={items:j.root.children,get label(){return G},set label(ye){G=ye,j.root.label=ye,B.$updateControllerLabel(R,G)},get id(){return R},createRunProfile:(ye,Re,Te,$e)=>{let Je=(0,C.hash)(ye);for(;de.has(Je);)Je++;const Ve=new Q(this.proxy,R,Je,ye,Re,Te,$e);return de.set(Je,Ve),Ve},createTestRun:(ye,Re,Te=!0)=>this.runTracker.createTestRun(R,j,ye,Re,Te),set resolveChildrenHandler(ye){j.resolveHandler=ye},get resolveChildrenHandler(){return j.resolveHandler},dispose:()=>{x.dispose()}};ne.createRunConfiguration=ne.createRunProfile,B.$registerTestController(R,G),x.add((0,_.toDisposable)(()=>B.$unregisterTestController(R)));const ue={controller:ne,collection:j,profiles:de};return this.controllers.set(R,ue),x.add((0,_.toDisposable)(()=>this.controllers.delete(R))),x.add(j.onDidGenerateDiff(ye=>B.$publishDiff(R,ye))),ne}createTestItem(R,G,x){return new u.TestItemImpl(R,G,x)}createTestObserver(){return this.observer.checkout()}async runTests(R,G=F.CancellationToken.None){const x=T(R);if(!x)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.controllers.get(x.controllerId);if(!j)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:R.include?.map(de=>de.id)??[j.collection.root.id],profileGroup:z[x.group],profileId:x.profileId,controllerId:x.controllerId}],exclude:R.exclude?.map(de=>({testId:de.id,controllerId:x.controllerId}))},G)}$provideFileCoverage(R,G,x){return y.Iterable.find(this.runTracker.trackers,j=>j.id===R)?.getCoverage(G)?.provideFileCoverage(x)??Promise.resolve([])}$resolveFileCoverage(R,G,x,j){return y.Iterable.find(this.runTracker.trackers,de=>de.id===R)?.getCoverage(G)?.resolveFileCoverage(x,j)??Promise.resolve([])}$configureRunProfile(R,G){this.controllers.get(R)?.profiles.get(G)?.configureHandler?.()}$publishTestResults(R){this.results=Object.freeze(R.map(G=>(0,k.deepFreeze)(m.TestResults.to(G))).concat(this.results).sort((G,x)=>x.completedAt-G.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest({controllerId:R,testId:G},x){const j=this.controllers.get(R)?.collection;j&&(await j.expand(G,x<0?Infinity:x),j.flushDiff())}$acceptDiff(R){this.observer.applyDiff(R)}async $runControllerTests(R,G){const x=this.controllers.get(R.controllerId);if(!x)return;const{collection:j,profiles:de}=x,B=de.get(R.profileId);if(!B)return;const ne=R.testIds.map(Te=>j.tree.get(Te)).filter(n.isDefined),ue=R.excludeExtIds.map(Te=>x.collection.tree.get(Te)).filter(n.isDefined).filter(Te=>ne.some($e=>$e.fullId.compare(Te.fullId)===2));if(!ne.length)return;const ye=new b.TestRunRequest(ne.some(Te=>Te.actual instanceof u.TestItemRootImpl)?void 0:ne.map(Te=>Te.actual),ue.map(Te=>Te.actual),B),Re=this.runTracker.prepareForMainThreadTestRun(ye,o.fromInternal(R,x.collection),G);try{await B.runHandler(ye,G)}finally{Re.isRunning&&!G.isCancellationRequested&&await S.Event.toPromise(Re.onEnd),this.runTracker.cancelRunById(R.runId)}}$cancelExtensionTestRun(R){R===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(R)}};h=ze([qe(0,d.IExtHostRpcService)],h),e.ExtHostTesting=h;class p extends _.Disposable{constructor(R,G,x){super();this.dto=R,this.proxy=G,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new S.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new F.CancellationTokenSource(x)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:j}of this.tasks.values())j.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(R){return this.tasks.get(R)?.coverage}createRun(R){const G=(0,I.generateUuid)(),x=new A(this.proxy,this.dto.id,G),j=new L(R,this.cts.token,G,x,this.dto,this.sharedTestIds,this.proxy,()=>{this.tasks.delete(j.taskId),this.isRunning||this.dispose()});return this.tasks.set(j.taskId,{run:j,coverage:x}),j}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}}class D{constructor(R){this.proxy=R,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(R,G,x){return this.getTracker(R,G,x)}cancelRunById(R){for(const G of this.tracked.values())if(G.id===R){G.dispose();return}}cancelAllRuns(){for(const R of this.tracked.values())R.dispose()}createTestRun(R,G,x,j,de){const B=this.tracked.get(x);if(B)return B.createRun(j);const ne=o.fromPublic(R,G,x),ue=T(x);this.proxy.$startedExtensionTestRun({controllerId:R,profile:ue&&{group:z[ue.group],id:ue.profileId},exclude:x.exclude?.map(Re=>Re.id)??[],id:ne.id,include:x.include?.map(Re=>Re.id)??[G.root.id],persist:de});const ye=this.getTracker(x,ne);return ye.onEnd(()=>this.proxy.$finishedExtensionTestRun(ne.id)),ye.createRun(j)}getTracker(R,G,x){const j=new p(G,this.proxy,x);return this.tracked.set(R,j),j.onEnd(()=>this.tracked.delete(R)),j}}e.TestRunCoordinator=D;const T=V=>{if(!!V.profile){if(!(V.profile instanceof Q))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return V.profile}};class o{constructor(R,G,x,j,de){this.controllerId=R,this.id=G,this.colllection=de,this.includePrefix=x.map(B=>B+"\0"),this.excludePrefix=j.map(B=>B+"\0")}static fromPublic(R,G,x){return new o(R,(0,I.generateUuid)(),x.include?.map(j=>a.TestId.fromExtHostTestItem(j,R).toString())??[R],x.exclude?.map(j=>a.TestId.fromExtHostTestItem(j,R).toString())??[],G)}static fromInternal(R,G){return new o(R.controllerId,R.runId,R.testIds,R.excludeExtIds,G)}isIncluded(R){const G=a.TestId.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const x of this.excludePrefix)if(G===x||G.startsWith(x))return!1;for(const x of this.includePrefix)if(G===x||G.startsWith(x))return!0;return!1}}e.TestRunDto=o;class A{constructor(R,G,x){this.proxy=R,this.runId=G,this.taskId=x}set coverageProvider(R){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this._coverageProvider=R,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(R){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(R))());try{return(await this.fileCoverage)?.map(m.TestCoverage.fromFile)??[]}catch(G){throw this.fileCoverage=void 0,G}}async resolveFileCoverage(R,G){const x=await this.fileCoverage;let j=x?.[R];return!this._coverageProvider||!x||!j?[]:(j.detailedCoverage||(j=x[R]=await this._coverageProvider.resolveFileCoverage?.(j,G)??j),j.detailedCoverage?.map(m.TestCoverage.fromDetailed)??[])}}class L{constructor(R,G,x,j,de,B,ne,ue){this.name=R,this.token=G,this.taskId=x,f.set(this,void 0),v.set(this,void 0),t.set(this,void 0),r.set(this,void 0),s.set(this,void 0),i.set(this,!1),nt(this,r,ue,"f"),nt(this,f,ne,"f"),nt(this,v,de,"f"),nt(this,s,j,"f"),nt(this,t,B,"f"),ne.$startedTestRunTask(de.id,{id:this.taskId,name:R,running:!0})}set coverageProvider(R){Ue(this,s,"f").coverageProvider=R}get coverageProvider(){return Ue(this,s,"f").coverageProvider}setState(R,G,x){const j=Ue(this,v,"f");!Ue(this,i,"f")&&j.isIncluded(R)&&(this.ensureTestIsKnown(R),Ue(this,f,"f").$updateTestStateInRun(j.id,this.taskId,a.TestId.fromExtHostTestItem(R,j.controllerId).toString(),G,x))}appendMessage(R,G){const x=Ue(this,v,"f");!Ue(this,i,"f")&&x.isIncluded(R)&&(this.ensureTestIsKnown(R),Ue(this,f,"f").$appendTestMessageInRun(x.id,this.taskId,a.TestId.fromExtHostTestItem(R,x.controllerId).toString(),m.TestMessage.from(G)))}appendOutput(R){Ue(this,i,"f")||Ue(this,f,"f").$appendOutputToRun(Ue(this,v,"f").id,this.taskId,g.VSBuffer.fromString(R))}end(){Ue(this,i,"f")||(nt(this,i,!0,"f"),Ue(this,f,"f").$finishedTestRunTask(Ue(this,v,"f").id,this.taskId),Ue(this,r,"f").call(this))}ensureTestIsKnown(R){const G=Ue(this,t,"f");if(G.has(R.id))return;const x=[],j=Ue(this,v,"f").colllection.root;for(;x.unshift(m.TestItem.from(R,j.id)),!(G.has(R.id)||(G.add(R.id),!R.parent));)R=R.parent;G.has(j.id)||(G.add(j.id),x.unshift(m.TestItem.from(j,j.id))),Ue(this,f,"f").$addTestsToRun(Ue(this,v,"f").controllerId,Ue(this,v,"f").id,x)}}f=new WeakMap,v=new WeakMap,t=new WeakMap,r=new WeakMap,s=new WeakMap,i=new WeakMap;class $ extends P.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,m.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:G,removed:x}=this;return{get added(){return[...R].map(j=>j.revived)},get updated(){return[...G].map(j=>j.revived)},get removed(){return[...x].map(j=>j.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class oe extends P.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new S.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,G){return{...R,revived:m.TestItem.toPlain(R.item),depth:G?G.depth+1:0,children:new Set}}createChangeCollector(){return new $(this.changeEmitter)}}e.MirroredTestCollection=oe;class he{constructor(R){this.proxy=R}checkout(){this.current||(this.current=this.createObserverData());const R=this.current;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(G=>G.revived)},dispose:(0,E.once)(()=>{--R.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(R){return this.current?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.current?.tests.apply(R)}createObserverData(){const R=new oe;return this.proxy.$subscribeToDiffs(),{observers:0,tests:R}}}class Q{constructor(R,G,x,j,de,B,ne=!1){this.controllerId=G,this.profileId=x,this._label=j,this.group=de,this.runHandler=B,this._isDefault=ne,c.set(this,void 0),nt(this,c,R,"f");const ue=z[de];if(typeof ue!="number")throw new Error(`Unknown TestRunProfile.group ${de}`);Ue(this,c,"f").$publishTestRunProfile({profileId:x,controllerId:G,label:j,group:ue,isDefault:ne,hasConfigurationHandler:!1})}get label(){return this._label}set label(R){R!==this._label&&(this._label=R,Ue(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get isDefault(){return this._isDefault}set isDefault(R){R!==this._isDefault&&(this._isDefault=R,Ue(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get configureHandler(){return this._configureHandler}set configureHandler(R){R!==this._configureHandler&&(this._configureHandler=R,Ue(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}dispose(){Ue(this,c,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=Q,c=new WeakMap;const z={[b.TestRunProfileGroup.Coverage]:8,[b.TestRunProfileGroup.Debug]:4,[b.TestRunProfileGroup.Run]:2}}),define(be[211],Ee([0,1,3,17,5,102,9,7]),function(ee,e,g,F,S,E,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class _{constructor(n,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new g.Emitter,this._onDidChangeTextEditorOptions=new g.Emitter,this._onDidChangeTextEditorVisibleRanges=new g.Emitter,this._onDidChangeTextEditorViewColumn=new g.Emitter,this._onDidChangeActiveTextEditor=new g.Emitter,this._onDidChangeVisibleTextEditors=new g.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=n.getProxy(S.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(l=>this._onDidChangeVisibleTextEditors.fire(l)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(l=>this._onDidChangeActiveTextEditor.fire(l))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(n){const I=this._extHostDocumentsAndEditors.allEditors();return n?I:I.map(l=>l.value)}async showTextDocument(n,I,l){let d;typeof I=="number"?d={position:C.ViewColumn.from(I),preserveFocus:l}:typeof I=="object"?d={position:C.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?C.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:d={preserveFocus:!1};const u=await this._proxy.$tryShowTextDocument(n.uri,d),m=u&&this._extHostDocumentsAndEditors.getEditor(u);if(m)return m.value;throw u?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}createTextEditorDecorationType(n,I){return new E.TextEditorDecorationType(this._proxy,n,I).value}$acceptEditorPropertiesChanged(n,I){const l=this._extHostDocumentsAndEditors.getEditor(n);if(!l)throw new Error("unknown text editor");if(I.options&&l._acceptOptions(I.options),I.selections){const d=I.selections.selections.map(C.Selection.to);l._acceptSelections(d)}if(I.visibleRanges){const d=F.coalesce(I.visibleRanges.map(C.Range.to));l._acceptVisibleRanges(d)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:l.value,options:{...I.options,lineNumbers:C.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const d=y.TextEditorSelectionChangeKind.fromValue(I.selections.source),u=I.selections.selections.map(C.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:l.value,selections:u,kind:d})}if(I.visibleRanges){const d=F.coalesce(I.visibleRanges.map(C.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:l.value,visibleRanges:d})}}$acceptEditorPositionData(n){for(const I in n){const l=this._extHostDocumentsAndEditors.getEditor(I);if(!l)throw new Error("Unknown text editor");const d=C.ViewColumn.to(n[I]);l.value.viewColumn!==d&&(l._acceptViewColumn(d),this._onDidChangeTextEditorViewColumn.fire({textEditor:l.value,viewColumn:d}))}}getDiffInformation(n){return Promise.resolve(this._proxy.$getDiffInformation(n))}}e.ExtHostEditors=_}),define(be[212],Ee([0,1,2,4,5,6,7]),function(ee,e,g,F,S,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,F.createDecorator)("IExtHostTimeline");class y{constructor(n,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=n.getProxy(S.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===11){const d=l.uri===void 0?void 0:g.URI.revive(l.uri);return this._itemsBySourceAndUriMap.get(l.source)?.get(_(d))?.get(l.handle)}return l}})}async $getTimeline(n,I,l,d,u){return this._providers.get(n)?.provideTimeline(g.URI.revive(I),l,d,u)}registerTimelineProvider(n,I,l,d){const u=new E.DisposableStore,m=this.convertTimelineItem(I.id,d,u).bind(this);let b;I.onDidChange&&(b=I.onDidChange(P=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...P,id:I.id}),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...I,scheme:n,onDidChange:void 0,async provideTimeline(P,a,f,v){v?.resetCache&&(u.clear(),w.get(I.id)?.clear());const t=await I.provideTimeline(P,a,f);if(t==null)return;const r=m(P,v);return{...t,source:I.id,items:t.items.map(r)}},dispose(){for(const P of w.values())P.get(I.id)?.clear();b?.dispose(),u.dispose()}})}convertTimelineItem(n,I,l){return(d,u)=>{let m;if(u?.cacheResults){let b=this._itemsBySourceAndUriMap.get(n);b===void 0&&(b=new Map,this._itemsBySourceAndUriMap.set(n,b));const w=_(d);m=b.get(w),m===void 0&&(m=new Map,b.set(w,m))}return b=>{const{iconPath:w,...P}=b,a=`${n}|${b.id??b.timestamp}`;m?.set(a,b);let f,v,t;return b.iconPath&&(w instanceof C.ThemeIcon?t={id:w.id,color:w.color}:g.URI.isUri(w)?(f=w,v=w):{light:f,dark:v}=w),{...P,id:P.id??void 0,handle:a,source:n,command:b.command?I.toInternal(b.command,l):void 0,icon:f,iconDark:v,themeIcon:t,accessibilityInformation:b.accessibilityInformation}}}}registerTimelineProviderCore(n){if(this._providers.get(n.id))throw new Error(`Timeline Provider ${n.id} already exists.`);return this._proxy.$registerTimelineProvider({id:n.id,label:n.label,scheme:n.scheme}),this._providers.set(n.id,n),(0,E.toDisposable)(()=>{for(const l of this._itemsBySourceAndUriMap.values())l.get(n.id)?.clear();this._providers.delete(n.id),this._proxy.$unregisterTimelineProvider(n.id),n.dispose()})}}e.ExtHostTimeline=y;function _(k){return k?.toString()}}),define(be[213],Ee([0,1,6,11,2,5]),function(ee,e,g,F,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(_){this._openers=new Map,this._proxy=_.getProxy(E.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,k,n,I){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const l=I.schemes.find(d=>!C.supportedSchemes.has(d));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,n),this._proxy.$registerUriOpener(k,I.schemes,_,I.label),(0,g.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(_,k,n){const I=this._openers.get(_);if(!I)throw new Error(`Unknown opener with id: ${_}`);const l=S.URI.revive(k);return I.canOpenExternalUri(l,n)}async $openUri(_,k,n){const I=this._openers.get(_);if(!I)throw new Error(`Unknown opener id: '${_}'`);return I.openExternalUri(S.URI.revive(k.resolvedUri),{sourceUri:S.URI.revive(k.sourceUri)},n)}}e.ExtHostUriOpeners=C,C.supportedSchemes=new Set([F.Schemas.http,F.Schemas.https])}),define(be[214],Ee([0,1,5,2,6,12,26]),function(ee,e,g,F,S,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class y{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(g.MainContext.MainThreadUrls)}registerUriHandler(k,n){if(this.handles.has(C.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const I=y.HandlePool++;return this.handles.add(C.ExtensionIdentifier.toKey(k)),this.handlers.set(I,n),this._proxy.$registerUriHandler(I,k),(0,S.toDisposable)(()=>{this.handles.delete(C.ExtensionIdentifier.toKey(k)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(k,n){const I=this.handlers.get(k);if(!I)return Promise.resolve(void 0);try{I.handleUri(F.URI.revive(n))}catch(l){(0,E.onUnexpectedError)(l)}return Promise.resolve(void 0)}async createAppUri(k){return F.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=y,y.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(ee,e,g,F,S){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Ue=this&&this.__classPrivateFieldGet||function(ee,e,g,F){if(g==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?F:g==="a"?F.call(ee):F?F.value:e.get(ee)};define(be[49],Ee([0,1,3,2,147,167,70,5]),function(ee,e,g,F,S,E,C,y){"use strict";var _,k,n,I,l,d,u,m,b,w,P,a;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class f{constructor(p,D,T,o,A,L,$){_.set(this,void 0),k.set(this,void 0),n.set(this,void 0),I.set(this,void 0),l.set(this,void 0),d.set(this,void 0),u.set(this,""),m.set(this,void 0),b.set(this,!1),w.set(this,!1),P.set(this,!1),this._onMessageEmitter=new g.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,a.set(this,new g.Emitter),this._onDidDispose=Ue(this,a,"f").event,nt(this,_,p,"f"),nt(this,k,D,"f"),nt(this,m,T,"f"),nt(this,I,o,"f"),nt(this,l,A,"f"),nt(this,d,L,"f"),nt(this,P,v(L),"f"),nt(this,n,$,"f")}dispose(){nt(this,b,!0,"f"),Ue(this,a,"f").fire(),Ue(this,a,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(p){return nt(this,w,!0,"f"),(0,C.asWebviewUri)(p,Ue(this,I,"f").remote)}get cspSource(){return C.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ue(this,u,"f")}set html(p){this.assertNotDisposed(),Ue(this,u,"f")!==p&&(nt(this,u,p,"f"),!Ue(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(p)&&(nt(this,w,!0,"f"),Ue(this,n,"f").report("Webview vscode-resource: uris",Ue(this,d,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,k,"f").$setHtml(Ue(this,_,"f"),p))}get options(){return this.assertNotDisposed(),Ue(this,m,"f")}set options(p){this.assertNotDisposed(),Ue(this,k,"f").$setOptions(Ue(this,_,"f"),s(Ue(this,d,"f"),Ue(this,l,"f"),p)),nt(this,m,p,"f")}async postMessage(p){if(Ue(this,b,"f"))return!1;const D=(0,E.serializeWebviewMessage)(p,{serializeBuffersForPostMessage:Ue(this,P,"f")});return Ue(this,k,"f").$postMessage(Ue(this,_,"f"),D.message,...D.buffers)}assertNotDisposed(){if(Ue(this,b,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=f,_=new WeakMap,k=new WeakMap,n=new WeakMap,I=new WeakMap,l=new WeakMap,d=new WeakMap,u=new WeakMap,m=new WeakMap,b=new WeakMap,w=new WeakMap,P=new WeakMap,a=new WeakMap;function v(h){try{const p=(0,S.normalizeVersion)((0,S.parseVersion)(h.engines.vscode));return!!p&&p.majorBase>=1&&p.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=v;class t{constructor(p,D,T,o,A){this.initData=D,this.workspace=T,this._logService=o,this._deprecationService=A,this._webviews=new Map,this._webviewProxy=p.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(p,D,...T){const o=this.getWebview(p);if(o){const{message:A}=(0,E.deserializeWebviewMessage)(D,T);o._onMessageEmitter.fire(A)}}$onMissingCsp(p,D){this._logService.warn(`${D} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(p,D,T){const o=new f(p,this._webviewProxy,i(D),this.initData,this.workspace,T,this._deprecationService);return this._webviews.set(p,o),o._onDidDispose(()=>{this._webviews.delete(p)}),o}deleteWebview(p){this._webviews.delete(p)}getWebview(p){return this._webviews.get(p)}}e.ExtHostWebviews=t;function r(h){return{id:h.identifier,location:h.extensionLocation}}e.toExtensionData=r;function s(h,p,D){return{enableCommandUris:D.enableCommandUris,enableScripts:D.enableScripts,portMapping:D.portMapping,localResourceRoots:D.localResourceRoots||c(h,p)}}e.serializeWebviewOptions=s;function i(h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots?.map(p=>F.URI.from(p))}}e.reviveOptions=i;function c(h,p){return[...(p?.getWorkspaceFolders()||[]).map(D=>D.uri),h.extensionLocation]}}),define(be[215],Ee([0,1,20,42,6,11,25,2,9,49,65,5,7]),function(ee,e,g,F,S,E,C,y,_,k,n,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class d{constructor(t,r){this.document=t,this._storagePath=r,this._backupCounter=1,this._edits=new n.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,r){await this.getEdit(t).undo(),r||this.disposeBackup()}async redo(t,r){await this.getEdit(t).redo(),r||this.disposeBackup()}disposeEdits(t){for(const r of t)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=f(this.document.uri)+this._backupCounter++;return(0,C.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const r=this._edits.get(t,0);if(!r)throw new Error("No edit found");return r}}class u{constructor(){this._documents=new Map}get(t,r){return this._documents.get(this.key(t,r))}add(t,r,s){const i=this.key(t,r.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${t} resource:${r.uri}`);const c=new d(r,s);return this._documents.set(i,c),c}delete(t,r){const s=this.key(t,r.uri);this._documents.delete(s)}key(t,r){return`${t}@@@${r}`}}var m;(function(v){v[v.Text=0]="Text",v[v.Custom=1]="Custom"})(m||(m={}));class b{constructor(){this._providers=new Map}addTextProvider(t,r,s){return this.add(0,t,r,s)}addCustomProvider(t,r,s){return this.add(1,t,r,s)}get(t){return this._providers.get(t)}add(t,r,s,i){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:t,extension:s,provider:i}),new l.Disposable(()=>this._providers.delete(r))}}class w{constructor(t,r,s,i,c){this._extHostDocuments=r,this._extensionStoragePaths=s,this._extHostWebview=i,this._extHostWebviewPanels=c,this._editorProviders=new b,this._documents=new u,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,r,s,i){const c=new S.DisposableStore;return P(s)?(c.add(this._editorProviders.addTextProvider(r,t,s)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(t),r,i.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(t))):(c.add(this._editorProviders.addCustomProvider(r,t,s)),this.supportEditing(s)&&c.add(s.onDidChangeCustomDocument(h=>{const p=this.getCustomDocumentEntry(r,h.document.uri);if(a(h)){const D=p.addEdit(h);this._proxy.$onDidEdit(h.document.uri,r,D,h.label)}else this._proxy.$onContentChange(h.document.uri,r)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(t),r,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(t))),l.Disposable.from(c,new l.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(t,r,s,i,c){const h=this._editorProviders.get(r);if(!h)throw new Error(`No provider found for '${r}'`);if(h.type!==1)throw new Error(`Invalid provide type for '${r}'`);const p=y.URI.revive(t),D=await h.provider.openCustomDocument(p,{backupId:s,untitledDocumentData:i?.buffer},c);let T;return this.supportEditing(h.provider)&&this._extensionStoragePaths&&(T=this._extensionStoragePaths.workspaceValue(h.extension)??this._extensionStoragePaths.globalValue(h.extension)),this._documents.add(r,D,T),{editable:this.supportEditing(h.provider)}}async $disposeCustomDocument(t,r){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${r}'`);const i=y.URI.revive(t),{document:c}=this.getCustomDocumentEntry(r,i);this._documents.delete(r,c),c.dispose()}async $resolveWebviewEditor(t,r,s,i,c,h){const p=this._editorProviders.get(s);if(!p)throw new Error(`No provider found for '${s}'`);const D=_.ViewColumn.to(c),T=this._extHostWebview.createNewWebview(r,i.webviewOptions,p.extension),o=this._extHostWebviewPanels.createNewWebviewPanel(r,s,i.title,D,i.panelOptions,T),A=y.URI.revive(t);switch(p.type){case 1:{const{document:L}=this.getCustomDocumentEntry(s,A);return p.provider.resolveCustomEditor(L,o,h)}case 0:{const L=this._extHostDocuments.getDocument(A);return p.provider.resolveCustomTextEditor(L,o,h)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,r,s){this.getCustomDocumentEntry(r,t).disposeEdits(s)}async $onMoveCustomEditor(t,r,s){const i=this._editorProviders.get(s);if(!i)throw new Error(`No provider found for '${s}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const c=this._extHostWebviewPanels.getWebviewPanel(t);if(!c)throw new Error("No webview found");const h=y.URI.revive(r),p=this._extHostDocuments.getDocument(h);await i.provider.moveCustomTextEditor(p,c,g.CancellationToken.None)}async $undo(t,r,s,i){return this.getCustomDocumentEntry(r,t).undo(s,i)}async $redo(t,r,s,i){return this.getCustomDocumentEntry(r,t).redo(s,i)}async $revert(t,r,s){const i=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).revertCustomDocument(i.document,s),i.disposeBackup()}async $onSave(t,r,s){const i=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).saveCustomDocument(i.document,s),i.disposeBackup()}async $onSaveAs(t,r,s,i){const c=this.getCustomDocumentEntry(r,t);return this.getCustomEditorProvider(r).saveCustomDocumentAs(c.document,y.URI.revive(s),i)}async $backup(t,r,s){const i=this.getCustomDocumentEntry(r,t),h=await this.getCustomEditorProvider(r).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},s);return i.updateBackup(h),h.id}getCustomDocumentEntry(t,r){const s=this._documents.get(t,y.URI.revive(r));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const s=this._editorProviders.get(t)?.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=w;function P(v){return typeof v.resolveCustomTextEditor=="function"}function a(v){return typeof v.undo=="function"&&typeof v.redo=="function"}function f(v){const t=v.scheme===E.Schemas.file||v.scheme===E.Schemas.untitled?v.fsPath:v.toString();return(0,F.hash)(t)+""}});var nt=this&&this.__classPrivateFieldSet||function(ee,e,g,F,S){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Ue=this&&this.__classPrivateFieldGet||function(ee,e,g,F){if(g==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?F:g==="a"?F.call(ee):F?F.value:e.get(ee)};define(be[216],Ee([0,1,3,6,2,36,9,49,5,7]),function(ee,e,g,F,S,E,C,y,_,k){"use strict";var n,I,l,d,u,m,b,w,P,a,f,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends F.Disposable{constructor(h,p,D,T,o,A,L){super();n.set(this,void 0),I.set(this,void 0),l.set(this,void 0),d.set(this,void 0),u.set(this,void 0),m.set(this,void 0),b.set(this,void 0),w.set(this,void 0),P.set(this,!0),a.set(this,!0),f.set(this,!1),v.set(this,this._register(new g.Emitter)),this.onDidDispose=Ue(this,v,"f").event,t.set(this,this._register(new g.Emitter)),this.onDidChangeViewState=Ue(this,t,"f").event,nt(this,n,h,"f"),nt(this,I,p,"f"),nt(this,l,D,"f"),nt(this,u,A,"f"),nt(this,w,o,"f"),nt(this,m,T,"f"),nt(this,d,L,"f")}dispose(){Ue(this,f,"f")||(nt(this,f,!0,"f"),Ue(this,v,"f").fire(),Ue(this,I,"f").$disposeWebview(Ue(this,n,"f")),Ue(this,d,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,d,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,l,"f")}get title(){return this.assertNotDisposed(),Ue(this,m,"f")}set title(h){this.assertNotDisposed(),Ue(this,m,"f")!==h&&(nt(this,m,h,"f"),Ue(this,I,"f").$setTitle(Ue(this,n,"f"),h))}get iconPath(){return this.assertNotDisposed(),Ue(this,b,"f")}set iconPath(h){this.assertNotDisposed(),Ue(this,b,"f")!==h&&(nt(this,b,h,"f"),Ue(this,I,"f").$setIconPath(Ue(this,n,"f"),S.URI.isUri(h)?{light:h,dark:h}:h))}get options(){return Ue(this,u,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,w,"f")=="number"&&Ue(this,w,"f")<0))return Ue(this,w,"f")}get active(){return this.assertNotDisposed(),Ue(this,a,"f")}get visible(){return this.assertNotDisposed(),Ue(this,P,"f")}_updateViewState(h){Ue(this,f,"f")||(this.active!==h.active||this.visible!==h.visible||this.viewColumn!==h.viewColumn)&&(nt(this,a,h.active,"f"),nt(this,P,h.visible,"f"),nt(this,w,h.viewColumn,"f"),Ue(this,t,"f").fire({webviewPanel:this}))}reveal(h,p){this.assertNotDisposed(),Ue(this,I,"f").$reveal(Ue(this,n,"f"),{viewColumn:h?C.ViewColumn.from(h):void 0,preserveFocus:!!p})}assertNotDisposed(){if(Ue(this,f,"f"))throw new Error("Webview is disposed")}}n=new WeakMap,I=new WeakMap,l=new WeakMap,d=new WeakMap,u=new WeakMap,m=new WeakMap,b=new WeakMap,w=new WeakMap,P=new WeakMap,a=new WeakMap,f=new WeakMap,v=new WeakMap,t=new WeakMap;class s{constructor(h,p,D){this.webviews=p,this.workspace=D,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=h.getProxy(_.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,E.generateUuid)()}createWebviewPanel(h,p,D,T,o={}){const A=typeof T=="object"?T.viewColumn:T,L={viewColumn:C.ViewColumn.from(A),preserveFocus:typeof T=="object"&&!!T.preserveFocus},$=(0,y.shouldSerializeBuffersForPostMessage)(h),oe=s.newHandle();this._proxy.$createWebviewPanel((0,y.toExtensionData)(h),oe,p,{title:D,panelOptions:i(o),webviewOptions:(0,y.serializeWebviewOptions)(h,this.workspace,o),serializeBuffersForPostMessage:$},L);const he=this.webviews.createNewWebview(oe,o,h);return this.createNewWebviewPanel(oe,p,D,A,o,he)}$onDidChangeWebviewPanelViewStates(h){const p=Object.keys(h);p.sort((D,T)=>{const o=h[D],A=h[T];return o.active?1:A.active?-1:+o.visible-+A.visible});for(const D of p){const T=this.getWebviewPanel(D);if(!T)continue;const o=h[D];T._updateViewState({active:o.active,visible:o.visible,viewColumn:C.ViewColumn.to(o.position)})}}async $onDidDisposeWebviewPanel(h){this.getWebviewPanel(h)?.dispose(),this._webviewPanels.delete(h),this.webviews.deleteWebview(h)}registerWebviewPanelSerializer(h,p,D){if(this._serializers.has(p))throw new Error(`Serializer for '${p}' already registered`);return this._serializers.set(p,{serializer:D,extension:h}),this._proxy.$registerSerializer(p,{serializeBuffersForPostMessage:(0,y.shouldSerializeBuffersForPostMessage)(h)}),new k.Disposable(()=>{this._serializers.delete(p),this._proxy.$unregisterSerializer(p)})}async $deserializeWebviewPanel(h,p,D,T){const o=this._serializers.get(p);if(!o)throw new Error(`No serializer found for '${p}'`);const{serializer:A,extension:L}=o,$=this.webviews.createNewWebview(h,D.webviewOptions,L),oe=this.createNewWebviewPanel(h,p,D.title,T,D.panelOptions,$);await A.deserializeWebviewPanel(oe,D.state)}createNewWebviewPanel(h,p,D,T,o,A){const L=new r(h,this._proxy,p,D,T,o,A);return this._webviewPanels.set(h,L),L}getWebviewPanel(h){return this._webviewPanels.get(h)}}e.ExtHostWebviewPanels=s;function i(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(ee,e,g,F,S){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Ue=this&&this.__classPrivateFieldGet||function(ee,e,g,F){if(g==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?F:g==="a"?F.call(ee):F?F.value:e.get(ee)};define(be[217],Ee([0,1,3,6,49,5,7]),function(ee,e,g,F,S,E,C){"use strict";var y,_,k,n,I,l,d,u,m,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends F.Disposable{constructor(f,v,t,r,s,i){super();y.set(this,void 0),_.set(this,void 0),k.set(this,void 0),n.set(this,void 0),I.set(this,!1),l.set(this,void 0),d.set(this,void 0),u.set(this,void 0),m.set(this,this._register(new g.Emitter)),this.onDidChangeVisibility=Ue(this,m,"f").event,b.set(this,this._register(new g.Emitter)),this.onDidDispose=Ue(this,b,"f").event,nt(this,k,t,"f"),nt(this,d,r,"f"),nt(this,y,f,"f"),nt(this,_,v,"f"),nt(this,n,s,"f"),nt(this,l,i,"f")}dispose(){Ue(this,I,"f")||(nt(this,I,!0,"f"),Ue(this,b,"f").fire(),Ue(this,n,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,d,"f")}set title(f){this.assertNotDisposed(),Ue(this,d,"f")!==f&&(nt(this,d,f,"f"),Ue(this,_,"f").$setWebviewViewTitle(Ue(this,y,"f"),f))}get description(){return this.assertNotDisposed(),Ue(this,u,"f")}set description(f){this.assertNotDisposed(),Ue(this,u,"f")!==f&&(nt(this,u,f,"f"),Ue(this,_,"f").$setWebviewViewDescription(Ue(this,y,"f"),f))}get visible(){return Ue(this,l,"f")}get webview(){return Ue(this,n,"f")}get viewType(){return Ue(this,k,"f")}_setVisible(f){f===Ue(this,l,"f")||Ue(this,I,"f")||(nt(this,l,f,"f"),Ue(this,m,"f").fire())}show(f){this.assertNotDisposed(),Ue(this,_,"f").$show(Ue(this,y,"f"),!!f)}assertNotDisposed(){if(Ue(this,I,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,_=new WeakMap,k=new WeakMap,n=new WeakMap,I=new WeakMap,l=new WeakMap,d=new WeakMap,u=new WeakMap,m=new WeakMap,b=new WeakMap;class P{constructor(f,v){this._extHostWebview=v,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=f.getProxy(E.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(f,v,t,r){if(this._viewProviders.has(v))throw new Error(`View provider for '${v}' already registered`);return this._viewProviders.set(v,{provider:t,extension:f}),this._proxy.$registerWebviewViewProvider((0,S.toExtensionData)(f),v,{retainContextWhenHidden:r?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new C.Disposable(()=>{this._viewProviders.delete(v),this._proxy.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(f,v,t,r,s){const i=this._viewProviders.get(v);if(!i)throw new Error(`No view provider found for '${v}'`);const{provider:c,extension:h}=i,p=this._extHostWebview.createNewWebview(f,{},h),D=new w(f,this._proxy,v,t,p,!0);this._webviewViews.set(f,D),await c.resolveWebviewView(D,{state:r},s)}async $onDidChangeWebviewViewVisibility(f,v){this.getWebviewView(f)._setVisible(v)}async $disposeWebviewView(f){const v=this.getWebviewView(f);this._webviewViews.delete(f),v.dispose(),this._extHostWebview.deleteWebview(f)}getWebviewView(f){const v=this._webviewViews.get(f);if(!v)throw new Error("No webview found");return v}}e.ExtHostWebviewViews=P}),define(be[106],Ee([0,1,3,5,2,11,8,4,13]),function(ee,e,g,F,S,E,C,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class xn{constructor(I){this._onDidChangeWindowState=new g.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=xn.InitialState,this._proxy=I.getProxy(F.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(l=>this.$onDidChangeWindowFocus(l))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state={...this._state,focused:I},this._onDidChangeWindowState.fire(this._state))}openUri(I,l){let d;if(typeof I=="string"){d=I;try{I=S.URI.parse(I)}catch(u){return Promise.reject(`Invalid uri - '${I}'`)}}return(0,C.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===E.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,d,l)}async asExternalUri(I,l){if((0,C.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this._proxy.$asExternalUri(I,l);return S.URI.from(d)}};k.InitialState={focused:!0},k=ze([qe(0,_.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,y.createDecorator)("IExtHostWindow")}),define(be[218],Ee([0,1,15,5,29,13]),function(ee,e,g,F,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let C=class extends g.AbstractLogger{constructor(_,k){super();this._proxy=_.getProxy(F.MainContext.MainThreadLog),this._logFile=k.logFile.toJSON(),this.setLevel(k.logLevel)}$setLevel(_){this.setLevel(_)}trace(_,...k){this.getLevel()<=g.LogLevel.Trace&&this._proxy.$log(this._logFile,g.LogLevel.Trace,Array.from(arguments))}debug(_,...k){this.getLevel()<=g.LogLevel.Debug&&this._proxy.$log(this._logFile,g.LogLevel.Debug,Array.from(arguments))}info(_,...k){this.getLevel()<=g.LogLevel.Info&&this._proxy.$log(this._logFile,g.LogLevel.Info,Array.from(arguments))}warn(_,...k){this.getLevel()<=g.LogLevel.Warning&&this._proxy.$log(this._logFile,g.LogLevel.Warning,Array.from(arguments))}error(_,...k){this.getLevel()<=g.LogLevel.Error&&this._proxy.$log(this._logFile,g.LogLevel.Error,Array.from(arguments))}critical(_,...k){this.getLevel()<=g.LogLevel.Critical&&this._proxy.$log(this._logFile,g.LogLevel.Critical,Array.from(arguments))}flush(){}};C=ze([qe(0,E.IExtHostRpcService),qe(1,S.IExtHostInitDataService)],C),e.ExtHostLogService=C}),define(be[219],Ee([0,1,16,20,12,3,6,117,188,103,24]),function(ee,e,g,F,S,E,C,y,_,k,n){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function l(i,c){try{return JSON.stringify(i,c)}catch(h){return"null"}}function d(i,c){return JSON.stringify(i,c)}function u(i){return i?(c,h)=>h&&h.$mid===1?i.transformOutgoing(h):h:null}var m;(function(i){i[i.LocalSide=0]="LocalSide",i[i.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));var b;(function(i){i[i.Responsive=0]="Responsive",i[i.Unresponsive=1]="Unresponsive"})(b=e.ResponsiveState||(e.ResponsiveState={}));const w=()=>{},P=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class f extends C.Disposable{constructor(c,h=null,p=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new E.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=c,this._logger=h,this._uriTransformer=p,this._uriReplacer=u(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let D=0,T=k.ProxyIdentifier.count;D<T;D++)this._locals[D]=null,this._proxies[D]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new g.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(D=>this._receiveOneMessage(D))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(c=>{this._pendingRPCReplies[c].resolveErr(S.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(c){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+f.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(c){this._unresponsiveTime=Date.now()+f.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(c){this._responsiveState!==c&&(this._responsiveState=c,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(c){return this._uriTransformer?(0,y.transformIncomingURIs)(c,this._uriTransformer):c}getProxy(c){const{nid:h,sid:p}=c;return this._proxies[h]||(this._proxies[h]=this._createProxy(h,p)),this._proxies[h]}_createProxy(c,h){let p={get:(D,T)=>(typeof T=="string"&&!D[T]&&T.charCodeAt(0)===36&&(D[T]=(...o)=>this._remoteCall(c,T,o)),T===a?h:D[T])};return new Proxy(Object.create(null),p)}set(c,h){return this._locals[c.nid]=h,h}assertRegistered(c){for(let h=0,p=c.length;h<p;h++){const D=c[h];if(!this._locals[D.nid])throw new Error(`Missing actor ${D.sid} (isMain: ${D.isMain})`)}}_receiveOneMessage(c){if(this._isDisposed)return;const h=c.byteLength,p=v.read(c,0),D=p.readUInt8(),T=p.readUInt32();switch(D){case 1:case 2:{let{rpcId:o,method:A,args:L}=t.deserializeRequestJSONArgs(p);this._uriTransformer&&(L=(0,y.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(h,T,o,A,L,D===2);break}case 3:case 4:{let{rpcId:o,method:A,args:L}=t.deserializeRequestMixedArgs(p);this._uriTransformer&&(L=(0,y.transformIncomingURIs)(L,this._uriTransformer)),this._receiveRequest(h,T,o,A,L,D===4);break}case 5:{this._logger&&this._logger.logIncoming(h,T,0,"ack"),this._onDidReceiveAcknowledge(T);break}case 6:{this._receiveCancel(h,T);break}case 7:{this._receiveReply(h,T,void 0);break}case 9:{let o=t.deserializeReplyOKJSON(p);this._uriTransformer&&(o=(0,y.transformIncomingURIs)(o,this._uriTransformer)),this._receiveReply(h,T,o);break}case 8:{let o=t.deserializeReplyOKVSBuffer(p);this._receiveReply(h,T,o);break}case 10:{let o=t.deserializeReplyErrError(p);this._uriTransformer&&(o=(0,y.transformIncomingURIs)(o,this._uriTransformer)),this._receiveReplyErr(h,T,o);break}case 11:{this._receiveReplyErr(h,T,void 0);break}default:console.error("received unexpected message"),console.error(c)}}_receiveRequest(c,h,p,D,T,o){this._logger&&this._logger.logIncoming(c,h,1,`receiveRequest ${(0,k.getStringIdentifierForProxy)(p)}.${D}(`,T);const A=String(h);let L,$;if(o){const he=new F.CancellationTokenSource;T.push(he.token),L=this._invokeHandler(p,D,T),$=()=>he.cancel()}else L=this._invokeHandler(p,D,T),$=w;this._cancelInvokedHandlers[A]=$;const oe=t.serializeAcknowledged(h);this._logger&&this._logger.logOutgoing(oe.byteLength,h,1,"ack"),this._protocol.send(oe),L.then(he=>{delete this._cancelInvokedHandlers[A];const Q=t.serializeReplyOK(h,he,this._uriReplacer);this._logger&&this._logger.logOutgoing(Q.byteLength,h,1,"reply:",he),this._protocol.send(Q)},he=>{delete this._cancelInvokedHandlers[A];const Q=t.serializeReplyErr(h,he);this._logger&&this._logger.logOutgoing(Q.byteLength,h,1,"replyErr:",he),this._protocol.send(Q)})}_receiveCancel(c,h){this._logger&&this._logger.logIncoming(c,h,1,"receiveCancel");const p=String(h);this._cancelInvokedHandlers[p]&&this._cancelInvokedHandlers[p]()}_receiveReply(c,h,p){this._logger&&this._logger.logIncoming(c,h,0,"receiveReply:",p);const D=String(h);if(!this._pendingRPCReplies.hasOwnProperty(D))return;const T=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D],T.resolveOk(p)}_receiveReplyErr(c,h,p){this._logger&&this._logger.logIncoming(c,h,0,"receiveReplyErr:",p);const D=String(h);if(!this._pendingRPCReplies.hasOwnProperty(D))return;const T=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D];let o;p&&(p.$isError?(o=new Error,o.name=p.name,o.message=p.message,o.stack=p.stack):o=p),T.resolveErr(o)}_invokeHandler(c,h,p){try{return Promise.resolve(this._doInvokeHandler(c,h,p))}catch(D){return Promise.reject(D)}}_doInvokeHandler(c,h,p){const D=this._locals[c];if(!D)throw new Error("Unknown actor "+(0,k.getStringIdentifierForProxy)(c));let T=D[h];if(typeof T!="function")throw new Error("Unknown method "+h+" on actor "+(0,k.getStringIdentifierForProxy)(c));return T.apply(D,p)}_remoteCall(c,h,p){if(this._isDisposed)return Promise.reject(S.canceled());let D=null;if(p.length>0&&F.CancellationToken.isCancellationToken(p[p.length-1])&&(D=p.pop()),D&&D.isCancellationRequested)return Promise.reject(S.canceled());const T=t.serializeRequestArguments(p,this._uriReplacer),o=++this._lastMessageId,A=String(o),L=new _.LazyPromise;D&&D.onCancellationRequested(()=>{const oe=t.serializeCancel(o);this._logger&&this._logger.logOutgoing(oe.byteLength,o,0,"cancel"),this._protocol.send(t.serializeCancel(o))}),this._pendingRPCReplies[A]=L,this._onWillSendRequest(o);const $=t.serializeRequest(o,c,h,T,!!D);return this._logger&&this._logger.logOutgoing($.byteLength,o,0,`request: ${(0,k.getStringIdentifierForProxy)(c)}.${h}(`,p),this._protocol.send($),L}}e.RPCProtocol=f,I=P,f.UNRESPONSIVE_TIME=3*1e3;class v{constructor(c,h){this._buff=c,this._offset=h}static alloc(c,h,p){let D=new v(n.VSBuffer.alloc(p+1+4),0);return D.writeUInt8(c),D.writeUInt32(h),D}static read(c,h){return new v(c,h)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(c){this._buff.writeUInt8(c,this._offset),this._offset+=1}readUInt8(){const c=this._buff.readUInt8(this._offset);return this._offset+=1,c}writeUInt32(c){this._buff.writeUInt32BE(c,this._offset),this._offset+=4}readUInt32(){const c=this._buff.readUInt32BE(this._offset);return this._offset+=4,c}static sizeShortString(c){return 1+c.byteLength}writeShortString(c){this._buff.writeUInt8(c.byteLength,this._offset),this._offset+=1,this._buff.set(c,this._offset),this._offset+=c.byteLength}readShortString(){const c=this._buff.readUInt8(this._offset);this._offset+=1;const p=this._buff.slice(this._offset,this._offset+c).toString();return this._offset+=c,p}static sizeLongString(c){return 4+c.byteLength}writeLongString(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}readLongString(){const c=this._buff.readUInt32BE(this._offset);this._offset+=4;const p=this._buff.slice(this._offset,this._offset+c).toString();return this._offset+=c,p}writeBuffer(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}static sizeVSBuffer(c){return 4+c.byteLength}writeVSBuffer(c){this._buff.writeUInt32BE(c.byteLength,this._offset),this._offset+=4,this._buff.set(c,this._offset),this._offset+=c.byteLength}readVSBuffer(){const c=this._buff.readUInt32BE(this._offset);this._offset+=4;const h=this._buff.slice(this._offset,this._offset+c);return this._offset+=c,h}static sizeMixedArray(c,h){let p=0;p+=1;for(let D=0,T=c.length;D<T;D++){const o=c[D],A=h[D];switch(p+=1,A){case 1:p+=this.sizeLongString(o);break;case 2:p+=this.sizeVSBuffer(o);break;case 3:break}}return p}writeMixedArray(c,h){this._buff.writeUInt8(c.length,this._offset),this._offset+=1;for(let p=0,D=c.length;p<D;p++){const T=c[p];switch(h[p]){case 1:this.writeUInt8(1),this.writeLongString(T);break;case 2:this.writeUInt8(2),this.writeVSBuffer(T);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const c=this._buff.readUInt8(this._offset);this._offset+=1;let h=new Array(c);for(let p=0;p<c;p++)switch(this.readUInt8()){case 1:h[p]=this.readLongString();break;case 2:h[p]=this.readVSBuffer();break;case 3:h[p]=void 0;break}return h}}class t{static _arrayContainsBufferOrUndefined(c){for(let h=0,p=c.length;h<p;h++)if(c[h]instanceof n.VSBuffer||typeof c[h]=="undefined")return!0;return!1}static serializeRequestArguments(c,h){if(this._arrayContainsBufferOrUndefined(c)){let p=[],D=[];for(let T=0,o=c.length;T<o;T++){const A=c[T];A instanceof n.VSBuffer?(p[T]=A,D[T]=2):typeof A=="undefined"?(p[T]=n.VSBuffer.alloc(0),D[T]=3):(p[T]=n.VSBuffer.fromString(d(A,h)),D[T]=1)}return{type:"mixed",args:p,argsType:D}}return{type:"simple",args:d(c,h)}}static serializeRequest(c,h,p,D,T){return D.type==="mixed"?this._requestMixedArgs(c,h,p,D.args,D.argsType,T):this._requestJSONArgs(c,h,p,D.args,T)}static _requestJSONArgs(c,h,p,D,T){const o=n.VSBuffer.fromString(p),A=n.VSBuffer.fromString(D);let L=0;L+=v.sizeUInt8(),L+=v.sizeShortString(o),L+=v.sizeLongString(A);let $=v.alloc(T?2:1,c,L);return $.writeUInt8(h),$.writeShortString(o),$.writeLongString(A),$.buffer}static deserializeRequestJSONArgs(c){const h=c.readUInt8(),p=c.readShortString(),D=c.readLongString();return{rpcId:h,method:p,args:JSON.parse(D)}}static _requestMixedArgs(c,h,p,D,T,o){const A=n.VSBuffer.fromString(p);let L=0;L+=v.sizeUInt8(),L+=v.sizeShortString(A),L+=v.sizeMixedArray(D,T);let $=v.alloc(o?4:3,c,L);return $.writeUInt8(h),$.writeShortString(A),$.writeMixedArray(D,T),$.buffer}static deserializeRequestMixedArgs(c){const h=c.readUInt8(),p=c.readShortString(),D=c.readMixedArray(),T=new Array(D.length);for(let o=0,A=D.length;o<A;o++){const L=D[o];typeof L=="string"?T[o]=JSON.parse(L):T[o]=L}return{rpcId:h,method:p,args:T}}static serializeAcknowledged(c){return v.alloc(5,c,0).buffer}static serializeCancel(c){return v.alloc(6,c,0).buffer}static serializeReplyOK(c,h,p){return typeof h=="undefined"?this._serializeReplyOKEmpty(c):h instanceof n.VSBuffer?this._serializeReplyOKVSBuffer(c,h):this._serializeReplyOKJSON(c,l(h,p))}static _serializeReplyOKEmpty(c){return v.alloc(7,c,0).buffer}static _serializeReplyOKVSBuffer(c,h){let p=0;p+=v.sizeVSBuffer(h);let D=v.alloc(8,c,p);return D.writeVSBuffer(h),D.buffer}static deserializeReplyOKVSBuffer(c){return c.readVSBuffer()}static _serializeReplyOKJSON(c,h){const p=n.VSBuffer.fromString(h);let D=0;D+=v.sizeLongString(p);let T=v.alloc(9,c,D);return T.writeLongString(p),T.buffer}static deserializeReplyOKJSON(c){const h=c.readLongString();return JSON.parse(h)}static serializeReplyErr(c,h){return h?this._serializeReplyErrEror(c,h):this._serializeReplyErrEmpty(c)}static _serializeReplyErrEror(c,h){const p=n.VSBuffer.fromString(l(S.transformErrorForSerialization(h),null));let D=0;D+=v.sizeLongString(p);let T=v.alloc(10,c,D);return T.writeLongString(p),T.buffer}static deserializeReplyErrError(c){const h=c.readLongString();return JSON.parse(h)}static _serializeReplyErrEmpty(c){return v.alloc(11,c,0).buffer}}var r;(function(i){i[i.RequestJSONArgs=1]="RequestJSONArgs",i[i.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",i[i.RequestMixedArgs=3]="RequestMixedArgs",i[i.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",i[i.Acknowledged=5]="Acknowledged",i[i.Cancel=6]="Cancel",i[i.ReplyOKEmpty=7]="ReplyOKEmpty",i[i.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",i[i.ReplyOKJSON=9]="ReplyOKJSON",i[i.ReplyErrError=10]="ReplyErrError",i[i.ReplyErrEmpty=11]="ReplyErrEmpty"})(r||(r={}));var s;(function(i){i[i.String=1]="String",i[i.VSBuffer=2]="VSBuffer",i[i.Undefined=3]="Undefined"})(s||(s={}))}),define(be[220],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const g=function(E){const C=y=>{self.removeEventListener("message",C);const _=y.data;Object.defineProperties(self,{postMessage:{value(k,n){_.postMessage(k,n)}},onmessage:{get(){return _.onmessage},set(k){_.onmessage=k}}}),_.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),_.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(E)};self.addEventListener("message",C)}.toString();class F extends EventTarget{constructor(E,C,y){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const _=`((${g})('${C}'))`,k=new Blob([_],{type:"application/javascript"}),n=URL.createObjectURL(k),I=new MessageChannel,l=n,d={type:"_newWorker",id:l,port:I.port2,url:n,options:y};E(d,[I.port2]),this.postMessage=I.port1.postMessage.bind(I.port1),this.terminate=()=>{const u={type:"_terminateWorker",id:l};I.port1.postMessage(u),URL.revokeObjectURL(n),I.port1.close(),I.port2.close()},Object.defineProperties(this,{onmessage:{get(){return I.port1.onmessage},set(u){I.port1.onmessage=u}},onmessageerror:{get(){return I.port1.onmessageerror},set(u){I.port1.onmessageerror=u}}}),I.port1.addEventListener("messageerror",u=>{const m=new MessageEvent("messageerror",{data:u.data});this.dispatchEvent(m)}),I.port1.addEventListener("message",u=>{const m=new MessageEvent("message",{data:u.data});this.dispatchEvent(m)}),I.port1.start()}}e.NestedWorker=F}),define(be[221],Ee([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,g.createDecorator)("remoteAgentService")}),define(be[222],Ee([0,1,11,14,22,2,4,96,46,184,221]),function(ee,e,g,F,S,E,C,y,_,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,C.createDecorator)("pathService");let I=class Bn{constructor(d,u,m,b){this.localUserHome=d,this.remoteAgentService=u,this.environmentService=m,this.contextService=b,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||S.OS)(),this.resolveUserHome=(async()=>{const w=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=w?.userHome||d})()}get defaultUriScheme(){return Bn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(d,u){if(d.remoteAuthority)return g.Schemas.vscodeRemote;const m=(0,y.getVirtualWorkspaceScheme)(u.getWorkspace());if(m)return m;const b=u.getWorkspace().folders[0];if(b)return b.uri.scheme;const w=u.getWorkspace().configuration;return w?w.scheme:g.Schemas.file}async userHome(d){return d?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(d=>d===1?F.win32:F.posix)}async fileURI(d){let u="";if(await this.resolveOS===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const b=d.indexOf("/",2);b===-1?(u=d.substring(2),d="/"):(u=d.substring(2,b),d=d.substring(b)||"/")}return E.URI.from({scheme:g.Schemas.file,authority:u,path:d,query:"",fragment:""})}};I=ze([qe(1,n.IRemoteAgentService),qe(2,k.IWorkbenchEnvironmentService),qe(3,_.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(be[107],Ee([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class g{constructor(C,y){this.line=C,this.character=y}isBefore(C){return!1}isBeforeOrEqual(C){return!1}isAfter(C){return!1}isAfterOrEqual(C){return!1}isEqual(C){return!1}compareTo(C){return 0}translate(C,y){return new g(0,0)}with(C){return new g(0,0)}}e.Position=g;class F{constructor(C,y,_,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new g(C,y),this.end=new g(_,k)}contains(C){return!1}isEqual(C){return!1}intersection(C){}union(C){return new F(0,0,0,0)}with(C){return new F(0,0,0,0)}}e.Range=F;var S;(function(E){E[E.Information=1]="Information",E[E.Warning=2]="Warning"})(S=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(be[39],Ee([0,1,17,27,23,44,8,4,14,12,107]),function(ee,e,g,F,S,E,C,y,_,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return n.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const I="\u27EA ",l=" characters skipped \u27EB",d=(I.length+l.length+5)*2;e.ISearchService=(0,y.createDecorator)("searchService");var u;(function(R){R[R.file=0]="file",R[R.text=1]="text"})(u=e.SearchProviderType||(e.SearchProviderType={}));var m;(function(R){R[R.File=1]="File",R[R.Text=2]="Text"})(m=e.QueryType||(e.QueryType={}));function b(R){return!!R.preview}e.resultIsMatch=b;function w(R){return!!R.resource}e.isFileMatch=w;function P(R){return!!R.message}e.isProgressMessage=P;var a;(function(R){R[R.Normal=0]="Normal",R[R.NewSearchStarted=1]="NewSearchStarted"})(a=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class f{constructor(G){this.resource=G,this.results=[]}}e.FileMatch=f;class v{constructor(G,x,j){this.ranges=x;const de=Array.isArray(x)?x:[x];if(j&&j.matchLines===1&&t(de)){G=(0,C.getNLines)(G,j.matchLines);let B="",ne=0,ue=0;const ye=Math.floor(j.charsPerLine/5),Re=[];for(const Te of de){const $e=Math.max(Te.startColumn-ye,0),Je=Te.startColumn+j.charsPerLine;if($e>ue+ye+d){const Ve=I+($e-ue)+l;B+=Ve+G.slice($e,Je),ne+=$e-(ue+Ve.length)}else B+=G.slice(ue,Je);Re.push(new s(0,Te.startColumn-ne,Te.endColumn-ne)),ue=Je}this.preview={text:B,matches:Array.isArray(this.ranges)?Re:Re[0]}}else{const B=Array.isArray(x)?x[0].startLineNumber:x.startLineNumber;this.preview={text:G,matches:(0,g.mapArrayOrNot)(x,ne=>new r(ne.startLineNumber-B,ne.startColumn,ne.endLineNumber-B,ne.endColumn))}}}}e.TextSearchMatch=v;function t(R){const G=R[0].startLineNumber;for(const x of R)if(x.startLineNumber!==G||x.endLineNumber!==G)return!1;return!0}class r{constructor(G,x,j,de){this.startLineNumber=G,this.startColumn=x,this.endLineNumber=j,this.endColumn=de}}e.SearchRange=r;class s extends r{constructor(G,x,j){super(G,x,G,j)}}e.OneLineRange=s;var i;(function(R){R.Default="default",R.FileNames="fileNames",R.Type="type",R.Modified="modified",R.CountDescending="countDescending",R.CountAscending="countAscending"})(i=e.SearchSortOrder||(e.SearchSortOrder={}));function c(R,G=!0){const x=R&&R.files&&R.files.exclude,j=G&&R&&R.search&&R.search.exclude;if(!x&&!j)return;if(!x||!j)return x||j;let de=Object.create(null);return de=S.mixin(de,S.deepClone(x)),de=S.mixin(de,S.deepClone(j),!0),de}e.getExcludes=c;function h(R,G){return R.excludePattern&&F.match(R.excludePattern,G)?!1:R.includePattern||R.usingSearchPaths?R.includePattern&&F.match(R.includePattern,G)?!0:R.usingSearchPaths?!!R.folderQueries&&R.folderQueries.some(x=>{const j=x.folder.fsPath;if(E.isEqualOrParent(G,j)){const de=_.relative(j,G);return!x.includePattern||!!F.match(x.includePattern,de)}else return!1}):!1:!0}e.pathIncludedInQuery=h;var p;(function(R){R[R.unknownEncoding=1]="unknownEncoding",R[R.regexParseError=2]="regexParseError",R[R.globParseError=3]="globParseError",R[R.invalidLiteral=4]="invalidLiteral",R[R.rgProcessError=5]="rgProcessError",R[R.other=6]="other",R[R.canceled=7]="canceled"})(p=e.SearchErrorCode||(e.SearchErrorCode={}));class D extends Error{constructor(G,x){super(G);this.code=x}}e.SearchError=D;function T(R){const G=R.message;if((0,k.isPromiseCanceledError)(R))return new D(G,p.canceled);try{const x=JSON.parse(G);return new D(x.message,x.code)}catch(x){return new D(G,p.other)}}e.deserializeSearchError=T;function o(R){const G={message:R.message,code:R.code};return new Error(JSON.stringify(G))}e.serializeSearchError=o;function A(R){return R.type==="error"?!0:R.type==="success"}e.isSerializedSearchComplete=A;function L(R){return R.type==="success"}e.isSerializedSearchSuccess=L;function $(R){return!!R.path}e.isSerializedFileMatch=$;function oe(R,G){const x=R.searchPath?R.searchPath:R.relativePath;return(0,C.fuzzyContains)(x,G)}e.isFilePatternMatch=oe;class he{constructor(G){this.path=G,this.results=[]}addMatch(G){this.results.push(G)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=he;function Q(R,G){const x={...R||{},...G||{}};return Object.keys(x).filter(j=>{const de=x[j];return typeof de=="boolean"&&de})}e.resolvePatternsForProvider=Q;class z{constructor(G,x){this._parsedIncludeExpression=null,this._excludeExpression={...G.excludePattern||{},...x.excludePattern||{}},this._parsedExcludeExpression=F.parse(this._excludeExpression);let j=G.includePattern;x.includePattern&&(j?j={...j,...x.includePattern}:j=x.includePattern),j&&(this._parsedIncludeExpression=F.parse(j))}includedInQuerySync(G,x,j){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(G,x,j)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(G,x,j))}includedInQuery(G,x,j){return Promise.resolve(this._parsedExcludeExpression(G,x,j)).then(B=>!!B).then(B=>B?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(G,x,j)).then(ne=>!!ne):Promise.resolve(!0)).then(B=>B)}hasSiblingExcludeClauses(){return V(this._excludeExpression)}}e.QueryGlobTester=z;function V(R){for(const G in R)if(typeof R[G]!="boolean")return!0;return!1}}),define(be[32],Ee([0,1,17,16,20,3,21,11,81,25,8,10,2,139,4,15,154,46,47,29,13,7,39,5]),function(ee,e,g,F,S,E,C,y,_,k,n,I,l,d,u,m,b,w,P,a,f,v,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(A,L,$){return new k.ExtUri(oe=>p(oe,$)).isEqual(A,L)}function i(A,L,$){return s(A.uri,L.uri,$)?0:(0,n.compare)(A.uri.toString(),L.uri.toString())}function c(A,L,$){return A.index!==L.index?A.index<L.index?-1:1:s(A.uri,L.uri,$)?(0,n.compare)(A.name,L.name):(0,n.compare)(A.uri.toString(),L.uri.toString())}function h(A,L,$,oe){const he=A.slice(0).sort((z,V)=>$(z,V,oe)),Q=L.slice(0).sort((z,V)=>$(z,V,oe));return(0,g.delta)(he,Q,(z,V)=>$(z,V,oe))}function p(A,L){const $=L.getCapabilities(A.scheme);return!($&&$&1024)}class D extends w.Workspace{constructor(L,$,oe,he,Q,z){super(L,oe.map(V=>new w.WorkspaceFolder(V)),he,z);this._name=$,this._isUntitled=Q,this._workspaceFolders=[],this._structure=C.TernarySearchTree.forUris(z),oe.forEach(V=>{this._workspaceFolders.push(V),this._structure.set(V.uri,V)})}static toExtHostWorkspace(L,$,oe,he){if(!L)return{workspace:null,added:[],removed:[]};const{id:Q,name:z,folders:V,configuration:R,isUntitled:G}=L,x=[],j=$;$?V.forEach((ue,ye)=>{const Re=l.URI.revive(ue.uri),Te=D._findFolder(oe||$,Re,he);Te?(Te.name=ue.name,Te.index=ue.index,x.push(Te)):x.push({uri:Re,name:ue.name,index:ye})}):x.push(...V.map(({uri:ue,name:ye,index:Re})=>({uri:l.URI.revive(ue),name:ye,index:Re}))),x.sort((ue,ye)=>ue.index<ye.index?-1:1);const de=new D(Q,z,x,R?l.URI.revive(R):null,!!G,ue=>p(ue,he)),{added:B,removed:ne}=h(j?j.workspaceFolders:[],de.workspaceFolders,i,he);return{workspace:de,added:B,removed:ne}}static _findFolder(L,$,oe){for(let he=0;he<L.folders.length;he++){const Q=L.workspaceFolders[he];if(s(Q.uri,$,oe))return Q}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,$){return $&&this._structure.get(L)&&(L=(0,k.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let T=class{constructor(L,$,oe,he){this._onDidChangeWorkspace=new E.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new E.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=he,this._extHostFileSystemInfo=oe,this._requestIdProvider=new _.Counter,this._barrier=new F.Barrier,this._proxy=L.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(r.MainContext.MainThreadMessageService);const Q=$.workspace;this._confirmedWorkspace=Q?new D(Q.id,Q.name,[],Q.configuration?l.URI.revive(Q.configuration):null,!!Q.isUntitled,z=>p(z,oe)):void 0}$initializeWorkspace(L,$){this._trusted=$,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?l.URI.from({scheme:y.Schemas.untitled,path:(0,k.basename)((0,k.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,$,oe,...he){const Q=[];if(Array.isArray(he)&&he.forEach(x=>{l.URI.isUri(x.uri)&&!Q.some(j=>s(j.uri,x.uri,this._extHostFileSystemInfo))&&Q.push({uri:x.uri,name:x.name||(0,k.basenameOrAuthority)(x.uri)})}),this._unconfirmedWorkspace||[$,oe].some(x=>typeof x!="number"||x<0)||oe===0&&Q.length===0)return!1;const z=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if($+oe>z.length)return!1;const V=z.slice(0);V.splice($,oe,...Q.map(x=>({uri:x.uri,name:x.name||(0,k.basenameOrAuthority)(x.uri),index:void 0})));for(let x=0;x<V.length;x++){const j=V[x];if(V.some((de,B)=>B!==x&&s(j.uri,de.uri,this._extHostFileSystemInfo)))return!1}V.forEach((x,j)=>x.index=j);const{added:R,removed:G}=h(z,V,c,this._extHostFileSystemInfo);if(R.length===0&&G.length===0)return!1;if(this._proxy){const x=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(x,$,oe,Q).then(void 0,j=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(b.Severity.Error,(0,d.localize)(0,null,x,j.toString()),{extension:L},[])})}return this.trySetWorkspaceFolders(V),!0}getWorkspaceFolder(L,$){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,$)}async getWorkspaceFolder2(L,$){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,$)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!this._actualWorkspace)return;const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,$){let oe,he="";if(typeof L=="string"?(oe=l.URI.file(L),he=L):typeof L!="undefined"&&(oe=L,he=L.fsPath),!oe)return he;const Q=this.getWorkspaceFolder(oe,!0);if(!Q)return he;typeof $=="undefined"&&this._actualWorkspace&&($=this._actualWorkspace.folders.length>1);let z=(0,k.relativePath)(Q.uri,oe);return $&&Q.name&&(z=`${Q.name}/${z}`),z}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=D.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:$,added:oe,removed:he}=D.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=$||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:oe,removed:he}))}findFiles(L,$,oe,he,Q=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${he.value}, entryPoint: findFiles`);let z;if($===null?z=!1:$&&(typeof $=="string"?z=$:z=$.pattern),Q&&Q.isCancellationRequested)return Promise.resolve([]);const{includePattern:V,folder:R}=o(L);return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)(V),(0,I.withUndefinedAsNull)(R),(0,I.withUndefinedAsNull)(z),(0,I.withUndefinedAsNull)(oe),Q).then(G=>Array.isArray(G)?G.map(x=>l.URI.revive(x)):[])}async findTextInFiles(L,$,oe,he,Q=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${he.value}, entryPoint: findTextInFiles`);const z=this._requestIdProvider.getNext(),V=typeof $.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:$.previewOptions,{includePattern:R,folder:G}=o($.include),x=typeof $.exclude=="string"?$.exclude:$.exclude?$.exclude.pattern:void 0,j={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useGlobalIgnoreFiles=="boolean"?!$.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof $.useDefaultExcludes=="boolean"?!$.useDefaultExcludes:!0,fileEncoding:$.encoding,maxResults:$.maxResults,previewOptions:V,afterContext:$.afterContext,beforeContext:$.beforeContext,includePattern:R,excludePattern:x},de=!1;if(this._activeSearchCallbacks[z]=B=>{if(de)return;const ne=l.URI.revive(B.resource);B.results.forEach(ue=>{(0,t.resultIsMatch)(ue)?oe({uri:ne,preview:{text:ue.preview.text,matches:(0,g.mapArrayOrNot)(ue.preview.matches,ye=>new v.Range(ye.startLineNumber,ye.startColumn,ye.endLineNumber,ye.endColumn))},ranges:(0,g.mapArrayOrNot)(ue.ranges,ye=>new v.Range(ye.startLineNumber,ye.startColumn,ye.endLineNumber,ye.endColumn))}):oe({uri:ne,text:ue.text,lineNumber:ue.lineNumber})})},Q.isCancellationRequested)return{};try{const B=await this._proxy.$startTextSearch(L,(0,I.withUndefinedAsNull)(G),j,z,Q);return delete this._activeSearchCallbacks[z],B||{}}catch(B){throw delete this._activeSearchCallbacks[z],B}}$handleTextSearchResult(L,$){this._activeSearchCallbacks[$]&&this._activeSearchCallbacks[$](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};T=ze([qe(0,f.IExtHostRpcService),qe(1,a.IExtHostInitDataService),qe(2,P.IExtHostFileSystemInfo),qe(3,m.ILogService)],T),e.ExtHostWorkspace=T,e.IExtHostWorkspace=(0,u.createDecorator)("IExtHostWorkspace");function o(A){let L,$;return A&&(typeof A=="string"?L=A:(L=A.pattern,$=A.baseFolder||l.URI.file(A.base))),{includePattern:L,folder:$}}}),define(be[33],Ee([0,1,23,3,32,5,7,157,63,10,16,4,13,15,2]),function(ee,e,g,F,S,E,C,y,_,k,n,I,l,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function m(r,s){if(s){const i=s.split(".");let c=r;for(let h=0;c&&h<i.length;h++)c=c[i[h]];return c}}function b(r){return r instanceof u.URI}function w(r){return r&&r.uri instanceof u.URI&&r.languageId&&typeof r.languageId=="string"}function P(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function a(r){return r&&r.uri instanceof u.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function f(r){if(b(r))return{resource:r};if(w(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(P(r))return{overrideIdentifier:r.languageId};if(a(r))return{resource:r.uri};if(r===null)return{resource:null}}let v=class{constructor(s,i,c){this._proxy=s.getProxy(E.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=c,this._barrier=new n.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,i){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(s,i))}};v=ze([qe(0,l.IExtHostRpcService),qe(1,S.IExtHostWorkspace),qe(2,d.ILogService)],v),e.ExtHostConfiguration=v;class t{constructor(s,i,c,h){this._onDidChangeConfiguration=new F.Emitter,this._proxy=s,this._logService=h,this._extHostWorkspace=i,this._configuration=y.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,i){const c={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=y.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,c))}getConfiguration(s,i,c){const h=f(i)||{},p=this._toReadonlyValue(s?m(this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,h,c?.identifier);function D(o){if(o==null)return null;if(typeof o=="boolean")return o?1:4;switch(o){case C.ConfigurationTarget.Global:return 1;case C.ConfigurationTarget.Workspace:return 4;case C.ConfigurationTarget.WorkspaceFolder:return 5}}const T={has(o){return typeof m(p,o)!="undefined"},get:(o,A)=>{this._validateConfigurationAccess(s?`${s}.${o}`:o,h,c?.identifier);let L=m(p,o);if(typeof L=="undefined")L=A;else{let $;const oe=(he,Q)=>{let z;const V=()=>{$=$||(0,g.deepClone)(p),z=z||m($,Q)};return(0,k.isObject)(he)?new Proxy(he,{get:(R,G)=>{if(typeof G=="string"&&G.toLowerCase()==="tojson")return V(),()=>z;if($)return z=z||m($,Q),z[G];const x=R[G];return typeof G=="string"?oe(x,`${Q}.${G}`):x},set:(R,G,x)=>(V(),z&&(z[G]=x),!0),deleteProperty:(R,G)=>(V(),z&&delete z[G],!0),defineProperty:(R,G,x)=>(V(),z&&Object.defineProperty(z,G,x),!0)}):he};L=oe(L,o)}return L},update:(o,A,L,$)=>{o=s?`${s}.${o}`:o;const oe=D(L);return A!==void 0?this._proxy.$updateConfigurationOption(oe,o,A,h,$):this._proxy.$removeConfigurationOption(oe,o,h,$)},inspect:o=>{o=s?`${s}.${o}`:o;const A=(0,g.deepClone)(this._configuration.inspect(o,h,this._extHostWorkspace.workspace));if(A)return{key:o,defaultValue:A.default?.value,globalValue:A.user?.value,workspaceValue:A.workspace?.value,workspaceFolderValue:A.workspaceFolder?.value,defaultLanguageValue:A.default?.override,globalLanguageValue:A.user?.override,workspaceLanguageValue:A.workspace?.override,workspaceFolderLanguageValue:A.workspaceFolder?.override,languageIds:A.overrideIdentifiers}}};return typeof p=="object"&&(0,g.mixin)(T,p,!1),Object.freeze(T)}_toReadonlyValue(s){const i=c=>(0,k.isObject)(c)?new Proxy(c,{get:(h,p)=>i(h[p]),set:(h,p,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(p)}' of object`)},deleteProperty:(h,p)=>{throw new Error(`TypeError: Cannot delete read only property '${String(p)}' of object`)},defineProperty:(h,p)=>{throw new Error(`TypeError: Cannot define property '${String(p)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return i(s)}_validateConfigurationAccess(s,i,c){const h=_.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),p=c?`[${c.value}] `:"";if(h===4){typeof i?.resource=="undefined"&&this._logService.warn(`${p}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){i?.resource&&this._logService.warn(`${p}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,i){const c=new y.ConfigurationChangeEvent(s,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(h,p)=>c.affectsConfiguration(h,f(p))})}_toMap(s){return s.reduce((i,c)=>(i.set(c[0],c[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(ee,e,g,F,S){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Ue=this&&this.__classPrivateFieldGet||function(ee,e,g,F){if(g==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?F:g==="a"?F.call(ee):F?F.value:e.get(ee)};define(be[108],Ee([0,1,2,16,3,5,7,32,48,33,20,38,13,29,4,11,22,15,74,174,12]),function(ee,e,g,F,S,E,C,y,_,k,n,I,l,d,u,m,b,w,P,a,f){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(he){function Q(V){if(V!=null)return V}he.from=Q;function z(V){if(V!=null)return V}he.to=z})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var r;(function(he){function Q(V){if(V!=null)return V}he.from=Q;function z(V){if(V!=null)return V}he.to=z})(r=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(he){function Q(V){if(V!=null)return V}he.from=Q;function z(V){if(V!=null)return V}he.to=z})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(he){function Q(R){if(R){const G=R;return G&&!!G.process}else return!1}he.is=Q;function z(R){if(R==null)return;const G={process:R.process,args:R.args};return R.options&&(G.options=s.from(R.options)),G}he.from=z;function V(R){if(R!=null)return new C.ProcessExecution(R.process,R.args,R.options)}he.to=V})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var c;(function(he){function Q(V){if(V!=null)return V}he.from=Q;function z(V){if(V!=null)return V}he.to=z})(c=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var h;(function(he){function Q(R){if(R){const G=R;return G&&(!!G.commandLine||!!G.command)}else return!1}he.is=Q;function z(R){if(R==null)return;const G={};return R.commandLine!==void 0?G.commandLine=R.commandLine:(G.command=R.command,G.args=R.args),R.options&&(G.options=c.from(R.options)),G}he.from=z;function V(R){if(!(R==null||R.command===void 0&&R.commandLine===void 0))return R.commandLine?new C.ShellExecution(R.commandLine,R.options):new C.ShellExecution(R.command,R.args?R.args:[],R.options)}he.to=V})(h=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var p;(function(he){function Q(R){if(R){let G=R;return G&&G.customExecution==="customExecution"}else return!1}he.is=Q;function z(R){return{customExecution:"customExecution"}}he.from=z;function V(R,G){return G.get(R)}he.to=V})(p=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var D;(function(he){function Q(z,V){let R;return z.scope!==void 0&&typeof z.scope!="number"?R=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===C.TaskScope.Workspace&&V&&V.workspaceFile?R=V.workspaceFile:R=a.USER_TASKS_GROUP_KEY),{id:z._id,workspaceFolder:R}}he.from=Q})(D=e.TaskHandleDTO||(e.TaskHandleDTO={}));var T;(function(he){function Q(R,G){if(R==null)return[];const x=[];for(let j of R){const de=z(j,G);de&&x.push(de)}return x}he.fromMany=Q;function z(R,G){if(R==null)return;let x;R.execution instanceof C.ProcessExecution?x=i.from(R.execution):R.execution instanceof C.ShellExecution?x=h.from(R.execution):R.execution&&R.execution instanceof C.CustomExecution&&(x=p.from(R.execution));const j=t.from(R.definition);let de;if(R.scope?typeof R.scope=="number"?de=R.scope:de=R.scope.uri:de=C.TaskScope.Workspace,!j||!de)return;const B=R.group?R.group.id:void 0;return{_id:R._id,definition:j,name:R.name,source:{extensionId:G.identifier.value,label:R.source,scope:de},execution:x,isBackground:R.isBackground,group:B,presentationOptions:r.from(R.presentationOptions),problemMatchers:R.problemMatchers,hasDefinedMatchers:R.hasDefinedMatchers,runOptions:R.runOptions?R.runOptions:{reevaluateOnRerun:!0},detail:R.detail}}he.from=z;async function V(R,G,x){if(R==null)return;let j;i.is(R.execution)?j=i.to(R.execution):h.is(R.execution)?j=h.to(R.execution):p.is(R.execution)&&(j=p.to(R._id,x));const de=t.to(R.definition);let B;if(R.source&&(R.source.scope!==void 0?typeof R.source.scope=="number"?B=R.source.scope:B=await G.resolveWorkspaceFolder(g.URI.revive(R.source.scope)):B=C.TaskScope.Workspace),!de||!B)return;const ne=new C.Task(de,B,R.name,R.source.label,j,R.problemMatchers);return R.isBackground!==void 0&&(ne.isBackground=R.isBackground),R.group!==void 0&&(ne.group=C.TaskGroup.from(R.group)),R.presentationOptions&&(ne.presentationOptions=r.to(R.presentationOptions)),R._id&&(ne._id=R._id),R.detail&&(ne.detail=R.detail),ne}he.to=V})(T=e.TaskDTO||(e.TaskDTO={}));var o;(function(he){function Q(V){return V}he.from=Q;function z(V){if(!!V)return Object.assign(Object.create(null),V)}he.to=z})(o=e.TaskFilterDTO||(e.TaskFilterDTO={}));class A{constructor(Q,z,V){this._id=z,this._task=V,v.set(this,void 0),nt(this,v,Q,"f")}get task(){return this._task}terminate(){Ue(this,v,"f").terminateTask(this)}fireDidStartProcess(Q){}fireDidEndProcess(Q){}}v=new WeakMap;var L;(function(he){function Q(z){return{id:z._id,task:void 0}}he.from=Q})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let $=class{constructor(Q,z,V,R,G,x,j,de){this._onDidExecuteTask=new S.Emitter,this._onDidTerminateTask=new S.Emitter,this._onDidTaskProcessStarted=new S.Emitter,this._onDidTaskProcessEnded=new S.Emitter,this._proxy=Q.getProxy(E.MainContext.MainThreadTask),this._workspaceProvider=V,this._editorService=R,this._configurationService=G,this._terminalService=x,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=j,this._deprecationService=de,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(Q,z,V){if(!V)return new C.Disposable(()=>{});const R=this.nextHandle();return this._handlers.set(R,{type:z,provider:V,extension:Q}),this._proxy.$registerTaskProvider(R,z),new C.Disposable(()=>{this._handlers.delete(R),this._proxy.$unregisterTaskProvider(R)})}registerTaskSystem(Q,z){this._proxy.$registerTaskSystem(Q,z)}fetchTasks(Q){return this._proxy.$fetchTasks(o.from(Q)).then(async z=>{const V=[];for(let R of z){const G=await T.to(R,this._workspaceProvider,this._providedCustomExecutions2);G&&V.push(G)}return V})}get taskExecutions(){const Q=[];return this._taskExecutions.forEach(z=>Q.push(z)),Q}terminateTask(Q){if(!(Q instanceof A))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(Q._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(Q,z,V){const R=this._providedCustomExecutions2.get(Q.id);if(R){if(this._activeCustomExecutions2.get(Q.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(Q.id,R),this._terminalService.attachPtyToTerminal(z,await R.callback(V))}this._lastStartedTask=Q.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(Q)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(Q){const z=await this.getTaskExecution(Q);this._taskExecutionPromises.delete(Q.id),this._taskExecutions.delete(Q.id),this.customExecutionComplete(Q),this._onDidTerminateTask.fire({execution:z})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(Q){const z=await this.getTaskExecution(Q.id);this._onDidTaskProcessStarted.fire({execution:z,processId:Q.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(Q){const z=await this.getTaskExecution(Q.id);this._onDidTaskProcessEnded.fire({execution:z,exitCode:Q.exitCode})}$provideTasks(Q,z){const V=this._handlers.get(Q);if(!V)return Promise.reject(new Error("no handler found"));const R=[],G=(0,F.asPromise)(()=>V.provider.provideTasks(n.CancellationToken.None)).then(x=>this.provideTasksInternal(z,R,V,x));return new Promise(x=>{G.then(j=>{Promise.all(R).then(()=>{x(j)})})})}async $resolveTask(Q,z){const V=this._handlers.get(Q);if(!V)return Promise.reject(new Error("no handler found"));if(z.definition.type!==V.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${V.type}].`);const R=await T.to(z,this._workspaceProvider,this._providedCustomExecutions2);if(!R)throw new Error("Unexpected: Task cannot be resolved.");const G=await V.provider.resolveTask(R,n.CancellationToken.None);if(!G)return;this.checkDeprecation(G,V);const x=T.from(G,V.extension);if(!x)throw new Error("Unexpected: Task cannot be resolved.");if(G.definition!==R.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(x.execution)&&await this.addCustomExecution(x,G,!0),await this.resolveTaskInternal(x)}nextHandle(){return this._handleCounter++}async addCustomExecution(Q,z,V){const R=await this._proxy.$createTaskId(Q);!V&&!this._providedCustomExecutions2.has(R)&&this._notProvidedCustomExecutions.add(R),this._providedCustomExecutions2.set(R,z.execution)}async getTaskExecution(Q,z){if(typeof Q=="string"){const G=this._taskExecutionPromises.get(Q);if(!G)throw new Error("Unexpected: The specified task is missing an execution");return G}let V=this._taskExecutionPromises.get(Q.id);if(V)return V;const R=new Promise(async(G,x)=>{const j=z||await T.to(Q.task,this._workspaceProvider,this._providedCustomExecutions2);j?G(new A(this,Q.id,j)):x("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(Q.id,R),R.then(G=>(this._taskExecutions.set(Q.id,G),G),G=>Promise.reject(G))}checkDeprecation(Q,z){Q._deprecated&&this._deprecationService.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(Q){this._activeCustomExecutions2.get(Q.id)&&this._activeCustomExecutions2.delete(Q.id),this._notProvidedCustomExecutions.has(Q.id)&&this._lastStartedTask!==Q.id&&(this._providedCustomExecutions2.delete(Q.id),this._notProvidedCustomExecutions.delete(Q.id));let V=this._notProvidedCustomExecutions.values(),R=V.next();for(;!R.done;)!this._activeCustomExecutions2.has(R.value)&&this._lastStartedTask!==R.value&&(this._providedCustomExecutions2.delete(R.value),this._notProvidedCustomExecutions.delete(R.value)),R=V.next()}};$=ze([qe(0,l.IExtHostRpcService),qe(1,d.IExtHostInitDataService),qe(2,y.IExtHostWorkspace),qe(3,_.IExtHostDocumentsAndEditors),qe(4,k.IExtHostConfiguration),qe(5,I.IExtHostTerminalService),qe(6,w.ILogService),qe(7,P.IExtHostApiDeprecationService)],$),e.ExtHostTaskBase=$;let oe=class extends ${constructor(Q,z,V,R,G,x,j,de){super(Q,z,V,R,G,x,j,de);this.registerTaskSystem(m.Schemas.vscodeRemote,{scheme:m.Schemas.vscodeRemote,authority:"",platform:b.PlatformToString(0)})}async executeTask(Q,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const V=T.from(z,Q);if(V===void 0)throw new Error("Task is not valid");if(p.is(V.execution))await this.addCustomExecution(V,z,!1);else throw new f.NotSupportedError;const R=await this.getTaskExecution(await this._proxy.$getTaskExecution(V),z);return this._proxy.$executeTask(V).catch(G=>{throw new Error(G)}),R}provideTasksInternal(Q,z,V,R){const G=[];if(R)for(let x of R){this.checkDeprecation(x,V),(!x.definition||!Q[x.definition.type])&&this._logService.warn(`The task [${x.source}, ${x.name}] uses an undefined task type. The task will be ignored in the future.`);const j=T.from(x,V.extension);j&&p.is(j.execution)?(G.push(j),z.push(this.addCustomExecution(j,x,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:G,extension:V.extension}}async resolveTaskInternal(Q){if(p.is(Q.execution))return Q;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(Q,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(Q,z,V){}};oe=ze([qe(0,l.IExtHostRpcService),qe(1,d.IExtHostInitDataService),qe(2,y.IExtHostWorkspace),qe(3,_.IExtHostDocumentsAndEditors),qe(4,k.IExtHostConfiguration),qe(5,I.IExtHostTerminalService),qe(6,w.ILogService),qe(7,P.IExtHostApiDeprecationService)],oe),e.WorkerExtHostTask=oe,e.IExtHostTask=(0,u.createDecorator)("IExtHostTask")}),define(be[223],Ee([0,1,17,50,27,84,21,11,14,25,8,10,2,120,143,94,46,100,222,39]),function(ee,e,g,F,S,E,C,y,_,k,n,I,l,d,u,m,b,w,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let f=class{constructor(D,T,o,A){this.configurationService=D,this.workspaceContextService=T,this.editorGroupsService=o,this.pathService=A}text(D,T,o={}){D=this.getContentPattern(D,o);const A=this.configurationService.getValue(),L=T&&T.some(oe=>!this.configurationService.getValue({resource:oe}).search.useRipgrep);return{...this.commonQuery(T?.map(b.toWorkspaceFolder),o),type:2,contentPattern:D,previewOptions:o.previewOptions,maxFileSize:o.maxFileSize,usePCRE2:A.search.usePCRE2||L||!1,beforeContext:o.beforeContext,afterContext:o.afterContext,userDisabledExcludesAndIgnoreFiles:o.disregardExcludeSettings&&o.disregardIgnoreFiles}}getContentPattern(D,T){const o=this.configurationService.getValue();D.isRegExp&&(D.pattern=D.pattern.replace(/\r?\n/g,"\\n"));const A={...D,wordSeparators:o.editor.wordSeparators};return this.isCaseSensitive(D,T)&&(A.isCaseSensitive=!0),this.isMultiline(D)&&(A.isMultiline=!0),A}file(D,T={}){return{...this.commonQuery(D,T),type:1,filePattern:T.filePattern?T.filePattern.trim():T.filePattern,exists:T.exists,sortByScore:T.sortByScore,cacheKey:T.cacheKey}}handleIncludeExclude(D,T){return D?(D=Array.isArray(D)?D.map(i):i(D),T?this.parseSearchPaths(D):{pattern:t(...Array.isArray(D)?D:[D])}):{}}commonQuery(D=[],T={}){const o=this.handleIncludeExclude(T.includePattern,T.expandPatterns),A=this.handleIncludeExclude(T.excludePattern,T.expandPatterns),L=D.length>1,$=(o.searchPaths&&o.searchPaths.length?o.searchPaths.map(Q=>this.getFolderQueryForSearchPath(Q,T,A)):D.map(Q=>this.getFolderQueryForRoot(Q,T,A,L))).filter(Q=>!!Q),oe={_reason:T._reason,folderQueries:$,usingSearchPaths:!!(o.searchPaths&&o.searchPaths.length),extraFileResources:T.extraFileResources,excludePattern:A.pattern,includePattern:o.pattern,onlyOpenEditors:T.onlyOpenEditors,maxResults:T.maxResults};if(T.onlyOpenEditors){const z=g.coalesce(g.flatten(this.editorGroupsService.groups.map(R=>R.editors.map(G=>G.resource)))).filter(R=>(0,a.pathIncludedInQuery)(oe,R.fsPath)),V=this.commonQueryFromFileList(z);return{...oe,...V}}const he=T.extraFileResources&&T.extraFileResources.filter(Q=>(0,a.pathIncludedInQuery)(oe,Q.fsPath));return oe.extraFileResources=he&&he.length?he:void 0,oe}commonQueryFromFileList(D){const T=[],o=new C.ResourceMap,A={};let L=!1;return D.forEach($=>{if($.scheme===y.Schemas.walkThrough)return;if((0,k.isAbsolutePath)($)){const he=this.workspaceContextService.getWorkspaceFolder($)?.uri??$.with({path:_.dirname($.fsPath)});let Q=o.get(he);Q||(L=!0,Q={folder:he,includePattern:{}},T.push(Q),o.set(he,Q));const z=_.relative(he.fsPath,$.fsPath);(0,I.assertIsDefined)(Q.includePattern)[z.replace(/\\/g,"/")]=!0}else $.fsPath&&(L=!0,A[$.fsPath]=!0)}),{folderQueries:T,includePattern:A,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(D,T){if(T.isSmartCase){if(D.isRegExp){if(n.containsUppercaseCharacter(D.pattern,!0))return!0}else if(n.containsUppercaseCharacter(D.pattern))return!0}return!!D.isCaseSensitive}isMultiline(D){return D.isMultiline||D.isRegExp&&(0,d.isMultilineRegexSource)(D.pattern)||D.pattern.indexOf(`
`)>=0?!0:!!D.isMultiline}parseSearchPaths(D){const T=V=>_.isAbsolute(V)||/^\.\.?([\/\\]|$)/.test(V),A=(Array.isArray(D)?D:r(D)).map(V=>{const R=this.pathService.resolvedUserHome;return R?(0,E.untildify)(V,R.scheme===y.Schemas.file?R.fsPath:R.path):V}),L=F.groupBy(A,V=>T(V)?"searchPaths":"exprSegments"),$=(L.exprSegments||[]).map(V=>n.rtrim(V,"/")).map(V=>n.rtrim(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),s(V))),oe={},he=this.expandSearchPathPatterns(L.searchPaths||[]);he&&he.length&&(oe.searchPaths=he);const Q=g.flatten($),z=t(...Q);return z&&(oe.pattern=z),oe}getExcludesForFolder(D,T){return T.disregardExcludeSettings?void 0:(0,a.getExcludes)(D,!T.disregardSearchExcludeSettings)}expandSearchPathPatterns(D){if(!D||!D.length)return[];const T=g.flatten(D.map(A=>{let{pathPortion:L,globPortion:$}=v(A);$&&($=c($));const oe=this.expandOneSearchPath(L);return g.flatten(oe.map(he=>this.resolveOneSearchPathPattern(he,$)))})),o=new Map;return T.forEach(A=>{const L=A.searchPath.toString(),$=o.get(L);$?A.pattern&&($.pattern=$.pattern||{},$.pattern[A.pattern]=!0):o.set(L,{searchPath:A.searchPath,pattern:A.pattern?t(A.pattern):void 0})}),Array.from(o.values())}expandOneSearchPath(D){if(_.isAbsolute(D)){const T=this.workspaceContextService.getWorkspace().folders;return T[0]&&T[0].uri.scheme!==y.Schemas.file?[{searchPath:T[0].uri.with({path:D})}]:[{searchPath:l.URI.file(_.normalize(D))}]}if(this.workspaceContextService.getWorkbenchState()===2){const T=this.workspaceContextService.getWorkspace().folders[0].uri;if(D=i(D),D.startsWith("../")||D===".."){const A=_.posix.resolve(T.path,D);return[{searchPath:T.with({path:A})}]}const o=c(D);return[{searchPath:T,pattern:o}]}else{if(D==="./"||D===".\\")return[];{const T=D.replace(/^\.[\/\\]/,""),A=this.workspaceContextService.getWorkspace().folders.map(L=>{const $=T.match(new RegExp(`^${n.escapeRegExpCharacters(L.name)}(?:/(.*)|$)`));return $?{match:$,folder:L}:null}).filter(I.isDefined);if(A.length)return A.map(L=>{const $=L.match[1];return{searchPath:L.folder.uri,pattern:$&&c($)}});{const L=D.match(/\.[\/\\](.+)[\/\\]?/),$=L?L[1]:D,oe=u.localize(0,null,$);throw new Error(oe)}}}}resolveOneSearchPathPattern(D,T){const o=D.pattern&&T?`${D.pattern}/${T}`:D.pattern||T,A=[{searchPath:D.searchPath,pattern:o}];return o&&!o.endsWith("**")&&A.push({searchPath:D.searchPath,pattern:o+"/**"}),A}getFolderQueryForSearchPath(D,T,o){const A=this.getFolderQueryForRoot((0,b.toWorkspaceFolder)(D.searchPath),T,o,!1);return A?{...A,includePattern:D.pattern}:null}getFolderQueryForRoot(D,T,o,A){let L;const $=l.URI.isUri(D)?D:D.uri;if(o.searchPaths){const V=o.searchPaths.filter(R=>(0,k.isEqual)(R.searchPath,$))[0];if(V&&!V.pattern)return null;V&&(L=V.pattern)}const oe=this.configurationService.getValue({resource:$}),Q={...this.getExcludesForFolder(oe,T)||{},...L||{}},z=l.URI.isUri(D)?(0,k.basename)(D):D.name;return{folder:$,folderName:A?z:void 0,excludePattern:Object.keys(Q).length>0?Q:void 0,fileEncoding:oe.files&&oe.files.encoding,disregardIgnoreFiles:typeof T.disregardIgnoreFiles=="boolean"?T.disregardIgnoreFiles:!oe.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof T.disregardGlobalIgnoreFiles=="boolean"?T.disregardGlobalIgnoreFiles:!oe.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof T.ignoreSymlinks=="boolean"?T.ignoreSymlinks:!oe.search.followSymlinks}}};f=ze([qe(0,m.IConfigurationService),qe(1,b.IWorkspaceContextService),qe(2,w.IEditorGroupsService),qe(3,P.IPathService)],f),e.QueryBuilder=f;function v(p){const D=p.match(/[\*\{\}\(\)\[\]\?]/);if(D){const T=D.index,o=p.substr(0,T).match(/[/|\\][^/\\]*$/);if(o){let A=p.substr(0,o.index);return A.match(/[/\\]/)||(A+="/"),{pathPortion:A,globPortion:p.substr((o.index||0)+1)}}}return{pathPortion:p}}function t(...p){return p.length?p.reduce((D,T)=>(D[T]=!0,D),Object.create(null)):void 0}function r(p){return S.splitGlobAware(p,",").map(D=>D.trim()).filter(D=>!!D.length)}function s(p){return[`**/${p}/**`,`**/${p}`].map(T=>T.replace(/\*\*\/\*\*/g,"**"))}function i(p){return p.replace(/\\/g,"/")}function c(p){return i(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function h(p,D){p=g.distinct(p,A=>A.toString());const T=[],o=D.getWorkspace();return p&&p.forEach(A=>{let L;if(D.getWorkbenchState()===2)L=(0,k.relativePath)(o.folders[0].uri,A),L&&L!=="."&&(L="./"+L);else{const $=D.getWorkspaceFolder(A);if($){const oe=$.name;if(o.folders.filter(Q=>Q.name===oe).length===1){const Q=(0,k.relativePath)($.uri,A);Q===""?L=`./${$.name}`:L=`./${$.name}/${Q}`}else L=A.fsPath}}L&&T.push(L)}),T}e.resolveResourcesForSearchIncludes=h}),define(be[224],Ee([0,1,25,2,20,12,4,223,39,46]),function(ee,e,g,F,S,E,C,y,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const n=7e3;function I(m,b){const w=b.activationEvents;if(!w)return Promise.resolve(void 0);const P=[],a=[];for(const i of w)if(/^workspaceContains:/.test(i)){const c=i.substr("workspaceContains:".length);c.indexOf("*")>=0||c.indexOf("?")>=0||m.forceUsingSearch?a.push(c):P.push(c)}if(P.length===0&&a.length===0)return Promise.resolve(void 0);let f;const v=new Promise((i,c)=>{f=i}),t=i=>f({activationEvent:i}),r=Promise.all(P.map(i=>l(m,i,t))).then(()=>{}),s=d(m,b.identifier,a,t);return Promise.all([r,s]).then(()=>{f(void 0)}),v}e.checkActivateWorkspaceContainsExtension=I;async function l(m,b,w){for(const P of m.folders)if(await m.exists(g.joinPath(F.URI.revive(P),b))){w(`workspaceContains:${b}`);return}}async function d(m,b,w,P){if(w.length===0)return Promise.resolve(void 0);const a=new S.CancellationTokenSource,f=m.checkExists(m.folders,w,a.token),v=setTimeout(async()=>{a.cancel(),P(`workspaceContainsTimeout:${w.join(",")}`)},n);let t=!1;try{t=await f}catch(r){E.isPromiseCanceledError(r)||E.onUnexpectedError(r)}a.dispose(),clearTimeout(v),t&&P(`workspaceContains:${w.join(",")}`)}function u(m,b,w,P){const a=m.get(C.IInstantiationService),f=m.get(_.ISearchService),t=a.createInstance(y.QueryBuilder).file(b.map(r=>(0,k.toWorkspaceFolder)(F.URI.revive(r))),{_reason:"checkExists",includePattern:w,exists:!0});return f.fileSearch(t,P).then(r=>!!r.limitHit,r=>E.isPromiseCanceledError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=u});var nt=this&&this.__classPrivateFieldSet||function(ee,e,g,F,S){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Ue=this&&this.__classPrivateFieldGet||function(ee,e,g,F){if(g==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!F:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?F:g==="a"?F.call(ee):F?F.value:e.get(ee)};define(be[34],Ee([0,1,134,14,79,25,16,6,21,2,15,5,33,187,77,32,30,185,12,26,24,162,7,95,4,29,78,13,62,68,38,3,224,73,164]),function(ee,e,g,F,S,E,C,y,_,k,n,I,l,d,u,m,b,w,P,a,f,v,t,r,s,i,c,h,p,D,T,o,A,L,$){"use strict";var oe,he,Q;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let z=class $n extends y.Disposable{constructor(x,j,de,B,ne,ue,ye,Re,Te,$e){super();this._onDidChangeRemoteConnectionData=this._register(new o.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=j,this._extHostContext=de,this._initData=ye,this._extHostWorkspace=B,this._extHostConfiguration=ne,this._logService=ue,this._extHostTunnelService=Te,this._extHostTerminalService=$e,this._disposables=new y.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new C.Barrier,this._readyToStartExtensionHost=new C.Barrier,this._readyToRunExtensions=new C.Barrier,this._eagerExtensionsActivated=new C.Barrier,this._registry=new w.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new u.ExtHostStorage(this._extHostContext),this._secretState=new L.ExtHostSecretState(this._extHostContext),this._storagePath=Re,this._instaService=x.createChild(new p.ServiceCollection([u.IExtHostStorage,this._storage],[L.IExtHostSecretState,this._secretState]));const Je=new Set;this._initData.hostExtensions.forEach(Ve=>Je.add(a.ExtensionIdentifier.toKey(Ve))),this._activator=new d.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ve,je,O)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ve,P.transformErrorForSerialization(je),O)},actualActivateExtension:async(Ve,je)=>{if(Je.has(a.ExtensionIdentifier.toKey(Ve)))return await this._mainThreadExtensionsProxy.$activateExtension(Ve,je),new d.HostExtension;const O=this._registry.getExtensionDescription(Ve);return this._activateExtension(O,je)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),S.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(x){P.onUnexpectedError(x)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let x=[];try{x=this._registry.getAllExtensionDescriptions().map(ne=>ne.identifier).filter(ne=>this.isActivated(ne)).map(ne=>this._deactivate(ne))}catch(j){}await Promise.all(x)}isActivated(x){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(x):!1}_activateByEvent(x,j){return this._activator.activateByEvent(x,j)}_activateById(x,j){return this._activator.activateById(x,j)}activateByIdWithErrors(x,j){return this._activateById(x,j).then(()=>{const de=this._activator.getActivatedExtension(x);if(de.activationFailed)return Promise.reject(de.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(x=>this._registry)}getExtensionExports(x){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(x).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const x=_.TernarySearchTree.forPaths(),j=this._registry.getAllExtensionDescriptions().map(de=>{if(!!this._getEntryPoint(de))return this._hostUtils.realpath(de.extensionLocation.fsPath).then(B=>x.set(k.URI.file(B).fsPath,de))});this._extensionPathIndex=Promise.all(j).then(()=>x)}return this._extensionPathIndex}_deactivate(x){let j=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(x))return j;const de=this._activator.getActivatedExtension(x);if(!de)return j;try{typeof de.module.deactivate=="function"&&(j=Promise.resolve(de.module.deactivate()).then(void 0,B=>(this._logService.error(B),Promise.resolve(void 0))))}catch(B){this._logService.error(B)}try{(0,y.dispose)(de.subscriptions)}catch(B){this._logService.error(B)}return j}async _activateExtension(x,j){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(x.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(x.identifier),this._doActivateExtension(x,j).then(de=>{const B=de.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(x.identifier,B.codeLoadingTime,B.activateCallTime,B.activateResolvedTime,j),this._logExtensionActivationTimes(x,j,"success",B),de},de=>{throw this._logExtensionActivationTimes(x,j,"failure"),de})}_logExtensionActivationTimes(x,j,de,B){const ne=V(x,j);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ne,...B||{},outcome:de})}_doActivateExtension(x,j){const de=V(x,j);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",de);const B=this._getEntryPoint(x);if(!B)return Promise.resolve(new d.EmptyExtension(d.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${x.identifier.value} ${JSON.stringify(j)}`),this._logService.flush();const ne=new d.ExtensionActivationTimesBuilder(j.startup);return Promise.all([this._loadCommonJSModule(x.identifier,(0,E.joinPath)(x.extensionLocation,B),ne),this._loadExtensionContext(x)]).then(ue=>(S.mark(`code/extHost/willActivateExtension/${x.identifier.value}`),$n._callActivate(this._logService,x.identifier,ue[0],ue[1],ne))).then(ue=>(S.mark(`code/extHost/didActivateExtension/${x.identifier.value}`),ue))}_loadExtensionContext(x){const j=new v.ExtensionGlobalMemento(x,this._storage),de=new v.ExtensionMemento(x.identifier.value,!1,this._storage),B=new $.ExtensionSecrets(x,this._secretState),ne=x.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ue=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${x.identifier.value}`),Promise.all([j.whenReady,de.whenReady,this._storagePath.whenReady]).then(()=>{const ye=this;let Re;return Object.freeze({globalState:j,workspaceState:de,secrets:B,subscriptions:[],get extensionUri(){return x.extensionLocation},get extensionPath(){return x.extensionLocation.fsPath},asAbsolutePath(Te){return F.join(x.extensionLocation.fsPath,Te)},get storagePath(){return ye._storagePath.workspaceValue(x)?.fsPath},get globalStoragePath(){return ye._storagePath.globalValue(x).fsPath},get logPath(){return F.join(ye._initData.logsLocation.fsPath,x.identifier.value)},get logUri(){return k.URI.joinPath(ye._initData.logsLocation,x.identifier.value)},get storageUri(){return ye._storagePath.workspaceValue(x)},get globalStorageUri(){return ye._storagePath.globalValue(x)},get extensionMode(){return ne},get extension(){return Re===void 0&&(Re=new R(ye,x.identifier,x,ue)),Re},get extensionRuntime(){return(0,b.checkProposedApiEnabled)(x),ye.extensionRuntime},get environmentVariableCollection(){return ye._extHostTerminalService.getEnvironmentVariableCollection(x)}})})}static _callActivate(x,j,de,B,ne){return de=de||{activate:void 0,deactivate:void 0},this._callActivateOptional(x,j,de,B,ne).then(ue=>new d.ActivatedExtension(!1,null,ne.build(),de,ue,B.subscriptions))}static _callActivateOptional(x,j,de,B,ne){if(typeof de.activate=="function")try{ne.activateCallStart(),x.trace(`ExtensionService#_callActivateOptional ${j.value}`);const ue=typeof global=="object"?global:self,ye=de.activate.apply(ue,[B]);return ne.activateCallStop(),ne.activateResolveStart(),Promise.resolve(ye).then(Re=>(ne.activateResolveStop(),Re))}catch(ue){return Promise.reject(ue)}else return Promise.resolve(de)}_activateOneStartupFinished(x,j){this._activateById(x.identifier,{startup:!1,extensionId:x.identifier,activationEvent:j}).then(void 0,de=>{this._logService.error(de)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(S.getMarks());for(const x of this._registry.getAllExtensionDescriptions())if(x.activationEvents)for(const j of x.activationEvents)j==="onStartupFinished"&&this._activateOneStartupFinished(x,j)}_handleEagerExtensions(){const x=this._activateByEvent("*",!0).then(void 0,ne=>{this._logService.error(ne)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(ne=>this._handleWorkspaceContainsEagerExtensions(ne.added)));const j=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],de=this._handleWorkspaceContainsEagerExtensions(j),B=Promise.all([x,de]).then(()=>{});return Promise.race([B,(0,C.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),B}_handleWorkspaceContainsEagerExtensions(x){return x.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(j=>this._handleWorkspaceContainsEagerExtension(x,j))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(x,j){if(this.isActivated(j.identifier))return;const de=!this._initData.remote.isRemote&&!!this._initData.remote.authority,B={folders:x.map(ue=>ue.uri),forceUsingSearch:de,exists:ue=>this._hostUtils.exists(ue.fsPath),checkExists:(ue,ye,Re)=>this._mainThreadWorkspaceProxy.$checkExists(ue,ye,Re)},ne=await(0,A.checkActivateWorkspaceContainsExtension)(B,j);if(!!ne)return this._activateById(j.identifier,{startup:!0,extensionId:j.identifier,activationEvent:ne.activationEvent}).then(void 0,ue=>this._logService.error(ue))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(x){throw console.error(x),x}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:x,extensionTestsLocationURI:j}=this._initData.environment;if(!x||!j)throw new Error(g.localize(0,null));const de=await this._loadCommonJSModule(null,j,new d.ExtensionActivationTimesBuilder(!1));if(!de||typeof de.run!="function")throw new Error(g.localize(1,null,j.toString()));return new Promise((B,ne)=>{const ue=(Te,$e)=>{Te?ne(Te):B(typeof $e=="number"&&$e>0?1:0)},ye=(0,E.originalFSPath)(j),Re=de.run(ye,ue);Re&&Re.then&&Re.then(()=>{B(0)}).catch(Te=>{ne(Te.toString())})})}async $extensionTestsExit(x){this._logService.info(`extension host terminating: test runner requested exit with code ${x}`),this._logService.info(`exiting with code ${x}`),this._logService.flush(),this._hostUtils.exit(x)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(x,j){return this._resolvers[x]=j,(0,y.toDisposable)(()=>{delete this._resolvers[x]})}async _activateAndGetResolver(x){const j=x.indexOf("+");if(j===-1)throw new Error("Not an authority that can be resolved!");const de=x.substr(0,j);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${de}`,!1),{authorityPrefix:de,resolver:this._resolvers[de]}}async $resolveAuthority(x,j){const{authorityPrefix:de,resolver:B}=await this._activateAndGetResolver(x);if(!B)return{type:"error",error:{code:r.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${de}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(B)),S.mark(`code/extHost/willResolveAuthority/${de}`);const ne=await B.resolve(x,{resolveAttempt:j});S.mark(`code/extHost/didResolveAuthorityOK/${de}`);const ue={authority:x,host:ne.host,port:ne.port,connectionToken:ne.connectionToken},ye={extensionHostEnv:ne.extensionHostEnv,isTrusted:ne.isTrusted};return{type:"ok",value:{authority:ue,options:ye,tunnelInformation:{environmentTunnels:ne.environmentTunnels}}}}catch(ne){if(S.mark(`code/extHost/didResolveAuthorityError/${de}`),ne instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:ne._code,message:ne._message,detail:ne._detail}};throw ne}}async $getCanonicalURI(x,j){const{authorityPrefix:de,resolver:B}=await this._activateAndGetResolver(x);if(!B)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${de}`);const ne=k.URI.revive(j);if(typeof B.getCanonicalURI=="undefined")return ne;const ue=await(0,C.asPromise)(()=>B.getCanonicalURI(ne));return ue||ne}$startExtensionHost(x){return this._registry.keepOnly(x),this._startExtensionHost()}$activateByEvent(x,j){return j===1?this._activateByEvent(x,!1):this._readyToRunExtensions.wait().then(de=>this._activateByEvent(x,!1))}async $activate(x,j){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(x)?(await this._activateById(x,j),!0):!1}async $deltaExtensions(x,j){x.forEach(B=>B.extensionLocation=k.URI.revive(B.extensionLocation));const de=await this.getExtensionPathIndex();return await Promise.all(j.map(async B=>{const ne=this._registry.getExtensionDescription(B);if(!ne)return;const ue=await this._hostUtils.realpath(ne.extensionLocation.fsPath);de.delete(k.URI.file(ue).fsPath)})),await Promise.all(x.map(async B=>{const ne=await this._hostUtils.realpath(B.extensionLocation.fsPath);de.set(k.URI.file(ne).fsPath,B)})),this._registry.deltaExtensions(x,j),Promise.resolve(void 0)}async $test_latency(x){return x}async $test_up(x){return x.byteLength}async $test_down(x){let j=f.VSBuffer.alloc(x),de=Math.random()%256;for(let B=0;B<x;B++)j.writeUInt8(de,B);return j}async $updateRemoteConnectionData(x){this._remoteConnectionData=x,this._onDidChangeRemoteConnectionData.fire()}};z=ze([qe(0,s.IInstantiationService),qe(1,e.IHostUtils),qe(2,h.IExtHostRpcService),qe(3,m.IExtHostWorkspace),qe(4,l.IExtHostConfiguration),qe(5,n.ILogService),qe(6,i.IExtHostInitDataService),qe(7,c.IExtensionStoragePaths),qe(8,D.IExtHostTunnelService),qe(9,T.IExtHostTerminalService)],z),e.AbstractExtHostExtensionService=z;function V(G,x){return{id:G.identifier.value,name:G.name,extensionVersion:G.version,publisherDisplayName:G.publisher,activationEvents:G.activationEvents?G.activationEvents.join(","):null,isBuiltin:G.isBuiltin,reason:x.activationEvent,reasonId:x.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class R{constructor(x,j,de,B){oe.set(this,void 0),he.set(this,void 0),Q.set(this,void 0),nt(this,oe,x,"f"),nt(this,he,j,"f"),nt(this,Q,de.identifier,"f"),this.id=de.identifier.value,this.extensionUri=de.extensionLocation,this.extensionPath=F.normalize((0,E.originalFSPath)(de.extensionLocation)),this.packageJSON=de,this.extensionKind=B}get isActive(){return Ue(this,oe,"f").isActivated(Ue(this,Q,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ue(this,oe,"f").getExtensionExports(Ue(this,Q,"f"))}activate(){return Ue(this,oe,"f").activateByIdWithErrors(Ue(this,Q,"f"),{startup:!1,extensionId:Ue(this,he,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=R,oe=new WeakMap,he=new WeakMap,Q=new WeakMap}),define(be[109],Ee([0,1,14,2,3,16,5,7,172,32,34,48,176,33,173,13,4,10,41,66]),function(ee,e,g,F,S,E,C,y,_,k,n,I,l,d,u,m,b,w,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,b.createDecorator)("IExtHostDebugService");let f=class{constructor(p,D,T,o,A,L){this._workspaceService=D,this._extensionService=T,this._editorsService=o,this._configurationService=A,this._editorTabs=L,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new S.Emitter,this._onDidTerminateDebugSession=new S.Emitter,this._onDidChangeActiveDebugSession=new S.Emitter,this._onDidReceiveDebugSessionCustomEvent=new S.Emitter,this._debugServiceProxy=p.getProxy(C.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new S.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then($=>{$.onDidChange(oe=>{this.registerAllDebugTypes($)}),this.registerAllDebugTypes($)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(p,D){const T=p;if(typeof T.sourceReference=="number"&&T.sourceReference>0){let o=`debug:${encodeURIComponent(T.path||"")}`,A="?";return D&&(o+=`${A}session=${encodeURIComponent(D.id)}`,A="&"),o+=`${A}ref=${T.sourceReference}`,F.URI.parse(o)}else{if(T.path)return F.URI.file(T.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(p){const D=[];for(const T of p.getAllExtensionDescriptions())if(T.contributes){const o=T.contributes.debuggers;if(o&&o.length>0)for(const A of o)(0,u.isDebuggerMainContribution)(A)&&D.push(A.type)}this._debugServiceProxy.$registerDebugTypes(D)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const p=[];return this._breakpoints.forEach(D=>p.push(D)),p}addBreakpoints(p){this.startBreakpoints();const D=p.filter(A=>{const L=A.id;return this._breakpoints.has(L)?!1:(this._breakpoints.set(L,A),!0)});this.fireBreakpointChanges(D,[],[]);const T=[],o=new Map;for(const A of D)if(A instanceof y.SourceBreakpoint){let L=o.get(A.location.uri.toString());L||(L={type:"sourceMulti",uri:A.location.uri,lines:[]},o.set(A.location.uri.toString(),L),T.push(L)),L.lines.push({id:A.id,enabled:A.enabled,condition:A.condition,hitCondition:A.hitCondition,logMessage:A.logMessage,line:A.location.range.start.line,character:A.location.range.start.character})}else A instanceof y.FunctionBreakpoint&&T.push({type:"function",id:A.id,enabled:A.enabled,hitCondition:A.hitCondition,logMessage:A.logMessage,condition:A.condition,functionName:A.functionName});return this._debugServiceProxy.$registerBreakpoints(T)}removeBreakpoints(p){this.startBreakpoints();const D=p.filter(L=>this._breakpoints.delete(L.id));this.fireBreakpointChanges([],D,[]);const T=D.filter(L=>L instanceof y.SourceBreakpoint).map(L=>L.id),o=D.filter(L=>L instanceof y.FunctionBreakpoint).map(L=>L.id),A=D.filter(L=>L instanceof y.DataBreakpoint).map(L=>L.id);return this._debugServiceProxy.$unregisterBreakpoints(T,o,A)}startDebugging(p,D,T){return this._debugServiceProxy.$startDebugging(p?p.uri:void 0,D,{parentSessionID:T.parentSession?T.parentSession.id:void 0,repl:T.consoleMode===y.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:T.noDebug,compact:T.compact,debugUI:T.debugUI})}stopDebugging(p){return this._debugServiceProxy.$stopDebugging(p?p.id:void 0)}registerDebugConfigurationProvider(p,D,T){if(!D)return new y.Disposable(()=>{});const o=this._configProviderHandleCounter++;return this._configProviders.push({type:p,handle:o,provider:D}),this._debugServiceProxy.$registerDebugConfigurationProvider(p,T,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,o),new y.Disposable(()=>{this._configProviders=this._configProviders.filter(A=>A.provider!==D),this._debugServiceProxy.$unregisterDebugConfigurationProvider(o)})}registerDebugAdapterDescriptorFactory(p,D,T){if(!T)return new y.Disposable(()=>{});if(!this.definesDebugType(p,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.getAdapterDescriptorFactoryByType(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const o=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:D,handle:o,factory:T}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(D,o),new y.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(A=>A.factory!==T),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(o)})}registerDebugAdapterTrackerFactory(p,D){if(!D)return new y.Disposable(()=>{});const T=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:p,handle:T,factory:D}),new y.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(o=>o.factory!==D)})}async $runInTerminal(p,D){return Promise.resolve(void 0)}async $substituteVariables(p,D){if(!this._variableResolver){const[A,L]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(A||[],this._editorsService,L)}let T;const o=await this.getFolder(p);return o&&(T={uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(T,D)}createDebugAdapter(p,D){if(p.type==="implementation")return new i(p.implementation)}createSignService(){}async $startDASession(p,D){const T=this,o=await this.getSession(D);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(o.type),o).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}' (extension might have failed to activate)`);const L=this.convertToDto(A),$=this.createDebugAdapter(L,o);if(!$)throw new Error(`Couldn't create a debug adapter for type '${o.type}'.`);const oe=$;return this._debugAdapters.set(p,oe),this.getDebugAdapterTrackers(o).then(he=>(he&&this._debugAdaptersTrackers.set(p,he),oe.onMessage(async Q=>{if(Q.type==="request"&&Q.command==="handshake"){const z=Q,V={type:"response",seq:0,command:z.command,request_seq:z.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const R=await this._signService.sign(z.arguments.value);V.body={signature:R},oe.sendResponse(V)}else throw new Error("no signer")}catch(R){V.success=!1,V.message=R.message,oe.sendResponse(V)}}else he&&he.onDidSendMessage&&he.onDidSendMessage(Q),Q=(0,u.convertToVSCPaths)(Q,!0),T._debugServiceProxy.$acceptDAMessage(p,Q)}),oe.onError(Q=>{he&&he.onError&&he.onError(Q),this._debugServiceProxy.$acceptDAError(p,Q.name,Q.message,Q.stack)}),oe.onExit(Q=>{he&&he.onExit&&he.onExit((0,w.withNullAsUndefined)(Q),void 0),this._debugServiceProxy.$acceptDAExit(p,(0,w.withNullAsUndefined)(Q),void 0)}),he&&he.onWillStartSession&&he.onWillStartSession(),oe.startSession()))})}$sendDAMessage(p,D){D=(0,u.convertToDAPaths)(D,!1);const T=this._debugAdaptersTrackers.get(p);T&&T.onWillReceiveMessage&&T.onWillReceiveMessage(D);const o=this._debugAdapters.get(p);o&&o.sendMessage(D)}$stopDASession(p){const D=this._debugAdaptersTrackers.get(p);this._debugAdaptersTrackers.delete(p),D&&D.onWillStopSession&&D.onWillStopSession();const T=this._debugAdapters.get(p);return this._debugAdapters.delete(p),T?T.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(p){const D=[],T=[],o=[];if(p.added)for(const A of p.added){const L=A.id;if(L&&!this._breakpoints.has(L)){let $;if(A.type==="function")$=new y.FunctionBreakpoint(A.functionName,A.enabled,A.condition,A.hitCondition,A.logMessage);else if(A.type==="data")$=new y.DataBreakpoint(A.label,A.dataId,A.canPersist,A.enabled,A.hitCondition,A.condition,A.logMessage);else{const oe=F.URI.revive(A.uri);$=new y.SourceBreakpoint(new y.Location(oe,new y.Position(A.line,A.character)),A.enabled,A.condition,A.hitCondition,A.logMessage)}$._id=L,this._breakpoints.set(L,$),D.push($)}}if(p.removed)for(const A of p.removed){const L=this._breakpoints.get(A);L&&(this._breakpoints.delete(A),T.push(L))}if(p.changed){for(const A of p.changed)if(A.id){const L=this._breakpoints.get(A.id);if(L){if(L instanceof y.FunctionBreakpoint&&A.type==="function"){const $=L;$.enabled=A.enabled,$.condition=A.condition,$.hitCondition=A.hitCondition,$.logMessage=A.logMessage,$.functionName=A.functionName}else if(L instanceof y.SourceBreakpoint&&A.type==="source"){const $=L;$.enabled=A.enabled,$.condition=A.condition,$.hitCondition=A.hitCondition,$.logMessage=A.logMessage,$.location=new y.Location(F.URI.revive(A.uri),new y.Position(A.line,A.character))}o.push(L)}}}this.fireBreakpointChanges(D,T,o)}$provideDebugConfigurations(p,D,T){return(0,E.asPromise)(async()=>{const o=this.getConfigProviderByHandle(p);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const A=await this.getFolder(D);return o.provideDebugConfigurations(A,T)}).then(o=>{if(!o)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return o})}$resolveDebugConfiguration(p,D,T,o){return(0,E.asPromise)(async()=>{const A=this.getConfigProviderByHandle(p);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.getFolder(D);return A.resolveDebugConfiguration(L,T,o)})}$resolveDebugConfigurationWithSubstitutedVariables(p,D,T,o){return(0,E.asPromise)(async()=>{const A=this.getConfigProviderByHandle(p);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.getFolder(D);return A.resolveDebugConfigurationWithSubstitutedVariables(L,T,o)})}async $provideDebugAdapter(p,D){const T=this.getAdapterDescriptorFactoryByHandle(p);if(!T)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const o=await this.getSession(D);return this.getAdapterDescriptor(T,o).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}'`);return this.convertToDto(A)})}async $acceptDebugSessionStarted(p){const D=await this.getSession(p);this._onDidStartDebugSession.fire(D)}async $acceptDebugSessionTerminated(p){const D=await this.getSession(p);D&&(this._onDidTerminateDebugSession.fire(D),this._debugSessions.delete(D.id))}async $acceptDebugSessionActiveChanged(p){this._activeDebugSession=p?await this.getSession(p):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(p,D){const T=await this.getSession(p);T&&T._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(p,D){const o={session:await this.getSession(p),event:D.event,body:D.body};this._onDidReceiveDebugSessionCustomEvent.fire(o)}convertToDto(p){if(p instanceof y.DebugAdapterExecutable)return{type:"executable",command:p.command,args:p.args,options:p.options};if(p instanceof y.DebugAdapterServer)return{type:"server",port:p.port,host:p.host};if(p instanceof y.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:p.path};if(p instanceof y.DebugAdapterInlineImplementation)return{type:"implementation",implementation:p.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(p){const D=this._adapterFactories.filter(T=>T.type===p);if(D.length>0)return D[0].factory}getAdapterDescriptorFactoryByHandle(p){const D=this._adapterFactories.filter(T=>T.handle===p);if(D.length>0)return D[0].factory}getConfigProviderByHandle(p){const D=this._configProviders.filter(T=>T.handle===p);if(D.length>0)return D[0].provider}definesDebugType(p,D){if(p.contributes){const T=p.contributes.debuggers;if(T&&T.length>0){for(const o of T)if(o.label&&o.type&&o.type===D)return!0}}return!1}getDebugAdapterTrackers(p){const T=p.configuration.type,o=this._trackerFactories.filter(A=>A.type===T||A.type==="*").map(A=>(0,E.asPromise)(()=>A.factory.createDebugAdapterTracker(p)).then(L=>L,L=>null));return Promise.race([Promise.all(o).then(A=>{const L=A.filter($=>!!$);if(L.length>0)return new s(L)}),new Promise((A,L)=>{const $=setTimeout(()=>{clearTimeout($),L(new Error("timeout"))},1e3)})]).catch(A=>{})}async getAdapterDescriptor(p,D){const T=D.configuration.debugServer;if(typeof T=="number")return Promise.resolve(new y.DebugAdapterServer(T));if(p){const A=await this._extensionService.getExtensionRegistry();return(0,E.asPromise)(()=>p.createDebugAdapterDescriptor(D,this.daExecutableFromPackage(D,A))).then(L=>{if(L)return L})}const o=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(D,o))}daExecutableFromPackage(p,D){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(p,D,T){(p.length>0||D.length>0||T.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:p,removed:D,changed:T}))}async getSession(p){if(p)if(typeof p=="string"){const D=this._debugSessions.get(p);if(D)return D}else{let D=this._debugSessions.get(p.id);if(!D){const T=await this.getFolder(p.folderUri),o=p.parent?this._debugSessions.get(p.parent):void 0;D=new v(this._debugServiceProxy,p.id,p.type,p.name,T,p.configuration,o),this._debugSessions.set(D.id,D),this._debugServiceProxy.$sessionCached(D.id)}return D}throw new Error("cannot find session")}getFolder(p){if(p){const D=F.URI.revive(p);return this._workspaceService.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}};f=ze([qe(0,m.IExtHostRpcService),qe(1,k.IExtHostWorkspace),qe(2,n.IExtHostExtensionService),qe(3,I.IExtHostDocumentsAndEditors),qe(4,d.IExtHostConfiguration),qe(5,a.IExtHostEditorTabs)],f),e.ExtHostDebugServiceBase=f;class v{constructor(p,D,T,o,A,L,$){this._debugServiceProxy=p,this._id=D,this._type=T,this._name=o,this._workspaceFolder=A,this._configuration=L,this._parentSession=$}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(p){this._name=p,this._debugServiceProxy.$setDebugSessionName(this._id,p)}get parentSession(){return this._parentSession}_acceptNameChanged(p){this._name=p}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(p,D){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,p,D)}getDebugProtocolBreakpoint(p){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,p.id)}}e.ExtHostDebugSession=v;class t{constructor(p){this.value=Object.freeze({append(D){p.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.ExtHostDebugConsole=t;class r extends l.AbstractVariableResolverService{constructor(p,D,T,o,A){function L(){if(D){const $=D.activeEditor();if($)return $.document.uri;const oe=o.tabs.filter(he=>he.isActive);if(oe.length>0)return oe[0].resource}}super({getFolderUri:$=>{const oe=p.filter(he=>he.name===$);if(oe&&oe.length>0)return oe[0].uri},getWorkspaceFolderCount:()=>p.length,getConfigurationValue:($,oe)=>T.getConfiguration(void 0,$).get(oe),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const $=L();if($)return g.normalize($.fsPath)},getWorkspaceFolderPathForFile:()=>{if(A){const $=L();if($){const oe=A.getWorkspaceFolder($);if(oe)return g.normalize(oe.uri.fsPath)}}},getSelectedText:()=>{if(D){const $=D.activeEditor();if($&&!$.selection.isEmpty)return $.document.getText($.selection)}},getLineNumber:()=>{if(D){const $=D.activeEditor();if($)return String($.selection.end.line+1)}}},void 0,Promise.resolve(P.env))}}e.ExtHostVariableResolverService=r;class s{constructor(p){this.trackers=p}onWillStartSession(){this.trackers.forEach(p=>p.onWillStartSession?p.onWillStartSession():void 0)}onWillReceiveMessage(p){this.trackers.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(p):void 0)}onDidSendMessage(p){this.trackers.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(p):void 0)}onWillStopSession(){this.trackers.forEach(p=>p.onWillStopSession?p.onWillStopSession():void 0)}onError(p){this.trackers.forEach(D=>D.onError?D.onError(p):void 0)}onExit(p,D){this.trackers.forEach(T=>T.onExit?T.onExit(p,D):void 0)}}class i extends _.AbstractDebugAdapter{constructor(p){super();this.implementation=p,p.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(p){this.implementation.handleMessage(p)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let c=class extends f{constructor(p,D,T,o,A,L){super(p,D,T,o,A,L)}createVariableResolver(p,D,T){return new r(p,D,T,this._editorTabs)}};c=ze([qe(0,m.IExtHostRpcService),qe(1,k.IExtHostWorkspace),qe(2,n.IExtHostExtensionService),qe(3,I.IExtHostDocumentsAndEditors),qe(4,d.IExtHostConfiguration),qe(5,a.IExtHostEditorTabs)],c),e.WorkerExtHostDebugService=c}),define(be[225],Ee([0,1,79,2,5,33,30,26,13,29,4,34,41,15]),function(ee,e,g,F,S,E,C,y,_,k,n,I,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let u=class{constructor(a,f,v,t,r,s,i){this._apiFactory=a,this._extensionRegistry=f,this._instaService=v,this._extHostConfiguration=t,this._extHostExtensionService=r,this._initData=s,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),g.mark("code/extHost/willWaitForConfig");const a=await this._extHostConfiguration.getConfigProvider();g.mark("code/extHost/didWaitForConfig");const f=await this._extHostExtensionService.getExtensionPathIndex();this.register(new m(this._apiFactory,f,this._extensionRegistry,a,this._logService)),this.register(this._instaService.createInstance(b)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,f,this._initData.environment.appUriScheme))}register(a){if(Array.isArray(a.nodeModuleName))for(let f of a.nodeModuleName)this._factories.set(f,a);else this._factories.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this._alternatives.push(f=>a.alternativeModuleName(f))}};u=ze([qe(2,n.IInstantiationService),qe(3,E.IExtHostConfiguration),qe(4,I.IExtHostExtensionService),qe(5,k.IExtHostInitDataService),qe(6,d.ILogService)],u),e.RequireInterceptor=u;class m{constructor(a,f,v,t,r){this._apiFactory=a,this._extensionPaths=f,this._extensionRegistry=v,this._configProvider=t,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(a,f){const v=this._extensionPaths.findSubstr(f.fsPath);if(v){let t=this._extApiImpl.get(y.ExtensionIdentifier.toKey(v.identifier));return t||(t=this._apiFactory(v,this._extensionRegistry,this._configProvider),this._extApiImpl.set(y.ExtensionIdentifier.toKey(v.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((r,s)=>t+=`	${s} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${f.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(C.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let b=class{constructor(a,f){this.nodeModuleName="keytar";const{environment:v}=f,t=a.getProxy(S.MainContext.MainThreadKeytar);if(v.appRoot){let r=v.appRoot.fsPath;l.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,s)=>t.$getPassword(r,s),setPassword:(r,s,i)=>t.$setPassword(r,s,i),deletePassword:(r,s)=>t.$deletePassword(r,s),findPassword:r=>t.$findPassword(r),findCredentials(r){return t.$findCredentials(r)}}}load(a,f){return this._impl}alternativeModuleName(a){const f=a.length;if(f<=7||!this.alternativeNames)return;const v=f-7;if((a.charAt(v)==="/"||a.charAt(v)==="\\")&&a.endsWith("keytar")&&(a=a.replace(/\\/g,"/"),this.alternativeNames.has(a)))return"keytar"}};b=ze([qe(0,_.IExtHostRpcService),qe(1,k.IExtHostInitDataService)],b);let w=class{constructor(a,f,v){this._extensionPaths=a,this._appUriScheme=f,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=v.getProxy(S.MainContext.MainThreadTelemetry);const t=v.getProxy(S.MainContext.MainThreadWindow);this._impl=(r,s)=>{const i=F.URI.parse(r);return s?this.callOriginal(r,s):i.scheme==="http"||i.scheme==="https"?t.$openUri(i,r,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?t.$openUri(i,r,{}):this.callOriginal(r,s)}}load(a,f,v){const t=this._extensionPaths.findSubstr(f.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=v(a),this._impl}callOriginal(a,f){return this.sendNoForwardTelemetry(),this._original(a,f)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=ze([qe(2,_.IExtHostRpcService)],w)}),define(be[226],Ee([0,1,16,12,79,6,2,5,219,15,59,62,29,153,13,69,34,38]),function(ee,e,g,F,S,E,C,y,_,k,n,I,l,d,u,m,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class P{constructor(f,v,t,r){this._disposables=new E.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new _.RPCProtocol(f,null,r),v=P._transform(v,this._rpcProtocol);const s=new I.ServiceCollection(...(0,n.getSingletonServiceDescriptors)());s.set(l.IExtHostInitDataService,{_serviceBrand:void 0,...v}),s.set(u.IExtHostRpcService,new u.ExtHostRpcService(this._rpcProtocol)),s.set(m.IURITransformerService,new m.URITransformerService(r)),s.set(b.IHostUtils,t);const i=new d.InstantiationService(s,!0),c=i.invokeFunction(T=>T.get(w.IExtHostTerminalService));this._disposables.add(c),this._logService=i.invokeFunction(T=>T.get(k.ILogService)),S.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",v),this._extensionService=i.invokeFunction(T=>T.get(b.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const h=new WeakMap;this._extensionService.getExtensionPathIndex().then(T=>{Error.prepareStackTrace=(o,A)=>{let L="",$,oe;for(const he of A)L+=`
	at ${he.toString()}`,oe=he.getFileName(),!$&&oe&&($=T.findSubstr(oe));return h.set(o,$),`${o.name||"Error"}: ${o.message||""}${L}`}});const p=this._rpcProtocol.getProxy(y.MainContext.MainThreadExtensionService),D=this._rpcProtocol.getProxy(y.MainContext.MainThreadErrors);F.setUnexpectedErrorHandler(T=>{const o=F.transformErrorForSerialization(T),A=h.get(T);A?p.$onExtensionRuntimeError(A.identifier,o):D.$onUnexpectedError(o)})}terminate(f){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${f}`),this._logService.flush(),this._disposables.dispose(),F.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const v=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,g.timeout)(4e3),v]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(f,v){f.extensions.forEach(r=>r.extensionLocation=C.URI.revive(v.transformIncomingURIs(r.extensionLocation))),f.environment.appRoot=C.URI.revive(v.transformIncomingURIs(f.environment.appRoot));const t=f.environment.extensionDevelopmentLocationURI;return t&&(f.environment.extensionDevelopmentLocationURI=t.map(r=>C.URI.revive(v.transformIncomingURIs(r)))),f.environment.extensionTestsLocationURI=C.URI.revive(v.transformIncomingURIs(f.environment.extensionTestsLocationURI)),f.environment.globalStorageHome=C.URI.revive(v.transformIncomingURIs(f.environment.globalStorageHome)),f.environment.workspaceStorageHome=C.URI.revive(v.transformIncomingURIs(f.environment.workspaceStorageHome)),f.logsLocation=C.URI.revive(v.transformIncomingURIs(f.logsLocation)),f.logFile=C.URI.revive(v.transformIncomingURIs(f.logFile)),f.workspace=v.transformIncomingURIs(f.workspace),f}}e.ExtensionHostMain=P}),define(be[227],Ee([0,1,14,20,58,27,25,55,39]),function(ee,e,g,F,S,E,C,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(l,d,u){this.config=l,this.provider=d,this.sessionToken=u,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=l.filePattern,this.includePattern=l.includePattern&&E.parse(l.includePattern),this.maxResults=l.maxResults||void 0,this.exists=l.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=l.excludePattern&&E.parse(l.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(l=>l.cancel()),this.activeCancellationTokens=new Set}search(l){const d=this.config.folderQueries||[];return new Promise((u,m)=>{const b=w=>{this.resultCount++,l(w)};if(this.isCanceled)return u({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(w=>{const P=w.toString(),a=g.basename(P);this.globalExcludePattern&&this.globalExcludePattern(P,a)||this.matchFile(b,{base:w,basename:a})}),Promise.all(d.map(w=>this.searchInFolder(w,b))).then(w=>{u({limitHit:this.isLimitHit,stats:w[0]||void 0})},w=>{m(new Error((0,S.toErrorMessage)(w)))})})}async searchInFolder(l,d){const u=new F.CancellationTokenSource,m=this.getSearchOptionsForFolder(l),b=this.initDirectoryTree(),w=new _.QueryGlobTester(this.config,l),P=!w.hasSiblingExcludeClauses();let a;try{this.activeCancellationTokens.add(u),a=y.StopWatch.create();const f=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},m,u.token),v=a.elapsed(),t=y.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(f&&f.forEach(r=>{const s=g.posix.relative(l.folder.path,r.path);if(P){const i=g.basename(r.path);this.matchFile(d,{base:l.folder,relativePath:s,basename:i});return}this.addDirectoryEntries(b,l.folder,s,d)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(b,w,d),{providerTime:v,postProcessTime:t.elapsed()})}finally{u.dispose(),this.activeCancellationTokens.delete(u)}}getSearchOptionsForFolder(l){const d=(0,_.resolvePatternsForProvider)(this.config.includePattern,l.includePattern),u=(0,_.resolvePatternsForProvider)(this.config.excludePattern,l.excludePattern);return{folder:l.folder,excludes:u,includes:d,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries({pathToEntries:l},d,u,m){if(u===this.filePattern){const w=g.basename(this.filePattern);this.matchFile(m,{base:d,relativePath:this.filePattern,basename:w})}function b(w){const P=g.basename(w),a=g.dirname(w);let f=l[a];f||(f=l[a]=[],b(a)),f.push({base:d,relativePath:w,basename:P})}b(u)}matchDirectoryTree({rootEntries:l,pathToEntries:d},u,m){const b=this,w=this.filePattern;function P(a){const f=E.hasSiblingFn(()=>a.map(v=>v.basename));for(let v=0,t=a.length;v<t;v++){const r=a[v],{relativePath:s,basename:i}=r;if(!u.includedInQuerySync(s,i,w!==i?f:void 0))continue;const c=d[s];if(c)P(c);else{if(s===w)continue;b.matchFile(m,r)}if(b.isLimitHit)break}}P(l)}matchFile(l,d){(!this.includePattern||d.relativePath&&this.includePattern(d.relativePath,d.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||l(d))}}class n{constructor(){this.sessions=new Map}fileSearch(l,d,u,m){const b=this.getSessionTokenSource(l.cacheKey),w=new k(l,d,b&&b.token);let P=0;const a=f=>{P+=f.length,u(f.map(v=>this.rawMatchToSearchItem(v)))};return this.doSearch(w,n.BATCH_SIZE,a,m).then(f=>({limitHit:f.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:P,detailStats:f.stats}}))}clearCache(l){const d=this.getSessionTokenSource(l);d&&d.cancel()}getSessionTokenSource(l){if(!!l)return this.sessions.has(l)||this.sessions.set(l,new F.CancellationTokenSource),this.sessions.get(l)}rawMatchToSearchItem(l){return l.relativePath?{resource:C.joinPath(l.base,l.relativePath)}:{resource:l.base}}doSearch(l,d,u,m){m.onCancellationRequested(()=>{l.cancel()});const b=P=>{P&&(w.push(P),d>0&&w.length>=d&&(u(w),w=[]))};let w=[];return l.search(b).then(P=>(w.length&&u(w),P),P=>(w.length&&u(w),Promise.reject(P)))}}e.FileSearchManager=n,n.BATCH_SIZE=512}),define(be[228],Ee([0,1,14,17,20,58,25,27,2,39,11,10]),function(ee,e,g,F,S,E,C,y,_,k,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class l{constructor(a,f,v){this.query=a,this.provider=f,this.fileUtils=v,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(a,f){const v=this.query.folderQueries||[],t=new S.CancellationTokenSource;return f.onCancellationRequested(()=>t.cancel()),new Promise((r,s)=>{this.collector=new u(a);let i=!1;const c=(h,p)=>{if(!i&&!this.isLimitHit){const D=this.resultSize(h);b(h)&&typeof this.query.maxResults=="number"&&this.resultCount+D>this.query.maxResults&&(this.isLimitHit=!0,i=!0,t.cancel(),h=this.trimResultToSize(h,this.query.maxResults-this.resultCount));const T=this.resultSize(h);this.resultCount+=T,(T>0||!b(h))&&this.collector.add(h,p)}};Promise.all(v.map((h,p)=>this.searchInFolder(h,D=>c(D,p),t.token))).then(h=>{t.dispose(),this.collector.flush();const p=h.some(D=>!!D&&!!D.limitHit);r({limitHit:this.isLimitHit||p,messages:(0,F.flatten)(h.map(D=>D?.message?(0,I.isArray)(D.message)?D.message:[D.message]:[])),stats:{type:"textSearchProvider"}})},h=>{t.dispose();const p=(0,E.toErrorMessage)(h);s(new Error(p))})})}resultSize(a){return b(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}trimResultToSize(a,f){const v=Array.isArray(a.ranges)?a.ranges:[a.ranges],t=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:v.slice(0,f),preview:{matches:t.slice(0,f),text:a.preview.text},uri:a.uri}}async searchInFolder(a,f,v){const t=new k.QueryGlobTester(this.query,a),r=[],s={report:h=>{if(!this.validateProviderResult(h))return;const p=a.folder.scheme===n.Schemas.file?y.hasSiblingPromiseFn(()=>this.fileUtils.readdir(C.dirname(h.uri))):void 0,D=C.relativePath(a.folder,h.uri);D&&r.push(t.includedInQuery(D,g.basename(D),p).then(T=>{T&&f(h)}))}},i=this.getSearchOptionsForFolder(a),c=await this.provider.provideTextSearchResults(d(this.query.contentPattern),i,s,v);return await Promise.all(r),c}validateProviderResult(a){if(b(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(a){const f=(0,k.resolvePatternsForProvider)(this.query.includePattern,a.includePattern),v=(0,k.resolvePatternsForProvider)(this.query.excludePattern,a.excludePattern),t={folder:_.URI.from(a.folder),excludes:v,includes:f,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.fileUtils.toCanonicalName(a.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=l;function d(P){return{isCaseSensitive:P.isCaseSensitive||!1,isRegExp:P.isRegExp||!1,isWordMatch:P.isWordMatch||!1,isMultiline:P.isMultiline||!1,pattern:P.pattern}}class u{constructor(a){this._onResult=a,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new w(512,f=>this.sendItems(f))}add(a,f){this._currentFileMatch&&(this._currentFolderIdx!==f||!C.isEqual(this._currentUri,a.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=f,this._currentFileMatch={resource:a.uri,results:[]}),this._currentFileMatch.results.push(m(a))}pushToCollector(){const a=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,a)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(a){this._onResult(a)}}e.TextSearchResultsCollector=u;function m(P){return b(P)?{preview:{matches:(0,F.mapArrayOrNot)(P.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:P.preview.text},ranges:(0,F.mapArrayOrNot)(P.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:P.text,lineNumber:P.lineNumber}}function b(P){return!!P.preview}e.extensionResultIsMatch=b;class w{constructor(a,f){this.maxBatchSize=a,this.cb=f,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(a,f){!a||this.addItemToBatch(a,f)}addItems(a,f){!a||this.addItemsToBatch(a,f)}addItemToBatch(a,f){this.batch.push(a),this.batchSize+=f,this.onUpdate()}addItemsToBatch(a,f){this.batch=this.batch.concat(a),this.batchSize+=f,this.onUpdate()}onUpdate(){this.totalNumberCompleted<w.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},w.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=w,w.TIMEOUT=4e3,w.START_BATCH_AFTER_COUNT=50}),define(be[110],Ee([0,1,6,5,4,227,13,69,15,2,228]),function(ee,e,g,F,S,E,C,y,_,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,S.createDecorator)("IExtHostSearch");let I=class{constructor(m,b,w){this.extHostRpc=m,this._uriTransformer=b,this._logService=w,this._proxy=this.extHostRpc.getProxy(F.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new E.FileSearchManager}_transformScheme(m){return this._uriTransformer.transformOutgoingScheme(m)}registerTextSearchProvider(m,b){if(this._textSearchUsedSchemes.has(m))throw new Error(`a text search provider for the scheme '${m}' is already registered`);this._textSearchUsedSchemes.add(m);const w=this._handlePool++;return this._textSearchProvider.set(w,b),this._proxy.$registerTextSearchProvider(w,this._transformScheme(m)),(0,g.toDisposable)(()=>{this._textSearchUsedSchemes.delete(m),this._textSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}registerFileSearchProvider(m,b){if(this._fileSearchUsedSchemes.has(m))throw new Error(`a file search provider for the scheme '${m}' is already registered`);this._fileSearchUsedSchemes.add(m);const w=this._handlePool++;return this._fileSearchProvider.set(w,b),this._proxy.$registerFileSearchProvider(w,this._transformScheme(m)),(0,g.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(m),this._fileSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}$provideFileSearchResults(m,b,w,P){const a=l(w),f=this._fileSearchProvider.get(m);if(f)return this._fileSearchManager.fileSearch(a,f,v=>{this._proxy.$handleFileMatch(m,b,v.map(t=>t.resource))},P);throw new Error("unknown provider: "+m)}$clearCache(m){return this._fileSearchManager.clearCache(m),Promise.resolve(void 0)}$provideTextSearchResults(m,b,w,P){const a=this._textSearchProvider.get(m);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${m}`);const f=l(w);return this.createTextSearchManager(f,a).search(t=>this._proxy.$handleTextMatch(m,b,t),P)}createTextSearchManager(m,b){return new n.TextSearchManager(m,b,{readdir:w=>Promise.resolve([]),toCanonicalName:w=>w})}};I=ze([qe(0,C.IExtHostRpcService),qe(1,y.IURITransformerService),qe(2,_.ILogService)],I),e.ExtHostSearch=I;function l(u){return{...u,folderQueries:u.folderQueries&&u.folderQueries.map(d),extraFileResources:u.extraFileResources&&u.extraFileResources.map(m=>k.URI.revive(m))}}e.reviveQuery=l;function d(u){return{...u,folder:k.URI.revive(u.folder)}}}),define(be[229],Ee([0,1,20,12,3,43,2,127,87,121,57,61,5,192,191,75,193,33,194,195,196,178,197,48,34,198,179,200,201,202,105,181,207,208,209,77,38,211,182,9,7,214,49,106,32,30,50,169,199,96,104,108,109,110,15,69,13,29,203,166,68,74,189,212,165,78,76,217,215,216,190,47,210,213,73,66,97,205,107,206,11,155,204,163,161]),function(ee,e,g,F,S,E,C,y,_,k,n,I,l,d,u,m,b,w,P,a,f,v,t,r,s,i,c,h,p,D,T,o,A,L,$,oe,he,Q,z,V,R,G,x,j,de,B,ne,ue,ye,Re,Te,$e,Je,Ve,je,O,K,X,se,q,ie,ge,Le,We,ve,Xe,H,Z,ce,Be,xe,Ze,De,Se,Pe,re,ae,fe,pe,U,me,we,Ie,Oe,He){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function et(Ke){const Ge=Ke.get(X.IExtHostInitDataService),lt=Ke.get(Ze.IExtHostFileSystemInfo),ft=Ke.get(H.IExtHostConsumerFileSystem),_t=Ke.get(s.IExtHostExtensionService),ut=Ke.get(de.IExtHostWorkspace),ot=Ke.get(ae.IExtHostTelemetry),_e=Ke.get(w.IExtHostConfiguration),ke=Ke.get(O.IURITransformerService),Y=Ke.get(K.IExtHostRpcService),W=Ke.get(oe.IExtHostStorage),Fe=Ke.get(Xe.IExtensionStoragePaths),Me=Ke.get(je.ILogService),tt=Ke.get(ie.IExtHostTunnelService),Qe=Ke.get(ge.IExtHostApiDeprecationService),dt=Ke.get(j.IExtHostWindow),yt=Ke.get(Pe.IExtHostSecretState),kt=Ke.get(re.IExtHostEditorTabs);Y.set(l.ExtHostContext.ExtHostFileSystemInfo,lt),Y.set(l.ExtHostContext.ExtHostLogService,Me),Y.set(l.ExtHostContext.ExtHostWorkspace,ut),Y.set(l.ExtHostContext.ExtHostConfiguration,_e),Y.set(l.ExtHostContext.ExtHostExtensionService,_t),Y.set(l.ExtHostContext.ExtHostStorage,W),Y.set(l.ExtHostContext.ExtHostTunnelService,tt),Y.set(l.ExtHostContext.ExtHostWindow,dt),Y.set(l.ExtHostContext.ExtHostSecretState,yt),Y.set(l.ExtHostContext.ExtHostTelemetry,ot),Y.set(l.ExtHostContext.ExtHostEditorTabs,kt);const bt=Y.set(l.ExtHostContext.ExtHostDecorations,Ke.get(Te.IExtHostDecorations)),mt=Y.set(l.ExtHostContext.ExtHostDocumentsAndEditors,Ke.get(r.IExtHostDocumentsAndEditors)),ct=Y.set(l.ExtHostContext.ExtHostCommands,Ke.get(m.IExtHostCommands)),Et=Y.set(l.ExtHostContext.ExtHostTerminalService,Ke.get(he.IExtHostTerminalService)),gt=Y.set(l.ExtHostContext.ExtHostDebugService,Ke.get(Je.IExtHostDebugService)),Ot=Y.set(l.ExtHostContext.ExtHostSearch,Ke.get(Ve.IExtHostSearch)),Pt=Y.set(l.ExtHostContext.ExtHostTask,Ke.get($e.IExtHostTask)),Kt=Y.set(l.ExtHostContext.ExtHostOutputService,Ke.get(T.IExtHostOutputService)),Ut=Y.set(l.ExtHostContext.ExtHostUrls,new G.ExtHostUrls(Y)),Ct=Y.set(l.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(Y,mt)),Qt=Y.set(l.ExtHostContext.ExtHostDocumentContentProviders,new f.ExtHostDocumentContentProvider(Y,mt,Me)),Yt=Y.set(l.ExtHostContext.ExtHostDocumentSaveParticipant,new v.ExtHostDocumentSaveParticipant(Me,Ct,Y.getProxy(l.MainContext.MainThreadBulkEdits))),pt=Y.set(l.ExtHostContext.ExtHostNotebook,new se.ExtHostNotebookController(Y,ct,mt,Ct,Fe)),qt=Y.set(l.ExtHostContext.ExtHostNotebookDocuments,new Oe.ExtHostNotebookDocuments(Me,pt)),zt=Y.set(l.ExtHostContext.ExtHostNotebookEditors,new Ie.ExtHostNotebookEditors(Me,Y,pt)),Jt=Y.set(l.ExtHostContext.ExtHostNotebookKernels,new fe.ExtHostNotebookKernels(Y,Ge,pt,Me)),Xt=Y.set(l.ExtHostContext.ExtHostNotebookRenderers,new U.ExtHostNotebookRenderers(Y,pt)),At=Y.set(l.ExtHostContext.ExtHostEditors,new Q.ExtHostEditors(Y,mt)),jt=Y.set(l.ExtHostContext.ExtHostTreeViews,new z.ExtHostTreeViews(Y.getProxy(l.MainContext.MainThreadTreeViews),ct,Me)),Zt=Y.set(l.ExtHostContext.ExtHostEditorInsets,new ue.ExtHostEditorInsets(Y.getProxy(l.MainContext.MainThreadEditorInsets),At,Ge)),Ht=Y.set(l.ExtHostContext.ExtHostDiagnostics,new P.ExtHostDiagnostics(Y,Me)),ht=Y.set(l.ExtHostContext.ExtHostLanguageFeatures,new h.ExtHostLanguageFeatures(Y,ke,Ct,ct,Ht,Me,Qe)),En=Y.set(l.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(Y,ht)),Rt=Y.set(l.ExtHostContext.ExtHostFileSystemEventService,new c.ExtHostFileSystemEventService(Y,Me,mt)),xt=Y.set(l.ExtHostContext.ExtHostQuickOpen,(0,A.createExtHostQuickOpen)(Y,ut,ct)),cn=Y.set(l.ExtHostContext.ExtHostSCM,new L.ExtHostSCM(Y,ct,Me)),_n=Y.set(l.ExtHostContext.ExtHostComments,(0,b.createExtHostComments)(Y,ct,Ct)),dn=Y.set(l.ExtHostContext.ExtHostProgress,new o.ExtHostProgress(Y.getProxy(l.MainContext.MainThreadProgress))),yn=Y.set(l.ExtHostContext.ExtHosLabelService,new ye.ExtHostLabelService(Y)),hn=Y.set(l.ExtHostContext.ExtHostTheming,new q.ExtHostTheming(Y)),Vt=Y.set(l.ExtHostContext.ExtHostAuthentication,new Le.ExtHostAuthentication(Y)),en=Y.set(l.ExtHostContext.ExtHostTimeline,new We.ExtHostTimeline(Y,ct)),tn=Y.set(l.ExtHostContext.ExtHostWebviews,new x.ExtHostWebviews(Y,{remote:Ge.remote},ut,Me,Qe)),nn=Y.set(l.ExtHostContext.ExtHostWebviewPanels,new Be.ExtHostWebviewPanels(Y,tn,ut)),Sn=Y.set(l.ExtHostContext.ExtHostCustomEditors,new ce.ExtHostCustomEditors(Y,Ct,Fe,tn,nn)),Dn=Y.set(l.ExtHostContext.ExtHostWebviewViews,new Z.ExtHostWebviewViews(Y,tn)),Ft=Y.set(l.ExtHostContext.ExtHostTesting,new De.ExtHostTesting(Y,ct)),Cn=Y.set(l.ExtHostContext.ExtHostUriOpeners,new Se.ExtHostUriOpeners(Y));Y.set(l.ExtHostContext.ExtHostInteractive,new He.ExtHostInteractive(Y,pt,mt));const kn=(0,ne.values)(l.ExtHostContext);Y.assertRegistered(kn);const rn=new xe.ExtHostBulkEdits(Y,mt),In=new u.ExtHostClipboard(Y),Bt=new D.ExtHostMessageService(Y,Me),Lt=new a.ExtHostDialogs(Y),fn=new $.ExtHostStatusBar(Y,ct.converter),Tt=new p.ExtHostLanguages(Y,Ct);return d.ExtHostApiCommands.register(ct),function(Ne,sn,mn){const vt=function(){let J=!Ne.isUnderDevelopment;function le(Ae){J||(Me.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),J=!0)}return function Ae(st){if(Array.isArray(st))st.forEach(Ae);else if(typeof st=="string")le(st);else{const wt=st;typeof wt.scheme=="undefined"&&le(st),!Ne.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,B.throwProposedApiError)(Ne)}return st}}(),Pn={getSession(J,le,Ae){return Vt.getSession(Ne,J,le,Ae)},get onDidChangeSessions(){return Vt.onDidChangeSessions},registerAuthenticationProvider(J,le,Ae,st){return Vt.registerAuthenticationProvider(J,le,Ae,st)}},An={registerCommand(J,le,Ae){return ct.registerCommand(!0,J,le,Ae)},registerTextEditorCommand(J,le,Ae){return ct.registerCommand(!0,J,(...st)=>{const wt=At.getActiveTextEditor();if(!wt){Me.warn("Cannot execute "+J+" because there is no active text editor.");return}return wt.edit(Dt=>{le.apply(Ae,[wt,Dt,...st])}).then(Dt=>{Dt||Me.warn("Edits from command "+J+" were not applied.")},Dt=>{Me.warn("An error occurred while running command "+J,Dt)})})},registerDiffInformationCommand:(J,le,Ae)=>((0,B.checkProposedApiEnabled)(Ne),ct.registerCommand(!0,J,async(...st)=>{const wt=mt.activeEditor(!0);if(!wt){Me.warn("Cannot execute "+J+" because there is no active text editor.");return}const Dt=await At.getDiffInformation(wt.id);le.apply(Ae,[Dt,...st])})),executeCommand(J,...le){return ct.executeCommand(J,...le)},getCommands(J=!1){return ct.getCommands(J)}},gn={get machineId(){return Ge.telemetryInfo.machineId},get sessionId(){return Ge.telemetryInfo.sessionId},get language(){return Ge.environment.appLanguage},get appName(){return Ge.environment.appName},get appRoot(){return Ge.environment.appRoot?.fsPath??""},get uriScheme(){return Ge.environment.appUriScheme},get clipboard(){return In.value},get shell(){return Et.getDefaultShell(!1)},get isTelemetryEnabled(){return ot.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ot.onDidChangeTelemetryEnabled},get isNewAppInstall(){const J=Date.now()-new Date(Ge.telemetryInfo.firstSessionDate).getTime();return isNaN(J)?!1:J<1e3*60*60*24},openExternal(J,le){return dt.openUri(J,{allowTunneling:!!Ge.remote.authority,allowContributedOpeners:le?.allowContributedOpeners})},async asExternalUri(J){if(J.scheme===Ge.environment.appUriScheme)return Ut.createAppUri(J);try{return await dt.asExternalUri(J,{allowTunneling:!!Ge.remote.authority})}catch(le){if((0,we.matchesScheme)(J,me.Schemas.http)||(0,we.matchesScheme)(J,me.Schemas.https))return J;throw le}},get remoteName(){return(0,Re.getRemoteName)(Ge.remote.authority)},get uiKind(){return Ge.uiKind}};Ge.environment.extensionTestsLocationURI||Object.freeze(gn);const pn=Ge.remote.isRemote?R.ExtensionKind.Workspace:R.ExtensionKind.UI,on={createTestController(J,le){return(0,B.checkProposedApiEnabled)(Ne),Ft.createTestController(J,le)},createTestItem(J,le,Ae){return(0,B.checkProposedApiEnabled)(Ne),Ft.createTestItem(J,le,Ae)},createTestObserver(){return(0,B.checkProposedApiEnabled)(Ne),Ft.createTestObserver()},runTests(J){return(0,B.checkProposedApiEnabled)(Ne),Ft.runTests(J)},get onDidChangeTestResults(){return(0,B.checkProposedApiEnabled)(Ne),Ft.onResultsChanged},get testResults(){return(0,B.checkProposedApiEnabled)(Ne),Ft.results}},Tn={getExtension(J){const le=sn.getExtensionDescription(J);if(le)return new s.Extension(_t,Ne.identifier,le,pn)},get all(){return sn.getAllExtensionDescriptions().map(J=>new s.Extension(_t,Ne.identifier,J,pn))},get onDidChange(){return sn.onDidChange}},Rn={createDiagnosticCollection(J){return Ht.createDiagnosticCollection(Ne.identifier,J)},get onDidChangeDiagnostics(){return Ht.onDidChangeDiagnostics},getDiagnostics:J=>Ht.getDiagnostics(J),getLanguages(){return Tt.getLanguages()},setTextDocumentLanguage(J,le){return Tt.changeLanguage(J.uri,le)},match(J,le){return(0,n.score)(V.LanguageSelector.from(J),le.uri,le.languageId,!0)},registerCodeActionsProvider(J,le,Ae){return ht.registerCodeActionProvider(Ne,vt(J),le,Ae)},registerCodeLensProvider(J,le){return ht.registerCodeLensProvider(Ne,vt(J),le)},registerDefinitionProvider(J,le){return ht.registerDefinitionProvider(Ne,vt(J),le)},registerDeclarationProvider(J,le){return ht.registerDeclarationProvider(Ne,vt(J),le)},registerImplementationProvider(J,le){return ht.registerImplementationProvider(Ne,vt(J),le)},registerTypeDefinitionProvider(J,le){return ht.registerTypeDefinitionProvider(Ne,vt(J),le)},registerHoverProvider(J,le){return ht.registerHoverProvider(Ne,vt(J),le,Ne.identifier)},registerEvaluatableExpressionProvider(J,le){return ht.registerEvaluatableExpressionProvider(Ne,vt(J),le,Ne.identifier)},registerInlineValuesProvider(J,le){return ht.registerInlineValuesProvider(Ne,vt(J),le,Ne.identifier)},registerDocumentHighlightProvider(J,le){return ht.registerDocumentHighlightProvider(Ne,vt(J),le)},registerLinkedEditingRangeProvider(J,le){return ht.registerLinkedEditingRangeProvider(Ne,vt(J),le)},registerReferenceProvider(J,le){return ht.registerReferenceProvider(Ne,vt(J),le)},registerRenameProvider(J,le){return ht.registerRenameProvider(Ne,vt(J),le)},registerDocumentSymbolProvider(J,le,Ae){return ht.registerDocumentSymbolProvider(Ne,vt(J),le,Ae)},registerWorkspaceSymbolProvider(J){return ht.registerWorkspaceSymbolProvider(Ne,J)},registerDocumentFormattingEditProvider(J,le){return ht.registerDocumentFormattingEditProvider(Ne,vt(J),le)},registerDocumentRangeFormattingEditProvider(J,le){return ht.registerDocumentRangeFormattingEditProvider(Ne,vt(J),le)},registerOnTypeFormattingEditProvider(J,le,Ae,...st){return ht.registerOnTypeFormattingEditProvider(Ne,vt(J),le,[Ae].concat(st))},registerDocumentSemanticTokensProvider(J,le,Ae){return ht.registerDocumentSemanticTokensProvider(Ne,vt(J),le,Ae)},registerDocumentRangeSemanticTokensProvider(J,le,Ae){return ht.registerDocumentRangeSemanticTokensProvider(Ne,vt(J),le,Ae)},registerSignatureHelpProvider(J,le,Ae,...st){return typeof Ae=="object"?ht.registerSignatureHelpProvider(Ne,vt(J),le,Ae):ht.registerSignatureHelpProvider(Ne,vt(J),le,typeof Ae=="undefined"?[]:[Ae,...st])},registerCompletionItemProvider(J,le,...Ae){return ht.registerCompletionItemProvider(Ne,vt(J),le,Ae)},registerInlineCompletionItemProvider(J,le){return(0,B.checkProposedApiEnabled)(Ne),ht.registerInlineCompletionsProvider(Ne,vt(J),le)},registerDocumentLinkProvider(J,le){return ht.registerDocumentLinkProvider(Ne,vt(J),le)},registerColorProvider(J,le){return ht.registerColorProvider(Ne,vt(J),le)},registerFoldingRangeProvider(J,le){return ht.registerFoldingRangeProvider(Ne,vt(J),le)},registerSelectionRangeProvider(J,le){return ht.registerSelectionRangeProvider(Ne,J,le)},registerCallHierarchyProvider(J,le){return ht.registerCallHierarchyProvider(Ne,J,le)},setLanguageConfiguration:(J,le)=>ht.setLanguageConfiguration(Ne,J,le),getTokenInformationAtPosition(J,le){return(0,B.checkProposedApiEnabled)(Ne),Tt.tokenAtPosition(J,le)},registerInlayHintsProvider(J,le){return(0,B.checkProposedApiEnabled)(Ne),ht.registerInlayHintsProvider(Ne,J,le)},registerTypeHierarchyProvider(J,le){return(0,B.checkProposedApiEnabled)(Ne),ht.registerTypeHierarchyProvider(Ne,J,le)}},Fn={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return Et.activeTerminal},get terminals(){return Et.terminals},async showTextDocument(J,le,Ae){const st=await(C.URI.isUri(J)?Promise.resolve(vn.openTextDocument(J)):Promise.resolve(J));return At.showTextDocument(st,le,Ae)},createTextEditorDecorationType(J){return At.createTextEditorDecorationType(Ne,J)},onDidChangeActiveTextEditor(J,le,Ae){return At.onDidChangeActiveTextEditor(J,le,Ae)},onDidChangeVisibleTextEditors(J,le,Ae){return At.onDidChangeVisibleTextEditors(J,le,Ae)},onDidChangeTextEditorSelection(J,le,Ae){return At.onDidChangeTextEditorSelection(J,le,Ae)},onDidChangeTextEditorOptions(J,le,Ae){return At.onDidChangeTextEditorOptions(J,le,Ae)},onDidChangeTextEditorVisibleRanges(J,le,Ae){return At.onDidChangeTextEditorVisibleRanges(J,le,Ae)},onDidChangeTextEditorViewColumn(J,le,Ae){return At.onDidChangeTextEditorViewColumn(J,le,Ae)},onDidCloseTerminal(J,le,Ae){return Et.onDidCloseTerminal(J,le,Ae)},onDidOpenTerminal(J,le,Ae){return Et.onDidOpenTerminal(J,le,Ae)},onDidChangeActiveTerminal(J,le,Ae){return Et.onDidChangeActiveTerminal(J,le,Ae)},onDidChangeTerminalDimensions(J,le,Ae){return(0,B.checkProposedApiEnabled)(Ne),Et.onDidChangeTerminalDimensions(J,le,Ae)},onDidWriteTerminalData(J,le,Ae){return(0,B.checkProposedApiEnabled)(Ne),Et.onDidWriteTerminalData(J,le,Ae)},get state(){return dt.state},onDidChangeWindowState(J,le,Ae){return dt.onDidChangeWindowState(J,le,Ae)},showInformationMessage(J,...le){return Bt.showMessage(Ne,E.default.Info,J,le[0],le.slice(1))},showWarningMessage(J,...le){return Bt.showMessage(Ne,E.default.Warning,J,le[0],le.slice(1))},showErrorMessage(J,...le){return Bt.showMessage(Ne,E.default.Error,J,le[0],le.slice(1))},showQuickPick(J,le,Ae){return xt.showQuickPick(J,!!Ne.enableProposedApi,le,Ae)},showWorkspaceFolderPick(J){return xt.showWorkspaceFolderPick(J)},showInputBox(J,le){return xt.showInput(J,le)},showOpenDialog(J){return Lt.showOpenDialog(J)},showSaveDialog(J){return Lt.showSaveDialog(J)},createStatusBarItem(J,le,Ae){let st,wt,Dt;return typeof J=="string"?(st=J,wt=le,Dt=Ae):(wt=J,Dt=le),fn.createStatusBarEntry(Ne,st,wt,Dt)},setStatusBarMessage(J,le){return fn.setStatusBarMessage(J,le)},withScmProgress(J){return Qe.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),dn.withProgress(Ne,{location:R.ProgressLocation.SourceControl},(le,Ae)=>J({report(st){}}))},withProgress(J,le){return dn.withProgress(Ne,J,le)},createOutputChannel(J){return Kt.createOutputChannel(J,Ne)},createWebviewPanel(J,le,Ae,st){return nn.createWebviewPanel(Ne,J,le,Ae,st)},createWebviewTextEditorInset(J,le,Ae,st){return(0,B.checkProposedApiEnabled)(Ne),Zt.createWebviewEditorInset(J,le,Ae,st,Ne)},createTerminal(J,le,Ae){return typeof J=="object"?(J.color&&(0,B.checkProposedApiEnabled)(Ne),"pty"in J?Et.createExtensionTerminal(J):Et.createTerminalFromOptions(J)):Et.createTerminal(J,le,Ae)},registerTerminalLinkProvider(J){return Et.registerLinkProvider(J)},registerTerminalProfileProvider(J,le){return Et.registerProfileProvider(Ne,J,le)},registerTreeDataProvider(J,le){return jt.registerTreeDataProvider(J,le,Ne)},createTreeView(J,le){return jt.createTreeView(J,le,Ne)},registerWebviewPanelSerializer:(J,le)=>nn.registerWebviewPanelSerializer(Ne,J,le),registerCustomEditorProvider:(J,le,Ae={})=>Sn.registerCustomEditorProvider(Ne,J,le,Ae),registerFileDecorationProvider(J){return bt.registerFileDecorationProvider(J,Ne.identifier)},registerUriHandler(J){return Ut.registerUriHandler(Ne.identifier,J)},createQuickPick(){return xt.createQuickPick(Ne.identifier,!!Ne.enableProposedApi)},createInputBox(){return xt.createInputBox(Ne.identifier)},get activeColorTheme(){return hn.activeColorTheme},onDidChangeActiveColorTheme(J,le,Ae){return hn.onDidChangeActiveColorTheme(J,le,Ae)},registerWebviewViewProvider(J,le,Ae){return Dn.registerWebviewViewProvider(Ne,J,le,Ae?.webviewOptions)},get activeNotebookEditor(){return(0,B.checkProposedApiEnabled)(Ne),pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(J,le,Ae){return(0,B.checkProposedApiEnabled)(Ne),pt.onDidChangeActiveNotebookEditor(J,le,Ae)},get visibleNotebookEditors(){return(0,B.checkProposedApiEnabled)(Ne),pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,B.checkProposedApiEnabled)(Ne),pt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(J,le,Ae){return(0,B.checkProposedApiEnabled)(Ne),zt.onDidChangeNotebookEditorSelection(J,le,Ae)},onDidChangeNotebookEditorVisibleRanges(J,le,Ae){return(0,B.checkProposedApiEnabled)(Ne),zt.onDidChangeNotebookEditorVisibleRanges(J,le,Ae)},showNotebookDocument(J,le){return(0,B.checkProposedApiEnabled)(Ne),pt.showNotebookDocument(J,le)},registerExternalUriOpener(J,le,Ae){return(0,B.checkProposedApiEnabled)(Ne),Cn.registerExternalUriOpener(Ne.identifier,J,le,Ae)},get openEditors(){return(0,B.checkProposedApiEnabled)(Ne),kt.tabs},get onDidChangeOpenEditors(){return(0,B.checkProposedApiEnabled)(Ne),kt.onDidChangeTabs},getInlineCompletionItemController(J){return(0,B.checkProposedApiEnabled)(Ne),h.InlineCompletionController.get(J)}},vn={get rootPath(){return Qe.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ut.getPath()},set rootPath(J){throw F.readonly()},getWorkspaceFolder(J){return ut.getWorkspaceFolder(J)},get workspaceFolders(){return ut.getWorkspaceFolders()},get name(){return ut.name},set name(J){throw F.readonly()},get workspaceFile(){return ut.workspaceFile},set workspaceFile(J){throw F.readonly()},updateWorkspaceFolders:(J,le,...Ae)=>ut.updateWorkspaceFolders(Ne,J,le||0,...Ae),onDidChangeWorkspaceFolders:function(J,le,Ae){return ut.onDidChangeWorkspace(J,le,Ae)},asRelativePath:(J,le)=>ut.getRelativePath(J,le),findFiles:(J,le,Ae,st)=>ut.findFiles(V.GlobPattern.from(J),V.GlobPattern.from(le),Ae,Ne.identifier,st),findTextInFiles:(J,le,Ae,st)=>{let wt,Dt;return typeof le=="object"?(wt=le,Dt=Ae):(wt={},Dt=le,st=Ae),ut.findTextInFiles(J,wt||{},Dt,Ne.identifier,st)},saveAll:J=>ut.saveAll(J),applyEdit(J){return rn.applyWorkspaceEdit(J)},createFileSystemWatcher:(J,le,Ae,st)=>Rt.createFileSystemWatcher(V.GlobPattern.from(J),le,Ae,st),get textDocuments(){return Ct.getAllDocumentData().map(J=>J.document)},set textDocuments(J){throw F.readonly()},openTextDocument(J){let le;const Ae=J;if(typeof J=="string")le=Promise.resolve(C.URI.file(J));else if(C.URI.isUri(J))le=Promise.resolve(J);else if(!Ae||typeof Ae=="object")le=Ct.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return le.then(st=>Ct.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(J,le,Ae)=>Ct.onDidAddDocument(J,le,Ae),onDidCloseTextDocument:(J,le,Ae)=>Ct.onDidRemoveDocument(J,le,Ae),onDidChangeTextDocument:(J,le,Ae)=>Ct.onDidChangeDocument(J,le,Ae),onDidSaveTextDocument:(J,le,Ae)=>Ct.onDidSaveDocument(J,le,Ae),onWillSaveTextDocument:(J,le,Ae)=>Yt.getOnWillSaveTextDocumentEvent(Ne)(J,le,Ae),get notebookDocuments(){return pt.notebookDocuments.map(J=>J.apiNotebook)},async openNotebookDocument(J,le){let Ae;if(C.URI.isUri(J))Ae=J,await pt.openNotebookDocument(J);else if(typeof J=="string")Ae=C.URI.revive(await pt.createNotebookDocument({viewType:J,content:le}));else throw new Error("Invalid arguments");return pt.getNotebookDocument(Ae).apiNotebook},get onDidOpenNotebookDocument(){return pt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return pt.onDidCloseNotebookDocument},registerNotebookSerializer(J,le,Ae,st){return pt.registerNotebookSerializer(Ne,J,le,Ae,Ne.enableProposedApi?st:void 0)},registerNotebookContentProvider:(J,le,Ae,st)=>((0,B.checkProposedApiEnabled)(Ne),pt.registerNotebookContentProvider(Ne,J,le,Ae,Ne.enableProposedApi?st:void 0)),onDidChangeConfiguration:(J,le,Ae)=>mn.onDidChangeConfiguration(J,le,Ae),getConfiguration(J,le){return le=arguments.length===1?void 0:le,mn.getConfiguration(J,le,Ne)},registerTextDocumentContentProvider(J,le){return Qt.registerTextDocumentContentProvider(J,le)},registerTaskProvider:(J,le)=>(Qe.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),Pt.registerTaskProvider(Ne,J,le)),registerFileSystemProvider(J,le,Ae){return En.registerFileSystemProvider(Ne.identifier,J,le,Ae,Ne.enableProposedApi)},get fs(){return ft.value},registerFileSearchProvider:(J,le)=>((0,B.checkProposedApiEnabled)(Ne),Ot.registerFileSearchProvider(J,le)),registerTextSearchProvider:(J,le)=>((0,B.checkProposedApiEnabled)(Ne),Ot.registerTextSearchProvider(J,le)),registerRemoteAuthorityResolver:(J,le)=>((0,B.checkProposedApiEnabled)(Ne),_t.registerRemoteAuthorityResolver(J,le)),registerResourceLabelFormatter:J=>((0,B.checkProposedApiEnabled)(Ne),yn.$registerResourceLabelFormatter(J)),onDidCreateFiles:(J,le,Ae)=>Rt.onDidCreateFile(J,le,Ae),onDidDeleteFiles:(J,le,Ae)=>Rt.onDidDeleteFile(J,le,Ae),onDidRenameFiles:(J,le,Ae)=>Rt.onDidRenameFile(J,le,Ae),onWillCreateFiles:(J,le,Ae)=>Rt.getOnWillCreateFileEvent(Ne)(J,le,Ae),onWillDeleteFiles:(J,le,Ae)=>Rt.getOnWillDeleteFileEvent(Ne)(J,le,Ae),onWillRenameFiles:(J,le,Ae)=>Rt.getOnWillRenameFileEvent(Ne)(J,le,Ae),openTunnel:J=>((0,B.checkProposedApiEnabled)(Ne),tt.openTunnel(Ne,J).then(le=>{if(!le)throw new Error("cannot open tunnel");return le})),get tunnels(){return(0,B.checkProposedApiEnabled)(Ne),tt.getTunnels()},onDidChangeTunnels:(J,le,Ae)=>((0,B.checkProposedApiEnabled)(Ne),tt.onDidChangeTunnels(J,le,Ae)),registerPortAttributesProvider:(J,le)=>((0,B.checkProposedApiEnabled)(Ne),tt.registerPortsAttributesProvider(J,le)),registerTimelineProvider:(J,le)=>((0,B.checkProposedApiEnabled)(Ne),en.registerTimelineProvider(J,le,Ne.identifier,ct.converter)),get isTrusted(){return ut.trusted},requestWorkspaceTrust:J=>((0,B.checkProposedApiEnabled)(Ne),ut.requestWorkspaceTrust(J)),onDidGrantWorkspaceTrust:(J,le,Ae)=>ut.onDidGrantWorkspaceTrust(J,le,Ae)},Mn={get inputBox(){return Qe.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),cn.getLastInputBox(Ne)},createSourceControl(J,le,Ae){return cn.createSourceControl(Ne,J,le,Ae)}},Ln={createCommentController(J,le){return _n.createCommentController(Ne,J,le)}},wn={get activeDebugSession(){return gt.activeDebugSession},get activeDebugConsole(){return gt.activeDebugConsole},get breakpoints(){return gt.breakpoints},onDidStartDebugSession(J,le,Ae){return gt.onDidStartDebugSession(J,le,Ae)},onDidTerminateDebugSession(J,le,Ae){return gt.onDidTerminateDebugSession(J,le,Ae)},onDidChangeActiveDebugSession(J,le,Ae){return gt.onDidChangeActiveDebugSession(J,le,Ae)},onDidReceiveDebugSessionCustomEvent(J,le,Ae){return gt.onDidReceiveDebugSessionCustomEvent(J,le,Ae)},onDidChangeBreakpoints(J,le,Ae){return gt.onDidChangeBreakpoints(J,le,Ae)},registerDebugConfigurationProvider(J,le,Ae){return gt.registerDebugConfigurationProvider(J,le,Ae||R.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(J,le){return gt.registerDebugAdapterDescriptorFactory(Ne,J,le)},registerDebugAdapterTrackerFactory(J,le){return gt.registerDebugAdapterTrackerFactory(J,le)},startDebugging(J,le,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?gt.startDebugging(J,le,{parentSession:Ae}):gt.startDebugging(J,le,Ae||{})},stopDebugging(J){return gt.stopDebugging(J)},addBreakpoints(J){return gt.addBreakpoints(J)},removeBreakpoints(J){return gt.removeBreakpoints(J)},asDebugSourceUri(J,le){return gt.asDebugSourceUri(J,le)}},Nn={registerTaskProvider:(J,le)=>Pt.registerTaskProvider(Ne,J,le),fetchTasks:J=>Pt.fetchTasks(J),executeTask:J=>Pt.executeTask(Ne,J),get taskExecutions(){return Pt.taskExecutions},onDidStartTask:(J,le,Ae)=>Pt.onDidStartTask(J,le,Ae),onDidEndTask:(J,le,Ae)=>Pt.onDidEndTask(J,le,Ae),onDidStartTaskProcess:(J,le,Ae)=>Pt.onDidStartTaskProcess(J,le,Ae),onDidEndTaskProcess:(J,le,Ae)=>Pt.onDidEndTaskProcess(J,le,Ae)},an={createNotebookController(J,le,Ae,st,wt){return Jt.createNotebookController(Ne,J,le,Ae,st,Ne.enableProposedApi?wt:void 0)},registerNotebookCellStatusBarItemProvider:(J,le)=>pt.registerNotebookCellStatusBarItemProvider(Ne,J,le),get onDidSaveNotebookDocument(){return(0,B.checkProposedApiEnabled)(Ne),qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(J){return(0,B.checkProposedApiEnabled)(Ne),zt.createNotebookEditorDecorationType(J)},createRendererMessaging(J){return Xt.createRendererMessaging(!!Ne.enableProposedApi,J)},onDidChangeNotebookDocumentMetadata(J,le,Ae){return(0,B.checkProposedApiEnabled)(Ne),qt.onDidChangeNotebookDocumentMetadata(J,le,Ae)},onDidChangeNotebookCells(J,le,Ae){return(0,B.checkProposedApiEnabled)(Ne),pt.onDidChangeNotebookCells(J,le,Ae)},onDidChangeNotebookCellExecutionState(J,le,Ae){return(0,B.checkProposedApiEnabled)(Ne),pt.onDidChangeNotebookCellExecutionState(J,le,Ae)},onDidChangeCellOutputs(J,le,Ae){return(0,B.checkProposedApiEnabled)(Ne),pt.onDidChangeCellOutputs(J,le,Ae)},onDidChangeCellMetadata(J,le,Ae){return(0,B.checkProposedApiEnabled)(Ne),pt.onDidChangeCellMetadata(J,le,Ae)},createConcatTextDocument(J,le){return(0,B.checkProposedApiEnabled)(Ne),new ve.ExtHostNotebookConcatDocument(pt,Ct,J,le)}};return{version:Ge.version,authentication:Pn,commands:An,comments:Ln,debug:wn,env:gn,extensions:Tn,languages:Rn,notebooks:an,scm:Mn,tasks:Nn,test:on,window:Fn,workspace:vn,Breakpoint:R.Breakpoint,CallHierarchyIncomingCall:R.CallHierarchyIncomingCall,CallHierarchyItem:R.CallHierarchyItem,CallHierarchyOutgoingCall:R.CallHierarchyOutgoingCall,CancellationError:F.CancellationError,CancellationTokenSource:g.CancellationTokenSource,CandidatePortSource:l.CandidatePortSource,CodeAction:R.CodeAction,CodeActionKind:R.CodeActionKind,CodeActionTriggerKind:R.CodeActionTriggerKind,CodeLens:R.CodeLens,Color:R.Color,ColorInformation:R.ColorInformation,ColorPresentation:R.ColorPresentation,ColorThemeKind:R.ColorThemeKind,CommentMode:R.CommentMode,CommentThreadCollapsibleState:R.CommentThreadCollapsibleState,CompletionItem:R.CompletionItem,CompletionItemKind:R.CompletionItemKind,CompletionItemTag:R.CompletionItemTag,CompletionList:R.CompletionList,CompletionTriggerKind:R.CompletionTriggerKind,ConfigurationTarget:R.ConfigurationTarget,CustomExecution:R.CustomExecution,DebugAdapterExecutable:R.DebugAdapterExecutable,DebugAdapterInlineImplementation:R.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:R.DebugAdapterNamedPipeServer,DebugAdapterServer:R.DebugAdapterServer,DebugConfigurationProviderTriggerKind:R.DebugConfigurationProviderTriggerKind,DebugConsoleMode:R.DebugConsoleMode,DecorationRangeBehavior:R.DecorationRangeBehavior,Diagnostic:R.Diagnostic,DiagnosticRelatedInformation:R.DiagnosticRelatedInformation,DiagnosticSeverity:R.DiagnosticSeverity,DiagnosticTag:R.DiagnosticTag,Disposable:R.Disposable,DocumentHighlight:R.DocumentHighlight,DocumentHighlightKind:R.DocumentHighlightKind,DocumentLink:R.DocumentLink,DocumentSymbol:R.DocumentSymbol,EndOfLine:R.EndOfLine,EnvironmentVariableMutatorType:R.EnvironmentVariableMutatorType,EvaluatableExpression:R.EvaluatableExpression,InlineValueText:R.InlineValueText,InlineValueVariableLookup:R.InlineValueVariableLookup,InlineValueEvaluatableExpression:R.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:R.InlineCompletionTriggerKind,EventEmitter:S.Emitter,ExtensionKind:R.ExtensionKind,ExtensionMode:R.ExtensionMode,ExternalUriOpenerPriority:R.ExternalUriOpenerPriority,FileChangeType:R.FileChangeType,FileDecoration:R.FileDecoration,FileSystemError:R.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:R.FoldingRange,FoldingRangeKind:R.FoldingRangeKind,FunctionBreakpoint:R.FunctionBreakpoint,InlineCompletionItem:R.InlineSuggestion,InlineCompletionList:R.InlineSuggestions,Hover:R.Hover,IndentAction:k.IndentAction,Location:R.Location,MarkdownString:R.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:R.ParameterInformation,PortAutoForwardAction:R.PortAutoForwardAction,Position:R.Position,ProcessExecution:R.ProcessExecution,ProgressLocation:R.ProgressLocation,QuickInputButtons:R.QuickInputButtons,Range:R.Range,RelativePattern:R.RelativePattern,Selection:R.Selection,SelectionRange:R.SelectionRange,SemanticTokens:R.SemanticTokens,SemanticTokensBuilder:R.SemanticTokensBuilder,SemanticTokensEdit:R.SemanticTokensEdit,SemanticTokensEdits:R.SemanticTokensEdits,SemanticTokensLegend:R.SemanticTokensLegend,ShellExecution:R.ShellExecution,ShellQuoting:R.ShellQuoting,SignatureHelp:R.SignatureHelp,SignatureHelpTriggerKind:R.SignatureHelpTriggerKind,SignatureInformation:R.SignatureInformation,SnippetString:R.SnippetString,SourceBreakpoint:R.SourceBreakpoint,StandardTokenType:R.StandardTokenType,StatusBarAlignment:R.StatusBarAlignment,SymbolInformation:R.SymbolInformation,SymbolKind:R.SymbolKind,SymbolTag:R.SymbolTag,Task:R.Task,TaskGroup:R.TaskGroup,TaskPanelKind:R.TaskPanelKind,TaskRevealKind:R.TaskRevealKind,TaskScope:R.TaskScope,TerminalLink:R.TerminalLink,TerminalProfile:R.TerminalProfile,TextDocumentSaveReason:R.TextDocumentSaveReason,TextEdit:R.TextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:R.TextEditorLineNumbersStyle,TextEditorRevealType:R.TextEditorRevealType,TextEditorSelectionChangeKind:R.TextEditorSelectionChangeKind,TextDocumentChangeReason:R.TextDocumentChangeReason,ThemeColor:R.ThemeColor,ThemeIcon:R.ThemeIcon,TreeItem:R.TreeItem,TreeItemCollapsibleState:R.TreeItemCollapsibleState,TypeHierarchyItem:R.TypeHierarchyItem,UIKind:l.UIKind,Uri:C.URI,ViewColumn:R.ViewColumn,WorkspaceEdit:R.WorkspaceEdit,InlayHint:R.InlayHint,InlayHintKind:R.InlayHintKind,RemoteAuthorityResolverError:R.RemoteAuthorityResolverError,ResolvedAuthority:R.ResolvedAuthority,SourceControlInputBoxValidationType:R.SourceControlInputBoxValidationType,ExtensionRuntime:R.ExtensionRuntime,TimelineItem:R.TimelineItem,NotebookRange:R.NotebookRange,NotebookCellKind:R.NotebookCellKind,NotebookCellExecutionState:R.NotebookCellExecutionState,NotebookCellData:R.NotebookCellData,NotebookData:R.NotebookData,NotebookRendererScript:R.NotebookRendererScript,NotebookCellStatusBarAlignment:R.NotebookCellStatusBarAlignment,NotebookEditorRevealType:R.NotebookEditorRevealType,NotebookCellOutput:R.NotebookCellOutput,NotebookCellOutputItem:R.NotebookCellOutputItem,NotebookCellStatusBarItem:R.NotebookCellStatusBarItem,NotebookControllerAffinity:R.NotebookControllerAffinity,PortAttributes:R.PortAttributes,LinkedEditingRanges:R.LinkedEditingRanges,TestResultState:R.TestResultState,TestRunRequest:R.TestRunRequest,TestMessage:R.TestMessage,TestRunProfileGroup:R.TestRunProfileGroup,TextSearchCompleteMessageType:pe.TextSearchCompleteMessageType,TestMessageSeverity:R.TestMessageSeverity,CoveredCount:R.CoveredCount,FileCoverage:R.FileCoverage,StatementCoverage:R.StatementCoverage,BranchCoverage:R.BranchCoverage,FunctionCoverage:R.FunctionCoverage,WorkspaceTrustState:R.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=et}),define(be[230],Ee([0,1,59,105,32,104,33,75,48,38,108,109,110,77,68,74,106,76,47,73,97,66]),function(ee,e,g,F,S,E,C,y,_,k,n,I,l,d,u,m,b,w,P,a,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(m.IExtHostApiDeprecationService,m.ExtHostApiDeprecationService),(0,g.registerSingleton)(y.IExtHostCommands,y.ExtHostCommands),(0,g.registerSingleton)(C.IExtHostConfiguration,C.ExtHostConfiguration),(0,g.registerSingleton)(w.IExtHostConsumerFileSystem,w.ExtHostConsumerFileSystem),(0,g.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,g.registerSingleton)(E.IExtHostDecorations,E.ExtHostDecorations),(0,g.registerSingleton)(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors),(0,g.registerSingleton)(P.IExtHostFileSystemInfo,P.ExtHostFileSystemInfo),(0,g.registerSingleton)(F.IExtHostOutputService,F.ExtHostOutputService),(0,g.registerSingleton)(l.IExtHostSearch,l.ExtHostSearch),(0,g.registerSingleton)(d.IExtHostStorage,d.ExtHostStorage),(0,g.registerSingleton)(n.IExtHostTask,n.WorkerExtHostTask),(0,g.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),(0,g.registerSingleton)(u.IExtHostTunnelService,u.ExtHostTunnelService),(0,g.registerSingleton)(b.IExtHostWindow,b.ExtHostWindow),(0,g.registerSingleton)(S.IExtHostWorkspace,S.ExtHostWorkspace),(0,g.registerSingleton)(a.IExtHostSecretState,a.ExtHostSecretState),(0,g.registerSingleton)(f.IExtHostTelemetry,f.ExtHostTelemetry),(0,g.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs)}),define(be[231],Ee([0,1,229,34,225,7,16,5,11]),function(ee,e,g,F,S,E,C,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var k;(function(u){const m=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(w,...P)=>{P.forEach(t=>{if(!self.trustedTypes?.isScript(t))throw new Error("TrustedScripts only, please")});const a=P.slice(0,-1).join(","),f=P.pop().toString();return`(function anonymous(${a}) {
${f}
})`}});function b(...w){return m?self.eval(m.createScript("",...w)):new Function(...w)}u.create=b})(k||(k={}));class n extends S.RequireInterceptor{_installInterceptor(){}getModule(m,b){for(let w of this._alternatives){let P=w(m);if(P){m=P;break}}if(this._factories.has(m))return this._factories.get(m).load(m,b,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class I extends F.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=E.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const m=this._extHostContext.getProxy(y.MainContext.MainThreadConsole);d(m,this._initData.environment.isExtensionDevelopmentDebug);const b=this._instaService.invokeFunction(g.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(n,b,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(m){return m.browser}async _loadCommonJSModule(m,b,w){b=b.with({path:l(b.path,".js")}),m&&performance.mark(`code/extHost/willFetchExtensionCode/${m.value}`);const P=await fetch(_.FileAccess.asBrowserUri(b).toString(!0));if(m&&performance.mark(`code/extHost/didFetchExtensionCode/${m.value}`),P.status!==200)throw new Error(P.statusText);const a=await P.text(),f=`${b.toString(!0)}#vscode-extension`,v=`${a}
//# sourceURL=${f}`;let t;try{t=k.create(I._ttpExtensionScripts?.createScript("module")??"module",I._ttpExtensionScripts?.createScript("exports")??"exports",I._ttpExtensionScripts?.createScript("require")??"require",I._ttpExtensionScripts?.createScript(v)??v)}catch(c){throw console.error(m?`Loading code for extension ${m.value} failed: ${c.message}`:`Loading code failed: ${c.message}`),console.error(`${b.toString(!0)}${typeof c.line=="number"?` line ${c.line}`:""}${typeof c.column=="number"?` column ${c.column}`:""}`),console.error(c),c}const r={},s={exports:r},i=c=>{const h=this._fakeModules.getModule(c,b);if(h===void 0)throw new Error(`Cannot load module '${c}'`);return h};try{return w.codeLoadingStart(),m&&performance.mark(`code/extHost/willLoadExtensionCode/${m.value}`),t(s,r,i),s.exports!==r?s.exports:r}finally{m&&performance.mark(`code/extHost/didLoadExtensionCode/${m.value}`),w.codeLoadingStop()}}async $setRemoteEnvironment(m){throw new Error("Not supported")}async _waitForDebuggerAttachment(m=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const b=Date.now()+m;for(;Date.now()<b&&!("__jsDebugIsReady"in globalThis);)await(0,C.timeout)(10)}}e.ExtHostExtensionService=I,I._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:u=>u});function l(u,m){return u.endsWith(m)?u:u+m}function d(u,m){b("info","log"),b("log","log"),b("warn","warn"),b("error","error");function b(a,f){const v=console[a];console[a]=function(){u.$logExtensionHostMessage({type:"__$console",severity:f,arguments:P(arguments)}),m&&v.apply(console,arguments)}}const w=1e5;function P(a){const f=[],v=[];if(a.length)for(let t=0;t<a.length;t++){if(typeof a[t]=="undefined")a[t]="undefined";else if(a[t]instanceof Error){const r=a[t];r.stack?a[t]=r.stack:a[t]=r.toString()}v.push(a[t])}try{const t=JSON.stringify(v,function(r,s){if(s&&typeof s=="object"){if(f.indexOf(s)!==-1)return"[Circular]";f.push(s)}return s});return t.length>w?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(be[232],Ee([0,1,59,15,34,78,231,218]),function(ee,e,g,F,S,E,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(S.IExtHostExtensionService,C.ExtHostExtensionService),(0,g.registerSingleton)(F.ILogService,y.ExtHostLogService),(0,g.registerSingleton)(E.IExtensionStoragePaths,E.ExtensionStoragePaths)}),define(be[234],Ee([0,1,24,3,186,226,220,14,79,11,2,230,232]),function(ee,e,g,F,S,E,C,y,_,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const I=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const P=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:f=>f}),a=self.Worker;Worker=function(f,v){/^file:/i.test(f.toString())&&(f=k.FileAccess.asBrowserUri(n.URI.parse(f.toString())).toString(!0));const t=`(function() {
	const ttPolicy = self.trustedTypes ? self.trustedTypes.createPolicy('extensionHostWorker', { createScriptURL: (value) => value }) : undefined;
	const stringUrl = '${f}';
	importScripts(ttPolicy ? ttPolicy.createScriptURL(stringUrl) : stringUrl);
})();
`;v=v||{},v.name=v.name||y.basename(f.toString());const r=new Blob([t],{type:"application/javascript"}),s=URL.createObjectURL(r);return new a(P?P.createScriptURL(s):s,v)}}else self.Worker=class extends C.NestedWorker{constructor(P,a){super(l,P,{name:y.basename(P.toString()),...a})}};const d=new class{exit(P){I()}async exists(P){return!0}async realpath(P){return P}};class u{constructor(){const a=new MessageChannel,f=new F.Emitter;let v=!1;l(a.port2,[a.port2]),a.port1.onmessage=t=>{const{data:r}=t;if(!(r instanceof ArrayBuffer)){console.warn("UNKNOWN data received",r);return}const s=g.VSBuffer.wrap(new Uint8Array(r,0,r.byteLength));if((0,S.isMessageOfType)(s,2)){v=!0,b("received terminate message from renderer");return}f.fire(s)},this.protocol={onMessage:f.event,send:t=>{if(!v){const r=t.buffer.buffer.slice(t.buffer.byteOffset,t.buffer.byteOffset+t.buffer.byteLength);a.port1.postMessage(r,[r])}}}}}function m(P){return new Promise(a=>{const f=P.onMessage(v=>{f.dispose();const t=JSON.parse(v.toString());P.send((0,S.createMessageOfType)(0)),a({protocol:P,initData:t})});P.send((0,S.createMessageOfType)(1))})}let b=P=>I();function w(){const P=new u;_.mark("code/extHost/willConnectToRenderer"),m(P.protocol).then(a=>{_.mark("code/extHost/didWaitForInitData");const f=new E.ExtensionHostMain(a.protocol,a.initData,d,null);b=v=>f.terminate(v)})}e.create=w})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b805d2e94937976bb17d0439f57fcd3a9d423c31/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
